/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(J){for(var e=[],L=0,D=J.length;L<D;L++)e[L]=ne[J[L]];return e};define(ne[70],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class L{static get(){const O=new Map,A=new Map,j=new Map,v=new Map;function u(d,S){d.has(S.detail)||d.set(S.detail,-S.timestamp)}function c(d,S){const w=d.get(S.detail);w&&(w>=0||d.set(S.detail,w+S.timestamp))}let b=[];typeof J=="function"&&typeof J.getStats=="function"&&(b=J.getStats().slice(0).sort((d,S)=>d.timestamp-S.timestamp));for(const d of b)switch(d.type){case 10:u(O,d);break;case 11:case 12:c(O,d);break;case 21:u(A,d);break;case 22:c(A,d);break;case 33:u(j,d);break;case 34:c(j,d);break;case 31:u(v,d);break;case 32:c(v,d);break}let R=0;j.forEach(d=>R+=d);function g(d){const S=[];return d.forEach((w,$)=>S.push([$,w])),S}return{amdLoad:g(O),amdInvoke:g(A),nodeRequire:g(j),nodeEval:g(v),nodeRequireTotal:R}}static toMarkdownTable(O,A){let j="";const v=[];return O.forEach((u,c)=>{v[c]=u.length}),A.forEach(u=>{u.forEach((c,b)=>{typeof c>"u"&&(c=u[b]="-");const R=c.toString().length;v[b]=Math.max(R,v[b])})}),O.forEach((u,c)=>{j+=`| ${u+" ".repeat(v[c]-u.toString().length)} `}),j+=`|
`,O.forEach((u,c)=>{j+=`| ${"-".repeat(v[c])} `}),j+=`|
`,A.forEach(u=>{u.forEach((c,b)=>{typeof c<"u"&&(j+=`| ${c+" ".repeat(v[b]-c.toString().length)} `)}),j+=`|
`}),j}}e.$T=L}),define(ne[52],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function L(j){return(v,u,c)=>{let b=null,R=null;if(typeof c.value=="function"?(b="value",R=c.value):typeof c.get=="function"&&(b="get",R=c.get),!R)throw new Error("not supported");c[b]=j(R,u)}}function D(j,v,u){let c=null,b=null;if(typeof u.value=="function"?(c="value",b=u.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",b=u.get),!b)throw new Error("not supported");const R=`$memoize$${v}`;u[c]=function(...g){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,g)}),this[R]}}e.$fh=D;function O(j,v,u){return L((c,b)=>{const R=`$debounce$${b}`,g=`$debounce$result$${b}`;return function(...d){this[g]||(this[g]=u?u():void 0),clearTimeout(this[R]),v&&(this[g]=v(this[g],...d),d=[this[g]]),this[R]=setTimeout(()=>{c.apply(this,d),this[g]=u?u():void 0},j)}})}e.$gh=O;function A(j,v,u){return L((c,b)=>{const R=`$throttle$timer$${b}`,g=`$throttle$result$${b}`,d=`$throttle$lastRun$${b}`,S=`$throttle$pending$${b}`;return function(...w){if(this[g]||(this[g]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),v&&(this[g]=v(this[g],...w)),this[S])return;const $=this[d]+j;$<=Date.now()?(this[d]=Date.now(),c.apply(this,[this[g]]),this[g]=u?u():void 0):(this[S]=!0,this[R]=setTimeout(()=>{this[S]=!1,this[d]=Date.now(),c.apply(this,[this[g]]),this[g]=u?u():void 0},$-Date.now()))}})}e.$hh=A}),define(ne[71],re([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function D(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=D;function O(u,c="Unreachable"){throw new Error(c)}e.$3c=O;function A(u){if(!u)throw new L.$bb("Assertion Failed")}e.$4c=A;function j(u){if(!u()){debugger;u(),(0,L.$Z)(new L.$bb("Assertion Failed"))}}e.$5c=j;function v(u,c){let b=0;for(;b<u.length-1;){const R=u[b],g=u[b+1];if(!c(R,g))return!1;b++}return!0}e.$6c=v}),define(ne[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var O;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(O||(e.ParseErrorCode=O={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function j(t,a=!1){let i=0;const n=t.length;let s="",r=0,l=16,P=0;function y(te){let ae=0,le=0;for(;ae<te;){const ie=t.charCodeAt(i);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;i++,ae++}return ae<te&&(le=-1),le}function E(te){i=te,s="",r=0,l=16,P=0}function N(){const te=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return P=3,t.substring(te,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;ae=i}else P=3;return t.substring(te,ae)}function W(){let te="",ae=i;for(;;){if(i>=n){te+=t.substring(ae,i),P=2;break}const le=t.charCodeAt(i);if(le===34){te+=t.substring(ae,i),i++;break}if(le===92){if(te+=t.substring(ae,i),i++,i>=n){P=2;break}switch(t.charCodeAt(i++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const q=y(4);q>=0?te+=String.fromCharCode(q):P=4;break}default:P=5}ae=i;continue}if(le>=0&&le<=31)if(u(le)){te+=t.substring(ae,i),P=2;break}else P=6;i++}return te}function x(){if(s="",P=0,r=i,i>=n)return r=n,l=17;let te=t.charCodeAt(i);if(v(te)){do i++,s+=String.fromCharCode(te),te=t.charCodeAt(i);while(v(te));return l=15}if(u(te))return i++,s+=String.fromCharCode(te),te===13&&t.charCodeAt(i)===10&&(i++,s+=`
`),l=14;switch(te){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,s=W(),l=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!u(t.charCodeAt(i));)i++;return s=t.substring(ae,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const le=n-1;let ie=!1;for(;i<le;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,P=1),s=t.substring(ae,i),l=13}return s+=String.fromCharCode(te),i++,l=16}case 45:if(s+=String.fromCharCode(te),i++,i===n||!c(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),l=11;default:for(;i<n&&_(te);)i++,te=t.charCodeAt(i);if(r!==i){switch(s=t.substring(r,i),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(te),i++,l=16}}function _(te){if(v(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let te;do te=x();while(te>=12&&te<=15);return te}return{setPosition:E,getPosition:()=>i,scan:a?ue:x,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>r,getTokenLength:()=>i-r,getTokenError:()=>P}}e.$Mm=j;function v(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function R(t,a){const i=[],n=new Object;let s;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(y,E,N,W){r.value=y,r.offset=E,r.length=N,r.type=W,r.colonOffset=void 0,s=r}try{I(t,{onObjectBegin:(y,E)=>{if(a<=y)throw n;s=void 0,l=a>y,i.push("")},onObjectProperty:(y,E,N)=>{if(a<E||(P(y,E,N,"property"),i[i.length-1]=y,a<=E+N))throw n},onObjectEnd:(y,E)=>{if(a<=y)throw n;s=void 0,i.pop()},onArrayBegin:(y,E)=>{if(a<=y)throw n;s=void 0,i.push(0)},onArrayEnd:(y,E)=>{if(a<=y)throw n;s=void 0,i.pop()},onLiteralValue:(y,E,N)=>{if(a<E||(P(y,E,N,k(y)),a<=E+N))throw n},onSeparator:(y,E,N)=>{if(a<=E)throw n;if(y===":"&&s&&s.type==="property")s.colonOffset=E,l=!1,s=void 0;else if(y===","){const W=i[i.length-1];typeof W=="number"?i[i.length-1]=W+1:(l=!0,i[i.length-1]=""),s=void 0}}})}catch(y){if(y!==n)throw y}return{path:i,previousNode:s,isAtPropertyKey:l,matches:y=>{let E=0;for(let N=0;E<y.length&&N<i.length;N++)if(y[E]===i[N]||y[E]==="*")E++;else if(y[E]!=="**")return!1;return E===y.length}}}e.$Nm=R;function g(t,a=[],i=A.DEFAULT){let n=null,s=[];const r=[];function l(y){Array.isArray(s)?s.push(y):n!==null&&(s[n]=y)}return I(t,{onObjectBegin:()=>{const y={};l(y),r.push(s),s=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{s=r.pop()},onArrayBegin:()=>{const y=[];l(y),r.push(s),s=y,n=null},onArrayEnd:()=>{s=r.pop()},onLiteralValue:l,onError:(y,E,N)=>{a.push({error:y,offset:E,length:N})}},i),s[0]}e.$Om=g;function d(t,a=[],i=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function r(y){return n.children.push(y),y}I(t,{onObjectBegin:y=>{n=r({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,E,N)=>{n=r({type:"property",offset:E,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:E,length:N,parent:n})},onObjectEnd:(y,E)=>{n.length=y+E-n.offset,n=n.parent,s(y+E)},onArrayBegin:(y,E)=>{n=r({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,E)=>{n.length=y+E-n.offset,n=n.parent,s(y+E)},onLiteralValue:(y,E,N)=>{r({type:k(y),offset:E,length:N,parent:n,value:y}),s(E+N)},onSeparator:(y,E,N)=>{n.type==="property"&&(y===":"?n.colonOffset=E:y===","&&s(E))},onError:(y,E,N)=>{a.push({error:y,offset:E,length:N})}},i);const P=n.children[0];return P&&delete P.parent,P}e.$Pm=d;function S(t,a){if(!t)return;let i=t;for(const n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const r of i.children)if(Array.isArray(r.children)&&r.children[0].value===n){i=r.children[1],s=!0;break}if(!s)return}else{const s=n;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.$Qm=S;function w(t){if(!t.parent||!t.parent.children)return[];const a=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.$Rm=w;function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const a=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(a[i.children[0].value]=$(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Sm=$;function h(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.$Tm=h;function f(t,a,i=!1){if(h(t,a,i)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=a;s++){const r=f(n[s],a,i);if(r)return r}return t}}e.$Um=f;function I(t,a,i=A.DEFAULT){const n=j(t,!1);function s(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function r(K){return K?Q=>K(Q,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(a.onObjectBegin),P=r(a.onObjectProperty),y=s(a.onObjectEnd),E=s(a.onArrayBegin),N=s(a.onArrayEnd),W=r(a.onLiteralValue),x=r(a.onSeparator),_=s(a.onComment),ue=r(a.onError),te=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function le(){for(;;){const K=n.scan();switch(n.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(K){case 12:case 13:te?ie(10):_();break;case 16:ie(1);break;case 15:case 14:break;default:return K}}}function ie(K,Q=[],F=[]){if(ue(K),Q.length+F.length>0){let z=n.getToken();for(;z!==17;){if(Q.indexOf(z)!==-1){le();break}else if(F.indexOf(z)!==-1)break;z=le()}}}function q(K){const Q=n.getTokenValue();return K?W(Q):P(Q),le(),!0}function G(){switch(n.getToken()){case 11:{let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(ie(2),K=0)}catch{ie(2)}W(K);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return le(),!0}function T(){return n.getToken()!==10?(ie(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(x(":"),le(),X()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function U(){l(),le();let K=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(K||ie(4,[],[]),x(","),le(),n.getToken()===2&&ae)break}else K&&ie(6,[],[]);T()||ie(4,[],[2,5]),K=!0}return y(),n.getToken()!==2?ie(7,[2],[]):le(),!0}function V(){E(),le();let K=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(K||ie(4,[],[]),x(","),le(),n.getToken()===4&&ae)break}else K&&ie(6,[],[]);X()||ie(4,[],[4,5]),K=!0}return N(),n.getToken()!==4?ie(8,[4],[]):le(),!0}function X(){switch(n.getToken()){case 3:return V();case 1:return U();case 10:return q(!0);default:return G()}}return le(),n.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):X()?(n.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$Vm=I;function p(t,a){const i=j(t),n=[];let s,r=0,l;do switch(l=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:r!==l&&n.push(t.substring(r,l)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),r=i.getPosition();break}while(s!==17);return n.join("")}e.$Wm=p;function k(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Xm=k}),define(ne[72],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.rot=e.$Kl=void 0;function L(v,u,c){return Math.min(Math.max(v,u),c)}e.$Kl=L;function D(v,u){return(u+v%u)%u}e.rot=D;class O{constructor(){this.a=0}getNext(){return this.a++}}e.$Ml=O;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nl=A;class j{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ol=j}),function(){function J(O){const A=[];typeof O=="number"&&A.push("code/timeOrigin",O);function j(u){A.push(u,Date.now())}function v(){const u=[];for(let c=0;c<A.length;c+=2)u.push({name:A[c],startTime:A[c+1]});return u}return{mark:j,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const j of performance.getEntriesByType("mark"))A.push({name:j.name,startTime:Math.round(O+j.startTime)});return A}};if(typeof process=="object"){const O=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:J)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(D){if(e[D])return e[D].exports;var O=e[D]={i:D,l:!1,exports:{}};return J[D].call(O.exports,O,O.exports,L),O.l=!0,O.exports}return L.m=J,L.c=e,L.d=function(D,O,A){L.o(D,O)||Object.defineProperty(D,O,{enumerable:!0,get:A})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,O){if(1&O&&(D=L(D)),8&O||4&O&&typeof D=="object"&&D&&D.__esModule)return D;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:D}),2&O&&typeof D!="string")for(var j in D)L.d(A,j,function(v){return D[v]}.bind(null,j));return A},L.n=function(D){var O=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(O,"a",O),O},L.o=function(D,O){return Object.prototype.hasOwnProperty.call(D,O)},L.p="",L(L.s=0)}([function(J,e,L){(function(D){var O;e=J.exports=F,O=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],u=e.src=[],c=0,b=c++;u[b]="0|[1-9]\\d*";var R=c++;u[R]="[0-9]+";var g=c++;u[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;u[d]="("+u[b]+")\\.("+u[b]+")\\.("+u[b]+")";var S=c++;u[S]="("+u[R]+")\\.("+u[R]+")\\.("+u[R]+")";var w=c++;u[w]="(?:"+u[b]+"|"+u[g]+")";var $=c++;u[$]="(?:"+u[R]+"|"+u[g]+")";var h=c++;u[h]="(?:-("+u[w]+"(?:\\."+u[w]+")*))";var f=c++;u[f]="(?:-?("+u[$]+"(?:\\."+u[$]+")*))";var I=c++;u[I]="[0-9A-Za-z-]+";var p=c++;u[p]="(?:\\+("+u[I]+"(?:\\."+u[I]+")*))";var k=c++,t="v?"+u[d]+u[h]+"?"+u[p]+"?";u[k]="^"+t+"$";var a="[v=\\s]*"+u[S]+u[f]+"?"+u[p]+"?",i=c++;u[i]="^"+a+"$";var n=c++;u[n]="((?:<|>)?=?)";var s=c++;u[s]=u[R]+"|x|X|\\*";var r=c++;u[r]=u[b]+"|x|X|\\*";var l=c++;u[l]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[h]+")?"+u[p]+"?)?)?";var P=c++;u[P]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[f]+")?"+u[p]+"?)?)?";var y=c++;u[y]="^"+u[n]+"\\s*"+u[l]+"$";var E=c++;u[E]="^"+u[n]+"\\s*"+u[P]+"$";var N=c++;u[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=c++;u[W]="(?:~>?)";var x=c++;u[x]="(\\s*)"+u[W]+"\\s+",v[x]=new RegExp(u[x],"g");var _=c++;u[_]="^"+u[W]+u[l]+"$";var ue=c++;u[ue]="^"+u[W]+u[P]+"$";var te=c++;u[te]="(?:\\^)";var ae=c++;u[ae]="(\\s*)"+u[te]+"\\s+",v[ae]=new RegExp(u[ae],"g");var le=c++;u[le]="^"+u[te]+u[l]+"$";var ie=c++;u[ie]="^"+u[te]+u[P]+"$";var q=c++;u[q]="^"+u[n]+"\\s*("+a+")$|^$";var G=c++;u[G]="^"+u[n]+"\\s*("+t+")$|^$";var T=c++;u[T]="(\\s*)"+u[n]+"\\s*("+a+"|"+u[l]+")",v[T]=new RegExp(u[T],"g");var U=c++;u[U]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var V=c++;u[V]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var X=c++;u[X]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)O(K,u[K]),v[K]||(v[K]=new RegExp(u[K]));function Q(B,Y){if(B instanceof F)return B;if(typeof B!="string"||B.length>A||!(Y?v[i]:v[k]).test(B))return null;try{return new F(B,Y)}catch{return null}}function F(B,Y){if(B instanceof F){if(B.loose===Y)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof F))return new F(B,Y);O("SemVer",B,Y),this.loose=Y;var ee=B.trim().match(Y?v[i]:v[k]);if(!ee)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<j)return ye}return $e}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=Q,e.valid=function(B,Y){var ee=Q(B,Y);return ee?ee.version:null},e.clean=function(B,Y){var ee=Q(B.trim().replace(/^[=v]+/,""),Y);return ee?ee.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(B){return O("SemVer.compare",this.version,this.loose,B),B instanceof F||(B=new F(B,this.loose)),this.compareMain(B)||this.comparePre(B)},F.prototype.compareMain=function(B){return B instanceof F||(B=new F(B,this.loose)),o(this.major,B.major)||o(this.minor,B.minor)||o(this.patch,B.patch)},F.prototype.comparePre=function(B){if(B instanceof F||(B=new F(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var Y=0;do{var ee=this.prerelease[Y],$e=B.prerelease[Y];if(O("prerelease compare",Y,ee,$e),ee===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ee===void 0)return-1;if(ee!==$e)return o(ee,$e)}while(++Y)},F.prototype.inc=function(B,Y){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,Y,ee,$e){typeof ee=="string"&&($e=ee,ee=void 0);try{return new F(B,ee).inc(Y,$e).version}catch{return null}},e.diff=function(B,Y){if(Z(B,Y))return null;var ee=Q(B),$e=Q(Y);if(ee.prerelease.length||$e.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return ye},e.compareIdentifiers=o;var z=/^[0-9]+$/;function o(B,Y){var ee=z.test(B),$e=z.test(Y);return ee&&$e&&(B=+B,Y=+Y),ee&&!$e?-1:$e&&!ee?1:B<Y?-1:B>Y?1:0}function m(B,Y,ee){return new F(B,ee).compare(new F(Y,ee))}function M(B,Y,ee){return m(B,Y,ee)>0}function C(B,Y,ee){return m(B,Y,ee)<0}function Z(B,Y,ee){return m(B,Y,ee)===0}function H(B,Y,ee){return m(B,Y,ee)!==0}function ce(B,Y,ee){return m(B,Y,ee)>=0}function oe(B,Y,ee){return m(B,Y,ee)<=0}function ge(B,Y,ee,$e){var ye;switch(Y){case"===":typeof B=="object"&&(B=B.version),typeof ee=="object"&&(ee=ee.version),ye=B===ee;break;case"!==":typeof B=="object"&&(B=B.version),typeof ee=="object"&&(ee=ee.version),ye=B!==ee;break;case"":case"=":case"==":ye=Z(B,ee,$e);break;case"!=":ye=H(B,ee,$e);break;case">":ye=M(B,ee,$e);break;case">=":ye=ce(B,ee,$e);break;case"<":ye=C(B,ee,$e);break;case"<=":ye=oe(B,ee,$e);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function de(B,Y){if(B instanceof de){if(B.loose===Y)return B;B=B.value}if(!(this instanceof de))return new de(B,Y);O("comparator",B,Y),this.loose=Y,this.parse(B),this.semver===me?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(B,Y){return o(Y,B)},e.major=function(B,Y){return new F(B,Y).major},e.minor=function(B,Y){return new F(B,Y).minor},e.patch=function(B,Y){return new F(B,Y).patch},e.compare=m,e.compareLoose=function(B,Y){return m(B,Y,!0)},e.rcompare=function(B,Y,ee){return m(Y,B,ee)},e.sort=function(B,Y){return B.sort(function(ee,$e){return e.compare(ee,$e,Y)})},e.rsort=function(B,Y){return B.sort(function(ee,$e){return e.rcompare(ee,$e,Y)})},e.gt=M,e.lt=C,e.eq=Z,e.neq=H,e.gte=ce,e.lte=oe,e.cmp=ge,e.Comparator=de;var me={};function fe(B,Y){if(B instanceof fe)return B.loose===Y?B:new fe(B.raw,Y);if(B instanceof de)return new fe(B.value,Y);if(!(this instanceof fe))return new fe(B,Y);if(this.loose=Y,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function he(B){return!B||B.toLowerCase()==="x"||B==="*"}function we(B,Y,ee,$e,ye,Ne,Se,Le,Ie,Ae,Fe,Re,je){return((Y=he(ee)?"":he($e)?">="+ee+".0.0":he(ye)?">="+ee+"."+$e+".0":">="+Y)+" "+(Le=he(Ie)?"":he(Ae)?"<"+(+Ie+1)+".0.0":he(Fe)?"<"+Ie+"."+(+Ae+1)+".0":Re?"<="+Ie+"."+Ae+"."+Fe+"-"+Re:"<="+Le)).trim()}function be(B,Y){for(var ee=0;ee<B.length;ee++)if(!B[ee].test(Y))return!1;if(Y.prerelease.length){for(ee=0;ee<B.length;ee++)if(O(B[ee].semver),B[ee].semver!==me&&B[ee].semver.prerelease.length>0){var $e=B[ee].semver;if($e.major===Y.major&&$e.minor===Y.minor&&$e.patch===Y.patch)return!0}return!1}return!0}function ke(B,Y,ee){try{Y=new fe(Y,ee)}catch{return!1}return Y.test(B)}function Me(B,Y,ee,$e){var ye,Ne,Se,Le,Ie;switch(B=new F(B,$e),Y=new fe(Y,$e),ee){case">":ye=M,Ne=oe,Se=C,Le=">",Ie=">=";break;case"<":ye=C,Ne=ce,Se=M,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(B,Y,$e))return!1;for(var Ae=0;Ae<Y.set.length;++Ae){var Fe=Y.set[Ae],Re=null,je=null;if(Fe.forEach(function(De){De.semver===me&&(De=new de(">=0.0.0")),Re=Re||De,je=je||De,ye(De.semver,Re.semver,$e)?Re=De:Se(De.semver,je.semver,$e)&&(je=De)}),Re.operator===Le||Re.operator===Ie||(!je.operator||je.operator===Le)&&Ne(B,je.semver)||je.operator===Ie&&Se(B,je.semver))return!1}return!0}de.prototype.parse=function(B){var Y=this.loose?v[q]:v[G],ee=B.match(Y);if(!ee)throw new TypeError("Invalid comparator: "+B);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new F(ee[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(B){return O("Comparator.test",B,this.loose),this.semver===me||(typeof B=="string"&&(B=new F(B,this.loose)),ge(B,this.operator,this.semver,this.loose))},de.prototype.intersects=function(B,Y){if(!(B instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(B.value,Y),ke(this.value,ee,Y);if(B.operator==="")return ee=new fe(this.value,Y),ke(B.semver,ee,Y);var $e=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Ne=this.semver.version===B.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Le=ge(this.semver,"<",B.semver,Y)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),Ie=ge(this.semver,">",B.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return $e||ye||Ne&&Se||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(B){var Y=this.loose;B=B.trim(),O("range",B,Y);var ee=Y?v[V]:v[U];B=B.replace(ee,we),O("hyphen replace",B),B=B.replace(v[T],"$1$2$3"),O("comparator trim",B,v[T]),B=(B=(B=B.replace(v[x],"$1~")).replace(v[ae],"$1^")).split(/\s+/).join(" ");var $e=Y?v[q]:v[G],ye=B.split(" ").map(function(Ne){return function(Se,Le){return O("comp",Se),Se=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Fe){return function(Re,je){O("caret",Re,je);var De=je?v[ie]:v[le];return Re.replace(De,function(Ue,ve,Ee,Pe,Oe){var ze;return O("caret",Re,Ue,ve,Ee,Pe,Oe),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?ze=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Oe?(O("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+Oe+" <"+(+ve+1)+".0.0"):(O("no pr"),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),O("caret return",ze),ze})}(Fe,Ae)}).join(" ")}(Se,Le),O("caret",Se),Se=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Fe){return function(Re,je){var De=je?v[ue]:v[_];return Re.replace(De,function(Ue,ve,Ee,Pe,Oe){var ze;return O("tilde",Re,Ue,ve,Ee,Pe,Oe),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?ze=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Oe?(O("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),ze=">="+ve+"."+Ee+"."+Pe+Oe+" <"+ve+"."+(+Ee+1)+".0"):ze=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",O("tilde return",ze),ze})}(Fe,Ae)}).join(" ")}(Se,Le),O("tildes",Se),Se=function(Ie,Ae){return O("replaceXRanges",Ie,Ae),Ie.split(/\s+/).map(function(Fe){return function(Re,je){Re=Re.trim();var De=je?v[E]:v[y];return Re.replace(De,function(Ue,ve,Ee,Pe,Oe,ze){O("xRange",Re,Ue,ve,Ee,Pe,Oe,ze);var qe=he(Ee),Ce=qe||he(Pe),Te=Ce||he(Oe);return ve==="="&&Te&&(ve=""),qe?Ue=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Ce&&(Pe=0),Te&&(Oe=0),ve===">"?(ve=">=",Ce?(Ee=+Ee+1,Pe=0,Oe=0):Te&&(Pe=+Pe+1,Oe=0)):ve==="<="&&(ve="<",Ce?Ee=+Ee+1:Pe=+Pe+1),Ue=ve+Ee+"."+Pe+"."+Oe):Ce?Ue=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ue=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),O("xRange return",Ue),Ue})}(Fe,Ae)}).join(" ")}(Se,Le),O("xrange",Se),Se=function(Ie,Ae){return O("replaceStars",Ie,Ae),Ie.trim().replace(v[X],"")}(Se,Le),O("stars",Se),Se}(Ne,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Ne){return!!Ne.match($e)})),ye=ye.map(function(Ne){return new de(Ne,Y)})},fe.prototype.intersects=function(B,Y){if(!(B instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function($e){return B.set.some(function(ye){return ye.every(function(Ne){return $e.intersects(Ne,Y)})})})})},e.toComparators=function(B,Y){return new fe(B,Y).set.map(function(ee){return ee.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new F(B,this.loose));for(var Y=0;Y<this.set.length;Y++)if(be(this.set[Y],B))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(B,Y,ee){var $e=null,ye=null;try{var Ne=new fe(Y,ee)}catch{return null}return B.forEach(function(Se){Ne.test(Se)&&($e&&ye.compare(Se)!==-1||(ye=new F($e=Se,ee)))}),$e},e.minSatisfying=function(B,Y,ee){var $e=null,ye=null;try{var Ne=new fe(Y,ee)}catch{return null}return B.forEach(function(Se){Ne.test(Se)&&($e&&ye.compare(Se)!==1||(ye=new F($e=Se,ee)))}),$e},e.validRange=function(B,Y){try{return new fe(B,Y).range||"*"}catch{return null}},e.ltr=function(B,Y,ee){return Me(B,Y,"<",ee)},e.gtr=function(B,Y,ee){return Me(B,Y,">",ee)},e.outside=Me,e.prerelease=function(B,Y){var ee=Q(B,Y);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(B,Y,ee){return B=new fe(B,ee),Y=new fe(Y,ee),B.intersects(Y)},e.coerce=function(B){if(B instanceof F)return B;if(typeof B!="string")return null;var Y=B.match(v[N]);return Y==null?null:Q((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,L(1))},function(J,e){var L,D,O=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function v($){if(L===setTimeout)return setTimeout($,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{D=typeof clearTimeout=="function"?clearTimeout:j}catch{D=j}})();var u,c=[],b=!1,R=-1;function g(){b&&u&&(b=!1,u.length?c=u.concat(c):R=-1,c.length&&d())}function d(){if(!b){var $=v(g);b=!0;for(var h=c.length;h;){for(u=c,c=[];++R<h;)u&&u[R].run();R=-1,h=c.length}u=null,b=!1,function(f){if(D===clearTimeout)return clearTimeout(f);if((D===j||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(f);try{D(f)}catch{try{return D.call(null,f)}catch{return D.call(this,f)}}}($)}}function S($,h){this.fun=$,this.array=h}function w(){}O.nextTick=function($){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];c.push(new S($,h)),c.length!==1||b||v(d)},S.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=w,O.addListener=w,O.once=w,O.off=w,O.removeListener=w,O.removeAllListeners=w,O.emit=w,O.prependListener=w,O.prependOnceListener=w,O.listeners=function($){return[]},O.binding=function($){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function($){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class D{constructor(v,u,c){this.level=v,this.key=u,this.value=c,this.forward=[]}}const O=void 0;class A{constructor(v,u=2**16){this.comparator=v,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,O,O)}get size(){return this.f}clear(){this.e=new D(this.c,O,O)}has(v){return!!A.g(this,v,this.comparator)}get(v){return A.g(this,v,this.comparator)?.value}set(v,u){return A.h(this,v,u,this.comparator)&&(this.f+=1),this}delete(v){const u=A.k(this,v,this.comparator);return u&&(this.f-=1),u}forEach(v,u){let c=this.e.forward[0];for(;c;)v.call(u,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let v=this.e.forward[0];for(;v;)yield[v.key,v.value],v=v.forward[0]}*keys(){let v=this.e.forward[0];for(;v;)yield v.key,v=v.forward[0]}*values(){let v=this.e.forward[0];for(;v;)yield v.value,v=v.forward[0]}toString(){let v="[SkipList]:",u=this.e.forward[0];for(;u;)v+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return v}static g(v,u,c){let b=v.e;for(let R=v.d-1;R>=0;R--)for(;b.forward[R]&&c(b.forward[R].key,u)<0;)b=b.forward[R];if(b=b.forward[0],b&&c(b.key,u)===0)return b}static h(v,u,c,b){const R=[];let g=v.e;for(let d=v.d-1;d>=0;d--){for(;g.forward[d]&&b(g.forward[d].key,u)<0;)g=g.forward[d];R[d]=g}if(g=g.forward[0],g&&b(g.key,u)===0)return g.value=c,!1;{const d=A.j(v);if(d>v.d){for(let S=v.d;S<d;S++)R[S]=v.e;v.d=d}g=new D(d,u,c);for(let S=0;S<d;S++)g.forward[S]=R[S].forward[S],R[S].forward[S]=g;return!0}}static j(v,u=.5){let c=1;for(;Math.random()<u&&c<v.c;)c+=1;return c}static k(v,u,c){const b=[];let R=v.e;for(let g=v.d-1;g>=0;g--){for(;R.forward[g]&&c(R.forward[g].key,u)<0;)R=R.forward[g];b[g]=R}if(R=R.forward[0],!R||c(R.key,u)!==0)return!1;for(let g=0;g<v.d&&b[g].forward[g]===R;g++)b[g].forward[g]=R.forward[g];for(;v.d>0&&v.e.forward[v.d-1]===O;)v.d-=1;return!0}}e.$rr=A}),define(ne[45],re([0,1,9,2]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function O(p){const k=p;return k?typeof k.read=="function":!1}e.$Xd=O;function A(p){const k=p;return k?[k.on,k.pause,k.resume,k.destroy].every(t=>typeof t=="function"):!1}e.$Yd=A;function j(p){const k=p;return k?A(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.$Zd=j;function v(p,k){return new u(p,k)}e.$1d=v;class u{constructor(k,t){this.e=k,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(t=>t(k))}h(k){this.c.error.length===0?(0,L.$Z)(k):this.c.error.slice(0).forEach(t=>t(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,t){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(k,t){if(this.a.destroyed)return;let a;switch(k){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(p,k){const t=[];let a;for(;(a=p.read())!==null;)t.push(a);return k(t)}e.$2d=c;function b(p,k,t){const a=[];let i;for(;(i=p.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?k(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return p.read()}}}e.$3d=b;function R(p,k){return new Promise((t,a)=>{const i=[];g(p,{onData:n=>{k&&i.push(n)},onError:n=>{k?a(n):t(void 0)},onEnd:()=>{t(k?k(i):void 0)}})})}e.$4d=R;function g(p,k,t){p.on("error",a=>{t?.isCancellationRequested||k.onError(a)}),p.on("end",()=>{t?.isCancellationRequested||k.onEnd()}),p.on("data",a=>{t?.isCancellationRequested||k.onData(a)})}e.$5d=g;function d(p,k){return new Promise((t,a)=>{const i=new D.$Qc,n=[],s=P=>{if(n.push(P),n.length>k)return i.dispose(),p.pause(),t({stream:p,buffer:n,ended:!1})},r=P=>(i.dispose(),a(P)),l=()=>(i.dispose(),t({stream:p,buffer:n,ended:!0}));i.add((0,D.$Pc)(()=>p.removeListener("error",r))),p.on("error",r),i.add((0,D.$Pc)(()=>p.removeListener("end",l))),p.on("end",l),i.add((0,D.$Pc)(()=>p.removeListener("data",s))),p.on("data",s)})}e.$6d=d;function S(p,k){const t=v(k);return t.end(p),t}e.$7d=S;function w(){const p=v(()=>{throw new Error("not supported")});return p.end(),p}e.$8d=w;function $(p){let k=!1;return{read:()=>k?null:(k=!0,p)}}e.$9d=$;function h(p,k,t){const a=v(t);return g(p,{onData:i=>a.write(k.data(i)),onError:i=>a.error(k.error?k.error(i):i),onEnd:()=>a.end()}),a}e.$0d=h;function f(p,k,t){let a=!1;return{read:()=>{const i=k.read();return a?i:(a=!0,i!==null?t([p,i]):p)}}}e.$$d=f;function I(p,k,t){let a=!1;const i=v(t);return g(k,{onData:n=>a?i.write(n):(a=!0,i.write(t([p,n]))),onError:n=>i.error(n),onEnd:()=>{a||(a=!0,i.write(p)),i.end()}}),i}e.$_d=I}),define(ne[14],re([0,1,164,45]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const O=typeof Buffer<"u",A=new L.$U(()=>new Uint8Array(256));let j,v;class u{static alloc(N){return O?new u(Buffer.allocUnsafe(N)):new u(new Uint8Array(N))}static wrap(N){return O&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new u(N)}static fromString(N,W){return!(W?.dontUseNodeBuffer||!1)&&O?new u(Buffer.from(N)):(j||(j=new TextEncoder),new u(j.encode(N)))}static fromByteArray(N){const W=u.alloc(N.length);for(let x=0,_=N.length;x<_;x++)W.buffer[x]=N[x];return W}static concat(N,W){if(typeof W>"u"){W=0;for(let ue=0,te=N.length;ue<te;ue++)W+=N[ue].byteLength}const x=u.alloc(W);let _=0;for(let ue=0,te=N.length;ue<te;ue++){const ae=N[ue];x.set(ae,_),_+=ae.byteLength}return x}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=u.alloc(this.byteLength);return N.set(this),N}toString(){return O?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(N,W){return new u(this.buffer.subarray(N,W))}set(N,W){if(N instanceof u)this.buffer.set(N.buffer,W);else if(N instanceof Uint8Array)this.buffer.set(N,W);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),W);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),W);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return g(this.buffer,N)}writeUInt32BE(N,W){d(this.buffer,N,W)}readUInt32LE(N){return S(this.buffer,N)}writeUInt32LE(N,W){w(this.buffer,N,W)}readUInt8(N){return $(this.buffer,N)}writeUInt8(N,W){h(this.buffer,N,W)}indexOf(N,W=0){return c(this.buffer,N instanceof u?N.buffer:N,W)}}e.$ae=u;function c(E,N,W=0){const x=N.byteLength,_=E.byteLength;if(x===0)return 0;if(x===1)return E.indexOf(N[0]);if(x>_-W)return-1;const ue=A.value;ue.fill(N.length);for(let ie=0;ie<N.length;ie++)ue[N[ie]]=N.length-ie-1;let te=W+N.length-1,ae=te,le=-1;for(;te<_;)if(E[te]===N[ae]){if(ae===0){le=te;break}te--,ae--}else te+=Math.max(N.length-ae,ue[E[te]]),ae=N.length-1;return le}e.$be=c;function b(E,N){return E[N+0]<<0>>>0|E[N+1]<<8>>>0}e.$ce=b;function R(E,N,W){E[W+0]=N&255,N=N>>>8,E[W+1]=N&255}e.$de=R;function g(E,N){return E[N]*2**24+E[N+1]*2**16+E[N+2]*2**8+E[N+3]}e.$ee=g;function d(E,N,W){E[W+3]=N,N=N>>>8,E[W+2]=N,N=N>>>8,E[W+1]=N,N=N>>>8,E[W]=N}e.$fe=d;function S(E,N){return E[N+0]<<0>>>0|E[N+1]<<8>>>0|E[N+2]<<16>>>0|E[N+3]<<24>>>0}e.$ge=S;function w(E,N,W){E[W+0]=N&255,N=N>>>8,E[W+1]=N&255,N=N>>>8,E[W+2]=N&255,N=N>>>8,E[W+3]=N&255}e.$he=w;function $(E,N){return E[N]}e.$ie=$;function h(E,N,W){E[W]=N}e.$je=h;function f(E){return D.$2d(E,N=>u.concat(N))}e.$ke=f;function I(E){return D.$9d(E)}e.$le=I;function p(E){return D.$4d(E,N=>u.concat(N))}e.$me=p;async function k(E){return E.ended?u.concat(E.buffer):u.concat([...E.buffer,await p(E.stream)])}e.$ne=k;function t(E){return D.$7d(E,N=>u.concat(N))}e.$oe=t;function a(E){return D.$0d(E,{data:N=>typeof N=="string"?u.fromString(N):u.wrap(N)},N=>u.concat(N))}e.$pe=a;function i(E){return D.$1d(N=>u.concat(N),E)}e.$qe=i;function n(E,N){return D.$$d(E,N,W=>u.concat(W))}e.$re=n;function s(E,N){return D.$_d(E,N,W=>u.concat(W))}e.$se=s;function r(E){let N=0,W=0,x=0;const _=new Uint8Array(Math.floor(E.length/4*3)),ue=ae=>{switch(W){case 3:_[x++]=N|ae,W=0;break;case 2:_[x++]=N|ae>>>2,N=ae<<6,W=3;break;case 1:_[x++]=N|ae>>>4,N=ae<<4,W=2;break;default:N=ae<<2,W=1}};for(let ae=0;ae<E.length;ae++){const le=E.charCodeAt(ae);if(le>=65&&le<=90)ue(le-65);else if(le>=97&&le<=122)ue(le-97+26);else if(le>=48&&le<=57)ue(le-48+52);else if(le===43||le===45)ue(62);else if(le===47||le===95)ue(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${E[ae]}`)}}const te=x;for(;W>0;)ue(0);return u.wrap(_).slice(0,te)}e.$te=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:E},N=!0,W=!1){const x=W?P:l;let _="";const ue=E.byteLength%3;let te=0;for(;te<E.byteLength-ue;te+=3){const ae=E[te+0],le=E[te+1],ie=E[te+2];_+=x[ae>>>2],_+=x[(ae<<4|le>>>4)&63],_+=x[(le<<2|ie>>>6)&63],_+=x[ie&63]}if(ue===1){const ae=E[te+0];_+=x[ae>>>2],_+=x[ae<<4&63],N&&(_+="==")}else if(ue===2){const ae=E[te+0],le=E[te+1];_+=x[ae>>>2],_+=x[(ae<<4|le>>>4)&63],_+=x[le<<2&63],N&&(_+="=")}return _}e.$ue=y}),define(ne[41],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=void 0;function D(h){return O(h,0)}e.$Bi=D;function O(h,f){switch(typeof h){case"object":return h===null?A(349,f):Array.isArray(h)?u(h,f):c(h,f);case"string":return v(h,f);case"boolean":return j(h,f);case"number":return A(h,f);case"undefined":return A(937,f);default:return A(617,f)}}e.$Ci=O;function A(h,f){return(f<<5)-f+h|0}e.$Di=A;function j(h,f){return A(h?433:863,f)}function v(h,f){f=A(149417,f);for(let I=0,p=h.length;I<p;I++)f=A(h.charCodeAt(I),f);return f}e.$Ei=v;function u(h,f){return f=A(104579,f),h.reduce((I,p)=>O(p,I),f)}function c(h,f){return f=A(181387,f),Object.keys(h).sort().reduce((I,p)=>(I=v(p,I),O(h[p],I)),f)}class b{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=O(f,this.g),this.g}}e.$Fi=b;var R;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function g(h,f,I=32){const p=I-f,k=~((1<<p)-1);return(h<<f|(k&h)>>>p)>>>0}function d(h,f=0,I=h.byteLength,p=0){for(let k=0;k<I;k++)h[f+k]=p}function S(h,f,I="0"){for(;h.length<f;)h=I+h;return h}function w(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(I=>I.toString(16).padStart(2,"0")).join(""):S((h>>>0).toString(16),f/4)}e.$Gi=w;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const I=f.length;if(I===0)return;const p=this.p;let k=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=f.charCodeAt(0),i=0);;){let n=a;if(L.$5e(a))if(i+1<I){const s=f.charCodeAt(i+1);L.$6e(s)?(i++,n=L.$7e(a,s)):n=65533}else{t=a;break}else L.$6e(a)&&(n=65533);if(k=this.w(p,k,n),i++,i<I)a=f.charCodeAt(i);else break}this.r=k,this.u=t}w(f,I,p){return p<128?f[I++]=p:p<2048?(f[I++]=192|(p&1984)>>>6,f[I++]=128|(p&63)>>>0):p<65536?(f[I++]=224|(p&61440)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0):(f[I++]=240|(p&1835008)>>>18,f[I++]=128|(p&258048)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0),I>=64&&(this.y(),I-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=$.g,I=this.q;for(let l=0;l<64;l+=4)f.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)f.setUint32(l,g(f.getUint32(l-12,!1)^f.getUint32(l-32,!1)^f.getUint32(l-56,!1)^f.getUint32(l-64,!1),1),!1);let p=this.h,k=this.l,t=this.m,a=this.n,i=this.o,n,s,r;for(let l=0;l<80;l++)l<20?(n=k&t|~k&a,s=1518500249):l<40?(n=k^t^a,s=1859775393):l<60?(n=k&t|k&a|t&a,s=2400959708):(n=k^t^a,s=3395469782),r=g(p,5)+n+i+s+f.getUint32(l*4,!1)&4294967295,i=a,a=t,t=g(k,30),k=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+k&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}e.$Hi=$}),define(ne[54],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(O){O[O.Ignore=0]="Ignore",O[O.Info=1]="Info",O[O.Warning=2]="Warning",O[O.Error=3]="Error"})(D||(D={})),function(O){const A="error",j="warning",v="warn",u="info",c="ignore";function b(g){return g?L.$1e(A,g)?O.Error:L.$1e(j,g)||L.$1e(v,g)?O.Warning:L.$1e(u,g)?O.Info:O.Ignore:O.Ignore}O.fromValue=b;function R(g){switch(g){case O.Error:return A;case O.Warning:return j;case O.Info:return u;default:return c}}O.toString=R}(D||(D={})),e.default=D}),define(ne[30],re([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=void 0;function D(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([I,p])=>{f[I]=p&&typeof p=="object"?D(p):p}),f}e.$Ym=D;function O(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const I=f.shift();Object.freeze(I);for(const p in I)if(A.call(I,p)){const k=I[p];typeof k=="object"&&!Object.isFrozen(k)&&!(0,L.$Af)(k)&&f.push(k)}}return h}e.$Zm=O;const A=Object.prototype.hasOwnProperty;function j(h,f){return v(h,f,new Set)}e.$1m=j;function v(h,f,I){if((0,L.$Gf)(h))return h;const p=f(h);if(typeof p<"u")return p;if(Array.isArray(h)){const k=[];for(const t of h)k.push(v(t,f,I));return k}if((0,L.$zf)(h)){if(I.has(h))throw new Error("Cannot clone recursive data-structure");I.add(h);const k={};for(const t in h)A.call(h,t)&&(k[t]=v(h[t],f,I));return I.delete(h),k}return h}function u(h,f,I=!0){return(0,L.$zf)(h)?((0,L.$zf)(f)&&Object.keys(f).forEach(p=>{p in h?I&&((0,L.$zf)(h[p])&&(0,L.$zf)(f[p])?u(h[p],f[p],I):h[p]=f[p]):h[p]=f[p]}),h):f}e.$2m=u;function c(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let I,p;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(I=0;I<h.length;I++)if(!c(h[I],f[I]))return!1}else{const k=[];for(p in h)k.push(p);k.sort();const t=[];for(p in f)t.push(p);if(t.sort(),!c(k,t))return!1;for(I=0;I<k.length;I++)if(!c(h[k[I]],f[k[I]]))return!1}return!0}e.$3m=c;function b(h){const f=new Set;return JSON.stringify(h,(I,p)=>{if((0,L.$zf)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.$4m=b;function R(h,f){const I=Object.create(null);return!h||!f||Object.keys(f).forEach(k=>{const t=h[k],a=f[k];c(t,a)||(I[k]=a)}),I}e.$5m=R;function g(h,f){const I=f.toLowerCase(),p=Object.keys(h).find(k=>k.toLowerCase()===I);return p?h[p]:h[f]}e.$6m=g;function d(h,f){const I=Object.create(null);for(const[p,k]of Object.entries(h))f(p,k)&&(I[p]=k);return I}e.$7m=d;function S(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.$8m=S;function w(h){const f=[];for(const I of S(h))typeof h[I]=="function"&&f.push(I);return f}e.$9m=w;function $(h,f){const I=k=>function(){const t=Array.prototype.slice.call(arguments,0);return f(k,t)},p={};for(const k of h)p[k]=I(k);return p}e.$0m=$}),define(ne[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(O){return L.test(O)}e.$cg=D,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(v){for(let u=0;u<v.length;u++)v[u]=Math.floor(Math.random()*256);return v};const A=new Uint8Array(16),j=[];for(let v=0;v<256;v++)j.push(v.toString(16).padStart(2,"0"));return function(){O(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,c="";return c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+="-",c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c+=j[A[u++]],c}}()}),define(ne[74],re([0,1,33]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function O(j){const v=j.replace(/\-/g,":").toLowerCase();return!D.has(v)}function A(){const j=(0,L.networkInterfaces)();for(const v in j){const u=j[v];if(u){for(const{mac:c}of u)if(O(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Jm=A}),define(ne[75],re([0,1,33,46,28,74]),function(J,e,L,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=void 0,e.$Km=new class{c(c){return this.a||(this.a=D.$Th.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(c)}value(){if(this.b===void 0){let c=0,b=0;const R=(0,L.networkInterfaces)();for(const g in R){const d=R[g];if(d)for(const{mac:S,internal:w}of d)w||(b+=1,this.c(S.toUpperCase())&&(c+=1))}this.b=b>0?c/b:0}return this.b}};let j;async function v(c){return j||(j=(async()=>await u(c)||O.$dg())()),j}e.$Lm=v;async function u(c){try{const b=await new Promise((g,d)=>{J(["crypto"],g,d)}),R=(0,A.$Jm)();return b.createHash("sha256").update(R,"utf8").digest("hex")}catch(b){c(b);return}}}),define(ne[76],re([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[77],re([0,1,76]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=void 0;const D=60,O=D*60,A=O*24,j=A*7,v=A*30,u=A*365;function c(R,g,d,S){typeof R!="number"&&(R=R.getTime());const w=Math.round((new Date().getTime()-R)/1e3);if(w<-30)return(0,L.localize)(0,null,c(new Date().getTime()+w*1e3,!1));if(!S&&w<30)return(0,L.localize)(1,null);let $;return w<D?($=w,g?$===1?d?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):d?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?d?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):d?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):w<O?($=Math.floor(w/D),g?$===1?d?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):d?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?d?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):d?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):w<A?($=Math.floor(w/O),g?$===1?d?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):d?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?d?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):d?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):w<j?($=Math.floor(w/A),g?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):w<v?($=Math.floor(w/j),g?$===1?d?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):d?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?d?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):d?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):w<u?($=Math.floor(w/v),g?$===1?d?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):d?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?d?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):d?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(w/u),g?$===1?d?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):d?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?d?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):d?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$9l=c;function b(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$0l=b}),define(ne[78],re([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,78]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function A(R,g){return g&&(R.stack||R.stacktrace)?O.localize(0,null,v(R),j(R.stack)||j(R.stacktrace)):v(R)}function j(R){return Array.isArray(R)?R.join(`
`):R}function v(R){return R.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${R.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?O.localize(1,null,R.message):R.message||O.localize(2,null)}function u(R=null,g=!1){if(!R)return O.localize(3,null);if(Array.isArray(R)){const d=L.$Gb(R),S=u(d[0],g);return d.length>1?O.localize(4,null,S,d.length):S}if(D.$xf(R))return R;if(R.detail){const d=R.detail;if(d.error)return A(d.error,g);if(d.exception)return A(d.exception,g)}return R.stack?A(R,g):R.message?R.message:O.localize(5,null)}e.$yi=u;function c(R){const g=R;return g instanceof Error&&Array.isArray(g.actions)}e.$zi=c;function b(R,g){let d;return typeof R=="string"?d=new Error(R):d=R,d.actions=g,d}e.$Ai=b}),define(ne[79],re([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],re([0,1,79]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;function D(O){switch(O){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$pp=D}),define(ne[55],re([0,1,13]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=e.TerminateResponseCode=e.Source=void 0;var D;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(D||(e.Source=D={}));var O;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(O||(e.TerminateResponseCode=O={}));function A(v,...u){const c=u.reduce((g,d)=>(g[d]=!0,g),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(g=>!c[g]).forEach(g=>{for(let d=0;d<b.length;d++)if(g.search(b[d])!==-1){delete v[g];break}})}e.$vl=A;function j(v){v&&(delete v.DEBUG,L.$k&&delete v.DYLD_LIBRARY_PATH,L.$l&&delete v.LD_PRELOAD)}e.$wl=j}),define(ne[81],re([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Sp=e.$Rp=e.$Qp=void 0;function D(c){const b=c;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.$Qp=D;function O(c){const b=[];let R;try{const g=JSON.parse(c.arguments),d=g[g.length-1];d&&d.__$stack&&(g.pop(),R=d.__$stack),b.push(...g)}catch{b.push("Unable to log remote console arguments",c.arguments)}return{args:b,stack:R}}e.$Rp=O;function A(c){if(typeof c!="string")return A(O(c).stack);const b=c;if(b){const R=j(b),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(g&&g.length===4)return{uri:L.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$Sp=A;function j(c){if(!c)return c;const b=c.indexOf(`
`);return b===-1?c:c.substring(0,b)}function v(c,b){const{args:R,stack:g}=O(c),d=typeof R[0]=="string"&&R.length===1;let S=j(g);S&&(S=`(${S.trim()})`);let w=[];if(typeof R[0]=="string"?S&&d?w=[`%c[${b}] %c${R[0]} %c${S}`,u("blue"),u(""),u("grey")]:w=[`%c[${b}] %c${R[0]}`,u("blue"),u(""),...R.slice(1)]:w=[`%c[${b}]%`,u("blue"),...R],S&&!d&&w.push(S),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,w)}e.log=v;function u(c){return`color: ${c}`}}),define(ne[47],re([0,1,14,11]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function O(u){return JSON.stringify(u,j)}e.$ih=O;function A(u){let c=JSON.parse(u);return c=v(c),c}e.$jh=A;function j(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function v(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof L.$ae||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let b=0;b<u.length;++b)u[b]=v(u[b],c+1);else for(const b in u)Object.hasOwnProperty.call(u,b)&&(u[b]=v(u[b],c+1))}return u}e.$kh=v}),define(ne[82],re([0,1,70,15,13,11]),function(J,e,L,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=void 0;class j{constructor(g,d,S){this.id=g,this.dependencies=d,this.callback=S}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,d,S)=>{typeof g!="string"&&(S=d,d=g,g=null),(typeof d!="object"||!Array.isArray(d))&&(S=d,d=null),this.c.push(new j(g,d,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const d=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!d)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(g){return new Promise((d,S)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const $=()=>{w.removeEventListener("load",h),w.removeEventListener("error",f)},h=I=>{$(),d(this.c.pop())},f=I=>{$(),S(I)};w.addEventListener("load",h),w.addEventListener("error",f),this.f&&(g=this.f.createScriptURL(g)),w.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(w)})}i(g){return new Promise((d,S)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),d(this.c.pop())}catch(w){S(w)}})}async j(g){try{const d=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(g).fsPath,h=d.readFileSync($).toString(),f=w.wrap(h.replace(/^#!.*/,""));return new S.Script(f).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const u=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function b(R,g,d){if(L.$S){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[R]&&(R=c[R]);const S=`${R}/${g}`;if(u.has(S))return u.get(S);let w;if(/^\w[\w\d+.-]*:\/\//.test(S))w=S;else{const I=`${d&&!O.$p?D.$$f:D.$0f}/${S}`;w=D.$bg.asBrowserUri(I).toString(!0)}const $=v.INSTANCE.load(w);return u.set(S,$),$}else return await new Promise((S,w)=>{J([R],S,w)})}e.$fC=b}),define(ne[83],re([0,1,33,16,24]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.$tl=void 0;const A=/^\d+$/,j=/^Microsoft.PowerShell_.*/,v=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class R{constructor(k,t,a){this.exePath=k,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await O.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:p=!1}={}){return p?c===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:p=!1,findPreview:k=!1}={}){const t=g({useAlternateBitness:p});if(!t)return null;const a=D.$ic(t,"PowerShell");if(!await O.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const l of await O.Promises.readdir(a)){let P=-1;if(k){const E=l.indexOf("-");if(E<0)continue;const N=l.substring(0,E);if(!A.test(N)||l.substring(E+1)!=="preview")continue;P=parseInt(N,10)}else{if(!A.test(l))continue;P=parseInt(l,10)}if(P<=i)continue;const y=D.$ic(a,l,"pwsh.exe");await O.SymlinkSupport.existsFile(y)&&(n=y,i=P)}if(!n)return null;const s=t.includes("x86")?" (x86)":"",r=k?" Preview":"";return new R(n,`PowerShell${r}${s}`,!0)}async function S({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const k=D.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await O.SymlinkSupport.existsDirectory(k))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=p?{pwshMsixDirRegex:v,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const i of await O.Promises.readdir(k))if(t.test(i)){const n=D.$ic(k,i,"pwsh.exe");return new R(n,a)}return null}function w(){const p=D.$ic(L.homedir(),".dotnet","tools","pwsh.exe");return new R(p,".NET Core PowerShell Global Tool")}function $(){const p=D.$ic(process.env.windir,c===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(p,"Windows PowerShell",!0)}async function*h(){let p=await d();p&&(yield p),p=await d({useAlternateBitness:!0}),p&&(yield p),p=await S(),p&&(yield p),p=w(),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await S({findPreview:!0}),p&&(yield p),p=await d({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=$(),p&&(yield p)}async function*f(){for await(const p of h())await p.exists()&&(yield p)}e.$tl=f;async function I(){for await(const p of f())return p;return null}e.$ul=I}),define(ne[56],re([0,1,16,13,35,55,3,24]),function(J,e,L,D,O,A,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$yl=e.$xl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(R=O.env){return R.comspec||"cmd.exe"}e.$xl=u;function c(R){let g=[],d=!1;const S=function(w){if(d){g.push(w);return}(!R.send(w,h=>{if(h&&console.error(h),d=!1,g.length>0){const f=g.slice(0);g=[],f.forEach(I=>S(I))}})||D.$j)&&(d=!0)};return{send:S}}e.$yl=c;var b;(function(R){async function g(d,S,w){if(L.$hc(d))return d;if(S===void 0&&(S=O.cwd()),L.$lc(d)!=="."||(w===void 0&&j.$xf(O.env.PATH)&&(w=O.env.PATH.split(L.$sc)),w===void 0||w.length===0))return L.$ic(S,d);async function h(f){if(await v.Promises.exists(f)){let I;try{I=await v.Promises.stat(f)}catch(p){p.message.startsWith("EACCES")&&(I=await v.Promises.lstat(f))}return I?!I.isDirectory():!1}return!1}for(const f of w){let I;if(L.$hc(f)?I=L.$ic(f,d):I=L.$ic(S,f,d),await h(I))return I;let p=I+".com";if(await h(p)||(p=I+".exe",await h(p)))return p}return L.$ic(S,d)}R.findExecutable=g})(b||(e.win32=b={}))}),define(ne[84],re([0,1,33,13,83,56]),function(J,e,L,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=void 0;async function j(R,g){return R===1?D.$j?b():A.$xl(g):u(R,g)}e.$zl=j;let v=null;function u(R,g){if(D.$l&&R===2||D.$k&&R===3)return"/bin/bash";if(!v){let d;if(D.$j)d="/bin/bash";else{if(d=g.SHELL,!d)try{d=(0,L.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}v=d}return v}let c=null;async function b(){return c||(c=(await(0,O.$ul)()).exePath),c}});var pe=this&&this.__decorate||function(J,e,L,D){var O=arguments.length,A=O<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,L,D);else for(var v=J.length-1;v>=0;v--)(j=J[v])&&(A=(O<3?j(A):O>3?j(e,L,A):j(e,L))||A);return O>3&&A&&Object.defineProperty(e,L,A),A};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,47,29,3]),function(J,e,L,D,O,A,j,v,u,c,b,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.ProxyChannel=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.RequestInitiator=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0;var d;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(d||(d={}));function S(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(w||(w={}));function $(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(h||(h={}));function f(T){let U=0;for(let V=0;;V+=7){const X=T.read(1);if(U|=(X.buffer[0]&127)<<V,!(X.buffer[0]&128))return U}}const I=i(0);function p(T,U){if(U===0){T.write(I);return}let V=0;for(let K=U;K!==0;K=K>>>7)V++;const X=O.$ae.alloc(V);for(let K=0;U!==0;K++)X.buffer[K]=U&127,U=U>>>7,U>0&&(X.buffer[K]|=128);T.write(X)}class k{constructor(U){this.b=U,this.a=0}read(U){const V=this.b.slice(this.a,this.a+U);return this.a+=V.byteLength,V}}e.$lh=k;class t{constructor(){this.a=[]}get buffer(){return O.$ae.concat(this.a)}write(U){this.a.push(U)}}e.$mh=t;var a;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(a||(a={}));function i(T){const U=O.$ae.alloc(1);return U.writeUInt8(T,0),U}const n={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},s=typeof Buffer<"u";function r(T,U){if(typeof U>"u")T.write(n.Undefined);else if(typeof U=="string"){const V=O.$ae.fromString(U);T.write(n.String),p(T,V.byteLength),T.write(V)}else if(s&&Buffer.isBuffer(U)){const V=O.$ae.wrap(U);T.write(n.Buffer),p(T,V.byteLength),T.write(V)}else if(U instanceof O.$ae)T.write(n.VSBuffer),p(T,U.byteLength),T.write(U);else if(Array.isArray(U)){T.write(n.Array),p(T,U.length);for(const V of U)r(T,V)}else if(typeof U=="number"&&(U|0)===U)T.write(n.Uint),p(T,U);else{const V=O.$ae.fromString(JSON.stringify(U));T.write(n.Object),p(T,V.byteLength),T.write(V)}}e.$nh=r;function l(T){switch(T.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return T.read(f(T)).toString();case a.Buffer:return T.read(f(T)).buffer;case a.VSBuffer:return T.read(f(T));case a.Array:{const V=f(T),X=[];for(let K=0;K<V;K++)X.push(l(T));return X}case a.Object:return JSON.parse(T.read(f(T)).toString());case a.Int:return f(T)}}e.$oh=l;class P{constructor(U,V,X=null,K=1e3){this.h=U,this.j=V,this.k=X,this.l=K,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(U,V){this.b.set(U,V),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const V=this.o([U.type]);this.k?.logOutgoing(V,0,1,$(U.type));return}case 201:case 202:case 204:case 203:{const V=this.o([U.type,U.id],U.data);this.k?.logOutgoing(V,U.id,1,$(U.type),U.data);return}}}o(U,V=void 0){const X=new t;return r(X,U),r(X,V),this.p(X.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const V=new k(U),X=l(V),K=l(V),Q=X[0];switch(Q){case 100:return this.k?.logIncoming(U.byteLength,X[1],1,`${S(Q)}: ${X[2]}.${X[3]}`,K),this.s({type:Q,id:X[1],channelName:X[2],name:X[3],arg:K});case 102:return this.k?.logIncoming(U.byteLength,X[1],1,`${S(Q)}: ${X[2]}.${X[3]}`,K),this.t({type:Q,id:X[1],channelName:X[2],name:X[3],arg:K});case 101:return this.k?.logIncoming(U.byteLength,X[1],1,`${S(Q)}`),this.u({type:Q,id:X[1]});case 103:return this.k?.logIncoming(U.byteLength,X[1],1,`${S(Q)}`),this.u({type:Q,id:X[1]})}}s(U){const V=this.b.get(U.channelName);if(!V){this.v(U);return}const X=new A.$Wd;let K;try{K=V.call(this.j,U.name,U.arg,X.token)}catch(z){K=Promise.reject(z)}const Q=U.id;K.then(z=>{this.m({id:Q,data:z,type:201})},z=>{z instanceof Error?this.m({id:Q,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:Q,data:z,type:203})}).finally(()=>{F.dispose(),this.d.delete(U.id)});const F=(0,c.$Pc)(()=>X.cancel());this.d.set(U.id,F)}t(U){const V=this.b.get(U.channelName);if(!V){this.v(U);return}const X=U.id,Q=V.listen(this.j,U.name,U.arg)(F=>this.m({id:X,data:F,type:204}));this.d.set(U.id,Q)}u(U){const V=this.d.get(U.id);V&&(V.dispose(),this.d.delete(U.id))}v(U){let V=this.g.get(U.channelName);V||(V=[],this.g.set(U.channelName,V));const X=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:U,timeoutTimer:X})}w(U){const V=this.g.get(U);if(V){for(const X of V)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$ph=P;var y;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class E{constructor(U,V=null){this.l=U,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$Md,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=V}getChannel(U){const V=this;return{call(X,K,Q){return V.a?Promise.reject(new v.$4):V.m(U,X,K,Q)},listen(X,K){return V.a?u.Event.None:V.o(U,X,K)}}}m(U,V,X,K=A.CancellationToken.None){const Q=this.g++,z={id:Q,type:100,channelName:U,name:V,arg:X};if(K.isCancellationRequested)return Promise.reject(new v.$4);let o;return new Promise((M,C)=>{if(K.isCancellationRequested)return C(new v.$4);const Z=()=>{const ge=de=>{switch(de.type){case 201:this.f.delete(Q),M(de.data);break;case 202:{this.f.delete(Q);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,C(me);break}case 203:this.f.delete(Q),C(de.data);break}};this.f.set(Q,ge),this.p(z)};let H=null;this.b===h.Idle?Z():(H=(0,D.$Gg)(ge=>this.u()),H.then(()=>{H=null,Z()}));const ce=()=>{H?(H.cancel(),H=null):this.p({id:Q,type:101}),C(new v.$4)},oe=K.onCancellationRequested(ce);o=(0,c.$Oc)((0,c.$Pc)(ce),oe),this.d.add(o)}).finally(()=>{o.dispose(),this.d.delete(o)})}o(U,V,X){const K=this.g++,F={id:K,type:102,channelName:U,name:V,arg:X};let z=null;const o=new u.$Md({onWillAddFirstListener:()=>{z=(0,D.$Gg)(M=>this.u()),z.then(()=>{z=null,this.d.add(o),this.p(F)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(o),this.p({id:K,type:103}))}}),m=M=>o.fire(M.data);return this.f.set(K,m),o.event}p(U){switch(U.type){case 100:case 102:{const V=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(V,U.id,0,`${S(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const V=this.q([U.type,U.id]);this.j?.logOutgoing(V,U.id,0,S(U.type));return}}}q(U,V=void 0){const X=new t;return r(X,U),r(X,V),this.r(X.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const V=new k(U),X=l(V),K=l(V),Q=X[0];switch(Q){case 200:return this.j?.logIncoming(U.byteLength,0,0,$(Q)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,X[1],0,$(Q),K),this.t({type:X[0],id:X[1],data:K})}}t(U){if(U.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$qh=E,pe([j.$fh],E.prototype,"onDidInitializePromise",null);class N{get connections(){const U=[];return this.f.forEach(V=>U.push(V)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new u.$Md,this.onDidAddConnection=this.g.event,this.h=new u.$Md,this.onDidRemoveConnection=this.h.event,this.j=new c.$Qc,this.j.add(U(({protocol:V,onDidClientDisconnect:X})=>{const K=u.Event.once(V.onMessage);this.j.add(K(Q=>{const F=new k(Q),z=l(F),o=new P(V,z),m=new E(V);this.a.forEach((C,Z)=>o.registerChannel(Z,C));const M={channelServer:o,channelClient:m,ctx:z};this.f.add(M),this.g.fire(M),this.j.add(X(()=>{o.dispose(),m.dispose(),this.f.delete(M),this.h.fire(M)}))}))}))}getChannel(U,V){const X=this;return{call(K,Q,F){let z;if((0,g.$Lf)(V)){const m=(0,L.$3b)(X.connections.filter(V));z=m?Promise.resolve(m):u.Event.toPromise(u.Event.filter(X.onDidAddConnection,V))}else z=V.routeCall(X,K,Q);const o=z.then(m=>m.channelClient.getChannel(U));return x(o).call(K,Q,F)},listen(K,Q){if((0,g.$Lf)(V))return X.k(U,V,K,Q);const F=V.routeEvent(X,K,Q).then(z=>z.channelClient.getChannel(U));return x(F).listen(K,Q)}}}k(U,V,X,K){const Q=this;let F;const z=new u.$Md({onWillAddFirstListener:()=>{F=new c.$Qc;const o=new u.$Sd,m=new Map,M=Z=>{const ce=Z.channelClient.getChannel(U).listen(X,K),oe=o.add(ce);m.set(Z,oe)},C=Z=>{const H=m.get(Z);H&&(H.dispose(),m.delete(Z))};Q.connections.filter(V).forEach(M),u.Event.filter(Q.onDidAddConnection,V)(M,void 0,F),Q.onDidRemoveConnection(C,void 0,F),o.event(z.fire,z,F),F.add(o)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return z.event}registerChannel(U,V){this.a.set(U,V);for(const X of this.f)X.channelServer.registerChannel(U,V)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$rh=N;class W{constructor(U,V,X=null){const K=new t;r(K,V),U.send(K.buffer),this.a=new E(U,X),this.d=new P(U,V,X)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,V){this.d.registerChannel(U,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$sh=W;function x(T){return{call(U,V,X){return T.then(K=>K.call(U,V,X))},listen(U,V){const X=new u.$Vd;return T.then(K=>X.input=K.listen(U,V)),X.event}}}e.$th=x;function _(T){let U=!1;return{call(V,X,K){return U?T.call(V,X,K):(0,D.$Tg)(0).then(()=>U=!0).then(()=>T.call(V,X,K))},listen(V,X){if(U)return T.listen(V,X);const K=new u.$Vd;return(0,D.$Tg)(0).then(()=>U=!0).then(()=>K.input=T.listen(V,X)),K.event}}}e.$uh=_;class ue{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const V of U.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await u.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$vh=ue;var te;(function(T){function U(Q,F,z){const o=Q,m=z&&z.disableMarshalling,M=new Map;for(const C in o)X(C)&&M.set(C,u.Event.buffer(o[C],!0,void 0,F));return new class{listen(C,Z,H){const ce=M.get(Z);if(ce)return ce;if(K(Z)){const oe=o[Z];if(typeof oe=="function")return oe.call(o,H)}throw new v.$ab(`Event not found: ${Z}`)}call(C,Z,H){const ce=o[Z];if(typeof ce=="function"){if(!m&&Array.isArray(H))for(let ge=0;ge<H.length;ge++)H[ge]=(0,b.$kh)(H[ge]);let oe=ce.apply(o,H);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new v.$ab(`Method not found: ${Z}`)}}}T.fromService=U;function V(Q,F){const z=F&&F.disableMarshalling;return new Proxy({},{get(o,m){if(typeof m=="string")return F?.properties?.has(m)?F.properties.get(m):K(m)?function(M){return Q.listen(m,M)}:X(m)?Q.listen(m):async function(...M){let C;F&&!(0,g.$Gf)(F.context)?C=[F.context,...M]:C=M;const Z=await Q.call(m,C);return z?Z:(0,b.$kh)(Z)};throw new v.$ab(`Property not found: ${String(m)}`)}})}T.toService=V;function X(Q){return Q[0]==="o"&&Q[1]==="n"&&R.$Ze(Q.charCodeAt(2))}function K(Q){return/^onDynamic/.test(Q)&&R.$Ze(Q.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const U=T.toString();if(U!=="[object Object]")return U}return T}function ie(T){return Array.isArray(T)?T.map(le):le(T)}function q(T,U,V,X,K,Q,F){F=ie(F);const z=ae[K],o=z[X%z.length];let m=[`%c[${T}]%c[${String(U).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${o}`];/\($/.test(Q)?(m=m.concat(F),m.push(")")):m.push(F),console.log.apply(console,m)}class G{constructor(U,V){this.d=U,this.f=V,this.a=0,this.b=0}logOutgoing(U,V,X,K,Q){this.b+=U,q(this.d,this.b,U,V,X,K,Q)}logIncoming(U,V,X,K,Q){this.a+=U,q(this.f,this.a,U,V,X,K,Q)}}e.$wh=G}),define(ne[85],re([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0;class S extends d.$ph{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>O.$ae.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Up=S;class w{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$Md,this.onDidProcessExit=this.h.event;const I=f&&f.timeout?f.timeout:6e4;this.b=new D.$Pg(I),this.d=null,this.f=null}getChannel(h){const f=this;return{call(I,p,k){return f.k(h,I,p,k)},listen(I,p){return f.l(h,I,p)}}}k(h,f,I,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(v.$5());this.b.cancel();const k=this.n(h),t=(0,D.$Gg)(n=>k.call(f,I,n)),a=p.onCancellationRequested(()=>t.cancel()),i=(0,c.$Pc)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,f,I){if(!this.b)return u.Event.None;this.b.cancel();let p;const k=new u.$Md({onWillAddFirstListener:()=>{p=this.n(h).listen(f,I)(k.fire,k),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return k.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,b.$Ym)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,g.$wl)(f.env),this.d=(0,L.fork)(this.i,h,f);const I=new u.$Md;u.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,j.$Qp)(s)){(0,j.log)(s,`IPC Library: ${this.j.serverName}`);return}I.fire(O.$ae.wrap(Buffer.from(s,"base64")))});const k=this.j.useQueue?(0,R.$yl)(this.d):this.d,t=s=>this.d&&this.d.connected&&k.send(s.buffer.toString("base64")),a=I.event,i={send:t,onMessage:a};this.f=new d.$qh(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,r)=>{process.removeListener("exit",n),this.c.forEach(l=>(0,c.$Mc)(l)),this.c.clear(),s!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Vp=w}),define(ne[86],re([0,1,8,4,2,47,3]),function(J,e,L,D,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.StorageState=e.$To=e.StorageHint=void 0;var v;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function u(g){const d=g;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$To=u;var c;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(c||(e.StorageState=c={}));class b extends O.$Rc{static{this.a=100}constructor(d,S=Object.create(null)){super(),this.r=d,this.s=S,this.b=this.B(new D.$Pd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$Qg(b.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((S,w)=>this.w(w,S)),d.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(d,S){if(this.c===c.Closed)return;let w=!1;(0,j.$Gf)(S)?w=this.f.delete(d):this.f.get(d)!==S&&(this.f.set(d,S),w=!0),w&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,S){const w=this.f.get(d);return(0,j.$Gf)(w)?S:w}getBoolean(d,S){const w=this.get(d);return(0,j.$Gf)(w)?S:w==="true"}getNumber(d,S){const w=this.get(d);return(0,j.$Gf)(w)?S:parseInt(w,10)}getObject(d,S){const w=this.get(d);return(0,j.$Gf)(w)?S:(0,A.$jh)(w)}async set(d,S,w=!1){if(this.c===c.Closed)return;if((0,j.$Gf)(S))return this.delete(d,w);const $=(0,j.$zf)(S)||Array.isArray(S)?(0,A.$ih)(S):String(S);if(this.f.get(d)!==$)return this.f.set(d,$),this.j.set(d,$),this.h.delete(d),this.b.fire({key:d,external:w}),this.D()}async delete(d,S=!1){if(!(this.c===c.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:S}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===v.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===v.STORAGE_IN_MEMORY}}e.$Uo=b;class R{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((S,w)=>this.a.set(w,S)),d.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$Vo=R}),define(ne[87],re([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var O;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...c){switch(c.length){case 1:return(0,D.localize)(0,null,c[0]);case 2:return(0,D.localize)(1,null,c[0],c[1]);case 3:return(0,D.localize)(2,null,c[0],c[1],c[2]);default:return}}const j=(0,D.localize)(3,null),v=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,L.$7)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const R=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:R})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const R=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:R})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const R=this.d,g=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:g};this.g.push({offset:R,lexeme:g,additionalInfo:b}),this.f.push(d)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const R=this.c.substring(this.d,this.e),g=u.b.get(R);g?this.k(g):this.f.push({type:17,lexeme:R,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,R=!1,g=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(v);return}const S=this.c.charCodeAt(b);if(R)R=!1;else if(S===47&&!g){b++;break}else S===91?g=!0:S===92?R=!0:S===93&&(g=!1);b++}for(;b<this.c.length&&u.a.has(this.c.charCodeAt(b));)b++;this.e=b;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=u}),define(ne[109],re([0,1,77,52,15,16,35,17,11]),function(J,e,L,D,O,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.$lc)(O.$bg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$ic)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,v.$ug)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:O.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,v.$ug)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,L.$0l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ic)(this.userDataPath,"logs",d)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,v.$ug)(u.URI.file((0,A.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,v.$ug)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,v.$ug)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,v.$ug)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=j.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$ic)(d,"argv.json")):(0,v.$ug)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.$jc)(d):(0,A.$gc)((0,A.$ic)(O.$bg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?u.URI.file((0,A.$jc)(d)):u.URI.file((0,A.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.$jc)(d);const S=j.env.VSCODE_EXTENSIONS;if(S)return S;const w=j.env.VSCODE_PORTABLE;return w?(0,A.$ic)(w,"extensions"):(0,v.$ug)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(S=>/^[^:/?#]+?:\/\//.test(S)?u.URI.parse(S):u.URI.file((0,A.$gc)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,A.$gc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$$l.test(d))}get extensionLogLevel(){const d=[];for(const S of this.args.log||[]){const w=e.$$l.exec(S);w&&w[1]&&w[2]&&d.push([w[1],w[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,v.$ug)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=j.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$ic)(d,"policy.json")):(0,v.$ug)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,S,w){this.a=d,this.b=S,this.c=w,this.editSessionId=this.args.editSessionId}}e.$_l=c,pe([D.$fh],c.prototype,"appRoot",null),pe([D.$fh],c.prototype,"userHome",null),pe([D.$fh],c.prototype,"userDataPath",null),pe([D.$fh],c.prototype,"appSettingsHome",null),pe([D.$fh],c.prototype,"tmpDir",null),pe([D.$fh],c.prototype,"cacheHome",null),pe([D.$fh],c.prototype,"stateResource",null),pe([D.$fh],c.prototype,"userRoamingDataHome",null),pe([D.$fh],c.prototype,"userDataSyncHome",null),pe([D.$fh],c.prototype,"sync",null),pe([D.$fh],c.prototype,"machineSettingsResource",null),pe([D.$fh],c.prototype,"workspaceStorageHome",null),pe([D.$fh],c.prototype,"localHistoryHome",null),pe([D.$fh],c.prototype,"keyboardLayoutResource",null),pe([D.$fh],c.prototype,"argvResource",null),pe([D.$fh],c.prototype,"isExtensionDevelopment",null),pe([D.$fh],c.prototype,"untitledWorkspacesHome",null),pe([D.$fh],c.prototype,"builtinExtensionsPath",null),pe([D.$fh],c.prototype,"extensionsPath",null),pe([D.$fh],c.prototype,"extensionDevelopmentLocationURI",null),pe([D.$fh],c.prototype,"extensionDevelopmentKind",null),pe([D.$fh],c.prototype,"extensionTestsLocationURI",null),pe([D.$fh],c.prototype,"debugExtensionHost",null),pe([D.$fh],c.prototype,"logLevel",null),pe([D.$fh],c.prototype,"extensionLogLevel",null),pe([D.$fh],c.prototype,"serviceMachineIdResource",null),pe([D.$fh],c.prototype,"disableTelemetry",null),pe([D.$fh],c.prototype,"disableWorkspaceTrust",null),pe([D.$fh],c.prototype,"useInMemorySecretStorage",null),pe([D.$fh],c.prototype,"policyFile",null);function b(g,d){return R(g["inspect-extensions"],g["inspect-brk-extensions"],5870,d,g.debugId,g.extensionEnvironment)}e.$am=b;function R(g,d,S,w,$,h){const I=Number(d||g)||(w?null:S),p=I?!!d:!1;let k;if(h)try{k=JSON.parse(h)}catch{}return{port:I,break:p,debugId:$,env:k}}e.$bm=R}),function(){"use strict";function J(e,L,D){function O(j,v){const u=A(j,v),c=[u];return e.isAbsolute(u)||c.unshift(D),e.resolve(...c)}function A(j,v){process.env.VSCODE_DEV&&(v="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,v);const b=j["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(R,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,v)}return{getUserDataPath:O}}if(typeof define=="function")define(ne[110],re([165,33,35]),function(e,L,D){return J(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,33,109,110]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=e.$cm=void 0;class A extends D.$_l{constructor(c,b){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,O.getUserDataPath)(c,b.nameShort)},b)}}e.$cm=A;function j(u,c){return(0,D.$bm)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}e.$dm=j;function v(u,c){return(0,D.$bm)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}e.$em=v}),define(ne[112],re([0,1,3,94]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=void 0;function O(j,v,u,c){try{A(j,v,u,c)}catch(b){j.error(b?.message??b)}return v}e.$qp=O;function A(j,v,u,c){const b=(R,g,d)=>{const S=R[g];if((0,L.$xf)(S)){const w=S,$=w.length;if($>1&&w[0]==="%"&&w[$-1]==="%"){const h=w.substr(1,$-2);let f=u[h];f===void 0&&c&&(f=c[h]);const I=typeof f=="string"?f:f?.message,p=c?.[h],k=typeof p=="string"?p:p?.message;if(!I){k||j.warn(`[${v.name}]: ${(0,D.localize)(0,null,h)}`);return}if(d&&(g==="title"||g==="category")&&k&&k!==I){const t={value:I,original:k};R[g]=t}else R[g]=I}}else if((0,L.$zf)(S))for(const w in S)S.hasOwnProperty(w)&&(w==="commands"?b(S,w,!0):b(S,w,d));else if(Array.isArray(S))for(let w=0;w<S.length;w++)b(S,w,d)};for(const R in v)v.hasOwnProperty(R)&&b(v,R)}}),define(ne[48],re([0,1,17,54,98,42]),function(J,e,L,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function u(h){return h=h.trim(),h==="*"||j.test(h)}e.$Eo=u;function c(h){if(!u(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(j);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$Fo=c;function b(h){if(!h)return null;const f=h.majorBase,I=h.majorMustEqual,p=h.minorBase;let k=h.minorMustEqual;const t=h.patchBase;let a=h.patchMustEqual;h.hasCaret&&(f===0||(k=!1),a=!1);let i=0;if(h.preRelease){const n=v.exec(h.preRelease);if(n){const[,s,r,l]=n;i=Date.UTC(Number(s),Number(r)-1,Number(l))}}return{majorBase:f,majorMustEqual:I,minorBase:p,minorMustEqual:k,patchBase:t,patchMustEqual:a,isMinimum:h.hasGreaterEquals,notBefore:i}}e.$Go=b;function R(h,f,I){let p;typeof h=="string"?p=b(c(h)):p=h;let k;f instanceof Date?k=f.getTime():typeof f=="string"&&(k=new Date(f).getTime());let t;if(typeof I=="string"?t=b(c(I)):t=I,!p||!t)return!1;const a=p.majorBase,i=p.minorBase,n=p.patchBase;let s=t.majorBase,r=t.minorBase,l=t.patchBase;const P=t.notBefore;let y=t.majorMustEqual,E=t.minorMustEqual,N=t.patchMustEqual;return t.isMinimum?a>s?!0:a<s?!1:i>r?!0:i<r||k&&k<P?!1:n>=l:(a===1&&s===0&&(!y||!E||!N)&&(s=1,r=0,l=0,y=!0,E=!1,N=!1),a<s?!1:a>s?!y:i<r?!1:i>r?!E:n<l?!1:n>l?!N:!(k&&k<P))}e.$Ho=R;function g(h,f,I,p,k){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([D.default.Error,O.localize(0,null)]),t;if(typeof p.name!="string")return t.push([D.default.Error,O.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([D.default.Error,O.localize(2,null,"version")]),t;if(!p.engines)return t.push([D.default.Error,O.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([D.default.Error,O.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!$(p.extensionDependencies))return t.push([D.default.Error,O.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!$(p.activationEvents))return t.push([D.default.Error,O.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([D.default.Error,O.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([D.default.Warning,O.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([D.default.Error,O.localize(9,null,"main")]),t;{const n=(0,L.$ug)(I,p.main);(0,L.$og)(n,I)||t.push([D.default.Warning,O.localize(10,null,n.path,I.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([D.default.Error,O.localize(11,null,"browser")]),t;{const n=(0,L.$ug)(I,p.browser);(0,L.$og)(n,I)||t.push([D.default.Warning,O.localize(12,null,n.path,I.path)])}}if(!A.valid(p.version))return t.push([D.default.Error,O.localize(13,null)]),t;const a=[];if(!d(h,f,p,k,a))for(const n of a)t.push([D.default.Error,n]);return t}e.$Io=g;function d(h,f,I,p,k){return p||typeof I.main>"u"&&typeof I.browser>"u"?!0:w(h,f,I.engines.vscode,k)}e.$Jo=d;function S(h,f,I){return h==="*"||w(f,I,h)}e.$Ko=S;function w(h,f,I,p=[]){const k=b(c(I));if(!k)return p.push(O.localize(14,null,I)),!1;if(k.majorBase===0){if(!k.majorMustEqual||!k.minorMustEqual)return p.push(O.localize(15,null,I)),!1}else if(!k.majorMustEqual)return p.push(O.localize(16,null,I)),!1;return R(h,f,k)?!0:(p.push(O.localize(17,null,h,I)),!1)}function $(h){if(!Array.isArray(h))return!1;for(let f=0,I=h.length;f<I;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,28]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=void 0;async function O(A,j,v){let u=v&&v.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const b=(await j.readFile(A.serviceMachineIdResource)).value.toString();u=(0,D.$cg)(b)?b:null}catch{u=null}if(!u){u=(0,D.$dg)();try{await j.writeFile(A.serviceMachineIdResource,L.$ae.fromString(u))}catch{}}return v?.store("storage.serviceMachineId",u,-1,1),u}e.$5o=O}),define(ne[49],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class L{constructor(O,A=[],j=!1){this.ctor=O,this.staticArguments=A,this.supportsDelayedInstantiation=j}}e.$Kh=L}),define(ne[114],re([0,1,49]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=e.InstantiationType=void 0;const D=[];var O;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})(O||(e.InstantiationType=O={}));function A(v,u,c){u instanceof L.$Kh||(u=new L.$Kh(u,[],!!c)),D.push([v,u])}e.$pr=A;function j(){return D}e.$qr=j}),define(ne[115],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0;class L{constructor(A,j){this.key=A,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$7p=L;class D{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const j of this.a.values())j.outgoing.size===0&&A.push(j);return A}insertEdge(A,j){const v=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(j);v.outgoing.set(u.key,u),u.incoming.set(v.key,v)}removeNode(A){const j=this.b(A);this.a.delete(j);for(const v of this.a.values())v.outgoing.delete(j),v.incoming.delete(j)}lookupOrInsertNode(A){const j=this.b(A);let v=this.a.get(j);return v||(v=new L(j,A),this.a.set(j,v)),v}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[j,v]of this.a)A.push(`${j}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,j]of this.a){const v=new Set([A]),u=this.c(j,v);if(u)return u}}c(A,j){for(const[v,u]of A.outgoing){if(j.has(v))return[...j,v].join(" -> ");j.add(v);const c=this.c(u,j);if(c)return c;j.delete(v)}}}e.$8p=D}),define(ne[25],re([0,1,3,11,10]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,O.$Nh)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof D.URI)}e.$ii=A;function j(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof D.URI)}e.$ji=j;var v;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function u(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=u;function c(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$li=c;function b(h,f){const I=Object.create(null);for(const p in h)R(I,p,h[p],f);return I}e.$mi=b;function R(h,f,I,p){const k=f.split("."),t=k.pop();let a=h;for(let i=0;i<k.length;i++){const n=k[i];let s=a[n];switch(typeof s){case"undefined":s=a[n]=Object.create(null);break;case"object":break;default:p(`Ignoring ${f} as ${k.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}a=s}if(typeof a=="object"&&a!==null)try{a[t]=I}catch{p(`Ignoring ${f} as ${k.join(".")} is ${JSON.stringify(a)}`)}else p(`Ignoring ${f} as ${k.join(".")} is ${JSON.stringify(a)}`)}e.$ni=R;function g(h,f){const I=f.split(".");d(h,I)}e.$oi=g;function d(h,f){const I=f.shift();if(f.length===0){delete h[I];return}if(Object.keys(h).indexOf(I)!==-1){const p=h[I];typeof p=="object"&&!Array.isArray(p)&&(d(p,f),Object.keys(p).length===0&&delete h[I])}}function S(h,f,I){function p(a,i){let n=a;for(const s of i){if(typeof n!="object"||n===null)return;n=n[s]}return n}const k=f.split("."),t=p(h,k);return typeof t>"u"?I:t}e.$pi=S;function w(h,f,I){Object.keys(f).forEach(p=>{p!=="__proto__"&&(p in h?L.$zf(h[p])&&L.$zf(f[p])?w(h[p],f[p],I):I&&(h[p]=f[p]):h[p]=f[p])})}e.$qi=w;function $(h){return h.replace(/[\[\]]/g,"")}e.$ri=$}),define(ne[116],re([0,1,13,29,108,10,89,9]),function(J,e,L,D,O,A,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$k),u.set("isLinux",L.$l),u.set("isWindows",L.$j),u.set("isWeb",L.$p),u.set("isMacNative",L.$k&&!L.$p),u.set("isEdge",L.$H),u.set("isFirefox",L.$F),u.set("isChrome",L.$E),u.set("isSafari",L.$G);function c(z,o){if(u.get(z)!==void 0)throw(0,v.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(z,o)}e.$Ji=c;const b=Object.prototype.hasOwnProperty;var R;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(R||(e.ContextKeyExprType=R={}));const g={regexParsingWithErrorRecovery:!0},d=(0,j.localize)(0,null),S=(0,j.localize)(1,null),w=(0,j.localize)(2,null),$=(0,j.localize)(3,null),h=(0,j.localize)(4,null),f=(0,j.localize)(5,null),I=(0,j.localize)(6,null),p=(0,j.localize)(7,null);class k{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(o=g){this.k=o,this.d=new O.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(o){if(o===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(o).scan(),this.g=0,this.h=[];try{const m=this.l();if(!this.E()){const M=this.D(),C=M.type===17?f:void 0;throw this.h.push({message:h,offset:M.offset,lexeme:O.$Ii.getLexeme(M),additionalInfo:C}),k.c}return m}catch(m){if(m!==k.c)throw m;return}}l(){return this.m()}m(){const o=[this.o()];for(;this.y(16);){const m=this.o();o.push(m)}return o.length===1?o[0]:t.or(...o)}o(){const o=[this.s()];for(;this.y(15);){const m=this.s();o.push(m)}return o.length===1?o[0]:t.and(...o)}s(){if(this.y(2)){const o=this.D();switch(o.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const m=this.l();return this.A(1,$),m?.negate()}case 17:return this.z(),W.create(o.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",o)}}return this.t()}t(){const o=this.D();switch(o.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const m=this.l();return this.A(1,$),m}case 17:{const m=o.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const Z=C.lexeme,H=Z.lastIndexOf("/"),ce=H===Z.length-1?void 0:this.w(Z.substring(H+1));let oe;try{oe=new RegExp(Z.substring(1,H),ce)}catch{throw this.B("REGEX",C)}return le.create(m,oe)}switch(C.type){case 10:case 19:{const Z=[C.lexeme];this.z();let H=this.D(),ce=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let fe=0;fe<H.lexeme.length;fe++)H.lexeme.charCodeAt(fe)===40?ce++:C.lexeme.charCodeAt(fe)===41&&ce--}if(ce<0)break;Z.push(O.$Ii.getLexeme(H)),this.z(),H=this.D()}const oe=Z.join(""),ge=oe.lastIndexOf("/"),de=ge===oe.length-1?void 0:this.w(oe.substring(ge+1));let me;try{me=new RegExp(oe.substring(1,ge),de)}catch{throw this.B("REGEX",C)}return t.regex(m,me)}case 18:{const Z=C.lexeme;this.z();let H=null;if(!(0,D.$Ae)(Z)){const ce=Z.indexOf("/"),oe=Z.lastIndexOf("/");if(ce!==oe&&ce>=0){const ge=Z.slice(ce+1,oe),de=Z[oe+1]==="i"?"i":"";try{H=new RegExp(ge,de)}catch{throw this.B("REGEX",C)}}}if(H===null)throw this.B("REGEX",C);return le.create(m,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const C=this.u();return t.notIn(m,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return t.equals(m,C);switch(C){case"true":return t.has(m);case"false":return t.not(m);default:return t.equals(m,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return t.notEquals(m,C);switch(C){case"true":return t.not(m);case"false":return t.has(m);default:return t.notEquals(m,C)}}case 5:return this.z(),te.create(m,this.u());case 6:return this.z(),ae.create(m,this.u());case 7:return this.z(),_.create(m,this.u());case 8:return this.z(),ue.create(m,this.u());case 13:return this.z(),t.in(m,this.u());default:return t.has(m)}}case 20:throw this.h.push({message:I,offset:o.offset,lexeme:"",additionalInfo:p}),k.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const o=this.D();switch(o.type){case 17:case 18:return this.z(),o.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(o){return o.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(o){return this.C(o)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(o,m){if(this.C(o))return this.z();throw this.B(m,this.D())}B(o,m,M){const C=(0,j.localize)(8,null,o,O.$Ii.getLexeme(m)),Z=m.offset,H=O.$Ii.getLexeme(m);return this.h.push({message:C,offset:Z,lexeme:H,additionalInfo:M}),k.c}C(o){return this.D().type===o}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=k;class t{static false(){return s.INSTANCE}static true(){return r.INSTANCE}static has(o){return l.create(o)}static equals(o,m){return P.create(o,m)}static notEquals(o,m){return N.create(o,m)}static regex(o,m){return le.create(o,m)}static in(o,m){return y.create(o,m)}static notIn(o,m){return E.create(o,m)}static not(o){return W.create(o)}static and(...o){return G.create(o,null,!0)}static or(...o){return T.create(o,null,!0)}static greater(o,m){return _.create(o,m)}static greaterEquals(o,m){return ue.create(o,m)}static smaller(o,m){return te.create(o,m)}static smallerEquals(o,m){return ae.create(o,m)}static{this.c=new k({regexParsingWithErrorRecovery:!1})}static deserialize(o){return o==null?void 0:this.c.parse(o)}}e.$Li=t;function a(z){const o=new k({regexParsingWithErrorRecovery:!1});return z.map(m=>(o.parse(m),o.lexingErrors.length>0?o.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,j.localize)(9,null,M.additionalInfo):(0,j.localize)(10,null),offset:M.offset,length:M.lexeme.length})):o.parsingErrors.length>0?o.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}e.$Mi=a;function i(z,o){const m=z?z.substituteConstants():void 0,M=o?o.substituteConstants():void 0;return!m&&!M?!0:!m||!M?!1:m.equals(M)}e.$Ni=i;function n(z,o){return z.cmp(o)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return r.INSTANCE}}e.$Oi=s;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}substituteConstants(){return this}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return s.INSTANCE}}e.$Pi=r;class l{static create(o,m=null){const M=u.get(o);return typeof M=="boolean"?M?r.INSTANCE:s.INSTANCE:new l(o,m)}constructor(o,m){this.key=o,this.c=m,this.type=2}cmp(o){return o.type!==this.type?this.type-o.type:V(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}substituteConstants(){const o=u.get(this.key);return typeof o=="boolean"?o?r.INSTANCE:s.INSTANCE:this}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.$Qi=l;class P{static create(o,m,M=null){if(typeof m=="boolean")return m?l.create(o,M):W.create(o,M);const C=u.get(o);return typeof C=="boolean"?m===(C?"true":"false")?r.INSTANCE:s.INSTANCE:new P(o,m,M)}constructor(o,m,M){this.c=o,this.d=m,this.f=M,this.type=4}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){const o=u.get(this.c);if(typeof o=="boolean"){const m=o?"true":"false";return this.d===m?r.INSTANCE:s.INSTANCE}return this}evaluate(o){return o.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(o){return o.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Ri=P;class y{static create(o,m){return new y(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=10,this.c=null}cmp(o){return o.type!==this.type?this.type-o.type:X(this.d,this.f,o.d,o.f)}equals(o){return o.type===this.type?this.d===o.d&&this.f===o.f:!1}substituteConstants(){return this}evaluate(o){const m=o.getValue(this.f),M=o.getValue(this.d);return Array.isArray(m)?m.includes(M):typeof M=="string"&&typeof m=="object"&&m!==null?b.call(m,M):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(o){return o.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Si=y;class E{static create(o,m){return new E(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=11,this.c=y.create(o,m)}cmp(o){return o.type!==this.type?this.type-o.type:this.c.cmp(o.c)}equals(o){return o.type===this.type?this.c.equals(o.c):!1}substituteConstants(){return this}evaluate(o){return!this.c.evaluate(o)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(o){return o.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=E;class N{static create(o,m,M=null){if(typeof m=="boolean")return m?W.create(o,M):l.create(o,M);const C=u.get(o);return typeof C=="boolean"?m===(C?"true":"false")?s.INSTANCE:r.INSTANCE:new N(o,m,M)}constructor(o,m,M){this.c=o,this.d=m,this.f=M,this.type=5}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){const o=u.get(this.c);if(typeof o=="boolean"){const m=o?"true":"false";return this.d===m?s.INSTANCE:r.INSTANCE}return this}evaluate(o){return o.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(o){return o.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Ui=N;class W{static create(o,m=null){const M=u.get(o);return typeof M=="boolean"?M?s.INSTANCE:r.INSTANCE:new W(o,m)}constructor(o,m){this.c=o,this.d=m,this.type=3}cmp(o){return o.type!==this.type?this.type-o.type:V(this.c,o.c)}equals(o){return o.type===this.type?this.c===o.c:!1}substituteConstants(){const o=u.get(this.c);return typeof o=="boolean"?o?s.INSTANCE:r.INSTANCE:this}evaluate(o){return!o.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(o){return o.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Vi=W;function x(z,o){if(typeof z=="string"){const m=parseFloat(z);isNaN(m)||(z=m)}return typeof z=="string"||typeof z=="number"?o(z):s.INSTANCE}class _{static create(o,m,M=null){return x(m,C=>new _(o,C,M))}constructor(o,m,M){this.c=o,this.d=m,this.f=M,this.type=12}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(o){return o.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Wi=_;class ue{static create(o,m,M=null){return x(m,C=>new ue(o,C,M))}constructor(o,m,M){this.c=o,this.d=m,this.f=M,this.type=13}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(o){return o.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Xi=ue;class te{static create(o,m,M=null){return x(m,C=>new te(o,C,M))}constructor(o,m,M){this.c=o,this.d=m,this.f=M,this.type=14}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(o){return o.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Yi=te;class ae{static create(o,m,M=null){return x(m,C=>new ae(o,C,M))}constructor(o,m,M){this.c=o,this.d=m,this.f=M,this.type=15}cmp(o){return o.type!==this.type?this.type-o.type:X(this.c,this.d,o.c,o.d)}equals(o){return o.type===this.type?this.c===o.c&&this.d===o.d:!1}substituteConstants(){return this}evaluate(o){return typeof this.d=="string"?!1:parseFloat(o.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(o){return o.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Zi=ae;class le{static create(o,m){return new le(o,m)}constructor(o,m){this.d=o,this.f=m,this.type=7,this.c=null}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.d<o.d)return-1;if(this.d>o.d)return 1;const m=this.f?this.f.source:"",M=o.f?o.f.source:"";return m<M?-1:m>M?1:0}equals(o){if(o.type===this.type){const m=this.f?this.f.source:"",M=o.f?o.f.source:"";return this.d===o.d&&m===M}return!1}substituteConstants(){return this}evaluate(o){const m=o.getValue(this.d);return this.f?this.f.test(m):!1}serialize(){const o=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${o}`}keys(){return[this.d]}map(o){return o.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$1i=le;class ie{static create(o){return new ie(o)}constructor(o){this.c=o,this.type=8}cmp(o){return o.type!==this.type?this.type-o.type:this.c.cmp(o.c)}equals(o){return o.type===this.type?this.c.equals(o.c):!1}substituteConstants(){return this}evaluate(o){return!this.c.evaluate(o)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(o){return new ie(this.c.map(o))}negate(){return this.c}}e.$2i=ie;function q(z){let o=null;for(let m=0,M=z.length;m<M;m++){const C=z[m].substituteConstants();if(z[m]!==C&&o===null){o=[];for(let Z=0;Z<m;Z++)o[Z]=z[Z]}o!==null&&(o[m]=C)}return o===null?z:o}class G{static create(o,m,M){return G.d(o,m,M)}constructor(o,m){this.expr=o,this.c=m,this.type=6}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let m=0,M=this.expr.length;m<M;m++){const C=n(this.expr[m],o.expr[m]);if(C!==0)return C}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let m=0,M=this.expr.length;m<M;m++)if(!this.expr[m].equals(o.expr[m]))return!1;return!0}return!1}substituteConstants(){const o=q(this.expr);return o===this.expr?this:G.create(o,this.c,!1)}evaluate(o){for(let m=0,M=this.expr.length;m<M;m++)if(!this.expr[m].evaluate(o))return!1;return!0}static d(o,m,M){const C=[];let Z=!1;for(const H of o)if(H){if(H.type===1){Z=!0;continue}if(H.type===0)return s.INSTANCE;if(H.type===6){C.push(...H.expr);continue}C.push(H)}if(C.length===0&&Z)return r.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(n);for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];for(;C.length>1;){const H=C[C.length-1];if(H.type!==9)break;C.pop();const ce=C.pop(),oe=C.length===0,ge=T.create(H.expr.map(de=>G.create([de,ce],null,M)),null,oe);ge&&(C.push(ge),C.sort(n))}if(C.length===1)return C[0];if(M){for(let H=0;H<C.length;H++)for(let ce=H+1;ce<C.length;ce++)if(C[H].negate().equals(C[ce]))return s.INSTANCE;if(C.length===1)return C[0]}return new G(C,m)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(const m of this.expr)o.push(...m.keys());return o}map(o){return new G(this.expr.map(m=>m.map(o)),null)}negate(){if(!this.c){const o=[];for(const m of this.expr)o.push(m.negate());this.c=T.create(o,this,!0)}return this.c}}e.$3i=G;class T{static create(o,m,M){return T.d(o,m,M)}constructor(o,m){this.expr=o,this.c=m,this.type=9}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let m=0,M=this.expr.length;m<M;m++){const C=n(this.expr[m],o.expr[m]);if(C!==0)return C}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let m=0,M=this.expr.length;m<M;m++)if(!this.expr[m].equals(o.expr[m]))return!1;return!0}return!1}substituteConstants(){const o=q(this.expr);return o===this.expr?this:T.create(o,this.c,!1)}evaluate(o){for(let m=0,M=this.expr.length;m<M;m++)if(this.expr[m].evaluate(o))return!0;return!1}static d(o,m,M){let C=[],Z=!1;if(o){for(let H=0,ce=o.length;H<ce;H++){const oe=o[H];if(oe){if(oe.type===0){Z=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){C=C.concat(oe.expr);continue}C.push(oe)}}if(C.length===0&&Z)return s.INSTANCE;C.sort(n)}if(C.length!==0){if(C.length===1)return C[0];for(let H=1;H<C.length;H++)C[H-1].equals(C[H])&&(C.splice(H,1),H--);if(C.length===1)return C[0];if(M){for(let H=0;H<C.length;H++)for(let ce=H+1;ce<C.length;ce++)if(C[H].negate().equals(C[ce]))return r.INSTANCE;if(C.length===1)return C[0]}return new T(C,m)}}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(const m of this.expr)o.push(...m.keys());return o}map(o){return new T(this.expr.map(m=>m.map(o)),null)}negate(){if(!this.c){const o=[];for(const m of this.expr)o.push(m.negate());for(;o.length>1;){const m=o.shift(),M=o.shift(),C=[];for(const Z of F(m))for(const H of F(M))C.push(G.create([Z,H],null,!1));o.unshift(T.create(C,null,!1))}this.c=T.create(o,this,!0)}return this.c}}e.$4i=T;class U extends l{static{this.d=[]}static all(){return U.d.values()}constructor(o,m,M){super(o,null),this.f=m,typeof M=="object"?U.d.push({...M,key:o}):M!==!0&&U.d.push({key:o,description:M,type:m!=null?typeof m:void 0})}bindTo(o){return o.createKey(this.key,this.f)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(o){return P.create(this.key,o)}notEqualsTo(o){return N.create(this.key,o)}}e.$5i=U,e.$6i=(0,A.$Nh)("contextKeyService");function V(z,o){return z<o?-1:z>o?1:0}function X(z,o,m,M){return z<m?-1:z>m?1:o<M?-1:o>M?1:0}function K(z,o){if(z.type===0||o.type===1)return!0;if(z.type===9)return o.type===9?Q(z.expr,o.expr):!1;if(o.type===9){for(const m of o.expr)if(K(z,m))return!0;return!1}if(z.type===6){if(o.type===6)return Q(o.expr,z.expr);for(const m of z.expr)if(K(m,o))return!0;return!1}return z.equals(o)}e.$7i=K;function Q(z,o){let m=0,M=0;for(;m<z.length&&M<o.length;){const C=z[m].cmp(o[M]);if(C<0)return!1;C===0&&m++,M++}return m===z.length}function F(z){return z.type===9?z.expr:[z]}}),define(ne[59],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0,e.$Gn=(0,L.$Nh)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,L.$Nh)("environmentService"),e.$Vh=(0,L.$Oh)(e.$Uh)}),define(ne[21],re([0,1,92,10]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$3n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=void 0,e.$Pn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Qn=new RegExp(e.$Pn),e.$Rn="__web_extension",e.$Sn="skipWalkthrough",e.$Tn="extensionsSync",e.$Un="dependecyOrPackExtensionInstall";function O(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Vn=O;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Wn=A;function j(f,I){switch(f){case 3:return I==="x64"?"win32-x64":I==="ia32"?"win32-ia32":I==="arm64"?"win32-arm64":"unknown";case 2:return I==="x64"?"linux-x64":I==="arm64"?"linux-arm64":I==="arm"?"linux-armhf":"unknown";case"alpine":return I==="x64"?"alpine-x64":I==="arm64"?"alpine-arm64":"unknown";case 1:return I==="x64"?"darwin-x64":I==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Xn=j;function v(f,I){return I==="web"&&!f.includes("web")}e.$Yn=v;function u(f,I,p){return v(I,p)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===p?!0:c(p).includes(f)}e.$Zn=u;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$1n=c;function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$2n=b;var R;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var g;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var d;(function(f){f.Install="install",f.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var S;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$3n=(0,D.$Nh)("extensionGalleryService");var w;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var $;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class h extends Error{constructor(I,p){super(I),this.code=p,this.name=p}}e.$4n=h,e.$5n=(0,D.$Nh)("extensionManagementService"),e.$6n="extensionsIdentifiers/disabled",e.$7n="extensionsIdentifiers/enabled",e.$8n=(0,D.$Nh)("IGlobalExtensionEnablementService"),e.$9n=(0,D.$Nh)("IExtensionTipsService"),e.$0n=(0,L.localize)(0,null),e.$$n={value:e.$0n,original:"Extensions"},e.$_n={value:(0,L.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=void 0,e.$0o=(0,L.$Nh)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((A,j)=>J(["node-vsce-sign"],async v=>A(v),j))),this.a}async verify(A,j,v){let u;try{u=await this.b()}catch{return!1}return u.verify(A,j,v)}}e.$$o=D}),define(ne[61],re([0,1,14,9,100,12]),function(J,e,L,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;async function j(b,R,g,d,S,w){let $;try{await v(b,R,g,d,S,w)}catch(h){$=h}finally{$&&S.errorTransformer&&($=S.errorTransformer($)),typeof $<"u"&&g.error($),g.end()}}e.$Fp=j;async function v(b,R,g,d,S,w){u(w);const $=await b.open(R,{create:!1});try{u(w);let h=0,f=0,I=S&&typeof S.length=="number"?S.length:void 0,p=L.$ae.alloc(Math.min(S.bufferSize,typeof I=="number"?I:S.bufferSize)),k=S&&typeof S.position=="number"?S.position:0,t=0;do f=await b.read($,k,p.buffer,t,p.byteLength-t),k+=f,t+=f,h+=f,typeof I=="number"&&(I-=f),t===p.byteLength&&(await g.write(d(p)),p=L.$ae.alloc(Math.min(S.bufferSize,typeof I=="number"?I:S.bufferSize)),t=0);while(f>0&&(typeof I!="number"||I>0)&&u(w)&&c(h,S));if(t>0){let a=t;typeof I=="number"&&(a=Math.min(t,I)),g.write(d(p.slice(0,a)))}}catch(h){throw(0,A.$jk)(h)}finally{await b.close($)}}function u(b){if(b.isCancellationRequested)throw(0,D.$5)();return!0}function c(b,R){if(typeof R?.limits?.size=="number"&&b>R.limits.size)throw(0,A.$ik)((0,O.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,13,167]),function(J,e,L,D,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;class v extends O.$Rc{constructor(){super(...arguments),this.a=this.B(new L.$Md),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Md),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const b=this.j(c),R=b.filter(d=>{const S=this.c.get(d.path);return S?!(0,D.$yj)(S.request.excludes,d.excludes)||!(0,D.$yj)(S.request.includes,d.includes):!0}),g=Array.from(this.c.values()).filter(({request:d})=>!b.find(S=>S.path===d.path&&(0,D.$yj)(S.excludes,d.excludes)&&(0,D.$yj)(S.includes,d.includes))).map(({request:d})=>d.path);R.length&&this.m(`Request to start watching: ${R.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),g.length&&this.m(`Request to stop watching: ${g.join(",")}`);for(const d of g)this.h(d);for(const d of R)this.g(d)}g(c){const b=new j.$2p(c,g=>this.a.fire(g),g=>this.b.fire(g),this.f),R={request:c,instance:b};this.c.set(c.path,R)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const b=this.c.get(c);b&&(this.c.delete(c),b.instance.dispose())}j(c){const b=new Map;for(const R of c){const g=A.$l?R.path:R.path.toLowerCase();b.set(g,R)}return Array.from(b.values())}async setVerboseLogging(c){this.f=c;for(const[,b]of this.c)b.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,b){return b?`[File Watcher (node.js)] ${c} (path: ${b.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$4p=v}),define(ne[118],re([0,1,62,117]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;class O extends L.$Jp{constructor(j,v,u){super(j,v,u),this.s()}r(j){return j.add(new D.$4p)}}e.$5p=O}),define(ne[119],re([0,1,15,57,85,62]),function(J,e,L,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;class j extends A.$Kp{constructor(u,c,b){super(u,c,b),this.s()}r(u){const c=u.add(new O.$Vp(L.$bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:b,signal:R})=>this.t(`terminated by itself with code ${b}, signal: ${R}`))),D.ProxyChannel.toService((0,D.$uh)(c.getChannel("watcher")))}}e.$Wp=j}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class L{constructor(...O){this.a=new Map;for(const[A,j]of O)this.set(A,j)}set(O,A){const j=this.a.get(O);return this.a.set(O,A),j}has(O){return this.a.has(O)}get(O){return this.a.get(O)}}e.$Lh=L}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(J,e,L,D,O,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0;const b=!1;class R extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class g{constructor($=new u.$Lh,h=!1,f,I=b){this.f=$,this.g=h,this.h=f,this.i=I,this.o=new Set,this.f.set(v.$Mh,this),this._globalGraph=I?f?._globalGraph??new j.$8p(p=>p):void 0}createChild($){return new g($,this.g,this,this.i)}invokeFunction($,...h){const f=S.traceInvocation(this.i,$);let I=!1;try{return $({get:k=>{if(I)throw(0,D.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(k,f);if(!t)throw new Error(`[invokeFunction] unknown service '${k}'`);return t}},...h)}finally{I=!0,f.stop()}}createInstance($,...h){let f,I;return $ instanceof A.$Kh?(f=S.traceCreation(this.i,$.ctor),I=this.j($.ctor,$.staticArguments.concat(h),f)):(f=S.traceCreation(this.i,$),I=this.j($,h,f)),f.stop(),I}j($,h=[],f){const I=v._util.getServiceDependencies($).sort((t,a)=>t.index-a.index),p=[];for(const t of I){const a=this.m(t.id,f);a||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(a)}const k=I.length>0?I[0].index:h.length;if(h.length!==k){console.trace(`[createInstance] First service dependency of ${$.name} at position ${k+1} conflicts with ${h.length} static arguments`);const t=k-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,k)}return Reflect.construct($,h.concat(p))}k($,h){if(this.f.get($)instanceof A.$Kh)this.f.set($,h);else if(this.h)this.h.k($,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const h=this.f.get($);return!h&&this.h?this.h.l($):h}m($,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const f=this.l($);return f instanceof A.$Kh?this.q($,f,h.branch($,!0)):(h.branch($,!1),f)}q($,h,f){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,h,f)}finally{this.o.delete($)}}r($,h,f){const I=new j.$8p(t=>t.id.toString());let p=0;const k=[{id:$,desc:h,_trace:f}];for(;k.length;){const t=k.pop();if(I.lookupOrInsertNode(t),p++>1e3)throw new R(I);for(const a of v._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${$} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof A.$Kh){const n={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};I.insertEdge(t,n),k.push(n)}}}for(;;){const t=I.roots();if(t.length===0){if(!I.isEmpty())throw new R(I);break}for(const{data:a}of t){if(this.l(a.id)instanceof A.$Kh){const n=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,n)}I.removeNode(a)}}return this.l($)}s($,h,f=[],I,p){if(this.f.get($)instanceof A.$Kh)return this.t($,h,f,I,p);if(this.h)return this.h.s($,h,f,I,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t($,h,f=[],I,p){if(I){const k=new g(void 0,this.g,this,this.i);k.c=String($);const t=new Map,a=new L.$0g(()=>{const i=k.j(h,f,p);for(const[n,s]of t){const r=i[n];if(typeof r=="function")for(const l of s)r.apply(i,l)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=t.get(n);return l||(l=new c.$1c,t.set(n,l)),(y,E,N)=>{const W=l.push([y,E,N]);return(0,O.$Pc)(W)}}if(n in i)return i[n];const s=a.value;let r=s[n];return typeof r!="function"||(r=r.bind(s),i[n]=r),r},set(i,n,s){return a.value[n]=s,!0},getPrototypeOf(i){return h.prototype}})}else return this.j(h,f,p)}u($,h){if(h&&console.warn($),this.g)throw new Error($)}}e.$9p=g;var d;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(d||(d={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,h){return $?new S(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation($,h){return $?new S(1,h.name):S.c}static{this.f=0}constructor($,h){this.type=$,this.name=h,this.g=Date.now(),this.h=[]}branch($,h){const f=new S(3,$.toString());return this.h.push([$,h,f]),f}stop(){const $=Date.now()-this.g;S.f+=$;let h=!1;function f(p,k){const t=[],a=new Array(p+1).join("	");for(const[i,n,s]of k.h)if(n&&s){h=!0,t.push(`${a}CREATES -> ${i}`);const r=f(p+1,s);r&&t.push(r)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const I=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];($>2||h)&&S.all.add(I.join(`
`))}}e.$0p=S});var se=this&&this.__param||function(J,e){return function(L,D){e(L,D,J)}};define(ne[64],re([0,1,20,2,13,102,21,10]),function(J,e,L,D,O,A,j,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=e.$Kq=void 0;function u(b){return b.tags.find(R=>R.startsWith("lp-"))?.split("lp-")[1]}e.$Kq=u,e.$Lq=(0,v.$Nh)("languagePackService");let c=class extends D.$Rc{constructor(R){super(),this.c=R}async getAvailableLanguages(){const R=new L.$Wd;setTimeout(()=>R.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},R.token)}catch{return[]}const S=g.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some($=>$.startsWith("lp-"))).map(w=>{const $=w.properties.localizedLanguages?.[0],h=u(w);return{...this.f(h,$,w),extensionId:w.identifier.id,galleryExtension:w}});return S.push(this.f("en","English")),S}f(R,g,d){const S=g??R;let w;if(S!==R&&(w=`(${R})`),R.toLowerCase()===O.$w.toLowerCase()&&(w??="",w+=(0,A.localize)(0,null)),d?.installCount){w??="";const $=d.installCount;let h;$>1e6?h=`${Math.floor($/1e5)/10}M`:$>1e3?h=`${Math.floor($/1e3)}K`:h=String($),w+=` $(cloud-download) ${h}`}return{id:R,label:S,description:w}}};e.$Mq=c,e.$Mq=c=pe([se(0,j.$3n)],c)}),define(ne[6],re([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(J,e,L,D,O,A,j,v,u,c,b,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,g.$Nh)("logService"),e.$9i=(0,g.$Nh)("loggerService");function d(){return new Date().toISOString()}function S(y){return(0,c.$Bf)(y)}e.$0i=S;var w;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$$i=w.Info;function $(y,E,N){switch(E){case w.Trace:y.trace(N);break;case w.Debug:y.debug(N);break;case w.Info:y.info(N);break;case w.Warning:y.warn(N);break;case w.Error:y.error(N);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=$;function h(y,E=!1){let N="";for(let W=0;W<y.length;W++){let x=y[W];if(x instanceof Error&&(x=(0,L.$yi)(x,E)),typeof x=="object")try{x=JSON.stringify(x)}catch{}N+=(W>0?" ":"")+x}return N}class f extends A.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new D.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==w.Off&&this.b<=E}}e.$aj=f;class I extends f{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...N){this.f(w.Trace)&&this.g(w.Trace,h([E,...N],!0))}debug(E,...N){this.f(w.Debug)&&this.g(w.Debug,h([E,...N]))}info(E,...N){this.f(w.Info)&&this.g(w.Info,h([E,...N]))}warn(E,...N){this.f(w.Warning)&&this.g(w.Warning,h([E,...N]))}error(E,...N){if(this.f(w.Error))if(E instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=E.stack,this.g(w.Error,h(W))}else this.g(w.Error,h([E,...N]))}flush(){}}e.$bj=I;class p extends f{constructor(E=e.$$i){super(),this.setLevel(E),this.g=!v.$j}trace(E,...N){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...N):console.log(`[main ${d()}]`,E,...N))}debug(E,...N){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...N):console.log(`[main ${d()}]`,E,...N))}info(E,...N){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,E,...N):console.log(`[main ${d()}]`,E,...N))}warn(E,...N){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,E,...N):console.warn(`[main ${d()}]`,E,...N))}error(E,...N){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,E,...N):console.error(`[main ${d()}]`,E,...N))}dispose(){}flush(){}}e.$cj=p;class k extends f{constructor(E=e.$$i,N=!0){super(),this.g=N,this.setLevel(E)}trace(E,...N){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...N):console.log(E,...N))}debug(E,...N){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...N):console.log(E,...N))}info(E,...N){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...N):console.log(E,...N))}warn(E,...N){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...N):console.log(E,...N))}error(E,...N){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...N):console.error(E,...N))}dispose(){}flush(){}}e.$dj=k;class t extends f{constructor(E,N=e.$$i){super(),this.g=E,this.setLevel(N)}trace(E,...N){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(E),...N])}debug(E,...N){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(E),...N])}info(E,...N){this.f(w.Info)&&this.g.log(w.Info,[this.h(E),...N])}warn(E,...N){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(E),...N])}error(E,...N){this.f(w.Error)&&this.g.log(w.Error,[this.h(E),...N])}h(E){return typeof E=="string"?E:(0,L.$yi)(E,this.f(w.Trace))}dispose(){}flush(){}}e.$ej=t;class a extends f{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const N of this.g)N.setLevel(E);super.setLevel(E)}trace(E,...N){for(const W of this.g)W.trace(E,...N)}debug(E,...N){for(const W of this.g)W.debug(E,...N)}info(E,...N){for(const W of this.g)W.info(E,...N)}warn(E,...N){for(const W of this.g)W.warn(E,...N)}error(E,...N){for(const W of this.g)W.error(E,...N)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.$fj=a;class i extends A.$Rc{constructor(E,N,W){if(super(),this.h=E,this.j=N,this.b=new j.$zc,this.c=this.B(new D.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Md),this.onDidChangeVisibility=this.g.event,W)for(const x of W)this.b.set(x.resource,{logger:void 0,info:x})}m(E){return(0,c.$xf)(E)?[...this.b.values()].find(N=>N.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,N){const W=this.n(E),x=(0,c.$xf)(E)?E:N?.id??(0,O.$Bi)(W.toString()).toString(16);let _=this.b.get(W)?.logger;const ue=N?.logLevel==="always"?w.Trace:N?.logLevel;_||(_=this.s(W,ue??this.getLogLevel(W)??this.h,{...N,id:x}));const te={logger:_,info:{resource:W,id:x,logLevel:ue,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(te.info),this.b.set(W,te),_}n(E){return(0,c.$xf)(E)?(0,u.$ug)(this.j,`${E}.log`):E}setLogLevel(E,N){if(b.URI.isUri(E)){const W=E,x=N,_=this.b.get(W);_&&x!==_.info.logLevel&&(_.info.logLevel=x===this.h?void 0:x,_.logger?.setLevel(x),this.b.set(_.info.resource,_),this.f.fire([W,x]))}else{this.h=E;for(const[W,x]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&x.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,N){const W=this.m(E);W&&N!==!W.info.hidden&&(W.info.hidden=!N,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,N]))}getLogLevel(E){let N;return E&&(N=this.b.get(E)?.info.logLevel),N??this.h}registerLogger(E){const N=this.b.get(E.resource);N?N.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const N=this.b.get(E);N&&(N.logger&&N.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=i;class n{constructor(){this.onDidChangeLogLevel=new D.$Md().event}setLevel(E){}getLevel(){return w.Info}trace(E,...N){}debug(E,...N){}info(E,...N){}warn(E,...N){}error(E,...N){}critical(E,...N){}dispose(){}flush(){}}e.$hj=n;class s extends n{}e.$ij=s;function r(y){if(y.verbose)return w.Trace;if(typeof y.logLevel=="string"){const E=P(y.logLevel.toLowerCase());if(E!==void 0)return E}return e.$$i}e.$jj=r;function l(y){switch(y){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$kj=l;function P(y){switch(y){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$lj=P,e.$mj=new R.$5i("logLevel",l(w.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(J,e,L,D,O,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;class b extends j.$Rc{constructor(g,d){super(),this.a=g,this.b=d,this.c=this.B(new A.$Md),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Md),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$Qg(0)),this.w=[],this.y=this.B(new D.$Qg(0))}watch(g,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(g,d):this.z(g,d)}n(g,d){const S={path:this.H(g),excludes:d.excludes,includes:d.includes,recursive:d.recursive},w=(0,L.$Tb)(this.j,S);return this.r(),(0,j.$Pc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,O.$Z)(g))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,u.$Lp)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const d of this.j)(0,u.$Hp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const d of this.j)(0,u.$Hp)(d)&&g.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,d){const S={path:this.H(g),excludes:d.excludes,includes:d.includes,recursive:!1},w=(0,L.$Tb)(this.w,S);return this.C(),(0,j.$Pc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,O.$Z)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,u.$Lp)(g)),g=>this.G(g),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}H(g){return(0,v.$gc)(g.fsPath)}}e.$Pp=b}),define(ne[122],re([0,1,19,8,14,20,4,41,65,2,46,15,123,17,45,99,12,61,6,9]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d,S,w,$,h,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;let p=class extends c.$Rc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new j.$Md),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$Md),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$Md),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$Md),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$Md),this.onDidFilesChange=this.X.event,this.Y=this.B(new j.$Md),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new D.$2g)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${t}`);const i=new c.$Qc;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>this.X.fire(new $.$ok(n,!this.S(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this.Y.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,c.$Pc)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,c.$Mc)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await D.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return u.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,d.$yg)(t))throw new $.$qk((0,w.localize)(0,null,this.qb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new I.$ab;throw i.message=(0,w.localize)(1,null,t.toString()),i}return a}async m(t){const a=await this.j(t);if((0,$.$bk)(a)||(0,$.$$j)(a)||(0,$.$ck)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const a=await this.j(t);if((0,$.$bk)(a)||(0,$.$$j)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.s(t,a)}catch(i){throw(0,$.$lk)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$qk((0,w.localize)(2,null,this.qb(t)),1):(0,$.$jk)(i)}}async s(t,a){const i=await this.j(t),n=this.S(i),s=a?.resolveTo,r=a?.resolveSingleChildDescendants,l=a?.resolveMetadata,P=await i.stat(t);let y;return this.t(i,t,P,void 0,!!l,(E,N)=>(y||(y=b.$Th.forUris(()=>!n),y.set(t,!0),s&&y.fill(!0,s)),y.get(E.resource)||y.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&r?N===1:!1))}async t(t,a,i,n,s,r){const{providerExtUri:l}=this.R(t),P={resource:a,name:l.basename(a),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Bk)({mtime:i.mtime,size:i.size}),children:void 0};if(P.isDirectory&&r(P,n)){try{const y=await t.readdir(a),E=await D.Promises.settled(y.map(async([N,W])=>{try{const x=l.joinPath(a,N),_=s?await t.stat(x):{type:W};return await this.t(t,x,_,y.length,s,r)}catch(x){return this.b.trace(x),null}}));P.children=(0,L.$Gb)(E)}catch(y){this.b.trace(y),P.children=[]}return P}return P}async resolveAll(t){return D.Promises.settled(t.map(async a=>{try{return{stat:await this.s(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.t(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.u(t,a)}catch(i){return i}return!0}async u(t,a){if(!a?.overwrite&&await this.exists(t))throw new $.$qk((0,w.localize)(3,null,this.qb(t)),3,a)}async createFile(t,a=O.$ae.fromString(""),i){await this.u(t,i);const n=await this.writeFile(t,a);return this.r.fire(new $.$nk(t,0,n)),n}async writeFile(t,a,i){const n=this.ob(await this.n(t),t),{providerExtUri:s}=this.R(n);let r=i;if((0,$.$ek)(n)&&!r?.atomic){const l=n.enforceAtomicWriteFile?.(t);l&&(r={...i,atomic:l})}try{await this.w(n,t,r)||await this.U(n,s.dirname(t));let P;if((0,$.$$j)(n)&&!(a instanceof O.$ae))if((0,S.$Yd)(a)){const y=await(0,S.$6d)(a,3);y.ended?P=O.$ae.concat(y.buffer):P=y}else P=(0,S.$3d)(a,y=>O.$ae.concat(y),3);else P=a;!(0,$.$bk)(n)||(0,$.$$j)(n)&&P instanceof O.$ae||(0,$.$$j)(n)&&(0,$.$ek)(n)&&r?.atomic?await this.fb(n,t,r,P):await this.bb(n,t,r,P instanceof O.$ae?(0,O.$le)(P):P),this.r.fire(new $.$nk(t,4))}catch(l){throw new $.$qk((0,w.localize)(4,null,this.qb(t),(0,$.$jk)(l).toString()),(0,$.$mk)(l),r)}return this.resolve(t,{resolveMetadata:!0})}async w(t,a,i){const n=!!i?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.qb(a)));if(!!i?.atomic){if(!(t.capabilities&32768))throw new Error((0,w.localize)(6,null,this.qb(a)));if(!(t.capabilities&2))throw new Error((0,w.localize)(7,null,this.qb(a)));if(n)throw new Error((0,w.localize)(8,null,this.qb(a)))}let r;try{r=await t.stat(a)}catch{return}if(r.type&$.FileType.Directory)throw new $.$qk((0,w.localize)(9,null,this.qb(a)),0,i);if(this.pb(a,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$Ak&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,$.$Bk)({mtime:i.mtime,size:r.size}))throw new $.$qk((0,w.localize)(10,null),3,i);return r}async readFile(t,a,i){const n=await this.m(t);return a?.atomic?this.z(n,t,a,i):this.C(n,t,a,i)}async z(t,a,i,n){return new Promise((s,r)=>{this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{try{const l=await this.C(t,a,i,n);s(l)}catch(l){r(l)}})})}async C(t,a,i,n){const s=await this.D(t,a,{...i,preferUnbuffered:!0},n);return{...s,value:await(0,O.$me)(s.value)}}async readFileStream(t,a,i){const n=await this.m(t);return this.D(n,t,a,i)}async D(t,a,i,n){const s=new A.$Wd(n);let r=i;(0,$.$dk)(t)&&t.enforceAtomicReadFile?.(a)&&(r={...i,atomic:!0});const l=this.J(a,r).then(y=>y,y=>{throw s.dispose(!0),y});let P;try{return typeof r?.etag=="string"&&r.etag!==$.$Ak&&await l,r?.atomic&&(0,$.$dk)(t)||!((0,$.$bk)(t)||(0,$.$ck)(t))||(0,$.$$j)(t)&&r?.preferUnbuffered?P=this.I(t,a,r):(0,$.$ck)(t)?P=this.G(t,a,s.token,r):P=this.H(t,a,s.token,r),P.on("end",()=>s.dispose()),P.on("error",()=>s.dispose()),{...await l,value:P}}catch(y){throw P&&await(0,S.$4d)(P),this.F(y,a,r)}}F(t,a,i){const n=(0,w.localize)(11,null,this.qb(a),(0,$.$jk)(t).toString());return t instanceof $.$sk?new $.$sk(n,t.stat,i):t instanceof $.$rk?new $.$rk(n,t.fileOperationResult,t.size,t.options):new $.$qk(n,(0,$.$mk)(t),i)}G(t,a,i,n=Object.create(null)){const s=t.readFileStream(a,n,i);return(0,S.$0d)(s,{data:r=>r instanceof O.$ae?r:O.$ae.wrap(r),error:r=>this.F(r,a,n)},r=>O.$ae.concat(r))}H(t,a,i,n=Object.create(null)){const s=(0,O.$qe)();return(0,h.$Fp)(t,a,s,r=>r,{...n,bufferSize:this.a,errorTransformer:r=>this.F(r,a,n)},i),s}I(t,a,i){const n=(0,S.$1d)(s=>O.$ae.concat(s));return(async()=>{try{let s;i?.atomic&&(0,$.$dk)(t)?s=await t.readFile(a,{atomic:!0}):s=await t.readFile(a),typeof i?.position=="number"&&(s=s.slice(i.position)),typeof i?.length=="number"&&(s=s.slice(0,i.length)),this.L(a,s.byteLength,i),n.end(O.$ae.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async J(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new $.$qk((0,w.localize)(12,null,this.qb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==$.$Ak&&a.etag===i.etag)throw new $.$sk((0,w.localize)(13,null),i,a);return this.L(t,i.size,a),i}L(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new $.$rk((0,w.localize)(14,null,this.qb(t)),7,a,i)}async canMove(t,a,i){return this.M(t,a,"move",i)}async canCopy(t,a,i){return this.M(t,a,"copy",i)}async M(t,a,i,n){if(t.toString()!==a.toString())try{const s=i==="move"?this.ob(await this.n(t),t):await this.m(t),r=this.ob(await this.n(a),a);await this.Q(s,t,r,a,i,n)}catch(s){return s}return!0}async move(t,a,i){const n=this.ob(await this.n(t),t),s=this.ob(await this.n(a),a),r=await this.N(n,t,s,a,"move",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new $.$nk(t,r==="move"?2:3,l)),l}async copy(t,a,i){const n=await this.m(t),s=this.ob(await this.n(a),a),r=await this.N(n,t,s,a,"copy",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new $.$nk(t,r==="copy"?3:2,l)),l}async N(t,a,i,n,s,r){if(a.toString()===n.toString())return s;const{exists:l,isSameResourceWithDifferentPathCase:P}=await this.Q(t,a,i,n,s,r);if(l&&!P&&r&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),s==="copy"){if(t===i&&(0,$.$_j)(t))await t.copy(a,n,{overwrite:r});else{const y=await this.resolve(a);y.isDirectory?await this.P(t,y,i,n):await this.O(t,a,i,n)}return s}else return t===i?(await t.rename(a,n,{overwrite:r}),s):(await this.N(t,a,i,n,"copy",r),await this.del(a,{recursive:!0}),"copy")}async O(t,a,i,n){if((0,$.$bk)(t)&&(0,$.$bk)(i))return this.hb(t,a,i,n);if((0,$.$bk)(t)&&(0,$.$$j)(i))return this.nb(t,a,i,n);if((0,$.$$j)(t)&&(0,$.$bk)(i))return this.lb(t,a,i,n);if((0,$.$$j)(t)&&(0,$.$$j)(i))return this.jb(t,a,i,n)}async P(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await D.Promises.settled(a.children.map(async s=>{const r=this.R(i).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.P(t,await this.resolve(s.resource),i,r):this.O(t,s.resource,i,r)}))}async Q(t,a,i,n,s,r){let l=!1;if(t===i){const{providerExtUri:y,isPathCaseSensitive:E}=this.R(t);if(E||(l=y.isEqual(a,n)),l&&s==="copy")throw new Error((0,w.localize)(15,null,this.qb(a),this.qb(n)));if(!l&&y.isEqualOrParent(n,a))throw new Error((0,w.localize)(16,null,this.qb(a),this.qb(n)))}const P=await this.exists(n);if(P&&!l){if(!r)throw new $.$qk((0,w.localize)(17,null,this.qb(a),this.qb(n)),4);if(t===i){const{providerExtUri:y}=this.R(t);if(y.isEqualOrParent(a,n))throw new Error((0,w.localize)(18,null,this.qb(a),this.qb(n)))}}return{exists:P,isSameResourceWithDifferentPathCase:l}}R(t){const a=this.S(t);return{providerExtUri:a?d.$kg:d.$mg,isPathCaseSensitive:a}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.ob(await this.j(t),t);await this.U(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$nk(t,0,i)),i}async U(t,a){const i=[],{providerExtUri:n}=this.R(t);for(;!n.isEqual(a,n.dirname(a));)try{if(!((await t.stat(a)).type&$.FileType.Directory))throw new Error((0,w.localize)(19,null,this.qb(a)));break}catch(s){if((0,$.$lk)(s)!==$.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(n.basename(a)),a=n.dirname(a)}for(let s=i.length-1;s>=0;s--){a=n.joinPath(a,i[s]);try{await t.mkdir(a)}catch(r){if((0,$.$lk)(r)!==$.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,a){try{await this.W(t,a)}catch(i){return i}return!0}async W(t,a){const i=this.ob(await this.j(t),t),n=!!a?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,w.localize)(20,null,this.qb(t)));const s=a?.atomic;if(s&&!(i.capabilities&65536))throw new Error((0,w.localize)(21,null,this.qb(t)));if(n&&s)throw new Error((0,w.localize)(22,null,this.qb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.pb(t,r);else throw new $.$qk((0,w.localize)(23,null,this.qb(t)),1);if(!!!a?.recursive){const P=await this.resolve(t);if(P.isDirectory&&Array.isArray(P.children)&&P.children.length>0)throw new Error((0,w.localize)(24,null,this.qb(t)))}return i}async del(t,a){const i=await this.W(t,a);let n=a;if((0,$.$fk)(i)&&!n?.atomic){const P=i.enforceAtomicDelete?.(t);P&&(n={...a,atomic:P})}const s=!!n?.useTrash,r=!!n?.recursive,l=n?.atomic??!1;await i.delete(t,{recursive:r,useTrash:s,atomic:l}),this.r.fire(new $.$nk(t,1))}async cloneFile(t,a){const i=await this.j(t),n=this.ob(await this.n(a),a);if(i===n&&this.R(i).providerExtUri.isEqual(t,a))return;if(i===n&&(0,$.$ak)(i))return i.cloneFile(t,a);await this.U(n,this.R(n).providerExtUri.dirname(a));const s=this.ab.queueFor(t,this.R(i).providerExtUri);return i===n&&(0,$.$_j)(i)?s.queue(()=>i.copy(t,a,{overwrite:!0})):s.queue(()=>this.O(i,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new c.$Qc;let n=!1,s=()=>{n=!0};return i.add((0,c.$Pc)(()=>s())),(async()=>{try{const r=await this.$(t,a);n?(0,c.$Mc)(r):s=()=>(0,c.$Mc)(r)}catch(r){this.b.error(r)}})(),i}async $(t,a){const i=await this.j(t),n=(0,v.$Bi)([this.R(i).providerExtUri.getComparisonKey(t),a]);let s=this.Z.get(n);return s||(s={count:0,disposable:i.watch(t,a)},this.Z.set(n,s)),s.count+=1,(0,c.$Pc)(()=>{s&&(s.count--,s.count===0&&((0,c.$Mc)(s.disposable),this.Z.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,c.$Mc)(t.disposable);this.Z.clear()}async bb(t,a,i,n){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(async()=>{const s=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,S.$Yd)(n)||(0,S.$Zd)(n)?await this.cb(t,s,n):await this.db(t,s,n)}catch(r){throw(0,$.$jk)(r)}finally{await t.close(s)}})}async cb(t,a,i){let n=0,s;if((0,S.$Zd)(i)){if(i.buffer.length>0){const r=O.$ae.concat(i.buffer);await this.eb(t,a,r,r.byteLength,n,0),n+=r.byteLength}if(i.ended)return;s=i.stream}else s=i;return new Promise((r,l)=>{(0,S.$5d)(s,{onData:async P=>{s.pause();try{await this.eb(t,a,P,P.byteLength,n,0)}catch(y){return l(y)}n+=P.byteLength,setTimeout(()=>s.resume())},onError:P=>l(P),onEnd:()=>r()})})}async db(t,a,i){let n=0,s;for(;(s=i.read())!==null;)await this.eb(t,a,s,s.byteLength,n,0),n+=s.byteLength}async eb(t,a,i,n,s,r){let l=0;for(;l<n;){const P=await t.write(a,s+l,i.buffer,r+l,n-l);l+=P}}async fb(t,a,i,n){return this.ab.queueFor(a,this.R(t).providerExtUri).queue(()=>this.gb(t,a,i,n))}async gb(t,a,i,n){let s;n instanceof O.$ae?s=n:(0,S.$Yd)(n)?s=await(0,O.$me)(n):(0,S.$Zd)(n)?s=await(0,O.$ne)(n):s=(0,O.$ke)(n),await t.writeFile(a,s.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async hb(t,a,i,n){return this.ab.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ib(t,a,i,n))}async ib(t,a,i,n){let s,r;try{s=await t.open(a,{create:!1}),r=await i.open(n,{create:!0,unlock:!1});const l=O.$ae.alloc(this.a);let P=0,y=0,E=0;do E=await t.read(s,P,l.buffer,y,l.byteLength-y),await this.eb(i,r,l,E,P,y),P+=E,y+=E,y===l.byteLength&&(y=0);while(E>0)}catch(l){throw(0,$.$jk)(l)}finally{await D.Promises.settled([typeof s=="number"?t.close(s):Promise.resolve(),typeof r=="number"?i.close(r):Promise.resolve()])}}async jb(t,a,i,n){return this.ab.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(t,a,i,n))}async kb(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async lb(t,a,i,n){return this.ab.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(t,a,i,n))}async mb(t,a,i,n){const s=await i.open(n,{create:!0,unlock:!1});try{const r=await t.readFile(a);await this.eb(i,s,O.$ae.wrap(r),r.byteLength,0,0)}catch(r){throw(0,$.$jk)(r)}finally{await i.close(s)}}async nb(t,a,i,n){const s=await(0,O.$me)(this.H(t,a,A.CancellationToken.None));await this.fb(i,n,void 0,s)}ob(t,a){if(t.capabilities&2048)throw new $.$qk((0,w.localize)(25,null,this.qb(a)),6);return t}pb(t,a){if((a.permissions??0)&$.FilePermission.Readonly)throw new $.$qk((0,w.localize)(26,null,this.qb(t)),6)}qb(t){return t.scheme===R.Schemas.file?t.fsPath:t.toString(!0)}};e.$Gp=p,e.$Gp=p=pe([se(0,f.$8i)],p)}),define(ne[124],re([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d,S,w,$,h,f,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(a){console.error(`Error enabling graceful-fs: ${(0,I.$yi)(a)}`)}})();class t extends f.$Pp{static{this.I=!1}constructor(i,n){super(i,n),this.onDidChangeCapabilities=v.Event.None,this.N=new A.$zc(s=>g.$lg.getComparisonKey(s)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,R.$l&&(this.J|=1024)),this.J}async stat(i){try{const{stat:n,symbolicLink:s}=await S.SymlinkSupport.stat(this.H(i));return{type:this.M(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:$.FilePermission.Locked}}catch(n){throw this.eb(n)}}async L(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const n=await S.Promises.readdir(this.H(i),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,g.$ug)(i,r.name))).type:l=this.M(r),s.push([r.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.eb(n)}}M(i,n){let s;return n?.dangling?s=$.FileType.Unknown:i.isFile()?s=$.FileType.File:i.isDirectory()?s=$.FileType.Directory:s=$.FileType.Unknown,n&&(s|=$.FileType.SymbolicLink),s}async O(i){const n=this.H(i);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.N.get(i);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const r=new O.$Rg;return this.N.set(i,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(i)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(i)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(i,n){let s;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(i)})`),s=await this.O(i));const r=this.H(i);return await S.Promises.readFile(r)}catch(r){throw this.eb(r)}finally{s?.dispose()}}P(i){t.I&&this.a.trace(i)}readFileStream(i,n,s){const r=(0,d.$1d)(l=>j.$ae.concat(l.map(P=>j.$ae.wrap(P))).buffer);return(0,h.$Fp)(this,i,r,l=>l.buffer,{...n,bufferSize:256*1024},s),r}async writeFile(i,n,s){return s?.atomic!==!1&&s?.atomic?.postfix?this.Q(i,(0,g.$ug)((0,g.$tg)(i),`${(0,g.$rg)(i)}${s.atomic.postfix}`),n,s):this.R(i,n,s)}async Q(i,n,s,r){const l=new c.$Qc;try{l.add(await this.O(i)),l.add(await this.O(n)),await this.R(n,s,r,!0);try{await this.rename(n,i,{overwrite:!0})}catch(P){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{l.dispose()}}async R(i,n,s,r){let l;try{const P=this.H(i);if(!s.create||!s.overwrite){if(await S.Promises.exists(P)){if(!s.overwrite)throw(0,$.$ik)((0,w.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,$.$ik)((0,w.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:s.unlock},r),await this.write(l,0,n,0,n.byteLength)}catch(P){throw await this.fb(i,P)}finally{typeof l=="number"&&await this.close(l)}}static{this.X=!0}static configureFlushOnWrite(i){t.X=i}async open(i,n,s){const r=this.H(i);let l;(0,$.$0j)(n)&&!s&&(l=await this.O(i));let P;try{if((0,$.$0j)(n)&&n.unlock)try{const{stat:E}=await S.SymlinkSupport.stat(r);E.mode&128||await S.Promises.chmod(r,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let y;if((0,$.$0j)(n)){if(R.$j)try{await S.Promises.truncate(r,0),y="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}y||(y="w")}else y="r";P=await S.Promises.open(r,y)}catch(y){throw l?.dispose(),(0,$.$0j)(n)?await this.fb(i,y):this.eb(y)}if(this.S.set(P,0),(0,$.$0j)(n)&&this.W.set(P,i),l){const y=this.U.get(P);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${r})`),this.U.set(P,l),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${r})`),y.dispose())}return P}async close(i){const n=this.U.get(i);try{if(this.S.delete(i),this.W.delete(i)&&t.X)try{await S.Promises.fdatasync(i)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await S.Promises.close(i)}catch(s){throw this.eb(s)}finally{n&&(this.U.get(i)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.U.delete(i)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,s,r,l){const P=this.Y(i,n);let y=null;try{y=(await S.Promises.read(i,s,r,l,P)).bytesRead}catch(E){throw this.eb(E)}finally{this.Z(i,P,y)}return y}Y(i,n){return n===this.S.get(i)?null:n}Z(i,n,s){const r=this.S.get(i);typeof r=="number"&&(typeof n=="number"||(typeof s=="number"?this.S.set(i,r+s):this.S.delete(i)))}async write(i,n,s,r,l){return(0,O.$$g)(()=>this.$(i,n,s,r,l),100,3)}async $(i,n,s,r,l){const P=this.Y(i,n);let y=null;try{y=(await S.Promises.write(i,s,r,l,P)).bytesWritten}catch(E){throw await this.fb(this.W.get(i),E)}finally{this.Z(i,P,y)}return y}async mkdir(i){try{await S.Promises.mkdir(this.H(i))}catch(n){throw this.eb(n)}}async delete(i,n){try{const s=this.H(i);if(n.recursive){let r;n?.atomic!==!1&&n.atomic.postfix&&(r=(0,b.$ic)((0,b.$lc)(s),`${(0,b.$mc)(s)}${n.atomic.postfix}`)),await S.Promises.rm(s,S.RimRafMode.MOVE,r)}else try{await S.Promises.unlink(s)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:P,symbolicLink:y}=await S.SymlinkSupport.stat(s);l=P.isDirectory()&&!y}catch{}if(l)await S.Promises.rmdir(s);else throw r}else throw r}}catch(s){throw this.eb(s)}}async rename(i,n,s){const r=this.H(i),l=this.H(n);if(r!==l)try{await this.ab(i,n,"move",s.overwrite),await S.Promises.rename(r,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,w.localize)(2,null,(0,b.$mc)(r),(0,b.$mc)((0,b.$lc)(l)),P.toString()))),this.eb(P)}}async copy(i,n,s){const r=this.H(i),l=this.H(n);if(r!==l)try{await this.ab(i,n,"copy",s.overwrite),await S.Promises.copy(r,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,w.localize)(3,null,(0,b.$mc)(r),(0,b.$mc)((0,b.$lc)(l)),P.toString()))),this.eb(P)}}async ab(i,n,s,r){const l=this.H(i),P=this.H(n);let y=!1;if(!!(this.capabilities&1024)||(y=(0,u.$Vf)(l,P,!0)),y){if(s==="copy")throw(0,$.$ik)((0,w.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const N=await this.L(i);if(!N)throw(0,$.$ik)((0,w.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const W=await this.L(n);if(W){if(!r)throw(0,$.$ik)((0,w.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);N.type&$.FileType.File&&W.type&$.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,n){return this.bb(i,n,!1)}async bb(i,n,s){const r=this.H(i),l=this.H(n),P=!!(this.capabilities&1024);if((0,u.$Vf)(r,l,!P))return;const y=new c.$Qc;try{y.add(await this.O(i)),y.add(await this.O(n)),s&&await S.Promises.mkdir((0,b.$lc)(l),{recursive:!0}),await S.Promises.copyFile(r,l)}catch(E){if(E.code==="ENOENT"&&!s)return this.bb(i,n,!0);throw this.eb(E)}finally{y.dispose()}}t(i,n,s){return new p.$Wp(r=>i(r),r=>n(r),s)}F(i,n,s){return new k.$5p(r=>i(r),r=>n(r),s)}eb(i){if(i instanceof $.$hk)return i;let n=i,s;switch(i.code){case"ENOENT":s=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=$.FileSystemProviderErrorCode.Unknown;break;default:s=$.FileSystemProviderErrorCode.Unknown}return(0,$.$ik)(n,s)}async fb(i,n){let s=this.eb(n);if(i&&s.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await S.SymlinkSupport.stat(this.H(i));r.mode&128||(s=(0,$.$ik)(n,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return s}}e.$6p=t}),define(ne[126],re([0,1,2,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=void 0;class O extends L.$Rc{constructor(j,v=[]){super(),this.a=new D.$fj([j,...v]),this.B(j.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...v){this.a.trace(j,...v)}debug(j,...v){this.a.debug(j,...v)}info(j,...v){this.a.info(j,...v)}warn(j,...v){this.a.warn(j,...v)}error(j,...v){this.a.error(j,...v)}flush(){this.a.flush()}}e.$uN=O}),define(ne[127],re([0,1,12,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=void 0;var O;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(O||(O={}));async function A(c,b,R,g,d){try{const S=await new Promise(($,h)=>{J(["@vscode/spdlog"],$,h)});S.setFlushOn(O.Trace);const w=await S.createAsyncRotatingLogger(c,b,R,g);return d?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(S){console.error(S)}return null}function j(c,b,R){switch(b){case D.LogLevel.Trace:c.trace(R);break;case D.LogLevel.Debug:c.debug(R);break;case D.LogLevel.Info:c.info(R);break;case D.LogLevel.Warning:c.warn(R);break;case D.LogLevel.Error:c.error(R);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function v(c,b){switch(b){case D.LogLevel.Trace:c.setLevel(O.Trace);break;case D.LogLevel.Debug:c.setLevel(O.Debug);break;case D.LogLevel.Info:c.setLevel(O.Info);break;case D.LogLevel.Warning:c.setLevel(O.Warning);break;case D.LogLevel.Error:c.setLevel(O.Error);break;case D.LogLevel.Off:c.setLevel(O.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class u extends D.$bj{constructor(b,R,g,d,S){super(),this.m=[],this.setLevel(S),this.n=this.s(b,R,g,d),this.B(this.onDidChangeLogLevel(w=>{this.r&&v(this.r,w)}))}async s(b,R,g,d){const S=g?6:1,w=30/S*L.$Dk.MB,$=await A(b,R,w,S,d);if($){this.r=$,v(this.r,this.getLevel());for(const{level:h,message:f}of this.m)j(this.r,h,f);this.m=[]}}g(b,R){this.r?j(this.r,b,R):this.getLevel()<=b&&this.m.push({level:b,message:R})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$jN=u}),define(ne[128],re([0,1,28,6,127]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=void 0;class A extends D.$gj{s(v,u,c){return new O.$jN((0,L.$dg)(),v.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$kN=A}),define(ne[38],re([0,1,4,65,2,10]),function(J,e,L,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=void 0,e.$an=(0,A.$Nh)("policy");class j extends O.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Md),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const b=Object.keys(this.f).length;return this.f={...c,...this.f},b!==Object.keys(this.f).length&&await this.j(c),D.Iterable.reduce(this.g.entries(),(R,[g,d])=>({...R,[g]:d}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(c,[b,R])=>({...c,[b]:{definition:R,value:this.g.get(b)}}),{})}}e.$bn=j;class v{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$cn=v}),define(ne[129],re([0,1,8,4,65,3,12,6,38]),function(J,e,L,D,O,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7b=void 0;function c(R,g){const d=[];for(const S of new Set(O.Iterable.concat(R.keys(),g.keys())))R.get(S)!==g.get(S)&&d.push(S);return d}let b=class extends u.$bn{constructor(g,d,S){super(),this.m=g,this.n=d,this.s=S,this.c=this.B(new L.$Qg(500));const w=D.Event.filter(d.onDidFilesChange,$=>$.affects(g));this.B(d.watch(g)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const g=new Map;try{const d=await this.n.readFile(this.m),S=JSON.parse(d.value.toString());if(!(0,A.$zf)(S))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(S))this.f[w]&&g.set(w,S[w])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return g}async w(){const g=await this.u(),d=c(this.g,g);this.g=g,d.length>0&&this.h.fire(d)}};e.$T7b=b,e.$T7b=b=pe([se(1,j.$9j),se(2,v.$8i)],b)}),define(ne[130],re([0,1,38,8,171,2,6]),function(J,e,L,D,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7b=void 0;let v=class extends L.$bn{constructor(c,b){super(),this.m=c,this.n=b,this.a=new D.$Mg,this.b=this.B(new A.$Sc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((b,R)=>{try{this.b.value=(0,O.createWatcher)(this.n,c,g=>{this.t(g),b()})}catch(g){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),R(g)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const b in c){const R=c[b];R===void 0?this.g.delete(b):this.g.set(b,R)}this.h.fire(Object.keys(c))}};e.$S7b=v,e.$S7b=v=pe([se(0,j.$8i)],v)}),define(ne[32],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,L.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0;class O{constructor(){this.a=new Map}add(j,v){L.ok(D.$xf(j)),L.ok(D.$zf(v)),L.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,v)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$$m=new O}),define(ne[131],re([0,1,4,36]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=void 0,e.$_m={JSONContribution:"base.contributions.json"};function O(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class A{constructor(){this.b=new L.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[O(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const j=new A;D.$$m.add(e.$_m.JSONContribution,j)}),define(ne[43],re([0,1,19,4,3,88,25,131,36]),function(J,e,L,D,O,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.ConfigurationScope=e.$dn=e.EditPresentationTypes=void 0;var c;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$dn={Configuration:"base.contributions.configuration"};var b;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn="vscode://schemas/settings/resourceLanguage",e.$ln="vscode://schemas/settings/configurationDefaults";const R=u.$$m.as(v.$_m.JSONContribution);class g{constructor(){this.h=new Set,this.i=new D.$Md,this.onDidSchemaChange=this.i.event,this.j=new D.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},R.registerSchema(e.$kn,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),R.registerSchema(e.$kn,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),R.registerSchema(e.$kn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),R.registerSchema(e.$kn,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:n,source:s}of t)for(const r in n)if(a.add(r),e.$nn.test(r)){const l=this.a.get(r),P=l?.valuesSources??new Map;if(s)for(const W of Object.keys(n[r]))P.set(W,s);const y={...l?.value||{},...n[r]};this.a.set(r,{source:s,value:y,valuesSources:P});const E=(0,j.$ri)(r),N={type:"object",default:y,description:A.localize(1,null,E),$ref:e.$kn,defaultDefaultValue:y,source:O.$xf(s)?void 0:s,defaultValueSource:s};i.push(...w(r)),this.d[r]=N,this.b.properties[r]=N}else{this.a.set(r,{value:n[r],source:s});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:n}of t)for(const s in i){const r=this.a.get(s),l=O.$xf(n)?n:n?.id,P=O.$xf(r?.source)?r?.source:r?.source?.id;if(l===P)if(a.add(s),this.a.delete(s),e.$nn.test(s))delete this.d[s],delete this.b.properties[s];else{const y=this.d[s];y&&(this.w(s,y),this.r(s,y))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(n=>{this.p(n,a,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,a){const i=n=>{if(n.properties)for(const s in n.properties){a.add(s);const r=this.d[s];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>i(s))};for(const n of t){i(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(t,a=!0,i,n,s=3,r){s=O.$Gf(t.scope)?s:t.scope;const l=t.properties;if(l)for(const y in l){const E=l[y];if(a&&I(y,E)){delete l[y];continue}if(E.source=i,E.defaultDefaultValue=l[y].default,this.w(y,E),e.$nn.test(y)?E.scope=void 0:(E.scope=O.$Gf(E.scope)?s:E.scope,E.restricted=O.$Gf(E.restricted)?!!n?.includes(y):E.restricted),l[y].hasOwnProperty("included")&&!l[y].included){this.f[y]=l[y],delete l[y];continue}else this.d[y]=l[y],l[y].policy?.name&&this.e.set(l[y].policy.name,y);!l[y].deprecationMessage&&l[y].markdownDeprecationMessage&&(l[y].deprecationMessage=l[y].markdownDeprecationMessage),r.add(y)}const P=t.allOf;if(P)for(const y of P)this.p(y,a,i,n,s,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const n=i.properties;if(n)for(const r in n)this.r(r,n[r]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$en.properties[t]=a,a.scope){case 1:e.$fn.properties[t]=a;break;case 2:e.$gn.properties[t]=a;break;case 6:e.$hn.properties[t]=a;break;case 3:e.$in.properties[t]=a;break;case 4:e.$jn.properties[t]=a;break;case 5:e.$jn.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$en.properties[t],a.scope){case 1:delete e.$fn.properties[t];break;case 2:delete e.$gn.properties[t];break;case 6:delete e.$hn.properties[t];break;case 3:delete e.$in.properties[t];break;case 4:case 5:delete e.$jn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$kn};this.w(a,i),e.$en.properties[a]=i,e.$fn.properties[a]=i,e.$gn.properties[a]=i,e.$hn.properties[a]=i,e.$in.properties[a]=i,e.$jn.properties[a]=i}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$kn};e.$en.patternProperties[e.$mn]=t,e.$fn.patternProperties[e.$mn]=t,e.$gn.patternProperties[e.$mn]=t,e.$hn.patternProperties[e.$mn]=t,e.$in.patternProperties[e.$mn]=t,e.$jn.patternProperties[e.$mn]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let n=i?.value,s=i?.source;O.$Ef(n)&&(n=a.defaultDefaultValue,s=void 0),O.$Ef(n)&&(n=h(a.type)),a.default=n,a.defaultValueSource=s}}const d="\\[([^\\]]+)\\]",S=new RegExp(d,"g");e.$mn=`^(${d})+$`,e.$nn=new RegExp(e.$mn);function w(k){const t=[];if(e.$nn.test(k)){let a=S.exec(k);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=S.exec(k)}}return(0,L.$Lb)(t)}e.$on=w;function $(k){return k.reduce((t,a)=>`${t}[${a}]`,"")}e.$pn=$;function h(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$qn=h;const f=new g;u.$$m.add(e.$dn.Configuration,f);function I(k,t){return k.trim()?e.$nn.test(k)?A.localize(7,null,k):f.getConfigurationProperties()[k]!==void 0?A.localize(8,null,k):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,k,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$rn=I;function p(){const k=[],t=f.getConfigurationProperties();for(const a of Object.keys(t))k.push([a,t[a].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.$sn=p}),define(ne[66],re([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(J,e,L,D,O,A,j,v,u,c,b,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=void 0;function d(a){return Object.isFrozen(a)?a:v.$Zm(a)}class S{constructor(i={},n=[],s=[],r){this.b=i,this.c=n,this.d=s,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof S)return n;const s=new w("");return s.parseRaw(n),s.configurationModel});this.f=i.reduce((n,s)=>s===n?s:n.merge(s),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,b.$pi)(this.contents,i):this.contents}inspect(i,n){const s=this.rawConfiguration.getValue(i),r=n?this.rawConfiguration.getOverrideValue(i,n):void 0,l=n?this.rawConfiguration.override(n).getValue(i):s;return{value:s,override:r,merged:l}}getOverrideValue(i,n){const s=this.i(n);return s?i?(0,b.$pi)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const s of this.overrides)s.identifiers.includes(i)&&n.push(...s.keys);return L.$Lb(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return L.$Lb(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=v.$Ym(this.contents),s=v.$Ym(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const P of i)if(l.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(n,P.contents);for(const y of P.overrides){const[E]=s.filter(N=>L.$tb(N.identifiers,y.identifiers));E?(this.h(E.contents,y.contents),E.keys.push(...y.keys),E.keys=L.$Lb(E.keys)):s.push(v.$Ym(y))}for(const y of P.keys)r.indexOf(y)===-1&&r.push(y)}return new S(n,r,s,l.every(P=>P instanceof S)?void 0:l)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const r of L.$Lb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[r];const P=n[r];P&&(typeof l=="object"&&typeof P=="object"?(l=v.$Ym(l),this.h(l,P)):l=P),s[r]=l}return new S(s,this.keys,this.overrides)}h(i,n){for(const s of Object.keys(n)){if(s in i&&u.$zf(i[s])&&u.$zf(n[s])){this.h(i[s],n[s]);continue}i[s]=v.$Ym(n[s])}}i(i){let n=null,s=null;const r=l=>{l&&(s?this.h(s,l):s=v.$Ym(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===i?n=l.contents:l.identifiers.includes(i)&&r(l.contents);return r(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,b.$oi)(this.contents,i),R.$nn.test(i)&&this.overrides.splice(this.overrides.findIndex(s=>L.$tb(s.identifiers,(0,R.$on)(i))),1))}j(i,n,s){(0,b.$ni)(this.contents,i,n,r=>console.error(r)),s=s||this.keys.indexOf(i)===-1,s&&this.keys.push(i),R.$nn.test(i)&&this.overrides.push({identifiers:(0,R.$on)(i),keys:Object.keys(this.contents[i]),contents:(0,b.$mi)(this.contents[i],r=>console.error(r))})}}e.$tn=S;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!u.$Gf(i)){const s=this.g(i);this.parseRaw(s,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:s,keys:r,overrides:l,restricted:P,hasExcludedProperties:y}=this.h(i,n);this.b=new S(s,r,l,y?[i]:void 0),this.c=P||[]}g(i){let n={},s=null,r=[];const l=[],P=[];function y(N){Array.isArray(r)?r.push(N):s!==null&&(r[s]=N)}const E={onObjectBegin:()=>{const N={};y(N),l.push(r),r=N,s=null},onObjectProperty:N=>{s=N},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const N=[];y(N),l.push(r),r=N,s=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:y,onError:(N,W,x)=>{P.push({error:N,offset:W,length:x})}};if(i)try{O.$Vm(i,E),n=r[0]||{}}catch(N){console.error(`Error while parsing settings file ${this.f}: ${N}`),this.d=[N]}return n}h(i,n){const s=g.$$m.as(R.$dn.Configuration).getConfigurationProperties(),r=this.i(i,s,!0,n);i=r.raw;const l=(0,b.$mi)(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),P=Object.keys(i),y=this.j(i,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:l,keys:P,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(i,n,s,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:l};const P={},y=[];for(const E in i)if(R.$nn.test(E)&&s){const N=this.i(i[E],n,!1,r);P[E]=N.raw,l=l||N.hasExcludedProperties,y.push(...N.restricted)}else{const N=n[E],W=N?typeof N.scope<"u"?N.scope:3:void 0;N?.restricted&&y.push(E),!r.exclude?.includes(E)&&(r.include?.includes(E)||(W===void 0||r.scopes===void 0||r.scopes.includes(W))&&!(r.skipRestricted&&N?.restricted))?P[E]=i[E]:l=!0}return{raw:P,restricted:y,hasExcludedProperties:l}}j(i,n){const s=[];for(const r of Object.keys(i))if(R.$nn.test(r)){const l={};for(const P in i[r])l[P]=i[r][P];s.push({identifiers:(0,R.$on)(r),keys:Object.keys(l),contents:(0,b.$mi)(l,n)})}return s}}e.$un=w;class $ extends A.$Rc{constructor(i,n,s,r){super(),this.c=i,this.f=n,this.g=r,this.b=this.B(new D.$Md),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$vn=$;class h{constructor(i,n,s,r,l,P,y,E,N,W,x,_,ue){this.a=i,this.b=n,this.c=s,this.overrideIdentifiers=r,this.d=l,this.f=P,this.g=y,this.h=E,this.i=N,this.j=W,this.k=x,this.l=_,this.m=ue}get value(){return d(this.c)}n(i,n,s){const r=i.inspect(n,s);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(i,n,s,r,l=new S,P=new S,y=new j.$zc,E=new S,N=new j.$zc){this.c=i,this.d=n,this.f=s,this.g=r,this.h=l,this.i=P,this.j=y,this.l=E,this.m=N,this.a=null,this.b=new j.$zc,this.n=null}getValue(i,n,s){return this.q(i,n,s).getValue(i)}updateValue(i,n,s={}){let r;s.resource?(r=this.m.get(s.resource),r||(r=new S,this.m.set(s.resource,r))):r=this.l,n===void 0?r.removeValue(i):r.setValue(i,n),s.resource||(this.a=null)}inspect(i,n,s){const r=this.q(i,n,s),l=this.u(n.resource,s),P=n.resource?this.m.get(n.resource)||this.l:this.l,y=new Set;for(const E of r.overrides)for(const N of E.identifiers)r.getOverrideValue(i,N)!==void 0&&y.add(N);return new h(i,n,r.getValue(i),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,P)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const s=[];if(!n){const{added:r,updated:l,removed:P}=k(this.c,i);n=[...r,...l,...P]}for(const r of n)for(const l of(0,R.$on)(r)){const P=this.c.getKeysForOverrideIdentifier(l),y=i.getKeysForOverrideIdentifier(l),E=[...y.filter(N=>P.indexOf(N)===-1),...P.filter(N=>y.indexOf(N)===-1),...P.filter(N=>!v.$3m(this.c.override(l).getValue(N),i.override(l).getValue(N)))];s.push([l,E])}return this.updateDefaultConfiguration(i),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:s,removed:r}=k(this.d,i),l=[...n,...s,...r];return l.length&&this.updatePolicyConfiguration(i),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:s,removed:r,overrides:l}=k(this.applicationConfiguration,i),P=[...n,...s,...r];return P.length&&this.updateApplicationConfiguration(i),{keys:P,overrides:l}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:s,removed:r,overrides:l}=k(this.localUserConfiguration,i),P=[...n,...s,...r];return P.length&&this.updateLocalUserConfiguration(i),{keys:P,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:s,removed:r,overrides:l}=k(this.remoteUserConfiguration,i),P=[...n,...s,...r];return P.length&&this.updateRemoteUserConfiguration(i),{keys:P,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:s,removed:r,overrides:l}=k(this.workspaceConfiguration,i),P=[...n,...s,...r];return P.length&&this.updateWorkspaceConfiguration(i),{keys:P,overrides:l}}compareAndUpdateFolderConfiguration(i,n){const s=this.p.get(i),{added:r,updated:l,removed:P,overrides:y}=k(s,n),E=[...r,...l,...P];return(E.length||!s)&&this.updateFolderConfiguration(i,n),{keys:E,overrides:y}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:r,removed:l,overrides:P}=k(n,void 0);return{keys:[...s,...r,...l],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,s){let r=this.r(n,s);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(r=r.merge(this.d)),r}r({resource:i},n){let s=this.s();if(n&&i){const r=n.getFolder(i);r&&(s=this.t(r.uri)||s);const l=this.m.get(i);l&&(s=s.merge(l))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const s=this.s(),r=this.j.get(i);r?(n=s.merge(r),this.b.set(i,n)):n=s}return n}u(i,n){if(n&&i){const s=n.getFolder(i);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:s,overrides:r,keys:l}=this.j.get(n);return i.push([n,{contents:s,overrides:r,keys:l}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(s=>i.add(s))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(i).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r))),[...n.values()]}static parse(i){const n=this.x(i.defaults),s=this.x(i.policy),r=this.x(i.application),l=this.x(i.user),P=this.x(i.workspace),y=i.folders.reduce((E,N)=>(E.set(c.URI.revive(N[0]),this.x(N[1])),E),new j.$zc);return new f(n,s,r,l,new S,P,y,new S,new j.$zc)}static x(i){return new S(i.contents,i.keys,i.overrides)}}e.$wn=f;function I(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const r of a)r.keys.forEach(l=>i.add(l)),r.overrides.forEach(([l,P])=>{const y=(0,j.$wc)(n,l,new Set);P.forEach(E=>y.add(E))});const s=[];return n.forEach((r,l)=>s.push([l,[...r.values()]])),{keys:[...i.values()],overrides:s}}e.$xn=I;class p{constructor(i,n,s,r){this.change=i,this.f=n,this.g=s,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of i.keys)this.affectedKeys.add(l);for(const[,l]of i.overrides)for(const P of l)this.affectedKeys.add(P);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(i,n){const s=this.a+i,r=this.d.indexOf(s);if(r<0)return!1;const l=r+s.length;if(l>=this.d.length)return!1;const P=this.d.charCodeAt(l);if(P!==this.b&&P!==this.c)return!1;if(n){const y=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,E=this.g.getValue(i,n,this.h);return!v.$3m(y,E)}return!0}}e.$yn=p;function k(a,i){const{added:n,removed:s,updated:r}=t(i?.rawConfiguration,a?.rawConfiguration),l=[],P=a?.getAllOverrideIdentifiers()||[],y=i?.getAllOverrideIdentifiers()||[];if(i){const E=y.filter(N=>!P.includes(N));for(const N of E)l.push([N,i.getKeysForOverrideIdentifier(N)])}if(a){const E=P.filter(N=>!y.includes(N));for(const N of E)l.push([N,a.getKeysForOverrideIdentifier(N)])}if(i&&a){for(const E of P)if(y.includes(E)){const N=t({contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});l.push([E,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:s,updated:r,overrides:l}}function t(a,i){const n=a?i?a.keys.filter(l=>i.keys.indexOf(l)===-1):[...a.keys]:[],s=i?a?i.keys.filter(l=>a.keys.indexOf(l)===-1):[...i.keys]:[],r=[];if(a&&i){for(const l of i.keys)if(a.keys.indexOf(l)!==-1){const P=(0,b.$pi)(i.contents,l),y=(0,b.$pi)(a.contents,l);v.$3m(P,y)||r.push(l)}}return{added:n,removed:s,updated:r}}}),define(ne[132],re([0,1,19,4,2,30,3,66,43,6,38,36]),function(J,e,L,D,O,A,j,v,u,c,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=void 0;class g extends O.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new v.$tn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(R.$$m.as(u.$dn.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:h})=>this.c(Array.from($),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,h){this.h($,R.$$m.as(u.$dn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new v.$tn;const $=R.$$m.as(u.$dn.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,h){const f=this.f();for(const I of $){const p=f[I],k=h[I];p!==void 0?this.b.addValue(I,p):k?this.b.addValue(I,k.default):this.b.removeValue(I)}}}e.$zn=g;class d{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new v.$tn}async initialize(){return this.configurationModel}}e.$An=d;let S=class extends O.$Rc{get configurationModel(){return this.b}constructor($,h,f){super(),this.c=$,this.f=h,this.g=f,this.a=this.B(new D.$Md),this.onDidChangeConfiguration=this.a.event,this.b=new v.$tn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const h={},f=[],I=R.$$m.as(u.$dn.Configuration).getConfigurationProperties();for(const p of $){const k=I[p];if(!k){f.push(p);continue}if(k.policy){if(k.type!=="string"&&k.type!=="number"){this.g.warn(`Policy ${k.policy.name} has unsupported type ${k.type}`);continue}f.push(p),h[k.policy.name]={type:k.type}}}return(0,j.$Kf)(h)||await this.f.updatePolicyDefinitions(h),f}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const h=R.$$m.as(u.$dn.Configuration).getPolicyConfigurations(),f=(0,L.$Gb)($.map(I=>h.get(I)));this.m(f,!0)}m($,h){this.g.trace("PolicyConfiguration#update",$);const f=R.$$m.as(u.$dn.Configuration).getConfigurationProperties(),I=[],p=this.b.isEmpty();for(const k of $){const t=f[k]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(p?a!==void 0:!(0,A.$3m)(this.b.getValue(k),a))&&I.push([k,a])}else this.b.getValue(k)!==void 0&&I.push([k,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const k=this.b;this.b=new v.$tn;for(const t of k.keys)this.b.setValue(t,k.getValue(t));for(const[t,a]of I)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);h&&this.a.fire(this.b)}}};e.$Bn=S,e.$Bn=S=pe([se(1,b.$an),se(2,c.$8i)],S)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(J,e,L,D,O,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=void 0;class b extends O.$Rc{constructor(g,d,S,w){super(),this.j=g,this.h=this.B(new D.$Md),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$zn),this.c=S instanceof c.$cn?new u.$An:this.B(new u.$Bn(this.b,S,w)),this.f=this.B(new v.$vn(this.j,{},A.$lg,d)),this.a=new v.$wn(this.b.configurationModel,this.c.configurationModel,new v.$tn,new v.$tn),this.g=this.B(new L.$5g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:h})=>this.n($,h))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,d,S]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new v.$wn(g,d,new v.$tn,S)}getConfigurationData(){return this.a.toData()}getValue(g,d){const S=typeof g=="string"?g:void 0,w=(0,j.$ii)(g)?g:(0,j.$ii)(d)?d:{};return this.a.getValue(S,w,void 0)}updateValue(g,d,S,w){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.m(g)}m(g){const d=this.a.toData(),S=this.a.compareAndUpdateLocalUserConfiguration(g);this.s(S,d,2)}n(g,d){const S=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(g,d);this.s(w,S,7)}r(g){const d=this.a.toData(),S=this.a.compareAndUpdatePolicyConfiguration(g);this.s(S,d,7)}s(g,d,S){const w=new v.$yn(g,{data:d},this.a);w.source=S,w.sourceConfig=this.t(S),this.h.fire(w)}t(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Cn=b}),define(ne[67],re([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0;function D(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$Rk=D;function O(c){if(!c)return;const b=c.indexOf("+");return b<0?c:c.substr(0,b)}e.$Sk=O;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Tk=A;function j(c){const{host:b,port:R}=u(c);if(typeof R>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:R}}e.$Uk=j;function v(c,b){let{host:R,port:g}=u(c);return typeof g>"u"&&(g=b),{host:R,port:g}}e.$Vk=v;function u(c){const b=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const R=c.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const g=c.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:c,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.TargetPlatform=e.ExtensionType=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=void 0,e.$Sl="extensions.user.cache",e.$Tl="extensions.builtin.cache",e.$Ul="undefined_publisher",e.$Vl=["ui","workspace","web"];function A(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Wl=A,e.$Xl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var j;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(j||(e.ExtensionType=j={}));var v;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class u{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,h){if(typeof $>"u"||$===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof $=="string"||typeof h=="string"){const f=typeof $=="string"?$:$.value,I=typeof h=="string"?h:h.value;return L.$1e(f,I)}return $._lower===h._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$Yl=u;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const h of $)this.add(h)}add($){this.c.add(u.toKey($))}delete($){return this.c.delete(u.toKey($))}has($){return this.c.has(u.toKey($))}}e.$Zl=c;class b{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(u.toKey($))}get($){return this.c.get(u.toKey($))}has($){return this.c.has(u.toKey($))}set($,h){this.c.set(u.toKey($),h)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$1l=b;function R(w){return g(w)}e.$2l=R;function g(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$3l=g;function d(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$4l=d;function S(w,$){if($){const h=`onResolveRemoteAuthority:${(0,O.$Sk)($)}`;return!!w.activationEvents?.includes(h)}return!1}e.$5l=S,e.$6l=(0,D.$Nh)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,12]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;class A extends L.$Rc{constructor(v,u,c,b,R){super(),this.a=v,this.b=u,this.c=c,this.f=R,this.B(b.onDidInstallExtensions(g=>this.g(g))),this.B(b.onDidUninstallExtension(g=>this.h(g)))}g(v){for(const u of v)u.local&&this.invalidate(u.profileLocation)}h(v){v.error||this.invalidate(v.profileLocation)}async invalidate(v){if(v)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,v)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(v){try{await this.b.del(this.c.extUri.joinPath(v.cacheHome,D.$Sl))}catch(u){(0,O.$mk)(u)!==1&&this.f.error(u)}}}e.$zp=A}),define(ne[44],re([0,1,14,9,2,103,43,10,6,36]),function(J,e,L,D,O,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Lo=(0,v.$Nh)("requestService");class b{constructor(k){this.b=k}toJSON(){if(!this.a){const k=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?k[t]="*****":k[t]=this.b[t];this.a=k}return this.a}}class R extends O.$Rc{constructor(k){super(),this.b=0,this.a=k.createLogger("network",{name:(0,A.localize)(0,null),when:u.$mj.isEqualTo((0,u.$kj)(u.LogLevel.Trace)).serialize()})}async c(k,t,a){const i=`${k} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new b(t.headers??{}));try{const n=await a();return this.a.trace(`${i} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${i} - error`,t.type,(0,D.$9)(n)),n}}}e.$Mo=R;function g(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$No=g;function d(p){return p.res.statusCode===204}e.$Oo=d;async function S(p){return d(p)?null:(await(0,L.$me)(p.stream)).toString()}e.$Po=S;async function w(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);return S(p)}e.$Qo=w;async function $(p){if(!g(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const t=(await(0,L.$me)(p.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.$Ro=$;function h(p){I(p)}e.$So=h;let f;function I(p){const k=c.$$m.as(j.$dn.Configuration),t=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},k.updateConfigurations({add:[f],remove:t?[t]:[]})}I(1)}),define(ne[135],re([0,1,20,15,12,44]),function(J,e,L,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JN=void 0;let j=class{constructor(u,c){this.a=u,this.b=c}async download(u,c,b=L.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,c);return}const R={type:"GET",url:u.toString(!0)},g=await this.a.request(R,b);if(g.res.statusCode===200)await this.b.writeFile(c,g.stream);else{const d=await(0,A.$Qo)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${d}`)}}};e.$JN=j,e.$JN=j=pe([se(0,A.$Lo),se(1,O.$9j)],j)}),define(ne[136],re([0,1,137,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;function O(j,v){return j.protocol==="http:"?v.HTTP_PROXY||v.http_proxy||null:j.protocol==="https:"&&(v.HTTPS_PROXY||v.https_proxy||v.HTTP_PROXY||v.http_proxy)||null}async function A(j,v,u={}){const c=(0,L.parse)(j),b=u.proxyUrl||O(c,v);if(!b)return null;const R=(0,L.parse)(b);if(!/^https?:$/.test(R.protocol||""))return null;const g={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,D.$Df)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((d,S)=>{J(["http-proxy-agent"],d,S)}))(g):new(await new Promise((d,S)=>{J(["https-proxy-agent"],d,S)}))(g)}e.$Qq=A}),define(ne[138],re([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0;let S;async function w(h,f,I,p){return I["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$j?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.$Jl)(p)&&!I["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.$Jl)(p)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=g.Promises.withAsyncBody(async(k,t)=>{const a=new A.$Wd;let i=1e4;const n=h.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,d.$Kl)(n,1,120)*1e3);const s=setTimeout(()=>{a.dispose(!0),t(new Error((0,O.localize)(0,null)))},i);try{k(await $(f,a.token))}catch(r){!(0,v.$3)(r)&&!a.token.isCancellationRequested?t(new Error((0,O.localize)(1,null,(0,j.$yi)(r)))):k({})}finally{clearTimeout(s),a.dispose()}})),S)}e.$Pl=w;async function $(h,f){const I=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",I);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",p);const k=(0,c.$dg)().replace(/-/g,"").substr(0,12),t=new RegExp(k+"({.*})"+k),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",a);const i=await(0,b.$zl)(u.OS,a);return h.trace("getUnixShellEnvironment#shell",i),new Promise((n,s)=>{if(f.isCancellationRequested)return s(new v.$4);const r=(0,D.$mc)(i);let l,P;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${y} -p '''${k}'' + JSON.stringify(process.env) + ''${k}'''`,P=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${y} -p '"${k}" + JSON.stringify(process.env) + "${k}"'`,P=["-i","-l","-c"]):(l=`'${process.execPath}' ${y} -p '"${k}" + JSON.stringify(process.env) + "${k}"'`,r==="tcsh"||r==="csh"?P=["-ic"]:P=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const E=(0,L.spawn)(i,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});f.onCancellationRequested(()=>(E.kill(),s(new v.$4))),E.on("error",x=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,j.$yi)(x)),s(x)});const N=[];E.stdout.on("data",x=>N.push(x));const W=[];E.stderr.on("data",x=>W.push(x)),E.on("close",(x,_)=>{const ue=Buffer.concat(N).toString("utf8");h.trace("getUnixShellEnvironment#raw",ue);const te=Buffer.concat(W).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),x||_)return s(new Error((0,O.localize)(2,null,x,_)));const ae=t.exec(ue),le=ae?ae[1]:"{}";try{const ie=JSON.parse(le);I?ie.ELECTRON_RUN_AS_NODE=I:delete ie.ELECTRON_RUN_AS_NODE,p?ie.ELECTRON_NO_ATTACH_CONSOLE=p:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",ie),n(ie)}catch(ie){h.error("getUnixShellEnvironment#errorCaught",(0,j.$yi)(ie)),s(ie)}})})}}),define(ne[139],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=void 0,e.$lN=(0,L.$Nh)("stateReadService"),e.$mN=(0,L.$Nh)("stateService")}),define(ne[68],re([0,1,8,14,2,3,18,12,6]),function(J,e,L,D,O,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=e.$oN=e.$nN=e.SaveStrategy=void 0;var c;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class b extends O.$Rc{constructor(S,w,$,h){super(),this.h=S,this.j=$,this.m=h,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=w===0?void 0:this.B(new L.$Qg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(S){S.fileOperationResult!==1&&this.j.error(S)}}getItem(S,w){const $=this.a[S];return(0,A.$Gf)($)?w:$}setItem(S,w){this.setItems([{key:S,data:w}])}setItems(S){let w=!1;for(const{key:$,data:h}of S)this.a[$]!==h&&((0,A.$Gf)(h)?(0,A.$Ef)(this.a[$])||(this.a[$]=void 0,w=!0):(this.a[$]=h,w=!0));w&&this.r()}removeItem(S){(0,A.$Ef)(this.a[S])||(this.a[S]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const S=JSON.stringify(this.a,null,4);if(S!==this.b)try{await this.m.writeFile(this.h,D.$ae.fromString(S),{atomic:{postfix:".vsctmp"}}),this.b=S}catch(w){this.j.error(w)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$nN=b;let R=class extends O.$Rc{constructor(S,w,$,h){super(),this.a=this.B(new b(w.stateResource,S,$,h))}async init(){await this.a.init()}getItem(S,w){return this.a.getItem(S,w)}};e.$oN=R,e.$oN=R=pe([se(1,j.$Uh),se(2,u.$8i),se(3,v.$9j)],R);class g extends R{setItem(S,w){this.a.setItem(S,w)}setItems(S){this.a.setItems(S)}removeItem(S){this.a.removeItem(S)}close(){return this.a.close()}}e.$pN=g}),define(ne[69],re([0,1,13,35,28]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=void 0;function A(u){if(L.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function j(u,c,b,R,g,d,S,w){const $=Object.create(null);$["common.machineId"]=d,$.sessionID=(0,O.$dg)()+Date.now(),$.commitHash=R,$.version=g,$["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,L.$i)(L.$u),$["common.nodePlatform"]=D.$cc,$["common.nodeArch"]=b,$["common.product"]=w||"desktop",S&&($["common.msftInternal"]=S);let h=0;const f=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),L.$m&&($["common.snap"]="true");const I=A(c);return I&&($["common.platformDetail"]=I),$}e.$ao=j;function v(u){const c=D.env.USERDNSDOMAIN;if(!c)return!1;const b=c.toLowerCase();return u.some(R=>b===R)}e.$bo=v}),define(ne[26],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0,e.$_k=(0,L.$Nh)("telemetryService"),e.$al=(0,L.$Nh)("customEndpointTelemetryService"),e.$bl="telemetry.currentSessionDate",e.$cl="telemetry.firstSessionDate",e.$dl="telemetry.lastSessionDate",e.$el="telemetry.machineId",e.$fl="telemetry",e.$gl="telemetry.telemetryLevel",e.$hl="telemetry.enableCrashReporter",e.$il="telemetry.enableTelemetry";var D;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var O;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(O||(e.TelemetryConfiguration=O={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(J,e,L,D,O,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=void 0;class c{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$co=c;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$do=b,e.$eo=new b;class R{async publicLog(s,r,l){}async publicLogError(s,r,l){}}e.$fo=R,e.$go="telemetry",e.$ho="extensionTelemetryLog",e.$io={log:()=>null,flush:()=>Promise.resolve(null)};function g(n,s){return O.Event.debounce(s.onDidChangeConfiguration,(l,P)=>{const y=l?new Set([...l.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:y}},1e3,!0)(l=>{l.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,A.$ki)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$jo=g;function d(n,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!n.enableTelemetry)}e.$ko=d;function S(n,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$lo=S;function w(n){const s=n.getValue(u.$gl),r=n.getValue(u.$hl);if(n.getValue(u.$il)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$mo=w;function $(n){const s={},r={},l={};I(n,l);for(let P in l){P=P.length>150?P.substr(P.length-149):P;const y=l[P];typeof y=="number"?r[P]=y:typeof y=="boolean"?r[P]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${y.length}`),s[P]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(s[P]=y)}return{properties:s,measurements:r}}e.$no=$;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(n){if(!n)return"none";const s=(0,j.$Sk)(n);return h.has(s)?s:"other"}e.$oo=f;function I(n,s,r=0,l){if(n)for(const P of Object.getOwnPropertyNames(n)){const y=n[P],E=l?l+P:P;Array.isArray(y)?s[E]=(0,L.$4m)(y):y instanceof Date?s[E]=y.toISOString():(0,D.$zf)(y)?r<2?I(y,s,r+1,E+"."):s[E]=(0,L.$4m)(y):s[E]=y}}function p(n,s){const r=n.msftInternalDomains||[],l=s.getValue("telemetry.internalTesting");return(0,v.$bo)(r)||l}e.$po=p;function k(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$qo=k;function t(n,s){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let r=n;const l=[];for(const N of s)for(;;){const W=N.exec(n);if(!W)break;l.push([W.index,N.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(r="";;){const N=y.exec(n);if(!N)break;const W=l.some(([x,_])=>N.index<_&&x<y.lastIndex);!P.test(N[0])&&!W&&(r+=n.substring(E,N.index)+"<REDACTED: user-file-path>",E=y.lastIndex)}return E<n.length&&(r+=n.substr(E)),r}function a(n){if(!n)return n;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of s)if(r.regex.test(n))return`<REDACTED: ${r.label}>`;return n}function i(n,s){return(0,L.$1m)(n,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=t(l,s);for(const P of s)l=l.replace(P,"");return l=a(l),l}})}e.$ro=i}),define(ne[27],re([0,1,29,21,37,13,11,9,35,39]),function(J,e,L,D,O,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=void 0;function b(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,L.$Ve)(i.id,n.id)===0}e.$so=b;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(n){const s=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new g(n.identifier,s,r)}static parse(n){const s=R.exec(n);return s&&s[1]&&s[2]?new g({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,r="undefined"){this.version=s,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof g?b(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$to=g;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(i){const n=d.exec(i);return n&&n[1]?[$(n[1]),n[2]]:[$(i),void 0]}e.$uo=S;function w(i,n){return`${i}.${n}`}e.$vo=w;function $(i){return i.toLowerCase()}e.$wo=$;function h(i,n){return $(w(i??O.$Ul,n))}e.$xo=h;function f(i,n){const s=[],r=l=>{for(const P of s)if(P.some(y=>b(n(y),n(l))))return P;return null};for(const l of i){const P=r(l);P?P.push(l):s.push([l])}return s}e.$yo=f;function I(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$zo=I;function p(i){return{id:new c.$co(i.identifier.id),name:new c.$co(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$Ao=p,e.$Bo=new O.$Yl("pprice.better-merge");function k(i,n){const s=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&s.every(P=>!b(P.identifier,{id:l}))){const P=i.filter(y=>b(y.identifier,{id:l}));P.length===1&&(s.push(P[0]),r.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$Co=k;async function t(i,n){if(!A.$l)return!1;let s;try{s=(await i.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await i.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,v.$9)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,n){const s=await t(i,n),r=(0,D.$Xn)(s?"alpine":A.$u,u.$dc);return n.debug("ComputeTargetPlatform:",r),r}e.$Do=a}),define(ne[140],re([0,1,20,9,15,17,42,11,93,21,27,37]),function(J,e,L,D,O,A,j,v,u,c,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=void 0;const g=$=>(0,u.localize)(0,null,$),d=(0,u.localize)(1,null,"ms-dotnettools.csharp");function S($,h){return h?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let w=class{constructor(h,f,I){this.a=h,this.b=f,this.d=I}get f(){}async listExtensions(h,f,I){let p=await this.b.getInstalled(1,I);const k=R.$Xl.map(a=>a.toLowerCase());if(f&&f!==""){if(k.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(a=>a.manifest.categories?a.manifest.categories.map(n=>n.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),k.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),p=p.sort((a,i)=>a.identifier.id.localeCompare(i.identifier.id));let t;for(const a of p)t!==a.identifier.id&&(t=a.identifier.id,this.a.info(S(a.manifest,h)))}async installExtensions(h,f,I,p){const k=[];try{const t=[];h.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const a=[];let i=[];const n=(r,l,P)=>{i.push({id:r,version:l!=="prerelease"?l:void 0,installOptions:{...I,isBuiltin:P,installPreReleaseVersion:l==="prerelease"||I.installPreReleaseVersion}})};for(const r of h)if(r instanceof v.URI)a.push({vsix:r,installOptions:I});else{const[l,P]=(0,b.$uo)(r);n(l,P,!1)}for(const r of f)if(r instanceof v.URI)a.push({vsix:r,installOptions:{...I,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,P]=(0,b.$uo)(r);n(l,P,!0)}const s=await this.b.getInstalled(1,I.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:r,installOptions:l})=>{try{const P=await this.g(r,l,p,s);P&&t.push(P)}catch(P){this.a.error(P),k.push(r.toString())}})),i.length&&(i=i.filter(({id:r,version:l})=>{const P=s.find(y=>(0,b.$so)(y.identifier,{id:r}));if(P){if(!p&&(!l||l==="prerelease"&&P.preRelease))return this.a.info((0,u.localize)(5,null,r,P.manifest.version,r)),!1;if(l&&P.manifest.version===l)return this.a.info((0,u.localize)(6,null,`${r}@${l}`)),!1}return!0}),i.length)){const r=await this.h(i);await Promise.all(i.map(async l=>{const P=r.get(l.id.toLowerCase());if(P)try{const y=await this.j(l,P,s);y&&t.push(y)}catch(y){this.a.error(y.message||y.stack||y),k.push(l.id)}else this.a.error(`${g(l.version?`${l.id}@${l.version}`:l.id)}
${d}`),k.push(l.id)}))}}catch(t){throw this.a.error((0,u.localize)(7,null,(0,D.$9)(t))),t}if(k.length)throw new Error((0,u.localize)(8,null,k.join(", ")))}async g(h,f,I,p){const k=await this.b.getManifest(h);if(!k)throw new Error("Invalid vsix");if(await this.l(k,I,f.profileLocation,p))try{return await this.b.install(h,f),this.a.info((0,u.localize)(9,null,(0,A.$rg)(h))),k}catch(a){if((0,D.$3)(a))return this.a.info((0,u.localize)(10,null,(0,A.$rg)(h))),null;throw a}return null}async h(h){const f=new Map,I=h.some(t=>t.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),k=[];for(const t of h)c.$Qn.test(t.id)&&k.push({...t,preRelease:I});if(k.length){const t=await this.d.getExtensions(k,{targetPlatform:p},L.CancellationToken.None);for(const a of t)f.set(a.identifier.id.toLowerCase(),a)}return f}async j({id:h,version:f,installOptions:I},p,k){const t=await this.d.getManifest(p,L.CancellationToken.None);if(t&&!this.k(t))return null;const a=k.find(i=>(0,b.$so)(i.identifier,p.identifier));if(a){if(p.version===a.manifest.version)return this.a.info((0,u.localize)(11,null,f?`${h}@${f}`:h)),null;this.a.info((0,u.localize)(12,null,h,p.version))}try{I.isBuiltin?this.a.info(f?(0,u.localize)(13,null,h,f):(0,u.localize)(14,null,h)):this.a.info(f?(0,u.localize)(15,null,h,f):(0,u.localize)(16,null,h));const i=await this.b.installFromGallery(p,{...I,installGivenVersion:!!f});return this.a.info((0,u.localize)(17,null,h,i.manifest.version)),t}catch(i){if((0,D.$3)(i))return this.a.info((0,u.localize)(18,null,h)),null;throw i}}k(h){return!0}async l(h,f,I,p){if(!f){const k={id:(0,b.$xo)(h.publisher,h.name)},t=p.find(a=>(0,b.$so)(k,a.identifier)&&(0,j.gt)(a.manifest.version,h.version));if(t)return this.a.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,f,I){const p=async t=>{if(t instanceof v.URI){const a=await this.b.getManifest(t);return S(a)}return t},k=[];for(const t of h){const a=await p(t),n=(await this.b.getInstalled(void 0,I)).filter(s=>(0,b.$so)(s.identifier,{id:a}));if(!n.length)throw new Error(`${this.m(a)}
${d}`);if(n.some(s=>s.type===0)){this.a.info((0,u.localize)(20,null,a));return}if(!f&&n.some(s=>s.isBuiltin)){this.a.info((0,u.localize)(21,null,a));return}this.a.info((0,u.localize)(22,null,a));for(const s of n)await this.b.uninstall(s,{profileLocation:I}),k.push(s);this.f?this.a.info((0,u.localize)(23,null,a,this.f)):this.a.info((0,u.localize)(24,null,a))}}async locateExtension(h){const f=await this.b.getInstalled();h.forEach(I=>{f.forEach(p=>{if(p.identifier.id===I&&p.location.scheme===O.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(h){return this.f?(0,u.localize)(25,null,h,this.f):(0,u.localize)(26,null,h)}};e.$_o=w,e.$_o=w=pe([se(1,c.$5n),se(2,c.$3n)],w)}),define(ne[141],re([0,1,4,2,31,27,37]),function(J,e,L,D,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;class v extends D.$Rc{constructor(c,b,R,g,d,S,w){super(),this.f=c,this.g=b,this.h=R,this.j=g,this.m=d,this.n=S,this.r=w,this.a=this.B(new L.$Md),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$Zc),this.s().then(null,$=>w.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(b=>(this.c.set(b.id,(0,D.$Oc)(this.n.watch(this.m.extUri.dirname(b.extensionsResource)),this.n.watch(b.extensionsResource))),this.G(b.extensionsResource))))}catch(b){throw this.r.error(b),b}}async w(c){for(const b of c.extensions)this.I(this.L(b.identifier,b.version),c.profileLocation)}async y(c){for(const b of c.extensions){const R=this.L(b.identifier,b.version);c.error?this.J(R,c.profileLocation):this.I(R,c.profileLocation)}}async z(c){for(const b of c.extensions)this.J(this.L(b.identifier,b.version),c.profileLocation)}async C(c){const b=[],R=[];for(const g of c.extensions){const d=this.L(g.identifier,g.version);c.error?this.I(d,c.profileLocation):(this.J(d,c.profileLocation),this.b.has(d)||(this.r.debug("Extension is removed from all profiles",g.identifier.id,g.version),R.push(this.f.scanInstalledExtensionAtLocation(g.location).then(S=>{S?b.push(S):this.r.info("Extension not found at the location",g.location.toString())},S=>this.r.error(S)))))}try{await Promise.all(R),b.length&&await this.H(b)}catch(g){this.r.error(g)}}D(c){for(const b of this.h.profiles)c.contains(b.extensionsResource,0,1)&&this.F(b.extensionsResource)}async F(c){const b=[],R=[],g=await this.j.scanProfileExtensions(c),d=new Set,S=new Set;for(const[w,$]of this.b)$.has(c)&&S.add(w);for(const w of g){const $=this.L(w.identifier,w.version);d.add($),S.has($)||(b.push(w.identifier),this.I($,c))}for(const w of S)if(!d.has(w)){const $=this.M(w);$&&(R.push($.identifier),this.J(w,c))}(b.length||R.length)&&this.a.fire({added:b.length?{extensions:b,profileLocation:c}:void 0,removed:R.length?{extensions:R,profileLocation:c}:void 0})}async G(c){const b=await this.j.scanProfileExtensions(c);for(const R of b)this.I(this.L(R.identifier,R.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(R=>!this.b.has(this.L(R.identifier,R.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,b){let R=this.b.get(c);R||this.b.set(c,R=new O.$Ac(g=>this.m.extUri.getComparisonKey(g))),R.add(b)}J(c,b){const R=this.b.get(c);R&&R.delete(b),R?.size||this.b.delete(c)}L(c,b){return`${j.$Yl.toKey(c.id)}@${b}`}M(c){const[b,R]=(0,A.$uo)(c);return R?{identifier:{id:b},version:R}:void 0}}e.$Ap=v}),define(ne[142],re([0,1,113,39]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=void 0;async function O(A,j,v,u,c,b,R){const g={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${j.nameShort})`};if((0,D.$ko)(j,v)&&(0,D.$mo)(u)===3){const d=await(0,L.$5o)(v,c,b);g["X-Market-User-Id"]=d,g["VSCode-SessionId"]=R.machineId||d}return g}e.$6o=O}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;let w=class extends d.$Mq{constructor(I,p,k,t){super(k),this.h=I,this.j=t,this.g=this.B(new $(p,t)),this.h.registerParticipant({postInstall:async a=>this.m(a),postUninstall:async a=>this.n(a)})}async getBuiltInExtensionTranslationsUri(I,p){const t=(await this.g.getLanguagePacks())[p];if(!t){this.j.warn(`No language pack found for ${p}`);return}const a=t.translations[I];return a?S.URI.file(a):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),p=Object.keys(I).map(k=>{const t=I[k];return{...this.f(k,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((k,t)=>k.label.localeCompare(t.label)),p}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const p=await this.g.getLanguagePacks();Object.keys(p).some(k=>p[k]&&p[k].extensions.some(t=>(0,R.$so)(t.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),k=await this.g.update(p);return!(0,D.$tb)(Object.keys(I),Object.keys(k))}};e.$Nq=w,e.$Nq=w=pe([se(0,b.$5n),se(1,c.$Vh),se(2,b.$3n),se(3,g.$8i)],w);let $=class extends A.$Rc{constructor(I,p){super(),this.j=p,this.c={},this.f=(0,v.$ic)(I.userDataPath,"languagepacks.json"),this.g=new O.$Zg}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(p=>{Object.keys(p).forEach(k=>delete p[k]),this.m(p,...I)}).then(()=>this.c)}m(I,...p){for(const k of p)k&&k.manifest&&k.manifest.contributes&&k.manifest.contributes.localizations&&k.manifest.contributes.localizations.length&&this.n(I,k);Object.keys(I).forEach(k=>this.r(I[k]))}n(I,p){const k=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const a of t)if(p.location.scheme===j.Schemas.file&&h(a)){let i=I[a.languageId];i||(i={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},I[a.languageId]=i);const n=i.extensions.filter(s=>(0,R.$so)(s.extensionIdentifier,k))[0];n?n.version=p.manifest.version:i.extensions.push({extensionIdentifier:k,version:p.manifest.version});for(const s of a.translations)i.translations[s.id]=(0,v.$ic)(p.location.fsPath,s.path)}}r(I){if(I){const p=(0,L.createHash)("md5");for(const k of I.extensions)p.update(k.extensionIdentifier.uuid||k.extensionIdentifier.id).update(k.version);I.hash=p.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let p=null;return u.Promises.readFile(this.f,"utf8").then(void 0,k=>k.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(k)).then(k=>{try{return JSON.parse(k)}catch{return{}}}).then(k=>(p=I(k),k)).then(k=>{for(const a of Object.keys(k))k[a]||delete k[a];this.c=k,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),u.Promises.writeFile(this.f,t)}).then(()=>p,k=>this.j.error(k))})}};$=pe([se(0,c.$Vh),se(1,g.$8i)],$);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const I of f.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[144],re([0,1,82,9,30,39]),function(J,e,L,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0;const j="https://mobile.events.data.microsoft.com/OneCollector/1.0",v="https://mobile.events.data.microsoft.com/ping";async function u(b,R,g){const d=await(0,L.$fC)("@microsoft/1ds-core-js","dist/ms.core.js"),S=await(0,L.$fC)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new d.AppInsightsCore,$=new S.PostChannel,h={instrumentationKey:b,endpointUrl:j,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(g){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:g};h.extensionConfig[$.identifier]=f}return w.initialize(h,[]),w.addTelemetryInitializer(f=>{R&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),w}class c{constructor(R,g,d,S,w){this.e=R,this.f=g,this.g=d,this.h=w,this.c=j,this.d=v,this.g||(this.g={}),typeof S=="function"?this.a=S():this.a=S,this.b=null}i(R){if(this.a){if(typeof this.a!="string"){R(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(g=>{R(g)},g=>{(0,D.$Z)(g),console.error(g)})}}log(R,g){if(!this.a)return;g=(0,O.$2m)(g,this.g),g=(0,A.$no)(g);const d=this.f+"/"+R;try{this.i(S=>{S.pluginVersionString=g?.properties.version??"Unknown",S.track({name:d,baseData:{name:d,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(R=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,R(void 0)})})}):Promise.resolve(void 0)}}e.$hN=c}),define(ne[145],re([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;let S=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,I){this.k=f,this.l=I,this.d={},this.i=new L.$Qc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$Ee)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Ee)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(g.$gl)||p.affectsConfiguration(g.$il)||p.affectsConfiguration(g.$hl))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,d.$mo)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const I=f.usage?3:f.error?2:0;h=Math.min(h,I)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,I){this.g<f||(I=(0,D.$2m)(I,this.d),I=(0,d.$ro)(I,this.j),I=(0,D.$2m)(I,this.c),this.b.forEach(p=>p.log(h,I)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$Tq=S,e.$Tq=S=pe([se(1,v.$hi),se(2,b.$nj)],S);function w(){const $=(0,j.localize)(0,null,c.default.nameLong),h=c.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=O.$p?"":(0,j.localize)(3,null),I=(0,j.localize)(4,null),p=(0,j.localize)(5,null),k=(0,j.localize)(6,null),t=(0,j.localize)(7,null),a=`
|       | ${I} | ${p} | ${k} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,j.localize)(8,null);return`
${$} ${h} ${f}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}R.$$m.as(u.$dn.Configuration).registerConfiguration({id:g.$fl,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[g.$gl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),R.$$m.as(u.$dn.Configuration).registerConfiguration({id:g.$fl,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[g.$il]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,j.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,j.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${g.$gl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,174,144]),function(J,e,L,D,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;async function j(b,R){const g=await R.request(b,D.CancellationToken.None),d=(await(0,L.$me)(g.stream)).toString(),S=g.res.statusCode??200;return{headers:g.res.headers,statusCode:S,responseData:d}}async function v(b){const R={method:b.type,headers:b.headers};return new Promise((d,S)=>{const w=O.request(b.url??"",R,$=>{$.on("data",function(h){d({headers:$.headers,statusCode:$.statusCode??200,responseData:h.toString()})}),$.on("error",function(h){S(h)})});w.write(b.data,$=>{$&&S($)}),w.end()})}async function u(b,R,g){const d=typeof R.data=="string"?R.data:new TextDecoder().decode(R.data),S={type:"POST",headers:{...R.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(R.data).toString()},url:R.urlString,data:d};try{const w=b?await j(S,b):await v(S);g(w.statusCode,w.headers,w.responseData)}catch{g(0,{})}}class c extends A.$hN{constructor(R,g,d,S,w){const $={sendPOST:(h,f)=>{u(R,h,f)}};super(g,d,S,w,$)}}e.$iN=c}),define(ne[148],re([0,1,16,24]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8b=void 0;async function O(A,j){const v=Object.create(null),u=(b,R)=>{const g=JSON.parse(b);v[R]=g};if(j){const b=[],R=await D.Promises.readdir(j);for(const d of R)try{(await D.Promises.stat((0,L.$ic)(j,d))).isDirectory()&&b.push(d)}catch{}const g=[];for(const d of b)(await D.Promises.readdir((0,L.$ic)(j,d))).filter(w=>w==="telemetry.json").length===1&&g.push(d);for(const d of g){const S=(await D.Promises.readFile((0,L.$ic)(j,d,"telemetry.json"))).toString();u(S,d)}}let c=(await D.Promises.readFile((0,L.$ic)(A,"telemetry-core.json"))).toString();return u(c,"vscode-core"),c=(await D.Promises.readFile((0,L.$ic)(A,"telemetry-extensions.json"))).toString(),u(c,"vscode-extensions"),JSON.stringify(v,null,4)}e.$e8b=O}),define(ne[149],re([0,1,13,75,26]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0;async function A(j,v){let u=j.getItem(O.$el);return(typeof u!="string"||L.$k&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,D.$Lm)(v.error.bind(v))),u}e.$z7b=A}),define(ne[22],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=void 0,e.$Fk=(0,L.$Nh)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,12,17,73,4,2]),function(J,e,L,D,O,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class c{static{this._clock=0}constructor(g){this.uri=g,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let b=class{constructor(g){this.g=g,this.c=new u.$Qc,this.f=2**16;const d=new Map,S=w=>{let $=d.get(w.scheme);return $===void 0&&($=g.hasProvider(w)&&!this.g.hasCapability(w,1024),d.set(w.scheme,$)),$};this.c.add(v.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(w=>{d.delete(w.scheme)})),this.extUri=new A.$jg(S),this.d=new j.$rr((w,$)=>this.extUri.compare(w,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,A.$vg)(g));const d=this.d.get(g);return d?d.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new c(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((S,w)=>S[1].time<w[1].time?1:S[1].time>w[1].time?-1:0);c._clock=0,this.d.clear();const d=this.f*.5;for(let S=0;S<d;S++)this.d.set(g[S][0],g[S][1].touch())}};e.$sr=b,e.$sr=b=pe([se(0,O.$9j)],b),(0,D.$pr)(L.$Fk,b,1)}),define(ne[151],re([0,1,4,2,12,46,31]),function(J,e,L,D,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U7b=void 0;class v extends D.$Rc{constructor(c,b,R,g,d,S){super(),this.f=c,this.g=b,this.h=R,this.j=g,this.m=d,this.n=S,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Md),this.onDidChangeFile=this.a.event,this.b=A.$Th.forUris(()=>!(this.capabilities&1024)),this.c=new j.$Ac(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(g.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,b){return this.g.open(this.t(c),b)}close(c){return this.g.close(c)}read(c,b,R,g,d){return this.g.read(c,b,R,g,d)}write(c,b,R,g,d){return this.g.write(c,b,R,g,d)}watch(c,b){this.b.set(c,c);const R=this.g.watch(this.t(c),b);return(0,D.$Pc)(()=>{this.b.delete(c),R.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,b,R){return this.g.rename(this.t(c),this.t(b),R)}readFile(c,b){return this.g.readFile(this.t(c),b)}readFileStream(c,b,R){return this.g.readFileStream(this.t(c),b,R)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,b,R){return this.g.writeFile(this.t(c),b,R)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,b){return this.g.delete(this.t(c),b)}copy(c,b,R){if((0,O.$_j)(this.g))return this.g.copy(this.t(c),this.t(b),R);throw new Error("copy not supported")}cloneFile(c,b){if((0,O.$ak)(this.g))return this.g.cloneFile(this.t(c),this.t(b));throw new Error("clone not supported")}s(c){const b=[];for(const R of c){if(R.resource.scheme!==this.f)continue;const g=this.u(R.resource);this.b.findSubstr(g)&&b.push({resource:g,type:R.type})}b.length&&(this.n.debug("User data changed"),this.a.fire(b))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$U7b=v}),define(ne[152],re([0,1,107,16,46,17,11,10,15]),function(J,e,L,D,O,A,j,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,v.$Nh)("contextService");function c(n){const s=n;return typeof s?.id=="string"&&j.URI.isUri(s.uri)}e.$Xh=c;function b(n){return typeof n?.id=="string"&&!c(n)&&!g(n)}e.$Yh=b,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function R(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.$mc)(n)}:s?e.$Zh:e.$1h;const r=n;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$2h=R;function g(n){const s=n;return typeof s?.id=="string"&&j.URI.isUri(s.configPath)}e.$3h=g;function d(n){const s=n;if(s?.uri)return{id:s.id,uri:j.URI.revive(s.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:j.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.$4h=d;var S;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function w(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$5h=w;function $(n){const s=n;return!!(s&&typeof s=="object"&&j.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$6h=$;class h{constructor(s,r,l,P,y){this.h=s,this.j=l,this.k=P,this.l=y,this.c=O.$Th.forUris(this.l,()=>!0),this.folders=r}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=O.$Th.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=h;class f{constructor(s,r){this.raw=r,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$ug)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=f;function I(n){return new f({uri:n,index:0,name:(0,A.$qg)(n)},{uri:n.toString()})}e.$9h=I,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,L.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function p(n,s){return A.$lg.isEqualOrParent(n,s.untitledWorkspacesHome)}e.$bi=p;function k(n){let s;return j.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===u.Schemas.tmp}e.$ci=k,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$di}e.$ei=t;function a(n,s){return!p(n,s)&&!k(n)}e.$fi=a;function i(n){return(typeof n=="string"?(0,D.$nc)(n):(0,A.$sg)(n))===e.$$h}e.$gi=i}),define(ne[23],re([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d,S,w,$,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.ProfileResourceType=void 0;var I;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function p(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&j.URI.isUri(s.location)&&j.URI.isUri(s.globalStorageHome)&&j.URI.isUri(s.settingsResource)&&j.URI.isUri(s.keybindingsResource)&&j.URI.isUri(s.tasksResource)&&j.URI.isUri(s.snippetsHome)&&j.URI.isUri(s.extensionsResource))}e.$Gk=p,e.$Hk=(0,b.$Nh)("IUserDataProfilesService");function k(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:j.URI.revive(n.location).with({scheme:s}),globalStorageHome:j.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:j.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:j.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:j.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:j.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:j.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:j.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$Ik=k;function t(n,s,r,l,P,y){return{id:n,name:s,location:r,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:y&&P?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$ug)(r,"globalStorage"),settingsResource:y&&P?.useDefaultFlags?.settings?y.settingsResource:(0,A.$ug)(r,"settings.json"),keybindingsResource:y&&P?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$ug)(r,"keybindings.json"),tasksResource:y&&P?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$ug)(r,"tasks.json"),snippetsHome:y&&P?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$ug)(r,"snippets"),extensionsResource:y&&P?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$ug)(r,"extensions.json"),cacheHome:(0,A.$ug)(l,n),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}e.$Jk=t;let a=class extends O.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,r,l,P){super(),this.t=s,this.u=r,this.w=l,this.y=P,this.f=!0,this.h=this.B(new D.$Md),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Md),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Md),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Md),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),r=[s];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,f.$xf)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(t((0,A.$rg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},s))}}catch(y){this.y.error(y)}const l=new d.$zc,P=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[E,N]of Object.entries(y.workspaces)){const W=j.URI.parse(E),x=r.find(_=>_.id===N);x&&l.set(W,x)}if(y.emptyWindows)for(const[E,N]of Object.entries(y.emptyWindows)){const W=r.find(x=>x.id===N);W&&P.set(E,W)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:l,emptyWindows:P}}return this.z}D(){const s=t("__default__profile__",(0,v.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const r="Temp",l=new RegExp(`${(0,h.$Ee)(r)}\\s(\\d+)`);let P=0;for(const E of this.profiles){const N=l.exec(E.name),W=N?parseInt(N[1]):0;P=W>P?W:P}const y=`${r} ${P+1}`;return this.createProfile((0,L.$Bi)((0,$.$dg)()).toString(16),y,{transient:!0},s)}async createNamedProfile(s,r,l){return this.createProfile((0,L.$Bi)((0,$.$dg)()).toString(16),s,r,l)}async createProfile(s,r,l,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(s,r,l);return P&&await this.setProfileForWorkspace(P,y),y}async F(s,r,l){if(!(0,f.$xf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(r);return P||(P=(async()=>{try{const y=this.profiles.find(W=>W.name===r||W.id===s);if(y)return y;const E=t(s,r,(0,A.$ug)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(E.location);const N=[];return this.j.fire({profile:E,join(W){N.push(W)}}),await w.Promises.settled(N),this.I([E],[],[]),E}finally{this.r.delete(r)}})(),this.r.set(r,P)),P}async updateProfile(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(P=>P.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=t(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(P=>P.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:r,join(P){l.push(P)}});try{await Promise.allSettled(l)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(P){(0,c.$mk)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(P=>P.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(s.map(r=>this.removeProfile(r)))}getProfileForWorkspace(s){const r=this.G(s);return j.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(s){return(0,g.$Xh)(s)?s.uri:(0,g.$3h)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,s.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,s.location)))}I(s,r,l){const P=[...this.profiles,...s],y=[];this.s.profiles=[];for(let E of P)E.isDefault||r.some(N=>E.id===N.id)||(E=l.find(N=>E.id===N.id)??E,E.isTransient?this.s.profiles.push(E):y.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(y),this.z=void 0,this.J(s,r,l)}J(s,r,l){this.h.fire({added:s,removed:r,updated:l,all:this.profiles})}L(s,r,l){l=r?.isTransient?!0:l,l||this.L(s,void 0,!0);const P=this.G(s),y=l?this.s:this.C;j.URI.isUri(P)?(y.workspaces.delete(P),r&&y.workspaces.set(P,r)):(y.emptyWindows.delete(P),r&&y.emptyWindows.set(P,r)),l||this.M()}M(){const s={};for(const[l,P]of this.C.workspaces.entries())s[l.toString()]=P.id;const r={};for(const[l,P]of this.C.emptyWindows.entries())r[l.toString()]=P.id;this.R({workspaces:s,emptyWindows:r}),this.z=void 0}N(s){const r={},l=this.D();if(s.workspaces)for(const[y,E]of Object.entries(s.workspaces)){const N=j.URI.parse(E);r[y]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}const P={};if(s.emptyWindows)for(const[y,E]of Object.entries(s.emptyWindows)){const N=j.URI.parse(E);P[y]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}return{workspaces:r,emptyWindows:P}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Kk=a,e.$Kk=a=pe([se(0,u.$Uh),se(1,c.$9j),se(2,S.$Fk),se(3,R.$8i)],a);class i extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Lk=i}),define(ne[153],re([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d,S,w,$,h,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=void 0;let p=class extends v.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,r,l,P,y,E){super(),this.z=s,this.C=r,this.D=l,this.F=P,this.G=y,this.H=E,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new j.$Md),this.s=this.B(new j.$Md),this.t=this.B(new j.$Md),this.u=this.B(new j.$Md),this.w=this.B(new j.$Md),this.y=[],this.B((0,v.$Pc)(()=>{this.j.forEach(({task:N})=>N.cancel()),this.m.forEach(N=>N.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const r=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,g.$Zn)(l,s.allTargetPlatforms,r))}async installFromGallery(s,r={}){try{const P=(await this.installGalleryExtensions([{extension:s,options:r}])).find(({identifier:y})=>(0,d.$so)(y,s.identifier));if(P?.local)return P?.local;throw P?.error?P.error:t(new Error(`Unknown error while installing extension ${s.identifier.id}`))}catch(l){throw t(l)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new g.$4n(R.localize(0,null),g.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(s.map(async({extension:P,options:y})=>{try{const E=await this.O(P,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);l.push({...E,options:y})}catch(E){r.push({identifier:P.identifier,operation:2,source:P,error:E})}})),l.length&&r.push(...await this.I(l));for(const P of r)P.error&&(this.F.error("Failed to install extension.",P.identifier.id),this.F.error(P.error),P.source&&!b.URI.isUri(P.source)&&a(this.C,"extensionGallery:install",{extensionData:(0,d.$Ao)(P.source),error:P.error}));return r}async uninstall(s,r={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.Q(s,r)}async toggleAppliationScope(s,r){if((0,S.$2l)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(s,this.H.defaultProfile.extensionsResource,r));for(const P of this.H.profiles){const y=(await this.getInstalled(1,P.extensionsResource)).find(E=>(0,d.$so)(E.identifier,s.identifier));y?this.w.fire(y):this.u.fire({identifier:s.identifier,profileLocation:P.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(s,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.X(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const r=[];return await Promise.allSettled(s.map(async l=>{try{const P=await this.J(l);r.push(...P)}catch(P){r.push({identifier:{id:(0,d.$xo)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:P})}})),this.s.fire(r),r}async J({manifest:s,extension:r,options:l}){const P=l.isApplicationScoped||l.isBuiltin||(0,S.$2l)(s),y={...l,installOnlyNewlyAddedFromExtensionPack:b.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:P,profileLocation:P?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},E=te=>`${d.$to.create(te).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!b.URI.isUri(r)){const te=this.j.get(E(r));if(te)return this.F.info("Extensions is already requested to install",r.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const N=[],W=[],x=[],_=this.Z(s,r,y);b.URI.isUri(r)||this.j.set(E(r),{task:_,waitingTasks:[]}),this.n.fire({identifier:_.identifier,source:r,profileLocation:y.profileLocation}),this.F.info("Installing extension:",_.identifier.id),N.push({task:_,manifest:s});let ue=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",_.identifier.id);else try{const ae=await this.N(_.identifier,s,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),le=await this.getInstalled(void 0,y.profileLocation),ie={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[g.$Un]:!0}};for(const{gallery:q,manifest:G}of(0,L.$Lb)(ae,({gallery:T})=>T.identifier.id)){ue=ue||!!G.extensionDependencies?.some(V=>(0,d.$so)({id:V},_.identifier));const T=E(q),U=this.j.get(T);if(U){if(this.L(_,U.task)){const V=U.task.identifier;this.F.info("Waiting for already requested installing extension",V.id,_.identifier.id),U.waitingTasks.push(_),W.push(j.Event.toPromise(j.Event.filter(this.onDidInstallExtensions,X=>X.some(K=>(0,d.$so)(K.identifier,V)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",V.id,_.identifier.id),!X.find(Q=>(0,d.$so)(Q.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else if(!le.some(({identifier:V})=>(0,d.$so)(V,q.identifier))){const V=this.Z(G,q,ie);this.j.set(T,{task:V,waitingTasks:[_]}),this.n.fire({identifier:V.identifier,source:q,profileLocation:y.profileLocation}),this.F.info("Installing extension:",V.identifier.id,_.identifier.id),N.push({task:V,manifest:G})}}}catch(ae){if(b.URI.isUri(_.source))(0,L.$Kb)(s.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",_.identifier.id,ae.message),(0,L.$Kb)(s.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",_.identifier.id,ae.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",_.identifier.id),ae}const te=N.reduce((ae,{task:le,manifest:ie})=>(ae.set(le.identifier.id.toLowerCase(),{task:le,manifest:ie}),ae),new Map);for(;te.size;){let ae;const le=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(q=>te.has(q.toLowerCase())));le.length?ae=te.size===1?le:le.filter(({task:ie})=>!(ie===_&&!ue)):(this.F.info("Found extensions with circular dependencies",le.map(({task:ie})=>ie.identifier.id)),ae=[...te.values()]),await this.M(ae.map(async({task:ie})=>{const q=new Date().getTime();try{const G=await ie.run();if(await this.M(this.y.map(T=>T.postInstall(G,ie.source,y,O.CancellationToken.None))),!b.URI.isUri(ie.source)){const T=ie.operation===3,U=T?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(a(this.C,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$Ao)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:U}),u.$p&&ie.operation!==3)try{await this.z.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}x.push({local:G,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw b.URI.isUri(ie.source)||a(this.C,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$Ao)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,error:G}),this.F.error("Error while installing the extension:",ie.identifier.id),G}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return W.length&&await this.M(W),x.forEach(({identifier:ae})=>this.F.info("Extension installed successfully:",ae.id)),x}catch(te){if(N.forEach(({task:ae})=>ae.cancel()),x.length)try{const ae=await Promise.allSettled(x.map(({local:le})=>this.$(le,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let le=0;le<ae.length;le++){const ie=ae[le],{identifier:q}=x[le];ie.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",q.id):this.F.warn("Rollback: Error while uninstalling extension",q.id,(0,A.$9)(ie.reason))}}catch(ae){this.F.warn("Error while rolling back extensions",(0,A.$9)(ae),x.map(({identifier:le})=>le.id))}return N.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:y.context,profileLocation:y.profileLocation,error:te}))}finally{for(const{task:te}of N)te.source&&!b.URI.isUri(te.source)&&this.j.delete(E(te.source))}}L(s,r){for(const[,{task:l,waitingTasks:P}]of this.j.entries())if(l===s&&(P.includes(r)||P.some(y=>this.L(y,r)))||l===r&&P[0]&&!this.L(s,P[0]))return!1;return!0}async M(s){const r=[],l=[],P=await Promise.allSettled(s);for(const y of P)y.status==="fulfilled"?r.push(y.value):l.push(y.reason);if(l.length)throw k(l);return r}async N(s,r,l,P,y){if(!this.z.isEnabled())return[];const E=await this.getInstalled(void 0,y),N=[],W=[],x=async(_,ue)=>{N.push(_);const te=ue.extensionDependencies||[],ae=[...te];if(ue.extensionPack){const le=l?E.find(ie=>(0,d.$so)(ie.identifier,_)):void 0;for(const ie of ue.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(q=>(0,d.$so)({id:q},{id:ie}))||ae.every(q=>!(0,d.$so)({id:q},{id:ie}))&&ae.push(ie)}if(ae.length){const le=ae.filter(ie=>N.every(q=>!(0,d.$so)(q,{id:ie})));if(le.length){const ie=await this.z.getExtensions(le.map(q=>({id:q,preRelease:P})),O.CancellationToken.None);for(const q of ie){if(N.find(U=>(0,d.$so)(U,q.identifier)))continue;const G=te.some(U=>(0,d.$so)({id:U},q.identifier));let T;try{T=await this.O(q,!1,P)}catch(U){if(G)throw U;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,A.$9)(U));continue}W.push({gallery:T.extension,manifest:T.manifest}),await x(T.extension.identifier,T.manifest)}}}};return await x(s,r),W}async O(s,r,l){let P;const y=await this.getExtensionsControlManifest();if(y.malicious.some(W=>(0,d.$so)(s.identifier,W)))throw new g.$4n(R.localize(1,null,s.identifier.id),g.ExtensionManagementErrorCode.Malicious);const E=y.deprecated[s.identifier.id.toLowerCase()];if(E?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${E.extension.id}' extension instead.`),P=(await this.z.getExtensions([{id:E.extension.id,preRelease:E.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0],!P)throw new g.$4n(R.localize(2,null,s.identifier.id,E.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const W=await this.getTargetPlatform();throw new g.$4n(R.localize(3,null,s.identifier.id,this.G.nameLong,(0,g.$Vn)(W)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(P=await this.P(s,r,l),!P)throw!l&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],O.CancellationToken.None))[0]?new g.$4n(R.localize(4,null,s.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$4n(R.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",P.identifier.id);const N=await this.z.getManifest(P,O.CancellationToken.None);if(N===null)throw new g.$4n(`Missing manifest for extension ${P.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(N.version!==P.version)throw new g.$4n(`Cannot install '${P.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:P,manifest:N}}async P(s,r,l){const P=await this.getTargetPlatform();let y=null;return!r&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(y=(await this.z.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:P,compatible:!0},O.CancellationToken.None))[0]||null),!y&&await this.z.isExtensionCompatible(s,l,P)&&(y=s),y||(r?y=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:P,compatible:!0},O.CancellationToken.None))[0]||null:y=await this.z.getCompatibleExtension(s,l,P)),y}async Q(s,r){const l={...r,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},P=_=>`${_.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,y=this.m.get(P(s.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),y.waitUntilTaskIsFinished();const E=_=>{const ue=this.$(_,l);return this.m.set(P(ue.extension.identifier),ue),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this.t.fire({identifier:_.identifier,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped}),ue},N=(_,ue)=>{ue?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString(),ue.message):this.F.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,ue.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),a(this.C,"extensionGallery:uninstall",{extensionData:(0,d.$zo)(_),error:ue}),this.u.fire({identifier:_.identifier,error:ue?.code,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped})},W=[],x=[];try{W.push(E(s));const _=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const ue=this.U(s,_);for(const te of ue)this.m.has(P(te.identifier))?this.F.info("Extensions is already requested to uninstall",te.identifier.id):W.push(E(te))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.R(W.map(ue=>ue.extension),_,s),await this.M(W.map(async ue=>{try{if(await ue.run(),await this.M(this.y.map(te=>te.postUninstall(ue.extension,l,O.CancellationToken.None))),ue.extension.identifier.uuid)try{await this.z.reportStatistic(ue.extension.manifest.publisher,ue.extension.manifest.name,ue.extension.manifest.version,"uninstall")}catch{}N(ue.extension)}catch(te){const ae=te instanceof g.$4n?te:new g.$4n((0,A.$9)(te),g.ExtensionManagementErrorCode.Internal);throw N(ue.extension,ae),ae}finally{x.push(ue)}}))}catch(_){const ue=_ instanceof g.$4n?_:new g.$4n((0,A.$9)(_),g.ExtensionManagementErrorCode.Internal);for(const te of W){try{te.cancel()}catch{}x.includes(te)||N(te.extension,ue)}throw ue}finally{for(const _ of W)this.m.delete(P(_.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}R(s,r,l){for(const P of s){const y=this.W(P,r);if(y.length){const E=y.filter(N=>!s.some(W=>(0,d.$so)(W.identifier,N.identifier)));if(E.length)throw new Error(this.S(P,E,l))}}}S(s,r,l){return l===s?r.length===1?R.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?R.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):R.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?R.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?R.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):R.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(s,r,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const P=s.manifest.extensionPack?s.manifest.extensionPack:[];if(P.length){const y=r.filter(N=>!N.isBuiltin&&P.some(W=>(0,d.$so)({id:W},N.identifier))),E=[];for(const N of y)E.push(...this.U(N,r,l));return[...y,...E]}return[]}W(s,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(P=>(0,d.$so)({id:P},s.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const s=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",s),s}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$ip=p,e.$ip=p=pe([se(0,g.$3n),se(1,h.$_k),se(2,f.$Fk),se(3,w.$8i),se(4,$.$nj),se(5,I.$Hk)],p);function k(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$jp=k;function t(n){if(n instanceof g.$4n)return n;const s=new g.$4n(n.message,g.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}e.$kp=t;function a(n,s,{extensionData:r,verificationStatus:l,duration:P,error:y,durationSinceUpdate:E}){let N,W;(0,c.$Ff)(l)&&(l===!0?l="Verified":(l===!1||(N=g.ExtensionManagementErrorCode.Signature,W=l),l="Unverified")),y&&(y instanceof g.$4n?(N=y.code,y.code===g.ExtensionManagementErrorCode.Signature&&(W=y.message)):N=g.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...r,verificationStatus:l,success:!y,duration:P,errorcode:N,errorcodeDetail:W,durationSinceUpdate:E})}class i{constructor(){this.d=new D.$Rg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$Gg)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$Gg)(s=>new Promise((r,l)=>{const P=s.onCancellationRequested(()=>{P.dispose(),l(new A.$4)})})),this.d.open()),this.g.cancel()}}e.$lp=i}),define(ne[40],re([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d,S,w,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class I extends Error{constructor(i,n){super(i),this.code=n}}e.$mp=I,e.$np=(0,R.$Nh)("IExtensionsProfileScannerService");let p=class extends O.$Rc{constructor(i,n,s,r,l,P){super(),this.j=i,this.m=n,this.n=s,this.r=r,this.s=l,this.t=P,this.b=this.B(new A.$Md),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Md),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Md),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Md),this.onDidRemoveExtensions=this.g.event,this.h=new j.$zc}scanProfileExtensions(i,n){return this.u(i,void 0,n)}async addExtensionsToProfile(i,n){const s=[],r=[];try{return await this.u(n,l=>{const P=[];for(const y of l)i.some(([E])=>(0,c.$so)(E.identifier,y.identifier)&&E.manifest.version!==y.version)?s.push(y):P.push(y);for(const[y,E]of i){const N=P.findIndex(x=>(0,c.$so)(x.identifier,y.identifier)&&x.version===y.manifest.version),W={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:E};N===-1?(r.push(W),P.push(W)):P.splice(N,1,W)}return r.length&&this.b.fire({extensions:r,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),P}),r.length&&this.c.fire({extensions:r,profileLocation:n}),s.length&&this.g.fire({extensions:s,profileLocation:n}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:n}),s.length&&this.g.fire({extensions:s,error:l,profileLocation:n}),l}}async updateMetadata(i,n){const s=[];return await this.u(n,r=>{const l=[];for(const P of r){const y=i.find(([E])=>(0,c.$so)(E.identifier,P.identifier)&&E.manifest.version===P.version);y&&(P.metadata={...P.metadata,...y[1]},s.push(P)),l.push(P)}return l}),s}async removeExtensionFromProfile(i,n){const s=[];try{await this.u(n,r=>{const l=[];for(const P of r)(0,c.$so)(P.identifier,i.identifier)?s.push(P):l.push(P);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(r){throw s.length&&this.g.fire({extensions:s,error:r,profileLocation:n}),r}}async u(i,n,s){return this.F(i).queue(async()=>{let r=[],l;try{const P=await this.m.readFile(i);l=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,b.$mk)(P)!==1)throw P;if(this.r.extUri.isEqual(i,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new I((0,$.$9)(P),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(i);let P=!1;for(const y of l){k(y)||this.w(i);let E;if((0,w.$xf)(y.relativeLocation)&&y.relativeLocation)E=this.z(y.relativeLocation);else if((0,w.$xf)(y.location))E=this.z(y.location),P=!0,y.relativeLocation=y.location,y.location=E.toJSON();else{E=v.URI.revive(y.location);const N=this.y(E);N&&(P=!0,y.relativeLocation=N)}r.push({identifier:y.identifier,location:E,version:y.version,metadata:y.metadata})}P&&await this.m.writeFile(i,D.$ae.fromString(JSON.stringify(l)))}if(n){r=n(r);const P=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(i,D.$ae.fromString(JSON.stringify(P)))}return r})}w(i){const n=new I(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(i){return this.r.extUri.isEqual(this.r.extUri.dirname(i),this.j)?this.r.extUri.basename(i):void 0}z(i){return this.r.extUri.joinPath(this.j,i)}async D(){return this.C||(this.C=(async()=>{const i=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(i)).value.toString()}catch(l){if((0,b.$mk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",i.toString());let r;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(P=>k(P))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$ae.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",i.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,b.$mk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",i.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(i)}catch(l){(0,b.$mk)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,b.$mk)(l)!==1&&this.t.error(l)}return r})()),this.C}F(i){let n=this.h.get(i);return n||(n=new L.$Zg,this.h.set(i,n)),n}};e.$op=p,e.$op=p=pe([se(1,b.$9j),se(2,d.$Hk),se(3,S.$Fk),se(4,h.$_k),se(5,g.$8i)],p);function k(a){return(0,w.$zf)(a)&&(0,u.$2n)(a.identifier)&&(t(a.location)||(0,w.$xf)(a.location)&&a.location)&&((0,w.$Ef)(a.relativeLocation)||(0,w.$xf)(a.relativeLocation))&&a.version&&(0,w.$xf)(a.version)}function t(a){return a?(0,w.$xf)(a.path)&&(0,w.$xf)(a.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,80,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,47,40,23,22,112]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d,S,w,$,h,f,I,p,k,t,a,i,n,s,r,l,P,y,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.Translations=void 0;var W;(function(ie){function q(G,T){if(G===T)return!0;const U=Object.keys(G),V=new Set;for(const X of Object.keys(T))V.add(X);if(U.length!==V.size)return!1;for(const X of U){if(G[X]!==T[X])return!1;V.delete(X)}return V.size===0}ie.equals=q})(W||(e.Translations=W={})),e.$rp=(0,i.$Nh)("IExtensionsScannerService");let x=class extends c.$Rc{constructor(q,G,T,U,V,X,K,Q,F,z,o,m){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=G,this.r=T,this.s=U,this.t=V,this.u=X,this.w=K,this.y=Q,this.z=F,this.C=z,this.D=o,this.F=m,this.g=this.B(new r.$Md),this.onDidChangeCache=this.g.event,this.h=(0,d.$ug)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(ue,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Do)(this.w,this.y)),this.G}async scanAllExtensions(q,G,T){const[U,V]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(G)]),X=T?await this.scanExtensionsUnderDevelopment(q,[...U,...V]):[];return this.L(U,V,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const G=[];G.push(this.M(!!q.useCache,q.language)),G.push(this.N(q.language,!!q.checkControlFile));const[T,U]=await Promise.all(G);return this.J([...T,...U],0,q,!1)}async scanUserExtensions(q){const G=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",G);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(G,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),V=q.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let X;try{X=await V.scanExtensions(U)}catch(K){if(K instanceof P.$mp&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await V.scanExtensions(U);else throw K}return X=await this.J(X,1,q,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(q,G){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===b.Schemas.file).map(async U=>{const V=await this.P(U,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(V)).map(K=>(K.type=G.find(Q=>(0,p.$so)(Q.identifier,K.identifier))?.type??K.type,this.n.validate(K,V)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,G,T){const U=await this.P(q,!1,G,!0,T.language,!0,void 0),V=await this.n.scanExtension(U);return!V||!T.includeInvalid&&!V.isValid?null:V}async scanOneOrMultipleExtensions(q,G,T){const U=await this.P(q,!1,G,!0,T.language,!0,void 0),V=await this.n.scanOneOrMultipleExtensions(U);return this.J(V,G,T,!0)}async scanMetadata(q){const G=(0,d.$ug)(q,"package.json"),T=(await this.w.readFile(G)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,G){const T=(0,d.$ug)(q,"package.json"),U=(await this.w.readFile(T)).value.toString(),V=JSON.parse(U);G.isMachineScoped=G.isMachineScoped||void 0,G.isBuiltin=G.isBuiltin||void 0,V.__metadata={...V.__metadata,...G},await this.w.writeFile((0,d.$ug)(q,"package.json"),A.$ae.fromString(JSON.stringify(V,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof P.$mp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(G=>[G,G.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$ae.fromString(JSON.stringify([])))}catch(G){(0,a.$mk)(G)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$9)(G))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,G,T,U){return T.includeAllVersions||(q=this.L(G===0?q:void 0,G===1?q:void 0,G==="development"?q:void 0,await this.getTargetPlatform(),U)),T.includeInvalid||(q=q.filter(V=>V.isValid)),q.sort((V,X)=>{const K=R.$mc(V.location.fsPath),Q=R.$mc(X.location.fsPath);return K<Q?-1:K>Q?1:0})}L(q,G,T,U,V){const X=(Q,F,z)=>{if(Q.isValid&&!F.isValid)return!1;if(Q.isValid===F.isValid){if(V&&S.gt(Q.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${Q.location.path} with version ${Q.manifest.version}`),!1;if(S.eq(Q.manifest.version,F.manifest.version)){if(Q.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${Q.location.path} with same version`),!1;if(Q.targetPlatform===U)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${Q.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${Q.location.path} with ${F.location.path}.`),!0},K=new k.$1l;return q?.forEach(Q=>{const F=K.get(Q.identifier.id);(!F||X(F,Q,!1))&&K.set(Q.identifier.id,Q)}),G?.forEach(Q=>{const F=K.get(Q.identifier.id);if(!F&&q&&Q.type===0){this.y.debug(`Skipping obsolete system extension ${Q.location.path}.`);return}(!F||X(F,Q,!1))&&K.set(Q.identifier.id,Q)}),T?.forEach(Q=>{const F=K.get(Q.identifier.id);(!F||X(F,Q,!0))&&K.set(Q.identifier.id,Q),K.set(Q.identifier.id,Q)}),[...K.values()]}async M(q,G){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0),V=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",V.length),V}async N(q,G){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const U=G?await this.O():{},V=[],X=h.URI.file(R.$gc(R.$ic(b.$bg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Q of T){const F=U[Q.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":V.push((0,d.$ug)(X,Q.name));break;default:V.push(h.URI.file(F));break}}const K=await Promise.all(V.map(async Q=>this.n.scanExtension(await this.P(Q,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",K.length),(0,L.$Gb)(K)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,G,T,U,V,X,K){const Q=await this.f(V??g.$w),F=await this.Q(q),z=G&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,o=z?await this.Q(z):void 0;return new _(q,F,z,o,G,K,T,U,X,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,V,Q)}async Q(q){try{const G=await this.w.stat(q);if(typeof G.mtime=="number")return G.mtime}catch{}}};e.$sp=x,e.$sp=x=pe([se(4,y.$Hk),se(5,P.$np),se(6,a.$9j),se(7,n.$8i),se(8,I.$Uh),se(9,s.$nj),se(10,E.$Fk),se(11,i.$Mh)],x);class _{constructor(q,G,T,U,V,X,K,Q,F,z,o,m,M,C,Z){this.location=q,this.mtime=G,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=U,this.profile=V,this.profileScanOptions=X,this.type=K,this.excludeObsolete=Q,this.validate=F,this.productVersion=z,this.productDate=o,this.productCommit=m,this.devMode=M,this.language=C,this.translations=Z}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,G){return(0,d.$ng)(q.location,G.location)&&q.mtime===G.mtime&&(0,d.$ng)(q.applicationExtensionslocation,G.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&q.profile===G.profile&&O.$3m(q.profileScanOptions,G.profileScanOptions)&&q.type===G.type&&q.excludeObsolete===G.excludeObsolete&&q.validate===G.validate&&q.productVersion===G.productVersion&&q.productDate===G.productDate&&q.productCommit===G.productCommit&&q.devMode===G.devMode&&q.language===G.language&&W.equals(q.translations,G.translations)}}e.$tp=_;let ue=class extends c.$Rc{constructor(q,G,T,U,V){super(),this.f=q,this.g=G,this.h=T,this.j=U,this.m=V}async scanExtensions(q){const G=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const U=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(U)}catch{}return(0,$.$Kf)(T)?G:G.filter(U=>!T[p.$to.create(U).toString()])}async n(q){const G=await this.j.resolve(q.location);if(!G.children?.length)return[];const T=await Promise.all(G.children.map(async U=>{if(!U.isDirectory||q.type===1&&(0,d.$rg)(U.resource).indexOf(".")===0)return null;const V=new _(U.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(V)}));return(0,L.$Gb)(T).sort((U,V)=>U.location.path<V.location.path?-1:1)}async r(q){let G=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){G=G.filter(U=>!U.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,q);G.push(...T)}return G}async s(q,G,T){const U=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!U.length)return[];const V=await Promise.all(U.map(async X=>{if(G(X)){const K=new _(X.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(K,X.metadata)}return null}));return(0,L.$Gb)(V)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,d.$ug)(q.location,"package.json"))){const G=await this.scanExtension(q);return G?[G]:[]}else return await this.scanExtensions(q)}catch(G){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,j.$9)(G)),[]}}async scanExtension(q,G){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=k.$Ul),G=G??T.__metadata,delete T.__metadata;const U=(0,p.$xo)(T.publisher,T.name),V=G?.id?{id:U,uuid:G.id}:{id:U},X=G?.isSystem?0:q.type,K=X===0||!!G?.isBuiltin;T=await this.t(q.location,T,_.createNlsConfiguration(q));const Q={type:X,identifier:V,manifest:T,location:q.location,isBuiltin:K,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return q.validate?this.validate(Q,q):Q}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,G){let T=!0;const U=(0,t.$Io)(G.productVersion,G.productDate,G.location,q.manifest,q.isBuiltin);for(const[V,X]of U)V===w.default.Error&&(T=!1,this.m.error(this.z(G.location,X)));return q.isValid=T,q.validations=U,q}async scanExtensionManifest(q){const G=(0,d.$ug)(q,"package.json");let T;try{T=(await this.j.readFile(G)).value.toString()}catch(V){return(0,a.$mk)(V)!==1&&this.m.error(this.z(q,(0,f.localize)(0,null,G.path,V.message))),null}let U;try{U=JSON.parse(T)}catch{const X=[];(0,v.$Om)(T,X);for(const K of X)this.m.error(this.z(q,(0,f.localize)(1,null,G.path,K.offset,K.length,(0,u.$pp)(K.error))));return null}return(0,v.$Xm)(U)!=="object"?(this.m.error(this.z(q,(0,f.localize)(2,null,G.path))),null):U}async t(q,G,T){const U=await this.u(q,G,T);if(U)try{const V=[],X=await this.w(U.default,V);if(V.length>0)return V.forEach(Q=>{this.m.error(this.z(q,(0,f.localize)(3,null,U.default?.path,(0,u.$pp)(Q.error))))}),G;if((0,v.$Xm)(U)!=="object")return this.m.error(this.z(q,(0,f.localize)(4,null,U.default?.path))),G;const K=U.values||Object.create(null);return(0,N.$qp)(this.m,G,K,X)}catch{}return G}async u(q,G,T){const U=(0,d.$ug)(q,"package.nls.json"),V=(F,z)=>{z.forEach(o=>{this.m.error(this.z(q,(0,f.localize)(5,null,F?.path,(0,u.$pp)(o.error))))})},X=F=>{this.m.error(this.z(q,(0,f.localize)(6,null,F?.path)))},K=`${G.publisher}.${G.name}`,Q=T.translations[K];if(Q)try{const F=h.URI.file(Q),z=(await this.j.readFile(F)).value.toString(),o=[],m=(0,v.$Om)(z,o);return o.length>0?(V(F,o),{values:void 0,default:U}):(0,v.$Xm)(m)!=="object"?(X(F),{values:void 0,default:U}):{values:m.contents?m.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let z;try{z=await this.y(q,T)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const o=(await this.j.readFile(z.localized)).value.toString(),m=[],M=(0,v.$Om)(o,m);return m.length>0?(V(z.localized,m),{values:void 0,default:z.original}):(0,v.$Xm)(M)!=="object"?(X(z.localized),{values:void 0,default:z.original}):{values:M,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(q,G){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,v.$Om)(T,G)}catch{}}y(q,G){return new Promise((T,U)=>{const V=X=>{const K=(0,d.$ug)(q,`package.nls.${X}.json`);this.j.exists(K).then(Q=>{Q&&T({localized:K,original:(0,d.$ug)(q,"package.nls.json")});const F=X.lastIndexOf("-");F===-1?T({localized:(0,d.$ug)(q,"package.nls.json"),original:null}):(X=X.substring(0,F),V(X))})};if(G.devMode||G.pseudo||!G.language)return T({localized:(0,d.$ug)(q,"package.nls.json"),original:null});V(G.language)})}z(q,G){return`[${q.path}]: ${G}`}};ue=pe([se(1,P.$np),se(2,E.$Fk),se(3,a.$9j),se(4,n.$8i)],ue);let te=class extends ue{constructor(q,G,T,U,V,X,K){super(G,U,V,X,K),this.G=q,this.H=T,this.D=this.B(new D.$Qg(3e3)),this.F=this.B(new r.$Md),this.onDidChangeCache=this.F.event}async scanExtensions(q){const G=this.M(q),T=await this.I(G);if(this.C=q,T&&T.input&&_.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(V=>(V.location=h.URI.revive(V.location),V));const U=await super.scanExtensions(q);return await this.J(G,{input:q,result:U}),U}async I(q){try{const G=await this.j.readFile(q),T=JSON.parse(G.value.toString());return{result:T.result,input:(0,l.$kh)(T.input)}}catch(G){this.m.debug("Error while reading the extension cache file:",q.path,(0,j.$9)(G))}return null}async J(q,G){try{await this.j.writeFile(q,A.$ae.fromString(JSON.stringify(G)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,j.$9)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),G=await this.I(q);if(!G)return;const T=G.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!O.$3m(U,T))try{this.m.info("Invalidating Cache",T,U),await this.j.del(q),this.F.fire()}catch(V){this.m.error(V)}}M(q){const G=this.N(q);return this.h.extUri.joinPath(G.cacheHome,q.type===0?k.$Tl:k.$Sl)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(G=>this.h.extUri.isEqual(q.location,G.extensionsResource))??this.G:this.H.defaultProfile}};te=pe([se(2,y.$Hk),se(3,P.$np),se(4,E.$Fk),se(5,a.$9j),se(6,n.$8i)],te);function ae(ie,q){const G=(0,p.$vo)(ie.manifest.publisher,ie.manifest.name);return{id:G,identifier:new k.$Yl(G),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:q,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.$up=ae;class le extends x{constructor(q,G,T,U,V,X,K,Q,F,z,o,m){super(q,G,(0,d.$ug)(T,".vscode-oss-dev","extensions","control.json"),U,V,X,K,Q,F,z,o,m),this.R=(async()=>{if(g.$z)try{const M=await this.w.readFile(h.URI.file(g.$z));return JSON.parse(M.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$vp=le}),define(ne[154],re([0,1,58,8,34,4,2,15,16,24,6,23]),function(J,e,L,D,O,A,j,v,u,c,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;let g=class extends j.$Rc{constructor(S,w){super(),this.b=S,this.f=w,this.a=new D.$Yg(5)}async postUninstall(S){const w=this.g(S,"uninstall");w&&(this.f.info(S.identifier.id,S.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(w.script,"uninstall",w.args,!0,S),this.f.info("Finished running post uninstall script",S.identifier.id,S.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",S.identifier.id,S.manifest.version),this.f.error($)}}));try{await c.Promises.rm(this.m(S))}catch($){this.f.error("Error while removing extension storage path",S.identifier.id),this.f.error($)}}g(S,w){const $=`vscode:${w}`;if(S.location.scheme===v.Schemas.file&&S.manifest&&S.manifest.scripts&&typeof S.manifest.scripts[$]=="string"){const h=S.manifest.scripts[$].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(S.identifier.id,S.manifest.version,`${$} should be a node script`),null):{script:(0,u.$ic)(S.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(S,w,$,h,f){return new Promise((I,p)=>{const k=this.j(S,w,$,f);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?p(i):I(void 0)};k.on("error",i=>{a((0,O.$yi)(i)||"Unknown")}),k.on("exit",(i,n)=>{a(i?`post-${w} process exited with code ${i}`:void 0)}),h&&(t=setTimeout(()=>{t=null,k.kill(),p("timed out")},5e3))})}j(S,w,$,h){const f={silent:!0,execArgv:void 0},I=(0,L.fork)(S,[`--type=extension-post-${w}`,...$],f);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(I.stdout,"data"),k=A.Event.fromNodeEventEmitter(I.stderr,"data");p(i=>this.f.info(h.identifier.id,h.manifest.version,`post-${w}`,i)),k(i=>this.f.error(h.identifier.id,h.manifest.version,`post-${w}`,i));const t=A.Event.any(A.Event.map(p,i=>({data:`%c${i}`,format:[""]})),A.Event.map(k,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),I}m(S){return(0,u.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,S.identifier.id.toLowerCase())}};e.$xp=g,e.$xp=g=pe([se(0,R.$Hk),se(1,b.$8i)],g)}),define(ne[155],re([0,1,6,23,22,26,40,12,18,11]),function(J,e,L,D,O,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=void 0;let b=class extends j.$op{constructor(g,d,S,w,$,h){super(c.URI.file(g.extensionsPath),d,S,w,$,h)}};e.$tN=b,e.$tN=b=pe([se(0,u.$Vh),se(1,v.$9j),se(2,D.$Hk),se(3,O.$Fk),se(4,A.$_k),se(5,L.$8i)],b)}),define(ne[156],re([0,1,11,18,40,50,12,10,6,32,22,23]),function(J,e,L,D,O,A,j,v,u,c,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=void 0;let g=class extends A.$vp{constructor(S,w,$,h,f,I,p,k){super(L.URI.file(f.builtinExtensionsPath),L.URI.file(f.extensionsPath),f.userHome,S.defaultProfile,S,w,$,h,f,I,p,k)}};e.$w7b=g,e.$w7b=g=pe([se(0,R.$Hk),se(1,O.$np),se(2,j.$9j),se(3,u.$8i),se(4,D.$Vh),se(5,c.$nj),se(6,b.$Fk),se(7,v.$Mh)],g)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(J,e,L,D,O,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Yo=e.$Xo=e.$Wo=void 0,e.$Wo="__$__isNewStorageMarker",e.$Xo="__$__targetStorageMarker",e.$Yo=(0,u.$Nh)("storageService");var b;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var R;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(R||(e.StorageScope=R={}));var g;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function d(f){const I=f.get(e.$Xo);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}e.$Zo=d;class S extends O.$Rc{static{this.a=60*1e3}constructor(I={flushInterval:S.a}){super(),this.m=I,this.b=this.B(new D.$Pd),this.c=this.B(new D.$Pd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Md),this.onWillSaveState=this.f.event,this.h=this.B(new L.$5g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new O.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,p,k){return D.Event.filter(this.b.event,t=>t.scope===I&&(p===void 0||t.key===p),k)}n(){this.j.value=(0,L.$9g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,O.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,p){const{key:k,external:t}=p;if(k===e.$Xo){switch(I){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:k,target:this.J(I)[k],external:t})}w(I){this.f.fire({reason:I})}get(I,p,k){return this.P(p)?.get(I,k)}getBoolean(I,p,k){return this.P(p)?.getBoolean(I,k)}getNumber(I,p,k){return this.P(p)?.getNumber(I,k)}getObject(I,p,k){return this.P(p)?.getObject(I,k)}storeAll(I,p){this.y(()=>{for(const k of I)this.store(k.key,k.value,k.scope,k.target,p)})}store(I,p,k,t,a=!1){if((0,j.$Gf)(p)){this.remove(I,k,a);return}this.y(()=>{this.z(I,k,t),this.P(k)?.set(I,p,a)})}remove(I,p,k=!1){this.y(()=>{this.z(I,p,void 0),this.P(p)?.delete(I,k)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,p){const k=[],t=this.J(I);for(const a of Object.keys(t))t[a]===p&&k.push(a);return k}z(I,p,k,t=!1){const a=this.J(p);typeof k=="number"?a[I]!==k&&(a[I]=k,this.P(p)?.set(e.$Xo,JSON.stringify(a),t)):typeof a[I]=="number"&&(delete a[I],this.P(p)?.set(e.$Xo,JSON.stringify(a),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(I){switch(I){case-1:return this.I;case 0:return this.G;default:return this.D}}L(I){const p=this.P(I);return p?d(p):Object.create(null)}isNew(I){return this.getBoolean(e.$Wo,I)===!0}async flush(I=b.NONE){this.f.fire({reason:I});const p=this.P(-1),k=this.P(0),t=this.P(1);switch(I){case b.NONE:await L.Promises.settled([p?.whenFlushed()??Promise.resolve(),k?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await L.Promises.settled([p?.flush(0)??Promise.resolve(),k?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,k=this.P(1)?.items??new Map;return h(I,p,k,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,p){return this.w(b.NONE),(0,c.$Gk)(I)?this.R(I,p):this.S(I,p)}M(I,p){return!(I.id===p.id||w(p)&&w(I))}N(I,p,k){this.y(()=>{const t=new Set;for(const[a,i]of I)t.add(a),p.get(a)!==i&&this.u(k,{key:a,external:!0});for(const[a]of p.items)t.has(a)||this.u(k,{key:a,external:!0})})}}e.$1o=S;function w(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$2o=w;class $ extends S{constructor(){super(),this.U=this.B(new v.$Uo(new v.$Vo,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new v.$Uo(new v.$Vo,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new v.$Uo(new v.$Vo,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(1,I))),this.B(this.W.onDidChangeStorage(I=>this.u(0,I))),this.B(this.U.onDidChangeStorage(I=>this.u(-1,I)))}P(I){switch(I){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(I){switch(I){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$3o=$;async function h(f,I,p,k,t,a){const i=W=>{try{return JSON.parse(W)}catch{return W}},n=new Map,s=new Map;f.forEach((W,x)=>{n.set(x,W),s.set(x,i(W))});const r=new Map,l=new Map;I.forEach((W,x)=>{r.set(x,W),l.set(x,i(W))});const P=new Map,y=new Map;p.forEach((W,x)=>{P.set(x,W),y.set(x,i(W))}),console.group(k!==t?`Storage: Application (path: ${k})`:`Storage: Application & Profile (path: ${k}, default profile)`);const E=[];if(n.forEach((W,x)=>{E.push({key:x,value:W})}),console.table(E),console.groupEnd(),console.log(s),k!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const W=[];r.forEach((x,_)=>{W.push({key:_,value:x})}),console.table(W),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${a})`);const N=[];P.forEach((W,x)=>{N.push({key:x,value:W})}),console.table(N),console.groupEnd(),console.log(y)}e.$4o=h}),define(ne[158],re([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d,S,w,$,h,f,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=void 0;const t=A.$p?"web":(0,R.$Xn)(A.$u,j.$dc),a="X-Market-Search-Activity-Id";var i;(function(o){o[o.None=0]="None",o[o.IncludeVersions=1]="IncludeVersions",o[o.IncludeFiles=2]="IncludeFiles",o[o.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",o[o.IncludeSharedAccounts=8]="IncludeSharedAccounts",o[o.IncludeVersionProperties=16]="IncludeVersionProperties",o[o.ExcludeNonValidated=32]="ExcludeNonValidated",o[o.IncludeInstallationTargets=64]="IncludeInstallationTargets",o[o.IncludeAssetUri=128]="IncludeAssetUri",o[o.IncludeStatistics=256]="IncludeStatistics",o[o.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",o[o.Unpublished=4096]="Unpublished",o[o.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...o){return String(o.reduce((m,M)=>m|M,0))}var s;(function(o){o[o.Tag=1]="Tag",o[o.ExtensionId=4]="ExtensionId",o[o.Category=5]="Category",o[o.ExtensionName=7]="ExtensionName",o[o.Target=8]="Target",o[o.Featured=9]="Featured",o[o.SearchText=10]="SearchText",o[o.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class E{constructor(m=y){this.d=m}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(m,M=this.d.pageSize){return new E({...this.d,pageNumber:m,pageSize:M})}withFilter(m,...M){const C=[...this.d.criteria,...M.length?M.map(Z=>({filterType:m,value:Z})):[{filterType:m}]];return new E({...this.d,criteria:C})}withSortBy(m){return new E({...this.d,sortBy:m})}withSortOrder(m){return new E({...this.d,sortOrder:m})}withFlags(...m){return new E({...this.d,flags:m.reduce((M,C)=>M|C,0)})}withAssetTypes(...m){return new E({...this.d,assetTypes:m})}withSource(m){return new E({...this.d,source:m})}get raw(){const{criteria:m,pageNumber:M,pageSize:C,sortBy:Z,sortOrder:H,flags:ce,assetTypes:oe}=this.d;return{filters:[{criteria:m,pageNumber:M,pageSize:C,sortBy:Z,sortOrder:H}],assetTypes:oe,flags:ce}}get searchText(){const m=this.d.criteria.filter(M=>M.filterType===s.SearchText)[0];return m&&m.value?m.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(m=>String(m.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function N(o,m){const M=(o||[]).filter(C=>C.statisticName===m)[0];return M?M.value:0}function W(o){const m="Microsoft.VisualStudio.Code.Translation.";return o.files.filter(C=>C.assetType.indexOf(m)===0).reduce((C,Z)=>{const H=ue(o,Z.assetType);return H&&C.push([Z.assetType.substring(m.length),H]),C},[])}function x(o){if(o.properties){const m=o.properties.filter(Z=>Z.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),C=m.filter(Z=>M.test(Z.value))[0];return C?{uri:C.value,fallbackUri:C.value}:null}return ue(o,r.Repository)}function _(o){return{uri:`${o.fallbackAssetUri}/${r.VSIX}?redirect=true${o.targetPlatform?`&targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${r.VSIX}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}}function ue(o,m){return o.files.filter(C=>C.assetType===m)[0]?{uri:`${o.assetUri}/${m}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`,fallbackUri:`${o.fallbackAssetUri}/${m}${o.targetPlatform?`?targetPlatform=${o.targetPlatform}`:""}`}:null}function te(o,m){const M=o.properties?o.properties.filter(Z=>Z.key===m):[],C=M.length>0&&M[0].value;return C?C.split(",").map(Z=>(0,g.$wo)(Z)):[]}function ae(o){const m=o.properties?o.properties.filter(M=>M.key===l.Engine):[];return m.length>0&&m[0].value||""}function le(o){const m=o.properties?o.properties.filter(M=>M.key===l.PreRelease):[];return m.length>0&&m[0].value==="true"}function ie(o){const m=o.properties?o.properties.filter(C=>C.key===l.LocalizedLanguages):[],M=m.length>0&&m[0].value||"";return M?M.split(","):[]}function q(o){return o.properties?.find(m=>m.key===l.SponsorLink)?.value}function G(o){return o.indexOf("preview")!==-1}function T(o){return o.targetPlatform?(0,R.$Wn)(o.targetPlatform):"undefined"}function U(o){const m=(0,L.$Lb)(o.versions.map(T)),M=!!o.tags?.includes(R.$Rn),C=m.indexOf("web");return M?C===-1&&m.push("web"):C!==-1&&m.splice(C,1),m}function V(o,m){const M=(0,R.$1n)(m);for(let C=0;C<o.length;C++){const Z=o[C];if(Z.version===o[C-1]?.version){let H=C;const ce=T(Z);if(ce===m)for(;H>0&&o[H-1].version===Z.version;)H--;else if(M.includes(ce))for(;H>0&&o[H-1].version===Z.version&&T(o[H-1])!==m;)H--;H!==C&&(o.splice(C,1),o.splice(H,0,Z))}}return o}e.$7o=V;function X(o,m,M){o.telemetryData={index:m,querySource:M,queryActivityId:o.queryContext?.[a]}}function K(o,m,M,C){const Z=o.versions[0],H={manifest:ue(m,r.Manifest),readme:ue(m,r.Details),changelog:ue(m,r.Changelog),license:ue(m,r.License),repository:x(m),download:_(m),icon:ue(m,r.Icon),signature:ue(m,r.Signature),coreTranslations:W(m)};return{identifier:{id:(0,g.$xo)(o.publisher.publisherName,o.extensionName),uuid:o.extensionId},name:o.extensionName,version:m.version,displayName:o.displayName,publisherId:o.publisher.publisherId,publisher:o.publisher.publisherName,publisherDisplayName:o.publisher.displayName,publisherDomain:o.publisher.domain?{link:o.publisher.domain,verified:!!o.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(Z),description:o.shortDescription||"",installCount:N(o.statistics,"install"),rating:N(o.statistics,"averagerating"),ratingCount:N(o.statistics,"ratingcount"),categories:o.categories||[],tags:o.tags||[],releaseDate:Date.parse(o.releaseDate),lastUpdated:Date.parse(o.lastUpdated),allTargetPlatforms:M,assets:H,properties:{dependencies:te(m,l.Dependency),extensionPack:te(m,l.ExtensionPack),engine:ae(m),localizedLanguages:ie(m),targetPlatform:T(m),isPreReleaseVersion:le(m)},hasPreReleaseVersion:le(Z),hasReleaseVersion:!0,preview:G(o.flags),isSigned:!!H.signature,queryContext:C}}let Q=class{constructor(m,M,C,Z,H,ce,oe,ge){this.k=M,this.l=C,this.n=Z,this.o=H,this.q=ce,this.u=oe,this.w=ge;const de=oe.extensionsGallery,me=de?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=me?de.servicePPEUrl:de?.serviceUrl,this.g=me?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,f.$6o)(oe.version,oe,this.n,this.w,this.q,m,this.o)}x(m=""){return`${this.d}${m}`}isEnabled(){return!!this.d}async getExtensions(m,M,C){const Z=D.CancellationToken.isCancellationToken(M)?{}:M,H=D.CancellationToken.isCancellationToken(M)?M:C,ce=[],oe=[],ge=[],de=[];let me=!0;for(const we of m){we.uuid?oe.push(we.uuid):ce.push(we.id);const be=!!(we.version||we.preRelease);ge.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),me=me&&!!we.hasPreRelease&&!be}if(!oe.length&&!ce.length)return[];let fe=new E().withPage(1,m.length);oe.length&&(fe=fe.withFilter(s.ExtensionId,...oe)),ce.length&&(fe=fe.withFilter(s.ExtensionName,...ce)),(Z.queryAllVersions||me)&&(fe=fe.withFlags(fe.flags,i.IncludeVersions)),Z.source&&(fe=fe.withSource(Z.source));const{extensions:he}=await this.z(fe,{targetPlatform:Z.targetPlatform??t,includePreRelease:ge,versions:de,compatible:!!Z.compatible},H);return Z.source&&he.forEach((we,be)=>X(we,be,Z.source)),he}async getCompatibleExtension(m,M,C){if((0,R.$Yn)(m.allTargetPlatforms,C))return null;if(await this.isExtensionCompatible(m,M,C))return m;const Z=new E().withFlags(i.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,m.identifier.uuid),{extensions:H}=await this.z(Z,{targetPlatform:C,compatible:!0,includePreRelease:M},D.CancellationToken.None);return H[0]||null}async isExtensionCompatible(m,M,C){if(!(0,R.$Zn)(m.properties.targetPlatform,m.allTargetPlatforms,C)||!M&&m.properties.isPreReleaseVersion)return!1;let Z=m.properties.engine;if(!Z){const H=await this.getManifest(m,D.CancellationToken.None);if(!H)throw new Error("Manifest was not found");Z=H.engines.vscode}return(0,d.$Ko)(Z,this.u.version,this.u.date)}async y(m,M,C,Z,H){if(!(0,R.$Zn)(T(m),Z,H)||M!=="any"&&le(m)!==(M==="prerelease"))return!1;if(C)try{const ce=await this.E(m);if(!(0,d.$Ko)(ce,this.u.version,this.u.date))return!1}catch(ce){return this.l.error(`Error while getting the engine for the version ${m.version}.`,(0,O.$9)(ce)),!1}return!0}async query(m,M){let C=m.text||"";const Z=m.pageSize??50;let H=new E().withPage(1,Z);C?(C=C.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,fe,he)=>(H=H.withFilter(s.Category,he||fe),"")),C=C.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,fe,he)=>(H=H.withFilter(s.Tag,he||fe),"")),C=C.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(s.Featured),"")),C=C.trim(),C&&(C=C.length<200?C:C.substring(0,200),H=H.withFilter(s.SearchText,C)),H=H.withSortBy(0)):m.ids?H=H.withFilter(s.ExtensionId,...m.ids):m.names?H=H.withFilter(s.ExtensionName,...m.names):H=H.withSortBy(4),typeof m.sortBy=="number"&&(H=H.withSortBy(m.sortBy)),typeof m.sortOrder=="number"&&(H=H.withSortOrder(m.sortOrder)),m.source&&(H=H.withSource(m.source));const ce=async(me,fe)=>{const{extensions:he,total:we}=await this.z(me,{targetPlatform:t,compatible:!1,includePreRelease:!!m.includePreRelease},fe);return he.forEach((be,ke)=>X(be,(me.pageNumber-1)*me.pageSize+ke,m.source)),{extensions:he,total:we}},{extensions:oe,total:ge}=await ce(H,M),de=async(me,fe)=>{if(fe.isCancellationRequested)throw new O.$4;const{extensions:he}=await ce(H.withPage(me+1),fe);return he};return{firstPage:oe,total:ge,pageSize:H.pageSize,getPage:de}}async z(m,M,C){const Z=m.flags;m.flags&i.IncludeLatestVersionOnly&&m.flags&i.IncludeVersions&&(m=m.withFlags(m.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(m.flags&i.IncludeLatestVersionOnly)&&!(m.flags&i.IncludeVersions)&&(m=m.withFlags(m.flags,i.IncludeLatestVersionOnly)),M.versions?.length&&(m=m.withFlags(m.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),m=m.withFlags(m.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:H,total:ce,context:oe}=await this.B(m,C);if(!(m.flags&i.IncludeLatestVersionOnly)){const fe=[];for(const he of H){const we=await this.A(he,M,oe);we&&fe.push(we)}return{extensions:fe,total:ce}}const de=[],me=new Map;for(let fe=0;fe<H.length;fe++){const he=H[fe],we={id:(0,g.$xo)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,v.$Df)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Me=>(0,g.$so)(Me,we))?.includePreRelease;if(M.compatible&&(0,R.$Yn)(U(he),M.targetPlatform))continue;const ke=await this.A(he,M,oe);!ke||ke.properties.isPreReleaseVersion&&(!be||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==M.targetPlatform&&ke.hasPreReleaseVersion?me.set(he.extensionId,fe):de.push([fe,ke])}if(me.size){const fe=new k.$Id,he=new E().withFlags(Z&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,me.size).withFilter(s.ExtensionId,...me.keys()),{extensions:we}=await this.z(he,M,C);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:me.size});for(const be of we){const ke=me.get(be.identifier.uuid);de.push([ke,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:ce}}async A(m,M,C){const Z={id:(0,g.$xo)(m.publisher.publisherName,m.extensionName),uuid:m.extensionId},H=M.versions?.find(de=>(0,g.$so)(de,Z))?.version,ce=(0,v.$Df)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(de=>(0,g.$so)(de,Z))?.includePreRelease,oe=U(m),ge=V(m.versions,M.targetPlatform);if(M.compatible&&(0,R.$Yn)(oe,M.targetPlatform))return null;for(let de=0;de<ge.length;de++){const me=ge[de];if(!(H&&me.version!==H)){if(await this.y(me,ce?"any":"release",M.compatible,oe,M.targetPlatform))return K(m,me,oe,C);if(H&&me.version===H)return null}}return H||M.compatible?null:K(m,m.versions[0],oe)}async B(m,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");m=m.withFlags(m.flags,i.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(i.Unpublished));const C=await this.j,Z=JSON.stringify(m.raw),H={...C,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},ce=new k.$Id;let oe,ge,de=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&m.criteria.some(fe=>fe.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:Z,headers:H},M),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:de};const me=await(0,h.$Ro)(oe);if(me){const fe=me.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[a]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(me){throw ge=me,me}finally{this.o.publicLog2("galleryService:query",{...m.telemetryData,requestBodySize:String(Z.length),duration:ce.elapsed(),success:!!oe&&(0,h.$No)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:ge?(0,O.$3)(ge)?"canceled":(0,O.$9)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(m,M,C,Z){if(!this.isEnabled())return;const H=A.$p?this.x(`/itemName/${m}.${M}/version/${C}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${m}/extensions/${M}/${C}/stats?statType=${Z}`),ce=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:ce};try{await this.k.request({type:"POST",url:H,headers:ge},D.CancellationToken.None)}catch{}}async download(m,M,C){this.l.trace("ExtensionGalleryService#download",m.identifier.id);const Z=(0,g.$Ao)(m),H=new Date().getTime(),ce=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Z,duration:fe}),oe=C===2?"install":C===3?"update":"",ge=oe?{uri:`${m.assets.download.uri}${u.URI.parse(m.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${m.assets.download.fallbackUri}${u.URI.parse(m.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:m.assets.download,de=m.queryContext?.[a]?{[a]:m.queryContext[a]}:void 0,me=await this.D(ge,de?{headers:de}:void 0);await this.q.writeFile(M,me.stream),ce(new Date().getTime()-H)}async downloadSignatureArchive(m,M){if(!m.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",m.identifier.id);const C=await this.D(m.assets.signature);await this.q.writeFile(M,C.stream)}async getReadme(m,M){if(m.assets.readme){const C=await this.D(m.assets.readme,{},M);return await(0,h.$Qo)(C)||""}return""}async getManifest(m,M){if(m.assets.manifest){const C=await this.D(m.assets.manifest,{},M),Z=await(0,h.$Qo)(C);return Z?JSON.parse(Z):null}return null}async C(m,M){const C=ue(m,r.Manifest);if(!C)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},H=await this.D(C,{headers:Z});return await(0,h.$Ro)(H)}async getCoreTranslation(m,M){const C=m.assets.coreTranslations.filter(Z=>Z[0]===M.toUpperCase())[0];if(C){const Z=await this.D(C[1]),H=await(0,h.$Qo)(Z);return H?JSON.parse(H):null}return null}async getChangelog(m,M){if(m.assets.changelog){const C=await this.D(m.assets.changelog,{},M);return await(0,h.$Qo)(C)||""}return""}async getAllCompatibleVersions(m,M,C){let Z=new E().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);m.identifier.uuid?Z=Z.withFilter(s.ExtensionId,m.identifier.uuid):Z=Z.withFilter(s.ExtensionName,m.identifier.id);const{galleryExtensions:H}=await this.B(Z,D.CancellationToken.None);if(!H.length)return[];const ce=U(H[0]);if((0,R.$Yn)(ce,C))return[];const oe=[];await Promise.all(H[0].versions.map(async me=>{try{await this.y(me,M?"any":"release",!0,ce,C)&&oe.push(me)}catch{}}));const ge=[],de=new Set;for(const me of V(oe,C))de.has(me.version)||(de.add(me.version),ge.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:le(me)}));return ge}async D(m,M={},C=D.CancellationToken.None){const Z=await this.j,H={type:"GET"},ce={...Z,...M.headers||{}};M={...M,...H,headers:ce};const oe=m.uri,ge=m.fallbackUri,de={...M,url:oe};try{const me=await this.k.request(de,C);if(me.res.statusCode===200)return me;const fe=await(0,h.$Qo)(me);throw new Error(`Expected 200, got back ${me.res.statusCode} instead.

${fe}`)}catch(me){if((0,O.$3)(me))throw me;const fe=(0,O.$9)(me);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:fe});const he={...M,url:ge};return this.k.request(he,C)}}async E(m){let M=ae(m);if(!M){const C=await this.C(m,D.CancellationToken.None);if(!C)throw new Error("Manifest was not found");M=C.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const m=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(m.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,h.$Ro)(m),C=[],Z={},H=[];if(M){for(const ce of M.malicious)C.push({id:ce});if(M.migrateToPreRelease)for(const[ce,oe]of Object.entries(M.migrateToPreRelease))(!oe.engine||(0,d.$Ko)(oe.engine,this.u.version,this.u.date))&&(Z[ce.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[ce,oe]of Object.entries(M.deprecated))oe&&(Z[ce.toLowerCase()]=(0,v.$Df)(oe)?{}:oe);if(M.search)for(const ce of M.search)H.push(ce)}return{malicious:C,deprecated:Z,search:H}}};Q=pe([se(1,h.$Lo),se(2,w.$8i),se(3,b.$Uh),se(4,p.$_k),se(5,S.$9j),se(6,$.$nj),se(7,c.$hi)],Q);let F=class extends Q{constructor(m,M,C,Z,H,ce,oe,ge){super(m,M,C,Z,H,ce,oe,ge)}};e.$8o=F,e.$8o=F=pe([se(0,I.$Yo),se(1,h.$Lo),se(2,w.$8i),se(3,b.$Uh),se(4,p.$_k),se(5,S.$9j),se(6,$.$nj),se(7,c.$hi)],F);let z=class extends Q{constructor(m,M,C,Z,H,ce,oe){super(void 0,m,M,C,Z,H,ce,oe)}};e.$9o=z,e.$9o=z=pe([se(0,h.$Lo),se(1,w.$8i),se(2,b.$Uh),se(3,p.$_k),se(4,S.$9j),se(5,$.$nj),se(6,c.$hi)],z)}),define(ne[159],re([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,L,D,O,A,j,v,u,c,b){"use strict";var R,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=e.$rN=e.$qN=void 0;let d=class extends u.$Kk{static{R=this}static{this.a="profileAssociationsMigration"}constructor(h,f,I,p,k){super(I,p,f,k),this.U=h,this.W=I}O(){return this.U.getItem(R.b,[]).map(f=>({...f,location:(0,c.$xf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):L.URI.revive(f.location)}))}Q(){const h=this.U.getItem(R.c,{});return this.U.getItem(R.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$qN=d,e.$qN=d=R=pe([se(0,j.$lN),se(1,v.$Fk),se(2,D.$Vh),se(3,O.$9j),se(4,A.$8i)],d);let S=g=class extends d{constructor(h,f,I,p,k){super(h,f,I,p,k),this.$=h}P(h){h.length?this.$.setItem(g.b,h.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(g.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(g.c,h):this.$.removeItem(g.c)}Q(){const h="workspaceAndProfileInfo",f=this.$.getItem(h,void 0);if(f){this.$.removeItem(h);const p=f.reduce((k,{workspace:t,profile:a})=>(k[L.URI.revive(t).toString()]=L.URI.revive(a).toString(),k),{});this.$.setItem(g.c,{workspaces:p})}const I=super.Q();return this.$.getItem(g.a,!1)||(this.R(I),this.$.setItem(g.a,!0)),I}};e.$rN=S,e.$rN=S=g=pe([se(0,j.$mN),se(1,v.$Fk),se(2,D.$Vh),se(3,O.$9j),se(4,A.$8i)],S);let w=class extends S{constructor(h,f,I,p){super(new b.$pN(0,f,p,I),h,f,I,p)}async init(){return await this.$.init(),super.init()}};e.$sN=w,e.$sN=w=pe([se(0,v.$Fk),se(1,D.$Vh),se(2,O.$9j),se(3,A.$8i)],w)}),define(ne[51],re([0,1,125,8,16,3,24,87,176,177]),function(J,e,L,D,O,A,j,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=e.$gp=e.zip=e.$ep=e.$dp=void 0,e.$dp="end of central directory record signature not found";const b=new RegExp(e.$dp);class R extends Error{constructor(a,i){let n=i.message;switch(a){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=a,this.cause=i}}e.$ep=R;function g(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>a&i).reduce((i,n)=>i+n,a&61440)}function d(t){if(t instanceof R)return t;let a;return b.test(t.message)&&(a="CorruptZip"),new R(a,t)}function S(t,a,i,n,s,r){const l=O.$lc(a),P=O.$ic(n,l);if(!P.startsWith(n))return Promise.reject(new Error(v.localize(0,null,a)));const y=O.$ic(n,a);let E;return r.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(j.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((N,W)=>{if(!r.isCancellationRequested)try{E=(0,L.createWriteStream)(y,{mode:i}),E.once("close",()=>N()),E.once("error",W),t.once("error",W),t.pipe(E)}catch(x){W(x)}}))}function w(t,a,i,n){let s=(0,D.$Gg)(()=>Promise.resolve()),r=0;const l=n.onCancellationRequested(()=>{s.cancel(),t.close()});return new Promise((P,y)=>{const E=new D.$Ng,N=W=>{W.isCancellationRequested||(r++,t.readEntry())};t.once("error",y),t.once("close",()=>s.then(()=>{n.isCancellationRequested||t.entryCount===r?P():y(new R("Incomplete",new Error(v.localize(1,null,r,t.entryCount))))},y)),t.readEntry(),t.on("entry",W=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(W.fileName)){N(n);return}const x=W.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(x)){const te=O.$ic(a,x);s=(0,D.$Gg)(ae=>j.Promises.mkdir(te,{recursive:!0}).then(()=>N(ae)).then(void 0,y));return}const _=h(t,W),ue=g(W);s=(0,D.$Gg)(te=>E.queue(()=>_.then(ae=>S(ae,x,ue,a,i,te).then(()=>N(te)))).then(null,y))})}).finally(()=>l.dispose())}function $(t,a=!1){return new Promise((i,n)=>{(0,u.open)(t,a?{lazyEntries:!0}:void 0,(s,r)=>{s?n(d(s)):i((0,A.$If)(r))})})}function h(t,a){return new Promise((i,n)=>{t.openReadStream(a,(s,r)=>{s?n(d(s)):i((0,A.$If)(r))})})}function f(t,a){return new Promise((i,n)=>{const s=new c.ZipFile;a.forEach(l=>{l.contents?s.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&s.addFile(l.localPath,l.path)}),s.end();const r=(0,L.createWriteStream)(t);s.outputStream.pipe(r),s.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>i(t))})}e.zip=f;function I(t,a,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let r=$(t,!0);return i.overwrite&&(r=r.then(l=>j.Promises.rm(a).then(()=>l))),r.then(l=>w(l,a,{sourcePathRegex:s},n))}e.$gp=I;function p(t,a){return $(t).then(i=>new Promise((n,s)=>{i.on("entry",r=>{r.fileName===a&&h(i,r).then(l=>n(l),l=>s(l))}),i.once("close",()=>s(new Error(v.localize(2,null,a))))}))}function k(t,a){return p(t,a).then(i=>new Promise((n,s)=>{const r=[];i.once("error",s),i.on("data",l=>r.push(l)),i.on("end",()=>n(Buffer.concat(r)))}))}e.$hp=k}),define(ne[160],re([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d,S,w,$,h,f){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;let p=class extends O.$Rc{static{I=this}static{this.c=".sigzip"}constructor(t,a,i,n,s,r){super(),this.h=a,this.j=i,this.m=n,this.n=s,this.r=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,a,i){await this.g;const n=(0,j.$ug)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,n,r=>this.j.download(t,r,a))}catch(r){throw new S.$4n(r.message,S.ExtensionManagementErrorCode.Download)}let s=!1;if(i&&this.t(t)){const r=await this.u(t);try{s=await this.n.verify(n.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(l){const P=l;if(s=P.code,P.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${P.output}`),s===S.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===S.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new S.$4n(R.$dp,S.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return s===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${t.identifier.id}`),{location:n,verificationStatus:s}}t(t){if(!t.isSigned)return!1;const a=this.m.getValue("extensions.verifySignature");return(0,u.$Df)(a)?a:!0}async u(t){await this.g;const a=(0,j.$ug)(this.extensionsDownloadDir,`${this.z(t)}${I.c}`);return await this.w(t,a,i=>this.j.downloadSignatureArchive(t,i)),a}async w(t,a,i){if(await this.h.exists(a))return;if(a.scheme!==A.Schemas.file){await i(a);return}const n=(0,j.$ug)(this.extensionsDownloadDir,`.${(0,c.$dg)()}`);await this.h.exists(n)||await i(n);try{await b.Promises.rename(n.fsPath,a.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.r.info(`Rename failed because of ${(0,D.$9)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],i=[],n=[];for(const l of t.children)if(l.name.endsWith(I.c))n.push(l.resource);else{const P=w.$to.parse(l.name);P&&i.push([P,l])}const s=(0,w.$yo)(i,([l])=>l),r=[];for(const l of s)l.sort((P,y)=>v.rcompare(P[0].version,y[0].version)),a.push(...l.slice(1).map(P=>P[1].resource)),r.push(l[0][1]);r.sort((l,P)=>l.mtime-P.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),a.push(...n),await L.Promises.settled(a.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(t){this.r.error(t)}}z(t){return this.f?w.$to.create(t).toString().toLowerCase():(0,c.$dg)()}};e.$wp=p,e.$wp=p=I=pe([se(0,d.$Vh),se(1,h.$9j),se(2,S.$3n),se(3,g.$hi),se(4,$.$0o),se(5,f.$8i)],p)}),define(ne[161],re([0,1,51,97]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=void 0;function O(A){return(0,L.$hp)(A,"extension/package.json").then(j=>{try{return JSON.parse(j.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$yp=O}),define(ne[162],re([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d,S,w,$,h,f,I,p,k,t,a,i,n,s,r,l,P,y,E,N,W,x,_,ue,te,ae,le,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.$Cp=e.$Bp=void 0,e.$Bp=(0,_.$Oh)(i.$5n);const q=".vsctmp";let G=class extends a.$ip{constructor(F,z,o,m,M,C,Z,H,ce,oe,ge,de){super(F,z,ge,o,oe,de),this.fb=M,this.gb=C,this.hb=Z,this.ib=ce,this.eb=new Map,this.rb=new b.$Ac;const me=this.B(H.createInstance(P.$xp));this.bb=this.B(H.createInstance(T,he=>me.postUninstall(he))),this.cb=this.B(new E.$zp(de,ce,ge,this,this.F)),this.db=this.B(H.createInstance(l.$wp));const fe=this.B(new N.$Ap(this,this.fb,de,C,ge,ce,o));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$Do)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const z=await this.pb(F),o=await(0,I.zip)((0,d.$ug)(this.db.extensionsDownloadDir,(0,h.$dg)()).fsPath,z);return $.URI.file(o)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:z,cleanup:o}=await this.lb(F),m=g.$jc(z.fsPath);try{return await(0,y.$yp)(m)}finally{await o()}}getInstalled(F,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(F??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.bb.scanUserExtensionAtLocation(F)}async install(F,z={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:o,cleanup:m}=await this.lb(F);try{const M=await(0,y.$yp)(g.$jc(o.fsPath)),C=(0,n.$xo)(M.publisher,M.name);if(M.engines&&M.engines.vscode&&!(0,W.$Ko)(M.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,C,this.G.version));const H=(await this.I([{manifest:M,extension:o,options:z}])).find(({identifier:ce})=>(0,n.$so)(ce,{id:C}));if(H?.local)return H.local;throw H?.error?H.error:(0,a.$kp)(new Error(`Unknown error while installing extension ${C}`))}finally{await m()}}async installFromLocation(F,z){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const o=await this.bb.scanUserExtensionAtLocation(F);if(!o)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.ub([[o,void 0]],z),this.F.info("Successfully installed extension",o.identifier.id,z.toString()),o}async installExtensionsFromProfile(F,z,o){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,z.toString(),o.toString());const m=(await this.bb.scanExtensions(1,z)).filter(M=>F.some(C=>(0,n.$so)(C,M.identifier)));if(m.length){const M=await Promise.all(m.map(C=>this.bb.scanMetadata(C,z)));await this.ub(m.map((C,Z)=>[C,M[Z]]),o),this.F.info("Successfully installed extensions",m.map(C=>C.identifier.id),o.toString())}return m}async updateMetadata(F,z,o=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.pinned=z.pinned||void 0,F=await this.bb.updateMetadata(F,z,o),this.cb.invalidate(o),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const z=await this.getTargetPlatform(),[o]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:z,compatible:!0},O.CancellationToken.None);if(!o)throw new Error(p.localize(2,null));await this.bb.setUninstalled(F);try{await this.bb.removeUninstalledExtension(F)}catch(m){throw new Error(p.localize(3,null,(0,A.$yi)(m)))}return this.installFromGallery(o)}ab(F,z,o,m){return this.bb.copyExtension(F,z,o,m)}copyExtensions(F,z){return this.bb.copyExtensions(F,z)}markAsUninstalled(...F){return this.bb.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(F){this.F.error(F)}}async download(F,z,o){const{location:m}=await this.db.download(F,z,!o);return m}async lb(F){if(F.scheme===R.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const z=(0,d.$ug)(this.db.extensionsDownloadDir,(0,h.$dg)());return await this.hb.download(F,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(m){this.F.error(m)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(F,z,o){if($.URI.isUri(z))return new X(F,z,o,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const m=n.$to.create(z).toString();let M=this.eb.get(m);return M||(this.eb.set(m,M=new V(F,z,o,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),M.waitUntilTaskIsFinished().finally(()=>this.eb.delete(m))),M}$(F,z){return new K(F,z.profileLocation,this.gb)}async pb(F){const z=async m=>{let M=await f.Promises.readdir(m);M=M.map(H=>g.$ic(m,H));const C=await Promise.all(M.map(H=>f.Promises.stat(H)));let Z=Promise.resolve([]);return C.forEach((H,ce)=>{const oe=M[ce];H.isFile()&&(Z=Z.then(ge=>[...ge,oe])),H.isDirectory()&&(Z=Z.then(ge=>z(oe).then(de=>[...ge,...de])))}),Z};return(await z(F.location.fsPath)).map(m=>({path:`extension/${g.$kc(F.location.fsPath,m)}`,localPath:m}))}async qb({added:F,removed:z}){if(z){const o=F&&this.D.extUri.isEqual(z.profileLocation,F.profileLocation)?z.extensions.filter(m=>F.extensions.every(M=>!(0,n.$so)(M,m))):z.extensions;for(const m of o)this.F.info("Extensions removed from another source",m.id,z.profileLocation.toString()),this.u.fire({identifier:m,profileLocation:z.profileLocation})}if(F){const m=(await this.bb.scanExtensions(1,F.profileLocation)).filter(M=>F.extensions.some(C=>(0,n.$so)(C,M.identifier)));this.s.fire(m.map(M=>(this.F.info("Extensions added from another source",M.identifier.id,F.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:F.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const F=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of F.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(F){if(!F.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const o of F.rawAdded){if(this.rb.has(o)||!this.D.extUri.isEqual(this.D.extUri.dirname(o),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(o,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(o).startsWith(".")||!(await this.ib.stat(o)).isDirectory)continue;const m=await this.bb.scanUserExtensionAtLocation(o);m&&m.installedTimestamp===void 0&&(this.rb.add(o),z.push(m))}z.length&&(await this.ub(z.map(o=>[o,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(o=>o.identifier.id)))}async ub(F,z){const o=F.map(m=>m[0]);await this.vb(o),await this.gb.addExtensionsToProfile(F,z),this.s.fire(o.map(m=>({local:m,identifier:m.identifier,operation:1,profileLocation:z})))}async vb(F){const z=await this.bb.getUninstalledExtensions();for(const o of F){const m=n.$to.create(o);z[m.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",m.id),await this.bb.setInstalled(m),this.F.info("Removed the extension from uninstalled list:",m.id))}}};e.$Cp=G,e.$Cp=G=pe([se(0,i.$3n),se(1,ae.$_k),se(2,ue.$8i),se(3,t.$Vh),se(4,r.$rp),se(5,s.$np),se(6,k.$Gn),se(7,_.$Mh),se(8,x.$9j),se(9,te.$nj),se(10,le.$Fk),se(11,ie.$Hk)],G);let T=class extends c.$Rc{constructor(F,z,o,m,M,C){super(),this.j=F,this.m=z,this.n=o,this.s=m,this.t=M,this.u=C,this.h=this.B(new v.$Md),this.onExtract=this.h.event,this.c=(0,d.$ug)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$Zg}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,z){const o={includeInvalid:!0,profileLocation:z};let m=[];return F===null||F===0?m.push(...await this.n.scanAllExtensions({includeInvalid:!0},o,!1)):F===1&&m.push(...await this.n.scanUserExtensions(o)),m=F!==null?m.filter(M=>M.type===F):m,Promise.all(m.map(M=>this.F(M)))}async scanAllUserExtensions(F){const z=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(z.map(o=>this.F(o)))}async scanUserExtensionAtLocation(F){try{const z=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(F,z,o,m,M){const C=F.toString(),Z=$.URI.file(g.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,h.$dg)()}`)),H=$.URI.file(g.$ic(this.n.userExtensionsLocation.fsPath,C));let ce=await this.m.exists(H);if(ce&&m){try{await this.y(F.id,H,"removeExisting")}catch{throw new i.$4n(p.localize(4,null,H.fsPath,F.id),i.ExtensionManagementErrorCode.Delete)}ce=!1}if(!ce)try{try{this.u.trace(`Started extracting the extension from ${z} to ${H.fsPath}`),await(0,I.$gp)(z,Z.fsPath,{sourcePath:"extension",overwrite:!0},M),this.u.info(`Extracted extension to ${H}:`,F.id)}catch(oe){let ge=i.ExtensionManagementErrorCode.Extract;throw oe instanceof I.$ep&&(oe.type==="CorruptZip"?ge=i.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(ge=i.ExtensionManagementErrorCode.IncompleteZip)),new i.$4n(oe.message,ge)}await this.n.updateMetadata(Z,o);try{this.u.trace(`Started renaming the extension from ${Z.fsPath} to ${H.fsPath}`),await this.C(Z.fsPath,H.fsPath),this.u.info("Renamed to",H.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,j.$9)(oe)}. Deleted from extracted location`,Z),oe}this.h.fire(H)}catch(oe){try{await this.m.del(Z,{recursive:!0})}catch{}throw oe}return this.D(H,1)}async scanMetadata(F,z){return z?(await this.w(F,z))?.metadata:this.n.scanMetadata(F.location)}async w(F,z){return(await this.s.scanProfileExtensions(z)).find(m=>(0,n.$so)(m.identifier,F.identifier))}async updateMetadata(F,z,o){return o?await this.s.updateMetadata([[F,z]],o):await this.n.updateMetadata(F.location,z),this.D(F.location,F.type,o)}getUninstalledExtensions(){return this.z()}async setUninstalled(...F){const z=F.map(o=>n.$to.create(o));await this.z(o=>z.forEach(m=>{o[m.toString()]=!0,this.u.info("Marked extension as uninstalled",m.toString())}))}async setInstalled(F){await this.z(z=>delete z[F.toString()])}async removeExtension(F,z){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,z)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(z=>delete z[n.$to.create(F).toString()])}async copyExtension(F,z,o,m){const M=await this.w(F,z),C=await this.w(F,o);return m={...M?.metadata,...m},C?await this.s.updateMetadata([[F,{...C.metadata,...m}]],o):await this.s.addExtensionsToProfile([[F,m]],o),this.D(F.location,F.type,o)}async copyExtensions(F,z){const o=await this.scanExtensions(1,F),m=await Promise.all(o.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,F)]));await this.s.addExtensionsToProfile(m,z)}async y(F,z,o){this.u.trace(`Deleting ${o} extension from disk`,F,z.fsPath);const m=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,u.$Bi)((0,h.$dg)()).toString(16)}${q}`);await this.C(z.fsPath,m.fsPath),await this.m.del(m,{recursive:!0}),this.u.info(`Deleted ${o} extension from disk`,F,z.fsPath)}async z(F){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(m){if((0,x.$mk)(m)!==1)throw m}let o={};if(z)try{o=JSON.parse(z)}catch{}return F&&(F(o),Object.keys(o).length?await this.m.writeFile(this.c,D.$ae.fromString(JSON.stringify(o))):await this.m.del(this.c)),o})}async C(F,z){try{await f.Promises.rename(F,z,2*60*1e3)}catch(o){throw new i.$4n(o.message||p.localize(5,null,F,z),o.code||i.ExtensionManagementErrorCode.Rename)}}async D(F,z,o){if(o){const M=(await this.n.scanUserExtensions({profileLocation:o})).find(C=>this.t.extUri.isEqual(C.location,F));if(M)return this.F(M)}else{const m=await this.n.scanExistingExtension(F,z,{includeInvalid:!0});if(m)return this.F(m)}throw new Error(p.localize(6,null,F.path))}async F(F){const z=await this.m.resolve(F.location);let o,m;return z.children&&(o=z.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,m=z.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:o,changelogUrl:m,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),o=new Set;for(const M of z)F[n.$to.create(M).toString()]||o.add(M.identifier.id.toLowerCase());try{const M=(0,n.$yo)(z,C=>C.identifier);await L.Promises.settled(M.map(async C=>{const Z=C.sort((H,ce)=>S.rcompare(H.manifest.version,ce.manifest.version))[0];o.has(Z.identifier.id.toLowerCase())||await this.j(await this.F(Z))}))}catch(M){this.u.error(M)}const m=z.filter(M=>M.metadata&&F[n.$to.create(M).toString()]);await Promise.allSettled(m.map(M=>this.removeUninstalledExtension(M)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,x.$mk)(z)!==1&&this.u.error(z);return}if(F?.children)try{await Promise.allSettled(F.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(o){(0,x.$mk)(o)!==1&&this.u.error(o)}}}))}catch{}}};e.$Dp=T,e.$Dp=T=pe([se(1,x.$9j),se(2,r.$rp),se(3,s.$np),se(4,le.$Fk),se(5,ue.$8i)],T);class U extends a.$lp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,w.$Ef)(this.options.operation)?this.l:this.options.operation}constructor(F,z,o,m,M,C,Z,H,ce){super(),this.identifier=F,this.source=z,this.options=o,this.m=m,this.n=M,this.o=C,this.p=Z,this.q=H,this.s=ce,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[z,o]=await this.x(F);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,o]],this.j),z}async u({zipPath:F,key:z,metadata:o},m,M){let C=await this.v(z);return C||(this.s.trace("Extracting extension...",z.id),C=await this.m.extractUserExtension(z,F,o,m,M),this.s.info("Extracting extension completed.",z.id)),C}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(m=>n.$to.create(m).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class V extends U{constructor(F,z,o,m,M,C,Z,H,ce,oe){super(z.identifier,z,o,M,C,Z,H,ce,oe),this.y=z,this.z=m}async x(F){const o=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Z=>(0,n.$so)(Z.identifier,this.y.identifier));o&&(this.l=3);const m={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||o?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||o?.isMachineScoped,isBuiltin:this.options.isBuiltin||o?.isBuiltin,isSystem:o?.type===0?!0:void 0,updated:!!o,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,w.$Df)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:o?.preRelease)};if(o?.manifest.version===this.y.version)return[await this.m.updateMetadata(o,m),m];const{location:M,verificationStatus:C}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=C,this.B(M.fsPath),[await this.u({zipPath:M.fsPath,key:n.$to.create(this.y),metadata:m},!1,F),m]}catch(Z){try{await this.z.delete(M)}catch(H){this.s.warn("Error while deleting the downloaded file",M.toString(),(0,j.$9)(H))}throw Z}}async B(F){try{await(0,y.$yp)(F)}catch(z){throw new i.$4n((0,a.$jp)(z).message,i.ExtensionManagementErrorCode.Invalid)}}}e.$Ep=V;class X extends U{constructor(F,z,o,m,M,C,Z,H,ce,oe){super({id:(0,n.$xo)(F.publisher,F.name)},z,o,M,C,Z,H,ce,oe),this.y=F,this.z=z,this.A=m}async h(F){const z=await super.h(F);return this.D(z,F),z}async x(F){const z=new n.$to(this.identifier,this.y.version),m=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Z=>(0,n.$so)(this.identifier,Z.identifier)),M={isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(m)if(this.l=3,z.equals(new n.$to(m.identifier,m.manifest.version)))try{await this.m.removeExtension(m,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&S.gt(m.manifest.version,this.y.version)&&await this.m.setUninstalled(m);else{const Z=await this.v(z);if(Z)try{await this.m.removeExtension(Z,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:g.$jc(this.z.fsPath),key:z,metadata:M},!0,F),M]}async D(F,z){try{let[o]=await this.A.getExtensions([{id:F.identifier.id,version:F.manifest.version}],z);if(o||([o]=await this.A.getExtensions([{id:F.identifier.id}],z)),o){const m={id:o.identifier.uuid,publisherDisplayName:o.publisherDisplayName,publisherId:o.publisherId,isPreReleaseVersion:o.properties.isPreReleaseVersion,preRelease:o.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,m,this.options.profileLocation)}}catch{}}}class K extends a.$lp{constructor(F,z,o){super(),this.extension=F,this.j=z,this.k=o}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,44,136,178]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;let S=class extends R.$Mo{constructor(f,I,p,k){super(k),this.m=f,this.n=I,this.r=p,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,I){const{f:p,g:k}=this;let t;try{t=await(0,c.$Pl)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$9)(n)))}const a={...process.env,...t},i=f.agent?f.agent:await(0,g.$Qq)(f.url||"",a,{proxyUrl:p,strictSSL:k});return f.agent=i,f.strictSSL=k,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>$(f,I))}async resolveProxy(f){}};e.$Rq=S,e.$Rq=S=pe([se(0,v.$hi),se(1,u.$Vh),se(2,b.$8i),se(3,b.$9i)],S);async function w(h){return((0,L.parse)(h.url).protocol==="https:"?await new Promise((p,k)=>{J(["https"],p,k)}):await new Promise((p,k)=>{J(["http"],p,k)})).request}async function $(h,f){return D.Promises.withAsyncBody(async(I,p)=>{const k=(0,L.parse)(h.url),t=h.getRawRequest?h.getRawRequest(h):await w(h),a={hostname:k.hostname,port:k.port?parseInt(k.port):k.protocol==="https:"?443:80,protocol:k.protocol,path:k.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,j.$Df)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(a.auth=h.user+":"+h.password);const i=t(a,n=>{const s=(0,j.$Bf)(h.followRedirects)?h.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)$({...h,url:n.headers.location,followRedirects:s-1},f).then(I,p);else{let r=n;!h.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(r=n.pipe((0,d.createGunzip)())),I({res:n,stream:(0,O.$pe)(r)})}});i.on("error",p),h.timeout&&i.setTimeout(h.timeout),h.isChromiumNetwork&&i.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&i.write(h.data),i.end(),f.onCancellationRequested(()=>{i.abort(),p(new A.$4)})})}e.$Sq=$}),define(ne[179],re([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,L,D,O,A,j,v,u,c,b,R,g,d,S,w,$,h,f,I,p,k,t,a,i,n,s,r,l,P,y,E,N,W,x,_,ue,te,ae,le,ie,q,G,T,U,V,X,K,Q,F,z,o,m,M,C,Z,H,ce,oe,ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends j.$Rc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const ke=be.get(_.$8i),Me=be.get(r.$9j),B=be.get(h.$Vh),Y=be.get(m.$Hk);ke.info("CLI main",this.b),this.g(ke),await this.h(B,Me,Y,he),await Promise.all(we.map(ee=>{(0,D.$Kg)(ee.flush(),1e3)}))})}async f(){const he=new N.$Lh,we={_serviceBrand:void 0,...le.default};he.set(ie.$nj,we);const be=new f.$cm(this.b,we);he.set(h.$Vh,be),await Promise.all([be.appSettingsHome.with({scheme:v.Schemas.file}).fsPath,be.extensionsPath].map(De=>De?g.Promises.mkdir(De,{recursive:!0}):void 0));const ke=new ce.$kN((0,_.$jj)(be),be.logsHome);he.set(_.$9i,ke);const Me=this.B(ke.createLogger("cli",{name:(0,oe.localize)(0,null)})),B=[];ke.getLogLevel()===_.LogLevel.Trace&&B.push(new _.$dj(ke.getLogLevel()));const Y=this.B(new H.$uN(Me,B));he.set(_.$8i,Y);const ee=this.B(new l.$Gp(Y));he.set(r.$9j,ee);const $e=this.B(new P.$6p(Y));ee.registerProvider(v.Schemas.file,$e);const ye=new o.$sr(ee);he.set(z.$Fk,ye);const Ne=new T.$oN(1,be,Y,ee),Se=new M.$qN(Ne,ye,be,ee,Y);he.set(m.$Hk,Se),ee.registerProvider(v.Schemas.vscodeUserData,new ge.$U7b(v.Schemas.file,$e,v.Schemas.vscodeUserData,Se,ye,Y));const Le=c.$j&&we.win32RegValueName?this.B(new ae.$S7b(Y,we.win32RegValueName)):be.policyFile?this.B(new ue.$T7b(be.policyFile,ee,Y)):new te.$cn;he.set(te.$an,Le);const Ie=this.B(new S.$Cn(Se.defaultProfile.settingsResource,ee,Le,Y));he.set(d.$hi,Ie),await Promise.all([Ne.init(),Ie.initialize()]);let Ae;try{Ae=await(0,C.$z7b)(Ne,Y)}catch(De){De.code!=="ENOENT"&&Y.error(De)}Se.init(),he.set(z.$Fk,new o.$sr(ee));const Fe=new G.$Rq(Ie,be,Y,ke);he.set(q.$Lo,Fe),he.set(w.$Gn,new y.$Kh($.$JN,void 0,!0)),he.set(a.$np,new y.$Kh(Z.$tN,void 0,!0)),he.set(i.$rp,new y.$Kh(s.$w7b,void 0,!0)),he.set(k.$0o,new y.$Kh(k.$$o,void 0,!0)),he.set(n.$Bp,new y.$Kh(n.$Cp,void 0,!0)),he.set(p.$3n,new y.$Kh(I.$9o,void 0,!0)),he.set(W.$Lq,new y.$Kh(x.$Nq,void 0,!1));const Re=[],je=(0,K.$po)(we,Ie);if((0,K.$ko)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Re.push(new Q.$iN(Fe,je,"monacoworkbench",null,we.aiConfig.ariaKey));const De={appenders:Re,sendErrorTelemetry:!1,commonProperties:(0,U.$ao)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ae,je),piiPaths:(0,K.$qo)(be)};he.set(V.$_k,new y.$Kh(X.$Tq,[De],!1))}else he.set(V.$_k,K.$eo);return[new E.$9p(he),Re]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,O.$yi)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$Y)(we)||(0,A.$Z)(we)}),process.on("unhandledRejection",we=>(0,A.$Z)(we))}async h(he,we,be,ke){let Me;if(he.args.profile&&(Me=be.profiles.find(Y=>Y.name===he.args.profile),!Me))throw new Error(`Profile '${he.args.profile}' not found.`);const B=(Me??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(t.$_o,new _.$dj(_.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,B);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Y={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:B};return ke.createInstance(t.$_o,new _.$dj(_.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Y,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(t.$_o,new _.$dj(_.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,B);if(this.b["locate-extension"])return ke.createInstance(t.$_o,new _.$dj(_.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$e8b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?R.URI.file((0,u.$hc)(we)?we:(0,u.$ic)((0,b.cwd)(),we)):we)}}async function me(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=me})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7d4027b62bb1e620e5454580450fa646682bc102/core/vs/code/node/cliProcessMain.js.map
