/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function($e){for(var e=[],D=0,T=$e.length;D<T;D++)e[D]=De[$e[D]];return e};define(De[156],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class D{static get(){const g=new Map,L=new Map,R=new Map,b=new Map;function E(k,S){k.has(S.detail)||k.set(S.detail,-S.timestamp)}function w(k,S){const p=k.get(S.detail);p&&(p>=0||k.set(S.detail,p+S.timestamp))}let A=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(A=$e.getStats().slice(0).sort((k,S)=>k.timestamp-S.timestamp));for(const k of A)switch(k.type){case 10:E(g,k);break;case 11:case 12:w(g,k);break;case 21:E(L,k);break;case 22:w(L,k);break;case 33:E(R,k);break;case 34:w(R,k);break;case 31:E(b,k);break;case 32:w(b,k);break}let I=0;R.forEach(k=>I+=k);function v(k){const S=[];return k.forEach((p,u)=>S.push([u,p])),S}return{amdLoad:v(g),amdInvoke:v(L),nodeRequire:v(R),nodeEval:v(b),nodeRequireTotal:I}}static toMarkdownTable(g,L){let R="";const b=[];return g.forEach((E,w)=>{b[w]=E.length}),L.forEach(E=>{E.forEach((w,A)=>{typeof w>"u"&&(w=E[A]="-");const I=w.toString().length;b[A]=Math.max(I,b[A])})}),g.forEach((E,w)=>{R+=`| ${E+" ".repeat(b[w]-E.toString().length)} `}),R+=`|
`,g.forEach((E,w)=>{R+=`| ${"-".repeat(b[w])} `}),R+=`|
`,L.forEach(E=>{E.forEach((w,A)=>{typeof w<"u"&&(R+=`| ${w+" ".repeat(b[A]-w.toString().length)} `)}),R+=`|
`}),R}}e.$T=D}),define(De[118],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function D(p,u,r){const s=T(p,u);if(s!==-1)return p[s]}e.$eb=D;function T(p,u,r=p.length-1){for(let s=r;s>=0;s--){const a=p[s];if(u(a))return s}return-1}e.$fb=T;function g(p,u){const r=L(p,u);return r===-1?void 0:p[r]}e.$gb=g;function L(p,u,r=0,s=p.length){let a=r,m=s;for(;a<m;){const l=Math.floor((a+m)/2);u(p[l])?a=l+1:m=l}return a-1}e.$hb=L;function R(p,u){const r=b(p,u);return r===p.length?void 0:p[r]}e.$ib=R;function b(p,u,r=0,s=p.length){let a=r,m=s;for(;a<m;){const l=Math.floor((a+m)/2);u(p[l])?m=l:a=l+1}return a}e.$jb=b;function E(p,u,r=0,s=p.length){const a=b(p,u,r,s);return a===p.length?-1:a}e.$kb=E;class w{static{this.assertInvariants=!1}constructor(u){this.e=u,this.c=0}findLastMonotonous(u){if(w.assertInvariants){if(this.d){for(const s of this.e)if(this.d(s)&&!u(s))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=u}const r=L(this.e,u,this.c);return this.c=r+1,r===-1?void 0:this.e[r]}}e.$lb=w;function A(p,u){if(p.length===0)return;let r=p[0];for(let s=1;s<p.length;s++){const a=p[s];u(a,r)>0&&(r=a)}return r}e.$mb=A;function I(p,u){if(p.length===0)return;let r=p[0];for(let s=1;s<p.length;s++){const a=p[s];u(a,r)>=0&&(r=a)}return r}e.$nb=I;function v(p,u){return A(p,(r,s)=>-u(r,s))}e.$ob=v;function k(p,u){if(p.length===0)return-1;let r=0;for(let s=1;s<p.length;s++){const a=p[s];u(a,p[r])>0&&(r=s)}return r}e.$pb=k;function S(p,u){for(const r of p){const s=u(r);if(s!==void 0)return s}}e.$qb=S}),define(De[73],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function D(R,b){const E=Object.create(null);for(const w of R){const A=b(w);let I=E[A];I||(I=E[A]=[]),I.push(w)}return E}e.$J=D;function T(R,b){const E=[],w=[];for(const A of R)b.has(A)||E.push(A);for(const A of b)R.has(A)||w.push(A);return{removed:E,added:w}}e.$K=T;function g(R,b){const E=[],w=[];for(const[A,I]of R)b.has(A)||E.push(I);for(const[A,I]of b)R.has(A)||w.push(I);return{removed:E,added:w}}e.$L=g;function L(R,b){const E=new Set;for(const w of b)R.has(w)&&E.add(w);return E}e.$M=L}),define(De[57],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function D(R){return(b,E,w)=>{let A=null,I=null;if(typeof w.value=="function"?(A="value",I=w.value):typeof w.get=="function"&&(A="get",I=w.get),!I)throw new Error("not supported");w[A]=R(I,E)}}function T(R,b,E){let w=null,A=null;if(typeof E.value=="function"?(w="value",A=E.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(w="get",A=E.get),!A)throw new Error("not supported");const I=`$memoize$${b}`;E[w]=function(...v){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,v)}),this[I]}}e.$fh=T;function g(R,b,E){return D((w,A)=>{const I=`$debounce$${A}`,v=`$debounce$result$${A}`;return function(...k){this[v]||(this[v]=E?E():void 0),clearTimeout(this[I]),b&&(this[v]=b(this[v],...k),k=[this[v]]),this[I]=setTimeout(()=>{w.apply(this,k),this[v]=E?E():void 0},R)}})}e.$gh=g;function L(R,b,E){return D((w,A)=>{const I=`$throttle$timer$${A}`,v=`$throttle$result$${A}`,k=`$throttle$lastRun$${A}`,S=`$throttle$pending$${A}`;return function(...p){if(this[v]||(this[v]=E?E():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),b&&(this[v]=b(this[v],...p)),this[S])return;const u=this[k]+R;u<=Date.now()?(this[k]=Date.now(),w.apply(this,[this[v]]),this[v]=E?E():void 0):(this[S]=!0,this[I]=setTimeout(()=>{this[S]=!1,this[k]=Date.now(),w.apply(this,[this[v]]),this[v]=E?E():void 0},u-Date.now()))}})}e.$hh=L}),define(De[8],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?a.isErrorNoTelemetry(t)?new a(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(n=>{n(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=D,e.$W=new D;function T(l){e.$W.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=T;function g(l){if(!l||typeof l!="object")return!1;const t=l;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=g;function L(l){w(l)||e.$W.onUnexpectedError(l)}e.$Z=L;function R(l){w(l)||e.$W.onUnexpectedExternalError(l)}e.$1=R;function b(l){if(l instanceof Error){const{name:t,message:n}=l,o=l.stacktrace||l.stack;return{$isError:!0,name:t,message:n,stack:o,noTelemetry:a.isErrorNoTelemetry(l)}}return l}e.$2=b;const E="Canceled";function w(l){return l instanceof A?!0:l instanceof Error&&l.name===E&&l.message===E}e.$3=w;class A extends Error{constructor(){super(E),this.name=this.message}}e.$4=A;function I(){const l=new Error(E);return l.name=l.message,l}e.$5=I;function v(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.$6=v;function k(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.$7=k;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=S;function p(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.$9=p;class u extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=u;class r extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=r;class s extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=s;class a extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof a)return t;const n=new a;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=a;class m extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$bb=m}),define(De[19],Ce([1,0,8,118]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function g(_,ie=0){return _[_.length-(1+ie)]}e.$rb=g;function L(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.$sb=L;function R(_,ie,ne=(Ee,oe)=>Ee===oe){if(_===ie)return!0;if(!_||!ie||_.length!==ie.length)return!1;for(let Ee=0,oe=_.length;Ee<oe;Ee++)if(!ne(_[Ee],ie[Ee]))return!1;return!0}e.$tb=R;function b(_,ie){const ne=_.length-1;ie<ne&&(_[ie]=_[ne]),_.pop()}e.$ub=b;function E(_,ie,ne){return w(_.length,Ee=>ne(_[Ee],ie))}e.$vb=E;function w(_,ie){let ne=0,Ee=_-1;for(;ne<=Ee;){const oe=(ne+Ee)/2|0,he=ie(oe);if(he<0)ne=oe+1;else if(he>0)Ee=oe-1;else return oe}return-(ne+1)}e.$wb=w;function A(_,ie,ne){if(_=_|0,_>=ie.length)throw new TypeError("invalid index");const Ee=ie[Math.floor(ie.length*Math.random())],oe=[],he=[],ee=[];for(const le of ie){const be=ne(le,Ee);be<0?oe.push(le):be>0?he.push(le):ee.push(le)}return _<oe.length?A(_,oe,ne):_<oe.length+ee.length?ee[0]:A(_-(oe.length+ee.length),he,ne)}e.$xb=A;function I(_,ie){const ne=[];let Ee;for(const oe of _.slice(0).sort(ie))!Ee||ie(Ee[0],oe)!==0?(Ee=[oe],ne.push(Ee)):Ee.push(oe);return ne}e.$yb=I;function*v(_,ie){let ne,Ee;for(const oe of _)Ee!==void 0&&ie(Ee,oe)?ne.push(oe):(ne&&(yield ne),ne=[oe]),Ee=oe;ne&&(yield ne)}e.$zb=v;function k(_,ie){for(let ne=0;ne<=_.length;ne++)ie(ne===0?void 0:_[ne-1],ne===_.length?void 0:_[ne])}e.$Ab=k;function S(_,ie){for(let ne=0;ne<_.length;ne++)ie(ne===0?void 0:_[ne-1],_[ne],ne+1===_.length?void 0:_[ne+1])}e.$Bb=S;function p(_,ie,ne){const Ee=[];function oe(le,be,Pe){if(be===0&&Pe.length===0)return;const B=Ee[Ee.length-1];B&&B.start+B.deleteCount===le?(B.deleteCount+=be,B.toInsert.push(...Pe)):Ee.push({start:le,deleteCount:be,toInsert:Pe})}let he=0,ee=0;for(;;){if(he===_.length){oe(he,0,ie.slice(ee));break}if(ee===ie.length){oe(he,_.length-he,[]);break}const le=_[he],be=ie[ee],Pe=ne(le,be);Pe===0?(he+=1,ee+=1):Pe<0?(oe(he,1,[]),he+=1):Pe>0&&(oe(he,0,[be]),ee+=1)}return Ee}e.$Cb=p;function u(_,ie,ne){const Ee=p(_,ie,ne),oe=[],he=[];for(const ee of Ee)oe.push(..._.slice(ee.start,ee.start+ee.deleteCount)),he.push(...ee.toInsert);return{removed:oe,added:he}}e.$Db=u;function r(_,ie,ne){if(ne===0)return[];const Ee=_.slice(0,ne).sort(ie);return a(_,ie,Ee,ne,_.length),Ee}e.top=r;function s(_,ie,ne,Ee,oe){return ne===0?Promise.resolve([]):new Promise((he,ee)=>{(async()=>{const le=_.length,be=_.slice(0,ne).sort(ie);for(let Pe=ne,B=Math.min(ne+Ee,le);Pe<le;Pe=B,B=Math.min(B+Ee,le)){if(Pe>ne&&await new Promise(Q=>setTimeout(Q)),oe&&oe.isCancellationRequested)throw new D.$4;a(_,ie,be,Pe,B)}return be})().then(he,ee)})}e.$Fb=s;function a(_,ie,ne,Ee,oe){for(const he=ne.length;Ee<oe;Ee++){const ee=_[Ee];if(ie(ee,ne[he-1])<0){ne.pop();const le=(0,T.$jb)(ne,be=>ie(ee,be)<0);ne.splice(le,0,ee)}}}function m(_){return _.filter(ie=>!!ie)}e.$Gb=m;function l(_){let ie=0;for(let ne=0;ne<_.length;ne++)_[ne]&&(_[ie]=_[ne],ie+=1);_.length=ie}e.$Hb=l;function t(_,ie,ne){_.splice(ne,0,_.splice(ie,1)[0])}e.$Ib=t;function n(_){return!Array.isArray(_)||_.length===0}e.$Jb=n;function o(_){return Array.isArray(_)&&_.length>0}e.$Kb=o;function i(_,ie=ne=>ne){const ne=new Set;return _.filter(Ee=>{const oe=ie(Ee);return ne.has(oe)?!1:(ne.add(oe),!0)})}e.$Lb=i;function c(_){const ie=new Set;return ne=>{const Ee=_(ne);return ie.has(Ee)?!1:(ie.add(Ee),!0)}}e.$Mb=c;function h(_,ie){return _.length>0?_[0]:ie}e.$Nb=h;function y(_,ie){return _.length>0?_[_.length-1]:ie}e.$Ob=y;function C(_,ie,ne=(Ee,oe)=>Ee===oe){let Ee=0;for(let oe=0,he=Math.min(_.length,ie.length);oe<he&&ne(_[oe],ie[oe]);oe++)Ee++;return Ee}e.$Pb=C;function $(_){return[].concat(..._)}e.$Qb=$;function f(_,ie){let ne=typeof ie=="number"?_:0;typeof ie=="number"?ne=_:(ne=0,ie=_);const Ee=[];if(ne<=ie)for(let oe=ne;oe<ie;oe++)Ee.push(oe);else for(let oe=ne;oe>ie;oe--)Ee.push(oe);return Ee}e.$Rb=f;function d(_,ie,ne){return _.reduce((Ee,oe)=>(Ee[ie(oe)]=ne?ne(oe):oe,Ee),Object.create(null))}e.$Sb=d;function P(_,ie){return _.push(ie),()=>N(_,ie)}e.$Tb=P;function N(_,ie){const ne=_.indexOf(ie);if(ne>-1)return _.splice(ne,1),ie}e.$Ub=N;function O(_,ie,ne){const Ee=_.slice(0,ie),oe=_.slice(ie);return Ee.concat(ne,oe)}e.$Vb=O;function M(_,ie){let ne;if(typeof ie=="number"){let Ee=ie;ne=()=>{const oe=Math.sin(Ee++)*179426549;return oe-Math.floor(oe)}}else ne=Math.random;for(let Ee=_.length-1;Ee>0;Ee-=1){const oe=Math.floor(ne()*(Ee+1)),he=_[Ee];_[Ee]=_[oe],_[oe]=he}}e.$Wb=M;function j(_,ie){const ne=_.indexOf(ie);ne>-1&&(_.splice(ne,1),_.unshift(ie))}e.$Xb=j;function U(_,ie){const ne=_.indexOf(ie);ne>-1&&(_.splice(ne,1),_.push(ie))}e.$Yb=U;function F(_,ie){for(const ne of ie)_.push(ne)}e.$Zb=F;function V(_,ie){return Array.isArray(_)?_.map(ie):ie(_)}e.$1b=V;function H(_){return Array.isArray(_)?_:[_]}e.$2b=H;function fe(_){return _[Math.floor(Math.random()*_.length)]}e.$3b=fe;function X(_,ie,ne){const Ee=q(_,ie),oe=_.length,he=ne.length;_.length=oe+he;for(let ee=oe-1;ee>=Ee;ee--)_[ee+he]=_[ee];for(let ee=0;ee<he;ee++)_[ee+Ee]=ne[ee]}e.$4b=X;function Y(_,ie,ne,Ee){const oe=q(_,ie);let he=_.splice(oe,ne);return he===void 0&&(he=[]),X(_,oe,Ee),he}e.$5b=Y;function q(_,ie){return ie<0?Math.max(ie+_.length,0):Math.min(ie,_.length)}var x;(function(_){function ie(he){return he<0}_.isLessThan=ie;function ne(he){return he<=0}_.isLessThanOrEqual=ne;function Ee(he){return he>0}_.isGreaterThan=Ee;function oe(he){return he===0}_.isNeitherLessOrGreaterThan=oe,_.greaterThan=1,_.lessThan=-1,_.neitherLessOrGreaterThan=0})(x||(e.CompareResult=x={}));function me(_,ie){return(ne,Ee)=>ie(_(ne),_(Ee))}e.$6b=me;function ue(..._){return(ie,ne)=>{for(const Ee of _){const oe=Ee(ie,ne);if(!x.isNeitherLessOrGreaterThan(oe))return oe}return x.neitherLessOrGreaterThan}}e.$7b=ue;const pe=(_,ie)=>_-ie;e.$8b=pe;const G=(_,ie)=>(0,e.$8b)(_?1:0,ie?1:0);e.$9b=G;function z(_){return(ie,ne)=>-_(ie,ne)}e.$0b=z;class K{constructor(ie){this.g=ie,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let ne=this.c;for(;ne<this.g.length&&ie(this.g[ne]);)ne++;const Ee=ne===this.c?null:this.g.slice(this.c,ne);return this.c=ne,Ee}takeFromEndWhile(ie){let ne=this.d;for(;ne>=0&&ie(this.g[ne]);)ne--;const Ee=ne===this.d?null:this.g.slice(ne+1,this.d+1);return this.d=ne,Ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ie=this.g[this.c];return this.c++,ie}removeLast(){const ie=this.g[this.d];return this.d--,ie}takeCount(ie){const ne=this.g.slice(this.c,this.c+ie);return this.c+=ie,ne}}e.$$b=K;class ge{static{this.empty=new ge(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(ne=>(ie(ne),!0))}toArray(){const ie=[];return this.iterate(ne=>(ie.push(ne),!0)),ie}filter(ie){return new ge(ne=>this.iterate(Ee=>ie(Ee)?ne(Ee):!0))}map(ie){return new ge(ne=>this.iterate(Ee=>ne(ie(Ee))))}some(ie){let ne=!1;return this.iterate(Ee=>(ne=ie(Ee),!ne)),ne}findFirst(ie){let ne;return this.iterate(Ee=>ie(Ee)?(ne=Ee,!1):!0),ne}findLast(ie){let ne;return this.iterate(Ee=>(ie(Ee)&&(ne=Ee),!0)),ne}findLastMaxBy(ie){let ne,Ee=!0;return this.iterate(oe=>((Ee||x.isGreaterThan(ie(oe,ne)))&&(Ee=!1,ne=oe),!0)),ne}}e.$_b=ge}),define(De[58],Ce([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function T(E,w){if(!E)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=T;function g(E,w="Unreachable"){throw new Error(w)}e.$3c=g;function L(E){if(!E)throw new D.$bb("Assertion Failed")}e.$4c=L;function R(E){if(!E()){debugger;E(),(0,D.$Z)(new D.$bb("Assertion Failed"))}}e.$5c=R;function b(E,w){let A=0;for(;A<E.length-1;){const I=E[A],v=E[A+1];if(!w(I,v))return!1;A++}return!0}e.$6c=b}),define(De[74],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function D(T){const g=this;let L=!1,R;return function(){return L||(L=!0,R=T.apply(g,arguments)),R}}e.$cb=D}),define(De[119],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=e.$cM=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$cM=D,e.$dM=new D("id#")}),define(De[50],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(T){function g(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}T.is=g;const L=Object.freeze([]);function R(){return L}T.empty=R;function*b(l){yield l}T.single=b;function E(l){return g(l)?l:b(l)}T.wrap=E;function w(l){return l||L}T.from=w;function*A(l){for(let t=l.length-1;t>=0;t--)yield l[t]}T.reverse=A;function I(l){return!l||l[Symbol.iterator]().next().done===!0}T.isEmpty=I;function v(l){return l[Symbol.iterator]().next().value}T.first=v;function k(l,t){for(const n of l)if(t(n))return!0;return!1}T.some=k;function S(l,t){for(const n of l)if(t(n))return n}T.find=S;function*p(l,t){for(const n of l)t(n)&&(yield n)}T.filter=p;function*u(l,t){let n=0;for(const o of l)yield t(o,n++)}T.map=u;function*r(...l){for(const t of l)for(const n of t)yield n}T.concat=r;function s(l,t,n){let o=n;for(const i of l)o=t(o,i);return o}T.reduce=s;function*a(l,t,n=l.length){for(t<0&&(t+=l.length),n<0?n+=l.length:n>l.length&&(n=l.length);t<n;t++)yield l[t]}T.slice=a;function m(l,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,l];const o=l[Symbol.iterator]();for(let i=0;i<t;i++){const c=o.next();if(c.done)return[n,T.empty()];n.push(c.value)}return[n,{[Symbol.iterator](){return o}}]}T.consume=m})(D||(e.Iterable=D={}))}),define(De[157],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,n=!1){let o=0;const i=t.length;let c="",h=0,y=16,C=0;function $(j){let U=0,F=0;for(;U<j;){const V=t.charCodeAt(o);if(V>=48&&V<=57)F=F*16+V-48;else if(V>=65&&V<=70)F=F*16+V-65+10;else if(V>=97&&V<=102)F=F*16+V-97+10;else break;o++,U++}return U<j&&(F=-1),F}function f(j){o=j,c="",h=0,y=16,C=0}function d(){const j=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&w(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&w(t.charCodeAt(o)))for(o++;o<t.length&&w(t.charCodeAt(o));)o++;else return C=3,t.substring(j,o);let U=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&w(t.charCodeAt(o))){for(o++;o<t.length&&w(t.charCodeAt(o));)o++;U=o}else C=3;return t.substring(j,U)}function P(){let j="",U=o;for(;;){if(o>=i){j+=t.substring(U,o),C=2;break}const F=t.charCodeAt(o);if(F===34){j+=t.substring(U,o),o++;break}if(F===92){if(j+=t.substring(U,o),o++,o>=i){C=2;break}switch(t.charCodeAt(o++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const H=$(4);H>=0?j+=String.fromCharCode(H):C=4;break}default:C=5}U=o;continue}if(F>=0&&F<=31)if(E(F)){j+=t.substring(U,o),C=2;break}else C=6;o++}return j}function N(){if(c="",C=0,h=o,o>=i)return h=i,y=17;let j=t.charCodeAt(o);if(b(j)){do o++,c+=String.fromCharCode(j),j=t.charCodeAt(o);while(b(j));return y=15}if(E(j))return o++,c+=String.fromCharCode(j),j===13&&t.charCodeAt(o)===10&&(o++,c+=`
`),y=14;switch(j){case 123:return o++,y=1;case 125:return o++,y=2;case 91:return o++,y=3;case 93:return o++,y=4;case 58:return o++,y=6;case 44:return o++,y=5;case 34:return o++,c=P(),y=10;case 47:{const U=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<i&&!E(t.charCodeAt(o));)o++;return c=t.substring(U,o),y=12}if(t.charCodeAt(o+1)===42){o+=2;const F=i-1;let V=!1;for(;o<F;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,V=!0;break}o++}return V||(o++,C=1),c=t.substring(U,o),y=13}return c+=String.fromCharCode(j),o++,y=16}case 45:if(c+=String.fromCharCode(j),o++,o===i||!w(t.charCodeAt(o)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=d(),y=11;default:for(;o<i&&O(j);)o++,j=t.charCodeAt(o);if(h!==o){switch(c=t.substring(h,o),c){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return c+=String.fromCharCode(j),o++,y=16}}function O(j){if(b(j)||E(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let j;do j=N();while(j>=12&&j<=15);return j}return{setPosition:f,getPosition:()=>o,scan:n?M:N,getToken:()=>y,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>o-h,getTokenError:()=>C}}e.$Mm=R;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function I(t,n){const o=[],i=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function C($,f,d,P){h.value=$,h.offset=f,h.length=d,h.type=P,h.colonOffset=void 0,c=h}try{a(t,{onObjectBegin:($,f)=>{if(n<=$)throw i;c=void 0,y=n>$,o.push("")},onObjectProperty:($,f,d)=>{if(n<f||(C($,f,d,"property"),o[o.length-1]=$,n<=f+d))throw i},onObjectEnd:($,f)=>{if(n<=$)throw i;c=void 0,o.pop()},onArrayBegin:($,f)=>{if(n<=$)throw i;c=void 0,o.push(0)},onArrayEnd:($,f)=>{if(n<=$)throw i;c=void 0,o.pop()},onLiteralValue:($,f,d)=>{if(n<f||(C($,f,d,l($)),n<=f+d))throw i},onSeparator:($,f,d)=>{if(n<=f)throw i;if($===":"&&c&&c.type==="property")c.colonOffset=f,y=!1,c=void 0;else if($===","){const P=o[o.length-1];typeof P=="number"?o[o.length-1]=P+1:(y=!0,o[o.length-1]=""),c=void 0}}})}catch($){if($!==i)throw $}return{path:o,previousNode:c,isAtPropertyKey:y,matches:$=>{let f=0;for(let d=0;f<$.length&&d<o.length;d++)if($[f]===o[d]||$[f]==="*")f++;else if($[f]!=="**")return!1;return f===$.length}}}e.$Nm=I;function v(t,n=[],o=L.DEFAULT){let i=null,c=[];const h=[];function y($){Array.isArray(c)?c.push($):i!==null&&(c[i]=$)}return a(t,{onObjectBegin:()=>{const $={};y($),h.push(c),c=$,i=null},onObjectProperty:$=>{i=$},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const $=[];y($),h.push(c),c=$,i=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:y,onError:($,f,d)=>{n.push({error:$,offset:f,length:d})}},o),c[0]}e.$Om=v;function k(t,n=[],o=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c($){i.type==="property"&&(i.length=$-i.offset,i=i.parent)}function h($){return i.children.push($),$}a(t,{onObjectBegin:$=>{i=h({type:"object",offset:$,length:-1,parent:i,children:[]})},onObjectProperty:($,f,d)=>{i=h({type:"property",offset:f,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:$,offset:f,length:d,parent:i})},onObjectEnd:($,f)=>{i.length=$+f-i.offset,i=i.parent,c($+f)},onArrayBegin:($,f)=>{i=h({type:"array",offset:$,length:-1,parent:i,children:[]})},onArrayEnd:($,f)=>{i.length=$+f-i.offset,i=i.parent,c($+f)},onLiteralValue:($,f,d)=>{h({type:l($),offset:f,length:d,parent:i,value:$}),c(f+d)},onSeparator:($,f,d)=>{i.type==="property"&&($===":"?i.colonOffset=f:$===","&&c(f))},onError:($,f,d)=>{n.push({error:$,offset:f,length:d})}},o);const C=i.children[0];return C&&delete C.parent,C}e.$Pm=k;function S(t,n){if(!t)return;let o=t;for(const i of n)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let c=!1;for(const h of o.children)if(Array.isArray(h.children)&&h.children[0].value===i){o=h.children[1],c=!0;break}if(!c)return}else{const c=i;if(o.type!=="array"||c<0||!Array.isArray(o.children)||c>=o.children.length)return;o=o.children[c]}return o}e.$Qm=S;function p(t){if(!t.parent||!t.parent.children)return[];const n=p(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;n.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&n.push(o)}return n}e.$Rm=p;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const n=Object.create(null);for(const o of t.children){const i=o.children[1];i&&(n[o.children[0].value]=u(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Sm=u;function r(t,n,o=!1){return n>=t.offset&&n<t.offset+t.length||o&&n===t.offset+t.length}e.$Tm=r;function s(t,n,o=!1){if(r(t,n,o)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=n;c++){const h=s(i[c],n,o);if(h)return h}return t}}e.$Um=s;function a(t,n,o=L.DEFAULT){const i=R(t,!1);function c(me){return me?()=>me(i.getTokenOffset(),i.getTokenLength()):()=>!0}function h(me){return me?ue=>me(ue,i.getTokenOffset(),i.getTokenLength()):()=>!0}const y=c(n.onObjectBegin),C=h(n.onObjectProperty),$=c(n.onObjectEnd),f=c(n.onArrayBegin),d=c(n.onArrayEnd),P=h(n.onLiteralValue),N=h(n.onSeparator),O=c(n.onComment),M=h(n.onError),j=o&&o.disallowComments,U=o&&o.allowTrailingComma;function F(){for(;;){const me=i.scan();switch(i.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:j||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(me){case 12:case 13:j?V(10):O();break;case 16:V(1);break;case 15:case 14:break;default:return me}}}function V(me,ue=[],pe=[]){if(M(me),ue.length+pe.length>0){let G=i.getToken();for(;G!==17;){if(ue.indexOf(G)!==-1){F();break}else if(pe.indexOf(G)!==-1)break;G=F()}}}function H(me){const ue=i.getTokenValue();return me?P(ue):C(ue),F(),!0}function fe(){switch(i.getToken()){case 11:{let me=0;try{me=JSON.parse(i.getTokenValue()),typeof me!="number"&&(V(2),me=0)}catch{V(2)}P(me);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return F(),!0}function X(){return i.getToken()!==10?(V(3,[],[2,5]),!1):(H(!1),i.getToken()===6?(N(":"),F(),x()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function Y(){y(),F();let me=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(me||V(4,[],[]),N(","),F(),i.getToken()===2&&U)break}else me&&V(6,[],[]);X()||V(4,[],[2,5]),me=!0}return $(),i.getToken()!==2?V(7,[2],[]):F(),!0}function q(){f(),F();let me=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(me||V(4,[],[]),N(","),F(),i.getToken()===4&&U)break}else me&&V(6,[],[]);x()||V(4,[],[4,5]),me=!0}return d(),i.getToken()!==4?V(8,[4],[]):F(),!0}function x(){switch(i.getToken()){case 3:return q();case 1:return Y();case 10:return H(!0);default:return fe()}}return F(),i.getToken()===17?o.allowEmptyContent?!0:(V(4,[],[]),!1):x()?(i.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.$Vm=a;function m(t,n){const o=R(t),i=[];let c,h=0,y;do switch(y=o.getPosition(),c=o.scan(),c){case 12:case 13:case 17:h!==y&&i.push(t.substring(h,y)),n!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,n)),h=o.getPosition();break}while(c!==17);return i.join("")}e.$Wm=m;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Xm=l}),define(De[51],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=D}),define(De[75],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}class T{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let L=this.a;for(;L!==D.Undefined;){const R=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=R}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,R){const b=new D(L);if(this.a===D.Undefined)this.a=b,this.b=b;else if(R){const w=this.b;this.b=b,b.prev=w,w.next=b}else{const w=this.a;this.a=b,b.next=w,w.prev=b}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(b))}}shift(){if(this.a!==D.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==D.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const R=L.prev;R.next=L.next,L.next.prev=R}else L.prev===D.Undefined&&L.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):L.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):L.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.$1c=T}),define(De[28],Ce([1,0]),function($e,e){"use strict";var D,T,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function L(s,a,m){let l=s.get(a);return l===void 0&&(l=m,s.set(a,l)),l}e.$wc=L;function R(s){const a=[];return s.forEach((m,l)=>{a.push(`${l} => ${m}`)}),`Map(${s.size}) {${a.join(", ")}}`}e.$xc=R;function b(s){const a=[];return s.forEach(m=>{a.push(m)}),`Set(${s.size}) {${a.join(", ")}}`}e.$yc=b;class E{constructor(a,m){this.uri=a,this.value=m}}function w(s){return Array.isArray(s)}class A{static{this.a=a=>a.toString()}constructor(a,m){if(this[D]="ResourceMap",a instanceof A)this.b=new Map(a.b),this.c=m??A.a;else if(w(a)){this.b=new Map,this.c=m??A.a;for(const[l,t]of a)this.set(l,t)}else this.b=new Map,this.c=a??A.a}set(a,m){return this.b.set(this.c(a),new E(a,m)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,m){typeof m<"u"&&(a=a.bind(m));for(const[l,t]of this.b)a(t.value,t.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}e.$zc=A;class I{constructor(a,m){this[T]="ResourceSet",!a||typeof a=="function"?this.a=new A(a):(this.a=new A(m),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,m){this.a.forEach((l,t)=>a.call(m,t,t,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=I;var v;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class k{constructor(){this[g]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,m=0){const l=this.a.get(a);if(l)return m!==0&&this.j(l,m),l.value}set(a,m,l=0){let t=this.a.get(a);if(t)t.value=m,l!==0&&this.j(t,l);else{switch(t={key:a,value:m,next:void 0,previous:void 0},l){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(a,t),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const m=this.a.get(a);if(m)return this.a.delete(a),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,m){const l=this.e;let t=this.b;for(;t;){if(m?a.bind(m)(t.value,t.key,this):a(t.value,t.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const a=this,m=this.e;let l=this.b;const t={[Symbol.iterator](){return t},next(){if(a.e!==m)throw new Error("LinkedMap got modified during iteration.");if(l){const n={value:l.key,done:!1};return l=l.next,n}else return{value:void 0,done:!0}}};return t}values(){const a=this,m=this.e;let l=this.b;const t={[Symbol.iterator](){return t},next(){if(a.e!==m)throw new Error("LinkedMap got modified during iteration.");if(l){const n={value:l.value,done:!1};return l=l.next,n}else return{value:void 0,done:!0}}};return t}entries(){const a=this,m=this.e;let l=this.b;const t={[Symbol.iterator](){return t},next(){if(a.e!==m)throw new Error("LinkedMap got modified during iteration.");if(l){const n={value:[l.key,l.value],done:!1};return l=l.next,n}else return{value:void 0,done:!0}}};return t}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let m=this.b,l=this.size;for(;m&&l>a;)this.a.delete(m.key),m=m.next,l--;this.b=m,this.d=l,m&&(m.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const m=a.next,l=a.previous;if(!m||!l)throw new Error("Invalid list");m.previous=l,l.next=m}a.next=void 0,a.previous=void 0,this.e++}j(a,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(a===this.b)return;const l=a.next,t=a.previous;a===this.c?(t.next=void 0,this.c=t):(l.previous=t,t.next=l),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(m===2){if(a===this.c)return;const l=a.next,t=a.previous;a===this.b?(l.previous=void 0,this.b=l):(l.previous=t,t.next=l),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((m,l)=>{a.push([l,m])}),a}fromJSON(a){this.clear();for(const[m,l]of a)this.set(m,l)}}e.$Bc=k;class S extends k{constructor(a,m=1){super(),this.k=a,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,m=2){return super.get(a,m)}peek(a){return super.get(a,0)}set(a,m){return super.set(a,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=S;class p{constructor(){this.a=new Map}add(a){return this.a.set(a,(this.a.get(a)||0)+1),this}delete(a){let m=this.a.get(a)||0;return m===0?!1:(m--,m===0?this.a.delete(a):this.a.set(a,m),!0)}has(a){return this.a.has(a)}}e.$Dc=p;class u{constructor(a){if(this.a=new Map,this.b=new Map,a)for(const[m,l]of a)this.set(m,l)}clear(){this.a.clear(),this.b.clear()}set(a,m){this.a.set(a,m),this.b.set(m,a)}get(a){return this.a.get(a)}getKey(a){return this.b.get(a)}delete(a){const m=this.a.get(a);return m===void 0?!1:(this.a.delete(a),this.b.delete(m),!0)}forEach(a,m){this.a.forEach((l,t)=>{a.call(m,l,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=u;class r{constructor(){this.a=new Map}add(a,m){let l=this.a.get(a);l||(l=new Set,this.a.set(a,l)),l.add(m)}delete(a,m){const l=this.a.get(a);l&&(l.delete(m),l.size===0&&this.a.delete(a))}forEach(a,m){const l=this.a.get(a);l&&l.forEach(m)}get(a){const m=this.a.get(a);return m||new Set}}e.$Fc=r}),define(De[3],Ce([1,0,19,73,28,74,50]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const b=!1;let E=null;class w{constructor(){this.b=new Map}static{this.a=0}c(d){let P=this.b.get(d);return P||(P={parent:null,source:null,isSingleton:!1,value:d,idx:w.a++},this.b.set(d,P)),P}trackDisposable(d){const P=this.c(d);P.source||(P.source=new Error().stack)}setParent(d,P){const N=this.c(d);N.parent=P}markAsDisposed(d){this.b.delete(d)}markAsSingleton(d){this.c(d).isSingleton=!0}f(d,P){const N=P.get(d);if(N)return N;const O=d.parent?this.f(this.c(d.parent),P):d;return P.set(d,O),O}getTrackedDisposables(){const d=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,d).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(d=10,P){let N;if(P)N=P;else{const F=new Map,V=[...this.b.values()].filter(fe=>fe.source!==null&&!this.f(fe,F).isSingleton);if(V.length===0)return;const H=new Set(V.map(fe=>fe.value));if(N=V.filter(fe=>!(fe.parent&&H.has(fe.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function O(F){function V(fe,X){for(;fe.length>0&&X.some(Y=>typeof Y=="string"?Y===fe[0]:fe[0].match(Y));)fe.shift()}const H=F.source.split(`
`).map(fe=>fe.trim().replace("at ","")).filter(fe=>fe!=="");return V(H,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),H.reverse()}const M=new g.$Fc;for(const F of N){const V=O(F);for(let H=0;H<=V.length;H++)M.add(V.slice(0,H).join(`
`),F)}N.sort((0,D.$6b)(F=>F.idx,D.$8b));let j="",U=0;for(const F of N.slice(0,d)){U++;const V=O(F),H=[];for(let fe=0;fe<V.length;fe++){let X=V[fe];X=`(shared with ${M.get(V.slice(0,fe+1).join(`
`)).size}/${N.length} leaks) at ${X}`;const q=M.get(V.slice(0,fe).join(`
`)),x=(0,T.$J)([...q].map(me=>O(me)[fe]),me=>me);delete x[V[fe]];for(const[me,ue]of Object.entries(x))H.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${me}`);H.unshift(X)}j+=`


==================== Leaking disposable ${U}/${N.length}: ${F.value.constructor.name} ====================
${H.join(`
`)}
============================================================

`}return N.length>d&&(j+=`


... and ${N.length-d} more leaking disposables

`),{leaks:N,details:j}}}e.$Gc=w;function A(f){E=f}if(e.$Hc=A,b){const f="__is_disposable_tracked__";A(new class{trackDisposable(d){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[f]||console.log(P)},3e3)}setParent(d,P){if(d&&d!==t.None)try{d[f]=!0}catch{}}markAsDisposed(d){if(d&&d!==t.None)try{d[f]=!0}catch{}}markAsSingleton(d){}})}function I(f){return E?.trackDisposable(f),f}e.$Ic=I;function v(f){E?.markAsDisposed(f)}e.$Jc=v;function k(f,d){E?.setParent(f,d)}function S(f,d){if(E)for(const P of f)E.setParent(P,d)}function p(f){return E?.markAsSingleton(f),f}e.$Kc=p;function u(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.$Lc=u;function r(f){if(R.Iterable.is(f)){const d=[];for(const P of f)if(P)try{P.dispose()}catch(N){d.push(N)}if(d.length===1)throw d[0];if(d.length>1)throw new AggregateError(d,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}e.$Mc=r;function s(f){for(const d of f)u(d)&&d.dispose();return[]}e.$Nc=s;function a(...f){const d=m(()=>r(f));return S(f,d),d}e.$Oc=a;function m(f){const d=I({dispose:(0,L.$cb)(()=>{v(d),f()})});return d}e.$Pc=m;class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{r(this.f)}finally{this.f.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return k(d,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(d),d}delete(d){if(d){if(d===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(d),d.dispose()}}deleteAndLeak(d){d&&this.f.has(d)&&(this.f.delete(d),k(d,null))}}e.$Qc=l;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,I(this),k(this.q,this)}dispose(){v(this),this.q.dispose()}B(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(d)}}e.$Rc=t;class n{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(d){this.b||d===this.a||(this.a?.dispose(),d&&k(d,this),this.a=d)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const d=this.a;return this.a=void 0,d&&k(d,null),d}}e.$Sc=n;class o{constructor(d){this.b=d,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=o;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(d){let P=d;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,v(this))},this}}e.$Uc=i;class c{constructor(){this.a=new Map}acquire(d,...P){let N=this.a.get(d);N||(N={counter:0,object:this.b(d,...P)},this.a.set(d,N));const{object:O}=N,M=(0,L.$cb)(()=>{--N.counter===0&&(this.c(d,N.object),this.a.delete(d))});return N.counter++,{object:O,dispose:M}}}e.$Vc=c;class h{constructor(d){this.a=d}async acquire(d,...P){const N=this.a.acquire(d,...P);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(O){throw N.dispose(),O}}}e.$Wc=h;class y{constructor(d){this.object=d}dispose(){}}e.$Xc=y;function C(f){const d=new l;try{f(d)}finally{d.dispose()}}e.$Yc=C;class ${constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{r(this.a.values())}finally{this.a.clear()}}has(d){return this.a.has(d)}get size(){return this.a.size}get(d){return this.a.get(d)}set(d,P,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(d)?.dispose(),this.a.set(d,P)}deleteAndDispose(d){this.a.get(d)?.dispose(),this.a.delete(d)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=$}),function($e,e){typeof define=="function"&&define.amd?define(De[158],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(ie,ne){for(var Ee=0;Ee<ne.length;Ee++){var oe=ne[Ee];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(ie,oe.key,oe)}}function D(ie,ne,Ee){return ne&&e(ie.prototype,ne),Ee&&e(ie,Ee),Object.defineProperty(ie,"prototype",{writable:!1}),ie}function T(ie,ne){if(ie){if(typeof ie=="string")return g(ie,ne);var Ee=Object.prototype.toString.call(ie).slice(8,-1);if(Ee==="Object"&&ie.constructor&&(Ee=ie.constructor.name),Ee==="Map"||Ee==="Set")return Array.from(ie);if(Ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ee))return g(ie,ne)}}function g(ie,ne){(ne==null||ne>ie.length)&&(ne=ie.length);for(var Ee=0,oe=new Array(ne);Ee<ne;Ee++)oe[Ee]=ie[Ee];return oe}function L(ie,ne){var Ee=typeof Symbol<"u"&&ie[Symbol.iterator]||ie["@@iterator"];if(Ee)return(Ee=Ee.call(ie)).next.bind(Ee);if(Array.isArray(ie)||(Ee=T(ie))||ne&&ie&&typeof ie.length=="number"){Ee&&(ie=Ee);var oe=0;return function(){return oe>=ie.length?{done:!0}:{done:!1,value:ie[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=R();function b(ie){$e.defaults=ie}var E=/[&<>"']/,w=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(ne){return v[ne]};function S(ie,ne){if(ne){if(E.test(ie))return ie.replace(w,k)}else if(A.test(ie))return ie.replace(I,k);return ie}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(ie){return ie.replace(p,function(ne,Ee){return Ee=Ee.toLowerCase(),Ee==="colon"?":":Ee.charAt(0)==="#"?Ee.charAt(1)==="x"?String.fromCharCode(parseInt(Ee.substring(2),16)):String.fromCharCode(+Ee.substring(1)):""})}var r=/(^|[^\[])\^/g;function s(ie,ne){ie=typeof ie=="string"?ie:ie.source,ne=ne||"";var Ee={replace:function(he,ee){return ee=ee.source||ee,ee=ee.replace(r,"$1"),ie=ie.replace(he,ee),Ee},getRegex:function(){return new RegExp(ie,ne)}};return Ee}var a=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(ie,ne,Ee){if(ie){var oe;try{oe=decodeURIComponent(u(Ee)).replace(a,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}ne&&!m.test(Ee)&&(Ee=c(ne,Ee));try{Ee=encodeURI(Ee).replace(/%25/g,"%")}catch{return null}return Ee}var t={},n=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ie,ne){t[" "+ie]||(n.test(ie)?t[" "+ie]=ie+"/":t[" "+ie]=$(ie,"/",!0)),ie=t[" "+ie];var Ee=ie.indexOf(":")===-1;return ne.substring(0,2)==="//"?Ee?ne:ie.replace(o,"$1")+ne:ne.charAt(0)==="/"?Ee?ne:ie.replace(i,"$1")+ne:ie+ne}var h={exec:function(){}};function y(ie){for(var ne=1,Ee,oe;ne<arguments.length;ne++){Ee=arguments[ne];for(oe in Ee)Object.prototype.hasOwnProperty.call(Ee,oe)&&(ie[oe]=Ee[oe])}return ie}function C(ie,ne){var Ee=ie.replace(/\|/g,function(ee,le,be){for(var Pe=!1,B=le;--B>=0&&be[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),oe=Ee.split(/ \|/),he=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>ne)oe.splice(ne);else for(;oe.length<ne;)oe.push("");for(;he<oe.length;he++)oe[he]=oe[he].trim().replace(/\\\|/g,"|");return oe}function $(ie,ne,Ee){var oe=ie.length;if(oe===0)return"";for(var he=0;he<oe;){var ee=ie.charAt(oe-he-1);if(ee===ne&&!Ee)he++;else if(ee!==ne&&Ee)he++;else break}return ie.slice(0,oe-he)}function f(ie,ne){if(ie.indexOf(ne[1])===-1)return-1;for(var Ee=ie.length,oe=0,he=0;he<Ee;he++)if(ie[he]==="\\")he++;else if(ie[he]===ne[0])oe++;else if(ie[he]===ne[1]&&(oe--,oe<0))return he;return-1}function d(ie){ie&&ie.sanitize&&!ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ie,ne){if(ne<1)return"";for(var Ee="";ne>1;)ne&1&&(Ee+=ie),ne>>=1,ie+=ie;return Ee+ie}function N(ie,ne,Ee,oe){var he=ne.href,ee=ne.title?S(ne.title):null,le=ie[1].replace(/\\([\[\]])/g,"$1");if(ie[0].charAt(0)!=="!"){oe.state.inLink=!0;var be={type:"link",raw:Ee,href:he,title:ee,text:le,tokens:oe.inlineTokens(le)};return oe.state.inLink=!1,be}return{type:"image",raw:Ee,href:he,title:ee,text:S(le)}}function O(ie,ne){var Ee=ie.match(/^(\s+)(?:```)/);if(Ee===null)return ne;var oe=Ee[1];return ne.split(`
`).map(function(he){var ee=he.match(/^\s+/);if(ee===null)return he;var le=ee[0];return le.length>=oe.length?he.slice(oe.length):he}).join(`
`)}var M=function(){function ie(Ee){this.options=Ee||$e.defaults}var ne=ie.prototype;return ne.space=function(oe){var he=this.rules.block.newline.exec(oe);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},ne.code=function(oe){var he=this.rules.block.code.exec(oe);if(he){var ee=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:$(ee,`
`)}}},ne.fences=function(oe){var he=this.rules.block.fences.exec(oe);if(he){var ee=he[0],le=O(ee,he[3]||"");return{type:"code",raw:ee,lang:he[2]?he[2].trim():he[2],text:le}}},ne.heading=function(oe){var he=this.rules.block.heading.exec(oe);if(he){var ee=he[2].trim();if(/#$/.test(ee)){var le=$(ee,"#");(this.options.pedantic||!le||/ $/.test(le))&&(ee=le.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:ee,tokens:this.lexer.inline(ee)}}},ne.hr=function(oe){var he=this.rules.block.hr.exec(oe);if(he)return{type:"hr",raw:he[0]}},ne.blockquote=function(oe){var he=this.rules.block.blockquote.exec(oe);if(he){var ee=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},ne.list=function(oe){var he=this.rules.block.list.exec(oe);if(he){var ee,le,be,Pe,B,Q,te,re,Z,de,ye,je,We=he[1].trim(),xe=We.length>1,Ze={type:"list",raw:"",ordered:xe,start:xe?+We.slice(0,-1):"",loose:!1,items:[]};We=xe?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=xe?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(je=!1,!(!(he=it.exec(oe))||this.rules.block.hr.test(oe)));){if(ee=he[0],oe=oe.substring(ee.length),re=he[2].split(`
`,1)[0],Z=oe.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=re.trimLeft()):(Pe=he[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=re.slice(Pe),Pe+=he[1].length),Q=!1,!re&&/^ *$/.test(Z)&&(ee+=Z+`
`,oe=oe.substring(Z.length+1),je=!0),!je)for(var et=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");oe&&(de=oe.split(`
`,1)[0],re=de,this.options.pedantic&&(re=re.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(re)||qe.test(re)||et.test(re)||Ae.test(oe)));){if(re.search(/[^ ]/)>=Pe||!re.trim())ye+=`
`+re.slice(Pe);else if(!Q)ye+=`
`+re;else break;!Q&&!re.trim()&&(Q=!0),ee+=de+`
`,oe=oe.substring(de.length+1)}Ze.loose||(te?Ze.loose=!0:/\n *\n *$/.test(ee)&&(te=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(ye),le&&(be=le[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ze.items.push({type:"list_item",raw:ee,task:!!le,checked:be,loose:!1,text:ye}),Ze.raw+=ee}Ze.items[Ze.items.length-1].raw=ee.trimRight(),Ze.items[Ze.items.length-1].text=ye.trimRight(),Ze.raw=Ze.raw.trimRight();var Le=Ze.items.length;for(B=0;B<Le;B++){this.lexer.state.top=!1,Ze.items[B].tokens=this.lexer.blockTokens(Ze.items[B].text,[]);var Ye=Ze.items[B].tokens.filter(function(ae){return ae.type==="space"}),ce=Ye.every(function(ae){for(var Ie=ae.raw.split(""),Ve=0,Ue=L(Ie),Xe;!(Xe=Ue()).done;){var rt=Xe.value;if(rt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Ze.loose&&Ye.length&&ce&&(Ze.loose=!0,Ze.items[B].loose=!0)}return Ze}},ne.html=function(oe){var he=this.rules.block.html.exec(oe);if(he){var ee={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(he[0]):S(he[0]);ee.type="paragraph",ee.text=le,ee.tokens=this.lexer.inline(le)}return ee}},ne.def=function(oe){var he=this.rules.block.def.exec(oe);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var ee=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:he[0],href:he[2],title:he[3]}}},ne.table=function(oe){var he=this.rules.block.table.exec(oe);if(he){var ee={type:"table",header:C(he[1]).map(function(te){return{text:te}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=he[0];var le=ee.align.length,be,Pe,B,Q;for(be=0;be<le;be++)/^ *-+: *$/.test(ee.align[be])?ee.align[be]="right":/^ *:-+: *$/.test(ee.align[be])?ee.align[be]="center":/^ *:-+ *$/.test(ee.align[be])?ee.align[be]="left":ee.align[be]=null;for(le=ee.rows.length,be=0;be<le;be++)ee.rows[be]=C(ee.rows[be],ee.header.length).map(function(te){return{text:te}});for(le=ee.header.length,Pe=0;Pe<le;Pe++)ee.header[Pe].tokens=this.lexer.inline(ee.header[Pe].text);for(le=ee.rows.length,Pe=0;Pe<le;Pe++)for(Q=ee.rows[Pe],B=0;B<Q.length;B++)Q[B].tokens=this.lexer.inline(Q[B].text);return ee}}},ne.lheading=function(oe){var he=this.rules.block.lheading.exec(oe);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},ne.paragraph=function(oe){var he=this.rules.block.paragraph.exec(oe);if(he){var ee=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:ee,tokens:this.lexer.inline(ee)}}},ne.text=function(oe){var he=this.rules.block.text.exec(oe);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},ne.escape=function(oe){var he=this.rules.inline.escape.exec(oe);if(he)return{type:"escape",raw:he[0],text:S(he[1])}},ne.tag=function(oe){var he=this.rules.inline.tag.exec(oe);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):S(he[0]):he[0]}},ne.link=function(oe){var he=this.rules.inline.link.exec(oe);if(he){var ee=he[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var le=$(ee.slice(0,-1),"\\");if((ee.length-le.length)%2===0)return}else{var be=f(he[2],"()");if(be>-1){var Pe=he[0].indexOf("!")===0?5:4,B=Pe+he[1].length+be;he[2]=he[2].substring(0,be),he[0]=he[0].substring(0,B).trim(),he[3]=""}}var Q=he[2],te="";if(this.options.pedantic){var re=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Q);re&&(Q=re[1],te=re[3])}else te=he[3]?he[3].slice(1,-1):"";return Q=Q.trim(),/^</.test(Q)&&(this.options.pedantic&&!/>$/.test(ee)?Q=Q.slice(1):Q=Q.slice(1,-1)),N(he,{href:Q&&Q.replace(this.rules.inline._escapes,"$1"),title:te&&te.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},ne.reflink=function(oe,he){var ee;if((ee=this.rules.inline.reflink.exec(oe))||(ee=this.rules.inline.nolink.exec(oe))){var le=(ee[2]||ee[1]).replace(/\s+/g," ");if(le=he[le.toLowerCase()],!le||!le.href){var be=ee[0].charAt(0);return{type:"text",raw:be,text:be}}return N(ee,le,ee[0],this.lexer)}},ne.emStrong=function(oe,he,ee){ee===void 0&&(ee="");var le=this.rules.inline.emStrong.lDelim.exec(oe);if(le&&!(le[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=le[1]||le[2]||"";if(!be||be&&(ee===""||this.rules.inline.punctuation.exec(ee))){var Pe=le[0].length-1,B,Q,te=Pe,re=0,Z=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Z.lastIndex=0,he=he.slice(-1*oe.length+Pe);(le=Z.exec(he))!=null;)if(B=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!B){if(Q=B.length,le[3]||le[4]){te+=Q;continue}else if((le[5]||le[6])&&Pe%3&&!((Pe+Q)%3)){re+=Q;continue}if(te-=Q,!(te>0)){if(Q=Math.min(Q,Q+te+re),Math.min(Pe,Q)%2){var de=oe.slice(1,Pe+le.index+Q);return{type:"em",raw:oe.slice(0,Pe+le.index+Q+1),text:de,tokens:this.lexer.inlineTokens(de)}}var ye=oe.slice(2,Pe+le.index+Q-1);return{type:"strong",raw:oe.slice(0,Pe+le.index+Q+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},ne.codespan=function(oe){var he=this.rules.inline.code.exec(oe);if(he){var ee=he[2].replace(/\n/g," "),le=/[^ ]/.test(ee),be=/^ /.test(ee)&&/ $/.test(ee);return le&&be&&(ee=ee.substring(1,ee.length-1)),ee=S(ee,!0),{type:"codespan",raw:he[0],text:ee}}},ne.br=function(oe){var he=this.rules.inline.br.exec(oe);if(he)return{type:"br",raw:he[0]}},ne.del=function(oe){var he=this.rules.inline.del.exec(oe);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},ne.autolink=function(oe,he){var ee=this.rules.inline.autolink.exec(oe);if(ee){var le,be;return ee[2]==="@"?(le=S(this.options.mangle?he(ee[1]):ee[1]),be="mailto:"+le):(le=S(ee[1]),be=le),{type:"link",raw:ee[0],text:le,href:be,tokens:[{type:"text",raw:le,text:le}]}}},ne.url=function(oe,he){var ee;if(ee=this.rules.inline.url.exec(oe)){var le,be;if(ee[2]==="@")le=S(this.options.mangle?he(ee[0]):ee[0]),be="mailto:"+le;else{var Pe;do Pe=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(Pe!==ee[0]);le=S(ee[0]),ee[1]==="www."?be="http://"+le:be=le}return{type:"link",raw:ee[0],text:le,href:be,tokens:[{type:"text",raw:le,text:le}]}}},ne.inlineText=function(oe,he){var ee=this.rules.inline.text.exec(oe);if(ee){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):S(ee[0]):ee[0]:le=S(this.options.smartypants?he(ee[0]):ee[0]),{type:"text",raw:ee[0],text:le}}},ie}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=s(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=s(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=s(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=s(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=s(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=s(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=y({},j),j.gfm=y({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=s(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=s(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=y({},j.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:s(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=s(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=s(j._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=s(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=s(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=s(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=s(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=s(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=s(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=s(U.reflink).replace("label",U._label).replace("ref",j._label).getRegex(),U.nolink=s(U.nolink).replace("ref",j._label).getRegex(),U.reflinkSearch=s(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=y({},U),U.pedantic=y({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=y({},U.normal,{escape:s(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=s(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=y({},U.gfm,{br:s(U.br).replace("{2,}","*").getRegex(),text:s(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ie){return ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(ie){var ne="",Ee,oe,he=ie.length;for(Ee=0;Ee<he;Ee++)oe=ie.charCodeAt(Ee),Math.random()>.5&&(oe="x"+oe.toString(16)),ne+="&#"+oe+";";return ne}var H=function(){function ie(Ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ee||$e.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:j.normal,inline:U.normal};this.options.pedantic?(oe.block=j.pedantic,oe.inline=U.pedantic):this.options.gfm&&(oe.block=j.gfm,this.options.breaks?oe.inline=U.breaks:oe.inline=U.gfm),this.tokenizer.rules=oe}ie.lex=function(oe,he){var ee=new ie(he);return ee.lex(oe)},ie.lexInline=function(oe,he){var ee=new ie(he);return ee.inlineTokens(oe)};var ne=ie.prototype;return ne.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},ne.blockTokens=function(oe,he){var ee=this;he===void 0&&(he=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(te,re,Z){return re+"    ".repeat(Z.length)});for(var le,be,Pe,B;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(te){return(le=te.call({lexer:ee},oe,he))?(oe=oe.substring(le.raw.length),he.push(le),!0):!1}))){if(le=this.tokenizer.space(oe)){oe=oe.substring(le.raw.length),le.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(le);continue}if(le=this.tokenizer.code(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+le.raw,be.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):he.push(le);continue}if(le=this.tokenizer.fences(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.heading(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.hr(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.blockquote(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.list(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.html(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.def(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+le.raw,be.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.lheading(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(Pe=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var te=1/0,re=oe.slice(1),Z=void 0;ee.options.extensions.startBlock.forEach(function(de){Z=de.call({lexer:this},re),typeof Z=="number"&&Z>=0&&(te=Math.min(te,Z))}),te<1/0&&te>=0&&(Pe=oe.substring(0,te+1))}(),this.state.top&&(le=this.tokenizer.paragraph(Pe))){be=he[he.length-1],B&&be.type==="paragraph"?(be.raw+=`
`+le.raw,be.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):he.push(le),B=Pe.length!==oe.length,oe=oe.substring(le.raw.length);continue}if(le=this.tokenizer.text(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&be.type==="text"?(be.raw+=`
`+le.raw,be.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):he.push(le);continue}if(oe){var Q="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return this.state.top=!0,he},ne.inline=function(oe,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:oe,tokens:he}),he},ne.inlineTokens=function(oe,he){var ee=this;he===void 0&&(he=[]);var le,be,Pe,B=oe,Q,te,re;if(this.tokens.links){var Z=Object.keys(this.tokens.links);if(Z.length>0)for(;(Q=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)Z.includes(Q[0].slice(Q[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,Q.index)+"["+P("a",Q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Q=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,Q.index)+"["+P("a",Q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Q=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,Q.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(te||(re=""),te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(le=ye.call({lexer:ee},oe,he))?(oe=oe.substring(le.raw.length),he.push(le),!0):!1}))){if(le=this.tokenizer.escape(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.tag(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&le.type==="text"&&be.type==="text"?(be.raw+=le.raw,be.text+=le.text):he.push(le);continue}if(le=this.tokenizer.link(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&le.type==="text"&&be.type==="text"?(be.raw+=le.raw,be.text+=le.text):he.push(le);continue}if(le=this.tokenizer.emStrong(oe,B,re)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.codespan(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.br(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.del(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.autolink(oe,V)){oe=oe.substring(le.raw.length),he.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(oe,V))){oe=oe.substring(le.raw.length),he.push(le);continue}if(Pe=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,je=oe.slice(1),We=void 0;ee.options.extensions.startInline.forEach(function(xe){We=xe.call({lexer:this},je),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Pe=oe.substring(0,ye+1))}(),le=this.tokenizer.inlineText(Pe,F)){oe=oe.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(re=le.raw.slice(-1)),te=!0,be=he[he.length-1],be&&be.type==="text"?(be.raw+=le.raw,be.text+=le.text):he.push(le);continue}if(oe){var de="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return he},D(ie,null,[{key:"rules",get:function(){return{block:j,inline:U}}}]),ie}(),fe=function(){function ie(Ee){this.options=Ee||$e.defaults}var ne=ie.prototype;return ne.code=function(oe,he,ee){var le=(he||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(oe,le);be!=null&&be!==oe&&(ee=!0,oe=be)}return oe=oe.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+S(le,!0)+'">'+(ee?oe:S(oe,!0))+`</code></pre>
`:"<pre><code>"+(ee?oe:S(oe,!0))+`</code></pre>
`},ne.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},ne.html=function(oe){return oe},ne.heading=function(oe,he,ee,le){if(this.options.headerIds){var be=this.options.headerPrefix+le.slug(ee);return"<h"+he+' id="'+be+'">'+oe+"</h"+he+`>
`}return"<h"+he+">"+oe+"</h"+he+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(oe,he,ee){var le=he?"ol":"ul",be=he&&ee!==1?' start="'+ee+'"':"";return"<"+le+be+`>
`+oe+"</"+le+`>
`},ne.listitem=function(oe){return"<li>"+oe+`</li>
`},ne.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(oe){return"<p>"+oe+`</p>
`},ne.table=function(oe,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+he+`</table>
`},ne.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},ne.tablecell=function(oe,he){var ee=he.header?"th":"td",le=he.align?"<"+ee+' align="'+he.align+'">':"<"+ee+">";return le+oe+("</"+ee+`>
`)},ne.strong=function(oe){return"<strong>"+oe+"</strong>"},ne.em=function(oe){return"<em>"+oe+"</em>"},ne.codespan=function(oe){return"<code>"+oe+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(oe){return"<del>"+oe+"</del>"},ne.link=function(oe,he,ee){if(oe=l(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var le='<a href="'+S(oe)+'"';return he&&(le+=' title="'+he+'"'),le+=">"+ee+"</a>",le},ne.image=function(oe,he,ee){if(oe=l(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var le='<img src="'+oe+'" alt="'+ee+'"';return he&&(le+=' title="'+he+'"'),le+=this.options.xhtml?"/>":">",le},ne.text=function(oe){return oe},ie}(),X=function(){function ie(){}var ne=ie.prototype;return ne.strong=function(oe){return oe},ne.em=function(oe){return oe},ne.codespan=function(oe){return oe},ne.del=function(oe){return oe},ne.html=function(oe){return oe},ne.text=function(oe){return oe},ne.link=function(oe,he,ee){return""+ee},ne.image=function(oe,he,ee){return""+ee},ne.br=function(){return""},ie}(),Y=function(){function ie(){this.seen={}}var ne=ie.prototype;return ne.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(oe,he){var ee=oe,le=0;if(this.seen.hasOwnProperty(ee)){le=this.seen[oe];do le++,ee=oe+"-"+le;while(this.seen.hasOwnProperty(ee))}return he||(this.seen[oe]=le,this.seen[ee]=0),ee},ne.slug=function(oe,he){he===void 0&&(he={});var ee=this.serialize(oe);return this.getNextSafeSlug(ee,he.dryrun)},ie}(),q=function(){function ie(Ee){this.options=Ee||$e.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new Y}ie.parse=function(oe,he){var ee=new ie(he);return ee.parse(oe)},ie.parseInline=function(oe,he){var ee=new ie(he);return ee.parseInline(oe)};var ne=ie.prototype;return ne.parse=function(oe,he){he===void 0&&(he=!0);var ee="",le,be,Pe,B,Q,te,re,Z,de,ye,je,We,xe,Ze,it,et,Ae,Fe,qe,Le=oe.length;for(le=0;le<Le;le++){if(ye=oe[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(qe=this.options.extensions.renderers[ye.type].call({parser:this},ye),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ee+=qe||"";continue}switch(ye.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,u(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(Z="",re="",B=ye.header.length,be=0;be<B;be++)re+=this.renderer.tablecell(this.parseInline(ye.header[be].tokens),{header:!0,align:ye.align[be]});for(Z+=this.renderer.tablerow(re),de="",B=ye.rows.length,be=0;be<B;be++){for(te=ye.rows[be],re="",Q=te.length,Pe=0;Pe<Q;Pe++)re+=this.renderer.tablecell(this.parseInline(te[Pe].tokens),{header:!1,align:ye.align[Pe]});de+=this.renderer.tablerow(re)}ee+=this.renderer.table(Z,de);continue}case"blockquote":{de=this.parse(ye.tokens),ee+=this.renderer.blockquote(de);continue}case"list":{for(je=ye.ordered,We=ye.start,xe=ye.loose,B=ye.items.length,de="",be=0;be<B;be++)it=ye.items[be],et=it.checked,Ae=it.task,Ze="",it.task&&(Fe=this.renderer.checkbox(et),xe?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Fe+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Fe+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Fe}):Ze+=Fe),Ze+=this.parse(it.tokens,xe),de+=this.renderer.listitem(Ze,Ae,et);ee+=this.renderer.list(de,je,We);continue}case"html":{ee+=this.renderer.html(ye.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(de=ye.tokens?this.parseInline(ye.tokens):ye.text;le+1<Le&&oe[le+1].type==="text";)ye=oe[++le],de+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ee+=he?this.renderer.paragraph(de):de;continue}default:{var Ye='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return ee},ne.parseInline=function(oe,he){he=he||this.renderer;var ee="",le,be,Pe,B=oe.length;for(le=0;le<B;le++){if(be=oe[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Pe=this.options.extensions.renderers[be.type].call({parser:this},be),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){ee+=Pe||"";continue}switch(be.type){case"escape":{ee+=he.text(be.text);break}case"html":{ee+=he.html(be.text);break}case"link":{ee+=he.link(be.href,be.title,this.parseInline(be.tokens,he));break}case"image":{ee+=he.image(be.href,be.title,be.text);break}case"strong":{ee+=he.strong(this.parseInline(be.tokens,he));break}case"em":{ee+=he.em(this.parseInline(be.tokens,he));break}case"codespan":{ee+=he.codespan(be.text);break}case"br":{ee+=he.br();break}case"del":{ee+=he.del(this.parseInline(be.tokens,he));break}case"text":{ee+=he.text(be.text);break}default:{var Q='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return ee},ie}();function x(ie,ne,Ee){if(typeof ie>"u"||ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");if(typeof ne=="function"&&(Ee=ne,ne=null),ne=y({},x.defaults,ne||{}),d(ne),Ee){var oe=ne.highlight,he;try{he=H.lex(ie,ne)}catch(B){return Ee(B)}var ee=function(Q){var te;if(!Q)try{ne.walkTokens&&x.walkTokens(he,ne.walkTokens),te=q.parse(he,ne)}catch(re){Q=re}return ne.highlight=oe,Q?Ee(Q):Ee(null,te)};if(!oe||oe.length<3||(delete ne.highlight,!he.length))return ee();var le=0;x.walkTokens(he,function(B){B.type==="code"&&(le++,setTimeout(function(){oe(B.text,B.lang,function(Q,te){if(Q)return ee(Q);te!=null&&te!==B.text&&(B.text=te,B.escaped=!0),le--,le===0&&ee()})},0))}),le===0&&ee();return}function be(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+S(B.message+"",!0)+"</pre>";throw B}try{var Pe=H.lex(ie,ne);if(ne.walkTokens){if(ne.async)return Promise.all(x.walkTokens(Pe,ne.walkTokens)).then(function(){return q.parse(Pe,ne)}).catch(be);x.walkTokens(Pe,ne.walkTokens)}return q.parse(Pe,ne)}catch(B){be(B)}}x.options=x.setOptions=function(ie){return y(x.defaults,ie),b(x.defaults),x},x.getDefaults=R,x.defaults=$e.defaults,x.use=function(){for(var ie=arguments.length,ne=new Array(ie),Ee=0;Ee<ie;Ee++)ne[Ee]=arguments[Ee];var oe=y.apply(void 0,[{}].concat(ne)),he=x.defaults.extensions||{renderers:{},childTokens:{}},ee;ne.forEach(function(le){if(le.extensions&&(ee=!0,le.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=he.renderers?he.renderers[Pe.name]:null;B?he.renderers[Pe.name]=function(){for(var Q=arguments.length,te=new Array(Q),re=0;re<Q;re++)te[re]=arguments[re];var Z=Pe.renderer.apply(this,te);return Z===!1&&(Z=B.apply(this,te)),Z}:he.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Pe.level]?he[Pe.level].unshift(Pe.tokenizer):he[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?he.startBlock?he.startBlock.push(Pe.start):he.startBlock=[Pe.start]:Pe.level==="inline"&&(he.startInline?he.startInline.push(Pe.start):he.startInline=[Pe.start]))}Pe.childTokens&&(he.childTokens[Pe.name]=Pe.childTokens)})),le.renderer&&function(){var Pe=x.defaults.renderer||new fe,B=function(re){var Z=Pe[re];Pe[re]=function(){for(var de=arguments.length,ye=new Array(de),je=0;je<de;je++)ye[je]=arguments[je];var We=le.renderer[re].apply(Pe,ye);return We===!1&&(We=Z.apply(Pe,ye)),We}};for(var Q in le.renderer)B(Q);oe.renderer=Pe}(),le.tokenizer&&function(){var Pe=x.defaults.tokenizer||new M,B=function(re){var Z=Pe[re];Pe[re]=function(){for(var de=arguments.length,ye=new Array(de),je=0;je<de;je++)ye[je]=arguments[je];var We=le.tokenizer[re].apply(Pe,ye);return We===!1&&(We=Z.apply(Pe,ye)),We}};for(var Q in le.tokenizer)B(Q);oe.tokenizer=Pe}(),le.walkTokens){var be=x.defaults.walkTokens;oe.walkTokens=function(Pe){var B=[];return B.push(le.walkTokens.call(this,Pe)),be&&(B=B.concat(be.call(this,Pe))),B}}ee&&(oe.extensions=he),x.setOptions(oe)})},x.walkTokens=function(ie,ne){for(var Ee=[],oe=function(){var be=ee.value;switch(Ee=Ee.concat(ne.call(x,be)),be.type){case"table":{for(var Pe=L(be.header),B;!(B=Pe()).done;){var Q=B.value;Ee=Ee.concat(x.walkTokens(Q.tokens,ne))}for(var te=L(be.rows),re;!(re=te()).done;)for(var Z=re.value,de=L(Z),ye;!(ye=de()).done;){var je=ye.value;Ee=Ee.concat(x.walkTokens(je.tokens,ne))}break}case"list":{Ee=Ee.concat(x.walkTokens(be.items,ne));break}default:x.defaults.extensions&&x.defaults.extensions.childTokens&&x.defaults.extensions.childTokens[be.type]?x.defaults.extensions.childTokens[be.type].forEach(function(We){Ee=Ee.concat(x.walkTokens(be[We],ne))}):be.tokens&&(Ee=Ee.concat(x.walkTokens(be.tokens,ne)))}},he=L(ie),ee;!(ee=he()).done;)oe();return Ee},x.parseInline=function(ie,ne){if(typeof ie>"u"||ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");ne=y({},x.defaults,ne||{}),d(ne);try{var Ee=H.lexInline(ie,ne);return ne.walkTokens&&x.walkTokens(Ee,ne.walkTokens),q.parseInline(Ee,ne)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+S(oe.message+"",!0)+"</pre>";throw oe}},x.Parser=q,x.parser=q.parse,x.Renderer=fe,x.TextRenderer=X,x.Lexer=H,x.lexer=H.lex,x.Tokenizer=M,x.Slugger=Y,x.parse=x;var me=x.options,ue=x.setOptions,pe=x.use,G=x.walkTokens,z=x.parseInline,K=x,ge=q.parse,_=H.lex;$e.Lexer=H,$e.Parser=q,$e.Renderer=fe,$e.Slugger=Y,$e.TextRenderer=X,$e.Tokenizer=M,$e.getDefaults=R,$e.lexer=_,$e.marked=x,$e.options=me,$e.parse=K,$e.parseInline=z,$e.parser=ge,$e.setOptions=ue,$e.use=pe,$e.walkTokens=G,Object.defineProperty($e,"__esModule",{value:!0})}),define(De[76],Ce([1,0,28]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=e.$ll=e.$kl=void 0;const T=new D.$Cc(1e4);function g(w){return E(w,"NFC",T)}e.$kl=g;const L=new D.$Cc(1e4);function R(w){return E(w,"NFD",L)}e.$ll=R;const b=/[^\u0000-\u0080]/;function E(w,A,I){if(!w)return w;const v=I.get(w);if(v)return v;let k;return b.test(w)?k=w.normalize(A):k=w,I.set(w,k),k}e.$ml=function(){const w=/[\u0300-\u036f]/g;return function(A){return R(A).replace(w,"")}}()}),define(De[120],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.rot=e.$Kl=void 0;function D(b,E,w){return Math.min(Math.max(b,E),w)}e.$Kl=D;function T(b,E){return(E+b%E)%E}e.rot=T;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$Ml=g;class L{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nl=L;class R{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const w=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ol=R}),function(){function $e(g){const L=[];typeof g=="number"&&L.push("code/timeOrigin",g);function R(E){L.push(E,Date.now())}function b(){const E=[];for(let w=0;w<L.length;w+=2)E.push({name:L[w],startTime:L[w+1]});return E}return{mark:R,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(g+R.startTime)});return L}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=D(T))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var T in D)(typeof exports=="object"?exports:$e)[T]=D[T]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function D(T){if(e[T])return e[T].exports;var g=e[T]={i:T,l:!1,exports:{}};return $e[T].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=$e,D.c=e,D.d=function(T,g,L){D.o(T,g)||Object.defineProperty(T,g,{enumerable:!0,get:L})},D.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},D.t=function(T,g){if(1&g&&(T=D(T)),8&g||4&g&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&g&&typeof T!="string")for(var R in T)D.d(L,R,function(b){return T[b]}.bind(null,R));return L},D.n=function(T){var g=T&&T.__esModule?function(){return T.default}:function(){return T};return D.d(g,"a",g),g},D.o=function(T,g){return Object.prototype.hasOwnProperty.call(T,g)},D.p="",D(D.s=0)}([function($e,e,D){(function(T){var g;e=$e.exports=pe,g=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],E=e.src=[],w=0,A=w++;E[A]="0|[1-9]\\d*";var I=w++;E[I]="[0-9]+";var v=w++;E[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=w++;E[k]="("+E[A]+")\\.("+E[A]+")\\.("+E[A]+")";var S=w++;E[S]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var p=w++;E[p]="(?:"+E[A]+"|"+E[v]+")";var u=w++;E[u]="(?:"+E[I]+"|"+E[v]+")";var r=w++;E[r]="(?:-("+E[p]+"(?:\\."+E[p]+")*))";var s=w++;E[s]="(?:-?("+E[u]+"(?:\\."+E[u]+")*))";var a=w++;E[a]="[0-9A-Za-z-]+";var m=w++;E[m]="(?:\\+("+E[a]+"(?:\\."+E[a]+")*))";var l=w++,t="v?"+E[k]+E[r]+"?"+E[m]+"?";E[l]="^"+t+"$";var n="[v=\\s]*"+E[S]+E[s]+"?"+E[m]+"?",o=w++;E[o]="^"+n+"$";var i=w++;E[i]="((?:<|>)?=?)";var c=w++;E[c]=E[I]+"|x|X|\\*";var h=w++;E[h]=E[A]+"|x|X|\\*";var y=w++;E[y]="[v=\\s]*("+E[h]+")(?:\\.("+E[h]+")(?:\\.("+E[h]+")(?:"+E[r]+")?"+E[m]+"?)?)?";var C=w++;E[C]="[v=\\s]*("+E[c]+")(?:\\.("+E[c]+")(?:\\.("+E[c]+")(?:"+E[s]+")?"+E[m]+"?)?)?";var $=w++;E[$]="^"+E[i]+"\\s*"+E[y]+"$";var f=w++;E[f]="^"+E[i]+"\\s*"+E[C]+"$";var d=w++;E[d]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=w++;E[P]="(?:~>?)";var N=w++;E[N]="(\\s*)"+E[P]+"\\s+",b[N]=new RegExp(E[N],"g");var O=w++;E[O]="^"+E[P]+E[y]+"$";var M=w++;E[M]="^"+E[P]+E[C]+"$";var j=w++;E[j]="(?:\\^)";var U=w++;E[U]="(\\s*)"+E[j]+"\\s+",b[U]=new RegExp(E[U],"g");var F=w++;E[F]="^"+E[j]+E[y]+"$";var V=w++;E[V]="^"+E[j]+E[C]+"$";var H=w++;E[H]="^"+E[i]+"\\s*("+n+")$|^$";var fe=w++;E[fe]="^"+E[i]+"\\s*("+t+")$|^$";var X=w++;E[X]="(\\s*)"+E[i]+"\\s*("+n+"|"+E[y]+")",b[X]=new RegExp(E[X],"g");var Y=w++;E[Y]="^\\s*("+E[y]+")\\s+-\\s+("+E[y]+")\\s*$";var q=w++;E[q]="^\\s*("+E[C]+")\\s+-\\s+("+E[C]+")\\s*$";var x=w++;E[x]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)g(me,E[me]),b[me]||(b[me]=new RegExp(E[me]));function ue(Z,de){if(Z instanceof pe)return Z;if(typeof Z!="string"||Z.length>L||!(de?b[o]:b[l]).test(Z))return null;try{return new pe(Z,de)}catch{return null}}function pe(Z,de){if(Z instanceof pe){if(Z.loose===de)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof pe))return new pe(Z,de);g("SemVer",Z,de),this.loose=de;var ye=Z.trim().match(de?b[o]:b[l]);if(!ye)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<R)return We}return je}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ue,e.valid=function(Z,de){var ye=ue(Z,de);return ye?ye.version:null},e.clean=function(Z,de){var ye=ue(Z.trim().replace(/^[=v]+/,""),de);return ye?ye.version:null},e.SemVer=pe,pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},pe.prototype.toString=function(){return this.version},pe.prototype.compare=function(Z){return g("SemVer.compare",this.version,this.loose,Z),Z instanceof pe||(Z=new pe(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},pe.prototype.compareMain=function(Z){return Z instanceof pe||(Z=new pe(Z,this.loose)),z(this.major,Z.major)||z(this.minor,Z.minor)||z(this.patch,Z.patch)},pe.prototype.comparePre=function(Z){if(Z instanceof pe||(Z=new pe(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var de=0;do{var ye=this.prerelease[de],je=Z.prerelease[de];if(g("prerelease compare",de,ye,je),ye===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ye===void 0)return-1;if(ye!==je)return z(ye,je)}while(++de)},pe.prototype.inc=function(Z,de){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,de,ye,je){typeof ye=="string"&&(je=ye,ye=void 0);try{return new pe(Z,ye).inc(de,je).version}catch{return null}},e.diff=function(Z,de){if(ie(Z,de))return null;var ye=ue(Z),je=ue(de);if(ye.prerelease.length||je.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return We},e.compareIdentifiers=z;var G=/^[0-9]+$/;function z(Z,de){var ye=G.test(Z),je=G.test(de);return ye&&je&&(Z=+Z,de=+de),ye&&!je?-1:je&&!ye?1:Z<de?-1:Z>de?1:0}function K(Z,de,ye){return new pe(Z,ye).compare(new pe(de,ye))}function ge(Z,de,ye){return K(Z,de,ye)>0}function _(Z,de,ye){return K(Z,de,ye)<0}function ie(Z,de,ye){return K(Z,de,ye)===0}function ne(Z,de,ye){return K(Z,de,ye)!==0}function Ee(Z,de,ye){return K(Z,de,ye)>=0}function oe(Z,de,ye){return K(Z,de,ye)<=0}function he(Z,de,ye,je){var We;switch(de){case"===":typeof Z=="object"&&(Z=Z.version),typeof ye=="object"&&(ye=ye.version),We=Z===ye;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof ye=="object"&&(ye=ye.version),We=Z!==ye;break;case"":case"=":case"==":We=ie(Z,ye,je);break;case"!=":We=ne(Z,ye,je);break;case">":We=ge(Z,ye,je);break;case">=":We=Ee(Z,ye,je);break;case"<":We=_(Z,ye,je);break;case"<=":We=oe(Z,ye,je);break;default:throw new TypeError("Invalid operator: "+de)}return We}function ee(Z,de){if(Z instanceof ee){if(Z.loose===de)return Z;Z=Z.value}if(!(this instanceof ee))return new ee(Z,de);g("comparator",Z,de),this.loose=de,this.parse(Z),this.semver===le?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(Z,de){return z(de,Z)},e.major=function(Z,de){return new pe(Z,de).major},e.minor=function(Z,de){return new pe(Z,de).minor},e.patch=function(Z,de){return new pe(Z,de).patch},e.compare=K,e.compareLoose=function(Z,de){return K(Z,de,!0)},e.rcompare=function(Z,de,ye){return K(de,Z,ye)},e.sort=function(Z,de){return Z.sort(function(ye,je){return e.compare(ye,je,de)})},e.rsort=function(Z,de){return Z.sort(function(ye,je){return e.rcompare(ye,je,de)})},e.gt=ge,e.lt=_,e.eq=ie,e.neq=ne,e.gte=Ee,e.lte=oe,e.cmp=he,e.Comparator=ee;var le={};function be(Z,de){if(Z instanceof be)return Z.loose===de?Z:new be(Z.raw,de);if(Z instanceof ee)return new be(Z.value,de);if(!(this instanceof be))return new be(Z,de);if(this.loose=de,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Pe(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function B(Z,de,ye,je,We,xe,Ze,it,et,Ae,Fe,qe,Le){return((de=Pe(ye)?"":Pe(je)?">="+ye+".0.0":Pe(We)?">="+ye+"."+je+".0":">="+de)+" "+(it=Pe(et)?"":Pe(Ae)?"<"+(+et+1)+".0.0":Pe(Fe)?"<"+et+"."+(+Ae+1)+".0":qe?"<="+et+"."+Ae+"."+Fe+"-"+qe:"<="+it)).trim()}function Q(Z,de){for(var ye=0;ye<Z.length;ye++)if(!Z[ye].test(de))return!1;if(de.prerelease.length){for(ye=0;ye<Z.length;ye++)if(g(Z[ye].semver),Z[ye].semver!==le&&Z[ye].semver.prerelease.length>0){var je=Z[ye].semver;if(je.major===de.major&&je.minor===de.minor&&je.patch===de.patch)return!0}return!1}return!0}function te(Z,de,ye){try{de=new be(de,ye)}catch{return!1}return de.test(Z)}function re(Z,de,ye,je){var We,xe,Ze,it,et;switch(Z=new pe(Z,je),de=new be(de,je),ye){case">":We=ge,xe=oe,Ze=_,it=">",et=">=";break;case"<":We=_,xe=Ee,Ze=ge,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(te(Z,de,je))return!1;for(var Ae=0;Ae<de.set.length;++Ae){var Fe=de.set[Ae],qe=null,Le=null;if(Fe.forEach(function(Ye){Ye.semver===le&&(Ye=new ee(">=0.0.0")),qe=qe||Ye,Le=Le||Ye,We(Ye.semver,qe.semver,je)?qe=Ye:Ze(Ye.semver,Le.semver,je)&&(Le=Ye)}),qe.operator===it||qe.operator===et||(!Le.operator||Le.operator===it)&&xe(Z,Le.semver)||Le.operator===et&&Ze(Z,Le.semver))return!1}return!0}ee.prototype.parse=function(Z){var de=this.loose?b[H]:b[fe],ye=Z.match(de);if(!ye)throw new TypeError("Invalid comparator: "+Z);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new pe(ye[2],this.loose):this.semver=le},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Z){return g("Comparator.test",Z,this.loose),this.semver===le||(typeof Z=="string"&&(Z=new pe(Z,this.loose)),he(Z,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Z,de){if(!(Z instanceof ee))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new be(Z.value,de),te(this.value,ye,de);if(Z.operator==="")return ye=new be(this.value,de),te(Z.semver,ye,de);var je=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),xe=this.semver.version===Z.semver.version,Ze=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),it=he(this.semver,"<",Z.semver,de)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),et=he(this.semver,">",Z.semver,de)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return je||We||xe&&Ze||it||et},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Z){var de=this.loose;Z=Z.trim(),g("range",Z,de);var ye=de?b[q]:b[Y];Z=Z.replace(ye,B),g("hyphen replace",Z),Z=Z.replace(b[X],"$1$2$3"),g("comparator trim",Z,b[X]),Z=(Z=(Z=Z.replace(b[N],"$1~")).replace(b[U],"$1^")).split(/\s+/).join(" ");var je=de?b[H]:b[fe],We=Z.split(" ").map(function(xe){return function(Ze,it){return g("comp",Ze),Ze=function(et,Ae){return et.trim().split(/\s+/).map(function(Fe){return function(qe,Le){g("caret",qe,Le);var Ye=Le?b[V]:b[F];return qe.replace(Ye,function(ce,ae,Ie,Ve,Ue){var Xe;return g("caret",qe,ce,ae,Ie,Ve,Ue),Pe(ae)?Xe="":Pe(Ie)?Xe=">="+ae+".0.0 <"+(+ae+1)+".0.0":Pe(Ve)?Xe=ae==="0"?">="+ae+"."+Ie+".0 <"+ae+"."+(+Ie+1)+".0":">="+ae+"."+Ie+".0 <"+(+ae+1)+".0.0":Ue?(g("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Xe=ae==="0"?Ie==="0"?">="+ae+"."+Ie+"."+Ve+Ue+" <"+ae+"."+Ie+"."+(+Ve+1):">="+ae+"."+Ie+"."+Ve+Ue+" <"+ae+"."+(+Ie+1)+".0":">="+ae+"."+Ie+"."+Ve+Ue+" <"+(+ae+1)+".0.0"):(g("no pr"),Xe=ae==="0"?Ie==="0"?">="+ae+"."+Ie+"."+Ve+" <"+ae+"."+Ie+"."+(+Ve+1):">="+ae+"."+Ie+"."+Ve+" <"+ae+"."+(+Ie+1)+".0":">="+ae+"."+Ie+"."+Ve+" <"+(+ae+1)+".0.0"),g("caret return",Xe),Xe})}(Fe,Ae)}).join(" ")}(Ze,it),g("caret",Ze),Ze=function(et,Ae){return et.trim().split(/\s+/).map(function(Fe){return function(qe,Le){var Ye=Le?b[M]:b[O];return qe.replace(Ye,function(ce,ae,Ie,Ve,Ue){var Xe;return g("tilde",qe,ce,ae,Ie,Ve,Ue),Pe(ae)?Xe="":Pe(Ie)?Xe=">="+ae+".0.0 <"+(+ae+1)+".0.0":Pe(Ve)?Xe=">="+ae+"."+Ie+".0 <"+ae+"."+(+Ie+1)+".0":Ue?(g("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Xe=">="+ae+"."+Ie+"."+Ve+Ue+" <"+ae+"."+(+Ie+1)+".0"):Xe=">="+ae+"."+Ie+"."+Ve+" <"+ae+"."+(+Ie+1)+".0",g("tilde return",Xe),Xe})}(Fe,Ae)}).join(" ")}(Ze,it),g("tildes",Ze),Ze=function(et,Ae){return g("replaceXRanges",et,Ae),et.split(/\s+/).map(function(Fe){return function(qe,Le){qe=qe.trim();var Ye=Le?b[f]:b[$];return qe.replace(Ye,function(ce,ae,Ie,Ve,Ue,Xe){g("xRange",qe,ce,ae,Ie,Ve,Ue,Xe);var rt=Pe(Ie),ot=rt||Pe(Ve),wt=ot||Pe(Ue);return ae==="="&&wt&&(ae=""),rt?ce=ae===">"||ae==="<"?"<0.0.0":"*":ae&&wt?(ot&&(Ve=0),wt&&(Ue=0),ae===">"?(ae=">=",ot?(Ie=+Ie+1,Ve=0,Ue=0):wt&&(Ve=+Ve+1,Ue=0)):ae==="<="&&(ae="<",ot?Ie=+Ie+1:Ve=+Ve+1),ce=ae+Ie+"."+Ve+"."+Ue):ot?ce=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":wt&&(ce=">="+Ie+"."+Ve+".0 <"+Ie+"."+(+Ve+1)+".0"),g("xRange return",ce),ce})}(Fe,Ae)}).join(" ")}(Ze,it),g("xrange",Ze),Ze=function(et,Ae){return g("replaceStars",et,Ae),et.trim().replace(b[x],"")}(Ze,it),g("stars",Ze),Ze}(xe,de)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(xe){return!!xe.match(je)})),We=We.map(function(xe){return new ee(xe,de)})},be.prototype.intersects=function(Z,de){if(!(Z instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(je){return Z.set.some(function(We){return We.every(function(xe){return je.intersects(xe,de)})})})})},e.toComparators=function(Z,de){return new be(Z,de).set.map(function(ye){return ye.map(function(je){return je.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new pe(Z,this.loose));for(var de=0;de<this.set.length;de++)if(Q(this.set[de],Z))return!0;return!1},e.satisfies=te,e.maxSatisfying=function(Z,de,ye){var je=null,We=null;try{var xe=new be(de,ye)}catch{return null}return Z.forEach(function(Ze){xe.test(Ze)&&(je&&We.compare(Ze)!==-1||(We=new pe(je=Ze,ye)))}),je},e.minSatisfying=function(Z,de,ye){var je=null,We=null;try{var xe=new be(de,ye)}catch{return null}return Z.forEach(function(Ze){xe.test(Ze)&&(je&&We.compare(Ze)!==1||(We=new pe(je=Ze,ye)))}),je},e.validRange=function(Z,de){try{return new be(Z,de).range||"*"}catch{return null}},e.ltr=function(Z,de,ye){return re(Z,de,"<",ye)},e.gtr=function(Z,de,ye){return re(Z,de,">",ye)},e.outside=re,e.prerelease=function(Z,de){var ye=ue(Z,de);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(Z,de,ye){return Z=new be(Z,ye),de=new be(de,ye),Z.intersects(de)},e.coerce=function(Z){if(Z instanceof pe)return Z;if(typeof Z!="string")return null;var de=Z.match(b[d]);return de==null?null:ue((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,D(1))},function($e,e){var D,T,g=$e.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function b(u){if(D===setTimeout)return setTimeout(u,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(u,0);try{return D(u,0)}catch{try{return D.call(null,u,0)}catch{return D.call(this,u,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var E,w=[],A=!1,I=-1;function v(){A&&E&&(A=!1,E.length?w=E.concat(w):I=-1,w.length&&k())}function k(){if(!A){var u=b(v);A=!0;for(var r=w.length;r;){for(E=w,w=[];++I<r;)E&&E[I].run();I=-1,r=w.length}E=null,A=!1,function(s){if(T===clearTimeout)return clearTimeout(s);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(s);try{T(s)}catch{try{return T.call(null,s)}catch{return T.call(this,s)}}}(u)}}function S(u,r){this.fun=u,this.array=r}function p(){}g.nextTick=function(u){var r=new Array(arguments.length-1);if(arguments.length>1)for(var s=1;s<arguments.length;s++)r[s-1]=arguments[s];w.push(new S(u,r)),w.length!==1||A||b(k)},S.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=p,g.addListener=p,g.once=p,g.off=p,g.removeListener=p,g.removeAllListeners=p,g.emit=p,g.prependListener=p,g.prependOnceListener=p,g.listeners=function(u){return[]},g.binding=function(u){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(u){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(De[37],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(L){return new T(L)}constructor(L){this.c=D&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Id=T}),define(De[4],Ce([1,0,8,74,3,75,37]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.Event=void 0;const b=!1,E=!1;var w;(function($){$.None=()=>g.$Rc.None;function f(he){if(E){const{onDidAddListener:ee}=he,le=S.create();let be=0;he.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),ee?.()}}}function d(he,ee){return fe(he,()=>{},0,void 0,!0,void 0,ee)}$.defer=d;function P(he){return(ee,le=null,be)=>{let Pe=!1,B;return B=he(Q=>{if(!Pe)return B?B.dispose():Pe=!0,ee.call(le,Q)},null,be),Pe&&B.dispose(),B}}$.once=P;function N(he,ee,le){return V((be,Pe=null,B)=>he(Q=>be.call(Pe,ee(Q)),null,B),le)}$.map=N;function O(he,ee,le){return V((be,Pe=null,B)=>he(Q=>{ee(Q),be.call(Pe,Q)},null,B),le)}$.forEach=O;function M(he,ee,le){return V((be,Pe=null,B)=>he(Q=>ee(Q)&&be.call(Pe,Q),null,B),le)}$.filter=M;function j(he){return he}$.signal=j;function U(...he){return(ee,le=null,be)=>{const Pe=(0,g.$Oc)(...he.map(B=>B(Q=>ee.call(le,Q))));return H(Pe,be)}}$.any=U;function F(he,ee,le,be){let Pe=le;return N(he,B=>(Pe=ee(Pe,B),Pe),be)}$.reduce=F;function V(he,ee){let le;const be={onWillAddFirstListener(){le=he(Pe.fire,Pe)},onDidRemoveLastListener(){le?.dispose()}};ee||f(be);const Pe=new a(be);return ee?.add(Pe),Pe.event}function H(he,ee){return ee instanceof Array?ee.push(he):ee&&ee.add(he),he}function fe(he,ee,le=100,be=!1,Pe=!1,B,Q){let te,re,Z,de=0,ye;const je={leakWarningThreshold:B,onWillAddFirstListener(){te=he(xe=>{de++,re=ee(re,xe),be&&!Z&&(We.fire(re),re=void 0),ye=()=>{const Ze=re;re=void 0,Z=void 0,(!be||de>1)&&We.fire(Ze),de=0},typeof le=="number"?(clearTimeout(Z),Z=setTimeout(ye,le)):Z===void 0&&(Z=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&de>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,te.dispose()}};Q||f(je);const We=new a(je);return Q?.add(We),We.event}$.debounce=fe;function X(he,ee=0,le){return $.debounce(he,(be,Pe)=>be?(be.push(Pe),be):[Pe],ee,void 0,!0,void 0,le)}$.accumulate=X;function Y(he,ee=(be,Pe)=>be===Pe,le){let be=!0,Pe;return M(he,B=>{const Q=be||!ee(B,Pe);return be=!1,Pe=B,Q},le)}$.latch=Y;function q(he,ee,le){return[$.filter(he,ee,le),$.filter(he,be=>!ee(be),le)]}$.split=q;function x(he,ee=!1,le=[],be){let Pe=le.slice(),B=he(re=>{Pe?Pe.push(re):te.fire(re)});be&&be.add(B);const Q=()=>{Pe?.forEach(re=>te.fire(re)),Pe=null},te=new a({onWillAddFirstListener(){B||(B=he(re=>te.fire(re)),be&&be.add(B))},onDidAddFirstListener(){Pe&&(ee?setTimeout(Q):Q())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return be&&be.add(te),te.event}$.buffer=x;function me(he,ee){return(be,Pe,B)=>{const Q=ee(new pe);return he(function(te){const re=Q.evaluate(te);re!==ue&&be.call(Pe,re)},void 0,B)}}$.chain=me;const ue=Symbol("HaltChainable");class pe{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(le=>(ee(le),le)),this}filter(ee){return this.f.push(le=>ee(le)?le:ue),this}reduce(ee,le){let be=le;return this.f.push(Pe=>(be=ee(be,Pe),be)),this}latch(ee=(le,be)=>le===be){let le=!0,be;return this.f.push(Pe=>{const B=le||!ee(Pe,be);return le=!1,be=Pe,B?Pe:ue}),this}evaluate(ee){for(const le of this.f)if(ee=le(ee),ee===ue)break;return ee}}function G(he,ee,le=be=>be){const be=(...te)=>Q.fire(le(...te)),Pe=()=>he.on(ee,be),B=()=>he.removeListener(ee,be),Q=new a({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return Q.event}$.fromNodeEventEmitter=G;function z(he,ee,le=be=>be){const be=(...te)=>Q.fire(le(...te)),Pe=()=>he.addEventListener(ee,be),B=()=>he.removeEventListener(ee,be),Q=new a({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return Q.event}$.fromDOMEventEmitter=z;function K(he){return new Promise(ee=>P(he)(ee))}$.toPromise=K;function ge(he){const ee=new a;return he.then(le=>{ee.fire(le)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}$.fromPromise=ge;function _(he,ee){return ee(void 0),he(le=>ee(le))}$.runAndSubscribe=_;function ie(he,ee){let le=null;function be(B){le?.dispose(),le=new g.$Qc,ee(B,le)}be(void 0);const Pe=he(B=>be(B));return(0,g.$Pc)(()=>{Pe.dispose(),le?.dispose()})}$.runAndSubscribeWithStore=ie;class ne{constructor(ee,le){this._observable=ee,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};le||f(be),this.emitter=new a(be),le&&le.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,le){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(he,ee){return new ne(he,ee).emitter.event}$.fromObservable=Ee;function oe(he){return ee=>{let le=0,be=!1;const Pe={beginUpdate(){le++},endUpdate(){le--,le===0&&(he.reportChanges(),be&&(be=!1,ee()))},handlePossibleChange(){},handleChange(){be=!0}};return he.addObserver(Pe),he.reportChanges(),{dispose(){he.removeObserver(Pe)}}}}$.fromObservableLight=oe})(w||(e.Event=w={}));class A{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${A.f++}`,A.all.add(this)}start(f){this.g=new R.$Id,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Kd=A;let I=-1;function v($){const f=I;return I=$,{dispose(){I=f}}}e.$Ld=v;class k{constructor(f,d=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=d,this.g=0}dispose(){this.f?.clear()}check(f,d){const P=this.threshold;if(P<=0||d<P)return;this.f||(this.f=new Map);const N=this.f.get(f.value)||0;if(this.f.set(f.value,N+1),this.g-=1,this.g<=0){this.g=P*.5;let O,M=0;for(const[j,U]of this.f)(!O||M<U)&&(O=j,M=U);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${M}):`),console.warn(O)}return()=>{const O=this.f.get(f.value)||0;this.f.set(f.value,O-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class u{constructor(f){this.value=f,this.id=p++}}const r=2,s=($,f)=>{if($ instanceof u)f($);else for(let d=0;d<$.length;d++){const P=$[d];P&&f(P)}};class a{constructor(f){this.x=0,this.f=f,this.g=I>0||this.f?.leakWarningThreshold?new k(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const f=this.t;queueMicrotask(()=>{s(f,d=>d.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,d,P)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$Rc.None;if(this.m)return g.$Rc.None;d&&(f=f.bind(d));const N=new u(f);let O,M;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(N.stack=S.create(),O=this.g.check(N.stack,this.x+1)),b&&(N.stack=M??S.create()),this.t?this.t instanceof u?(this.u??=new l,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.x++;const j=(0,g.$Pc)(()=>{O?.(),this.y(N)});return P instanceof g.$Qc?P.add(j):Array.isArray(P)&&P.push(j),j},this.q}y(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const d=this.t,P=d.indexOf(f);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,d[P]=void 0;const N=this.u.current===this;if(this.x*r<=d.length){let O=0;for(let M=0;M<d.length;M++)d[M]?d[O++]=d[M]:N&&(this.u.end--,O<this.u.i&&this.u.i--);d.length=O}}z(f,d){if(!f)return;const P=this.f?.onListenerError||D.$Z;if(!P){f.value(d);return}try{f.value(d)}catch(N){P(N)}}A(f){const d=f.current.t;for(;f.i<f.end;)this.z(d[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof u)this.z(this.t,f);else{const d=this.u;d.enqueue(this,f,this.t.length),this.A(d)}this.j?.stop()}hasListeners(){return this.x>0}}e.$Md=a;const m=()=>new l;e.$Nd=m;class l{constructor(){this.i=-1,this.end=0}enqueue(f,d,P){this.i=0,this.end=P,this.current=f,this.value=d}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends a{async fireAsync(f,d,P){if(this.t)for(this.h||(this.h=new L.$1c),s(this.t,N=>this.h.push([N.value,f]));this.h.size>0&&!d.isCancellationRequested;){const[N,O]=this.h.shift(),M=[],j={...O,token:d,waitUntil:U=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");P&&(U=P(U,N)),M.push(U)}};try{N(j)}catch(U){(0,D.$Z)(U);continue}Object.freeze(M),await Promise.allSettled(M).then(U=>{for(const F of U)F.status==="rejected"&&(0,D.$Z)(F.reason)})}}}e.$Od=t;class n extends a{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new L.$1c,this.w=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.w(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.x&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Pd=n;class o extends n{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$Qd=o;class i extends a{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(d=>super.fire(d)),this.h=[]}))}}e.$Rd=i;class c{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const d={event:f,listener:null};this.h.push(d),this.g&&this.m(d);const P=()=>{this.g&&this.o(d);const N=this.h.indexOf(d);this.h.splice(N,1)};return(0,g.$Pc)((0,T.$cb)(P))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(d=>this.f.fire(d))}o(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.f.dispose()}}e.$Sd=c;class h{constructor(f,d,P,N){this.f=new g.$Qc;const O=this.f.add(new c),M=this.f.add(new g.$Zc);function j(U){M.set(U,O.add(N(U)))}for(const U of f)j(U);this.f.add(d(U=>{j(U)})),this.f.add(P(U=>{M.deleteAndDispose(U)})),this.event=O.event}dispose(){this.f.dispose()}}e.$Td=h;class y{constructor(){this.f=[]}wrapEvent(f){return(d,P,N)=>f(O=>{const M=this.f[this.f.length-1];M?M.push(()=>d.call(P,O)):d.call(P,O)},void 0,N)}bufferEvents(f){const d=[];this.f.push(d);const P=f();return this.f.pop(),d.forEach(N=>N()),P}}e.$Ud=y;class C{constructor(){this.f=!1,this.g=w.None,this.h=g.$Rc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Vd=C}),define(De[21],Ce([1,0,4]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.CancellationToken=void 0;const T=Object.freeze(function(b,E){const w=setTimeout(b.bind(E),0);return{dispose(){clearTimeout(w)}}});var g;(function(b){function E(w){return w===b.None||w===b.Cancelled||w instanceof L?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}b.isCancellationToken=E,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(g||(e.CancellationToken=g={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new D.$Md),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=g.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=g.None}}e.$Wd=R}),define(De[159],Ce([1,0,21]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=void 0;class T{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new D.$Wd,E=this.b(b.token);return this.a={promise:E,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$ve=T;class g{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const E=JSON.stringify(b);return this.b!==E&&(this.b=E,this.a=this.c(b)),this.a}}e.$we=g;class L{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const E=this.b(b);return this.a.set(b,E),E}}e.$xe=L}),define(De[97],Ce([1,0,8,3]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function g(m){const l=m;return l?typeof l.read=="function":!1}e.$Xd=g;function L(m){const l=m;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}e.$Yd=L;function R(m){const l=m;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$Zd=R;function b(m,l){return new E(m,l)}e.$1d=b;class E{constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,D.$Z)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let n;switch(l){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const o=n.indexOf(t);o>=0&&n.splice(o,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(m,l){const t=[];let n;for(;(n=m.read())!==null;)t.push(n);return l(t)}e.$2d=w;function A(m,l,t){const n=[];let o;for(;(o=m.read())!==null&&n.length<t;)n.push(o);return o===null&&n.length>0?l(n):{read:()=>{if(n.length>0)return n.shift();if(typeof o<"u"){const i=o;return o=void 0,i}return m.read()}}}e.$3d=A;function I(m,l){return new Promise((t,n)=>{const o=[];v(m,{onData:i=>{l&&o.push(i)},onError:i=>{l?n(i):t(void 0)},onEnd:()=>{t(l?l(o):void 0)}})})}e.$4d=I;function v(m,l,t){m.on("error",n=>{t?.isCancellationRequested||l.onError(n)}),m.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),m.on("data",n=>{t?.isCancellationRequested||l.onData(n)})}e.$5d=v;function k(m,l){return new Promise((t,n)=>{const o=new T.$Qc,i=[],c=C=>{if(i.push(C),i.length>l)return o.dispose(),m.pause(),t({stream:m,buffer:i,ended:!1})},h=C=>(o.dispose(),n(C)),y=()=>(o.dispose(),t({stream:m,buffer:i,ended:!0}));o.add((0,T.$Pc)(()=>m.removeListener("error",h))),m.on("error",h),o.add((0,T.$Pc)(()=>m.removeListener("end",y))),m.on("end",y),o.add((0,T.$Pc)(()=>m.removeListener("data",c))),m.on("data",c)})}e.$6d=k;function S(m,l){const t=b(l);return t.end(m),t}e.$7d=S;function p(){const m=b(()=>{throw new Error("not supported")});return m.end(),m}e.$8d=p;function u(m){let l=!1;return{read:()=>l?null:(l=!0,m)}}e.$9d=u;function r(m,l,t){const n=b(t);return v(m,{onData:o=>n.write(l.data(o)),onError:o=>n.error(l.error?l.error(o):o),onEnd:()=>n.end()}),n}e.$0d=r;function s(m,l,t){let n=!1;return{read:()=>{const o=l.read();return n?o:(n=!0,o!==null?t([m,o]):m)}}}e.$$d=s;function a(m,l,t){let n=!1;const o=b(t);return v(l,{onData:i=>n?o.write(i):(n=!0,o.write(t([m,i]))),onError:i=>o.error(i),onEnd:()=>{n||(n=!0,o.write(m)),o.end()}}),o}e.$_d=a}),define(De[22],Ce([1,0,51,97]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const g=typeof Buffer<"u",L=new D.$U(()=>new Uint8Array(256));let R,b;class E{static alloc(d){return g?new E(Buffer.allocUnsafe(d)):new E(new Uint8Array(d))}static wrap(d){return g&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new E(d)}static fromString(d,P){return!(P?.dontUseNodeBuffer||!1)&&g?new E(Buffer.from(d)):(R||(R=new TextEncoder),new E(R.encode(d)))}static fromByteArray(d){const P=E.alloc(d.length);for(let N=0,O=d.length;N<O;N++)P.buffer[N]=d[N];return P}static concat(d,P){if(typeof P>"u"){P=0;for(let M=0,j=d.length;M<j;M++)P+=d[M].byteLength}const N=E.alloc(P);let O=0;for(let M=0,j=d.length;M<j;M++){const U=d[M];N.set(U,O),O+=U.byteLength}return N}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=E.alloc(this.byteLength);return d.set(this),d}toString(){return g?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(d,P){return new E(this.buffer.subarray(d,P))}set(d,P){if(d instanceof E)this.buffer.set(d.buffer,P);else if(d instanceof Uint8Array)this.buffer.set(d,P);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),P);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return v(this.buffer,d)}writeUInt32BE(d,P){k(this.buffer,d,P)}readUInt32LE(d){return S(this.buffer,d)}writeUInt32LE(d,P){p(this.buffer,d,P)}readUInt8(d){return u(this.buffer,d)}writeUInt8(d,P){r(this.buffer,d,P)}indexOf(d,P=0){return w(this.buffer,d instanceof E?d.buffer:d,P)}}e.$ae=E;function w(f,d,P=0){const N=d.byteLength,O=f.byteLength;if(N===0)return 0;if(N===1)return f.indexOf(d[0]);if(N>O-P)return-1;const M=L.value;M.fill(d.length);for(let V=0;V<d.length;V++)M[d[V]]=d.length-V-1;let j=P+d.length-1,U=j,F=-1;for(;j<O;)if(f[j]===d[U]){if(U===0){F=j;break}j--,U--}else j+=Math.max(d.length-U,M[f[j]]),U=d.length-1;return F}e.$be=w;function A(f,d){return f[d+0]<<0>>>0|f[d+1]<<8>>>0}e.$ce=A;function I(f,d,P){f[P+0]=d&255,d=d>>>8,f[P+1]=d&255}e.$de=I;function v(f,d){return f[d]*2**24+f[d+1]*2**16+f[d+2]*2**8+f[d+3]}e.$ee=v;function k(f,d,P){f[P+3]=d,d=d>>>8,f[P+2]=d,d=d>>>8,f[P+1]=d,d=d>>>8,f[P]=d}e.$fe=k;function S(f,d){return f[d+0]<<0>>>0|f[d+1]<<8>>>0|f[d+2]<<16>>>0|f[d+3]<<24>>>0}e.$ge=S;function p(f,d,P){f[P+0]=d&255,d=d>>>8,f[P+1]=d&255,d=d>>>8,f[P+2]=d&255,d=d>>>8,f[P+3]=d&255}e.$he=p;function u(f,d){return f[d]}e.$ie=u;function r(f,d,P){f[P]=d}e.$je=r;function s(f){return T.$2d(f,d=>E.concat(d))}e.$ke=s;function a(f){return T.$9d(f)}e.$le=a;function m(f){return T.$4d(f,d=>E.concat(d))}e.$me=m;async function l(f){return f.ended?E.concat(f.buffer):E.concat([...f.buffer,await m(f.stream)])}e.$ne=l;function t(f){return T.$7d(f,d=>E.concat(d))}e.$oe=t;function n(f){return T.$0d(f,{data:d=>typeof d=="string"?E.fromString(d):E.wrap(d)},d=>E.concat(d))}e.$pe=n;function o(f){return T.$1d(d=>E.concat(d),f)}e.$qe=o;function i(f,d){return T.$$d(f,d,P=>E.concat(P))}e.$re=i;function c(f,d){return T.$_d(f,d,P=>E.concat(P))}e.$se=c;function h(f){let d=0,P=0,N=0;const O=new Uint8Array(Math.floor(f.length/4*3)),M=U=>{switch(P){case 3:O[N++]=d|U,P=0;break;case 2:O[N++]=d|U>>>2,d=U<<6,P=3;break;case 1:O[N++]=d|U>>>4,d=U<<4,P=2;break;default:d=U<<2,P=1}};for(let U=0;U<f.length;U++){const F=f.charCodeAt(U);if(F>=65&&F<=90)M(F-65);else if(F>=97&&F<=122)M(F-97+26);else if(F>=48&&F<=57)M(F-48+52);else if(F===43||F===45)M(62);else if(F===47||F===95)M(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${f[U]}`)}}const j=N;for(;P>0;)M(0);return E.wrap(O).slice(0,j)}e.$te=h;const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:f},d=!0,P=!1){const N=P?C:y;let O="";const M=f.byteLength%3;let j=0;for(;j<f.byteLength-M;j+=3){const U=f[j+0],F=f[j+1],V=f[j+2];O+=N[U>>>2],O+=N[(U<<4|F>>>4)&63],O+=N[(F<<2|V>>>6)&63],O+=N[V&63]}if(M===1){const U=f[j+0];O+=N[U>>>2],O+=N[U<<4&63],d&&(O+="==")}else if(M===2){const U=f[j+0],F=f[j+1];O+=N[U>>>2],O+=N[(U<<4|F>>>4)&63],O+=N[F<<2&63],d&&(O+="=")}return O}e.$ue=$}),define(De[15],Ce([1,0,159,51]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wf=e.$vf=e.$uf=e.$tf=e.GraphemeBreakType=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function g(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Ae=g;const L=/{(\d+)}/g;function R(Ae,...Fe){return Fe.length===0?Ae:Ae.replace(L,function(qe,Le){const Ye=parseInt(Le,10);return isNaN(Ye)||Ye<0||Ye>=Fe.length?qe:Fe[Ye]})}e.$Be=R;const b=/{([^}]+)}/g;function E(Ae,Fe){return Ae.replace(b,(qe,Le)=>Fe[Le]??qe)}e.$Ce=E;function w(Ae){return Ae.replace(/[<>&]/g,function(Fe){switch(Fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Fe}})}e.$De=w;function A(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ee=A;function I(Ae,Fe){let qe=0;const Le=Fe.charCodeAt(0);for(let Ye=Ae.length-1;Ye>=0;Ye--)Ae.charCodeAt(Ye)===Le&&qe++;return qe}e.$Fe=I;function v(Ae,Fe,qe="\u2026"){return Ae.length<=Fe?Ae:`${Ae.substr(0,Fe)}${qe}`}e.$Ge=v;function k(Ae,Fe=" "){const qe=S(Ae,Fe);return p(qe,Fe)}e.$He=k;function S(Ae,Fe){if(!Ae||!Fe)return Ae;const qe=Fe.length;if(qe===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Fe,Le)===Le;)Le=Le+qe;return Ae.substring(Le)}e.$Ie=S;function p(Ae,Fe){if(!Ae||!Fe)return Ae;const qe=Fe.length,Le=Ae.length;if(qe===0||Le===0)return Ae;let Ye=Le,ce=-1;for(;ce=Ae.lastIndexOf(Fe,Ye-1),!(ce===-1||ce+qe!==Ye);){if(ce===0)return"";Ye=ce}return Ae.substring(0,Ye)}e.$Je=p;function u(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ke=u;function r(Ae){return Ae.replace(/\*/g,"")}e.$Le=r;function s(Ae,Fe,qe={}){if(!Ae)throw new Error("Cannot create regex from empty string");Fe||(Ae=A(Ae)),qe.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return qe.global&&(Le+="g"),qe.matchCase||(Le+="i"),qe.multiline&&(Le+="m"),qe.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$Me=s;function a(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Ne=a;function m(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Oe=m;function l(Ae){for(let Fe=0,qe=Ae.length;Fe<qe;Fe++){const Le=Ae.charCodeAt(Fe);if(Le!==32&&Le!==9)return Fe}return-1}e.$Pe=l;function t(Ae,Fe=0,qe=Ae.length){for(let Le=Fe;Le<qe;Le++){const Ye=Ae.charCodeAt(Le);if(Ye!==32&&Ye!==9)return Ae.substring(Fe,Le)}return Ae.substring(Fe,qe)}e.$Qe=t;function n(Ae,Fe=Ae.length-1){for(let qe=Fe;qe>=0;qe--){const Le=Ae.charCodeAt(qe);if(Le!==32&&Le!==9)return qe}return-1}e.$Re=n;function o(Ae,Fe,qe){const Le=[];let Ye=0;for(const ce of Ae.matchAll(Fe)){if(Le.push(Ae.slice(Ye,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");Ye=ce.index+ce[0].length,Le.push(qe(ce[0],...ce.slice(1),ce.index,Ae,ce.groups))}return Le.push(Ae.slice(Ye)),Promise.all(Le).then(ce=>ce.join(""))}e.$Se=o;function i(Ae,Fe){return Ae<Fe?-1:Ae>Fe?1:0}e.$Te=i;function c(Ae,Fe,qe=0,Le=Ae.length,Ye=0,ce=Fe.length){for(;qe<Le&&Ye<ce;qe++,Ye++){const Ve=Ae.charCodeAt(qe),Ue=Fe.charCodeAt(Ye);if(Ve<Ue)return-1;if(Ve>Ue)return 1}const ae=Le-qe,Ie=ce-Ye;return ae<Ie?-1:ae>Ie?1:0}e.$Ue=c;function h(Ae,Fe){return y(Ae,Fe,0,Ae.length,0,Fe.length)}e.$Ve=h;function y(Ae,Fe,qe=0,Le=Ae.length,Ye=0,ce=Fe.length){for(;qe<Le&&Ye<ce;qe++,Ye++){let Ve=Ae.charCodeAt(qe),Ue=Fe.charCodeAt(Ye);if(Ve===Ue)continue;if(Ve>=128||Ue>=128)return c(Ae.toLowerCase(),Fe.toLowerCase(),qe,Le,Ye,ce);$(Ve)&&(Ve-=32),$(Ue)&&(Ue-=32);const Xe=Ve-Ue;if(Xe!==0)return Xe}const ae=Le-qe,Ie=ce-Ye;return ae<Ie?-1:ae>Ie?1:0}e.$We=y;function C(Ae){return Ae>=48&&Ae<=57}e.$Xe=C;function $(Ae){return Ae>=97&&Ae<=122}e.$Ye=$;function f(Ae){return Ae>=65&&Ae<=90}e.$Ze=f;function d(Ae,Fe){return Ae.length===Fe.length&&y(Ae,Fe)===0}e.$1e=d;function P(Ae,Fe){const qe=Fe.length;return Fe.length>Ae.length?!1:y(Ae,Fe,0,qe)===0}e.$2e=P;function N(Ae,Fe){const qe=Math.min(Ae.length,Fe.length);let Le;for(Le=0;Le<qe;Le++)if(Ae.charCodeAt(Le)!==Fe.charCodeAt(Le))return Le;return qe}e.$3e=N;function O(Ae,Fe){const qe=Math.min(Ae.length,Fe.length);let Le;const Ye=Ae.length-1,ce=Fe.length-1;for(Le=0;Le<qe;Le++)if(Ae.charCodeAt(Ye-Le)!==Fe.charCodeAt(ce-Le))return Le;return qe}e.$4e=O;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$5e=M;function j(Ae){return 56320<=Ae&&Ae<=57343}e.$6e=j;function U(Ae,Fe){return(Ae-55296<<10)+(Fe-56320)+65536}e.$7e=U;function F(Ae,Fe,qe){const Le=Ae.charCodeAt(qe);if(M(Le)&&qe+1<Fe){const Ye=Ae.charCodeAt(qe+1);if(j(Ye))return U(Le,Ye)}return Le}e.$8e=F;function V(Ae,Fe){const qe=Ae.charCodeAt(Fe-1);if(j(qe)&&Fe>1){const Le=Ae.charCodeAt(Fe-2);if(M(Le))return U(Le,qe)}return qe}class H{get offset(){return this.e}constructor(Fe,qe=0){this.c=Fe,this.d=Fe.length,this.e=qe}setOffset(Fe){this.e=Fe}prevCodePoint(){const Fe=V(this.c,this.e);return this.e-=Fe>=65536?2:1,Fe}nextCodePoint(){const Fe=F(this.c,this.d,this.e);return this.e+=Fe>=65536?2:1,Fe}eol(){return this.e>=this.d}}e.$9e=H;class fe{get offset(){return this.c.offset}constructor(Fe,qe=0){this.c=new H(Fe,qe)}nextGraphemeLength(){const Fe=de.getInstance(),qe=this.c,Le=qe.offset;let Ye=Fe.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const ce=qe.offset,ae=Fe.getGraphemeBreakType(qe.nextCodePoint());if(re(Ye,ae)){qe.setOffset(ce);break}Ye=ae}return qe.offset-Le}prevGraphemeLength(){const Fe=de.getInstance(),qe=this.c,Le=qe.offset;let Ye=Fe.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const ce=qe.offset,ae=Fe.getGraphemeBreakType(qe.prevCodePoint());if(re(ae,Ye)){qe.setOffset(ce);break}Ye=ae}return Le-qe.offset}eol(){return this.c.eol()}}e.$0e=fe;function X(Ae,Fe){return new fe(Ae,Fe).nextGraphemeLength()}e.$$e=X;function Y(Ae,Fe){return new fe(Ae,Fe).prevGraphemeLength()}e.$_e=Y;function q(Ae,Fe){Fe>0&&j(Ae.charCodeAt(Fe))&&Fe--;const qe=Fe+X(Ae,Fe);return[qe-Y(Ae,qe),qe]}e.$af=q;function x(Ae){const Fe=new fe(Ae);let qe=0;for(;!Fe.eol();)qe++,Fe.nextGraphemeLength();return qe}e.$bf=x;let me;function ue(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function pe(Ae){return me||(me=ue()),me.test(Ae)}e.$cf=pe;const G=/^[\t\n\r\x20-\x7E]*$/;function z(Ae){return G.test(Ae)}e.$df=z,e.$ef=/[\u2028\u2029]/;function K(Ae){return e.$ef.test(Ae)}e.$ff=K;function ge(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$gf=ge;function _(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$hf=_;function ie(Ae,Fe){if(Ae.length<Fe)return Ae;const qe=/\b/g;let Le=0;for(;qe.test(Ae)&&!(Ae.length-qe.lastIndex<Fe);)Le=qe.lastIndex,qe.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$if=ie;const ne=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Ee=/\x1b\].*?\x07/g;function oe(Ae){return Ae&&(Ae=Ae.replace(ne,"").replace(Ee,"")),Ae}e.$jf=oe,e.$kf=String.fromCharCode(65279);function he(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$lf=he;function ee(Ae){return he(Ae)?Ae.substr(1):Ae}e.$mf=ee;function le(Ae,Fe){if(!Ae||!Fe||Ae.length<Fe.length)return!1;const qe=Fe.length,Le=Ae.toLowerCase();let Ye=0,ce=-1;for(;Ye<qe;){const ae=Le.indexOf(Fe[Ye],ce+1);if(ae<0)return!1;ce=ae,Ye++}return!0}e.$nf=le;function be(Ae,Fe=!1){return Ae?(Fe&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$of=be;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$pf=Pe;function B(Ae,Fe=1){if(Fe===0)return"";let qe=-1;do qe=Ae.indexOf(`
`,qe+1),Fe--;while(Fe>0&&qe>=0);return qe===-1?Ae:(Ae[qe-1]==="\r"&&qe--,Ae.substr(0,qe))}e.$qf=B;function Q(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$rf=Q;function te(Ae){return de.getInstance().getGraphemeBreakType(Ae)}e.$sf=te;function re(Ae,Fe){return Ae===0?Fe!==5&&Fe!==7:Ae===2&&Fe===3?!1:Ae===4||Ae===2||Ae===3||Fe===4||Fe===2||Fe===3?!0:!(Ae===8&&(Fe===8||Fe===9||Fe===11||Fe===12)||(Ae===11||Ae===9)&&(Fe===9||Fe===10)||(Ae===12||Ae===10)&&Fe===10||Fe===5||Fe===13||Fe===7||Ae===1||Ae===13&&Fe===14||Ae===6&&Fe===6)}var Z;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Z||(e.GraphemeBreakType=Z={}));class de{static{this.c=null}static getInstance(){return de.c||(de.c=new de),de.c}constructor(){this.d=ye()}getGraphemeBreakType(Fe){if(Fe<32)return Fe===10?3:Fe===13?2:4;if(Fe<127)return 0;const qe=this.d,Le=qe.length/3;let Ye=1;for(;Ye<=Le;)if(Fe<qe[3*Ye])Ye=2*Ye;else if(Fe>qe[3*Ye+1])Ye=2*Ye+1;else return qe[3*Ye+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Fe){if(Ae===0)return 0;const qe=We(Ae,Fe);if(qe!==void 0)return qe;const Le=new H(Fe,Ae);return Le.prevCodePoint(),Le.offset}e.$tf=je;function We(Ae,Fe){const qe=new H(Fe,Ae);let Le=qe.prevCodePoint();for(;xe(Le)||Le===65039||Le===8419;){if(qe.offset===0)return;Le=qe.prevCodePoint()}if(!_(Le))return;let Ye=qe.offset;return Ye>0&&qe.prevCodePoint()===8205&&(Ye=qe.offset),Ye}function xe(Ae){return 127995<=Ae&&Ae<=127999}var Ze;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),e.$uf="\xA0";class it{static{this.c=new T.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$we(Fe=>{function qe(Xe){const rt=new Map;for(let ot=0;ot<Xe.length;ot+=2)rt.set(Xe[ot],Xe[ot+1]);return rt}function Le(Xe,rt){const ot=new Map(Xe);for(const[wt,kt]of rt)ot.set(wt,kt);return ot}function Ye(Xe,rt){if(!Xe)return rt;const ot=new Map;for(const[wt,kt]of Xe)rt.has(wt)&&ot.set(wt,kt);return ot}const ce=this.c.value;let ae=Fe.filter(Xe=>!Xe.startsWith("_")&&Xe in ce);ae.length===0&&(ae=["_default"]);let Ie;for(const Xe of ae){const rt=qe(ce[Xe]);Ie=Ye(Ie,rt)}const Ve=qe(ce._common),Ue=Le(Ve,Ie);return new it(Ue)})}static getInstance(Fe){return it.d.get(Array.from(Fe))}static{this.e=new T.$U(()=>Object.keys(it.c.value).filter(Fe=>!Fe.startsWith("_")))}static getLocales(){return it.e.value}constructor(Fe){this.f=Fe}isAmbiguous(Fe){return this.f.has(Fe)}getPrimaryConfusable(Fe){return this.f.get(Fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$vf=it;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Fe){return et.e().has(Fe)}static get codePoints(){return et.e()}}e.$wf=et}),define(De[121],Ce([1,0,28,15]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.FuzzyScore=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.or=void 0;function g(...ee){return function(le,be){for(let Pe=0,B=ee.length;Pe<B;Pe++){const Q=ee[Pe](le,be);if(Q)return Q}return null}}e.or=g,e.$Aj=L.bind(void 0,!1),e.$Bj=L.bind(void 0,!0);function L(ee,le,be){if(!be||be.length<le.length)return null;let Pe;return ee?Pe=T.$2e(be,le):Pe=be.indexOf(le)===0,Pe?le.length>0?[{start:0,end:le.length}]:[]:null}function R(ee,le){const be=le.toLowerCase().indexOf(ee.toLowerCase());return be===-1?null:[{start:be,end:be+ee.length}]}e.$Cj=R;function b(ee,le){return E(ee.toLowerCase(),le.toLowerCase(),0,0)}e.$Dj=b;function E(ee,le,be,Pe){if(be===ee.length)return[];if(Pe===le.length)return null;if(ee[be]===le[Pe]){let B=null;return(B=E(ee,le,be+1,Pe+1))?r({start:Pe,end:Pe+1},B):null}return E(ee,le,be,Pe+1)}function w(ee){return 97<=ee&&ee<=122}function A(ee){return 65<=ee&&ee<=90}e.$Ej=A;function I(ee){return 48<=ee&&ee<=57}function v(ee){return ee===32||ee===9||ee===10||ee===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>k.add(ee.charCodeAt(0)));function S(ee){return v(ee)||k.has(ee)}function p(ee,le){return ee===le||S(ee)&&S(le)}function u(ee){return w(ee)||A(ee)||I(ee)}function r(ee,le){return le.length===0?le=[ee]:ee.end===le[0].start?le[0].start=ee.start:le.unshift(ee),le}function s(ee,le){for(let be=le;be<ee.length;be++){const Pe=ee.charCodeAt(be);if(A(Pe)||I(Pe)||be>0&&!u(ee.charCodeAt(be-1)))return be}return ee.length}function a(ee,le,be,Pe){if(be===ee.length)return[];if(Pe===le.length)return null;if(ee[be]!==le[Pe].toLowerCase())return null;{let B=null,Q=Pe+1;for(B=a(ee,le,be+1,Pe+1);!B&&(Q=s(le,Q))<le.length;)B=a(ee,le,be+1,Q),Q++;return B===null?null:r({start:Pe,end:Pe+1},B)}}function m(ee){let le=0,be=0,Pe=0,B=0,Q=0;for(let ye=0;ye<ee.length;ye++)Q=ee.charCodeAt(ye),A(Q)&&le++,w(Q)&&be++,u(Q)&&Pe++,I(Q)&&B++;const te=le/ee.length,re=be/ee.length,Z=Pe/ee.length,de=B/ee.length;return{upperPercent:te,lowerPercent:re,alphaPercent:Z,numericPercent:de}}function l(ee){const{upperPercent:le,lowerPercent:be}=ee;return be===0&&le>.6}function t(ee){const{upperPercent:le,lowerPercent:be,alphaPercent:Pe,numericPercent:B}=ee;return be>.2&&le<.8&&Pe>.6&&B<.2}function n(ee){let le=0,be=0,Pe=0,B=0;for(let Q=0;Q<ee.length;Q++)Pe=ee.charCodeAt(Q),A(Pe)&&le++,w(Pe)&&be++,v(Pe)&&B++;return(le===0||be===0)&&B===0?ee.length<=30:le<=5}function o(ee,le){if(!le||(le=le.trim(),le.length===0)||!n(ee)||le.length>60)return null;const be=m(le);if(!t(be)){if(!l(be))return null;le=le.toLowerCase()}let Pe=null,B=0;for(ee=ee.toLowerCase();B<le.length&&(Pe=a(ee,le,0,B))===null;)B=s(le,B+1);return Pe}e.$Fj=o;function i(ee,le,be=!1){if(!le||le.length===0)return null;let Pe=null,B=0;for(ee=ee.toLowerCase(),le=le.toLowerCase();B<le.length&&(Pe=c(ee,le,0,B,be))===null;)B=h(le,B+1);return Pe}e.$Gj=i;function c(ee,le,be,Pe,B){if(be===ee.length)return[];if(Pe===le.length)return null;if(p(ee.charCodeAt(be),le.charCodeAt(Pe))){let Q=null,te=Pe+1;if(Q=c(ee,le,be+1,Pe+1,B),!B)for(;!Q&&(te=h(le,te))<le.length;)Q=c(ee,le,be+1,te,B),te++;return Q?ee.charCodeAt(be)!==le.charCodeAt(Pe)?Q:r({start:Pe,end:Pe+1},Q):null}else return null}function h(ee,le){for(let be=le;be<ee.length;be++)if(S(ee.charCodeAt(be))||be>0&&S(ee.charCodeAt(be-1)))return be;return ee.length}const y=g(e.$Bj,o,R),C=g(e.$Bj,o,b),$=new D.$Cc(1e4);function f(ee,le,be=!1){if(typeof ee!="string"||typeof le!="string")return null;let Pe=$.get(ee);Pe||(Pe=new RegExp(T.$Ke(ee),"i"),$.set(ee,Pe));const B=Pe.exec(le);return B?[{start:B.index,end:B.index+B[0].length}]:be?C(ee,le):y(ee,le)}e.$Hj=f;function d(ee,le){const be=ge(ee,ee.toLowerCase(),0,le,le.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?N(be):null}e.$Ij=d;function P(ee,le,be,Pe,B,Q){const te=Math.min(13,ee.length);for(;be<te;be++){const re=ge(ee,le,be,Pe,B,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return re}return[0,Q]}e.$Jj=P;function N(ee){if(typeof ee>"u")return[];const le=[],be=ee[1];for(let Pe=ee.length-1;Pe>1;Pe--){const B=ee[Pe]+be,Q=le[le.length-1];Q&&Q.end===B?Q.end=B+1:le.push({start:B,end:B+1})}return le}e.$Kj=N;const O=128;function M(){const ee=[],le=[];for(let be=0;be<=O;be++)le[be]=0;for(let be=0;be<=O;be++)ee.push(le.slice(0));return ee}function j(ee){const le=[];for(let be=0;be<=ee;be++)le[be]=0;return le}const U=j(2*O),F=j(2*O),V=M(),H=M(),fe=M(),X=!1;function Y(ee,le,be,Pe,B){function Q(re,Z,de=" "){for(;re.length<Z;)re=de+re;return re}let te=` |   |${Pe.split("").map(re=>Q(re,3)).join("|")}
`;for(let re=0;re<=be;re++)re===0?te+=" |":te+=`${le[re-1]}|`,te+=ee[re].slice(0,B+1).map(Z=>Q(Z.toString(),3)).join("|")+`
`;return te}function q(ee,le,be,Pe){ee=ee.substr(le),be=be.substr(Pe),console.log(Y(H,ee,ee.length,be,be.length)),console.log(Y(fe,ee,ee.length,be,be.length)),console.log(Y(V,ee,ee.length,be,be.length))}function x(ee,le){if(le<0||le>=ee.length)return!1;const be=ee.codePointAt(le);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$hf(be)}}function me(ee,le){if(le<0||le>=ee.length)return!1;switch(ee.charCodeAt(le)){case 32:case 9:return!0;default:return!1}}function ue(ee,le,be){return le[ee]!==be[ee]}function pe(ee,le,be,Pe,B,Q,te=!1){for(;le<be&&B<Q;)ee[le]===Pe[B]&&(te&&(U[le]=B),le+=1),B+=1;return le===be}e.$Lj=pe;var G;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(G||(G={}));var z;(function(ee){ee.Default=[-100,0];function le(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}ee.isDefault=le})(z||(e.FuzzyScore=z={}));class K{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(le,be){this.firstMatchCanBeWeak=le,this.boostFullMatch=be}}e.$Mj=K;function ge(ee,le,be,Pe,B,Q,te=K.default){const re=ee.length>O?O:ee.length,Z=Pe.length>O?O:Pe.length;if(be>=re||Q>=Z||re-be>Z-Q||!pe(le,be,re,B,Q,Z,!0))return;_(re,Z,be,Q,le,B);let de=1,ye=1,je=be,We=Q;const xe=[!1];for(de=1,je=be;je<re;de++,je++){const Fe=U[je],qe=F[je],Le=je+1<re?F[je+1]:Z;for(ye=Fe-Q+1,We=Fe;We<Le;ye++,We++){let Ye=Number.MIN_SAFE_INTEGER,ce=!1;We<=qe&&(Ye=ie(ee,le,je,be,Pe,B,We,Z,Q,V[de-1][ye-1]===0,xe));let ae=0;Ye!==Number.MAX_SAFE_INTEGER&&(ce=!0,ae=Ye+H[de-1][ye-1]);const Ie=We>Fe,Ve=Ie?H[de][ye-1]+(V[de][ye-1]>0?-5:0):0,Ue=We>Fe+1&&V[de][ye-1]>0,Xe=Ue?H[de][ye-2]+(V[de][ye-2]>0?-5:0):0;if(Ue&&(!Ie||Xe>=Ve)&&(!ce||Xe>=ae))H[de][ye]=Xe,fe[de][ye]=3,V[de][ye]=0;else if(Ie&&(!ce||Ve>=ae))H[de][ye]=Ve,fe[de][ye]=2,V[de][ye]=0;else if(ce)H[de][ye]=ae,fe[de][ye]=1,V[de][ye]=V[de-1][ye-1]+1;else throw new Error("not possible")}}if(X&&q(ee,be,Pe,Q),!xe[0]&&!te.firstMatchCanBeWeak)return;de--,ye--;const Ze=[H[de][ye],Q];let it=0,et=0;for(;de>=1;){let Fe=ye;do{const qe=fe[de][Fe];if(qe===3)Fe=Fe-2;else if(qe===2)Fe=Fe-1;else break}while(Fe>=1);it>1&&le[be+de-1]===B[Q+ye-1]&&!ue(Fe+Q-1,Pe,B)&&it+1>V[de][Fe]&&(Fe=ye),Fe===ye?it++:it=1,et||(et=Fe),de--,ye=Fe-1,Ze.push(ye)}Z===re&&te.boostFullMatch&&(Ze[0]+=2);const Ae=et-re;return Ze[0]-=Ae,Ze}e.$Nj=ge;function _(ee,le,be,Pe,B,Q){let te=ee-1,re=le-1;for(;te>=be&&re>=Pe;)B[te]===Q[re]&&(F[te]=re,te--),re--}function ie(ee,le,be,Pe,B,Q,te,re,Z,de,ye){if(le[be]!==Q[te])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return te===be-Pe?je=ee[be]===B[te]?7:5:ue(te,B,Q)&&(te===0||!ue(te-1,B,Q))?(je=ee[be]===B[te]?7:5,We=!0):x(Q,te)&&(te===0||!x(Q,te-1))?je=5:(x(Q,te-1)||me(Q,te-1))&&(je=5,We=!0),je>1&&be===Pe&&(ye[0]=!0),We||(We=ue(te,B,Q)||x(Q,te-1)||me(Q,te-1)),be===Pe?te>Z&&(je-=We?3:5):de?je+=We?2:0:je+=We?0:1,te+1===re&&(je-=We?3:5),je}function ne(ee,le,be,Pe,B,Q,te){return oe(ee,le,be,Pe,B,Q,!0,te)}e.$Oj=ne;function Ee(ee,le,be,Pe,B,Q,te){return oe(ee,le,be,Pe,B,Q,!1,te)}e.$Pj=Ee;function oe(ee,le,be,Pe,B,Q,te,re){let Z=ge(ee,le,be,Pe,B,Q,re);if(Z&&!te)return Z;if(ee.length>=3){const de=Math.min(7,ee.length-1);for(let ye=be+1;ye<de;ye++){const je=he(ee,ye);if(je){const We=ge(je,je.toLowerCase(),be,Pe,B,Q,re);We&&(We[0]-=3,(!Z||We[0]>Z[0])&&(Z=We))}}}return Z}function he(ee,le){if(le+1>=ee.length)return;const be=ee[le],Pe=ee[le+1];if(be!==Pe)return ee.slice(0,le)+Pe+be+ee.slice(le+2)}}),define(De[52],Ce([1,0,15]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=void 0;function T(r){return g(r,0)}e.$Bi=T;function g(r,s){switch(typeof r){case"object":return r===null?L(349,s):Array.isArray(r)?E(r,s):w(r,s);case"string":return b(r,s);case"boolean":return R(r,s);case"number":return L(r,s);case"undefined":return L(937,s);default:return L(617,s)}}e.$Ci=g;function L(r,s){return(s<<5)-s+r|0}e.$Di=L;function R(r,s){return L(r?433:863,s)}function b(r,s){s=L(149417,s);for(let a=0,m=r.length;a<m;a++)s=L(r.charCodeAt(a),s);return s}e.$Ei=b;function E(r,s){return s=L(104579,s),r.reduce((a,m)=>g(m,a),s)}function w(r,s){return s=L(181387,s),Object.keys(r).sort().reduce((a,m)=>(a=b(m,a),g(r[m],a)),s)}class A{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=g(s,this.g),this.g}}e.$Fi=A;var I;(function(r){r[r.BLOCK_SIZE=64]="BLOCK_SIZE",r[r.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function v(r,s,a=32){const m=a-s,l=~((1<<m)-1);return(r<<s|(l&r)>>>m)>>>0}function k(r,s=0,a=r.byteLength,m=0){for(let l=0;l<a;l++)r[s+l]=m}function S(r,s,a="0"){for(;r.length<s;)r=a+r;return r}function p(r,s=32){return r instanceof ArrayBuffer?Array.from(new Uint8Array(r)).map(a=>a.toString(16).padStart(2,"0")).join(""):S((r>>>0).toString(16),s/4)}e.$Gi=p;class u{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const a=s.length;if(a===0)return;const m=this.p;let l=this.r,t=this.u,n,o;for(t!==0?(n=t,o=-1,t=0):(n=s.charCodeAt(0),o=0);;){let i=n;if(D.$5e(n))if(o+1<a){const c=s.charCodeAt(o+1);D.$6e(c)?(o++,i=D.$7e(n,c)):i=65533}else{t=n;break}else D.$6e(n)&&(i=65533);if(l=this.w(m,l,i),o++,o<a)n=s.charCodeAt(o);else break}this.r=l,this.u=t}w(s,a,m){return m<128?s[a++]=m:m<2048?(s[a++]=192|(m&1984)>>>6,s[a++]=128|(m&63)>>>0):m<65536?(s[a++]=224|(m&61440)>>>12,s[a++]=128|(m&4032)>>>6,s[a++]=128|(m&63)>>>0):(s[a++]=240|(m&1835008)>>>18,s[a++]=128|(m&258048)>>>12,s[a++]=128|(m&4032)>>>6,s[a++]=128|(m&63)>>>0),a>=64&&(this.y(),a-=64,this.t+=64,s[0]=s[64+0],s[1]=s[64+1],s[2]=s[64+2]),a}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=u.g,a=this.q;for(let y=0;y<64;y+=4)s.setUint32(y,a.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)s.setUint32(y,v(s.getUint32(y-12,!1)^s.getUint32(y-32,!1)^s.getUint32(y-56,!1)^s.getUint32(y-64,!1),1),!1);let m=this.h,l=this.l,t=this.m,n=this.n,o=this.o,i,c,h;for(let y=0;y<80;y++)y<20?(i=l&t|~l&n,c=1518500249):y<40?(i=l^t^n,c=1859775393):y<60?(i=l&t|l&n|t&n,c=2400959708):(i=l^t^n,c=3395469782),h=v(m,5)+i+o+c+s.getUint32(y*4,!1)&4294967295,o=n,n=t,t=v(l,30),l=m,m=h;this.h=this.h+m&4294967295,this.l=this.l+l&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+o&4294967295}}e.$Hi=u}),define(De[38],Ce([1,0,15]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(T||(T={})),function(g){const L="error",R="warning",b="warn",E="info",w="ignore";function A(v){return v?D.$1e(L,v)?g.Error:D.$1e(R,v)||D.$1e(b,v)?g.Warning:D.$1e(E,v)?g.Info:g.Ignore:g.Ignore}g.fromValue=A;function I(v){switch(v){case g.Error:return L;case g.Warning:return R;case g.Info:return E;default:return w}}g.toString=I}(T||(T={})),e.default=T}),define(De[160],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Jd=Symbol("MicrotaskDelay")}),define(De[77],Ce([1,0,19,15]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class g{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const S=k.charCodeAt(0),p=this.b.charCodeAt(this.c);return S-p}value(){return this.b[this.c]}}e.$Ph=g;class L{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,T.$Ue)(k,this.b,0,k.length,this.c,this.d):(0,T.$We)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Qh=L;class R{constructor(k=!0,S=!0){this.f=k,this.g=S}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let S=k.length-1;S>=0;S--,this.c--){const p=this.b.charCodeAt(S);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,T.$Ue)(k,this.b,0,k.length,this.d,this.e):(0,T.$We)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Rh=R;var b;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(b||(b={}));class E{constructor(k,S){this.f=k,this.g=S,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,T.$Ve)(k,this.c.scheme);if(this.d[this.e]===2)return(0,T.$Ve)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,T.$Te)(k,this.c.query);if(this.d[this.e]===5)return(0,T.$Te)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Sh=E;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(A||(A={}));class I{static forUris(k=()=>!1,S=()=>!1){return new I(new E(k,S))}static forPaths(k=!1){return new I(new R(void 0,!k))}static forStrings(){return new I(new g)}static forConfigKeys(){return new I(new L)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,S){if(S){const p=S.slice(0);(0,D.$Wb)(p);for(const u of p)this.set(u,k)}else{const p=k.slice(0);(0,D.$Wb)(p);for(const u of p)this.set(u[0],u[1])}}set(k,S){const p=this.b.reset(k);let u;this.c||(this.c=new w,this.c.segment=p.value());const r=[];for(u=this.c;;){const a=p.cmp(u.segment);if(a>0)u.left||(u.left=new w,u.left.segment=p.value()),r.push([-1,u]),u=u.left;else if(a<0)u.right||(u.right=new w,u.right.segment=p.value()),r.push([1,u]),u=u.right;else if(p.hasNext())p.next(),u.mid||(u.mid=new w,u.mid.segment=p.value()),r.push([0,u]),u=u.mid;else break}const s=u.value;u.value=S,u.key=k;for(let a=r.length-1;a>=0;a--){const m=r[a][1];m.updateHeight();const l=m.balanceFactor();if(l<-1||l>1){const t=r[a][0],n=r[a+1][0];if(t===1&&n===1)r[a][1]=m.rotateLeft();else if(t===-1&&n===-1)r[a][1]=m.rotateRight();else if(t===1&&n===-1)m.right=r[a+1][1]=r[a+1][1].rotateRight(),r[a][1]=m.rotateLeft();else if(t===-1&&n===1)m.left=r[a+1][1]=r[a+1][1].rotateLeft(),r[a][1]=m.rotateRight();else throw new Error;if(a>0)switch(r[a-1][0]){case-1:r[a-1][1].left=r[a][1];break;case 1:r[a-1][1].right=r[a][1];break;case 0:r[a-1][1].mid=r[a][1];break}else this.c=r[0][1]}}return s}get(k){return this.d(k)?.value}d(k){const S=this.b.reset(k);let p=this.c;for(;p;){const u=S.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(S.hasNext())S.next(),p=p.mid;else break}return p}has(k){const S=this.d(k);return!(S?.value===void 0&&S?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,S){const p=this.b.reset(k),u=[];let r=this.c;for(;r;){const s=p.cmp(r.segment);if(s>0)u.push([-1,r]),r=r.left;else if(s<0)u.push([1,r]),r=r.right;else if(p.hasNext())p.next(),u.push([0,r]),r=r.mid;else break}if(r){if(S?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const s=this.f(r.right);if(s.key){const{key:a,value:m,segment:l}=s;this.e(s.key,!1),r.key=a,r.value=m,r.segment=l}}else{const s=r.left??r.right;if(u.length>0){const[a,m]=u[u.length-1];switch(a){case-1:m.left=s;break;case 0:m.mid=s;break;case 1:m.right=s;break}}else this.c=s}for(let s=u.length-1;s>=0;s--){const a=u[s][1];a.updateHeight();const m=a.balanceFactor();if(m>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),u[s][1]=a.rotateLeft()):m<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),u[s][1]=a.rotateRight()),s>0)switch(u[s-1][0]){case-1:u[s-1][1].left=u[s][1];break;case 1:u[s-1][1].right=u[s][1];break;case 0:u[s-1][1].mid=u[s][1];break}else this.c=u[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const S=this.b.reset(k);let p=this.c,u;for(;p;){const r=S.cmp(p.segment);if(r>0)p=p.left;else if(r<0)p=p.right;else if(S.hasNext())S.next(),u=p.value||u,p=p.mid;else break}return p&&p.value||u}findSuperstr(k){return this.g(k,!1)}g(k,S){const p=this.b.reset(k);let u=this.c;for(;u;){const r=p.cmp(u.segment);if(r>0)u=u.left;else if(r<0)u=u.right;else if(p.hasNext())p.next(),u=u.mid;else return u.mid?this.h(u.mid):S?u.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[S,p]of this)k(p,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const S=[];return this.j(k,S),S[Symbol.iterator]()}j(k,S){k&&(k.left&&this.j(k.left,S),k.value&&S.push([k.key,k.value]),k.mid&&this.j(k.mid,S),k.right&&this.j(k.right,S))}_isBalanced(){const k=S=>{if(!S)return!0;const p=S.balanceFactor();return p<-1||p>1?!1:k(S.left)&&k(S.right)};return k(this.c)}}e.$Th=I}),define(De[18],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=void 0;function D(l){return typeof l=="string"}e.$xf=D;function T(l){return Array.isArray(l)&&l.every(t=>D(t))}e.$yf=T;function g(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.$zf=g;function L(l){const t=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof t}e.$Af=L;function R(l){return typeof l=="number"&&!isNaN(l)}e.$Bf=R;function b(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.$Cf=b;function E(l){return l===!0||l===!1}e.$Df=E;function w(l){return typeof l>"u"}e.$Ef=w;function A(l){return!I(l)}e.$Ff=A;function I(l){return w(l)||l===null}e.$Gf=I;function v(l,t){if(!l)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Hf=v;function k(l){if(I(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.$If=k;function S(...l){const t=[];for(let n=0;n<l.length;n++){const o=l[n];if(I(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(o)}return t}e.$Jf=S;const p=Object.prototype.hasOwnProperty;function u(l){if(!g(l))return!1;for(const t in l)if(p.call(l,t))return!1;return!0}e.$Kf=u;function r(l){return typeof l=="function"}e.$Lf=r;function s(...l){return l.length>0&&l.every(r)}e.$Mf=s;function a(l,t){const n=Math.min(l.length,t.length);for(let o=0;o<n;o++)m(l[o],t[o])}e.$Nf=a;function m(l,t){if(D(t)){if(typeof l!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(r(t)){try{if(l instanceof t)return}catch{}if(!I(l)&&l.constructor===t||t.length===1&&t.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Of=m}),define(De[78],Ce([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=void 0;const T=Object.create(null);function g(b,E){if((0,D.$xf)(E)){const w=T[E];if(w===void 0)throw new Error(`${b} references an unknown codicon: ${E}`);E=w}return T[b]=E,{id:b}}function L(){return T}e.$Qj=L;function R(){return Object.values(e.$Sj)}e.$Rj=R,e.$Sj={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(De[23],Ce([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=void 0;function T(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const s=Array.isArray(r)?[]:{};return Object.entries(r).forEach(([a,m])=>{s[a]=m&&typeof m=="object"?T(m):m}),s}e.$Ym=T;function g(r){if(!r||typeof r!="object")return r;const s=[r];for(;s.length>0;){const a=s.shift();Object.freeze(a);for(const m in a)if(L.call(a,m)){const l=a[m];typeof l=="object"&&!Object.isFrozen(l)&&!(0,D.$Af)(l)&&s.push(l)}}return r}e.$Zm=g;const L=Object.prototype.hasOwnProperty;function R(r,s){return b(r,s,new Set)}e.$1m=R;function b(r,s,a){if((0,D.$Gf)(r))return r;const m=s(r);if(typeof m<"u")return m;if(Array.isArray(r)){const l=[];for(const t of r)l.push(b(t,s,a));return l}if((0,D.$zf)(r)){if(a.has(r))throw new Error("Cannot clone recursive data-structure");a.add(r);const l={};for(const t in r)L.call(r,t)&&(l[t]=b(r[t],s,a));return a.delete(r),l}return r}function E(r,s,a=!0){return(0,D.$zf)(r)?((0,D.$zf)(s)&&Object.keys(s).forEach(m=>{m in r?a&&((0,D.$zf)(r[m])&&(0,D.$zf)(s[m])?E(r[m],s[m],a):r[m]=s[m]):r[m]=s[m]}),r):s}e.$2m=E;function w(r,s){if(r===s)return!0;if(r==null||s===null||s===void 0||typeof r!=typeof s||typeof r!="object"||Array.isArray(r)!==Array.isArray(s))return!1;let a,m;if(Array.isArray(r)){if(r.length!==s.length)return!1;for(a=0;a<r.length;a++)if(!w(r[a],s[a]))return!1}else{const l=[];for(m in r)l.push(m);l.sort();const t=[];for(m in s)t.push(m);if(t.sort(),!w(l,t))return!1;for(a=0;a<l.length;a++)if(!w(r[l[a]],s[l[a]]))return!1}return!0}e.$3m=w;function A(r){const s=new Set;return JSON.stringify(r,(a,m)=>{if((0,D.$zf)(m)||Array.isArray(m)){if(s.has(m))return"[Circular]";s.add(m)}return m})}e.$4m=A;function I(r,s){const a=Object.create(null);return!r||!s||Object.keys(s).forEach(l=>{const t=r[l],n=s[l];w(t,n)||(a[l]=n)}),a}e.$5m=I;function v(r,s){const a=s.toLowerCase(),m=Object.keys(r).find(l=>l.toLowerCase()===a);return m?r[m]:r[s]}e.$6m=v;function k(r,s){const a=Object.create(null);for(const[m,l]of Object.entries(r))s(m,l)&&(a[m]=l);return a}e.$7m=k;function S(r){let s=[];for(;Object.prototype!==r;)s=s.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return s}e.$8m=S;function p(r){const s=[];for(const a of S(r))typeof r[a]=="function"&&s.push(a);return s}e.$9m=p;function u(r,s){const a=l=>function(){const t=Array.prototype.slice.call(arguments,0);return s(l,t)},m={};for(const l of r)m[l]=a(l);return m}e.$0m=u}),define(De[59],Ce([1,0,78]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Tj=e.ThemeColor=void 0;var T;(function(R){function b(E){return E&&typeof E=="object"&&typeof E.id=="string"}R.isThemeColor=b})(T||(e.ThemeColor=T={}));function g(R){return{id:R}}e.$Tj=g;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function E(s){const a=b.exec(s.id);if(!a)return E(D.$Sj.error);const[,m,l]=a,t=["codicon","codicon-"+m];return l&&t.push("codicon-modifier-"+l.substring(1)),t}R.asClassNameArray=E;function w(s){return E(s).join(" ")}R.asClassName=w;function A(s){return"."+E(s).join(".")}R.asCSSSelector=A;function I(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||T.isThemeColor(s.color))}R.isThemeIcon=I;const v=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function k(s){const a=v.exec(s);if(!a)return;const[,m]=a;return{id:m}}R.fromString=k;function S(s){return{id:s}}R.fromId=S;function p(s,a){let m=s.id;const l=m.lastIndexOf("~");return l!==-1&&(m=m.substring(0,l)),a&&(m=`${m}~${a}`),{id:m}}R.modify=p;function u(s){const a=s.id.lastIndexOf("~");if(a!==-1)return s.id.substring(a+1)}R.getModifier=u;function r(s,a){return s.id===a.id&&s.color?.id===a.color?.id}R.isEqual=r})(L||(e.ThemeIcon=L={}))}),define(De[161],Ce([1,0,121,15,59]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=void 0;const L="$(",R=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${R.source}`,"g");function E(r){return r.replace(b,(s,a)=>a?s:`\\${s}`)}e.$Uj=E;const w=new RegExp(`\\\\${R.source}`,"g");function A(r){return r.replace(w,s=>`\\${s}`)}e.$Vj=A;const I=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function v(r){return r.indexOf(L)===-1?r:r.replace(I,(s,a,m,l)=>m?s:a||l||"")}e.$Wj=v;function k(r){return r?r.replace(/\$\((.*?)\)/g,(s,a)=>` ${a} `).trim():""}e.$Xj=k;const S=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(r){S.lastIndex=0;let s="";const a=[];let m=0;for(;;){const l=S.lastIndex,t=S.exec(r),n=r.substring(l,t?.index);if(n.length>0){s+=n;for(let o=0;o<n.length;o++)a.push(m)}if(!t)break;m+=t[0].length}return{text:s,iconOffsets:a}}e.$Yj=p;function u(r,s,a=!1){const{text:m,iconOffsets:l}=s;if(!l||l.length===0)return(0,D.$Hj)(r,m,a);const t=(0,T.$Ie)(m," "),n=m.length-t.length,o=(0,D.$Hj)(r,t,a);if(o)for(const i of o){const c=l[i.start+n]+n;i.start+=c,i.end+=c}return o}e.$Zj=u}),define(De[122],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.Constants=void 0;var D;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function T(L){return L<0?0:L>255?255:L|0}e.$ye=T;function g(L){return L<0?0:L>4294967295?4294967295:L|0}e.$ze=g}),define(De[31],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(g){return D.test(g)}e.$cg=T,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(b){for(let E=0;E<b.length;E++)b[E]=Math.floor(Math.random()*256);return b};const L=new Uint8Array(16),R=[];for(let b=0;b<256;b++)R.push(b.toString(16).padStart(2,"0"));return function(){g(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,w="";return w+=R[L[E++]],w+=R[L[E++]],w+=R[L[E++]],w+=R[L[E++]],w+="-",w+=R[L[E++]],w+=R[L[E++]],w+="-",w+=R[L[E++]],w+=R[L[E++]],w+="-",w+=R[L[E++]],w+=R[L[E++]],w+="-",w+=R[L[E++]],w+=R[L[E++]],w+=R[L[E++]],w+=R[L[E++]],w+=R[L[E++]],w+=R[L[E++]],w}}()}),define(De[162],Ce([1,0,19,50,31]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.$Vs=e.$Us=e.$Ts=e.$Ss=void 0;function L(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$Ss=L;function R(I,v,k){const S={id:(0,g.$dg)(),name:I,uri:v,data:k};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$Ts=R;class b{constructor(){this.a=new Map}get size(){let v=0;for(const k of this.a)v++;return v}has(v){return this.a.has(this.b(v))}matches(v){const k=[...this.a.keys()];return T.Iterable.some(this,([S,p])=>p.asFile())&&k.push("files"),A(E(v),k)}get(v){return this.a.get(this.b(v))?.[0]}append(v,k){const S=this.a.get(v);S?S.push(k):this.a.set(this.b(v),[k])}replace(v,k){this.a.set(this.b(v),[k])}delete(v){this.a.delete(this.b(v))}*[Symbol.iterator](){for(const[v,k]of this.a)for(const S of k)yield[v,S]}b(v){return E(v)}}e.$Us=b;function E(I){return I.toLowerCase()}function w(I,v){return A(E(I),v.map(E))}e.$Vs=w;function A(I,v){if(I==="*/*")return v.length>0;if(v.includes(I))return!0;const k=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[S,p,u]=k;return u==="*"?v.some(r=>r.startsWith(p+"/")):!1}e.$Ws=Object.freeze({create:I=>(0,D.$Lb)(I.map(v=>v.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Ws.split(I).filter(v=>!v.startsWith("#"))})}),define(De[163],Ce([1,0,60]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.$gg=e.$fg=void 0;function T(b,E,w,A=1){let I=!1;return new Promise(v=>{const k=setTimeout(()=>{if(!I)return I=!0,v(0)},w);g(b,E,A,S=>{if(!I)return I=!0,clearTimeout(k),v(S)})})}e.$fg=T;function g(b,E,w,A){if(E===0)return A(0);const I=new D.Socket;I.once("connect",()=>(R(I),g(b+w,E-1,w,A))),I.once("data",()=>{}),I.once("error",v=>(R(I),v.code!=="ECONNREFUSED"?g(b+w,E-1,w,A):A(b))),I.connect(b,"127.0.0.1")}e.$gg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(b,E,w,A="127.0.0.1"){let I=!1,v,k=1;const S=D.createServer({pauseOnConnect:!0});function p(u,r){I||(I=!0,S.removeAllListeners(),S.close(),v&&clearTimeout(v),r(u))}return new Promise(u=>{v=setTimeout(()=>{p(0,u)},w),S.on("listening",()=>{p(b,u)}),S.on("error",r=>{r&&(r.code==="EADDRINUSE"||r.code==="EACCES")&&k<E?(b++,k++,S.listen(b,A)):p(0,u)}),S.on("close",()=>{p(0,u)}),S.listen(b,A)})}e.$hg=L;function R(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(E){console.error(E)}}}),define(De[123],Ce([1,0,122]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=e.$Ks=void 0;class T{constructor(b){const E=(0,D.$ye)(b);this.c=E,this.a=T.d(E),this.b=new Map}static d(b){const E=new Uint8Array(256);return E.fill(b),E}set(b,E){const w=(0,D.$ye)(E);b>=0&&b<256?this.a[b]=w:this.b.set(b,w)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Ks=T;var g;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(g||(g={}));class L{constructor(){this.a=new T(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$Ls=L}),define(De[61],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=void 0;class D{constructor(g,L){this.lineNumber=g,this.column=L}with(g=this.lineNumber,L=this.column){return g===this.lineNumber&&L===this.column?this:new D(g,L)}delta(g=0,L=0){return this.with(this.lineNumber+g,this.column+L)}equals(g){return D.equals(this,g)}static equals(g,L){return!g&&!L?!0:!!g&&!!L&&g.lineNumber===L.lineNumber&&g.column===L.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,L){return g.lineNumber<L.lineNumber?!0:L.lineNumber<g.lineNumber?!1:g.column<L.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,L){return g.lineNumber<L.lineNumber?!0:L.lineNumber<g.lineNumber?!1:g.column<=L.column}static compare(g,L){const R=g.lineNumber|0,b=L.lineNumber|0;if(R===b){const E=g.column|0,w=L.column|0;return E-w}return R-b}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}}e.$ms=D}),define(De[34],Ce([1,0,61]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0;class T{constructor(L,R,b,E){L>b||L===b&&R>E?(this.startLineNumber=b,this.startColumn=E,this.endLineNumber=L,this.endColumn=R):(this.startLineNumber=L,this.startColumn=R,this.endLineNumber=b,this.endColumn=E)}isEmpty(){return T.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return T.containsPosition(this,L)}static containsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<L.startColumn||R.lineNumber===L.endLineNumber&&R.column>L.endColumn)}static strictContainsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<=L.startColumn||R.lineNumber===L.endLineNumber&&R.column>=L.endColumn)}containsRange(L){return T.containsRange(this,L)}static containsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>L.endColumn)}strictContainsRange(L){return T.strictContainsRange(this,L)}static strictContainsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<=L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>=L.endColumn)}plusRange(L){return T.plusRange(this,L)}static plusRange(L,R){let b,E,w,A;return R.startLineNumber<L.startLineNumber?(b=R.startLineNumber,E=R.startColumn):R.startLineNumber===L.startLineNumber?(b=R.startLineNumber,E=Math.min(R.startColumn,L.startColumn)):(b=L.startLineNumber,E=L.startColumn),R.endLineNumber>L.endLineNumber?(w=R.endLineNumber,A=R.endColumn):R.endLineNumber===L.endLineNumber?(w=R.endLineNumber,A=Math.max(R.endColumn,L.endColumn)):(w=L.endLineNumber,A=L.endColumn),new T(b,E,w,A)}intersectRanges(L){return T.intersectRanges(this,L)}static intersectRanges(L,R){let b=L.startLineNumber,E=L.startColumn,w=L.endLineNumber,A=L.endColumn;const I=R.startLineNumber,v=R.startColumn,k=R.endLineNumber,S=R.endColumn;return b<I?(b=I,E=v):b===I&&(E=Math.max(E,v)),w>k?(w=k,A=S):w===k&&(A=Math.min(A,S)),b>w||b===w&&E>A?null:new T(b,E,w,A)}equalsRange(L){return T.equalsRange(this,L)}static equalsRange(L,R){return!L&&!R?!0:!!L&&!!R&&L.startLineNumber===R.startLineNumber&&L.startColumn===R.startColumn&&L.endLineNumber===R.endLineNumber&&L.endColumn===R.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(L){return new D.$ms(L.endLineNumber,L.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(L){return new D.$ms(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,R){return new T(this.startLineNumber,this.startColumn,L,R)}setStartPosition(L,R){return new T(L,R,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(L){return new T(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(L){return new T(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new T(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,R=L){return new T(L.lineNumber,L.column,R.lineNumber,R.column)}static lift(L){return L?new T(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn)}static areIntersecting(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,R){if(L&&R){const w=L.startLineNumber|0,A=R.startLineNumber|0;if(w===A){const I=L.startColumn|0,v=R.startColumn|0;if(I===v){const k=L.endLineNumber|0,S=R.endLineNumber|0;if(k===S){const p=L.endColumn|0,u=R.endColumn|0;return p-u}return k-S}return I-v}return w-A}return(L?1:0)-(R?1:0)}static compareRangesUsingEnds(L,R){return L.endLineNumber===R.endLineNumber?L.endColumn===R.endColumn?L.startLineNumber===R.startLineNumber?L.startColumn-R.startColumn:L.startLineNumber-R.startLineNumber:L.endColumn-R.endColumn:L.endLineNumber-R.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$ns=T}),define(De[164],Ce([1,0,34]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=void 0;class T{static insert(L,R){return{range:new D.$ns(L.lineNumber,L.column,L.lineNumber,L.column),text:R,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,R){return{range:L,text:R}}static replaceMove(L,R){return{range:L,text:R,forceMoveMarkers:!0}}}e.$os=T}),define(De[165],Ce([1,0,61,34]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.SelectionDirection=void 0;var g;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class L extends T.$ns{constructor(b,E,w,A){super(b,E,w,A),this.selectionStartLineNumber=b,this.selectionStartColumn=E,this.positionLineNumber=w,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return L.selectionsEqual(this,b)}static selectionsEqual(b,E){return b.selectionStartLineNumber===E.selectionStartLineNumber&&b.selectionStartColumn===E.selectionStartColumn&&b.positionLineNumber===E.positionLineNumber&&b.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,E){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,b,E):new L(b,E,this.startLineNumber,this.startColumn)}getPosition(){return new D.$ms(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$ms(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,E){return this.getDirection()===0?new L(b,E,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,b,E)}static fromPositions(b,E=b){return new L(b.lineNumber,b.column,E.lineNumber,E.column)}static fromRange(b,E){return E===0?new L(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new L(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new L(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,E){if(b&&!E||!b&&E)return!1;if(!b&&!E)return!0;if(b.length!==E.length)return!1;for(let w=0,A=b.length;w<A;w++)if(!this.selectionsEqual(b[w],E[w]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,E,w,A,I){return I===0?new L(b,E,w,A):new L(w,A,b,E)}}e.$ps=L}),define(De[166],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=void 0,e.$Xr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[167],Ce([1,0,123]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=e.$Ms=e.WordCharacterClass=void 0;var T;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class g extends D.$Ks{constructor(b){super(0);for(let E=0,w=b.length;E<w;E++)this.set(b.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Ms=g;function L(R){const b={};return E=>(b.hasOwnProperty(E)||(b[E]=R(E)),b[E])}e.$Ns=L(R=>new g(R))}),define(De[124],Ce([1,0,50,3,75]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=e.$2r=e.$1r=e.$Zr=e.$Yr=void 0,e.$Yr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(I=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.$Yr)I.indexOf(k)>=0||(v+="\\"+k);return v+="\\s]+)",new RegExp(v,"g")}e.$Zr=L();function R(I){let v=e.$Zr;if(I&&I instanceof RegExp)if(I.global)v=I;else{let k="g";I.ignoreCase&&(k+="i"),I.multiline&&(k+="m"),I.unicode&&(k+="u"),v=new RegExp(I.source,k)}return v.lastIndex=0,v}e.$1r=R;const b=new g.$1c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(I){const v=b.unshift(I);return(0,T.$Pc)(v)}e.$2r=E;function w(I,v,k,S,p){if(p||(p=D.Iterable.first(b)),k.length>p.maxLen){let m=I-p.maxLen/2;return m<0?m=0:S+=m,k=k.substring(m,I+p.maxLen/2),w(I,v,k,S,p)}const u=Date.now(),r=I-1-S;let s=-1,a=null;for(let m=1;!(Date.now()-u>=p.timeBudget);m++){const l=r-p.windowSize*m;v.lastIndex=Math.max(0,l);const t=A(v,k,r,s);if(!t&&a||(a=t,l<=0))break;s=l}if(a){const m={word:a[0],startColumn:S+1+a.index,endColumn:S+1+a.index+a[0].length};return v.lastIndex=0,m}return null}e.$3r=w;function A(I,v,k,S){let p;for(;p=I.exec(v);){const u=p.index||0;if(u<=k&&I.lastIndex>=k)return p;if(S>0&&u>S)return null}return null}}),define(De[168],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=e.$jt=e.IndentAction=void 0;var D;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class T{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let E=0,w=b.notIn.length;E<w;E++)switch(b.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,E){if(b.getTokenCount()===0)return!0;const w=b.findTokenIndexAtOffset(E-2),A=b.getStandardTokenType(w);return this.isOK(A)}g(b,E){for(let w=b;w<=E;w++){const A=String.fromCharCode(w);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$jt=T;class g{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of b)L(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),L(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),L(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),L(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&L(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$kt=g;function L(R,b,E){R.has(b)?R.get(b).push(E):R.set(b,[E])}}),define(De[169],Ce([1,0,123]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PY=e.$OY=e.$NY=e.State=void 0;var T;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class g{constructor(S,p,u){const r=new Uint8Array(S*p);for(let s=0,a=S*p;s<a;s++)r[s]=u;this.a=r,this.rows=S,this.cols=p}get(S,p){return this.a[S*this.cols+p]}set(S,p,u){this.a[S*this.cols+p]=u}}class L{constructor(S){let p=0,u=0;for(let s=0,a=S.length;s<a;s++){const[m,l,t]=S[s];l>p&&(p=l),m>u&&(u=m),t>u&&(u=t)}p++,u++;const r=new g(u,p,0);for(let s=0,a=S.length;s<a;s++){const[m,l,t]=S[s];r.set(m,l,t)}this.a=r,this.b=p}nextState(S,p){return p<0||p>=this.b?0:this.a.get(S,p)}}e.$NY=L;let R=null;function b(){return R===null&&(R=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var E;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let w=null;function A(){if(w===null){w=new D.$Ks(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<k.length;p++)w.set(k.charCodeAt(p),1);const S=".,;:";for(let p=0;p<S.length;p++)w.set(S.charCodeAt(p),2)}return w}class I{static a(S,p,u,r,s){let a=s-1;do{const m=p.charCodeAt(a);if(S.get(m)!==2)break;a--}while(a>r);if(r>0){const m=p.charCodeAt(r-1),l=p.charCodeAt(a);(m===40&&l===41||m===91&&l===93||m===123&&l===125)&&a--}return{range:{startLineNumber:u,startColumn:r+1,endLineNumber:u,endColumn:a+2},url:p.substring(r,a+1)}}static computeLinks(S,p=b()){const u=A(),r=[];for(let s=1,a=S.getLineCount();s<=a;s++){const m=S.getLineContent(s),l=m.length;let t=0,n=0,o=0,i=1,c=!1,h=!1,y=!1,C=!1;for(;t<l;){let $=!1;const f=m.charCodeAt(t);if(i===13){let d;switch(f){case 40:c=!0,d=0;break;case 41:d=c?0:1;break;case 91:y=!0,h=!0,d=0;break;case 93:y=!1,d=h?0:1;break;case 123:C=!0,d=0;break;case 125:d=C?0:1;break;case 39:case 34:case 96:o===f?d=1:o===39||o===34||o===96?d=0:d=1;break;case 42:d=o===42?1:0;break;case 124:d=o===124?1:0;break;case 32:d=y?0:1;break;default:d=u.get(f)}d===1&&(r.push(I.a(u,m,s,n,t)),$=!0)}else if(i===12){let d;f===91?(h=!0,d=0):d=u.get(f),d===1?$=!0:i=13}else i=p.nextState(i,f),i===0&&($=!0);$&&(i=1,c=!1,h=!1,C=!1,n=t+1,o=f),t++}i===13&&r.push(I.a(u,m,s,n,l))}return r}}e.$OY=I;function v(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:I.computeLinks(k)}e.$PY=v}),define(De[125],Ce([1,0,23]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ju=e.$Iu=e.$Hu=e.$Gu=e.ModelConstants=e.PositionAffinity=e.$Fu=e.TrackedRangeStickiness=e.$Eu=e.$Du=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var g;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(g||(e.GlyphMarginLane=g={}));var L;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var R;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var b;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var E;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var w;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(w||(e.EndOfLineSequence=w={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),l.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,l.indentSize|0),this.a=!1),this.insertSpaces=!!l.insertSpaces,this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=!!l.trimAutoWhitespace,this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.a===l.a&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,D.$3m)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.$Du=A;class I{constructor(l,t){this._findMatchBrand=void 0,this.range=l,this.matches=t}}e.$Eu=I;var v;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(v||(e.TrackedRangeStickiness=v={}));function k(m){return m&&typeof m.read=="function"}e.$Fu=k;var S;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var p;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(p||(e.ModelConstants=p={}));class u{constructor(l,t,n,o,i,c){this.identifier=l,this.range=t,this.text=n,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=i,this._isTracked=c}}e.$Gu=u;class r{constructor(l,t,n){this.regex=l,this.wordSeparators=t,this.simpleSearch=n}}e.$Hu=r;class s{constructor(l,t,n){this.reverseEdits=l,this.changes=t,this.trimAutoWhitespaceLineNumbers=n}}e.$Iu=s;function a(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.$Ju=a}),define(De[170],Ce([1,0,19,122]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ou=e.$Nu=e.$Mu=void 0;class g{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,w){E=(0,T.$ze)(E);const A=this.a,I=this.b,v=w.length;return v===0?!1:(this.a=new Uint32Array(A.length+v),this.a.set(A.subarray(0,E),0),this.a.set(A.subarray(E),E+v),this.a.set(w,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(E,w){return E=(0,T.$ze)(E),w=(0,T.$ze)(w),this.a[E]===w?!1:(this.a[E]=w,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,w){E=(0,T.$ze)(E),w=(0,T.$ze)(w);const A=this.a,I=this.b;if(E>=A.length)return!1;const v=A.length-E;return w>=v&&(w=v),w===0?!1:(this.a=new Uint32Array(A.length-w),this.a.set(A.subarray(0,E),0),this.a.set(A.subarray(E+w),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,T.$ze)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let w=this.c[0]+1;w===0&&(this.b[0]=this.a[0],w++),E>=this.a.length&&(E=this.a.length-1);for(let A=w;A<=E;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let w=0,A=this.a.length-1,I=0,v=0,k=0;for(;w<=A;)if(I=w+(A-w)/2|0,v=this.b[I],k=v-this.a[I],E<k)A=I-1;else if(E>=v)w=I+1;else break;return new R(I,E-k)}}e.$Mu=g;class L{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const w=this.e[E],A=w>0?this.d[w-1]:0;return new R(w,E-A)}removeValues(E,w){this.a.splice(E,w),this.f(E)}insertValues(E,w){this.a=(0,D.$Vb)(this.a,E,w),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,w=this.a.length;E<w;E++){const A=this.a[E],I=E>0?this.d[E-1]:0;this.d[E]=I+A;for(let v=0;v<A;v++)this.e[I+v]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,w){this.a[E]!==w&&(this.a[E]=w,this.f(E))}}e.$Nu=L;class R{constructor(E,w){this.index=E,this.remainder=w,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=w}}e.$Ou=R}),define(De[171],Ce([1,0,15,61,170]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pu=void 0;class L{constructor(b,E,w,A){this.d=b,this.f=E,this.g=w,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const E=b.changes;for(const w of E)this.o(w.range),this.p(new T.$ms(w.range.startLineNumber,w.range.startColumn),w.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,E=this.f.length,w=new Uint32Array(E);for(let A=0;A<E;A++)w[A]=this.f[A].length+b;this.j=new g.$Mu(w)}}n(b,E){this.f[b]=E,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,E){if(E.length===0)return;const w=(0,D.$Oe)(E);if(w.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+w[0]+this.f[b.lineNumber-1].substring(b.column-1));return}w[w.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+w[0]);const A=new Uint32Array(w.length-1);for(let I=1;I<w.length;I++)this.f.splice(b.lineNumber+I-1,0,w[I]),A[I-1]=w[I].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$Pu=L}),define(De[172],Ce([1,0,15,167,61,34,125]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rB=e.$qB=e.$pB=e.$oB=e.$nB=e.$mB=void 0;const b=999;class E{constructor(s,a,m,l){this.searchString=s,this.isRegex=a,this.matchCase=m,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=w(this.searchString):s=this.searchString.indexOf(`
`)>=0;let a=null;try{a=D.$Me(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch{return null}if(!a)return null;let m=!this.isRegex&&!s;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new R.$Hu(a,this.wordSeparators?(0,T.$Ns)(this.wordSeparators):null,m?this.searchString:null)}}e.$mB=E;function w(r){if(!r||r.length===0)return!1;for(let s=0,a=r.length;s<a;s++){const m=r.charCodeAt(s);if(m===10)return!0;if(m===92){if(s++,s>=a)break;const l=r.charCodeAt(s);if(l===110||l===114||l===87)return!0}}return!1}e.$nB=w;function A(r,s,a){if(!a)return new R.$Eu(r,null);const m=[];for(let l=0,t=s.length;l<t;l++)m[l]=s[l];return new R.$Eu(r,m)}e.$oB=A;class I{constructor(s){const a=[];let m=0;for(let l=0,t=s.length;l<t;l++)s.charCodeAt(l)===10&&(a[m++]=l);this.a=a}findLineFeedCountBeforeOffset(s){const a=this.a;let m=0,l=a.length-1;if(l===-1||s<=a[0])return 0;for(;m<l;){const t=m+((l-m)/2>>0);a[t]>=s?l=t-1:a[t+1]>=s?(m=t,l=t):m=t+1}return m+1}}class v{static findMatches(s,a,m,l,t){const n=a.parseSearchRequest();return n?n.regex.multiline?this.b(s,m,new u(n.wordSeparators,n.regex),l,t):this.c(s,m,n,l,t):[]}static a(s,a,m,l,t,n){let o,i=0;l?(i=l.findLineFeedCountBeforeOffset(t),o=a+t+i):o=a+t;let c;if(l){const $=l.findLineFeedCountBeforeOffset(t+n.length)-i;c=o+n.length+$}else c=o+n.length;const h=s.getPositionAt(o),y=s.getPositionAt(c);return new L.$ns(h.lineNumber,h.column,y.lineNumber,y.column)}static b(s,a,m,l,t){const n=s.getOffsetAt(a.getStartPosition()),o=s.getValueInRange(a,1),i=s.getEOL()===`\r
`?new I(o):null,c=[];let h=0,y;for(m.reset(0);y=m.next(o);)if(c[h++]=A(this.a(s,n,o,i,y.index,y[0]),y,l),h>=t)return c;return c}static c(s,a,m,l,t){const n=[];let o=0;if(a.startLineNumber===a.endLineNumber){const c=s.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return o=this.d(m,c,a.startLineNumber,a.startColumn-1,o,n,l,t),n}const i=s.getLineContent(a.startLineNumber).substring(a.startColumn-1);o=this.d(m,i,a.startLineNumber,a.startColumn-1,o,n,l,t);for(let c=a.startLineNumber+1;c<a.endLineNumber&&o<t;c++)o=this.d(m,s.getLineContent(c),c,0,o,n,l,t);if(o<t){const c=s.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);o=this.d(m,c,a.endLineNumber,0,o,n,l,t)}return n}static d(s,a,m,l,t,n,o,i){const c=s.wordSeparators;if(!o&&s.simpleSearch){const C=s.simpleSearch,$=C.length,f=a.length;let d=-$;for(;(d=a.indexOf(C,d+$))!==-1;)if((!c||p(c,a,f,d,$))&&(n[t++]=new R.$Eu(new L.$ns(m,d+1+l,m,d+1+$+l),null),t>=i))return t;return t}const h=new u(s.wordSeparators,s.regex);let y;h.reset(0);do if(y=h.next(a),y&&(n[t++]=A(new L.$ns(m,y.index+1+l,m,y.index+1+y[0].length+l),y,o),t>=i))return t;while(y);return t}static findNextMatch(s,a,m,l){const t=a.parseSearchRequest();if(!t)return null;const n=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.e(s,m,n,l):this.f(s,m,n,l)}static e(s,a,m,l){const t=new g.$ms(a.lineNumber,1),n=s.getOffsetAt(t),o=s.getLineCount(),i=s.getValueInRange(new L.$ns(t.lineNumber,t.column,o,s.getLineMaxColumn(o)),1),c=s.getEOL()===`\r
`?new I(i):null;m.reset(a.column-1);const h=m.next(i);return h?A(this.a(s,n,i,c,h.index,h[0]),h,l):a.lineNumber!==1||a.column!==1?this.e(s,new g.$ms(1,1),m,l):null}static f(s,a,m,l){const t=s.getLineCount(),n=a.lineNumber,o=s.getLineContent(n),i=this.g(m,o,n,a.column,l);if(i)return i;for(let c=1;c<=t;c++){const h=(n+c-1)%t,y=s.getLineContent(h+1),C=this.g(m,y,h+1,1,l);if(C)return C}return null}static g(s,a,m,l,t){s.reset(l-1);const n=s.next(a);return n?A(new L.$ns(m,n.index+1,m,n.index+1+n[0].length),n,t):null}static findPreviousMatch(s,a,m,l){const t=a.parseSearchRequest();if(!t)return null;const n=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.h(s,m,n,l):this.j(s,m,n,l)}static h(s,a,m,l){const t=this.b(s,new L.$ns(1,1,a.lineNumber,a.column),m,l,10*b);if(t.length>0)return t[t.length-1];const n=s.getLineCount();return a.lineNumber!==n||a.column!==s.getLineMaxColumn(n)?this.h(s,new g.$ms(n,s.getLineMaxColumn(n)),m,l):null}static j(s,a,m,l){const t=s.getLineCount(),n=a.lineNumber,o=s.getLineContent(n).substring(0,a.column-1),i=this.k(m,o,n,l);if(i)return i;for(let c=1;c<=t;c++){const h=(t+n-c-1)%t,y=s.getLineContent(h+1),C=this.k(m,y,h+1,l);if(C)return C}return null}static k(s,a,m,l){let t=null,n;for(s.reset(0);n=s.next(a);)t=A(new L.$ns(m,n.index+1,m,n.index+1+n[0].length),n,l);return t}}e.$pB=v;function k(r,s,a,m,l){if(m===0)return!0;const t=s.charCodeAt(m-1);if(r.get(t)!==0||t===13||t===10)return!0;if(l>0){const n=s.charCodeAt(m);if(r.get(n)!==0)return!0}return!1}function S(r,s,a,m,l){if(m+l===a)return!0;const t=s.charCodeAt(m+l);if(r.get(t)!==0||t===13||t===10)return!0;if(l>0){const n=s.charCodeAt(m+l-1);if(r.get(n)!==0)return!0}return!1}function p(r,s,a,m,l){return k(r,s,a,m,l)&&S(r,s,a,m,l)}e.$qB=p;class u{constructor(s,a){this._wordSeparators=s,this.a=a,this.b=-1,this.c=0}reset(s){this.a.lastIndex=s,this.b=-1,this.c=0}next(s){const a=s.length;let m;do{if(this.b+this.c===a||(m=this.a.exec(s),!m))return null;const l=m.index,t=m[0].length;if(l===this.b&&t===this.c){if(t===0){D.$8e(s,a,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=l,this.c=t,!this._wordSeparators||p(this._wordSeparators,s,a,l,t))return m}while(m);return null}}e.$rB=u}),define(De[173],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7=e.$A7=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$A7=D;class T{constructor(L){this.identifier=L}}e.$B7=T}),define(De[174],Ce([1,0,4,3]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Md,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,E){return this.a.set(b,E),this.handleChange([b]),(0,T.$Pc)(()=>{this.a.get(b)===E&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,E){this.b.get(b)?.dispose();const w=new L(this,b,E);return this.b.set(b,w),(0,T.$Pc)(()=>{const A=this.b.get(b);!A||A!==w||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const E=this.get(b);if(E)return E;const w=this.b.get(b);return!w||w.isResolved?null:(await w.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const w=this.b.get(b);return!!(!w||w.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Ys=g;class L extends T.$Rc{get isResolved(){return this.c}constructor(b,E,w){super(),this.f=b,this.g=E,this.h=w,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(De[175],Ce([9,10]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(De[176],Ce([1,0,4,3,175]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class L extends T.$Rc{constructor(v,k="",S="",p=!0,u){super(),this.h=this.B(new D.$Md),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=k,this.u=S,this.w=p,this.C=u}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,k){this.C&&await this.C(v)}}e.$si=L;class R extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new D.$Md),this.onWillRun=this.f.event,this.m=this.B(new D.$Md),this.onDidRun=this.m.event}async run(v,k){if(!v.enabled)return;this.f.fire({action:v});let S;try{await this.u(v,k)}catch(p){S=p}this.m.fire({action:v,error:S})}async u(v,k){await v.run(k)}}e.$ti=R;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let k=[];for(const S of v)S.length&&(k.length?k=[...k,new b,...S]:k=S);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$ui=b;class E{get actions(){return this.a}constructor(v,k,S,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=k,this.class=p,this.a=S}async run(){}}e.$vi=E;class w extends L{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,g.localize(0,null),void 0,!1)}}e.$wi=w;function A(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...v)=>I.run(...v),tooltip:I.label}}e.$xi=A}),define(De[177],Ce([9,10]),function($e,e){return $e.create("vs/base/common/date",e)}),define(De[178],Ce([1,0,177]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=void 0;const T=60,g=T*60,L=g*24,R=L*7,b=L*30,E=L*365;function w(I,v,k,S){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,D.localize)(0,null,w(new Date().getTime()+p*1e3,!1));if(!S&&p<30)return(0,D.localize)(1,null);let u;return p<T?(u=p,v?u===1?k?(0,D.localize)(2,null,u):(0,D.localize)(3,null,u):k?(0,D.localize)(4,null,u):(0,D.localize)(5,null,u):u===1?k?(0,D.localize)(6,null,u):(0,D.localize)(7,null,u):k?(0,D.localize)(8,null,u):(0,D.localize)(9,null,u)):p<g?(u=Math.floor(p/T),v?u===1?k?(0,D.localize)(10,null,u):(0,D.localize)(11,null,u):k?(0,D.localize)(12,null,u):(0,D.localize)(13,null,u):u===1?k?(0,D.localize)(14,null,u):(0,D.localize)(15,null,u):k?(0,D.localize)(16,null,u):(0,D.localize)(17,null,u)):p<L?(u=Math.floor(p/g),v?u===1?k?(0,D.localize)(18,null,u):(0,D.localize)(19,null,u):k?(0,D.localize)(20,null,u):(0,D.localize)(21,null,u):u===1?k?(0,D.localize)(22,null,u):(0,D.localize)(23,null,u):k?(0,D.localize)(24,null,u):(0,D.localize)(25,null,u)):p<R?(u=Math.floor(p/L),v?u===1?(0,D.localize)(26,null,u):(0,D.localize)(27,null,u):u===1?(0,D.localize)(28,null,u):(0,D.localize)(29,null,u)):p<b?(u=Math.floor(p/R),v?u===1?k?(0,D.localize)(30,null,u):(0,D.localize)(31,null,u):k?(0,D.localize)(32,null,u):(0,D.localize)(33,null,u):u===1?k?(0,D.localize)(34,null,u):(0,D.localize)(35,null,u):k?(0,D.localize)(36,null,u):(0,D.localize)(37,null,u)):p<E?(u=Math.floor(p/b),v?u===1?k?(0,D.localize)(38,null,u):(0,D.localize)(39,null,u):k?(0,D.localize)(40,null,u):(0,D.localize)(41,null,u):u===1?k?(0,D.localize)(42,null,u):(0,D.localize)(43,null,u):k?(0,D.localize)(44,null,u):(0,D.localize)(45,null,u)):(u=Math.floor(p/E),v?u===1?k?(0,D.localize)(46,null,u):(0,D.localize)(47,null,u):k?(0,D.localize)(48,null,u):(0,D.localize)(49,null,u):u===1?k?(0,D.localize)(50,null,u):(0,D.localize)(51,null,u):k?(0,D.localize)(52,null,u):(0,D.localize)(53,null,u))}e.$9l=w;function A(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$0l=A}),define(De[179],Ce([9,10]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(De[46],Ce([1,0,19,18,179]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function L(I,v){return v&&(I.stack||I.stacktrace)?g.localize(0,null,b(I),R(I.stack)||R(I.stacktrace)):b(I)}function R(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?g.localize(1,null,I.message):I.message||g.localize(2,null)}function E(I=null,v=!1){if(!I)return g.localize(3,null);if(Array.isArray(I)){const k=D.$Gb(I),S=E(k[0],v);return k.length>1?g.localize(4,null,S,k.length):S}if(T.$xf(I))return I;if(I.detail){const k=I.detail;if(k.error)return L(k.error,v);if(k.exception)return L(k.exception,v)}return I.stack?L(I,v):I.message?I.message:g.localize(5,null)}e.$yi=E;function w(I){const v=I;return v instanceof Error&&Array.isArray(v.actions)}e.$zi=w;function A(I,v){let k;return typeof I=="string"?k=new Error(I):k=I,k.actions=v,k}e.$Ai=A}),define(De[180],Ce([9,10]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(De[12],Ce([1,0,180]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let T=!1,g=!1,L=!1,R=!1,b=!1,E=!1,w=!1,A=!1,I=!1,v=!1,k,S=e.$g,p=e.$g,u,r;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?s=e.$h.vscode.process:typeof process<"u"&&(s=process);const a=typeof s?.versions?.electron=="string",m=a&&s?.type==="renderer";if(typeof navigator=="object"&&!m)r=navigator.userAgent,T=r.indexOf("Windows")>=0,g=r.indexOf("Macintosh")>=0,A=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=r.indexOf("Linux")>=0,v=r?.indexOf("Mobi")>=0,E=!0,k=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,S=k,p=navigator.language;else if(typeof s=="object"){T=s.platform==="win32",g=s.platform==="darwin",L=s.platform==="linux",R=L&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,w=a,I=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.$g,S=e.$g;const C=s.env.VSCODE_NLS_CONFIG;if(C)try{const $=JSON.parse(C),f=$.availableLanguages["*"];k=$.locale,p=$.osLocale,S=f||e.$g,u=$._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var l;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(l||(e.Platform=l={}));function t(C){switch(C){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=t;let n=0;g?n=1:T?n=3:L&&(n=2),e.$j=T,e.$k=g,e.$l=L,e.$m=R,e.$n=b,e.$o=w,e.$p=E,e.$q=E&&typeof e.$h.importScripts=="function",e.$r=A,e.$s=v,e.$t=I,e.$u=n,e.$v=r,e.$w=S;var o;(function(C){function $(){return e.$w}C.value=$;function f(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}C.isDefaultVariant=f;function d(){return e.$w==="en"}C.isDefault=d})(o||(e.Language=o={})),e.$x=k,e.$y=p,e.$z=u,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const C=[];e.$h.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let d=0,P=C.length;d<P;d++){const N=C[d];if(N.id===f.data.vscodeScheduleAsyncWork){C.splice(d,1),N.callback();return}}});let $=0;return f=>{const d=++$;C.push({id:d,callback:f}),e.$h.postMessage({vscodeScheduleAsyncWork:d},"*")}}return C=>setTimeout(C)})();var i;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=g||A?2:T?1:3;let c=!0,h=!1;function y(){if(!h){h=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,c=new Uint16Array(C.buffer)[0]===(2<<8)+1}return c}e.$D=y,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(De[47],Ce([1,0,12]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let T;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.process<"u"){const g=D.$h.vscode.process;T={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return D.$j?"win32":D.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$cc=T.platform,e.$dc=T.arch}),define(De[16],Ce([1,0,47]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const T=65,g=97,L=90,R=122,b=46,E=47,w=92,A=58,I=63;class v extends Error{constructor(n,o,i){let c;typeof o=="string"&&o.indexOf("not ")===0?(c="must not be",o=o.replace(/^not /,"")):c="must be";const h=n.indexOf(".")!==-1?"property":"argument";let y=`The "${n}" ${h} ${c} of type ${o}`;y+=`. Received type ${typeof i}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,n){if(t===null||typeof t!="object")throw new v(n,"Object",t)}function S(t,n){if(typeof t!="string")throw new v(n,"string",t)}const p=D.$cc==="win32";function u(t){return t===E||t===w}function r(t){return t===E}function s(t){return t>=T&&t<=L||t>=g&&t<=R}function a(t,n,o,i){let c="",h=0,y=-1,C=0,$=0;for(let f=0;f<=t.length;++f){if(f<t.length)$=t.charCodeAt(f);else{if(i($))break;$=E}if(i($)){if(!(y===f-1||C===1))if(C===2){if(c.length<2||h!==2||c.charCodeAt(c.length-1)!==b||c.charCodeAt(c.length-2)!==b){if(c.length>2){const d=c.lastIndexOf(o);d===-1?(c="",h=0):(c=c.slice(0,d),h=c.length-1-c.lastIndexOf(o)),y=f,C=0;continue}else if(c.length!==0){c="",h=0,y=f,C=0;continue}}n&&(c+=c.length>0?`${o}..`:"..",h=2)}else c.length>0?c+=`${o}${t.slice(y+1,f)}`:c=t.slice(y+1,f),h=f-y-1;y=f,C=0}else $===b&&C!==-1?++C:C=-1}return c}function m(t,n){k(n,"pathObject");const o=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return o?o===n.root?`${o}${i}`:`${o}${t}${i}`:i}e.$ec={resolve(...t){let n="",o="",i=!1;for(let c=t.length-1;c>=-1;c--){let h;if(c>=0){if(h=t[c],S(h,"path"),h.length===0)continue}else n.length===0?h=D.cwd():(h=D.env[`=${n}`]||D.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==n.toLowerCase()&&h.charCodeAt(2)===w)&&(h=`${n}\\`));const y=h.length;let C=0,$="",f=!1;const d=h.charCodeAt(0);if(y===1)u(d)&&(C=1,f=!0);else if(u(d))if(f=!0,u(h.charCodeAt(1))){let P=2,N=P;for(;P<y&&!u(h.charCodeAt(P));)P++;if(P<y&&P!==N){const O=h.slice(N,P);for(N=P;P<y&&u(h.charCodeAt(P));)P++;if(P<y&&P!==N){for(N=P;P<y&&!u(h.charCodeAt(P));)P++;(P===y||P!==N)&&($=`\\\\${O}\\${h.slice(N,P)}`,C=P)}}}else C=1;else s(d)&&h.charCodeAt(1)===A&&($=h.slice(0,2),C=2,y>2&&u(h.charCodeAt(2))&&(f=!0,C=3));if($.length>0)if(n.length>0){if($.toLowerCase()!==n.toLowerCase())continue}else n=$;if(i){if(n.length>0)break}else if(o=`${h.slice(C)}\\${o}`,i=f,f&&n.length>0)break}return o=a(o,!i,"\\",u),i?`${n}\\${o}`:`${n}${o}`||"."},normalize(t){S(t,"path");const n=t.length;if(n===0)return".";let o=0,i,c=!1;const h=t.charCodeAt(0);if(n===1)return r(h)?"\\":t;if(u(h))if(c=!0,u(t.charCodeAt(1))){let C=2,$=C;for(;C<n&&!u(t.charCodeAt(C));)C++;if(C<n&&C!==$){const f=t.slice($,C);for($=C;C<n&&u(t.charCodeAt(C));)C++;if(C<n&&C!==$){for($=C;C<n&&!u(t.charCodeAt(C));)C++;if(C===n)return`\\\\${f}\\${t.slice($)}\\`;C!==$&&(i=`\\\\${f}\\${t.slice($,C)}`,o=C)}}}else o=1;else s(h)&&t.charCodeAt(1)===A&&(i=t.slice(0,2),o=2,n>2&&u(t.charCodeAt(2))&&(c=!0,o=3));let y=o<n?a(t.slice(o),!c,"\\",u):"";return y.length===0&&!c&&(y="."),y.length>0&&u(t.charCodeAt(n-1))&&(y+="\\"),i===void 0?c?`\\${y}`:y:c?`${i}\\${y}`:`${i}${y}`},isAbsolute(t){S(t,"path");const n=t.length;if(n===0)return!1;const o=t.charCodeAt(0);return u(o)||n>2&&s(o)&&t.charCodeAt(1)===A&&u(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,o;for(let h=0;h<t.length;++h){const y=t[h];S(y,"path"),y.length>0&&(n===void 0?n=o=y:n+=`\\${y}`)}if(n===void 0)return".";let i=!0,c=0;if(typeof o=="string"&&u(o.charCodeAt(0))){++c;const h=o.length;h>1&&u(o.charCodeAt(1))&&(++c,h>2&&(u(o.charCodeAt(2))?++c:i=!1))}if(i){for(;c<n.length&&u(n.charCodeAt(c));)c++;c>=2&&(n=`\\${n.slice(c)}`)}return e.$ec.normalize(n)},relative(t,n){if(S(t,"from"),S(n,"to"),t===n)return"";const o=e.$ec.resolve(t),i=e.$ec.resolve(n);if(o===i||(t=o.toLowerCase(),n=i.toLowerCase(),t===n))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===w;)c++;let h=t.length;for(;h-1>c&&t.charCodeAt(h-1)===w;)h--;const y=h-c;let C=0;for(;C<n.length&&n.charCodeAt(C)===w;)C++;let $=n.length;for(;$-1>C&&n.charCodeAt($-1)===w;)$--;const f=$-C,d=y<f?y:f;let P=-1,N=0;for(;N<d;N++){const M=t.charCodeAt(c+N);if(M!==n.charCodeAt(C+N))break;M===w&&(P=N)}if(N!==d){if(P===-1)return i}else{if(f>d){if(n.charCodeAt(C+N)===w)return i.slice(C+N+1);if(N===2)return i.slice(C+N)}y>d&&(t.charCodeAt(c+N)===w?P=N:N===2&&(P=3)),P===-1&&(P=0)}let O="";for(N=c+P+1;N<=h;++N)(N===h||t.charCodeAt(N)===w)&&(O+=O.length===0?"..":"\\..");return C+=P,O.length>0?`${O}${i.slice(C,$)}`:(i.charCodeAt(C)===w&&++C,i.slice(C,$))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.$ec.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===w){if(n.charCodeAt(1)===w){const o=n.charCodeAt(2);if(o!==I&&o!==b)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(s(n.charCodeAt(0))&&n.charCodeAt(1)===A&&n.charCodeAt(2)===w)return`\\\\?\\${n}`;return t},dirname(t){S(t,"path");const n=t.length;if(n===0)return".";let o=-1,i=0;const c=t.charCodeAt(0);if(n===1)return u(c)?t:".";if(u(c)){if(o=i=1,u(t.charCodeAt(1))){let C=2,$=C;for(;C<n&&!u(t.charCodeAt(C));)C++;if(C<n&&C!==$){for($=C;C<n&&u(t.charCodeAt(C));)C++;if(C<n&&C!==$){for($=C;C<n&&!u(t.charCodeAt(C));)C++;if(C===n)return t;C!==$&&(o=i=C+1)}}}}else s(c)&&t.charCodeAt(1)===A&&(o=n>2&&u(t.charCodeAt(2))?3:2,i=o);let h=-1,y=!0;for(let C=n-1;C>=i;--C)if(u(t.charCodeAt(C))){if(!y){h=C;break}}else y=!1;if(h===-1){if(o===-1)return".";h=o}return t.slice(0,h)},basename(t,n){n!==void 0&&S(n,"ext"),S(t,"path");let o=0,i=-1,c=!0,h;if(t.length>=2&&s(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(o=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let y=n.length-1,C=-1;for(h=t.length-1;h>=o;--h){const $=t.charCodeAt(h);if(u($)){if(!c){o=h+1;break}}else C===-1&&(c=!1,C=h+1),y>=0&&($===n.charCodeAt(y)?--y===-1&&(i=h):(y=-1,i=C))}return o===i?i=C:i===-1&&(i=t.length),t.slice(o,i)}for(h=t.length-1;h>=o;--h)if(u(t.charCodeAt(h))){if(!c){o=h+1;break}}else i===-1&&(c=!1,i=h+1);return i===-1?"":t.slice(o,i)},extname(t){S(t,"path");let n=0,o=-1,i=0,c=-1,h=!0,y=0;t.length>=2&&t.charCodeAt(1)===A&&s(t.charCodeAt(0))&&(n=i=2);for(let C=t.length-1;C>=n;--C){const $=t.charCodeAt(C);if(u($)){if(!h){i=C+1;break}continue}c===-1&&(h=!1,c=C+1),$===b?o===-1?o=C:y!==1&&(y=1):o!==-1&&(y=-1)}return o===-1||c===-1||y===0||y===1&&o===c-1&&o===i+1?"":t.slice(o,c)},format:m.bind(null,"\\"),parse(t){S(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const o=t.length;let i=0,c=t.charCodeAt(0);if(o===1)return u(c)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(u(c)){if(i=1,u(t.charCodeAt(1))){let P=2,N=P;for(;P<o&&!u(t.charCodeAt(P));)P++;if(P<o&&P!==N){for(N=P;P<o&&u(t.charCodeAt(P));)P++;if(P<o&&P!==N){for(N=P;P<o&&!u(t.charCodeAt(P));)P++;P===o?i=P:P!==N&&(i=P+1)}}}}else if(s(c)&&t.charCodeAt(1)===A){if(o<=2)return n.root=n.dir=t,n;if(i=2,u(t.charCodeAt(2))){if(o===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let h=-1,y=i,C=-1,$=!0,f=t.length-1,d=0;for(;f>=i;--f){if(c=t.charCodeAt(f),u(c)){if(!$){y=f+1;break}continue}C===-1&&($=!1,C=f+1),c===b?h===-1?h=f:d!==1&&(d=1):h!==-1&&(d=-1)}return C!==-1&&(h===-1||d===0||d===1&&h===C-1&&h===y+1?n.base=n.name=t.slice(y,C):(n.name=t.slice(y,h),n.base=t.slice(y,C),n.ext=t.slice(h,C))),y>0&&y!==i?n.dir=t.slice(0,y-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(p){const t=/\\/g;return()=>{const n=D.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>D.cwd()})();e.$fc={resolve(...t){let n="",o=!1;for(let i=t.length-1;i>=-1&&!o;i--){const c=i>=0?t[i]:l();S(c,"path"),c.length!==0&&(n=`${c}/${n}`,o=c.charCodeAt(0)===E)}return n=a(n,!o,"/",r),o?`/${n}`:n.length>0?n:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E,o=t.charCodeAt(t.length-1)===E;return t=a(t,!n,"/",r),t.length===0?n?"/":o?"./":".":(o&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let n;for(let o=0;o<t.length;++o){const i=t[o];S(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.$fc.normalize(n)},relative(t,n){if(S(t,"from"),S(n,"to"),t===n||(t=e.$fc.resolve(t),n=e.$fc.resolve(n),t===n))return"";const o=1,i=t.length,c=i-o,h=1,y=n.length-h,C=c<y?c:y;let $=-1,f=0;for(;f<C;f++){const P=t.charCodeAt(o+f);if(P!==n.charCodeAt(h+f))break;P===E&&($=f)}if(f===C)if(y>C){if(n.charCodeAt(h+f)===E)return n.slice(h+f+1);if(f===0)return n.slice(h+f)}else c>C&&(t.charCodeAt(o+f)===E?$=f:f===0&&($=0));let d="";for(f=o+$+1;f<=i;++f)(f===i||t.charCodeAt(f)===E)&&(d+=d.length===0?"..":"/..");return`${d}${n.slice(h+$)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E;let o=-1,i=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===E){if(!i){o=c;break}}else i=!1;return o===-1?n?"/":".":n&&o===1?"//":t.slice(0,o)},basename(t,n){n!==void 0&&S(n,"ext"),S(t,"path");let o=0,i=-1,c=!0,h;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let y=n.length-1,C=-1;for(h=t.length-1;h>=0;--h){const $=t.charCodeAt(h);if($===E){if(!c){o=h+1;break}}else C===-1&&(c=!1,C=h+1),y>=0&&($===n.charCodeAt(y)?--y===-1&&(i=h):(y=-1,i=C))}return o===i?i=C:i===-1&&(i=t.length),t.slice(o,i)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===E){if(!c){o=h+1;break}}else i===-1&&(c=!1,i=h+1);return i===-1?"":t.slice(o,i)},extname(t){S(t,"path");let n=-1,o=0,i=-1,c=!0,h=0;for(let y=t.length-1;y>=0;--y){const C=t.charCodeAt(y);if(C===E){if(!c){o=y+1;break}continue}i===-1&&(c=!1,i=y+1),C===b?n===-1?n=y:h!==1&&(h=1):n!==-1&&(h=-1)}return n===-1||i===-1||h===0||h===1&&n===i-1&&n===o+1?"":t.slice(n,i)},format:m.bind(null,"/"),parse(t){S(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const o=t.charCodeAt(0)===E;let i;o?(n.root="/",i=1):i=0;let c=-1,h=0,y=-1,C=!0,$=t.length-1,f=0;for(;$>=i;--$){const d=t.charCodeAt($);if(d===E){if(!C){h=$+1;break}continue}y===-1&&(C=!1,y=$+1),d===b?c===-1?c=$:f!==1&&(f=1):c!==-1&&(f=-1)}if(y!==-1){const d=h===0&&o?1:h;c===-1||f===0||f===1&&c===y-1&&c===h+1?n.base=n.name=t.slice(d,y):(n.name=t.slice(d,c),n.base=t.slice(d,y),n.ext=t.slice(c,y))}return h>0?n.dir=t.slice(0,h-1):o&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=p?e.$ec.normalize:e.$fc.normalize,e.$hc=p?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=p?e.$ec.join:e.$fc.join,e.$jc=p?e.$ec.resolve:e.$fc.resolve,e.$kc=p?e.$ec.relative:e.$fc.relative,e.$lc=p?e.$ec.dirname:e.$fc.dirname,e.$mc=p?e.$ec.basename:e.$fc.basename,e.$nc=p?e.$ec.extname:e.$fc.extname,e.$oc=p?e.$ec.format:e.$fc.format,e.$pc=p?e.$ec.parse:e.$fc.parse,e.$qc=p?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=p?e.$ec.sep:e.$fc.sep,e.$sc=p?e.$ec.delimiter:e.$fc.delimiter}),define(De[126],Ce([1,0,51,16]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=void 0;const g=new D.$U(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),L=new D.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new D.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(C,$,f=!1){const d=C||"",P=$||"",N=g.value.collator.compare(d,P);return g.value.collatorIsNumeric&&N===0&&d!==P?d<P?-1:1:N}e.$aq=b;function E(C,$){const f=L.value.collator;return C=C||"",$=$||"",m(f,C,$)}e.$bq=E;function w(C,$){const f=L.value.collator;return C=C||"",$=$||"",o(C,$)||m(f,C,$)}e.$cq=w;function A(C,$){const f=L.value.collator;return C=C||"",$=$||"",n(C,$)||m(f,C,$)}e.$dq=A;function I(C,$){return C=C||"",$=$||"",C===$?0:C<$?-1:1}e.$eq=I;function v(C,$){const[f,d]=s(C),[P,N]=s($);let O=g.value.collator.compare(d,N);if(O===0){if(g.value.collatorIsNumeric&&d!==N)return d<N?-1:1;if(O=g.value.collator.compare(f,P),g.value.collatorIsNumeric&&O===0&&f!==P)return f<P?-1:1}return O}e.$fq=v;function k(C,$){C=C||"",$=$||"";const f=a(C),d=a($),P=L.value.collator,N=R.value.collator;return m(N,f,d)||m(P,C,$)}e.$gq=k;function S(C,$){C=C||"",$=$||"";const f=a(C),d=a($),P=L.value.collator,N=R.value.collator;return m(N,f,d)||o(C,$)||m(P,C,$)}e.$hq=S;function p(C,$){C=C||"",$=$||"";const f=a(C),d=a($),P=L.value.collator,N=R.value.collator;return m(N,f,d)||n(C,$)||m(P,C,$)}e.$iq=p;function u(C,$){C=C||"",$=$||"";const f=a(C).toLowerCase(),d=a($).toLowerCase();return f!==d?f<d?-1:1:C!==$?C<$?-1:1:0}e.$jq=u;const r=/^(.*?)(\.([^.]*))?$/;function s(C,$=!1){const f=C?r.exec(C):[];let d=[f&&f[1]||"",f&&f[3]||""];return $&&(!d[0]&&d[1]||d[0]&&d[0].charAt(0)===".")&&(d=[d[0]+"."+d[1],""]),d}function a(C){const $=C?r.exec(C):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function m(C,$,f){const d=C.compare($,f);return d!==0?d:$.length!==f.length?$.length<f.length?-1:1:0}function l(C){const $=C.charAt(0);return $.toLocaleUpperCase()!==$}function t(C){const $=C.charAt(0);return $.toLocaleLowerCase()!==$}function n(C,$){return l(C)&&t($)?-1:t(C)&&l($)?1:0}function o(C,$){return t(C)&&l($)?-1:l(C)&&t($)?1:0}function i(C,$,f=!1){return f||(C=C&&C.toLowerCase(),$=$&&$.toLowerCase()),C===$?0:C<$?-1:1}function c(C,$,f=!1){const d=C.split(T.sep),P=$.split(T.sep),N=d.length-1,O=P.length-1;let M,j;for(let U=0;;U++){if(M=N===U,j=O===U,M&&j)return b(d[U],P[U],f);if(M)return-1;if(j)return 1;const F=i(d[U],P[U],f);if(F!==0)return F}}e.$kq=c;function h(C,$,f){const d=C.toLowerCase(),P=$.toLowerCase(),N=y(C,$,f);if(N)return N;const O=d.endsWith(f),M=P.endsWith(f);if(O!==M)return O?-1:1;const j=b(d,P);return j!==0?j:d.localeCompare(P)}e.$lq=h;function y(C,$,f){const d=C.toLowerCase(),P=$.toLowerCase(),N=d.startsWith(f),O=P.startsWith(f);if(N!==O)return N?-1:1;if(N&&O){if(d.length<P.length)return-1;if(d.length>P.length)return 1}return 0}e.$mq=y}),define(De[32],Ce([1,0,16,12,15,18]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=void 0;function R(h){return h===47||h===92}e.$Pf=R;function b(h){return h.replace(/[\\/]/g,D.$fc.sep)}e.$Qf=b;function E(h){return h.indexOf("/")===-1&&(h=b(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Rf=E;function w(h,y=D.$fc.sep){if(!h)return"";const C=h.length,$=h.charCodeAt(0);if(R($)){if(R(h.charCodeAt(1))&&!R(h.charCodeAt(2))){let d=3;const P=d;for(;d<C&&!R(h.charCodeAt(d));d++);if(P!==d&&!R(h.charCodeAt(d+1))){for(d+=1;d<C;d++)if(R(h.charCodeAt(d)))return h.slice(0,d+1).replace(/[\\/]/g,y)}}return y}else if(r($)&&h.charCodeAt(1)===58)return R(h.charCodeAt(2))?h.slice(0,2)+y:h.slice(0,2);let f=h.indexOf("://");if(f!==-1){for(f+=3;f<C;f++)if(R(h.charCodeAt(f)))return h.slice(0,f+1)}return""}e.$Sf=w;function A(h){if(!T.$j||!h||h.length<5)return!1;let y=h.charCodeAt(0);if(y!==92||(y=h.charCodeAt(1),y!==92))return!1;let C=2;const $=C;for(;C<h.length&&(y=h.charCodeAt(C),y!==92);C++);return!($===C||(y=h.charCodeAt(C+1),isNaN(y)||y===92))}e.$Tf=A;const I=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(h,y=T.$j){const C=y?I:v;return!(!h||h.length===0||/^\s+$/.test(h)||(C.lastIndex=0,C.test(h))||y&&k.test(h)||h==="."||h===".."||y&&h[h.length-1]==="."||y&&h.length!==h.trim().length||h.length>255)}e.$Uf=S;function p(h,y,C){const $=h===y;return!C||$?$:!h||!y?!1:(0,g.$1e)(h,y)}e.$Vf=p;function u(h,y,C,$=D.sep){if(h===y)return!0;if(!h||!y||y.length>h.length)return!1;if(C){if(!(0,g.$2e)(h,y))return!1;if(y.length===h.length)return!0;let d=y.length;return y.charAt(y.length-1)===$&&d--,h.charAt(d)===$}return y.charAt(y.length-1)!==$&&(y+=$),h.indexOf(y)===0}e.$Wf=u;function r(h){return h>=65&&h<=90||h>=97&&h<=122}e.$Xf=r;function s(h,y){return T.$j&&h.endsWith(":")&&(h+=D.sep),(0,D.$hc)(h)||(h=(0,D.$ic)(y,h)),h=(0,D.$gc)(h),T.$j?(h=(0,g.$Je)(h,D.sep),h.endsWith(":")&&(h+=D.sep)):(h=(0,g.$Je)(h,D.sep),h||(h=D.sep)),h}e.$Yf=s;function a(h){const y=(0,D.$gc)(h);return T.$j?h.length>3?!1:m(y)&&(h.length===2||y.charCodeAt(2)===92):y===D.$fc.sep}e.$Zf=a;function m(h,y=T.$j){return y?r(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$1f=m;function l(h,y=T.$j){return m(h,y)?h[0]:void 0}e.$2f=l;function t(h,y,C){return y.length>h.length?-1:h===y?0:(C&&(h=h.toLowerCase(),y=y.toLowerCase()),h.indexOf(y))}e.$3f=t;function n(h){const y=h.split(":");let C,$,f;for(const d of y){const P=Number(d);(0,L.$Bf)(P)?$===void 0?$=P:f===void 0&&(f=P):C=C?[C,d].join(":"):d}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:$!==void 0?$:void 0,column:f!==void 0?f:$!==void 0?1:void 0}}e.$4f=n;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(h,y,C=8){let $="";for(let d=0;d<C;d++){let P;d===0&&T.$j&&!y&&(C===3||C===4)?P=i:P=o,$+=P.charAt(Math.floor(Math.random()*P.length))}let f;return y?f=`${y}-${$}`:f=$,h?(0,D.$ic)(h,f):f}e.$5f=c}),define(De[127],Ce([1,0,126,121,52,16,12,15]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=void 0;const E=0,w=[E,[]];function A(V,H,fe,X){if(!V||!H)return w;const Y=V.length,q=H.length;if(Y<q)return w;const x=V.toLowerCase();return I(H,fe,q,V,x,Y,X)}e.$nq=A;function I(V,H,fe,X,Y,q,x){const me=[],ue=[];for(let K=0;K<fe;K++){const ge=K*q,_=ge-q,ie=K>0,ne=V[K],Ee=H[K];for(let oe=0;oe<q;oe++){const he=oe>0,ee=ge+oe,le=ee-1,be=_+oe-1,Pe=he?me[le]:0,B=ie&&he?me[be]:0,Q=ie&&he?ue[be]:0;let te;!B&&ie?te=0:te=v(ne,Ee,X,Y,oe,Q),te&&B+te>=Pe&&(x||ie||Y.startsWith(H,oe))?(ue[ee]=Q+1,me[ee]=B+te):(ue[ee]=E,me[ee]=Pe)}}const pe=[];let G=fe-1,z=q-1;for(;G>=0&&z>=0;){const K=G*q+z;ue[K]===E||(pe.push(z),G--),z--}return[me[fe*q-1],pe.reverse()]}function v(V,H,fe,X,Y,q){let x=0;if(!k(H,X[Y]))return x;if(x+=1,q>0&&(x+=q*5),V===fe[Y]&&(x+=1),Y===0)x+=8;else{const me=S(fe.charCodeAt(Y-1));me?x+=me:(0,T.$Ej)(fe.charCodeAt(Y))&&q===0&&(x+=2)}return x}function k(V,H){return V===H?!0:V==="/"||V==="\\"?H==="/"||H==="\\":!1}function S(V){switch(V){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function u(V,H,fe=0,X=0){const Y=H;return Y.values&&Y.values.length>1?r(V,Y.values,fe,X):s(V,H,fe,X)}e.$oq=u;function r(V,H,fe,X){let Y=0;const q=[];for(const x of H){const[me,ue]=s(V,x,fe,X);if(typeof me!="number")return p;Y+=me,q.push(...ue)}return[Y,C(q)]}function s(V,H,fe,X){const Y=(0,T.$Nj)(H.original,H.originalLowercase,fe,V,V.toLowerCase(),X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,T.$Kj)(Y)]:p}const a=Object.freeze({score:0}),m=1<<18,l=1<<17,t=1<<16;function n(V,H,fe,X){const Y=X.values?X.values:[X];return(0,g.$Bi)({[X.normalized]:{values:Y.map(x=>({value:x.normalized,expectContiguousMatch:x.expectContiguousMatch})),label:V,description:H,allowNonContiguousMatches:fe}})}function o(V,H,fe,X,Y){if(!V||!H.normalized)return a;const q=X.getItemLabel(V);if(!q)return a;const x=X.getItemDescription(V),me=n(q,x,fe,H),ue=Y[me];if(ue)return ue;const pe=i(q,x,X.getItemPath(V),H,fe);return Y[me]=pe,pe}e.$pq=o;function i(V,H,fe,X,Y){const q=!fe||!X.containsPathSeparator;return fe&&(R.$l?X.pathNormalized===fe:(0,b.$1e)(X.pathNormalized,fe))?{score:m,labelMatch:[{start:0,end:V.length}],descriptionMatch:H?[{start:0,end:H.length}]:void 0}:X.values&&X.values.length>1?c(V,H,fe,X.values,q,Y):h(V,H,fe,X,q,Y)}function c(V,H,fe,X,Y,q){let x=0;const me=[],ue=[];for(const pe of X){const{score:G,labelMatch:z,descriptionMatch:K}=h(V,H,fe,pe,Y,q);if(G===E)return a;x+=G,z&&me.push(...z),K&&ue.push(...K)}return{score:x,labelMatch:C(me),descriptionMatch:C(ue)}}function h(V,H,fe,X,Y,q){if(Y||!H){const[x,me]=A(V,X.normalized,X.normalizedLowercase,q&&!X.expectContiguousMatch);if(x){const ue=(0,T.$Bj)(X.normalized,V);let pe;if(ue){pe=l;const G=Math.round(X.normalized.length/V.length*100);pe+=G}else pe=t;return{score:pe+x,labelMatch:ue||y(me)}}}if(H){let x=H;fe&&(x=`${H}${L.sep}`);const me=x.length,ue=`${x}${V}`,[pe,G]=A(ue,X.normalized,X.normalizedLowercase,q&&!X.expectContiguousMatch);if(pe){const z=y(G),K=[],ge=[];return z.forEach(_=>{_.start<me&&_.end>me?(K.push({start:0,end:_.end-me}),ge.push({start:_.start,end:me})):_.start>=me?K.push({start:_.start-me,end:_.end-me}):ge.push(_)}),{score:pe,labelMatch:K,descriptionMatch:ge}}}return a}function y(V){const H=[];if(!V)return H;let fe;for(const X of V)fe&&fe.end===X?fe.end+=1:(fe={start:X,end:X+1},H.push(fe));return H}function C(V){const H=V.sort((Y,q)=>Y.start-q.start),fe=[];let X;for(const Y of H)!X||!$(X,Y)?(X=Y,fe.push(Y)):(X.start=Math.min(X.start,Y.start),X.end=Math.max(X.end,Y.end));return fe}function $(V,H){return!(V.end<H.start||H.end<V.start)}function f(V,H,fe,X,Y,q){const x=o(V,fe,X,Y,q),me=o(H,fe,X,Y,q),ue=x.score,pe=me.score;if((ue===m||pe===m)&&ue!==pe)return ue===m?-1:1;if(ue>t||pe>t){if(ue!==pe)return ue>pe?-1:1;if(ue<l&&pe<l){const ne=P(x.labelMatch,me.labelMatch);if(ne!==0)return ne}const _=Y.getItemLabel(V)||"",ie=Y.getItemLabel(H)||"";if(_.length!==ie.length)return _.length-ie.length}if(ue!==pe)return ue>pe?-1:1;const G=Array.isArray(x.labelMatch)&&x.labelMatch.length>0,z=Array.isArray(me.labelMatch)&&me.labelMatch.length>0;if(G&&!z)return-1;if(z&&!G)return 1;const K=d(V,x,Y),ge=d(H,me,Y);return K&&ge&&K!==ge?ge>K?-1:1:N(V,H,fe,Y)}e.$qq=f;function d(V,H,fe){let X=-1,Y=-1;if(H.descriptionMatch&&H.descriptionMatch.length?X=H.descriptionMatch[0].start:H.labelMatch&&H.labelMatch.length&&(X=H.labelMatch[0].start),H.labelMatch&&H.labelMatch.length){if(Y=H.labelMatch[H.labelMatch.length-1].end,H.descriptionMatch&&H.descriptionMatch.length){const q=fe.getItemDescription(V);q&&(Y+=q.length)}}else H.descriptionMatch&&H.descriptionMatch.length&&(Y=H.descriptionMatch[H.descriptionMatch.length-1].end);return Y-X}function P(V,H){if(!V&&!H||(!V||!V.length)&&(!H||!H.length))return 0;if(!H||!H.length)return-1;if(!V||!V.length)return 1;const fe=V[0].start,Y=V[V.length-1].end-fe,q=H[0].start,me=H[H.length-1].end-q;return Y===me?0:me<Y?1:-1}function N(V,H,fe,X){const Y=X.getItemLabel(V)||"",q=X.getItemLabel(H)||"",x=X.getItemDescription(V),me=X.getItemDescription(H),ue=Y.length+(x?x.length:0),pe=q.length+(me?me.length:0);if(ue!==pe)return ue-pe;const G=X.getItemPath(V),z=X.getItemPath(H);return G&&z&&G.length!==z.length?G.length-z.length:Y!==q?(0,D.$lq)(Y,q,fe.normalized):x&&me&&x!==me?(0,D.$lq)(x,me,fe.normalized):G&&z&&G!==z?(0,D.$lq)(G,z,fe.normalized):0}function O(V){return V.startsWith('"')&&V.endsWith('"')}const M=" ";function j(V){typeof V!="string"&&(V="");const H=V.toLowerCase(),{pathNormalized:fe,normalized:X,normalizedLowercase:Y}=U(V),q=fe.indexOf(L.sep)>=0,x=O(V);let me;const ue=V.split(M);if(ue.length>1)for(const pe of ue){const G=O(pe),{pathNormalized:z,normalized:K,normalizedLowercase:ge}=U(pe);K&&(me||(me=[]),me.push({original:pe,originalLowercase:pe.toLowerCase(),pathNormalized:z,normalized:K,normalizedLowercase:ge,expectContiguousMatch:G}))}return{original:V,originalLowercase:H,pathNormalized:fe,normalized:X,normalizedLowercase:Y,values:me,containsPathSeparator:q,expectContiguousMatch:x}}e.$rq=j;function U(V){let H;R.$j?H=V.replace(/\//g,L.sep):H=V.replace(/\\/g,L.sep);const fe=(0,b.$Le)(H).replace(/\s|"/g,"");return{pathNormalized:H,normalized:fe,normalizedLowercase:fe.toLowerCase()}}function F(V){return Array.isArray(V)?j(V.map(H=>H.original).join(M)):j(V.original)}e.$sq=F}),define(De[98],Ce([1,0,16]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=e.$Nr=e.$Mr=e.$Lr=e.$Kr=void 0,e.$Kr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(A){const I=(0,D.$nc)(A),v=T[I.toLowerCase()];return v!==void 0?v:R(A)}e.$Lr=L;function R(A){const I=(0,D.$nc)(A);return g[I.toLowerCase()]}e.$Mr=R;function b(A){for(const I in g)if(g[I]===A)return I}e.$Nr=b;const E=/^(.+)\/(.+?)(;.+)?$/;function w(A,I){const v=E.exec(A);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:I?void 0:A}e.$Or=w}),define(De[99],Ce([1,0,12]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=e.TerminateResponseCode=e.Source=void 0;var T;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(T||(e.Source=T={}));var g;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function L(b,...E){const w=E.reduce((v,k)=>(v[k]=!0,v),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(v=>!w[v]).forEach(v=>{for(let k=0;k<A.length;k++)if(v.search(A[k])!==-1){delete b[v];break}})}e.$vl=L;function R(b){b&&(delete b.DEBUG,D.$k&&delete b.DYLD_LIBRARY_PATH,D.$l&&delete b.LD_PRELOAD)}e.$wl=R}),define(De[2],Ce([1,0,16,12]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,L=/^\//,R=/^\/\//;function b(i,c){if(!i.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!g.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(i,c){return!i&&!c?"file":i}function w(i,c){switch(i){case"https":case"http":case"file":c?c[0]!==I&&(c=I+c):c=I;break}return c}const A="",I="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(c){return c instanceof k?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,h,y,C,$,f=!1){typeof c=="object"?(this.scheme=c.scheme||A,this.authority=c.authority||A,this.path=c.path||A,this.query=c.query||A,this.fragment=c.fragment||A):(this.scheme=E(c,f),this.authority=h||A,this.path=w(this.scheme,y||A),this.query=C||A,this.fragment=$||A,b(this,f))}get fsPath(){return m(this,!1)}with(c){if(!c)return this;let{scheme:h,authority:y,path:C,query:$,fragment:f}=c;return h===void 0?h=this.scheme:h===null&&(h=A),y===void 0?y=this.authority:y===null&&(y=A),C===void 0?C=this.path:C===null&&(C=A),$===void 0?$=this.query:$===null&&($=A),f===void 0?f=this.fragment:f===null&&(f=A),h===this.scheme&&y===this.authority&&C===this.path&&$===this.query&&f===this.fragment?this:new u(h,y,C,$,f)}static parse(c,h=!1){const y=v.exec(c);return y?new u(y[2]||A,o(y[4]||A),o(y[5]||A),o(y[7]||A),o(y[9]||A),h):new u(A,A,A,A,A)}static file(c){let h=A;if(T.$j&&(c=c.replace(/\\/g,I)),c[0]===I&&c[1]===I){const y=c.indexOf(I,2);y===-1?(h=c.substring(2),c=I):(h=c.substring(2,y),c=c.substring(y)||I)}return new u("file",h,c,A,A)}static from(c,h){return new u(c.scheme,c.authority,c.path,c.query,c.fragment,h)}static joinPath(c,...h){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return T.$j&&c.scheme==="file"?y=k.file(D.$ec.join(m(c,!0),...h)).path:y=D.$fc.join(c.path,...h),c.with({path:y})}toString(c=!1){return l(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof k)return c;{const h=new u(c);return h._formatted=c.external??null,h._fsPath=c._sep===p?c.fsPath??null:null,h}}else return c}}e.URI=k;function S(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$uc=S;const p=T.$j?1:void 0;class u extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(c=!1){return c?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=p),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function s(i,c,h){let y,C=-1;for(let $=0;$<i.length;$++){const f=i.charCodeAt($);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||c&&f===47||h&&f===91||h&&f===93||h&&f===58)C!==-1&&(y+=encodeURIComponent(i.substring(C,$)),C=-1),y!==void 0&&(y+=i.charAt($));else{y===void 0&&(y=i.substr(0,$));const d=r[f];d!==void 0?(C!==-1&&(y+=encodeURIComponent(i.substring(C,$)),C=-1),y+=d):C===-1&&(C=$)}}return C!==-1&&(y+=encodeURIComponent(i.substring(C))),y!==void 0?y:i}function a(i){let c;for(let h=0;h<i.length;h++){const y=i.charCodeAt(h);y===35||y===63?(c===void 0&&(c=i.substr(0,h)),c+=r[y]):c!==void 0&&(c+=i[h])}return c!==void 0?c:i}function m(i,c){let h;return i.authority&&i.path.length>1&&i.scheme==="file"?h=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?c?h=i.path.substr(1):h=i.path[1].toLowerCase()+i.path.substr(2):h=i.path,T.$j&&(h=h.replace(/\//g,"\\")),h}e.$vc=m;function l(i,c){const h=c?a:s;let y="",{scheme:C,authority:$,path:f,query:d,fragment:P}=i;if(C&&(y+=C,y+=":"),($||C==="file")&&(y+=I,y+=I),$){let N=$.indexOf("@");if(N!==-1){const O=$.substr(0,N);$=$.substr(N+1),N=O.lastIndexOf(":"),N===-1?y+=h(O,!1,!1):(y+=h(O.substr(0,N),!1,!1),y+=":",y+=h(O.substr(N+1),!1,!0)),y+="@"}$=$.toLowerCase(),N=$.lastIndexOf(":"),N===-1?y+=h($,!1,!0):(y+=h($.substr(0,N),!1,!0),y+=$.substr(N))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const N=f.charCodeAt(1);N>=65&&N<=90&&(f=`/${String.fromCharCode(N+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const N=f.charCodeAt(0);N>=65&&N<=90&&(f=`${String.fromCharCode(N+32)}:${f.substr(2)}`)}y+=h(f,!0,!1)}return d&&(y+="?",y+=h(d,!1,!1)),P&&(y+="#",y+=c?P:s(P,!1,!1)),y}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(i){return i.match(n)?i.replace(n,c=>t(c)):i}}),define(De[181],Ce([1,0,2]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Sp=e.$Rp=e.$Qp=void 0;function T(w){const A=w;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$Qp=T;function g(w){const A=[];let I;try{const v=JSON.parse(w.arguments),k=v[v.length-1];k&&k.__$stack&&(v.pop(),I=k.__$stack),A.push(...v)}catch{A.push("Unable to log remote console arguments",w.arguments)}return{args:A,stack:I}}e.$Rp=g;function L(w){if(typeof w!="string")return L(g(w).stack);const A=w;if(A){const I=R(A),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(v&&v.length===4)return{uri:D.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$Sp=L;function R(w){if(!w)return w;const A=w.indexOf(`
`);return A===-1?w:w.substring(0,A)}function b(w,A){const{args:I,stack:v}=g(w),k=typeof I[0]=="string"&&I.length===1;let S=R(v);S&&(S=`(${S.trim()})`);let p=[];if(typeof I[0]=="string"?S&&k?p=[`%c[${A}] %c${I[0]} %c${S}`,E("blue"),E(""),E("grey")]:p=[`%c[${A}] %c${I[0]}`,E("blue"),E(""),...I.slice(1)]:p=[`%c[${A}]%`,E("blue"),...I],S&&!k&&p.push(S),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,p)}e.log=b;function E(w){return`color: ${w}`}}),define(De[62],Ce([1,0,22,2]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function g(E){return JSON.stringify(E,R)}e.$ih=g;function L(E){let w=JSON.parse(E);return w=b(w),w}e.$jh=L;function R(E,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function b(E,w=0){if(!E||w>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return T.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof D.$ae||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let A=0;A<E.length;++A)E[A]=b(E[A],w+1);else for(const A in E)Object.hasOwnProperty.call(E,A)&&(E[A]=b(E[A],w+1))}return E}e.$kh=b}),define(De[17],Ce([1,0,8,12,2]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.Schemas=void 0;var L;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$6f="vscode-tkn",e.$7f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${L.vscodeRemoteResource}`}set(A,I,v){this.a[A]=I,this.b[A]=v}setConnectionToken(A,I){this.c[A]=I}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(u){return D.$Z(u),A}const I=A.authority;let v=this.a[I];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const k=this.b[I],S=this.c[I];let p=`path=${encodeURIComponent(A.path)}`;return typeof S=="string"&&(p+=`&${e.$7f}=${encodeURIComponent(S)}`),g.URI.from({scheme:T.$p?this.d:L.vscodeRemoteResource,authority:`${v}:${k}`,path:this.f,query:p})}}e.$8f=new R,e.$9f="vs/../../extensions",e.$0f="vs/../../node_modules",e.$$f="vs/../../node_modules.asar",e.$_f="vs/../../node_modules.asar.unpacked",e.$ag="vscode-app";class b{static{this.a=e.$ag}asBrowserUri(A){const I=this.b(A,$e);return this.uriToBrowserUri(I)}uriToBrowserUri(A){return A.scheme===L.vscodeRemote?e.$8f.rewrite(A):A.scheme===L.file&&(T.$n||T.$q&&T.$h.origin===`${L.vscodeFileResource}://${b.a}`)?A.with({scheme:L.vscodeFileResource,authority:A.authority||b.a,query:null,fragment:null}):A}asFileUri(A){const I=this.b(A,$e);return this.uriToFileUri(I)}uriToFileUri(A){return A.scheme===L.vscodeFileResource?A.with({scheme:L.file,authority:A.authority!==b.a?A.authority:null,query:null,fragment:null}):A}b(A,I){return g.URI.isUri(A)?A:g.URI.parse(I.toUrl(A))}}e.$bg=new b;var E;(function(w){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(A.get("3"));const I="vscode-coi";function v(S){let p;typeof S=="string"?p=new URL(S).searchParams:S instanceof URL?p=S.searchParams:g.URI.isUri(S)&&(p=new URL(S.toString(!0)).searchParams);const u=p?.get(I);if(u)return A.get(u)}w.getHeadersFromQuery=v;function k(S,p,u){if(!globalThis.crossOriginIsolated)return;const r=p&&u?"3":u?"2":"1";S instanceof URLSearchParams?S.set(I,r):S[I]=r}w.addSearchParam=k})(E||(e.COI=E={}))}),define(De[182],Ce([1,0,156,17,12,2]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=void 0;class R{constructor(v,k,S){this.id=v,this.dependencies=k,this.callback=S}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(v,k,S)=>{typeof v!="string"&&(S=k,k=v,v=null),(typeof k!="object"||!Array.isArray(k))&&(S=k,k=null),this.c.push(new R(v,k,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this.g();const k=await(this.a?this.i(v):this.b?this.h(v):this.j(v));if(!k)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h(v){return new Promise((k,S)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const u=()=>{p.removeEventListener("load",r),p.removeEventListener("error",s)},r=a=>{u(),k(this.c.pop())},s=a=>{u(),S(a)};p.addEventListener("load",r),p.addEventListener("error",s),this.f&&(v=this.f.createScriptURL(v)),p.setAttribute("src",v),document.getElementsByTagName("head")[0].appendChild(p)})}i(v){return new Promise((k,S)=>{try{this.f&&(v=this.f.createScriptURL(v)),importScripts(v),k(this.c.pop())}catch(p){S(p)}})}async j(v){try{const k=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,u=L.URI.parse(v).fsPath,r=k.readFileSync(u).toString(),s=p.wrap(r.replace(/^#!.*/,""));return new S.Script(s).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}const E=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function A(I,v,k){if(D.$S){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[I]&&(I=w[I]);const S=`${I}/${v}`;if(E.has(S))return E.get(S);let p;if(/^\w[\w\d+.-]*:\/\//.test(S))p=S;else{const a=`${k&&!g.$p?T.$$f:T.$0f}/${S}`;p=T.$bg.asBrowserUri(a).toString(!0)}const u=b.INSTANCE.load(p);return E.set(S,u),u}else return await new Promise((S,p)=>{$e([I],S,p)})}e.$fC=A}),define(De[24],Ce([1,0,32,17,16,12,15,2]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.DataUri=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function E(k){return(0,b.$vc)(k,!0)}e.$ig=E;class w{constructor(S){this.a=S}compare(S,p,u=!1){return S===p?0:(0,R.$Te)(this.getComparisonKey(S,u),this.getComparisonKey(p,u))}isEqual(S,p,u=!1){return S===p?!0:!S||!p?!1:this.getComparisonKey(S,u)===this.getComparisonKey(p,u)}getComparisonKey(S,p=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,p,u=!1){if(S.scheme===p.scheme){if(S.scheme===T.Schemas.file)return D.$Wf(E(S),E(p),this.a(S))&&S.query===p.query&&(u||S.fragment===p.fragment);if((0,e.$zg)(S.authority,p.authority))return D.$Wf(S.path,p.path,this.a(S),"/")&&S.query===p.query&&(u||S.fragment===p.fragment)}return!1}joinPath(S,...p){return b.URI.joinPath(S,...p)}basenameOrAuthority(S){return(0,e.$rg)(S)||S.authority}basename(S){return g.$fc.basename(S.path)}extname(S){return g.$fc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let p;return S.scheme===T.Schemas.file?p=b.URI.file(g.$lc(E(S))).path:(p=g.$fc.dirname(S.path),S.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),p="/")),S.with({path:p})}normalizePath(S){if(!S.path.length)return S;let p;return S.scheme===T.Schemas.file?p=b.URI.file(g.$gc(E(S))).path:p=g.$fc.normalize(S.path),S.with({path:p})}relativePath(S,p){if(S.scheme!==p.scheme||!(0,e.$zg)(S.authority,p.authority))return;if(S.scheme===T.Schemas.file){const s=g.$kc(E(S),E(p));return L.$j?D.$Qf(s):s}let u=S.path||"/";const r=p.path||"/";if(this.a(S)){let s=0;for(const a=Math.min(u.length,r.length);s<a&&!(u.charCodeAt(s)!==r.charCodeAt(s)&&u.charAt(s).toLowerCase()!==r.charAt(s).toLowerCase());s++);u=r.substr(0,s)+u.substr(s)}return g.$fc.relative(u,r)}resolvePath(S,p){if(S.scheme===T.Schemas.file){const u=b.URI.file(g.$jc(E(S),p));return S.with({authority:u.authority,path:u.path})}return p=D.$Rf(p),S.with({path:g.$fc.resolve(S.path,p)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,p){return S===p||S!==void 0&&p!==void 0&&(0,R.$1e)(S,p)}hasTrailingPathSeparator(S,p=g.sep){if(S.scheme===T.Schemas.file){const u=E(S);return u.length>D.$Sf(u).length&&u[u.length-1]===p}else{const u=S.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,p=g.sep){return(0,e.$Ag)(S,p)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,p=g.sep){let u=!1;if(S.scheme===T.Schemas.file){const r=E(S);u=r!==void 0&&r.length===D.$Sf(r).length&&r[r.length-1]===p}else{p="/";const r=S.path;u=r.length===1&&r.charCodeAt(r.length-1)===47}return!u&&!(0,e.$Ag)(S,p)?S.with({path:S.path+"/"}):S}}e.$jg=w,e.$kg=new w(()=>!1),e.$lg=new w(k=>k.scheme===T.Schemas.file?!L.$l:!0),e.$mg=new w(k=>!0),e.$ng=e.$kg.isEqual.bind(e.$kg),e.$og=e.$kg.isEqualOrParent.bind(e.$kg),e.$pg=e.$kg.getComparisonKey.bind(e.$kg),e.$qg=e.$kg.basenameOrAuthority.bind(e.$kg),e.$rg=e.$kg.basename.bind(e.$kg),e.$sg=e.$kg.extname.bind(e.$kg),e.$tg=e.$kg.dirname.bind(e.$kg),e.$ug=e.$kg.joinPath.bind(e.$kg),e.$vg=e.$kg.normalizePath.bind(e.$kg),e.$wg=e.$kg.relativePath.bind(e.$kg),e.$xg=e.$kg.resolvePath.bind(e.$kg),e.$yg=e.$kg.isAbsolutePath.bind(e.$kg),e.$zg=e.$kg.isEqualAuthority.bind(e.$kg),e.$Ag=e.$kg.hasTrailingPathSeparator.bind(e.$kg),e.$Bg=e.$kg.removeTrailingPathSeparator.bind(e.$kg),e.$Cg=e.$kg.addTrailingPathSeparator.bind(e.$kg);function A(k,S){const p=[];for(let u=0;u<k.length;u++){const r=S(k[u]);k.some((s,a)=>a===u?!1:(0,e.$og)(r,S(s)))||p.push(k[u])}return p}e.$Dg=A;var I;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function S(p){const u=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(a=>{const[m,l]=a.split(":");m&&l&&u.set(m,l)});const s=p.path.substring(0,p.path.indexOf(";"));return s&&u.set(k.META_DATA_MIME,s),u}k.parseMetaData=S})(I||(e.DataUri=I={}));function v(k,S,p){if(S){let u=k.path;return u&&u[0]!==g.$fc.sep&&(u=g.$fc.sep+u),k.with({scheme:p,authority:S,path:u})}return k.with({scheme:p})}e.$Eg=v}),define(De[11],Ce([1,0,21,8,4,3,24,12,160]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eh=e.$dh=e.$ch=e.Promises=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function w(z){return!!z&&typeof z.then=="function"}e.$Fg=w;function A(z){const K=new D.$Wd,ge=z(K.token),_=new Promise((ie,ne)=>{const Ee=K.token.onCancellationRequested(()=>{Ee.dispose(),K.dispose(),ne(new T.$4)});Promise.resolve(ge).then(oe=>{Ee.dispose(),K.dispose(),ie(oe)},oe=>{Ee.dispose(),K.dispose(),ne(oe)})});return new class{cancel(){K.cancel()}then(ie,ne){return _.then(ie,ne)}catch(ie){return this.then(void 0,ie)}finally(ie){return _.finally(ie)}}}e.$Gg=A;function I(z,K,ge){return new Promise((_,ie)=>{const ne=K.onCancellationRequested(()=>{ne.dispose(),_(ge)});z.then(_,ie).finally(()=>ne.dispose())})}e.$Hg=I;function v(z,K){return new Promise((ge,_)=>{const ie=K.onCancellationRequested(()=>{ie.dispose(),_(new T.$4)});z.then(ge,_).finally(()=>ie.dispose())})}e.$Ig=v;async function k(z){let K=-1;const ge=z.map((_,ie)=>_.then(ne=>(K=ie,ne)));try{return await Promise.race(ge)}finally{z.forEach((_,ie)=>{ie!==K&&_.cancel()})}}e.$Jg=k;function S(z,K,ge){let _;const ie=setTimeout(()=>{_?.(void 0),ge?.()},K);return Promise.race([z.finally(()=>clearTimeout(ie)),new Promise(ne=>_=ne)])}e.$Kg=S;function p(z){return new Promise((K,ge)=>{const _=z();w(_)?_.then(K,ge):K(_)})}e.$Lg=p;class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const ge=()=>{if(this.b=null,this.f)return;const _=this.queue(this.d);return this.d=null,_};this.b=new Promise(_=>{this.a.then(ge,ge).then(_)})}return new Promise((ge,_)=>{this.b.then(ge,_)})}return this.a=K(),new Promise((ge,_)=>{this.a.then(ie=>{this.a=null,ge(ie)},ie=>{this.a=null,_(ie)})})}dispose(){this.f=!0}}e.$Mg=u;class r{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$Ng=r;class s{constructor(){this.a=new Map}queue(K,ge){const ie=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.a.get(K)===ie&&this.a.delete(K)});return this.a.set(K,ie),ie}}e.$Og=s;const a=(z,K)=>{let ge=!0;const _=setTimeout(()=>{ge=!1,K()},z);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(_),ge=!1}}},m=z=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,z())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class l{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,ge=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((ie,ne)=>{this.d=ie,this.f=ne}).then(()=>{if(this.b=null,this.d=null,this.g){const ie=this.g;return this.g=null,ie()}}));const _=()=>{this.a=null,this.d?.(null)};return this.a=ge===E.$Jd?m(_):a(ge,_),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Pg=l;class t{constructor(K){this.a=new l(K),this.b=new u}trigger(K,ge){return this.a.trigger(()=>this.b.queue(K),ge)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Qg=t;class n{constructor(){this.a=!1,this.b=new Promise((K,ge)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Rg=n;class o extends n{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$Sg=o;function i(z,K){return K?new Promise((ge,_)=>{const ie=setTimeout(()=>{ne.dispose(),ge()},z),ne=K.onCancellationRequested(()=>{clearTimeout(ie),ne.dispose(),_(new T.$4)})}):A(ge=>i(z,ge))}e.$Tg=i;function c(z,K=0,ge){const _=setTimeout(()=>{z(),ge&&ie.dispose()},K),ie=(0,L.$Pc)(()=>{clearTimeout(_),ge?.deleteAndLeak(ie)});return ge?.add(ie),ie}e.$Ug=c;function h(z){const K=[];let ge=0;const _=z.length;function ie(){return ge<_?z[ge++]():null}function ne(Ee){Ee!=null&&K.push(Ee);const oe=ie();return oe?oe.then(ne):Promise.resolve(K)}return Promise.resolve(null).then(ne)}e.$Vg=h;function y(z,K=_=>!!_,ge=null){let _=0;const ie=z.length,ne=()=>{if(_>=ie)return Promise.resolve(ge);const Ee=z[_++];return Promise.resolve(Ee()).then(he=>K(he)?Promise.resolve(he):ne())};return ne()}e.$Wg=y;function C(z,K=_=>!!_,ge=null){if(z.length===0)return Promise.resolve(ge);let _=z.length;const ie=()=>{_=-1;for(const ne of z)ne.cancel?.()};return new Promise((ne,Ee)=>{for(const oe of z)oe.then(he=>{--_>=0&&K(he)?(ie(),ne(he)):_===0&&ne(ge)}).catch(he=>{--_>=0&&(ie(),Ee(he))})})}e.$Xg=C;class ${constructor(K){this.a=0,this.d=K,this.f=[],this.b=0,this.g=new g.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(K){return this.a++,new Promise((ge,_)=>{this.f.push({factory:K,c:ge,e:_}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const K=this.f.shift();this.b++;const ge=K.factory();ge.then(K.c,K.e),ge.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Yg=$;class f extends ${constructor(){super(1)}}e.$Zg=f;class d{constructor(){this.a=new fe,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$1g=d;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new q;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueFor(K,ge=R.$kg){const _=ge.getComparisonKey(K);let ie=this.a.get(_);if(!ie){ie=new f;const ne=this.f++,Ee=g.Event.once(ie.onDrained)(()=>{ie?.dispose(),this.a.delete(_),this.h(),this.d?.deleteAndDispose(ne),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$Zc),this.d.set(ne,Ee),this.a.set(_,ie)}return ie}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$2g=P;class N{constructor(K,ge){this.a=-1,typeof K=="function"&&typeof ge=="number"&&this.setIfNotSet(K,ge)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,ge){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},ge)}setIfNotSet(K,ge){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},ge))}}e.$3g=N;class O{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(K,ge){this.cancel(),this.a=setInterval(()=>{K()},ge)}}e.$4g=O;class M{constructor(K,ge){this.b=-1,this.a=K,this.d=ge,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$5g=M;class j{constructor(K,ge){ge%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.a=K,this.b=ge,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$6g=j;class U extends M{constructor(K,ge){super(K,ge),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$7g=U;class F extends L.$Rc{constructor(K,ge){super(),this.g=K,this.h=ge,this.a=[],this.b=this.B(new L.$Sc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ge of K)this.a.push(ge);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$8g=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$9g=z=>{(0,b.$B)(()=>{if(K)return;const ge=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let K=!1;return{dispose(){K||(K=!0)}}}:e.$9g=(z,K)=>{const ge=requestIdleCallback(z,typeof K=="number"?{timeout:K}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(ge))}}}}();class V{constructor(K){this.d=!1,this.a=()=>{try{this.f=K()}catch(ge){this.g=ge}finally{this.d=!0}},this.b=(0,e.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$0g=V;async function H(z,K,ge){let _;for(let ie=0;ie<ge;ie++)try{return await z()}catch(ne){_=ne,await i(K)}throw _}e.$$g=H;class fe{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,ge,_){return this.a={taskId:K,cancel:()=>_?.(),promise:ge},ge.then(()=>this.d(K),()=>this.d(K)),ge}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{let ge,_;const ie=new Promise((ne,Ee)=>{ge=ne,_=Ee});this.b={run:K,promise:ie,promiseResolve:ge,promiseReject:_}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$_g=fe;class X{constructor(K,ge=()=>Date.now()){this.d=K,this.f=ge,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$ah=X;var Y;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(Y||(Y={}));class q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,ge)=>{this.a=K,this.b=ge})}complete(K){return new Promise(ge=>{this.a(K),this.d={outcome:0,value:K},ge()})}error(K){return new Promise(ge=>{this.b(K),this.d={outcome:1,value:K},ge()})}cancel(){return this.error(new T.$4)}}e.$bh=q;var x;(function(z){async function K(_){let ie;const ne=await Promise.all(_.map(Ee=>Ee.then(oe=>oe,oe=>{ie||(ie=oe)})));if(typeof ie<"u")throw ie;return ne}z.settled=K;function ge(_){return new Promise(async(ie,ne)=>{try{await _(ie,ne)}catch(Ee){ne(Ee)}})}z.withAsyncBody=ge})(x||(e.Promises=x={}));var me;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(me||(me={}));class ue{static fromArray(K){return new ue(ge=>{ge.emitMany(K)})}static fromPromise(K){return new ue(async ge=>{ge.emitMany(await K)})}static fromPromises(K){return new ue(async ge=>{await Promise.all(K.map(async _=>ge.emitOne(await _)))})}static merge(K){return new ue(async ge=>{await Promise.all(K.map(async _=>{for await(const ie of _)ge.emitOne(ie)}))})}static{this.EMPTY=ue.fromArray([])}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new g.$Md,queueMicrotask(async()=>{const ge={emitOne:_=>this.g(_),emitMany:_=>this.h(_),reject:_=>this.k(_)};try{await Promise.resolve(K(ge)),this.j()}catch(_){this.k(_)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(K,ge){return new ue(async _=>{for await(const ie of K)_.emitOne(ge(ie))})}map(K){return ue.map(this,K)}static filter(K,ge){return new ue(async _=>{for await(const ie of K)ge(ie)&&_.emitOne(ie)})}filter(K){return ue.filter(this,K)}static coalesce(K){return ue.filter(K,ge=>!!ge)}coalesce(){return ue.coalesce(this)}static async toPromise(K){const ge=[];for await(const _ of K)ge.push(_);return ge}toPromise(){return ue.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.$ch=ue;class pe extends ue{constructor(K,ge){super(ge),this.l=K}cancel(){this.l.cancel()}}e.$dh=pe;function G(z){const K=new D.$Wd,ge=z(K.token);return new pe(K,async _=>{const ie=K.token.onCancellationRequested(()=>{ie.dispose(),K.dispose(),_.reject(new T.$4)});try{for await(const ne of ge){if(K.token.isCancellationRequested)return;_.emitOne(ne)}ie.dispose(),K.dispose()}catch(ne){ie.dispose(),K.dispose(),_.reject(ne)}})}e.$eh=G}),define(De[35],Ce([1,0,19,11,32,28,16,12,15]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0;function w(){return Object.create(null)}e.$pj=w,e.$qj="**",e.$rj="/";const A="[/\\\\]",I="[^/\\\\]",v=/\//g;function k(fe,X){switch(fe){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}${X?`|${A}${I}+`:""})*?`}}function S(fe,X){if(!fe)return[];const Y=[];let q=!1,x=!1,me="";for(const ue of fe){switch(ue){case X:if(!q&&!x){Y.push(me),me="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":x=!0;break;case"]":x=!1;break}me+=ue}return me&&Y.push(me),Y}e.$sj=S;function p(fe){if(!fe)return"";let X="";const Y=S(fe,e.$rj);if(Y.every(q=>q===e.$qj))X=".*";else{let q=!1;Y.forEach((x,me)=>{if(x===e.$qj){if(q)return;X+=k(2,me===Y.length-1)}else{let ue=!1,pe="",G=!1,z="";for(const K of x){if(K!=="}"&&ue){pe+=K;continue}if(G&&(K!=="]"||!z)){let ge;K==="-"?ge=K:(K==="^"||K==="!")&&!z?ge="^":K===e.$rj?ge="":ge=(0,E.$Ee)(K),z+=ge;continue}switch(K){case"{":ue=!0;continue;case"[":G=!0;continue;case"}":{const _=`(?:${S(pe,",").map(ie=>p(ie)).join("|")})`;X+=_,ue=!1,pe="";break}case"]":{X+="["+z+"]",G=!1,z="";break}case"?":X+=I;continue;case"*":X+=k(1);continue;default:X+=(0,E.$Ee)(K)}}me<Y.length-1&&(Y[me+1]!==e.$qj||me+2<Y.length)&&(X+=A)}q=x===e.$qj})}return X}const u=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,s=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Cc(1e4),n=function(){return!1},o=function(){return null};function i(fe,X){if(!fe)return o;let Y;typeof fe!="string"?Y=fe.pattern:Y=fe,Y=Y.trim();const q=`${Y}_${!!X.trimForExclusions}`;let x=t.get(q);if(x)return c(x,fe);let me;return u.test(Y)?x=y(Y.substr(4),Y):(me=r.exec(h(Y,X)))?x=C(me[1],Y):(X.trimForExclusions?a:s).test(Y)?x=$(Y,X):(me=m.exec(h(Y,X)))?x=f(me[1].substr(1),Y,!0):(me=l.exec(h(Y,X)))?x=f(me[1],Y,!1):x=d(Y),t.set(q,x),c(x,fe)}function c(fe,X){if(typeof X=="string")return fe;const Y=function(q,x){return(0,g.$Wf)(q,X.base,!b.$l)?fe((0,E.$Ie)(q.substr(X.base.length),R.sep),x):null};return Y.allBasenames=fe.allBasenames,Y.allPaths=fe.allPaths,Y.basenames=fe.basenames,Y.patterns=fe.patterns,Y}function h(fe,X){return X.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function y(fe,X){return function(Y,q){return typeof Y=="string"&&Y.endsWith(fe)?X:null}}function C(fe,X){const Y=`/${fe}`,q=`\\${fe}`,x=function(ue,pe){return typeof ue!="string"?null:pe?pe===fe?X:null:ue===fe||ue.endsWith(Y)||ue.endsWith(q)?X:null},me=[fe];return x.basenames=me,x.patterns=[X],x.allBasenames=me,x}function $(fe,X){const Y=V(fe.slice(1,-1).split(",").map(pe=>i(pe,X)).filter(pe=>pe!==o),fe),q=Y.length;if(!q)return o;if(q===1)return Y[0];const x=function(pe,G){for(let z=0,K=Y.length;z<K;z++)if(Y[z](pe,G))return fe;return null},me=Y.find(pe=>!!pe.allBasenames);me&&(x.allBasenames=me.allBasenames);const ue=Y.reduce((pe,G)=>G.allPaths?pe.concat(G.allPaths):pe,[]);return ue.length&&(x.allPaths=ue),x}function f(fe,X,Y){const q=R.sep===R.$fc.sep,x=q?fe:fe.replace(v,R.sep),me=R.sep+x,ue=R.$fc.sep+fe;let pe;return Y?pe=function(G,z){return typeof G=="string"&&(G===x||G.endsWith(me)||!q&&(G===fe||G.endsWith(ue)))?X:null}:pe=function(G,z){return typeof G=="string"&&(G===x||!q&&G===fe)?X:null},pe.allPaths=[(Y?"*/":"./")+fe],pe}function d(fe){try{const X=new RegExp(`^${p(fe)}$`);return function(Y){return X.lastIndex=0,typeof Y=="string"&&X.test(Y)?fe:null}}catch{return o}}function P(fe,X,Y){return!fe||typeof X!="string"?!1:N(fe)(X,void 0,Y)}e.$tj=P;function N(fe,X={}){if(!fe)return n;if(typeof fe=="string"||O(fe)){const Y=i(fe,X);if(Y===o)return n;const q=function(x,me){return!!Y(x,me)};return Y.allBasenames&&(q.allBasenames=Y.allBasenames),Y.allPaths&&(q.allPaths=Y.allPaths),q}return U(fe,X)}e.$uj=N;function O(fe){const X=fe;return X?typeof X.base=="string"&&typeof X.pattern=="string":!1}e.$vj=O;function M(fe){return fe.allBasenames||[]}e.$wj=M;function j(fe){return fe.allPaths||[]}e.$xj=j;function U(fe,X){const Y=V(Object.getOwnPropertyNames(fe).map(pe=>F(pe,fe[pe],X)).filter(pe=>pe!==o)),q=Y.length;if(!q)return o;if(!Y.some(pe=>!!pe.requiresSiblings)){if(q===1)return Y[0];const pe=function(K,ge){let _;for(let ie=0,ne=Y.length;ie<ne;ie++){const Ee=Y[ie](K,ge);if(typeof Ee=="string")return Ee;(0,T.$Fg)(Ee)&&(_||(_=[]),_.push(Ee))}return _?(async()=>{for(const ie of _){const ne=await ie;if(typeof ne=="string")return ne}return null})():null},G=Y.find(K=>!!K.allBasenames);G&&(pe.allBasenames=G.allBasenames);const z=Y.reduce((K,ge)=>ge.allPaths?K.concat(ge.allPaths):K,[]);return z.length&&(pe.allPaths=z),pe}const x=function(pe,G,z){let K,ge;for(let _=0,ie=Y.length;_<ie;_++){const ne=Y[_];ne.requiresSiblings&&z&&(G||(G=(0,R.$mc)(pe)),K||(K=G.substr(0,G.length-(0,R.$nc)(pe).length)));const Ee=ne(pe,G,K,z);if(typeof Ee=="string")return Ee;(0,T.$Fg)(Ee)&&(ge||(ge=[]),ge.push(Ee))}return ge?(async()=>{for(const _ of ge){const ie=await _;if(typeof ie=="string")return ie}return null})():null},me=Y.find(pe=>!!pe.allBasenames);me&&(x.allBasenames=me.allBasenames);const ue=Y.reduce((pe,G)=>G.allPaths?pe.concat(G.allPaths):pe,[]);return ue.length&&(x.allPaths=ue),x}function F(fe,X,Y){if(X===!1)return o;const q=i(fe,Y);if(q===o)return o;if(typeof X=="boolean")return q;if(X){const x=X.when;if(typeof x=="string"){const me=(ue,pe,G,z)=>{if(!z||!q(ue,pe))return null;const K=x.replace("$(basename)",()=>G),ge=z(K);return(0,T.$Fg)(ge)?ge.then(_=>_?fe:null):ge?fe:null};return me.requiresSiblings=!0,me}}return q}function V(fe,X){const Y=fe.filter(pe=>!!pe.basenames);if(Y.length<2)return fe;const q=Y.reduce((pe,G)=>{const z=G.basenames;return z?pe.concat(z):pe},[]);let x;if(X){x=[];for(let pe=0,G=q.length;pe<G;pe++)x.push(X)}else x=Y.reduce((pe,G)=>{const z=G.patterns;return z?pe.concat(z):pe},[]);const me=function(pe,G){if(typeof pe!="string")return null;if(!G){let K;for(K=pe.length;K>0;K--){const ge=pe.charCodeAt(K-1);if(ge===47||ge===92)break}G=pe.substr(K)}const z=q.indexOf(G);return z!==-1?x[z]:null};me.basenames=q,me.patterns=x,me.allBasenames=q;const ue=fe.filter(pe=>!pe.basenames);return ue.push(me),ue}function H(fe,X){return(0,D.$tb)(fe,X,(Y,q)=>typeof Y=="string"&&typeof q=="string"?Y===q:typeof Y!="string"&&typeof q!="string"?Y.base===q.base&&Y.pattern===q.pattern:!1)}e.$yj=H}),define(De[79],Ce([1,0,8,161,24,15,2]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class E{constructor(r="",s=!1){if(this.value=r,typeof this.value!="string")throw(0,D.$6)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(r,s=0){return this.value+=v(this.supportThemeIcons?(0,T.$Uj)(r):r).replace(/([ \t]+)/g,(a,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(r){return this.value+=r,this}appendCodeblock(r,s){return this.value+="\n```",this.value+=r,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(r,s,a){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String(r),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(r,s){const a=new RegExp((0,L.$Ee)(s),"g");return r.replace(a,(m,l)=>r.charAt(l-1)!=="\\"?`\\${m}`:m)}}e.$1j=E;function w(u){return A(u)?!u.value:Array.isArray(u)?u.every(w):!0}e.$2j=w;function A(u){return u instanceof E?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||typeof u.isTrusted=="object"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.$3j=A;function I(u,r){return u===r?!0:!u||!r?!1:u.value===r.value&&u.isTrusted===r.isTrusted&&u.supportThemeIcons===r.supportThemeIcons&&u.supportHtml===r.supportHtml&&(u.baseUri===r.baseUri||!!u.baseUri&&!!r.baseUri&&(0,g.$ng)(R.URI.from(u.baseUri),R.URI.from(r.baseUri)))}e.$4j=I;function v(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$5j=v;function k(u){return u.replace(/"/g,"&quot;")}e.$6j=k;function S(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$7j=S;function p(u){const r=[],s=u.split("|").map(m=>m.trim());u=s[0];const a=s[1];if(a){const m=/height=(\d+)/.exec(a),l=/width=(\d+)/.exec(a),t=m?m[1]:"",n=l?l[1]:"",o=isFinite(parseInt(n)),i=isFinite(parseInt(t));o&&r.push(`width="${n}"`),i&&r.push(`height="${t}"`)}return{href:u,dimensions:r}}e.$8j=p}),define(De[100],Ce([1,0,19,32,16,12,24,15]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=void 0;function E(i,c){const{os:h,tildify:y,relative:C}=c;if(C){const d=w(i,C,h);if(typeof d=="string")return d}let $=i.fsPath;if(h===1&&!L.$j?$=$.replace(/\//g,"\\"):h!==1&&L.$j&&($=$.replace(/\\/g,"/")),h!==1&&y?.userHome){const d=y.userHome.fsPath;let P;i.scheme!==y.userHome.scheme&&i.path.startsWith(g.$fc.sep)?P=y.userHome.with({path:i.path}).fsPath:P=i.fsPath,$=v(P,d,h)}return(h===1?g.$ec:g.$fc).normalize(A($,h===1))}e.$kv=E;function w(i,c,h){const y=h===1?g.$ec:g.$fc,C=h===3?R.$kg:R.$mg,$=c.getWorkspace(),f=(0,D.$Nb)($.folders);if(!f)return;i.scheme!==f.uri.scheme&&i.path.startsWith(g.$fc.sep)&&(i=f.uri.with({path:i.path}));const d=c.getWorkspaceFolder(i);if(!d)return;let P;if(C.isEqual(d.uri,i)?P="":P=C.relativePath(d.uri,i)??"",P&&(P=y.normalize(P)),$.folders.length>1&&!c.noPrefix){const N=d.name?d.name:C.basenameOrAuthority(d.uri);P=P?`${N} \u2022 ${P}`:N}return P}function A(i,c=L.$j){return(0,T.$1f)(i,c)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$lv=A;let I=Object.create(null);function v(i,c,h=L.OS){if(h===1||!i||!c)return i;let y=I.original===c?I.normalized:void 0;y||(y=c,L.$j&&(y=(0,T.$Qf)(y)),y=`${(0,b.$Je)(y,g.$fc.sep)}${g.$fc.sep}`,I={original:c,normalized:y});let C=i;return L.$j&&(C=(0,T.$Qf)(C)),(h===3?C.startsWith(y):(0,b.$2e)(C,y))?`~/${C.substr(y.length)}`:i}e.$mv=v;function k(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.$nv=k;const S="\u2026",p="\\\\",u="~";function r(i,c=g.sep){const h=new Array(i.length);let y=!1;for(let C=0;C<i.length;C++){const $=i[C];if($===""){h[C]=`.${c}`;continue}if(!$){h[C]=$;continue}y=!0;let f="",d=$;d.indexOf(p)===0?(f=d.substr(0,d.indexOf(p)+p.length),d=d.substr(d.indexOf(p)+p.length)):d.indexOf(c)===0?(f=d.substr(0,d.indexOf(c)+c.length),d=d.substr(d.indexOf(c)+c.length)):d.indexOf(u)===0&&(f=d.substr(0,d.indexOf(u)+u.length),d=d.substr(d.indexOf(u)+u.length));const P=d.split(c);for(let N=1;y&&N<=P.length;N++)for(let O=P.length-N;y&&O>=0;O--){y=!1;let M=P.slice(O,O+N).join(c);for(let j=0;!y&&j<i.length;j++)if(j!==C&&i[j]&&i[j].indexOf(M)>-1){const U=O+N===P.length,F=O>0&&i[j].indexOf(c)>-1?c+M:M,V=i[j].endsWith(F);y=!U||V}if(!y){let j="";(P[0].endsWith(":")||f!=="")&&(O===1&&(O=0,N++,M=P[0]+c+M),O>0&&(j=P[0]+c),j=f+j),O>0&&(j=j+S+c),j=j+M,O+N<P.length&&(j=j+c+S),h[C]=j}}y&&(h[C]=$)}return h}e.$ov=r;var s;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function a(i,c=Object.create(null)){const h=[];let y=!1,C="";for(const $ of i)if($==="$"||y&&$==="{")C&&h.push({value:C,type:s.TEXT}),C="",y=!0;else if($==="}"&&y){const f=c[C];if(typeof f=="string")f.length&&h.push({value:f,type:s.VARIABLE});else if(f){const d=h[h.length-1];(!d||d.type!==s.SEPARATOR)&&h.push({value:f.label,type:s.SEPARATOR})}C="",y=!1}else C+=$;return C&&!y&&h.push({value:C,type:s.TEXT}),h.filter(($,f)=>{if($.type===s.SEPARATOR){const d=h[f-1],P=h[f+1];return[d,P].every(N=>N&&(N.type===s.VARIABLE||N.type===s.TEXT)&&N.value.length>0)}return!0}).map($=>$.value).join("")}e.$pv=a;function m(i,c){return L.$k||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$k?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$qv=m;function l(i,c){return L.$k||c?i.replace(/\(&&\w\)|&&/g,""):L.$j?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$rv=l;function t(i){return i.replace(/&/g,"&&")}e.$sv=t;function n(i){if(i.endsWith("]")){const c=i.lastIndexOf(" [",i.length-2);if(c!==-1){const h=o(i.substring(0,c));return{name:h.name,parentPath:h.parentPath+i.substring(c)}}}return o(i)}e.$tv=n;function o(i){const c=i.indexOf("/")!==-1?g.$fc:g.$ec,h=c.basename(i),y=c.dirname(i);return h.length?{name:h,parentPath:y}:{name:y,parentPath:""}}}),define(De[128],Ce([1,0,22,2]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=e.$Gm=e.$Fm=e.$Em=void 0;function g(I){return I.toJSON()}class L{constructor(v){this.a=v}transformIncoming(v){const k=this.a.transformIncoming(v);return k===v?v:g(T.URI.from(k))}transformOutgoing(v){const k=this.a.transformOutgoing(v);return k===v?v:g(T.URI.from(k))}transformOutgoingURI(v){const k=this.a.transformOutgoing(v);return k===v?v:T.URI.from(k)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$Em=L,e.$Fm=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,v,k){if(!I||k>200)return null;if(typeof I=="object"){if(I instanceof T.URI)return v.transformOutgoing(I);for(const S in I)if(Object.hasOwnProperty.call(I,S)){const p=R(I[S],v,k+1);p!==null&&(I[S]=p)}}return null}function b(I,v){const k=R(I,v,0);return k===null?I:k}e.$Gm=b;function E(I,v,k,S){if(!I||S>200)return null;if(typeof I=="object"){if(I.$mid===1)return k?T.URI.revive(v.transformIncoming(I)):v.transformIncoming(I);if(I instanceof D.$ae)return null;for(const p in I)if(Object.hasOwnProperty.call(I,p)){const u=E(I[p],v,k,S+1);u!==null&&(I[p]=u)}}return null}function w(I,v){const k=E(I,v,!1,0);return k===null?I:k}e.$Hm=w;function A(I,v){const k=E(I,v,!0,0);return k===null?I:k}e.$Im=A}),define(De[29],Ce([1,0,53,63,370,11,32,76,16,12,24,2]),function($e,e,D,T,g,L,R,b,E,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function k(F,V=v.UNLINK,H){if((0,R.$Zf)(F))throw new Error("rimraf - will refuse to recursively delete root");return V===v.UNLINK?p(F):S(F,H)}async function S(F,V=(0,R.$5f)((0,T.tmpdir)())){try{try{await D.promises.rename(F,V)}catch(H){return H.code==="ENOENT"?void 0:p(F)}p(V).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function p(F){return(0,g.promisify)(D.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function u(F){if((0,R.$Zf)(F))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function r(F,V){return m(await(V?s(F):(0,g.promisify)(D.readdir)(F)))}async function s(F){try{return await(0,g.promisify)(D.readdir)(F,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const V=[],H=await r(F);for(const fe of H){let X=!1,Y=!1,q=!1;try{const x=await e.Promises.lstat((0,E.$ic)(F,fe));X=x.isFile(),Y=x.isDirectory(),q=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}V.push({name:fe,isFile:()=>X,isDirectory:()=>Y,isSymbolicLink:()=>q})}return V}function a(F){return m(D.readdirSync(F))}e.readdirSync=a;function m(F){return F.map(V=>typeof V=="string"?w.$k?(0,b.$kl)(V):V:(V.name=w.$k?(0,b.$kl)(V.name):V.name,V))}async function l(F){const V=await r(F),H=[];for(const fe of V)await n.existsDirectory((0,E.$ic)(F,fe))&&H.push(fe);return H}function t(F,V=1e3){return new Promise(H=>{let fe=!1;const X=setInterval(()=>{fe||(fe=!0,D.access(F,Y=>{fe=!1,Y&&(clearInterval(X),H(void 0))}))},V)})}e.whenDeleted=t;var n;(function(F){async function V(X){let Y;try{if(Y=await e.Promises.lstat(X),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(w.$j&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw x}throw q}}F.stat=V;async function H(X){try{const{stat:Y,symbolicLink:q}=await F.stat(X);return Y.isFile()&&q?.dangling!==!0}catch{}return!1}F.existsFile=H;async function fe(X){try{const{stat:Y,symbolicLink:q}=await F.stat(X);return Y.isDirectory()&&q?.dangling!==!0}catch{}return!1}F.existsDirectory=fe})(n||(e.SymlinkSupport=n={}));const o=new L.$2g;function i(F,V,H){return o.queueFor(I.URI.file(F),A.$lg).queue(()=>{const fe=$(H);return new Promise((X,Y)=>y(F,V,fe,q=>q?Y(q):X()))})}let c=!0;function h(F){c=F}e.configureFlushOnWrite=h;function y(F,V,H,fe){if(!c)return D.writeFile(F,V,{mode:H.mode,flag:H.flag},fe);D.open(F,H.flag,H.mode,(X,Y)=>{if(X)return fe(X);D.writeFile(Y,V,q=>{if(q)return D.close(Y,()=>fe(q));D.fdatasync(Y,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),h(!1)),D.close(Y,me=>fe(me))))})})}function C(F,V,H){const fe=$(H);if(!c)return D.writeFileSync(F,V,{mode:fe.mode,flag:fe.flag});const X=D.openSync(F,fe.flag,fe.mode);try{D.writeFileSync(X,V);try{D.fdatasyncSync(X)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),h(!1)}}finally{D.closeSync(X)}}e.writeFileSync=C;function $(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function f(F,V,H=6e4){if(F!==V)try{w.$j&&typeof H=="number"?await d(F,V,Date.now(),H):await(0,g.promisify)(D.rename)(F,V)}catch(fe){if(F.toLowerCase()!==V.toLowerCase()&&fe.code==="EXDEV"||F.endsWith("."))await P(F,V,{preserveSymlinks:!1}),await k(F,v.MOVE);else throw fe}}async function d(F,V,H,fe,X=0){try{return await(0,g.promisify)(D.rename)(F,V)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="EPERM"&&Y.code!=="EBUSY")throw Y;if(Date.now()-H>=fe)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${Y}`),Y;if(X===0){let q=!1;try{const{stat:x}=await n.stat(V);x.isFile()||(q=!0)}catch{}if(q)throw Y}return await(0,L.$Tg)(Math.min(100,X*10)),d(F,V,H,fe,X+1)}}async function P(F,V,H){return O(F,V,{root:{source:F,target:V},options:H,handledSourcePaths:new Set})}const N=511;async function O(F,V,H){if(H.handledSourcePaths.has(F))return;H.handledSourcePaths.add(F);const{stat:fe,symbolicLink:X}=await n.stat(F);if(X){if(H.options.preserveSymlinks)try{return await U(F,V,H)}catch(Y){console.warn("[node.js fs] copy of symlink failed: ",Y)}if(X.dangling)return}return fe.isDirectory()?M(F,V,fe.mode&N,H):j(F,V,fe.mode&N)}async function M(F,V,H,fe){await e.Promises.mkdir(V,{recursive:!0,mode:H});const X=await r(F);for(const Y of X)await O((0,E.$ic)(F,Y),(0,E.$ic)(V,Y),fe)}async function j(F,V,H){await e.Promises.copyFile(F,V),await e.Promises.chmod(V,H)}async function U(F,V,H){let fe=await e.Promises.readlink(F);(0,R.$Wf)(fe,H.root.source,!w.$l)&&(fe=(0,E.$ic)(H.root.target,fe.substr(H.root.source.length+1))),await e.Promises.symlink(fe,V)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(F,V,H,fe,X)=>new Promise((Y,q)=>{D.read(F,V,H,fe,X,(x,me,ue)=>x?q(x):Y({bytesRead:me,buffer:ue}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(F,V,H,fe,X)=>new Promise((Y,q)=>{D.write(F,V,H,fe,X,(x,me,ue)=>x?q(x):Y({bytesWritten:me,buffer:ue}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return r}get readDirsInDir(){return l}get writeFile(){return i}get rm(){return k}get rename(){return f}get copy(){return P}}}),define(De[101],Ce([1,0,53,16,12,15,29]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.$Yp=e.$Xp=void 0;function b(v){if(g.$l)return v;const k=(0,T.$lc)(v);if(v===k)return v;const S=((0,T.$mc)(v)||v).toLowerCase();try{const u=(0,R.readdirSync)(k).filter(r=>r.toLowerCase()===S);if(u.length===1){const r=b(k);if(r)return(0,T.$ic)(r,u[0])}else if(u.length>1){const r=u.indexOf(S);if(r>=0){const s=b(k);if(s)return(0,T.$ic)(s,u[r])}}}catch{}return null}e.$Xp=b;async function E(v){if(g.$l)return v;const k=(0,T.$lc)(v);if(v===k)return v;const S=((0,T.$mc)(v)||v).toLowerCase();try{const u=(await R.Promises.readdir(k)).filter(r=>r.toLowerCase()===S);if(u.length===1){const r=await E(k);if(r)return(0,T.$ic)(r,u[0])}else if(u.length>1){const r=u.indexOf(S);if(r>=0){const s=await E(k);if(s)return(0,T.$ic)(s,u[r])}}}catch{}return null}e.$Yp=E;async function w(v){try{return await R.Promises.realpath(v)}catch{const S=I(v);return await R.Promises.access(S,D.constants.R_OK),S}}e.$Zp=w;function A(v){try{return D.realpathSync(v)}catch{const S=I(v);return D.accessSync(S,D.constants.R_OK),S}}e.$1p=A;function I(v){return(0,L.$Je)((0,T.$gc)(v),T.sep)}}),define(De[102],Ce([1,0,16,12,47,99,18,29]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$yl=e.$xl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(I=g.env){return I.comspec||"cmd.exe"}e.$xl=E;function w(I){let v=[],k=!1;const S=function(p){if(k){v.push(p);return}(!I.send(p,r=>{if(r&&console.error(r),k=!1,v.length>0){const s=v.slice(0);v=[],s.forEach(a=>S(a))}})||T.$j)&&(k=!0)};return{send:S}}e.$yl=w;var A;(function(I){async function v(k,S,p){if(D.$hc(k))return k;if(S===void 0&&(S=g.cwd()),D.$lc(k)!=="."||(p===void 0&&R.$xf(g.env.PATH)&&(p=g.env.PATH.split(D.$sc)),p===void 0||p.length===0))return D.$ic(S,k);async function r(s){if(await b.Promises.exists(s)){let a;try{a=await b.Promises.stat(s)}catch(m){m.message.startsWith("EACCES")&&(a=await b.Promises.lstat(s))}return a?!a.isDirectory():!1}return!1}for(const s of p){let a;if(D.$hc(s)?a=D.$ic(s,k):a=D.$ic(S,s,k),await r(a))return a;let m=a+".com";if(await r(m)||(m=a+".exe",await r(m)))return m}return D.$ic(S,k)}I.findExecutable=v})(A||(e.win32=A={}))});var He=this&&this.__decorate||function($e,e,D,T){var g=arguments.length,L=g<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,D):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($e,e,D,T);else for(var b=$e.length-1;b>=0;b--)(R=$e[b])&&(L=(g<3?R(L):g>3?R(e,D,L):R(e,D))||L);return g>3&&L&&Object.defineProperty(e,D,L),L};define(De[80],Ce([1,0,19,11,22,21,57,8,4,3,62,15,18]),function($e,e,D,T,g,L,R,b,E,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.ProxyChannel=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.RequestInitiator=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=void 0;var k;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(k||(k={}));function S(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(p||(p={}));function u(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var r;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(r||(r={}));function s(X){let Y=0;for(let q=0;;q+=7){const x=X.read(1);if(Y|=(x.buffer[0]&127)<<q,!(x.buffer[0]&128))return Y}}const a=o(0);function m(X,Y){if(Y===0){X.write(a);return}let q=0;for(let me=Y;me!==0;me=me>>>7)q++;const x=g.$ae.alloc(q);for(let me=0;Y!==0;me++)x.buffer[me]=Y&127,Y=Y>>>7,Y>0&&(x.buffer[me]|=128);X.write(x)}class l{constructor(Y){this.b=Y,this.a=0}read(Y){const q=this.b.slice(this.a,this.a+Y);return this.a+=q.byteLength,q}}e.$lh=l;class t{constructor(){this.a=[]}get buffer(){return g.$ae.concat(this.a)}write(Y){this.a.push(Y)}}e.$mh=t;var n;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(n||(n={}));function o(X){const Y=g.$ae.alloc(1);return Y.writeUInt8(X,0),Y}const i={Undefined:o(n.Undefined),String:o(n.String),Buffer:o(n.Buffer),VSBuffer:o(n.VSBuffer),Array:o(n.Array),Object:o(n.Object),Uint:o(n.Int)},c=typeof Buffer<"u";function h(X,Y){if(typeof Y>"u")X.write(i.Undefined);else if(typeof Y=="string"){const q=g.$ae.fromString(Y);X.write(i.String),m(X,q.byteLength),X.write(q)}else if(c&&Buffer.isBuffer(Y)){const q=g.$ae.wrap(Y);X.write(i.Buffer),m(X,q.byteLength),X.write(q)}else if(Y instanceof g.$ae)X.write(i.VSBuffer),m(X,Y.byteLength),X.write(Y);else if(Array.isArray(Y)){X.write(i.Array),m(X,Y.length);for(const q of Y)h(X,q)}else if(typeof Y=="number"&&(Y|0)===Y)X.write(i.Uint),m(X,Y);else{const q=g.$ae.fromString(JSON.stringify(Y));X.write(i.Object),m(X,q.byteLength),X.write(q)}}e.$nh=h;function y(X){switch(X.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return X.read(s(X)).toString();case n.Buffer:return X.read(s(X)).buffer;case n.VSBuffer:return X.read(s(X));case n.Array:{const q=s(X),x=[];for(let me=0;me<q;me++)x.push(y(X));return x}case n.Object:return JSON.parse(X.read(s(X)).toString());case n.Int:return s(X)}}e.$oh=y;class C{constructor(Y,q,x=null,me=1e3){this.h=Y,this.j=q,this.k=x,this.l=me,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ue=>this.q(ue)),this.m({type:200})}registerChannel(Y,q){this.b.set(Y,q),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case 200:{const q=this.o([Y.type]);this.k?.logOutgoing(q,0,1,u(Y.type));return}case 201:case 202:case 204:case 203:{const q=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(q,Y.id,1,u(Y.type),Y.data);return}}}o(Y,q=void 0){const x=new t;return h(x,Y),h(x,q),this.p(x.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const q=new l(Y),x=y(q),me=y(q),ue=x[0];switch(ue){case 100:return this.k?.logIncoming(Y.byteLength,x[1],1,`${S(ue)}: ${x[2]}.${x[3]}`,me),this.s({type:ue,id:x[1],channelName:x[2],name:x[3],arg:me});case 102:return this.k?.logIncoming(Y.byteLength,x[1],1,`${S(ue)}: ${x[2]}.${x[3]}`,me),this.t({type:ue,id:x[1],channelName:x[2],name:x[3],arg:me});case 101:return this.k?.logIncoming(Y.byteLength,x[1],1,`${S(ue)}`),this.u({type:ue,id:x[1]});case 103:return this.k?.logIncoming(Y.byteLength,x[1],1,`${S(ue)}`),this.u({type:ue,id:x[1]})}}s(Y){const q=this.b.get(Y.channelName);if(!q){this.v(Y);return}const x=new L.$Wd;let me;try{me=q.call(this.j,Y.name,Y.arg,x.token)}catch(G){me=Promise.reject(G)}const ue=Y.id;me.then(G=>{this.m({id:ue,data:G,type:201})},G=>{G instanceof Error?this.m({id:ue,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.m({id:ue,data:G,type:203})}).finally(()=>{pe.dispose(),this.d.delete(Y.id)});const pe=(0,w.$Pc)(()=>x.cancel());this.d.set(Y.id,pe)}t(Y){const q=this.b.get(Y.channelName);if(!q){this.v(Y);return}const x=Y.id,ue=q.listen(this.j,Y.name,Y.arg)(pe=>this.m({id:x,data:pe,type:204}));this.d.set(Y.id,ue)}u(Y){const q=this.d.get(Y.id);q&&(q.dispose(),this.d.delete(Y.id))}v(Y){let q=this.g.get(Y.channelName);q||(q=[],this.g.set(Y.channelName,q));const x=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:Y,timeoutTimer:x})}w(Y){const q=this.g.get(Y);if(q){for(const x of q)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.s(x.request);break;case 102:this.t(x.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Mc)(this.d.values()),this.d.clear()}}e.$ph=C;var $;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));class f{constructor(Y,q=null){this.l=Y,this.a=!1,this.b=r.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$Md,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(x=>this.s(x)),this.j=q}getChannel(Y){const q=this;return{call(x,me,ue){return q.a?Promise.reject(new b.$4):q.m(Y,x,me,ue)},listen(x,me){return q.a?E.Event.None:q.o(Y,x,me)}}}m(Y,q,x,me=L.CancellationToken.None){const ue=this.g++,G={id:ue,type:100,channelName:Y,name:q,arg:x};if(me.isCancellationRequested)return Promise.reject(new b.$4);let z;return new Promise((ge,_)=>{if(me.isCancellationRequested)return _(new b.$4);const ie=()=>{const he=ee=>{switch(ee.type){case 201:this.f.delete(ue),ge(ee.data);break;case 202:{this.f.delete(ue);const le=new Error(ee.data.message);le.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,le.name=ee.data.name,_(le);break}case 203:this.f.delete(ue),_(ee.data);break}};this.f.set(ue,he),this.p(G)};let ne=null;this.b===r.Idle?ie():(ne=(0,T.$Gg)(he=>this.u()),ne.then(()=>{ne=null,ie()}));const Ee=()=>{ne?(ne.cancel(),ne=null):this.p({id:ue,type:101}),_(new b.$4)},oe=me.onCancellationRequested(Ee);z=(0,w.$Oc)((0,w.$Pc)(Ee),oe),this.d.add(z)}).finally(()=>{z.dispose(),this.d.delete(z)})}o(Y,q,x){const me=this.g++,pe={id:me,type:102,channelName:Y,name:q,arg:x};let G=null;const z=new E.$Md({onWillAddFirstListener:()=>{G=(0,T.$Gg)(ge=>this.u()),G.then(()=>{G=null,this.d.add(z),this.p(pe)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(z),this.p({id:me,type:103}))}}),K=ge=>z.fire(ge.data);return this.f.set(me,K),z.event}p(Y){switch(Y.type){case 100:case 102:{const q=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(q,Y.id,0,`${S(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const q=this.q([Y.type,Y.id]);this.j?.logOutgoing(q,Y.id,0,S(Y.type));return}}}q(Y,q=void 0){const x=new t;return h(x,Y),h(x,q),this.r(x.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const q=new l(Y),x=y(q),me=y(q),ue=x[0];switch(ue){case 200:return this.j?.logIncoming(Y.byteLength,0,0,u(ue)),this.t({type:x[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Y.byteLength,x[1],0,u(ue),me),this.t({type:x[0],id:x[1],data:me})}}t(Y){if(Y.type===200){this.b=r.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===r.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Mc)(this.d.values()),this.d.clear()}}e.$qh=f,He([R.$fh],f.prototype,"onDidInitializePromise",null);class d{get connections(){const Y=[];return this.f.forEach(q=>Y.push(q)),Y}constructor(Y){this.a=new Map,this.f=new Set,this.g=new E.$Md,this.onDidAddConnection=this.g.event,this.h=new E.$Md,this.onDidRemoveConnection=this.h.event,this.j=new w.$Qc,this.j.add(Y(({protocol:q,onDidClientDisconnect:x})=>{const me=E.Event.once(q.onMessage);this.j.add(me(ue=>{const pe=new l(ue),G=y(pe),z=new C(q,G),K=new f(q);this.a.forEach((_,ie)=>z.registerChannel(ie,_));const ge={channelServer:z,channelClient:K,ctx:G};this.f.add(ge),this.g.fire(ge),this.j.add(x(()=>{z.dispose(),K.dispose(),this.f.delete(ge),this.h.fire(ge)}))}))}))}getChannel(Y,q){const x=this;return{call(me,ue,pe){let G;if((0,v.$Lf)(q)){const K=(0,D.$3b)(x.connections.filter(q));G=K?Promise.resolve(K):E.Event.toPromise(E.Event.filter(x.onDidAddConnection,q))}else G=q.routeCall(x,me,ue);const z=G.then(K=>K.channelClient.getChannel(Y));return N(z).call(me,ue,pe)},listen(me,ue){if((0,v.$Lf)(q))return x.k(Y,q,me,ue);const pe=q.routeEvent(x,me,ue).then(G=>G.channelClient.getChannel(Y));return N(pe).listen(me,ue)}}}k(Y,q,x,me){const ue=this;let pe;const G=new E.$Md({onWillAddFirstListener:()=>{pe=new w.$Qc;const z=new E.$Sd,K=new Map,ge=ie=>{const Ee=ie.channelClient.getChannel(Y).listen(x,me),oe=z.add(Ee);K.set(ie,oe)},_=ie=>{const ne=K.get(ie);ne&&(ne.dispose(),K.delete(ie))};ue.connections.filter(q).forEach(ge),E.Event.filter(ue.onDidAddConnection,q)(ge,void 0,pe),ue.onDidRemoveConnection(_,void 0,pe),z.event(G.fire,G,pe),pe.add(z)},onDidRemoveLastListener:()=>{pe?.dispose(),pe=void 0}});return G.event}registerChannel(Y,q){this.a.set(Y,q);for(const x of this.f)x.channelServer.registerChannel(Y,q)}dispose(){this.j.dispose();for(const Y of this.f)Y.channelClient.dispose(),Y.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$rh=d;class P{constructor(Y,q,x=null){const me=new t;h(me,q),Y.send(me.buffer),this.a=new f(Y,x),this.d=new C(Y,q,x)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,q){this.d.registerChannel(Y,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$sh=P;function N(X){return{call(Y,q,x){return X.then(me=>me.call(Y,q,x))},listen(Y,q){const x=new E.$Vd;return X.then(me=>x.input=me.listen(Y,q)),x.event}}}e.$th=N;function O(X){let Y=!1;return{call(q,x,me){return Y?X.call(q,x,me):(0,T.$Tg)(0).then(()=>Y=!0).then(()=>X.call(q,x,me))},listen(q,x){if(Y)return X.listen(q,x);const me=new E.$Vd;return(0,T.$Tg)(0).then(()=>Y=!0).then(()=>me.input=X.listen(q,x)),me.event}}}e.$uh=O;class M{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const q of Y.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await E.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}e.$vh=M;var j;(function(X){function Y(ue,pe,G){const z=ue,K=G&&G.disableMarshalling,ge=new Map;for(const _ in z)x(_)&&ge.set(_,E.Event.buffer(z[_],!0,void 0,pe));return new class{listen(_,ie,ne){const Ee=ge.get(ie);if(Ee)return Ee;if(me(ie)){const oe=z[ie];if(typeof oe=="function")return oe.call(z,ne)}throw new b.$ab(`Event not found: ${ie}`)}call(_,ie,ne){const Ee=z[ie];if(typeof Ee=="function"){if(!K&&Array.isArray(ne))for(let he=0;he<ne.length;he++)ne[he]=(0,A.$kh)(ne[he]);let oe=Ee.apply(z,ne);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new b.$ab(`Method not found: ${ie}`)}}}X.fromService=Y;function q(ue,pe){const G=pe&&pe.disableMarshalling;return new Proxy({},{get(z,K){if(typeof K=="string")return pe?.properties?.has(K)?pe.properties.get(K):me(K)?function(ge){return ue.listen(K,ge)}:x(K)?ue.listen(K):async function(...ge){let _;pe&&!(0,v.$Gf)(pe.context)?_=[pe.context,...ge]:_=ge;const ie=await ue.call(K,_);return G?ie:(0,A.$kh)(ie)};throw new b.$ab(`Property not found: ${String(K)}`)}})}X.toService=q;function x(ue){return ue[0]==="o"&&ue[1]==="n"&&I.$Ze(ue.charCodeAt(2))}function me(ue){return/^onDynamic/.test(ue)&&I.$Ze(ue.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const Y=X.toString();if(Y!=="[object Object]")return Y}return X}function V(X){return Array.isArray(X)?X.map(F):F(X)}function H(X,Y,q,x,me,ue,pe){pe=V(pe);const G=U[me],z=G[x%G.length];let K=[`%c[${X}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${z}`];/\($/.test(ue)?(K=K.concat(pe),K.push(")")):K.push(pe),console.log.apply(console,K)}class fe{constructor(Y,q){this.d=Y,this.f=q,this.a=0,this.b=0}logOutgoing(Y,q,x,me,ue){this.b+=Y,H(this.d,this.b,Y,q,x,me,ue)}logIncoming(Y,q,x,me,ue){this.a+=Y,H(this.f,this.a,Y,q,x,me,ue)}}e.$wh=fe}),define(De[81],Ce([1,0,22,4,3,80]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e.$yh=e.ProtocolConstants=e.$xh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var b;(function(i){i.enableDiagnostics=!1,i.records=[];const c=new WeakMap;let h=0;function y($,f){if(!c.has($)){const d=String(++h);c.set($,d)}return c.get($)}function C($,f,d,P){if(!i.enableDiagnostics)return;const N=y($,f);if(P instanceof D.$ae||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const O=D.$ae.alloc(P.byteLength);O.set(P),i.records.push({timestamp:Date.now(),id:N,label:f,type:d,buff:O})}else i.records.push({timestamp:Date.now(),id:N,label:f,type:d,data:P})}i.traceSocketEvent=C})(b||(e.SocketDiagnostics=b={}));var E;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let w=null;function A(){return w||(w=D.$ae.alloc(0)),w}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,h){if(c===0)return A();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const f=this.a[0];return h&&(this.a.shift(),this.b-=c),f}if(this.a[0].byteLength>c){const f=this.a[0].slice(0,c);return h&&(this.a[0]=this.a[0].slice(c),this.b-=c),f}const y=D.$ae.alloc(c);let C=0,$=0;for(;c>0;){const f=this.a[$];if(f.byteLength>c){const d=f.slice(0,c);y.set(d,C),C+=c,h&&(this.a[$]=f.slice(c),this.b-=c),c-=c}else y.set(f,C),C+=f.byteLength,h?(this.a.shift(),this.b-=f.byteLength):$++,c-=f.byteLength}return y}}e.$xh=I;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function k(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class p{constructor(c,h,y,C){this.type=c,this.id=h,this.ack=y,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends g.$Rc{constructor(c){super(),this.f=this.B(new T.$Md),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new I,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:k(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const y=this.g.messageType,C=this.g.id,$=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new p(y,C,$,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class r{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=D.$ae.alloc(13);h.writeUInt8(c.type,0),h.writeUInt32BE(c.id,1),h.writeUInt32BE(c.ack,5),h.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:k(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(h,c.data)}g(c,h){const y=this.f===0;return this.d.push(c,h),this.f+=c.byteLength+h.byteLength,y}h(){const c=D.$ae.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,h){this.g(c,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class s extends g.$Rc{constructor(c){super(),this.f=new T.$Md,this.onMessage=this.f.event,this.g=new T.$Md,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new r(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new p(1,0,0,c))}}e.$yh=s;class a extends L.$sh{static fromSocket(c,h){return new a(new s(c),h)}get onDidDispose(){return this.b.onDidDispose}constructor(c,h,y=null){super(c,h,y),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$zh=a;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$Md({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$Ah=m;class l{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,h=this.a;for(;h;)h=h.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let h=0,y=this.a;for(;y;)c[h++]=y.data,y=y.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const h=new l(c);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const c=Date.now();for(let h=0;h<n.a;h++)this.c[h]=c-1e3*h;setInterval(()=>{for(let h=n.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),h=(1+n.a)*1e3;let y=0;for(let C=0;C<n.a;C++)c-this.c[C]<=h&&y++;return 1-y/n.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??n.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$Qc,this.o=c.socket,this.p=this.r.add(new r(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new p(5,0,0,A());this.p.write(c),this.p.flush()}sendPause(){const c=new p(7,0,0,A());this.p.write(c)}sendResume(){const c=new p(8,0,0,A());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,h){this.a=!0,this.r.dispose(),this.r=new g.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new r(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(y=>this.z(y))),this.r.add(this.o.onClose(y=>this.x.fire(y))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new p(3,0,this.h,A());this.p.write(c);const h=this.b.toArray();for(let y=0,C=h.length;y<C;y++)this.p.write(h[y]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const h=this.b.peek();if(h&&h.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new p(6,0,0,A())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let y=0,C=h.length;y<C;y++)this.p.write(h[y]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const h=++this.c;this.h=this.g;const y=new p(1,h,this.h,c);this.b.push(y),this.a||(this.p.write(y),this.B())}sendControl(c){const h=new p(2,0,0,c);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),h=Date.now()-c.writtenTime,y=Date.now()-this.q.lastReadTime,C=Date.now()-this.n;if(h>=2e4&&y>=2e4&&C>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:y});return}const $=Math.max(2e4-h,2e4-y,2e4-C,500);this.f=setTimeout(()=>{this.f=null,this.B()},$)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new p(3,0,this.h,A());this.p.write(c)}D(){this.h=this.g;const c=new p(9,0,this.h,A());this.p.write(c)}}e.$Bh=o}),define(De[183],Ce([1,0,48,11,22,21,181,8,4,3,23,102,99,80]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0;class S extends k.$ph{constructor(r){super({send:s=>{try{process.send?.(s.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",s=>g.$ae.wrap(Buffer.from(s,"base64")))},r),process.once("disconnect",()=>this.dispose())}}e.$Up=S;class p{constructor(r,s){this.i=r,this.j=s,this.c=new Set,this.g=new Map,this.h=new E.$Md,this.onDidProcessExit=this.h.event;const a=s&&s.timeout?s.timeout:6e4;this.b=new T.$Pg(a),this.d=null,this.f=null}getChannel(r){const s=this;return{call(a,m,l){return s.k(r,a,m,l)},listen(a,m){return s.l(r,a,m)}}}k(r,s,a,m=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(b.$5());this.b.cancel();const l=this.n(r),t=(0,T.$Gg)(i=>l.call(s,a,i)),n=m.onCancellationRequested(()=>t.cancel()),o=(0,w.$Pc)(()=>t.cancel());return this.c.add(o),t.finally(()=>{n.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(r,s,a){if(!this.b)return E.Event.None;this.b.cancel();let m;const l=new E.$Md({onWillAddFirstListener:()=>{m=this.n(r).listen(s,a)(l.fire,l),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const r=this.j&&this.j.args?this.j.args:[],s=Object.create(null);s.env={...(0,A.$Ym)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(s.env={...s.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(s.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(s.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(s.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),s.execArgv===void 0&&(s.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,v.$wl)(s.env),this.d=(0,D.fork)(this.i,r,s);const a=new E.$Md;E.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,R.$Qp)(c)){(0,R.log)(c,`IPC Library: ${this.j.serverName}`);return}a.fire(g.$ae.wrap(Buffer.from(c,"base64")))});const l=this.j.useQueue?(0,I.$yl)(this.d):this.d,t=c=>this.d&&this.d.connected&&l.send(c.buffer.toString("base64")),n=a.event,o={send:t,onMessage:n};this.f=new k.$qh(o);const i=()=>this.o();process.once("exit",i),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,h)=>{process.removeListener("exit",i),this.c.forEach(y=>(0,w.$Mc)(y)),this.c.clear(),c!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:h})})}return this.f}n(r){let s=this.g.get(r);return s||(s=this.m.getChannel(r),this.g.set(r,s)),s}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Vp=p}),define(De[184],Ce([1,0,11,4,3,62,18]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.StorageState=e.$To=e.StorageHint=void 0;var b;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function E(v){const k=v;return k?.changed instanceof Map||k?.deleted instanceof Set}e.$To=E;var w;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(w||(e.StorageState=w={}));class A extends g.$Rc{static{this.a=100}constructor(k,S=Object.create(null)){super(),this.r=k,this.s=S,this.b=this.B(new T.$Pd),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new D.$Qg(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach((S,p)=>this.w(p,S)),k.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(k,S){if(this.c===w.Closed)return;let p=!1;(0,R.$Gf)(S)?p=this.f.delete(k):this.f.get(k)!==S&&(this.f.set(k,S),p=!0),p&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,S){const p=this.f.get(k);return(0,R.$Gf)(p)?S:p}getBoolean(k,S){const p=this.get(k);return(0,R.$Gf)(p)?S:p==="true"}getNumber(k,S){const p=this.get(k);return(0,R.$Gf)(p)?S:parseInt(p,10)}getObject(k,S){const p=this.get(k);return(0,R.$Gf)(p)?S:(0,L.$jh)(p)}async set(k,S,p=!1){if(this.c===w.Closed)return;if((0,R.$Gf)(S))return this.delete(k,p);const u=(0,R.$zf)(S)||Array.isArray(S)?(0,L.$ih)(S):String(S);if(this.f.get(k)!==u)return this.f.set(k,u),this.j.set(k,u),this.h.delete(k),this.b.fire({key:k,external:p}),this.D()}async delete(k,S=!1){if(!(this.c===w.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:S}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(this.z)return this.D(k)}async D(k){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Uo=A;class I{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach((S,p)=>this.a.set(p,S)),k.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$Vo=I}),define(De[185],Ce([1,0,35,16]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jE=void 0;function g(L,R,b,E,w,A){if(Array.isArray(L)){let I=0;for(const v of L){const k=g(v,R,b,E,w,A);if(k===10)return k;k>I&&(I=k)}return I}else{if(typeof L=="string")return E?L==="*"?5:L===b?10:0:0;if(L){const{language:I,pattern:v,scheme:k,hasAccessToAllModels:S,notebookType:p}=L;if(!E&&!S)return 0;p&&w&&(R=w);let u=0;if(k)if(k===R.scheme)u=10;else if(k==="*")u=5;else return 0;if(I)if(I===b)u=10;else if(I==="*")u=Math.max(u,5);else return 0;if(p)if(p===A)u=10;else if(p==="*"&&A!==void 0)u=Math.max(u,5);else return 0;if(v){let r;if(typeof v=="string"?r=v:r={...v,base:(0,T.$gc)(v.base)},r===R.fsPath||(0,D.$tj)(r,R.fsPath))u=10;else return 0}return u}else return 0}}e.$jE=g}),define(De[129],Ce([1,0,22,12]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L0=e.$K0=void 0;var g;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(g||(g={}));function L(I){for(let v=0,k=I.length;v<k;v+=4){const S=I[v+0],p=I[v+1],u=I[v+2],r=I[v+3];I[v+0]=r,I[v+1]=u,I[v+2]=p,I[v+3]=S}}function R(I){const v=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.$D()||L(v),D.$ae.wrap(v)}function b(I){const v=I.buffer;if(T.$D()||L(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const k=new Uint8Array(v.byteLength);return k.set(v),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function E(I){const v=new Uint32Array(w(I));let k=0;if(v[k++]=I.id,I.type==="full")v[k++]=1,v[k++]=I.data.length,v.set(I.data,k),k+=I.data.length;else{v[k++]=2,v[k++]=I.deltas.length;for(const S of I.deltas)v[k++]=S.start,v[k++]=S.deleteCount,S.data?(v[k++]=S.data.length,v.set(S.data,k),k+=S.data.length):v[k++]=0}return R(v)}e.$K0=E;function w(I){let v=0;if(v+=1+1,I.type==="full")v+=1+I.data.length;else{v+=1,v+=(1+1+1)*I.deltas.length;for(const k of I.deltas)k.data&&(v+=k.data.length)}return v}function A(I){const v=b(I);let k=0;const S=v[k++];if(v[k++]===1){const s=v[k++],a=v.subarray(k,k+s);return k+=s,{id:S,type:"full",data:a}}const u=v[k++],r=[];for(let s=0;s<u;s++){const a=v[k++],m=v[k++],l=v[k++];let t;l>0&&(t=v.subarray(k,k+l),k+=l),r[s]={start:a,deleteCount:m,data:t}}return{id:S,type:"delta",deltas:r}}e.$L0=A}),define(De[186],Ce([9,10]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(De[130],Ce([1,0,19,23,12,166,124,186]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(ce){ce[ce.None=0]="None",ce[ce.Keep=1]="Keep",ce[ce.Brackets=2]="Brackets",ce[ce.Advanced=3]="Advanced",ce[ce.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(ae){this.c=ae}hasChanged(ae){return this.c[ae]}}e.ConfigurationChangedEvent=w;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class I{constructor(ae,Ie,Ve,Ue){this.id=ae,this.name=Ie,this.defaultValue=Ve,this.schema=Ue}applyUpdate(ae,Ie){return k(ae,Ie)}compute(ae,Ie,Ve){return Ve}}class v{constructor(ae,Ie){this.newValue=ae,this.didChange=Ie}}e.ApplyUpdateResult=v;function k(ce,ae){if(typeof ce!="object"||typeof ae!="object"||!ce||!ae)return new v(ae,ce!==ae);if(Array.isArray(ce)||Array.isArray(ae)){const Ve=Array.isArray(ce)&&Array.isArray(ae)&&D.$tb(ce,ae);return new v(ae,!Ve)}let Ie=!1;for(const Ve in ae)if(ae.hasOwnProperty(Ve)){const Ue=k(ce[Ve],ae[Ve]);Ue.didChange&&(ce[Ve]=Ue.newValue,Ie=!0)}return new v(ce,Ie)}class S{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,Ie){return k(ae,Ie)}validate(ae){return this.defaultValue}}class p{constructor(ae,Ie,Ve,Ue){this.id=ae,this.name=Ie,this.defaultValue=Ve,this.schema=Ue}applyUpdate(ae,Ie){return k(ae,Ie)}validate(ae){return typeof ae>"u"?this.defaultValue:ae}compute(ae,Ie,Ve){return Ve}}function u(ce,ae){return typeof ce>"u"?ae:ce==="false"?!1:!!ce}e.boolean=u;class r extends p{constructor(ae,Ie,Ve,Ue=void 0){typeof Ue<"u"&&(Ue.type="boolean",Ue.default=Ve),super(ae,Ie,Ve,Ue)}validate(ae){return u(ae,this.defaultValue)}}function s(ce,ae,Ie,Ve){if(typeof ce>"u")return ae;let Ue=parseInt(ce,10);return isNaN(Ue)?ae:(Ue=Math.max(Ie,Ue),Ue=Math.min(Ve,Ue),Ue|0)}e.clampedInt=s;class a extends p{static clampedInt(ae,Ie,Ve,Ue){return s(ae,Ie,Ve,Ue)}constructor(ae,Ie,Ve,Ue,Xe,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Ve,rt.minimum=Ue,rt.maximum=Xe),super(ae,Ie,Ve,rt),this.minimum=Ue,this.maximum=Xe}validate(ae){return a.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}function m(ce,ae,Ie,Ve){if(typeof ce>"u")return ae;const Ue=l.float(ce,ae);return l.clamp(Ue,Ie,Ve)}e.clampedFloat=m;class l extends p{static clamp(ae,Ie,Ve){return ae<Ie?Ie:ae>Ve?Ve:ae}static float(ae,Ie){if(typeof ae=="number")return ae;if(typeof ae>"u")return Ie;const Ve=parseFloat(ae);return isNaN(Ve)?Ie:Ve}constructor(ae,Ie,Ve,Ue,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Ve),super(ae,Ie,Ve,Xe),this.validationFn=Ue}validate(ae){return this.validationFn(l.float(ae,this.defaultValue))}}class t extends p{static string(ae,Ie){return typeof ae!="string"?Ie:ae}constructor(ae,Ie,Ve,Ue=void 0){typeof Ue<"u"&&(Ue.type="string",Ue.default=Ve),super(ae,Ie,Ve,Ue)}validate(ae){return t.string(ae,this.defaultValue)}}function n(ce,ae,Ie,Ve){return typeof ce!="string"?ae:Ve&&ce in Ve?Ve[ce]:Ie.indexOf(ce)===-1?ae:ce}e.stringSet=n;class o extends p{constructor(ae,Ie,Ve,Ue,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Ue,Xe.default=Ve),super(ae,Ie,Ve,Xe),this.c=Ue}validate(ae){return n(ae,this.defaultValue,this.c)}}class i extends I{constructor(ae,Ie,Ve,Ue,Xe,rt,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=Xe,ot.default=Ue),super(ae,Ie,Ve,ot),this.c=Xe,this.d=rt}validate(ae){return typeof ae!="string"?this.defaultValue:this.c.indexOf(ae)===-1?this.defaultValue:this.d(ae)}}function c(ce){switch(ce){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,Ie,Ve){return Ve===0?ae.accessibilitySupport:Ve}}class y extends I{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{insertSpace:u(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(ce){ce[ce.Hidden=0]="Hidden",ce[ce.Blink=1]="Blink",ce[ce.Smooth=2]="Smooth",ce[ce.Phase=3]="Phase",ce[ce.Expand=4]="Expand",ce[ce.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function $(ce){switch(ce){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(ce){ce[ce.Line=1]="Line",ce[ce.Block=2]="Block",ce[ce.Underline=3]="Underline",ce[ce.LineThin=4]="LineThin",ce[ce.BlockOutline=5]="BlockOutline",ce[ce.UnderlineThin=6]="UnderlineThin"})(f||(e.TextEditorCursorStyle=f={}));function d(ce){switch(ce){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function P(ce){switch(ce){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class N extends S{constructor(){super(140)}compute(ae,Ie,Ve){const Ue=["monaco-editor"];return Ie.get(39)&&Ue.push(Ie.get(39)),ae.extraEditorClassName&&Ue.push(ae.extraEditorClassName),Ie.get(73)==="default"?Ue.push("mouse-default"):Ie.get(73)==="copy"&&Ue.push("mouse-copy"),Ie.get(110)&&Ue.push("showUnused"),Ie.get(138)&&Ue.push("showDeprecated"),Ue.join(" ")}}class O extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ae,Ie,Ve){return Ve&&ae.emptySelectionClipboard}}class M extends I{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:b.localize(16,null),included:g.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:b.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{cursorMoveOnType:u(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":n(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":n(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(Ie.loop,this.defaultValue.loop)}}}class j extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?j.OFF:ae==="true"?j.ON:ae:ae?j.ON:j.OFF}}e.EditorFontLigatures=j;class U extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?U.OFF:ae==="true"?U.TRANSLATE:ae:ae?U.TRANSLATE:U.OFF}compute(ae,Ie,Ve){return ae.fontInfo.fontVariationSettings}}e.EditorFontVariations=U;class F extends S{constructor(){super(50)}compute(ae,Ie,Ve){return ae.fontInfo}}class V extends p{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ae){const Ie=l.float(ae,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(Ie,6,100)}compute(ae,Ie,Ve){return ae.fontInfo.fontSize}}class H extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.d,maximum:H.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(a.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,H.d,H.e))}}class fe extends I{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:Ve,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:Ve,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:Ve,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:Ve,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:Ve,description:b.localize(41,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{multiple:n(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??n(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??n(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??n(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??n(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??n(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class X extends I{constructor(){const ae={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ae.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:b.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),delay:a.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:u(Ie.sticky,this.defaultValue.sticky),hidingDelay:a.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:u(Ie.above,this.defaultValue.above)}}}var Y;(function(ce){ce[ce.None=0]="None",ce[ce.Text=1]="Text",ce[ce.Blocks=2]="Blocks"})(Y||(e.RenderMinimap=Y={}));class q extends S{constructor(){super(143)}compute(ae,Ie,Ve){return q.computeLayout(Ie,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio,glyphMarginDecorationLaneCount:ae.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ae){const Ie=ae.height/ae.lineHeight,Ve=Math.floor(ae.paddingTop/ae.lineHeight);let Ue=Math.floor(ae.paddingBottom/ae.lineHeight);ae.scrollBeyondLastLine&&(Ue=Math.max(Ue,Ie-1));const Xe=(Ve+ae.viewLineCount+Ue)/(ae.pixelRatio*ae.height),rt=Math.floor(ae.viewLineCount/Xe);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Ue,desiredRatio:Xe,minimapLineCount:rt}}static c(ae,Ie){const Ve=ae.outerWidth,Ue=ae.outerHeight,Xe=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const rt=Ie.stableMinimapLayoutInput,ot=rt&&ae.outerHeight===rt.outerHeight&&ae.lineHeight===rt.lineHeight&&ae.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&ae.pixelRatio===rt.pixelRatio&&ae.scrollBeyondLastLine===rt.scrollBeyondLastLine&&ae.paddingTop===rt.paddingTop&&ae.paddingBottom===rt.paddingBottom&&ae.minimap.enabled===rt.minimap.enabled&&ae.minimap.side===rt.minimap.side&&ae.minimap.size===rt.minimap.size&&ae.minimap.showSlider===rt.minimap.showSlider&&ae.minimap.renderCharacters===rt.minimap.renderCharacters&&ae.minimap.maxColumn===rt.minimap.maxColumn&&ae.minimap.scale===rt.minimap.scale&&ae.verticalScrollbarWidth===rt.verticalScrollbarWidth&&ae.isViewportWrapping===rt.isViewportWrapping,wt=ae.lineHeight,kt=ae.typicalHalfwidthCharacterWidth,Yt=ae.scrollBeyondLastLine,Vt=ae.minimap.renderCharacters;let pt=Xe>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const Ut=ae.minimap.maxColumn,Ft=ae.minimap.size,zt=ae.minimap.side,At=ae.verticalScrollbarWidth,Rt=ae.viewLineCount,Nt=ae.remainingWidth,Bt=ae.isViewportWrapping,Kt=Vt?2:3;let Wt=Math.floor(Xe*Ue);const ct=Wt/Xe;let lt=!1,Jt=!1,Pt=Kt*pt,St=pt/Xe,dt=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Te,extraLinesBeforeFirstLine:Se,extraLinesBeyondLastLine:se,desiredRatio:Ne,minimapLineCount:Ke}=q.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Yt,paddingTop:ae.paddingTop,paddingBottom:ae.paddingBottom,height:Ue,lineHeight:wt,pixelRatio:Xe});if(Rt/Ke>1)lt=!0,Jt=!0,pt=1,Pt=1,St=pt/Xe;else{let Je=!1,nt=pt+1;if(Ft==="fit"){const bt=Math.ceil((Se+Rt+se)*Pt);Bt&&ot&&Nt<=Ie.stableFitRemainingWidth?(Je=!0,nt=Ie.stableFitMaxMinimapScale):Je=bt>Wt}if(Ft==="fill"||Je){lt=!0;const bt=pt;Pt=Math.min(wt*Xe,Math.max(1,Math.floor(1/Ne))),Bt&&ot&&Nt<=Ie.stableFitRemainingWidth&&(nt=Ie.stableFitMaxMinimapScale),pt=Math.min(nt,Math.max(1,Math.floor(Pt/Kt))),pt>bt&&(dt=Math.min(2,pt/bt)),St=pt/Xe/dt,Wt=Math.ceil(Math.max(Te,Se+Rt+se)*Pt),Bt?(Ie.stableMinimapLayoutInput=ae,Ie.stableFitRemainingWidth=Nt,Ie.stableFitMaxMinimapScale=pt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Ct=Math.floor(Ut*St),Tt=Math.min(Ct,Math.max(0,Math.floor((Nt-At-2)*St/(kt+St)))+e.MINIMAP_GUTTER_WIDTH);let Et=Math.floor(Xe*Tt);const Ge=Et/Xe;Et=Math.floor(Et*dt);const Ot=Vt?1:2,Me=zt==="left"?0:Ve-Tt-At;return{renderMinimap:Ot,minimapLeft:Me,minimapWidth:Tt,minimapHeightIsEditorHeight:lt,minimapIsSampling:Jt,minimapScale:pt,minimapLineHeight:Pt,minimapCanvasInnerWidth:Et,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Ge,minimapCanvasOuterHeight:ct}}static computeLayout(ae,Ie){const Ve=Ie.outerWidth|0,Ue=Ie.outerHeight|0,Xe=Ie.lineHeight|0,rt=Ie.lineNumbersDigitCount|0,ot=Ie.typicalHalfwidthCharacterWidth,wt=Ie.maxDigitWidth,kt=Ie.pixelRatio,Yt=Ie.viewLineCount,Vt=ae.get(135),pt=Vt==="inherit"?ae.get(134):Vt,Ut=pt==="inherit"?ae.get(130):pt,Ft=ae.get(133),zt=Ie.isDominatedByLongLines,At=ae.get(57),Rt=ae.get(67).renderType!==0,Nt=ae.get(68),Bt=ae.get(104),Kt=ae.get(83),Wt=ae.get(72),ct=ae.get(102),lt=ct.verticalScrollbarSize,Jt=ct.verticalHasArrows,Pt=ct.arrowSize,St=ct.horizontalScrollbarSize,dt=ae.get(43),Ct=ae.get(109)!=="never";let Tt=ae.get(65);dt&&Ct&&(Tt+=16);let Et=0;if(Rt){const ft=Math.max(rt,Nt);Et=Math.round(ft*wt)}let Ge=0;At&&(Ge=Xe*Ie.glyphMarginDecorationLaneCount);let Ot=0,Me=Ot+Ge,Te=Me+Et,Se=Te+Tt;const se=Ve-Ge-Et-Tt;let Ne=!1,Ke=!1,_e=-1;pt==="inherit"&&zt?(Ne=!0,Ke=!0):Ut==="on"||Ut==="bounded"?Ke=!0:Ut==="wordWrapColumn"&&(_e=Ft);const Je=q.c({outerWidth:Ve,outerHeight:Ue,lineHeight:Xe,typicalHalfwidthCharacterWidth:ot,pixelRatio:kt,scrollBeyondLastLine:Bt,paddingTop:Kt.top,paddingBottom:Kt.bottom,minimap:Wt,verticalScrollbarWidth:lt,viewLineCount:Yt,remainingWidth:se,isViewportWrapping:Ke},Ie.memory||new A);Je.renderMinimap!==0&&Je.minimapLeft===0&&(Ot+=Je.minimapWidth,Me+=Je.minimapWidth,Te+=Je.minimapWidth,Se+=Je.minimapWidth);const nt=se-Je.minimapWidth,bt=Math.max(1,Math.floor((nt-lt-2)/ot)),vt=Jt?Pt:0;return Ke&&(_e=Math.max(1,bt),Ut==="bounded"&&(_e=Math.min(_e,Ft))),{width:Ve,height:Ue,glyphMarginLeft:Ot,glyphMarginWidth:Ge,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Me,lineNumbersWidth:Et,decorationsLeft:Te,decorationsWidth:Tt,contentLeft:Se,contentWidth:nt,minimap:Je,viewportColumn:bt,isWordWrapMinified:Ne,isViewportWrapping:Ke,wrappingColumn:_e,verticalScrollbarWidth:lt,horizontalScrollbarHeight:St,overviewRuler:{top:vt,width:lt,height:Ue-2*vt,right:0}}}}e.EditorLayoutInfoComputer=q;class x extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ae){return n(ae,"simple",["simple","advanced"])}compute(ae,Ie,Ve){return Ie.get(2)===2?"advanced":Ve}}class me extends I{constructor(){const ae={enabled:!0};super(64,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"boolean",default:ae.enabled,description:b.localize(50,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:u(ae.enabled,this.defaultValue.enabled)}}}class ue extends I{constructor(){const ae={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ae,{"editor.stickyScroll.enabled":{type:"boolean",default:ae.enabled,description:b.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ae.maxLineCount,minimum:1,maximum:10,description:b.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ae.defaultModel,description:b.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ae.scrollWithEditor,description:b.localize(54,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),maxLineCount:a.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:n(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:u(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class pe extends I{constructor(){const ae={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"string",default:ae.enabled,description:b.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(56,null),b.localize(57,null,g.$k?"Ctrl+Option":"Ctrl+Alt"),b.localize(58,null,g.$k?"Ctrl+Option":"Ctrl+Alt"),b.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:b.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:b.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ae.padding,description:b.localize(62,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:n(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:a.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:u(Ie.padding,this.defaultValue.padding)}}}class G extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(ae){return typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)?-parseFloat(ae.substring(0,ae.length-2)):a.clampedInt(ae,this.defaultValue,0,1e3)}compute(ae,Ie,Ve){return Ve<0?a.clampedInt(-Ve*ae.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class z extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>l.clamp(ae,0,150),{markdownDescription:b.localize(63,null)})}compute(ae,Ie,Ve){return ae.fontInfo.lineHeight}}class K extends I{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:b.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ae.autohide,description:b.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(66,null),b.localize(67,null),b.localize(68,null)],default:ae.size,description:b.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:b.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:b.localize(71,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:b.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:b.localize(74,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),autohide:u(Ie.autohide,this.defaultValue.autohide),size:n(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(Ie.side,this.defaultValue.side,["right","left"]),showSlider:n(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(Ie.scale,1,1,3),maxColumn:a.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ge(ce){return ce==="ctrlCmd"?g.$k?"metaKey":"ctrlKey":"altKey"}class _ extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(76,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{top:a.clampedInt(Ie.top,0,0,1e3),bottom:a.clampedInt(Ie.bottom,0,0,1e3)}}}class ie extends I{constructor(){const ae={enabled:!0,cycle:!0};super(85,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:b.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:b.localize(78,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),cycle:u(Ie.cycle,this.defaultValue.cycle)}}}class ne extends S{constructor(){super(141)}compute(ae,Ie,Ve){return ae.pixelRatio}}class Ee extends I{constructor(){const ae={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(79,null),b.localize(80,null),b.localize(81,null)]}];super(88,"quickSuggestions",ae,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ae.strings,description:b.localize(82,null)},comments:{anyOf:Ie,default:ae.comments,description:b.localize(83,null)},other:{anyOf:Ie,default:ae.other,description:b.localize(84,null)}},default:ae,markdownDescription:b.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ae}validate(ae){if(typeof ae=="boolean"){const kt=ae?"on":"off";return{comments:kt,strings:kt,other:kt}}if(!ae||typeof ae!="object")return this.defaultValue;const{other:Ie,comments:Ve,strings:Ue}=ae,Xe=["on","inline","off"];let rt,ot,wt;return typeof Ie=="boolean"?rt=Ie?"on":"off":rt=n(Ie,this.defaultValue.other,Xe),typeof Ve=="boolean"?ot=Ve?"on":"off":ot=n(Ve,this.defaultValue.comments,Xe),typeof Ue=="boolean"?wt=Ue?"on":"off":wt=n(Ue,this.defaultValue.strings,Xe),{other:rt,comments:ot,strings:wt}}}var oe;(function(ce){ce[ce.Off=0]="Off",ce[ce.On=1]="On",ce[ce.Relative=2]="Relative",ce[ce.Interval=3]="Interval",ce[ce.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class he extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(86,null),b.localize(87,null),b.localize(88,null),b.localize(89,null)],default:"on",description:b.localize(90,null)})}validate(ae){let Ie=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof ae<"u"&&(typeof ae=="function"?(Ie=4,Ve=ae):ae==="interval"?Ie=3:ae==="relative"?Ie=2:ae==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ve}}}function ee(ce){const ae=ce.get(97);return ae==="editable"?ce.get(90):ae!=="on"}e.filterValidationDecorations=ee;class le extends I{constructor(){const ae=[],Ie={type:"number",description:b.localize(91,null)};super(101,"rulers",ae,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(92,null),format:"color-hex"}}}]},default:ae,description:b.localize(93,null)})}validate(ae){if(Array.isArray(ae)){const Ie=[];for(const Ve of ae)if(typeof Ve=="number")Ie.push({column:a.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Ue=Ve;Ie.push({column:a.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return Ie.sort((Ve,Ue)=>Ve.column-Ue.column),Ie}return this.defaultValue}}class be extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:ae}}function Pe(ce,ae){if(typeof ce!="string")return ae;switch(ce){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(94,null),b.localize(95,null),b.localize(96,null)],default:"auto",description:b.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(98,null),b.localize(99,null),b.localize(100,null)],default:"auto",description:b.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:b.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:b.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:b.localize(104,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae,Ve=a.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=a.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:u(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:a.clampedInt(Ie.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:a.clampedInt(Ie.verticalSliderSize,Ue,0,1e3),scrollByPage:u(Ie.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends I{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:b.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:b.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:b.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:b.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:b.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:b.localize(111,null)}})}applyUpdate(ae,Ie){let Ve=!1;Ie.allowedCharacters&&ae&&(T.$3m(ae.allowedCharacters,Ie.allowedCharacters)||(ae={...ae,allowedCharacters:Ie.allowedCharacters},Ve=!0)),Ie.allowedLocales&&ae&&(T.$3m(ae.allowedLocales,Ie.allowedLocales)||(ae={...ae,allowedLocales:Ie.allowedLocales},Ve=!0));const Ue=super.applyUpdate(ae,Ie);return Ve?new v(Ue.newValue,!0):Ue}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{nonBasicASCII:de(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ae.allowedLocales,this.defaultValue.allowedLocales)}}c(ae,Ie){if(typeof ae!="object"||!ae)return Ie;const Ve={};for(const[Ue,Xe]of Object.entries(ae))Xe===!0&&(Ve[Ue]=!0);return Ve}}class te extends I{constructor(){const ae={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:b.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ae.showToolbar,enum:["always","onHover"],enumDescriptions:[b.localize(113,null),b.localize(114,null)],description:b.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ae.suppressSuggestions,description:b.localize(116,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),mode:n(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:u(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:u(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class re extends I{constructor(){const ae={enabled:L.$Xr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Xr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ae.independentColorPoolPerBracketType,description:b.localize(118,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends I{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(119,null),b.localize(120,null),b.localize(121,null)],default:ae.bracketPairs,description:b.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(123,null),b.localize(124,null),b.localize(125,null)],default:ae.bracketPairsHorizontal,description:b.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:b.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:b.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(129,null),b.localize(130,null),b.localize(131,null)],default:ae.highlightActiveIndentation,description:b.localize(132,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{bracketPairs:de(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(ce,ae,Ie){const Ve=Ie.indexOf(ce);return Ve===-1?ae:Ie[Ve]}class ye extends I{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(133,null),b.localize(134,null)],default:ae.insertMode,description:b.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:b.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:b.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:b.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null),b.localize(142,null)],default:ae.selectionMode,markdownDescription:b.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:b.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:b.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:b.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:b.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:b.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{insertMode:n(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:u(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:u(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:u(Ie.preview,this.defaultValue.preview),previewMode:n(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(Ie.showMethods,this.defaultValue.showMethods),showFunctions:u(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:u(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(Ie.showFields,this.defaultValue.showFields),showVariables:u(Ie.showVariables,this.defaultValue.showVariables),showClasses:u(Ie.showClasses,this.defaultValue.showClasses),showStructs:u(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:u(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:u(Ie.showModules,this.defaultValue.showModules),showProperties:u(Ie.showProperties,this.defaultValue.showProperties),showEvents:u(Ie.showEvents,this.defaultValue.showEvents),showOperators:u(Ie.showOperators,this.defaultValue.showOperators),showUnits:u(Ie.showUnits,this.defaultValue.showUnits),showValues:u(Ie.showValues,this.defaultValue.showValues),showConstants:u(Ie.showConstants,this.defaultValue.showConstants),showEnums:u(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:u(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(Ie.showKeywords,this.defaultValue.showKeywords),showWords:u(Ie.showWords,this.defaultValue.showWords),showColors:u(Ie.showColors,this.defaultValue.showColors),showFiles:u(Ie.showFiles,this.defaultValue.showFiles),showReferences:u(Ie.showReferences,this.defaultValue.showReferences),showFolders:u(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:u(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:u(Ie.showUsers,this.defaultValue.showUsers),showIssues:u(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(182,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:u(ae.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(ce){ce[ce.None=0]="None",ce[ce.Same=1]="Same",ce[ce.Indent=2]="Indent",ce[ce.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class xe extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(183,null),b.localize(184,null),b.localize(185,null),b.localize(186,null)],description:b.localize(187,null),default:"same"}})}validate(ae){switch(ae){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ae,Ie,Ve){return Ie.get(2)===2?0:Ve}}class Ze extends S{constructor(){super(144)}compute(ae,Ie,Ve){const Ue=Ie.get(143);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}class it extends I{constructor(){const ae={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ae,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(190,null),b.localize(191,null)],default:"afterDrop"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showDropSelector:n(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends I{constructor(){const ae={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ae,{"editor.pasteAs.enabled":{type:"boolean",default:ae.enabled,markdownDescription:b.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(194,null),b.localize(195,null)],default:"afterPaste"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ie=ae;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showPasteSelector:n(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Fe="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$k?Fe:g.$l?qe:Ae,fontWeight:"normal",fontSize:g.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ce){return e.editorOptionsRegistry[ce.id]=ce,ce}var Ye;(function(ce){ce[ce.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ce[ce.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ce[ce.accessibilitySupport=2]="accessibilitySupport",ce[ce.accessibilityPageSize=3]="accessibilityPageSize",ce[ce.ariaLabel=4]="ariaLabel",ce[ce.ariaRequired=5]="ariaRequired",ce[ce.autoClosingBrackets=6]="autoClosingBrackets",ce[ce.autoClosingComments=7]="autoClosingComments",ce[ce.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ce[ce.autoClosingDelete=9]="autoClosingDelete",ce[ce.autoClosingOvertype=10]="autoClosingOvertype",ce[ce.autoClosingQuotes=11]="autoClosingQuotes",ce[ce.autoIndent=12]="autoIndent",ce[ce.automaticLayout=13]="automaticLayout",ce[ce.autoSurround=14]="autoSurround",ce[ce.bracketPairColorization=15]="bracketPairColorization",ce[ce.guides=16]="guides",ce[ce.codeLens=17]="codeLens",ce[ce.codeLensFontFamily=18]="codeLensFontFamily",ce[ce.codeLensFontSize=19]="codeLensFontSize",ce[ce.colorDecorators=20]="colorDecorators",ce[ce.colorDecoratorsLimit=21]="colorDecoratorsLimit",ce[ce.columnSelection=22]="columnSelection",ce[ce.comments=23]="comments",ce[ce.contextmenu=24]="contextmenu",ce[ce.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ce[ce.cursorBlinking=26]="cursorBlinking",ce[ce.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ce[ce.cursorStyle=28]="cursorStyle",ce[ce.cursorSurroundingLines=29]="cursorSurroundingLines",ce[ce.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ce[ce.cursorWidth=31]="cursorWidth",ce[ce.disableLayerHinting=32]="disableLayerHinting",ce[ce.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ce[ce.domReadOnly=34]="domReadOnly",ce[ce.dragAndDrop=35]="dragAndDrop",ce[ce.dropIntoEditor=36]="dropIntoEditor",ce[ce.emptySelectionClipboard=37]="emptySelectionClipboard",ce[ce.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ce[ce.extraEditorClassName=39]="extraEditorClassName",ce[ce.fastScrollSensitivity=40]="fastScrollSensitivity",ce[ce.find=41]="find",ce[ce.fixedOverflowWidgets=42]="fixedOverflowWidgets",ce[ce.folding=43]="folding",ce[ce.foldingStrategy=44]="foldingStrategy",ce[ce.foldingHighlight=45]="foldingHighlight",ce[ce.foldingImportsByDefault=46]="foldingImportsByDefault",ce[ce.foldingMaximumRegions=47]="foldingMaximumRegions",ce[ce.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ce[ce.fontFamily=49]="fontFamily",ce[ce.fontInfo=50]="fontInfo",ce[ce.fontLigatures=51]="fontLigatures",ce[ce.fontSize=52]="fontSize",ce[ce.fontWeight=53]="fontWeight",ce[ce.fontVariations=54]="fontVariations",ce[ce.formatOnPaste=55]="formatOnPaste",ce[ce.formatOnType=56]="formatOnType",ce[ce.glyphMargin=57]="glyphMargin",ce[ce.gotoLocation=58]="gotoLocation",ce[ce.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ce[ce.hover=60]="hover",ce[ce.inDiffEditor=61]="inDiffEditor",ce[ce.inlineSuggest=62]="inlineSuggest",ce[ce.letterSpacing=63]="letterSpacing",ce[ce.lightbulb=64]="lightbulb",ce[ce.lineDecorationsWidth=65]="lineDecorationsWidth",ce[ce.lineHeight=66]="lineHeight",ce[ce.lineNumbers=67]="lineNumbers",ce[ce.lineNumbersMinChars=68]="lineNumbersMinChars",ce[ce.linkedEditing=69]="linkedEditing",ce[ce.links=70]="links",ce[ce.matchBrackets=71]="matchBrackets",ce[ce.minimap=72]="minimap",ce[ce.mouseStyle=73]="mouseStyle",ce[ce.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ce[ce.mouseWheelZoom=75]="mouseWheelZoom",ce[ce.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ce[ce.multiCursorModifier=77]="multiCursorModifier",ce[ce.multiCursorPaste=78]="multiCursorPaste",ce[ce.multiCursorLimit=79]="multiCursorLimit",ce[ce.occurrencesHighlight=80]="occurrencesHighlight",ce[ce.overviewRulerBorder=81]="overviewRulerBorder",ce[ce.overviewRulerLanes=82]="overviewRulerLanes",ce[ce.padding=83]="padding",ce[ce.pasteAs=84]="pasteAs",ce[ce.parameterHints=85]="parameterHints",ce[ce.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ce[ce.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ce[ce.quickSuggestions=88]="quickSuggestions",ce[ce.quickSuggestionsDelay=89]="quickSuggestionsDelay",ce[ce.readOnly=90]="readOnly",ce[ce.readOnlyMessage=91]="readOnlyMessage",ce[ce.renameOnType=92]="renameOnType",ce[ce.renderControlCharacters=93]="renderControlCharacters",ce[ce.renderFinalNewline=94]="renderFinalNewline",ce[ce.renderLineHighlight=95]="renderLineHighlight",ce[ce.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ce[ce.renderValidationDecorations=97]="renderValidationDecorations",ce[ce.renderWhitespace=98]="renderWhitespace",ce[ce.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ce[ce.roundedSelection=100]="roundedSelection",ce[ce.rulers=101]="rulers",ce[ce.scrollbar=102]="scrollbar",ce[ce.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ce[ce.scrollBeyondLastLine=104]="scrollBeyondLastLine",ce[ce.scrollPredominantAxis=105]="scrollPredominantAxis",ce[ce.selectionClipboard=106]="selectionClipboard",ce[ce.selectionHighlight=107]="selectionHighlight",ce[ce.selectOnLineNumbers=108]="selectOnLineNumbers",ce[ce.showFoldingControls=109]="showFoldingControls",ce[ce.showUnused=110]="showUnused",ce[ce.snippetSuggestions=111]="snippetSuggestions",ce[ce.smartSelect=112]="smartSelect",ce[ce.smoothScrolling=113]="smoothScrolling",ce[ce.stickyScroll=114]="stickyScroll",ce[ce.stickyTabStops=115]="stickyTabStops",ce[ce.stopRenderingLineAfter=116]="stopRenderingLineAfter",ce[ce.suggest=117]="suggest",ce[ce.suggestFontSize=118]="suggestFontSize",ce[ce.suggestLineHeight=119]="suggestLineHeight",ce[ce.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ce[ce.suggestSelection=121]="suggestSelection",ce[ce.tabCompletion=122]="tabCompletion",ce[ce.tabIndex=123]="tabIndex",ce[ce.unicodeHighlighting=124]="unicodeHighlighting",ce[ce.unusualLineTerminators=125]="unusualLineTerminators",ce[ce.useShadowDOM=126]="useShadowDOM",ce[ce.useTabStops=127]="useTabStops",ce[ce.wordBreak=128]="wordBreak",ce[ce.wordSeparators=129]="wordSeparators",ce[ce.wordWrap=130]="wordWrap",ce[ce.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ce[ce.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ce[ce.wordWrapColumn=133]="wordWrapColumn",ce[ce.wordWrapOverride1=134]="wordWrapOverride1",ce[ce.wordWrapOverride2=135]="wordWrapOverride2",ce[ce.wrappingIndent=136]="wrappingIndent",ce[ce.wrappingStrategy=137]="wrappingStrategy",ce[ce.showDeprecated=138]="showDeprecated",ce[ce.inlayHints=139]="inlayHints",ce[ce.editorClassName=140]="editorClassName",ce[ce.pixelRatio=141]="pixelRatio",ce[ce.tabFocusMode=142]="tabFocusMode",ce[ce.layoutInfo=143]="layoutInfo",ce[ce.wrappingInfo=144]="wrappingInfo",ce[ce.defaultColorDecorators=145]="defaultColorDecorators",ce[ce.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ce[ce.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ye||(e.EditorOption=Ye={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(196,null)})),acceptSuggestionOnEnter:Le(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(197,null),""],markdownDescription:b.localize(198,null)})),accessibilitySupport:Le(new h),accessibilityPageSize:Le(new a(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(199,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",b.localize(200,null))),ariaRequired:Le(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Le(new o(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(202,null),b.localize(203,null),""],description:b.localize(204,null)})),autoClosingComments:Le(new o(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(205,null),b.localize(206,null),""],description:b.localize(207,null)})),autoClosingDelete:Le(new o(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(208,null),""],description:b.localize(209,null)})),autoClosingOvertype:Le(new o(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(210,null),""],description:b.localize(211,null)})),autoClosingQuotes:Le(new o(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(212,null),b.localize(213,null),""],description:b.localize(214,null)})),autoIndent:Le(new i(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[b.localize(215,null),b.localize(216,null),b.localize(217,null),b.localize(218,null),b.localize(219,null)],description:b.localize(220,null)})),automaticLayout:Le(new r(13,"automaticLayout",!1)),autoSurround:Le(new o(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null),""],description:b.localize(224,null)})),bracketPairColorization:Le(new re),bracketPairGuides:Le(new Z),stickyTabStops:Le(new r(115,"stickyTabStops",!1,{description:b.localize(225,null)})),codeLens:Le(new r(17,"codeLens",!0,{description:b.localize(226,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:b.localize(227,null)})),codeLensFontSize:Le(new a(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(228,null)})),colorDecorators:Le(new r(20,"colorDecorators",!0,{description:b.localize(229,null)})),colorDecoratorActivatedOn:Le(new o(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(230,null),b.localize(231,null),b.localize(232,null)],description:b.localize(233,null)})),colorDecoratorsLimit:Le(new a(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(234,null)})),columnSelection:Le(new r(22,"columnSelection",!1,{description:b.localize(235,null)})),comments:Le(new y),contextmenu:Le(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new r(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(236,null)})),cursorBlinking:Le(new i(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:b.localize(237,null)})),cursorSmoothCaretAnimation:Le(new o(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(238,null),b.localize(239,null),b.localize(240,null)],description:b.localize(241,null)})),cursorStyle:Le(new i(28,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(242,null)})),cursorSurroundingLines:Le(new a(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(243,null)})),cursorSurroundingLinesStyle:Le(new o(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(244,null),b.localize(245,null)],markdownDescription:b.localize(246,null)})),cursorWidth:Le(new a(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(247,null)})),disableLayerHinting:Le(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new r(34,"domReadOnly",!1)),dragAndDrop:Le(new r(35,"dragAndDrop",!0,{description:b.localize(248,null)})),emptySelectionClipboard:Le(new O),dropIntoEditor:Le(new it),stickyScroll:Le(new ue),experimentalWhitespaceRendering:Le(new o(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(249,null),b.localize(250,null),b.localize(251,null)],description:b.localize(252,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new l(40,"fastScrollSensitivity",5,ce=>ce<=0?5:ce,{markdownDescription:b.localize(253,null)})),find:Le(new M),fixedOverflowWidgets:Le(new r(42,"fixedOverflowWidgets",!1)),folding:Le(new r(43,"folding",!0,{description:b.localize(254,null)})),foldingStrategy:Le(new o(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(255,null),b.localize(256,null)],description:b.localize(257,null)})),foldingHighlight:Le(new r(45,"foldingHighlight",!0,{description:b.localize(258,null)})),foldingImportsByDefault:Le(new r(46,"foldingImportsByDefault",!1,{description:b.localize(259,null)})),foldingMaximumRegions:Le(new a(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(260,null)})),unfoldOnClickAfterEndOfLine:Le(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(261,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(262,null)})),fontInfo:Le(new F),fontLigatures2:Le(new j),fontSize:Le(new V),fontWeight:Le(new H),fontVariations:Le(new U),formatOnPaste:Le(new r(55,"formatOnPaste",!1,{description:b.localize(263,null)})),formatOnType:Le(new r(56,"formatOnType",!1,{description:b.localize(264,null)})),glyphMargin:Le(new r(57,"glyphMargin",!0,{description:b.localize(265,null)})),gotoLocation:Le(new fe),hideCursorInOverviewRuler:Le(new r(59,"hideCursorInOverviewRuler",!1,{description:b.localize(266,null)})),hover:Le(new X),inDiffEditor:Le(new r(61,"inDiffEditor",!1)),letterSpacing:Le(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ce=>l.clamp(ce,-5,20),{description:b.localize(267,null)})),lightbulb:Le(new me),lineDecorationsWidth:Le(new G),lineHeight:Le(new z),lineNumbers:Le(new he),lineNumbersMinChars:Le(new a(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new r(69,"linkedEditing",!1,{description:b.localize(268,null)})),links:Le(new r(70,"links",!0,{description:b.localize(269,null)})),matchBrackets:Le(new o(71,"matchBrackets","always",["always","near","never"],{description:b.localize(270,null)})),minimap:Le(new K),mouseStyle:Le(new o(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new l(74,"mouseWheelScrollSensitivity",1,ce=>ce===0?1:ce,{markdownDescription:b.localize(271,null)})),mouseWheelZoom:Le(new r(75,"mouseWheelZoom",!1,{markdownDescription:b.localize(272,null)})),multiCursorMergeOverlapping:Le(new r(76,"multiCursorMergeOverlapping",!0,{description:b.localize(273,null)})),multiCursorModifier:Le(new i(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ge,{markdownEnumDescriptions:[b.localize(274,null),b.localize(275,null)],markdownDescription:b.localize(276,null)})),multiCursorPaste:Le(new o(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(277,null),b.localize(278,null)],markdownDescription:b.localize(279,null)})),multiCursorLimit:Le(new a(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(280,null)})),occurrencesHighlight:Le(new r(80,"occurrencesHighlight",!0,{description:b.localize(281,null)})),overviewRulerBorder:Le(new r(81,"overviewRulerBorder",!0,{description:b.localize(282,null)})),overviewRulerLanes:Le(new a(82,"overviewRulerLanes",3,0,3)),padding:Le(new _),pasteAs:Le(new et),parameterHints:Le(new ie),peekWidgetDefaultFocus:Le(new o(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(283,null),b.localize(284,null)],description:b.localize(285,null)})),definitionLinkOpensInPeek:Le(new r(87,"definitionLinkOpensInPeek",!1,{description:b.localize(286,null)})),quickSuggestions:Le(new Ee),quickSuggestionsDelay:Le(new a(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(287,null)})),readOnly:Le(new r(90,"readOnly",!1)),readOnlyMessage:Le(new be),renameOnType:Le(new r(92,"renameOnType",!1,{description:b.localize(288,null),markdownDeprecationMessage:b.localize(289,null)})),renderControlCharacters:Le(new r(93,"renderControlCharacters",!0,{description:b.localize(290,null),restricted:!0})),renderFinalNewline:Le(new o(94,"renderFinalNewline",g.$l?"dimmed":"on",["off","on","dimmed"],{description:b.localize(291,null)})),renderLineHighlight:Le(new o(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(292,null)],description:b.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Le(new r(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(294,null)})),renderValidationDecorations:Le(new o(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new o(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(295,null),b.localize(296,null),b.localize(297,null),""],description:b.localize(298,null)})),revealHorizontalRightPadding:Le(new a(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new r(100,"roundedSelection",!0,{description:b.localize(299,null)})),rulers:Le(new le),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new a(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(300,null)})),scrollBeyondLastLine:Le(new r(104,"scrollBeyondLastLine",!0,{description:b.localize(301,null)})),scrollPredominantAxis:Le(new r(105,"scrollPredominantAxis",!0,{description:b.localize(302,null)})),selectionClipboard:Le(new r(106,"selectionClipboard",!0,{description:b.localize(303,null),included:g.$l})),selectionHighlight:Le(new r(107,"selectionHighlight",!0,{description:b.localize(304,null)})),selectOnLineNumbers:Le(new r(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new o(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(305,null),b.localize(306,null),b.localize(307,null)],description:b.localize(308,null)})),showUnused:Le(new r(110,"showUnused",!0,{description:b.localize(309,null)})),showDeprecated:Le(new r(138,"showDeprecated",!0,{description:b.localize(310,null)})),inlayHints:Le(new pe),snippetSuggestions:Le(new o(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(311,null),b.localize(312,null),b.localize(313,null),b.localize(314,null)],description:b.localize(315,null)})),smartSelect:Le(new je),smoothScrolling:Le(new r(113,"smoothScrolling",!1,{description:b.localize(316,null)})),stopRenderingLineAfter:Le(new a(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ye),inlineSuggest:Le(new te),inlineCompletionsAccessibilityVerbose:Le(new r(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(317,null)})),suggestFontSize:Le(new a(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new a(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new r(120,"suggestOnTriggerCharacters",!0,{description:b.localize(320,null)})),suggestSelection:Le(new o(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(321,null),b.localize(322,null),b.localize(323,null)],description:b.localize(324,null)})),tabCompletion:Le(new o(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(325,null),b.localize(326,null),b.localize(327,null)],description:b.localize(328,null)})),tabIndex:Le(new a(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new Q),unusualLineTerminators:Le(new o(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(329,null),b.localize(330,null),b.localize(331,null)],description:b.localize(332,null)})),useShadowDOM:Le(new r(126,"useShadowDOM",!0)),useTabStops:Le(new r(127,"useTabStops",!0,{description:b.localize(333,null)})),wordBreak:Le(new o(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(334,null),b.localize(335,null)],description:b.localize(336,null)})),wordSeparators:Le(new t(129,"wordSeparators",R.$Yr,{description:b.localize(337,null)})),wordWrap:Le(new o(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(338,null),b.localize(339,null),b.localize(340,null),b.localize(341,null)],description:b.localize(342,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new a(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(343,null)})),wordWrapOverride1:Le(new o(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new o(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new N),defaultColorDecorators:Le(new r(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(344,null)})),pixelRatio:Le(new ne),tabFocusMode:Le(new r(142,"tabFocusMode",!1,{markdownDescription:b.localize(345,null)})),layoutInfo:Le(new q),wrappingInfo:Le(new Ze),wrappingIndent:Le(new xe),wrappingStrategy:Le(new x)}}),define(De[187],Ce([9,10]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(De[82],Ce([1,0,78,2,164,34,174,187]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$et=e.$dt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$ct=e.$bt=e.SymbolKinds=e.SymbolTag=e.$at=e.$_s=e.SymbolKind=e.$$s=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$0s=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$9s=e.$8s=e.$7s=void 0;class E{constructor(j,U,F){this.offset=j,this.type=U,this.language=F,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$7s=E;class w{constructor(j,U){this.tokens=j,this.endState=U,this._tokenizationResultBrand=void 0}}e.$8s=w;class A{constructor(j,U){this.tokens=j,this.endState=U,this._encodedTokenizationResultBrand=void 0}}e.$9s=A;var I;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var v;(function(M){const j=new Map;j.set(0,D.$Sj.symbolMethod),j.set(1,D.$Sj.symbolFunction),j.set(2,D.$Sj.symbolConstructor),j.set(3,D.$Sj.symbolField),j.set(4,D.$Sj.symbolVariable),j.set(5,D.$Sj.symbolClass),j.set(6,D.$Sj.symbolStruct),j.set(7,D.$Sj.symbolInterface),j.set(8,D.$Sj.symbolModule),j.set(9,D.$Sj.symbolProperty),j.set(10,D.$Sj.symbolEvent),j.set(11,D.$Sj.symbolOperator),j.set(12,D.$Sj.symbolUnit),j.set(13,D.$Sj.symbolValue),j.set(15,D.$Sj.symbolEnum),j.set(14,D.$Sj.symbolConstant),j.set(15,D.$Sj.symbolEnum),j.set(16,D.$Sj.symbolEnumMember),j.set(17,D.$Sj.symbolKeyword),j.set(27,D.$Sj.symbolSnippet),j.set(18,D.$Sj.symbolText),j.set(19,D.$Sj.symbolColor),j.set(20,D.$Sj.symbolFile),j.set(21,D.$Sj.symbolReference),j.set(22,D.$Sj.symbolCustomColor),j.set(23,D.$Sj.symbolFolder),j.set(24,D.$Sj.symbolTypeParameter),j.set(25,D.$Sj.account),j.set(26,D.$Sj.issues);function U(H){let fe=j.get(H);return fe||(console.info("No codicon found for CompletionItemKind "+H),fe=D.$Sj.symbolProperty),fe}M.toIcon=U;const F=new Map;F.set("method",0),F.set("function",1),F.set("constructor",2),F.set("field",3),F.set("variable",4),F.set("class",5),F.set("struct",6),F.set("interface",7),F.set("module",8),F.set("property",9),F.set("event",10),F.set("operator",11),F.set("unit",12),F.set("value",13),F.set("constant",14),F.set("enum",15),F.set("enum-member",16),F.set("enumMember",16),F.set("keyword",17),F.set("snippet",27),F.set("text",18),F.set("color",19),F.set("file",20),F.set("reference",21),F.set("customcolor",22),F.set("folder",23),F.set("type-parameter",24),F.set("typeParameter",24),F.set("account",25),F.set("issue",26);function V(H,fe){let X=F.get(H);return typeof X>"u"&&!fe&&(X=9),X}M.fromString=V})(v||(e.CompletionItemKinds=v={}));var k;(function(M){M[M.Deprecated=1]="Deprecated"})(k||(e.CompletionItemTag=k={}));var S;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var p;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var u;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(u||(e.InlineCompletionTriggerKind=u={}));class r{constructor(j,U,F,V){this.range=j,this.text=U,this.completionKind=F,this.isSnippetText=V}equals(j){return L.$ns.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$0s=r;var s;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var a;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(a||(e.SignatureHelpTriggerKind=a={}));var m;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(m||(e.DocumentHighlightKind=m={}));function l(M){return M&&T.URI.isUri(M.uri)&&L.$ns.isIRange(M.range)&&(L.$ns.isIRange(M.originSelectionRange)||L.$ns.isIRange(M.targetSelectionRange))}e.$$s=l;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$_s={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function n(M,j){return(0,b.localize)(26,null,M,e.$_s[j])}e.$at=n;var o;(function(M){M[M.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var i;(function(M){const j=new Map;j.set(0,D.$Sj.symbolFile),j.set(1,D.$Sj.symbolModule),j.set(2,D.$Sj.symbolNamespace),j.set(3,D.$Sj.symbolPackage),j.set(4,D.$Sj.symbolClass),j.set(5,D.$Sj.symbolMethod),j.set(6,D.$Sj.symbolProperty),j.set(7,D.$Sj.symbolField),j.set(8,D.$Sj.symbolConstructor),j.set(9,D.$Sj.symbolEnum),j.set(10,D.$Sj.symbolInterface),j.set(11,D.$Sj.symbolFunction),j.set(12,D.$Sj.symbolVariable),j.set(13,D.$Sj.symbolConstant),j.set(14,D.$Sj.symbolString),j.set(15,D.$Sj.symbolNumber),j.set(16,D.$Sj.symbolBoolean),j.set(17,D.$Sj.symbolArray),j.set(18,D.$Sj.symbolObject),j.set(19,D.$Sj.symbolKey),j.set(20,D.$Sj.symbolNull),j.set(21,D.$Sj.symbolEnumMember),j.set(22,D.$Sj.symbolStruct),j.set(23,D.$Sj.symbolEvent),j.set(24,D.$Sj.symbolOperator),j.set(25,D.$Sj.symbolTypeParameter);function U(F){let V=j.get(F);return V||(console.info("No codicon found for SymbolKind "+F),V=D.$Sj.symbolProperty),V}M.toIcon=U})(i||(e.SymbolKinds=i={}));class c{static asEditOperation(j){return g.$os.replace(L.$ns.lift(j.range),j.text)}}e.$bt=c;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(j){switch(j){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(j)}constructor(j){this.value=j}}e.$ct=h;var y;(function(M){function j(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}M.is=j})(y||(e.Command=y={}));var C;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(C||(e.CommentThreadCollapsibleState=C={}));var $;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})($||(e.CommentThreadState=$={}));var f;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(f||(e.CommentMode=f={}));var d;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(d||(e.CommentState=d={}));var P;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class N{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$dt=N,e.$et=new R.$Ys;var O;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(O||(e.ExternalUriOpenerPriority=O={}))}),define(De[188],Ce([9,10]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[189],Ce([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(De[190],Ce([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(De[191],Ce([9,10]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(De[192],Ce([9,10]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[193],Ce([9,10]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[194],Ce([9,10]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[195],Ce([9,10]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(De[196],Ce([9,10]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(De[197],Ce([9,10]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[198],Ce([9,10]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(De[199],Ce([9,10]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(De[200],Ce([9,10]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[201],Ce([9,10]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(De[202],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(De[203],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[204],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[205],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[206],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(De[207],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[208],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(De[209],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[210],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[211],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[212],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[213],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[214],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[215],Ce([9,10]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[216],Ce([9,10]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(De[217],Ce([9,10]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(De[218],Ce([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[219],Ce([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[220],Ce([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[221],Ce([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[222],Ce([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[223],Ce([9,10]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[224],Ce([9,10]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[225],Ce([9,10]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(De[226],Ce([9,10]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[227],Ce([1,0,8,190]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var g;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(g||(e.TokenType=g={}));function L(...w){switch(w.length){case 1:return(0,T.localize)(0,null,w[0]);case 2:return(0,T.localize)(1,null,w[0],w[1]);case 3:return(0,T.localize)(2,null,w[0],w[1],w[2]);default:return}}const R=(0,T.localize)(3,null),b=(0,T.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,D.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const I=this.d,v=this.c.substring(this.d,this.e),k={type:19,offset:this.d,lexeme:v};this.g.push({offset:I,lexeme:v,additionalInfo:A}),this.f.push(k)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const I=this.c.substring(this.d,this.e),v=E.b.get(I);v?this.k(v):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,I=!1,v=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const S=this.c.charCodeAt(A);if(I)I=!1;else if(S===47&&!v){A++;break}else S===91?v=!0:S===92?I=!0:S===93&&(v=!1);A++}for(;A<this.c.length&&E.a.has(this.c.charCodeAt(A));)A++;this.e=A;const k=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:k,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=E}),define(De[228],Ce([1,0,24,38,193,371]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function E(r){return r=r.trim(),r==="*"||R.test(r)}e.$Eo=E;function w(r){if(!E(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const s=r.match(R);return s?{hasCaret:s[1]==="^",hasGreaterEquals:s[1]===">=",majorBase:s[2]==="x"?0:parseInt(s[2],10),majorMustEqual:s[2]!=="x",minorBase:s[4]==="x"?0:parseInt(s[4],10),minorMustEqual:s[4]!=="x",patchBase:s[6]==="x"?0:parseInt(s[6],10),patchMustEqual:s[6]!=="x",preRelease:s[8]||null}:null}e.$Fo=w;function A(r){if(!r)return null;const s=r.majorBase,a=r.majorMustEqual,m=r.minorBase;let l=r.minorMustEqual;const t=r.patchBase;let n=r.patchMustEqual;r.hasCaret&&(s===0||(l=!1),n=!1);let o=0;if(r.preRelease){const i=b.exec(r.preRelease);if(i){const[,c,h,y]=i;o=Date.UTC(Number(c),Number(h)-1,Number(y))}}return{majorBase:s,majorMustEqual:a,minorBase:m,minorMustEqual:l,patchBase:t,patchMustEqual:n,isMinimum:r.hasGreaterEquals,notBefore:o}}e.$Go=A;function I(r,s,a){let m;typeof r=="string"?m=A(w(r)):m=r;let l;s instanceof Date?l=s.getTime():typeof s=="string"&&(l=new Date(s).getTime());let t;if(typeof a=="string"?t=A(w(a)):t=a,!m||!t)return!1;const n=m.majorBase,o=m.minorBase,i=m.patchBase;let c=t.majorBase,h=t.minorBase,y=t.patchBase;const C=t.notBefore;let $=t.majorMustEqual,f=t.minorMustEqual,d=t.patchMustEqual;return t.isMinimum?n>c?!0:n<c?!1:o>h?!0:o<h||l&&l<C?!1:i>=y:(n===1&&c===0&&(!$||!f||!d)&&(c=1,h=0,y=0,$=!0,f=!1,d=!1),n<c?!1:n>c?!$:o<h?!1:o>h?!f:i<y?!1:i>y?!d:!(l&&l<C))}e.$Ho=I;function v(r,s,a,m,l){const t=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return t.push([T.default.Error,g.localize(0,null)]),t;if(typeof m.name!="string")return t.push([T.default.Error,g.localize(1,null,"name")]),t;if(typeof m.version!="string")return t.push([T.default.Error,g.localize(2,null,"version")]),t;if(!m.engines)return t.push([T.default.Error,g.localize(3,null,"engines")]),t;if(typeof m.engines.vscode!="string")return t.push([T.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof m.extensionDependencies<"u"&&!u(m.extensionDependencies))return t.push([T.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof m.activationEvents<"u"){if(!u(m.activationEvents))return t.push([T.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof m.main>"u"&&typeof m.browser>"u")return t.push([T.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&t.push([T.default.Warning,g.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return t.push([T.default.Error,g.localize(9,null,"main")]),t;{const i=(0,D.$ug)(a,m.main);(0,D.$og)(i,a)||t.push([T.default.Warning,g.localize(10,null,i.path,a.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return t.push([T.default.Error,g.localize(11,null,"browser")]),t;{const i=(0,D.$ug)(a,m.browser);(0,D.$og)(i,a)||t.push([T.default.Warning,g.localize(12,null,i.path,a.path)])}}if(!L.valid(m.version))return t.push([T.default.Error,g.localize(13,null)]),t;const n=[];if(!k(r,s,m,l,n))for(const i of n)t.push([T.default.Error,i]);return t}e.$Io=v;function k(r,s,a,m,l){return m||typeof a.main>"u"&&typeof a.browser>"u"?!0:p(r,s,a.engines.vscode,l)}e.$Jo=k;function S(r,s,a){return r==="*"||p(s,a,r)}e.$Ko=S;function p(r,s,a,m=[]){const l=A(w(a));if(!l)return m.push(g.localize(14,null,a)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return m.push(g.localize(15,null,a)),!1}else if(!l.majorMustEqual)return m.push(g.localize(16,null,a)),!1;return I(r,s,l)?!0:(m.push(g.localize(17,null,r,a)),!1)}function u(r){if(!Array.isArray(r))return!1;for(let s=0,a=r.length;s<a;s++)if(typeof r[s]!="string")return!1;return!0}}),define(De[103],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class D{constructor(g,L=[],R=!1){this.ctor=g,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$Kh=D}),define(De[104],Ce([1,0,103]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=e.InstantiationType=void 0;const T=[];var g;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function L(b,E,w){E instanceof D.$Kh||(E=new D.$Kh(E,[],!!w)),T.push([b,E])}e.$pr=L;function R(){return T}e.$qr=R}),define(De[229],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0;class D{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$7p=D;class T{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const b=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(R);b.outgoing.set(E.key,E),E.incoming.set(b.key,b)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const b of this.a.values())b.outgoing.delete(R),b.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let b=this.a.get(R);return b||(b=new D(R,L),this.a.set(R,b)),b}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,b]of this.a)L.push(`${R}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const b=new Set([L]),E=this.c(R,b);if(E)return E}}c(L,R){for(const[b,E]of L.outgoing){if(R.has(b))return[...R,b].join(" -> ");R.add(b);const w=this.c(E,R);if(w)return w;R.delete(b)}}}e.$8p=T}),define(De[5],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e._util=void 0;var D;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function b(E){return E[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=b})(D||(e._util=D={})),e.$Mh=g("instantiationService");function T(R,b,E){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:R,index:E}):(b[D.DI_DEPENDENCIES]=[{id:R,index:E}],b[D.DI_TARGET]=b)}function g(R){if(D.serviceIds.has(R))return D.serviceIds.get(R);const b=function(E,w,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(b,E,A)};return b.toString=()=>R,D.serviceIds.set(R,b),b}e.$Nh=g;function L(R){return R}e.$Oh=L}),define(De[49],Ce([1,0,18,2,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,g.$Nh)("configurationService");function L(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof T.URI)}e.$ii=L;function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof T.URI)}e.$ji=R;var b;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function E(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=E;function w(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}e.$li=w;function A(r,s){const a=Object.create(null);for(const m in r)I(a,m,r[m],s);return a}e.$mi=A;function I(r,s,a,m){const l=s.split("."),t=l.pop();let n=r;for(let o=0;o<l.length;o++){const i=l[o];let c=n[i];switch(typeof c){case"undefined":c=n[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${s} as ${l.slice(0,o+1).join(".")} is ${JSON.stringify(c)}`);return}n=c}if(typeof n=="object"&&n!==null)try{n[t]=a}catch{m(`Ignoring ${s} as ${l.join(".")} is ${JSON.stringify(n)}`)}else m(`Ignoring ${s} as ${l.join(".")} is ${JSON.stringify(n)}`)}e.$ni=I;function v(r,s){const a=s.split(".");k(r,a)}e.$oi=v;function k(r,s){const a=s.shift();if(s.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const m=r[a];typeof m=="object"&&!Array.isArray(m)&&(k(m,s),Object.keys(m).length===0&&delete r[a])}}function S(r,s,a){function m(n,o){let i=n;for(const c of o){if(typeof i!="object"||i===null)return;i=i[c]}return i}const l=s.split("."),t=m(r,l);return typeof t>"u"?a:t}e.$pi=S;function p(r,s,a){Object.keys(s).forEach(m=>{m!=="__proto__"&&(m in r?D.$zf(r[m])&&D.$zf(s[m])?p(r[m],s[m],a):a&&(r[m]=s[m]):r[m]=s[m])})}e.$qi=p;function u(r){return r.replace(/[\[\]]/g,"")}e.$ri=u}),define(De[41],Ce([1,0,12,15,227,5,189,8]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",D.$k),E.set("isLinux",D.$l),E.set("isWindows",D.$j),E.set("isWeb",D.$p),E.set("isMacNative",D.$k&&!D.$p),E.set("isEdge",D.$H),E.set("isFirefox",D.$F),E.set("isChrome",D.$E),E.set("isSafari",D.$G);function w(G,z){if(E.get(G)!==void 0)throw(0,b.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(G,z)}e.$Ji=w;const A=Object.prototype.hasOwnProperty;var I;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const v={regexParsingWithErrorRecovery:!0},k=(0,R.localize)(0,null),S=(0,R.localize)(1,null),p=(0,R.localize)(2,null),u=(0,R.localize)(3,null),r=(0,R.localize)(4,null),s=(0,R.localize)(5,null),a=(0,R.localize)(6,null),m=(0,R.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=v){this.k=z,this.d=new g.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:k,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const K=this.l();if(!this.E()){const ge=this.D(),_=ge.type===17?s:void 0;throw this.h.push({message:r,offset:ge.offset,lexeme:g.$Ii.getLexeme(ge),additionalInfo:_}),l.c}return K}catch(K){if(K!==l.c)throw K;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const K=this.o();z.push(K)}return z.length===1?z[0]:t.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const K=this.s();z.push(K)}return z.length===1?z[0]:t.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const K=this.l();return this.A(1,u),K?.negate()}case 17:return this.z(),P.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const K=this.l();return this.A(1,u),K}case 17:{const K=z.lexeme;if(this.z(),this.y(9)){const _=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),_.type!==10)throw this.B("REGEX",_);const ie=_.lexeme,ne=ie.lastIndexOf("/"),Ee=ne===ie.length-1?void 0:this.w(ie.substring(ne+1));let oe;try{oe=new RegExp(ie.substring(1,ne),Ee)}catch{throw this.B("REGEX",_)}return F.create(K,oe)}switch(_.type){case 10:case 19:{const ie=[_.lexeme];this.z();let ne=this.D(),Ee=0;for(let be=0;be<_.lexeme.length;be++)_.lexeme.charCodeAt(be)===40?Ee++:_.lexeme.charCodeAt(be)===41&&Ee--;for(;!this.E()&&ne.type!==15&&ne.type!==16;){switch(ne.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let be=0;be<ne.lexeme.length;be++)ne.lexeme.charCodeAt(be)===40?Ee++:_.lexeme.charCodeAt(be)===41&&Ee--}if(Ee<0)break;ie.push(g.$Ii.getLexeme(ne)),this.z(),ne=this.D()}const oe=ie.join(""),he=oe.lastIndexOf("/"),ee=he===oe.length-1?void 0:this.w(oe.substring(he+1));let le;try{le=new RegExp(oe.substring(1,he),ee)}catch{throw this.B("REGEX",_)}return t.regex(K,le)}case 18:{const ie=_.lexeme;this.z();let ne=null;if(!(0,T.$Ae)(ie)){const Ee=ie.indexOf("/"),oe=ie.lastIndexOf("/");if(Ee!==oe&&Ee>=0){const he=ie.slice(Ee+1,oe),ee=ie[oe+1]==="i"?"i":"";try{ne=new RegExp(he,ee)}catch{throw this.B("REGEX",_)}}}if(ne===null)throw this.B("REGEX",_);return F.create(K,ne)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const _=this.u();return t.notIn(K,_)}switch(this.D().type){case 3:{this.z();const _=this.u();if(this.x().type===18)return t.equals(K,_);switch(_){case"true":return t.has(K);case"false":return t.not(K);default:return t.equals(K,_)}}case 4:{this.z();const _=this.u();if(this.x().type===18)return t.notEquals(K,_);switch(_){case"true":return t.not(K);case"false":return t.has(K);default:return t.notEquals(K,_)}}case 5:return this.z(),j.create(K,this.u());case 6:return this.z(),U.create(K,this.u());case 7:return this.z(),O.create(K,this.u());case 8:return this.z(),M.create(K,this.u());case 13:return this.z(),t.in(K,this.u());default:return t.has(K)}}case 20:throw this.h.push({message:a,offset:z.offset,lexeme:"",additionalInfo:m}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,K){if(this.C(z))return this.z();throw this.B(K,this.D())}B(z,K,ge){const _=(0,R.localize)(8,null,z,g.$Ii.getLexeme(K)),ie=K.offset,ne=g.$Ii.getLexeme(K);return this.h.push({message:_,offset:ie,lexeme:ne,additionalInfo:ge}),l.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=l;class t{static false(){return c.INSTANCE}static true(){return h.INSTANCE}static has(z){return y.create(z)}static equals(z,K){return C.create(z,K)}static notEquals(z,K){return d.create(z,K)}static regex(z,K){return F.create(z,K)}static in(z,K){return $.create(z,K)}static notIn(z,K){return f.create(z,K)}static not(z){return P.create(z)}static and(...z){return fe.create(z,null,!0)}static or(...z){return X.create(z,null,!0)}static greater(z,K){return O.create(z,K)}static greaterEquals(z,K){return M.create(z,K)}static smaller(z,K){return j.create(z,K)}static smallerEquals(z,K){return U.create(z,K)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Li=t;function n(G){const z=new l({regexParsingWithErrorRecovery:!1});return G.map(K=>(z.parse(K),z.lexingErrors.length>0?z.lexingErrors.map(ge=>({errorMessage:ge.additionalInfo?(0,R.localize)(9,null,ge.additionalInfo):(0,R.localize)(10,null),offset:ge.offset,length:ge.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(ge=>({errorMessage:ge.additionalInfo?`${ge.message}. ${ge.additionalInfo}`:ge.message,offset:ge.offset,length:ge.lexeme.length})):[]))}e.$Mi=n;function o(G,z){const K=G?G.substituteConstants():void 0,ge=z?z.substituteConstants():void 0;return!K&&!ge?!0:!K||!ge?!1:K.equals(ge)}e.$Ni=o;function i(G,z){return G.cmp(z)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return h.INSTANCE}}e.$Oi=c;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return c.INSTANCE}}e.$Pi=h;class y{static create(z,K=null){const ge=E.get(z);return typeof ge=="boolean"?ge?h.INSTANCE:c.INSTANCE:new y(z,K)}constructor(z,K){this.key=z,this.c=K,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:q(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=E.get(this.key);return typeof z=="boolean"?z?h.INSTANCE:c.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Qi=y;class C{static create(z,K,ge=null){if(typeof K=="boolean")return K?y.create(z,ge):P.create(z,ge);const _=E.get(z);return typeof _=="boolean"?K===(_?"true":"false")?h.INSTANCE:c.INSTANCE:new C(z,K,ge)}constructor(z,K,ge){this.c=z,this.d=K,this.f=ge,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:x(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=E.get(this.c);if(typeof z=="boolean"){const K=z?"true":"false";return this.d===K?h.INSTANCE:c.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.$Ri=C;class ${static create(z,K){return new $(z,K)}constructor(z,K){this.d=z,this.f=K,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:x(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const K=z.getValue(this.f),ge=z.getValue(this.d);return Array.isArray(K)?K.includes(ge):typeof ge=="string"&&typeof K=="object"&&K!==null?A.call(K,ge):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Si=$;class f{static create(z,K){return new f(z,K)}constructor(z,K){this.d=z,this.f=K,this.type=11,this.c=$.create(z,K)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=f;class d{static create(z,K,ge=null){if(typeof K=="boolean")return K?P.create(z,ge):y.create(z,ge);const _=E.get(z);return typeof _=="boolean"?K===(_?"true":"false")?c.INSTANCE:h.INSTANCE:new d(z,K,ge)}constructor(z,K,ge){this.c=z,this.d=K,this.f=ge,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:x(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=E.get(this.c);if(typeof z=="boolean"){const K=z?"true":"false";return this.d===K?c.INSTANCE:h.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Ui=d;class P{static create(z,K=null){const ge=E.get(z);return typeof ge=="boolean"?ge?c.INSTANCE:h.INSTANCE:new P(z,K)}constructor(z,K){this.c=z,this.d=K,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:q(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=E.get(this.c);return typeof z=="boolean"?z?c.INSTANCE:h.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Vi=P;function N(G,z){if(typeof G=="string"){const K=parseFloat(G);isNaN(K)||(G=K)}return typeof G=="string"||typeof G=="number"?z(G):c.INSTANCE}class O{static create(z,K,ge=null){return N(K,_=>new O(z,_,ge))}constructor(z,K,ge){this.c=z,this.d=K,this.f=ge,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:x(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Wi=O;class M{static create(z,K,ge=null){return N(K,_=>new M(z,_,ge))}constructor(z,K,ge){this.c=z,this.d=K,this.f=ge,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:x(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Xi=M;class j{static create(z,K,ge=null){return N(K,_=>new j(z,_,ge))}constructor(z,K,ge){this.c=z,this.d=K,this.f=ge,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:x(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Yi=j;class U{static create(z,K,ge=null){return N(K,_=>new U(z,_,ge))}constructor(z,K,ge){this.c=z,this.d=K,this.f=ge,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:x(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Zi=U;class F{static create(z,K){return new F(z,K)}constructor(z,K){this.d=z,this.f=K,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const K=this.f?this.f.source:"",ge=z.f?z.f.source:"";return K<ge?-1:K>ge?1:0}equals(z){if(z.type===this.type){const K=this.f?this.f.source:"",ge=z.f?z.f.source:"";return this.d===z.d&&K===ge}return!1}substituteConstants(){return this}evaluate(z){const K=z.getValue(this.d);return this.f?this.f.test(K):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$1i=F;class V{static create(z){return new V(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new V(this.c.map(z))}negate(){return this.c}}e.$2i=V;function H(G){let z=null;for(let K=0,ge=G.length;K<ge;K++){const _=G[K].substituteConstants();if(G[K]!==_&&z===null){z=[];for(let ie=0;ie<K;ie++)z[ie]=G[ie]}z!==null&&(z[K]=_)}return z===null?G:z}class fe{static create(z,K,ge){return fe.d(z,K,ge)}constructor(z,K){this.expr=z,this.c=K,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let K=0,ge=this.expr.length;K<ge;K++){const _=i(this.expr[K],z.expr[K]);if(_!==0)return _}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let K=0,ge=this.expr.length;K<ge;K++)if(!this.expr[K].equals(z.expr[K]))return!1;return!0}return!1}substituteConstants(){const z=H(this.expr);return z===this.expr?this:fe.create(z,this.c,!1)}evaluate(z){for(let K=0,ge=this.expr.length;K<ge;K++)if(!this.expr[K].evaluate(z))return!1;return!0}static d(z,K,ge){const _=[];let ie=!1;for(const ne of z)if(ne){if(ne.type===1){ie=!0;continue}if(ne.type===0)return c.INSTANCE;if(ne.type===6){_.push(...ne.expr);continue}_.push(ne)}if(_.length===0&&ie)return h.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(i);for(let ne=1;ne<_.length;ne++)_[ne-1].equals(_[ne])&&(_.splice(ne,1),ne--);if(_.length===1)return _[0];for(;_.length>1;){const ne=_[_.length-1];if(ne.type!==9)break;_.pop();const Ee=_.pop(),oe=_.length===0,he=X.create(ne.expr.map(ee=>fe.create([ee,Ee],null,ge)),null,oe);he&&(_.push(he),_.sort(i))}if(_.length===1)return _[0];if(ge){for(let ne=0;ne<_.length;ne++)for(let Ee=ne+1;Ee<_.length;Ee++)if(_[ne].negate().equals(_[Ee]))return c.INSTANCE;if(_.length===1)return _[0]}return new fe(_,K)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const K of this.expr)z.push(...K.keys());return z}map(z){return new fe(this.expr.map(K=>K.map(z)),null)}negate(){if(!this.c){const z=[];for(const K of this.expr)z.push(K.negate());this.c=X.create(z,this,!0)}return this.c}}e.$3i=fe;class X{static create(z,K,ge){return X.d(z,K,ge)}constructor(z,K){this.expr=z,this.c=K,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let K=0,ge=this.expr.length;K<ge;K++){const _=i(this.expr[K],z.expr[K]);if(_!==0)return _}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let K=0,ge=this.expr.length;K<ge;K++)if(!this.expr[K].equals(z.expr[K]))return!1;return!0}return!1}substituteConstants(){const z=H(this.expr);return z===this.expr?this:X.create(z,this.c,!1)}evaluate(z){for(let K=0,ge=this.expr.length;K<ge;K++)if(this.expr[K].evaluate(z))return!0;return!1}static d(z,K,ge){let _=[],ie=!1;if(z){for(let ne=0,Ee=z.length;ne<Ee;ne++){const oe=z[ne];if(oe){if(oe.type===0){ie=!0;continue}if(oe.type===1)return h.INSTANCE;if(oe.type===9){_=_.concat(oe.expr);continue}_.push(oe)}}if(_.length===0&&ie)return c.INSTANCE;_.sort(i)}if(_.length!==0){if(_.length===1)return _[0];for(let ne=1;ne<_.length;ne++)_[ne-1].equals(_[ne])&&(_.splice(ne,1),ne--);if(_.length===1)return _[0];if(ge){for(let ne=0;ne<_.length;ne++)for(let Ee=ne+1;Ee<_.length;Ee++)if(_[ne].negate().equals(_[Ee]))return h.INSTANCE;if(_.length===1)return _[0]}return new X(_,K)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const K of this.expr)z.push(...K.keys());return z}map(z){return new X(this.expr.map(K=>K.map(z)),null)}negate(){if(!this.c){const z=[];for(const K of this.expr)z.push(K.negate());for(;z.length>1;){const K=z.shift(),ge=z.shift(),_=[];for(const ie of pe(K))for(const ne of pe(ge))_.push(fe.create([ie,ne],null,!1));z.unshift(X.create(_,null,!1))}this.c=X.create(z,this,!0)}return this.c}}e.$4i=X;class Y extends y{static{this.d=[]}static all(){return Y.d.values()}constructor(z,K,ge){super(z,null),this.f=K,typeof ge=="object"?Y.d.push({...ge,key:z}):ge!==!0&&Y.d.push({key:z,description:ge,type:K!=null?typeof K:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return C.create(this.key,z)}notEqualsTo(z){return d.create(this.key,z)}}e.$5i=Y,e.$6i=(0,L.$Nh)("contextKeyService");function q(G,z){return G<z?-1:G>z?1:0}function x(G,z,K,ge){return G<K?-1:G>K?1:z<ge?-1:z>ge?1:0}function me(G,z){if(G.type===0||z.type===1)return!0;if(G.type===9)return z.type===9?ue(G.expr,z.expr):!1;if(z.type===9){for(const K of z.expr)if(me(G,K))return!0;return!1}if(G.type===6){if(z.type===6)return ue(z.expr,G.expr);for(const K of G.expr)if(me(K,z))return!0;return!1}return G.equals(z)}e.$7i=me;function ue(G,z){let K=0,ge=0;for(;K<G.length&&ge<z.length;){const _=G[K].cmp(z[ge]);if(_<0)return!1;_===0&&K++,ge++}return K===G.length}function pe(G){return G.type===9?G.expr:[G]}}),define(De[230],Ce([1,0,24,38,191,5,100,12,23]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yv=e.$xv=e.ConfirmResult=e.$wv=e.$vv=e.$uv=void 0,e.$uv=(0,L.$Nh)("dialogService");var w;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(w||(w={}));class A{a(u){return this.d(u,w.Confirmation)}b(u){return this.d(u,w.Prompt)}c(u){return this.d(u,w.Input)}d(u,r){const s=[];switch(r){case w.Confirmation:{const a=u;a.primaryButton?s.push(a.primaryButton):s.push((0,g.localize)(0,null)),a.cancelButton?s.push(a.cancelButton):s.push((0,g.localize)(1,null));break}case w.Prompt:{const a=u;Array.isArray(a.buttons)&&a.buttons.length>0&&s.push(...a.buttons.map(m=>m.label)),a.cancelButton&&(a.cancelButton===!0?s.push((0,g.localize)(2,null)):typeof a.cancelButton=="string"?s.push(a.cancelButton):a.cancelButton.label?s.push(a.cancelButton.label):s.push((0,g.localize)(3,null))),s.length===0&&s.push((0,g.localize)(4,null));break}case w.Input:{const a=u;a.primaryButton?s.push(a.primaryButton):s.push((0,g.localize)(5,null)),a.cancelButton?s.push(a.cancelButton):s.push((0,g.localize)(6,null));break}}return s}e(u){if(typeof u=="string")return u;if(typeof u=="number")return u===T.default.Info?"info":u===T.default.Error?"error":u===T.default.Warning?"warning":"none"}async f(u,r,s){const a=[...u.buttons??[]];return u.cancelButton&&typeof u.cancelButton!="string"&&typeof u.cancelButton!="boolean"&&a.push(u.cancelButton),{result:await a[r]?.run({checkboxChecked:s}),checkboxChecked:s}}}e.$vv=A,e.$wv=(0,L.$Nh)("fileDialogService");var I;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const v=10;function k(p){const u=[];return u.push(...p.slice(0,v).map(r=>typeof r=="string"?r:(0,D.$rg)(r))),p.length>v&&(p.length-v===1?u.push((0,g.localize)(7,null)):u.push((0,g.localize)(8,null,p.length-v))),u.push(""),u.join(`
`)}e.$xv=k;function S(p,u){const r=(0,E.$Ym)(p);let s=(r.buttons??[]).map(t=>(0,R.$rv)(t)),a=(p.buttons||[]).map((t,n)=>n),m=0,l=r.cancelId??s.length-1;if(s.length>1){const t=typeof l=="number"?s[l]:void 0;if(b.$l||b.$k){if(typeof t=="string"&&s.length>1&&l!==1){s.splice(l,1),s.splice(1,0,t);const n=a[l];a.splice(l,1),a.splice(1,0,n),l=1}b.$l&&s.length>1&&(s=s.reverse(),a=a.reverse(),m=s.length-1,typeof t=="string"&&(l=m-1))}else if(b.$j&&typeof t=="string"&&s.length>1&&l!==s.length-1){s.splice(l,1),s.push(t);const n=a[l];a.splice(l,1),a.push(n),l=s.length-1}}return r.buttons=s,r.defaultId=m,r.cancelId=l,r.noLink=!0,r.title=r.title||u.nameLong,{options:r,buttonIndeces:a}}e.$yv=S}),define(De[131],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,D.$Nh)("environmentService"),e.$Vh=(0,D.$Oh)(e.$Uh)}),define(De[132],Ce([1,0,192,5]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$3n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=void 0,e.$Pn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Qn=new RegExp(e.$Pn),e.$Rn="__web_extension",e.$Sn="skipWalkthrough",e.$Tn="extensionsSync",e.$Un="dependecyOrPackExtensionInstall";function g(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Vn=g;function L(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Wn=L;function R(s,a){switch(s){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Xn=R;function b(s,a){return a==="web"&&!s.includes("web")}e.$Yn=b;function E(s,a,m){return b(a,m)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===m?!0:w(m).includes(s)}e.$Zn=E;function w(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$1n=w;function A(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$2n=A;var I;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var v;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var k;(function(s){s.Install="install",s.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var S;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$3n=(0,T.$Nh)("extensionGalleryService");var p;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var u;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class r extends Error{constructor(a,m){super(a),this.code=m,this.name=m}}e.$4n=r,e.$5n=(0,T.$Nh)("extensionManagementService"),e.$6n="extensionsIdentifiers/disabled",e.$7n="extensionsIdentifiers/enabled",e.$8n=(0,T.$Nh)("IGlobalExtensionEnablementService"),e.$9n=(0,T.$Nh)("IExtensionTipsService"),e.$0n=(0,D.localize)(0,null),e.$$n={value:e.$0n,original:"Extensions"},e.$_n={value:(0,D.localize)(1,null),original:"Preferences"}}),define(De[231],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RXb=e.$QXb=void 0,e.$QXb=(0,D.$Nh)("externalTerminal"),e.$RXb="Terminal.app"}),define(De[232],Ce([1,0,48,17,16,12,99,29,102,194,231]),function($e,e,D,T,g,L,R,b,E,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=e.$D6b=e.$C6b=void 0;const I=w.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends v{static{this.b="cmd.exe"}openTerminal(m,l){return this.spawnTerminal(D,m,E.$xl(),l)}spawnTerminal(m,l,t,n){const o=l.windowsExec||k.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const i=g.$mc(o,".exe").toLowerCase();if(i==="cmder")return m.spawn(o,n?[n]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return o.indexOf(" ")>=0&&c.push('""'),c.push(o),i==="wt"&&c.push("-d ."),new Promise((h,y)=>{const C=u(process),$=m.spawn(t,c,{cwd:n,env:C});$.on("error",y),$.on("exit",()=>h())})}runInTerminal(m,l,t,n,o){const i="windowsExec"in o&&o.windowsExec?o.windowsExec:k.getDefaultTerminalWindows();return new Promise((c,h)=>{const y=`"${l} - ${I}"`,C=`""${t.join('" "')}" & pause"`,$=Object.assign({},u(process),n);Object.keys($).filter(O=>$[O]===null).forEach(O=>delete $[O]);const f={cwd:l,env:$,windowsVerbatimArguments:!0};let d,P;g.$mc(i,".exe")==="wt"?(d=i,P=["-d",".",k.b,"/c",C]):(d=k.b,P=["/c","start",y,"/wait",i,"/c",C]),D.spawn(d,P,f).on("error",O=>{h(r(O))}),c(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const m=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${m?"Sysnative":"System32"}\\cmd.exe`}return k.d}}e.$C6b=k;class S extends v{static{this.b="/usr/bin/osascript"}openTerminal(m,l){return this.spawnTerminal(D,m,l)}runInTerminal(m,l,t,n,o){const i=o.osxExec||A.$RXb;return new Promise((c,h)=>{if(i===A.$RXb||i==="iTerm.app"){const y=i===A.$RXb?"TerminalHelper":"iTermHelper",$=[T.$bg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",m||I,"-w",l];for(const P of t)$.push("-a"),$.push(P);if(n){const P=Object.assign({},u(process),n);for(const N in P){const O=P[N];O===null?($.push("-u"),$.push(N)):($.push("-e"),$.push(`${N}=${O}`))}}let f="";const d=D.spawn(S.b,$);d.on("error",P=>{h(r(P))}),d.stderr.on("data",P=>{f+=P.toString()}),d.on("exit",P=>{if(P===0)c(void 0);else if(f){const N=f.split(`
`,1);h(new Error(N[0]))}else h(new Error(w.localize(1,null,y,P)))})}else h(new Error(w.localize(2,null,i)))})}spawnTerminal(m,l,t){const n=l.osxExec||A.$RXb;return new Promise((o,i)=>{const c=["-a",n];t&&c.push(t);const h=u(process),y=m.spawn("/usr/bin/open",c,{cwd:t,env:h});y.on("error",i),y.on("exit",()=>o())})}}e.$D6b=S;class p extends v{static{this.b=w.localize(3,null)}openTerminal(m,l){return this.spawnTerminal(D,m,l)}runInTerminal(m,l,t,n,o){const i=o.linuxExec?Promise.resolve(o.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((c,h)=>{const y=[];i.then(C=>{C.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const $=`${s(t)}; echo; read -p "${p.b}" -n1;`;y.push(`''${$}''`);const f=Object.assign({},u(process),n);Object.keys(f).filter(O=>f[O]===null).forEach(O=>delete f[O]);const d={cwd:l,env:f};let P="";const N=D.spawn(C,y,d);N.on("error",O=>{h(r(O))}),N.stderr.on("data",O=>{P+=O.toString()}),N.on("exit",O=>{if(O===0)c(void 0);else if(P){const M=P.split(`
`,1);h(new Error(M[0]))}else h(new Error(w.localize(4,null,C,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!L.$l)p.d=Promise.resolve("xterm");else{const m=await b.Promises.exists("/etc/debian_version");p.d=new Promise(l=>{m?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return p.d}spawnTerminal(m,l,t){const n=l.linuxExec?Promise.resolve(l.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((o,i)=>{n.then(c=>{const h=u(process),y=m.spawn(c,[],{cwd:t,env:h});y.on("error",i),y.on("exit",()=>o())})})}}e.$E6b=p;function u(a){const m={...a.env};return(0,R.$vl)(m),m}function r(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(w.localize(5,null,a.path)):a}function s(a){let m="";for(const l of a)l.indexOf(" ")>=0?m+='"'+l+'"':m+=l,m+=" ";return m}}),define(De[30],Ce([1,0,77,16,15,18,2,195,5,12,17]),function($e,e,D,T,g,L,R,b,E,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.FileKind=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileOperationResult=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileChangeType=e.$nk=e.FileOperation=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderErrorCode=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$0j=e.$9j=void 0,e.$9j=(0,E.$Nh)("fileService");function I(q){return q.create===!0}e.$0j=I;var v;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var k;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(k||(e.FilePermission=k={}));var S;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(S||(e.FileSystemProviderCapabilities=S={}));function p(q){return!!(q.capabilities&2)}e.$$j=p;function u(q){return!!(q.capabilities&8)}e.$_j=u;function r(q){return!!(q.capabilities&131072)}e.$ak=r;function s(q){return!!(q.capabilities&4)}e.$bk=s;function a(q){return!!(q.capabilities&16)}e.$ck=a;function m(q){return p(q)?!!(q.capabilities&16384):!1}e.$dk=m;function l(q){return p(q)?!!(q.capabilities&32768):!1}e.$ek=l;function t(q){return!!(q.capabilities&65536)}e.$fk=t;function n(q){return!!(q.capabilities&2048)}e.$gk=n;var o;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class i extends Error{static create(x,me){const ue=new i(x.toString(),me);return y(ue,me),ue}constructor(x,me){super(x),this.code=me}}e.$hk=i;function c(q,x){return i.create(q,x)}e.$ik=c;function h(q){return q||c((0,b.localize)(0,null),o.Unknown)}e.$jk=h;function y(q,x){return q.name=x?`${x} (FileSystemError)`:"FileSystemError",q}e.$kk=y;function C(q){if(!q)return o.Unknown;if(q instanceof i)return q.code;const x=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!x)return o.Unknown;switch(x[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}e.$lk=C;function $(q){if(q instanceof M)return q.fileOperationResult;switch(C(q)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}e.$mk=$;var f;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(f||(e.FileOperation=f={}));class d{constructor(x,me,ue){this.resource=x,this.operation=me,this.target=ue}isOperation(x){return this.operation===x}}e.$nk=d;var P;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class N{constructor(x,me){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ue=new Map;for(const pe of x){const G=ue.get(pe.type);switch(G?G.push([pe.resource,pe]):ue.set(pe.type,[[pe.resource,pe]]),pe.type){case 1:this.rawAdded.push(pe.resource);break;case 0:this.rawUpdated.push(pe.resource);break;case 2:this.rawDeleted.push(pe.resource);break}}for(const[pe,G]of ue)switch(pe){case 1:this.a=D.$Th.forUris(()=>me),this.a.fill(G);break;case 0:this.b=D.$Th.forUris(()=>me),this.b.fill(G);break;case 2:this.c=D.$Th.forUris(()=>me),this.c.fill(G);break}}contains(x,...me){return this.d(x,{includeChildren:!1},...me)}affects(x,...me){return this.d(x,{includeChildren:!0},...me)}d(x,me,...ue){if(!x)return!1;const pe=ue.length>0;return!!((!pe||ue.includes(1))&&(this.a?.get(x)||me.includeChildren&&this.a?.findSuperstr(x))||(!pe||ue.includes(0))&&(this.b?.get(x)||me.includeChildren&&this.b?.findSuperstr(x))||(!pe||ue.includes(2))&&(this.c?.findSubstr(x)||me.includeChildren&&this.c?.findSuperstr(x)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$ok=N;function O(q,x,me){return!q||!x||q===x||x.length>q.length?!1:(x.charAt(x.length-1)!==T.sep&&(x+=T.sep),me?(0,g.$2e)(q,x):q.indexOf(x)===0)}e.$pk=O;class M extends Error{constructor(x,me,ue){super(x),this.fileOperationResult=me,this.options=ue}}e.$qk=M;class j extends M{constructor(x,me,ue,pe){super(x,me,pe),this.fileOperationResult=me,this.size=ue}}e.$rk=j;class U extends M{constructor(x,me,ue){super(x,2,ue),this.stat=me}}e.$sk=U;var F;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(F||(e.FileOperationResult=F={})),e.$tk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$uk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$vk="files.associations",e.$wk="files.exclude",e.$xk="files.readonlyInclude",e.$yk="files.readonlyExclude",e.$zk="files.readonlyFromPermissions";var V;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.$Ak="";function H(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$Bk=H;async function fe(q,x){if(!x.hasProvider(R.URI.from({scheme:q.scheme})))return new Promise(me=>{const ue=x.onDidChangeFileSystemProviderRegistrations(pe=>{pe.scheme===q.scheme&&pe.added&&(ue.dispose(),me())})})}e.$Ck=fe;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(x){return(0,L.$Bf)(x)||(x=0),x<X.KB?(0,b.localize)(1,null,x.toFixed(0)):x<X.MB?(0,b.localize)(2,null,(x/X.KB).toFixed(2)):x<X.GB?(0,b.localize)(3,null,(x/X.MB).toFixed(2)):x<X.TB?(0,b.localize)(4,null,(x/X.GB).toFixed(2)):(0,b.localize)(5,null,(x/X.TB).toFixed(2))}}e.$Dk=X;function Y(q){const x=typeof q=="string"||q?.scheme===A.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===A.Schemas.file?1024*X.MB:x?10*X.MB:w.$p?50*X.MB:1024*X.MB}e.$Ek=Y}),define(De[233],Ce([1,0,22,8,196,30]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;async function R(A,I,v,k,S,p){let u;try{await b(A,I,v,k,S,p)}catch(r){u=r}finally{u&&S.errorTransformer&&(u=S.errorTransformer(u)),typeof u<"u"&&v.error(u),v.end()}}e.$Fp=R;async function b(A,I,v,k,S,p){E(p);const u=await A.open(I,{create:!1});try{E(p);let r=0,s=0,a=S&&typeof S.length=="number"?S.length:void 0,m=D.$ae.alloc(Math.min(S.bufferSize,typeof a=="number"?a:S.bufferSize)),l=S&&typeof S.position=="number"?S.position:0,t=0;do s=await A.read(u,l,m.buffer,t,m.byteLength-t),l+=s,t+=s,r+=s,typeof a=="number"&&(a-=s),t===m.byteLength&&(await v.write(k(m)),m=D.$ae.alloc(Math.min(S.bufferSize,typeof a=="number"?a:S.bufferSize)),t=0);while(s>0&&(typeof a!="number"||a>0)&&E(p)&&w(r,S));if(t>0){let n=t;typeof a=="number"&&(n=Math.min(t,a)),v.write(k(m.slice(0,n)))}}catch(r){throw(0,L.$jk)(r)}finally{await A.close(u)}}function E(A){if(A.isCancellationRequested)throw(0,T.$5)();return!0}function w(A,I){if(typeof I?.limits?.size=="number"&&A>I.limits.size)throw(0,L.$ik)((0,g.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[83],Ce([1,0,35,3,16,12,2,30]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.$Mp=e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=void 0;function E(r){return r.recursive===!0}e.$Hp=E;class w extends T.$Rc{static{this.a=5}constructor(s,a,m,l){super(),this.h=s,this.j=a,this.m=m,this.n=l,this.c=this.B(new T.$Sc),this.f=void 0,this.g=0}s(){const s=new T.$Qc;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(a=>this.h(a))),s.add(this.b.onDidLogMessage(a=>this.j(a))),s.add(this.b.onDidError(a=>this.t(a)))}t(s){this.n.restartOnError?this.g<w.a&&this.f?(this.w(`restarting watcher after error: ${s}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${s}`):this.w(s)}u(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}w(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}y(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Ip=w;class A extends w{constructor(s,a,m){super(s,a,m,{type:"node.js",restartOnError:!1})}}e.$Jp=A;class I extends w{constructor(s,a,m){super(s,a,m,{type:"universal",restartOnError:!0})}}e.$Kp=I;function v(r){return r.map(s=>({type:s.type,resource:R.URI.revive(s.resource)}))}e.$Lp=v;function k(r){const s=new u;for(const a of r)s.processEvent(a);return s.coalesce()}e.$Mp=k;function S(r,s){return typeof s=="string"&&!s.startsWith(D.$qj)&&!(0,g.$hc)(s)?{base:r,pattern:s}:s}e.$Np=S;function p(r,s){const a=[];for(const m of s)a.push((0,D.$uj)(S(r,m)));return a}e.$Op=p;class u{constructor(){this.a=new Set,this.b=new Map}c(s){return L.$l?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const a=this.b.get(this.c(s));let m=!1;if(a){const l=a.type,t=s.type;a.resource.fsPath!==s.resource.fsPath&&(s.type===2||s.type===1)?m=!0:l===1&&t===2?(this.b.delete(this.c(s)),this.a.delete(a)):l===2&&t===1?a.type=0:l===1&&t===0||(a.type=t)}else m=!0;m&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],a=[];return Array.from(this.a).filter(m=>m.type!==2?(s.push(m),!1):!0).sort((m,l)=>m.resource.fsPath.length-l.resource.fsPath.length).filter(m=>a.some(l=>(0,b.$pk)(m.resource.fsPath,l,!L.$l))?!1:(a.push(m.resource.fsPath),!0)).concat(s)}}}),define(De[234],Ce([1,0,53,11,21,32,3,76,16,12,2,101,29,83]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0;class S extends R.$Rc{static{this.a=100}static{this.b=75}constructor(r,s,a,m){super(),this.m=r,this.n=s,this.r=a,this.s=m,this.c=this.B(new T.$8g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.n(l))),this.f=this.B(new T.$7g(l=>this.z(l),S.b)),this.g=(0,k.$Op)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$Op)(this.m.path,this.m.includes):void 0,this.j=new g.$Wd,this.ready=this.t()}async t(){try{const r=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const s=await v.Promises.stat(r);this.B(await this.w(r,s.isDirectory()))}catch(r){r.code!=="ENOENT"?this.D(r):this.G(r)}}async u(r){let s=r.path;try{s=await v.Promises.realpath(r.path),r.path===s&&(s=await(0,I.$Yp)(r.path)??r.path),r.path!==s&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${s})`)}catch{}return s}async w(r,s){if(w.$k&&(0,L.$Wf)(r,"/Volumes/",!0))return this.D(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Rc.None;const a=new g.$Wd(this.j.token),m=new R.$Qc;try{const l=(0,E.$mc)(r),t=(0,D.watch)(r);m.add((0,R.$Pc)(()=>{t.removeAllListeners(),t.close()})),this.G(`Started watching: '${r}'`);const n=new Set;if(s)try{for(const i of await v.Promises.readdir(r))n.add(i)}catch(i){this.D(i)}const o=new Map;m.add((0,R.$Pc)(()=>{for(const[,i]of o)i.dispose();o.clear()})),t.on("error",(i,c)=>{this.D(`Failed to watch ${r} for changes using fs.watch() (${i}, ${c})`),this.dispose()}),t.on("change",(i,c)=>{if(a.token.isCancellationRequested)return;this.G(`[raw] ["${i}"] ${c}`);let h="";if(c&&(h=c.toString(),w.$k&&(h=(0,b.$kl)(h))),!(!h||i!=="change"&&i!=="rename"))if(s)if(i==="rename"){o.get(h)?.dispose();const y=setTimeout(async()=>{if(o.delete(h),h===l&&!await v.Promises.exists(r)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const C=await this.C((0,E.$ic)(r,h));if(a.token.isCancellationRequested)return;let $;C?n.has(h)?$=0:($=1,n.add(h)):(n.delete(h),$=2),this.y({resource:A.URI.file((0,E.$ic)(this.m.path,h)),type:$})},S.a);o.set(h,(0,R.$Pc)(()=>clearTimeout(y)))}else{let y;n.has(h)?y=0:(y=1,n.add(h)),this.y({resource:A.URI.file((0,E.$ic)(this.m.path,h)),type:y})}else if(i==="rename"||h!==l){const y=setTimeout(async()=>{const C=await v.Promises.exists(r);a.token.isCancellationRequested||(C?(this.y({resource:A.URI.file(this.m.path),type:0},!0),m.add(await this.w(r,!1))):(this.y({resource:A.URI.file(this.m.path),type:2},!0),this.f.flush(),this.dispose()))},S.a);m.clear(),m.add((0,R.$Pc)(()=>clearTimeout(y)))}else this.y({resource:A.URI.file(this.m.path),type:0},!0)})}catch(l){await v.Promises.exists(r)&&!a.token.isCancellationRequested&&this.D(`Failed to watch ${r} for changes using fs.watch() (${l.toString()})`)}return(0,R.$Pc)(()=>{a.dispose(!0),m.dispose()})}y(r,s=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.resource.fsPath}`),!s&&this.g.some(a=>a(r.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${r.resource.fsPath}`):!s&&this.h&&this.h.length>0&&!this.h.some(a=>a(r.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${r.resource.fsPath}`):this.f.work(r))}z(r){const s=(0,k.$Mp)(r);if(s.length>0){if(this.s)for(const m of s)this.G(`>> normalized ${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(r){if(w.$l)return v.Promises.exists(r);try{const s=(0,E.$mc)(r);return(await v.Promises.readdir((0,E.$lc)(r))).some(m=>m===s)}catch(s){return this.G(s),!1}}setVerboseLogging(r){this.s=r}D(r){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}F(r){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}G(r){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$2p=S;async function p(u,r,s,a,m=512){const l=await v.Promises.open(u,"r"),t=Buffer.allocUnsafe(m),n=new g.$Wd(a);let o,i=!1;const c={path:u,excludes:[],recursive:!1},h=new S(c,y=>{(async()=>{for(const{type:C}of y)if(C===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:$}=await v.Promises.read(l,t,0,m,null);if(!$||n.token.isCancellationRequested)break;r(t.slice(0,$))}}catch($){o=new Error($),n.dispose(!0)}finally{i=!1}}})()});return await h.ready,s(),new Promise((y,C)=>{n.token.onCancellationRequested(async()=>{h.dispose();try{await v.Promises.close(l)}catch($){o=new Error($)}o?C(o):y()})})}e.$3p=p}),define(De[235],Ce([1,0,4,35,3,12,234]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;class b extends g.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Md),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Md),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(w){const A=this.j(w),I=A.filter(k=>{const S=this.c.get(k.path);return S?!(0,T.$yj)(S.request.excludes,k.excludes)||!(0,T.$yj)(S.request.includes,k.includes):!0}),v=Array.from(this.c.values()).filter(({request:k})=>!A.find(S=>S.path===k.path&&(0,T.$yj)(S.excludes,k.excludes)&&(0,T.$yj)(S.includes,k.includes))).map(({request:k})=>k.path);I.length&&this.m(`Request to start watching: ${I.map(k=>`${k.path} (excludes: ${k.excludes.length>0?k.excludes:"<none>"}, includes: ${k.includes&&k.includes.length>0?JSON.stringify(k.includes):"<all>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const k of v)this.h(k);for(const k of I)this.g(k)}g(w){const A=new R.$2p(w,v=>this.a.fire(v),v=>this.b.fire(v),this.f),I={request:w,instance:A};this.c.set(w.path,I)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const A=this.c.get(w);A&&(this.c.delete(w),A.instance.dispose())}j(w){const A=new Map;for(const I of w){const v=L.$l?I.path:I.path.toLowerCase();A.set(v,I)}return Array.from(A.values())}async setVerboseLogging(w){this.f=w;for(const[,A]of this.c)A.instance.setVerboseLogging(w)}m(w){this.f&&this.b.fire({type:"trace",message:this.n(w)})}n(w,A){return A?`[File Watcher (node.js)] ${w} (path: ${A.request.path})`:`[File Watcher (node.js)] ${w}`}}e.$4p=b}),define(De[236],Ce([1,0,83,235]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;class g extends D.$Jp{constructor(R,b,E){super(R,b,E),this.s()}r(R){return R.add(new T.$4p)}}e.$5p=g}),define(De[237],Ce([1,0,17,80,183,83]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;class R extends L.$Kp{constructor(E,w,A){super(E,w,A),this.s()}r(E){const w=E.add(new g.$Vp(D.$bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(w.onDidProcessExit(({code:A,signal:I})=>this.t(`terminated by itself with code ${A}, signal: ${I}`))),T.ProxyChannel.toService((0,T.$uh)(w.getChannel("watcher")))}}e.$Wp=R}),define(De[105],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class D{constructor(...g){this.a=new Map;for(const[L,R]of g)this.set(L,R)}set(g,L){const R=this.a.get(g);return this.a.set(g,L),R}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$Lh=D}),define(De[238],Ce([1,0,11,8,3,103,229,5,105,75]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0;const A=!1;class I extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class v{constructor(u=new E.$Lh,r=!1,s,a=A){this.f=u,this.g=r,this.h=s,this.i=a,this.o=new Set,this.f.set(b.$Mh,this),this._globalGraph=a?s?._globalGraph??new R.$8p(m=>m):void 0}createChild(u){return new v(u,this.g,this,this.i)}invokeFunction(u,...r){const s=S.traceInvocation(this.i,u);let a=!1;try{return u({get:l=>{if(a)throw(0,T.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(l,s);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...r)}finally{a=!0,s.stop()}}createInstance(u,...r){let s,a;return u instanceof L.$Kh?(s=S.traceCreation(this.i,u.ctor),a=this.j(u.ctor,u.staticArguments.concat(r),s)):(s=S.traceCreation(this.i,u),a=this.j(u,r,s)),s.stop(),a}j(u,r=[],s){const a=b._util.getServiceDependencies(u).sort((t,n)=>t.index-n.index),m=[];for(const t of a){const n=this.m(t.id,s);n||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),m.push(n)}const l=a.length>0?a[0].index:r.length;if(r.length!==l){console.trace(`[createInstance] First service dependency of ${u.name} at position ${l+1} conflicts with ${r.length} static arguments`);const t=l-r.length;t>0?r=r.concat(new Array(t)):r=r.slice(0,l)}return Reflect.construct(u,r.concat(m))}k(u,r){if(this.f.get(u)instanceof L.$Kh)this.f.set(u,r);else if(this.h)this.h.k(u,r);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const r=this.f.get(u);return!r&&this.h?this.h.l(u):r}m(u,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const s=this.l(u);return s instanceof L.$Kh?this.q(u,s,r.branch(u,!0)):(r.branch(u,!1),s)}q(u,r,s){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,r,s)}finally{this.o.delete(u)}}r(u,r,s){const a=new R.$8p(t=>t.id.toString());let m=0;const l=[{id:u,desc:r,_trace:s}];for(;l.length;){const t=l.pop();if(a.lookupOrInsertNode(t),m++>1e3)throw new I(a);for(const n of b._util.getServiceDependencies(t.desc.ctor)){const o=this.l(n.id);if(o||this.u(`[createInstance] ${u} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),o instanceof L.$Kh){const i={id:n.id,desc:o,_trace:t._trace.branch(n.id,!0)};a.insertEdge(t,i),l.push(i)}}}for(;;){const t=a.roots();if(t.length===0){if(!a.isEmpty())throw new I(a);break}for(const{data:n}of t){if(this.l(n.id)instanceof L.$Kh){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}a.removeNode(n)}}return this.l(u)}s(u,r,s=[],a,m){if(this.f.get(u)instanceof L.$Kh)return this.t(u,r,s,a,m);if(this.h)return this.h.s(u,r,s,a,m);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}t(u,r,s=[],a,m){if(a){const l=new v(void 0,this.g,this,this.i);l.c=String(u);const t=new Map,n=new D.$0g(()=>{const o=l.j(r,s,m);for(const[i,c]of t){const h=o[i];if(typeof h=="function")for(const y of c)h.apply(o,y)}return t.clear(),o});return new Proxy(Object.create(null),{get(o,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let y=t.get(i);return y||(y=new w.$1c,t.set(i,y)),($,f,d)=>{const P=y.push([$,f,d]);return(0,g.$Pc)(P)}}if(i in o)return o[i];const c=n.value;let h=c[i];return typeof h!="function"||(h=h.bind(c),o[i]=h),h},set(o,i,c){return n.value[i]=c,!0},getPrototypeOf(o){return r.prototype}})}else return this.j(r,s,m)}u(u,r){if(r&&console.warn(u),this.g)throw new Error(u)}}e.$9p=v;var k;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(k||(k={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(u,r){return u?new S(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(u,r){return u?new S(1,r.name):S.c}static{this.f=0}constructor(u,r){this.type=u,this.name=r,this.g=Date.now(),this.h=[]}branch(u,r){const s=new S(3,u.toString());return this.h.push([u,r,s]),s}stop(){const u=Date.now()-this.g;S.f+=u;let r=!1;function s(m,l){const t=[],n=new Array(m+1).join("	");for(const[o,i,c]of l.h)if(i&&c){r=!0,t.push(`${n}CREATES -> ${o}`);const h=s(m+1,c);h&&t.push(h)}else t.push(`${n}uses -> ${o}`);return t.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${s(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(u>2||r)&&S.all.add(a.join(`
`))}}e.$0p=S}),define(De[13],Ce([1,0,46,4,52,3,28,12,24,18,2,41,5]),function($e,e,D,T,g,L,R,b,E,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,v.$Nh)("logService"),e.$9i=(0,v.$Nh)("loggerService");function k(){return new Date().toISOString()}function S($){return(0,w.$Bf)($)}e.$0i=S;var p;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$$i=p.Info;function u($,f,d){switch(f){case p.Trace:$.trace(d);break;case p.Debug:$.debug(d);break;case p.Info:$.info(d);break;case p.Warning:$.warn(d);break;case p.Error:$.error(d);break;case p.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=u;function r($,f=!1){let d="";for(let P=0;P<$.length;P++){let N=$[P];if(N instanceof Error&&(N=(0,D.$yi)(N,f)),typeof N=="object")try{N=JSON.stringify(N)}catch{}d+=(P>0?" ":"")+N}return d}class s extends L.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new T.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==p.Off&&this.b<=f}}e.$aj=s;class a extends s{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...d){this.f(p.Trace)&&this.g(p.Trace,r([f,...d],!0))}debug(f,...d){this.f(p.Debug)&&this.g(p.Debug,r([f,...d]))}info(f,...d){this.f(p.Info)&&this.g(p.Info,r([f,...d]))}warn(f,...d){this.f(p.Warning)&&this.g(p.Warning,r([f,...d]))}error(f,...d){if(this.f(p.Error))if(f instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=f.stack,this.g(p.Error,r(P))}else this.g(p.Error,r([f,...d]))}flush(){}}e.$bj=a;class m extends s{constructor(f=e.$$i){super(),this.setLevel(f),this.g=!b.$j}trace(f,...d){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,f,...d):console.log(`[main ${k()}]`,f,...d))}debug(f,...d){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,f,...d):console.log(`[main ${k()}]`,f,...d))}info(f,...d){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,f,...d):console.log(`[main ${k()}]`,f,...d))}warn(f,...d){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,f,...d):console.warn(`[main ${k()}]`,f,...d))}error(f,...d){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,f,...d):console.error(`[main ${k()}]`,f,...d))}dispose(){}flush(){}}e.$cj=m;class l extends s{constructor(f=e.$$i,d=!0){super(),this.g=d,this.setLevel(f)}trace(f,...d){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...d):console.log(f,...d))}debug(f,...d){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...d):console.log(f,...d))}info(f,...d){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...d):console.log(f,...d))}warn(f,...d){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...d):console.log(f,...d))}error(f,...d){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...d):console.error(f,...d))}dispose(){}flush(){}}e.$dj=l;class t extends s{constructor(f,d=e.$$i){super(),this.g=f,this.setLevel(d)}trace(f,...d){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(f),...d])}debug(f,...d){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(f),...d])}info(f,...d){this.f(p.Info)&&this.g.log(p.Info,[this.h(f),...d])}warn(f,...d){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(f),...d])}error(f,...d){this.f(p.Error)&&this.g.log(p.Error,[this.h(f),...d])}h(f){return typeof f=="string"?f:(0,D.$yi)(f,this.f(p.Trace))}dispose(){}flush(){}}e.$ej=t;class n extends s{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const d of this.g)d.setLevel(f);super.setLevel(f)}trace(f,...d){for(const P of this.g)P.trace(f,...d)}debug(f,...d){for(const P of this.g)P.debug(f,...d)}info(f,...d){for(const P of this.g)P.info(f,...d)}warn(f,...d){for(const P of this.g)P.warn(f,...d)}error(f,...d){for(const P of this.g)P.error(f,...d)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$fj=n;class o extends L.$Rc{constructor(f,d,P){if(super(),this.h=f,this.j=d,this.b=new R.$zc,this.c=this.B(new T.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Md),this.onDidChangeVisibility=this.g.event,P)for(const N of P)this.b.set(N.resource,{logger:void 0,info:N})}m(f){return(0,w.$xf)(f)?[...this.b.values()].find(d=>d.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,d){const P=this.n(f),N=(0,w.$xf)(f)?f:d?.id??(0,g.$Bi)(P.toString()).toString(16);let O=this.b.get(P)?.logger;const M=d?.logLevel==="always"?p.Trace:d?.logLevel;O||(O=this.s(P,M??this.getLogLevel(P)??this.h,{...d,id:N}));const j={logger:O,info:{resource:P,id:N,logLevel:M,name:d?.name,hidden:d?.hidden,extensionId:d?.extensionId,when:d?.when}};return this.registerLogger(j.info),this.b.set(P,j),O}n(f){return(0,w.$xf)(f)?(0,E.$ug)(this.j,`${f}.log`):f}setLogLevel(f,d){if(A.URI.isUri(f)){const P=f,N=d,O=this.b.get(P);O&&N!==O.info.logLevel&&(O.info.logLevel=N===this.h?void 0:N,O.logger?.setLevel(N),this.b.set(O.info.resource,O),this.f.fire([P,N]))}else{this.h=f;for(const[P,N]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,d){const P=this.m(f);P&&d!==!P.info.hidden&&(P.info.hidden=!d,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,d]))}getLogLevel(f){let d;return f&&(d=this.b.get(f)?.info.logLevel),d??this.h}registerLogger(f){const d=this.b.get(f.resource);d?d.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const d=this.b.get(f);d&&(d.logger&&d.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[d.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=o;class i{constructor(){this.onDidChangeLogLevel=new T.$Md().event}setLevel(f){}getLevel(){return p.Info}trace(f,...d){}debug(f,...d){}info(f,...d){}warn(f,...d){}error(f,...d){}critical(f,...d){}dispose(){}flush(){}}e.$hj=i;class c extends i{}e.$ij=c;function h($){if($.verbose)return p.Trace;if(typeof $.logLevel=="string"){const f=C($.logLevel.toLowerCase());if(f!==void 0)return f}return e.$$i}e.$jj=h;function y($){switch($){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$kj=y;function C($){switch($){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$lj=C,e.$mj=new I.$5i("logLevel",y(p.Info))}),define(De[239],Ce([1,0,19,11,8,4,3,16,83,13]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;class A extends R.$Rc{constructor(v,k){super(),this.a=v,this.b=k,this.c=this.B(new L.$Md),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Md),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new T.$Qg(0)),this.w=[],this.y=this.B(new T.$Qg(0))}watch(v,k){return k.recursive||this.b?.watcher?.forceUniversal?this.n(v,k):this.z(v,k)}n(v,k){const S={path:this.H(v),excludes:k.excludes,includes:k.includes,recursive:k.recursive},p=(0,D.$Tb)(this.j,S);return this.r(),(0,R.$Pc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,g.$Z)(v))}s(){this.h||(this.h=this.B(this.t(k=>this.c.fire((0,E.$Lp)(k)),k=>this.G(k),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const k of this.j)(0,E.$Hp)(k)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const k of this.j)(0,E.$Hp)(k)&&v.includes(k.path)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,k){const S={path:this.H(v),excludes:k.excludes,includes:k.includes,recursive:!1},p=(0,D.$Tb)(this.w,S);return this.C(),(0,R.$Pc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,g.$Z)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,E.$Lp)(v)),v=>this.G(v),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,b.$gc)(v.fsPath)}}e.$Pp=A}),define(De[240],Ce([1,0,53,372,11,28,22,4,32,3,16,12,24,97,29,197,30,233,239,46,237,236]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=void 0,(()=>{try{(0,T.gracefulify)(D)}catch(n){console.error(`Error enabling graceful-fs: ${(0,a.$yi)(n)}`)}})();class t extends s.$Pp{static{this.I=!1}constructor(o,i){super(o,i),this.onDidChangeCapabilities=b.Event.None,this.N=new L.$zc(c=>v.$lg.getComparisonKey(c)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,I.$l&&(this.J|=1024)),this.J}async stat(o){try{const{stat:i,symbolicLink:c}=await S.SymlinkSupport.stat(this.H(o));return{type:this.M(i,c),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:u.FilePermission.Locked}}catch(i){throw this.eb(i)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const i=await S.Promises.readdir(this.H(o),{withFileTypes:!0}),c=[];return await Promise.all(i.map(async h=>{try{let y;h.isSymbolicLink()?y=(await this.stat((0,v.$ug)(o,h.name))).type:y=this.M(h),c.push([h.name,y])}catch(y){this.a.trace(y)}})),c}catch(i){throw this.eb(i)}}M(o,i){let c;return i?.dangling?c=u.FileType.Unknown:o.isFile()?c=u.FileType.File:o.isDirectory()?c=u.FileType.Directory:c=u.FileType.Unknown,i&&(c|=u.FileType.SymbolicLink),c}async O(o){const i=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let c;for(;c=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await c.wait();const h=new g.$Rg;return this.N.set(o,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,w.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(o)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),h.open()})}async readFile(o,i){let c;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),c=await this.O(o));const h=this.H(o);return await S.Promises.readFile(h)}catch(h){throw this.eb(h)}finally{c?.dispose()}}P(o){t.I&&this.a.trace(o)}readFileStream(o,i,c){const h=(0,k.$1d)(y=>R.$ae.concat(y.map(C=>R.$ae.wrap(C))).buffer);return(0,r.$Fp)(this,o,h,y=>y.buffer,{...i,bufferSize:256*1024},c),h}async writeFile(o,i,c){return c?.atomic!==!1&&c?.atomic?.postfix?this.Q(o,(0,v.$ug)((0,v.$tg)(o),`${(0,v.$rg)(o)}${c.atomic.postfix}`),i,c):this.R(o,i,c)}async Q(o,i,c,h){const y=new w.$Qc;try{y.add(await this.O(o)),y.add(await this.O(i)),await this.R(i,c,h,!0);try{await this.rename(i,o,{overwrite:!0})}catch(C){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{y.dispose()}}async R(o,i,c,h){let y;try{const C=this.H(o);if(!c.create||!c.overwrite){if(await S.Promises.exists(C)){if(!c.overwrite)throw(0,u.$ik)((0,p.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,u.$ik)((0,p.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}y=await this.open(o,{create:!0,unlock:c.unlock},h),await this.write(y,0,i,0,i.byteLength)}catch(C){throw await this.fb(o,C)}finally{typeof y=="number"&&await this.close(y)}}static{this.X=!0}static configureFlushOnWrite(o){t.X=o}async open(o,i,c){const h=this.H(o);let y;(0,u.$0j)(i)&&!c&&(y=await this.O(o));let C;try{if((0,u.$0j)(i)&&i.unlock)try{const{stat:f}=await S.SymlinkSupport.stat(h);f.mode&128||await S.Promises.chmod(h,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let $;if((0,u.$0j)(i)){if(I.$j)try{await S.Promises.truncate(h,0),$="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}$||($="w")}else $="r";C=await S.Promises.open(h,$)}catch($){throw y?.dispose(),(0,u.$0j)(i)?await this.fb(o,$):this.eb($)}if(this.S.set(C,0),(0,u.$0j)(i)&&this.W.set(C,o),y){const $=this.U.get(C);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${h})`),this.U.set(C,y),$&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${h})`),$.dispose())}return C}async close(o){const i=this.U.get(o);try{if(this.S.delete(o),this.W.delete(o)&&t.X)try{await S.Promises.fdatasync(o)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await S.Promises.close(o)}catch(c){throw this.eb(c)}finally{i&&(this.U.get(o)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.U.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),i.dispose())}}async read(o,i,c,h,y){const C=this.Y(o,i);let $=null;try{$=(await S.Promises.read(o,c,h,y,C)).bytesRead}catch(f){throw this.eb(f)}finally{this.Z(o,C,$)}return $}Y(o,i){return i===this.S.get(o)?null:i}Z(o,i,c){const h=this.S.get(o);typeof h=="number"&&(typeof i=="number"||(typeof c=="number"?this.S.set(o,h+c):this.S.delete(o)))}async write(o,i,c,h,y){return(0,g.$$g)(()=>this.$(o,i,c,h,y),100,3)}async $(o,i,c,h,y){const C=this.Y(o,i);let $=null;try{$=(await S.Promises.write(o,c,h,y,C)).bytesWritten}catch(f){throw await this.fb(this.W.get(o),f)}finally{this.Z(o,C,$)}return $}async mkdir(o){try{await S.Promises.mkdir(this.H(o))}catch(i){throw this.eb(i)}}async delete(o,i){try{const c=this.H(o);if(i.recursive){let h;i?.atomic!==!1&&i.atomic.postfix&&(h=(0,A.$ic)((0,A.$lc)(c),`${(0,A.$mc)(c)}${i.atomic.postfix}`)),await S.Promises.rm(c,S.RimRafMode.MOVE,h)}else try{await S.Promises.unlink(c)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let y=!1;try{const{stat:C,symbolicLink:$}=await S.SymlinkSupport.stat(c);y=C.isDirectory()&&!$}catch{}if(y)await S.Promises.rmdir(c);else throw h}else throw h}}catch(c){throw this.eb(c)}}async rename(o,i,c){const h=this.H(o),y=this.H(i);if(h!==y)try{await this.ab(o,i,"move",c.overwrite),await S.Promises.rename(h,y)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,p.localize)(2,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(y)),C.toString()))),this.eb(C)}}async copy(o,i,c){const h=this.H(o),y=this.H(i);if(h!==y)try{await this.ab(o,i,"copy",c.overwrite),await S.Promises.copy(h,y,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,p.localize)(3,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(y)),C.toString()))),this.eb(C)}}async ab(o,i,c,h){const y=this.H(o),C=this.H(i);let $=!1;if(!!(this.capabilities&1024)||($=(0,E.$Vf)(y,C,!0)),$){if(c==="copy")throw(0,u.$ik)((0,p.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const d=await this.L(o);if(!d)throw(0,u.$ik)((0,p.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(i);if(P){if(!h)throw(0,u.$ik)((0,p.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);d.type&u.FileType.File&&P.type&u.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,i){return this.bb(o,i,!1)}async bb(o,i,c){const h=this.H(o),y=this.H(i),C=!!(this.capabilities&1024);if((0,E.$Vf)(h,y,!C))return;const $=new w.$Qc;try{$.add(await this.O(o)),$.add(await this.O(i)),c&&await S.Promises.mkdir((0,A.$lc)(y),{recursive:!0}),await S.Promises.copyFile(h,y)}catch(f){if(f.code==="ENOENT"&&!c)return this.bb(o,i,!0);throw this.eb(f)}finally{$.dispose()}}t(o,i,c){return new m.$Wp(h=>o(h),h=>i(h),c)}F(o,i,c){return new l.$5p(h=>o(h),h=>i(h),c)}eb(o){if(o instanceof u.$hk)return o;let i=o,c;switch(o.code){case"ENOENT":c=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=u.FileSystemProviderErrorCode.Unknown;break;default:c=u.FileSystemProviderErrorCode.Unknown}return(0,u.$ik)(i,c)}async fb(o,i){let c=this.eb(i);if(o&&c.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await S.SymlinkSupport.stat(this.H(o));h.mode&128||(c=(0,u.$ik)(i,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return c}}e.$6p=t}),define(De[241],Ce([1,0,3,13]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=void 0;class g extends D.$Rc{constructor(R,b=[]){super(),this.a=new T.$fj([R,...b]),this.B(R.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...b){this.a.trace(R,...b)}debug(R,...b){this.a.debug(R,...b)}info(R,...b){this.a.info(R,...b)}warn(R,...b){this.a.warn(R,...b)}error(R,...b){this.a.error(R,...b)}flush(){this.a.flush()}}e.$uN=g}),define(De[242],Ce([1,0,30,13]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=void 0;var g;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(g||(g={}));async function L(w,A,I,v,k){try{const S=await new Promise((u,r)=>{$e(["@vscode/spdlog"],u,r)});S.setFlushOn(g.Trace);const p=await S.createAsyncRotatingLogger(w,A,I,v);return k?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(S){console.error(S)}return null}function R(w,A,I){switch(A){case T.LogLevel.Trace:w.trace(I);break;case T.LogLevel.Debug:w.debug(I);break;case T.LogLevel.Info:w.info(I);break;case T.LogLevel.Warning:w.warn(I);break;case T.LogLevel.Error:w.error(I);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(w,A){switch(A){case T.LogLevel.Trace:w.setLevel(g.Trace);break;case T.LogLevel.Debug:w.setLevel(g.Debug);break;case T.LogLevel.Info:w.setLevel(g.Info);break;case T.LogLevel.Warning:w.setLevel(g.Warning);break;case T.LogLevel.Error:w.setLevel(g.Error);break;case T.LogLevel.Off:w.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class E extends T.$bj{constructor(A,I,v,k,S){super(),this.m=[],this.setLevel(S),this.n=this.s(A,I,v,k),this.B(this.onDidChangeLogLevel(p=>{this.r&&b(this.r,p)}))}async s(A,I,v,k){const S=v?6:1,p=30/S*D.$Dk.MB,u=await L(A,I,p,S,k);if(u){this.r=u,b(this.r,this.getLevel());for(const{level:r,message:s}of this.m)R(this.r,r,s);this.m=[]}}g(A,I){this.r?R(this.r,A,I):this.getLevel()<=A&&this.m.push({level:A,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$jN=E}),define(De[133],Ce([1,0,38,198,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(E){function w(S,p){return p-S}E.compare=w;const A=Object.create(null);A[E.Error]=(0,T.localize)(0,null),A[E.Warning]=(0,T.localize)(1,null),A[E.Info]=(0,T.localize)(2,null);function I(S){return A[S]||""}E.toString=I;function v(S){switch(S){case D.default.Error:return E.Error;case D.default.Warning:return E.Warning;case D.default.Info:return E.Info;case D.default.Ignore:return E.Hint}}E.fromSeverity=v;function k(S){switch(S){case E.Error:return D.default.Error;case E.Warning:return D.default.Warning;case E.Info:return D.default.Info;case E.Hint:return D.default.Ignore}}E.toSeverity=k}(R||(e.MarkerSeverity=R={}));var b;(function(E){const w="";function A(v){return I(v,!0)}E.makeKey=A;function I(v,k){const S=[w];return v.source?S.push(v.source.replace("\xA6","\\\xA6")):S.push(w),v.code?typeof v.code=="string"?S.push(v.code.replace("\xA6","\\\xA6")):S.push(v.code.value.replace("\xA6","\\\xA6")):S.push(w),v.severity!==void 0&&v.severity!==null?S.push(R.toString(v.severity)):S.push(w),v.message&&k?S.push(v.message.replace("\xA6","\\\xA6")):S.push(w),v.startLineNumber!==void 0&&v.startLineNumber!==null?S.push(v.startLineNumber.toString()):S.push(w),v.startColumn!==void 0&&v.startColumn!==null?S.push(v.startColumn.toString()):S.push(w),v.endLineNumber!==void 0&&v.endLineNumber!==null?S.push(v.endLineNumber.toString()):S.push(w),v.endColumn!==void 0&&v.endColumn!==null?S.push(v.endColumn.toString()):S.push(w),S.push(w),S.join("\xA6")}E.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.$6s=(0,g.$Nh)("markerService")}),define(De[243],Ce([1,0,4,38,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vu=e.$Uu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Tu=e.Severity=void 0,e.Severity=T.default,e.$Tu=(0,g.$Nh)("notificationService");var L;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var b;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(b||(e.NotificationsFilter=b={}));class E{constructor(){this.progress=new w,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$Uu=E;class w{infinite(){}done(){}total(I){}worked(I){}}e.$Vu=w}),define(De[134],Ce([1,0,15,2,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7T=e.$6T=e.$5T=e.$4T=e.$3T=void 0,e.$3T=(0,g.$Nh)("openerService");function L(w,A){return T.URI.isUri(w)?(0,D.$1e)(w.scheme,A):(0,D.$2e)(w,A+":")}e.$4T=L;function R(w,...A){return A.some(I=>L(w,I))}e.$5T=R;function b(w,A){return w.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$6T=b;function E(w){let A;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(w.fragment);return I&&(A={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},w=w.with({fragment:""})),{selection:A,uri:w}}e.$7T=E}),define(De[244],Ce([1,0,12,47]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let g;if(typeof D.$h.vscode<"u"&&typeof D.$h.vscode.context<"u"){const L=D.$h.vscode.context.configuration();if(L)g=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(g=globalThis._VSCODE_PRODUCT_JSON,T.env.VSCODE_DEV&&Object.assign(g,{nameShort:`${g.nameShort} Dev`,nameLong:`${g.nameLong} Dev`,dataFolderName:`${g.dataFolderName}-dev`,serverDataFolderName:g.serverDataFolderName?`${g.serverDataFolderName}-dev`:void 0}),!g.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(g,{version:L.version})}}else g={},Object.keys(g).length===0&&Object.assign(g,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=g}),define(De[135],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,D.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function($e,e){return function(D,T){e(D,T,$e)}};define(De[84],Ce([1,0,11,21,3,5]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=e.$1u=e.$Zu=e.$Yu=e.$Xu=e.ProgressLocation=e.$Wu=void 0,e.$Wu=(0,L.$Nh)("progressService");var R;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Xu=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,v){this.e=I,this.report=v?.async?this.g.bind(this):this.f.bind(this)}f(I){this.a=I,this.e(this.a)}g(I){this.b?this.b.push(I):this.b=[I],this.h()}async h(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const I=this.b.shift();this.a=I,await this.e(this.a)}}finally{this.c=!1;const I=this.d;this.d=void 0,I?.()}}drain(){return this.c?new Promise(I=>{const v=this.d;this.d=()=>{v?.(),I()}}):Promise.resolve()}}e.$Yu=b;let E=class extends g.$Rc{constructor(I,v){super(),this.a=new D.$bh,v.withProgress(I,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,g.$Pc)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$Zu=E,e.$Zu=E=He([Be(1,e.$Wu)],E);class w extends g.$Rc{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new g.$Qc)}start(I){this.stop();const v=++this.a,k=new T.$Wd;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,g.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,g.$Pc)(()=>k.cancel())),this.b.add((0,g.$Pc)(()=>this.c?this.c.done():void 0)),{id:v,token:k.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$1u=w,e.$2u=(0,L.$Nh)("editorProgressService")}),define(De[42],Ce([1,0,58,18]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0;class g{constructor(){this.a=new Map}add(R,b){D.ok(T.$xf(R)),D.ok(T.$zf(b)),D.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,b)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$$m=new g}),define(De[106],Ce([1,0,4,42]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=void 0,e.$_m={JSONContribution:"base.contributions.json"};function g(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class L{constructor(){this.b=new D.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,w){this.a[g(E)]=w,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;T.$$m.add(e.$_m.JSONContribution,R)}),define(De[136],Ce([1,0,19,4,18,188,49,106,42]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.ConfigurationScope=e.$dn=e.EditPresentationTypes=void 0;var w;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$dn={Configuration:"base.contributions.configuration"};var A;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn="vscode://schemas/settings/resourceLanguage",e.$ln="vscode://schemas/settings/configurationDefaults";const I=E.$$m.as(b.$_m.JSONContribution);class v{constructor(){this.h=new Set,this.i=new T.$Md,this.onDidSchemaChange=this.i.event,this.j=new T.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$kn,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const o=new Set;this.n(t,n,o),I.registerSchema(e.$kn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const n=new Set;this.o(t,n),I.registerSchema(e.$kn,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const o=new Set;this.o(n,o),this.n(t,!1,o),I.registerSchema(e.$kn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const o=[];for(const{overrides:i,source:c}of t)for(const h in i)if(n.add(h),e.$nn.test(h)){const y=this.a.get(h),C=y?.valuesSources??new Map;if(c)for(const P of Object.keys(i[h]))C.set(P,c);const $={...y?.value||{},...i[h]};this.a.set(h,{source:c,value:$,valuesSources:C});const f=(0,R.$ri)(h),d={type:"object",default:$,description:L.localize(1,null,f),$ref:e.$kn,defaultDefaultValue:$,source:g.$xf(c)?void 0:c,defaultValueSource:c};o.push(...p(h)),this.d[h]=d,this.b.properties[h]=d}else{this.a.set(h,{value:i[h],source:c});const y=this.d[h];y&&(this.w(h,y),this.r(h,y))}this.m(o)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:o,source:i}of t)for(const c in o){const h=this.a.get(c),y=g.$xf(i)?i:i?.id,C=g.$xf(h?.source)?h?.source:h?.source?.id;if(y===C)if(n.add(c),this.a.delete(c),e.$nn.test(c))delete this.d[c],delete this.b.properties[c];else{const $=this.d[c];$&&(this.w(c,$),this.r(c,$))}}this.u()}deltaConfiguration(t){let n=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,o){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,o),this.c.push(i),this.q(i)})}o(t,n){const o=i=>{if(i.properties)for(const c in i.properties){n.add(c);const h=this.d[c];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[c],this.s(c,i.properties[c])}i.allOf?.forEach(c=>o(c))};for(const i of t){o(i);const c=this.c.indexOf(i);c!==-1&&this.c.splice(c,1)}}p(t,n=!0,o,i,c=3,h){c=g.$Gf(t.scope)?c:t.scope;const y=t.properties;if(y)for(const $ in y){const f=y[$];if(n&&a($,f)){delete y[$];continue}if(f.source=o,f.defaultDefaultValue=y[$].default,this.w($,f),e.$nn.test($)?f.scope=void 0:(f.scope=g.$Gf(f.scope)?c:f.scope,f.restricted=g.$Gf(f.restricted)?!!i?.includes($):f.restricted),y[$].hasOwnProperty("included")&&!y[$].included){this.f[$]=y[$],delete y[$];continue}else this.d[$]=y[$],y[$].policy?.name&&this.e.set(y[$].policy.name,$);!y[$].deprecationMessage&&y[$].markdownDeprecationMessage&&(y[$].deprecationMessage=y[$].markdownDeprecationMessage),h.add($)}const C=t.allOf;if(C)for(const $ of C)this.p($,n,o,i,c,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=o=>{const i=o.properties;if(i)for(const h in i)this.r(h,i[h]);o.allOf?.forEach(n)};n(t)}r(t,n){switch(e.$en.properties[t]=n,n.scope){case 1:e.$fn.properties[t]=n;break;case 2:e.$gn.properties[t]=n;break;case 6:e.$hn.properties[t]=n;break;case 3:e.$in.properties[t]=n;break;case 4:e.$jn.properties[t]=n;break;case 5:e.$jn.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.$en.properties[t],n.scope){case 1:delete e.$fn.properties[t];break;case 2:delete e.$gn.properties[t];break;case 6:delete e.$hn.properties[t];break;case 3:delete e.$in.properties[t];break;case 4:case 5:delete e.$jn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,o={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$kn};this.w(n,o),e.$en.properties[n]=o,e.$fn.properties[n]=o,e.$gn.properties[n]=o,e.$hn.properties[n]=o,e.$in.properties[n]=o,e.$jn.properties[n]=o}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$kn};e.$en.patternProperties[e.$mn]=t,e.$fn.patternProperties[e.$mn]=t,e.$gn.patternProperties[e.$mn]=t,e.$hn.patternProperties[e.$mn]=t,e.$in.patternProperties[e.$mn]=t,e.$jn.patternProperties[e.$mn]=t,this.i.fire()}w(t,n){const o=this.a.get(t);let i=o?.value,c=o?.source;g.$Ef(i)&&(i=n.defaultDefaultValue,c=void 0),g.$Ef(i)&&(i=r(n.type)),n.default=i,n.defaultValueSource=c}}const k="\\[([^\\]]+)\\]",S=new RegExp(k,"g");e.$mn=`^(${k})+$`,e.$nn=new RegExp(e.$mn);function p(l){const t=[];if(e.$nn.test(l)){let n=S.exec(l);for(;n?.length;){const o=n[1].trim();o&&t.push(o),n=S.exec(l)}}return(0,D.$Lb)(t)}e.$on=p;function u(l){return l.reduce((t,n)=>`${t}[${n}]`,"")}e.$pn=u;function r(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$qn=r;const s=new v;E.$$m.add(e.$dn.Configuration,s);function a(l,t){return l.trim()?e.$nn.test(l)?L.localize(7,null,l):s.getConfigurationProperties()[l]!==void 0?L.localize(8,null,l):t.policy?.name&&s.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,l,t.policy?.name,s.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$rn=a;function m(){const l=[],t=s.getConfigurationProperties();for(const n of Object.keys(t))l.push([n,t[n].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$sn=m}),define(De[245],Ce([1,0,19,4,157,3,28,23,18,2,49,136,42]),function($e,e,D,T,g,L,R,b,E,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=void 0;function k(n){return Object.isFrozen(n)?n:b.$Zm(n)}class S{constructor(o={},i=[],c=[],h){this.b=o,this.c=i,this.d=c,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(i=>{if(i instanceof S)return i;const c=new p("");return c.parseRaw(i),c.configurationModel});this.f=o.reduce((i,c)=>c===i?c:i.merge(c),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,A.$pi)(this.contents,o):this.contents}inspect(o,i){const c=this.rawConfiguration.getValue(o),h=i?this.rawConfiguration.getOverrideValue(o,i):void 0,y=i?this.rawConfiguration.override(i).getValue(o):c;return{value:c,override:h,merged:y}}getOverrideValue(o,i){const c=this.i(i);return c?o?(0,A.$pi)(c,o):c:void 0}getKeysForOverrideIdentifier(o){const i=[];for(const c of this.overrides)c.identifiers.includes(o)&&i.push(...c.keys);return D.$Lb(i)}getAllOverrideIdentifiers(){const o=[];for(const i of this.overrides)o.push(...i.identifiers);return D.$Lb(o)}override(o){let i=this.a.get(o);return i||(i=this.g(o),this.a.set(o,i)),i}merge(...o){const i=b.$Ym(this.contents),c=b.$Ym(this.overrides),h=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const C of o)if(y.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(i,C.contents);for(const $ of C.overrides){const[f]=c.filter(d=>D.$tb(d.identifiers,$.identifiers));f?(this.h(f.contents,$.contents),f.keys.push(...$.keys),f.keys=D.$Lb(f.keys)):c.push(b.$Ym($))}for(const $ of C.keys)h.indexOf($)===-1&&h.push($)}return new S(i,h,c,y.every(C=>C instanceof S)?void 0:y)}g(o){const i=this.i(o);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const c={};for(const h of D.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let y=this.contents[h];const C=i[h];C&&(typeof y=="object"&&typeof C=="object"?(y=b.$Ym(y),this.h(y,C)):y=C),c[h]=y}return new S(c,this.keys,this.overrides)}h(o,i){for(const c of Object.keys(i)){if(c in o&&E.$zf(o[c])&&E.$zf(i[c])){this.h(o[c],i[c]);continue}o[c]=b.$Ym(i[c])}}i(o){let i=null,c=null;const h=y=>{y&&(c?this.h(c,y):c=b.$Ym(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===o?i=y.contents:y.identifiers.includes(o)&&h(y.contents);return h(i),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,i){this.j(o,i,!0)}setValue(o,i){this.j(o,i,!1)}removeValue(o){const i=this.keys.indexOf(o);i!==-1&&(this.keys.splice(i,1),(0,A.$oi)(this.contents,o),I.$nn.test(o)&&this.overrides.splice(this.overrides.findIndex(c=>D.$tb(c.identifiers,(0,I.$on)(o))),1))}j(o,i,c){(0,A.$ni)(this.contents,o,i,h=>console.error(h)),c=c||this.keys.indexOf(o)===-1,c&&this.keys.push(o),I.$nn.test(o)&&this.overrides.push({identifiers:(0,I.$on)(o),keys:Object.keys(this.contents[o]),contents:(0,A.$mi)(this.contents[o],h=>console.error(h))})}}e.$tn=S;class p{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,i){if(!E.$Gf(o)){const c=this.g(o);this.parseRaw(c,i)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,i){this.a=o;const{contents:c,keys:h,overrides:y,restricted:C,hasExcludedProperties:$}=this.h(o,i);this.b=new S(c,h,y,$?[o]:void 0),this.c=C||[]}g(o){let i={},c=null,h=[];const y=[],C=[];function $(d){Array.isArray(h)?h.push(d):c!==null&&(h[c]=d)}const f={onObjectBegin:()=>{const d={};$(d),y.push(h),h=d,c=null},onObjectProperty:d=>{c=d},onObjectEnd:()=>{h=y.pop()},onArrayBegin:()=>{const d=[];$(d),y.push(h),h=d,c=null},onArrayEnd:()=>{h=y.pop()},onLiteralValue:$,onError:(d,P,N)=>{C.push({error:d,offset:P,length:N})}};if(o)try{g.$Vm(o,f),i=h[0]||{}}catch(d){console.error(`Error while parsing settings file ${this.f}: ${d}`),this.d=[d]}return i}h(o,i){const c=v.$$m.as(I.$dn.Configuration).getConfigurationProperties(),h=this.i(o,c,!0,i);o=h.raw;const y=(0,A.$mi)(o,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),C=Object.keys(o),$=this.j(o,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:y,keys:C,overrides:$,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(o,i,c,h){let y=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:y};const C={},$=[];for(const f in o)if(I.$nn.test(f)&&c){const d=this.i(o[f],i,!1,h);C[f]=d.raw,y=y||d.hasExcludedProperties,$.push(...d.restricted)}else{const d=i[f],P=d?typeof d.scope<"u"?d.scope:3:void 0;d?.restricted&&$.push(f),!h.exclude?.includes(f)&&(h.include?.includes(f)||(P===void 0||h.scopes===void 0||h.scopes.includes(P))&&!(h.skipRestricted&&d?.restricted))?C[f]=o[f]:y=!0}return{raw:C,restricted:$,hasExcludedProperties:y}}j(o,i){const c=[];for(const h of Object.keys(o))if(I.$nn.test(h)){const y={};for(const C in o[h])y[C]=o[h][C];c.push({identifiers:(0,I.$on)(h),keys:Object.keys(y),contents:(0,A.$mi)(y,i)})}return c}}e.$un=p;class u extends L.$Rc{constructor(o,i,c,h){super(),this.c=o,this.f=i,this.g=h,this.b=this.B(new T.$Md),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&c.isEqual(y.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$vn=u;class r{constructor(o,i,c,h,y,C,$,f,d,P,N,O,M){this.a=o,this.b=i,this.c=c,this.overrideIdentifiers=h,this.d=y,this.f=C,this.g=$,this.h=f,this.i=d,this.j=P,this.k=N,this.l=O,this.m=M}get value(){return k(this.c)}n(o,i,c){const h=o.inspect(i,c);return{get value(){return k(h.value)},get override(){return k(h.override)},get merged(){return k(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class s{constructor(o,i,c,h,y=new S,C=new S,$=new R.$zc,f=new S,d=new R.$zc){this.c=o,this.d=i,this.f=c,this.g=h,this.h=y,this.i=C,this.j=$,this.l=f,this.m=d,this.a=null,this.b=new R.$zc,this.n=null}getValue(o,i,c){return this.q(o,i,c).getValue(o)}updateValue(o,i,c={}){let h;c.resource?(h=this.m.get(c.resource),h||(h=new S,this.m.set(c.resource,h))):h=this.l,i===void 0?h.removeValue(o):h.setValue(o,i),c.resource||(this.a=null)}inspect(o,i,c){const h=this.q(o,i,c),y=this.u(i.resource,c),C=i.resource?this.m.get(i.resource)||this.l:this.l,$=new Set;for(const f of h.overrides)for(const d of f.identifiers)h.getOverrideValue(o,d)!==void 0&&$.add(d);return new r(o,i,h.getValue(o),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,y||void 0,C)}keys(o){const i=this.u(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,i){this.j.set(o,i),this.b.delete(o)}deleteFolderConfiguration(o){this.p.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,i){const c=[];if(!i){const{added:h,updated:y,removed:C}=l(this.c,o);i=[...h,...y,...C]}for(const h of i)for(const y of(0,I.$on)(h)){const C=this.c.getKeysForOverrideIdentifier(y),$=o.getKeysForOverrideIdentifier(y),f=[...$.filter(d=>C.indexOf(d)===-1),...C.filter(d=>$.indexOf(d)===-1),...C.filter(d=>!b.$3m(this.c.override(y).getValue(d),o.override(y).getValue(d)))];c.push([y,f])}return this.updateDefaultConfiguration(o),{keys:i,overrides:c}}compareAndUpdatePolicyConfiguration(o){const{added:i,updated:c,removed:h}=l(this.d,o),y=[...i,...c,...h];return y.length&&this.updatePolicyConfiguration(o),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:i,updated:c,removed:h,overrides:y}=l(this.applicationConfiguration,o),C=[...i,...c,...h];return C.length&&this.updateApplicationConfiguration(o),{keys:C,overrides:y}}compareAndUpdateLocalUserConfiguration(o){const{added:i,updated:c,removed:h,overrides:y}=l(this.localUserConfiguration,o),C=[...i,...c,...h];return C.length&&this.updateLocalUserConfiguration(o),{keys:C,overrides:y}}compareAndUpdateRemoteUserConfiguration(o){const{added:i,updated:c,removed:h,overrides:y}=l(this.remoteUserConfiguration,o),C=[...i,...c,...h];return C.length&&this.updateRemoteUserConfiguration(o),{keys:C,overrides:y}}compareAndUpdateWorkspaceConfiguration(o){const{added:i,updated:c,removed:h,overrides:y}=l(this.workspaceConfiguration,o),C=[...i,...c,...h];return C.length&&this.updateWorkspaceConfiguration(o),{keys:C,overrides:y}}compareAndUpdateFolderConfiguration(o,i){const c=this.p.get(o),{added:h,updated:y,removed:C,overrides:$}=l(c,i),f=[...h,...y,...C];return(f.length||!c)&&this.updateFolderConfiguration(o,i),{keys:f,overrides:$}}compareAndDeleteFolderConfiguration(o){const i=this.p.get(o);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:c,updated:h,removed:y,overrides:C}=l(i,void 0);return{keys:[...c,...h,...y],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(o,i,c){let h=this.r(i,c);return i.overrideIdentifier&&(h=h.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(h=h.merge(this.d)),h}r({resource:o},i){let c=this.s();if(i&&o){const h=i.getFolder(o);h&&(c=this.t(h.uri)||c);const y=this.m.get(o);y&&(c=c.merge(y))}return c}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(o){let i=this.b.get(o);if(!i){const c=this.s(),h=this.j.get(o);h?(i=c.merge(h),this.b.set(o,i)):i=c}return i}u(o,i){if(i&&o){const c=i.getFolder(o);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,i)=>{const{contents:c,overrides:h,keys:y}=this.j.get(i);return o.push([i,{contents:c,overrides:h,keys:y}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(i=>o.add(i)),this.userConfiguration.keys.forEach(i=>o.add(i)),this.i.keys.forEach(i=>o.add(i)),this.j.forEach(i=>i.keys.forEach(c=>o.add(c))),[...o.values()]}v(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(c=>o.add(c))),[...o.values()]}w(o){const i=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(c=>i.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(c=>i.add(c)),this.i.getKeysForOverrideIdentifier(o).forEach(c=>i.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(o).forEach(h=>i.add(h))),[...i.values()]}static parse(o){const i=this.x(o.defaults),c=this.x(o.policy),h=this.x(o.application),y=this.x(o.user),C=this.x(o.workspace),$=o.folders.reduce((f,d)=>(f.set(w.URI.revive(d[0]),this.x(d[1])),f),new R.$zc);return new s(i,c,h,y,new S,C,$,new S,new R.$zc)}static x(o){return new S(o.contents,o.keys,o.overrides)}}e.$wn=s;function a(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const o=new Set,i=new Map;for(const h of n)h.keys.forEach(y=>o.add(y)),h.overrides.forEach(([y,C])=>{const $=(0,R.$wc)(i,y,new Set);C.forEach(f=>$.add(f))});const c=[];return i.forEach((h,y)=>c.push([y,[...h.values()]])),{keys:[...o.values()],overrides:c}}e.$xn=a;class m{constructor(o,i,c,h){this.change=o,this.f=i,this.g=c,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const y of o.keys)this.affectedKeys.add(y);for(const[,y]of o.overrides)for(const C of y)this.affectedKeys.add(C);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=s.parse(this.f.data)),this.i}affectsConfiguration(o,i){const c=this.a+o,h=this.d.indexOf(c);if(h<0)return!1;const y=h+c.length;if(y>=this.d.length)return!1;const C=this.d.charCodeAt(y);if(C!==this.b&&C!==this.c)return!1;if(i){const $=this.previousConfiguration?this.previousConfiguration.getValue(o,i,this.f?.workspace):void 0,f=this.g.getValue(o,i,this.h);return!b.$3m($,f)}return!0}}e.$yn=m;function l(n,o){const{added:i,removed:c,updated:h}=t(o?.rawConfiguration,n?.rawConfiguration),y=[],C=n?.getAllOverrideIdentifiers()||[],$=o?.getAllOverrideIdentifiers()||[];if(o){const f=$.filter(d=>!C.includes(d));for(const d of f)y.push([d,o.getKeysForOverrideIdentifier(d)])}if(n){const f=C.filter(d=>!$.includes(d));for(const d of f)y.push([d,n.getKeysForOverrideIdentifier(d)])}if(o&&n){for(const f of C)if($.includes(f)){const d=t({contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)},{contents:o.getOverrideValue(void 0,f)||{},keys:o.getKeysForOverrideIdentifier(f)});y.push([f,[...d.added,...d.removed,...d.updated]])}}return{added:i,removed:c,updated:h,overrides:y}}function t(n,o){const i=n?o?n.keys.filter(y=>o.keys.indexOf(y)===-1):[...n.keys]:[],c=o?n?o.keys.filter(y=>n.keys.indexOf(y)===-1):[...o.keys]:[],h=[];if(n&&o){for(const y of o.keys)if(n.keys.indexOf(y)!==-1){const C=(0,A.$pi)(o.contents,y),$=(0,A.$pi)(n.contents,y);b.$3m(C,$)||h.push(y)}}return{added:i,removed:c,updated:h}}}),define(De[246],Ce([1,0,22,4,3,81]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pkb=e.$okb=e.$nkb=e.$mkb=void 0;const R=(w,A,I)=>{const v=new Uint8Array(16);for(let p=0;p<16;p++)v[p]=Math.round(Math.random()*256);const k=(0,D.$ue)(D.$ae.wrap(v));return[`GET ws://localhost${w}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$mkb=R,e.$nkb=D.$ae.fromString(`\r
\r
`);async function b(w,A,I,v,k){w.write(D.$ae.fromString((0,e.$mkb)(A,I,v)));const S=new g.$Qc;try{return await new Promise((p,u)=>{let r;S.add(w.onData(s=>{r?r=D.$ae.concat([r,s],r.byteLength+s.byteLength):r=s;const a=r.indexOf(e.$nkb);if(a===-1)return;p(w),w.pauseData();const m=r.slice(a+e.$nkb.byteLength);m.byteLength&&k.onData.fire(m)})),S.add(w.onClose(s=>u(s??new Error("socket closed")))),S.add(w.onEnd(()=>u(new Error("socket ended"))))})}catch(p){throw w.dispose(),p}finally{S.dispose()}}e.$okb=b;class E extends g.$Rc{constructor(A,I){super(),this.g=A,this.a=this.B(new T.$Pd),this.onData=(...v)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...v)),this.b=this.B(new T.$Md),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(v=>this.a.fire(v))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,I){L.SocketDiagnostics.traceSocketEvent(this,this.g,A,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$pkb=E}),define(De[64],Ce([1,0,8,5]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.RemoteAuthorityResolverErrorCode=e.$Ok=e.$Nk=e.RemoteConnectionType=e.$Mk=void 0,e.$Mk=(0,T.$Nh)("remoteAuthorityResolverService");var g;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class L{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Nk=L;class R{constructor(I,v){this.host=I,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ok=R;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class E extends D.$ab{static isNotAvailable(I){return I instanceof E&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof E&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof E&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof E&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof E&&I.isHandled}constructor(I,v=b.Unknown,k){super(I),this._message=I,this._code=v,this._detail=k,this.isHandled=v===b.NotAvailable&&k===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Pk=E;function w(A){const I=A.indexOf("+");return I===-1?A:A.substring(0,I)}e.$Qk=w}),define(De[65],Ce([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0;function T(w){return w.scheme===D.Schemas.vscodeRemote?w.authority:void 0}e.$Rk=T;function g(w){if(!w)return;const A=w.indexOf("+");return A<0?w:w.substr(0,A)}e.$Sk=g;function L(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$Tk=L;function R(w){const{host:A,port:I}=E(w);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:I}}e.$Uk=R;function b(w,A){let{host:I,port:v}=E(w);return typeof v>"u"&&(v=A),{host:I,port:v}}e.$Vk=b;function E(w){const A=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const I=w.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const v=w.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:w,port:void 0}}}),define(De[25],Ce([1,0,15,5,65]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.TargetPlatform=e.ExtensionType=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=void 0,e.$Sl="extensions.user.cache",e.$Tl="extensions.builtin.cache",e.$Ul="undefined_publisher",e.$Vl=["ui","workspace","web"];function L(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$Wl=L,e.$Xl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(R||(e.ExtensionType=R={}));var b;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class E{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,r){if(typeof u>"u"||u===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof u=="string"||typeof r=="string"){const s=typeof u=="string"?u:u.value,a=typeof r=="string"?r:r.value;return D.$1e(s,a)}return u._lower===r._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$Yl=E;class w{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const r of u)this.add(r)}add(u){this.c.add(E.toKey(u))}delete(u){return this.c.delete(E.toKey(u))}has(u){return this.c.has(E.toKey(u))}}e.$Zl=w;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(E.toKey(u))}get(u){return this.c.get(E.toKey(u))}has(u){return this.c.has(E.toKey(u))}set(u,r){this.c.set(E.toKey(u),r)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$1l=A;function I(p){return v(p)}e.$2l=I;function v(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$3l=v;function k(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$4l=k;function S(p,u){if(u){const r=`onResolveRemoteAuthority:${(0,g.$Sk)(u)}`;return!!p.activationEvents?.includes(r)}return!1}e.$5l=S,e.$6l=(0,T.$Nh)("IBuiltinExtensionsScannerService")}),define(De[137],Ce([1,0,8,25]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NE=e.$ME=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(R,b){this.a.set(R,b)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const b=Object.create(null);for(const E of R){const w=this.readActivationEvents(E);w.length>0&&(b[T.$Yl.toKey(E.identifier)]=w)}return b}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const b=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return b;for(const E in R.contributes){const w=this.a.get(E);if(!w)continue;const A=R.contributes[E],I=Array.isArray(A)?A:[A];try{w(I,b)}catch(v){(0,D.$Z)(v)}}return b}}e.$ME=g,e.$NE=new g}),define(De[247],Ce([1,0,11,22,21,8,4,3,54,37,31,81,64,65]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.PersistentConnectionEventType=e.$3k=e.$2k=e.$1k=e.ConnectionType=void 0;const S=30*1e3;var p;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function u(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function r(G){const z=new g.$Wd;return setTimeout(()=>z.cancel(),G),z.token}function s(G,z){if(G.isCancellationRequested||z.isCancellationRequested)return g.CancellationToken.Cancelled;const K=new g.$Wd;return G.onCancellationRequested(()=>K.cancel()),z.onCancellationRequested(()=>K.cancel()),K.token}class a{get didTimeout(){return this.c==="timedout"}constructor(z){this.c="pending",this.d=new b.$Qc,this.promise=new Promise((K,ge)=>{this.f=K,this.g=ge}),z.isCancellationRequested?this.h():this.d.add(z.onCancellationRequested(()=>this.h()))}registerDisposable(z){this.c==="pending"?this.d.add(z):z.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(z))}reject(z){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(z))}}function m(G,z){const K=new a(z);return K.registerDisposable(G.onControlMessage(ge=>{const _=JSON.parse(ge.toString()),ie=Y(_);ie?K.reject(ie):K.resolve(_)})),K.promise}function l(G,z,K,ge,_,ie,ne,Ee){const oe=new a(Ee),he=w.$Id.create(!1);return G.info(`Creating a socket (${ne})...`),E.mark(`code/willCreateSocket/${ie}`),z.connect(K,ge,_,ne).then(ee=>{oe.didTimeout?(E.mark(`code/didCreateSocketError/${ie}`),G.info(`Creating a socket (${ne}) finished after ${he.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(E.mark(`code/didCreateSocketOK/${ie}`),G.info(`Creating a socket (${ne}) was successful after ${he.elapsed()} ms.`),oe.resolve(ee))},ee=>{E.mark(`code/didCreateSocketError/${ie}`),G.info(`Creating a socket (${ne}) returned an error after ${he.elapsed()} ms.`),G.error(ee),oe.reject(ee)}),oe.promise}function t(G,z){const K=new a(z);return G.then(ge=>{K.didTimeout||K.resolve(ge)},ge=>{K.didTimeout||K.reject(ge)}),K.promise}async function n(G,z,K,ge){const _=ue(G,z);G.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let ie;try{ie=await l(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,k.$Tk)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,u(z),`renderer-${u(z)}-${G.reconnectionToken}`,ge)}catch(ee){throw G.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),G.logService.error(ee),ee}G.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let ne,Ee;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(ie,null),ne=G.reconnectionProtocol,Ee=!1):(ne=new I.$Bh({socket:ie}),Ee=!0),G.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const oe=await t(G.signService.createNewMessage((0,A.$dg)()),ge),he={type:"auth",auth:G.connectionToken||"00000000000000000000",data:oe.data};ne.sendControl(T.$ae.fromString(JSON.stringify(he)));try{const ee=await m(ne,s(ge,r(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(G.logService.trace(`${_} 4/6. received SignRequest control message.`),!await t(G.signService.validate(oe,ee.signedData),ge)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const be=await t(G.signService.sign(ee.data),ge),Pe={type:"connectionType",commit:G.commit,signedData:be,desiredConnectionType:z};return K&&(Pe.args=K),G.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),ne.sendControl(T.$ae.fromString(JSON.stringify(Pe))),{protocol:ne,ownsProtocol:Ee}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(G.logService.error(`${_} the handshake timed out. Error:`),G.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${_} received error control message when negotiating connection. Error:`),G.logService.error(ee)),Ee&&X(ne),ee}}async function o(G,z,K,ge){const _=Date.now(),ie=ue(G,z),{protocol:ne,ownsProtocol:Ee}=await n(G,z,K,ge),oe=new a(ge);return oe.registerDisposable(ne.onControlMessage(he=>{const ee=JSON.parse(he.toString()),le=Y(ee);le?(G.logService.error(`${ie} received error control message when negotiating connection. Error:`),G.logService.error(le),Ee&&X(ne),oe.reject(le)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${ie} 6/6. handshake finished, connection is up and running after ${pe(_)}!`),oe.resolve({protocol:ne,firstMessage:ee}))})),oe.promise}async function i(G,z){const{protocol:K}=await o(G,1,void 0,z);return{protocol:K}}async function c(G,z,K){const{protocol:ge,firstMessage:_}=await o(G,2,z,K),ie=_&&_.debugPort;return{protocol:ge,debugPort:ie}}async function h(G,z,K){const ge=Date.now(),_=ue(G,3),{protocol:ie}=await n(G,3,z,K);return G.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${pe(ge)}!`),ie}async function y(G,z,K){const{connectTo:ge,connectionToken:_}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:ge,connectionToken:_,reconnectionToken:z,reconnectionProtocol:K,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function C(G,z,K){return f(G,async ge=>{const{protocol:_}=await i(ge,g.CancellationToken.None);return new H(G,z,K,ge.reconnectionToken,_)})}e.$1k=C;async function $(G,z){return f(G,async K=>{const{protocol:ge,debugPort:_}=await c(K,z,g.CancellationToken.None);return new fe(G,z,K.reconnectionToken,ge,_)})}e.$2k=$;async function f(G,z){for(let ge=1;;ge++)try{const _=(0,A.$dg)(),ie=await y(G,_,null);return await z(ie)}catch(_){if(ge<5)G.logService.error(`[remote-connection][attempt ${ge}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(_);else throw G.logService.error(`[remote-connection][attempt ${ge}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(_),V.triggerPermanentFailure(0,0,v.$Pk.isHandled(_)),_}}async function d(G,z,K){const ge=await y(G,(0,A.$dg)(),null);return await h(ge,{host:z,port:K},g.CancellationToken.None)}e.$3k=d;function P(G){return(0,D.$Gg)(z=>new Promise((K,ge)=>{const _=setTimeout(K,G*1e3);z.onCancellationRequested(()=>{clearTimeout(_),K()})}))}var N;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class O{constructor(z,K){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.type=0}}e.$4k=O;class M{constructor(z,K,ge,_){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.durationSeconds=ge,this.c=_,this.type=1}skipWait(){this.c.cancel()}}e.$5k=M;class j{constructor(z,K,ge){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.attempt=ge,this.type=2}}e.$6k=j;class U{constructor(z,K,ge){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.attempt=ge,this.type=4}}e.$7k=U;class F{constructor(z,K,ge,_){this.reconnectionToken=z,this.millisSinceLastIncomingData=K,this.attempt=ge,this.handled=_,this.type=3}}e.$8k=F;class V extends b.$Rc{static triggerPermanentFailure(z,K,ge){this._permanentFailure=!0,this.f=z,this.g=K,this.h=ge,this.j.forEach(_=>_.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(z=>z.y())}static debugPauseSocketWriting(){this.j.forEach(z=>z.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||V._permanentFailure}constructor(z,K,ge,_,ie){super(),this.t=z,this.u=K,this.reconnectionToken=ge,this.protocol=_,this.w=ie,this.m=this.B(new R.$Md),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new U(this.reconnectionToken,0,0)),this.B(_.onSocketClose(ne=>{const Ee=me(this.t,this.reconnectionToken,!0);ne?ne.type===0?(this.u.logService.info(`${Ee} received socket close event (hadError: ${ne.hadError}).`),ne.error&&this.u.logService.error(ne.error)):(this.u.logService.info(`${Ee} received socket close event (wasClean: ${ne.wasClean}, code: ${ne.code}, reason: ${ne.reason}).`),ne.event&&this.u.logService.error(ne.event)):this.u.logService.info(`${Ee} received socket close event.`),this.y()})),this.B(_.onSocketTimeout(ne=>{const Ee=me(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Ee} received socket timeout event (unacknowledgedMsgCount: ${ne.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ne.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ne.timeSinceLastReceivedSomeData}).`),this.y()})),V.j.push(this),this.B((0,b.$Pc)(()=>{const ne=V.j.indexOf(this);ne>=0&&V.j.splice(ne,1)})),this.n&&this.D(V.f,V.g,V.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const z=me(this.t,this.reconnectionToken,!0);this.u.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const K=[0,5,5,10,10,10,10,10,30];let ge=-1;do{ge++;const _=ge<K.length?K[ge]:K[K.length-1];try{if(_>0){const ne=P(_);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,ne)),this.u.logService.info(`${z} waiting for ${_} seconds before reconnecting...`);try{await ne}catch{}}if(this.n){this.u.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ge+1)),this.u.logService.info(`${z} resolving connection...`);const ie=await y(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${z} connecting to ${ie.connectTo}...`),await this.G(ie,r(S)),this.u.logService.info(`${z} reconnected!`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ge+1));break}catch(ie){if(ie.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,!1);break}if(ge>360){this.u.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,!1);break}if(v.$Pk.isTemporarilyNotAvailable(ie)){this.u.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((ie.code==="ETIMEDOUT"||ie.code==="ENETUNREACH"||ie.code==="ECONNREFUSED"||ie.code==="ECONNRESET")&&ie.syscall==="connect"){this.u.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((0,L.$3)(ie)){this.u.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if(ie instanceof v.$Pk){this.u.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,v.$Pk.isHandled(ie));break}this.u.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,!1);break}}while(!this.n&&!this.s)}C(z,K,ge){this.w?V.triggerPermanentFailure(z,K,ge):this.D(z,K,ge)}D(z,K,ge){this.m.fire(new F(this.reconnectionToken,z,K,ge)),X(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9k=V;class H extends V{constructor(z,K,ge,_,ie){super(1,z,_,ie,!0),this.client=this.B(new I.$zh(ie,{remoteAuthority:K,clientId:ge},z.ipcLogger))}async G(z,K){await i(z,K)}}e.$0k=H;class fe extends V{constructor(z,K,ge,_,ie){super(2,z,ge,_,!1),this.H=K,this.debugPort=ie}async G(z,K){await c(z,this.H,K)}}e.$$k=fe;function X(G){try{G.acceptDisconnect();const z=G.getSocket();G.dispose(),z.dispose()}catch(z){(0,L.$Z)(z)}}function Y(G){if(G&&G.type==="error"){const z=new Error(`Connection error: ${G.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function q(G,z){for(;G.length<z;)G+=" ";return G}function x(G,z){return`[remote-connection][${q(u(G),13)}][${z.substr(0,5)}\u2026]`}function me(G,z,K){return`${x(G,z)}[${K?"reconnect":"initial"}]`}function ue(G,z){return`${me(z,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function pe(G){return`${Date.now()-G} ms`}}),define(De[248],Ce([1,0,3,5]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=void 0,e.$Wk=(0,T.$Nh)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(R,b){return this.a[R]??=[],this.a[R].push(b),(0,D.$Pc)(()=>{const E=this.a[R]?.indexOf(b);typeof E=="number"&&E>=0&&this.a[R]?.splice(E,1)})}b(R){return(this.a[R.type]||[]).find(E=>E.supports(R))}connect(R,b,E,w){const A=this.b(R);if(!A)throw new Error(`No socket factory found for ${R}`);return A.connect(R,b,E,w)}}e.$Xk=g}),define(De[249],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$52b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const L=await this.c();if(L){const R=String(D.a++);return this.b.set(R,L),{id:R,data:L.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,L){if(!g.id)return!0;const R=this.b.get(g.id);if(!R)return!1;this.b.delete(g.id);try{return R.validate(L)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$52b=D}),define(De[107],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=void 0,e.$Yk="signService",e.$Zk=(0,D.$Nh)(e.$Yk)}),define(De[138],Ce([1,0,249]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R7b=void 0;class T extends D.$52b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(R=>new R.signer().sign(L))}h(){return new Promise((L,R)=>$e(["vsda"],L,R))}}e.$R7b=T}),define(De[250],Ce([1,0,12,47,31]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=void 0;function L(E){if(D.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function R(E,w,A,I,v,k,S,p){const u=Object.create(null);u["common.machineId"]=k,u.sessionID=(0,g.$dg)()+Date.now(),u.commitHash=I,u.version=v,u["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,D.$i)(D.$u),u["common.nodePlatform"]=T.$cc,u["common.nodeArch"]=A,u["common.product"]=p||"desktop",S&&(u["common.msftInternal"]=S);let r=0;const s=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),D.$m&&(u["common.snap"]="true");const a=L(w);return a&&(u["common.platformDetail"]=a),u}e.$ao=R;function b(E){const w=T.env.USERDNSDOMAIN;if(!w)return!1;const A=w.toLowerCase();return E.some(I=>A===I)}e.$bo=b}),define(De[251],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0,e.$_k=(0,D.$Nh)("telemetryService"),e.$al=(0,D.$Nh)("customEndpointTelemetryService"),e.$bl="telemetry.currentSessionDate",e.$cl="telemetry.firstSessionDate",e.$dl="telemetry.lastSessionDate",e.$el="telemetry.machineId",e.$fl="telemetry",e.$gl="telemetry.telemetryLevel",e.$hl="telemetry.enableCrashReporter",e.$il="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var g;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(De[85],Ce([1,0,23,18,4,49,65,250,251]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=void 0;class w{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$co=w;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$do=A,e.$eo=new A;class I{async publicLog(c,h,y){}async publicLogError(c,h,y){}}e.$fo=I,e.$go="telemetry",e.$ho="extensionTelemetryLog",e.$io={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,c){return g.Event.debounce(c.onDidChangeConfiguration,(y,C)=>{const $=y?new Set([...y.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:$}},1e3,!0)(y=>{y.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,L.$ki)(y.source),configurationKeys:Array.from(y.affectedKeys)})})}e.$jo=v;function k(i,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!i.enableTelemetry)}e.$ko=k;function S(i,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$lo=S;function p(i){const c=i.getValue(E.$gl),h=i.getValue(E.$hl);if(i.getValue(E.$il)===!1||h===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$mo=p;function u(i){const c={},h={},y={};a(i,y);for(let C in y){C=C.length>150?C.substr(C.length-149):C;const $=y[C];typeof $=="number"?h[C]=$:typeof $=="boolean"?h[C]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${$.length}`),c[C]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(c[C]=$)}return{properties:c,measurements:h}}e.$no=u;const r=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(i){if(!i)return"none";const c=(0,R.$Sk)(i);return r.has(c)?c:"other"}e.$oo=s;function a(i,c,h=0,y){if(i)for(const C of Object.getOwnPropertyNames(i)){const $=i[C],f=y?y+C:C;Array.isArray($)?c[f]=(0,D.$4m)($):$ instanceof Date?c[f]=$.toISOString():(0,T.$zf)($)?h<2?a($,c,h+1,f+"."):c[f]=(0,D.$4m)($):c[f]=$}}function m(i,c){const h=i.msftInternalDomains||[],y=c.getValue("telemetry.internalTesting");return(0,b.$bo)(h)||y}e.$po=m;function l(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$qo=l;function t(i,c){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let h=i;const y=[];for(const d of c)for(;;){const P=d.exec(i);if(!P)break;y.push([P.index,d.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(h="";;){const d=$.exec(i);if(!d)break;const P=y.some(([N,O])=>d.index<O&&N<$.lastIndex);!C.test(d[0])&&!P&&(h+=i.substring(f,d.index)+"<REDACTED: user-file-path>",f=$.lastIndex)}return f<i.length&&(h+=i.substr(f)),h}function n(i){if(!i)return i;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of c)if(h.regex.test(i))return`<REDACTED: ${h.label}>`;return i}function o(i,c){return(0,D.$1m)(i,h=>{if(h instanceof w||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let y=h.replaceAll("%20"," ");y=t(y,c);for(const C of c)y=y.replace(C,"");return y=n(y),y}})}e.$ro=o}),define(De[252],Ce([1,0,15,132,25,12,2,8,47,85]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=void 0;function A(o,i){return o.uuid&&i.uuid?o.uuid===i.uuid:o.id===i.id?!0:(0,D.$Ve)(o.id,i.id)===0}e.$so=A;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const c=i.manifest?i.manifest.version:i.version,h=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,c,h)}static parse(i){const c=I.exec(i);return c&&c[1]&&c[2]?new v({id:c[1]},c[2],c[4]||void 0):null}constructor(i,c,h="undefined"){this.version=c,this.targetPlatform=h,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?A(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$to=v;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(o){const i=k.exec(o);return i&&i[1]?[u(i[1]),i[2]]:[u(o),void 0]}e.$uo=S;function p(o,i){return`${o}.${i}`}e.$vo=p;function u(o){return o.toLowerCase()}e.$wo=u;function r(o,i){return u(p(o??g.$Ul,i))}e.$xo=r;function s(o,i){const c=[],h=y=>{for(const C of c)if(C.some($=>A(i($),i(y))))return C;return null};for(const y of o){const C=h(y);C?C.push(y):c.push([y])}return c}e.$yo=s;function a(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$zo=a;function m(o){return{id:new w.$co(o.identifier.id),name:new w.$co(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Ao=m,e.$Bo=new g.$Yl("pprice.better-merge");function l(o,i){const c=[],h=i.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const y=h.shift();if(y&&c.every(C=>!A(C.identifier,{id:y}))){const C=o.filter($=>A($.identifier,{id:y}));C.length===1&&(c.push(C[0]),h.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.$Co=l;async function t(o,i){if(!L.$l)return!1;let c;try{c=(await o.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await o.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(y){i.debug("Error while getting the os-release file.",(0,b.$9)(y))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(o,i){const c=await t(o,i),h=(0,T.$Xn)(c?"alpine":L.$u,E.$dc);return i.debug("ComputeTargetPlatform:",h),h}e.$Do=n}),define(De[253],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=e.$gr=e.$fr=e.$er=e.$dr=void 0;function D(E){return[...E.entries()]}e.$dr=D;function T(E){return E?[...E.entries()]:[]}e.$er=T;function g(E){return new Map(E)}e.$fr=g;function L(E){return new Map(E??[])}e.$gr=L;function R(E){return Array.from(E.entries()).map(w=>[w[0],D(w[1].map),T(w[1].descriptionMap)])}e.$hr=R;function b(E){return new Map(E.map(w=>[w[0],{map:g(w[1]),descriptionMap:L(w[2])}]))}e.$ir=b}),define(De[254],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,L,R=5){const b=L(E=>{const w=typeof E=="string"?E:E.data;let A=this.a.get(g);if(A){A.data.push(w);return}const I=setTimeout(()=>this.flushBuffer(g),R);A={data:[w],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(g),b.dispose()}},this.a.set(g,A)});return b}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const L=this.a.get(g);L&&(this.a.delete(g),this.b(g,L.data.join("")))}}e.$Fkb=D}),define(De[255],Ce([1,0,11,78,59,4,18,2,199,106,42]),function($e,e,D,T,g,L,R,b,E,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.IconFontDefinition=e.IconContribution=e.$Xv=void 0,e.$Xv={IconContribution:"base.contributions.icons"};var I;(function(m){function l(t,n){let o=t.defaults;for(;g.ThemeIcon.isThemeIcon(o);){const i=S.getIcon(o.id);if(!i)return;o=i.defaults}return o}m.getDefinition=l})(I||(e.IconContribution=I={}));var v;(function(m){function l(n){return{weight:n.weight,style:n.style,src:n.src.map(o=>({format:o.format,location:o.location.toString()}))}}m.toJSONObject=l;function t(n){const o=i=>(0,R.$xf)(i)?i:void 0;if(n&&Array.isArray(n.src)&&n.src.every(i=>(0,R.$xf)(i.format)&&(0,R.$xf)(i.location)))return{weight:o(n.weight),style:o(n.style),src:n.src.map(i=>({format:i.format,location:b.URI.parse(i.location)}))}}m.fromJSONObject=t})(v||(e.IconFontDefinition=v={}));class k{constructor(){this.a=new L.$Md,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,t,n,o){const i=this.b[l];if(i){if(n&&!i.description){i.description=n,this.d.properties[l].markdownDescription=`${n} $(${l})`;const y=this.e.enum.indexOf(l);y!==-1&&(this.e.enumDescriptions[y]=n),this.a.fire()}return i}const c={id:l,description:n,defaults:t,deprecationMessage:o};this.b[l]=c;const h={$ref:"#/definitions/icons"};return o&&(h.deprecationMessage=o),n&&(h.markdownDescription=`${n}: $(${l})`),this.d.properties[l]=h,this.e.enum.push(l),this.e.enumDescriptions.push(n||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const t=this.e.enum.indexOf(l);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,t){const n=this.f[l];return n||(this.f[l]=t,this.a.fire(),t)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(i,c)=>i.id.localeCompare(c.id),t=i=>{for(;g.ThemeIcon.isThemeIcon(i.defaults);)i=this.b[i.defaults.id];return`codicon codicon-${i?i.id:""}`},n=[];n.push("| preview     | identifier                        | default codicon ID                | description"),n.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map(i=>this.b[i]);for(const i of o.filter(c=>!!c.description).sort(l))n.push(`|<i class="${t(i)}"></i>|${i.id}|${g.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);n.push("| preview     | identifier                        "),n.push("| ----------- | --------------------------------- |");for(const i of o.filter(c=>!g.ThemeIcon.isThemeIcon(c.defaults)).sort(l))n.push(`|<i class="${t(i)}"></i>|${i.id}|`);return n.join(`
`)}}const S=new k;A.$$m.add(e.$Xv.IconContribution,S);function p(m,l,t,n){return S.registerIcon(m,l,t,n)}e.$Yv=p;function u(){return S}e.$Zv=u;function r(){const m=(0,T.$Qj)();for(const l in m){const t="\\"+m[l].toString(16);S.registerIcon(l,{fontCharacter:t})}}r(),e.$1v="vscode://schemas/icons";const s=A.$$m.as(w.$_m.JSONContribution);s.registerSchema(e.$1v,S.getIconSchema());const a=new D.$5g(()=>s.notifySchemaChanged(e.$1v),200);S.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$2v=p("widget-close",T.$Sj.close,(0,E.localize)(2,null)),e.$3v=p("goto-previous-location",T.$Sj.arrowUp,(0,E.localize)(3,null)),e.$4v=p("goto-next-location",T.$Sj.arrowDown,(0,E.localize)(4,null)),e.$5v=g.ThemeIcon.modify(T.$Sj.sync,"spin"),e.$6v=g.ThemeIcon.modify(T.$Sj.loading,"spin")}),define(De[86],Ce([1,0,4,49,5,13]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.ProvidedOnAutoForward=e.$5u=e.TunnelPrivacyId=e.TunnelProtocol=e.$4u=e.$3u=void 0,e.$3u=(0,g.$Nh)("tunnelService"),e.$4u=(0,g.$Nh)("sharedTunnelsService");var R;(function(u){u.Http="http",u.Https="https"})(R||(e.TunnelProtocol=R={}));var b;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(b||(e.TunnelPrivacyId=b={}));function E(u){return!!u.forwardPort}e.$5u=E;var w;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function A(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(r)return{address:r[1],port:+r[2]}}e.$6u=A,e.$7u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(u){return e.$7u.indexOf(u)>=0}e.$8u=I,e.$9u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(u){return e.$9u.indexOf(u)>=0}e.$0u=v;function k(u,r,s,a){if(s===1)return!1;if(s===2&&v(r)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(m?.length===4&&parseInt(m[1])>=18)return!1}return u<1024}e.$$u=k;class S{constructor(r,s,a){this.remoteAddress=r,this.localAddress=s,this.b=a,this.a=new D.$Md,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$_u=S;let p=class{constructor(r,s){this.j=r,this.k=s,this.a=new D.$Md,this.onTunnelOpened=this.a.event,this.b=new D.$Md,this.onTunnelClosed=this.b.event,this.c=new D.$Md,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const r=this.k.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.f=r,r?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.g=r.elevation,this.h=r.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const r=[],s=Array.from(this.e.values());for(const a of s){const m=Array.from(a.values());for(const l of m){const t=await l.value;t&&typeof t!="string"&&r.push(t)}}return r}async dispose(){for(const r of this.e.values()){for(const{value:s}of r.values())await s.then(a=>typeof a!="string"?a?.dispose():void 0);r.clear()}this.e.clear()}setEnvironmentTunnel(r,s,a,m,l){this.p(r,s,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:s,localAddress:a,privacy:m,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,s){(v(r)||I(r))&&(r=e.$7u[0]);const a=this.r(r,s);if(a)return++a.refcount,a.value}openTunnel(r,s,a,m,l,t=!1,n,o){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${s}:${a} on local port ${l}.`);const i=this.f??r;if(!i)return;if(s||(s="localhost"),m||(m=this.l),this.f&&this.i.has(a)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.s(i,s,a,m,l,t,n,o);return c?c.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(s,a),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(s,a);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const y=this.n(h);return(h.tunnelRemoteHost!==s||h.tunnelRemotePort!==a)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&h.privacy!==n&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(y),y}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}n(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const s=this.e.get(r.tunnelRemoteHost);if(s){const a=s.get(r.tunnelRemotePort);a&&(a.refcount--,await this.o(r.tunnelRemoteHost,r.tunnelRemotePort,a))}}}}async o(r,s,a){if(a.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${s}.`);const m=a.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(r)&&this.e.get(r).delete(s),m}}async closeTunnel(r,s){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${s} `);const a=this.e.get(r);if(a&&a.has(s)){const m=a.get(s);m.refcount=0,await this.o(r,s,m)}}p(r,s,a){this.e.has(r)||this.e.set(r,new Map),this.e.get(r).set(s,{refcount:1,value:a})}async q(r,s){const a=this.e.get(r);if(a){const m=a.get(s),l=m?await m.value:void 0;(!l||typeof l=="string")&&a.delete(s),a.size===0&&this.e.delete(r)}}r(r,s){const a=[r];I(r)?(a.push(...e.$7u),a.push(...e.$9u)):v(r)&&a.push(...e.$9u);const m=a.map(l=>this.e.get(l));for(const l of m){const t=l?.get(s);if(t)return t}}canTunnel(r){return!!A(r)}t(r,s,a,m,l,t,n){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${s}:${a} on local port ${m}.`);const o=a;this.i.add(o);const i=m===void 0?a:m,c={elevationRequired:l?this.isPortPrivileged(i):!1},h={remoteAddress:{host:s,port:a},localAddressPort:m,privacy:t,public:t?t!==b.Private:void 0,protocol:n},y=r.forwardPort(h,c);return y?(this.p(s,a,y),y.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(o)})):this.i.delete(o),y}};e.$av=p,e.$av=p=He([Be(0,L.$8i),Be(1,T.$hi)],p)}),define(De[256],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=void 0,e.$Fk=(0,D.$Nh)("IUriIdentityService")}),define(De[257],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$bv=void 0,e.$bv=(0,D.$Nh)("editSessionIdentityService");var T;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(De[258],Ce([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=void 0;function T(E){return E.scheme!==D.Schemas.file&&E.scheme!==D.Schemas.vscodeRemote}e.$FJ=T;function g(E){if(E.folders.length)return E.folders.every(w=>T(w.uri))?E.folders[0].uri:void 0;if(E.configuration&&T(E.configuration))return E.configuration}e.$GJ=g;function L(E){return g(E)?.scheme}e.$HJ=L;function R(E){return g(E)?.authority}e.$IJ=R;function b(E){return g(E)!==void 0}e.$JJ=b}),define(De[43],Ce([1,0,201,16,77,24,2,5,17]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,b.$Nh)("contextService");function w(i){const c=i;return typeof c?.id=="string"&&R.URI.isUri(c.uri)}e.$Xh=w;function A(i){return typeof i?.id=="string"&&!w(i)&&!v(i)}e.$Yh=A,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function I(i,c){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,T.$mc)(i)}:c?e.$Zh:e.$1h;const h=i;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$2h=I;function v(i){const c=i;return typeof c?.id=="string"&&R.URI.isUri(c.configPath)}e.$3h=v;function k(i){const c=i;if(c?.uri)return{id:c.id,uri:R.URI.revive(c.uri)};const h=i;if(h?.configPath)return{id:h.id,configPath:R.URI.revive(h.configPath)};if(i?.id)return{id:i.id}}e.$4h=k;var S;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function p(i){const c=i;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.$5h=p;function u(i){const c=i;return!!(c&&typeof c=="object"&&R.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.$6h=u;class r{constructor(c,h,y,C,$){this.h=c,this.j=y,this.k=C,this.l=$,this.c=g.$Th.forUris(this.l,()=>!0),this.folders=h}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=g.$Th.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=r;class s{constructor(c,h){this.raw=h,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,L.$ug)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=s;function a(i){return new s({uri:i,index:0,name:(0,L.$qg)(i)},{uri:i.toString()})}e.$9h=a,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,D.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function m(i,c){return L.$lg.isEqualOrParent(i,c.untitledWorkspacesHome)}e.$bi=m;function l(i){let c;return R.URI.isUri(i)?c=i:c=i.configuration,c?.scheme===E.Schemas.tmp}e.$ci=l,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$di}e.$ei=t;function n(i,c){return!m(i,c)&&!l(i)}e.$fi=n;function o(i){return(typeof i=="string"?(0,T.$nc)(i):(0,L.$sg)(i))===e.$$h}e.$gi=o}),define(De[259],Ce([1,0,52,4,3,24,2,200,131,30,5,13,43,28,256,11,31,15,18]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.ProfileResourceType=void 0;var a;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(a||(e.ProfileResourceType=a={}));function m(i){const c=i;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&R.URI.isUri(c.location)&&R.URI.isUri(c.globalStorageHome)&&R.URI.isUri(c.settingsResource)&&R.URI.isUri(c.keybindingsResource)&&R.URI.isUri(c.tasksResource)&&R.URI.isUri(c.snippetsHome)&&R.URI.isUri(c.extensionsResource))}e.$Gk=m,e.$Hk=(0,A.$Nh)("IUserDataProfilesService");function l(i,c){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:R.URI.revive(i.location).with({scheme:c}),globalStorageHome:R.URI.revive(i.globalStorageHome).with({scheme:c}),settingsResource:R.URI.revive(i.settingsResource).with({scheme:c}),keybindingsResource:R.URI.revive(i.keybindingsResource).with({scheme:c}),tasksResource:R.URI.revive(i.tasksResource).with({scheme:c}),snippetsHome:R.URI.revive(i.snippetsHome).with({scheme:c}),extensionsResource:R.URI.revive(i.extensionsResource).with({scheme:c}),cacheHome:R.URI.revive(i.cacheHome).with({scheme:c}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Ik=l;function t(i,c,h,y,C,$){return{id:i,name:c,location:h,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:$&&C?.useDefaultFlags?.globalState?$.globalStorageHome:(0,L.$ug)(h,"globalStorage"),settingsResource:$&&C?.useDefaultFlags?.settings?$.settingsResource:(0,L.$ug)(h,"settings.json"),keybindingsResource:$&&C?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,L.$ug)(h,"keybindings.json"),tasksResource:$&&C?.useDefaultFlags?.tasks?$.tasksResource:(0,L.$ug)(h,"tasks.json"),snippetsHome:$&&C?.useDefaultFlags?.snippets?$.snippetsHome:(0,L.$ug)(h,"snippets"),extensionsResource:$&&C?.useDefaultFlags?.extensions?$.extensionsResource:(0,L.$ug)(h,"extensions.json"),cacheHome:(0,L.$ug)(y,i),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.$Jk=t;let n=class extends g.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,h,y,C){super(),this.t=c,this.u=h,this.w=y,this.y=C,this.f=!0,this.h=this.B(new T.$Md),this.onDidChangeProfiles=this.h.event,this.j=this.B(new T.$Md),this.onWillCreateProfile=this.j.event,this.m=this.B(new T.$Md),this.onWillRemoveProfile=this.m.event,this.n=this.B(new T.$Md),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new k.$zc,emptyWindows:new Map},this.profilesHome=(0,L.$ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),h=[c];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,s.$xf)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}h.push(t((0,L.$rg)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},c))}}catch($){this.y.error($)}const y=new k.$zc,C=new Map;if(h.length)try{const $=this.Q();if($.workspaces)for(const[f,d]of Object.entries($.workspaces)){const P=R.URI.parse(f),N=h.find(O=>O.id===d);N&&y.set(P,N)}if($.emptyWindows)for(const[f,d]of Object.entries($.emptyWindows)){const P=h.find(N=>N.id===d);P&&C.set(f,P)}}catch($){this.y.error($)}this.z={profiles:h,workspaces:y,emptyWindows:C}}return this.z}D(){const c=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const h="Temp",y=new RegExp(`${(0,r.$Ee)(h)}\\s(\\d+)`);let C=0;for(const f of this.profiles){const d=y.exec(f.name),P=d?parseInt(d[1]):0;C=P>C?P:C}const $=`${h} ${C+1}`;return this.createProfile((0,D.$Bi)((0,u.$dg)()).toString(16),$,{transient:!0},c)}async createNamedProfile(c,h,y){return this.createProfile((0,D.$Bi)((0,u.$dg)()).toString(16),c,h,y)}async createProfile(c,h,y,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(c,h,y);return C&&await this.setProfileForWorkspace(C,$),$}async F(c,h,y){if(!(0,s.$xf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.r.get(h);return C||(C=(async()=>{try{const $=this.profiles.find(P=>P.name===h||P.id===c);if($)return $;const f=t(c,h,(0,L.$ug)(this.profilesHome,c),this.g,y,this.defaultProfile);await this.u.createFolder(f.location);const d=[];return this.j.fire({profile:f,join(P){d.push(P)}}),await p.Promises.settled(d),this.I([f],[],[]),f}finally{this.r.delete(h)}})(),this.r.set(h,C)),C}async updateProfile(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let y=this.profiles.find(C=>C.id===c.id);if(!y)throw new Error(`Profile '${c.name}' does not exist`);return y=t(y.id,h.name??y.name,y.location,this.g,{shortName:h.shortName??y.shortName,icon:h.icon===null?void 0:h.icon??y.icon,transient:h.transient??y.isTransient,useDefaultFlags:h.useDefaultFlags??y.useDefaultFlags},this.defaultProfile),this.I([],[],[y]),y}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(C=>C.id===c.id);if(!h)throw new Error(`Profile '${c.name}' does not exist`);const y=[];this.m.fire({profile:h,join(C){y.push(C)}});try{await Promise.allSettled(y)}catch(C){this.y.error(C)}for(const C of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(C)?.id&&this.C.emptyWindows.delete(C);for(const C of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(C)?.id&&this.C.workspaces.delete(C);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(C){(0,w.$mk)(C)!==1&&this.y.error(C)}}async setProfileForWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=this.profiles.find(C=>C.id===h.id);if(!y)throw new Error(`Profile '${h.name}' does not exist`);this.L(c,y)}unsetWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(h=>h.isDirectory&&this.profiles.every(y=>!this.w.extUri.isEqual(y.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(c.map(h=>this.removeProfile(h)))}getProfileForWorkspace(c){const h=this.G(c);return R.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(c){return(0,v.$Xh)(c)?c.uri:(0,v.$3h)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location)))}I(c,h,y){const C=[...this.profiles,...c],$=[];this.s.profiles=[];for(let f of C)f.isDefault||h.some(d=>f.id===d.id)||(f=y.find(d=>f.id===d.id)??f,f.isTransient?this.s.profiles.push(f):$.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P($),this.z=void 0,this.J(c,h,y)}J(c,h,y){this.h.fire({added:c,removed:h,updated:y,all:this.profiles})}L(c,h,y){y=h?.isTransient?!0:y,y||this.L(c,void 0,!0);const C=this.G(c),$=y?this.s:this.C;R.URI.isUri(C)?($.workspaces.delete(C),h&&$.workspaces.set(C,h)):($.emptyWindows.delete(C),h&&$.emptyWindows.set(C,h)),y||this.M()}M(){const c={};for(const[y,C]of this.C.workspaces.entries())c[y.toString()]=C.id;const h={};for(const[y,C]of this.C.emptyWindows.entries())h[y.toString()]=C.id;this.R({workspaces:c,emptyWindows:h}),this.z=void 0}N(c){const h={},y=this.D();if(c.workspaces)for(const[$,f]of Object.entries(c.workspaces)){const d=R.URI.parse(f);h[$]=this.w.extUri.isEqual(d,y.location)?y.id:this.w.extUri.basename(d)}const C={};if(c.emptyWindows)for(const[$,f]of Object.entries(c.emptyWindows)){const d=R.URI.parse(f);C[$]=this.w.extUri.isEqual(d,y.location)?y.id:this.w.extUri.basename(d)}return{workspaces:h,emptyWindows:C}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Kk=n,e.$Kk=n=He([Be(0,E.$Uh),Be(1,w.$9j),Be(2,S.$Fk),Be(3,I.$8i)],n);class o extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Lk=o}),define(De[260],Ce([1,0,11,4,3,54,18,184,5,259]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Yo=e.$Xo=e.$Wo=void 0,e.$Wo="__$__isNewStorageMarker",e.$Xo="__$__targetStorageMarker",e.$Yo=(0,E.$Nh)("storageService");var A;(function(s){s[s.NONE=0]="NONE",s[s.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var I;(function(s){s[s.APPLICATION=-1]="APPLICATION",s[s.PROFILE=0]="PROFILE",s[s.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var v;(function(s){s[s.USER=0]="USER",s[s.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function k(s){const a=s.get(e.$Xo);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}e.$Zo=k;class S extends g.$Rc{static{this.a=60*1e3}constructor(a={flushInterval:S.a}){super(),this.m=a,this.b=this.B(new T.$Pd),this.c=this.B(new T.$Pd),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$Md),this.onWillSaveState=this.f.event,this.h=this.B(new D.$5g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(a,m,l){return T.Event.filter(this.b.event,t=>t.scope===a&&(m===void 0||t.key===m),l)}n(){this.j.value=(0,D.$9g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(a,m){const{key:l,external:t}=m;if(l===e.$Xo){switch(a){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:a})}else this.b.fire({scope:a,key:l,target:this.J(a)[l],external:t})}w(a){this.f.fire({reason:a})}get(a,m,l){return this.P(m)?.get(a,l)}getBoolean(a,m,l){return this.P(m)?.getBoolean(a,l)}getNumber(a,m,l){return this.P(m)?.getNumber(a,l)}getObject(a,m,l){return this.P(m)?.getObject(a,l)}storeAll(a,m){this.y(()=>{for(const l of a)this.store(l.key,l.value,l.scope,l.target,m)})}store(a,m,l,t,n=!1){if((0,R.$Gf)(m)){this.remove(a,l,n);return}this.y(()=>{this.z(a,l,t),this.P(l)?.set(a,m,n)})}remove(a,m,l=!1){this.y(()=>{this.z(a,m,void 0),this.P(m)?.delete(a,l)})}y(a){this.b.pause(),this.c.pause();try{a()}finally{this.b.resume(),this.c.resume()}}keys(a,m){const l=[],t=this.J(a);for(const n of Object.keys(t))t[n]===m&&l.push(n);return l}z(a,m,l,t=!1){const n=this.J(m);typeof l=="number"?n[a]!==l&&(n[a]=l,this.P(m)?.set(e.$Xo,JSON.stringify(n),t)):typeof n[a]=="number"&&(delete n[a],this.P(m)?.set(e.$Xo,JSON.stringify(n),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(a){switch(a){case-1:return this.I;case 0:return this.G;default:return this.D}}L(a){const m=this.P(a);return m?k(m):Object.create(null)}isNew(a){return this.getBoolean(e.$Wo,a)===!0}async flush(a=A.NONE){this.f.fire({reason:a});const m=this.P(-1),l=this.P(0),t=this.P(1);switch(a){case A.NONE:await D.Promises.settled([m?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await D.Promises.settled([m?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const a=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,l=this.P(1)?.items??new Map;return r(a,m,l,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(a){return await this.flush(),this.P(a)?.optimize()}async switch(a,m){return this.w(A.NONE),(0,w.$Gk)(a)?this.R(a,m):this.S(a,m)}M(a,m){return!(a.id===m.id||p(m)&&p(a))}N(a,m,l){this.y(()=>{const t=new Set;for(const[n,o]of a)t.add(n),m.get(n)!==o&&this.u(l,{key:n,external:!0});for(const[n]of m.items)t.has(n)||this.u(l,{key:n,external:!0})})}}e.$1o=S;function p(s){return s.isDefault||!!s.useDefaultFlags?.globalState}e.$2o=p;class u extends S{constructor(){super(),this.U=this.B(new b.$Uo(new b.$Vo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Uo(new b.$Vo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Uo(new b.$Vo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(a=>this.u(1,a))),this.B(this.W.onDidChangeStorage(a=>this.u(0,a))),this.B(this.U.onDidChangeStorage(a=>this.u(-1,a)))}P(a){switch(a){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(a){switch(a){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(a){return!1}}e.$3o=u;async function r(s,a,m,l,t,n){const o=P=>{try{return JSON.parse(P)}catch{return P}},i=new Map,c=new Map;s.forEach((P,N)=>{i.set(N,P),c.set(N,o(P))});const h=new Map,y=new Map;a.forEach((P,N)=>{h.set(N,P),y.set(N,o(P))});const C=new Map,$=new Map;m.forEach((P,N)=>{C.set(N,P),$.set(N,o(P))}),console.group(l!==t?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const f=[];if(i.forEach((P,N)=>{f.push({key:N,value:P})}),console.table(f),console.groupEnd(),console.log(c),l!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];h.forEach((N,O)=>{P.push({key:O,value:N})}),console.table(P),console.groupEnd(),console.log(y)}console.group(`Storage: Workspace (path: ${n})`);const d=[];C.forEach((P,N)=>{d.push({key:N,value:P})}),console.table(d),console.groupEnd(),console.log($)}e.$4o=r}),define(De[87],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const L=this.c++;return this.b.set(L,g),this.e(),L}get(g,L){return this.b.has(g)?this.b.get(g)[L]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Abc=D}),define(De[55],Ce([1,0,17,24,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=e.$Cbc=void 0;class L{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new T.$jg(b=>{const E=this.b.get(b.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(b,E){E===null?this.b.delete(b.scheme):this.b.set(b.scheme,E)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Cbc=L,e.$Dbc=(0,g.$Nh)("IExtHostFileSystemInfo")}),define(De[26],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=void 0,e.$nM=(0,D.$Nh)("IExtHostInitDataService")}),define(De[261],Ce([1,0,206,13,241,26]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;let R=class extends g.$uN{constructor(E,w,A){const I=A.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",v=A.remote.isRemote?(0,D.localize)(0,null):E?(0,D.localize)(1,null):(0,D.localize)(2,null);super(w.createLogger(I,{name:v}))}};e.$Jdc=R,e.$Jdc=R=He([Be(1,T.$9i),Be(2,L.$nM)],R)}),define(De[262],Ce([1,0,11]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=e.$6bc=void 0;class T{constructor(R,b,E){this.h=new Map,this.a=R,this.b=b,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new D.$5g(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of w.values())A.complete()}catch(A){for(const I of w.values())I.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,b){let E=this.f[R];return typeof E>"u"&&(E=b),E}update(R,b){this.f[R]=b;const E=this.h.get(R);if(E!==void 0)return E.p;const w=new D.$bh;return this.h.set(R,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$6bc=T;class g extends T{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,b){super(R.identifier.value,!0,b),this.j=R}}e.$7bc=g}),define(De[263],Ce([1,0,4,2]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;class g{constructor(R){this.c=R,this.a=new D.$Md,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Md,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,b,E,w){const I=this.c.getNotebookDocument(T.URI.revive(R)).acceptModelChanged(b.value,E,w);this.b.fire(I)}$acceptDirtyStateChanged(R,b){this.c.getNotebookDocument(T.URI.revive(R)).acceptDirty(b)}$acceptModelSaved(R){const b=this.c.getNotebookDocument(T.URI.revive(R));this.a.fire(b.apiNotebook)}}e.$sdc=g}),define(De[20],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=void 0,e.$0L=(0,D.$Nh)("IExtHostRpcService");class T{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$$L=T}),define(De[264],Ce([1,0,25,4]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;class g{#e;constructor(R,b){this.b=new T.$Md,this.onDidChange=this.b.event,this.a=D.$Yl.toKey(R.identifier),this.#e=b,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(R){return this.#e.get(this.a,R)}store(R,b){return this.#e.store(this.a,R,b)}delete(R){return this.#e.delete(this.a,R)}}e.$fcc=g}),define(De[66],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=void 0,e.$Nbc=(0,D.$Nh)("IURITransformerService");class T{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Obc=T}),define(De[265],Ce([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncb=e.$mcb=void 0;class T{constructor(){this.buffers=[]}add(E){let w=this.buffers.indexOf(E);return w<0&&(w=this.buffers.length,this.buffers.push(E)),w}}function g(b,E){if(E.serializeBuffersForPostMessage){const w=new T,I=JSON.stringify(b,(k,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(S)};if(ArrayBuffer.isView(S)){const p=L(S);if(p)return{$$vscode_array_buffer_reference$$:!0,index:w.add(S.buffer),view:{type:p,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),v=w.buffers.map(k=>{const S=new Uint8Array(k);return D.$ae.wrap(S)});return{message:I,buffers:v}}else return{message:JSON.stringify(b),buffers:[]}}e.$mcb=g;function L(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(b,E){const w=E.map(v=>{const k=new ArrayBuffer(v.byteLength);return new Uint8Array(k).set(v.buffer),k}),A=E.length?(v,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const S=k,{index:p}=S,u=w[p];if(S.view)switch(S.view.type){case 1:return new Int8Array(u,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return k}:void 0;return{message:JSON.parse(b,A),arrayBuffers:w}}e.$ncb=R}),define(De[266],Ce([1,0,267,373,374,60,2,13,375]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0;const w=!1;function A(a,m,l,t,n,o){const i=o.environment.useHostProxy,c=typeof i=="boolean"?i:!o.remote.isRemote,h={resolveProxy:$=>a.resolveProxy($),lookupProxyAuthorization:u.bind(void 0,t,n,m,{},o.remote.isRemote),getProxyURL:()=>m.getConfiguration("http").get("proxy"),getProxySupport:()=>m.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>v(m),getSystemCertificatesV2:()=>k(m),log:($,f,...d)=>{switch($){case E.LogLevel.Trace:t.trace(f,...d);break;case E.LogLevel.Debug:t.debug(f,...d);break;case E.LogLevel.Info:t.info(f,...d);break;case E.LogLevel.Warning:t.warn(f,...d);break;case E.LogLevel.Error:t.error(f,...d);break;case E.LogLevel.Critical:t.error(f,...d);break;case E.LogLevel.Off:break;default:P($,f,d);break}function P(N,O,...M){t.error("Unknown log level",N),t.error(O,...M)}},getLogLevel:()=>{const $=t.getLevel();switch($){case b.LogLevel.Trace:return E.LogLevel.Trace;case b.LogLevel.Debug:return E.LogLevel.Debug;case b.LogLevel.Info:return E.LogLevel.Info;case b.LogLevel.Warning:return E.LogLevel.Warning;case b.LogLevel.Error:return E.LogLevel.Error;case b.LogLevel.Off:return E.LogLevel.Off;default:return f($)}function f(d){return t.error("Unknown log level",d),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,addCertificates:[],env:process.env},y=(0,E.createProxyResolver)(h),C=I(h,y);return p(l,C)}e.$fec=A;function I(a,m){return{http:Object.assign(D,(0,E.createHttpPatch)(a,D,m)),https:Object.assign(T,(0,E.createHttpPatch)(a,T,m)),net:Object.assign(L,(0,E.createNetPatch)(a,L)),tls:Object.assign(g,(0,E.createTlsPatch)(a,g))}}function v(a){const m=a.getConfiguration("http");return!m.get("experimental.systemCertificatesV2",w)&&!!m.get("systemCertificates")}function k(a){const m=a.getConfiguration("http");return!!m.get("experimental.systemCertificatesV2",w)&&!!m.get("systemCertificates")}const S=new Map;function p(a,m){return a.getExtensionPathIndex().then(l=>{const t=globalThis._VSCODE_NODE_MODULES.module,n=t._load;t._load=function(i,c,h){if(i==="net")return m.net;if(i==="tls")return m.tls;if(i!=="http"&&i!=="https")return n.apply(this,arguments);const y=l.findSubstr(R.URI.file(c.filename));let C=S.get(y);if(C||S.set(y,C={}),!C[i]){const $=m[i];C[i]={...$}}return C[i]}})}async function u(a,m,l,t,n,o,i,c){const h=t[o];i&&(t[o]=i),a.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${o}`,`proxyAuthenticate:${i}`,`proxyAuthenticateCache:${h}`);const y=i||h,C=Array.isArray(y)?y:typeof y=="string"?[y]:[];if(s(m,C,n),C.some($=>/^(Negotiate|Kerberos)( |$)/i.test($))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const $=await new Promise((O,M)=>{$e(["kerberos"],O,M)}),f=new URL(o),d=l.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${f.hostname}`:`HTTP@${f.hostname}`);return a.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${o}`,`spn:${d}`),"Negotiate "+await(await $.initializeClient(d)).step("")}catch($){a.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",$)}}let r=!1;function s(a,m,l){r||!m.length||(r=!0,a.$publicLog2("proxyAuthenticationRequest",{authenticationType:m.map(t=>t.split(" ")[0]).join(","),extensionHostType:l?"remote":"local"}))}}),define(De[268],Ce([1,0,128]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=void 0;function T(L){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:L,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function g(L){return new D.$Em(T(L))}e.$tr=g}),define(De[139],Ce([1,0,216,18,2,3,5,42,30,17,46,176,38]),function($e,e,D,T,g,L,R,b,E,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_D=e.$$D=e.$0D=e.EditorsOrder=e.$9D=e.CloseDirection=e.$8D=e.$7D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$6D=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.EditorInputCapabilities=e.$XD=e.SaveReason=e.Verbosity=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=e.$QD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$PD=e.$OD=e.$ND=e.$MD=e.$LD=void 0,e.$LD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$MD={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$ND="workbench.editor.sidebysideEditor",e.$OD="workbench.editors.textDiffEditor",e.$PD="workbench.editors.binaryResourceDiffEditor";var k;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var S;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function p(ue){const pe=ue;return!!pe&&typeof pe.getSelection=="function"&&!!pe.onDidChangeSelection}e.$QD=p;function u(ue,pe,G){for(const z of G.visibleEditorPanes)if(z.group.id===pe&&ue.matches(z.input))return z.getViewState()}e.$RD=u;function r(ue){if(h(ue))return!1;const pe=ue;return g.URI.isUri(pe?.resource)}e.$SD=r;function s(ue){if(h(ue))return!1;const pe=ue;return pe?.original!==void 0&&pe.modified!==void 0}e.$TD=s;function a(ue){if(h(ue)||s(ue))return!1;const pe=ue;return pe?.primary!==void 0&&pe.secondary!==void 0}e.$UD=a;function m(ue){if(h(ue))return!1;const pe=ue;return pe?pe.resource===void 0||pe.resource.scheme===w.Schemas.untitled||pe.forceUntitled===!0:!1}e.$VD=m;function l(ue){if(h(ue))return!1;const pe=ue;return g.URI.isUri(pe?.base?.resource)&&g.URI.isUri(pe?.input1?.resource)&&g.URI.isUri(pe?.input2?.resource)&&g.URI.isUri(pe?.result?.resource)}e.$WD=l;var t;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var n;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class o{constructor(){this.a=new Map}registerSource(pe,G){let z=this.a.get(pe);return z||(z={source:pe,label:G},this.a.set(pe,z)),z.source}getSourceLabel(pe){return this.a.get(pe)?.label??pe}}e.$XD=new o;var i;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors",ue[ue.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class c extends L.$Rc{}e.$YD=c;function h(ue){return ue instanceof c}e.$ZD=h;function y(ue){const pe=ue;return g.URI.isUri(pe?.preferredResource)}function C(ue){const pe=ue;return h(pe?.primary)&&h(pe?.secondary)}e.$1D=C;function $(ue){const pe=ue;return h(pe?.modified)&&h(pe?.original)}e.$2D=$;function f(ue,pe,G,z,K){return me(z,[(0,I.$xi)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const ge={...G,limits:{size:Number.MAX_VALUE}};ue.openEditor(pe,ge)}}),(0,I.$xi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>K.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.$3D=f;function d(ue){return h(ue?.editor)}e.$4D=d;function P(ue){const pe=ue;return d(ue)&&pe?.group!==void 0}e.$5D=P;function N(ue){const pe=ue;return typeof pe?.groupId=="number"&&h(pe.editor)}e.$6D=N;var O;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(O||(e.EditorCloseContext=O={}));var M;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LOCKED=2]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=3]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=4]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=5]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=7]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=9]="EDITOR_PIN",ue[ue.EDITOR_STICKY=10]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=11]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var j;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class U{getOriginalUri(pe,G){if(!pe)return;if(l(pe))return e.$8D.getOriginalUri(pe.result,G);if(G?.supportSideBySide){const{primary:K,secondary:ge}=this.a(pe);if(K&&ge){if(G?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:G.filterByScheme}),secondary:this.getOriginalUri(ge,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getOriginalUri(K,{filterByScheme:G.filterByScheme})??this.getOriginalUri(ge,{filterByScheme:G.filterByScheme});pe=G.supportSideBySide===j.PRIMARY?K:ge}}if(s(pe)||a(pe)||l(pe))return;const z=y(pe)?pe.preferredResource:pe.resource;return!z||!G||!G.filterByScheme?z:this.b(z,G.filterByScheme)}a(pe){return C(pe)||a(pe)?{primary:pe.primary,secondary:pe.secondary}:$(pe)||s(pe)?{primary:pe.modified,secondary:pe.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(pe,G){if(!pe)return;if(l(pe))return e.$8D.getCanonicalUri(pe.result,G);if(G?.supportSideBySide){const{primary:K,secondary:ge}=this.a(pe);if(K&&ge){if(G?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:G.filterByScheme}),secondary:this.getCanonicalUri(ge,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getCanonicalUri(K,{filterByScheme:G.filterByScheme})??this.getCanonicalUri(ge,{filterByScheme:G.filterByScheme});pe=G.supportSideBySide===j.PRIMARY?K:ge}}if(s(pe)||a(pe)||l(pe))return;const z=pe.resource;return!z||!G||!G.filterByScheme?z:this.b(z,G.filterByScheme)}b(pe,G){if(Array.isArray(G)){if(G.some(z=>pe.scheme===z))return pe}else if(G===pe.scheme)return pe}}var F;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.KEYBOARD=1]="KEYBOARD",ue[ue.MOUSE=2]="MOUSE"})(F||(e.EditorCloseMethod=F={}));function V(ue,pe,G,z){if(!ue.isSticky(pe))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return G===F.MOUSE||G===F.KEYBOARD;case"mouse":return G===F.MOUSE;case"keyboard":return G===F.KEYBOARD}return!1}e.$7D=V,e.$8D=new U;var H;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(H||(e.CloseDirection=H={}));class fe{constructor(){this.c=new Map,this.d=new Map}start(pe){const G=this.a=pe.get(R.$Mh);for(const[z,K]of this.c)this.e(z,K,G);this.c.clear()}e(pe,G,z){const K=z.createInstance(G);this.d.set(pe,K)}registerFileEditorFactory(pe){if(this.b)throw new Error("Can only register one file editor factory.");this.b=pe}getFileEditorFactory(){return(0,T.$If)(this.b)}registerEditorSerializer(pe,G){if(this.c.has(pe)||this.d.has(pe))throw new Error(`A editor serializer with type ID '${pe}' was already registered.`);return this.a?this.e(pe,G,this.a):this.c.set(pe,G),(0,L.$Pc)(()=>{this.c.delete(pe),this.d.delete(pe)})}getEditorSerializer(pe){return this.d.get(typeof pe=="string"?pe:pe.typeId)}}b.$$m.add(e.$LD.EditorFactory,new fe);async function X(ue,pe,G){return!ue||!ue.length?[]:await Promise.all(ue.map(async z=>{const K=g.URI.revive(z.fileUri);if(!K){G.info("Cannot resolve the path because it is not valid.",z);return}if(!await pe.canHandleResource(K)){G.info("Cannot resolve the path because it cannot be handled",z);return}let _=z.exists,ie=z.type;if(typeof _!="boolean"||typeof ie!="number")try{ie=(await pe.stat(K)).isDirectory?E.FileType.Directory:E.FileType.Unknown,_=!0}catch(Ee){G.error(Ee),_=!1}if(!_&&z.openOnlyIfExists){G.info("Cannot resolve the path because it does not exist",z);return}if(ie===E.FileType.Directory){G.info("Cannot resolve the path because it is a directory",z);return}const ne={...z.options,pinned:!0};return _?{resource:K,options:ne}:{resource:K,options:ne,forceUntitled:!0}}))}e.$9D=X;var Y;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(Y||(e.EditorsOrder=Y={}));function q(ue){const pe=ue;if(!pe)return!1;const G=pe;if(G.modified)return q(G.modified);const z=pe;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$0D=q;function x(ue){return(0,A.$zi)(ue)}e.$$D=x;function me(ue,pe,G){const z=(0,A.$Ai)(ue,pe);return z.forceMessage=G?.forceMessage,z.forceSeverity=G?.forceSeverity,z.allowDialog=G?.allowDialog,z}e.$_D=me}),define(De[269],Ce([1,0,4,217,5,3,28,42,19,23,78,255]),function($e,e,D,T,g,L,R,b,E,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iE=e.$hE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$gE=e.$fE=e.ViewContentGroups=e.$eE=e.$dE=e.ViewContainerLocation=e.Extensions=e.$cE=void 0,e.$cE=(0,I.$Yv)("default-view-icon",A.$Sj.window,(0,T.localize)(0,null));var v;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var k;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(k||(e.ViewContainerLocation=k={})),e.$dE=[0,1,2];function S(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$eE=S;class p extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new D.$Md),this.onDidRegister=this.c.event,this.f=this.B(new D.$Md),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Qb)([...this.g.values()])}registerViewContainer(o,i,c){const h=this.get(o.id);if(h)return h;const y=o;return y.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,R.$wc)(this.g,i,[]).push(y),c?.isDefault&&this.h.push(y),this.c.fire({viewContainer:y,viewContainerLocation:i}),y}deregisterViewContainer(o){for(const i of this.g.keys()){const c=this.g.get(i),h=c?.indexOf(o);if(h!==-1){c?.splice(h,1),c.length===0&&this.g.delete(i),this.f.fire({viewContainer:o,viewContainerLocation:i});return}}}get(o){return this.all.filter(i=>i.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(i=>this.getViewContainers(i).filter(c=>c?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(i=>this.getViewContainerLocation(i)===o)}}b.$$m.add(v.ViewContainersRegistry,new p);var u;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(u||(e.ViewContentGroups=u={}));function r(n,o){const i=n.group??u.More,c=o.group??u.More;return i!==c?i.localeCompare(c):(n.order??5)-(o.order??5)}class s extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new D.$Md),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Md),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Md),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Md),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(o,i){this.registerViews2([{views:o,viewContainer:i}])}registerViews2(o){o.forEach(({views:i,viewContainer:c})=>this.r(i,c)),this.c.fire(o)}deregisterViews(o,i){const c=this.s(o,i);c.length&&this.f.fire({views:c,viewContainer:i})}moveViews(o,i){for(const c of this.m.keys())if(c!==i){const h=this.s(o,c);h.length&&(this.r(h,i),this.g.fire({views:h,from:c,to:i}))}}getViews(o){return this.m.get(o)||[]}getView(o){for(const i of this.j){const c=(this.m.get(i)||[]).filter(h=>h.id===o)[0];if(c)return c}return null}getViewContainer(o){for(const i of this.j)if((this.m.get(i)||[]).filter(h=>h.id===o)[0])return i;return null}registerViewWelcomeContent(o,i){return this.n.add(o,i),this.h.fire(o),(0,L.$Pc)(()=>{this.n.delete(o,i),this.h.fire(o)})}registerViewWelcomeContent2(o,i){const c=new Map;for(const[h,y]of i)this.n.add(o,y),c.set(h,(0,L.$Pc)(()=>{this.n.delete(o,y),this.h.fire(o)}));return this.h.fire(o),c}getViewWelcomeContent(o){const i=[];return this.n.forEach(o,c=>i.push(c)),i.sort(r)}r(o,i){let c=this.m.get(i);c||(c=[],this.m.set(i,c),this.j.push(i));for(const h of o){if(this.getView(h.id)!==null)throw new Error((0,T.localize)(1,null,h.id));c.push(h)}}s(o,i){const c=this.m.get(i);if(!c)return[];const h=[],y=[];for(const C of c)o.includes(C)?h.push(C):y.push(C);return h.length&&(y.length?this.m.set(i,y):(this.m.delete(i),this.j.splice(this.j.indexOf(i),1))),h}}b.$$m.add(v.ViewsRegistry,new s),e.$fE=(0,g.$Nh)("viewsService"),e.$gE=(0,g.$Nh)("viewDescriptorService");var a;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(a||(e.ViewVisibilityState=a={}));var m;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(m||(e.TreeItemCollapsibleState=m={}));class l{constructor(o,i){this.c=!1,this.d=!1,(0,w.$2m)(this,o),this.d=!!i,this.resolve=async c=>{if(i&&!this.c){const h=await i(c);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$hE=l;class t extends Error{constructor(o){super((0,T.localize)(2,null,o)),this.name="NoTreeViewError"}static is(o){return o.name==="NoTreeViewError"}}e.$iE=t}),define(De[140],Ce([1,0,4,11,218]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new D.$Md,this.n=new D.$Md,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,E,w,A){const I={command:b};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.s("request",I),typeof A=="number"){const v=setTimeout(()=>{clearTimeout(v);const k=this.f.get(I.seq);if(k){this.f.delete(I.seq);const S={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,g.localize)(0,null,A,b)};k(S)}},A)}return w&&this.f.set(I.seq,w),I.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,E){return b.type!=="event"||E.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,T.$Tg)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const E=b,w=this.f.get(E.request_seq);w&&(this.f.delete(E.request_seq),w(E));break}}}}s(b,E){E.type=b,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((E,w)=>b.set(w,E)),await(0,T.$Tg)(500),b.forEach((E,w)=>{E({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Scb=L}),define(De[270],Ce([1,0,219,41,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$YG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$XG=e.MemoryRangeType=e.$WG=e.State=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=void 0,e.$UF="workbench.view.debug",e.$VF="workbench.debug.variablesView",e.$WF="workbench.debug.watchExpressionsView",e.$XF="workbench.debug.callStackView",e.$YF="workbench.debug.loadedScriptsView",e.$ZF="workbench.debug.breakPointsView",e.$1F="workbench.debug.disassemblyView",e.$2F="workbench.panel.repl",e.$3F="workbench.panel.repl.view",e.$4F=new T.$5i("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$5F=new T.$5i("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$6F=new T.$5i("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$7F="debugUx",e.$8F=new T.$5i(e.$7F,"default",{type:"string",description:D.localize(3,null)}),e.$9F=new T.$5i("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$0F=new T.$5i("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$$F=new T.$5i("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$_F=new T.$5i("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$aG=new T.$5i("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$bG=new T.$5i("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$cG=new T.$5i("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$dG=new T.$5i("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$eG=new T.$5i("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$fG=new T.$5i("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$gG=new T.$5i("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$hG=new T.$5i("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$iG=new T.$5i("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$jG=new T.$5i("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$kG=new T.$5i("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$lG=new T.$5i("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$mG=new T.$5i("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$nG=new T.$5i("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$oG=new T.$5i("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$pG=new T.$5i("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$qG=new T.$5i("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$rG=new T.$5i("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$sG=new T.$5i("stepBackSupported",!1,{type:"boolean",description:D.localize(26,null)}),e.$tG=new T.$5i("restartFrameSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$uG=new T.$5i("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(28,null)}),e.$vG=new T.$5i("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(29,null)}),e.$wG=new T.$5i("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$xG=new T.$5i("breakpointsExist",!1,{type:"boolean",description:D.localize(31,null)}),e.$yG=new T.$5i("debuggersAvailable",!1,{type:"boolean",description:D.localize(32,null)}),e.$zG=new T.$5i("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(33,null)}),e.$AG=new T.$5i("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(34,null)}),e.$BG=new T.$5i("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(35,null)}),e.$CG=new T.$5i("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$DG=new T.$5i("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$EG=new T.$5i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$FG=new T.$5i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$GG=new T.$5i("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$HG=new T.$5i("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$IG=new T.$5i("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(42,null)}),e.$JG=new T.$5i("variableIsReadonly",!1,{type:"boolean",description:D.localize(43,null)}),e.$KG=new T.$5i("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(44,null)}),e.$LG=new T.$5i("multiSessionRepl",!1,{type:"boolean",description:D.localize(45,null)}),e.$MG=new T.$5i("multiSessionDebug",!1,{type:"boolean",description:D.localize(46,null)}),e.$NG=new T.$5i("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(47,null)}),e.$OG=new T.$5i("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(48,null)}),e.$PG=new T.$5i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(49,null)}),e.$QG=new T.$5i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(50,null)});const L=v=>D.localize(51,null,v);e.$RG=L,e.$SG="editor.contrib.debug",e.$TG="editor.contrib.breakpoint",e.$UG="debug",e.$VG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(52,null)};var R;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(R||(e.State=R={}));function b(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$WG=b;var E;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$XG="vscode-debug-memory";var w;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var A;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$YG=(0,g.$Nh)("debugService");var I;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(De[271],Ce([1,0,15,2,16,23,17,34,21,19]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=void 0;const A=/{([^}]+)}/g;function I(C,$,f){return C.replace(A,function(d,P){return $&&P.length>0&&P[0]!=="_"?d:f&&f.hasOwnProperty(P)?f[P]:d})}e.$jF=I;function v(C){const $={};for(const f of Object.keys(C))f.startsWith("!")||($[f]=C[f]);return $}e.$kF=v;function k(C){return C.configuration.request==="attach"&&!S(C)&&(!C.parentSession||k(C.parentSession))}e.$lF=k;function S(C){let $=C.configuration.type;if($)return $==="vslsShare"&&($=C.configuration.adapterProxy.configuration.type),(0,D.$1e)($,"extensionhost")||(0,D.$1e)($,"pwa-extensionhost")?C:C.parentSession?S(C.parentSession):void 0}e.$mF=S;function p(C){return C.type&&(C.label||C.program||C.runtime)}e.$nF=p;function u(C,$,f){let d,P=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=N.exec(C);){const M=O.index+1,j=M+O[0].length;if(M<=$&&j>=f){d=O[0],P=M;break}}if(d){const M=/\w+/g;let j=null;for(;(j=M.exec(d))&&!(j.index+1+P+j[0].length>=f););j&&(d=d.substring(0,M.lastIndex))}return d?{start:P,end:P+d.length-1}:{start:0,end:0}}e.$oF=u;async function r(C,$,f,d){if(C.evaluatableExpressionProvider.has($)){const P=C.evaluatableExpressionProvider.ordered($),N=(0,w.$Gb)(await Promise.all(P.map(async O=>{try{return await O.provideEvaluatableExpression($,f,d??E.CancellationToken.None)}catch{return}})));if(N.length>0){let O=N[0].expression;const M=N[0].range;return O||(O=$.getLineContent(f.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:O}}}else{const P=$.getLineContent(f.lineNumber),{start:N,end:O}=u(P,f.column,f.column),M=P.substring(N-1,O);return{matchingExpression:M,range:new b.$ns(f.lineNumber,N,f.lineNumber,N+M.length)}}return null}e.$pF=r;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(C){return!!(C&&C.match(s))}e.$qF=a;function m(C){if(typeof C.path=="string"&&!(typeof C.sourceReference=="number"&&C.sourceReference>0)){if(a(C.path))return T.URI.parse(C.path);if((0,g.$hc)(C.path))return T.URI.file(C.path)}return C.path}function l(C){if(typeof C.path=="object"){const $=T.URI.revive(C.path);if($)return $.scheme===R.Schemas.file?$.fsPath:$.toString()}return C.path}function t(C,$){const f=$?m:l,d=(0,L.$Ym)(C);return o(d,(P,N)=>{P&&N&&(N.path=f(N))}),d}e.$rF=t;function n(C,$){const f=$?m:l,d=(0,L.$Ym)(C);return o(d,(P,N)=>{!P&&N&&(N.path=f(N))}),d}e.$sF=n;function o(C,$){switch(C.type){case"event":{const f=C;switch(f.event){case"output":$(!1,f.body.source);break;case"loadedSource":$(!1,f.body.source);break;case"breakpoint":$(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=C;switch(f.command){case"setBreakpoints":$(!0,f.arguments.source);break;case"breakpointLocations":$(!0,f.arguments.source);break;case"source":$(!0,f.arguments.source);break;case"gotoTargets":$(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(d=>$(!1,d));break;default:break}break}case"response":{const f=C;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(d=>$(!1,d.source));break;case"loadedSources":f.body.sources.forEach(d=>$(!1,d));break;case"scopes":f.body.scopes.forEach(d=>$(!1,d.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(d=>$(!1,d.source));break;case"setBreakpoints":f.body.breakpoints.forEach(d=>$(!1,d.source));break;case"disassemble":f.body?.instructions.forEach(P=>$(!1,P.location));break;default:break}break}}}function i(C){return C.filter($=>!$.presentation?.hidden).sort(($,f)=>$.presentation?f.presentation?$.presentation.group?f.presentation.group?$.presentation.group!==f.presentation.group?$.presentation.group.localeCompare(f.presentation.group):c($.presentation.order,f.presentation.order):-1:f.presentation.group?1:c($.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.$tF=i;function c(C,$){return typeof C!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:C-$}async function h(C,$){const f=C.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(f!=="none"&&(await $.saveAll(),f==="allEditorsInActiveGroup")){const d=$.activeEditorPane;d&&d.input.resource?.scheme===R.Schemas.untitled&&await $.save({editor:d.input,groupId:d.group.id})}await C.reloadConfiguration()}e.$uF=h;const y=(C,$)=>!C||!$?C===$:C.name===$.name&&C.path===$.path&&C.sourceReference===$.sourceReference;e.$vF=y}),define(De[272],Ce([1,0,48,60,23,16,12,15,29,220,140]),function($e,e,D,T,g,L,R,b,E,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=e.$Sdc=e.$Rdc=e.$Qdc=e.$Pdc=void 0;class I extends A.$Scb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(r,s){this.p=s,this.r=Buffer.allocUnsafe(0),this.t=-1,r.on("data",a=>this.w(a))}sendMessage(r){if(this.p){const s=JSON.stringify(r);this.p.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${I.a}${s}`,"utf8")}}w(r){for(this.r=Buffer.concat([this.r,r]);;){if(this.t>=0){if(this.r.length>=this.t){const s=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(a){this.m.fire(new Error((a.message||a)+`
`+s))}continue}}else{const s=this.r.indexOf(I.a);if(s!==-1){const m=this.r.toString("utf8",0,s).split(I.b);for(const l of m){const t=l.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(s+I.a.length);continue}}break}}}e.$Pdc=I;class v extends I{startSession(){return new Promise((r,s)=>{let a=!1;this.x=this.y(()=>{this.v(this.x,this.x),r(),a=!0}),this.x.on("close",()=>{a?this.m.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.x.on("error",m=>{a?this.m.fire(m):s(m)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Qdc=v;class k extends v{constructor(r){super(),this.z=r}y(r){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",r)}}e.$Rdc=k;class S extends v{constructor(r){super(),this.z=r}y(r){return T.createConnection(this.z.path,r)}}e.$Sdc=S;class p extends I{constructor(r,s){super(),this.y=r,this.z=s}async startSession(){const r=this.y.command,s=this.y.args,a=this.y.options||{};try{if(r)if(L.$hc(r)){if(!await E.Promises.exists(r))throw new Error(w.localize(0,null,r))}else r.indexOf("/")<0&&r.indexOf("\\")<0;else throw new Error(w.localize(1,null,this.z));let m=process.env;if(a.env&&Object.keys(a.env).length>0&&(m=g.$2m(g.$Ym(process.env),a.env)),r==="node")if(Array.isArray(s)&&s.length>0){const l=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:m,execArgv:l?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(t.cwd=a.cwd);const n=D.fork(s[0],s.slice(1),t);if(!n.pid)throw new Error(w.localize(2,null,s[0]));this.x=n}else throw new Error(w.localize(3,null));else{const l={env:m};a.cwd&&(l.cwd=a.cwd),this.x=D.spawn(r,s,l)}this.x.on("error",l=>{this.m.fire(l)}),this.x.on("exit",(l,t)=>{this.n.fire(l)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",l=>{this.m.fire(l)}),this.x.stdin.on("error",l=>{this.m.fire(l)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(m){this.m.fire(m)}}async stopSession(){return this.x?(await this.u(),R.$j?new Promise((r,s)=>{const a=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(m,l,t){if(m)return s(m)});a.on("exit",r),a.on("error",s)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(r,s){if(!r)return;const a=Object.create(null);r.runtime&&(r.runtime.indexOf("./")===0?a.runtime=L.$ic(s,r.runtime):a.runtime=r.runtime),r.runtimeArgs&&(a.runtimeArgs=r.runtimeArgs),r.program&&(L.$hc(r.program)?a.program=r.program:a.program=L.$ic(s,r.program)),r.args&&(a.args=r.args);const m=r;return m.win&&(a.win=p.A(m.win,s)),m.winx86&&(a.winx86=p.A(m.winx86,s)),m.windows&&(a.windows=p.A(m.windows,s)),m.osx&&(a.osx=p.A(m.osx,s)),m.linux&&(a.linux=p.A(m.linux,s)),a}static platformAdapterExecutable(r,s){let a=Object.create(null);s=s.toLowerCase();for(const i of r)if(i.contributes){const c=i.contributes.debuggers;c&&c.length>0&&c.filter(h=>typeof h.type=="string"&&b.$1e(h.type,s)).forEach(h=>{const y=p.A(h,i.extensionLocation.fsPath);a=g.$2m(a,y,i.isBuiltin)})}let m;R.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=a.winx86||a.win||a.windows:R.$j?m=a.win||a.windows:R.$k?m=a.osx:R.$l&&(m=a.linux),m=m||a;const l=m.program||a.program,t=m.args||a.args,n=m.runtime||a.runtime,o=m.runtimeArgs||a.runtimeArgs;if(n)return{type:"executable",command:n,args:(o||[]).concat(typeof l=="string"?[l]:[]).concat(t||[])};if(l)return{type:"executable",command:l,args:t||[]}}}e.$Tdc=p}),define(De[273],Ce([1,0,48,32,12]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=e.$Udc=void 0;function L(w,A){return new Promise((I,v)=>{let k="";const S=D.spawn(w,A);S.pid&&S.stdout.on("data",p=>{k+=p.toString()}),S.on("error",p=>{v(p)}),S.on("close",p=>{I(k)})})}async function R(w){if(w)if(g.$j){const A=await new Promise((I,v)=>{$e(["@vscode/windows-process-tree"],I,v)});return new Promise(I=>{A.getProcessTree(w,v=>{I(!!v&&v.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(w)]).then(A=>{const I=A.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$Udc=R;var b;(function(w){w[w.cmd=0]="cmd",w[w.powershell=1]="powershell",w[w.bash=2]="bash"})(b||(b={}));function E(w,A,I,v,k){w=w.trim().toLowerCase();let S;w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0?S=1:w.indexOf("cmd.exe")>=0?S=0:w.indexOf("bash")>=0?S=2:g.$j?S=0:S=2;let p,u=" ";switch(S){case 1:if(p=r=>(r=r.replace(/\'/g,"''"),r.length>0&&r.charAt(r.length-1)==="\\"?`'${r}\\'`:`'${r}'`),v){const r=(0,T.$2f)(v);r&&(u+=`${r}:; `),u+=`cd ${p(v)}; `}if(k)for(const r in k){const s=k[r];s===null?u+=`Remove-Item env:${r}; `:u+=`\${env:${r}}='${s}'; `}if(A.length>0){const r=A.shift(),s=I?r:p(r);u+=s[0]==="'"?`& ${s} `:`${s} `;for(const a of A)u+=a==="<"||a===">"||I?a:p(a),u+=" "}break;case 0:if(p=r=>(r=r.replace(/\"/g,'""'),r=r.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(s=>r.includes(s))||r.length===0?`"${r}"`:r),v){const r=(0,T.$2f)(v);r&&(u+=`${r}: && `),u+=`cd ${p(v)} && `}if(k){u+='cmd /C "';for(const r in k){let s=k[r];s===null?u+=`set "${r}=" && `:(s=s.replace(/[&^|<>]/g,a=>`^${a}`),u+=`set "${r}=${s}" && `)}}for(const r of A)u+=r==="<"||r===">"||I?r:p(r),u+=" ";k&&(u+='"');break;case 2:{p=s=>(s=s.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),s.length===0?'""':s);const r=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(v&&(u+=`cd ${p(v)} ; `),k){u+="/usr/bin/env";for(const s in k){const a=k[s];a===null?u+=` -u ${r(s)}`:u+=` ${r(`${s}=${a}`)}`}u+=" "}for(const s of A)u+=s==="<"||s===">"||I?s:p(s),u+=" ";break}}return u}e.$Vdc=E}),define(De[108],Ce([1,0,22,35,50,98,17,16,12,41]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kI=e.$jI=e.$iI=e.$hI=e.CellStatusbarAlignment=e.$gI=e.$fI=e.$eI=e.NotebookEditorPriority=e.$dI=e.$cI=e.$bI=e.$aI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$_H=e.$$H=e.$0H=e.$9H=e.CellKind=e.$8H=e.$7H=e.$6H=void 0,e.$6H="workbench.editor.notebook",e.$7H="workbench.editor.notebookTextDiffEditor",e.$8H="workbench.editor.interactive";var A;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(A||(e.CellKind=A={})),e.$9H=["application/json","application/javascript","text/html","image/svg+xml",L.$Kr.latex,L.$Kr.markdown,"image/png","image/jpeg",L.$Kr.text],e.$0H=[L.$Kr.latex,L.$Kr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Kr.text],e.$$H=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$_H="_notAvailable";var I;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var v;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var k;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(k||(e.NotebookExecutionState=k={}));var S;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var p;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(p||(e.RendererMessagingSpec=p={}));var u;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(u||(e.NotebookCellsChangeType=u={}));var r;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var s;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(s||(e.CellEditType=s={}));var a;(function(F){F.scheme=R.Schemas.vscodeNotebookCell;const V=["W","X","Y","Z","a","b","c","d","e","f"],H=new RegExp(`^[${V.join("")}]+`),fe=7;function X(pe,G){const z=G.toString(fe),ge=`${z.length<V.length?V[z.length-1]:"z"}${z}s${(0,D.$ue)(D.$ae.fromString(pe.scheme),!0,!0)}`;return pe.with({scheme:F.scheme,fragment:ge})}F.generate=X;function Y(pe){if(pe.scheme!==F.scheme)return;const G=pe.fragment.indexOf("s");if(G<0)return;const z=parseInt(pe.fragment.substring(0,G).replace(H,""),fe),K=(0,D.$te)(pe.fragment.substring(G+1)).toString();if(!isNaN(z))return{handle:z,notebook:pe.with({scheme:K,fragment:null})}}F.parse=Y;function q(pe,G){return pe.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${pe.scheme!==R.Schemas.file?pe.scheme:""}`})}F.generateCellOutputUri=q;function x(pe){if(pe.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(pe.fragment);if(!G)return;const z=G[1]&&G[1]!==""?G[1]:void 0,K=G[2];return{outputId:z,notebook:pe.with({scheme:K||R.Schemas.file,fragment:null})}}F.parseCellOutputUri=x;function me(pe,G,z){return F.generate(pe,G).with({scheme:z})}F.generateCellPropertyUri=me;function ue(pe,G){if(pe.scheme===G)return F.parse(pe.with({scheme:F.scheme}))}F.parseCellPropertyUri=ue})(a||(e.CellUri=a={}));const m=F=>E.$j?F.replace(/\//g,"\\"):F;class l{constructor(V=[],H=e.$9H){this.e=H,this.d=[...new Set(V)].map(fe=>({pattern:fe,matches:T.$uj(m(fe))}))}sort(V){const H=new Map(g.Iterable.map(V,X=>[X,m(X)]));let fe=[];for(const{matches:X}of this.d)for(const[Y,q]of H)if(X(q)){fe.push(Y),H.delete(Y);break}return H.size&&(fe=fe.concat([...H.keys()].sort((X,Y)=>this.e.indexOf(X)-this.e.indexOf(Y)))),fe}prioritize(V,H){const fe=this.f(V);if(fe===-1){this.d.unshift({pattern:V,matches:T.$uj(m(V))});return}const X=new Set(H.map(q=>this.f(q,fe)));X.delete(-1);const Y=Array.from(X).sort();this.d.splice(fe+1,0,...Y.map(q=>this.d[q]));for(let q=Y.length-1;q>=0;q--)this.d.splice(Y[q],1)}toArray(){return this.d.map(V=>V.pattern)}f(V,H=this.d.length){const fe=m(V);for(let X=0;X<H;X++)if(this.d[X].matches(fe))return X;return-1}}e.$aI=l;function t(F,V,H,fe=(X,Y)=>X===Y){const X=[];function Y(me,ue,pe){if(ue===0&&pe.length===0)return;const G=X[X.length-1];G&&G.start+G.deleteCount===me?(G.deleteCount+=ue,G.toInsert.push(...pe)):X.push({start:me,deleteCount:ue,toInsert:pe})}let q=0,x=0;for(;;){if(q===F.length){Y(q,0,V.slice(x));break}if(x===V.length){Y(q,F.length-q,[]);break}const me=F[q],ue=V[x];if(fe(me,ue)){q+=1,x+=1;continue}H(ue)?(Y(q,1,[]),q+=1):(Y(q,0,[ue]),x+=1)}return X}e.$bI=t,e.$cI=new w.$5i("notebookEditorCursorAtBoundary","none"),e.$dI=new w.$5i("notebookEditorCursorAtLineBoundary","none");var n;(function(F){F.default="default",F.option="option"})(n||(e.NotebookEditorPriority=n={}));function o(F){const V=F;return!!((typeof V.include=="string"||T.$vj(V.include))&&(typeof V.exclude=="string"||T.$vj(V.exclude)))}e.$eI=o;function i(F,V,H){if(Array.isArray(F.viewType)&&F.viewType.indexOf(V)>=0||F.viewType===V)return!0;if(F.filenamePattern){const fe=o(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,X=o(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(T.$tj(fe,(0,b.$mc)(H.fsPath).toLowerCase()))return!(X&&T.$tj(X,(0,b.$mc)(H.fsPath).toLowerCase()))}return!1}e.$fI=i,e.$gI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var c;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class h{static{this.d="notebook/"}static create(V){return`${h.d}${V}`}static parse(V){if(V.startsWith(h.d))return V.substring(h.d.length)}}e.$hI=h;function y(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.$iI=y;const C=new TextDecoder;function $(F){const V=[];let H=!1;for(const q of F)(V.length===0||H)&&(V.push(q),H=!0);let fe=P(V);const X=D.$ae.concat(V.map(q=>D.$ae.wrap(q))),Y=U(X);return fe=fe||Y.byteLength!==X.byteLength,{data:Y,didCompression:fe}}e.$jI=$,e.$kI=`${String.fromCharCode(27)}[A`;const f=e.$kI.split("").map(F=>F.charCodeAt(0)),d=10;function P(F){let V=!1;return F.forEach((H,fe)=>{if(fe===0||H.length<e.$kI.length)return;const X=F[fe-1],Y=H.subarray(0,e.$kI.length);if(Y[0]===f[0]&&Y[1]===f[1]&&Y[2]===f[2]){const q=X.lastIndexOf(d);if(q===-1)return;V=!0,F[fe-1]=X.subarray(0,q),F[fe]=H.subarray(e.$kI.length)}}),V}function N(F){let V=F;do F=V,V=F.replace(/[^\n]\x08/gm,"");while(V.length<F.length);return F}function O(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const V=F.match(/^(.*)\r+/m)[1];let H=F.match(/\r+(.*)$/m)[1];H=H+V.slice(H.length,V.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,H)}return F}const M="\b".charCodeAt(0),j="\r".charCodeAt(0);function U(F){return!F.buffer.includes(M)&&!F.buffer.includes(j)?F:D.$ae.fromString(O(N(C.decode(F.buffer))))}}),define(De[7],Ce([1,0,19,8,79,28,98,15,18,2,31,25,30,64,108]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S){"use strict";var p,u,r,s,a,m,l,t,n,o,i,c,h,y,C,$,f,d;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$YL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.TestRunProfileKind=e.TestResultState=e.$FL=e.$EL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$DL=e.$CL=e.$BL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$AL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.ColorThemeKind=e.$uL=e.$tL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$sL=e.DebugConsoleMode=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$mL=e.$lL=e.FileChangeType=e.$kL=e.$jL=e.$iL=e.$hL=e.InlineCompletionTriggerKind=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.ConfigurationTarget=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$WK=e.ViewBadge=e.ProgressLocation=e.$VK=e.$UK=e.TaskScope=e.ShellQuoting=e.$TK=e.$SK=e.$RK=e.TaskPanelKind=e.TaskRevealKind=e.$QK=e.TerminalLocation=e.$PK=e.$OK=e.$NK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$MK=e.$LK=e.$KK=e.$JK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$IK=e.StatusBarAlignment=e.ViewColumn=e.$HK=e.$GK=e.$FK=e.$EK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$DK=e.$CK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.LanguageStatusSeverity=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.CodeActionTriggerKind=e.$qK=e.$pK=e.SymbolTag=e.SymbolKind=e.$oK=e.DocumentHighlightKind=e.$nK=e.$mK=e.$lK=e.$kK=e.DiagnosticSeverity=e.DiagnosticTag=e.$jK=e.$iK=e.FileEditType=e.$hK=e.$gK=e.$fK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(J){return Object.assign(J,{apply:function(...ve){if(ve.length===0)return Reflect.construct(J,[]);{const Re=ve.length===1?[]:ve[1];return Reflect.construct(J,Re,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(J,[]);{const[Re,...Qe]=ve;return Reflect.construct(J,Qe,Re.constructor)}}})}var N;(function(J){J[J.Top=0]="Top",J[J.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var O;(function(J){J[J.TerminalCommand=0]="TerminalCommand",J[J.Opener=1]="Opener",J[J.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let M=p=class{static from(...W){let ve=W;return new p(function(){if(ve){for(const Re of ve)Re&&typeof Re.dispose=="function"&&Re.dispose();ve=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$$J=M,e.$$J=M=p=He([P],M);let j=u=class{static Min(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isBefore(ve)&&(ve=Qe)}return ve}static Max(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isAfter(ve)&&(ve=Qe)}return ve}static isPosition(W){if(!W)return!1;if(W instanceof u)return!0;const{line:ve,character:Re}=W;return typeof ve=="number"&&typeof Re=="number"}static of(W){if(W instanceof u)return W;if(this.isPosition(W))return new u(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,ve){if(W<0)throw(0,T.$6)("line must be non-negative");if(ve<0)throw(0,T.$6)("character must be non-negative");this.c=W,this.e=ve}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,ve=0){if(W===null||ve===null)throw(0,T.$6)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,ve=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&ve===0?this:new u(this.line+Re,this.character+ve)}with(W,ve=this.character){if(W===null||ve===null)throw(0,T.$6)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,ve=typeof W.character=="number"?W.character:this.character),Re===this.line&&ve===this.character?this:new u(Re,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$_J=j,e.$_J=j=u=He([P],j);let U=r=class{static isRange(W){return W instanceof r?!0:W?j.isPosition(W.start)&&j.isPosition(W.end):!1}static of(W){if(W instanceof r)return W;if(this.isRange(W))return new r(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,ve,Re,Qe){let tt,at;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new j(W,ve),at=new j(Re,Qe)):j.isPosition(W)&&j.isPosition(ve)&&(tt=j.of(W),at=j.of(ve)),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this.c=tt,this.e=at):(this.c=at,this.e=tt)}contains(W){return r.isRange(W)?this.contains(W.start)&&this.contains(W.end):j.isPosition(W)?!(j.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const ve=j.Max(W.start,this.c),Re=j.Min(W.end,this.e);if(!ve.isAfter(Re))return new r(ve,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ve=j.Min(W.start,this.c),Re=j.Max(W.end,this.end);return new r(ve,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,ve=this.end){if(W===null||ve===null)throw(0,T.$6)();let Re;return W?j.isPosition(W)?Re=W:(Re=W.start||this.start,ve=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&ve.isEqual(this.end)?this:new r(Re,ve)}toJSON(){return[this.start,this.end]}};e.$aK=U,e.$aK=U=r=He([P],U);let F=s=class extends U{static isSelection(W){return W instanceof s?!0:W?U.isRange(W)&&j.isPosition(W.anchor)&&j.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,ve,Re,Qe){let tt,at;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new j(W,ve),at=new j(Re,Qe)):j.isPosition(W)&&j.isPosition(ve)&&(tt=j.of(W),at=j.of(ve)),!tt||!at)throw new Error("Invalid arguments");super(tt,at),this.f=tt,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$bK=F,e.$bK=F=s=He([P],F);const V=J=>{if(typeof J!="string"||J.length===0||!/^[0-9A-Za-z_\-]+$/.test(J))throw(0,T.$6)("connectionToken")};class H{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve,Re){if(typeof W!="string"||W.length===0)throw(0,T.$6)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,T.$6)("port");typeof Re<"u"&&V(Re),this.host=W,this.port=Math.round(ve),this.connectionToken=Re}}e.$cK=H;class fe{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve){this.makeConnection=W,this.connectionToken=ve,typeof ve<"u"&&V(ve)}}e.$dK=fe;class X extends Error{static NotAvailable(W,ve){return new X(W,k.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(W){return new X(W,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ve=k.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=ve,this._detail=Re,Object.setPrototypeOf(this,X.prototype)}}e.$eK=X;var Y;(function(J){J[J.LF=1]="LF",J[J.CRLF=2]="CRLF"})(Y||(e.EndOfLine=Y={}));var q;(function(J){J[J.Replace=1]="Replace",J[J.Append=2]="Append",J[J.Prepend=3]="Prepend"})(q||(e.EnvironmentVariableMutatorType=q={}));let x=a=class{static isTextEdit(W){return W instanceof a?!0:W?U.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ve){return new a(W,ve)}static insert(W,ve){return a.replace(new U(W,W),ve)}static delete(W){return a.replace(W,"")}static setEndOfLine(W){const ve=new a(new U(new j(0,0),new j(0,0)),"");return ve.newEol=W,ve}get range(){return this.c}set range(W){if(W&&!U.isRange(W))throw(0,T.$6)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,T.$6)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,T.$6)("newEol");this.f=W}constructor(W,ve){this.c=W,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$fK=x,e.$fK=x=a=He([P],x);let me=m=class{static isNotebookCellEdit(W){return W instanceof m?!0:W?Xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ve){return new m(W,ve)}static insertCells(W,ve){return new m(new Xt(W,W),ve)}static deleteCells(W){return new m(W,[])}static updateCellMetadata(W,ve){const Re=new m(new Xt(W,W),[]);return Re.newCellMetadata=ve,Re}static updateNotebookMetadata(W){const ve=new m(new Xt(0,0),[]);return ve.newNotebookMetadata=W,ve}constructor(W,ve){this.range=W,this.newCells=ve}};e.$gK=me,e.$gK=me=m=He([P],me);class ue{static isSnippetTextEdit(W){return W instanceof ue?!0:W?U.isRange(W.range)&&z.isSnippetString(W.snippet):!1}static replace(W,ve){return new ue(W,ve)}static insert(W,ve){return ue.replace(new U(W,W),ve)}constructor(W,ve){this.range=W,this.snippet=ve}}e.$hK=ue;var pe;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.Cell=3]="Cell",J[J.CellReplace=5]="CellReplace",J[J.Snippet=6]="Snippet"})(pe||(e.FileEditType=pe={}));let G=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,ve,Re,Qe){this.c.push({_type:1,from:W,to:ve,options:Re,metadata:Qe})}createFile(W,ve,Re){this.c.push({_type:1,from:void 0,to:W,options:ve,metadata:Re})}deleteFile(W,ve,Re){this.c.push({_type:1,from:W,to:void 0,options:ve,metadata:Re})}e(W,ve,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(W,ve,Re,Qe){const tt=ve.start,at=ve.end;(tt!==at||Re.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:at-tt,cells:Re,metadata:Qe})}g(W,ve,Re,Qe){this.c.push({_type:3,metadata:Qe,uri:W,edit:{editType:3,index:ve,metadata:Re}})}replace(W,ve,Re,Qe){this.c.push({_type:2,uri:W,edit:new x(ve,Re),metadata:Qe})}insert(W,ve,Re,Qe){this.replace(W,new U(ve,ve),Re,Qe)}delete(W,ve,Re){this.replace(W,ve,"",Re)}has(W){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===W.toString())}set(W,ve){if(ve)for(const Re of ve){if(!Re)continue;let Qe,tt;Array.isArray(Re)?(Qe=Re[0],tt=Re[1]):Qe=Re,me.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(W,Qe.range.start,Qe.newCellMetadata,tt):Qe.newNotebookMetadata?this.e(W,Qe.newNotebookMetadata,tt):this.f(W,Qe.range,Qe.newCells,tt):ue.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:W,range:Qe.range,edit:Qe.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Qe,metadata:tt})}else{for(let Re=0;Re<this.c.length;Re++){const Qe=this.c[Re];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,D.$Hb)(this.c)}}get(W){const ve=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&ve.push(Re.edit);return ve}entries(){const W=new L.$zc;for(const ve of this.c)if(ve._type===2){let Re=W.get(ve.uri);Re||(Re=[ve.uri,[]],W.set(ve.uri,Re)),Re[1].push(ve.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$iK=G,e.$iK=G=He([P],G);let z=l=class{static isSnippetString(W){return W instanceof l?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=l.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ve=this.e++){if(typeof W=="function"){const Re=new l;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=l.c(W);return this.value+="${",this.value+=ve,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ve=this.e++){const Re=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,ve){if(typeof ve=="function"){const Re=new l;Re.e=this.e,ve(Re),this.e=Re.e,ve=Re.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$jK=z,e.$jK=z=l=He([P],z);var K;(function(J){J[J.Unnecessary=1]="Unnecessary",J[J.Deprecated=2]="Deprecated"})(K||(e.DiagnosticTag=K={}));var ge;(function(J){J[J.Hint=3]="Hint",J[J.Information=2]="Information",J[J.Warning=1]="Warning",J[J.Error=0]="Error"})(ge||(e.DiagnosticSeverity=ge={}));let _=t=class{static isLocation(W){return W instanceof t?!0:W?U.isRange(W.range)&&w.URI.isUri(W.uri):!1}constructor(W,ve){if(this.uri=W,ve)if(U.isRange(ve))this.range=U.of(ve);else if(j.isPosition(ve))this.range=new U(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$kK=_,e.$kK=_=t=He([P],_);let ie=class{static is(W){return W?typeof W.message=="string"&&W.location&&U.isRange(W.location.range)&&w.URI.isUri(W.location.uri):!1}constructor(W,ve){this.location=W,this.message=ve}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.location.range.isEqual(ve.location.range)&&W.location.uri.toString()===ve.location.uri.toString()}};e.$lK=ie,e.$lK=ie=He([P],ie);let ne=class{constructor(W,ve,Re=ge.Error){if(!U.isRange(W))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=W,this.message=ve,this.severity=Re}toJSON(){return{severity:ge[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.severity===ve.severity&&W.code===ve.code&&W.severity===ve.severity&&W.source===ve.source&&W.range.isEqual(ve.range)&&(0,D.$tb)(W.tags,ve.tags)&&(0,D.$tb)(W.relatedInformation,ve.relatedInformation,ie.isEqual)}};e.$mK=ne,e.$mK=ne=He([P],ne);let Ee=class{constructor(W,ve){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ve}};e.$nK=Ee,e.$nK=Ee=He([P],Ee);var oe;(function(J){J[J.Text=0]="Text",J[J.Read=1]="Read",J[J.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let he=class{constructor(W,ve=oe.Text){this.range=W,this.kind=ve}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$oK=he,e.$oK=he=He([P],he);var ee;(function(J){J[J.File=0]="File",J[J.Module=1]="Module",J[J.Namespace=2]="Namespace",J[J.Package=3]="Package",J[J.Class=4]="Class",J[J.Method=5]="Method",J[J.Property=6]="Property",J[J.Field=7]="Field",J[J.Constructor=8]="Constructor",J[J.Enum=9]="Enum",J[J.Interface=10]="Interface",J[J.Function=11]="Function",J[J.Variable=12]="Variable",J[J.Constant=13]="Constant",J[J.String=14]="String",J[J.Number=15]="Number",J[J.Boolean=16]="Boolean",J[J.Array=17]="Array",J[J.Object=18]="Object",J[J.Key=19]="Key",J[J.Null=20]="Null",J[J.EnumMember=21]="EnumMember",J[J.Struct=22]="Struct",J[J.Event=23]="Event",J[J.Operator=24]="Operator",J[J.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var le;(function(J){J[J.Deprecated=1]="Deprecated"})(le||(e.SymbolTag=le={}));let be=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ve,Re,Qe,tt){this.name=W,this.kind=ve,this.containerName=tt,typeof Re=="string"&&(this.containerName=Re),Qe instanceof _?this.location=Qe:Re instanceof U&&(this.location=new _(Qe,Re)),n.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.$pK=be,e.$pK=be=n=He([P],be);let Pe=o=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(o.validate)}constructor(W,ve,Re,Qe,tt){this.name=W,this.detail=ve,this.kind=Re,this.range=Qe,this.selectionRange=tt,this.children=[],o.validate(this)}};e.$qK=Pe,e.$qK=Pe=o=He([P],Pe);var B;(function(J){J[J.Invoke=1]="Invoke",J[J.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let Q=class{constructor(W,ve){this.title=W,this.kind=ve}};e.$rK=Q,e.$rK=Q=He([P],Q);let te=class{static{i=this}static{this.c="."}constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.c)}};e.$sK=te,e.$sK=te=i=He([P],te),te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorMove=te.Refactor.append("move"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll"),te.Notebook=te.Empty.append("notebook");let re=class{constructor(W,ve){if(this.range=W,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$tK=re,e.$tK=re=He([P],re);class Z{constructor(W,ve,Re,Qe,tt,at){this.kind=W,this.name=ve,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=at}}e.$uK=Z;class de{constructor(W,ve){this.fromRanges=ve,this.from=W}}e.$vK=de;class ye{constructor(W,ve){this.fromRanges=ve,this.to=W}}e.$wK=ye;var je;(function(J){J[J.Information=0]="Information",J[J.Warning=1]="Warning",J[J.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(W,ve){this.range=W,this.command=ve}get isResolved(){return!!this.command}};e.$xK=We,e.$xK=We=He([P],We);let xe=c=class{#e;static isMarkdownString(W){return W instanceof c?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ve=!1){this.#e=new g.$1j(W,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,ve){return this.#e.appendCodeblock(ve??"",W),this}};e.$yK=xe,e.$yK=xe=c=He([P],xe);let Ze=class{constructor(W,ve){this.label=W,this.documentation=ve}};e.$zK=Ze,e.$zK=Ze=He([P],Ze);let it=class{constructor(W,ve){this.label=W,this.documentation=ve,this.parameters=[]}};e.$AK=it,e.$AK=it=He([P],it);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$BK=et,e.$BK=et=He([P],et);var Ae;(function(J){J[J.Invoke=1]="Invoke",J[J.TriggerCharacter=2]="TriggerCharacter",J[J.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Fe;(function(J){J[J.Type=1]="Type",J[J.Parameter=2]="Parameter"})(Fe||(e.InlayHintKind=Fe={}));let qe=class{constructor(W){this.value=W}};e.$CK=qe,e.$CK=qe=He([P],qe);let Le=class{constructor(W,ve,Re){this.position=W,this.label=ve,this.kind=Re}};e.$DK=Le,e.$DK=Le=He([P],Le);var Ye;(function(J){J[J.Invoke=0]="Invoke",J[J.TriggerCharacter=1]="TriggerCharacter",J[J.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye||(e.CompletionTriggerKind=Ye={}));var ce;(function(J){J[J.Text=0]="Text",J[J.Method=1]="Method",J[J.Function=2]="Function",J[J.Constructor=3]="Constructor",J[J.Field=4]="Field",J[J.Variable=5]="Variable",J[J.Class=6]="Class",J[J.Interface=7]="Interface",J[J.Module=8]="Module",J[J.Property=9]="Property",J[J.Unit=10]="Unit",J[J.Value=11]="Value",J[J.Enum=12]="Enum",J[J.Keyword=13]="Keyword",J[J.Snippet=14]="Snippet",J[J.Color=15]="Color",J[J.File=16]="File",J[J.Reference=17]="Reference",J[J.Folder=18]="Folder",J[J.EnumMember=19]="EnumMember",J[J.Constant=20]="Constant",J[J.Struct=21]="Struct",J[J.Event=22]="Event",J[J.Operator=23]="Operator",J[J.TypeParameter=24]="TypeParameter",J[J.User=25]="User",J[J.Issue=26]="Issue"})(ce||(e.CompletionItemKind=ce={}));var ae;(function(J){J[J.Deprecated=1]="Deprecated"})(ae||(e.CompletionItemTag=ae={}));let Ie=class{constructor(W,ve){this.label=W,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$EK=Ie,e.$EK=Ie=He([P],Ie);let Ve=class{constructor(W=[],ve=!1){this.items=W,this.isIncomplete=ve}};e.$FK=Ve,e.$FK=Ve=He([P],Ve);let Ue=class{constructor(W,ve,Re){this.insertText=W,this.range=ve,this.command=Re}};e.$GK=Ue,e.$GK=Ue=He([P],Ue);let Xe=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$HK=Xe,e.$HK=Xe=He([P],Xe);var rt;(function(J){J[J.Active=-1]="Active",J[J.Beside=-2]="Beside",J[J.One=1]="One",J[J.Two=2]="Two",J[J.Three=3]="Three",J[J.Four=4]="Four",J[J.Five=5]="Five",J[J.Six=6]="Six",J[J.Seven=7]="Seven",J[J.Eight=8]="Eight",J[J.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var ot;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function wt(J,W){return`${I.$Yl.toKey(J)}.${W}`}e.$IK=wt;var kt;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative"})(kt||(e.TextEditorLineNumbersStyle=kt={}));var Yt;(function(J){J[J.Manual=1]="Manual",J[J.AfterDelay=2]="AfterDelay",J[J.FocusOut=3]="FocusOut"})(Yt||(e.TextDocumentSaveReason=Yt={}));var Vt;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(Vt||(e.TextEditorRevealType=Vt={}));var pt;(function(J){J[J.Keyboard=1]="Keyboard",J[J.Mouse=2]="Mouse",J[J.Command=3]="Command"})(pt||(e.TextEditorSelectionChangeKind=pt={}));var Ut;(function(J){J[J.Undo=1]="Undo",J[J.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Ft;(function(J){J[J.OpenOpen=0]="OpenOpen",J[J.ClosedClosed=1]="ClosedClosed",J[J.OpenClosed=2]="OpenClosed",J[J.ClosedOpen=3]="ClosedOpen"})(Ft||(e.DecorationRangeBehavior=Ft={})),function(J){function W(ve){switch(ve){case"keyboard":return J.Keyboard;case"mouse":return J.Mouse;case"api":return J.Command}}J.fromValue=W}(pt||(e.TextEditorSelectionChangeKind=pt={}));var zt;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(zt||(e.SyntaxTokenType=zt={})),function(J){function W(ve){switch(ve){case J.Other:return"other";case J.Comment:return"comment";case J.String:return"string";case J.RegEx:return"regex"}return"other"}J.toString=W}(zt||(e.SyntaxTokenType=zt={}));let At=class{constructor(W,ve){if(ve&&!w.URI.isUri(ve))throw(0,T.$6)("target");if(!U.isRange(W)||W.isEmpty)throw(0,T.$6)("range");this.range=W,this.target=ve}};e.$JK=At,e.$JK=At=He([P],At);let Rt=class{constructor(W,ve,Re,Qe){this.red=W,this.green=ve,this.blue=Re,this.alpha=Qe}};e.$KK=Rt,e.$KK=Rt=He([P],Rt);let Nt=class{constructor(W,ve){if(ve&&!(ve instanceof Rt))throw(0,T.$6)("color");if(!U.isRange(W)||W.isEmpty)throw(0,T.$6)("range");this.range=W,this.color=ve}};e.$LK=Nt,e.$LK=Nt=He([P],Nt);let Bt=class{constructor(W){if(!W||typeof W!="string")throw(0,T.$6)("label");this.label=W}};e.$MK=Bt,e.$MK=Bt=He([P],Bt);var Kt;(function(J){J[J.RGB=0]="RGB",J[J.HEX=1]="HEX",J[J.HSL=2]="HSL"})(Kt||(e.ColorFormat=Kt={}));var Wt;(function(J){J[J.Error=0]="Error",J[J.Warning=1]="Warning",J[J.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var ct;(function(J){J[J.Unknown=0]="Unknown",J[J.Shutdown=1]="Shutdown",J[J.Process=2]="Process",J[J.User=3]="User",J[J.Extension=4]="Extension"})(ct||(e.TerminalExitReason=ct={}));class lt{constructor(W,ve,Re){if(this.startIndex=W,this.length=ve,this.tooltip=Re,typeof W!="number"||W<0)throw(0,T.$6)("startIndex");if(typeof ve!="number"||ve<1)throw(0,T.$6)("length");if(Re!==void 0&&typeof Re!="string")throw(0,T.$6)("tooltip")}}e.$NK=lt;class Jt{constructor(W){this.uri=W}}e.$OK=Jt;class Pt{constructor(W){this.terminalCommand=W}}e.$PK=Pt;var St;(function(J){J[J.Panel=1]="Panel",J[J.Editor=2]="Editor"})(St||(e.TerminalLocation=St={}));class dt{constructor(W){if(this.options=W,typeof W!="object")throw(0,T.$6)("options")}}e.$QK=dt;var Ct;(function(J){J[J.Always=1]="Always",J[J.Silent=2]="Silent",J[J.Never=3]="Never"})(Ct||(e.TaskRevealKind=Ct={}));var Tt;(function(J){J[J.Shared=1]="Shared",J[J.Dedicated=2]="Dedicated",J[J.New=3]="New"})(Tt||(e.TaskPanelKind=Tt={}));let Et=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(W){switch(W){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(W,ve){if(this.label=ve,typeof W!="string"||typeof ve!="string")throw(0,T.$6)("name");this.c=W}get id(){return this.c}};e.$RK=Et,e.$RK=Et=h=He([P],Et);function Ge(J){let W="";for(let ve=0;ve<J.length;ve++)W+=J[ve].replace(/,/g,",,")+",";return W}let Ot=class{constructor(W,ve,Re){if(typeof W!="string")throw(0,T.$6)("process");this.e=[],this.c=W,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Re):this.f=ve)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,T.$6)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)W.push(ve);return Ge(W)}};e.$SK=Ot,e.$SK=Ot=He([P],Ot);let Me=class{constructor(W,ve,Re){if(this.f=[],Array.isArray(ve)){if(!W)throw(0,T.$6)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$6)("command");this.e=W,this.f=ve,this.g=Re}else{if(typeof W!="string")throw(0,T.$6)("commandLine");this.c=W,this.g=ve}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,T.$6)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$6)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)W.push(typeof ve=="string"?ve:ve.value);return Ge(W)}};e.$TK=Me,e.$TK=Me=He([P],Me);var Te;(function(J){J[J.Escape=1]="Escape",J[J.Strong=2]="Strong",J[J.Weak=3]="Weak"})(Te||(e.ShellQuoting=Te={}));var Se;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace"})(Se||(e.TaskScope=Se={}));class se{constructor(W){this.c=W}computeId(){return"customExecution"+(0,A.$dg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$UK=se;let Ne=class{static{y=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,ve,Re,Qe,tt,at){this.j=!1,this.k=this.definition=W;let ht;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Re,this.execution=Qe,ht=tt,this.j=!0):ve===Se.Global||ve===Se.Workspace?(this.target=ve,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,ht=at):(this.target=ve,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,ht=at),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ot?this.k={type:y.e,id:this.n.computeId()}:this.n instanceof Me?this.k={type:y.f,id:this.n.computeId()}:this.n instanceof se?this.k={type:y.c,id:this.n.computeId()}:this.k={type:y.g,id:(0,A.$dg)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,T.$6)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,T.$6)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const ve=this.k.type;(y.g===ve||y.e===ve||y.f===ve||y.c===ve)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,T.$6)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$VK=Ne,e.$VK=Ne=y=He([P],Ne);var Ke;(function(J){J[J.SourceControl=1]="SourceControl",J[J.Window=10]="Window",J[J.Notification=15]="Notification"})(Ke||(e.ProgressLocation=Ke={}));var _e;(function(J){function W(ve){const Re=ve;return(0,E.$Bf)(Re.value)?Re.tooltip&&!(0,E.$xf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}J.isViewBadge=W})(_e||(e.ViewBadge=_e={}));let Je=C=class{static isTreeItem(W,ve){const Re=W;if(Re.checkboxState!==void 0){const Qe=(0,E.$Bf)(Re.checkboxState)?Re.checkboxState:(0,E.$zf)(Re.checkboxState)&&(0,E.$Bf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,tt=!(0,E.$Bf)(Re.checkboxState)&&(0,E.$zf)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==bt.Checked&&Qe!==bt.Unchecked||tt!==void 0&&!(0,E.$xf)(tt))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof C)return!0;if(Re.label!==void 0&&!(0,E.$xf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,E.$xf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,E.$xf)(Re.iconPath)&&!w.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,E.$xf)(Re.iconPath.id))){const Qe=Re.iconPath;if(!Qe||!(0,E.$xf)(Qe.light)&&!w.URI.isUri(Qe.light)&&!(0,E.$xf)(Qe.dark)&&!w.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,E.$xf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!w.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,E.$xf)(Re.tooltip)&&!(Re.tooltip instanceof xe)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<nt.None&&Re.collapsibleState>nt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,E.$xf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,ve=nt.None){this.collapsibleState=ve,w.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$WK=Je,e.$WK=Je=C=He([P],Je);var nt;(function(J){J[J.None=0]="None",J[J.Collapsed=1]="Collapsed",J[J.Expanded=2]="Expanded"})(nt||(e.TreeItemCollapsibleState=nt={}));var bt;(function(J){J[J.Unchecked=0]="Unchecked",J[J.Checked=1]="Checked"})(bt||(e.TreeItemCheckboxState=bt={}));let vt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$XK=vt,e.$XK=vt=He([P],vt);class ft extends vt{}e.$YK=ft;class gt extends ft{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$ZK=gt;class mt{constructor(W,ve,Re,Qe){this.name=W,this.uri=ve,this._itemId=Re,this.c=Qe}data(){return this.c()}}e.$1K=mt;let gi=class{#e=new Map;constructor(W){for(const[ve,Re]of W??[]){const Qe=this.#e.get(this.#t(ve));Qe?Qe.push(Re):this.#e.set(this.#t(ve),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,ve){this.#e.set(this.#t(W),[ve])}forEach(W,ve){for(const[Re,Qe]of this.#e)for(const tt of Qe)W.call(ve,tt,Re,this)}*[Symbol.iterator](){for(const[W,ve]of this.#e)for(const Re of ve)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$2K=gi,e.$2K=gi=He([P],gi);let Ht=class{constructor(W){this.insertText=W}};e.$3K=Ht,e.$3K=Ht=He([P],Ht);let Ei=class{constructor(W,ve){this.label=ve,this.insertText=W}};e.$4K=Ei,e.$4K=Ei=He([P],Ei);let qt=class{constructor(W,ve){this.id=W,this.color=ve}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$5K=qt,e.$5K=qt=He([P],qt),qt.File=new qt("file"),qt.Folder=new qt("folder");let mi=class{constructor(W){this.id=W}};e.$6K=mi,e.$6K=mi=He([P],mi);var It;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace",J[J.WorkspaceFolder=3]="WorkspaceFolder"})(It||(e.ConfigurationTarget=It={}));let ki=class{get base(){return this.c}set base(W){this.c=W,this.e=w.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,ve){if(typeof W!="string"&&(!W||!w.URI.isUri(W)&&!w.URI.isUri(W.uri)))throw(0,T.$6)("base");if(typeof ve!="string")throw(0,T.$6)("pattern");typeof W=="string"?this.baseUri=w.URI.file(W):w.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$7K=ki,e.$7K=ki=He([P],ki);const qi=new WeakMap;function Dt(J,W){qi.set(J,W)}e.$8K=Dt;let ti=class{constructor(W,ve,Re,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof ve=="string"&&(this.condition=ve),typeof Re=="string"&&(this.hitCondition=Re),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=qi.get(this)??(0,A.$dg)()),this.c}};e.$9K=ti,e.$9K=ti=He([P],ti);let $i=class extends ti{constructor(W,ve,Re,Qe,tt){if(super(ve,Re,Qe,tt),W===null)throw(0,T.$6)("location");this.location=W}};e.$0K=$i,e.$0K=$i=He([P],$i);let si=class extends ti{constructor(W,ve,Re,Qe,tt){super(ve,Re,Qe,tt),this.functionName=W}};e.$$K=si,e.$$K=si=He([P],si);let Si=class extends ti{constructor(W,ve,Re,Qe,tt,at,ht){if(super(Qe,tt,at,ht),!ve)throw(0,T.$6)("dataId");this.label=W,this.dataId=ve,this.canPersist=Re}};e.$_K=Si,e.$_K=Si=He([P],Si);let Di=class{constructor(W,ve,Re){this.command=W,this.args=ve||[],this.options=Re}};e.$aL=Di,e.$aL=Di=He([P],Di);let Lt=class{constructor(W,ve){this.port=W,this.host=ve}};e.$bL=Lt,e.$bL=Lt=He([P],Lt);let bi=class{constructor(W){this.path=W}};e.$cL=bi,e.$cL=bi=He([P],bi);let Ci=class{constructor(W){this.implementation=W}};e.$dL=Ci,e.$dL=Ci=He([P],Ci);let oi=class{constructor(W,ve,Re){this.session=W,this.threadId=ve,this.frameId=Re}};e.$eL=oi,e.$eL=oi=He([P],oi);let ai=class{constructor(W,ve){this.session=W,this.threadId=ve}};e.$fL=ai,e.$fL=ai=He([P],ai);let ut=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$gL=ut,e.$gL=ut=He([P],ut);var Vi;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(Vi||(e.InlineCompletionTriggerKind=Vi={}));let Zt=class{constructor(W,ve){this.range=W,this.text=ve}};e.$hL=Zt,e.$hL=Zt=He([P],Zt);let ii=class{constructor(W,ve,Re=!0){this.range=W,this.variableName=ve,this.caseSensitiveLookup=Re}};e.$iL=ii,e.$iL=ii=He([P],ii);let wi=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$jL=wi,e.$jL=wi=He([P],wi);let Ii=class{constructor(W,ve){this.frameId=W,this.stoppedLocation=ve}};e.$kL=Ii,e.$kL=Ii=He([P],Ii);var Ki;(function(J){J[J.Changed=1]="Changed",J[J.Created=2]="Created",J[J.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Pi=$=class extends Error{static FileExists(W){return new $(W,v.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(W){return new $(W,v.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(W){return new $(W,v.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(W){return new $(W,v.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(W){return new $(W,v.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(W){return new $(W,v.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(W,ve=v.FileSystemProviderErrorCode.Unknown,Re){super(w.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,v.$kk)(this,ve),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$lL=Pi,e.$lL=Pi=$=He([P],Pi);let vi=class{constructor(W,ve,Re){this.start=W,this.end=ve,this.kind=Re}};e.$mL=vi,e.$mL=vi=He([P],vi);var Hi;(function(J){J[J.Comment=1]="Comment",J[J.Imports=2]="Imports",J[J.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Ai;(function(J){J[J.Collapsed=0]="Collapsed",J[J.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ci;(function(J){J[J.Editing=0]="Editing",J[J.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var Ji;(function(J){J[J.Published=0]="Published",J[J.Draft=1]="Draft"})(Ji||(e.CommentState=Ji={}));var pi;(function(J){J[J.Unresolved=0]="Unresolved",J[J.Resolved=1]="Resolved"})(pi||(e.CommentThreadState=pi={}));class Ri{constructor(W,ve=[]){this.tokenTypes=W,this.tokenModifiers=ve}}e.$nL=Ri;function cn(J){return typeof J>"u"||(0,E.$yf)(J)}class Li{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let ve=0,Re=W.tokenTypes.length;ve<Re;ve++)this.j.set(W.tokenTypes[ve],ve);for(let ve=0,Re=W.tokenModifiers.length;ve<Re;ve++)this.k.set(W.tokenModifiers[ve],ve)}}push(W,ve,Re,Qe,tt){if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Qe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(W,ve,Re,Qe,tt);if(U.isRange(W)&&typeof ve=="string"&&cn(Re))return this.m(W,ve,Re);throw(0,T.$6)()}m(W,ve,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,tt=W.start.character,at=W.end.character-W.start.character,ht=this.j.get(ve);let jt=0;if(Re)for(const Qt of Re){if(!this.k.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this.k.get(Qt);jt|=1<<_t>>>0}this.n(Qe,tt,at,ht,jt)}n(W,ve,Re,Qe,tt){if(this.f&&(W<this.c||W===this.c&&ve<this.e)){this.f=!1;const jt=this.g.length/5|0;let Qt=0,_t=0;for(let ei=0;ei<jt;ei++){let ri=this.g[5*ei],Bi=this.g[5*ei+1];ri===0?(ri=Qt,Bi+=_t):ri+=Qt,this.g[5*ei]=ri,this.g[5*ei+1]=Bi,Qt=ri,_t=Bi}}let at=W,ht=ve;this.f&&this.h>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ht,this.g[this.h++]=Re,this.g[this.h++]=Qe,this.g[this.h++]=tt,this.c=W,this.e=ve}static o(W){const ve=[],Re=W.length/5|0;for(let ht=0;ht<Re;ht++)ve[ht]=ht;ve.sort((ht,jt)=>{const Qt=W[5*ht],_t=W[5*jt];if(Qt===_t){const ei=W[5*ht+1],ri=W[5*jt+1];return ei-ri}return Qt-_t});const Qe=new Uint32Array(W.length);let tt=0,at=0;for(let ht=0;ht<Re;ht++){const jt=5*ve[ht],Qt=W[jt+0],_t=W[jt+1],ei=W[jt+2],ri=W[jt+3],Bi=W[jt+4],pn=Qt-tt,Ln=pn===0?_t-at:_t,Wi=5*ht;Qe[Wi+0]=pn,Qe[Wi+1]=Ln,Qe[Wi+2]=ei,Qe[Wi+3]=ri,Qe[Wi+4]=Bi,tt=Qt,at=_t}return Qe}build(W){return this.f?new ni(new Uint32Array(this.g),W):new ni(Li.o(this.g),W)}}e.$oL=Li;class ni{constructor(W,ve){this.resultId=ve,this.data=W}}e.$pL=ni;class un{constructor(W,ve,Re){this.start=W,this.deleteCount=ve,this.data=Re}}e.$qL=un;class ln{constructor(W,ve){this.resultId=ve,this.edits=W}}e.$rL=ln;var Gi;(function(J){J[J.Separate=0]="Separate",J[J.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new qt("arrow-left")}}constructor(){}};e.$sL=fi,e.$sL=fi=He([P],fi);var Qi;(function(J){J[J.Separator=-1]="Separator",J[J.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Yi;(function(J){J[J.Info=1]="Info",J[J.Warning=2]="Warning",J[J.Error=3]="Error"})(Yi||(e.InputBoxValidationSeverity=Yi={}));var ui;(function(J){J[J.UI=1]="UI",J[J.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Zi{static validate(W){if(typeof W.badge=="string"){let ve=(0,b.$$e)(W.badge,0);if(ve<W.badge.length&&(ve+=(0,b.$$e)(W.badge,ve)),W.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!qt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ve,Re){this.badge=W,this.tooltip=ve,this.color=Re}}e.$tL=Zi;let Mi=class{constructor(W){this.kind=W}};e.$uL=Mi,e.$uL=Mi=He([P],Mi);var Xi;(function(J){J[J.Light=1]="Light",J[J.Dark=2]="Dark",J[J.HighContrast=3]="HighContrast",J[J.HighContrastLight=4]="HighContrastLight"})(Xi||(e.ColorThemeKind=Xi={}));class Xt{static isNotebookRange(W){return W instanceof Xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,ve){if(W<0)throw(0,T.$6)("start must be positive");if(ve<0)throw(0,T.$6)("end must be positive");W<=ve?(this.c=W,this.e=ve):(this.c=ve,this.e=W)}with(W){let ve=this.c,Re=this.e;return W.start!==void 0&&(ve=W.start),W.end!==void 0&&(Re=W.end),ve===this.c&&Re===this.e?this:new Xt(ve,Re)}}e.$vL=Xt;class yi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ve=>yi.isNotebookCellData(ve))}static isNotebookCellData(W){return!0}constructor(W,ve,Re,Qe,tt,at,ht){this.kind=W,this.value=ve,this.languageId=Re,this.mime=Qe,this.outputs=tt??[],this.metadata=at,this.executionSummary=ht,yi.validate(this)}}e.$wL=yi;class hn{constructor(W){this.cells=W}}e.$xL=hn;class Gt{static isNotebookCellOutputItem(W){return W instanceof Gt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ve={name:W.name,message:W.message,stack:W.stack};return Gt.json(ve,"application/vnd.code.notebook.error")}static stdout(W){return Gt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Gt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ve="application/octet-stream"){return new Gt(W,ve)}static#e=new TextEncoder;static text(W,ve=R.$Kr.text){const Re=Gt.#e.encode(String(W));return new Gt(Re,ve)}static json(W,ve="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Gt.text(Re,ve)}constructor(W,ve){this.data=W,this.mime=ve;const Re=(0,R.$Or)(ve,!0);if(!Re)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$yL=Gt;class li{static isNotebookCellOutput(W){return W instanceof li?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ve=!1){const Re=new Set,Qe=new Set;for(let tt=0;tt<W.length;tt++){const at=W[tt],ht=(0,R.$Or)(at.mime);if(!Re.has(ht)||(0,S.$iI)(ht)){Re.add(ht);continue}Qe.add(tt),ve&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Qe.size===0?W:W.filter((tt,at)=>!Qe.has(at))}constructor(W,ve,Re){this.items=li.ensureUniqueMimeTypes(W,!0),typeof ve=="string"?(this.id=ve,this.metadata=Re):(this.id=(0,A.$dg)(),this.metadata=ve??Re)}}e.$zL=li;var Ti;(function(J){J[J.Markup=1]="Markup",J[J.Code=2]="Code"})(Ti||(e.NotebookCellKind=Ti={}));var ze;(function(J){J[J.Idle=1]="Idle",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(ze||(e.NotebookCellExecutionState=ze={}));var xt;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(xt||(e.NotebookCellStatusBarAlignment=xt={}));var Fi;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(Fi||(e.NotebookEditorRevealType=Fi={}));class $t{constructor(W,ve){this.text=W,this.alignment=ve}}e.$AL=$t;var xi;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred"})(xi||(e.NotebookControllerAffinity=xi={}));var _i;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred",J[J.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class en{constructor(W,ve=[]){this.uri=W,this.provides=(0,D.$2b)(ve)}}e.$BL=en;class dn{constructor(W){this.label=W}}e.$CL=dn;let hi=class{constructor(W,ve){this.label=W,this.timestamp=ve}};e.$DL=hi,e.$DL=hi=He([P],hi);var tn;(function(J){J[J.Production=1]="Production",J[J.Development=2]="Development",J[J.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(J){J[J.Node=1]="Node",J[J.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(W,ve){this.ranges=W,this.wordPattern=ve}}e.$EL=sn;class fn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$FL=fn;var on;(function(J){J[J.Queued=1]="Queued",J[J.Running=2]="Running",J[J.Passed=3]="Passed",J[J.Failed=4]="Failed",J[J.Skipped=5]="Skipped",J[J.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(J){J[J.Run=1]="Run",J[J.Debug=2]="Debug",J[J.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ni=class{constructor(W=void 0,ve=void 0,Re=void 0,Qe=!1){this.include=W,this.exclude=ve,this.profile=Re,this.continuous=Qe}};e.$GL=Ni,e.$GL=Ni=He([P],Ni);let Oi=f=class{static diff(W,ve,Re){const Qe=new f(W);return Qe.expectedOutput=ve,Qe.actualOutput=Re,Qe}constructor(W){this.message=W}};e.$HL=Oi,e.$HL=Oi=f=He([P],Oi);let ji=class{constructor(W){this.id=W}};e.$IL=ji,e.$IL=ji=He([P],ji);let di=class{constructor(W,ve){this.covered=W,this.total=ve}};e.$JL=di,e.$JL=di=He([P],di);let Ui=d=class{static fromDetails(W,ve){const Re=new di(0,0),Qe=new di(0,0),tt=new di(0,0);for(const ht of ve)if("branches"in ht){Re.total+=1,Re.covered+=ht.executionCount>0?1:0;for(const jt of ht.branches)Qe.total+=1,Qe.covered+=jt.executionCount>0?1:0}else tt.total+=1,tt.covered+=ht.executionCount>0?1:0;const at=new d(W,Re,Qe.total>0?Qe:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=ve,at}constructor(W,ve,Re,Qe){this.uri=W,this.statementCoverage=ve,this.branchCoverage=Re,this.functionCoverage=Qe}};e.$KL=Ui,e.$KL=Ui=d=He([P],Ui);let zi=class{constructor(W,ve,Re=[]){this.executionCount=W,this.location=ve,this.branches=Re}};e.$LL=zi,e.$LL=zi=He([P],zi);let we=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$ML=we,e.$ML=we=He([P],we);let ke=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$NL=ke,e.$NL=ke=He([P],ke);var Oe;(function(J){J[J.None=0]="None",J[J.Option=1]="Option",J[J.Default=2]="Default",J[J.Preferred=3]="Preferred"})(Oe||(e.ExternalUriOpenerPriority=Oe={}));var st;(function(J){J[J.Untrusted=0]="Untrusted",J[J.Trusted=1]="Trusted",J[J.Unspecified=2]="Unspecified"})(st||(e.WorkspaceTrustState=st={}));var yt;(function(J){J[J.Notify=1]="Notify",J[J.OpenBrowser=2]="OpenBrowser",J[J.OpenPreview=3]="OpenPreview",J[J.Silent=4]="Silent",J[J.Ignore=5]="Ignore",J[J.OpenBrowserOnce=6]="OpenBrowserOnce"})(yt||(e.PortAutoForwardAction=yt={}));class Mt{constructor(W,ve,Re,Qe,tt,at){this.kind=W,this.name=ve,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=at}}e.$OL=Mt;class yn{constructor(W){this.uri=W}}e.$PL=yn;class En{constructor(W,ve){this.original=W,this.modified=ve}}e.$QL=En;class kn{constructor(W,ve,Re,Qe){this.base=W,this.input1=ve,this.input2=Re,this.result=Qe}}e.$RL=kn;class Sn{constructor(W,ve){this.uri=W,this.viewType=ve}}e.$SL=Sn;class Dn{constructor(W){this.viewType=W}}e.$TL=Dn;class Cn{constructor(W,ve){this.uri=W,this.notebookType=ve}}e.$UL=Cn;class In{constructor(W,ve,Re){this.original=W,this.modified=ve,this.notebookType=Re}}e.$VL=In;class Pn{constructor(){}}e.$WL=Pn;class An{constructor(W,ve){this.uri=W,this.inputBoxUri=ve}}e.$XL=An;var gn;(function(J){J[J.Up=1]="Up",J[J.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(J){J[J.Action=1]="Action",J[J.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful",J[J.Undone=2]="Undone",J[J.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var bn;(function(J){J[J.System=0]="System",J[J.User=1]="User",J[J.Assistant=2]="Assistant",J[J.Function=3]="Function"})(bn||(e.ChatMessageRole=bn={}));var wn;(function(J){J[J.Short=1]="Short",J[J.Medium=2]="Medium",J[J.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Rn{constructor(W,ve){this.role=W,this.content=ve}}e.$YL=Rn;var vn;(function(J){J[J.SymbolInformation=1]="SymbolInformation",J[J.CommandInformation=2]="CommandInformation",J[J.SearchInformation=3]="SearchInformation",J[J.SettingInformation=4]="SettingInformation"})(vn||(e.RelatedInformationType=vn={}))}),define(De[141],Ce([1,0,58,17,15,171,124,7,19]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=e.$_L=void 0;const w=new Map;function A(S,p){p?w.set(S,p):w.delete(S)}e.$_L=A;function I(S){return w.get(S)}class v extends L.$Pu{constructor(p,u,r,s,a,m,l,t){super(u,r,s,a),this.c=p,this.m=m,this.q=l,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(p){return(0,E.$tb)(this.f,p)}get document(){if(!this.a){const p=this;this.a={get uri(){return p.d},get fileName(){return p.d.fsPath},get isUntitled(){return p.d.scheme===T.Schemas.untitled},get languageId(){return p.m},get version(){return p.h},get isClosed(){return p.b},get isDirty(){return p.q},save(){return p.r()},getText(u){return u?p.s(u):p.getText()},get eol(){return p.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return p.f.length},lineAt(u){return p.t(u)},offsetAt(u){return p.u(u)},positionAt(u){return p.v(u)},validateRange(u){return p.w(u)},validatePosition(u){return p.x(u)},getWordRangeAtPosition(u,r){return p.y(u,r)}}}return Object.freeze(this.a)}_acceptLanguageId(p){(0,D.ok)(!this.b),this.m=p}_acceptIsDirty(p){(0,D.ok)(!this.b),this.q=p}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(p){const u=this.w(p);if(u.isEmpty)return"";if(u.isSingleLine)return this.f[u.start.line].substring(u.start.character,u.end.character);const r=this.g,s=u.start.line,a=u.end.line,m=[];m.push(this.f[s].substring(u.start.character));for(let l=s+1;l<a;l++)m.push(this.f[l]);return m.push(this.f[a].substring(0,u.end.character)),m.join(r)}t(p){let u;if(p instanceof b.$_J?u=p.line:typeof p=="number"&&(u=p),typeof u!="number"||u<0||u>=this.f.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new k(u,this.f[u],u===this.f.length-1)}u(p){return p=this.x(p),this.l(),this.j.getPrefixSum(p.line-1)+p.character}v(p){p=Math.floor(p),p=Math.max(0,p),this.l();const u=this.j.getIndexOf(p),r=this.f[u.index].length;return new b.$_J(u.index,Math.min(u.remainder,r))}w(p){if(!(p instanceof b.$aK))throw new Error("Invalid argument");const u=this.x(p.start),r=this.x(p.end);return u===p.start&&r===p.end?p:new b.$aK(u.line,u.character,r.line,r.character)}x(p){if(!(p instanceof b.$_J))throw new Error("Invalid argument");if(this.f.length===0)return p.with(0,0);let{line:u,character:r}=p,s=!1;if(u<0)u=0,r=0,s=!0;else if(u>=this.f.length)u=this.f.length-1,r=this.f[u].length,s=!0;else{const a=this.f[u].length;r<0?(r=0,s=!0):r>a&&(r=a,s=!0)}return s?new b.$_J(u,r):p}y(p,u){const r=this.x(p);if(!u)u=I(this.m);else if((0,g.$Ne)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const s=(0,R.$3r)(r.character+1,(0,R.$1r)(u),this.f[r.line],0);if(s)return new b.$aK(r.line,s.startColumn-1,r.line,s.endColumn-1)}}e.$aM=v;class k{constructor(p,u,r){this.a=p,this.b=u,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$aK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$aK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$bM=k}),define(De[274],Ce([1,0,7,20,4]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0;let L=class{constructor(b){this.a=new D.$uL(D.ColorThemeKind.Dark),this.b=new g.$Md}get activeColorTheme(){return this.a}$onColorThemeChange(b){let E;switch(b){case"light":E=D.ColorThemeKind.Light;break;case"hcDark":E=D.ColorThemeKind.HighContrast;break;case"hcLight":E=D.ColorThemeKind.HighContrastLight;break;default:E=D.ColorThemeKind.Dark}this.a=new D.$uL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$bdc=L,e.$bdc=L=He([Be(0,T.$0L)],L)}),define(De[275],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mI=e.CellExecutionUpdateType=void 0;var T;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$mI=(0,D.$Nh)("INotebookExecutionService")}),define(De[67],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2I=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(L){L.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var T;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class g{static fromExtHostTestItem(R,b,E=R.parent){if(R._isRoot)return new g([b]);const w=[R.id];for(let A=E;A&&A.id!==b;A=A.parent)w.push(A.id);return w.push(b),new g(w.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const b=R.indexOf("\0");return b===-1?R:R.slice(0,b)}static fromString(R){return new g(R.split("\0"))}static join(R,b){return new g([...R.path,b])}static joinToString(R,b){return R.toString()+"\0"+b}static parentId(R){const b=R.lastIndexOf("\0");return b===-1?void 0:R.slice(0,b)}static localId(R){const b=R.lastIndexOf("\0");return b===-1?R:R.slice(b+1)}static isChild(R,b){return b.startsWith(R)&&b[R.length]==="\0"}static compare(R,b){return R===b?0:g.isChild(R,b)?2:g.isChild(b,R)?3:1}constructor(R,b=R.length){if(this.path=R,this.d=b,R.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new g(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new g(this.path,R)}compare(R){if(typeof R=="string")return g.compare(this.toString(),R);for(let b=0;b<R.d&&b<this.d;b++)if(R.path[b]!==this.path[b])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$2I=g}),define(De[88],Ce([1,0,2,34,67]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9I=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$8I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$7I=e.$6I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$5I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$4I=e.$3I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var R;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var b;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$3I=[2,4,8,16,32,64];const E=C=>"runId"in C;e.$4I=E;var w;(function(C){C.serialize=$=>({range:$.range.toJSON(),uri:$.uri.toJSON()}),C.deserialize=$=>({range:T.$ns.lift($.range),uri:D.URI.revive($.uri)})})(w||(e.IRichLocation=w={}));var A;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(A||(e.TestMessageType=A={}));var I;(function(C){C.serialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&w.serialize($.location)}),C.deserialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&w.deserialize($.location)})})(I||(e.ITestErrorMessage=I={}));const v=(C,$)=>`${$?"s":"e"}${C}`;e.$5I=v;var k;(function(C){C.serialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&w.serialize($.location)}),C.deserialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&w.deserialize($.location)})})(k||(e.ITestOutputMessage=k={}));var S;(function(C){C.serialize=$=>$.type===0?I.serialize($):k.serialize($),C.deserialize=$=>$.type===0?I.deserialize($):k.deserialize($)})(S||(e.ITestMessage=S={}));var p;(function(C){C.serializeWithoutMessages=$=>({state:$.state,duration:$.duration,messages:[]}),C.serialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(S.serialize)}),C.deserialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(S.deserialize)})})(p||(e.ITestTaskState=p={}));const u="\0",r=(C,$)=>C+u+$;e.$6I=r;const s=C=>{const $=C.indexOf(u);return{ctrlId:C.slice(0,$),tagId:C.slice($+1)}};e.$7I=s;var a;(function(C){C.serialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?.toJSON(),range:$.range?.toJSON()||null,description:$.description,error:$.error,sortText:$.sortText}),C.deserialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?D.URI.revive($.uri):void 0,range:$.range?T.$ns.lift($.range):null,description:$.description,error:$.error,sortText:$.sortText})})(a||(e.ITestItem=a={}));var m;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(m||(e.TestItemExpandState=m={}));var l;(function(C){C.serialize=$=>({expand:$.expand,item:a.serialize($.item)}),C.deserialize=$=>({controllerId:g.$2I.root($.item.extId),expand:$.expand,item:a.deserialize($.item)})})(l||(e.InternalTestItem=l={}));var t;(function(C){C.serialize=$=>{let f;return $.item&&(f={},$.item.label!==void 0&&(f.label=$.item.label),$.item.tags!==void 0&&(f.tags=$.item.tags),$.item.busy!==void 0&&(f.busy=$.item.busy),$.item.uri!==void 0&&(f.uri=$.item.uri?.toJSON()),$.item.range!==void 0&&(f.range=$.item.range?.toJSON()),$.item.description!==void 0&&(f.description=$.item.description),$.item.error!==void 0&&(f.error=$.item.error),$.item.sortText!==void 0&&(f.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:f}},C.deserialize=$=>{let f;return $.item&&(f={},$.item.label!==void 0&&(f.label=$.item.label),$.item.tags!==void 0&&(f.tags=$.item.tags),$.item.busy!==void 0&&(f.busy=$.item.busy),$.item.range!==void 0&&(f.range=$.item.range?T.$ns.lift($.item.range):null),$.item.description!==void 0&&(f.description=$.item.description),$.item.error!==void 0&&(f.error=$.item.error),$.item.sortText!==void 0&&(f.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:f}}})(t||(e.ITestItemUpdate=t={}));const n=(C,$)=>{$.expand!==void 0&&(C.expand=$.expand),$.item!==void 0&&(C.item=C.item?Object.assign(C.item,$.item):$.item)};e.$8I=n;var o;(function(C){C.serializeWithoutMessages=$=>({...l.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(p.serializeWithoutMessages)}),C.serialize=$=>({...l.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(p.serialize)}),C.deserialize=$=>({...l.deserialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(p.deserialize),retired:!0})})(o||(e.TestResultItem=o={}));var i;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(i||(e.DetailType=i={}));var c;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(c||(e.TestDiffOpType=c={}));var h;(function(C){C.deserialize=$=>$.op===0?{op:$.op,item:l.deserialize($.item)}:$.op===1?{op:$.op,item:t.deserialize($.item)}:$.op===2?{op:$.op,uri:D.URI.revive($.uri),docv:$.docv}:$,C.serialize=$=>$.op===0?{op:$.op,item:l.serialize($.item)}:$.op===1?{op:$.op,item:t.serialize($.item)}:$})(h||(e.TestsDiffOp=h={}));class y{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply($){const f=this.p();for(const d of $)switch(d.op){case 0:this.k(l.deserialize(d.item),f);break;case 1:this.l(t.deserialize(d.item),f);break;case 3:this.m(d.itemId,f);break;case 5:this.o(d.itemId);break;case 4:this.updatePendingRoots(d.amount);break;case 6:this.d.set(d.tag.id,d.tag);break;case 7:this.d.delete(d.id);break}f.complete?.()}k($,f){const d=g.$2I.parentId($.item.extId)?.toString();let P;if(!d)P=this.q($),this.g.add(P),this.f.set($.item.extId,P);else if(this.f.has(d)){const N=this.f.get(d);N.children.add($.item.extId),P=this.q($,N),this.f.set($.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify($)}`);return}return f.add?.(P),$.expand===2&&this.h++,P}l($,f){const d=this.f.get($.extId);if(d)return $.expand!==void 0&&(d.expand===2&&this.h--,$.expand===2&&this.h++),(0,e.$8I)(d,$),f.update?.(d),d}m($,f){const d=this.f.get($);if(!d)return;const P=g.$2I.parentId(d.item.extId)?.toString();P?this.f.get(P).children.delete(d.item.extId):this.g.delete(d);const N=[[$]];for(;N.length;)for(const O of N.pop()){const M=this.f.get(O);M&&(N.push(M.children),this.f.delete(O),f.remove?.(M,M!==d),M.expand===2&&this.h--)}}o($){}updatePendingRoots($){this.j+=$}p(){return{}}}e.$9I=y}),define(De[109],Ce([1,0,11,4,3,58,88,67]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.TestItemEventOp=void 0;var E;(function(s){s[s.Upsert=0]="Upsert",s[s.SetTags=1]="SetTags",s[s.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",s[s.RemoveChild=3]="RemoveChild",s[s.SetProp=4]="SetProp",s[s.Bulk=5]="Bulk",s[s.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const w=(s,a)=>s===a,I=Object.entries({range:(s,a)=>s===a?!0:!s||!a?!1:s.equalsRange(a),busy:w,label:w,description:w,error:w,sortText:w,tags:(s,a)=>!(s.length!==a.length||s.some(m=>!a.includes(m)))}),v=(s,a)=>{let m;for(const[l,t]of I)t(s[l],a[l])||(m?m[l]=a[l]:m={[l]:a[l]});return m};class k extends g.$Rc{get root(){return this.s.root}constructor(a){super(),this.s=a,this.f=this.B(new D.$5g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Md),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(a){this.h=a;for(const m of this.tree.values())this.I(m)}get resolveHandler(){return this.h}collectDiff(){const a=this.m;return this.m=[],a}pushDiff(a){switch(a.op){case 2:{for(const m of this.m)if(m.op===2&&m.uri===a.uri){m.docv=a.docv;return}break}case 1:{const m=this.m[this.m.length-1];if(m){if(m.op===1&&m.item.extId===a.item.extId){(0,R.$8I)(m.item,a.item);return}if(m.op===0&&m.item.item.extId===a.item.extId){(0,R.$8I)(m.item,a.item);return}}break}}this.m.push(a),this.f.isScheduled()||this.f.schedule()}expand(a,m){const l=this.tree.get(a);if(l){if((l.expandLevels===void 0||m>l.expandLevels)&&(l.expandLevels=m),l.expand===1){const t=this.L(l);return t.isOpen()?this.J(l,m-1):t.wait().then(()=>this.J(l,m-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.J(l,m-1)):this.J(l,m-1)}}dispose(){for(const a of this.tree.values())this.s.getApiFor(a.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(a,m){switch(m.op){case 3:this.N(b.$2I.joinToString(a.fullId,m.id));break;case 0:this.y(m.item,a);break;case 5:for(const l of m.ops)this.u(a,l);break;case 1:this.z(m.new,m.old,a.fullId.toString());break;case 2:this.I(a);break;case 4:this.pushDiff({op:1,item:{extId:a.fullId.toString(),item:m.update}});break;case 6:this.w(a.actual.uri);break;default:(0,L.$3c)(m)}}w(a){a&&this.pushDiff({op:2,uri:a,docv:this.s.getDocumentVersion(a)})}y(a,m){const l=b.$2I.fromExtHostTestItem(a,this.root.id,m?.actual),t=this.s.getApiFor(a);t.parent&&t.parent!==m?.actual&&this.s.getChildren(t.parent).delete(a.id);let n=this.tree.get(l.toString());if(!n){n={fullId:l,actual:a,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},a.tags.forEach(this.C,this),this.tree.set(n.fullId.toString(),n),this.F(a,m),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(a)}}),this.H(a,n,m);return}if(n.actual===a){this.G(a,n,m);return}if(n.actual.uri?.toString()!==a.uri?.toString())return this.N(l.toString()),this.y(a,m);const o=this.s.getChildren(n.actual),i=n.actual,c=v(this.s.toITestItem(i),this.s.toITestItem(a));this.s.getApiFor(i).listener=void 0,n.actual=a,n.expand=0,c&&(c.hasOwnProperty("tags")&&(this.z(a.tags,i.tags,l.toString()),delete c.tags),this.u(n,{op:4,update:c})),this.H(a,n,m);for(const[h,y]of o)this.s.getChildren(a).get(y.id)||this.N(b.$2I.joinToString(l,y.id));this.w(n.actual.uri)}z(a,m,l){const t=new Set(m.map(n=>n.id));for(const n of a)t.delete(n.id)||this.C(n);this.pushDiff({op:1,item:{extId:l,item:{tags:a.map(n=>(0,R.$6I)(this.s.controllerId,n.id))}}}),t.forEach(this.D,this)}C(a){const m=this.j.get(a.id);m?m.refCount++:(this.j.set(a.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$6I)(this.s.controllerId,a.id)}}))}D(a){const m=this.j.get(a);m&&!--m.refCount&&(this.j.delete(a),this.pushDiff({op:7,id:(0,R.$6I)(this.s.controllerId,a)}))}F(a,m){this.s.getApiFor(a).parent=m&&m.actual!==this.root?m.actual:void 0}G(a,m,l){this.F(a,l);const t=this.s.getApiFor(a);t.parent=l?.actual,t.listener=n=>this.u(m,n),this.I(m)}H(a,m,l){this.G(a,m,l);for(const[t,n]of this.s.getChildren(a))this.y(n,m)}I(a){let m;this.h?a.resolveBarrier?m=a.resolveBarrier.isOpen()?3:2:m=a.actual.canResolveChildren?1:0:m=0,m!==a.expand&&(a.expand=m,this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:m}}),m===1&&a.expandLevels!==void 0&&this.L(a))}J(a,m){if(m<0)return;const l=[];for(const[t,n]of this.s.getChildren(a.actual)){const o=this.expand(b.$2I.joinToString(a.fullId,n.id),m);(0,D.$Fg)(o)&&l.push(o)}if(l.length)return Promise.all(l).then(()=>{})}L(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this.h){const n=new D.$Rg;return n.open(),n}a.expand=2,this.M(a);const m=a.resolveBarrier=new D.$Rg,l=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let t;try{t=this.h(a.actual===this.root?void 0:a.actual)}catch(n){l(n)}return(0,D.$Fg)(t)?t.catch(l).then(()=>{m.open(),this.I(a)}):(m.open(),this.I(a)),a.resolveBarrier}M(a){this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:a.expand}})}N(a){const m=this.tree.get(a);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:a});const l=[m];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.D(n.id);this.tree.delete(t.fullId.toString());for(const[n,o]of this.s.getChildren(t.actual))l.push(this.tree.get(b.$2I.joinToString(t.fullId,o.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.g.fire(a)}}e.$ZL=k;class S extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.$1L=S;class p extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$2L=p;class u extends Error{constructor(a,m,l){super(`TestItem with ID "${a}" is from controller "${m}" and cannot be added as a child of an item from controller "${l}".`)}}e.$3L=u;const r=(s,a,m)=>{let l=new Map;return{get size(){return l.size},forEach(t,n){for(const o of l.values())t.call(n,o,this)},[Symbol.iterator](){return l.entries()},replace(t){const n=new Map,o=new Set(l.keys()),i={op:5,ops:[]};for(const c of t){if(!(c instanceof m))throw new p(c.id);const h=a(c).controllerId;if(h!==s.controllerId)throw new u(c.id,h,s.controllerId);if(n.has(c.id))throw new S(c.id);n.set(c.id,c),o.delete(c.id),i.ops.push({op:0,item:c})}for(const c of o.keys())i.ops.push({op:3,id:c});s.listener?.(i),l=n},add(t){if(!(t instanceof m))throw new p(t.id);l.set(t.id,t),s.listener?.({op:0,item:t})},delete(t){l.delete(t)&&s.listener?.({op:3,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$4L=r}),define(De[142],Ce([1,0,109]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=void 0;const T=new WeakMap,g=(R,b)=>{const E={controllerId:b};return T.set(R,E),E};e.$5L=g;const L=R=>{const b=T.get(R);if(!b)throw new D.$2L(R?.id||"<unknown>");return b};e.$6L=L}),define(De[110],Ce([1,0,17,2]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wob=e.$Vob=e.$Uob=e.$Tob=e.$Sob=void 0,e.$Sob="vscode-cdn.net",e.$Tob=`vscode-resource.${e.$Sob}`,e.$Uob=`'self' https://*.${e.$Sob}`;function g(b,E){return b.scheme===D.Schemas.http||b.scheme===D.Schemas.https?b:(E&&E.authority&&E.isRemote&&b.scheme===D.Schemas.file&&(b=T.URI.from({scheme:D.Schemas.vscodeRemote,authority:E.authority,path:b.path})),T.URI.from({scheme:D.Schemas.https,authority:`${b.scheme}+${L(b.authority)}.${e.$Tob}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$Vob=g;function L(b){return b.replace(/./g,E=>{const w=E.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?E:"-"+w.toString(16).padStart(4,"0")})}function R(b){return b.replace(/-([0-9a-f]{4})/g,(E,w)=>String.fromCharCode(parseInt(w,16)))}e.$Wob=R}),define(De[276],Ce([1,0,4,3,110]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;class L{constructor(b,E,w){this.d=b,this.e=E,this.f=w,this.a=0,this.b=new T.$Qc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const A=E.getVisibleTextEditors();for(const I of this.c.values())A.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,E,w,A,I){let v;for(const a of this.e.getVisibleTextEditors(!0))if(a.value===b){v=a;break}if(!v)throw new Error("not a visible editor");const k=this,S=this.a++,p=new D.$Md,u=new D.$Md,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(a){return(0,g.$Vob)(a,k.f)}get cspSource(){return g.$Uob}set options(a){this.b=a,k.d.$setOptions(S,a)}get options(){return this.b}set html(a){this.a=a,k.d.$setHtml(S,a)}get html(){return this.a}get onDidReceiveMessage(){return p.event}postMessage(a){return k.d.$postMessage(S,a)}},s=new class{constructor(){this.editor=b,this.line=E,this.height=w,this.webview=r,this.onDidDispose=u.event}dispose(){k.c.has(S)&&(k.c.delete(S),k.d.$disposeEditorInset(S),u.fire(),u.dispose(),p.dispose())}};return this.d.$createEditorInset(S,v.id,v.value.document.uri,E+1,w,A||{},I.identifier,I.extensionLocation),this.c.set(S,{editor:b,inset:s,onDidReceiveMessage:p}),s}$onDidDispose(b){const E=this.c.get(b);E&&E.inset.dispose()}$onDidReceiveMessage(b,E){this.c.get(b)?.onDidReceiveMessage.fire(E)}}e.$Lcc=L}),define(De[277],Ce([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.VariableKind=e.$VM=void 0,e.$VM=(0,D.$Nh)("configurationResolverService");var T;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class g extends Error{constructor(R,b){super(b),this.variable=R}}e.$WM=g}),define(De[278],Ce([1,0,16,47,18,23,12,100,223,277,15]),function($e,e,D,T,g,L,R,b,E,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,S,p,u){this.h=new Map,this.a=k,this.b=S,this.g=p,u&&(this.c=u.then(r=>this.i(r)))}i(k){if(R.$j){const S=Object.create(null);return Object.keys(k).forEach(p=>{S[p.toLowerCase()]=k[p]}),S}return k}resolveWithEnvironment(k,S,p){return this.l({env:this.i(k),userHome:void 0},S?S.uri:void 0,p)}async resolveAsync(k,S){const p={env:await this.c,userHome:await this.g};return this.l(p,k?k.uri:void 0,S)}async j(k,S,p,u){const r=L.$Ym(S);R.$j&&r.windows?Object.keys(r.windows).forEach(a=>r[a]=r.windows[a]):R.$k&&r.osx?Object.keys(r.osx).forEach(a=>r[a]=r.osx[a]):R.$l&&r.linux&&Object.keys(r.linux).forEach(a=>r[a]=r.linux[a]),delete r.windows,delete r.osx,delete r.linux;const s={env:await this.c,userHome:await this.g};return this.l(s,k?k.uri:void 0,r,p,u)}async resolveAnyAsync(k,S,p){return this.j(k,S,p)}async resolveAnyMap(k,S,p){const u=new Map;return{newConfig:await this.j(k,S,p,u),resolvedVariables:u}}resolveWithInteractionReplace(k,S,p,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,S,p,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,S){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,S)}async l(k,S,p,u,r){if(g.$xf(p))return this.m(k,S,p,u,r);if(Array.isArray(p))return Promise.all(p.map(s=>this.l(k,S,s,u,r)));if(g.$zf(p)){const s=Object.create(null),a=await Promise.all(Object.keys(p).map(async m=>[await this.m(k,S,m,u,r),await this.l(k,S,p[m],u,r)]));for(const[m,l]of a)s[m]=l;return s}return p}m(k,S,p,u,r){return(0,A.$Se)(p,I.VARIABLE_REGEXP,async(s,a)=>{if(a.includes(I.VARIABLE_LHS))return s;let m=await this.o(k,s,a,S,u);return r?.set(a,m),m!==s&&g.$xf(m)&&m.match(I.VARIABLE_REGEXP)&&(m=await this.m(k,S,m,u,r)),m})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,S,p,u,r){let s;const a=p.split(":");a.length>1&&(p=a[0],s=a[1]);const m=n=>{const o=this.a.getFilePath();if(o)return(0,b.$lv)(o);throw new w.$WM(n,(0,E.localize)(0,null,S))},l=n=>{const o=m(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,b.$lv)(i)}throw new w.$WM(n,(0,E.localize)(1,null,S,D.$mc(o)))},t=n=>{if(s){const o=this.a.getFolderUri(s);if(o)return o;throw new w.$WM(n,(0,E.localize)(2,null,S,s))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new w.$WM(n,(0,E.localize)(3,null,S)):new w.$WM(n,(0,E.localize)(4,null,S))};switch(p){case"env":if(s){if(k.env){const n=k.env[R.$j?s.toLowerCase():s];if(g.$xf(n))return n}return""}throw new w.$WM(w.VariableKind.Env,(0,E.localize)(5,null,S));case"config":if(s){const n=this.a.getConfigurationValue(u,s);if(g.$Gf(n))throw new w.$WM(w.VariableKind.Config,(0,E.localize)(6,null,S,s));if(g.$zf(n))throw new w.$WM(w.VariableKind.Config,(0,E.localize)(7,null,S,s));return n}throw new w.$WM(w.VariableKind.Config,(0,E.localize)(8,null,S));case"command":return this.p(w.VariableKind.Command,S,s,r,"command");case"input":return this.p(w.VariableKind.Input,S,s,r,"input");case"extensionInstallFolder":if(s){const n=await this.a.getExtension(s);if(!n)throw new w.$WM(w.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,S,s));return this.n(n.extensionLocation)}throw new w.$WM(w.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,S));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,b.$lv)(this.n(t(w.VariableKind.WorkspaceFolder)));case"cwd":return u||s?(0,b.$lv)(this.n(t(w.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$lv)(D.$mc(this.n(t(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new w.$WM(w.VariableKind.UserHome,(0,E.localize)(11,null,S))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new w.$WM(w.VariableKind.LineNumber,(0,E.localize)(12,null,S))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new w.$WM(w.VariableKind.SelectedText,(0,E.localize)(13,null,S))}case"file":return m(w.VariableKind.File);case"fileWorkspaceFolder":return l(w.VariableKind.FileWorkspaceFolder);case"relativeFile":return u||s?D.$kc(this.n(t(w.VariableKind.RelativeFile)),m(w.VariableKind.RelativeFile)):m(w.VariableKind.RelativeFile);case"relativeFileDirname":{const n=D.$lc(m(w.VariableKind.RelativeFileDirname));if(u||s){const o=D.$kc(this.n(t(w.VariableKind.RelativeFileDirname)),n);return o.length===0?".":o}return n}case"fileDirname":return D.$lc(m(w.VariableKind.FileDirname));case"fileExtname":return D.$nc(m(w.VariableKind.FileExtname));case"fileBasename":return D.$mc(m(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=D.$mc(m(w.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-D.$nc(n).length)}case"fileDirnameBasename":return D.$mc(D.$lc(m(w.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||S}case"execInstallFolder":{const n=this.a.getAppRoot();return n||S}case"pathSeparator":return D.sep;default:try{const n=s?`${p}:${s}`:p;return this.p(w.VariableKind.Unknown,S,n,r,void 0)}catch{return S}}}}p(k,S,p,u,r){if(p&&u){const s=r===void 0?u[p]:u[r+":"+p];if(typeof s=="string")return s;throw new w.$WM(k,(0,E.localize)(14,null,S))}return S}}e.$$M=I}),define(De[143],Ce([1,0,5,139]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=e.$_B=e.OpenEditorContext=e.GroupsOrder=e.$$B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$0B=void 0,e.$0B=(0,D.$Nh)("editorGroupsService");var g;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var L;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var b;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EVEN=1]="EVEN",S[S.TOGGLE=2]="TOGGLE"})(b||(e.GroupsArrangement=b={}));var E;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function w(S){const p=S;return(0,T.$ZD)(p?.editor)&&(0,T.$ZD)(p?.replacement)}e.$$B=w;var A;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var I;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function v(S){const p=S;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.$_B=v;function k(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$aC=k}),define(De[279],Ce([1,0,5,143]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=e.$dC=e.$cC=e.$bC=void 0,e.$bC=(0,D.$Nh)("editorService"),e.$cC=-1,e.$dC=-2;function g(L){const R=L;return typeof L=="number"||(0,T.$_B)(R)}e.$eC=g}),define(De[14],Ce([1,0,19,22,162,74,79,28,158,62,98,23,18,2,34,82,133,142,139,108,67,88,279,7]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m,l,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$9L=e.$8L=e.MarkdownString=e.$7L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(Me){function Te(se){const{selectionStartLineNumber:Ne,selectionStartColumn:Ke,positionLineNumber:_e,positionColumn:Je}=se,nt=new n.$_J(Ne-1,Ke-1),bt=new n.$_J(_e-1,Je-1);return new n.$bK(nt,bt)}Me.to=Te;function Se(se){const{anchor:Ne,active:Ke}=se;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}Me.from=Se})(o||(e.Selection=o={}));var i;(function(Me){function Te(se){if(!se)return;const{start:Ne,end:Ke}=se;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}Me.from=Te;function Se(se){if(!se)return;const{startLineNumber:Ne,startColumn:Ke,endLineNumber:_e,endColumn:Je}=se;return new n.$aK(Ne-1,Ke-1,_e-1,Je-1)}Me.to=Se})(i||(e.Range=i={}));var c;(function(Me){function Te(Se){switch(Se){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Me.to=Te})(c||(e.TokenType=c={}));var h;(function(Me){function Te(se){return new n.$_J(se.lineNumber-1,se.column-1)}Me.to=Te;function Se(se){return{lineNumber:se.line+1,column:se.character+1}}Me.from=Se})(h||(e.Position=h={}));var y;(function(Me){function Te(Ne,Ke,_e){return(0,D.$Gb)((0,D.$2b)(Ne).map(Je=>Se(Je,Ke,_e)))}Me.from=Te;function Se(Ne,Ke,_e){if(typeof Ne=="string")return{$serialized:!0,language:Ne,isBuiltin:_e?.isBuiltin};if(Ne)return{$serialized:!0,language:Ne.language,scheme:se(Ne.scheme,Ke),pattern:Ye.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType,isBuiltin:_e?.isBuiltin}}function se(Ne,Ke){return Ke&&typeof Ne=="string"?Ke.transformOutgoingScheme(Ne):Ne}})(y||(e.DocumentSelector=y={}));var C;(function(Me){function Te(se){switch(se){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Se(se){switch(se){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Me.to=Se})(C||(e.DiagnosticTag=C={}));var $;(function(Me){function Te(se){let Ne;return se.code&&((0,v.$xf)(se.code)||(0,v.$Bf)(se.code)?Ne=String(se.code):Ne={value:String(se.code.value),target:se.code.target}),{...i.from(se.range),message:se.message,source:se.source,code:Ne,severity:d.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(f.from),tags:Array.isArray(se.tags)?(0,D.$Gb)(se.tags.map(C.from)):void 0}}Me.from=Te;function Se(se){const Ne=new n.$mK(i.to(se),se.message,d.to(se.severity));return Ne.source=se.source,Ne.code=(0,v.$xf)(se.code)?se.code:se.code?.value,Ne.relatedInformation=se.relatedInformation&&se.relatedInformation.map(f.to),Ne.tags=se.tags&&(0,D.$Gb)(se.tags.map(C.to)),Ne}Me.to=Se})($||(e.Diagnostic=$={}));var f;(function(Me){function Te(se){return{...i.from(se.location.range),message:se.message,resource:se.location.uri}}Me.from=Te;function Se(se){return new n.$lK(new n.$kK(se.resource,i.to(se)),se.message)}Me.to=Se})(f||(e.DiagnosticRelatedInformation=f={}));var d;(function(Me){function Te(se){switch(se){case n.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Me.from=Te;function Se(se){switch(se){case u.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Me.to=Se})(d||(e.DiagnosticSeverity=d={}));var P;(function(Me){function Te(se){return typeof se=="number"&&se>=n.ViewColumn.One?se-1:se===n.ViewColumn.Beside?t.$dC:t.$cC}Me.from=Te;function Se(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Se})(P||(e.ViewColumn=P={}));function N(Me){return typeof Me.range<"u"}function O(Me){return Me.length===0?!0:!!N(Me[0])}e.$7L=O;var M;(function(Me){function Te(Je){return Je.map(Me.from)}Me.fromMany=Te;function Se(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function se(Je){let nt;if(Se(Je)){const{language:gt,value:mt}=Je;nt={value:"```"+gt+`
`+mt+"\n```\n"}}else n.$yK.isMarkdownString(Je)?nt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?nt={value:Je}:nt={value:""};const bt=Object.create(null);nt.uris=bt;const vt=gt=>{try{let mt=k.URI.parse(gt,!0);mt=mt.with({query:Ne(mt.query,bt)}),bt[gt]=mt}catch{}return""},ft=new E.marked.Renderer;return ft.link=vt,ft.image=gt=>typeof gt=="string"?vt(R.$8j(gt).href):"",(0,E.marked)(nt.value,{renderer:ft}),nt}Me.from=se;function Ne(Je,nt){if(!Je)return Je;let bt;try{bt=(0,w.$jh)(Je)}catch{}if(!bt)return Je;let vt=!1;return bt=(0,I.$1m)(bt,ft=>{if(k.URI.isUri(ft)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[gt]=ft,vt=!0,gt}else return}),vt?JSON.stringify(bt):Je}function Ke(Je){const nt=new n.$yK(Je.value,Je.supportThemeIcons);return nt.isTrusted=Je.isTrusted,nt.supportHtml=Je.supportHtml,nt.baseUri=Je.baseUri?k.URI.from(Je.baseUri):void 0,nt}Me.to=Ke;function _e(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=_e})(M||(e.MarkdownString=M={}));function j(Me){return O(Me)?Me.map(Te=>({range:i.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?M.fromMany(Te.hoverMessage):Te.hoverMessage?M.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:i.from(Te)}))}e.$8L=j;function U(Me){return typeof Me>"u"?Me:typeof Me=="string"?k.URI.file(Me):Me}e.$9L=U;var F;(function(Me){function Te(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?U(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Me.from=Te})(F||(e.ThemableDecorationAttachmentRenderOptions=F={}));var V;(function(Me){function Te(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?U(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?F.from(Se.before):void 0,after:Se.after?F.from(Se.after):void 0}}Me.from=Te})(V||(e.ThemableDecorationRenderOptions=V={}));var H;(function(Me){function Te(Se){if(typeof Se>"u")return Se;switch(Se){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(H||(e.DecorationRangeBehavior=H={}));var fe;(function(Me){function Te(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?H.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?V.from(Se.light):void 0,dark:Se.dark?V.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?U(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?F.from(Se.before):void 0,after:Se.after?F.from(Se.after):void 0}}Me.from=Te})(fe||(e.DecorationRenderOptions=fe={}));var X;(function(Me){function Te(se){return{text:se.newText,eol:se.newEol&&et.from(se.newEol),range:i.from(se.range)}}Me.from=Te;function Se(se){const Ne=new n.$fK(i.to(se.range),se.text);return Ne.newEol=typeof se.eol>"u"?void 0:et.to(se.eol),Ne}Me.to=Se})(X||(e.TextEdit=X={}));var Y;(function(Me){function Te(se,Ne){const Ke={edits:[]};if(se instanceof n.$iK){const _e=new b.$Ac;for(const Je of se._allEntries())Je._type===1&&k.URI.isUri(Je.to)&&Je.from===void 0&&_e.add(Je.to);for(const Je of se._allEntries())if(Je._type===1){let nt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?nt={type:"base64",value:(0,T.$ue)(T.$ae.wrap(Je.options.contents))}:nt={type:"dataTransferItem",id:Je.options.contents._itemId}),Ke.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:nt},metadata:Je.metadata})}else Je._type===2?Ke.edits.push({resource:Je.uri,textEdit:X.from(Je.edit),versionId:_e.has(Je.uri)?void 0:Ne?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Ke.edits.push({resource:Je.uri,textEdit:{range:i.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:_e.has(Je.uri)?void 0:Ne?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Ke.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Ke.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(ot.from)}})}return Ke}Me.from=Te;function Se(se){const Ne=new n.$iK,Ke=new b.$zc;for(const _e of se.edits)if(_e.textEdit){const Je=_e,nt=k.URI.revive(Je.resource),bt=i.to(Je.textEdit.range),vt=Je.textEdit.text,ft=Je.textEdit.insertAsSnippet;let gt;ft?gt=n.$hK.replace(bt,new n.$jK(vt)):gt=n.$fK.replace(bt,vt);const mt=Ke.get(nt);mt?mt.push(gt):Ke.set(nt,[gt])}else Ne.renameFile(k.URI.revive(_e.oldResource),k.URI.revive(_e.newResource),_e.options);for(const[_e,Je]of Ke)Ne.set(_e,Je);return Ne}Me.to=Se})(Y||(e.WorkspaceEdit=Y={}));var q;(function(Me){const Te=Object.create(null);Te[n.SymbolKind.File]=0,Te[n.SymbolKind.Module]=1,Te[n.SymbolKind.Namespace]=2,Te[n.SymbolKind.Package]=3,Te[n.SymbolKind.Class]=4,Te[n.SymbolKind.Method]=5,Te[n.SymbolKind.Property]=6,Te[n.SymbolKind.Field]=7,Te[n.SymbolKind.Constructor]=8,Te[n.SymbolKind.Enum]=9,Te[n.SymbolKind.Interface]=10,Te[n.SymbolKind.Function]=11,Te[n.SymbolKind.Variable]=12,Te[n.SymbolKind.Constant]=13,Te[n.SymbolKind.String]=14,Te[n.SymbolKind.Number]=15,Te[n.SymbolKind.Boolean]=16,Te[n.SymbolKind.Array]=17,Te[n.SymbolKind.Object]=18,Te[n.SymbolKind.Key]=19,Te[n.SymbolKind.Null]=20,Te[n.SymbolKind.EnumMember]=21,Te[n.SymbolKind.Struct]=22,Te[n.SymbolKind.Event]=23,Te[n.SymbolKind.Operator]=24,Te[n.SymbolKind.TypeParameter]=25;function Se(Ne){return typeof Te[Ne]=="number"?Te[Ne]:6}Me.from=Se;function se(Ne){for(const Ke in Te)if(Te[Ke]===Ne)return Number(Ke);return n.SymbolKind.Property}Me.to=se})(q||(e.SymbolKind=q={}));var x;(function(Me){function Te(se){switch(se){case n.SymbolTag.Deprecated:return 1}}Me.from=Te;function Se(se){switch(se){case 1:return n.SymbolTag.Deprecated}}Me.to=Se})(x||(e.SymbolTag=x={}));var me;(function(Me){function Te(se){return{name:se.name,kind:q.from(se.kind),tags:se.tags&&se.tags.map(x.from),containerName:se.containerName,location:K.from(se.location)}}Me.from=Te;function Se(se){const Ne=new n.$pK(se.name,q.to(se.kind),se.containerName,K.to(se.location));return Ne.tags=se.tags&&se.tags.map(x.to),Ne}Me.to=Se})(me||(e.WorkspaceSymbol=me={}));var ue;(function(Me){function Te(se){const Ne={name:se.name||"!!MISSING: name!!",detail:se.detail,range:i.from(se.range),selectionRange:i.from(se.selectionRange),kind:q.from(se.kind),tags:se.tags?.map(x.from)??[]};return se.children&&(Ne.children=se.children.map(Te)),Ne}Me.from=Te;function Se(se){const Ne=new n.$qK(se.name,se.detail,q.to(se.kind),i.to(se.range),i.to(se.selectionRange));return(0,D.$Kb)(se.tags)&&(Ne.tags=se.tags.map(x.to)),se.children&&(Ne.children=se.children.map(Se)),Ne}Me.to=Se})(ue||(e.DocumentSymbol=ue={}));var pe;(function(Me){function Te(se){const Ne=new n.$uK(q.to(se.kind),se.name,se.detail||"",k.URI.revive(se.uri),i.to(se.range),i.to(se.selectionRange));return Ne._sessionId=se._sessionId,Ne._itemId=se._itemId,Ne}Me.to=Te;function Se(se,Ne,Ke){if(Ne=Ne??se._sessionId,Ke=Ke??se._itemId,Ne===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Ke,name:se.name,detail:se.detail,kind:q.from(se.kind),uri:se.uri,range:i.from(se.range),selectionRange:i.from(se.selectionRange),tags:se.tags?.map(x.from)}}Me.from=Se})(pe||(e.CallHierarchyItem=pe={}));var G;(function(Me){function Te(Se){return new n.$vK(pe.to(Se.from),Se.fromRanges.map(se=>i.to(se)))}Me.to=Te})(G||(e.CallHierarchyIncomingCall=G={}));var z;(function(Me){function Te(Se){return new n.$wK(pe.to(Se.to),Se.fromRanges.map(se=>i.to(se)))}Me.to=Te})(z||(e.CallHierarchyOutgoingCall=z={}));var K;(function(Me){function Te(se){return{range:se.range&&i.from(se.range),uri:se.uri}}Me.from=Te;function Se(se){return new n.$kK(k.URI.revive(se.uri),i.to(se.range))}Me.to=Se})(K||(e.location=K={}));var ge;(function(Me){function Te(se){const Ne=se,Ke=se;return{originSelectionRange:Ne.originSelectionRange?i.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Ke.uri,range:i.from(Ne.targetRange?Ne.targetRange:Ke.range),targetSelectionRange:Ne.targetSelectionRange?i.from(Ne.targetSelectionRange):void 0}}Me.from=Te;function Se(se){return{targetUri:k.URI.revive(se.uri),targetRange:i.to(se.range),targetSelectionRange:se.targetSelectionRange?i.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?i.to(se.originSelectionRange):void 0}}Me.to=Se})(ge||(e.DefinitionLink=ge={}));var _;(function(Me){function Te(se){return{range:i.from(se.range),contents:M.fromMany(se.contents)}}Me.from=Te;function Se(se){return new n.$nK(se.contents.map(M.to),i.to(se.range))}Me.to=Se})(_||(e.Hover=_={}));var ie;(function(Me){function Te(se){return{range:i.from(se.range),expression:se.expression}}Me.from=Te;function Se(se){return new n.$gL(i.to(se.range),se.expression)}Me.to=Se})(ie||(e.EvaluatableExpression=ie={}));var ne;(function(Me){function Te(se){if(se instanceof n.$hL)return{type:"text",range:i.from(se.range),text:se.text};if(se instanceof n.$iL)return{type:"variable",range:i.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof n.$jL)return{type:"expression",range:i.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Se(se){switch(se.type){case"text":return{range:i.to(se.range),text:se.text};case"variable":return{range:i.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:i.to(se.range),expression:se.expression}}}Me.to=Se})(ne||(e.InlineValue=ne={}));var Ee;(function(Me){function Te(se){return{frameId:se.frameId,stoppedLocation:i.from(se.stoppedLocation)}}Me.from=Te;function Se(se){return new n.$kL(se.frameId,i.to(se.stoppedLocation))}Me.to=Se})(Ee||(e.InlineValueContext=Ee={}));var oe;(function(Me){function Te(se){return{range:i.from(se.range),kind:se.kind}}Me.from=Te;function Se(se){return new n.$oK(i.to(se.range),se.kind)}Me.to=Se})(oe||(e.DocumentHighlight=oe={}));var he;(function(Me){function Te(Se){switch(Se){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Me.to=Te})(he||(e.CompletionTriggerKind=he={}));var ee;(function(Me){function Te(Se){return{triggerKind:he.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Me.to=Te})(ee||(e.CompletionContext=ee={}));var le;(function(Me){function Te(se){switch(se){case n.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Se(se){switch(se){case 1:return n.CompletionItemTag.Deprecated}}Me.to=Se})(le||(e.CompletionItemTag=le={}));var be;(function(Me){const Te=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function Se(Ke){return Te.get(Ke)??9}Me.from=Se;const se=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Ne(Ke){return se.get(Ke)??n.CompletionItemKind.Property}Me.to=Ne})(be||(e.CompletionItemKind=be={}));var Pe;(function(Me){function Te(Se,se){const Ne=new n.$EK(Se.label);return Ne.insertText=Se.insertText,Ne.kind=be.to(Se.kind),Ne.tags=Se.tags?.map(le.to),Ne.detail=Se.detail,Ne.documentation=R.$3j(Se.documentation)?M.to(Se.documentation):Se.documentation,Ne.sortText=Se.sortText,Ne.filterText=Se.filterText,Ne.preselect=Se.preselect,Ne.commitCharacters=Se.commitCharacters,S.$ns.isIRange(Se.range)?Ne.range=i.to(Se.range):typeof Se.range=="object"&&(Ne.range={inserting:i.to(Se.range.insert),replacing:i.to(Se.range.replace)}),Ne.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Ne.insertText=new n.$jK(Se.insertText):(Ne.insertText=Se.insertText,Ne.textEdit=Ne.range instanceof n.$aK?new n.$fK(Ne.range,Ne.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Se.additionalTextEdits.map(Ke=>X.to(Ke))),Ne.command=se&&Se.command?se.fromInternal(Se.command):void 0,Ne}Me.to=Te})(Pe||(e.CompletionItem=Pe={}));var B;(function(Me){function Te(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:M.fromStrict(se.documentation)}}Me.from=Te;function Se(se){return{label:se.label,documentation:R.$3j(se.documentation)?M.to(se.documentation):se.documentation}}Me.to=Se})(B||(e.ParameterInformation=B={}));var Q;(function(Me){function Te(se){return{label:se.label,documentation:M.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(B.from):[],activeParameter:se.activeParameter}}Me.from=Te;function Se(se){return{label:se.label,documentation:R.$3j(se.documentation)?M.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(B.to):[],activeParameter:se.activeParameter}}Me.to=Se})(Q||(e.SignatureInformation=Q={}));var te;(function(Me){function Te(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(Q.from):[]}}Me.from=Te;function Se(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(Q.to):[]}}Me.to=Se})(te||(e.SignatureHelp=te={}));var re;(function(Me){function Te(Se,se){const Ne=new n.$DK(h.to(se.position),typeof se.label=="string"?se.label:se.label.map(Z.to.bind(void 0,Se)),se.kind&&de.to(se.kind));return Ne.textEdits=se.textEdits&&se.textEdits.map(X.to),Ne.tooltip=R.$3j(se.tooltip)?M.to(se.tooltip):se.tooltip,Ne.paddingLeft=se.paddingLeft,Ne.paddingRight=se.paddingRight,Ne}Me.to=Te})(re||(e.InlayHint=re={}));var Z;(function(Me){function Te(Se,se){const Ne=new n.$CK(se.label);return Ne.tooltip=R.$3j(se.tooltip)?M.to(se.tooltip):se.tooltip,p.Command.is(se.command)&&(Ne.command=Se.fromInternal(se.command)),se.location&&(Ne.location=K.to(se.location)),Ne}Me.to=Te})(Z||(e.InlayHintLabelPart=Z={}));var de;(function(Me){function Te(se){return se}Me.from=Te;function Se(se){return se}Me.to=Se})(de||(e.InlayHintKind=de={}));var ye;(function(Me){function Te(se){return{range:i.from(se.range),url:se.target,tooltip:se.tooltip}}Me.from=Te;function Se(se){let Ne;if(se.url)try{Ne=typeof se.url=="string"?k.URI.parse(se.url,!0):k.URI.revive(se.url)}catch{}return new n.$JK(i.to(se.range),Ne)}Me.to=Se})(ye||(e.DocumentLink=ye={}));var je;(function(Me){function Te(se){const Ne=new n.$MK(se.label);return se.textEdit&&(Ne.textEdit=X.to(se.textEdit)),se.additionalTextEdits&&(Ne.additionalTextEdits=se.additionalTextEdits.map(Ke=>X.to(Ke))),Ne}Me.to=Te;function Se(se){return{label:se.label,textEdit:se.textEdit?X.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Ne=>X.from(Ne)):void 0}}Me.from=Se})(je||(e.ColorPresentation=je={}));var We;(function(Me){function Te(se){return new n.$KK(se[0],se[1],se[2],se[3])}Me.to=Te;function Se(se){return[se.red,se.green,se.blue,se.alpha]}Me.from=Se})(We||(e.Color=We={}));var xe;(function(Me){function Te(se){return{range:i.from(se.range)}}Me.from=Te;function Se(se){return new n.$tK(i.to(se.range))}Me.to=Se})(xe||(e.SelectionRange=xe={}));var Ze;(function(Me){function Te(Se){switch(Se){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Me.to=Te})(Ze||(e.TextDocumentSaveReason=Ze={}));var it;(function(Me){function Te(se){switch(se){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Se(se){switch(se){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Me.to=Se})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Me){function Te(se){if(se===n.EndOfLine.CRLF)return 1;if(se===n.EndOfLine.LF)return 0}Me.from=Te;function Se(se){if(se===1)return n.EndOfLine.CRLF;if(se===0)return n.EndOfLine.LF}Me.to=Se})(et||(e.EndOfLine=et={}));var Ae;(function(Me){function Te(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(Ae||(e.ProgressLocation=Ae={}));var Fe;(function(Me){function Te(se){const Ne={start:se.start+1,end:se.end+1};return se.kind&&(Ne.kind=qe.from(se.kind)),Ne}Me.from=Te;function Se(se){const Ne={start:se.start-1,end:se.end-1};return se.kind&&(Ne.kind=qe.to(se.kind)),Ne}Me.to=Se})(Fe||(e.FoldingRange=Fe={}));var qe;(function(Me){function Te(se){if(se)switch(se){case n.FoldingRangeKind.Comment:return p.$ct.Comment;case n.FoldingRangeKind.Imports:return p.$ct.Imports;case n.FoldingRangeKind.Region:return p.$ct.Region}}Me.from=Te;function Se(se){if(se)switch(se.value){case p.$ct.Comment.value:return n.FoldingRangeKind.Comment;case p.$ct.Imports.value:return n.FoldingRangeKind.Imports;case p.$ct.Region.value:return n.FoldingRangeKind.Region}}Me.to=Se})(qe||(e.FoldingRangeKind=qe={}));var Le;(function(Me){function Te(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?i.from(Se.selection):void 0,override:typeof Se.override=="boolean"?s.$MD.id:void 0}}Me.from=Te})(Le||(e.TextEditorOpenOptions=Le={}));var Ye;(function(Me){function Te(Ke){return Ke instanceof n.$7K?Ke.toJSON():typeof Ke=="string"?Ke:Se(Ke)||se(Ke)?new n.$7K(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}Me.from=Te;function Se(Ke){const _e=Ke;return _e?k.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function se(Ke){const _e=Ke;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Ne(Ke){return typeof Ke=="string"?Ke:new n.$7K(k.URI.revive(Ke.baseUri),Ke.pattern)}Me.to=Ne})(Ye||(e.GlobPattern=Ye={}));var ce;(function(Me){function Te(Se){if(Se){if(Array.isArray(Se))return Se.map(Te);if(typeof Se=="string")return Se;{const se=Se;return{language:se.language,scheme:se.scheme,pattern:Ye.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Me.from=Te})(ce||(e.LanguageSelector=ce={}));var ae;(function(Me){function Te(se){return!!se&&typeof se=="object"&&"documents"in se&&Array.isArray(se.documents)&&se.documents.every(Ne=>Array.isArray(Ne)&&Ne.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&k.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(_e=>_e instanceof n.$aK)))}Me.is=Te;function Se(se){return{documents:se.documents.map(Ne=>Ne.map(Ke=>({uri:k.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(_e=>i.from(_e))})))}}Me.from=Se})(ae||(e.MappedEditsContext=ae={}));var Ie;(function(Me){function Te(se){return{start:se.start,end:se.end}}Me.from=Te;function Se(se){return new n.$vL(se.start,se.end)}Me.to=Se})(Ie||(e.NotebookRange=Ie={}));var Ve;(function(Me){function Te(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Me.to=Te;function Se(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Me.from=Se})(Ve||(e.NotebookCellExecutionSummary=Ve={}));var Ue;(function(Me){function Te(Se){if(Se===a.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(Se===a.NotebookCellExecutionState.Pending)return;if(Se===a.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Me.to=Te})(Ue||(e.NotebookCellExecutionState=Ue={}));var Xe;(function(Me){function Te(se){switch(se){case n.NotebookCellKind.Markup:return a.CellKind.Markup;case n.NotebookCellKind.Code:default:return a.CellKind.Code}}Me.from=Te;function Se(se){switch(se){case a.CellKind.Markup:return n.NotebookCellKind.Markup;case a.CellKind.Code:default:return n.NotebookCellKind.Code}}Me.to=Se})(Xe||(e.NotebookCellKind=Xe={}));var rt;(function(Me){function Te(se){const Ne={metadata:se.metadata??Object.create(null),cells:[]};for(const Ke of se.cells)n.$wL.validate(Ke),Ne.cells.push(ot.from(Ke));return Ne}Me.from=Te;function Se(se){const Ne=new n.$xL(se.cells.map(ot.to));return(0,v.$Kf)(se.metadata)||(Ne.metadata=se.metadata),Ne}Me.to=Se})(rt||(e.NotebookData=rt={}));var ot;(function(Me){function Te(se){return{cellKind:Xe.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Ve.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(kt.from):[]}}Me.from=Te;function Se(se){return new n.$wL(Xe.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(kt.to):void 0,se.metadata,se.internalMetadata?Ve.to(se.internalMetadata):void 0)}Me.to=Se})(ot||(e.NotebookCellData=ot={}));var wt;(function(Me){function Te(se){return{mime:se.mime,valueBytes:T.$ae.wrap(se.data)}}Me.from=Te;function Se(se){return new n.$yL(se.valueBytes.buffer,se.mime)}Me.to=Se})(wt||(e.NotebookCellOutputItem=wt={}));var kt;(function(Me){function Te(se){return{outputId:se.id,items:se.items.map(wt.from),metadata:se.metadata}}Me.from=Te;function Se(se){const Ne=se.items.map(wt.to);return new n.$zL(Ne,se.outputId,se.metadata)}Me.to=Se})(kt||(e.NotebookCellOutput=kt={}));var Yt;(function(Me){function Te(Ne){return se(Ne)?{include:Ye.from(Ne.include)??void 0,exclude:Ye.from(Ne.exclude)??void 0}:Ye.from(Ne)??void 0}Me.from=Te;function Se(Ne){return se(Ne)?{include:Ye.to(Ne.include),exclude:Ye.to(Ne.exclude)}:Ye.to(Ne)}Me.to=Se;function se(Ne){const Ke=Ne;return Ke?!(0,v.$Gf)(Ke.include)&&!(0,v.$Gf)(Ke.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var Vt;(function(Me){function Te(Se,se,Ne){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(Ke,Ne),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Me.from=Te})(Vt||(e.NotebookStatusBarItem=Vt={}));var pt;(function(Me){function Te(Se,se,Ne){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:se.toInternal(Ke,Ne),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Me.from=Te})(pt||(e.NotebookKernelSourceAction=pt={}));var Ut;(function(Me){function Te(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Me.from=Te})(Ut||(e.NotebookDocumentContentOptions=Ut={}));var Ft;(function(Me){function Te(se){return{uri:se.uri,provides:se.provides}}Me.from=Te;function Se(se){return new n.$BL(k.URI.revive(se.uri),se.provides)}Me.to=Se})(Ft||(e.NotebookRendererScript=Ft={}));var zt;(function(Me){function Te(se){return{message:M.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,contextValue:se.contextValue,location:se.location&&{range:i.from(se.location.range),uri:se.location.uri}}}Me.from=Te;function Se(se){const Ne=new n.$HL(typeof se.message=="string"?se.message:M.to(se.message));return Ne.actualOutput=se.actual,Ne.expectedOutput=se.expected,Ne.contextValue=se.contextValue,Ne.location=se.location?K.to(se.location):void 0,Ne}Me.to=Se})(zt||(e.TestMessage=zt={}));var At;(function(Me){Me.namespace=l.$6I,Me.denamespace=l.$7I})(At||(e.TestTag=At={}));var Rt;(function(Me){function Te(se){const Ne=(0,r.$6L)(se).controllerId;return{extId:m.$2I.fromExtHostTestItem(se,Ne).toString(),label:se.label,uri:k.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(Ke=>At.namespace(Ne,Ke.id)),range:S.$ns.lift(i.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&M.fromStrict(se.error)||null}}Me.from=Te;function Se(se){return{parent:void 0,error:void 0,id:m.$2I.fromString(se.extId).localId,label:se.label,uri:k.URI.revive(se.uri),tags:(se.tags||[]).map(Ne=>{const{tagId:Ke}=At.denamespace(Ne);return new n.$IL(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Me.toPlain=Se})(Rt||(e.TestItem=Rt={})),function(Me){function Te(se){return{id:se.id}}Me.from=Te;function Se(se){return new n.$IL(se.id)}Me.to=Se}(At||(e.TestTag=At={}));var Nt;(function(Me){const Te=(se,Ne)=>{const Ke=[];for(const[Je,nt]of Ne)m.$2I.compare(nt.item.extId,Je)===2&&(Ne.delete(Je),Ke.push(nt));const _e={...Rt.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(nt=>nt.type===0).map(zt.to)})),children:Ke.map(Je=>Te(Je,Ne))};for(const Je of _e.children)Je.parent=_e;return _e};function Se(se){const Ne=[],Ke=new Map;for(const _e of se.items){Ke.set(_e.item.extId,_e);const Je=m.$2I.root(_e.item.extId);se.request.targets.some(nt=>nt.controllerId===Je&&nt.testIds.includes(_e.item.extId))&&Ne.push(_e)}return{completedAt:se.completedAt,results:Ne.map(_e=>Te(_e,Ke))}}Me.to=Se})(Nt||(e.TestResults=Nt={}));var Bt;(function(Me){function Te(Ke){return{covered:Ke.covered,total:Ke.covered}}function Se(Ke){return"line"in Ke?h.from(Ke):i.from(Ke)}function se(Ke){return"branches"in Ke?{count:Ke.executionCount,location:Se(Ke.location),type:1,branches:Ke.branches.length?Ke.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Se(_e.location)})):void 0}:{type:0,count:Ke.executionCount,location:Se(Ke.location)}}Me.fromDetailed=se;function Ne(Ke){return{uri:Ke.uri,statement:Te(Ke.statementCoverage),branch:Ke.branchCoverage&&Te(Ke.branchCoverage),function:Ke.functionCoverage&&Te(Ke.functionCoverage),details:Ke.detailedCoverage?.map(se)}}Me.fromFile=Ne})(Bt||(e.TestCoverage=Bt={}));var Kt;(function(Me){function Te(Se){switch(Se){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Me.to=Te})(Kt||(e.CodeActionTriggerKind=Kt={}));var Wt;(function(Me){function Te(se){const Ne=new n.$OL(q.to(se.kind),se.name,se.detail||"",k.URI.revive(se.uri),i.to(se.range),i.to(se.selectionRange));return Ne._sessionId=se._sessionId,Ne._itemId=se._itemId,Ne}Me.to=Te;function Se(se,Ne,Ke){if(Ne=Ne??se._sessionId,Ke=Ke??se._itemId,Ne===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Ke,kind:q.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:i.from(se.range),selectionRange:i.from(se.selectionRange),tags:se.tags?.map(x.from)}}Me.from=Se})(Wt||(e.TypeHierarchyItem=Wt={}));var ct;(function(Me){function Te(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Me.from=Te})(ct||(e.ViewBadge=ct={}));var lt;(function(Me){function Te(Ke,_e,Je){const nt=_e.fileData;return nt?new n.$ZK(new n.$1K(nt.name,k.URI.revive(nt.uri),nt.id,(0,L.$cb)(()=>Je(nt.id)))):Ke===A.$Kr.uriList&&_e.uriListData?new n.$YK(Ne(_e.uriListData)):new n.$YK(_e.asString)}Me.to=Te;async function Se(Ke,_e){const Je=await _e.asString();if(Ke===A.$Kr.uriList)return{asString:Je,fileData:void 0,uriListData:se(Je)};const nt=_e.asFile();return{asString:Je,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Me.from=Se;function se(Ke){return g.$Ws.split(Ke).map(_e=>{if(_e.startsWith("#"))return _e;try{return k.URI.parse(_e)}catch{}return _e})}function Ne(Ke){return g.$Ws.create(Ke.map(_e=>typeof _e=="string"?_e:k.URI.revive(_e)))}})(lt||(e.DataTransferItem=lt={}));var Jt;(function(Me){function Te(se,Ne){const Ke=se.items.map(([_e,Je])=>[_e,lt.to(_e,Je,Ne)]);return new n.$2K(Ke)}Me.toDataTransfer=Te;async function Se(se){const Ne={items:[]},Ke=[];for(const[_e,Je]of se)Ke.push((async()=>{Ne.items.push([_e,await lt.from(_e,Je)])})());return await Promise.all(Ke),Ne}Me.from=Se})(Jt||(e.DataTransfer=Jt={}));var Pt;(function(Me){function Te(se){return{message:se.message,metadata:se.metadata,title:se.title,tooltip:se.tooltip}}Me.to=Te;function Se(se){return{kind:"reply",message:se.message,metadata:se.metadata,title:se.title,tooltip:se.tooltip}}Me.from=Se})(Pt||(e.ChatReplyFollowup=Pt={}));var St;(function(Me){function Te(Se){return typeof Se=="string"?{title:Se,message:Se,kind:"reply"}:"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:Pt.from(Se)}Me.from=Te})(St||(e.ChatFollowup=St={}));var dt;(function(Me){function Te(se){const Ne=new n.$YL(Ct.to(se.role),se.content);return Ne.name=se.name,Ne}Me.to=Te;function Se(se){return{role:Ct.from(se.role),content:se.content,name:se.name}}Me.from=Se})(dt||(e.ChatMessage=dt={}));var Ct;(function(Me){function Te(se){switch(se){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}Me.to=Te;function Se(se){switch(se){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}Me.from=Se})(Ct||(e.ChatMessageRole=Ct={}));var Tt;(function(Me){function Te(se){return{level:Et.to(se.level),value:se.value,description:se.description}}Me.to=Te;function Se(se){return{level:Et.from(se.level),value:se.value,description:se.description}}Me.from=Se})(Tt||(e.ChatVariable=Tt={}));var Et;(function(Me){function Te(se){switch(se){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}Me.to=Te;function Se(se){switch(se){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}Me.from=Se})(Et||(e.ChatVariableLevel=Et={}));var Ge;(function(Me){function Te(Se){switch(Se){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Te})(Ge||(e.InteractiveEditorResponseFeedbackKind=Ge={}));var Ot;(function(Me){function Te(Se,se,Ne){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand}:"uri"in Se?{uri:Se.uri}:se.toInternal(Se,Ne)}Me.from=Te})(Ot||(e.TerminalQuickFix=Ot={}))}),define(De[280],Ce([1,0,2,8,7,14,75]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=void 0;class b{constructor(w,A,I,v={timeout:1500,errors:3}){this.c=w,this.d=A,this.f=I,this.g=v,this.a=new R.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(A,I,v)=>{const S={dispose:this.a.push([A,I,w])};return Array.isArray(v)&&v.push(S),S}}async $participateInSave(w,A){const I=D.URI.revive(w);let v=!1;const k=setTimeout(()=>v=!0,this.g.timeout),S=[];try{for(const p of[...this.a]){if(v)break;const u=this.d.getDocument(I),r=await this.h(p,{document:u,reason:L.TextDocumentSaveReason.to(A)});S.push(r)}}finally{clearTimeout(k)}return S}h([w,A,I],v){const k=this.b.get(w);return typeof k=="number"&&k>this.g.errors?Promise.resolve(!1):this.i(I,w,A,v).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const p=this.b.get(w);this.b.set(w,p?p+1:1),typeof p=="number"&&p>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,A,I,v){const k=[],S=Date.now(),{document:p,reason:u}=v,{version:r}=p,s=Object.freeze({document:p,reason:u,waitUntil(a){if(Object.isFrozen(k))throw(0,T.$7)("waitUntil can not be called async");k.push(Promise.resolve(a))}});try{A.apply(I,[s])}catch(a){return Promise.reject(a)}return Object.freeze(k),new Promise((a,m)=>{const l=setTimeout(()=>m(new Error("timeout")),this.g.timeout);return Promise.all(k).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(l),a(t)}).catch(t=>{clearTimeout(l),m(t)})}).then(a=>{const m={edits:[]};for(const l of a)if(Array.isArray(l)&&l.every(t=>t instanceof g.$fK))for(const{newText:t,newEol:n,range:o}of l)m.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:o&&L.Range.from(o),text:t,eol:n&&L.EndOfLine.from(n)}});if(m.edits.length!==0)return r===p.version?this.f.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.$Wbc=b}),define(De[281],Ce([1,0,17,2,14,7,108]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=e.$0cc=void 0;class b{constructor(I,v,k,S){this.start=I,this.deletedCount=v,this.deletedItems=k,this.items=S}asApiEvent(){return{range:new L.$vL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(I,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,v,k){this.notebook=I,this.h=v,this.j=k,this.handle=k.handle,this.uri=T.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(g.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return I.g},set mime(S){I.g=S},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(k)}return this.f}setOutputs(I){this.a=I.map(g.NotebookCellOutput.to)}setOutputItems(I,v,k){const S=k.map(g.NotebookCellOutputItem.to),p=this.a.find(u=>u.id===I);if(p&&(v||(p.items.length=0),p.items.push(...S),p.items.length>1&&p.items.every(u=>R.$iI(u.mime)))){const u=new Map,r=[];p.items.forEach(s=>{let a;u.has(s.mime)?a=u.get(s.mime):(a=[],u.set(s.mime,a),r.push(s.mime)),a.push(s.data)}),p.items.length=0,r.forEach(s=>{const a=R.$jI(u.get(s));p.items.push({mime:s,data:a.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$0cc=E;class w{static{this.a=0}constructor(I,v,k,S,p){this.k=I,this.l=v,this.m=k,this.uri=S,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=p.viewType,this.f=Object.freeze(p.metadata??Object.create(null)),this.r([[0,0,p.cells]],!0,void 0),this.g=p.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,v={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===D.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(k){return k=I.n(k),I.b[k].apiCell},getCells(k){return(k?I.p(k):I.b).map(p=>p.apiCell)},save(){return I.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,v,k){this.g=I.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:k});const S={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},p=[];for(const r of I.rawEvents)r.kind===R.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,S.contentChanges):r.kind===R.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,S.contentChanges):r.kind===R.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),p.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===R.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),p.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),p.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===R.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),p.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),p.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const u=new Map;for(let r=0;r<p.length;r++){const s=p[r],a=u.get(s.cell);if(a===void 0){const m=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...s});u.set(s.cell,m-1)}else S.cellChanges[a]={...S.cellChanges[a],...s}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let v=I.start|0,k=I.end|0;return v<0&&(v=0),k>this.b.length&&(k=this.b.length),I.with({start:v,end:k})}p(I){I=this.o(I);const v=[];for(let k=I.start;k<I.end;k++)v.push(this.b[k]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,v,k){if(this.j)return;const S=[],p=[],u=[];if(I.reverse().forEach(r=>{const a=r[2].map(t=>{const n=new E(this,this.l,t);return v||p.push(E.asModelAddData(this.apiNotebook,t)),n}),m=new b(r[0],r[1],[],a),l=this.b.splice(r[0],r[1],...a);for(const t of l)u.push(t.uri),m.deletedItems.push(t.apiCell);S.push(m)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:u}),k)for(const r of S)k.push(r.asApiEvent())}s(I,v,k,S){const p=this.b.splice(I,v);this.b.splice(k,0,...p);const u=[new b(I,v,p.map(r=>r.apiCell),[]),new b(k,0,[],p)];for(const r of u)S.push(r.asApiEvent())}t(I,v){this.b[I].setOutputs(v)}u(I,v,k,S){this.b[I].setOutputItems(v,k,S)}v(I,v){const k=this.b[I];k.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(k.uri,v)}w(I,v){const k=this.b[I];k.apiCell.mime=v}x(I,v){this.b[I].setMetadata(v)}y(I,v){this.b[I].setInternalMetadata(v)}getCellFromApiCell(I){return this.b.find(v=>v.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(v=>v.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$$cc=w}),define(De[282],Ce([1,0,4,2,14,7]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class R{constructor(E,w,A,I={timeout:1500,errors:3}){this.b=E,this.c=w,this.d=A,this.f=I,this.a=new D.$Od}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(w,A,I)=>{const v=function(S){w.call(A,S)};return v.extension=E,this.a.event(v,void 0,I)}}async $participateInSave(E,w,A){const I=T.URI.revive(E),v=this.c.getNotebookDocument(I);if(!v)throw new Error("Unable to resolve notebook document");const k=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:g.TextDocumentSaveReason.to(w)},A,async(p,u)=>{const r=Date.now(),s=await await Promise.resolve(p);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier),!A.isCancellationRequested&&s&&(s instanceof L.$iK?k.push(s):this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(k.length===0)return!0;const S={edits:[]};for(const p of k){const{edits:u}=g.WorkspaceEdit.from(p);S.edits=S.edits.concat(u)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$ydc=R}),define(De[144],Ce([1,0,8,14,7]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,E,w,A,I,v){this.id=b,this.f=E,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=A,this.c=v}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(E){this.selections=[E]},get selections(){return b.a},set selections(E){if(!Array.isArray(E)||!E.every(g.$vL.isNotebookRange))throw(0,D.$6)("selections");b.a=E,b.g(E)},get visibleRanges(){return b.b},revealRange(E,w){b.f.$tryRevealRange(b.id,T.NotebookRange.from(E),w??g.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(T.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$_cc=L}),define(De[283],Ce([1,0,8,4,13,14]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;let R=class{constructor(E,w){this.c=E,this.d=w,this.a=new T.$Md({onListenerError:D.$1}),this.b=new T.$Md({onListenerError:D.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,w){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,w);const A=this.d.getEditorById(E);w.visibleRanges&&A._acceptVisibleRanges(w.visibleRanges.ranges.map(L.NotebookRange.to)),w.selections&&A._acceptSelections(w.selections.selections.map(L.NotebookRange.to)),w.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),w.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const w in E)this.d.getEditorById(w)._acceptViewColumn(L.ViewColumn.to(E[w]))}};e.$rdc=R,e.$rdc=R=He([Be(0,g.$8i)],R)}),define(De[284],Ce([1,0,14,84,208,21,57,8]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class E{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,k,S){const p=this.b++,{title:u,location:r,cancellable:s}=k,a={label:(0,g.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(p,{location:D.ProgressLocation.from(r),title:u,source:a,cancellable:s},v.isUnderDevelopment?void 0:v.identifier.value).catch(b.$1),this.d(p,S,!!s)}d(v,k,S){let p;S&&(p=new L.$Wd,this.c.set(v,p));const u=s=>{this.a.$progressEnd(s),this.c.delete(s),p?.dispose()};let r;try{r=k(new A(this.a,v),S&&p?p.token:L.CancellationToken.None)}catch(s){throw u(v),s}return r.then(s=>u(v),s=>u(v)),r}$acceptProgressCanceled(v){const k=this.c.get(v);k&&(k.cancel(),this.c.delete(v))}}e.$vcc=E;function w(I,v){return I.message=v.message,typeof v.increment=="number"&&(typeof I.increment=="number"?I.increment+=v.increment:I.increment=v.increment),I}class A extends T.$Yu{constructor(v,k){super(S=>this.throttledReport(S)),this.i=v,this.j=k}throttledReport(v){this.i.$progressReport(this.j,v)}}He([(0,R.$hh)(100,(I,v)=>w(I,v),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(De[145],Ce([1,0,34,142,67,109,88,14,2]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=e.$kM=e.$jM=void 0;const w=(a,m,l,t)=>{let n=m;return{enumerable:!0,configurable:!1,get(){return n},set(o){if(!l(n,o)){const i=n;n=o,a.listener?.(t(o,i))}}}},A=(a,m)=>a===m,I={range:(a,m)=>a===m?!0:!a||!m?!1:a.isEqual(m),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(a,m)=>!(a.length!==m.length||a.some(l=>!m.find(t=>l.id===t.id)))},v=a=>m=>({op:4,update:a(m)}),k=(a,m)=>({range:(()=>{let l;const t=v(n=>({range:D.$ns.lift(b.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return l},set(n){a.listener?.({op:6}),I.range(l,n)||(l=n,a.listener?.(t(n)))}}})(),label:w(a,m,I.label,v(l=>({label:l}))),description:w(a,void 0,I.description,v(l=>({description:l}))),sortText:w(a,void 0,I.sortText,v(l=>({sortText:l}))),canResolveChildren:w(a,!1,I.canResolveChildren,l=>({op:2,state:l})),busy:w(a,!1,I.busy,v(l=>({busy:l}))),error:w(a,void 0,I.error,v(l=>({error:b.MarkdownString.fromStrict(l)||null}))),tags:w(a,[],I.tags,(l,t)=>({op:1,new:l.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),S=a=>{const m=g.$2I.fromString(a.extId),l=new u(m.controllerId,m.localId,a.label,E.URI.revive(a.uri)||void 0);return l.range=b.Range.to(a.range||void 0),l.description=a.description||void 0,l.sortText=a.sortText||void 0,l.tags=a.tags.map(t=>b.TestTag.to({id:(0,R.$7I)(t).tagId})),l},p=a=>{let m;for(const l of a.tests){const t=S(l.item);(0,T.$6L)(t).parent=m,m=t}return m};e.$jM=p;class u{constructor(m,l,t,n){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const o=(0,T.$5L)(this,m);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof r?void 0:o.parent}},children:{value:(0,L.$4L)(o,T.$6L,u),enumerable:!0,writable:!1},...k(o,t)})}}e.$kM=u;class r extends u{constructor(m,l){super(m,m,l,void 0),this._isRoot=!0}}e.$lM=r;class s extends L.$ZL{constructor(m,l,t){super({controllerId:m,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:T.$6L,getChildren:n=>n.children,root:new r(m,l),toITestItem:b.TestItem.from})}}e.$mM=s}),define(De[146],Ce([1,0,58,8,119,14,7]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gM=e.$fM=e.$eM=void 0;class b{static{this.c=new g.$cM("TextEditorDecorationType")}constructor(v,k,S){const p=b.c.nextId();v.$registerTextEditorDecorationType(k.identifier,p,L.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:p,dispose(){v.$removeTextEditorDecorationType(p)}})}}e.$eM=b;class E{constructor(v,k){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,k){this.k();let S=null;if(v instanceof R.$_J)S=new R.$aK(v,v);else if(v instanceof R.$aK)S=v;else throw new Error("Unrecognized location");this.l(S,k,!1)}insert(v,k){this.k(),this.l(new R.$aK(v,v),k,!0)}delete(v){this.k();let k=null;if(v instanceof R.$aK)k=v;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(v,k,S){const p=this.c.validateRange(v);this.g.push({range:p,text:k,forceMoveMarkers:S})}setEndOfLine(v){if(this.k(),v!==R.EndOfLine.LF&&v!==R.EndOfLine.CRLF)throw(0,T.$6)("endOfLine");this.h=v}}class w{constructor(v,k,S,p){this.c=v,this.d=k,this._accept(S),this.e=p;const u=this;this.value={get tabSize(){return u.f},set tabSize(r){u.m(r)},get indentSize(){return u.g},set indentSize(r){u.o(r)},get insertSpaces(){return u.h},set insertSpaces(r){u.q(r)},get cursorStyle(){return u.j},set cursorStyle(r){u.s(r)},get lineNumbers(){return u.k},set lineNumbers(r){u.t(r)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const k=Math.floor(v);return k>0?k:null}if(typeof v=="string"){const k=parseInt(v,10);return isNaN(k)?null:k>0?k:null}return null}m(v){const k=this.l(v);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const k=Math.floor(v);return k>0?k:null}if(typeof v=="string"){const k=parseInt(v,10);return isNaN(k)?null:k>0?k:null}return null}o(v){const k=this.n(v);if(k!==null){if(typeof k=="number"){if(this.g===k)return;this.g=k}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}p(v){return v==="auto"?"auto":v==="false"?!1:!!v}q(v){const k=this.p(v);if(typeof k=="boolean"){if(this.h===k)return;this.h=k}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(v)})))}assign(v){const k={};let S=!1;if(typeof v.tabSize<"u"){const p=this.l(v.tabSize);p==="auto"?(S=!0,k.tabSize=p):typeof p=="number"&&this.f!==p&&(this.f=p,S=!0,k.tabSize=p)}if(typeof v.indentSize<"u"){const p=this.n(v.indentSize);p==="tabSize"?(S=!0,k.indentSize=p):typeof p=="number"&&this.g!==p&&(this.g=p,S=!0,k.indentSize=p)}if(typeof v.insertSpaces<"u"){const p=this.p(v.insertSpaces);p==="auto"?(S=!0,k.insertSpaces=p):this.h!==p&&(this.h=p,S=!0,k.insertSpaces=p)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,S=!0,k.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,S=!0,k.lineNumbers=L.TextEditorLineNumbersStyle.from(v.lineNumbers)),S&&this.u("setOptions",this.c.$trySetOptions(this.d,k))}u(v,k){k.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(S)})}}e.$fM=w;class A{constructor(v,k,S,p,u,r,s,a){this.id=v,this.j=k,this.k=S,this.g=!1,this.h=new Set,this.c=u,this.d=new w(this.j,this.id,r,S),this.e=s,this.f=a;const m=this;this.value=Object.freeze({get document(){return p.value},set document(l){throw new T.$8("document")},get selection(){return m.c&&m.c[0]},set selection(l){if(!(l instanceof R.$bK))throw(0,T.$6)("selection");m.c=[l],m.l()},get selections(){return m.c},set selections(l){if(!Array.isArray(l)||l.some(t=>!(t instanceof R.$bK)))throw(0,T.$6)("selections");m.c=l,m.l()},get visibleRanges(){return m.e},set visibleRanges(l){throw new T.$8("visibleRanges")},get options(){return m.d.value},set options(l){m.g||m.d.assign(l)},get viewColumn(){return m.f},set viewColumn(l){throw new T.$8("viewColumn")},edit(l,t={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new E(p.value,t);return l(n),m.m(n)},insertSnippet(l,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=m.c.map(i=>L.Range.from(i));else if(t instanceof R.$_J){const{lineNumber:i,column:c}=L.Position.from(t);o=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(t instanceof R.$aK)o=[L.Range.from(t)];else{o=[];for(const i of t)if(i instanceof R.$aK)o.push(L.Range.from(i));else{const{lineNumber:c,column:h}=L.Position.from(i);o.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return k.$tryInsertSnippet(v,p.value.version,l.value,o,n)},setDecorations(l,t){const n=t.length===0;n&&!m.h.has(l.key)||(n?m.h.delete(l.key):m.h.add(l.key),m.n(()=>{if(L.$7L(t))return k.$trySetDecorations(v,l.key,L.$8L(t));{const o=new Array(4*t.length);for(let i=0,c=t.length;i<c;i++){const h=t[i];o[4*i]=h.start.line+1,o[4*i+1]=h.start.character+1,o[4*i+2]=h.end.line+1,o[4*i+3]=h.end.character+1}return k.$trySetDecorationsFast(v,l.key,o)}}))},revealRange(l,t){m.n(()=>k.$tryRevealRange(v,L.Range.from(l),t||R.TextEditorRevealType.Default))},show(l){k.$tryShowEditor(v,L.ViewColumn.from(l))},hide(){k.$tryHideEditor(v)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,D.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,D.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,D.ok)(!this.g),this.f=v}_acceptSelections(v){(0,D.ok)(!this.g),this.c=v}async l(){const v=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const k=v.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const S=k.edits.map(u=>u.range);S.sort((u,r)=>u.end.line===r.end.line?u.end.character===r.end.character?u.start.line===r.start.line?u.start.character-r.start.character:u.start.line-r.start.line:u.end.character-r.end.character:u.end.line-r.end.line);for(let u=0,r=S.length-1;u<r;u++){const s=S[u].end;if(S[u+1].start.isBefore(s))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=k.edits.map(u=>({range:L.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,p,{setEndOfLine:typeof k.setEndOfLine=="number"?L.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$gM=A}),define(De[147],Ce([1,0,5,131]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=void 0,e.$tJ=(0,D.$Oh)(T.$Uh)}),define(De[148],Ce([1,0,25,4,16,3]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$03b=e.$93b=e.$83b=e.$73b=e.$63b=e.$53b=void 0;class R{constructor(r,s){this.versionId=r,this.removedDueToLooping=s}}e.$53b=R;class b{static isHostExtension(r,s,a){if(s.getExtensionDescription(r))return!1;const m=a.getExtensionDescription(r);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(r,s){this.j=r,this.c=new T.$Md,this.onDidChange=this.c.event,this.d=0,this.e=s,this.k()}k(){this.e.sort(S),this.f=new D.$1l,this.g=[],this.h=new Map;for(const r of this.e){if(this.f.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.f.set(r.identifier,r),this.g.push(r);const s=this.j.readActivationEvents(r);if(Array.isArray(s))for(let a of s)a==="onUri"&&(a=`onUri:${D.$Yl.toKey(r.identifier)}`),this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(r)}}set(r){return this.e=r,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(r,s){this.e=p(this.e,s),this.e=this.e.concat(r);const a=b.l(this.e);return this.e=p(this.e,a.map(m=>m.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,a)}static l(r){const s=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,o){this.addNode(n),this.addNode(o),this.c.has(n)?this.c.get(n).push(o):this.c.set(n,[o])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,o){const i=s.getArcs(n);for(let c=0;c<i.length;c++)if(!o.has(i[c]))return!1;return!0}getNodes(){return this.e}},a=new D.$1l;for(const n of r)if(a.set(n.identifier,n),n.extensionDependencies)for(const o of n.extensionDependencies)s.addArc(D.$Yl.toKey(n.identifier),D.$Yl.toKey(o));const m=new Set;s.getNodes().filter(n=>s.getArcs(n).length===0).forEach(n=>m.add(n));const l=s.getNodes().filter(n=>!m.has(n));let t;do{t=!1;for(let n=0;n<l.length;n++){const o=l[n];s.hasOnlyGoodArcs(o,m)&&(l.splice(n,1),n--,m.add(o),t=!0)}}while(t);return l.map(n=>a.get(n))}containsActivationEvent(r){return this.h.has(r)}containsExtension(r){return this.f.has(r)}getExtensionDescriptionsForActivationEvent(r){const s=this.h.get(r);return s?s.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(r){const s=this.f.get(r);return s||void 0}getExtensionDescriptionByUUID(r){for(const s of this.g)if(s.uuid===r)return s}getExtensionDescriptionByIdOrUUID(r,s){return this.getExtensionDescription(r)??(s?this.getExtensionDescriptionByUUID(s):void 0)}}e.$63b=b;class E{constructor(r,s){this.versionId=r,this.extensions=s}}e.$73b=E,e.$83b={readActivationEvents:u=>u.activationEvents};class w{constructor(r){this.d=new v,this.c=new b(r,[])}async acquireLock(r){const s=await this.d.acquire(r);return new A(this,s)}deltaExtensions(r,s,a){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(s,a)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,s){return this.c.getExtensionDescriptionByIdOrUUID(r,s)}}e.$93b=w;class A extends L.$Rc{constructor(r,s){super(),this.f=r,this.c=!1,this.B(s)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$03b=A;class I{constructor(r){this.name=r,this.promise=new Promise((s,a)=>{this.c=s})}resolve(r){this.c(r)}}class v{constructor(){this.c=[],this.d=!1}async acquire(r){const s=new I(r);return this.c.push(s),this.e(),s.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let s=!0;const a=setTimeout(()=>{s&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{s&&(clearTimeout(a),s=!1,this.d=!1,this.e())};r.resolve((0,L.$Pc)(m))}}var k;(function(u){u[u.Builtin=0]="Builtin",u[u.User=1]="User",u[u.Dev=2]="Dev"})(k||(k={}));function S(u,r){const s=u.isBuiltin?0:u.isUnderDevelopment?2:1,a=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(s!==a)return s-a;const m=g.$fc.basename(u.extensionLocation.path),l=g.$fc.basename(r.extensionLocation.path);return m<l?-1:m>l?1:0}function p(u,r){const s=new D.$Zl(r);return u.filter(a=>!s.has(a.identifier))}}),define(De[285],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.ExtHostConnectionType=void 0;var D;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[T.ENV_KEY]=this.pipeName}}e.$qm=T;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[g.ENV_KEY]="1"}}e.$rm=g;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[L.ENV_KEY]="1"}}e.$sm=L;function R(A){delete A[T.ENV_KEY],delete A[g.ENV_KEY],delete A[L.ENV_KEY]}function b(A,I){R(I),A.serialize(I)}e.$tm=b;function E(A){if(A[T.ENV_KEY])return w(A,new T(A[T.ENV_KEY]));if(A[g.ENV_KEY])return w(A,new g);if(A[L.ENV_KEY])return w(A,new L);throw new Error("No connection information defined in environment!")}e.$um=E;function w(A,I){return R(A),I}}),define(De[111],Ce([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$8l=e.$7l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(T||(e.UIKind=T={}));var g;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var L;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(w){const A=D.$ae.alloc(1);switch(w){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$7l=R;function b(w,A){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$8l=b;var E;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(De[89],Ce([1,0,5,4,13,26,111,65,85,23,2,3,210]),function($e,e,D,T,g,L,R,b,E,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=e.$pM=e.$oM=void 0;let k=class extends I.$Rc{constructor(r,s){super(),this.s=r,this.t=s,this.a=this.B(new T.$Md),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Md),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=s.createLogger(this.m,{id:E.$ho,name:(0,v.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(s.onDidChangeLogLevel(a=>{(0,g.$0i)(a)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,s,a){const m=this.getTelemetryDetails(),l=new S(s,a,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}),t=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...t,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(r,s,a){this.f=r,this.g=s,this.c=a??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const s=Object.create(null);switch(s["common.extname"]=`${r.publisher}.${r.name}`,s["common.extversion"]=r.version,s["common.vscodemachineid"]=this.s.telemetryInfo.machineId,s["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,s["common.vscodeversion"]=this.s.version,s["common.isnewappinstall"]=p(this.s.telemetryInfo.firstSessionDate),s["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:s["common.uikind"]="web";break;case R.UIKind.Desktop:s["common.uikind"]="desktop";break;default:s["common.uikind"]="unknown"}return s["common.remotename"]=(0,b.$Sk)((0,E.$oo)(this.s.remote.authority)),s}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const s=this.getTelemetryDetails();this.r.forEach((a,m)=>{const l=a.filter(t=>!t.isDisposed);l.length===0?this.r.delete(m):this.r.set(m,l)}),this.r.forEach(a=>{for(const m of a)m.updateTelemetryEnablements(s.isUsageEnabled,s.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,s){const m=this.r.get(r.value)?.filter(t=>!t.isDisposed);if(!m)return this.r.delete(r.value),!1;let l=!1;for(const t of m)t.ignoreUnhandledExtHostErrors||(t.logError(s),l=!0);return l}};e.$oM=k,e.$oM=k=He([Be(0,L.$nM),Be(1,g.$9i)],k);class S{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,s,a,m,l,t,n){this.g=a,this.h=m,this.i=l,this.j=t,this.a=new T.$Md,this.ignoreUnhandledExtHostErrors=s?.ignoreUnhandledErrors??!1,this.b=s?.ignoreBuiltInCommonProperties??!1,this.c=s?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(r,s){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:s},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let s="properties"in r?r.properties??{}:r;return s=(0,E.$ro)(s,[]),this.c&&(s=(0,w.$2m)(s,this.c)),this.b||(s=(0,w.$2m)(s,this.j)),"properties"in r?r.properties=s:r=s,r}k(r,s){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,s=this.mixInCommonPropsAndCleanData(s||{}),this.i||this.f?.sendEventData(r,s),this.h.trace(r,s))}logUsage(r,s){this.d.isUsageEnabled&&this.k(r,s)}logError(r,s){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,s);else{const a={name:r.name,message:r.message,stack:r.stack,cause:r.cause},m=(0,E.$ro)(a,[]),l=new Error(m.message,{cause:m.cause});l.stack=m.stack,l.name=m.name,s=this.mixInCommonPropsAndCleanData(s||{}),this.i||this.f.sendErrorData(l,s),this.h.trace("exception",s)}}get apiTelemetryLogger(){if(!this.e){const r=this,s={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(s)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$pM=S;function p(u){const r=Date.now()-new Date(u).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$qM=p,e.$rM=(0,D.$Nh)("IExtHostTelemetry")}),define(De[27],Ce([1,0,4,2,252,137,25,5]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bF=e.$aF=e.$_E=e.ActivationKind=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.ExtensionHostStartup=e.$6E=e.$5E=e.$4E=e.$3E=void 0,e.$3E=Object.freeze({identifier:new R.$Yl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$4E="extensions.webWorker",e.$5E=(0,b.$Nh)("extensionService");class E{constructor(l){this.dependency=l}}e.$6E=E;var w;(function(m){m[m.EagerAutoStart=1]="EagerAutoStart",m[m.EagerManualStart=2]="EagerManualStart",m[m.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,n){this.c=l,this.d=t.slice(0),this.e=n.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$NE.createActivationEventsMap(this.d)}}set(l,t,n){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const o=[],i=[],c=[],h=[],y=I(this.d),C=I(t),$=(O,M)=>O.extensionLocation.toString()===M.extensionLocation.toString()||O.isBuiltin===M.isBuiltin||O.isUserBuiltin===M.isUserBuiltin||O.isUnderDevelopment===M.isUnderDevelopment;for(const O of this.d){const M=C.get(O.identifier);if(!M){o.push(O.identifier),y.delete(O.identifier);continue}if(!$(O,M)){o.push(O.identifier),y.delete(O.identifier);continue}}for(const O of t){const M=y.get(O.identifier);if(!M){i.push(O);continue}if(!$(M,O)){o.push(M.identifier),y.delete(M.identifier);continue}}const f=new R.$Zl(this.e),d=new R.$Zl(n);for(const O of this.e)d.has(O)||c.push(O);for(const O of n)f.has(O)||h.push(O);const P=L.$NE.createActivationEventsMap(i),N={versionId:l,toRemove:o,toAdd:i,addActivationEvents:P,myToRemove:c,myToAdd:h};return this.delta(N),N}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:n,myToRemove:o,myToAdd:i}=l,c=new R.$Zl(t),h=new R.$Zl(o);for(let y=0;y<this.d.length;y++)c.has(this.d[y].identifier)&&(this.d.splice(y,1),y--);for(let y=0;y<this.e.length;y++)h.has(this.e[y])&&(this.e.splice(y,1),y--);for(const y of n)this.d.push(y);for(const y of i)this.e.push(y);return l}containsExtension(l){for(const t of this.e)if(R.$Yl.equals(t,l))return!0;return!1}}e.$7E=A;function I(m){const l=new R.$1l;for(const t of m)l.set(t.identifier,t);return l}function v(m,l){return m.enabledApiProposals?m.enabledApiProposals.includes(l):!1}e.$8E=v;function k(m,l){if(!v(m,l))throw new Error(`Extension '${m.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${m.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.$9E=k;class S{constructor(l,t,n,o){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=o}}e.$0E=S;class p{constructor(l,t){this.description=l,this.value=t}}e.$$E=p;var u;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(u||(e.ActivationKind=u={}));function r(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,g.$xo)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation,targetPlatform:m.targetPlatform,validations:[],isValid:!0}}e.$_E=r;function s(m,l){return{identifier:new R.$Yl((0,g.$vo)(m.manifest.publisher,m.manifest.name)),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!!l,extensionLocation:m.location,...m.manifest,uuid:m.identifier.uuid,targetPlatform:m.targetPlatform}}e.$aF=s;class a{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$bF=a}),define(De[286],Ce([1,0,8,148,25,27,13,11]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=e.$1bc=e.$Zbc=e.$Ybc=e.$Xbc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(r,s,a,m){this.startup=r,this.codeLoadingTime=s,this.activateCallTime=a,this.activateResolvedTime=m}}e.$Xbc=E;class w{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,s){return r===-1||s===-1?-1:s-r}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ybc=w;class A{constructor(r,s,a,m,l,t){this.activationFailed=r,this.activationFailedError=s,this.activationTimes=a,this.module=m,this.exports=l,this.subscriptions=t}}e.$Zbc=A;class I extends A{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$1bc=I;class v extends A{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$2bc=v;class k extends A{constructor(r){super(!0,r,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(r,s,a,m){this.g=m,this.a=r,this.b=s,this.c=a,this.d=new g.$1l,this.f=Object.create(null)}dispose(){for(const[r,s]of this.d)s.dispose()}async waitForActivatingExtensions(){const r=[];for(const[s,a]of this.d)r.push(a.wait());await Promise.all(r)}isActivated(r){const s=this.d.get(r);return!!(s&&s.value)}getActivatedExtension(r){const s=this.d.get(r);if(!s||!s.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return s.value}async activateByEvent(r,s){if(this.f[r])return;const a=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(a.map(m=>({id:m.identifier,reason:{startup:s,extensionId:m.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,s){const a=this.a.getExtensionDescription(r);if(!a)throw new Error(`Extension '${r}' is not known`);return this.h([{id:a.identifier,reason:s}])}async h(r){const s=r.filter(a=>!this.isActivated(a.id)).map(a=>this.j(a));await Promise.all(s.map(a=>a.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const s=this.a.getExtensionDescription(r.id);if(!s){const l=new Error(`Cannot activate unknown extension '${r.id.value}'`),t=this.k(r,null,[],new k(l));return this.c.onExtensionActivationError(r.id,l,new L.$6E(r.id.value)),t}const a=[],m=typeof s.extensionDependencies>"u"?[]:s.extensionDependencies;for(const l of m){if(this.m(l))continue;const t=this.d.get(l);if(t){a.push(t);continue}if(this.l(l)){a.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:r.reason}));continue}const n=this.a.getExtensionDescription(l);if(n){if(!n.main&&!n.browser)continue;a.push(this.j({id:n.identifier,reason:r.reason}));continue}const o=s.displayName||s.identifier.value,i=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${l}'`),c=this.k(r,s.displayName,[],new k(i));return this.c.onExtensionActivationError(s.identifier,i,new L.$6E(l)),c}return this.k(r,s.displayName,a,null)}k(r,s,a,m){const l=new p(r.id,s,r.reason,a,m,this.c,this.g);return this.d.set(r.id,l),l}l(r){return T.$63b.isHostExtension(r,this.a,this.b)}m(r){const s=this.b.getExtensionDescription(r);return s?!s.main&&!s.browser:!1}};e.$3bc=S,e.$3bc=S=He([Be(3,R.$8i)],S);let p=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,s,a,m,l,t,n){this.c=r,this.d=s,this.f=a,this.g=m,this.h=l,this.j=t,this.k=n,this.a=new b.$Rg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const s=this.g[r];if(s.value&&!s.value.activationFailed){this.g.splice(r,1),r--;continue}if(s.value&&s.value.activationFailed){const a=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${s.friendlyName}' failed to activate`);a.detail=s.value.activationFailedError,this.h=new k(a),this.j.onExtensionActivationError(this.c,a,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const s=new Error;if(r&&r.name&&(s.name=r.name),r&&r.message?s.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:s.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(s.stack=r.stack),this.h=new k(s),this.b&&D.$3(r))return;this.j.onExtensionActivationError(this.c,s,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};p=He([Be(6,R.$8i)],p)}),define(De[287],Ce([1,0,212,24,2,4,3,269,11,7,18,19,14,79,21,173,27]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;function r(m,l){if((0,A.$xf)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let t;return Array.isArray(m.highlights)&&(t=m.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),t=t.length?t:void 0),{label:m.label,highlights:t}}}class s extends R.$Rc{constructor(l,t,n){super(),this.f=l,this.g=t,this.h=n,this.a=new Map,this.b=new p.$A7;function o(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:i=>o(i)?this.r(i):Array.isArray(i)&&i.length>0?i.map(c=>o(c)?this.r(c):c):i})}registerTreeDataProvider(l,t,n){const o=this.createTreeView(l,{treeDataProvider:t},n);return{dispose:()=>o.dispose()}}createTreeView(l,t,n){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=t.dragAndDropController?.dropMimeTypes??[],i=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,y=this.m(l,t,n),C={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:o,dragMimeTypes:i,hasHandleDrag:c,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(l,C),f={get onDidCollapseElement(){return y.onDidCollapseElement},get onDidExpandElement(){return y.onDidExpandElement},get selection(){return y.selectedElements},get onDidChangeSelection(){return y.onDidChangeSelection},get activeItem(){return(0,u.$9E)(n,"treeViewActiveItem"),y.focusedElement},get onDidChangeActiveItem(){return(0,u.$9E)(n,"treeViewActiveItem"),y.onDidChangeActiveItem},get visible(){return y.visible},get onDidChangeVisibility(){return y.onDidChangeVisibility},get onDidChangeCheckboxState(){return y.onDidChangeCheckboxState},get message(){return y.message},set message(d){(0,k.$3j)(d)&&(0,u.$9E)(n,"treeViewMarkdownMessage"),y.message=d},get title(){return y.title},set title(d){y.title=d},get description(){return y.description},set description(d){y.description=d},get badge(){return y.badge},set badge(d){d!==void 0&&w.ViewBadge.isViewBadge(d)?y.badge={value:Math.floor(Math.abs(d.value)),tooltip:d.tooltip}:d===void 0&&(y.badge=void 0)},reveal:(d,P)=>y.reveal(d,P),dispose:async()=>{await $,this.a.delete(l),y.dispose()}};return this.B(f),f}$getChildren(l,t){const n=this.a.get(l);return n?n.getChildren(t):Promise.reject(new b.$iE(l))}async $handleDrop(l,t,n,o,i,c,h,y){const C=this.a.get(l);if(!C)return Promise.reject(new b.$iE(l));const $=v.DataTransfer.toDataTransfer(n,async f=>(await this.f.$resolveDropFileData(l,t,f)).buffer);return h===l&&y&&await this.j($,C,y,i,c),C.onDrop($,o,i)}async j(l,t,n,o,i){const c=this.b.removeDragOperationTransfer(i);if(c)(await c)?.forEach((h,y)=>{h&&l.set(y,h)});else if(i&&t.handleDrag){const h=t.handleDrag(n,l,o);this.b.addDragOperationTransfer(i,h),await h}return l}async $handleDrag(l,t,n,o){const i=this.a.get(l);if(!i)return Promise.reject(new b.$iE(l));const c=await this.j(new w.$2K,i,t,o,n);if(!(!c||o.isCancellationRequested))return v.DataTransfer.from(c)}async $hasResolve(l){const t=this.a.get(l);if(!t)throw new b.$iE(l);return t.hasResolve}$resolve(l,t,n){const o=this.a.get(l);if(!o)throw new b.$iE(l);return o.resolveTreeItem(t,n)}$setExpanded(l,t,n){const o=this.a.get(l);if(!o)throw new b.$iE(l);o.setExpanded(t,n)}$setSelectionAndFocus(l,t,n){const o=this.a.get(l);if(!o)throw new b.$iE(l);o.setSelectionAndFocus(t,n)}$setVisible(l,t){const n=this.a.get(l);if(!n){if(!t)return;throw new b.$iE(l)}n.setVisible(t)}$changeCheckboxState(l,t){const n=this.a.get(l);if(!n)throw new b.$iE(l);n.setCheckboxState(t)}m(l,t,n){const o=this.B(new a(l,t,this.f,this.g.converter,this.h,n));return this.a.set(l,o),o}r(l){const t=this.a.get(l.$treeViewId);return t&&"$treeItemHandle"in l?t.getExtensionElement(l.$treeItemHandle):t&&"$focusedTreeItem"in l&&l.$focusedTreeItem?t.focusedElement:null}}e.$Ccc=s;class a extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,A.$Gf)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,t,n,o,i,c){if(super(),this.I=l,this.J=n,this.L=o,this.M=i,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Md),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Md),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Md),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Md),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Md),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Md),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Md),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$Wd,c.contributes&&c.contributes.views)for(const $ in c.contributes.views)for(const f of c.contributes.views[$])f.id===l&&(this.P=f.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let h,y;const C=L.Event.debounce(this.F.event,($,f)=>($||($={message:!1,elements:[]}),f.element!==!1&&(h||(h=new Promise(d=>y=d),this.G=this.G.then(()=>h)),Array.isArray(f.element)?$.elements.push(...f.element):$.elements.push(f.element)),f.message&&($.message=!0),$),200,!0);this.B(C(({message:$,elements:f})=>{f.length&&(this.H=this.H.then(()=>{const d=y;return h=null,this.$(f).then(()=>d())})),$&&this.J.$setMessage(this.I,v.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const t=l?this.getExtensionElement(l):void 0;if(l&&!t)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let n=this.X(l);return n||(n=await this.Y(t)),n?n.map(o=>o.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,t){t=t||{select:!0,focus:!1};const n=(0,A.$Gf)(t.select)?!0:t.select,o=(0,A.$Gf)(t.focus)?!1:t.focus,i=(0,A.$Gf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(c=>this.W(l,c[c.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:c.map(y=>y.item)},{select:n,focus:o,expand:i})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:n,focus:o,expand:i})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=v.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,t){const n=this.getExtensionElement(l);n&&(t?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(l,t){const n=!(0,I.$tb)(this.s,l);this.s=l;const o=this.t!==t;this.t=t,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),o&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const t=(await Promise.all(l.map(async n=>{const o=this.getExtensionElement(n.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:n.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);t.forEach(n=>{n.treeItem.checkboxState=n.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(n=>[n.extensionItem,n.newState])})}async handleDrag(l,t,n){const o=[];for(const i of l){const c=this.getExtensionElement(i);c&&o.push(c)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,t,n),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,t,n){const o=t?this.getExtensionElement(t):void 0;if(!(!o&&t||!this.g?.handleDrop))return(0,E.$Lg)(()=>this.g?.handleDrop?this.g.handleDrop(o,l,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,t){if(!this.f.resolveTreeItem)return;const n=this.j.get(l);if(n){const o=this.m.get(n);if(o){const i=await this.f.resolveTreeItem(o.extensionItem,n,t)??o.extensionItem;return this.hb(i),o.item.tooltip=this.eb(i.tooltip),o.item.command=this.fb(o.disposableStore,i.command),o.item}}}S(l){return this.U(l).then(t=>t?this.S(t).then(n=>this.W(t,n[n.length-1]).then(o=>(n.push(o),n))):Promise.resolve([]))}U(l){const t=this.m.get(l);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,E.$Lg)(()=>this.f.getParent(l))}W(l,t){const n=this.m.get(l);return n?Promise.resolve(n):(0,E.$Lg)(()=>this.f.getTreeItem(l)).then(o=>this.kb(l,o,t,!0)).then(o=>this.getChildren(t?t.item.handle:void 0).then(()=>{const i=this.getExtensionElement(o);if(i){const c=this.m.get(i);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${o} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let t;if(typeof l=="string"){const n=this.getExtensionElement(l);t=n?this.m.get(n):void 0}else t=l;return t&&t.children||void 0}return this.h}async Y(l){this.rb(l);const t=new S.$Wd(this.Z.token);try{const n=l?this.m.get(l):void 0,o=await this.f.getChildren(l);if(t.token.isCancellationRequested)return;const i=await Promise.all((0,I.$Gb)(o||[]).map(async c=>{const h=await this.f.getTreeItem(c);return h&&!t.token.isCancellationRequested?this.db(c,h,n):null}));return t.token.isCancellationRequested?void 0:(0,I.$Gb)(i)}finally{t.dispose()}}$(l){if(l.some(n=>!n))return this.Z.dispose(!0),this.Z=new S.$Wd,this.tb(),this.J.$refresh(this.I);{const n=this.ab(l);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(l){const t=new Set,n=l.map(i=>this.m.get(i));for(const i of n)if(i&&!t.has(i.item.handle)){let c=i;for(;c&&c.parent&&n.findIndex(h=>c&&c.parent&&h&&h.item.handle===c.parent.item.handle)===-1;){const h=this.j.get(c.parent.item.handle);c=h?this.m.get(h):void 0}c&&!c.parent&&t.add(i.item.handle)}const o=[];return t.forEach(i=>{const c=this.j.get(i);if(c){const h=this.m.get(c);h&&(!h.parent||!t.has(h.parent.item.handle))&&o.push(i)}}),o}bb(l){const t={};return Promise.all(l.map(n=>this.cb(n).then(o=>{o&&(t[n]=o.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(l){const t=this.getExtensionElement(l);if(t){const n=this.m.get(t);if(n)return this.rb(t),(0,E.$Lg)(()=>this.f.getTreeItem(t)).then(o=>{if(o){const i=this.ib(t,o,n.parent);return this.pb(t,i,n,n.parent),n.dispose(),i}return null})}return Promise.resolve(null)}db(l,t,n){const o=this.ib(l,t,n);if(t.id&&this.j.has(o.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(l,o),this.qb(o,n),o}eb(l){return w.$yK.isMarkdownString(l)?v.MarkdownString.from(l):l}fb(l,t){return t?{...this.L.toInternal(t,l),originalId:t.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let t,n,o;return typeof l.checkboxState=="number"?t=l.checkboxState:(t=l.checkboxState.state,n=l.checkboxState.tooltip,o=l.checkboxState.accessibilityInformation),{isChecked:t===w.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:o}}hb(l){if(!w.$WK.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,t,n){this.hb(t);const o=this.B(new R.$Qc),i=this.kb(l,t,n),c=this.lb(t);return{item:{handle:i,parentHandle:n?n.item.handle:void 0,label:r(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(o,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,A.$Gf)(t.collapsibleState)?w.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:n,children:void 0,disposableStore:o,dispose(){o.dispose()}}}jb(l){return l.iconPath instanceof w.$5K?l.iconPath:void 0}kb(l,{id:t,label:n,resourceUri:o},i,c){if(t)return`${a.b}/${t}`;const h=r(n,this.N),y=i?i.item.handle:a.a;let C=h?h.label:o?(0,T.$rg)(o):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const $=this.m.has(l)?this.m.get(l).item.handle:void 0,f=this.X(i)||[];let d,P=0;do{if(d=`${y}/${P}:${C}`,c||!this.j.has(d)||$===d)break;P++}while(P<=f.length);return d}lb(l){if(l.iconPath&&!(l.iconPath instanceof w.$5K))return typeof l.iconPath=="string"||g.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof w.$5K)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return g.URI.isUri(l)?l:g.URI.file(l)}ob(l,t){this.j.set(t.item.handle,l),this.m.set(l,t)}pb(l,t,n,o){this.j.delete(t.item.handle),this.m.delete(l),t.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(l,t);const i=this.X(o)||[],c=i.filter(h=>h.item.handle===n.item.handle)[0];c&&i.splice(i.indexOf(c),1,t)}qb(l,t){t?(t.children||(t.children=[]),t.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const t=this.m.get(l);if(t){if(t.children)for(const n of t.children){const o=this.j.get(n.item.handle);o&&this.sb(o)}t.children=void 0}}else this.tb()}sb(l){const t=this.m.get(l);if(t){if(t.children)for(const n of t.children){const o=this.j.get(n.item.handle);o&&this.sb(o)}this.m.delete(l),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(De[288],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[289],Ce([1,0,224,8,38,132,106,42,25,288,135,137]),function($e,e,D,T,g,L,R,b,E,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=void 0;const v=b.$$m.as(R.$_m.JSONContribution);class k{constructor(l,t,n){this.a=l,this.b=t,this.c=n}d(l,t){this.a({type:l,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(g.default.Error,l)}warn(l){this.d(g.default.Warning,l)}info(l){this.d(g.default.Info,l)}}e.$WE=k;class S{static a(l){const t=new E.$Zl;for(let n=0,o=l.length;n<o;n++)t.add(l[n].description.identifier);return t}static compute(l,t){if(!l||!l.length)return new S(t,[]);if(!t||!t.length)return new S([],l);const n=this.a(l),o=this.a(t),i=t.filter(h=>!n.has(h.description.identifier)),c=l.filter(h=>!o.has(h.description.identifier));return new S(i,c)}constructor(l,t){this.added=l,this.removed=t}}e.$XE=S;class p{constructor(l,t){this.name=l,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=S.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,T.$Z)(l)}}}e.$YE=p;const u={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$ZE={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$Xl},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"*",description:D.localize(42,null),body:"*"}]}},badges:{type:"array",description:D.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(44,null)},href:{type:"string",description:D.localize(45,null)},description:{type:"string",description:D.localize(46,null)}}}},markdown:{type:"string",description:D.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Pn}},extensionPack:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Pn}},extensionKind:{description:D.localize(51,null),type:"array",items:u,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(52,null)},{body:["workspace"],description:D.localize(53,null)},{body:["ui","workspace"],description:D.localize(54,null)},{body:["workspace","ui"],description:D.localize(55,null)},{body:[],description:D.localize(56,null)}]},capabilities:{description:D.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(60,null),D.localize(61,null),D.localize(62,null)]},description:{type:"string",markdownDescription:D.localize(63,null)}}},untrustedWorkspaces:{description:D.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(66,null),D.localize(67,null),D.localize(68,null)]},restrictedConfigurations:{description:D.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(70,null)}}}}},sponsor:{description:D.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(73,null),type:"string"},"vscode:uninstall":{description:D.localize(74,null),type:"string"}}},icon:{type:"string",description:D.localize(75,null)},l10n:{type:"string",description:D.localize(76,null)},pricing:{type:"string",markdownDescription:D.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class s{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const t=new p(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,t),l.activationEventsGenerator&&I.$NE.register(l.extensionPoint,l.activationEventsGenerator),e.$ZE.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,v.registerSchema(r,e.$ZE),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$1E=s;const a={ExtensionsRegistry:"ExtensionsRegistry"};b.$$m.add(a.ExtensionsRegistry,new s),e.$2E=b.$$m.as(a.ExtensionsRegistry),v.registerSchema(r,e.$ZE),v.registerSchema(A.$oj,{properties:{extensionEnabledApiProposals:{description:D.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(De[290],Ce([1,0,221,18,23,289,41,4]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var w;(function(v){function k(S,p,u){if(!S)return;const r=T.$xf(S.type)?S.type:void 0;if(!r||r.length===0){u.error(D.localize(3,null));return}const s=[];if(Array.isArray(S.required))for(const a of S.required)T.$xf(a)&&s.push(a);return{extensionId:p.value,taskType:r,required:s,properties:S.properties?g.$Ym(S.properties):{},when:S.when?R.$Li.deserialize(S.when):void 0}}v.from=k})(w||(w={}));const A=L.$2E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,k)=>{for(const S of v)S.type&&k.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:E}});class I{constructor(){this.d=new b.$Md,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,S)=>{A.setHandler((p,u)=>{this.c=void 0;try{for(const r of u.removed){const s=r.value;for(const a of s)this.a&&a.type&&this.a[a.type]&&delete this.a[a.type]}for(const r of u.added){const s=r.value;for(const a of s){const m=w.from(a,r.description.identifier,r.collector);m&&(this.a[m.taskType]=m)}}(u.removed.length>0||u.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const S of this.all()){const p={type:"object",additionalProperties:!1};S.required.length>0&&(p.required=S.required.slice(0)),S.properties!==void 0?p.properties=g.$Ym(S.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[S.taskType]},k.push(p)}this.c={oneOf:k}}return this.c}}e.$JF=new I}),define(De[291],Ce([1,0,222,18,24,23,41,290]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$TF=e.JsonSchemaVersion=e.ExecutionEngine=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$NF=e.ShellQuoting=e.$MF=e.$LF=e.$KF=void 0,e.$KF="settings",e.$LF=new R.$5i("taskRunning",!1,D.localize(0,null)),e.$MF={value:D.localize(1,null),original:"Tasks"};var E;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$NF="$customized",function(U){function F(V){if(!V)return U.Strong;switch(V.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=F}(E||(e.ShellQuoting=E={}));var w;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var A;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(A||(e.RevealKind=A={})),function(U){function F(V){switch(V.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=F}(A||(e.RevealKind=A={}));var I;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(U){function F(V){switch(V.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=F}(I||(e.RevealProblemKind=I={}));var v;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(v||(e.PanelKind=v={})),function(U){function F(V){switch(V.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=F}(v||(e.PanelKind=v={}));var k;(function(U){U.defaults={echo:!0,reveal:A.Always,revealProblems:I.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(k||(e.PresentationOptions=k={}));var S;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(U){function F(H){switch(H.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=F;function V(H){switch(H){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=V}(S||(e.RuntimeType=S={}));var p;(function(U){function F(V){return T.$xf(V)?V:V.value}U.value=F})(p||(e.CommandString=p={}));var u;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function F(H){return H===U.Clean._id||H===U.Build._id||H===U.Rebuild._id||H===U.Test._id}U.is=F;function V(H){if(H!==void 0)return T.$xf(H)?F(H)?{_id:H,isDefault:!1}:void 0:H}U.from=V})(u||(e.TaskGroup=u={}));var r;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var s;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function F(V){switch(V){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=F})(s||(e.TaskSourceKind=s={}));var a;(function(U){U.parallel="parallel",U.sequence="sequence"})(a||(e.DependsOrder=a={}));var m;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(m||(e.RunOnOptions=m={}));var l;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:m.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class t{constructor(F,V,H,fe,X,Y){this._label="",this._id=F,V&&(this._label=V),H&&(this.type=H),this.runOptions=fe,this.configurationProperties=X,this._source=Y}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,V=!1){if(F===void 0)return!1;if(T.$xf(F))return F===this._label||F===this.configurationProperties.identifier||V&&F===this._id;const H=this.getDefinition(!0);return H!==void 0&&H._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$OF=t;class n extends t{constructor(F,V,H,fe,X,Y,q,x){super(F,H,void 0,q,x,V),this.command={},this._source=V,this.hasDefinedMatchers=Y,X&&(this.command=X)}clone(){return new n(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case S.Shell:V="shell";break;case S.Process:V="process";break;case S.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(F){return F instanceof n}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===s.User?e.$KF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let V=this.configurationProperties.identifier;this._source.kind!==s.Workspace&&(V+=this._source.kind);const H={type:e.$NF,folder:F,id:V};return JSON.stringify(H)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$rg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new n(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$PF=n;class o extends t{constructor(F,V,H,fe,X,Y,q){super(F,H,fe,Y,q,V),this._source=V,this.configures=X}static is(F){return F instanceof o}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$rg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===s.User?e.$KF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let V=this.configurationProperties.identifier;this._source.kind!==s.Workspace&&(V+=this._source.kind);const H={type:e.$NF,folder:F,id:V};return JSON.stringify(H)}}e.$QF=o;class i extends t{constructor(F,V,H,fe,X,Y,q,x,me){super(F,H,fe,x,me,V),this.defines=X,this.hasDefinedMatchers=q,this.command=Y,this.icon=me.icon,this.hide=me.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof i}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new i(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$RF=i;class c extends t{constructor(F,V,H,fe,X,Y){super(F,H,fe,X,Y,V),this._source=V}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new c(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$SF=c;var h;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(U){U._default=U.Terminal}(h||(e.ExecutionEngine=h={}));var y;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class C{constructor(F){this.c=new Map;for(let V=0;V<F.length;V++)this.c.set(F[V].uri.toString(),V)}compare(F,V){const H=F.getWorkspaceFolder(),fe=V.getWorkspaceFolder();if(H&&fe){let X=this.c.get(H.uri.toString());X=X===void 0?0:X+1;let Y=this.c.get(fe.uri.toString());return Y=Y===void 0?0:Y+1,X===Y?F._label.localeCompare(V._label):X-Y}else return!H&&fe?-1:H&&!fe?1:0}}e.$TF=C;var $;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})($||(e.TaskEventKind=$={}));var f;(function(U){U.SingleRun="singleRun",U.Background="background"})(f||(e.TaskRunType=f={}));var d;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(d||(e.TaskRunSource=d={}));var P;(function(U){function F(x){return{taskId:x._id,taskName:x.configurationProperties.name,runType:x.configurationProperties.isBackground?"background":"singleRun",group:x.configurationProperties.group,__task:x}}function V(x,me,ue){return{...F(x),kind:"start",terminalId:me,resolvedVariables:ue}}U.start=V;function H(x,me,ue){return{...F(x),kind:"processStarted",terminalId:me,processId:ue}}U.processStarted=H;function fe(x,me,ue){return{...F(x),kind:"processEnded",terminalId:me,exitCode:ue}}U.processEnded=fe;function X(x,me,ue){return{...F(x),kind:"terminated",exitReason:ue,terminalId:me}}U.terminated=X;function Y(x,me,ue){return{...F(me),kind:x,terminalId:ue}}U.general=Y;function q(){return{kind:"changed"}}U.changed=q})(P||(e.TaskEvent=P={}));var N;(function(U){function F(H){const fe=Object.keys(H).sort();let X="";for(const Y of fe){let q=H[Y];q instanceof Object?q=F(q):typeof q=="string"&&(q=q.replace(/,/g,",,")),X+=Y+","+q+","}return X}function V(H){const X={_key:F(H),type:H.taskType};return Object.assign(X,H),X}U.create=V})(N||(e.KeyedTaskIdentifier=N={}));var O;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(O||(e.TaskSettingId=O={}));var M;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var j;(function(U){function F(V,H){const fe=b.$JF.get(V.type);if(fe===void 0){const x=L.$Ym(V);return delete x._key,N.create(x)}const X=Object.create(null);X.type=fe.taskType;const Y=new Set;fe.required.forEach(x=>Y.add(x));const q=fe.properties;for(const x of Object.keys(q)){const me=V[x];if(me!=null)X[x]=me;else if(Y.has(x)){const ue=q[x];if(ue.default!==void 0)X[x]=L.$Ym(ue.default);else switch(ue.type){case"boolean":X[x]=!1;break;case"number":case"integer":X[x]=0;break;case"string":X[x]="";break;default:H.error(D.localize(2,null,JSON.stringify(V,void 0,0),x));return}}}return N.create(X)}U.createTaskIdentifier=F})(j||(e.TaskDefinition=j={}))}),define(De[292],Ce([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_3b=e.$$3b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,b)=>{this.b=R,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,D.$Z)(R))}then(R,b){return this.j().then(R,b)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$$3b=T;class g extends T{constructor(){super(),this.h=!0,this.i=new D.$4}}e.$_3b=g}),define(De[68],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jv=e.$iv=e.$hv=e.$gv=void 0;class D{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++D.count}}e.$gv=D;const T=[];function g(b){const E=new D(b);return T[E.nid]=E,E}e.$hv=g;function L(b){return T[b].sid}e.$iv=L;class R{constructor(E){this.value=E}}e.$jv=R}),define(De[6],Ce([1,0,68]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$8J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var g;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(g||(e.TabInputKind=g={}));var L;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var b;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var E;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var w;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var A;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class I{static{this.a=0}static mixin(u){return u._id=I.a++,u}}e.$8J=I;var v;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var k;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var S;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$9J={MainThreadAuthentication:(0,D.$hv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$hv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$hv)("MainThreadChatProvider"),MainThreadChatAgents:(0,D.$hv)("MainThreadChatAgents"),MainThreadChatVariables:(0,D.$hv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$hv)("MainThreadClipboard"),MainThreadCommands:(0,D.$hv)("MainThreadCommands"),MainThreadComments:(0,D.$hv)("MainThreadComments"),MainThreadConfiguration:(0,D.$hv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$hv)("MainThreadConsole"),MainThreadDebugService:(0,D.$hv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$hv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$hv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$hv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$hv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$hv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$hv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$hv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$hv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$hv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$hv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$hv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$hv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$hv)("MainThreadLanguages"),MainThreadLogger:(0,D.$hv)("MainThreadLogger"),MainThreadMessageService:(0,D.$hv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$hv)("MainThreadOutputService"),MainThreadProgress:(0,D.$hv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$hv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$hv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$hv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$hv)("MainThreadSecretState"),MainThreadStorage:(0,D.$hv)("MainThreadStorage"),MainThreadTelemetry:(0,D.$hv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$hv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$hv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$hv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$hv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$hv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$hv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$hv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$hv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$hv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$hv)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.$hv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$hv)("MainThreadSCM"),MainThreadSearch:(0,D.$hv)("MainThreadSearch"),MainThreadShare:(0,D.$hv)("MainThreadShare"),MainThreadTask:(0,D.$hv)("MainThreadTask"),MainThreadWindow:(0,D.$hv)("MainThreadWindow"),MainThreadLabelService:(0,D.$hv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$hv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$hv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$hv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$hv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$hv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$hv)("MainThreadInteractive"),MainThreadChat:(0,D.$hv)("MainThreadChat"),MainThreadInlineChat:(0,D.$hv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$hv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$hv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$hv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$hv)("MainThreadTimeline"),MainThreadTesting:(0,D.$hv)("MainThreadTesting"),MainThreadLocalization:(0,D.$hv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$hv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$hv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$hv)("MainThreadIssueReporter")},e.$0J={ExtHostCommands:(0,D.$hv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$hv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$hv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$hv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$hv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$hv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$hv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$hv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$hv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$hv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$hv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$hv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$hv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$hv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$hv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$hv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$hv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$hv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$hv)("ExtHostStatusBar"),ExtHostShare:(0,D.$hv)("ExtHostShare"),ExtHostExtensionService:(0,D.$hv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$hv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$hv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$hv)("ExtHostSCM"),ExtHostSearch:(0,D.$hv)("ExtHostSearch"),ExtHostTask:(0,D.$hv)("ExtHostTask"),ExtHostWorkspace:(0,D.$hv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$hv)("ExtHostWindow"),ExtHostWebviews:(0,D.$hv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$hv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$hv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$hv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$hv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$hv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$hv)("ExtHostProgress"),ExtHostComments:(0,D.$hv)("ExtHostComments"),ExtHostSecretState:(0,D.$hv)("ExtHostSecretState"),ExtHostStorage:(0,D.$hv)("ExtHostStorage"),ExtHostUrls:(0,D.$hv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$hv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$hv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$hv)("ExtHostOutputService"),ExtHosLabelService:(0,D.$hv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$hv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$hv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$hv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$hv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$hv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$hv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$hv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$hv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$hv)("ExtHostChat"),ExtHostChatAgents:(0,D.$hv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$hv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$hv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,D.$hv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$hv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$hv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$hv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$hv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$hv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$hv)("ExtHostTimeline"),ExtHostTesting:(0,D.$hv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$hv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$hv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$hv)("ExtHostIssueReporter")}}),define(De[293],Ce([1,0,6,7]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$9J.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,b,E){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(R);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(b,E)??[]}getRelatedInformation(R,b,E){return this.c.$getAiRelatedInformation(b,E)}registerRelatedInformationProvider(R,b,E){const w=this.b;return this.b++,this.a.set(w,E),this.c.$registerAiRelatedInformationProvider(w,b),new T.$$J(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$Ddc=g}),define(De[90],Ce([1,0,5,13,6,20]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=e.$Hbc=e.$Gbc=void 0,e.$Gbc=(0,D.$Nh)("IExtHostApiDeprecationService");let R=class{constructor(E,w){this.c=w,this.a=new Set,this.b=E.getProxy(g.$9J.MainThreadTelemetry)}report(E,w,A){const I=this.d(E,w);this.a.has(I)||(this.a.add(I),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:E}))}d(E,w){return`${E}-${w.identifier.value}`}};e.$Hbc=R,e.$Hbc=R=He([Be(0,L.$0L),Be(1,T.$8i)],R),e.$Ibc=Object.freeze(new class{report(b,E,w){}})}),define(De[294],Ce([1,0,4,6,7,25]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;class R{constructor(w){this.b=new Map,this.c=[],this.d=new D.$Md,this.onDidChangeSessions=this.d.event,this.f=new b,this.g=new b,this.a=w.getProxy(T.$9J.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,A,I,v={}){const k=L.$Yl.toKey(w.identifier),S=[...I].sort().join(" ");return await this.f.getOrCreate(`${k} ${A} ${S}`,async()=>{await this.a.$ensureProvider(A);const p=w.displayName||w.name;return this.a.$getSession(A,I,k,p,v)})}async getSessions(w,A,I){const v=L.$Yl.toKey(w.identifier),k=[...I].sort().join(" ");return await this.g.getOrCreate(`${v} ${k}`,async()=>{await this.a.$ensureProvider(A);const S=w.displayName||w.name;return this.a.$getSessions(A,I,v,S)})}async removeSession(w,A){const I=this.b.get(w);return I?I.provider.removeSession(A):this.a.$removeSession(w,A)}registerAuthenticationProvider(w,A,I,v){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:A,provider:I,options:v??{supportsMultipleAccounts:!1}}),this.c.find(S=>S.id===w)||this.c.push({id:w,label:A});const k=I.onDidChangeSessions(S=>{this.a.$sendDidChangeSessions(w,{added:S.added??[],changed:S.changed??[],removed:S.removed??[]})});return this.a.$registerAuthenticationProvider(w,A,v?.supportsMultipleAccounts??!1),new g.$$J(()=>{k.dispose(),this.b.delete(w);const S=this.c.findIndex(p=>p.id===w);S>-1&&this.c.splice(S),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,A,I){const v=this.b.get(w);if(v)return Promise.resolve(v.provider.createSession(A,I));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,A){const I=this.b.get(w);if(I)return Promise.resolve(I.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,A){const I=this.b.get(w);if(I)return Promise.resolve(I.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,A){return this.d.fire({provider:{id:w,label:A}}),Promise.resolve()}}e.$cdc=R;class b{constructor(){this.a=new Map}getOrCreate(w,A){const I=this.a.get(w);if(I)return I;const v=A().finally(()=>this.a.delete(w));return this.a.set(w,v),v}}}),define(De[295],Ce([1,0,6,20,14]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;let L=class{constructor(b,E){this.a=b.getProxy(D.$9J.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>E.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,E,w){const A=g.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,w?.isRefactoring??!1)}};e.$idc=L,e.$idc=L=He([Be(0,T.$0L)],L)}),define(De[296],Ce([1,0,11,4,50,3,37,202,6,14]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class A{static{this.a=0}constructor(k,S){this.extension=k,this.provider=S,this.handle=A.a++}}class I{static{this.a=0}constructor(k,S){this.i=S,this.b=new Map,this.e=new Map,this.g=new T.$Md,this.onDidPerformUserAction=this.g.event,this.h=k.getProxy(E.$9J.MainThreadChat)}registerChatProvider(k,S,p){const u=new A(k,p);return this.b.set(u.handle,u),this.h.$registerChatProvider(u.handle,S),(0,L.$Pc)(()=>{this.h.$unregisterChatProvider(u.handle),this.b.delete(u.handle)})}transferChatSession(k,S){const p=g.Iterable.find(this.e.keys(),u=>this.e.get(u)===k)??0;typeof p=="number"&&this.h.$transferChatSession(p,S)}addChatRequest(k){this.h.$addRequest(k)}sendInteractiveRequestToProvider(k,S){this.h.$sendRequestToProvider(k,S)}async $prepareChat(k,S,p){const u=this.b.get(k);if(!u)return;const r=await u.provider.prepareSession(S,p);if(!r)return;const s=I.a++;return this.e.set(s,r),{id:s,requesterUsername:r.requester?.name,requesterAvatarIconUri:r.requester?.icon,responderUsername:r.responder?.name,responderAvatarIconUri:r.responder?.icon,inputPlaceholder:r.inputPlaceholder}}async $resolveRequest(k,S,p,u){const r=this.b.get(k);if(!r)return;const s=this.e.get(S);if(!s||!r.provider.resolveRequest)return;const a=await r.provider.resolveRequest(s,p,u);if(a)return{message:typeof a.message=="string"?a.message:w.ChatReplyFollowup.from(a.message)}}async $provideWelcomeMessage(k,S){const p=this.b.get(k);if(!p||!p.provider.provideWelcomeMessage)return;const u=await p.provider.provideWelcomeMessage(S);if(u)return u.map(r=>typeof r=="string"?r:r.map(s=>w.ChatReplyFollowup.from(s)))}async $provideFollowups(k,S,p){const u=this.b.get(k);if(!u)return;const r=this.e.get(S);return!r||!u.provider.provideFollowups?void 0:(await u.provider.provideFollowups(r,p))?.map(a=>w.ChatFollowup.from(a))}$removeRequest(k,S,p){const u=this.b.get(k);if(!u)return;const r=this.e.get(S);r&&u.provider.removeRequest&&u.provider.removeRequest(r,p)}async $provideReply(k,S,p,u){const r=this.b.get(k);if(!r)return;const s=this.e.get(S);if(!s)return;const a={session:s,message:typeof p.message=="string"?p.message:w.ChatReplyFollowup.to(p.message),variables:{}};if(p.variables)for(const i of Object.keys(p.variables))a.variables[i]=p.variables[i].map(w.ChatVariable.to);const m=R.$Id.create(!1);let l;const t={report:i=>{if(!u.isCancellationRequested)if(typeof l>"u"&&(l=m.elapsed()),"responseId"in i)this.h.$acceptResponseProgress(k,S,{requestId:i.responseId});else if("placeholder"in i&&"resolvedContent"in i){const c=Promise.all([this.h.$acceptResponseProgress(k,S,{placeholder:i.placeholder}),i.resolvedContent]);(0,D.$Hg)(c,u).then(h=>{if(!h)return;const[y,C]=h;this.h.$acceptResponseProgress(k,S,C,y??void 0)})}else"content"in i?this.h.$acceptResponseProgress(k,S,{content:typeof i.content=="string"?i.content:w.MarkdownString.from(i.content)}):"documents"in i?this.h.$acceptResponseProgress(k,S,{documents:i.documents.map(c=>({uri:c.uri,version:c.version,ranges:c.ranges.map(h=>w.Range.from(h))}))}):this.h.$acceptResponseProgress(k,S,i)}};let n;try{n=await r.provider.provideResponseWithProgress(a,t,u),n||(n={errorDetails:{message:(0,b.localize)(0,null)}})}catch(i){n={errorDetails:{message:(0,b.localize)(1,null,i.message),responseIsIncomplete:!0}},this.i.error(i)}try{if(s.saveState&&this.e.has(S)){const i=s.saveState();this.h.$acceptChatState(S,i)}}catch(i){this.i.warn(i)}const o={firstProgress:l??0,totalElapsed:m.elapsed()};return{errorDetails:n.errorDetails,timings:o}}async $provideSlashCommands(k,S,p){const u=this.b.get(k);if(!u)return;const r=this.e.get(S);return!r||!u.provider.provideSlashCommands?void 0:(await u.provider.provideSlashCommands(r,p))?.map(a=>({...a,kind:w.CompletionItemKind.from(a.kind)}))}$releaseSession(k){this.e.delete(k)}async $onDidPerformUserAction(k){this.g.fire(k)}}e.$wdc=I}),define(De[297],Ce([1,0,11,3,84,6,14,7]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class E{static{this.a=0}constructor(I,v,k){this.d=v,this.e=k,this.b=new Map,this.c=I.getProxy(L.$9J.MainThreadChatAgents)}registerAgent(I,v,k,S){const p=E.a++;return this.b.set(p,{extension:I,agent:k}),this.c.$registerAgent(p,v,S),(0,T.$Pc)(()=>{this.c.$unregisterAgent(p),this.b.delete(p)})}async $invokeAgent(I,v,k,S,p){const u=this.b.get(I);if(!u){this.e.warn(`[CHAT](${I}) CANNOT invoke agent because the agent is not registered`);return}let r=!1;function s(){if(r)throw new Error("Only valid while executing the command")}const a=new D.$bh;p.onCancellationRequested(()=>a.complete()),setTimeout(()=>a.complete(),3*1e3),this.d.allowListExtensionWhile(u.extension,a.p);const m=u.agent({role:b.ChatMessageRole.User,content:k},{history:S.history.map(R.ChatMessage.to)},new g.$Yu(l=>{s(),this.c.$handleProgressChunk(v,{content:w(l.message)?l.message:l.message.value})}),p);try{return await(0,D.$Hg)(Promise.resolve(m).then(l=>{if(l&&"followUp"in l)return{followUp:l?.followUp?.map(n=>R.ChatFollowup.from(n))}}),p)}finally{r=!0,a.complete()}}}e.$Fdc=E;function w(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(De[298],Ce([1,0,3,6,14,84,25]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class b{static{this.a=1}constructor(w,A){this.d=A,this.c=new Map,this.e=new Map,this.f=new R.$1l,this.b=w.getProxy(T.$9J.MainThreadChatProvider)}registerProvider(w,A,I,v){const k=b.a++;return this.c.set(k,{extension:w,provider:I}),this.b.$registerProvider(k,A,{extension:w,displayName:v.name??w.value}),(0,D.$Pc)(()=>{this.b.$unregisterProvider(k),this.c.delete(k)})}async $provideChatResponse(w,A,I,v,k){const S=this.c.get(w);if(!S)return;const p=new L.$Yu(async u=>{if(k.isCancellationRequested){this.d.warn(`[CHAT](${S.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(A,{index:u.index,part:u.part})},{async:!0});return S.provider.provideChatResponse(I.map(g.ChatMessage.to),v,p,k)}allowListExtensionWhile(w,A){this.f.set(w,A),A.finally(()=>this.f.delete(w))}async requestChatResponseProvider(w,A){if(!this.f.has(w))throw new Error("Extension is NOT allowed to make chat requests");const I=this;return{get isRevoked(){return!I.f.has(w)},async makeRequest(v,k,S,p){if(!I.f.has(w))throw new Error("Access to chat has been revoked");const u=Math.random()*1e6|0;I.e.set(u,S);try{await I.b.$fetchResponse(w,A,u,v.map(g.ChatMessage.from),k,p)}finally{I.e.delete(u)}}}}async $handleResponseFragment(w,A){this.e.get(w)?.report(A)}}e.$Bdc=b}),define(De[299],Ce([1,0,3,6,8,14]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class R{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(T.$9J.MainThreadChatVariables)}async $resolveVariable(E,w,A){const I=this.b.get(E);if(I)try{const v=await I.resolver.resolve(I.data.name,{message:w},A);if(v)return v.map(L.ChatVariable.from)}catch(v){(0,g.$1)(v)}}registerVariableResolver(E,w,A,I){const v=R.a++;return this.b.set(v,{extension:E.identifier,data:{name:w,description:A},resolver:I}),this.c.$registerVariable(v,{name:w,description:A}),(0,D.$Pc)(()=>{this.b.delete(v),this.c.$unregisterVariable(v)})}}e.$Cdc=R}),define(De[300],Ce([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=void 0;class T{constructor(L){const R=L.getProxy(D.$9J.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(b){return R.$writeText(b)}})}}e.$Lbc=T}),define(De[33],Ce([1,0,18,7,14,23,6,19,13,62,34,61,2,3,5,20,145,22,68,46,37,85,89]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=void 0;let n=class{#e;#t;#i;constructor(C,$,f){this.b=new Map,this.c=new Map,this.#e=C.getProxy(R.$9J.MainThreadCommands),this.d=$,this.#i=f,this.#t=C.getProxy(R.$9J.MainThreadTelemetry),this.converter=new o(this,d=>{const P=this.c.get(d);return P?.result===c.Void?P:void 0},$),this.f=[{processArgument(d){return(0,w.$kh)(d)}},{processArgument(d){return(0,L.$1m)(d,function(P){if(A.$ns.isIRange(P))return g.Range.to(P);if(I.$ms.isIPosition(P))return g.Position.to(P);if(A.$ns.isIRange(P.range)&&v.URI.isUri(P.uri))return g.location.to(P);if(P instanceof r.$ae)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const $=this.registerCommand(!1,C.id,async(...f)=>{const d=C.args.map((N,O)=>{if(!N.validate(f[O]))throw new Error(`Invalid argument '${N.name}' when running '${C.id}', received: ${typeof f[O]=="object"?JSON.stringify(f[O],null,"	"):f[O]} `);return N.convert(f[O])}),P=await this.executeCommand(C.internalId,...d);return C.result.convert(P,f,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new T.$$J(()=>{$.dispose(),this.c.delete(C.id)})}registerCommand(C,$,f,d,P,N){if(this.d.trace("ExtHostCommands#registerCommand",$),!$.trim().length)throw new Error("invalid id");if(this.b.has($))throw new Error(`command '${$}' already exists`);return this.b.set($,{callback:f,thisArg:d,description:P,extension:N}),C&&this.#e.$registerCommand($),new T.$$J(()=>{this.b.delete($)&&C&&this.#e.$unregisterCommand($)})}executeCommand(C,...$){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,$,!0)}async g(C,$,f){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,$,!1);{let d=!1;const P=(0,L.$1m)($,function(N){if(N instanceof T.$_J)return g.Position.from(N);if(N instanceof T.$aK)return g.Range.from(N);if(N instanceof T.$kK)return g.location.from(N);if(T.$vL.isNotebookRange(N))return g.NotebookRange.from(N);if(N instanceof ArrayBuffer)return d=!0,r.$ae.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return d=!0,r.$ae.wrap(N);if(N instanceof r.$ae)return d=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(C,d?new s.$jv(P):P,f);return(0,w.$kh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(C,$,!1);throw N}}}async h(C,$,f){const d=this.b.get(C);if(!d)throw new Error("Unknown command");const{callback:P,thisArg:N,description:O}=d;if(O)for(let j=0;j<O.args.length;j++)try{(0,D.$Of)($[j],O.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed.Illegal argument '${O.args[j].name}' - ${O.args[j].description} `)}const M=m.$Id.create();try{return await P.apply(N,$)}catch(j){if(C===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...$);U&&(C=U.command)}if(this.d.error(j,C,d.extension?.identifier),!f)throw j;if(d.extension?.identifier){const U=this.#i.onExtensionError(d.extension.identifier,j);this.d.trace("forwarded error to extension?",U,d.extension?.identifier)}throw new class extends Error{constructor(){super((0,a.$yi)(j)),this.id=C,this.source=d.extension?.displayName??d.extension?.name}}}finally{this.j(d,C,M.elapsed())}}j(C,$,f){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new l.$co($),duration:f})}$executeContributedCommand(C,...$){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const f=this.b.get(C);return f?($=$.map(d=>this.f.reduce((P,N)=>N.processArgument(P,f.extension?.identifier),d)),this.h(C,$,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then($=>(C&&($=$.filter(f=>f[0]!=="_")),$))}$getContributedCommandHandlerDescriptions(){const C=Object.create(null);for(const[$,f]of this.b){const{description:d}=f;d&&(C[$]=d)}return Promise.resolve(C)}};e.$sM=n,e.$sM=n=He([Be(0,p.$0L),Be(1,E.$8i),Be(2,t.$rM)],n),e.$tM=(0,S.$Nh)("IExtHostCommands");class o{constructor(C,$,f){this.d=C,this.f=$,this.g=f,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,$){if(!C)return;const f={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return f;const d=this.f(C.command);if(d)f.id=d.internalId,f.arguments=d.args.map((P,N)=>P.convert(C.arguments&&C.arguments[N]));else if((0,b.$Kb)(C.arguments)){const P=`${C.command} /${++this.c}`;this.b.set(P,C),$.add((0,k.$Pc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),f.$ident=P,f.id=this.delegatingCommandId,f.arguments=[P],this.g.trace("CommandsConverter#CREATE",C.command,P)}return f}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const $=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],$?$.command:"MISSING"),$?this.d.executeCommand($.command,...$.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$uM=o;class i{static{this.Uri=new i("uri","Uri of a text document",C=>v.URI.isUri(C),C=>C)}static{this.Position=new i("position","A position in a text document",C=>T.$_J.isPosition(C),g.Position.from)}static{this.Range=new i("range","A range in a text document",C=>T.$aK.isRange(C),g.Range.from)}static{this.Selection=new i("selection","A selection in a text document",C=>T.$bK.isSelection(C),g.Selection.from)}static{this.Number=new i("number","",C=>typeof C=="number",C=>C)}static{this.String=new i("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=i.Arr(i.String)}static Arr(C){return new i(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,$=>Array.isArray($)&&$.every(f=>C.validate(f)),$=>$.map(f=>C.convert(f)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",C=>C instanceof T.$uK,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",C=>C instanceof T.$OL,g.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VS Code TestItem",C=>C instanceof u.$kM,g.TestItem.from)}constructor(C,$,f,d){this.name=C,this.description=$,this.validate=f,this.convert=d}optional(){return new i(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,$){return new i(C??this.name,$??this.description,this.validate,this.convert)}}e.$vM=i;class c{static{this.Void=new c("no result",C=>C)}constructor(C,$){this.description=C,this.convert=$}}e.$wM=c;class h{constructor(C,$,f,d,P){this.id=C,this.internalId=$,this.description=f,this.args=d,this.result=P}}e.$xM=h}),define(De[301],Ce([1,0,19,17,2,82,129,41,134,33,14,7]),function($e,e,D,T,g,L,R,b,E,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;const v=[new w.$xM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[w.$vM.Uri,w.$vM.Position],new w.$wM("A promise that resolves to an array of DocumentHighlight-instances.",S(A.DocumentHighlight.to))),new w.$xM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[w.$vM.Uri],new w.$wM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,r)=>{if((0,D.$Jb)(u))return;class s extends I.$pK{static to(m){const l=new s(m.name,A.SymbolKind.to(m.kind),m.containerName||"",new I.$kK(r[0],A.Range.to(m.range)));return l.detail=m.detail,l.range=l.location.range,l.selectionRange=A.Range.to(m.selectionRange),l.children=m.children?m.children.map(s.to):[],l}}return u.map(s.to)})),new w.$xM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[w.$vM.Uri,new w.$vM("options","Formatting options",u=>!0,u=>u)],new w.$wM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new w.$xM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[w.$vM.Uri,w.$vM.Range,new w.$vM("options","Formatting options",u=>!0,u=>u)],new w.$wM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new w.$xM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[w.$vM.Uri,w.$vM.Position,new w.$vM("ch","Trigger character",u=>typeof u=="string",u=>u),new w.$vM("options","Formatting options",u=>!0,u=>u)],new w.$wM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new w.$xM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[w.$vM.Uri,w.$vM.Position],new w.$wM("A promise that resolves to an array of Location or LocationLink instances.",p)),new w.$xM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[w.$vM.Uri,w.$vM.Position],new w.$wM("A promise that resolves to an array of Location or LocationLink instances.",p)),new w.$xM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[w.$vM.Uri,w.$vM.Position],new w.$wM("A promise that resolves to an array of Location or LocationLink instances.",p)),new w.$xM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[w.$vM.Uri,w.$vM.Position],new w.$wM("A promise that resolves to an array of Location or LocationLink instances.",p)),new w.$xM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[w.$vM.Uri,w.$vM.Position],new w.$wM("A promise that resolves to an array of Location-instances.",S(A.location.to))),new w.$xM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[w.$vM.Uri,w.$vM.Position],new w.$wM("A promise that resolves to an array of Hover-instances.",S(A.Hover.to))),new w.$xM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[w.$vM.Uri,new w.$vM("position","A position in a text document",u=>Array.isArray(u)&&u.every(r=>I.$_J.isPosition(r)),u=>u.map(A.Position.from))],new w.$wM("A promise that resolves to an array of ranges.",u=>u.map(r=>{let s;for(const a of r.reverse())s=new I.$tK(A.Range.to(a),s);return s}))),new w.$xM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[w.$vM.String.with("query","Search string")],new w.$wM("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(A.WorkspaceSymbol.to))),new w.$xM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[w.$vM.Uri,w.$vM.Position],new w.$wM("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(A.CallHierarchyItem.to))),new w.$xM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[w.$vM.CallHierarchyItem],new w.$wM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(A.CallHierarchyIncomingCall.to))),new w.$xM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[w.$vM.CallHierarchyItem],new w.$wM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(A.CallHierarchyOutgoingCall.to))),new w.$xM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[w.$vM.Uri,w.$vM.Position],new w.$wM("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:A.Range.to(u.range),placeholder:u.text}})),new w.$xM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[w.$vM.Uri,w.$vM.Position,w.$vM.String.with("newName","The new symbol name")],new w.$wM("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return A.WorkspaceEdit.to(u)}})),new w.$xM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[w.$vM.Uri,w.$vM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new w.$wM("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(A.DocumentLink.to))),new w.$xM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[w.$vM.Uri],new w.$wM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new I.$nL(u.tokenTypes,u.tokenModifiers)})),new w.$xM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[w.$vM.Uri],new w.$wM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const r=(0,R.$L0)(u);if(r.type==="full")return new I.$pL(r.data,void 0)})),new w.$xM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[w.$vM.Uri,w.$vM.Range.optional()],new w.$wM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new I.$nL(u.tokenTypes,u.tokenModifiers)})),new w.$xM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[w.$vM.Uri,w.$vM.Range],new w.$wM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const r=(0,R.$L0)(u);if(r.type==="full")return new I.$pL(r.data,void 0)})),new w.$xM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[w.$vM.Uri,w.$vM.Position,w.$vM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),w.$vM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new w.$wM("A promise that resolves to a CompletionList-instance.",(u,r,s)=>{if(!u)return new I.$FK([]);const a=u.suggestions.map(m=>A.CompletionItem.to(m,s));return new I.$FK(a,u.incomplete)})),new w.$xM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[w.$vM.Uri,w.$vM.Position,w.$vM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new w.$wM("A promise that resolves to SignatureHelp.",u=>{if(u)return A.SignatureHelp.to(u)})),new w.$xM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[w.$vM.Uri,w.$vM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new w.$wM("A promise that resolves to an array of CodeLens-instances.",(u,r,s)=>S(a=>new I.$xK(A.Range.to(a.range),a.command&&s.fromInternal(a.command)))(u))),new w.$xM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[w.$vM.Uri,new w.$vM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>I.$aK.isRange(u),u=>I.$bK.isSelection(u)?A.Selection.from(u):A.Range.from(u)),w.$vM.String.with("kind","Code action kind to return code actions for").optional(),w.$vM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new w.$wM("A promise that resolves to an array of Command-instances.",(u,r,s)=>S(a=>{if(a._isSynthetic){if(!a.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(a.command)}else{const m=new I.$rK(a.title,a.kind?new I.$sK(a.kind):void 0);return a.edit&&(m.edit=A.WorkspaceEdit.to(a.edit)),a.command&&(m.command=s.fromInternal(a.command)),m.isPreferred=a.isPreferred,m}})(u))),new w.$xM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[w.$vM.Uri],new w.$wM("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(r=>new I.$LK(A.Range.to(r.range),A.Color.to(r.color))):[])),new w.$xM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new w.$vM("color","The color to show and insert",u=>u instanceof I.$KK,A.Color.from),new w.$vM("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:A.Range.from(u.range)}))],new w.$wM("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(A.ColorPresentation.to):[])),new w.$xM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[w.$vM.Uri,w.$vM.Range],new w.$wM("A promise that resolves to an array of Inlay objects",(u,r,s)=>u.map(A.InlayHint.to.bind(void 0,s)))),new w.$xM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[w.$vM.Uri],new w.$wM("A promise that resolves to an array of FoldingRange objects",(u,r)=>{if(u)return u.map(A.FoldingRange.to)})),new w.$xM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new w.$wM("A promise that resolves to an array of NotebookContentProvider static info objects.",S(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(r=>A.NotebookExclusiveDocumentPattern.to(r))})))),new w.$xM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[w.$vM.Uri,w.$vM.Range,new w.$vM("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof I.$aK,u=>A.InlineValueContext.from(u))],new w.$wM("A promise that resolves to an array of InlineValue objects",u=>u.map(A.InlineValue.to))),new w.$xM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new w.$vM("uriOrString","Uri-instance or string (only http/https)",u=>g.URI.isUri(u)||typeof u=="string"&&(0,E.$5T)(u,T.Schemas.http,T.Schemas.https),u=>u),new w.$vM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[A.ViewColumn.from(u),void 0]:[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)])).optional(),w.$vM.String.with("label","").optional()],w.$wM.Void),new w.$xM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[w.$vM.Uri.with("resource","Resource to open"),w.$vM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new w.$vM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[A.ViewColumn.from(u),void 0]:[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)])).optional()],w.$wM.Void),new w.$xM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[w.$vM.Uri.with("left","Left-hand side resource of the diff editor"),w.$vM.Uri.with("right","Right-hand side resource of the diff editor"),w.$vM.String.with("title","Human readable title for the diff editor").optional(),new w.$vM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)]).optional()],w.$wM.Void),new w.$xM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[w.$vM.Uri,w.$vM.Position],new w.$wM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new w.$xM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[w.$vM.TypeHierarchyItem],new w.$wM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new w.$xM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[w.$vM.TypeHierarchyItem],new w.$wM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new w.$xM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[w.$vM.TestItem],w.$wM.Void),new w.$xM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[w.$vM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],w.$wM.Void),new w.$xM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[w.$vM.String.with("name","The context key name"),new w.$vM("value","The context key value",()=>!0,u=>u)],w.$wM.Void),new w.$xM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[w.$vM.Uri,w.$vM.StringArray,new w.$vM("MappedEditsContext","Mapped Edits Context",u=>A.MappedEditsContext.is(u),u=>A.MappedEditsContext.from(u))],new w.$wM("A promise that resolves to a workspace edit or null",u=>u?A.WorkspaceEdit.to(u):null))];class k{static register(r){v.forEach(r.registerApiCommand,r),this.a(r)}static a(r){r.registerCommand(!1,"_validateWhenClauses",b.$Mi)}}e.$Kbc=k;function S(u){return r=>{if(Array.isArray(r))return r.map(u)}}function p(u){if(!Array.isArray(u))return;const r=[];for(const s of u)L.$$s(s)?r.push(A.DefinitionLink.to(s)):r.push(A.location.to(s));return r}}),define(De[302],Ce([1,0,11,57,4,3,2,82,25,14,7,6,27]),function($e,e,D,T,g,L,R,b,E,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=void 0;function k(S,p,u){const r=S.getProxy(I.$9J.MainThreadComments);class s{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$1l,p.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const y=this.b.get(h.handle);return y?y.value:h}else if(h&&h.$mid===7){const y=this.b.get(h.commentControlHandle);if(!y)return h;const C=y.getCommentThread(h.commentThreadHandle);return C?C.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const y=this.b.get(h.thread.commentControlHandle);if(!y)return h;const C=y.getCommentThread(h.thread.commentThreadHandle);return C?h.$mid===8?C.value:{thread:C.value,text:h.text}:h}else if(h&&h.$mid===10){const y=this.b.get(h.thread.commentControlHandle);if(!y)return h;const C=y.getCommentThread(h.thread.commentThreadHandle);if(!C)return h;const $=h.commentUniqueId,f=C.getCommentByUniqueId($);return f||h}else if(h&&h.$mid===11){const y=this.b.get(h.thread.commentControlHandle);if(!y)return h;const C=y.getCommentThread(h.thread.commentThreadHandle);if(!C)return h;const $=h.text,f=h.commentUniqueId,d=C.getCommentByUniqueId(f);return d?(typeof d.body=="string"?d.body=$:d.body=new A.$yK($),d):h}return h}})}createCommentController(h,y,C){const $=s.a++,f=new m(h,$,y,C);this.b.set(f.handle,f);const d=this.c.get(h.identifier)||[];return d.push(f),this.c.set(h.identifier,d),f.value}$createCommentThreadTemplate(h,y,C){const $=this.b.get(h);$&&$.$createCommentThreadTemplate(y,C)}async $updateCommentThreadTemplate(h,y,C){const $=this.b.get(h);$&&$.$updateCommentThreadTemplate(y,C)}$deleteCommentThread(h,y){this.b.get(h)?.$deleteCommentThread(y)}$provideCommentingRanges(h,y,C){const $=this.b.get(h);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const f=u.getDocument(R.URI.revive(y));return(0,D.$Lg)(async()=>{const d=await $.commentingRangeProvider.provideCommentingRanges(f,C);let P;return Array.isArray(d)?P={ranges:d,fileComments:!1}:d?P={ranges:d.ranges||[],fileComments:d.fileComments||!1}:P=d??void 0,P}).then(d=>{let P;return d&&(P={ranges:d.ranges.map(N=>w.Range.from(N)),fileComments:d.fileComments}),P})}$toggleReaction(h,y,C,$,f){const d=this.b.get(h);return!d||!d.reactionHandler?Promise.resolve(void 0):(0,D.$Lg)(()=>{const P=d.getCommentThread(y);if(P){const N=P.getCommentByUniqueId($.uniqueIdInThread);if(d!==void 0&&N&&d.reactionHandler)return d.reactionHandler(N,n(f))}return Promise.resolve(void 0)})}}class a{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,y,C,$,f,d,P,N){this.m=y,this.n=C,this.o=$,this.p=f,this.q=d,this.extensionDescription=P,this.r=N,this.handle=a.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$Md,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Sc,this.l.value=new L.$Qc,this.n===void 0&&(this.n=`${h}.${this.handle}`),r.$createCommentThread(y,this.handle,this.n,this.o,w.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=d,this.i.push({dispose:()=>{r.$deleteCommentThread(y,this.handle)}});const O=this;this.value={get uri(){return O.uri},get range(){return O.range},set range(M){O.range=M},get comments(){return O.comments},set comments(M){O.comments=M},get collapsibleState(){return O.collapsibleState},set collapsibleState(M){O.collapsibleState=M},get canReply(){return O.canReply},set canReply(M){O.canReply=M},get contextValue(){return O.contextValue},set contextValue(M){O.contextValue=M},get label(){return O.label},set label(M){O.label=M},get state(){return O.state},set state(M){O.state=M},dispose:()=>{O.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Qc);const h=C=>Object.prototype.hasOwnProperty.call(this.b,C),y={};h("range")&&(y.range=w.Range.from(this.p)),h("label")&&(y.label=this.label),h("contextValue")&&(y.contextValue=this.contextValue??null),h("comments")&&(y.comments=this.q.map(C=>l(this,C,this.k,this.extensionDescription))),h("collapsibleState")&&(y.collapseState=o(this.g)),h("canReply")&&(y.canReply=this.canReply),h("state")&&(y.state=i(this.h)),h("isTemplate")&&(y.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,y)}getCommentByUniqueId(h){for(const y of this.k){const C=y[0],$=y[1];if(h===$)return C}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}He([(0,T.$gh)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class m{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,r.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,y,C,$){this.f=h,this.g=y,this.h=C,this.i=$,this.a=new Map,r.$registerCommentController(this.handle,C,$,this.f.identifier.value);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(d){f.options=d},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(d){f.commentingRangeProvider=d},get reactionHandler(){return f.reactionHandler},set reactionHandler(d){f.reactionHandler=d},createCommentThread(d,P,N){return f.createCommentThread(d,P,N).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(h,y,C){y===void 0&&(0,v.$9E)(this.f,"fileComments");const $=new a(this.id,this.handle,void 0,h,y,C,this.f,!1);return this.a.set($.handle,$),$}$createCommentThreadTemplate(h,y){const C=new a(this.id,this.handle,void 0,R.URI.revive(h),w.Range.to(y),[],this.f,!0);return C.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(C.handle,C),C}$updateCommentThreadTemplate(h,y){const C=this.a.get(h);C&&(C.range=w.Range.to(y))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function l(c,h,y,C){let $=y.get(h);return $||($=++c.commentHandle,y.set(h,$)),h.state!==void 0&&(0,v.$9E)(C,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:$,body:typeof h.body=="string"?h.body:w.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(f=>t(f)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?w.$9L(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function n(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?R.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function o(c){if(c!==void 0)switch(c){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function i(c){if(c!==void 0)switch(c){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new s}e.$Mbc=k}),define(De[303],Ce([1,0,23,6,26,20]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;let R=class{constructor(A,I){this.a=A.getProxy(T.$9J.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,I){const v=this,k=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){v.e(A,I,k,arguments)}})}e(A,I,v,k){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:E(k,this.b)}),this.c&&this.f(A,v,k)}};e.$Idc=R,e.$Idc=R=He([Be(0,L.$0L),Be(1,g.$nM)],R);const b=1e5;function E(w,A){const I=[];if(w.length)for(let v=0;v<w.length;v++){let k=w[v];if(typeof k>"u")k="undefined";else if(k instanceof Error){const S=k;S.stack?k=S.stack:k=S.toString()}I.push(k)}if(A){const v=new Error().stack;v&&I.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,D.$4m)(I);return v.length>b?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(De[149],Ce([1,0,2,6,7,5,20,13,19,15,16,27]),function($e,e,D,T,g,L,R,b,E,w,A,I){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=void 0;let k=class{static{v=this}static{this.c=0}static{this.d=250}constructor(p,u){this.h=u,this.f=new Map,this.g=p.getProxy(T.$9J.MainThreadDecorations)}registerFileDecorationProvider(p,u){const r=v.c++;this.f.set(r,{provider:p,extensionDescription:u}),this.g.$registerDecorationProvider(r,u.identifier.value);const s=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(a=>{if(!a){this.g.$onDidChange(r,null);return}const m=(0,E.$2b)(a);if(m.length<=v.d){this.g.$onDidChange(r,m);return}this.h.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,m.length);const l=m.map(o=>({uri:o,rank:(0,w.$Fe)(o.path,"/")})),t=(0,E.$yb)(l,(o,i)=>o.rank-i.rank||(0,w.$Te)(o.uri.path,i.uri.path)),n=[];e:for(const o of t){let i;for(const c of o){const h=(0,A.$lc)(c.uri.path);if(i!==h&&(i=h,n.push(c.uri)>=v.d))break e}}this.g.$onDidChange(r,n)});return new g.$$J(()=>{s?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(p,u,r){if(!this.f.has(p))return Object.create(null);const s=Object.create(null),{provider:a,extensionDescription:m}=this.f.get(p);return await Promise.all(u.map(async l=>{try{const{uri:t,id:n}=l,o=await Promise.resolve(a.provideFileDecoration(D.URI.revive(t),r));if(!o)return;try{g.$tL.validate(o),o.badge&&typeof o.badge!="string"&&(0,I.$9E)(m,"codiconDecoration"),s[n]=[o.propagate,o.tooltip,o.badge,o.color]}catch(i){this.h.warn(`INVALID decoration from extension '${m.identifier.value}': ${i}`)}}catch(t){this.h.error(t)}})),s}};e.$Ncc=k,e.$Ncc=k=v=He([Be(0,R.$0L),Be(1,b.$8i)],k),e.$Occ=(0,L.$Nh)("IExtHostDecorations")}),define(De[304],Ce([1,0,203,133,2,6,7,14,4,13,28,55]),function($e,e,D,T,g,L,R,b,E,w,A,I){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=e.$Ebc=void 0;class k{#e;#t;#i;constructor(u,r,s,a,m,l,t,n){this.d=u,this.e=r,this.f=s,this.g=a,this.h=m,this.c=!1,this.f=Math.max(a,s),this.#i=new A.$zc(o=>l.getComparisonKey(o)),this.#e=t,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(u,r){if(!u){this.clear();return}this.j();let s=[];if(g.URI.isUri(u)){if(!r){this.delete(u);return}this.#i.set(u,r.slice()),s=[u]}else if(Array.isArray(u)){s=[];let l;u=[...u].sort(k.k);for(const t of u){const[n,o]=t;if((!l||n.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=n,s.push(n),this.#i.set(n,[])),o)this.#i.get(n)?.push(...o);else{const i=this.#i.get(n);i&&(i.length=0)}}}if(this.#t.fire(s),!this.#e)return;const a=[];let m=0;for(const l of s){let t=[];const n=this.#i.get(l);if(n)if(n.length>this.g){t=[];const o=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const c of n)if(c.severity===o[i]&&t.push({...b.Diagnostic.from(c),modelVersionId:this.h(l)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,D.localize)(0,null,n.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=n.map(o=>({...b.Diagnostic.from(o),modelVersionId:this.h(l)}));if(a.push([l,t]),m+=t.length,m>this.f)break}this.#e.$changeMany(this.e,a)}delete(u){this.j(),this.#t.fire([u]),this.#i.delete(u),this.#e?.$changeMany(this.e,[[u,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(u,r){this.j();for(const[s,a]of this)u.call(r,s,a,this)}*[Symbol.iterator](){this.j();for(const u of this.#i.keys())yield[u,this.get(u)]}get(u){this.j();const r=this.#i.get(u);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(u){return this.j(),Array.isArray(this.#i.get(u))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(u,r){return u[0].toString()<r[0].toString()?-1:u[0].toString()>r[0].toString()?1:0}}e.$Ebc=k;let S=class{static{v=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*v.d}static _mapper(u){const r=new A.$zc;for(const s of u)r.set(s,s);return{uris:Object.freeze(Array.from(r.values()))}}constructor(u,r,s,a){this.j=r,this.k=s,this.l=a,this.g=new Map,this.h=new E.$Qd({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,v._mapper),this.f=u.getProxy(L.$9J.MainThreadDiagnostics)}createDiagnosticCollection(u,r){const{g:s,f:a,h:m,j:l,k:t,l:n}=this,o=new class{$changeMany(h,y){a.$changeMany(h,y),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,h,y.length===0?"CLEARING":y)}$clear(h){a.$clear(h),l.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,h)}dispose(){a.dispose()}};let i;if(!r)r="_generated_diagnostic_collection_name_#"+v.c++,i=r;else if(!s.has(r))i=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do i=r+v.c++;while(s.has(i))}return new class extends k{constructor(){super(r,i,v.e,v.d,h=>n.getDocument(h)?.version,t.extUri,o,m),s.set(i,this)}dispose(){super.dispose(),s.delete(i)}}}getDiagnostics(u){if(u)return this.m(u);{const r=new Map,s=[];for(const a of this.g.values())a.forEach((m,l)=>{let t=r.get(m.toString());typeof t>"u"&&(t=s.length,r.set(m.toString(),t),s.push([m,[]])),s[t][1]=s[t][1].concat(...l)});return s}}m(u){let r=[];for(const s of this.g.values())s.has(u)&&(r=r.concat(s.get(u)));return r}$acceptMarkersChange(u){if(!this.n){const r="_generated_mirror",s=new k(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,a=>{},this.k.extUri,void 0,this.h);this.g.set(r,s),this.n=s}for(const[r,s]of u)this.n.set(g.URI.revive(r),s.map(b.Diagnostic.to))}};e.$Fbc=S,e.$Fbc=S=v=He([Be(1,w.$8i),Be(2,I.$Dbc)],S)}),define(De[305],Ce([1,0,2,6,27]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class L{constructor(b){this.a=b.getProxy(T.$9J.MainThreadDialogs)}showOpenDialog(b,E){return E?.allowUIResources&&(0,g.$9E)(b,"showLocal"),this.a.$showOpenDialog(E).then(w=>w?w.map(A=>D.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(E=>E?D.URI.revive(E):void 0)}}e.$Ubc=L}),define(De[306],Ce([1,0,8,2,7,6,17,21,15]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;class w{static{this.a=0}constructor(I,v,k){this.d=v,this.e=k,this.b=new Map,this.c=I.getProxy(L.$9J.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,v){if(Object.keys(R.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const k=w.a++;this.b.set(k,v),this.c.$registerTextContentProvider(k,I);let S;return typeof v.onDidChange=="function"&&(S=v.onDidChange(p=>{if(p.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this.d.getDocument(p)&&this.$provideTextDocumentContent(k,p).then(u=>{if(!u&&typeof u!="string")return;const r=this.d.getDocument(p);if(!r)return;const s=(0,E.$Oe)(u);if(!r.equalLines(s))return this.c.$onVirtualDocumentChange(p,u)},D.$Z)})),new g.$$J(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(I,v){const k=this.b.get(I);return k?Promise.resolve(k.provideTextDocumentContent(T.URI.revive(v),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.$Vbc=w}),define(De[307],Ce([1,0,4,3,2,6,141,14,18,23,7,8]),function($e,e,D,T,g,L,R,b,E,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=void 0;class v{constructor(S,p){this.a=new D.$Md({onListenerError:I.$1}),this.b=new D.$Md({onListenerError:I.$1}),this.c=new D.$Md({onListenerError:I.$1}),this.d=new D.$Md({onListenerError:I.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Qc,this.h=new Map,this.f=S.getProxy(L.$9J.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(u=>{for(const r of u)this.b.fire(r.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const r of u)this.a.fire(r.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const p=this.g.getDocument(S);if(p)return p}getDocument(S){const p=this.getDocumentData(S);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return p.document}ensureDocumentData(S){const p=this.g.getDocument(S);if(p)return Promise.resolve(p);let u=this.h.get(S.toString());return u||(u=this.f.$tryOpenDocument(S).then(r=>{this.h.delete(S.toString());const s=g.URI.revive(r);return(0,E.$If)(this.g.getDocument(s))},r=>(this.h.delete(S.toString()),Promise.reject(r))),this.h.set(S.toString(),u)),u}createDocumentData(S){return this.f.$tryCreateDocument(S).then(p=>g.URI.revive(p))}$acceptModelLanguageChanged(S,p){const u=g.URI.revive(S),r=this.g.getDocument(u);if(!r)throw new Error("unknown document");this.b.fire(r.document),r._acceptLanguageId(p),this.a.fire(r.document)}$acceptModelSaved(S){const p=g.URI.revive(S),u=this.g.getDocument(p);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(S,p){const u=g.URI.revive(S),r=this.g.getDocument(u);if(!r)throw new Error("unknown document");r._acceptIsDirty(p),this.c.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,p,u){const r=g.URI.revive(S),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(u),s.onEvents(p);let a;p.isUndoing?a=A.TextDocumentChangeReason.Undo:p.isRedoing&&(a=A.TextDocumentChangeReason.Redo),this.c.fire((0,w.$Zm)({document:s.document,contentChanges:p.changes.map(m=>({range:b.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:a}))}setWordDefinitionFor(S,p){(0,R.$_L)(S,p)}}e.$Bbc=v}),define(De[69],Ce([1,0,58,4,3,2,5,6,141,20,146,14,13,28,17,50,51]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=void 0;class r{constructor(m){this.value=m,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let s=class{constructor(m,l){this.h=m,this.i=l,this.a=null,this.b=new Map,this.c=new k.$zc,this.d=new T.$Md,this.e=new T.$Md,this.f=new T.$Md,this.g=new T.$Md,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const l=[],t=[],n=[];if(m.removedDocuments)for(const o of m.removedDocuments){const i=L.URI.revive(o),c=this.c.get(i);c?.unref()&&(this.c.delete(i),l.push(c.value))}if(m.addedDocuments)for(const o of m.addedDocuments){const i=L.URI.revive(o.uri);let c=this.c.get(i);if(c&&i.scheme!==S.Schemas.vscodeNotebookCell&&i.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new r(new E.$aM(this.h.getProxy(b.$9J.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this.c.set(i,c),t.push(c.value)),c.ref()}if(m.removedEditors)for(const o of m.removedEditors){const i=this.b.get(o);this.b.delete(o),i&&n.push(i)}if(m.addedEditors)for(const o of m.addedEditors){const i=L.URI.revive(o.documentUri);D.ok(this.c.has(i),`document '${i}' does not exist`),D.ok(!this.b.has(o.id),`editor '${o.id}' already exists!`);const c=this.c.get(i).value,h=new A.$gM(o.id,this.h.getProxy(b.$9J.MainThreadTextEditors),this.i,new u.$U(()=>c.document),o.selections.map(I.Selection.to),o.options,o.visibleRanges.map(y=>I.Range.to(y)),typeof o.editorPosition=="number"?I.ViewColumn.to(o.editorPosition):void 0);this.b.set(o.id,h)}m.newActiveEditor!==void 0&&(D.ok(m.newActiveEditor===null||this.b.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this.a=m.newActiveEditor),(0,g.$Mc)(l),(0,g.$Mc)(n),m.removedDocuments&&this.e.fire(l),m.addedDocuments&&this.d.fire(t),(m.removedEditors||m.addedEditors)&&this.f.fire(this.allEditors().map(o=>o.value)),m.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(m){return this.c.get(m)?.value}allDocuments(){return p.Iterable.map(this.c.values(),m=>m.value)}getEditor(m){return this.b.get(m)}activeEditor(m){if(!this.a)return;const l=this.b.get(this.a);return m?l:l?.value}allEditors(){return[...this.b.values()]}};e.$hM=s,e.$hM=s=He([Be(0,w.$0L),Be(1,v.$8i)],s),e.$iM=(0,R.$Nh)("IExtHostDocumentsAndEditors")}),define(De[70],Ce([1,0,14,6,2,4,5,7,20,18,73]),function($e,e,D,T,g,L,R,b,E,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=void 0,e.$Scc=(0,R.$Nh)("IExtHostEditorTabs");class I{constructor(u,r,s){this.e=s,this.d=r,this.acceptDtoUpdate(u)}get apiObject(){if(!this.a){const u=this,r={get isActive(){return u.b.id===u.e()},get label(){return u.b.label},get input(){return u.c},get isDirty(){return u.b.isDirty},get isPinned(){return u.b.isPinned},get isPreview(){return u.b.isPreview},get group(){return u.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(u){this.b=u,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new b.$PL(g.URI.revive(this.b.input.uri));case 2:return new b.$QL(g.URI.revive(this.b.input.original),g.URI.revive(this.b.input.modified));case 3:return new b.$RL(g.URI.revive(this.b.input.base),g.URI.revive(this.b.input.input1),g.URI.revive(this.b.input.input2),g.URI.revive(this.b.input.result));case 6:return new b.$SL(g.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new b.$TL(this.b.input.viewType);case 4:return new b.$UL(g.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new b.$VL(g.URI.revive(this.b.input.original),g.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new b.$WL;case 9:return new b.$XL(g.URI.revive(this.b.input.uri),g.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(u,r){this.c=[],this.d="",this.b=u,this.e=r;for(const s of u.tabs)s.isActive&&(this.d=s.id),this.c.push(new I(s,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const u=this,r={get isActive(){return u.b.groupId===u.e()},get viewColumn(){return D.ViewColumn.to(u.b.viewColumn)},get activeTab(){return u.c.find(s=>s.tabId===u.d)?.apiObject},get tabs(){return Object.freeze(u.c.map(s=>s.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(u){this.b=u}acceptTabOperation(u){if(u.kind===0){const s=new I(u.tabDto,this,()=>this.activeTabId());return this.c.splice(u.index,0,s),u.tabDto.isActive&&(this.d=s.tabId),s}else if(u.kind===1){const s=this.c.splice(u.index,1)[0];if(!s)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return s.tabId===this.d&&(this.d=""),s}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const s=this.c.splice(u.oldIndex,1)[0];if(!s)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this.c.splice(u.index,0,s),s}const r=this.c.find(s=>s.tabId===u.tabDto.id);if(!r)throw new Error("INVALID tab");return u.tabDto.isActive?this.d=u.tabDto.id:this.d===u.tabDto.id&&!u.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(u.tabDto),r}activeTabId(){return this.d}}let k=class{constructor(u){this.b=new L.$Md,this.c=new L.$Md,this.e=[],this.a=u.getProxy(T.$9J.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const u=this,r={onDidChangeTabGroups:u.c.event,onDidChangeTabs:u.b.event,get all(){return Object.freeze(u.e.map(s=>s.apiObject))},get activeTabGroup(){const s=u.d;return(0,w.$If)(u.e.find(m=>m.groupId===s)?.apiObject)},close:async(s,a)=>{const m=Array.isArray(s)?s:[s];return m.length?S(m[0])?this.j(m,a):this.i(m,a):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(u){const r=new Set(this.e.map(o=>o.groupId)),s=new Set(u.map(o=>o.groupId)),a=(0,A.$K)(r,s),m=this.e.filter(o=>a.removed.includes(o.groupId)).map(o=>o.apiObject),l=[],t=[];this.e=u.map(o=>{const i=new v(o,()=>this.d);return a.added.includes(i.groupId)?l.push(i.apiObject):t.push(i.apiObject),i});const n=(0,w.$If)(u.find(o=>o.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:l,closed:m,changed:t}))}$acceptTabGroupUpdate(u){const r=this.e.find(s=>s.groupId===u.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(u),u.isActive&&(this.d=u.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const r=this.e.find(a=>a.groupId===u.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const s=r.acceptTabOperation(u);switch(u.kind){case 0:this.b.fire(Object.freeze({opened:[s.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[s.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[s.apiObject]}));return}}g(u){for(const r of this.e)for(const s of r.tabs)if(s.apiObject===u)return s}h(u){return this.e.find(r=>r.apiObject===u)}async i(u,r){const s=[];for(const a of u){const m=this.g(a);if(!m)throw new Error("Tab close: Invalid tab not found!");s.push(m.tabId)}return this.a.$closeTab(s,r)}async j(u,r){const s=[];for(const a of u){const m=this.h(a);if(!m)throw new Error("Group close: Invalid group not found!");s.push(m.groupId)}return this.a.$closeGroup(s,r)}};e.$Tcc=k,e.$Tcc=k=He([Be(0,E.$0L)],k);function S(p){return p.tabs!==void 0}}),define(De[308],Ce([1,0,6,7]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$9J.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,b,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(R);if(!w)throw new Error("Embedding vector provider not found");const A=await w.provideEmbeddingVector(b,E);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,b,E){const w=this.b;return this.b++,this.a.set(w,E),this.c.$registerAiEmbeddingVectorProvider(b,w),new T.$$J(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$Edc=g}),define(De[309],Ce([1,0,2,6,3,7,14,169,15,22,27,79]),function($e,e,D,T,g,L,R,b,E,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;class v{constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const u=this.a.indexOf(p);u>=0&&(this.a.splice(u,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),u=[];let r,s,a=14,m=14;for(const l of p){let t=r?(0,E.$3e)(r,l):0;for(t===0?s=1:s=m;t<l.length;t++)t+1===l.length?(a=m,m=9):m+=1,u.push([s,l.toUpperCase().charCodeAt(t),m]),u.push([s,l.toLowerCase().charCodeAt(t),m]),s=m;r=l,m=a}u.push([9,58,10]),u.push([10,47,12]),this.b=new b.$NY(u)}}provideDocumentLinks(p){this.c();const u=[],r=b.$OY.computeLinks({getLineContent(s){return p.lineAt(s-1).text},getLineCount(){return p.lineCount}},this.b);for(const s of r){const a=R.DocumentLink.to(s);a.target&&u.push(a)}return u}}class k{constructor(p,u){this.i=u,this.b=new v,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(T.$9J.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,u,r,s={}){if(k.j(r),this.d.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const a=this.h++;this.b.add(u),this.d.add(u),this.c.set(a,r);let m=2;s.isCaseSensitive&&(m+=1024),s.isReadonly&&(m+=2048),typeof r.copy=="function"&&(m+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,A.$9E)(p,"fsChunks"),m+=4);let l;s.isReadonly&&(0,I.$3j)(s.isReadonly)&&((0,A.$9E)(p,"readonlyMessage"),l={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(a,u,m,l).catch(n=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${u}`),console.error(n)});const t=r.onDidChangeFile(n=>{const o=[];for(const i of n){const{uri:c,type:h}=i;if(c.scheme!==u)continue;let y;switch(h){case L.FileChangeType.Changed:y=0;break;case L.FileChangeType.Created:y=1;break;case L.FileChangeType.Deleted:y=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:c,type:y})}this.a.$onFileSystemChange(a,o)});return(0,g.$Pc)(()=>{t.dispose(),this.b.delete(u),this.d.delete(u),this.c.delete(a),this.a.$unregisterProvider(a)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:u,ctime:r,mtime:s,size:a,permissions:m}=p;return{type:u,ctime:r,mtime:s,size:a,permissions:m}}$stat(p,u){return Promise.resolve(this.l(p).stat(D.URI.revive(u))).then(r=>k.k(r))}$readdir(p,u){return Promise.resolve(this.l(p).readDirectory(D.URI.revive(u)))}$readFile(p,u){return Promise.resolve(this.l(p).readFile(D.URI.revive(u))).then(r=>w.$ae.wrap(r))}$writeFile(p,u,r,s){return Promise.resolve(this.l(p).writeFile(D.URI.revive(u),r.buffer,s))}$delete(p,u,r){return Promise.resolve(this.l(p).delete(D.URI.revive(u),r))}$rename(p,u,r,s){return Promise.resolve(this.l(p).rename(D.URI.revive(u),D.URI.revive(r),s))}$copy(p,u,r,s){const a=this.l(p);if(!a.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(a.copy(D.URI.revive(u),D.URI.revive(r),s))}$mkdir(p,u){return Promise.resolve(this.l(p).createDirectory(D.URI.revive(u)))}$watch(p,u,r,s){const a=this.l(p).watch(D.URI.revive(r),s);this.f.set(u,a)}$unwatch(p,u){const r=this.f.get(u);r&&(r.dispose(),this.f.delete(u))}$open(p,u,r){const s=this.l(p);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(D.URI.revive(u),r))}$close(p,u){const r=this.l(p);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(u))}$read(p,u,r,s){const a=this.l(p);if(!a.read)throw new Error('FileSystemProvider does not implement "read"');const m=w.$ae.alloc(s);return Promise.resolve(a.read(u,r,m.buffer,0,s)).then(l=>m.slice(0,l))}$write(p,u,r,s){const a=this.l(p);if(!a.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(a.write(u,r,s.buffer,0,s.byteLength))}l(p){const u=this.c.get(p);if(!u){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return u}}e.$pcc=k}),define(De[71],Ce([1,0,6,30,7,22,5,20,55,3,11,24,17]),function($e,e,D,T,g,L,R,b,E,w,A,I,v){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=e.$8bc=void 0;let S=k=class{constructor(u,r){this.b=new Map,this.c=new A.$2g,this.a=u.getProxy(D.$9J.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(a){try{let m;const l=s.b.get(a.scheme);return l?(await s.a.$ensureActivation(a.scheme),m=await l.impl.stat(a)):m=await s.a.$stat(a),{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===T.FilePermission.Readonly?1:void 0}}catch(m){k.e(m)}},async readDirectory(a){try{const m=s.b.get(a.scheme);return m?(await s.a.$ensureActivation(a.scheme),(await m.impl.readDirectory(a)).slice()):await s.a.$readdir(a)}catch(m){return k.e(m)}},async createDirectory(a){try{const m=s.b.get(a.scheme);return m&&!m.isReadonly?(await s.a.$ensureActivation(a.scheme),await s.d(m.impl,m.extUri,a)):await s.a.$mkdir(a)}catch(m){return k.e(m)}},async readFile(a){try{const m=s.b.get(a.scheme);return m?(await s.a.$ensureActivation(a.scheme),(await m.impl.readFile(a)).slice()):(await s.a.$readFile(a)).buffer}catch(m){return k.e(m)}},async writeFile(a,m){try{const l=s.b.get(a.scheme);return l&&!l.isReadonly?(await s.a.$ensureActivation(a.scheme),await s.d(l.impl,l.extUri,l.extUri.dirname(a)),await s.c.queueFor(a).queue(()=>Promise.resolve(l.impl.writeFile(a,m,{create:!0,overwrite:!0})))):await s.a.$writeFile(a,L.$ae.wrap(m))}catch(l){return k.e(l)}},async delete(a,m){try{const l=s.b.get(a.scheme);return l&&!l.isReadonly?(await s.a.$ensureActivation(a.scheme),await l.impl.delete(a,{recursive:!1,...m})):await s.a.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...m})}catch(l){return k.e(l)}},async rename(a,m,l){try{return await s.a.$rename(a,m,{overwrite:!1,...l})}catch(t){return k.e(t)}},async copy(a,m,l){try{return await s.a.$copy(a,m,{overwrite:!1,...l})}catch(t){return k.e(t)}},isWritableFileSystem(a){const m=r.getCapabilities(a);if(typeof m=="number")return!(m&2048)}})}async d(u,r,s){const a=[];for(;!r.isEqual(s,r.dirname(s));)try{if(!((await u.stat(s)).type&T.FileType.Directory))throw g.$lL.FileExists(`Unable to create folder '${s.scheme===v.Schemas.file?s.fsPath:s.toString(!0)}' that already exists but is not a directory`);break}catch(m){if(T.$lk(m)!==T.FileSystemProviderErrorCode.FileNotFound)throw m;a.push(r.basename(s)),s=r.dirname(s)}for(let m=a.length-1;m>=0;m--){s=r.joinPath(s,a[m]);try{await u.createDirectory(s)}catch(l){if(T.$lk(l)!==T.FileSystemProviderErrorCode.FileExists)throw l}}}static e(u){if(u instanceof g.$lL)throw u;if(u instanceof T.$hk)switch(u.code){case T.FileSystemProviderErrorCode.FileExists:throw g.$lL.FileExists(u.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$lL.FileNotFound(u.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$lL.FileNotADirectory(u.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$lL.FileIsADirectory(u.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$lL.NoPermissions(u.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$lL.Unavailable(u.message);default:throw new g.$lL(u.message,u.name)}if(!(u instanceof Error))throw new g.$lL(String(u));if(u.name==="ENOPRO"||u.message.includes("ENOPRO"))throw g.$lL.Unavailable(u.message);switch(u.name){case T.FileSystemProviderErrorCode.FileExists:throw g.$lL.FileExists(u.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$lL.FileNotFound(u.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$lL.FileNotADirectory(u.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$lL.FileIsADirectory(u.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$lL.NoPermissions(u.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$lL.Unavailable(u.message);default:throw new g.$lL(u.message,u.name)}}addFileSystemProvider(u,r,s){return this.b.set(u,{impl:r,extUri:s?.isCaseSensitive?I.$kg:I.$mg,isReadonly:!!s?.isReadonly}),(0,w.$Pc)(()=>this.b.delete(u))}getFileSystemProviderExtUri(u){return this.b.get(u)?.extUri??I.$kg}};e.$8bc=S,e.$8bc=S=k=He([Be(0,b.$0L),Be(1,E.$Dbc)],S),e.$9bc=(0,R.$Nh)("IExtHostConsumerFileSystem")}),define(De[310],Ce([1,0,4,35,2,6,14,7,51]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;class w{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(k,S,p,u,r,s,a,m){this.a=new D.$Md,this.b=new D.$Md,this.c=new D.$Md;const l=this.h(k,p,r);this.g=0,s&&(this.g+=1),a&&(this.g+=2),m&&(this.g+=4);const t=(0,T.$uj)(r),n=typeof r=="string",o=u(i=>{if(!s)for(const c of i.created){const h=g.URI.revive(c);t(h.fsPath)&&(!n||S.getWorkspaceFolder(h))&&this.a.fire(h)}if(!a)for(const c of i.changed){const h=g.URI.revive(c);t(h.fsPath)&&(!n||S.getWorkspaceFolder(h))&&this.b.fire(h)}if(!m)for(const c of i.deleted){const h=g.URI.revive(c);t(h.fsPath)&&(!n||S.getWorkspaceFolder(h))&&this.c.fire(h)}});this.d=b.$$J.from(l,this.a,this.b,this.c,o)}h(k,S,p){const u=b.$$J.from();if(typeof p=="string")return u;const r=k.getProxy(L.$9J.MainThreadFileSystem);let s=!1;(p.pattern.includes(T.$qj)||p.pattern.includes(T.$rj))&&(s=!0);const a=Math.random();return r.$watch(S.identifier.value,a,p.baseUri,{recursive:s,excludes:[]}),b.$$J.from({dispose:()=>r.$unwatch(a)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class A{constructor(k){this.a=k,this.b=new E.$U(()=>this.a.created.map(g.URI.revive)),this.c=new E.$U(()=>this.a.changed.map(g.URI.revive)),this.d=new E.$U(()=>this.a.deleted.map(g.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(k,S,p){this.j=k,this.k=S,this.l=p,this.a=new D.$Md,this.b=new D.$Md,this.c=new D.$Md,this.d=new D.$Md,this.g=new D.$Od,this.h=new D.$Od,this.i=new D.$Od,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,S,p,u,r,s){return new w(this.j,k,S,this.a.event,R.GlobPattern.from(p),u,r,s)}$onFileEvent(k){this.a.fire(new A(k))}$onDidRunFileOperation(k,S){switch(k){case 2:this.b.fire(Object.freeze({files:S.map(p=>({oldUri:g.URI.revive(p.source),newUri:g.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(p=>g.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(p=>g.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,S){return(p,u,r)=>{const s=function(m){p.call(u,m)};return s.extension=k,S.event(s,void 0,r)}}async $onWillRunFileOperation(k,S,p,u){switch(k){case 2:return await this.n(this.g,{files:S.map(r=>({oldUri:g.URI.revive(r.source),newUri:g.URI.revive(r.target)}))},p,u);case 1:return await this.n(this.i,{files:S.map(r=>g.URI.revive(r.target))},p,u);case 0:case 3:return await this.n(this.h,{files:S.map(r=>g.URI.revive(r.target))},p,u)}}async n(k,S,p,u){const r=new Set,s=[];if(await k.fireAsync(S,u,async(m,l)=>{const t=Date.now(),n=await Promise.resolve(m);n instanceof b.$iK&&(s.push([l.extension,n]),r.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-t>p&&this.k.warn("SLOW file-participant",l.extension.identifier)}),u.isCancellationRequested||s.length===0)return;const a={edits:[]};for(const[,m]of s){const{edits:l}=R.WorkspaceEdit.from(m,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(l)}return{edit:a,extensionNames:Array.from(r)}}}e.$qcc=I}),define(De[311],Ce([1,0,3,2,6,14,7,33]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class E{static{this.a=0}constructor(v,k){this.extension=v,this.provider=k,this.handle=E.a++}}class w{constructor(v){this.session=v,this.responses=[]}}class A{static{this.a=0}constructor(v,k,S,p){this.f=S,this.g=p,this.b=new Map,this.d=new Map,this.e=v.getProxy(g.$9J.MainThreadInlineChat),k.registerApiCommand(new b.$xM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$vM("Run arguments","",u=>!0,u=>{if(u)return{initialRange:u.initialRange?L.Range.from(u.initialRange):void 0,initialSelection:u.initialSelection?L.Selection.from(u.initialSelection):void 0,message:u.message,autoSend:u.autoSend,position:u.position?L.Position.from(u.position):void 0}})],b.$wM.Void))}registerProvider(v,k,S){const p=new E(v,k);return this.b.set(p.handle,p),this.e.$registerInteractiveEditorProvider(p.handle,S.label,v.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function"),(0,D.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(p.handle),this.b.delete(p.handle)})}async $prepareSession(v,k,S,p){const u=this.b.get(v);if(!u){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(T.URI.revive(k)),s=L.Selection.to(S),a=await u.provider.prepareInteractiveEditorSession({document:r,selection:s},p);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(s))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const m=A.a++;return this.d.set(m,new w(a)),{id:m,placeholder:a.placeholder,slashCommands:a.slashCommands?.map(l=>({command:l.command,detail:l.detail,refer:l.refer,executeImmediately:l.executeImmediately})),wholeRange:L.Range.from(a.wholeRange),message:a.message}}async $provideResponse(v,k,S,p){const u=this.b.get(v);if(!u)return;const r=this.d.get(k.id);if(!r)return;const s={prompt:S.prompt,selection:L.Selection.to(S.selection),wholeRange:L.Range.to(S.wholeRange),attempt:S.attempt,live:S.live};let a=!1;const m={report:async n=>{if(!S.live)throw new Error("Progress reporting is only supported for live sessions");a||p.isCancellationRequested||!n.message&&!n.edits||await this.e.$handleProgressChunk(S.requestId,{message:n.message,edits:n.edits?.map(L.TextEdit.from)})}},l=u.provider.provideInteractiveEditorResponse(r.session,s,m,p);Promise.resolve(l).finally(()=>a=!0);const t=await l;if(t){const n=r.responses.push(t)-1,o={wholeRange:L.Range.from(t.wholeRange),placeholder:t.placeholder};if(A.h(t))return{...o,id:n,type:"message",message:L.MarkdownString.from(t.contents)};const{edits:i}=t;if(i instanceof R.$iK)return{...o,id:n,type:"bulkEdit",edits:L.WorkspaceEdit.from(i)};if(Array.isArray(i))return{...o,id:n,type:"editorEdit",edits:i.map(L.TextEdit.from)}}}$handleFeedback(v,k,S,p){const u=this.b.get(v),r=this.d.get(k),s=r?.responses[S];if(u&&s){const a=L.InteractiveEditorResponseFeedbackKind.to(p);u.provider.handleInteractiveEditorResponseFeedback?.(r.session,s,a)}}$releaseSession(v,k){}static h(v){return typeof v=="object"&&typeof v.contents=="object"}}e.$xdc=A}),define(De[312],Ce([1,0,2,33]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class g{constructor(R,b,E,w,A){this.a=b,this.b=E,this.c=w;const I=new T.$xM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$vM("showOptions","Show Options",v=>!0,v=>v),new T.$vM("resource","Interactive resource Uri",v=>!0,v=>v),new T.$vM("controllerId","Notebook controller Id",v=>!0,v=>v),new T.$vM("title","Interactive editor title",v=>!0,v=>v)],new T.$wM("Notebook and input URI",v=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const k=this.a.getEditorById(v.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:D.URI.revive(v.notebookUri),inputUri:D.URI.revive(v.inputUri),notebookEditor:k.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:D.URI.revive(v.notebookUri),inputUri:D.URI.revive(v.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(R,b,E,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:E,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$tdc=g}),define(De[313],Ce([1,0,6,7]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;class g{constructor(R){this.a=new Map,this.b=R.getProxy(D.$9J.MainThreadIssueReporter)}async $getIssueReporterUri(R,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(R);if(!E)throw new Error("Issue request handler not found");const w=await E.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}registerIssueUriRequestHandler(R,b){const E=R.identifier.value;return this.a.set(E,b),this.b.$registerIssueUriRequestHandler(E),new T.$$J(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$zdc=g}),define(De[314],Ce([1,0,3,6]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class g{constructor(R){this.b=0,this.a=R.getProxy(T.$9J.MainThreadLabelService)}$registerResourceLabelFormatter(R){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,R),(0,D.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$Mcc=g}),define(De[315],Ce([1,0,2,23,14,7,82,6,15,34,19,18,165,21,25,3,129,119,87,37,8,11,27,205]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m,l,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class o{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentSymbols(B,Q){const te=this.d.getDocument(B),re=await this.e.provideDocumentSymbols(te,Q);if(!(0,A.$Jb)(re))return re[0]instanceof L.$qK?re.map(g.DocumentSymbol.from):o.f(re)}static f(B){B=B.slice(0).sort((re,Z)=>{let de=re.location.range.start.compareTo(Z.location.range.start);return de===0&&(de=Z.location.range.end.compareTo(re.location.range.end)),de});const Q=[],te=[];for(const re of B){const Z={name:re.name||"!!MISSING: name!!",kind:g.SymbolKind.from(re.kind),tags:re.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:re.containerName,range:g.Range.from(re.location.range),selectionRange:g.Range.from(re.location.range),children:[]};for(;;){if(te.length===0){te.push(Z),Q.push(Z);break}const de=te[te.length-1];if(w.$ns.containsRange(de.range,Z.range)&&!w.$ns.equalsRange(de.range,Z.range)){de.children?.push(Z),te.push(Z);break}te.pop()}}return Q}}class i{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,Q,te){this.g=B,this.h=Q,this.j=te,this.e=new s.$Abc("CodeLens"),this.f=new Map}async provideCodeLenses(B,Q){const te=this.g.getDocument(B),re=await this.j.provideCodeLenses(te,Q);if(!re||Q.isCancellationRequested)return;const Z=this.e.add(re),de=new p.$Qc;this.f.set(Z,de);const ye={cacheId:Z,lenses:[]};for(let je=0;je<re.length;je++)ye.lenses.push({cacheId:[Z,je],range:g.Range.from(re[je].range),command:this.h.toInternal(re[je].command,de)});return ye}async resolveCodeLens(B,Q){const te=B.cacheId&&this.e.get(...B.cacheId);if(!te)return;let re;if(typeof this.j.resolveCodeLens!="function"||te.isResolved?re=te:re=await this.j.resolveCodeLens(te,Q),re||(re=te),Q.isCancellationRequested)return;const Z=B.cacheId&&this.f.get(B.cacheId[0]);if(Z)return B.command=this.h.toInternal(re.command??i.d,Z),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function c(Pe){return Array.isArray(Pe)?Pe.map(g.DefinitionLink.from):Pe?[g.DefinitionLink.from(Pe)]:[]}class h{constructor(B,Q){this.d=B,this.e=Q}async provideDefinition(B,Q,te){const re=this.d.getDocument(B),Z=g.Position.to(Q),de=await this.e.provideDefinition(re,Z,te);return c(de)}}class y{constructor(B,Q){this.d=B,this.e=Q}async provideDeclaration(B,Q,te){const re=this.d.getDocument(B),Z=g.Position.to(Q),de=await this.e.provideDeclaration(re,Z,te);return c(de)}}class C{constructor(B,Q){this.d=B,this.e=Q}async provideImplementation(B,Q,te){const re=this.d.getDocument(B),Z=g.Position.to(Q),de=await this.e.provideImplementation(re,Z,te);return c(de)}}class ${constructor(B,Q){this.d=B,this.e=Q}async provideTypeDefinition(B,Q,te){const re=this.d.getDocument(B),Z=g.Position.to(Q),de=await this.e.provideTypeDefinition(re,Z,te);return c(de)}}class f{constructor(B,Q){this.d=B,this.e=Q}async provideHover(B,Q,te){const re=this.d.getDocument(B),Z=g.Position.to(Q),de=await this.e.provideHover(re,Z,te);if(!(!de||(0,A.$Jb)(de.contents)))return de.range||(de.range=re.getWordRangeAtPosition(Z)),de.range||(de.range=new L.$aK(Z,Z)),g.Hover.from(de)}}class d{constructor(B,Q){this.d=B,this.e=Q}async provideEvaluatableExpression(B,Q,te){const re=this.d.getDocument(B),Z=g.Position.to(Q),de=await this.e.provideEvaluatableExpression(re,Z,te);if(de)return g.EvaluatableExpression.from(de)}}class P{constructor(B,Q){this.d=B,this.e=Q}async provideInlineValues(B,Q,te,re){const Z=this.d.getDocument(B),de=await this.e.provideInlineValues(Z,g.Range.to(Q),g.InlineValueContext.to(te),re);if(Array.isArray(de))return de.map(ye=>g.InlineValue.from(ye))}}class N{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentHighlights(B,Q,te){const re=this.d.getDocument(B),Z=g.Position.to(Q),de=await this.e.provideDocumentHighlights(re,Z,te);if(Array.isArray(de))return de.map(g.DocumentHighlight.from)}}class O{constructor(B,Q){this.d=B,this.e=Q}async provideLinkedEditingRanges(B,Q,te){const re=this.d.getDocument(B),Z=g.Position.to(Q),de=await this.e.provideLinkedEditingRanges(re,Z,te);if(de&&Array.isArray(de.ranges))return{ranges:(0,A.$Gb)(de.ranges.map(g.Range.from)),wordPattern:de.wordPattern}}}class M{constructor(B,Q){this.d=B,this.e=Q}async provideReferences(B,Q,te,re){const Z=this.d.getDocument(B),de=g.Position.to(Q),ye=await this.e.provideReferences(Z,de,te,re);if(Array.isArray(ye))return ye.map(g.location.from)}}class j{static{this.d=1e3}constructor(B,Q,te,re,Z,de,ye){this.g=B,this.h=Q,this.j=te,this.k=re,this.l=Z,this.m=de,this.n=ye,this.e=new s.$Abc("CodeAction"),this.f=new Map}async provideCodeActions(B,Q,te,re){const Z=this.g.getDocument(B),de=v.$ps.isISelection(Q)?g.Selection.to(Q):g.Range.to(Q),ye=[];for(const et of this.j.getDiagnostics(B))if(de.intersection(et.range)&&ye.push(et)>j.d)break;const je={diagnostics:ye,only:te.only?new L.$sK(te.only):void 0,triggerKind:g.CodeActionTriggerKind.to(te.trigger)},We=await this.k.provideCodeActions(Z,de,je,re);if(!(0,A.$Kb)(We)||re.isCancellationRequested)return;const xe=this.e.add(We),Ze=new p.$Qc;this.f.set(xe,Ze);const it=[];for(let et=0;et<We.length;et++){const Ae=We[et];Ae&&(j.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ze)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[xe,et],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ze),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(g.Diagnostic.from),edit:Ae.edit&&g.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$8E)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:xe,actions:it}}async resolveCodeAction(B,Q){const[te,re]=B,Z=this.e.get(te,re);if(!Z||j.o(Z))return{};if(!this.k.resolveCodeAction)return{};const de=await this.k.resolveCodeAction(Z,Q)??Z;let ye;de.edit&&(ye=g.WorkspaceEdit.from(de.edit,void 0));let je;if(de.command){const We=this.f.get(te);We&&(je=this.h.toInternal(de.command,We))}return{edit:ye,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class U{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,te,re,Z){this.d=B,this.e=Q,this.f=te,this.g=re,this.h=Z}async prepareDocumentPaste(B,Q,te,re){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(B),de=Q.map(We=>g.Range.to(We)),ye=g.DataTransfer.toDataTransfer(te,()=>{throw new m.$0});if(await this.f.prepareDocumentPaste(Z,de,ye,re),re.isCancellationRequested)return;const je=Array.from(ye).filter(([,We])=>!(We instanceof L.$YK));return g.DataTransfer.from(je)}async providePasteEdits(B,Q,te,re,Z){if(!this.f.provideDocumentPasteEdits)return;const de=this.e.getDocument(Q),ye=te.map(xe=>g.Range.to(xe)),je=g.DataTransfer.toDataTransfer(re,async xe=>(await this.d.$resolvePasteFileData(this.g,B,xe)).buffer),We=await this.f.provideDocumentPasteEdits(de,ye,je,Z);if(We)return{label:We.label??(0,n.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:U.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?g.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class F{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentFormattingEdits(B,Q,te){const re=this.d.getDocument(B),Z=await this.e.provideDocumentFormattingEdits(re,Q,te);if(Array.isArray(Z))return Z.map(g.TextEdit.from)}}class V{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeFormattingEdits(B,Q,te,re){const Z=this.d.getDocument(B),de=g.Range.to(Q),ye=await this.e.provideDocumentRangeFormattingEdits(Z,de,te,re);if(Array.isArray(ye))return ye.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Q,te,re){(0,I.$Hf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Z=this.d.getDocument(B),de=Q.map(g.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(Z,de,te,re);if(Array.isArray(ye))return ye.map(g.TextEdit.from)}}class H{constructor(B,Q){this.d=B,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Q,te,re,Z){const de=this.d.getDocument(B),ye=g.Position.to(Q),je=await this.e.provideOnTypeFormattingEdits(de,ye,te,re,Z);if(Array.isArray(je))return je.map(g.TextEdit.from)}}class fe{constructor(B,Q){this.e=B,this.f=Q,this.d=new s.$Abc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Q){const te=await this.e.provideWorkspaceSymbols(B,Q);if(!(0,A.$Kb)(te))return{symbols:[]};const re=this.d.add(te),Z={cacheId:re,symbols:[]};for(let de=0;de<te.length;de++){const ye=te[de];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Z.symbols.push({...g.WorkspaceSymbol.from(ye),cacheId:[re,de]})}return Z}async resolveWorkspaceSymbol(B,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const te=this.d.get(...B.cacheId);if(te){const re=await this.e.resolveWorkspaceSymbol(te,Q);return re&&(0,T.$2m)(B,g.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class X{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Q,te){this.d=B,this.e=Q,this.f=te}async provideRenameEdits(B,Q,te,re){const Z=this.d.getDocument(B),de=g.Position.to(Q);try{const ye=await this.e.provideRenameEdits(Z,de,te,re);return ye?g.WorkspaceEdit.from(ye):void 0}catch(ye){const je=X.g(ye);return je?{rejectReason:je,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,Q,te){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const re=this.d.getDocument(B),Z=g.Position.to(Q);try{const de=await this.e.prepareRename(re,Z,te);let ye,je;if(L.$aK.isRange(de)?(ye=de,je=re.getText(de)):(0,I.$zf)(de)&&(ye=de.range,je=de.placeholder),!ye||!je)return;if(ye.start.line>Z.line||ye.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(ye),text:je}}catch(de){const ye=X.g(de);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(de)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Y{constructor(B,Q){this.resultId=B,this.tokens=Q}}class q{constructor(B,Q){this.f=B,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Q,te){const re=this.f.getDocument(B),Z=Q!==0?this.d.get(Q):null;let de=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(re,Z.resultId,te):await this.g.provideDocumentSemanticTokens(re,te);return Z&&this.d.delete(Q),de?(de=q.h(de),this.o(q.n(Z,de),de)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return q.j(B)?q.k(B)?B:new L.$pL(new Uint32Array(B.data),B.resultId):q.l(B)?q.m(B)?B:new L.$rL(B.edits.map(Q=>new L.$qL(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Q of B.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(B,Q){if(!q.j(Q)||!B||!B.tokens)return Q;const te=B.tokens,re=te.length,Z=Q.data,de=Z.length;let ye=0;const je=Math.min(re,de);for(;ye<je&&te[ye]===Z[ye];)ye++;if(ye===re&&ye===de)return new L.$rL([],Q.resultId);let We=0;const xe=je-ye;for(;We<xe&&te[re-We-1]===Z[de-We-1];)We++;return new L.$rL([{start:ye,deleteCount:re-ye-We,data:Z.subarray(ye,de-We)}],Q.resultId)}o(B,Q){if(q.j(B)){const te=this.e++;return this.d.set(te,new Y(B.resultId,B.data)),(0,u.$K0)({id:te,type:"full",data:B.data})}if(q.l(B)){const te=this.e++;return q.j(Q)?this.d.set(te,new Y(Q.resultId,Q.data)):this.d.set(te,new Y(B.resultId)),(0,u.$K0)({id:te,type:"delta",deltas:(B.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}class x{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeSemanticTokens(B,Q,te){const re=this.d.getDocument(B),Z=await this.e.provideDocumentRangeSemanticTokens(re,g.Range.to(Q),te);return Z?this.f(Z):null}f(B){return(0,u.$K0)({id:0,type:"full",data:B.data})}}class me{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Q,te,re,Z){this.f=B,this.g=Q,this.h=te,this.j=re,this.k=Z,this.d=new s.$Abc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Q,te,re){const Z=this.f.getDocument(B),de=g.Position.to(Q),ye=Z.getWordRangeAtPosition(de)||new L.$aK(de,de),je=ye.with({end:de}),We=new a.$Id,xe=await this.h.provideCompletionItems(Z,de,re,g.CompletionContext.to(te));if(!xe||re.isCancellationRequested)return;const Ze=Array.isArray(xe)?new L.$FK(xe):xe,it=me.supportsResolving(this.h)?this.d.add(Ze.items):this.d.add([]),et=new p.$Qc;this.e.set(it,et);const Ae=[],Fe={x:it,b:Ae,a:{replace:g.Range.from(ye),insert:g.Range.from(je)},c:Ze.isIncomplete||void 0,d:We.elapsed()};for(let qe=0;qe<Ze.items.length;qe++){const Le=Ze.items[qe],Ye=this.l(Le,[it,qe],je,ye);Ae.push(Ye)}return Fe}async resolveCompletionItem(B,Q){if(typeof this.h.resolveCompletionItem!="function")return;const te=this.d.get(...B);if(!te)return;const re=this.l(te,B),Z=await this.h.resolveCompletionItem(te,Q);if(!Z)return;const de=this.l(Z,B);return(re.h!==de.h||re.i!==de.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(re.n!==de.n||re.o!==de.o||!(0,T.$3m)(re.p,de.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...re,d:de.d,c:de.c,l:de.l,h:de.h,i:de.i,n:de.n,o:de.o,p:de.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q,te,re){const Z=this.e.get(Q[0]);if(!Z)throw Error("DisposableStore is missing...");const de=this.g.toInternal(B.command,Z),ye={x:Q,a:B.label,b:B.kind!==void 0?g.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(g.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:g.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(g.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof L.$jK&&(ye.h=B.insertText.value,ye.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),L.$aK.isRange(je)?ye.j=g.Range.from(je):je&&(!te?.isEqual(je.inserting)||!re?.isEqual(je.replacing))&&(ye.j={insert:g.Range.from(je.inserting),replace:g.Range.from(je.replacing)}),ye}}class ue{async provideInlineCompletions(B,Q,te,re){}disposeCompletions(B){}handleDidShowCompletionItem(B,Q,te){}handlePartialAccept(B,Q,te){}}class pe extends ue{constructor(B,Q,te,re){super(),this.f=B,this.g=Q,this.h=te,this.j=re,this.d=new G,this.e=(0,t.$8E)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$8E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Q,te,re){const Z=this.g.getDocument(B),de=g.Position.to(Q),ye=await this.h.provideInlineCompletionItems(Z,de,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:g.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[te.triggerKind]},re);if(!ye||re.isCancellationRequested)return;const je=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],xe=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ze;return{pid:this.d.createReferenceId({dispose(){Ze?.dispose()},items:je}),items:je.map((et,Ae)=>{let Fe;et.command&&(Ze||(Ze=new p.$Qc),Fe=this.j.toInternal(et.command,Ze));const qe=et.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:et.filterText,range:et.range?g.Range.from(et.range):void 0,command:Fe,idx:Ae,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:We.map(et=>(Ze||(Ze=new p.$Qc),this.j.toInternal(et,Ze))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Q,te){const re=this.d.get(B)?.items[Q];re&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(re,te)}handlePartialAccept(B,Q,te){const re=this.d.get(B)?.items[Q];re&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(re,te)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Q=this.e++;return this.d.set(Q,B),Q}disposeReferenceId(B){const Q=this.d.get(B);return this.d.delete(B),Q}get(B){return this.d.get(B)}}class z{constructor(B,Q){this.e=B,this.f=Q,this.d=new s.$Abc("SignatureHelp")}async provideSignatureHelp(B,Q,te,re){const Z=this.e.getDocument(B),de=g.Position.to(Q),ye=this.g(te),je=await this.f.provideSignatureHelp(Z,de,re,ye);if(je){const We=this.d.add([je]);return{...g.SignatureHelp.from(je),id:We}}}g(B){let Q;if(B.activeSignatureHelp){const te=g.SignatureHelp.to(B.activeSignatureHelp),re=this.d.get(B.activeSignatureHelp.id,0);re?(Q=re,Q.activeSignature=te.activeSignature,Q.activeParameter=te.activeParameter):Q=te}return{...B,activeSignatureHelp:Q}}releaseSignatureHelp(B){this.d.delete(B)}}class K{constructor(B,Q,te,re,Z){this.f=B,this.g=Q,this.h=te,this.j=re,this.k=Z,this.d=new s.$Abc("InlayHints"),this.e=new Map}async provideInlayHints(B,Q,te){const re=this.f.getDocument(B),Z=g.Range.to(Q),de=await this.h.provideInlayHints(re,Z,te);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${Q}`);return}if(te.isCancellationRequested)return;const ye=this.d.add(de);this.e.set(ye,new p.$Qc);const je={hints:[],cacheId:ye};for(let We=0;We<de.length;We++)this.l(de[We],Z)&&je.hints.push(this.m(de[We],[ye,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${Q}`),je}async resolveInlayHint(B,Q){if(typeof this.h.resolveInlayHint!="function")return;const te=this.d.get(...B);if(!te)return;const re=await this.h.resolveInlayHint(te,Q);if(re&&this.l(re))return this.m(re,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q){return B.label.length===0||Array.isArray(B.label)&&B.label.every(te=>te.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Q&&!Q.contains(B.position))}m(B,Q){const te=this.e.get(Q[0]);if(!te)throw Error("DisposableStore is missing...");const re={label:"",cacheId:Q,tooltip:g.MarkdownString.fromStrict(B.tooltip),position:g.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(g.TextEdit.from),kind:B.kind&&g.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?re.label=B.label:re.label=B.label.map(Z=>{const de={label:Z.value};return de.tooltip=g.MarkdownString.fromStrict(Z.tooltip),L.$kK.isLocation(Z.location)&&(de.location=g.location.from(Z.location)),Z.command&&(de.command=this.g.toInternal(Z.command,te)),de}),re}}class ge{constructor(B,Q){this.e=B,this.f=Q,this.d=new s.$Abc("DocumentLink")}async provideLinks(B,Q){const te=this.e.getDocument(B),re=await this.f.provideDocumentLinks(te,Q);if(!(!Array.isArray(re)||re.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:re.filter(ge.g).map(g.DocumentLink.from)};{const Z=this.d.add(re),de={links:[],cacheId:Z};for(let ye=0;ye<re.length;ye++){if(!ge.g(re[ye]))continue;const je=g.DocumentLink.from(re[ye]);je.cacheId=[Z,ye],de.links.push(je)}return de}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Q){if(typeof this.f.resolveDocumentLink!="function")return;const te=this.d.get(...B);if(!te)return;const re=await this.f.resolveDocumentLink(te,Q);if(!(!re||!ge.g(re)))return g.DocumentLink.from(re)}releaseLinks(B){this.d.delete(B)}}class _{constructor(B,Q){this.d=B,this.e=Q}async provideColors(B,Q){const te=this.d.getDocument(B),re=await this.e.provideDocumentColors(te,Q);return Array.isArray(re)?re.map(de=>({color:g.Color.from(de.color),range:g.Range.from(de.range)})):[]}async provideColorPresentations(B,Q,te){const re=this.d.getDocument(B),Z=g.Range.to(Q.range),de=g.Color.to(Q.color),ye=await this.e.provideColorPresentations(de,{document:re,range:Z},te);if(Array.isArray(ye))return ye.map(g.ColorPresentation.from)}}class ie{constructor(B,Q){this.d=B,this.e=Q}async provideFoldingRanges(B,Q,te){const re=this.d.getDocument(B),Z=await this.e.provideFoldingRanges(re,Q,te);if(Array.isArray(Z))return Z.map(g.FoldingRange.from)}}class ne{constructor(B,Q,te){this.d=B,this.e=Q,this.f=te}async provideSelectionRanges(B,Q,te){const re=this.d.getDocument(B),Z=Q.map(g.Position.to),de=await this.e.provideSelectionRanges(re,Z,te);if(!(0,A.$Kb)(de))return[];if(de.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let je=0;je<Z.length;je++){const We=[];ye.push(We);let xe=Z[je],Ze=de[je];for(;;){if(!Ze.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(We.push(g.SelectionRange.from(Ze)),!Ze.parent)break;xe=Ze.range,Ze=Ze.parent}}return ye}}class Ee{constructor(B,Q){this.f=B,this.g=Q,this.d=new r.$cM(""),this.e=new Map}async prepareSession(B,Q,te){const re=this.f.getDocument(B),Z=g.Position.to(Q),de=await this.g.prepareCallHierarchy(re,Z,te);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(je=>this.h(ye,je)):[this.h(ye,de)]}async provideCallsTo(B,Q,te){const re=this.j(B,Q);if(!re)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(re,te);if(Z)return Z.map(de=>({from:this.h(B,de.from),fromRanges:de.fromRanges.map(ye=>g.Range.from(ye))}))}async provideCallsFrom(B,Q,te){const re=this.j(B,Q);if(!re)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(re,te);if(Z)return Z.map(de=>({to:this.h(B,de.to),fromRanges:de.fromRanges.map(ye=>g.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,Q){const te=this.e.get(B),re=g.CallHierarchyItem.from(Q,B,te.size.toString(36));return te.set(re._itemId,Q),re}j(B,Q){return this.e.get(B)?.get(Q)}}class oe{constructor(B,Q){this.f=B,this.g=Q,this.d=new r.$cM(""),this.e=new Map}async prepareSession(B,Q,te){const re=this.f.getDocument(B),Z=g.Position.to(Q),de=await this.g.prepareTypeHierarchy(re,Z,te);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(je=>this.h(ye,je)):[this.h(ye,de)]}async provideSupertypes(B,Q,te){const re=this.j(B,Q);if(!re)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(re,te);if(Z)return Z.map(de=>this.h(B,de))}async provideSubtypes(B,Q,te){const re=this.j(B,Q);if(!re)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(re,te);if(Z)return Z.map(de=>this.h(B,de))}releaseSession(B){this.e.delete(B)}h(B,Q){const te=this.e.get(B),re=g.TypeHierarchyItem.from(Q,B,te.size.toString(36));return te.set(re._itemId,Q),re}j(B,Q){return this.e.get(B)?.get(Q)}}class he{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,te,re,Z){this.d=B,this.e=Q,this.f=te,this.g=re,this.h=Z}async provideDocumentOnDropEdits(B,Q,te,re,Z){const de=this.e.getDocument(Q),ye=g.Position.to(te),je=g.DataTransfer.toDataTransfer(re,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,xe)).buffer),We=await this.f.provideDocumentDropEdits(de,ye,je,Z);if(We)return{label:We.label??(0,n.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:he.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?g.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ee{constructor(B,Q){this.d=B,this.e=Q}async provideMappedEdits(B,Q,te,re){const Z=D.URI.revive(B),de=this.d.getDocument(Z),ye=te.documents.map(xe=>xe.map(Ze=>({uri:D.URI.revive(Ze.uri),version:Ze.version,ranges:Ze.ranges.map(it=>g.Range.to(it))}))),je={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(de,Q,je,re);return We?g.WorkspaceEdit.from(We):null}}class le{constructor(B,Q){this.adapter=B,this.extension=Q}}class be{static{this.d=0}constructor(B,Q,te,re,Z,de,ye,je){this.g=Q,this.h=te,this.j=re,this.k=Z,this.l=de,this.m=ye,this.n=je,this.f=new Map,this.e=B.getProxy(b.$9J.MainThreadLanguageFeatures)}o(B,Q){return g.DocumentSelector.from(B,this.g,Q)}p(B){return new L.$$J(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return be.d++}async s(B,Q,te,re,Z,de=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof Q))return re;const je=Date.now();de||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${te.toString().replace(/[\r\n]/g,"")}'`);const We=te(ye.adapter,ye.extension);return Promise.resolve(We).catch(xe=>{(0,m.$3)(xe)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(ye.extension.identifier,xe))}).finally(()=>{de||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),k.CancellationToken.isCancellationToken(Z)?(0,l.$Ig)(We,Z):We}t(B,Q){const te=this.q();return this.f.set(te,new le(B,Q)),te}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Q,te,re){const Z=this.t(new o(this.h,te),B),de=re&&re.label||be.u(B);return this.e.$registerDocumentSymbolProvider(Z,this.o(Q,B),de),this.p(Z)}$provideDocumentSymbols(B,Q,te){return this.s(B,o,re=>re.provideDocumentSymbols(D.URI.revive(Q),te),void 0,te)}registerCodeLensProvider(B,Q,te){const re=this.q(),Z=typeof te.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(re,new le(new i(this.h,this.j.converter,te),B)),this.e.$registerCodeLensSupport(re,this.o(Q,B),Z);let de=this.p(re);if(Z!==void 0){const ye=te.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(Z));de=L.$$J.from(de,ye)}return de}$provideCodeLenses(B,Q,te){return this.s(B,i,re=>re.provideCodeLenses(D.URI.revive(Q),te),void 0,te)}$resolveCodeLens(B,Q,te){return this.s(B,i,re=>re.resolveCodeLens(Q,te),void 0,void 0)}$releaseCodeLenses(B,Q){this.s(B,i,te=>Promise.resolve(te.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(B,Q,te){const re=this.t(new h(this.h,te),B);return this.e.$registerDefinitionSupport(re,this.o(Q,B)),this.p(re)}$provideDefinition(B,Q,te,re){return this.s(B,h,Z=>Z.provideDefinition(D.URI.revive(Q),te,re),[],re)}registerDeclarationProvider(B,Q,te){const re=this.t(new y(this.h,te),B);return this.e.$registerDeclarationSupport(re,this.o(Q,B)),this.p(re)}$provideDeclaration(B,Q,te,re){return this.s(B,y,Z=>Z.provideDeclaration(D.URI.revive(Q),te,re),[],re)}registerImplementationProvider(B,Q,te){const re=this.t(new C(this.h,te),B);return this.e.$registerImplementationSupport(re,this.o(Q,B)),this.p(re)}$provideImplementation(B,Q,te,re){return this.s(B,C,Z=>Z.provideImplementation(D.URI.revive(Q),te,re),[],re)}registerTypeDefinitionProvider(B,Q,te){const re=this.t(new $(this.h,te),B);return this.e.$registerTypeDefinitionSupport(re,this.o(Q,B)),this.p(re)}$provideTypeDefinition(B,Q,te,re){return this.s(B,$,Z=>Z.provideTypeDefinition(D.URI.revive(Q),te,re),[],re)}registerHoverProvider(B,Q,te,re){const Z=this.t(new f(this.h,te),B);return this.e.$registerHoverProvider(Z,this.o(Q,B)),this.p(Z)}$provideHover(B,Q,te,re){return this.s(B,f,Z=>Z.provideHover(D.URI.revive(Q),te,re),void 0,re)}registerEvaluatableExpressionProvider(B,Q,te,re){const Z=this.t(new d(this.h,te),B);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(Q,B)),this.p(Z)}$provideEvaluatableExpression(B,Q,te,re){return this.s(B,d,Z=>Z.provideEvaluatableExpression(D.URI.revive(Q),te,re),void 0,re)}registerInlineValuesProvider(B,Q,te,re){const Z=typeof te.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new P(this.h,te),B);this.e.$registerInlineValuesProvider(de,this.o(Q,B),Z);let ye=this.p(de);if(Z!==void 0){const je=te.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Z));ye=L.$$J.from(ye,je)}return ye}$provideInlineValues(B,Q,te,re,Z){return this.s(B,P,de=>de.provideInlineValues(D.URI.revive(Q),te,re,Z),void 0,Z)}registerDocumentHighlightProvider(B,Q,te){const re=this.t(new N(this.h,te),B);return this.e.$registerDocumentHighlightProvider(re,this.o(Q,B)),this.p(re)}$provideDocumentHighlights(B,Q,te,re){return this.s(B,N,Z=>Z.provideDocumentHighlights(D.URI.revive(Q),te,re),void 0,re)}registerLinkedEditingRangeProvider(B,Q,te){const re=this.t(new O(this.h,te),B);return this.e.$registerLinkedEditingRangeProvider(re,this.o(Q,B)),this.p(re)}$provideLinkedEditingRanges(B,Q,te,re){return this.s(B,O,async Z=>{const de=await Z.provideLinkedEditingRanges(D.URI.revive(Q),te,re);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?be.w(de.wordPattern):void 0}},void 0,re)}registerReferenceProvider(B,Q,te){const re=this.t(new M(this.h,te),B);return this.e.$registerReferenceSupport(re,this.o(Q,B)),this.p(re)}$provideReferences(B,Q,te,re,Z){return this.s(B,M,de=>de.provideReferences(D.URI.revive(Q),te,re,Z),void 0,Z)}registerCodeActionProvider(B,Q,te,re){const Z=new p.$Qc,de=this.t(new j(this.h,this.j.converter,this.k,te,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(de,this.o(Q,B),{providedKinds:re?.providedCodeActionKinds?.map(ye=>ye.value),documentation:re?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Z)}))},be.u(B),!!te.resolveCodeAction),Z.add(this.p(de)),Z}$provideCodeActions(B,Q,te,re,Z){return this.s(B,j,de=>de.provideCodeActions(D.URI.revive(Q),te,re,Z),void 0,Z)}$resolveCodeAction(B,Q,te){return this.s(B,j,re=>re.resolveCodeAction(Q,te),{},void 0)}$releaseCodeActions(B,Q){this.s(B,j,te=>Promise.resolve(te.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Q,te){const re=this.t(new F(this.h,te),B);return this.e.$registerDocumentFormattingSupport(re,this.o(Q,B),B.identifier,B.displayName||B.name),this.p(re)}$provideDocumentFormattingEdits(B,Q,te,re){return this.s(B,F,Z=>Z.provideDocumentFormattingEdits(D.URI.revive(Q),te,re),void 0,re)}registerDocumentRangeFormattingEditProvider(B,Q,te){const re=typeof te.provideDocumentRangesFormattingEdits=="function",Z=this.t(new V(this.h,te),B);return this.e.$registerRangeFormattingSupport(Z,this.o(Q,B),B.identifier,B.displayName||B.name,re),this.p(Z)}$provideDocumentRangeFormattingEdits(B,Q,te,re,Z){return this.s(B,V,de=>de.provideDocumentRangeFormattingEdits(D.URI.revive(Q),te,re,Z),void 0,Z)}$provideDocumentRangesFormattingEdits(B,Q,te,re,Z){return this.s(B,V,de=>de.provideDocumentRangesFormattingEdits(D.URI.revive(Q),te,re,Z),void 0,Z)}registerOnTypeFormattingEditProvider(B,Q,te,re){const Z=this.t(new H(this.h,te),B);return this.e.$registerOnTypeFormattingSupport(Z,this.o(Q,B),re,B.identifier),this.p(Z)}$provideOnTypeFormattingEdits(B,Q,te,re,Z,de){return this.s(B,H,ye=>ye.provideOnTypeFormattingEdits(D.URI.revive(Q),te,re,Z,de),void 0,de)}registerWorkspaceSymbolProvider(B,Q){const te=this.t(new fe(Q,this.l),B);return this.e.$registerNavigateTypeSupport(te,typeof Q.resolveWorkspaceSymbol=="function"),this.p(te)}$provideWorkspaceSymbols(B,Q,te){return this.s(B,fe,re=>re.provideWorkspaceSymbols(Q,te),{symbols:[]},te)}$resolveWorkspaceSymbol(B,Q,te){return this.s(B,fe,re=>re.resolveWorkspaceSymbol(Q,te),void 0,void 0)}$releaseWorkspaceSymbols(B,Q){this.s(B,fe,te=>te.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(B,Q,te){const re=this.t(new X(this.h,te,this.l),B);return this.e.$registerRenameSupport(re,this.o(Q,B),X.supportsResolving(te)),this.p(re)}$provideRenameEdits(B,Q,te,re,Z){return this.s(B,X,de=>de.provideRenameEdits(D.URI.revive(Q),te,re,Z),void 0,Z)}$resolveRenameLocation(B,Q,te,re){return this.s(B,X,Z=>Z.resolveRenameLocation(D.URI.revive(Q),te,re),void 0,re)}registerDocumentSemanticTokensProvider(B,Q,te,re){const Z=this.t(new q(this.h,te),B),de=typeof te.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(Q,B),re,de);let ye=this.p(Z);if(de){const je=te.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(de));ye=L.$$J.from(ye,je)}return ye}$provideDocumentSemanticTokens(B,Q,te,re){return this.s(B,q,Z=>Z.provideDocumentSemanticTokens(D.URI.revive(Q),te,re),null,re)}$releaseDocumentSemanticTokens(B,Q){this.s(B,q,te=>te.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Q,te,re){const Z=this.t(new x(this.h,te),B);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(Q,B),re),this.p(Z)}$provideDocumentRangeSemanticTokens(B,Q,te,re){return this.s(B,x,Z=>Z.provideDocumentRangeSemanticTokens(D.URI.revive(Q),te,re),null,re)}registerCompletionItemProvider(B,Q,te,re){const Z=this.t(new me(this.h,this.j.converter,te,this.m,B),B);return this.e.$registerCompletionsProvider(Z,this.o(Q,B),re,me.supportsResolving(te),B.identifier),this.p(Z)}$provideCompletionItems(B,Q,te,re,Z){return this.s(B,me,de=>de.provideCompletionItems(D.URI.revive(Q),te,re,Z),void 0,Z)}$resolveCompletionItem(B,Q,te){return this.s(B,me,re=>re.resolveCompletionItem(Q,te),void 0,te)}$releaseCompletionItems(B,Q){this.s(B,me,te=>te.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(B,Q,te,re){const Z=new pe(B,this.h,te,this.j.converter),de=this.t(Z,B);return this.e.$registerInlineCompletionsSupport(de,this.o(Q,B),Z.supportsHandleEvents,S.$Yl.toKey(B.identifier.value),re?.yieldTo?.map(ye=>S.$Yl.toKey(ye))||[]),this.p(de)}$provideInlineCompletions(B,Q,te,re,Z){return this.s(B,ue,de=>de.provideInlineCompletions(D.URI.revive(Q),te,re,Z),void 0,Z)}$handleInlineCompletionDidShow(B,Q,te,re){this.s(B,ue,async Z=>{Z.handleDidShowCompletionItem(Q,te,re)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Q,te,re){this.s(B,ue,async Z=>{Z.handlePartialAccept(Q,te,re)},void 0,void 0)}$freeInlineCompletionsList(B,Q){this.s(B,ue,async te=>{te.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(B,Q,te,re){const Z=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,de=this.t(new z(this.h,te),B);return this.e.$registerSignatureHelpProvider(de,this.o(Q,B),Z),this.p(de)}$provideSignatureHelp(B,Q,te,re,Z){return this.s(B,z,de=>de.provideSignatureHelp(D.URI.revive(Q),te,re,Z),void 0,Z)}$releaseSignatureHelp(B,Q){this.s(B,z,te=>te.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(B,Q,te){const re=typeof te.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new K(this.h,this.j.converter,te,this.l,B),B);this.e.$registerInlayHintsProvider(Z,this.o(Q,B),typeof te.resolveInlayHint=="function",re,be.u(B));let de=this.p(Z);if(re!==void 0){const ye=te.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(re));de=L.$$J.from(de,ye)}return de}$provideInlayHints(B,Q,te,re){return this.s(B,K,Z=>Z.provideInlayHints(D.URI.revive(Q),te,re),void 0,re)}$resolveInlayHint(B,Q,te){return this.s(B,K,re=>re.resolveInlayHint(Q,te),void 0,te)}$releaseInlayHints(B,Q){this.s(B,K,te=>te.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(B,Q,te){const re=this.t(new ge(this.h,te),B);return this.e.$registerDocumentLinkProvider(re,this.o(Q,B),typeof te.resolveDocumentLink=="function"),this.p(re)}$provideDocumentLinks(B,Q,te){return this.s(B,ge,re=>re.provideLinks(D.URI.revive(Q),te),void 0,te,Q.scheme==="output")}$resolveDocumentLink(B,Q,te){return this.s(B,ge,re=>re.resolveLink(Q,te),void 0,void 0,!0)}$releaseDocumentLinks(B,Q){this.s(B,ge,te=>te.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(B,Q,te){const re=this.t(new _(this.h,te),B);return this.e.$registerDocumentColorProvider(re,this.o(Q,B)),this.p(re)}$provideDocumentColors(B,Q,te){return this.s(B,_,re=>re.provideColors(D.URI.revive(Q),te),[],te)}$provideColorPresentations(B,Q,te,re){return this.s(B,_,Z=>Z.provideColorPresentations(D.URI.revive(Q),te,re),void 0,re)}registerFoldingRangeProvider(B,Q,te){const re=this.q(),Z=typeof te.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(re,new le(new ie(this.h,te),B)),this.e.$registerFoldingRangeProvider(re,this.o(Q,B),B.identifier,Z);let de=this.p(re);if(Z!==void 0){const ye=te.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));de=L.$$J.from(de,ye)}return de}$provideFoldingRanges(B,Q,te,re){return this.s(B,ie,Z=>Z.provideFoldingRanges(D.URI.revive(Q),te,re),void 0,re)}registerSelectionRangeProvider(B,Q,te){const re=this.t(new ne(this.h,te,this.l),B);return this.e.$registerSelectionRangeProvider(re,this.o(Q,B)),this.p(re)}$provideSelectionRanges(B,Q,te,re){return this.s(B,ne,Z=>Z.provideSelectionRanges(D.URI.revive(Q),te,re),[],re)}registerCallHierarchyProvider(B,Q,te){const re=this.t(new Ee(this.h,te),B);return this.e.$registerCallHierarchyProvider(re,this.o(Q,B)),this.p(re)}$prepareCallHierarchy(B,Q,te,re){return this.s(B,Ee,Z=>Promise.resolve(Z.prepareSession(D.URI.revive(Q),te,re)),void 0,re)}$provideCallHierarchyIncomingCalls(B,Q,te,re){return this.s(B,Ee,Z=>Z.provideCallsTo(Q,te,re),void 0,re)}$provideCallHierarchyOutgoingCalls(B,Q,te,re){return this.s(B,Ee,Z=>Z.provideCallsFrom(Q,te,re),void 0,re)}$releaseCallHierarchy(B,Q){this.s(B,Ee,te=>Promise.resolve(te.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(B,Q,te){const re=this.t(new oe(this.h,te),B);return this.e.$registerTypeHierarchyProvider(re,this.o(Q,B)),this.p(re)}$prepareTypeHierarchy(B,Q,te,re){return this.s(B,oe,Z=>Promise.resolve(Z.prepareSession(D.URI.revive(Q),te,re)),void 0,re)}$provideTypeHierarchySupertypes(B,Q,te,re){return this.s(B,oe,Z=>Z.provideSupertypes(Q,te,re),void 0,re)}$provideTypeHierarchySubtypes(B,Q,te,re){return this.s(B,oe,Z=>Z.provideSubtypes(Q,te,re),void 0,re)}$releaseTypeHierarchy(B,Q){this.s(B,oe,te=>Promise.resolve(te.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Q,te,re){const Z=this.q();this.f.set(Z,new le(new he(this.e,this.h,te,Z,B),B));const de=(0,t.$8E)(B,"dropMetadata")&&re?he.toInternalProviderId(B.identifier.value,re.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Z,this.o(Q,B),de,(0,t.$8E)(B,"dropMetadata")?re:void 0),this.p(Z)}$provideDocumentOnDropEdits(B,Q,te,re,Z,de){return this.s(B,he,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(Q,D.URI.revive(te),re,Z,de)),void 0,void 0)}registerMappedEditsProvider(B,Q,te){const re=this.t(new ee(this.h,te),B);return this.e.$registerMappedEditsProvider(re,this.o(Q,B)),this.p(re)}$provideMappedEdits(B,Q,te,re,Z){return this.s(B,ee,de=>Promise.resolve(de.provideMappedEdits(Q,te,re,Z)),null,Z)}registerDocumentPasteEditProvider(B,Q,te,re){const Z=this.q();this.f.set(Z,new le(new U(this.e,this.h,te,Z,B),B));const de=U.toInternalProviderId(B.identifier.value,re.id);return this.e.$registerPasteEditProvider(Z,this.o(Q,B),de,{supportsCopy:!!te.prepareDocumentPaste,supportsPaste:!!te.provideDocumentPasteEdits,copyMimeTypes:re.copyMimeTypes,pasteMimeTypes:re.pasteMimeTypes}),this.p(Z)}$prepareDocumentPaste(B,Q,te,re,Z){return this.s(B,U,de=>de.prepareDocumentPaste(D.URI.revive(Q),te,re,Z),void 0,Z)}$providePasteEdits(B,Q,te,re,Z,de){return this.s(B,U,ye=>ye.providePasteEdits(Q,D.URI.revive(te),re,Z,de),void 0,de)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:be.w(B.decreaseIndentPattern),increaseIndentPattern:be.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?be.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?be.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:be.w(B.beforeText),afterText:B.afterText?be.w(B.afterText):void 0,previousLineText:B.previousLineText?be.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(be.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Q=>L.SyntaxTokenType.toString(Q)):void 0}}static D(B){return B.map(be.C)}setLanguageConfiguration(B,Q,te){const{wordPattern:re}=te;if(re&&(0,E.$Ne)(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this.h.setWordDefinitionFor(Q,re):this.h.setWordDefinitionFor(Q,void 0),te.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),te.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const Z=this.q(),de={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?be.w(te.wordPattern):void 0,indentationRules:te.indentationRules?be.y(te.indentationRules):void 0,onEnterRules:te.onEnterRules?be.B(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport,autoClosingPairs:te.autoClosingPairs?be.D(te.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Z,Q,de),this.p(Z)}$setWordDefinitions(B){for(const Q of B)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$Jbc=be}),define(De[316],Ce([1,0,6,14,7,38,11,3]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class E{constructor(A,I,v,k){this.c=I,this.d=v,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=A.getProxy(D.$9J.MainThreadLanguages)}$acceptLanguageIds(A){this.b=A}async getLanguages(){return this.b.slice(0)}async changeLanguage(A,I){await this.a.$changeLanguage(A,I);const v=this.c.getDocumentData(A);if(!v)throw new Error(`document '${A.toString()}' NOT found`);return v.document}async tokenAtPosition(A,I){const v=A.version,k=T.Position.from(I),S=await this.a.$tokensAtPosition(A.uri,k),p={type:g.StandardTokenType.Other,range:A.getWordRangeAtPosition(I)??new g.$aK(I.line,I.character,I.line,I.character)};if(!S)return p;const u={range:T.Range.to(S.range),type:T.TokenType.to(S.type)};return!u.range.contains(I)||v!==A.version?p:u}createLanguageStatusItem(A,I,v){const k=this.f++,S=this.a,p=this.g,u=`${A.identifier.value}/${I}`;if(p.has(u))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);p.add(u);const r={selector:v,id:I,name:A.displayName??A.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let s;const a=new b.$Qc,m=()=>{if(s?.dispose(),!p.has(u)){console.warn(`LanguageStatusItem (${I}) from ${A.identifier.value} has been disposed and CANNOT be updated anymore`);return}s=(0,R.$Ug)(()=>{a.clear(),this.a.$setLanguageStatus(k,{id:u,name:r.name??A.displayName??A.name,source:A.displayName??A.name,selector:T.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===g.LanguageStatusSeverity.Error?L.default.Error:r.severity===g.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:r.command&&this.d.toInternal(r.command,a),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},l={dispose(){a.dispose(),s?.dispose(),S.$removeLanguageStatus(k),p.delete(u)},get id(){return r.id},get name(){return r.name},set name(t){r.name=t,m()},get selector(){return r.selector},set selector(t){r.selector=t,m()},get text(){return r.text},set text(t){r.text=t,m()},get detail(){return r.detail},set detail(t){r.detail=t,m()},get severity(){return r.severity},set severity(t){r.severity=t,m()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(t){r.accessibilityInformation=t,m()},get command(){return r.command},set command(t){r.command=t,m()},get busy(){return r.busy},set busy(t){r.busy=t,m()}};return m(),l}}e.$rcc=E}),define(De[112],Ce([1,0,12,15,2,5,13,6,26,20]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=e.$gcc=void 0;let A=class{constructor(v,k,S){this.f=S,this.d=new Map,this.a=k.getProxy(b.$9J.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===D.$g}getMessage(v,k){const{message:S,args:p,comment:u}=k;if(this.c)return(0,T.$Ce)(S,p??{});let r=S;u&&u.length>0&&(r+=`/${Array.isArray(u)?u.join(""):u}`);const s=this.d.get(v)?.contents[r];return s||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,T.$Ce)(s??S,p??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let k;const S=await this.g(v);if(!S){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const p=await this.a.$fetchBundleContents(S),u=JSON.parse(p);k=v.isBuiltin?u.contents?.bundle:u}catch(p){this.f.error(`Failed to load translations for ${v.identifier.value} from ${S}: ${p.message}`);return}k&&this.d.set(v.identifier.value,{contents:k,uri:S})}async g(v){if(v.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(v.identifier.value,this.b);return g.URI.revive(k)}return v.l10n?g.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$gcc=A,e.$gcc=A=He([Be(0,E.$nM),Be(1,w.$0L),Be(2,R.$8i)],A),e.$hcc=(0,L.$Nh)("IExtHostLocalizationService")}),define(De[150],Ce([1,0,13,6,26,20,2,62]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;let E=class extends D.$gj{constructor(I,v){super(v.logLevel,v.logsLocation,v.loggers.map(k=>(0,b.$kh)(k))),this.r=I.getProxy(T.$9J.MainThreadLogger)}$setLogLevel(I,v){v?this.setLogLevel(R.URI.revive(v),I):this.setLogLevel(I)}setVisibility(I,v){super.setVisibility(I,v),this.r.$setVisibility(I,v)}s(I,v,k){return new w(this.r,I,v,k)}};e.$Hdc=E,e.$Hdc=E=He([Be(0,L.$0L),Be(1,g.$nM)],E);class w extends D.$bj{constructor(I,v,k,S){super(S?.logLevel==="always"),this.r=I,this.s=v,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(v,S).then(()=>{this.u(this.n),this.m=!0})}g(I,v){const k=[[I,v]];this.m?this.u(k):this.n.push(...k)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(De[113],Ce([1,0,6,5,3,20,22]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=void 0,e.$icc=(0,T.$Nh)("IExtHostManagedSockets");let b=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(D.$9J.MainThreadManagedSockets)}setFactory(I,v){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(I,v),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const v=++this.b,k=await this.c.makeConnection(),S=new g.$Qc;return this.d.set(v,new w(v,k,S)),S.add((0,g.$Pc)(()=>this.d.delete(v))),S.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(v),S.dispose()})),S.add(k.onDidClose(p=>{this.a.$onDidManagedSocketClose(v,p?.stack??p?.message),S.dispose()})),S.add(k.onDidReceiveMessage(p=>this.a.$onDidManagedSocketHaveData(v,R.$ae.wrap(p)))),v}$remoteSocketWrite(I,v){this.d.get(I)?.actual.send(v.buffer)}$remoteSocketEnd(I){const v=this.d.get(I);v&&(v.actual.end(),v.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$jcc=b,e.$jcc=b=He([Be(0,L.$0L)],b);class E{constructor(I,v){this.socketFactoryId=I,this.makeConnection=v}}class w extends g.$Rc{constructor(I,v,k){super(),this.socketId=I,this.actual=v,this.B(k)}}}),define(De[317],Ce([1,0,6,13,27]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;function L(b){return b&&b.title}let R=class{constructor(E,w){this.b=w,this.a=E.getProxy(D.$9J.MainThreadMessageService)}showMessage(E,w,A,I,v){const k={source:{identifier:E.identifier,label:E.displayName||E.name}};let S;typeof I=="string"||L(I)?S=[I,...v]:(k.modal=I?.modal,k.useCustom=I?.useCustom,k.detail=I?.detail,S=v),k.useCustom&&(0,g.$9E)(E,"resolvers");const p=[];for(let u=0;u<S.length;u++){const r=S[u];if(typeof r=="string")p.push({title:r,handle:u,isCloseAffordance:!1});else if(typeof r=="object"){const{title:s,isCloseAffordance:a}=r;p.push({title:s,isCloseAffordance:!!a,handle:u})}else this.b.warn("Invalid message item:",r)}return this.a.$showMessage(w,A,k,p).then(u=>{if(typeof u=="number")return S[u]})}};e.$scc=R,e.$scc=R=He([Be(1,T.$8i)],R)}),define(De[318],Ce([1,0,207,22,4,3,28,15,18,2,30,87,6,33,14,7,68,281,144,8,23,17]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(o=>o.apiEditor)}constructor(o,i,c,h,y){this.q=c,this.r=h,this.s=y,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new g.$Md({onListenerError:a.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$Md({onListenerError:a.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$Md({onListenerError:a.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$Md({onListenerError:a.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Abc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=o.getProxy(v.$9J.MainThreadNotebook),this.c=o.getProxy(v.$9J.MainThreadNotebookDocuments),this.d=o.getProxy(v.$9J.MainThreadNotebookEditors),this.i=i.converter,i.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const $=C.notebookEditor?.notebookUri,f=C.cell.handle,P=this.g.get($)?.getCell(f);if(P)return P.apiCell}if(C&&C.$mid===14){const $=C.uri,f=this.g.get($);if(f)return f.apiNotebook}return C}}),t.A(i)}getEditorById(o){const i=this.h.get(o);if(!i)throw new Error(`unknown text editor: ${o}. known editors: ${[...this.h.keys()]} `);return i}getIdByEditor(o){for(const[i,c]of this.h)if(c.apiEditor===o)return i}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(o,i){const c=this.g.get(o);if(!c&&!i)throw new Error(`NO notebook document for '${o}'`);return c}static t(o,i){if(!i)return;const c=i.filenamePattern.map(h=>S.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(i.filenamePattern&&!c){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:i.displayName,filenamePattern:c,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,i,c){const h=t.a++,y=typeof c.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(h,c),this.b.$registerNotebookCellStatusBarItemProvider(h,y,i);let C;return y!==void 0&&(C=c.onDidChangeCellStatusBarItems($=>this.b.$emitCellStatusBarEvent(y))),new p.$$J(()=>{this.f.delete(h),this.b.$unregisterNotebookCellStatusBarItemProvider(h,y),C?.dispose()})}async createNotebookDocument(o){const i=await this.c.$tryCreateNotebook({viewType:o.viewType,content:o.content&&S.NotebookData.from(o.content)});return w.URI.revive(i)}async openNotebookDocument(o){const i=this.g.get(o);if(i)return i.apiNotebook;const c=await this.c.$tryOpenNotebook(o),h=this.g.get(w.URI.revive(c));return(0,E.$If)(h?.apiNotebook)}async showNotebookDocument(o,i){w.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let c;typeof i=="object"?c={position:S.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(S.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:c={preserveFocus:!1};const h=await this.d.$tryShowNotebookDocument(o.uri,o.notebookType,c),y=h&&this.h.get(h)?.apiEditor;if(y)return y;throw h?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,i,c,h){const y=this.f.get(o),C=w.URI.revive(i),$=this.g.get(C);if(!$||!y)return;const f=$.getCellFromIndex(c);if(!f)return;const d=await y.provideCellStatusBarItems(f.apiCell,h);if(!d)return;const P=new L.$Qc,N=this.p.add([P]),M=(Array.isArray(d)?d:[d]).map(j=>S.NotebookStatusBarItem.from(j,this.i,P));return{cacheId:N,items:M}}$releaseNotebookCellStatusBarItems(o){this.p.delete(o)}registerNotebookSerializer(o,i,c,h,y){if((0,b.$Ae)(i))throw new Error("viewType cannot be empty or just whitespace");const C=this.u++;return this.w.set(C,{viewType:i,serializer:c,options:h}),this.b.$registerNotebookSerializer(C,{id:o.identifier,location:o.extensionLocation},i,S.NotebookDocumentContentOptions.from(h),t.t(o,y)),(0,L.$Pc)(()=>{this.b.$unregisterNotebookSerializer(C)})}async $dataToNotebook(o,i,c){const h=this.w.get(o);if(!h)throw new Error("NO serializer found");const y=await h.serializer.deserializeNotebook(i.buffer,c);return new u.$jv(S.NotebookData.from(y))}async $notebookToData(o,i,c){const h=this.w.get(o);if(!h)throw new Error("NO serializer found");const y=await h.serializer.serializeNotebook(S.NotebookData.to(i.value),c);return T.$ae.wrap(y)}async $saveNotebook(o,i,c,h,y){const C=w.URI.revive(i),$=this.w.get(o);if(!$)throw new Error("NO serializer found");const f=this.g.get(C);if(!f)throw new Error("Document NOT found");if(f.versionId!==c)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(C.scheme))throw new A.$qk((0,D.localize)(0,null,this.y(C)),6);await this.x(C,h);const d={metadata:(0,m.$7m)(f.apiNotebook.metadata,j=>!($.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of f.apiNotebook.getCells()){const U=new p.$wL(j.kind,j.document.getText(),j.document.languageId,j.mime,$.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);U.metadata=(0,m.$7m)(j.metadata,F=>!($.options?.transientCellMetadata??{})[F]),d.cells.push(U)}const P=await $.serializer.serializeNotebook(d,y);await this.s.value.writeFile(C,P);const N=this.s.getFileSystemProviderExtUri(C.scheme),O=await this.s.value.stat(C);return{name:N.basename(C),isFile:(O.type&A.FileType.File)!==0,isDirectory:(O.type&A.FileType.Directory)!==0,isSymbolicLink:(O.type&A.FileType.SymbolicLink)!==0,mtime:O.mtime,ctime:O.ctime,size:O.size,readonly:!!((O.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(C.scheme),locked:!!((O.permissions??0)&A.FilePermission.Locked),etag:A.$Bk({mtime:O.mtime,size:O.size}),children:void 0}}async x(o,i){const c=await this.s.value.stat(o);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==A.$Ak&&typeof c.mtime=="number"&&typeof c.size=="number"&&i.mtime<c.mtime&&i.etag!==A.$Bk({mtime:i.mtime,size:c.size}))throw new A.$qk((0,D.localize)(1,null),3,i)}y(o){return o.scheme===l.Schemas.file?o.fsPath:o.toString()}z(o,i,c){if(this.h.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const h=new s.$_cc(i,this.d,o,c.visibleRanges.map(S.NotebookRange.to),c.selections.map(S.NotebookRange.to),typeof c.viewColumn=="number"?S.ViewColumn.to(c.viewColumn):void 0);this.h.set(i,h)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const c of o.value.removedDocuments){const h=w.URI.revive(c),y=this.g.get(h);y&&(y.dispose(),this.g.delete(h),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:y.apiNotebook.getCells().map(C=>C.document.uri)}),this.n.fire(y.apiNotebook));for(const C of this.h.values())C.notebookData.uri.toString()===h.toString()&&this.h.delete(C.id)}if(o.value.addedDocuments){const c=[];for(const h of o.value.addedDocuments){const y=w.URI.revive(h.uri);if(this.g.has(y))throw new Error(`adding EXISTING notebook ${y} `);const C=new r.$$cc(this.c,this.q,this.r,y,h);c.push(...h.cells.map($=>r.$0cc.asModelAddData(C.apiNotebook,$))),this.g.get(y)?.dispose(),this.g.set(y,C),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:c}),this.m.fire(C.apiNotebook)}}if(o.value.addedEditors)for(const c of o.value.addedEditors){if(this.h.has(c.id))return;const h=w.URI.revive(c.documentUri),y=this.g.get(h);y&&this.z(y,c.id,c)}const i=[];if(o.value.removedEditors)for(const c of o.value.removedEditors){const h=this.h.get(c);h&&(this.h.delete(c),this.k?.id===h.id&&(this.k=void 0),i.push(h))}if(o.value.visibleEditors){this.l=o.value.visibleEditors.map(h=>this.h.get(h)).filter(h=>!!h);const c=new Set;this.l.forEach(h=>c.add(h.id));for(const h of this.h.values()){const y=c.has(h.id);h._acceptVisibility(y)}this.l=[...this.h.values()].map(h=>h).filter(h=>h.visible),this.o.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this.k=void 0:o.value.newActiveEditor&&(this.h.get(o.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${o.value.newActiveEditor}`),this.k=this.h.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(o){const i=k.$vM.String.with("notebookType","A notebook type"),c=new k.$xM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new k.$vM("data","Bytes to convert to data",y=>y instanceof Uint8Array,y=>T.$ae.wrap(y))],new k.$wM("Notebook Data",y=>S.NotebookData.to(y.value))),h=new k.$xM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new k.$vM("NotebookData","Notebook data to convert to bytes",y=>!0,y=>new u.$jv(S.NotebookData.from(y)))],new k.$wM("Bytes",y=>y.buffer));o.registerApiCommand(c),o.registerApiCommand(h)}}e.$adc=t}),define(De[319],Ce([1,0,19,11,21,4,3,28,2,25,13,87,6,33,14,7,110,275,27,68]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=e.$odc=void 0;let m=class{constructor(y,C,$,f,d){this.m=C,this.n=$,this.o=f,this.q=d,this.b=new b.$zc,this.c=new b.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new I.$Abc("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new L.$Md,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=y.getProxy(v.$9J.MainThreadNotebookKernels);const P=new k.$xM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new k.$vM("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const O=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:O}}else if(N&&"notebookEditor"in N){const O=this.n.getIdByEditor(N.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return N})],k.$wM.Void);this.o.registerApiCommand(P)}createNotebookController(y,C,$,f,d,P){for(const me of this.j.values())if(me.controller.id===C&&w.$Yl.equals(y.identifier,me.extensionId))throw new Error(`notebook controller with id '${C}' ALREADY exist`);const N=this.k++,O=this;this.q.trace(`NotebookController[${N}], CREATED by ${y.identifier.value}, ${C}`);const M=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${y.identifier}'`);let j=!1;const U=new L.$Md,F=new L.$Md,V={id:c(y.identifier,C),notebookType:$,extensionId:y.identifier,extensionLocation:y.extensionLocation,label:f||y.identifier.value,preloads:P?P.map(S.NotebookRendererScript.from):[]};let H=d??M,fe;this.a.$addKernel(N,V).catch(me=>{console.log(me),j=!0});let X=0;const Y=()=>{if(j)return;const me=++X;Promise.resolve().then(()=>{me===X&&this.a.$updateKernel(N,V)})},q=new b.$zc,x={get id(){return C},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return V.label},set label(me){V.label=me??y.displayName??y.name,Y()},get detail(){return V.detail??""},set detail(me){V.detail=me,Y()},get description(){return V.description??""},set description(me){V.description=me,Y()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(me){V.supportedLanguages=me,Y()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(me){V.supportsExecutionOrder=me,Y()},get rendererScripts(){return V.preloads?V.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(me){H=me??M},get interruptHandler(){return fe},set interruptHandler(me){fe=me,V.supportsInterrupt=!!me,Y()},createNotebookCellExecution(me){if(j)throw new Error("notebook controller is DISPOSED");if(!q.has(me.notebook.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(q.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.notebook.uri.toString()}`);return O._createNotebookCellExecution(me,c(y.identifier,this.id))},createNotebookExecution(me){if((0,s.$9E)(y,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!q.has(me.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(q.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.uri.toString()}`);return O._createNotebookExecution(me,c(y.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${N}], DISPOSED`),j=!0,this.j.delete(N),U.dispose(),F.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(me,ue){ue===p.NotebookControllerAffinity2.Hidden&&(0,s.$9E)(y,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(N,me.uri,ue)},onDidReceiveMessage:F.event,postMessage(me,ue){return(0,s.$9E)(y,"notebookMessaging"),O.a.$postMessage(N,ue&&O.n.getIdByEditor(ue),me)},asWebviewUri(me){return(0,s.$9E)(y,"notebookMessaging"),(0,u.$Vob)(me,O.m.remote)}};return this.j.set(N,{extensionId:y.identifier,controller:x,onDidReceiveMessage:F,onDidChangeSelection:U,associatedNotebooks:q}),x}getIdByController(y){for(const[C,$]of this.j)if($.controller===y)return c($.extensionId,y.id);return null}createNotebookControllerDetectionTask(y,C){const $=this.f++,f=this;this.q.trace(`NotebookControllerDetectionTask[${$}], CREATED by ${y.identifier.value}`),this.a.$addKernelDetectionTask($,C);const d={dispose:()=>{this.e.delete($),f.a.$removeKernelDetectionTask($)}};return this.e.set($,d),d}registerKernelSourceActionProvider(y,C,$){const f=this.h++,d=typeof $.onDidChangeNotebookKernelSourceActions=="function"?f:void 0,P=this;this.g.set(f,$),this.q.trace(`NotebookKernelSourceActionProvider[${f}], CREATED by ${y.identifier.value}`),this.a.$addKernelSourceActionProvider(f,f,C);let N;return d!==void 0&&(N=$.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(d))),{dispose:()=>{this.g.delete(f),P.a.$removeKernelSourceActionProvider(f,f),N?.dispose()}}}async $provideKernelSourceActions(y,C){const $=this.g.get(y);if($){const f=new R.$Qc;return this.i.add([f]),(await $.provideNotebookKernelSourceActions(C)??[]).map(P=>S.NotebookKernelSourceAction.from(P,this.o.converter,f))}return[]}$acceptNotebookAssociation(y,C,$){const f=this.j.get(y);if(f){const d=this.n.getNotebookDocument(E.URI.revive(C));$?f.associatedNotebooks.set(d.uri,!0):f.associatedNotebooks.delete(d.uri),this.q.trace(`NotebookController[${y}] ASSOCIATE notebook`,d.uri.toString(),$),f.onDidChangeSelection.fire({selected:$,notebook:d.apiNotebook})}}async $executeCells(y,C,$){const f=this.j.get(y);if(!f)return;const d=this.n.getNotebookDocument(E.URI.revive(C)),P=[];for(const N of $){const O=d.getCell(N);O&&P.push(O.apiCell)}try{this.q.trace(`NotebookController[${y}] EXECUTE cells`,d.uri.toString(),P.length),await f.controller.executeHandler.call(f.controller,P,d.apiNotebook,f.controller)}catch(N){this.q.error(`NotebookController[${y}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(y,C,$){const f=this.j.get(y);if(!f)return;const d=this.n.getNotebookDocument(E.URI.revive(C));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,d.apiNotebook);else for(const P of $){const N=d.getCell(P);N&&this.b.get(N.uri)?.cancel()}if(f.controller.interruptHandler){const P=this.c.get(d.uri);$.length&&Array.isArray(P)&&P.length&&P.forEach(N=>N.dispose())}}$acceptKernelMessageFromRenderer(y,C,$){const f=this.j.get(y);if(!f)return;const d=this.n.getEditorById(C);f.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:$}))}$cellExecutionChanged(y,C,$){const d=this.n.getNotebookDocument(E.URI.revive(y)).getCell(C);if(d){const P=$?S.NotebookCellExecutionState.to($):p.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:d.apiCell,state:P})}}_createNotebookCellExecution(y,C){if(y.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this.n.getNotebookDocument(y.notebook.uri).getCellFromApiCell(y);if(!f)throw new Error("invalid cell");if(this.b.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const d=new t(C,f,this.a);this.b.set(f.uri,d);const P=d.onDidChangeState(()=>{d.state===l.Resolved&&(d.dispose(),P.dispose(),this.b.delete(f.uri))});return d.asApiObject()}_createNotebookExecution(y,C){const $=this.n.getNotebookDocument(y.uri),f=y.getCells().find(N=>{const O=$.getCellFromApiCell(N);return O&&this.b.has(O.uri)});if(f)throw new Error(`duplicate cell execution for ${f.document.uri}`);if(this.c.has($.uri))throw new Error(`duplicate notebook execution for ${$.uri}`);const d=new o(C,$,this.a),P=d.onDidChangeState(()=>{d.state===n.Resolved&&(d.dispose(),P.dispose(),this.c.delete($.uri))});return this.c.set($.uri,[d,P]),d.asApiObject()}};e.$odc=m,e.$odc=m=He([Be(4,A.$8i)],m);var l;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(l||(l={}));class t extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(y,C,$){super(),this.m=C,this.n=$,this.b=t.a++,this.c=new L.$Md,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new g.$Wd),this.h=new i(10,f=>this.s(f)),this.j=C.internalMetadata.executionOrder,this.n.$createExecution(this.b,y,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(y){await this.h.addItem(y)}async s(y){const C=Array.isArray(y)?y:[y];return this.n.$updateExecution(this.b,new a.$jv(C))}t(){if(this.f===l.Init)throw new Error("Must call start before modifying cell output");if(this.f===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(y){let C=this.m;if(y&&(C=this.m.notebook.getCellFromApiCell(y)),!C)throw new Error("INVALID cell");return C.handle}y(y){return y.map(C=>{const $=p.$zL.ensureUniqueMimeTypes(C.items,!0);return $===C.items?S.NotebookCellOutput.from(C):S.NotebookCellOutput.from({items:$,id:C.id,metadata:C.metadata})})}async z(y,C,$){const f=this.w(C),d=this.y((0,D.$2b)(y));return this.r({editType:r.CellExecutionUpdateType.Output,cellHandle:f,append:$,outputs:d})}async C(y,C,$){return y=p.$zL.ensureUniqueMimeTypes((0,D.$2b)(y),!0),this.r({editType:r.CellExecutionUpdateType.OutputItems,items:y.map(S.NotebookCellOutputItem.from),outputId:C.id,append:$})}asApiObject(){const y=this;return Object.freeze({get token(){return y.g.token},get cell(){return y.m.apiCell},get executionOrder(){return y.j},set executionOrder($){y.j=$,y.s([{editType:r.CellExecutionUpdateType.ExecutionState,executionOrder:y.j}])},start($){if(y.f===l.Resolved||y.f===l.Started)throw new Error("Cannot call start again");y.f=l.Started,y.c.fire(),y.s({editType:r.CellExecutionUpdateType.ExecutionState,runStartTime:$})},end($,f){if(y.f===l.Resolved)throw new Error("Cannot call resolve twice");y.f=l.Resolved,y.c.fire(),y.h.flush(),y.n.$completeExecution(y.b,new a.$jv({runEndTime:f,lastRunSuccess:$}))},clearOutput($){return y.t(),y.z([],$,!1)},appendOutput($,f){return y.t(),y.z($,f,!0)},replaceOutput($,f){return y.t(),y.z($,f,!1)},appendOutputItems($,f){return y.t(),y.C($,f,!0)},replaceOutputItems($,f){return y.t(),y.C($,f,!1)}})}}var n;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(n||(n={}));class o extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(y,C,$){super(),this.h=C,this.j=$,this.b=o.a++,this.c=new L.$Md,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new g.$Wd),this.j.$createNotebookExecution(this.b,y,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class i{constructor(y,C){this.e=y,this.f=C,this.a=[],this.b=Date.now()}addItem(y){return this.a.push(y),this.c||(this.c=new T.$bh,this.b=Date.now(),(0,T.$Tg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const y=this.c;this.c=void 0;const C=this.a;return this.a=[],this.f(C).finally(()=>y.complete())}}function c(h,y){return`${h.value}/${y}`}e.$pdc=c}),define(De[320],Ce([1,0,4,6,144]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class L{constructor(b,E){this.c=E,this.a=new Map,this.b=b.getProxy(T.$9J.MainThreadNotebookRenderers)}$postRendererMessage(b,E,w){const A=this.c.getEditorById(b);this.a.get(E)?.fire({editor:A.apiEditor,message:w})}createRendererMessaging(b,E){if(!b.contributes?.notebookRenderer?.some(A=>A.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(A,I,v)=>this.d(E).event(A,I,v),postMessage:(A,I)=>{g.$_cc.apiEditorsToExtHost.has(A)&&([A,I]=[I,A]);const v=I&&g.$_cc.apiEditorsToExtHost.get(I);return this.b.$postMessage(v?.id,E,A)}}}d(b){let E=this.a.get(b);return E||(E=new D.$Md({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(b)}}),this.a.set(b,E),E)}}e.$qdc=L}),define(De[321],Ce([1,0,3,18,2,27,6]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;class b{constructor(w){this.b=new Map,this.a=w.getProxy(R.$9J.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,A,I){if((0,L.$9E)(w,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,I),this.a.$registerProfileContentHandler(A,I.name,I.description,w.identifier.value),(0,D.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(w,A,I,v){const k=this.b.get(w);if(!k)throw new Error(`Unknown handler with id: ${w}`);return k.saveProfile(A,I,v)}async $readProfile(w,A,I){const v=this.b.get(w);if(!v)throw new Error(`Unknown handler with id: ${w}`);return v.readProfile((0,T.$xf)(A)?A:g.URI.revive(A),I)}}e.$udc=b}),define(De[322],Ce([1,0,2,6,11,14]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=void 0;class R{static{this.a=0}constructor(E,w){this.d=w,this.c=new Map,this.b=E.getProxy(T.$9J.MainThreadQuickDiff)}$provideOriginalResource(E,w,A){const I=D.URI.revive(w),v=this.c.get(E);return v?(0,g.$Lg)(()=>v.provideOriginalResource(I,A)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(E,w,A,I){const v=R.a++;return this.c.set(v,w),this.b.$registerQuickDiffProvider(v,L.DocumentSelector.from(E,this.d),A,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(v),this.c.delete(v)}}}}e.$vdc=R}),define(De[323],Ce([1,0,21,4,3,6,2,7,8,19,38,59,27,14]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;function S(p,u,r){const s=p.getProxy(L.$9J.MainThreadQuickOpen);class a{constructor(y,C){this.e=new Map,this.f=0,this.a=y,this.b=C}showQuickPick(y,C,$,f=D.CancellationToken.None){this.c=void 0;const d=Promise.resolve(C),P=++this.f,N=s.$show(P,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},f),O={},M=N.then(()=>O);return Promise.race([M,d]).then(j=>{if(j===O)return;const U=(0,v.$8E)(y,"quickPickItemTooltip");return d.then(F=>{const V=[];for(let H=0;H<F.length;H++){const fe=F[H];if(typeof fe=="string")V.push({label:fe,handle:H});else if(fe.kind===b.QuickPickItemKind.Separator)V.push({type:"separator",label:fe.label});else{fe.tooltip&&!U&&console.warn(`Extension '${y.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${y.identifier.value}`);const X=fe.iconPath?o(fe.iconPath):void 0;V.push({label:fe.label,iconPath:X?.iconPath,iconClass:X?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:U?k.MarkdownString.fromStrict(fe.tooltip):void 0,handle:H})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=H=>{$.onDidSelectItem(F[H])}),s.$setItems(P,V),N.then(H=>{if(typeof H=="number")return F[H];if(Array.isArray(H))return H.map(fe=>F[fe])})})}).then(void 0,j=>{if(!(0,E.$3)(j))return s.$setError(P,j),Promise.reject(j)})}$onItemSelected(y){this.c?.(y)}showInput(y,C=D.CancellationToken.None){return this.d=y?.validateInput,s.$input(y,typeof this.d=="function",C).then(void 0,$=>{if(!(0,E.$3)($))return Promise.reject($)})}async $validateInput(y){if(!this.d)return;const C=await this.d(y);if(!C||typeof C=="string")return C;let $;switch(C.severity){case b.InputBoxValidationSeverity.Info:$=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:$=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:$=A.default.Error;break;default:$=C.message?A.default.Error:A.default.Ignore;break}return{content:C.message,severity:$}}async showWorkspaceFolderPick(y,C=D.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[y]);if(!$)return;const f=await this.a.getWorkspaceFolders2();if(f)return f.find(d=>d.uri.toString()===$.uri.toString())}createQuickPick(y){const C=new i(y,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}createInputBox(y){const C=new c(y,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}$onDidChangeValue(y,C){this.e.get(y)?._fireDidChangeValue(C)}$onDidAccept(y){this.e.get(y)?._fireDidAccept()}$onDidChangeActive(y,C){const $=this.e.get(y);$ instanceof i&&$._fireDidChangeActive(C)}$onDidChangeSelection(y,C){const $=this.e.get(y);$ instanceof i&&$._fireDidChangeSelection(C)}$onDidTriggerButton(y,C){this.e.get(y)?._fireDidTriggerButton(C)}$onDidTriggerItemButton(y,C,$){const f=this.e.get(y);f instanceof i&&f._fireDidTriggerItemButton(C,$)}$onDidHide(y){this.e.get(y)?._fireDidHide()}}class m{static{this.a=1}constructor(y,C){this.x=y,this.y=C,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Md,this.q=new T.$Md,this.r=new T.$Md,this.s=new T.$Md,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(y){this.b=y,this.z({title:y})}get step(){return this.c}set step(y){this.c=y,this.z({step:y})}get totalSteps(){return this.d}set totalSteps(y){this.d=y,this.z({totalSteps:y})}get enabled(){return this.g}set enabled(y){this.g=y,this.z({enabled:y})}get busy(){return this.j}set busy(y){this.j=y,this.z({busy:y})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(y){this.k=y,this.z({ignoreFocusOut:y})}get value(){return this.l}set value(y){this.l=y,this.z({value:y})}get placeholder(){return this.m}set placeholder(y){this.m=y,this.z({placeholder:y})}get buttons(){return this.n}set buttons(y){this.n=y.slice(),this.o.clear(),y.forEach((C,$)=>{const f=C===b.$sL.Back?-1:$;this.o.set(f,C)}),this.z({buttons:y.map((C,$)=>({...o(C.iconPath),tooltip:C.tooltip,handle:C===b.$sL.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(y){this.l=y,this.q.fire(y)}_fireDidTriggerButton(y){const C=this.o.get(y);C&&this.r.fire(C)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),s.$dispose(this._id))}z(y){if(!this.v){for(const C of Object.keys(y)){const $=y[C];this.u[C]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){s.$createOrUpdate(this.u),this.u={id:this._id}}}function l(h){if(h instanceof b.$5K)return{id:h.id};const y=n(h),C=t(h);return{dark:typeof y=="string"?R.URI.file(y):y,light:typeof C=="string"?R.URI.file(C):C}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function n(h){return typeof h=="object"&&"dark"in h?h.dark:h}function o(h){const y=l(h);let C,$;return"id"in y?$=I.ThemeIcon.asClassName(y):C=y,{iconPath:C,iconClass:$}}class i extends m{constructor(y,C){super(y.identifier,C),this.O=y,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Md,this.L=[],this.M=new T.$Md,this.N=new T.$Md,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(y){this.B=y.slice(),this.C.clear(),this.D.clear(),y.forEach((f,d)=>{this.C.set(d,f),this.D.set(f,d)});const C=(0,v.$8E)(this.O,"quickPickItemTooltip"),$=[];for(let f=0;f<y.length;f++){const d=y[f];if(d.kind===b.QuickPickItemKind.Separator)$.push({type:"separator",label:d.label});else{d.tooltip&&!C&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=d.iconPath?o(d.iconPath):void 0;$.push({handle:f,label:d.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,tooltip:C?k.MarkdownString.fromStrict(d.tooltip):void 0,buttons:d.buttons?.map((N,O)=>({...o(N.iconPath),tooltip:N.tooltip,handle:O}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(y){this.E=y,this.z({canSelectMany:y})}get matchOnDescription(){return this.F}set matchOnDescription(y){this.F=y,this.z({matchOnDescription:y})}get matchOnDetail(){return this.G}set matchOnDetail(y){this.G=y,this.z({matchOnDetail:y})}get sortByLabel(){return this.H}set sortByLabel(y){this.H=y,this.z({sortByLabel:y})}get keepScrollPosition(){return this.I}set keepScrollPosition(y){this.I=y,this.z({keepScrollPosition:y})}get activeItems(){return this.J}set activeItems(y){this.J=y.filter(C=>this.D.has(C)),this.z({activeItems:this.J.map(C=>this.D.get(C))})}get selectedItems(){return this.L}set selectedItems(y){this.L=y.filter(C=>this.D.has(C)),this.z({selectedItems:this.L.map(C=>this.D.get(C))})}_fireDidChangeActive(y){const C=(0,w.$Gb)(y.map($=>this.C.get($)));this.J=C,this.K.fire(C)}_fireDidChangeSelection(y){const C=(0,w.$Gb)(y.map($=>this.C.get($)));this.L=C,this.M.fire(C)}_fireDidTriggerItemButton(y,C){const $=this.C.get(y);if(!$||!$.buttons||!$.buttons.length)return;const f=$.buttons[C];f&&this.N.fire({button:f,item:$})}}class c extends m{constructor(y,C){super(y.identifier,C),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(y){this.B=y,this.z({password:y})}get prompt(){return this.C}set prompt(y){this.C=y,this.z({prompt:y})}get valueSelection(){return this.D}set valueSelection(y){this.D=y,this.z({valueSelection:y})}get validationMessage(){return this.E}set validationMessage(y){this.E=y,y?typeof y=="string"?this.z({validationMessage:y,severity:A.default.Error}):this.z({validationMessage:y.message,severity:y.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new a(u,r)}e.$wcc=S}),define(De[324],Ce([1,0,2,4,57,3,11,6,19,126,13,25,59,14,27,17]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=void 0;function r(f){if(f)return typeof f.iconPath=="string"?D.URI.file(f.iconPath):D.URI.isUri(f.iconPath)||v.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function s(f){if(f.icon){if(D.URI.isUri(f.icon))return f.icon;if(v.ThemeIcon.isThemeIcon(f.icon))return f.icon;{const d=f.icon;return{light:d.light,dark:d.dark}}}else return}function a(f,d){if(!f.iconPath&&!d.iconPath)return 0;if(f.iconPath){if(!d.iconPath)return 1}else return-1;const P=typeof f.iconPath=="string"?f.iconPath:D.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,N=typeof d.iconPath=="string"?d.iconPath:D.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,w.$kq)(P,N)}function m(f,d){let P=0;if(f.strikeThrough!==d.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==d.faded)return f.faded?1:-1;if(f.tooltip!==d.tooltip)return(f.tooltip||"").localeCompare(d.tooltip||"");if(P=a(f,d),P!==0)return P;if(f.light&&d.light)P=a(f.light,d.light);else{if(f.light)return 1;if(d.light)return-1}if(P!==0)return P;if(f.dark&&d.dark)P=a(f.dark,d.dark);else{if(f.dark)return 1;if(d.dark)return-1}return P}function l(f,d){if(f.command!==d.command)return f.command<d.command?-1:1;if(f.title!==d.title)return f.title<d.title?-1:1;if(f.tooltip!==d.tooltip){if(f.tooltip!==void 0&&d.tooltip!==void 0)return f.tooltip<d.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(f.arguments===d.arguments)return 0;if(f.arguments)if(d.arguments){if(f.arguments.length!==d.arguments.length)return f.arguments.length-d.arguments.length}else return 1;else return-1;for(let P=0;P<f.arguments.length;P++){const N=f.arguments[P],O=d.arguments[P];if(N!==O)return N<O?-1:1}return 0}function t(f,d){let P=(0,w.$kq)(f.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(P!==0)return P;if(f.command&&d.command)P=l(f.command,d.command);else{if(f.command)return 1;if(d.command)return-1}if(P!==0)return P;if(f.decorations&&d.decorations)P=m(f.decorations,d.decorations);else{if(f.decorations)return 1;if(d.decorations)return-1}return P}function n(f,d){for(let P=0;P<f.length;P++)if(f[P]!==d[P])return!1;return!0}function o(f,d){return f.command===d.command&&f.title===d.title&&f.tooltip===d.tooltip&&(f.arguments&&d.arguments?n(f.arguments,d.arguments):f.arguments===d.arguments)}function i(f,d){return(0,E.$tb)(f,d,o)}function c(f,d){return f===d?!0:!f||!d?!1:f.id===d.id&&f.label===d.label&&f.upstream?.id===d.upstream?.id&&f.upstream?.label===d.upstream?.label}class h{#e;#t;get value(){return this.d}set value(d){d=d??"",this.#e.$setInputBoxValue(this.l,d),this.n(d)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(d){this.#e.$setInputBoxPlaceholder(this.l,d),this.f=d}get validateInput(){return(0,S.$9E)(this.k,"scmValidation"),this.g}set validateInput(d){if((0,S.$9E)(this.k,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=d,this.#e.$setValidationProviderIsEnabled(this.l,!!d)}get enabled(){return this.h}set enabled(d){d=!!d,this.h!==d&&(this.h=d,this.#e.$setInputBoxEnablement(this.l,d))}get visible(){return this.j}set visible(d){d=!!d,this.j!==d&&(this.j=d,this.#e.$setInputBoxVisibility(this.l,d))}get document(){return(0,S.$9E)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(d,P,N,O,M){this.k=d,this.l=O,this.m=M,this.d="",this.e=new T.$Md,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=N}showValidationMessage(d,P){(0,S.$9E)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,d,P)}$onInputBoxValueChange(d){this.n(d)}n(d){this.d=d,this.e.fire(d)}}e.$xcc=h;class y{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(d){this.v=d,this.q.$updateGroupLabel(this.t,this.handle,d)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(d){this.p=d,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(d){this.f=[...d],this.k.fire()}constructor(d,P,N,O,M){this.q=d,this.s=P,this.t=N,this.u=O,this.v=M,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Md,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Md,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=y.d++}getResourceState(d){return this.g.get(d)}$executeResourceCommand(d,P){const N=this.h.get(d);return N?(0,R.$Lg)(()=>this.s.executeCommand(N.command,...N.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this.f].sort(t),N=(0,E.$Cb)(this.o,d,t).map(j=>{const U=j.toInsert.map(F=>{const V=this.e++;this.g.set(V,F);const H=F.resourceUri;let fe;if(F.command)if(F.command.command==="vscode.open"||F.command.command==="vscode.diff"){const K=new L.$Qc;fe=this.s.converter.toInternal(F.command,K),this.j.set(V,K)}else this.h.set(V,F.command);const X=r(F.decorations),Y=F.decorations&&r(F.decorations.light)||X,q=F.decorations&&r(F.decorations.dark)||X,x=[Y,q],me=F.decorations&&F.decorations.tooltip||"",ue=F.decorations&&!!F.decorations.strikeThrough,pe=F.decorations&&!!F.decorations.faded,G=F.contextValue||"";return{rawResource:[V,H,x,me,ue,pe,G,fe],handle:V}});return{start:j.start,deleteCount:j.deleteCount,toInsert:U}}),O=N.map(({start:j,deleteCount:U,toInsert:F})=>[j,U,F.map(V=>V.rawResource)]),M=N.reverse();for(const{start:j,deleteCount:U,toInsert:F}of M){const V=F.map(fe=>fe.handle),H=this.n.splice(j,U,...V);for(const fe of H)this.g.delete(fe),this.h.delete(fe),this.j.get(fe)?.dispose(),this.j.delete(fe)}return this.o=d,O}dispose(){this.l=!0,this.m.fire()}}class C{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(d){this.g!==d&&(this.g=d,this.#e.$updateSourceControl(this.x,{count:d}))}get quickDiffProvider(){return this.h}set quickDiffProvider(d){this.h=d;let P;(0,S.$8E)(this.y,"quickDiffProvider")&&(P=d?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!d,quickDiffLabel:P})}get historyProvider(){return(0,S.$9E)(this.y,"scmHistoryProvider"),this.j}set historyProvider(d){(0,S.$9E)(this.y,"scmHistoryProvider"),this.j=d,this.k.value=new L.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!d}),d&&(this.k.value.add(d.onDidChangeCurrentHistoryItemGroup(()=>{c(this.l,d?.currentHistoryItemGroup)||(this.l=d?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(d.onDidChangeActionButton(()=>{(0,S.$9E)(this.y,"scmActionButton"),this.m.value=new L.$Qc;const P=d.actionButton!==void 0?{command:this.z.converter.toInternal(d.actionButton.command,this.m.value),description:d.actionButton.description,enabled:d.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(d){d!==this.n&&(this.n=d,this.#e.$updateSourceControl(this.x,{commitTemplate:d}))}get acceptInputCommand(){return this.p}set acceptInputCommand(d){this.o.value=new L.$Qc,this.p=d;const P=this.z.converter.toInternal(d,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,S.$9E)(this.y,"scmActionButton"),this.s}set actionButton(d){(0,S.$9E)(this.y,"scmActionButton"),this.q.value=new L.$Qc,this.s=d;const P=d!==void 0?{command:this.z.converter.toInternal(d.command,this.q.value),secondaryCommands:d.secondaryCommands?.map(N=>N.map(O=>this.z.converter.toInternal(O,this.q.value))),description:d.description,enabled:d.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(d){if(this.u&&d&&i(this.u,d))return;this.t.value=new L.$Qc,this.u=d;const P=(d||[]).map(N=>this.z.converter.toInternal(N,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(d,P,N,O,M,j,U){this.y=d,this.z=O,this.A=M,this.B=j,this.C=U,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Sc,this.m=new L.$Sc,this.n=void 0,this.o=new L.$Sc,this.p=void 0,this.q=new L.$Sc,this.t=new L.$Sc,this.u=void 0,this.v=!1,this.w=new T.$Md,this.onDidChangeSelection=this.w.event,this.x=C.d++,this.D=new Map,this.E=new Set,this.#e=N;const F=D.URI.from({scheme:p.Schemas.vscodeSourceControl,path:`${M}/scm${this.x}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new h(d,P,this.#e,this.x,F),this.#e.$registerSourceControl(this.x,M,j,U,F)}createResourceGroup(d,P){const N=new y(this.#e,this.z,this.x,d,P),O=T.Event.once(N.onDidDispose)(()=>this.D.delete(N));return this.D.set(N,O),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const d=[],P=[];for(const[N,O]of this.D){O.dispose();const M=N.onDidUpdateResourceStates(()=>{this.E.add(N),this.eventuallyUpdateResourceStates()});T.Event.once(N.onDidDispose)(()=>{this.E.delete(N),M.dispose(),this.e.delete(N.handle),this.#e.$unregisterGroup(this.x,N.handle)}),d.push([N.handle,N.id,N.label,N.features]);const j=N._takeResourceStateSnapshot();j.length>0&&P.push([N.handle,j]),this.e.set(N.handle,N)}this.#e.$registerGroups(this.x,d,P),this.D.clear()}eventuallyUpdateResourceStates(){const d=[];this.E.forEach(P=>{const N=P._takeResourceStateSnapshot();N.length!==0&&d.push([P.handle,N])}),d.length>0&&this.#e.$spliceResourceStates(this.x,d),this.E.clear()}getResourceGroup(d){return this.e.get(d)}setSelectionState(d){this.v=d,this.w.fire(d)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(d=>d.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,g.$gh)(100)],C.prototype,"eventuallyAddResourceGroups",null),He([(0,g.$gh)(100)],C.prototype,"eventuallyUpdateResourceStates",null);let $=class{static{u=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(d,P,N,O){this.l=P,this.m=N,this.n=O,this.g=new Map,this.h=new I.$1l,this.j=new T.$Md,this.e=d.getProxy(b.$9J.MainThreadSCM),this.f=d.getProxy(b.$9J.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const j=this.g.get(M.sourceControlHandle);if(!j)return M;const U=j.getResourceGroup(M.groupHandle);return U?U.getResourceState(M.handle):M}else if(M&&M.$mid===4){const j=this.g.get(M.sourceControlHandle);return j?j.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const j=this.g.get(M.handle);return j||M}return M}})}createSourceControl(d,P,N,O){this.n.trace("ExtHostSCM#createSourceControl",d.identifier.value,P,N,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const M=u.d++,j=new C(d,this.m,this.e,this.l,P,N,O);this.g.set(M,j);const U=this.h.get(d.identifier)||[];return U.push(j),this.h.set(d.identifier,U),j}getLastInputBox(d){this.n.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const P=this.h.get(d.identifier),N=P&&P[P.length-1];return N&&N.inputBox}$provideOriginalResource(d,P,N){const O=D.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",d,O.toString());const M=this.g.get(d);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Lg)(()=>M.quickDiffProvider.provideOriginalResource(O,N)).then(j=>j||null)}$onInputBoxValueChange(d,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",d);const N=this.g.get(d);return N&&N.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(d,P,N,O){this.n.trace("ExtHostSCM#$executeResourceCommand",d,P,N);const M=this.g.get(d);if(!M)return Promise.resolve(void 0);const j=M.getResourceGroup(P);return j?j.$executeResourceCommand(N,O):Promise.resolve(void 0)}$validateInput(d,P,N){this.n.trace("ExtHostSCM#$validateInput",d);const O=this.g.get(d);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Lg)(()=>O.inputBox.validateInput(P,N)).then(M=>{if(!M)return Promise.resolve(void 0);const j=k.MarkdownString.fromStrict(M.message);return j?Promise.resolve([j,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this.g.get(d)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=d,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(d,P,N){return await this.g.get(d)?.historyProvider?.resolveHistoryItemGroupBase(P,N)??void 0}async $resolveHistoryItemGroupCommonAncestor(d,P,N,O){return await this.g.get(d)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,N,O)??void 0}async $provideHistoryItems(d,P,N,O){return(await this.g.get(d)?.historyProvider?.provideHistoryItems(P,N,O))?.map(U=>({id:U.id,parentIds:U.parentIds,label:U.label,description:U.description,icon:s(U),timestamp:U.timestamp}))??void 0}async $provideHistoryItemChanges(d,P,N){return await this.g.get(d)?.historyProvider?.provideHistoryItemChanges(P,N)??void 0}};e.$ycc=$,e.$ycc=$=u=He([Be(3,A.$8i)],$)}),define(De[114],Ce([1,0,6,4,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=void 0;class L{constructor(b){this.b=new T.$Md,this.onDidChangePassword=this.b.event,this.a=b.getProxy(D.$9J.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,E){return this.a.$getPassword(b,E)}store(b,E,w){return this.a.$setPassword(b,E,w)}delete(b,E){return this.a.$deletePassword(b,E)}}e.$dcc=L,e.$ecc=(0,g.$Nh)("IExtHostSecretState")}),define(De[325],Ce([1,0,6,14,2]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;class L{static{this.a=0}constructor(b,E){this.d=E,this.c=new Map,this.b=b.getProxy(D.$9J.MainThreadShare)}async $provideShare(b,E,w){return await this.c.get(b)?.provideShare({selection:T.Range.to(E.selection),resourceUri:g.URI.revive(E.resourceUri)},w)??void 0}registerShareProvider(b,E){const w=L.a++;return this.c.set(w,E),this.b.$registerShareProvider(w,T.DocumentSelector.from(b,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$Adc=L}),define(De[326],Ce([1,0,7,6,209,3,14,18]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$6K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$6K("statusBarItem.warningForeground")]])}#e;#t;constructor(v,k,S,p,u,r=D.StatusBarAlignment.Left,s){if(this.i=!1,this.k="",this.q=new L.$Qc,this.#e=v,this.#t=k,u&&p){this.c=(0,D.$IK)(p.identifier,u);const a=S.get(this.c);a&&(r=a.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,s=a.priority,this.j=!0,this.name=a.name,this.text=a.text,this.tooltip=a.tooltip,this.command=a.command,this.accessibilityInformation=a.accessibilityInformation)}else this.c=String(E.a++);this.e=p,this.f=u,this.g=r,this.h=this.u(s)}u(v){if((0,b.$Bf)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(v){this.k=v,this.v()}set name(v){this.m=v,this.v()}set tooltip(v){this.l=v,this.v()}set color(v){this.n=v,this.v()}set backgroundColor(v){v&&!E.b.has(v.id)&&(v=void 0),this.o=v,this.v()}set command(v){this.r?.fromApi!==v&&(this.p&&this.q.add(this.p),this.p=new L.$Qc,typeof v=="string"?this.r={fromApi:v,internal:this.#t.toInternal({title:"",command:v},this.p)}:v?this.r={fromApi:v,internal:this.#t.toInternal(v,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(v){this.t=v,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let k;this.m?k=this.m:k=(0,g.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=E.b.get(this.o.id));const p=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,v,this.e?.identifier.value,k,this.k,p,this.r?.internal,S,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$zcc=E;class w{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const k={message:v};return this.b.unshift(k),this.c(),new D.$$J(()=>{const S=this.b.indexOf(k);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(v,k){this.e=new Map,this.a=v.getProxy(T.$9J.MainThreadStatusBar),this.b=k,this.c=new w(this)}$acceptStaticEntries(v){for(const k of v)this.e.set(k.entryId,k)}createStatusBarEntry(v,k,S,p){return new E(this.a,this.b,this.e,v,k,S,p)}setStatusBarMessage(v,k){const S=this.c.setMessage(v);let p;return typeof k=="number"?p=setTimeout(()=>S.dispose(),k):typeof k<"u"&&k.then(()=>S.dispose(),()=>S.dispose()),new D.$$J(()=>{S.dispose(),clearTimeout(p)})}}e.$Acc=A}),define(De[115],Ce([1,0,6,4,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=e.$4bc=void 0;class L{constructor(b,E){this.c=E,this.b=new T.$Md,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(D.$9J.MainThreadStorage)}registerExtensionStorageKeysToSync(b,E){this.a.$registerExtensionStorageKeysToSync(b,E)}async initializeExtensionStorage(b,E,w){const A=await this.a.$initializeExtensionStorage(b,E);let I;return A&&(I=this.d(b,E,A)),I||w}setValue(b,E,w){return this.a.$setValue(b,E,w)}$acceptValue(b,E,w){const A=this.d(b,E,w);A&&this.b.fire({shared:b,key:E,value:A})}d(b,E,w){try{return JSON.parse(w)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${b}): ${A}`)}}}e.$4bc=L,e.$5bc=(0,g.$Nh)("IExtHostStorage")}),define(De[91],Ce([1,0,5,26,13,71,2]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=void 0,e.$0bc=(0,D.$Nh)("IExtensionStoragePaths");let b=class{constructor(w,A,I){this.d=A,this.f=I,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(w){return R.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,A=await this.g(w);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(w){if(this.c)return R.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return R.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$$bc=b,e.$$bc=b=He([Be(0,T.$nM),Be(1,g.$8i),Be(2,L.$9bc)],b)}),define(De[44],Ce([1,0,4,6,5,2,20,3,7,211,8,253,21,31,254,59,11,14,33]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=e.$bcc=e.$acc=e.$_bc=void 0,e.$_bc=(0,g.$Nh)("IExtHostTerminalService");class a{constructor($,f,d,P){this.l=$,this._id=f,this.m=d,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(O=>this.f=O);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(O,M=!0){N.q(),N.l.$sendText(N._id,O,M)},show(O){N.q(),N.l.$show(N._id,O)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create($,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??void 0,env:$.env??void 0,icon:c($.iconPath)??void 0,color:p.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,isFeatureTerminal:f?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:f?.useShellEnvironment??void 0,location:f?.location||this.o($.location,f?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,f,d,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:d,color:p.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o($,f),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o($,f){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in $?{viewColumn:r.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.n=$}setExitStatus($,f){this.h=Object.freeze({code:$,reason:f})}setDimensions($,f){return $===this.d&&f===this.g||$===0||f===0?!1:(this.d=$,this.g=f,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection($){this.k=$}_setProcessId($){this.f?(this.f($),this.f=void 0):this.b.then(f=>{f!==$&&(this.b=Promise.resolve($))})}}e.$acc=a;class m{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new D.$Md,this.onProcessData=this.a.event,this.b=new D.$Md,this.d=new D.$Md,this.onDidChangeProperty=this.d.event,this.f=new D.$Md,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,f){this.g.setDimensions?.({columns:$,rows:f})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:"title",value:f})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,t=class extends b.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,f,d){super(),this.Q=f,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Md,this.onDidCloseTerminal=this.H.event,this.I=new D.$Md,this.onDidOpenTerminal=this.I.event,this.J=new D.$Md,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Md,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Md,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Md,this.onDidChangeShell=this.N.event,this.O=new D.$Md({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Md({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=d.getProxy(T.$9J.MainThreadTerminalService),this.y=new S.$Fkb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:P=>{const N=O=>{const M=O;return this.W(M.instanceId)?.value};switch(P?.$mid){case 15:return N(P);default:{if(Array.isArray(P))for(let O=0;O<P.length&&P[O].$mid===15;O++)P[O]=N(P[O]);return P}}}}),this.B({dispose:()=>{for(const[P,N]of this.g)N.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,f){const d=new a(this.a,(0,k.$dg)(),$,$.name),P=new m($.pty);return d.createExtensionTerminal($.location,this.R($,f).resolvedExtHostIdentifier,c($.iconPath),h($.color)).then(N=>{const O=this.S(N,P);this.h[N]=O}),this.f.push(d),d.value}R($,f){if(f=f||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const d=$.location.parentTerminal;if(d){const P=this.f.find(N=>N.value===d);P&&(f.resolvedExtHostIdentifier=P._id)}}else $.location&&typeof $.location!="object"?f.location=$.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal($,f){if(!this.W($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const P=new m(f),N=this.S($,P);this.h[$]=N}async $acceptActiveTerminalChanged($){const f=this.b;if($===null){this.b=void 0,f!==this.b&&this.J.fire(this.b);return}const d=this.W($);d&&(this.b=d,f!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,f){const d=this.W($);d&&this.O.fire({terminal:d.value,data:f})}async $acceptTerminalDimensions($,f,d){const P=this.W($);P&&P.setDimensions(f,d)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand($,f){const d=this.W($);d&&this.P.fire({terminal:d.value,...f})}async $acceptTerminalMaximumDimensions($,f,d){this.g.get($)?.resize(f,d)}async $acceptTerminalTitleChange($,f){const d=this.W($);d&&(d.name=f)}async $acceptTerminalClosed($,f,d){const P=this.Y(this.f,$);if(P!==null){const N=this.f.splice(P,1)[0];N.setExitStatus(f,d),this.H.fire(N.value)}}$acceptTerminalOpened($,f,d,P){if(f){const M=this.Y(this.f,f);if(M!==null){this.f[M]._id=$,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const N={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:L.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},O=new a(this.a,$,N,d);this.f.push(O),this.I.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId($,f){this.W($)?._setProcessId(f)}async $startExtensionTerminal($,f){const d=this.W($);if(!d)return{message:(0,w.localize)(0,null,$)};d.isOpen||await new Promise(N=>{const O=this.onDidOpenTerminal(async M=>{M===d.value&&(O.dispose(),N())})});const P=this.g.get($);P?P.startSendingEvents(f):this.j[$]={initialDimensions:f}}S($,f){const d=new b.$Qc;d.add(f.onProcessReady(N=>this.a.$sendProcessReady($,N.pid,N.cwd,N.windowsPty))),d.add(f.onDidChangeProperty(N=>this.a.$sendProcessProperty($,N))),this.y.startBuffering($,f.onProcessData),d.add(f.onProcessExit(N=>this.U($,N))),this.g.set($,f);const P=this.j[$];return P&&f instanceof m&&(f.startSendingEvents(P.initialDimensions),delete this.j[$]),d}$acceptProcessAckDataEvent($,f){this.g.get($)?.acknowledgeDataEvent(f)}$acceptProcessInput($,f){this.g.get($)?.input(f)}$acceptTerminalInteraction($){const f=this.W($);f?.setInteractedWith()&&this.M.fire(f.value)}$acceptTerminalSelection($,f){this.W($)?.setSelection(f)}$acceptProcessResize($,f,d){try{this.g.get($)?.resize(f,d)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown($,f){this.g.get($)?.shutdown(f)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(f=>this.a.$sendProcessProperty($,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(f=>this.a.$sendProcessProperty($,{type:"cwd",value:f}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new E.$$J(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,f,d){if(this.C.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.C.set(f,d),this.a.$registerProfileProvider(f,$.identifier.value),new E.$$J(()=>{this.C.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider($,f,d){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,d),this.a.$registerQuickFixProvider($,f),new E.$$J(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,f){const d=new v.$Wd().token;if(d.isCancellationRequested)return;const P=this.D.get($);if(!P)return;const N=await P.provideTerminalQuickFixes(f,d);if(N===null||Array.isArray(N)&&N.length===0)return;const O=new b.$Qc;if(this.w.value=O,!Array.isArray(N))return N?r.TerminalQuickFix.from(N,this.Q.converter,O):void 0;const M=[];for(const j of N){const U=r.TerminalQuickFix.from(j,this.Q.converter,O);U&&M.push(U)}return M}async $createContributedProfileTerminal($,f){const d=new v.$Wd().token;let P=await this.C.get($)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,f);return}this.createTerminalFromOptions(P.options,f)}}async $provideLinks($,f){const d=this.W($);if(!d)return[];this.F.delete($),this.G.get($)?.dispose(!0);const N=new v.$Wd;this.G.set($,N);const O=[],M={terminal:d.value,line:f},j=[];for(const V of this.z)j.push(u.Promises.withAsyncBody(async H=>{N.token.onCancellationRequested(()=>H({provider:V,links:[]}));const fe=await V.provideTerminalLinks(M,N.token)||[];N.token.isCancellationRequested||H({provider:V,links:fe})}));const U=await Promise.all(j);if(N.token.isCancellationRequested)return[];const F=new Map;for(const V of U)V&&V.links.length>0&&O.push(...V.links.map(H=>{const fe={id:l++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return F.set(fe.id,{provider:V.provider,link:H}),fe}));return this.F.set($,F),O}$activateLink($,f){const d=this.F.get($)?.get(f);d&&d.provider.handleTerminalLink(d.link)}U($,f){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const d=this.h[$];d&&(d.dispose(),delete this.h[$]),this.a.$sendProcessExit($,f)}W($){return this.X(this.f,$)}X($,f){const d=this.Y($,f);return d!==null?$[d]:null}Y($,f){const d=$.findIndex(P=>P._id===f);return d===-1?null:d}getEnvironmentVariableCollection($){let f=this.n.get($.identifier.value);return f||(f=new n,this.$($.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}Z($,f){const d=(0,I.$dr)(f.map),P=(0,I.$er)(f.descriptionMap);this.a.$setEnvironmentVariableCollection($,f.persistent,d.length===0?void 0:d,P)}$initEnvironmentVariableCollections($){$.forEach(f=>{const d=f[0],P=new n(f[1]);this.$(d,P)})}$acceptDefaultProfile($,f){const d=this.s;this.s=$,this.u=f,d?.path!==$.path&&this.N.fire($.path)}$($,f){this.n.set($,f),f.onDidChangeCollection(()=>{this.Z($,f)})}};e.$bcc=t,e.$bcc=t=He([Be(1,s.$tM),Be(2,R.$0L)],t);class n{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Md,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const f=this.h($);let d=this.a.get(f);return d||(d=new o(this,$),this.a.set(f,d),d.onDidChangeCollection(()=>this.d.fire())),d}replace($,f,d,P){this.f($,{value:f,type:E.EnvironmentVariableMutatorType.Replace,options:d??{applyAtProcessCreation:!0},scope:P})}append($,f,d,P){this.f($,{value:f,type:E.EnvironmentVariableMutatorType.Append,options:d??{applyAtProcessCreation:!0},scope:P})}prepend($,f,d,P){this.f($,{value:f,type:E.EnvironmentVariableMutatorType.Prepend,options:d??{applyAtProcessCreation:!0},scope:P})}f($,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const d=this.g($,f.scope),P=this.map.get(d),N=f.options?{applyAtProcessCreation:f.options.applyAtProcessCreation??!1,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==f.value||P.type!==f.type||P.options?.applyAtProcessCreation!==N.applyAtProcessCreation||P.options?.applyAtShellIntegration!==N.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const O=this.g($,f.scope),M={variable:$,...f,options:N};this.map.set(O,M),this.d.fire()}}get($,f){const d=this.g($,f),P=this.map.get(d);return P?y(P):void 0}g($,f){const d=this.h(f);return d.length?`${$}:::${d}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const f=new Map;for(const[d,P]of this.map)this.h(P.scope)===this.h($)&&f.set(P.variable,y(P));return f}delete($,f){const d=this.g($,f);this.map.delete(d),this.d.fire()}clear($){if($?.workspaceFolder){for(const[f,d]of this.map)d.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(f);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,f){const d=this.h(f),P=this.descriptionMap.get(d);if(!P||P.description!==$){let N;typeof $=="string"?N=$:N=$?.value.split(`

`)[0];const O={description:N,scope:f};this.descriptionMap.set(d,O),this.d.fire()}}getDescription($){const f=this.h($);return this.descriptionMap.get(f)?.description}k($){const f=this.h($);this.descriptionMap.delete(f)}}class o{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,f){this.b=$,this.d=f,this.a=new D.$Md}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,f,d){this.b.replace($,f,d,this.d)}append($,f,d){this.b.append($,f,d,this.d)}prepend($,f,d){this.b.prepend($,f,d,this.d)}get($){return this.b.get($,this.d)}forEach($,f){this.b.getVariableMap(this.d).forEach((d,P)=>$.call(f,P,d,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let i=class extends t{constructor($,f){super(!1,$,f)}createTerminal($,f,d){throw new A.$$}createTerminalFromOptions($,f){throw new A.$$}};e.$ccc=i,e.$ccc=i=He([Be(0,s.$tM),Be(1,R.$0L)],i);function c(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function h(C){return p.ThemeColor.isThemeColor(C)?C:void 0}function y(C){const $={...C};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(De[327],Ce([1,0,118,11,22,21,4,74,52,3,23,18,31,6,20,145,14,7,67,109,88,27]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=e.$ldc=e.$kdc=e.$jdc=void 0;let t=class{constructor(M,j,U){this.k=U,this.d=new R.$Md,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=M.getProxy(k.$9J.MainThreadTesting),this.j=new d(this.g),this.h=new c(this.g),j.registerArgumentProcessor({processArgument:F=>{switch(F?.$mid){case 16:{const V=F,H=V.tests[V.tests.length-1].item.extId;return this.f.get(s.$2I.root(H))?.collection.tree.get(H)?.actual??(0,p.$jM)(F)}case 18:{const{extId:V,message:H}=F;return{test:this.f.get(s.$2I.root(V))?.collection.tree.get(V)?.actual,message:u.TestMessage.to(H)}}default:return F}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const F=await j.executeCommand("_testing.getExplorerSelection"),V=H=>{const fe=this.f.get(s.$2I.root(H));if(fe)return s.$2I.isRoot(H)?fe.controller:fe.collection.tree.get(H)?.actual};return{include:F?.include.map(V).filter(I.$Ff)||[],exclude:F?.exclude.map(V).filter(I.$Ff)||[]}})}createTestController(M,j,U,F){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const V=new w.$Qc,H=V.add(new p.$mM(j,U,this.k));H.root.label=U;const fe=new Map,X=this.g,Y={items:H.root.children,get label(){return U},set label(x){U=x,H.root.label=x,X.$updateController(j,{label:U})},get refreshHandler(){return F},set refreshHandler(x){F=x,X.$updateController(j,{canRefresh:!!x})},get id(){return j},createRunProfile:(x,me,ue,pe,G,z)=>{let K=(0,E.$Bi)(x);for(;fe.has(K);)K++;return new P(this.g,fe,j,K,x,me,ue,pe,G,z)},createTestItem(x,me,ue){return new p.$kM(j,x,me,ue)},createTestRun:(x,me,ue=!0)=>this.h.createTestRun(M,j,H,x,me,ue),invalidateTestResults:x=>{if(x===void 0)this.g.$markTestRetired(void 0);else{const me=x instanceof Array?x:[x];this.g.$markTestRetired(me.map(ue=>s.$2I.fromExtHostTestItem(ue,j).toString()))}},set resolveHandler(x){H.resolveHandler=x},get resolveHandler(){return H.resolveHandler},dispose:()=>{V.dispose()}};X.$registerTestController(j,U,!!F),V.add((0,w.$Pc)(()=>X.$unregisterTestController(j)));const q={controller:Y,collection:H,profiles:fe,extension:M};return this.f.set(j,q),V.add((0,w.$Pc)(()=>this.f.delete(j))),V.add(H.onDidGenerateDiff(x=>X.$publishDiff(j,x.map(m.TestsDiffOp.serialize)))),Y}createTestObserver(){return this.j.checkout()}async runTests(M,j=L.CancellationToken.None){const U=h(M);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.f.get(U.controllerId);if(!F)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(V=>s.$2I.fromExtHostTestItem(V,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:N[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:M.exclude?.map(V=>V.id)},j)}$syncTests(){for(const{collection:M}of this.f.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,j,U){return(0,D.$qb)(this.h.trackers,V=>V.id===M?V.getCoverage(j):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(M,j,U,F){return(0,D.$qb)(this.h.trackers,H=>H.id===M?H.getCoverage(j):void 0)?.resolveFileCoverage(U,F)??Promise.resolve([])}$configureRunProfile(M,j){this.f.get(M)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(M,j){await this.f.get(M)?.controller.refreshHandler?.(j)}$publishTestResults(M){this.results=Object.freeze(M.map(j=>(0,A.$Zm)(u.TestResults.to(j))).concat(this.results).sort((j,U)=>U.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(M,j){const U=this.f.get(s.$2I.fromString(M).controllerId)?.collection;U&&(await U.expand(M,j<0?1/0:j),U.flushDiff())}$acceptDiff(M){this.j.applyDiff(M.map(m.TestsDiffOp.deserialize))}async $runControllerTests(M,j){return Promise.all(M.map(U=>this.l(U,!1,j)))}async $startContinuousRun(M,j){const U=new L.$Wd(j),F=await Promise.all(M.map(V=>this.l(V,!0,U.token)));return!j.isCancellationRequested&&!F.some(V=>V.error)&&await new Promise(V=>j.onCancellationRequested(V)),U.dispose(!0),F}async l(M,j,U){const F=this.f.get(M.controllerId);if(!F)return{};const{collection:V,profiles:H,extension:fe}=F,X=H.get(M.profileId);if(!X)return{};const Y=M.testIds.map(ue=>V.tree.get(ue)).filter(I.$Ff),q=M.excludeExtIds.map(ue=>F.collection.tree.get(ue)).filter(I.$Ff).filter(ue=>Y.some(pe=>pe.fullId.compare(ue.fullId)===2));if(!Y.length)return{};const x=new r.$GL(Y.some(ue=>ue.actual instanceof p.$lM)?void 0:Y.map(ue=>ue.actual),q.map(ue=>ue.actual),X,j),me=(0,m.$4I)(M)&&this.h.prepareForMainThreadTestRun(x,y.fromInternal(M,F.collection),fe,U);try{return await X.runHandler(x,U),{}}catch(ue){return{error:String(ue)}}finally{me&&(me.hasRunningTasks&&!U.isCancellationRequested&&await R.Event.toPromise(me.onEnd),me.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.h.cancelAllRuns():this.h.cancelRunById(M)}};e.$jdc=t,e.$jdc=t=He([Be(0,S.$0L)],t);const n=1e4;var o;(function(O){O[O.Running=0]="Running",O[O.Cancelling=1]="Cancelling",O[O.Ended=2]="Ended"})(o||(o={}));class i extends w.$Rc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(M,j,U,F){super(),this.s=M,this.u=j,this.w=U,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$Md),this.onEnd=this.m.event,this.j=this.B(new L.$Wd(F));const V=this.B(new T.$5g(()=>this.y(),n));this.B(this.j.token.onCancellationRequested(()=>V.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(M){return this.g.get(M)?.coverage}createRun(M){const j=this.s.id,U=this.s.controllerId,F=(0,v.$dg)(),V=new C(this.u,j,F),H=q=>(x,...me)=>{if(X){console.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}this.s.isIncluded(x)&&(this.C(x),q(x,...me))},fe=(q,x)=>{const me=x instanceof Array?x.map(u.TestMessage.from):[u.TestMessage.from(x)];if(me.some(ue=>ue.contextValue!==void 0)&&(0,l.$9E)(this.w,"testMessageContextValue"),q.uri&&q.range){const ue={range:u.Range.from(q.range),uri:q.uri};for(const pe of me)pe.location=pe.location||ue}this.u.$appendTestMessagesInRun(j,F,s.$2I.fromExtHostTestItem(q,U).toString(),me)};let X=!1;const Y={isPersisted:this.s.isPersisted,token:this.j.token,name:M,get coverageProvider(){return V.coverageProvider},set coverageProvider(q){V.coverageProvider=q},enqueued:H(q=>{this.u.$updateTestStateInRun(j,F,s.$2I.fromExtHostTestItem(q,U).toString(),1)}),skipped:H(q=>{this.u.$updateTestStateInRun(j,F,s.$2I.fromExtHostTestItem(q,U).toString(),5)}),started:H(q=>{this.u.$updateTestStateInRun(j,F,s.$2I.fromExtHostTestItem(q,U).toString(),2)}),errored:H((q,x,me)=>{fe(q,x),this.u.$updateTestStateInRun(j,F,s.$2I.fromExtHostTestItem(q,U).toString(),6,me)}),failed:H((q,x,me)=>{fe(q,x),this.u.$updateTestStateInRun(j,F,s.$2I.fromExtHostTestItem(q,U).toString(),4,me)}),passed:H((q,x)=>{this.u.$updateTestStateInRun(j,F,s.$2I.fromExtHostTestItem(q,this.s.controllerId).toString(),3,x)}),appendOutput:(q,x,me)=>{X||(me&&(this.s.isIncluded(me)?this.C(me):me=void 0),this.u.$appendOutputToRun(j,F,g.$ae.fromString(q),x&&u.location.from(x),me&&s.$2I.fromExtHostTestItem(me,U).toString()))},end:()=>{X||(X=!0,this.u.$finishedTestRunTask(j,F),this.g.delete(F),this.g.size||this.z())}};return this.g.set(F,{run:Y,coverage:V}),this.u.$startedTestRunTask(j,{id:F,name:M,running:!0}),Y}y(){for(const{run:M}of this.g.values())M.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(M){if(!(M instanceof p.$kM))throw new a.$2L(M.id);if(this.h.has(s.$2I.fromExtHostTestItem(M,this.s.controllerId).toString()))return;const j=[],U=this.s.colllection.root;for(;;){const F=u.TestItem.from(M);if(j.unshift(F),this.h.has(F.extId)||(this.h.add(F.extId),M===U))break;M=M.parent||U}this.u.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.z(),super.dispose()}}class c{get trackers(){return this.d.values()}constructor(M){this.f=M,this.d=new Map}prepareForMainThreadTestRun(M,j,U,F){return this.g(M,j,U,F)}cancelRunById(M){for(const j of this.d.values())if(j.id===M){j.cancel();return}}cancelAllRuns(){for(const M of this.d.values())M.cancel()}createTestRun(M,j,U,F,V,H){const fe=this.d.get(F);if(fe)return fe.createRun(V);const X=y.fromPublic(j,U,F,H),Y=h(F);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!F.continuous,profile:Y&&{group:N[Y.kind],id:Y.profileId},exclude:F.exclude?.map(x=>s.$2I.fromExtHostTestItem(x,U.root.id).toString())??[],id:X.id,include:F.include?.map(x=>s.$2I.fromExtHostTestItem(x,U.root.id).toString())??[U.root.id],persist:H});const q=this.g(F,X,M);return R.Event.once(q.onEnd)(()=>{this.f.$finishedExtensionTestRun(X.id),q.dispose()}),q.createRun(V)}g(M,j,U,F){const V=new i(j,this.f,U,F);return this.d.set(M,V),R.Event.once(V.onEnd)(()=>this.d.delete(M)),V}}e.$kdc=c;const h=O=>{if(O.profile){if(!(O.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class y{static fromPublic(M,j,U,F){return new y(M,(0,v.$dg)(),U.include?.map(V=>s.$2I.fromExtHostTestItem(V,M).toString())??[M],U.exclude?.map(V=>s.$2I.fromExtHostTestItem(V,M).toString())??[],F,j)}static fromInternal(M,j){return new y(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,j)}constructor(M,j,U,F,V,H){this.controllerId=M,this.id=j,this.isPersisted=V,this.colllection=H,this.d=U.map(fe=>fe+"\0"),this.f=F.map(fe=>fe+"\0")}isIncluded(M){const j=s.$2I.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const U of this.f)if(j===U||j.startsWith(U))return!1;for(const U of this.d)if(j===U||j.startsWith(U))return!0;return!1}}e.$ldc=y;class C{set coverageProvider(M){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.d=M,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(M,j,U){this.g=M,this.h=j,this.j=U}async provideFileCoverage(M){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(M))());try{return(await this.f)?.map(u.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(M,j){const U=await this.f;let F=U?.[M];return!this.d||!U||!F?[]:(F.detailedCoverage||(F=U[M]=await this.d.resolveFileCoverage?.(F,j)??F),F.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class ${get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(M){this.j=M,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(M){this.d.add(M)}update(M){Object.assign(M.revived,u.TestItem.toPlain(M.item)),this.d.has(M)||this.f.add(M)}remove(M){if(this.d.has(M)){this.d.delete(M);return}this.f.delete(M);const j=s.$2I.parentId(M.item.extId);if(j&&this.h.has(j.toString())){this.h.add(M.item.extId);return}this.g.add(M)}getChangeEvent(){const{d:M,f:j,g:U}=this;return{get added(){return[...M].map(F=>F.revived)},get updated(){return[...j].map(F=>F.revived)},get removed(){return[...U].map(F=>F.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class f extends m.$9I{constructor(){super(...arguments),this.s=new R.$Md,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(M){return this.f.get(M)}getMirroredTestDataByReference(M){return this.f.get(M.id)}q(M,j){return{...M,revived:u.TestItem.toPlain(M.item),depth:j?j.depth+1:0,children:new Set}}p(){return new $(this.s)}}class d{constructor(M){this.f=M}checkout(){this.d||(this.d=this.g());const M=this.d;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(j=>j.revived)},dispose:(0,b.$cb)(()=>{--M.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(M){return this.d?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.d?.tests.apply(M)}g(){const M=new f;return this.f.$subscribeToDiffs(),{observers:0,tests:M}}}class P{#e;#t;get label(){return this.f}set label(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(M){M!==this.h&&(this.h=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.g}set isDefault(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?u.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.d}set configureHandler(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,j,U,F,V,H,fe,X=!1,Y=void 0,q=!1){this.controllerId=U,this.profileId=F,this.f=V,this.kind=H,this.runHandler=fe,this.g=X,this._tag=Y,this.h=q,this.#e=M,this.#t=j,j.set(F,this);const x=N[H];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${H}`);this.#e.$publishTestRunProfile({profileId:F,controllerId:U,tag:Y?u.TestTag.namespace(this.controllerId,Y.id):null,label:V,group:x,isDefault:X,hasConfigurationHandler:!1,supportsContinuousRun:q})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$mdc=P;const N={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(De[328],Ce([1,0,19,8,4,6,146,14,7]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class w{constructor(I,v){this.i=v,this.a=new g.$Md({onListenerError:T.$1}),this.b=new g.$Md({onListenerError:T.$1}),this.c=new g.$Md({onListenerError:T.$1}),this.d=new g.$Md({onListenerError:T.$1}),this.f=new g.$Md({onListenerError:T.$1}),this.g=new g.$Md({onListenerError:T.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(L.$9J.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(k=>this.g.fire(k)),this.i.onDidChangeActiveTextEditor(k=>this.f.fire(k))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const v=this.i.allEditors();return I?v:v.map(k=>k.value)}async showTextDocument(I,v,k){let S;typeof v=="number"?S={position:b.ViewColumn.from(v),preserveFocus:k}:typeof v=="object"?S={position:b.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selection:typeof v.selection=="object"?b.Range.from(v.selection):void 0,pinned:typeof v.preview=="boolean"?!v.preview:void 0}:S={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(I.uri,S),u=p&&this.i.getEditor(p);if(u)return u.value;throw p?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,v){return new R.$eM(this.h,I,v).value}$acceptEditorPropertiesChanged(I,v){const k=this.i.getEditor(I);if(!k)throw new Error("unknown text editor");if(v.options&&k._acceptOptions(v.options),v.selections){const S=v.selections.selections.map(b.Selection.to);k._acceptSelections(S)}if(v.visibleRanges){const S=D.$Gb(v.visibleRanges.map(b.Range.to));k._acceptVisibleRanges(S)}if(v.options&&this.b.fire({textEditor:k.value,options:{...v.options,lineNumbers:b.TextEditorLineNumbersStyle.to(v.options.lineNumbers)}}),v.selections){const S=E.TextEditorSelectionChangeKind.fromValue(v.selections.source),p=v.selections.selections.map(b.Selection.to);this.a.fire({textEditor:k.value,selections:p,kind:S})}if(v.visibleRanges){const S=D.$Gb(v.visibleRanges.map(b.Range.to));this.c.fire({textEditor:k.value,visibleRanges:S})}}$acceptEditorPositionData(I){for(const v in I){const k=this.i.getEditor(v);if(!k)throw new Error("Unknown text editor");const S=b.ViewColumn.to(I[v]);k.value.viewColumn!==S&&(k._acceptViewColumn(S),this.d.fire({textEditor:k.value,viewColumn:S}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$Bcc=w}),define(De[329],Ce([1,0,2,5,6,3,7,14,25,18]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=e.$ddc=void 0,e.$ddc=(0,T.$Nh)("IExtHostTimeline");class A{constructor(k,S){this.b=new Map,this.c=new Map,this.a=k.getProxy(g.$9J.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(p,u)=>{if(p&&p.$mid===12)if(this.b.get(p.source)&&E.$Yl.equals(u,this.b.get(p.source)?.extension)){const r=p.uri===void 0?void 0:D.URI.revive(p.uri);return this.c.get(p.source)?.get(I(r))?.get(p.handle)}else return;return p}})}async $getTimeline(k,S,p,u){return this.b.get(k)?.provider.provideTimeline(D.URI.revive(S),p,u)}registerTimelineProvider(k,S,p,u){const r=new L.$Qc,s=this.d(S.id,u,r).bind(this);let a;S.onDidChange&&(a=S.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:S.id}),this));const m=this.c;return this.f({...S,scheme:k,onDidChange:void 0,async provideTimeline(l,t,n){t?.resetCache&&(r.clear(),m.get(S.id)?.clear());const o=await S.provideTimeline(l,t,n);if(o==null)return;const i=s(l,t);return{...o,source:S.id,items:o.items.map(i)}},dispose(){for(const l of m.values())l.get(S.id)?.clear();a?.dispose(),r.dispose()}},p)}d(k,S,p){return(u,r)=>{let s;if(r?.cacheResults){let a=this.c.get(k);a===void 0&&(a=new Map,this.c.set(k,a));const m=I(u);s=a.get(m),s===void 0&&(s=new Map,a.set(m,s))}return a=>{const{iconPath:m,...l}=a,t=`${k}|${a.id??a.timestamp}`;s?.set(t,a);let n,o,i;a.iconPath&&(m instanceof R.$5K?i={id:m.id,color:m.color}:D.URI.isUri(m)?(n=m,o=m):{light:n,dark:o}=m);let c;return R.$yK.isMarkdownString(l.tooltip)?c=b.MarkdownString.from(l.tooltip):(0,w.$xf)(l.tooltip)?c=l.tooltip:R.$yK.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=b.MarkdownString.from(l.detail)):(0,w.$xf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=l.detail),{...l,id:l.id??void 0,handle:t,source:k,command:a.command?S.toInternal(a.command,p):void 0,icon:n,iconDark:o,themeIcon:i,tooltip:c,accessibilityInformation:a.accessibilityInformation}}}}f(k,S){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:S}),(0,L.$Pc)(()=>{for(const u of this.c.values())u.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.$edc=A;function I(v){return v?.toString()}}),define(De[72],Ce([1,0,21,4,3,213,5,13,86,6,26,20,7]),function($e,e,D,T,g,L,R,b,E,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Svb=e.$Rvb=e.TunnelDtoConverter=void 0;class k extends E.$_u{}var S;(function(u){function r(a){return{remoteAddress:a.remoteAddress,localAddress:a.localAddress,public:!!a.public,privacy:a.privacy??(a.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:a.protocol}}u.fromApiTunnel=r;function s(a){return{remoteAddress:{host:a.tunnelRemoteHost,port:a.tunnelRemotePort},localAddress:a.localAddress,public:a.privacy!==E.TunnelPrivacyId.ConstantPrivate&&a.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:a.privacy,protocol:a.protocol}}u.fromServiceTunnel=s})(S||(e.TunnelDtoConverter=S={})),e.$Rvb=(0,R.$Nh)("IExtHostTunnelService");let p=class extends g.$Rc{constructor(r,s,a){super(),this.s=a,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Md,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(w.$9J.MainThreadTunnelService)}async openTunnel(r,s){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${s.remoteAddress.host}:${s.remoteAddress.port}.`);const a=await this.a.$openTunnel(s,r.displayName);if(a){const m=new k(a.remoteAddress,a.localAddress,()=>this.a.$closeTunnel(a.remoteAddress));return this.B(m),m}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,s){const a=this.u();return this.r.set(a,{selector:r,provider:s}),this.a.$registerPortsAttributesProvider(r,a),new v.$$J(()=>{this.r.delete(a),this.a.$unregisterPortsAttributesProvider(a)})}async $providePortAttributes(r,s,a,m,l){const t=[];for(const o of r){const i=this.r.get(o);if(!i)return[];t.push(...await Promise.all(s.map(async c=>{let h;try{h=await i.provider.providePortAttributes({port:c,pid:a,commandLine:m},l)}catch{h=await i.provider.providePortAttributes(c,a,m,l)}return{providedAttributes:h,port:c}})))}const n=t.filter(o=>!!o.providedAttributes);return n.length>0?n.map(o=>({autoForwardAction:o.providedAttributes.autoForwardAction,port:o.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,s){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(m,l)=>await r.provideTunnel(m,l,new D.$Wd().token)??void 0;const a=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,privacyOptions:s.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(a),Promise.resolve((0,g.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,s){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const a=r.tunnelFactory??(s?this.w(s):void 0);if(a){this.b=a;let m=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const l=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:m}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,g.$Pc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,s){if(this.g.has(r.host)){const a=this.g.get(r.host);a.has(r.port)&&(s&&a.get(r.port).disposeListener.dispose(),await a.get(r.port).tunnel.dispose(),a.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,s){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const a=this.b(r,s);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),a!==void 0){const m=await a;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),m===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const l=this.B(m.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(m.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:m,disposeListener:l}),S.fromApiTunnel(m)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(a){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),a instanceof Error)return a.message}}async $applyCandidateFilter(r){const s=await Promise.all(r.map(m=>this.f(m.host,m.port,m.detail??""))),a=r.filter((m,l)=>s[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(m=>m.port).join(", ")} to ${a.map(m=>m.port).join(", ")}`),a}};e.$Svb=p,e.$Svb=p=He([Be(0,I.$0L),Be(1,A.$nM),Be(2,b.$8i)],p)}),define(De[330],Ce([1,0,3,17,2,6]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;class R{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(L.$9J.MainThreadUriOpeners)}registerExternalUriOpener(E,w,A,I){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const v=I.schemes.find(k=>!R.a.has(k));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(w,A),this.b.$registerUriOpener(w,I.schemes,E,I.label),(0,D.$Pc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(E,w,A){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const v=g.URI.revive(w);return I.canOpenExternalUri(v,A)}async $openUri(E,w,A){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(g.URI.revive(w.resolvedUri),{sourceUri:g.URI.revive(w.sourceUri)},A)}}e.$ndc=R}),define(De[331],Ce([1,0,6,2,3,8,25]),function($e,e,D,T,g,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;class b{static{this.a=0}constructor(w){this.c=new R.$Zl,this.d=new Map,this.b=w.getProxy(D.$9J.MainThreadUrls)}registerUriHandler(w,A){const I=w.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const v=b.a++;return this.c.add(I),this.d.set(v,A),this.b.$registerUriHandler(v,I,w.displayName||w.name),(0,g.$Pc)(()=>{this.c.delete(I),this.d.delete(v),this.b.$unregisterUriHandler(v)})}$handleExternalUri(w,A){const I=this.d.get(w);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(A))}catch(v){(0,L.$Z)(v)}return Promise.resolve(void 0)}async createAppUri(w){return T.URI.revive(await this.b.$createAppUri(w))}}e.$Dcc=b}),define(De[92],Ce([1,0,4,3,17,23,2,228,265,110,6]),function($e,e,D,T,g,L,R,b,E,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=e.$Hcc=e.$Gcc=e.$Fcc=e.$Ecc=void 0;class I{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(m,l,t,n,o,i,c){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new D.$Md,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Md,this._onDidDispose=this.#h.event,this.#e=m,this.#t=l,this.#r=t,this.#l=n,this.#u=o,this.#n=i,this.#c=v(i),this.#d=k(i),this.#i=c}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return this.#a=!0,(0,w.$Vob)(m,this.#l)}get cspSource(){const m=this.#n.extensionLocation;if(m.scheme===g.Schemas.https||m.scheme===g.Schemas.http){let l=m.toString();return l.endsWith("/")||(l+="/"),l+" "+w.$Uob}return w.$Uob}get html(){return this.a(),this.#s}set html(m){this.a(),this.#s!==m&&(this.#s=m,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(m)))}get options(){return this.a(),this.#r}set options(m){this.a(),L.$3m(this.#r,m)||this.#t.$setOptions(this.#e,u(this.#n,this.#u,m)),this.#r=m}async postMessage(m){if(this.#o)return!1;const l=(0,E.$mcb)(m,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(m){if(!this.#d)return m;const l=this.#n.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return m.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,o,i,c,h,y)=>{const C=R.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),$=(0,w.$Vob)(C,{isRemote:l,authority:t}).toString();return`${o}${$}${y}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,o,i,c,h,y)=>{const C=R.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),$=(0,w.$Vob)(C,{isRemote:l,authority:t}).toString();return`${o}${$}${y}`})}}e.$Ecc=I;function v(a){try{const m=(0,b.$Go)((0,b.$Fo)(a.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.$Fcc=v;function k(a){try{const m=(0,b.$Go)((0,b.$Fo)(a.engines.vscode));return m?m.majorBase<1||m.majorBase===1&&m.minorBase<60:!1}catch{return!1}}class S extends T.$Rc{constructor(m,l,t,n,o){super(),this.c=l,this.f=t,this.g=n,this.h=o,this.b=new Map,this.a=m.getProxy(A.$9J.MainThreadWebviews)}dispose(){super.dispose();for(const m of this.b.values())m.dispose();this.b.clear()}$onMessage(m,l,t){const n=this.j(m);if(n){const{message:o}=(0,E.$ncb)(l,t.value);n._onMessageEmitter.fire(o)}}$onMissingCsp(m,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,l,t){const n=new I(m,this.a,r(l),this.c,this.f,t,this.h);this.b.set(m,n);const o=n._onDidDispose(()=>{o.dispose(),this.deleteWebview(m)});return n}deleteWebview(m){this.b.delete(m)}j(m){return this.b.get(m)}}e.$Gcc=S;function p(a){return{id:a.identifier,location:a.extensionLocation}}e.$Hcc=p;function u(a,m,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||s(a,m)}}e.$Icc=u;function r(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(m=>R.URI.from(m))}}function s(a,m){return[...(m?.getWorkspaceFolders()||[]).map(l=>l.uri),a.extensionLocation]}}),define(De[332],Ce([1,0,21,52,3,17,24,2,14,92,87,6,7]),function($e,e,D,T,g,L,R,b,E,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;class k{constructor(n,o){this.document=n,this.b=o,this.a=1,this.c=new A.$Abc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,o){await this.f(n).undo(),o||this.disposeBackup()}async redo(n,o){await this.f(n).redo(),o||this.disposeBackup()}disposeEdits(n){for(const o of n)this.c.delete(o)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=l(this.document.uri)+this.a++;return(0,R.$ug)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const o=this.c.get(n,0);if(!o)throw new Error("No edit found");return o}}class S{constructor(){this.a=new Map}get(n,o){return this.a.get(this.b(n,o))}add(n,o,i){const c=this.b(n,o.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${n} resource:${o.uri}`);const h=new k(o,i);return this.a.set(c,h),h}delete(n,o){const i=this.b(n,o.uri);this.a.delete(i)}b(n,o){return`${n}@@@${o}`}}var p;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(p||(p={}));class u{constructor(){this.a=new Map}addTextProvider(n,o,i){return this.b(0,n,o,i)}addCustomProvider(n,o,i){return this.b(1,n,o,i)}get(n){return this.a.get(n)}b(n,o,i,c){if(this.a.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this.a.set(o,{type:n,extension:i,provider:c}),new v.$$J(()=>this.a.delete(o))}}class r{constructor(n,o,i,c,h){this.d=o,this.f=i,this.g=c,this.h=h,this.b=new u,this.c=new S,this.a=n.getProxy(I.$9J.MainThreadCustomEditors)}registerCustomEditorProvider(n,o,i,c){const h=new g.$Qc;return a(i)?(h.add(this.b.addTextProvider(o,n,i)),this.a.$registerTextEditorProvider((0,w.$Hcc)(n),o,c.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,w.$Fcc)(n))):(h.add(this.b.addCustomProvider(o,n,i)),s(i)&&h.add(i.onDidChangeCustomDocument(y=>{const C=this.i(o,y.document.uri);if(m(y)){const $=C.addEdit(y);this.a.$onDidEdit(y.document.uri,o,$,y.label)}else this.a.$onContentChange(y.document.uri,o)})),this.a.$registerCustomEditorProvider((0,w.$Hcc)(n),o,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,w.$Fcc)(n))),v.$$J.from(h,new v.$$J(()=>{this.a.$unregisterEditorProvider(o)}))}async $createCustomDocument(n,o,i,c,h){const y=this.b.get(o);if(!y)throw new Error(`No provider found for '${o}'`);if(y.type!==1)throw new Error(`Invalid provide type for '${o}'`);const C=b.URI.revive(n),$=await y.provider.openCustomDocument(C,{backupId:i,untitledDocumentData:c?.buffer},h);let f;return s(y.provider)&&this.f&&(f=this.f.workspaceValue(y.extension)??this.f.globalValue(y.extension)),this.c.add(o,$,f),{editable:s(y.provider)}}async $disposeCustomDocument(n,o){const i=this.b.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${o}'`);const c=b.URI.revive(n),{document:h}=this.i(o,c);this.c.delete(o,h),h.dispose()}async $resolveCustomEditor(n,o,i,c,h,y){const C=this.b.get(i);if(!C)throw new Error(`No provider found for '${i}'`);const $=E.ViewColumn.to(h),f=this.g.createNewWebview(o,c.contentOptions,C.extension),d=this.h.createNewWebviewPanel(o,i,c.title,$,c.options,f,c.active),P=b.URI.revive(n);switch(C.type){case 1:{const{document:N}=this.i(i,P);return C.provider.resolveCustomEditor(N,d,y)}case 0:{const N=this.d.getDocument(P);return C.provider.resolveCustomTextEditor(N,d,y)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,o,i){this.i(o,n).disposeEdits(i)}async $onMoveCustomEditor(n,o,i){const c=this.b.get(i);if(!c)throw new Error(`No provider found for '${i}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const h=this.h.getWebviewPanel(n);if(!h)throw new Error("No webview found");const y=b.URI.revive(o),C=this.d.getDocument(y);await c.provider.moveCustomTextEditor(C,h,D.CancellationToken.None)}async $undo(n,o,i,c){return this.i(o,n).undo(i,c)}async $redo(n,o,i,c){return this.i(o,n).redo(i,c)}async $revert(n,o,i){const c=this.i(o,n);await this.j(o).revertCustomDocument(c.document,i),c.disposeBackup()}async $onSave(n,o,i){const c=this.i(o,n);await this.j(o).saveCustomDocument(c.document,i),c.disposeBackup()}async $onSaveAs(n,o,i,c){const h=this.i(o,n);return this.j(o).saveCustomDocumentAs(h.document,b.URI.revive(i),c)}async $backup(n,o,i){const c=this.i(o,n),y=await this.j(o).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},i);return c.updateBackup(y),y.id}i(n,o){const i=this.c.get(n,b.URI.revive(o));if(!i)throw new Error("No custom document found");return i}j(n){const i=this.b.get(n)?.provider;if(!i||!s(i))throw new Error("Custom document is not editable");return i}}e.$hdc=r;function s(t){return!!t.onDidChangeCustomDocument}function a(t){return typeof t.resolveCustomTextEditor=="function"}function m(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function l(t){const n=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,T.$Bi)(n)+""}}),define(De[333],Ce([1,0,4,3,2,31,14,92,6,7]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;class A extends T.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(S,p,u,r){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new D.$Md),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Md),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=p,this.#l=u,this.#i=r.viewType,this.#u=r.panelOptions,this.#r=r.viewColumn,this.#n=r.title,this.#a=r.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(S){this.c(),this.#n!==S&&(this.#n=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#s}set iconPath(S){this.c(),this.#s!==S&&(this.#s=S,this.#t.$setIconPath(this.#e,g.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(S){this.#c||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#a=S.active,this.#o=S.visible,this.#r=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,p){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:R.ViewColumn.from(S),preserveFocus:!!p})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I extends T.$Rc{static c(){return(0,L.$dg)()}constructor(S,p,u){super(),this.j=p,this.m=u,this.g=new Map,this.h=new Map,this.f=S.getProxy(E.$9J.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,p,u,r,s={}){const a=typeof r=="object"?r.viewColumn:r,m={viewColumn:R.ViewColumn.from(a),preserveFocus:typeof r=="object"&&!!r.preserveFocus},l=(0,b.$Fcc)(S),t=I.c();this.f.$createWebviewPanel((0,b.$Hcc)(S),t,p,{title:u,panelOptions:v(s),webviewOptions:(0,b.$Icc)(S,this.m,s),serializeBuffersForPostMessage:l},m);const n=this.j.createNewWebview(t,s,S);return this.createNewWebviewPanel(t,p,u,a,s,n,!0)}$onDidChangeWebviewPanelViewStates(S){const p=Object.keys(S);p.sort((u,r)=>{const s=S[u],a=S[r];return s.active?1:a.active?-1:+s.visible-+a.visible});for(const u of p){const r=this.getWebviewPanel(u);if(!r)continue;const s=S[u];r._updateViewState({active:s.active,visible:s.visible,viewColumn:R.ViewColumn.to(s.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,p,u){if(this.h.has(p))throw new Error(`Serializer for '${p}' already registered`);return this.h.set(p,{serializer:u,extension:S}),this.f.$registerSerializer(p,{serializeBuffersForPostMessage:(0,b.$Fcc)(S)}),new w.$$J(()=>{this.h.delete(p),this.f.$unregisterSerializer(p)})}async $deserializeWebviewPanel(S,p,u,r){const s=this.h.get(p);if(!s)throw new Error(`No serializer found for '${p}'`);const{serializer:a,extension:m}=s,l=this.j.createNewWebview(S,u.webviewOptions,m),t=this.createNewWebviewPanel(S,p,u.title,r,u.panelOptions,l,u.active);await a.deserializeWebviewPanel(t,u.state)}createNewWebviewPanel(S,p,u,r,s,a,m){const l=new A(S,this.f,a,{viewType:p,title:u,viewColumn:r,panelOptions:s,active:m});return this.g.set(S,l),l}getWebviewPanel(S){return this.g.get(S)}}e.$gdc=I;function v(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(De[334],Ce([1,0,4,3,92,14,6,7]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=void 0;class E extends T.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,v,k,S,p,u){super(),this.#u=!1,this.#a=this.B(new D.$Md),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new D.$Md),this.onDidDispose=this.#c.event,this.#i=k,this.#s=S,this.#e=I,this.#t=v,this.#l=p,this.#n=u}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class w{constructor(I,v){this.d=v,this.b=new Map,this.c=new Map,this.a=I.getProxy(R.$9J.MainThreadWebviewViews)}registerWebviewViewProvider(I,v,k,S){if(this.b.has(v))throw new Error(`View provider for '${v}' already registered`);return this.b.set(v,{provider:k,extension:I}),this.a.$registerWebviewViewProvider((0,g.$Hcc)(I),v,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$Fcc)(I)}),new b.$$J(()=>{this.b.delete(v),this.a.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(I,v,k,S,p){const u=this.b.get(v);if(!u)throw new Error(`No view provider found for '${v}'`);const{provider:r,extension:s}=u,a=this.d.createNewWebview(I,{},s),m=new E(I,this.a,v,k,a,!0);this.c.set(I,m),await r.resolveWebviewView(m,{state:S},p)}async $onDidChangeWebviewViewVisibility(I,v){this.e(I)._setVisible(v)}async $disposeWebviewView(I){const v=this.e(I);this.c.delete(I),v.dispose(),this.d.deleteWebview(I)}e(I){const v=this.c.get(I);if(!v)throw new Error("No webview found");return v}}e.$fdc=w}),define(De[151],Ce([1,0,4,6,2,17,15,5,20,27]),function($e,e,D,T,g,L,R,b,E,w){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=void 0;let I=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(k){const S=this.d;return{get focused(){return S.focused},get active(){return(0,w.$9E)(k,"windowActivity"),S.active}}}constructor(k){this.c=new D.$Md,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=k.getProxy(T.$9J.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:p})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(k){this.onDidChangeWindowProperty("focused",k)}$onDidChangeWindowActive(k){this.onDidChangeWindowProperty("active",k)}onDidChangeWindowProperty(k,S){S!==this.d[k]&&(this.d={...this.d,[k]:S},this.c.fire(this.d))}openUri(k,S){let p;if(typeof k=="string"){p=k;try{k=g.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,R.$Ae)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,p,S)}async asExternalUri(k,S){if((0,R.$Ae)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(k,S);return g.URI.from(p)}};e.$Jcc=I,e.$Jcc=I=A=He([Be(0,E.$0L)],I),e.$Kcc=(0,b.$Nh)("IExtHostWindow")}),define(De[335],Ce([1,0,303,26,20]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;const L=1024*1024;let R=class extends D.$Idc{constructor(E,w){super(E,w),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,w,A){const I=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),w.apply(console,A),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,w){const A=process[E],I=A.write;let v="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(k,S,p)=>{if(!this.g){v+=k.toString(S);const u=v.length>L?v.length:v.lastIndexOf(`
`);u!==-1&&(console[w](v.slice(0,u)),v=v.slice(u+1))}I.call(A,k,S,p)}})}};e.$hec=R,e.$hec=R=He([Be(0,g.$0L),Be(1,T.$nM)],R)}),define(De[336],Ce([1,0,71,17,13,240,30,12]),function($e,e,D,T,g,L,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;let E=class{constructor(I,v){I.addFileSystemProvider(T.Schemas.file,new w(v),{isCaseSensitive:b.$l})}};e.$iec=E,e.$iec=E=He([Be(0,D.$9bc),Be(1,g.$8i)],E);class w{constructor(I){this.b=I,this.a=new L.$6p(this.b)}async stat(I){const v=await this.a.stat(I);return{type:v.type,ctime:v.ctime,mtime:v.mtime,size:v.size,permissions:v.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,v,k){return this.a.writeFile(I,v,{...k,unlock:!1,atomic:!1})}delete(I,v){return this.a.delete(I,{...v,useTrash:!1,atomic:!1})}rename(I,v,k){return this.a.rename(I,v,k)}copy(I,v,k){return this.a.copy(I,v,k)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,v){throw new Error("Method not implemented.")}}}),define(De[337],Ce([1,0,16,63,31,33,3,6,2,20]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;let A=class extends R.$Rc{constructor(v,k){super();const S=v.getProxy(b.$9J.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async p=>{const u=E.URI.file((0,D.$ic)((0,T.tmpdir)(),(0,g.$dg)()));return await S.$download(p,u),u})}};e.$gec=A,e.$gec=A=He([Be(0,w.$0L),Be(1,L.$tM)],A)}),define(De[338],Ce([1,0,150,17,242,31]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=void 0;class R extends D.$Hdc{s(E,w,A){return E.scheme===T.Schemas.file?new g.$jN(A?.name||(0,L.$dg)(),E.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,w):super.s(E,w,A)}registerLogger(E){super.registerLogger(E),this.r.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.r.$deregisterLogger(E)}}e.$tec=R}),define(De[339],Ce([1,0,53,16,2,91,3,17,11,29]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;class A extends L.$$bc{constructor(){super(...arguments),this.i=null}async g(t){const n=await super.g(t);if(n.scheme!==b.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const o=n.fsPath;let i=0;do{let c;i===0?c=o:c=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${i}`:`${o}-${i}`,await I(c);const h=T.$ic(c,"vscode.lock"),y=await p(this.d,h,!1);if(y)return this.i=y,process.on("exit",()=>{y.dispose()}),g.URI.file(c);i++}while(i<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$sec=A;async function I(l){try{await w.Promises.stat(l);return}catch{}try{await w.Promises.mkdir(l,{recursive:!0})}catch{}}const v=1e3,k=10*60*1e3;class S extends R.$Rc{constructor(t,n){super(),this.b=t,this.c=n,this.a=this.B(new E.$4g),this.a.cancelAndSet(async()=>{const o=await u(t,n);(!o||o.pid!==process.pid)&&(t.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await w.Promises.utimes(n,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${n}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+t};await w.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function p(l,t,n){try{const i={pid:process.pid,willReleaseAt:0};await w.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){l.error(i)}const o=await u(l,t);return!o||o.pid!==process.pid?n?(l.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(l.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),a(l,t)):(l.info(`Lock '${t}': Lock acquired.`),new S(l,t))}async function u(l,t){let n;try{n=await w.Promises.readFile(t)}catch(o){return l.error(o),null}try{return JSON.parse(String(n))}catch(o){return l.error(o),null}}async function r(l,t){let n;try{n=await w.Promises.stat(t)}catch(o){return l.error(o),0}return n.mtime.getTime()}function s(l){try{return process.kill(l,0),!0}catch{return!1}}async function a(l,t){const n=await u(l,t);if(!n)return l.info(`Lock '${t}': Could not read pid of lock holder.`),m(l,t);if(n.willReleaseAt){let y=n.willReleaseAt-Date.now();if(y<5e3){for(y>0?l.info(`Lock '${t}': The lockfile is scheduled to be released in ${y} ms.`):l.info(`Lock '${t}': The lockfile is scheduled to have been released.`);y>0;){if(await(0,E.$Tg)(Math.min(100,y)),await r(l,t)===0)return m(l,t);y=n.willReleaseAt-Date.now()}return m(l,t)}}if(!s(n.pid))return l.info(`Lock '${t}': The pid ${n.pid} appears to be gone.`),m(l,t);const o=await r(l,t),i=Date.now()-o;if(i<=k)return l.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;l.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Tg)(2e3);const c=await r(l,t),h=Date.now()-c;return h<=k?(l.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(l.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),m(l,t))}async function m(l,t){l.info(`Lock '${t}': Deleting a stale lock.`);try{await w.Promises.unlink(t)}catch{}return p(l,t,!0)}}),define(De[340],Ce([1,0,31,20,44,33]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;let R=class extends g.$bcc{constructor(E,w){super(!0,E,w)}createTerminal(E,w,A){return this.createTerminalFromOptions({name:E,shellPath:w,shellArgs:A})}createTerminalFromOptions(E,w){const A=new g.$acc(this.a,(0,D.$dg)(),E,E.name);return this.f.push(A),A.create(E,this.R(E,w)),A.value}};e.$Ndc=R,e.$Ndc=R=He([Be(0,L.$tM),Be(1,T.$0L)],R)}),define(De[341],Ce([1,0,11,22,21,8,4,3,128,292,68]),function($e,e,D,T,g,L,R,b,E,w,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$c4b=e.ResponsiveState=e.RequestInitiator=e.$b4b=e.$a4b=void 0;function v(d,P){try{return JSON.stringify(d,P)}catch{return"null"}}const k="$$ref$$",S={[k]:-1};class p{constructor(P,N){this.jsonString=P,this.referencedBuffers=N}}function u(d,P=null,N=!1){const O=[];return{jsonString:(N?v:JSON.stringify)(d,(j,U)=>{if(typeof U>"u")return S;if(typeof U=="object"){if(U instanceof T.$ae){const F=O.push(U)-1;return{[k]:F}}if(P)return P(j,U)}return U}),referencedBuffers:O}}e.$a4b=u;function r(d,P,N){return JSON.parse(d,(O,M)=>{if(M){const j=M[k];if(typeof j=="number")return P[j];if(N&&M.$mid===1)return N.transformIncoming(M)}return M})}e.$b4b=r;function s(d,P){return JSON.stringify(d,P)}function a(d){return d?(P,N)=>N&&N.$mid===1?d.transformOutgoing(N):N:null}var m;(function(d){d[d.LocalSide=0]="LocalSide",d[d.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));var l;(function(d){d[d.Responsive=0]="Responsive",d[d.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const t=()=>{},n=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class i extends b.$Rc{static{I=n}static{this.a=3*1e3}constructor(P,N=null,O=null){super(),this[I]=!0,this.b=this.B(new R.$Md),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=N,this.g=O,this.h=a(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,j=A.$gv.count;M<j;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$5g(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const N=this.w[P];delete this.w[P],N.resolveErr(L.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+i.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+i.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,E.$Hm)(P,this.g):P}getProxy(P){const{nid:N,sid:O}=P;return this.s[N]||(this.s[N]=this.J(N,O)),this.s[N]}J(P,N){const O={get:(M,j)=>(typeof j=="string"&&!M[j]&&j.charCodeAt(0)===36&&(M[j]=(...U)=>this.U(P,j,U)),j===o?N:M[j])};return new Proxy(Object.create(null),O)}set(P,N){return this.m[P.nid]=N,N}assertRegistered(P){for(let N=0,O=P.length;N<O;N++){const M=P[N];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(P){if(this.j)return;const N=P.byteLength,O=h.read(P,0),M=O.readUInt8(),j=O.readUInt32();switch(M){case 1:case 2:{let{rpcId:U,method:F,args:V}=C.deserializeRequestJSONArgs(O);this.g&&(V=(0,E.$Hm)(V,this.g)),this.M(N,j,U,F,V,M===2);break}case 3:case 4:{let{rpcId:U,method:F,args:V}=C.deserializeRequestMixedArgs(O);this.g&&(V=(0,E.$Hm)(V,this.g)),this.M(N,j,U,F,V,M===4);break}case 5:{this.f?.logIncoming(N,j,0,"ack"),this.G(j);break}case 6:{this.N(N,j);break}case 7:{this.O(N,j,void 0);break}case 9:{let U=C.deserializeReplyOKJSON(O);this.g&&(U=(0,E.$Hm)(U,this.g)),this.O(N,j,U);break}case 10:{const U=C.deserializeReplyOKJSONWithBuffers(O,this.g);this.O(N,j,U);break}case 8:{const U=C.deserializeReplyOKVSBuffer(O);this.O(N,j,U);break}case 11:{let U=C.deserializeReplyErrError(O);this.g&&(U=(0,E.$Hm)(U,this.g)),this.P(N,j,U);break}case 12:{this.P(N,j,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,N,O,M,j,U){this.f?.logIncoming(P,N,1,`receiveRequest ${(0,A.$iv)(O)}.${M}(`,j);const F=String(N);let V,H;if(U){const X=new g.$Wd;j.push(X.token),V=this.Q(O,M,j),H=()=>X.cancel()}else V=this.Q(O,M,j),H=t;this.u[F]=H;const fe=C.serializeAcknowledged(N);this.f?.logOutgoing(fe.byteLength,N,1,"ack"),this.c.send(fe),V.then(X=>{delete this.u[F];const Y=C.serializeReplyOK(N,X,this.h);this.f?.logOutgoing(Y.byteLength,N,1,"reply:",X),this.c.send(Y)},X=>{delete this.u[F];const Y=C.serializeReplyErr(N,X);this.f?.logOutgoing(Y.byteLength,N,1,"replyErr:",X),this.c.send(Y)})}N(P,N){this.f?.logIncoming(P,N,1,"receiveCancel");const O=String(N);this.u[O]?.()}O(P,N,O){this.f?.logIncoming(P,N,0,"receiveReply:",O);const M=String(N);if(!this.w.hasOwnProperty(M))return;const j=this.w[M];delete this.w[M],j.resolveOk(O)}P(P,N,O){this.f?.logIncoming(P,N,0,"receiveReplyErr:",O);const M=String(N);if(!this.w.hasOwnProperty(M))return;const j=this.w[M];delete this.w[M];let U;O&&(O.$isError?(U=new Error,U.name=O.name,U.message=O.message,U.stack=O.stack):U=O),j.resolveErr(U)}Q(P,N,O){try{return Promise.resolve(this.S(P,N,O))}catch(M){return Promise.reject(M)}}S(P,N,O){const M=this.m[P];if(!M)throw new Error("Unknown actor "+(0,A.$iv)(P));const j=M[N];if(typeof j!="function")throw new Error("Unknown method "+N+" on actor "+(0,A.$iv)(P));return j.apply(M,O)}U(P,N,O){if(this.j)return new w.$_3b;let M=null;if(O.length>0&&g.CancellationToken.isCancellationToken(O[O.length-1])&&(M=O.pop()),M&&M.isCancellationRequested)return Promise.reject(L.$5());const j=C.serializeRequestArguments(O,this.h),U=++this.t,F=String(U),V=new w.$$3b,H=new b.$Qc;M&&H.add(M.onCancellationRequested(()=>{const X=C.serializeCancel(U);this.f?.logOutgoing(X.byteLength,U,0,"cancel"),this.c.send(C.serializeCancel(U))})),this.w[F]=new c(V,H),this.F(U);const fe=C.serializeRequest(U,P,N,j,!!M);return this.f?.logOutgoing(fe.byteLength,U,0,`request: ${(0,A.$iv)(P)}.${N}(`,O),this.c.send(fe),V}}e.$c4b=i;class c{constructor(P,N){this.a=P,this.b=N}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class h{static alloc(P,N,O){const M=new h(T.$ae.alloc(O+1+4),0);return M.writeUInt8(P),M.writeUInt32(N),M}static read(P,N){return new h(P,N)}get buffer(){return this.a}constructor(P,N){this.a=P,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const O=this.a.slice(this.b,this.b+P).toString();return this.b+=P,O}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+P).toString();return this.b+=P,O}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+P);return this.b+=P,N}static sizeMixedArray(P){let N=0;N+=1;for(let O=0,M=P.length;O<M;O++){const j=P[O];switch(N+=1,j.type){case 1:N+=this.sizeLongString(j.value);break;case 2:N+=this.sizeVSBuffer(j.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(j.value);for(let U=0;U<j.buffers.length;++U)N+=this.sizeVSBuffer(j.buffers[U]);break;case 4:break}}return N}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let N=0,O=P.length;N<O;N++){const M=P[N];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let j=0;j<M.buffers.length;++j)this.writeBuffer(M.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const N=new Array(P);for(let O=0;O<P;O++)switch(this.readUInt8()){case 1:N[O]=this.readLongString();break;case 2:N[O]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),U=this.readLongString(),F=[];for(let V=0;V<j;++V)F.push(this.readVSBuffer());N[O]=new A.$jv(r(U,F,null));break}case 4:N[O]=void 0;break}return N}}var y;(function(d){d[d.Simple=0]="Simple",d[d.Mixed=1]="Mixed"})(y||(y={}));class C{static a(P){for(let N=0,O=P.length;N<O;N++)if(P[N]instanceof T.$ae||P[N]instanceof A.$jv||typeof P[N]>"u")return!0;return!1}static serializeRequestArguments(P,N){if(this.a(P)){const O=[];for(let M=0,j=P.length;M<j;M++){const U=P[M];if(U instanceof T.$ae)O[M]={type:2,value:U};else if(typeof U>"u")O[M]={type:4};else if(U instanceof A.$jv){const{jsonString:F,referencedBuffers:V}=u(U.value,N);O[M]={type:3,value:T.$ae.fromString(F),buffers:V}}else O[M]={type:1,value:T.$ae.fromString(s(U,N))}}return{type:1,args:O}}return{type:0,args:s(P,N)}}static serializeRequest(P,N,O,M,j){switch(M.type){case 0:return this.b(P,N,O,M.args,j);case 1:return this.c(P,N,O,M.args,j)}}static b(P,N,O,M,j){const U=T.$ae.fromString(O),F=T.$ae.fromString(M);let V=0;V+=h.sizeUInt8(),V+=h.sizeShortString(U),V+=h.sizeLongString(F);const H=h.alloc(j?2:1,P,V);return H.writeUInt8(N),H.writeShortString(U),H.writeLongString(F),H.buffer}static deserializeRequestJSONArgs(P){const N=P.readUInt8(),O=P.readShortString(),M=P.readLongString();return{rpcId:N,method:O,args:JSON.parse(M)}}static c(P,N,O,M,j){const U=T.$ae.fromString(O);let F=0;F+=h.sizeUInt8(),F+=h.sizeShortString(U),F+=h.sizeMixedArray(M);const V=h.alloc(j?4:3,P,F);return V.writeUInt8(N),V.writeShortString(U),V.writeMixedArray(M),V.buffer}static deserializeRequestMixedArgs(P){const N=P.readUInt8(),O=P.readShortString(),M=P.readMixedArray(),j=new Array(M.length);for(let U=0,F=M.length;U<F;U++){const V=M[U];typeof V=="string"?j[U]=JSON.parse(V):j[U]=V}return{rpcId:N,method:O,args:j}}static serializeAcknowledged(P){return h.alloc(5,P,0).buffer}static serializeCancel(P){return h.alloc(6,P,0).buffer}static serializeReplyOK(P,N,O){if(typeof N>"u")return this.d(P);if(N instanceof T.$ae)return this.e(P,N);if(N instanceof A.$jv){const{jsonString:M,referencedBuffers:j}=u(N.value,O,!0);return this.g(P,M,j)}else return this.f(P,v(N,O))}static d(P){return h.alloc(7,P,0).buffer}static e(P,N){let O=0;O+=h.sizeVSBuffer(N);const M=h.alloc(8,P,O);return M.writeVSBuffer(N),M.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,N){const O=T.$ae.fromString(N);let M=0;M+=h.sizeLongString(O);const j=h.alloc(9,P,M);return j.writeLongString(O),j.buffer}static g(P,N,O){const M=T.$ae.fromString(N);let j=0;j+=h.sizeUInt32,j+=h.sizeLongString(M);for(const F of O)j+=h.sizeVSBuffer(F);const U=h.alloc(10,P,j);U.writeUInt32(O.length),U.writeLongString(M);for(const F of O)U.writeBuffer(F);return U.buffer}static deserializeReplyOKJSON(P){const N=P.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(P,N){const O=P.readUInt32(),M=P.readLongString(),j=[];for(let U=0;U<O;++U)j.push(P.readVSBuffer());return new A.$jv(r(M,j,N))}static serializeReplyErr(P,N){const O=N?v(L.$2(N),null):void 0;if(typeof O!="string")return this.h(P);const M=T.$ae.fromString(O);let j=0;j+=h.sizeLongString(M);const U=h.alloc(11,P,j);return U.writeLongString(M),U.buffer}static deserializeReplyErrError(P){const N=P.readLongString();return JSON.parse(N)}static h(P){return h.alloc(12,P,0).buffer}}var $;(function(d){d[d.RequestJSONArgs=1]="RequestJSONArgs",d[d.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",d[d.RequestMixedArgs=3]="RequestMixedArgs",d[d.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",d[d.Acknowledged=5]="Acknowledged",d[d.Cancel=6]="Cancel",d[d.ReplyOKEmpty=7]="ReplyOKEmpty",d[d.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",d[d.ReplyOKJSON=9]="ReplyOKJSON",d[d.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",d[d.ReplyErrError=11]="ReplyErrError",d[d.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var f;(function(d){d[d.String=1]="String",d[d.VSBuffer=2]="VSBuffer",d[d.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",d[d.Undefined=4]="Undefined"})(f||(f={}))}),define(De[342],Ce([1,0,4,42,41,5]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.$rJ=e.OutputChannelUpdateMode=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=void 0,e.$hJ="text/x-code-output",e.$iJ="output",e.$jJ="Log",e.$kJ="text/x-code-log-output",e.$lJ="log",e.$mJ="workbench.panel.output",e.$nJ=new g.$5i("inOutput",!1),e.$oJ=new g.$5i("activeLogOutput",!1),e.$pJ=new g.$5i("outputView.scrollLock",!1),e.$qJ=(0,L.$Nh)("outputService");var R;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$rJ={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new D.$Md,this.onDidRegisterChannel=this.b.event,this.c=new D.$Md,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(A=>w.push(A)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}T.$$m.add(e.$rJ.OutputChannels,new b),e.$sJ=new g.$5i("activeOutputChannel","")}),define(De[152],Ce([1,0,6,5,20,25,13,342,71,26,55,178,22,18,30,4,3]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=void 0;class r extends R.$bj{get disposed(){return this.n}constructor(l,t,n,o,i){super(),this.id=l,this.name=t,this.r=n,this.s=o,this.extension=i,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,l)}replace(l){const t=this.m;this.info(l),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(l,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:t))}hide(){this.s.$close(this.id)}g(l,t){this.m+=v.$ae.fromString(t).byteLength,(0,R.log)(this.r,l,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class s extends r{appendLine(l){this.append(l)}}let a=class{constructor(l,t,n,o,i,c){this.i=t,this.j=n,this.k=o,this.l=i,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(D.$9J.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$0l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[t,n]of this.g)n.visible=t===this.h}createOutputChannel(l,t,n){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const o=typeof t=="object"&&t.log,i=(0,k.$xf)(t)?t:void 0;if((0,k.$xf)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const h=this.i.environment.extensionLogLevel?.find(([C])=>L.$Yl.equals(n.identifier,C))?.[1];h&&(c=(0,R.$lj)(h));const y=o?this.o(l,c,n):this.n(l,i,n);return y.then(C=>{this.g.set(C.id,C),C.visible=C.id===this.h}),o?this.r(l,c??this.m.getLevel(),y):this.q(l,y)}async n(l,t,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const o=await this.c,i=this.k.extUri.joinPath(o,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(l,i,t,n.identifier.value);return new r(h,l,c,this.a,n)}async o(l,t,n){const o=await this.p(n),i=l.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(o,`${i}.log`),h=`${n.identifier.value}.${i}`,y=this.l.createLogger(c,{id:h,name:l,logLevel:t,extensionId:n.identifier.value});return new s(h,l,y,this.a,n)}p(l){let t=this.d.get(l.identifier.value);if(!t){const n=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(n)}catch(o){if((0,S.$lk)(o)!==S.FileSystemProviderErrorCode.FileExists)throw o}return n})())}return t}q(l,t){let n=!1;const o=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return l},append(i){o(),t.then(c=>c.append(i))},appendLine(i){o(),t.then(c=>c.appendLine(i))},clear(){o(),t.then(i=>i.clear())},replace(i){o(),t.then(c=>c.replace(i))},show(i,c){o(),t.then(h=>h.show(i,c))},hide(){o(),t.then(i=>i.hide())},dispose(){n=!0,t.then(i=>i.dispose())}}}r(l,t,n){const o=new u.$Qc,i=()=>{if(o.isDisposed)throw new Error("Channel has been closed")},c=o.add(new p.$Md);function h(y){t=y,c.fire(y)}return n.then(y=>{o.add(y),y.logLevel!==t&&h(y.logLevel),o.add(y.onDidChangeLogLevel(C=>h(C)))}),{...this.q(l,n),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(y,...C){i(),n.then($=>$.trace(y,...C))},debug(y,...C){i(),n.then($=>$.debug(y,...C))},info(y,...C){i(),n.then($=>$.info(y,...C))},warn(y,...C){i(),n.then($=>$.warn(y,...C))},error(y,...C){i(),n.then($=>$.error(y,...C))},dispose(){o.dispose()}}}};e.$tcc=a,e.$tcc=a=He([Be(0,g.$0L),Be(1,w.$nM),Be(2,E.$9bc),Be(3,A.$Dbc),Be(4,R.$9i),Be(5,R.$8i)],a),e.$ucc=(0,T.$Nh)("IExtHostOutputService")}),define(De[343],Ce([1,0,5,11]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=void 0,e.$mm=(0,D.$Nh)("remoteAgentService"),e.$nm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let L=1/0;for(let b=0;b<this.maxSampleCount;b++){const E=await g.getRoundTripTime();if(E===void 0)return;L=Math.min(L,E/2),await(0,T.$Tg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce((b,E)=>b+E,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce((b,E)=>b+E,0)/this.average.length,high:(()=>typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[344],Ce([1,0,32,17,16,12,24,2,5,258,43,147,343]),function($e,e,D,T,g,L,R,b,E,w,A,I,v){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$LJ=e.$KJ=void 0,e.$KJ=(0,E.$Nh)("pathService");let S=k=class{constructor(u,r,s,a){this.d=u,this.e=r,this.f=s,this.g=a,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const m=await this.e.getEnvironment();return this.c=m?.userHome??u})()}hasValidBasename(u,r,s){return typeof r=="string"||typeof r>"u"?this.a.then(a=>this.h(u,a,r)):this.h(u,r,s)}h(u,r,s){return u.scheme===T.Schemas.file||u.scheme===T.Schemas.vscodeRemote?(0,D.$Uf)(s??(0,R.$rg)(u),r===1):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(u,r){if(u.remoteAuthority)return T.Schemas.vscodeRemote;const s=(0,w.$HJ)(r.getWorkspace());if(s)return s;const a=r.getWorkspace().folders[0];if(a)return a.uri.scheme;const m=r.getWorkspace().configuration;return m?m.scheme:T.Schemas.file}userHome(u){return u?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(u=>u===1?g.$ec:g.$fc)}async fileURI(u){let r="";if(await this.a===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const a=u.indexOf("/",2);a===-1?(r=u.substring(2),u="/"):(r=u.substring(2,a),u=u.substring(a)||"/")}return b.URI.from({scheme:T.Schemas.file,authority:r,path:u,query:"",fragment:""})}};e.$LJ=S,e.$LJ=S=k=He([Be(1,v.$mm),Be(2,I.$tJ),Be(3,A.$Wh)],S)}),define(De[345],Ce([1,0,225,19,57,4,52,3,2,49,230,13,64,260,86,43,147,27,21,18,23,41]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EJ=e.$DJ=e.$CJ=e.OnPortForward=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.TunnelSource=e.TunnelCloseReason=e.$wJ=e.$vJ=e.$uJ=void 0;const t=10*1e3,n="remote.tunnels.toRestore";e.$uJ="onTunnel",e.$vJ=new l.$5i("forwardedPortsViewEnabled",!1,D.localize(0,null));function o(N){const O=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}e.$wJ=o;var i;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(i||(e.TunnelCloseReason=i={}));var c;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(c||(e.TunnelSource=c={})),e.$xJ={source:c.User,description:D.localize(1,null)},e.$yJ={source:c.Auto,description:D.localize(2,null)};function h(N,O,M){const j=N.get(C(O,M));if(j)return j;if((0,S.$8u)(O))for(const U of S.$7u){const F=C(U,M);if(N.has(F))return N.get(F)}else if((0,S.$0u)(O))for(const U of S.$9u){const F=C(U,M);if(N.has(F))return N.get(F)}}e.$zJ=h;function y(N,O,M){const j=h(N,O,M);if(j)return j;const U=(0,S.$0u)(O)?"localhost":(0,S.$8u)(O)?"0.0.0.0":void 0;if(U)return h(N,U,M)}e.$AJ=y;function C(N,O){return N+":"+O}e.$BJ=C;var $;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})($||(e.OnPortForward=$={}));function f(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$CJ=f;class d extends b.$Rc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.r=O,this.j=[],this.n=new L.$Md,this.onDidChangeAttributes=this.n.event,this.B(O.onDidChangeConfiguration(M=>{(M.affectsConfiguration(d.c)||M.affectsConfiguration(d.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(O,M,j){let U=this.w(O,M,j,this.j,0);const F={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;U>=0;){const V=this.j[U];V.key===O?(F.onAutoForward=V.onAutoForward??F.onAutoForward,F.elevateIfNeeded=V.elevateIfNeeded!==void 0?V.elevateIfNeeded:F.elevateIfNeeded,F.label=V.label??F.label,F.requireLocalPort=V.requireLocalPort,F.protocol=V.protocol):(F.onAutoForward=F.onAutoForward??V.onAutoForward,F.elevateIfNeeded=F.elevateIfNeeded!==void 0?F.elevateIfNeeded:V.elevateIfNeeded,F.label=F.label??V.label,F.requireLocalPort=F.requireLocalPort!==void 0?F.requireLocalPort:void 0,F.protocol=F.protocol??V.protocol),U=this.w(O,M,j,this.j,U+1)}return F.onAutoForward!==void 0||F.elevateIfNeeded!==void 0||F.label!==void 0||F.requireLocalPort!==void 0||F.protocol!==void 0?F:this.C()}t(O){return O.start!==void 0&&O.end!==void 0}u(O){return O.host!==void 0&&O.port!==void 0&&(0,a.$xf)(O.host)&&(0,a.$Bf)(O.port)}w(O,M,j,U,F){if(F>=U.length)return-1;const V=!(0,S.$8u)(M)&&!(0,S.$0u)(M),fe=U.slice(F).findIndex(X=>(0,a.$Bf)(X.key)?V?!1:X.key===O:this.t(X.key)?V?!1:O>=X.key.start&&O<=X.key.end:this.u(X.key)?O===X.key.port&&M===X.key.host:j?X.key.test(j):!1);return fe>=0?fe+F:-1}y(){const O=this.r.getValue(d.c);if(!O||!(0,a.$zf)(O))return[];const M=[];for(const U in O){if(U===void 0)continue;const F=O[U];let V;if(Number(U))V=Number(U);else if((0,a.$xf)(U))if(d.g.test(U)){const H=U.match(d.g);V={start:Number(H[1]),end:Number(H[2])}}else if(d.h.test(U)){const H=U.match(d.h);V={host:H[1],port:Number(H[2])}}else{let H;try{H=RegExp(U)}catch{}H&&(V=H)}V&&M.push({key:V,elevateIfNeeded:F.elevateIfNeeded,onAutoForward:F.onAutoForward,label:F.label,requireLocalPort:F.requireLocalPort,protocol:F.protocol})}const j=this.r.getValue(d.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(M)}z(O){function M(j,U){return(0,a.$Bf)(j.key)?j.key:U.t(j.key)?j.key.start:U.u(j.key)?j.key.port:Number.MAX_VALUE}return O.sort((j,U)=>M(j,this)-M(U,this))}C(){return this.m}static providedActionToAction(O){switch(O){case S.ProvidedOnAutoForward.Notify:return $.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return $.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return $.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return $.OpenPreview;case S.ProvidedOnAutoForward.Silent:return $.Silent;case S.ProvidedOnAutoForward.Ignore:return $.Ignore;default:return}}async addAttributes(O,M,j){const F=this.r.inspect(d.c).userRemoteValue;let V;!F||!(0,a.$zf)(F)?V={}:V=(0,m.$Ym)(F),V[`${O}`]||(V[`${O}`]={});for(const H in M)V[`${O}`][H]=M[H];return this.r.updateValue(d.c,V,j)}}e.$DJ=d;let P=class extends b.$Rc{constructor(O,M,j,U,F,V,H,fe,X,Y){super(),this.H=O,this.I=M,this.J=j,this.L=U,this.M=F,this.N=V,this.O=H,this.P=fe,this.Q=X,this.R=Y,this.c=new Map,this.g=new L.$Md,this.onForwardPort=this.g.event,this.h=new L.$Md,this.onClosePort=this.h.event,this.j=new L.$Md,this.onPortName=this.j.event,this.n=new L.$Md,this.onCandidatesChanged=this.n.event,this.t=new L.$Md,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$Md,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new d(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async q=>{const x=await this.getAttributes(q.map(me=>({port:me.tunnelRemotePort,host:me.tunnelRemoteHost})));for(const me of q)if(me.localAddress){const ue=C(me.tunnelRemoteHost,me.tunnelRemotePort),pe=y(this.m??new Map,me.tunnelRemoteHost,me.tunnelRemotePort);this.forwarded.set(ue,{remotePort:me.tunnelRemotePort,remoteHost:me.tunnelRemoteHost,localAddress:me.localAddress,protocol:x?.get(me.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(me.localAddress,x?.get(me.tunnelRemotePort)),localPort:me.tunnelLocalPort,runningProcess:pe?.detail,hasRunningProcess:!!pe,pid:pe?.pid,privacy:me.privacy,source:e.$xJ}),this.f.set(ue,me)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async q=>{const x=C(q.tunnelRemoteHost,q.tunnelRemotePort);if(!y(this.forwarded,q.tunnelRemoteHost,q.tunnelRemotePort)&&!y(this.detected,q.tunnelRemoteHost,q.tunnelRemotePort)&&!y(this.c,q.tunnelRemoteHost,q.tunnelRemotePort)&&q.localAddress){const me=y(this.m??new Map,q.tunnelRemoteHost,q.tunnelRemotePort),ue=(await this.getAttributes([{port:q.tunnelRemotePort,host:q.tunnelRemoteHost}]))?.get(q.tunnelRemotePort);this.forwarded.set(x,{remoteHost:q.tunnelRemoteHost,remotePort:q.tunnelRemotePort,localAddress:q.localAddress,protocol:ue?.protocol??S.TunnelProtocol.Http,localUri:await this.X(q.localAddress,ue),localPort:q.tunnelLocalPort,closeable:!0,runningProcess:me?.detail,hasRunningProcess:!!me,pid:me?.pid,privacy:q.privacy,source:e.$xJ})}await this.$(),this.f.set(x,q),this.g.fire(this.forwarded.get(x))})),this.B(this.H.onTunnelClosed(q=>this.W(q,i.Other))),this.U()}S(){return this.Q.extensions.find(O=>O.activationEvents?.includes(e.$uJ))?(this.R.createKey(e.$vJ.key,!0),!0):!1}U(){if(this.S())return;const O=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&O.dispose()}))}async W(O,M){const j=C(O.host,O.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(O))}X(O,M){if(O.startsWith("http"))return E.URI.parse(O);const j=M?.protocol??"http";return E.URI.parse(`${j}://${O}`)}async Y(){const O=this.N.getWorkspace(),M=O.configuration?(0,R.$Bi)(O.configuration.path):O.folders.length>0?(0,R.$Bi)(O.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${n}.${this.L.remoteAuthority}.${M}`}async Z(){const O=this.I.get(n,1);if(O)return this.I.remove(n,1),await this.$(),O;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=await this.s;if(O&&O!==this.y){const M=JSON.parse(O)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(j=>j.remotePort).join(", ")}`);for(const j of M){const U=y(this.detected,j.remoteHost,j.remotePort);j.source.source!==c.Extension&&!U||j.source.source===c.Extension&&U?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===c.Extension&&!U&&this.D.set(C(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const O=await this.Y();this.w=this.B(new b.$Qc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===O&&(this.s=Promise.resolve(this.I.get(O,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=JSON.stringify(Array.from(this.forwarded.values()));if(O!==this.y){this.y=O;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(O,M,j){if(!O.tunnelLocalPort||!j?.requireLocalPort||O.tunnelLocalPort===M)return;const U=new Date;if(this.ab.getTime()+t>U.getTime())return;this.ab=U;const F=D.localize(3,null,M,O.tunnelRemotePort,O.tunnelLocalPort);return this.P.info(F)}async forward(O,M){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.cb(O,M)}async cb(O,M){await this.Q.activateByEvent(e.$uJ);const j=y(this.forwarded,O.remote.host,O.remote.port);M=M??(M!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const U=O.local!==void 0?O.local:O.remote.port;let F;if(j)return this.eb(j,O,M);{const V=this.L.remoteAuthority,H=V?{getAddress:async()=>(await this.M.resolveAuthority(V)).authority}:void 0,fe=C(O.remote.host,O.remote.port);this.c.set(fe,!0),O=this.db(fe,O);const X=await this.H.openTunnel(H,O.remote.host,O.remote.port,void 0,U,O.elevateIfNeeded?O.elevateIfNeeded:M?.elevateIfNeeded,O.privacy,M?.protocol);if(typeof X=="string")F=X;else if(X&&X.localAddress){const Y=y(this.m??new Map,O.remote.host,O.remote.port),q=X.protocol?X.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:M?.protocol??S.TunnelProtocol.Http,x={remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localPort:X.tunnelLocalPort,name:M?.label??O.name,closeable:!0,localAddress:X.localAddress,protocol:q,localUri:await this.X(X.localAddress,M),runningProcess:Y?.detail,hasRunningProcess:!!Y,pid:Y?.pid,source:O.source??e.$xJ,privacy:X.privacy};return this.forwarded.set(fe,x),this.f.set(fe,X),this.c.delete(fe),await this.$(),await this.bb(X,U,M),this.g.fire(x),X}this.c.delete(fe)}return F}db(O,M){const j=this.D.has(O)?this.D:this.F.has(O)?this.F:void 0;if(j){const U=j.get(O);j.delete(O),U&&(M.name=U.name??M.name,M.local=("local"in U?U.local:"localPort"in U?U.localPort:void 0)??M.local,M.privacy=U.privacy??M.privacy)}return M}async eb(O,M,j){const U=j?.label??M.name;let F;(function(H){H[H.None=0]="None",H[H.Fire=1]="Fire",H[H.Reopen=2]="Reopen"})(F||(F={}));let V=F.None;switch(U!==O.name&&(O.name=U,V=F.Fire),(j?.protocol||O.protocol!==S.TunnelProtocol.Http)&&j?.protocol!==O.protocol&&(M.source=O.source,V=F.Reopen),M.privacy&&O.privacy!==M.privacy&&(V=F.Reopen),V){case F.Fire:{this.g.fire();break}case F.Reopen:await this.close(O.remoteHost,O.remotePort,i.User),await this.cb(M,j)}return y(this.f,M.remote.host,M.remote.port)}async name(O,M,j){const U=y(this.forwarded,O,M),F=C(O,M);if(U){U.name=j,await this.$(),this.j.fire({host:O,port:M});return}else this.detected.has(F)&&(this.detected.get(F).name=j,this.j.fire({host:O,port:M}))}async close(O,M,j){const U=C(O,M),F=this.forwarded.get(U);return j===i.AutoForwardEnd&&F&&F.source.source===c.Auto&&this.F.set(U,{local:F.localPort,name:F.name,privacy:F.privacy}),await this.H.closeTunnel(O,M),this.W({host:O,port:M},j)}address(O,M){const j=C(O,M);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(O){if(O)for(const M of O){const j=y(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),U=typeof M.localAddress=="string"?M.localAddress:C(M.localAddress.host,M.localAddress.port);this.detected.set(C(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:U,protocol:S.TunnelProtocol.Http,localUri:this.X(U),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:c.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,U,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(O){this.r=O}async setCandidates(O){let M=O;this.r&&(M=await this.r(O));const j=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(U=>U.port).join(", ")}`),this.n.fire(j)}fb(O){const M=this.m??new Map,j=new Map;return this.m=j,O.forEach(U=>{const F=C(U.host,U.port);j.set(F,{host:U.host,port:U.port,detail:U.detail,pid:U.pid}),M.has(F)&&M.delete(F);const V=y(this.forwarded,U.host,U.port);V&&(V.runningProcess=U.detail,V.hasRunningProcess=!0,V.pid=U.pid)}),M.forEach((U,F)=>{const V=o(F);if(!V)return;const H=y(this.forwarded,V.host,V.port);H&&(H.runningProcess=void 0,H.hasRunningProcess=!1,H.pid=void 0);const fe=y(this.detected,V.host,V.port);fe&&(fe.runningProcess=void 0,fe.hasRunningProcess=!1,fe.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const O=Array.from(this.forwarded.values()),M=await this.getAttributes(O.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(M)for(const j of O){const U=M.get(j.remotePort);(U?.protocol||j.protocol!==S.TunnelProtocol.Http)&&U?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},U),U&&U.label&&U.label!==j.name&&await this.name(j.remoteHost,j.remotePort,U.label)}}async getAttributes(O,M=!0){const j=new Map,U=new Map;O.forEach(X=>{const Y=y(this.m??new Map,S.$7u[0],X.port)??X;if(Y){j.set(X.port,Y);const q=f(Y)?Y.pid:void 0;U.has(q)||U.set(q,[]),U.get(q)?.push(X.port)}});const F=new Map;if(O.forEach(X=>{const Y=this.configPortsAttributes.getAttributes(X.port,X.host,j.get(X.port)?.detail);Y&&F.set(X.port,Y)}),this.G.length===0||!M)return F.size>0?F:void 0;const V=await Promise.all((0,T.$Qb)(this.G.map(X=>Array.from(U.entries()).map(Y=>{const q=Y[1],x=j.get(q[0]);return X.providePortAttributes(q,x?.pid,x?.detail,new s.$Wd().token)})))),H=new Map;if(V.forEach(X=>X.forEach(Y=>{Y&&H.set(Y.port,Y)})),!F&&!H)return;const fe=new Map;return O.forEach(X=>{const Y=F.get(X.port),q=H.get(X.port);fe.set(X.port,{elevateIfNeeded:Y?.elevateIfNeeded,label:Y?.label,onAutoForward:Y?.onAutoForward??d.providedActionToAction(q?.autoForwardAction),requireLocalPort:Y?.requireLocalPort,protocol:Y?.protocol})}),fe}addAttributesProvider(O){this.G.push(O)}};e.$EJ=P,He([(0,g.$gh)(1e3)],P.prototype,"$",null),e.$EJ=P=He([Be(0,S.$3u),Be(1,k.$Yo),Be(2,w.$hi),Be(3,u.$tJ),Be(4,v.$Mk),Be(5,p.$Wh),Be(6,I.$8i),Be(7,A.$uv),Be(8,r.$5E),Be(9,l.$6i)],P)}),define(De[93],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$uI=e.$tI=void 0;class D{constructor(R,b){this.line=R,this.character=b}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,b){return new D(0,0)}with(R){return new D(0,0)}}e.$tI=D;class T{constructor(R,b,E,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(R,b),this.end=new D(E,w)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.$uI=T;var g;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(De[36],Ce([1,0,19,35,23,32,15,5,16,8,93,11]),function($e,e,D,T,g,L,R,b,E,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.SearchErrorCode=e.$JI=e.$II=e.SearchSortOrder=e.ViewMode=e.$HI=e.$GI=e.$FI=e.$EI=e.SearchCompletionExitCode=e.$DI=e.$CI=e.$BI=e.QueryType=e.SearchProviderType=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$vI="workbench.view.search",e.$wI="workbench.panel.search",e.$xI="workbench.view.search",e.$yI="search-result",e.$zI="search.exclude";const v="\u27EA ",k=" characters skipped \u27EB",S=(v.length+k.length+5)*2;e.$AI=(0,b.$Nh)("searchService");var p;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(p||(e.SearchProviderType=p={}));var u;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(u||(e.QueryType=u={}));function r(q){return!!q.preview}e.$BI=r;function s(q){return!!q.resource}e.$CI=s;function a(q){return!!q.message}e.$DI=a;var m;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(m||(e.SearchCompletionExitCode=m={}));class l{constructor(x){this.resource=x,this.results=[]}}e.$EI=l;class t{constructor(x,me,ue,pe){this.ranges=me,this.webviewIndex=pe;const G=Array.isArray(me)?me:[me];if(ue&&ue.matchLines===1&&n(G)){x=(0,R.$qf)(x,ue.matchLines);let z="",K=0,ge=0;const _=Math.floor(ue.charsPerLine/5),ie=[];for(const ne of G){const Ee=Math.max(ne.startColumn-_,0),oe=ne.startColumn+ue.charsPerLine;if(Ee>ge+_+S){const he=v+(Ee-ge)+k;z+=he+x.slice(Ee,oe),K+=Ee-(ge+he.length)}else z+=x.slice(ge,oe);ie.push(new i(0,ne.startColumn-K,ne.endColumn-K)),ge=oe}this.preview={text:z,matches:Array.isArray(this.ranges)?ie:ie[0]}}else{const z=Array.isArray(me)?me[0].startLineNumber:me.startLineNumber;this.preview={text:x,matches:(0,D.$1b)(me,K=>new o(K.startLineNumber-z,K.startColumn,K.endLineNumber-z,K.endColumn))}}}}e.$FI=t;function n(q){const x=q[0].startLineNumber;for(const me of q)if(me.startLineNumber!==x||me.endLineNumber!==x)return!1;return!0}class o{constructor(x,me,ue,pe){this.startLineNumber=x,this.startColumn=me,this.endLineNumber=ue,this.endColumn=pe}}e.$GI=o;class i extends o{constructor(x,me,ue){super(x,me,x,ue)}}e.$HI=i;var c;(function(q){q.List="list",q.Tree="tree"})(c||(e.ViewMode=c={}));var h;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function y(q,x=!0){const me=q&&q.files&&q.files.exclude,ue=x&&q&&q.search&&q.search.exclude;if(!me&&!ue)return;if(!me||!ue)return me||ue;let pe=Object.create(null);return pe=g.$2m(pe,g.$Ym(me)),pe=g.$2m(pe,g.$Ym(ue),!0),pe}e.$II=y;function C(q,x){return q.excludePattern&&T.$tj(q.excludePattern,x)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&T.$tj(q.includePattern,x)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(me=>{const ue=me.folder.fsPath;if(L.$Wf(x,ue)){const pe=E.$kc(ue,x);return!me.includePattern||!!T.$tj(me.includePattern,pe)}else return!1}):!1:!0}e.$JI=C;var $;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class f extends Error{constructor(x,me){super(x),this.code=me}}e.$KI=f;function d(q){const x=q.message;if((0,w.$3)(q))return new f(x,$.canceled);try{const me=JSON.parse(x);return new f(me.message,me.code)}catch{return new f(x,$.other)}}e.$LI=d;function P(q){const x={message:q.message,code:q.code};return new Error(JSON.stringify(x))}e.$MI=P;function N(q){return q.type==="error"?!0:q.type==="success"}e.$NI=N;function O(q){return q.type==="success"}e.$OI=O;function M(q){return!!q.path}e.$PI=M;function j(q,x){const me=q.searchPath?q.searchPath:q.relativePath;return(0,R.$nf)(me,x)}e.$QI=j;class U{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$RI=U;function F(q,x){const me={...q||{},...x||{}};return Object.keys(me).filter(ue=>{const pe=me[ue];return typeof pe=="boolean"&&pe})}e.$SI=F;class V{constructor(x,me){this.c=null,this.a={...x.excludePattern||{},...me.excludePattern||{}},this.b=T.$uj(this.a);let ue=x.includePattern;me.includePattern&&(ue?ue={...ue,...me.includePattern}:ue=me.includePattern),ue&&(this.c=T.$uj(ue))}matchesExcludesSync(x,me,ue){return!!(this.b&&this.b(x,me,ue))}includedInQuerySync(x,me,ue){return!(this.b&&this.b(x,me,ue)||this.c&&!this.c(x,me,ue))}includedInQuery(x,me,ue){const pe=this.b(x,me,ue),G=()=>this.c?!!this.c(x,me,ue):!0;return(0,I.$Fg)(pe)?pe.then(z=>z?!1:G()):G()}hasSiblingExcludeClauses(){return H(this.a)}}e.$TI=V;function H(q){for(const x in q)if(typeof q[x]!="boolean")return!0;return!1}function fe(q){if(!q)return;let x;return me=>(x||(x=(q()||Promise.resolve([])).then(ue=>ue?Y(ue):{})),x.then(ue=>!!ue[me]))}e.$UI=fe;function X(q){if(!q)return;let x;return me=>{if(!x){const ue=q();x=ue?Y(ue):{}}return!!x[me]}}e.$VI=X;function Y(q){const x={};for(const me of q)x[me]=!0;return x}}),define(De[39],Ce([1,0,19,11,21,4,3,77,17,120,24,15,2,214,5,13,243,43,55,26,20,14,7,66,36,6]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m,l,t,n,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=e.$Pbc=void 0;function c(N,O,M){return new A.$jg(j=>$(j,M)).isEqual(N,O)}function h(N,O,M){return c(N.uri,O.uri,M)?0:(0,I.$Te)(N.uri.toString(),O.uri.toString())}function y(N,O,M){return N.index!==O.index?N.index<O.index?-1:1:c(N.uri,O.uri,M)?(0,I.$Te)(N.name,O.name):(0,I.$Te)(N.uri.toString(),O.uri.toString())}function C(N,O,M,j){const U=N.slice(0).sort((V,H)=>M(V,H,j)),F=O.slice(0).sort((V,H)=>M(V,H,j));return(0,D.$Db)(U,F,(V,H)=>M(V,H,j))}function $(N,O){const M=O.getCapabilities(N.scheme);return!(M&&M&1024)}class f extends r.$7h{static toExtHostWorkspace(O,M,j,U){if(!O)return{workspace:null,added:[],removed:[]};const{id:F,name:V,folders:H,configuration:fe,transient:X,isUntitled:Y}=O,q=[],x=M;M?H.forEach((G,z)=>{const K=v.URI.revive(G.uri),ge=f.o(j||M,K,U);ge?(ge.name=G.name,ge.index=G.index,q.push(ge)):q.push({uri:K,name:G.name,index:z})}):q.push(...H.map(({uri:G,name:z,index:K})=>({uri:v.URI.revive(G),name:z,index:K}))),q.sort((G,z)=>G.index<z.index?-1:1);const me=new f(F,V,q,!!X,fe?v.URI.revive(fe):null,!!Y,G=>$(G,U)),{added:ue,removed:pe}=C(x?x.workspaceFolders:[],me.workspaceFolders,h,U);return{workspace:me,added:ue,removed:pe}}static o(O,M,j){for(let U=0;U<O.folders.length;U++){const F=O.workspaceFolders[U];if(c(F.uri,M,j))return F}}constructor(O,M,j,U,F,V,H){super(O,j.map(fe=>new r.$8h(fe)),U,F,H),this.t=M,this.u=V,this.q=[],this.s=b.$Th.forUris(H),j.forEach(fe=>{this.q.push(fe),this.s.set(fe.uri,fe)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(O,M){return M&&this.s.get(O)&&(O=(0,A.$tg)(O)),this.s.findSubstr(O)}resolveWorkspaceFolder(O){return this.s.get(O)}}let d=class{constructor(O,M,j,U,F){this.c=new L.$Md,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Md,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Od,this.B=new Map,this.h=U,this.s=j,this.t=F,this.j=new w.$Ml,this.k=new T.$Rg,this.o=O.getProxy(i.$9J.MainThreadWorkspace),this.q=O.getProxy(i.$9J.MainThreadMessageService);const V=M.workspace;this.l=V?new f(V.id,V.name,[],!!V.transient,V.configuration?v.URI.revive(V.configuration):null,!!V.isUntitled,H=>$(H,j)):void 0}$initializeWorkspace(O,M){this.v=M,this.$acceptWorkspaceData(O),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?v.URI.from({scheme:E.Schemas.untitled,path:(0,A.$rg)((0,A.$tg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(O,M,j,...U){const F=[];if(Array.isArray(U)&&U.forEach(Y=>{v.URI.isUri(Y.uri)&&!F.some(q=>c(q.uri,Y.uri,this.s))&&F.push({uri:Y.uri,name:Y.name||(0,A.$qg)(Y.uri)})}),this.n||[M,j].some(Y=>typeof Y!="number"||Y<0)||j===0&&F.length===0)return!1;const V=this.x?this.x.workspaceFolders:[];if(M+j>V.length)return!1;const H=V.slice(0);H.splice(M,j,...F.map(Y=>({uri:Y.uri,name:Y.name||(0,A.$qg)(Y.uri),index:void 0})));for(let Y=0;Y<H.length;Y++){const q=H[Y];if(H.some((x,me)=>me!==Y&&c(q.uri,x.uri,this.s)))return!1}H.forEach((Y,q)=>Y.index=q);const{added:fe,removed:X}=C(V,H,y,this.s);if(fe.length===0&&X.length===0)return!1;if(this.o){const Y=O.displayName||O.name;this.o.$updateWorkspaceFolders(Y,M,j,F).then(void 0,q=>{this.n=void 0;const x={source:{identifier:O.identifier,label:O.displayName||O.name}};this.q.$showMessage(u.Severity.Error,(0,k.localize)(0,null,Y,q.toString()),x,[])})}return this.y(H),!0}getWorkspaceFolder(O,M){if(this.x)return this.x.getWorkspaceFolder(O,M)}async getWorkspaceFolder2(O,M){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(O,M)}async resolveWorkspaceFolder(O){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(O)}getPath(){if(!this.x)return;const{folders:O}=this.x;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,M){let j,U="";if(typeof O=="string"?(j=v.URI.file(O),U=O):typeof O<"u"&&(j=O,U=O.fsPath),!j)return U;const F=this.getWorkspaceFolder(j,!0);if(!F)return U;typeof M>"u"&&this.x&&(M=this.x.folders.length>1);let V=(0,A.$wg)(F.uri,j);return M&&F.name&&(V=`${F.name}/${V}`),V}y(O){this.x&&(this.n=f.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:O,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:M,added:j,removed:U}=f.toExtHostWorkspace(O,this.l,this.n,this.s);this.l=M||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:U}))}findFiles(O,M,j,U,F=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let V;if(M===null?V=!1:M&&(typeof M=="string"?V=M:V=M.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:fe}=P(l.GlobPattern.from(O));return this.o.$startFileSearch(H??null,fe??null,V??null,j??null,F).then(X=>Array.isArray(X)?X.map(Y=>v.URI.revive(Y)):[])}async findTextInFiles(O,M,j,U,F=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const V=this.j.getNext(),H=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:fe,folder:X}=P(l.GlobPattern.from(M.include)),Y=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,q={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:H,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:fe,excludePattern:Y},x=!1;if(this.u[V]=me=>{if(x)return;const ue=v.URI.revive(me.resource);me.results.forEach(pe=>{(0,o.$BI)(pe)?j({uri:ue,preview:{text:pe.preview.text,matches:(0,D.$1b)(pe.preview.matches,G=>new t.$aK(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))},ranges:(0,D.$1b)(pe.ranges,G=>new t.$aK(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))}):j({uri:ue,text:pe.text,lineNumber:pe.lineNumber})})},F.isCancellationRequested)return{};try{const me=await this.o.$startTextSearch(O,X??null,q,V,F);return delete this.u[V],me||{}}catch(me){throw delete this.u[V],me}}$handleTextSearchResult(O,M){this.u[M]?.(O)}async save(O){const M=await this.o.$save(O,{saveAs:!1});return v.URI.revive(M)}async saveAs(O){const M=await this.o.$save(O,{saveAs:!0});return v.URI.revive(M)}saveAll(O){return this.o.$saveAll(O)}resolveProxy(O){return this.o.$resolveProxy(O)}get trusted(){return this.v}requestWorkspaceTrust(O){return this.o.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(O,M){if(this.w.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.w.set(O,M);const j=this.t.transformOutgoingScheme(O),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,j),(0,R.$Pc)(()=>{this.w.delete(O),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(O,M){this.h.info("Getting edit session identifier for workspaceFolder",O);const j=await this.resolveWorkspaceFolder(v.URI.revive(O));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const U=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!U),!U)return;const F=await U.provideEditSessionIdentity(j,M);if(this.h.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch(O,M,j,U){this.h.info("Getting edit session identifier for workspaceFolder",O);const F=await this.resolveWorkspaceFolder(v.URI.revive(O));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const V=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!V),!V)return;const H=await V.provideEditSessionIdentityMatch?.(M,j,U);if(this.h.info("Provider returned edit session identifier match result: ",H),!!H)return H}getOnWillCreateEditSessionIdentityEvent(O){return(M,j,U)=>{const F=function(H){M.call(j,H)};return F.extension=O,this.A.event(F,void 0,U)}}async $onWillCreateEditSessionIdentity(O,M,j){const U=await this.resolveWorkspaceFolder(v.URI.revive(O));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},M,async(F,V)=>{const H=Date.now();await Promise.resolve(F),Date.now()-H>j&&this.h.warn("SLOW edit session create-participant",V.extension.identifier)}),M.isCancellationRequested}registerCanonicalUriProvider(O,M){if(this.B.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.B.set(O,M);const j=this.t.transformOutgoingScheme(O),U=this.z++;return this.o.$registerCanonicalUriProvider(U,j),(0,R.$Pc)(()=>{this.B.delete(O),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(O,M,j){const U=this.B.get(O.scheme);if(!U)return;const F=await U.provideCanonicalUri?.(v.URI.revive(O),M,j);if(F)return F}async $provideCanonicalUri(O,M,j){return this.provideCanonicalUri(v.URI.revive(O),{targetScheme:M},j)}};e.$Pbc=d,e.$Pbc=d=He([Be(0,m.$0L),Be(1,a.$nM),Be(2,s.$Dbc),Be(3,p.$8i),Be(4,n.$Nbc)],d),e.$Qbc=(0,S.$Nh)("IExtHostWorkspace");function P(N){let O,M;return N&&(typeof N=="string"?O=N:(O=N.pattern,M=v.URI.revive(N.baseUri))),{includePattern:O,folder:M}}}),define(De[40],Ce([1,0,23,4,39,6,7,245,136,18,11,5,20,13,2]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=e.$Sbc=e.$Rbc=void 0;function p(n,o){if(o){const i=o.split(".");let c=n;for(let h=0;c&&h<i.length;h++)c=c[i[h]];return c}}function u(n){return n instanceof S.URI}function r(n){return n&&n.uri instanceof S.URI&&n.languageId&&typeof n.languageId=="string"}function s(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function a(n){return n&&n.uri instanceof S.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function m(n){if(u(n))return{resource:n};if(r(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(s(n))return{overrideIdentifier:n.languageId};if(a(n))return{resource:n.uri};if(n===null)return{resource:null}}let l=class{constructor(o,i,c){this.a=o.getProxy(L.$9J.MainThreadConfiguration),this.c=i,this.b=c,this.d=new A.$Rg,this.e=null}getConfigProvider(){return this.d.wait().then(o=>this.e)}$initializeConfiguration(o){this.e=new t(this.a,this.c,o,this.b),this.d.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(o,i))}};e.$Rbc=l,e.$Rbc=l=He([Be(0,v.$0L),Be(1,g.$Qbc),Be(2,k.$8i)],l);class t{constructor(o,i,c,h){this.a=new T.$Md,this.b=o,this.f=h,this.c=i,this.e=b.$wn.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(o,i){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$wn.parse(o),this.d=this.k(o.configurationScopes),this.a.fire(this.j(i,c))}getConfiguration(o,i,c){const h=m(i)||{},y=this.g(o?p(this.e.getValue(void 0,h,this.c.workspace),o):this.e.getValue(void 0,h,this.c.workspace));o&&this.h(o,h,c?.identifier);function C(f){if(f==null)return null;if(typeof f=="boolean")return f?2:5;switch(f){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(f){return typeof p(y,f)<"u"},get:(f,d)=>{this.h(o?`${o}.${f}`:f,h,c?.identifier);let P=p(y,f);if(typeof P>"u")P=d;else{let N;const O=(M,j)=>{if((0,w.$zf)(M)){let U;const F=()=>{N=N||(0,D.$Ym)(y),U=U||p(N,j)};return new Proxy(M,{get:(V,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return F(),()=>U;if(N)return U=U||p(N,j),U[H];const fe=V[H];return typeof H=="string"?O(fe,`${j}.${H}`):fe},set:(V,H,fe)=>(F(),U&&(U[H]=fe),!0),deleteProperty:(V,H)=>(F(),U&&delete U[H],!0),defineProperty:(V,H,fe)=>(F(),U&&Object.defineProperty(U,H,fe),!0)})}return Array.isArray(M)?(0,D.$Ym)(M):M};P=O(P,f)}return P},update:(f,d,P,N)=>{f=o?`${o}.${f}`:f;const O=C(P);return d!==void 0?this.b.$updateConfigurationOption(O,f,d,h,N):this.b.$removeConfigurationOption(O,f,h,N)},inspect:f=>{f=o?`${o}.${f}`:f;const d=this.e.inspect(f,h,this.c.workspace);if(d)return{key:f,defaultValue:(0,D.$Ym)(d.policy?.value??d.default?.value),globalValue:(0,D.$Ym)(d.user?.value??d.application?.value),workspaceValue:(0,D.$Ym)(d.workspace?.value),workspaceFolderValue:(0,D.$Ym)(d.workspaceFolder?.value),defaultLanguageValue:(0,D.$Ym)(d.default?.override),globalLanguageValue:(0,D.$Ym)(d.user?.override??d.application?.override),workspaceLanguageValue:(0,D.$Ym)(d.workspace?.override),workspaceFolderLanguageValue:(0,D.$Ym)(d.workspaceFolder?.override),languageIds:(0,D.$Ym)(d.overrideIdentifiers)}}};return typeof y=="object"&&(0,D.$2m)($,y,!1),Object.freeze($)}g(o){const i=c=>(0,w.$zf)(c)?new Proxy(c,{get:(h,y)=>i(h[y]),set:(h,y,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(h,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(h,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(o)}h(o,i,c){const h=E.$nn.test(o)?4:this.d.get(o),y=c?`[${c.value}] `:"";if(h===4){typeof i?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){i?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(o,i){const c=new b.$yn(o,i,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,y)=>c.affectsConfiguration(h,m(y))})}k(o){return o.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.$Sbc=t,e.$Tbc=(0,I.$Nh)("IExtHostConfiguration")}),define(De[94],Ce([1,0,2,11,4,6,7,39,69,40,21,44,20,26,5,17,12,13,90,291,8]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=e.$Pcc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(O){function M(U){if(U!=null)return U}O.from=M;function j(U){if(U!=null)return U}O.to=j})(l||(l={}));var t;(function(O){function M(U){if(U!=null)return U}O.from=M;function j(U){if(U!=null)return U}O.to=j})(t||(t={}));var n;(function(O){function M(U){if(U!=null)return U}O.from=M;function j(U){if(U!=null)return U}O.to=j})(n||(n={}));var o;(function(O){function M(F){if(F){const V=F;return V&&!!V.process}else return!1}O.is=M;function j(F){if(F==null)return;const V={process:F.process,args:F.args};return F.options&&(V.options=n.from(F.options)),V}O.from=j;function U(F){if(F!=null)return new R.$SK(F.process,F.args,F.options)}O.to=U})(o||(o={}));var i;(function(O){function M(U){if(U!=null)return U}O.from=M;function j(U){if(U!=null)return U}O.to=j})(i||(i={}));var c;(function(O){function M(F){if(F){const V=F;return V&&(!!V.commandLine||!!V.command)}else return!1}O.is=M;function j(F){if(F==null)return;const V={};return F.commandLine!==void 0?V.commandLine=F.commandLine:(V.command=F.command,V.args=F.args),F.options&&(V.options=i.from(F.options)),V}O.from=j;function U(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new R.$TK(F.commandLine,F.options):new R.$TK(F.command,F.args?F.args:[],F.options)}O.to=U})(c||(c={}));var h;(function(O){function M(F){if(F){const V=F;return V&&V.customExecution==="customExecution"}else return!1}O.is=M;function j(F){return{customExecution:"customExecution"}}O.from=j;function U(F,V){return V.get(F)}O.to=U})(h||(e.CustomExecutionDTO=h={}));var y;(function(O){function M(j,U){let F;return j.scope!==void 0&&typeof j.scope!="number"?F=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===R.TaskScope.Workspace&&U&&U.workspaceFile?F=U.workspaceFile:F=a.$KF),{id:j._id,workspaceFolder:F}}O.from=M})(y||(e.TaskHandleDTO=y={}));var C;(function(O){function M(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}O.from=M})(C||(C={}));var $;(function(O){function M(F,V){if(F==null)return[];const H=[];for(const fe of F){const X=j(fe,V);X&&H.push(X)}return H}O.fromMany=M;function j(F,V){if(F==null)return;let H;F.execution instanceof R.$SK?H=o.from(F.execution):F.execution instanceof R.$TK?H=c.from(F.execution):F.execution&&F.execution instanceof R.$UK&&(H=h.from(F.execution));const fe=l.from(F.definition);let X;return F.scope?typeof F.scope=="number"?X=F.scope:X=F.scope.uri:X=R.TaskScope.Workspace,!fe||!X?void 0:{_id:F._id,definition:fe,name:F.name,source:{extensionId:V.identifier.value,label:F.source,scope:X},execution:H,isBackground:F.isBackground,group:C.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}O.from=j;async function U(F,V,H){if(F==null)return;let fe;o.is(F.execution)?fe=o.to(F.execution):c.is(F.execution)?fe=c.to(F.execution):h.is(F.execution)&&(fe=h.to(F._id,H));const X=l.to(F.definition);let Y;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Y=F.source.scope:Y=await V.resolveWorkspaceFolder(D.URI.revive(F.source.scope)):Y=R.TaskScope.Workspace),!X||!Y)return;const q=new R.$VK(X,Y,F.name,F.source.label,fe,F.problemMatchers);return F.isBackground!==void 0&&(q.isBackground=F.isBackground),F.group!==void 0&&(q.group=R.$RK.from(F.group._id),q.group&&F.group.isDefault&&(q.group=new R.$RK(q.group.id,q.group.label),F.group.isDefault===!0&&(q.group.isDefault=F.group.isDefault))),F.presentationOptions&&(q.presentationOptions=t.to(F.presentationOptions)),F._id&&(q._id=F._id),F.detail&&(q.detail=F.detail),q}O.to=U})($||(e.TaskDTO=$={}));var f;(function(O){function M(U){return U}O.from=M;function j(U){if(U)return Object.assign(Object.create(null),U)}O.to=j})(f||(f={}));class d{#e;constructor(M,j,U){this._id=j,this.a=U,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let P=class{constructor(M,j,U,F,V,H,fe,X){this.q=new g.$Md,this.r=new g.$Md,this.s=new g.$Md,this.t=new g.$Md,this.a=M.getProxy(L.$9J.MainThreadTask),this.b=U,this.c=F,this.d=V,this.e=H,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=X,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,j,U){if(!U)return new R.$$J(()=>{});const F=this.w();return this.j.set(F,{type:j,provider:U,extension:M}),this.a.$registerTaskProvider(F,j),new R.$$J(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(M,j){this.a.$registerTaskSystem(M,j)}fetchTasks(M){return this.a.$fetchTasks(f.from(M)).then(async j=>{const U=[];for(const F of j){const V=await $.to(F,this.b,this.m);V&&U.push(V)}return U})}get taskExecutions(){const M=[];return this.k.forEach(j=>M.push(j)),M}terminateTask(M){if(!(M instanceof d))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,j,U){const F=this.m.get(M.id);F&&(this.o.set(M.id,F),this.e.attachPtyToTerminal(j,await F.callback(U))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const j=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const j=await this.y(M.id);this.s.fire({execution:j,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const j=await this.y(M.id);this.t.fire({execution:j,exitCode:M.exitCode})}$provideTasks(M,j){const U=this.j.get(M);if(!U)return Promise.reject(new Error("no handler found"));const F=[],V=(0,T.$Lg)(()=>U.provider.provideTasks(A.CancellationToken.None)).then(H=>this.u(j,F,U,H));return new Promise(H=>{V.then(fe=>{Promise.all(F).then(()=>{H(fe)})})})}async $resolveTask(M,j){const U=this.j.get(M);if(!U)return Promise.reject(new Error("no handler found"));if(j.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${U.type}].`);const F=await $.to(j,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const V=await U.provider.resolveTask(F,A.CancellationToken.None);if(!V)return;this.z(V,U);const H=$.from(V,U.extension);if(!H)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(H.execution)&&await this.x(H,V,!0),await this.v(H)}w(){return this.h++}async x(M,j,U){const F=await this.a.$createTaskId(M);!U&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,j.execution)),this.m.set(F,j.execution)}async y(M,j){if(typeof M=="string"){const V=this.l.get(M);if(!V)throw new m.$ab("Unexpected: The specified task is missing an execution");return V}const U=this.l.get(M.id);if(U)return U;const F=new Promise((V,H)=>{function fe(X,Y,q){q?V(new d(X,Y.id,q)):H("Unexpected: Task does not exist.")}j?fe(this,M,j):$.to(M.task,this.b,this.m).then(X=>fe(this,M,X))});return this.l.set(M.id,F),F.then(V=>(this.k.set(M.id,V),V),V=>Promise.reject(V))}z(M,j){M._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const U=this.n.values();let F=U.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=U.next()}};e.$Pcc=P,e.$Pcc=P=He([Be(0,v.$0L),Be(1,k.$nM),Be(2,b.$Qbc),Be(3,E.$iM),Be(4,w.$Tbc),Be(5,I.$_bc),Be(6,r.$8i),Be(7,s.$Gbc)],P);let N=class extends P{constructor(M,j,U,F,V,H,fe,X){super(M,j,U,F,V,H,fe,X),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:u.$i(0)})}async executeTask(M,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const U=$.from(j,M);if(U===void 0)throw new Error("Task is not valid");if(h.is(U.execution))await this.x(U,j,!1);else throw new m.$$;const F=await this.y(await this.a.$getTaskExecution(U),j);return this.a.$executeTask(U).catch(V=>{throw new Error(V)}),F}u(M,j,U,F){const V=[];if(F)for(const H of F){this.z(H,U),(!H.definition||!M[H.definition.type])&&this.f.warn(`The task [${H.source}, ${H.name}] uses an undefined task type. The task will be ignored in the future.`);const fe=$.from(H,U.extension);fe&&h.is(fe.execution)?(V.push(fe),j.push(this.x(fe,H,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:U.extension}}async v(M){if(h.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,j,U){}};e.$Qcc=N,e.$Qcc=N=He([Be(0,v.$0L),Be(1,k.$nM),Be(2,b.$Qbc),Be(3,E.$iM),Be(4,w.$Tbc),Be(5,I.$_bc),Be(6,r.$8i),Be(7,s.$Gbc)],N),e.$Rcc=(0,S.$Nh)("IExtHostTask")}),define(De[346],Ce([1,0,16,21,46,35,24,37,36]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;class w{constructor(v,k,S){this.k=v,this.l=k,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&L.$uj(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&L.$uj(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const k=this.k.folderQueries||[];return new Promise((S,p)=>{const u=r=>{this.f++,v(r)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const s=r.toString(),a=D.$mc(s);this.j&&this.j(s,a)||this.v(u,{base:r,basename:a})}),Promise.all(k.map(r=>this.p(r,u))).then(r=>{S({limitHit:this.e,stats:r[0]||void 0})},r=>{p(new Error((0,g.$yi)(r)))})})}async p(v,k){const S=new T.$Wd,p=this.q(v),u=this.r(),r=new E.$TI(this.k,v),s=!r.hasSiblingExcludeClauses();let a;try{this.h.add(S),a=b.$Id.create();const m=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},p,S.token),l=a.elapsed(),t=b.$Id.create();return this.g&&!this.e||(m&&m.forEach(n=>{const o=D.$fc.relative(v.folder.path,n.path);if(s){const i=D.$mc(n.path);this.v(k,{base:v.folder,relativePath:o,basename:i});return}this.s(u,v.folder,o,k)}),this.g&&!this.e)?null:(this.u(u,r,k),{providerTime:l,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(v){const k=(0,E.$SI)(this.k.includePattern,v.includePattern),S=(0,E.$SI)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:S,includes:k,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},k,S,p){if(S===this.a){const r=D.$mc(this.a);this.v(p,{base:k,relativePath:this.a,basename:r})}function u(r){const s=D.$mc(r),a=D.$lc(r);let m=v[a];m||(m=v[a]=[],u(a)),m.push({base:k,relativePath:r,basename:s})}u(S)}u({rootEntries:v,pathToEntries:k},S,p){const u=this,r=this.a;function s(a){const m=(0,E.$VI)(()=>a.map(l=>l.basename));for(let l=0,t=a.length;l<t;l++){const n=a[l],{relativePath:o,basename:i}=n;if(S.matchesExcludesSync(o,i,r!==i?m:void 0))continue;const c=k[o];if(c)s(c);else{if(o===r)continue;u.v(p,n)}if(u.e)break}}s(v)}v(v,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(k))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(v,k,S,p){const u=this.c(v.cacheKey),r=new w(v,k,u&&u.token);let s=0;const a=m=>{s+=m.length,S(m.map(l=>this.d(l)))};return this.e(r,A.a,a,p).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:s,detailStats:m.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(v)return this.b.has(v)||this.b.set(v,new T.$Wd),this.b.get(v)}d(v){return v.relativePath?{resource:R.$ug(v.base,v.relativePath)}:{resource:v.base}}e(v,k,S,p){const u=p.onCancellationRequested(()=>{v.cancel()}),r=a=>{a&&(s.push(a),k>0&&s.length>=k&&(S(s),s=[]))};let s=[];return v.search(r).then(a=>(s.length&&S(s),u.dispose(),a),a=>(s.length&&S(s),u.dispose(),Promise.reject(a)))}}e.$2cc=A}),define(De[347],Ce([1,0,19,73,35,100,28,17,16,24,15,18,2,172,226,49,13,43,143,344,36]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.$MJ=void 0;let l=class{constructor(f,d,P,N,O){this.a=f,this.b=d,this.c=P,this.d=N,this.e=O}text(f,d,P={}){f=this.f(f,P);const N=this.a.getValue(),O=d&&d.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(d?.map(r.$9h),P),type:2,contentPattern:f,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:N.search.usePCRE2||O||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(f,d){const P=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const N={...f,wordSeparators:P.editor.wordSeparators};return this.j(f,d)&&(N.isCaseSensitive=!0),this.k(f)&&(N.isMultiline=!0),d.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=d.notebookSearchConfig.includeMarkupInput),d.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=d.notebookSearchConfig.includeMarkupPreview),d.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=d.notebookSearchConfig.includeCodeInput),d.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=d.notebookSearchConfig.includeOutput),N}file(f,d={}){return{...this.h(f,d),type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey}}g(f,d){return f?(f=Array.isArray(f)?f.map(c):c(f),d?this.parseSearchPaths(f):{pattern:n(...Array.isArray(f)?f:[f])}):{}}h(f=[],d={}){const P=this.g(d.includePattern,d.expandPatterns),N=this.g(d.excludePattern,d.expandPatterns),O=f.length>1,M=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(F=>this.q(F,d,N)):f.map(F=>this.r(F,d,N,O))).filter(F=>!!F),j={_reason:d._reason,folderQueries:M,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:N.pattern,includePattern:P.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const F=D.$Gb(D.$Qb(this.c.groups.map(fe=>fe.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const V=F.filter(fe=>(0,m.$JI)(j,fe.fsPath)),H=this.i(V);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(H)),{...j,...H}}const U=d.extraFileResources&&d.extraFileResources.filter(F=>(0,m.$JI)(j,F.fsPath));return j.extraFileResources=U&&U.length?U:void 0,j}i(f){const d=[],P=new R.$zc,N={};let O=!1;return f.forEach(M=>{if(M.scheme===b.Schemas.walkThrough)return;if((0,w.$yg)(M)){const U=this.b.getWorkspaceFolder(M)?.uri??M.with({path:E.$lc(M.fsPath)});let F=P.get(U);F||(O=!0,F={folder:U,includePattern:{}},d.push(F),P.set(U,F));const V=E.$kc(U.fsPath,M.fsPath);(0,I.$If)(F.includePattern)[V.replace(/\\/g,"/")]=!0}else M.fsPath&&(O=!0,N[M.fsPath]=!0)}),{folderQueries:d,includePattern:N,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(f,d){if(d.isSmartCase){if(f.isRegExp){if(A.$of(f.pattern,!0))return!0}else if(A.$of(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,k.$nB)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const d=H=>E.$hc(H)||/^\.\.?([\/\\]|$)/.test(H),N=(Array.isArray(f)?f:o(f)).map(H=>{const fe=this.e.resolvedUserHome;return fe?(0,L.$nv)(H,fe.scheme===b.Schemas.file?fe.fsPath:fe.path):H}),O=T.$J(N,H=>d(H)?"searchPaths":"exprSegments"),M=(O.exprSegments||[]).map(H=>A.$Je(H,"/")).map(H=>A.$Je(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),i(H))),j={},U=this.m(O.searchPaths||[]);U&&U.length&&(j.searchPaths=U);const F=D.$Qb(M),V=n(...F);return V&&(j.pattern=V),j}l(f,d){return d.disregardExcludeSettings?void 0:(0,m.$II)(f,!d.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const d=f.flatMap(N=>{let{pathPortion:O,globPortion:M}=t(N);return M&&(M=h(M)),this.n(O).flatMap(U=>this.o(U,M))}),P=new Map;return d.forEach(N=>{const O=N.searchPath.toString(),M=P.get(O);M?N.pattern&&(M.pattern=M.pattern||{},M.pattern[N.pattern]=!0):P.set(O,{searchPath:N.searchPath,pattern:N.pattern?n(N.pattern):void 0})}),Array.from(P.values())}n(f){if(E.$hc(f)){const d=this.b.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==b.Schemas.file?[{searchPath:d[0].uri.with({path:f})}]:[{searchPath:v.URI.file(E.$gc(f))}]}if(this.b.getWorkbenchState()===2){const d=this.b.getWorkspace().folders[0].uri;if(f=c(f),f.startsWith("../")||f===".."){const N=E.$fc.resolve(d.path,f);return[{searchPath:d.with({path:N})}]}const P=h(f);return[{searchPath:d,pattern:P}]}else{if(f==="./"||f===".\\")return[];{const d=f.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(O=>{const M=d.match(new RegExp(`^${A.$Ee(O.name)}(?:/(.*)|$)`));return M?{match:M,folder:O}:null}).filter(I.$Ff);if(N.length)return N.map(O=>{const M=O.match[1];return{searchPath:O.folder.uri,pattern:M&&h(M)}});{const O=f.match(/\.[\/\\](.+)[\/\\]?/),M=O?O[1]:f,j=S.localize(0,null,M);throw new Error(j)}}}}o(f,d){const P=f.pattern&&d?`${f.pattern}/${d}`:f.pattern||d,N=[{searchPath:f.searchPath,pattern:P}];return P&&!P.endsWith("**")&&N.push({searchPath:f.searchPath,pattern:P+"/**"}),N}q(f,d,P){const N=this.r((0,r.$9h)(f.searchPath),d,P,!1);return N?{...N,includePattern:f.pattern}:null}r(f,d,P,N){let O;const M=v.URI.isUri(f)?f:f.uri;if(P.searchPaths){const H=P.searchPaths.filter(fe=>(0,w.$ng)(fe.searchPath,M))[0];if(H&&!H.pattern)return null;H&&(O=H.pattern)}const j=this.a.getValue({resource:M}),F={...this.l(j,d)||{},...O||{}},V=v.URI.isUri(f)?(0,w.$rg)(f):f.name;return{folder:M,folderName:N?V:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof d.disregardParentIgnoreFiles=="boolean"?d.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!j.search.followSymlinks}}};e.$MJ=l,e.$MJ=l=He([Be(0,p.$hi),Be(1,r.$Wh),Be(2,s.$0B),Be(3,u.$8i),Be(4,a.$KJ)],l);function t($){const f=$.match(/[\*\{\}\(\)\[\]\?]/);if(f){const d=f.index,P=$.substr(0,d).match(/[/|\\][^/\\]*$/);if(P){let N=$.substr(0,P.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:$.substr((P.index||0)+1)}}}return{pathPortion:$}}function n(...$){return $.length?$.reduce((f,d)=>(f[d]=!0,f),Object.create(null)):void 0}function o($){return g.$sj($,",").map(f=>f.trim()).filter(f=>!!f.length)}function i($){return[`**/${$}/**`,`**/${$}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function c($){return $.replace(/\\/g,"/")}function h($){return c($).replace(/^\.\//,"").replace(/\/+$/g,"")}function y($){return $.replace(/([?*[\]])/g,"[$1]")}function C($,f){$=D.$Lb($,N=>N.toString());const d=[],P=f.getWorkspace();return $&&$.forEach(N=>{let O;if(f.getWorkbenchState()===2)O=(0,w.$wg)(P.folders[0].uri,N),O&&O!=="."&&(O="./"+O);else{const M=f.getWorkspaceFolder(N);if(M){const j=M.name;if(P.folders.filter(F=>F.name===j).length===1){const F=(0,w.$wg)(M.uri,N);F===""?O=`./${M.name}`:O=`./${M.name}/${F}`}else O=N.fsPath}}O&&d.push(y(O))}),d}e.$NJ=C}),define(De[348],Ce([1,0,24,2,21,8,5,347,36,43]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlb=e.$llb=void 0;const A=7e3;function I(p,u){const r=u.activationEvents;if(!r)return Promise.resolve(void 0);const s=[],a=[];for(const i of r)if(/^workspaceContains:/.test(i)){const c=i.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||p.forceUsingSearch?a.push(c):s.push(c)}if(s.length===0&&a.length===0)return Promise.resolve(void 0);let m;const l=new Promise((i,c)=>{m=i}),t=i=>m({activationEvent:i}),n=Promise.all(s.map(i=>v(p,i,t))).then(()=>{}),o=k(p,u.identifier,a,t);return Promise.all([n,o]).then(()=>{m(void 0)}),l}e.$llb=I;async function v(p,u,r){for(const s of p.folders)if(await p.exists(D.$ug(T.URI.revive(s),u))){r(`workspaceContains:${u}`);return}}async function k(p,u,r,s){if(r.length===0)return Promise.resolve(void 0);const a=new g.$Wd,m=p.checkExists(p.folders,r,a.token),l=setTimeout(async()=>{a.cancel(),p.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},A);let t=!1;try{t=await m}catch(n){L.$3(n)||L.$Z(n)}a.dispose(),clearTimeout(l),t&&s(`workspaceContains:${r.join(",")}`)}function S(p,u,r,s){const a=p.get(R.$Mh),m=p.get(E.$AI),t=a.createInstance(b.$MJ).file(u.map(n=>(0,w.$9h)(T.URI.revive(n))),{_reason:"checkExists",includePattern:r,exists:!0});return m.fileSearch(t,s).then(n=>!!n.limitHit,n=>L.$3(n)?!1:Promise.reject(n))}e.$mlb=S}),define(De[45],Ce([1,0,204,16,54,24,11,3,77,2,13,6,40,286,115,39,27,148,8,25,22,262,7,64,5,26,91,20,105,72,44,4,348,114,264,17,112,37,12,113]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m,l,t,n,o,i,c,h,y,C,$,f,d,P,N,O,M,j,U,F){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=e.$ncc=e.$mcc=e.$lcc=e.$kcc=void 0,e.$kcc=(0,o.$Nh)("IHostUtils");let H=V=class extends b.$Rc{constructor(G,z,K,ge,_,ie,ne,Ee,oe,he,ee,le){super(),this.X=le,this.a=this.B(new f.$Md),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=z,this.g=K,this.f=ne,this.j=ge,this.m=_,this.s=ie,this.t=oe,this.u=he,this.w=ee,this.y=this.g.getProxy(I.$9J.MainThreadWorkspace),this.z=this.g.getProxy(I.$9J.MainThreadTelemetry),this.C=this.g.getProxy(I.$9J.MainThreadExtensionService),this.D=new R.$Rg,this.F=new R.$Rg,this.G=new R.$Rg,this.H=new R.$Rg,this.I=new ue(this.f.extensions.activationEvents),this.L=new r.$63b(this.I,this.f.extensions.allExtensions);const be=new a.$Zl(this.f.extensions.myExtensions);this.J=new r.$63b(this.I,x(this.L,be)),U.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Y(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Y(this.J)}`)),this.M=new S.$4bc(this.g,this.s),this.N=new P.$dcc(this.g),this.O=Ee,this.h=G.createChild(new y.$Lh([S.$5bc,this.M],[P.$ecc,this.N])),this.P=this.B(new k.$3bc(this.J,this.L,{onExtensionActivationError:(Pe,B,Q)=>{this.C.$onExtensionActivationError(Pe,s.$2(B),Q)},actualActivateExtension:async(Pe,B)=>{if(r.$63b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,B),new k.$2bc;const Q=this.J.getExtensionDescription(Pe);return this.db(Q,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(G){s.$Z(G)}}async Y(){this.O.onWillDeactivateAll();let G=[];try{G=this.J.getAllExtensionDescriptions().map(_=>_.identifier).filter(_=>this.isActivated(_)).map(_=>this.cb(_))}catch{}await Promise.all(G)}terminate(G,z=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${G}`),this.s.flush(),this.u.dispose(),this.P.dispose(),s.setUnexpectedErrorHandler(ge=>{this.s.error(ge)}),this.g.dispose();const K=this.Y();Promise.race([(0,R.$Tg)(5e3),K]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(G){return this.G.isOpen()?this.P.isActivated(G):!1}async getExtension(G){const z=await this.C.$getExtension(G);return z&&{...z,identifier:new a.$Yl(z.identifier.value),extensionLocation:w.URI.revive(z.extensionLocation)}}Z(G,z){return this.P.activateByEvent(G,z)}$(G,z){return this.P.activateById(G,z)}activateByIdWithErrors(G,z){return this.$(G,z).then(()=>{const K=this.P.getActivatedExtension(G);if(K.activationFailed)return Promise.reject(K.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(G=>this.J)}getExtensionExports(G){if(this.G.isOpen())return this.P.getActivatedExtension(G).exports;try{return this.P.getActivatedExtension(G).exports}catch{return null}}async ab(G){if(G.scheme===O.Schemas.file&&this.c.fsRealpath){const z=await this.c.fsRealpath(G.fsPath);return w.URI.file(z)}return G}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(G=>new me(G))),this.Q}async bb(G){const z=E.$Th.forUris(K=>L.$lg.ignorePathCasing(K));return await Promise.all(G.map(async K=>{if(this.ub(K)){const ge=await this.ab(K.extensionLocation);z.set(ge,K)}})),z}cb(G){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(G))return z;const K=this.P.getActivatedExtension(G);if(!K)return z;try{typeof K.module.deactivate=="function"&&(z=Promise.resolve(K.module.deactivate()).then(void 0,ge=>(this.s.error(ge),Promise.resolve(void 0))))}catch(ge){this.s.error(`An error occurred when deactivating the extension '${G.value}':`),this.s.error(ge)}try{(0,b.$Mc)(K.subscriptions)}catch(ge){this.s.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this.s.error(ge)}return z}async db(G,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(G.identifier):await this.C.$onWillActivateExtension(G.identifier),this.fb(G,z).then(K=>{const ge=K.activationTimes;return this.C.$onDidActivateExtension(G.identifier,ge.codeLoadingTime,ge.activateCallTime,ge.activateResolvedTime,z),this.eb(G,z,"success",ge),K},K=>{throw this.eb(G,z,"failure"),K})}eb(G,z,K,ge){const _=X(G,z);this.z.$publicLog2("extensionActivationTimes",{..._,...ge||{},outcome:K})}fb(G,z){const K=X(G,z);this.z.$publicLog2("activatePlugin",K);const ge=this.ub(G);if(!ge)return Promise.resolve(new k.$1bc(k.$Xbc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${G.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const _=new k.$Ybc(z.startup);return Promise.all([this.vb(G,(0,L.$ug)(G.extensionLocation,ge),_),this.gb(G)]).then(ie=>(g.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),V.hb(this.s,G.identifier,ie[0],ie[1],_))).then(ie=>(g.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),ie))}gb(G){const z=new l.$7bc(G,this.M),K=new l.$6bc(G.identifier.value,!1,this.M),ge=new N.$fcc(G,this.N),_=G.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ie=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([z.whenReady,K.whenReady,this.O.whenReady]).then(()=>{const ne=this;let Ee,oe;const he=(0,u.$8E)(G,"ipc")?this.f.messagePorts?.get(a.$Yl.toKey(G.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:K,secrets:ge,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(ee){return T.$ic(G.extensionLocation.fsPath,ee)},get storagePath(){return ne.O.workspaceValue(G)?.fsPath},get globalStoragePath(){return ne.O.globalValue(G).fsPath},get logPath(){return T.$ic(ne.f.logsLocation.fsPath,G.identifier.value)},get logUri(){return w.URI.joinPath(ne.f.logsLocation,G.identifier.value)},get storageUri(){return ne.O.workspaceValue(G)},get globalStorageUri(){return ne.O.globalValue(G)},get extensionMode(){return _},get extension(){return Ee===void 0&&(Ee=new q(ne,G.identifier,G,ie,!1)),Ee},get extensionRuntime(){return(0,u.$9E)(G,"extensionRuntime"),ne.extensionRuntime},get environmentVariableCollection(){return ne.u.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!oe){if(!he)return;const ee=f.Event.buffer(f.Event.fromDOMEventEmitter(he,"message",le=>le.data));he.start(),oe={onDidReceiveMessage:ee,postMessage:he.postMessage.bind(he)}}return oe}})})}static hb(G,z,K,ge,_){return K=K||{activate:void 0,deactivate:void 0},this.ib(G,z,K,ge,_).then(ie=>new k.$Zbc(!1,null,_.build(),K,ie,ge.subscriptions))}static ib(G,z,K,ge,_){if(typeof K.activate=="function")try{_.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${z.value}`);const ie=typeof global=="object"?global:self,ne=K.activate.apply(ie,[ge]);return _.activateCallStop(),_.activateResolveStart(),Promise.resolve(ne).then(Ee=>(_.activateResolveStop(),Ee))}catch(ie){return Promise.reject(ie)}else return Promise.resolve(K)}jb(G,z){this.$(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:z}).then(void 0,K=>{this.s.error(K)})}kb(G,z=0){const ge=Date.now();(0,U.$B)(()=>{for(let _=z;_<G.length;_+=1){const ie=G[_];for(const ne of ie.activationEvents??[])if(ne==="onStartupFinished")if(Date.now()-ge>50){this.kb(G,_);break}else this.jb(ie,ne)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(G=>{const z=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),K=this.J.getAllExtensionDescriptions();if(z)this.kb(K);else for(const ge of K)if(ge.activationEvents)for(const _ of ge.activationEvents)_==="onStartupFinished"&&this.jb(ge,_)})}mb(){const G=this.Z("*",!0).then(void 0,ie=>{this.s.error(ie)});this.B(this.j.onDidChangeWorkspace(ie=>this.nb(ie.added)));const z=this.j.workspace?this.j.workspace.folders:[],K=this.nb(z),ge=this.pb(),_=Promise.all([ge,G,K]).then(()=>{});return Promise.race([_,(0,R.$Tg)(1e4)]).then(()=>{this.lb()}),_}nb(G){return G.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.ob(G,z))).then(()=>{})}async ob(G,z){if(this.isActivated(z.identifier))return;const K=!this.f.remote.isRemote&&!!this.f.remote.authority,ge={logService:this.s,folders:G.map(ie=>ie.uri),forceUsingSearch:K||!this.c.fsExists,exists:ie=>this.c.fsExists(ie.fsPath),checkExists:(ie,ne,Ee)=>this.y.$checkExists(ie,ne,Ee)},_=await(0,d.$llb)(ge,z);if(_)return this.$(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:_.activationEvent}).then(void 0,ie=>this.s.error(ie))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(G){throw console.error(G),G}}async qb(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:z}=this.f.environment;if(!G||!z)throw new Error(D.localize(0,null));const K=await this.vb(null,z,new k.$Ybc(!1));if(!K||typeof K.run!="function")throw new Error(D.localize(1,null,z.toString()));return new Promise((ge,_)=>{const ie=(oe,he)=>{oe?(U.$t&&this.s.error("Test runner called back with error",oe),_(oe)):(U.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),ge(typeof he=="number"&&he>0?1:0))},ne=(0,L.$ig)(z),Ee=K.run(ne,ie);Ee&&Ee.then&&Ee.then(()=>{U.$t&&this.s.info("Test runner finished successfully."),ge(0)}).catch(oe=>{U.$t&&this.s.error("Test runner finished with error",oe),_(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Tg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,z){return this.R[G]=z,(0,b.$Pc)(()=>{delete this.R[G]})}async getRemoteExecServer(G){const{resolver:z}=await this.sb(G);return z?.resolveExecServer?.(G,{resolveAttempt:0})}async sb(G){const z=G.indexOf("+");if(z===-1)throw new t.$eK("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const K=G.substr(0,z);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${K}`,!1),{authorityPrefix:K,resolver:this.R[K]}}async $resolveAuthority(G,z){const K=j.$Id.create(!1),ge=()=>`[resolveAuthority(${(0,n.$Qk)(G)},${z})][${K.elapsed()}ms] `,_=re=>this.s.info(`${ge()}${re}`),ie=re=>this.s.warn(`${ge()}${re}`),ne=(re,Z=void 0)=>this.s.error(`${ge()}${re}`,Z),Ee=re=>{if(re instanceof t.$eK)return{type:"error",error:{code:re._code,message:re._message,detail:re._detail}};throw re},oe=async re=>{_(`activating resolver for ${re}...`);const{resolver:Z,authorityPrefix:de}=await this.sb(re);if(!Z)throw ne(`no resolver for ${de}`),new t.$eK(`No remote extension installed to resolve ${de}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Z,authorityPrefix:de,remoteAuthority:re}},he=G.split(/@|%40/g).reverse();_(`activating remote resolvers ${he.join(" -> ")}`);let ee;try{ee=await Promise.all(he.map(oe)).catch(async re=>{if(!(re instanceof t.$eK)||re._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw re;return ie(`resolving nested authorities failed: ${re.message}`),[await oe(G)]})}catch(re){return Ee(re)}const le=new R.$4g;le.cancelAndSet(()=>_("waiting..."),1e3);let be,Pe;for(const[re,{authorityPrefix:Z,resolver:de,remoteAuthority:ye}]of ee.entries())try{if(re===ee.length-1)_("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${Z}`),be=await de.resolve(ye,{resolveAttempt:z,execServer:Pe}),g.mark(`code/extHost/didResolveAuthorityOK/${Z}`),_("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(de,t.$dK.isManagedResolvedAuthority(be)?be:void 0));else{if(_(`invoking resolveExecServer() for ${ye}`),g.mark(`code/extHost/willResolveExecServer/${Z}`),Pe=await de.resolveExecServer?.(ye,{resolveAttempt:z,execServer:Pe}),!Pe)throw new t.$eK(`Exec server was not available for ${ye}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${Z}`)}}catch(je){return g.mark(`code/extHost/didResolveAuthorityError/${Z}`),ne("returned an error",je),le.dispose(),Ee(je)}le.dispose();const B={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},Q={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};_(`returned ${t.$dK.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let te;if(t.$dK.isManagedResolvedAuthority(be)){const re=z;this.X.setFactory(re,be.makeConnection),te={authority:G,connectTo:new n.$Nk(re),connectionToken:be.connectionToken}}else te={authority:G,connectTo:new n.$Ok(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:te,options:Q,tunnelInformation:B}}}async $getCanonicalURI(G,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Qk)(G)})`);const{resolver:K}=await this.sb(G);if(!K)return null;const ge=w.URI.revive(z);if(typeof K.getCanonicalURI>"u")return ge;const _=await(0,R.$Lg)(()=>K.getCanonicalURI(ge));return _||ge}$startExtensionHost(G){G.toAdd.forEach(ge=>ge.extensionLocation=w.URI.revive(ge.extensionLocation));const{globalRegistry:z,myExtensions:K}=fe(this.I,this.L,this.J,G);return this.L.set(z.getAllExtensionDescriptions()),this.J.set(K),U.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Y(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Y(this.J)}`)),this.rb()}$activateByEvent(G,z){return z===1?this.D.wait().then(K=>this.Z(G,!1)):this.G.wait().then(K=>this.Z(G,!1))}async $activate(G,z){return await this.G.wait(),this.J.getExtensionDescription(G)?(await this.$(G,z),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(ie=>ie.extensionLocation=w.URI.revive(ie.extensionLocation));const{globalRegistry:z,myExtensions:K}=fe(this.I,this.L,this.J,G),ge=await this.bb(K);return(await this.getExtensionPathIndex()).setSearchTree(ge),this.L.set(z.getAllExtensionDescriptions()),this.J.set(K),U.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Y(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Y(this.J)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const z=m.$ae.alloc(G),K=Math.random()%256;for(let ge=0;ge<G;ge++)z.writeUInt8(K,ge);return z}async $updateRemoteConnectionData(G){this.W=G,this.a.fire()}};e.$lcc=H,e.$lcc=H=V=He([Be(0,o.$Mh),Be(1,e.$kcc),Be(2,h.$0L),Be(3,p.$Qbc),Be(4,v.$Tbc),Be(5,A.$8i),Be(6,i.$nM),Be(7,c.$0bc),Be(8,C.$Rvb),Be(9,$.$_bc),Be(10,M.$hcc),Be(11,F.$icc)],H);function fe(pe,G,z,K){pe.addActivationEvents(K.addActivationEvents);const ge=new r.$63b(pe,G.getAllExtensionDescriptions());ge.deltaExtensions(K.toAdd,K.toRemove);const _=new a.$Zl(z.getAllExtensionDescriptions().map(ne=>ne.identifier));for(const ne of K.myToRemove)_.delete(ne);for(const ne of K.myToAdd)_.add(ne);const ie=x(ge,_);return{globalRegistry:ge,myExtensions:ie}}function X(pe,G){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function Y(pe){return pe.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.$mcc=(0,o.$Nh)("IExtHostExtensionService");class q{#e;#t;#i;constructor(G,z,K,ge,_){this.#e=G,this.#t=z,this.#i=K.identifier,this.id=K.identifier.value,this.extensionUri=K.extensionLocation,this.extensionPath=T.$gc((0,L.$ig)(K.extensionLocation)),this.packageJSON=K,this.extensionKind=ge,this.isFromDifferentExtensionHost=_}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$ncc=q;function x(pe,G){return pe.getAllExtensionDescriptions().filter(z=>G.has(z.identifier))}class me{constructor(G){this.a=G}setSearchTree(G){this.a=G}findSubstr(G){return this.a.findSubstr(G)}forEach(G){return this.a.forEach(G)}}e.$occ=me;class ue{constructor(G){this.a=new a.$1l,this.addActivationEvents(G)}readActivationEvents(G){return this.a.get(G.identifier)}addActivationEvents(G){for(const z of Object.keys(G))this.a.set(z,G[z])}}}),define(De[349],Ce([1,0,54,2,6,40,27,25,20,26,5,45,13,15]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;let p=class{constructor(m,l,t,n,o,i,c){this.c=m,this.d=l,this.e=t,this.f=n,this.g=o,this.h=i,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const m=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new r(this.c,l,this.d,m,this.i)),this.register(this.e.createInstance(u)),this.h.remote.isRemote&&this.register(this.e.createInstance(s,l,this.h.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const l of m.nodeModuleName)this.a.set(l,m);else this.a.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this.b.push(l=>m.alternativeModuleName(l))}};e.$Kdc=p,e.$Kdc=p=He([Be(2,A.$Mh),Be(3,L.$Tbc),Be(4,I.$mcc),Be(5,w.$nM),Be(6,v.$8i)],p);let u=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(m){if(m.environment.appRoot&&S.a.size){const l=(0,k.$Ee)(this.c(m.environment.appRoot.fsPath)),t="[a-z0-9_.-]",n=`@${t}+\\/${t}+|${t}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${o}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(m){if(!this.b)return;const l=this.b.exec(this.c(m));if(!l)return;const[,t,n,o]=l,i=S.a.get(n);if(i!==void 0)return console.warn(`${n} as been renamed to ${i}, please update your imports`),t+i+o}c(m){return m.replace(/\\/g,"/")}};u=S=He([Be(0,w.$nM)],u);class r{constructor(m,l,t,n,o){this.c=m,this.d=l,this.e=t,this.f=n,this.g=o,this.nodeModuleName="vscode",this.a=new b.$1l}load(m,l){const t=this.d.findSubstr(l);if(t){let n=this.a.get(t.identifier);return n||(n=this.c(t,this.e,this.f),this.a.set(t.identifier,n)),n}if(!this.b){let n="";this.d.forEach((o,i)=>n+=`	${i} -> ${o.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${n}`),this.b=this.c(R.$3E,this.e,this.f)}return this.b}}let s=class{constructor(m,l,t){this.e=m,this.f=l,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$9J.MainThreadTelemetry);const n=t.getProxy(g.$9J.MainThreadWindow);this.c=(o,i)=>{const c=T.URI.parse(o);return i?this.g(o,i):c.scheme==="http"||c.scheme==="https"?n.$openUri(c,o,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?n.$openUri(c,o,{}):this.g(o,i)}}load(m,l,t){const n=this.e.findSubstr(l);return n&&(this.a=n.identifier.value,this.h()),this.b=t(m),this.c}g(m,l){return this.i(),this.b(m,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};s=He([Be(2,E.$0L)],s)}),define(De[56],Ce([1,0,51,3,16,47,5,69,70,45,7,39,278,40]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=e.$Ucc=void 0,e.$Ucc=(0,R.$Nh)("IExtHostVariableResolverProvider");class S extends v.$$M{constructor(r,s,a,m,l,t,n){function o(){if(a){const i=a.activeEditor();if(i)return i.document.uri;const c=m.tabGroups.all.find(h=>h.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof A.$QL||c.input instanceof A.$VL)return c.input.modified;if(c.input instanceof A.$PL||c.input instanceof A.$UL||c.input instanceof A.$SL)return c.input.uri}}}super({getFolderUri:i=>{const c=t.folders.filter(h=>h.name===i);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,c)=>l.getConfiguration(void 0,i).get(c),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=o();if(i)return g.$gc(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(s){const i=o();if(i){const c=s.getWorkspaceFolder(i);if(c)return g.$gc(c.uri.fsPath)}}},getSelectedText:()=>{if(a){const i=a.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(a){const i=a.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>r.getExtension(i)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(L.env))}}let p=class extends T.$Rc{constructor(r,s,a,m,l){super(),this.b=r,this.c=s,this.g=a,this.h=m,this.j=l,this.a=new D.$U(async()=>{const t=await this.h.getConfigProvider(),o={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async i=>{o.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,o,this.m())})}getResolver(){return this.a.value}m(){}};e.$Vcc=p,e.$Vcc=p=He([Be(0,w.$mcc),Be(1,I.$Qbc),Be(2,b.$iM),Be(3,k.$Tbc),Be(4,E.$Scc)],p)}),define(De[95],Ce([1,0,11,4,2,5,6,70,45,20,7,39,140,271,40,56]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=e.$Ycc=e.$Xcc=e.$Wcc=void 0,e.$Wcc=(0,L.$Nh)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,o,i,c,h,y){this.E=o,this.F=i,this.G=c,this.H=h,this.I=y,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Md,this.n=new T.$Md,this.o=new T.$Md,this.u=new T.$Md,this.k=n.getProxy(R.$9J.MainThreadDebugService),this.y=new T.$Md,this.A=new T.$Md,this.v=new s(this.k),this.w=new Map,this.F.getExtensionRegistry().then(C=>{C.onDidChange($=>{this.J(C)}),this.J(C)})}asDebugSourceUri(n,o){const i=n;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let c=`debug:${encodeURIComponent(i.path||"")}`,h="?";return o&&(c+=`${h}session=${encodeURIComponent(o.id)}`,h="&"),c+=`${h}ref=${i.sourceReference}`,g.URI.parse(c)}else{if(i.path)return g.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(n){const o=[];for(const i of n.getAllExtensionDescriptions())if(i.contributes){const c=i.contributes.debuggers;if(c&&c.length>0)for(const h of c)(0,k.$nF)(h)&&o.push(h.type)}this.k.$registerDebugTypes(o)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const n=[];return this.w.forEach(o=>n.push(o)),n}addBreakpoints(n){const o=n.filter(h=>{const y=h.id;return this.w.has(y)?!1:(this.w.set(y,h),!0)});this.U(o,[],[]);const i=[],c=new Map;for(const h of o)if(h instanceof A.$0K){let y=c.get(h.location.uri.toString());y||(y={type:"sourceMulti",uri:h.location.uri,lines:[]},c.set(h.location.uri.toString(),y),i.push(y)),y.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof A.$$K&&i.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(n){const o=n.filter(y=>this.w.delete(y.id));this.U([],o,[]);const i=o.filter(y=>y instanceof A.$0K).map(y=>y.id),c=o.filter(y=>y instanceof A.$$K).map(y=>y.id),h=o.filter(y=>y instanceof A.$_K).map(y=>y.id);return this.k.$unregisterBreakpoints(i,c,h)}startDebugging(n,o,i){return this.k.$startDebugging(n?n.uri:void 0,o,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,o,i){if(!o)return new A.$$J(()=>{});const c=this.d++;return this.f.push({type:n,handle:c,provider:o}),this.k.$registerDebugConfigurationProvider(n,i,!!o.provideDebugConfigurations,!!o.resolveDebugConfiguration,!!o.resolveDebugConfigurationWithSubstitutedVariables,c),new A.$$J(()=>{this.f=this.f.filter(h=>h.provider!==o),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(n,o,i){if(!i)return new A.$$J(()=>{});if(!this.Q(n,o))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${o}' debugger.`);if(this.N(o))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:o,handle:c,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(o,c),new A.$$J(()=>{this.h=this.h.filter(h=>h.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(n,o){if(!o)return new A.$$J(()=>{});const i=this.i++;return this.j.push({type:n,handle:i,factory:o}),new A.$$J(()=>{this.j=this.j.filter(c=>c.factory!==o)})}async $runInTerminal(n,o){return Promise.resolve(void 0)}async $substituteVariables(n,o){let i;const c=await this.W(n);return c&&(i={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(i,o)}K(n,o){if(n.type==="implementation")return new m(n.implementation)}L(){}async $startDASession(n,o){const i=this,c=await this.V(o);return this.S(this.N(c.type),c).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const y=this.M(h),C=this.K(y,c);if(!C)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const $=C;return this.B.set(n,$),this.R(c).then(f=>(f&&this.C.set(n,f),$.onMessage(async d=>{if(d.type==="request"&&d.command==="handshake"){const P=d,N={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const O=await this.D.sign(P.arguments.value);N.body={signature:O},$.sendResponse(N)}else throw new Error("no signer")}catch(O){N.success=!1,N.message=O.message,$.sendResponse(N)}}else f&&f.onDidSendMessage&&f.onDidSendMessage(d),d=(0,k.$sF)(d,!0),i.k.$acceptDAMessage(n,d)}),$.onError(d=>{f&&f.onError&&f.onError(d),this.k.$acceptDAError(n,d.name,d.message,d.stack)}),$.onExit(d=>{f&&f.onExit&&f.onExit(d??void 0,void 0),this.k.$acceptDAExit(n,d??void 0,void 0)}),f&&f.onWillStartSession&&f.onWillStartSession(),$.startSession()))})}$sendDAMessage(n,o){o=(0,k.$rF)(o,!1);const i=this.C.get(n);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(o),this.B.get(n)?.sendMessage(o)}$stopDASession(n){const o=this.C.get(n);this.C.delete(n),o&&o.onWillStopSession&&o.onWillStopSession();const i=this.B.get(n);return this.B.delete(n),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const o=[],i=[],c=[];if(n.added)for(const h of n.added){const y=h.id;if(y&&!this.w.has(y)){let C;if(h.type==="function")C=new A.$$K(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")C=new A.$_K(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const $=g.URI.revive(h.uri);C=new A.$0K(new A.$kK($,new A.$_J(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,A.$8K)(C,y),this.w.set(y,C),o.push(C)}}if(n.removed)for(const h of n.removed){const y=this.w.get(h);y&&(this.w.delete(h),i.push(y))}if(n.changed){for(const h of n.changed)if(h.id){const y=this.w.get(h.id);if(y){if(y instanceof A.$$K&&h.type==="function"){const C=y;C.enabled=h.enabled,C.condition=h.condition,C.hitCondition=h.hitCondition,C.logMessage=h.logMessage,C.functionName=h.functionName}else if(y instanceof A.$0K&&h.type==="source"){const C=y;C.enabled=h.enabled,C.condition=h.condition,C.hitCondition=h.hitCondition,C.logMessage=h.logMessage,C.location=new A.$kK(g.URI.revive(h.uri),new A.$_J(h.line,h.character))}c.push(y)}}}this.U(o,i,c)}async $acceptStackFrameFocus(n){let o;const i=n.sessionId?await this.V(n.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?o=new A.$fL(i,n.threadId):o=new A.$eL(i,n.threadId,n.frameId),this.z=o,this.A.fire(this.z)}$provideDebugConfigurations(n,o,i){return(0,D.$Lg)(async()=>{const c=this.P(n);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(o);return c.provideDebugConfigurations(h,i)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(n,o,i,c){return(0,D.$Lg)(async()=>{const h=this.P(n);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const y=await this.W(o);return h.resolveDebugConfiguration(y,i,c)})}$resolveDebugConfigurationWithSubstitutedVariables(n,o,i,c){return(0,D.$Lg)(async()=>{const h=this.P(n);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const y=await this.W(o);return h.resolveDebugConfigurationWithSubstitutedVariables(y,i,c)})}async $provideDebugAdapter(n,o){const i=this.O(n);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(o);return this.S(i,c).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(n){const o=await this.V(n);this.m.fire(o)}async $acceptDebugSessionTerminated(n){const o=await this.V(n);o&&(this.n.fire(o),this.l.delete(o.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,o){(await this.V(n))?._acceptNameChanged(o)}async $acceptDebugSessionCustomEvent(n,o){const c={session:await this.V(n),event:o.event,body:o.body};this.u.fire(c)}M(n){if(n instanceof A.$aL)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof A.$bL)return{type:"server",port:n.port,host:n.host};if(n instanceof A.$cL)return{type:"pipeServer",path:n.path};if(n instanceof A.$dL)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}N(n){const o=this.h.filter(i=>i.type===n);if(o.length>0)return o[0].factory}O(n){const o=this.h.filter(i=>i.handle===n);if(o.length>0)return o[0].factory}P(n){const o=this.f.filter(i=>i.handle===n);if(o.length>0)return o[0].provider}Q(n,o){if(n.contributes){const i=n.contributes.debuggers;if(i&&i.length>0){for(const c of i)if(c.label&&c.type&&c.type===o)return!0}}return!1}R(n){const i=n.configuration.type,c=this.j.filter(h=>h.type===i||h.type==="*").map(h=>(0,D.$Lg)(()=>h.factory.createDebugAdapterTracker(n)).then(y=>y,y=>null));return Promise.race([Promise.all(c).then(h=>{const y=h.filter(C=>!!C);if(y.length>0)return new a(y)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(n,o){const i=o.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new A.$bL(i));if(n){const h=await this.F.getExtensionRegistry();return(0,D.$Lg)(()=>n.createDebugAdapterDescriptor(o,this.T(o,h))).then(y=>{if(y)return y})}const c=await this.F.getExtensionRegistry();return Promise.resolve(this.T(o,c))}T(n,o){}U(n,o,i){(n.length>0||o.length>0||i.length>0)&&this.y.fire(Object.freeze({added:n,removed:o,changed:i}))}async V(n){if(n)if(typeof n=="string"){const o=this.l.get(n);if(o)return o}else{let o=this.l.get(n.id);if(!o){const i=await this.W(n.folderUri),c=n.parent?this.l.get(n.parent):void 0;o=new r(this.k,n.id,n.type,n.name,i,n.configuration,c),this.l.set(o.id,o),this.k.$sessionCached(o.id)}return o}throw new Error("cannot find session")}W(n){if(n){const o=g.URI.revive(n);return this.E.resolveWorkspaceFolder(o)}return Promise.resolve(void 0)}};e.$Xcc=u,e.$Xcc=u=He([Be(0,w.$0L),Be(1,I.$Qbc),Be(2,E.$mcc),Be(3,S.$Tbc),Be(4,b.$Scc),Be(5,p.$Ucc)],u);class r{constructor(n,o,i,c,h,y,C){this.d=n,this.f=o,this.g=i,this.h=c,this.i=h,this.j=y,this.k=C}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,o){return this.d.$customDebugAdapterRequest(this.f,n,o)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$Ycc=r;class s{constructor(n){this.value=Object.freeze({append(o){n.$appendDebugConsole(o)},appendLine(o){this.append(o+`
`)}})}}e.$Zcc=s;class a{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(o=>o.onWillReceiveMessage?o.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(o=>o.onDidSendMessage?o.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(o=>o.onError?o.onError(n):void 0)}onExit(n,o){this.d.forEach(i=>i.onExit?i.onExit(n,o):void 0)}}class m extends v.$Scb{constructor(n){super(),this.h=n,n.onDidSendMessage(o=>{this.acceptMessage(o)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends u{constructor(n,o,i,c,h,y){super(n,o,i,c,h,y)}};e.$1cc=l,e.$1cc=l=He([Be(0,w.$0L),Be(1,I.$Qbc),Be(2,E.$mcc),Be(3,S.$Tbc),Be(4,b.$Scc),Be(5,p.$Ucc)],l)}),define(De[350],Ce([1,0,8,54,2,6,341,13,104,105,26,238,20,66,45,89]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.$Ldc=void 0;class u{static async installEarlyHandler(a){Error.stackTraceLimit=100;const m=a.get(b.$8i),t=a.get(v.$0L).getProxy(L.$9J.MainThreadErrors);D.setUnexpectedErrorHandler(n=>{m.error(n);const o=D.$2(n);t.$onUnexpectedError(o)})}static async installFullHandler(a){const m=a.get(b.$8i),l=a.get(v.$0L),t=a.get(S.$mcc),n=a.get(p.$rM),o=l.getProxy(L.$9J.MainThreadExtensionService),i=l.getProxy(L.$9J.MainThreadErrors),c=await t.getExtensionPathIndex(),h=new WeakMap;function y(f,d){if(h.has(f))return h.get(f).stack;let P="",N,O;for(const j of d)P+=`
	at ${j.toString()}`,O=j.getFileName(),!N&&O&&(N=c.findSubstr(g.URI.file(O)));const M=`${f.name||"Error"}: ${f.message||""}${P}`;return h.set(f,{extensionIdentifier:N?.identifier,stack:M}),M}const C=Symbol("prepareStackTrace wrapped");let $=y;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(f){if(f===y||!f||f[C]){$=f||y;return}$=function(d,P){return y(d,P),f.call(Error,d,P)},Object.assign($,{[C]:!0})}}),D.setUnexpectedErrorHandler(f=>{m.error(f);const d=D.$2(f),P=h.get(f);if(!P?.extensionIdentifier){i.$onUnexpectedError(d);return}o.$onExtensionRuntimeError(P.extensionIdentifier,d);const N=n.onExtensionError(P.extensionIdentifier,f);m.trace("forwarded error to extension?",N,P)})}}e.$Ldc=u;class r{constructor(a,m,l,t,n){this.a=l,this.b=new R.$c4b(a,null,t),m=r.e(m,this.b);const o=new w.$Lh(...(0,E.$qr)());o.set(A.$nM,{_serviceBrand:void 0,...m,messagePorts:n}),o.set(v.$0L,new v.$$L(this.b)),o.set(k.$Nbc,new k.$Obc(t)),o.set(S.$kcc,l);const i=new I.$9p(o,!0);i.invokeFunction(u.installEarlyHandler),this.d=i.invokeFunction(c=>c.get(b.$8i)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",m),this.c=i.invokeFunction(c=>c.get(S.$mcc)),this.c.initialize(),i.invokeFunction(u.installFullHandler)}async asBrowserUri(a){const m=this.b.getProxy(L.$9J.MainThreadExtensionService);return g.URI.revive(await m.$asBrowserUri(a))}terminate(a){this.c.terminate(a)}static e(a,m){a.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive(m.transformIncomingURIs(t.extensionLocation))}),a.environment.appRoot=g.URI.revive(m.transformIncomingURIs(a.environment.appRoot));const l=a.environment.extensionDevelopmentLocationURI;return l&&(a.environment.extensionDevelopmentLocationURI=l.map(t=>g.URI.revive(m.transformIncomingURIs(t)))),a.environment.extensionTestsLocationURI=g.URI.revive(m.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=g.URI.revive(m.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=g.URI.revive(m.transformIncomingURIs(a.environment.workspaceStorageHome)),a.environment.extensionTelemetryLogResource=g.URI.revive(m.transformIncomingURIs(a.environment.extensionTelemetryLogResource)),a.nlsBaseUrl=g.URI.revive(m.transformIncomingURIs(a.nlsBaseUrl)),a.logsLocation=g.URI.revive(m.transformIncomingURIs(a.logsLocation)),a.workspace=m.transformIncomingURIs(a.workspace),a}}e.$Mdc=r}),define(De[351],Ce([1,0,11,12,215,232,138,95,70,45,20,44,7,56,39,272,273,40]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;let s=class extends b.$Xcc{constructor(n,o,i,c,h,y,C){super(n,o,i,c,y,C),this.Z=h,this.X=new l}K(n,o){switch(n.type){case"server":return new p.$Rdc(n);case"pipeServer":return new p.$Sdc(n);case"executable":return new p.$Tdc(n,o.type)}return super.K(n,o)}T(n,o){const i=p.$Tdc.platformAdapterExecutable(o.getAllExtensionDescriptions(),n.type);if(i)return new v.$aL(i.command,i.args,i.options)}L(){return new R.$R7b}async $runInTerminal(n,o){if(n.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const i=await this.G.getConfigProvider(),c=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),y=n.title||g.localize(0,null),C=JSON.stringify({shell:c,shellArgs:h});let $=await this.X.checkout(C,y),f,d=!1;if($)f=n.cwd;else{const M={shellPath:c,shellArgs:h,cwd:n.cwd,name:y,iconPath:new v.$5K("debug")};d=!0,$=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert($,C)}$.show(!0);const P=await $.processId;d?await new Promise(M=>setTimeout(M,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?$.sendText("cls"):c.indexOf("bash")>=0?$.sendText("clear"):T.$j?$.sendText("cls"):$.sendText("clear"));const N=(0,u.$Vdc)(c,n.args,!!n.argsCanBeInterpretedByShell,f,n.env);$.sendText(N);const O=this.onDidTerminateDebugSession(M=>{M.id===o&&(this.X.free($),O.dispose())});return P}else if(n.kind==="external")return m(n,await this.G.getConfigProvider());return super.$runInTerminal(n,o)}};e.$Wdc=s,e.$Wdc=s=He([Be(0,A.$0L),Be(1,S.$Qbc),Be(2,w.$mcc),Be(3,r.$Tbc),Be(4,I.$_bc),Be(5,E.$Scc),Be(6,k.$Ucc)],s);let a;function m(t,n){if(!a)if(T.$j)a=new L.$C6b;else if(T.$k)a=new L.$D6b;else if(T.$l)a=new L.$E6b;else throw new Error("external terminals not supported on this platform");const o=n.getConfiguration("terminal");return a.runInTerminal(t.title,t.cwd,t.args,t.env||{},o.external||{})}class l{constructor(){this.b=new Map}static{this.a=1e3}async checkout(n,o){const c=[...this.b.entries()].map(([h,y])=>(0,D.$Gg)(async C=>{if(h.name!==o||y.lastUsedAt!==-1&&await(0,u.$Udc)(await h.processId))return null;const $=Date.now();return y.lastUsedAt+l.a>$||C.isCancellationRequested||y.config!==n?null:(y.lastUsedAt=$,h)}));return await(0,D.$Xg)(c,h=>!!h)}insert(n,o){this.b.set(n,{lastUsedAt:Date.now(),config:o})}free(n){const o=this.b.get(n);o&&(o.lastUsedAt=-1)}onTerminalClosed(n){this.b.delete(n)}}}),define(De[352],Ce([1,0,16,2,102,39,69,40,43,44,20,26,94,17,13,90,24,63,56]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;let a=class extends v.$Pcc{constructor(l,t,n,o,i,c,h,y,C){super(l,t,n,o,i,c,h,y),this.B=n,this.C=C,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(l,t){const n=t;if(!t.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const o=v.TaskHandleDTO.from(n,this.B),i=await this.a.$getTaskExecution(o);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(i,t);return this.a.$executeTask(o).catch(()=>{}),c}else{const o=v.TaskDTO.from(t,l);if(o===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(o.execution)&&await this.x(o,t,!1);const i=await this.y(await this.a.$getTaskExecution(o),t);return this.a.$executeTask(o).catch(()=>{}),i}}u(l,t,n,o){const i=[];if(o)for(const c of o){this.z(c,n),(!c.definition||!l[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const h=v.TaskDTO.from(c,n.extension);h&&(i.push(h),v.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,c,!0)))}return{tasks:i,extension:n.extension}}async v(l){return l}async F(l){let t=l&&l.length>0?l[0]:void 0;if(!t){const n=T.URI.file((0,r.homedir)());t=new E.$8h({uri:n,name:u.$rg(n),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(l,t){const n=T.URI.revive(l),o={process:void 0,variables:Object.create(null)},i=await this.b.resolveWorkspaceFolder(n),c=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),y=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const C of t.variables)o.variables[C]=await h.resolveAsync(y,C);if(t.process!==void 0){let C;if(t.process.path!==void 0){C=t.process.path.split(D.$sc);for(let $=0;$<C.length;$++)C[$]=await h.resolveAsync(y,C[$])}o.process=await g.win32.findExecutable(await h.resolveAsync(y,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(y,t.process.cwd):void 0,C)}return o}async $jsonTasksSupported(){return!0}async $findExecutable(l,t,n){return g.win32.findExecutable(l,t,n)}};e.$Odc=a,e.$Odc=a=He([Be(0,A.$0L),Be(1,I.$nM),Be(2,L.$Qbc),Be(3,R.$iM),Be(4,b.$Tbc),Be(5,w.$_bc),Be(6,S.$8i),Be(7,p.$Gbc),Be(8,s.$Ucc)],a)}),define(De[353],Ce([1,0,63,56]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;class g extends T.$Vcc{m(){return(0,D.homedir)()}}e.$uec=g}),define(De[153],Ce([1,0,19,11,21,46,17,16,24,2,36]),function($e,e,D,T,g,L,R,b,E,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=e.$5cc=e.$4cc=e.$3cc=void 0;class I{constructor(s,a,m,l){this.d=s,this.e=a,this.f=m,this.g=l,this.a=null,this.b=!1,this.c=0}search(s,a){const m=this.d.folderQueries||[],l=new g.$Wd(a);return new Promise((t,n)=>{this.a=new k(s);let o=!1;const i=(c,h)=>{if(!o&&!this.b){const y=this.h(c);p(c)&&typeof this.d.maxResults=="number"&&this.c+y>this.d.maxResults&&(this.b=!0,o=!0,l.cancel(),c=this.j(c,this.d.maxResults-this.c));const C=this.h(c);this.c+=C,(C>0||!p(c))&&this.a.add(c,h)}};Promise.all(m.map((c,h)=>this.k(c,y=>i(y,h),l.token))).then(c=>{l.dispose(),this.a.flush();const h=c.some(y=>!!y&&!!y.limitHit);t({limitHit:this.b||h,messages:(0,D.$Qb)(c.map(y=>y?.message?Array.isArray(y.message)?y.message:[y.message]:[])),stats:{type:this.g}})},c=>{l.dispose();const h=(0,L.$yi)(c);n(new Error(h))})})}h(s){return p(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}j(s,a){const m=Array.isArray(s.ranges)?s.ranges:[s.ranges],l=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:m.slice(0,a),preview:{matches:l.slice(0,a),text:s.preview.text},uri:s.uri}}async k(s,a,m){const l=new A.$TI(this.d,s),t=[],n={report:c=>{if(!this.l(c))return;const h=s.folder.scheme===R.Schemas.file?(0,A.$UI)(()=>this.f.readdir(E.$tg(c.uri))):void 0,y=E.$wg(s.folder,c.uri);if(y){const C=l.includedInQuery(y,b.$mc(y),h);(0,T.$Fg)(C)?t.push(C.then($=>{$&&a(c)})):C&&a(c)}}},o=this.n(s),i=await this.e.provideTextSearchResults(v(this.d.contentPattern),o,n,m);return t.length&&await Promise.all(t),i}l(s){if(p(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(s){const a=(0,A.$SI)(this.d.includePattern,s.includePattern),m=(0,A.$SI)(this.d.excludePattern,s.excludePattern),l={folder:w.URI.from(s.folder),excludes:m,includes:a,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!s.disregardParentIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.f.toCanonicalName(s.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$3cc=I;function v(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class k{constructor(s){this.e=s,this.b=-1,this.d=null,this.a=new u(512,a=>this.g(a))}add(s,a){this.d&&(this.b!==a||!E.$ng(this.c,s.uri))&&(this.f(),this.d=null),this.d||(this.b=a,this.d={resource:s.uri,results:[]}),this.d.results.push(S(s))}f(){const s=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,s)}flush(){this.f(),this.a.flush()}g(s){this.e(s)}}e.$4cc=k;function S(r){return p(r)?{preview:{matches:(0,D.$1b)(r.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:r.preview.text},ranges:(0,D.$1b)(r.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function p(r){return!!r.preview}e.$5cc=p;class u{static{this.a=4e3}static{this.b=50}constructor(s,a){this.g=s,this.h=a,this.c=0,this.d=[],this.e=0}addItem(s,a){s&&this.j(s,a)}addItems(s,a){s&&this.k(s,a)}j(s,a){this.d.push(s),this.e+=a,this.l()}k(s,a){this.d=this.d.concat(s),this.e+=a,this.l()}l(){this.c<u.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},u.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$6cc=u}),define(De[96],Ce([1,0,3,6,5,346,20,66,13,2,153]),function($e,e,D,T,g,L,R,b,E,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=e.$7cc=void 0,e.$7cc=(0,g.$Nh)("IExtHostSearch");let I=class{constructor(p,u,r){this.k=p,this.l=u,this.n=r,this.c=this.k.getProxy(T.$9J.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$2cc}o(p){return this.l.transformOutgoingScheme(p)}registerTextSearchProvider(p,u){if(this.g.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this.g.add(p);const r=this.d++;return this.e.set(r,u),this.c.$registerTextSearchProvider(r,this.o(p)),(0,D.$Pc)(()=>{this.g.delete(p),this.e.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(p,u){if(this.i.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this.i.add(p);const r=this.d++;return this.h.set(r,u),this.c.$registerFileSearchProvider(r,this.o(p)),(0,D.$Pc)(()=>{this.i.delete(p),this.h.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(p,u,r,s){const a=v(r),m=this.h.get(p);if(m)return this.j.fileSearch(a,m,l=>{this.c.$handleFileMatch(p,u,l.map(t=>t.resource))},s);throw new Error("unknown provider: "+p)}$clearCache(p){return this.j.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,u,r,s){const a=this.e.get(p);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const m=v(r);return this.q(m,a).search(t=>this.c.$handleTextMatch(p,u,t),s)}$enableExtensionHostSearch(){}q(p,u){return new A.$3cc(p,u,{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}};e.$8cc=I,e.$8cc=I=He([Be(0,R.$0L),Be(1,b.$Nbc),Be(2,E.$8i)],I);function v(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(k),extraFileResources:S.extraFileResources&&S.extraFileResources.map(p=>w.URI.revive(p))}}e.$9cc=v;function k(S){return{...S,folder:w.URI.revive(S.folder)}}}),define(De[354],Ce([1,0,21,8,4,38,2,130,125,168,185,30,6,111,301,300,33,302,40,304,305,306,280,307,69,45,309,310,315,316,317,152,284,323,324,326,115,44,328,287,14,7,85,331,92,151,39,25,276,314,65,149,94,95,96,13,66,20,26,318,274,72,90,294,329,91,71,334,332,333,295,55,327,330,114,70,89,319,93,320,17,134,283,263,312,3,27,270,112,257,321,322,296,311,282,313,113,325,298,299,293,308,297]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m,l,t,n,o,i,c,h,y,C,$,f,d,P,N,O,M,j,U,F,V,H,fe,X,Y,q,x,me,ue,pe,G,z,K,ge,_,ie,ne,Ee,oe,he,ee,le,be,Pe,B,Q,te,re,Z,de,ye,je,We,xe,Ze,it,et,Ae,Fe,qe,Le,Ye,ce,ae,Ie,Ve,Ue,Xe,rt,ot,wt,kt,Yt,Vt,pt,Ut,Ft,zt,At,Rt,Nt,Bt,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;function Wt(ct){const lt=ct.get(oe.$nM),Jt=ct.get(je.$Dbc),Pt=ct.get(te.$9bc),St=ct.get(i.$mcc),dt=ct.get(x.$Qbc),Ct=ct.get(et.$rM),Tt=ct.get(s.$Tbc),Et=ct.get(ne.$Nbc),Ge=ct.get(Ee.$0L),Ot=ct.get(M.$5bc),Me=ct.get(Q.$0bc),Te=ct.get(ie.$9i),Se=ct.get(ie.$8i),se=ct.get(le.$Rvb),Ne=ct.get(be.$Gbc),Ke=ct.get(q.$Kcc),_e=ct.get(Ze.$ecc),Je=ct.get(it.$Scc),nt=ct.get(Ft.$icc);Ge.set(v.$0J.ExtHostFileSystemInfo,Jt),Ge.set(v.$0J.ExtHostLogLevelServiceShape,Te),Ge.set(v.$0J.ExtHostWorkspace,dt),Ge.set(v.$0J.ExtHostConfiguration,Tt),Ge.set(v.$0J.ExtHostExtensionService,St),Ge.set(v.$0J.ExtHostStorage,Ot),Ge.set(v.$0J.ExtHostTunnelService,se),Ge.set(v.$0J.ExtHostWindow,Ke),Ge.set(v.$0J.ExtHostSecretState,_e),Ge.set(v.$0J.ExtHostTelemetry,Ct),Ge.set(v.$0J.ExtHostEditorTabs,Je),Ge.set(v.$0J.ExtHostManagedSockets,nt);const bt=Ge.set(v.$0J.ExtHostDecorations,ct.get(z.$Occ)),vt=Ge.set(v.$0J.ExtHostDocumentsAndEditors,ct.get(o.$iM)),ft=Ge.set(v.$0J.ExtHostCommands,ct.get(u.$tM)),gt=Ge.set(v.$0J.ExtHostTerminalService,ct.get(j.$_bc)),mt=Ge.set(v.$0J.ExtHostDebugService,ct.get(ge.$Wcc)),gi=Ge.set(v.$0J.ExtHostSearch,ct.get(_.$7cc)),Ht=Ge.set(v.$0J.ExtHostTask,ct.get(K.$Rcc)),Ei=Ge.set(v.$0J.ExtHostOutputService,ct.get(f.$ucc)),qt=Ge.set(v.$0J.ExtHostLocalization,ct.get(rt.$hcc)),mi=Ge.set(v.$0J.ExtHostUrls,new X.$Dcc(Ge)),It=Ge.set(v.$0J.ExtHostDocuments,new n.$Bbc(Ge,vt)),ki=Ge.set(v.$0J.ExtHostDocumentContentProviders,new l.$Vbc(Ge,vt,Se)),qi=Ge.set(v.$0J.ExtHostDocumentSaveParticipant,new t.$Wbc(Se,It,Ge.getProxy(v.$9J.MainThreadBulkEdits))),Dt=Ge.set(v.$0J.ExtHostNotebook,new he.$adc(Ge,ft,vt,It,Pt)),ti=Ge.set(v.$0J.ExtHostNotebookDocuments,new ae.$sdc(Dt)),$i=Ge.set(v.$0J.ExtHostNotebookEditors,new ce.$rdc(Se,Dt)),si=Ge.set(v.$0J.ExtHostNotebookKernels,new Ae.$odc(Ge,lt,Dt,ft,Se)),Si=Ge.set(v.$0J.ExtHostNotebookRenderers,new qe.$qdc(Ge,Dt)),Di=Ge.set(v.$0J.ExtHostNotebookDocumentSaveParticipant,new pt.$ydc(Se,Dt,Ge.getProxy(v.$9J.MainThreadBulkEdits))),Lt=Ge.set(v.$0J.ExtHostEditors,new U.$Bcc(Ge,vt)),bi=Ge.set(v.$0J.ExtHostTreeViews,new F.$Ccc(Ge.getProxy(v.$9J.MainThreadTreeViews),ft,Se)),Ci=Ge.set(v.$0J.ExtHostEditorInsets,new ue.$Lcc(Ge.getProxy(v.$9J.MainThreadEditorInsets),Lt,lt.remote)),oi=Ge.set(v.$0J.ExtHostDiagnostics,new a.$Fbc(Ge,Se,Jt,vt)),ai=Ge.set(v.$0J.ExtHostLanguages,new C.$rcc(Ge,It,ft.converter,Et)),ut=Ge.set(v.$0J.ExtHostLanguageFeatures,new y.$Jbc(Ge,Et,It,ft,oi,Se,Ne,Ct)),Vi=Ge.set(v.$0J.ExtHostFileSystem,new c.$pcc(Ge,ut)),Zt=Ge.set(v.$0J.ExtHostFileSystemEventService,new h.$qcc(Ge,Se,vt)),ii=Ge.set(v.$0J.ExtHostQuickOpen,(0,P.$wcc)(Ge,dt,ft)),wi=Ge.set(v.$0J.ExtHostSCM,new N.$ycc(Ge,ft,It,Se)),Ii=Ge.set(v.$0J.ExtHostQuickDiff,new kt.$vdc(Ge,Et)),Ki=Ge.set(v.$0J.ExtHostShare,new zt.$Adc(Ge,Et)),Pi=Ge.set(v.$0J.ExtHostComments,(0,r.$Mbc)(Ge,ft,It)),vi=Ge.set(v.$0J.ExtHostProgress,new d.$vcc(Ge.getProxy(v.$9J.MainThreadProgress))),Hi=Ge.set(v.$0J.ExtHosLabelService,new pe.$Mcc(Ge)),Ai=Ge.set(v.$0J.ExtHostTheming,new ee.$bdc(Ge)),ci=Ge.set(v.$0J.ExtHostAuthentication,new Pe.$cdc(Ge)),Ji=Ge.set(v.$0J.ExtHostTimeline,new B.$edc(Ge,ft)),pi=Ge.set(v.$0J.ExtHostWebviews,new Y.$Gcc(Ge,lt.remote,dt,Se,Ne)),Ri=Ge.set(v.$0J.ExtHostWebviewPanels,new de.$gdc(Ge,pi,dt)),cn=Ge.set(v.$0J.ExtHostCustomEditors,new Z.$hdc(Ge,It,Me,pi,Ri)),Li=Ge.set(v.$0J.ExtHostWebviewViews,new re.$fdc(Ge,pi)),ni=Ge.set(v.$0J.ExtHostTesting,new We.$jdc(Ge,ft,vt)),un=Ge.set(v.$0J.ExtHostUriOpeners,new xe.$ndc(Ge)),ln=Ge.set(v.$0J.ExtHostProfileContentHandlers,new wt.$udc(Ge));Ge.set(v.$0J.ExtHostInteractive,new Ie.$tdc(Ge,Dt,vt,ft,Se));const Gi=Ge.set(v.$0J.ExtHostInlineChat,new Vt.$xdc(Ge,ft,It,Se)),fi=Ge.set(v.$0J.ExtHostChatProvider,new At.$Bdc(Ge,Se)),Qi=Ge.set(v.$0J.ExtHostChatAgents,new Kt.$Fdc(Ge,fi,Se)),Yi=Ge.set(v.$0J.ExtHostChatVariables,new Rt.$Cdc(Ge)),ui=Ge.set(v.$0J.ExtHostChat,new Yt.$wdc(Ge,Se)),Zi=Ge.set(v.$0J.ExtHostAiRelatedInformation,new Nt.$Ddc(Ge)),Mi=Ge.set(v.$0J.ExtHostAiEmbeddingVector,new Bt.$Edc(Ge)),Xi=Ge.set(v.$0J.ExtHostIssueReporter,new Ut.$zdc(Ge)),Xt=Ge.set(v.$0J.ExtHostStatusBar,new O.$Acc(Ge,ft.converter)),yi=Object.values(v.$0J);Ge.assertRegistered(yi);const hn=new ye.$idc(Ge,vt),Gt=new p.$Lbc(Ge),li=new $.$scc(Ge,Se),Ti=new m.$Ubc(Ge);return S.$Kbc.register(ft),function(ze,xt,Fi){const $t=function(){let we=!ze.isUnderDevelopment;function ke(){we||(Se.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")ke();else{const yt=st;typeof yt.scheme>"u"&&ke(),typeof yt.exclusive=="boolean"&&(0,Ue.$9E)(ze,"documentFiltersExclusive")}return st}}(),xi={getSession(we,ke,Oe){return ci.getSession(ze,we,ke,Oe)},getSessions(we,ke){return(0,Ue.$9E)(ze,"authGetSessions"),ci.getSessions(ze,we,ke)},async hasSession(we,ke){return(0,Ue.$9E)(ze,"authSession"),!!await ci.getSession(ze,we,ke,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(we,ke,Oe,st){return ci.registerAuthenticationProvider(we,ke,Oe,st)}},_i={registerCommand(we,ke,Oe){return ft.registerCommand(!0,we,ke,Oe,void 0,ze)},registerTextEditorCommand(we,ke,Oe){return ft.registerCommand(!0,we,(...st)=>{const yt=Lt.getActiveTextEditor();if(!yt){Se.warn("Cannot execute "+we+" because there is no active text editor.");return}return yt.edit(Mt=>{ke.apply(Oe,[yt,Mt,...st])}).then(Mt=>{Mt||Se.warn("Edits from command "+we+" were not applied.")},Mt=>{Se.warn("An error occurred while running command "+we,Mt)})},void 0,void 0,ze)},registerDiffInformationCommand:(we,ke,Oe)=>((0,Ue.$9E)(ze,"diffCommand"),ft.registerCommand(!0,we,async(...st)=>{const yt=vt.activeEditor(!0);if(!yt){Se.warn("Cannot execute "+we+" because there is no active text editor.");return}const Mt=await Lt.getDiffInformation(yt.id);ke.apply(Oe,[Mt,...st])},void 0,void 0,ze)),executeCommand(we,...ke){return ft.executeCommand(we,...ke)},getCommands(we=!1){return ft.getCommands(we)}},en={get machineId(){return lt.telemetryInfo.machineId},get sessionId(){return lt.telemetryInfo.sessionId},get language(){return lt.environment.appLanguage},get appName(){return lt.environment.appName},get appRoot(){return lt.environment.appRoot?.fsPath??""},get appHost(){return lt.environment.appHost},get uriScheme(){return lt.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return gt.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ue.$9E)(ze,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ue.$9E)(ze,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.$qM)(lt.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,ke){return et.$pM.validateSender(we),Ct.instantiateLogger(ze,we,ke)},openExternal(we,ke){return Ke.openUri(we,{allowTunneling:!!lt.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===lt.environment.appUriScheme)return mi.createAppUri(we);try{return await Ke.asExternalUri(we,{allowTunneling:!!lt.remote.authority})}catch(ke){if((0,Ye.$4T)(we,Le.Schemas.http)||(0,Ye.$4T)(we,Le.Schemas.https))return we;throw ke}},get remoteName(){return(0,G.$Sk)(lt.remote.authority)},get remoteAuthority(){return(0,Ue.$9E)(ze,"resolvers"),lt.remote.authority},get uiKind(){return lt.uiKind},get logLevel(){return Se.getLevel()},get onDidChangeLogLevel(){return Se.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,Ue.$9E)(ze,"handleIssueUri"),Xi.registerIssueUriRequestHandler(ze,we)},get appQuality(){return(0,Ue.$9E)(ze,"resolvers"),lt.quality},get appCommit(){return(0,Ue.$9E)(ze,"resolvers"),lt.commit}};lt.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(we,ke,Oe){return ni.createTestController(ze,we,ke,Oe)},createTestObserver(){return(0,Ue.$9E)(ze,"testObserver"),ni.createTestObserver()},runTests(we){return(0,Ue.$9E)(ze,"testObserver"),ni.runTests(we)},get onDidChangeTestResults(){return(0,Ue.$9E)(ze,"testObserver"),ni.onResultsChanged},get testResults(){return(0,Ue.$9E)(ze,"testObserver"),ni.results}},hi=lt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,tn={getExtension(we,ke){(0,Ue.$8E)(ze,"extensionsAny")||(ke=!1);const Oe=xt.mine.getExtensionDescription(we);if(Oe)return new i.$ncc(St,ze.identifier,Oe,hi,!1);if(ke){const st=xt.all.getExtensionDescription(we);if(st)return new i.$ncc(St,ze.identifier,st,hi,!0)}},get all(){const we=[];for(const ke of xt.mine.getAllExtensionDescriptions())we.push(new i.$ncc(St,ze.identifier,ke,hi,!1));return we},get allAcrossExtensionHosts(){(0,Ue.$9E)(ze,"extensionsAny");const we=new me.$Zl(xt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ke=[];for(const Oe of xt.all.getAllExtensionDescriptions()){const st=!we.has(Oe.identifier);ke.push(new i.$ncc(St,ze.identifier,Oe,hi,st))}return ke},get onDidChange(){return(0,Ue.$8E)(ze,"extensionsAny")?g.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},nn={createDiagnosticCollection(we){return oi.createDiagnosticCollection(ze.identifier,we)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:we=>oi.getDiagnostics(we),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(we,ke){return ai.changeLanguage(we.uri,ke)},match(we,ke){const Oe=It.getDocumentData(ke.uri)?.notebook;return(0,A.$jE)(V.LanguageSelector.from(we),ke.uri,ke.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(we,ke,Oe){return ut.registerCodeActionProvider(ze,$t(we),ke,Oe)},registerDocumentPasteEditProvider(we,ke,Oe){return(0,Ue.$9E)(ze,"documentPaste"),ut.registerDocumentPasteEditProvider(ze,$t(we),ke,Oe)},registerCodeLensProvider(we,ke){return ut.registerCodeLensProvider(ze,$t(we),ke)},registerDefinitionProvider(we,ke){return ut.registerDefinitionProvider(ze,$t(we),ke)},registerDeclarationProvider(we,ke){return ut.registerDeclarationProvider(ze,$t(we),ke)},registerImplementationProvider(we,ke){return ut.registerImplementationProvider(ze,$t(we),ke)},registerTypeDefinitionProvider(we,ke){return ut.registerTypeDefinitionProvider(ze,$t(we),ke)},registerHoverProvider(we,ke){return ut.registerHoverProvider(ze,$t(we),ke,ze.identifier)},registerEvaluatableExpressionProvider(we,ke){return ut.registerEvaluatableExpressionProvider(ze,$t(we),ke,ze.identifier)},registerInlineValuesProvider(we,ke){return ut.registerInlineValuesProvider(ze,$t(we),ke,ze.identifier)},registerDocumentHighlightProvider(we,ke){return ut.registerDocumentHighlightProvider(ze,$t(we),ke)},registerLinkedEditingRangeProvider(we,ke){return ut.registerLinkedEditingRangeProvider(ze,$t(we),ke)},registerReferenceProvider(we,ke){return ut.registerReferenceProvider(ze,$t(we),ke)},registerRenameProvider(we,ke){return ut.registerRenameProvider(ze,$t(we),ke)},registerDocumentSymbolProvider(we,ke,Oe){return ut.registerDocumentSymbolProvider(ze,$t(we),ke,Oe)},registerWorkspaceSymbolProvider(we){return ut.registerWorkspaceSymbolProvider(ze,we)},registerDocumentFormattingEditProvider(we,ke){return ut.registerDocumentFormattingEditProvider(ze,$t(we),ke)},registerDocumentRangeFormattingEditProvider(we,ke){return ut.registerDocumentRangeFormattingEditProvider(ze,$t(we),ke)},registerOnTypeFormattingEditProvider(we,ke,Oe,...st){return ut.registerOnTypeFormattingEditProvider(ze,$t(we),ke,[Oe].concat(st))},registerDocumentSemanticTokensProvider(we,ke,Oe){return ut.registerDocumentSemanticTokensProvider(ze,$t(we),ke,Oe)},registerDocumentRangeSemanticTokensProvider(we,ke,Oe){return ut.registerDocumentRangeSemanticTokensProvider(ze,$t(we),ke,Oe)},registerSignatureHelpProvider(we,ke,Oe,...st){return typeof Oe=="object"?ut.registerSignatureHelpProvider(ze,$t(we),ke,Oe):ut.registerSignatureHelpProvider(ze,$t(we),ke,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(we,ke,...Oe){return ut.registerCompletionItemProvider(ze,$t(we),ke,Oe)},registerInlineCompletionItemProvider(we,ke,Oe){return ke.handleDidShowCompletionItem&&(0,Ue.$9E)(ze,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,Ue.$9E)(ze,"inlineCompletionsAdditions"),Oe&&(0,Ue.$9E)(ze,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(ze,$t(we),ke,Oe)},registerDocumentLinkProvider(we,ke){return ut.registerDocumentLinkProvider(ze,$t(we),ke)},registerColorProvider(we,ke){return ut.registerColorProvider(ze,$t(we),ke)},registerFoldingRangeProvider(we,ke){return ut.registerFoldingRangeProvider(ze,$t(we),ke)},registerSelectionRangeProvider(we,ke){return ut.registerSelectionRangeProvider(ze,we,ke)},registerCallHierarchyProvider(we,ke){return ut.registerCallHierarchyProvider(ze,we,ke)},registerTypeHierarchyProvider(we,ke){return ut.registerTypeHierarchyProvider(ze,we,ke)},setLanguageConfiguration:(we,ke)=>ut.setLanguageConfiguration(ze,we,ke),getTokenInformationAtPosition(we,ke){return(0,Ue.$9E)(ze,"tokenInformation"),ai.tokenAtPosition(we,ke)},registerInlayHintsProvider(we,ke){return ut.registerInlayHintsProvider(ze,we,ke)},createLanguageStatusItem(we,ke){return ai.createLanguageStatusItem(ze,we,ke)},registerDocumentDropEditProvider(we,ke,Oe){return ut.registerDocumentOnDropEditProvider(ze,we,ke,(0,Ue.$8E)(ze,"dropMetadata")?Oe:void 0)}},rn={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(we,ke,Oe){const st=await(R.URI.isUri(we)?Promise.resolve(sn.openTextDocument(we)):Promise.resolve(we));return Lt.showTextDocument(st,ke,Oe)},createTextEditorDecorationType(we){return Lt.createTextEditorDecorationType(ze,we)},onDidChangeActiveTextEditor(we,ke,Oe){return Lt.onDidChangeActiveTextEditor(we,ke,Oe)},onDidChangeVisibleTextEditors(we,ke,Oe){return Lt.onDidChangeVisibleTextEditors(we,ke,Oe)},onDidChangeTextEditorSelection(we,ke,Oe){return Lt.onDidChangeTextEditorSelection(we,ke,Oe)},onDidChangeTextEditorOptions(we,ke,Oe){return Lt.onDidChangeTextEditorOptions(we,ke,Oe)},onDidChangeTextEditorVisibleRanges(we,ke,Oe){return Lt.onDidChangeTextEditorVisibleRanges(we,ke,Oe)},onDidChangeTextEditorViewColumn(we,ke,Oe){return Lt.onDidChangeTextEditorViewColumn(we,ke,Oe)},onDidCloseTerminal(we,ke,Oe){return gt.onDidCloseTerminal(we,ke,Oe)},onDidOpenTerminal(we,ke,Oe){return gt.onDidOpenTerminal(we,ke,Oe)},onDidChangeActiveTerminal(we,ke,Oe){return gt.onDidChangeActiveTerminal(we,ke,Oe)},onDidChangeTerminalDimensions(we,ke,Oe){return(0,Ue.$9E)(ze,"terminalDimensions"),gt.onDidChangeTerminalDimensions(we,ke,Oe)},onDidChangeTerminalState(we,ke,Oe){return gt.onDidChangeTerminalState(we,ke,Oe)},onDidWriteTerminalData(we,ke,Oe){return(0,Ue.$9E)(ze,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(we,ke,Oe)},onDidExecuteTerminalCommand(we,ke,Oe){return(0,Ue.$9E)(ze,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(we,ke,Oe)},get state(){return Ke.getState(ze)},onDidChangeWindowState(we,ke,Oe){return Ke.onDidChangeWindowState(we,ke,Oe)},showInformationMessage(we,...ke){return li.showMessage(ze,L.default.Info,we,ke[0],ke.slice(1))},showWarningMessage(we,...ke){return li.showMessage(ze,L.default.Warning,we,ke[0],ke.slice(1))},showErrorMessage(we,...ke){return li.showMessage(ze,L.default.Error,we,ke[0],ke.slice(1))},showQuickPick(we,ke,Oe){return ii.showQuickPick(ze,we,ke,Oe)},showWorkspaceFolderPick(we){return ii.showWorkspaceFolderPick(we)},showInputBox(we,ke){return ii.showInput(we,ke)},showOpenDialog(we){return Ti.showOpenDialog(ze,we)},showSaveDialog(we){return Ti.showSaveDialog(we)},createStatusBarItem(we,ke,Oe){let st,yt,Mt;return typeof we=="string"?(st=we,yt=ke,Mt=Oe):(yt=we,Mt=ke),Xt.createStatusBarEntry(ze,st,yt,Mt)},setStatusBarMessage(we,ke){return Xt.setStatusBarMessage(we,ke)},withScmProgress(we){return Ne.report("window.withScmProgress",ze,"Use 'withProgress' instead."),vi.withProgress(ze,{location:H.ProgressLocation.SourceControl},(ke,Oe)=>we({report(st){}}))},withProgress(we,ke){return vi.withProgress(ze,we,ke)},createOutputChannel(we,ke){return Ei.createOutputChannel(we,ke,ze)},createWebviewPanel(we,ke,Oe,st){return Ri.createWebviewPanel(ze,we,ke,Oe,st)},createWebviewTextEditorInset(we,ke,Oe,st){return(0,Ue.$9E)(ze,"editorInsets"),Ci.createWebviewEditorInset(we,ke,Oe,st,ze)},createTerminal(we,ke,Oe){return typeof we=="object"?"pty"in we?gt.createExtensionTerminal(we):gt.createTerminalFromOptions(we):gt.createTerminal(we,ke,Oe)},registerTerminalLinkProvider(we){return gt.registerLinkProvider(we)},registerTerminalProfileProvider(we,ke){return gt.registerProfileProvider(ze,we,ke)},registerTerminalQuickFixProvider(we,ke){return(0,Ue.$9E)(ze,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(we,ze.identifier.value,ke)},registerTreeDataProvider(we,ke){return bi.registerTreeDataProvider(we,ke,ze)},createTreeView(we,ke){return bi.createTreeView(we,ke,ze)},registerWebviewPanelSerializer:(we,ke)=>Ri.registerWebviewPanelSerializer(ze,we,ke),registerCustomEditorProvider:(we,ke,Oe={})=>cn.registerCustomEditorProvider(ze,we,ke,Oe),registerFileDecorationProvider(we){return bt.registerFileDecorationProvider(we,ze)},registerUriHandler(we){return mi.registerUriHandler(ze,we)},createQuickPick(){return ii.createQuickPick(ze)},createInputBox(){return ii.createInputBox(ze)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(we,ke,Oe){return Ai.onDidChangeActiveColorTheme(we,ke,Oe)},registerWebviewViewProvider(we,ke,Oe){return Li.registerWebviewViewProvider(ze,we,ke,Oe?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,ke,Oe){return Dt.onDidChangeActiveNotebookEditor(we,ke,Oe)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,ke,Oe){return $i.onDidChangeNotebookEditorSelection(we,ke,Oe)},onDidChangeNotebookEditorVisibleRanges(we,ke,Oe){return $i.onDidChangeNotebookEditorVisibleRanges(we,ke,Oe)},showNotebookDocument(we,ke){return Dt.showNotebookDocument(we,ke)},registerExternalUriOpener(we,ke,Oe){return(0,Ue.$9E)(ze,"externalUriOpener"),un.registerExternalUriOpener(ze.identifier,we,ke,Oe)},registerProfileContentHandler(we,ke){return(0,Ue.$9E)(ze,"profileContentHandlers"),ln.registrProfileContentHandler(ze,we,ke)},registerQuickDiffProvider(we,ke,Oe,st){return(0,Ue.$9E)(ze,"quickDiffProvider"),Ii.registerQuickDiffProvider($t(we),ke,Oe,st)},get tabGroups(){return Je.tabGroups},registerShareProvider(we,ke){return(0,Ue.$9E)(ze,"shareProvider"),Ki.registerShareProvider($t(we),ke)}},sn={get rootPath(){return Ne.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(we){throw new T.$8("rootPath")},getWorkspaceFolder(we){return dt.getWorkspaceFolder(we)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(we){throw new T.$8("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(we){throw new T.$8("workspaceFile")},updateWorkspaceFolders:(we,ke,...Oe)=>dt.updateWorkspaceFolders(ze,we,ke||0,...Oe),onDidChangeWorkspaceFolders:function(we,ke,Oe){return dt.onDidChangeWorkspace(we,ke,Oe)},asRelativePath:(we,ke)=>dt.getRelativePath(we,ke),findFiles:(we,ke,Oe,st)=>dt.findFiles(we,ke,Oe,ze.identifier,st),findTextInFiles:(we,ke,Oe,st)=>{(0,Ue.$9E)(ze,"findTextInFiles");let yt,Mt;return typeof ke=="object"?(yt=ke,Mt=Oe):(yt={},Mt=ke,st=Oe),dt.findTextInFiles(we,yt||{},Mt,ze.identifier,st)},save:we=>((0,Ue.$9E)(ze,"saveEditor"),dt.save(we)),saveAs:we=>((0,Ue.$9E)(ze,"saveEditor"),dt.saveAs(we)),saveAll:we=>dt.saveAll(we),applyEdit(we,ke){return hn.applyWorkspaceEdit(we,ze,ke)},createFileSystemWatcher:(we,ke,Oe,st)=>Zt.createFileSystemWatcher(dt,ze,we,ke,Oe,st),get textDocuments(){return It.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new T.$8("textDocuments")},openTextDocument(we){let ke;const Oe=we;if(typeof we=="string")ke=Promise.resolve(R.URI.file(we));else if(R.URI.isUri(we))ke=Promise.resolve(we);else if(!Oe||typeof Oe=="object")ke=It.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>It.ensureDocumentData(st).then(yt=>yt.document))},onDidOpenTextDocument:(we,ke,Oe)=>It.onDidAddDocument(we,ke,Oe),onDidCloseTextDocument:(we,ke,Oe)=>It.onDidRemoveDocument(we,ke,Oe),onDidChangeTextDocument:(we,ke,Oe)=>It.onDidChangeDocument(we,ke,Oe),onDidSaveTextDocument:(we,ke,Oe)=>It.onDidSaveDocument(we,ke,Oe),onWillSaveTextDocument:(we,ke,Oe)=>qi.getOnWillSaveTextDocumentEvent(ze)(we,ke,Oe),get notebookDocuments(){return Dt.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,ke){let Oe;if(R.URI.isUri(we))Oe=we,await Dt.openNotebookDocument(we);else if(typeof we=="string")Oe=R.URI.revive(await Dt.createNotebookDocument({viewType:we,content:ke}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(we,ke,Oe){return ti.onDidSaveNotebookDocument(we,ke,Oe)},onDidChangeNotebookDocument(we,ke,Oe){return ti.onDidChangeNotebookDocument(we,ke,Oe)},onWillSaveNotebookDocument(we,ke,Oe){return Di.getOnWillSaveNotebookDocumentEvent(ze)(we,ke,Oe)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(we,ke,Oe,st){return Dt.registerNotebookSerializer(ze,we,ke,Oe,(0,Ue.$8E)(ze,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(we,ke,Oe)=>Fi.onDidChangeConfiguration(we,ke,Oe),getConfiguration(we,ke){return ke=arguments.length===1?void 0:ke,Fi.getConfiguration(we,ke,ze)},registerTextDocumentContentProvider(we,ke){return ki.registerTextDocumentContentProvider(we,ke)},registerTaskProvider:(we,ke)=>(Ne.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(ze,we,ke)),registerFileSystemProvider(we,ke,Oe){return(0,Ve.$Oc)(Vi.registerFileSystemProvider(ze,we,ke,Oe),Pt.addFileSystemProvider(we,ke,Oe))},get fs(){return Pt.value},registerFileSearchProvider:(we,ke)=>((0,Ue.$9E)(ze,"fileSearchProvider"),gi.registerFileSearchProvider(we,ke)),registerTextSearchProvider:(we,ke)=>((0,Ue.$9E)(ze,"textSearchProvider"),gi.registerTextSearchProvider(we,ke)),registerRemoteAuthorityResolver:(we,ke)=>((0,Ue.$9E)(ze,"resolvers"),St.registerRemoteAuthorityResolver(we,ke)),registerResourceLabelFormatter:we=>((0,Ue.$9E)(ze,"resolvers"),Hi.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,Ue.$9E)(ze,"resolvers"),St.getRemoteExecServer(we)),onDidCreateFiles:(we,ke,Oe)=>Zt.onDidCreateFile(we,ke,Oe),onDidDeleteFiles:(we,ke,Oe)=>Zt.onDidDeleteFile(we,ke,Oe),onDidRenameFiles:(we,ke,Oe)=>Zt.onDidRenameFile(we,ke,Oe),onWillCreateFiles:(we,ke,Oe)=>Zt.getOnWillCreateFileEvent(ze)(we,ke,Oe),onWillDeleteFiles:(we,ke,Oe)=>Zt.getOnWillDeleteFileEvent(ze)(we,ke,Oe),onWillRenameFiles:(we,ke,Oe)=>Zt.getOnWillRenameFileEvent(ze)(we,ke,Oe),openTunnel:we=>((0,Ue.$9E)(ze,"tunnels"),se.openTunnel(ze,we).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,Ue.$9E)(ze,"tunnels"),se.getTunnels()},onDidChangeTunnels:(we,ke,Oe)=>((0,Ue.$9E)(ze,"tunnels"),se.onDidChangeTunnels(we,ke,Oe)),registerPortAttributesProvider:(we,ke)=>((0,Ue.$9E)(ze,"portsAttributes"),se.registerPortsAttributesProvider(we,ke)),registerTunnelProvider:(we,ke)=>((0,Ue.$9E)(ze,"tunnelFactory"),se.registerTunnelProvider(we,ke)),registerTimelineProvider:(we,ke)=>((0,Ue.$9E)(ze,"timeline"),Ji.registerTimelineProvider(we,ke,ze.identifier,ft.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:we=>((0,Ue.$9E)(ze,"workspaceTrust"),dt.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,ke,Oe)=>dt.onDidGrantWorkspaceTrust(we,ke,Oe),registerEditSessionIdentityProvider:(we,ke)=>((0,Ue.$9E)(ze,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(we,ke)),onWillCreateEditSessionIdentity:(we,ke,Oe)=>((0,Ue.$9E)(ze,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(ze)(we,ke,Oe)),registerCanonicalUriProvider:(we,ke)=>((0,Ue.$9E)(ze,"canonicalUriProvider"),dt.registerCanonicalUriProvider(we,ke)),getCanonicalUri:(we,ke,Oe)=>((0,Ue.$9E)(ze,"canonicalUriProvider"),dt.provideCanonicalUri(we,ke,Oe))},fn={get inputBox(){return Ne.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),wi.getLastInputBox(ze)},createSourceControl(we,ke,Oe){return wi.createSourceControl(ze,we,ke,Oe)}},on={createCommentController(we,ke){return Pi.createCommentController(ze,we,ke)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(we,ke,Oe){return mt.onDidStartDebugSession(we,ke,Oe)},onDidTerminateDebugSession(we,ke,Oe){return mt.onDidTerminateDebugSession(we,ke,Oe)},onDidChangeActiveDebugSession(we,ke,Oe){return mt.onDidChangeActiveDebugSession(we,ke,Oe)},onDidReceiveDebugSessionCustomEvent(we,ke,Oe){return mt.onDidReceiveDebugSessionCustomEvent(we,ke,Oe)},onDidChangeBreakpoints(we,ke,Oe){return mt.onDidChangeBreakpoints(we,ke,Oe)},onDidChangeStackFrameFocus(we,ke,Oe){return(0,Ue.$9E)(ze,"debugFocus"),mt.onDidChangeStackFrameFocus(we,ke,Oe)},registerDebugConfigurationProvider(we,ke,Oe){return mt.registerDebugConfigurationProvider(we,ke,Oe||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,ke){return mt.registerDebugAdapterDescriptorFactory(ze,we,ke)},registerDebugAdapterTrackerFactory(we,ke){return mt.registerDebugAdapterTrackerFactory(we,ke)},startDebugging(we,ke,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?mt.startDebugging(we,ke,{parentSession:Oe}):mt.startDebugging(we,ke,Oe||{})},stopDebugging(we){return mt.stopDebugging(we)},addBreakpoints(we){return mt.addBreakpoints(we)},removeBreakpoints(we){return mt.removeBreakpoints(we)},asDebugSourceUri(we,ke){return mt.asDebugSourceUri(we,ke)}},Ni={registerTaskProvider:(we,ke)=>Ht.registerTaskProvider(ze,we,ke),fetchTasks:we=>Ht.fetchTasks(we),executeTask:we=>Ht.executeTask(ze,we),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(we,ke,Oe)=>Ht.onDidStartTask(we,ke,Oe),onDidEndTask:(we,ke,Oe)=>Ht.onDidEndTask(we,ke,Oe),onDidStartTaskProcess:(we,ke,Oe)=>Ht.onDidStartTaskProcess(we,ke,Oe),onDidEndTaskProcess:(we,ke,Oe)=>Ht.onDidEndTaskProcess(we,ke,Oe)},Oi={createNotebookController(we,ke,Oe,st,yt){return si.createNotebookController(ze,we,ke,Oe,st,(0,Ue.$8E)(ze,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(we,ke)=>Dt.registerNotebookCellStatusBarItemProvider(ze,we,ke),createRendererMessaging(we){return Si.createRendererMessaging(ze,we)},createNotebookControllerDetectionTask(we){return(0,Ue.$9E)(ze,"notebookKernelSource"),si.createNotebookControllerDetectionTask(ze,we)},registerKernelSourceActionProvider(we,ke){return(0,Ue.$9E)(ze,"notebookKernelSource"),si.registerKernelSourceActionProvider(ze,we,ke)},onDidChangeNotebookCellExecutionState(we,ke,Oe){return(0,Ue.$9E)(ze,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(we,ke,Oe)}},ji={t(...we){if(typeof we[0]=="string"){const ke=we.shift(),Oe=!we||typeof we[0]!="object"?we:we[0];return qt.getMessage(ze.identifier.value,{message:ke,args:Oe})}return qt.getMessage(ze.identifier.value,we[0])},get bundle(){return qt.getBundle(ze.identifier.value)},get uri(){return qt.getBundleUri(ze.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(we,ke){return(0,Ue.$9E)(ze,"interactive"),Gi.registerProvider(ze,we,ke={label:ke?.label??ze.displayName??ze.name})},registerInteractiveSessionProvider(we,ke){return(0,Ue.$9E)(ze,"interactive"),ui.registerChatProvider(ze,we,ke)},addInteractiveRequest(we){return(0,Ue.$9E)(ze,"interactive"),ui.addChatRequest(we)},sendInteractiveRequestToProvider(we,ke){return(0,Ue.$9E)(ze,"interactive"),ui.sendInteractiveRequestToProvider(we,ke)},get onDidPerformUserAction(){return(0,Ue.$9E)(ze,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(we,ke){return(0,Ue.$9E)(ze,"interactive"),ui.transferChatSession(we,ke)}},Ui={getRelatedInformation(we,ke){return(0,Ue.$9E)(ze,"aiRelatedInformation"),Zi.getRelatedInformation(ze,we,ke)},registerRelatedInformationProvider(we,ke){return(0,Ue.$9E)(ze,"aiRelatedInformation"),Zi.registerRelatedInformationProvider(ze,we,ke)},registerEmbeddingVectorProvider(we,ke){return(0,Ue.$9E)(ze,"aiRelatedInformation"),Mi.registerEmbeddingVectorProvider(ze,we,ke)}},zi={registerChatResponseProvider(we,ke,Oe){return(0,Ue.$9E)(ze,"chatProvider"),fi.registerProvider(ze.identifier,we,ke,Oe)},requestChatAccess(we){return(0,Ue.$9E)(ze,"chatRequestAccess"),fi.requestChatResponseProvider(ze.identifier,we)},registerVariable(we,ke,Oe){return(0,Ue.$9E)(ze,"chatVariables"),Yi.registerVariableResolver(ze,we,ke,Oe)},registerMappedEditsProvider(we,ke){return(0,Ue.$9E)(ze,"mappedEditsProvider"),ut.registerMappedEditsProvider(ze,we,ke)},registerAgent(we,ke,Oe){return(0,Ue.$9E)(ze,"chatAgents"),Qi.registerAgent(ze.identifier,we,ke,Oe)}};return{version:lt.version,ai:Ui,authentication:xi,commands:_i,comments:on,chat:zi,debug:an,env:en,extensions:tn,interactive:di,l10n:ji,languages:nn,notebooks:Oi,scm:fn,tasks:Ni,tests:dn,window:rn,workspace:sn,Breakpoint:H.$9K,TerminalOutputAnchor:H.TerminalOutputAnchor,ChatMessage:H.$YL,ChatMessageRole:H.ChatMessageRole,ChatVariableLevel:H.ChatVariableLevel,CallHierarchyIncomingCall:H.$vK,CallHierarchyItem:H.$uK,CallHierarchyOutgoingCall:H.$wK,CancellationError:T.$4,CancellationTokenSource:D.$Wd,CandidatePortSource:v.CandidatePortSource,CodeAction:H.$rK,CodeActionKind:H.$sK,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.$xK,Color:H.$KK,ColorInformation:H.$LK,ColorPresentation:H.$MK,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentState:H.CommentState,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CompletionItem:H.$EK,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.$FK,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.$UK,DebugAdapterExecutable:H.$aL,DebugAdapterInlineImplementation:H.$dL,DebugAdapterNamedPipeServer:H.$cL,DebugAdapterServer:H.$bL,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.$mK,DiagnosticRelatedInformation:H.$lK,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.$$J,DocumentHighlight:H.$oK,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.$JK,DocumentSymbol:H.$qK,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.$gL,InlineValueText:H.$hL,InlineValueVariableLookup:H.$iL,InlineValueEvaluatableExpression:H.$jL,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:g.$Md,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.$tL,FileDecoration2:H.$tL,FileSystemError:H.$lL,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:H.$mL,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.$$K,InlineCompletionItem:H.$GK,InlineCompletionList:H.$HK,Hover:H.$nK,IndentAction:w.IndentAction,Location:H.$kK,MarkdownString:H.$yK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:H.$zK,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.$_J,ProcessExecution:H.$SK,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.$sL,Range:H.$aK,RelativePattern:H.$7K,Selection:H.$bK,SelectionRange:H.$tK,SemanticTokens:H.$pL,SemanticTokensBuilder:H.$oL,SemanticTokensEdit:H.$qL,SemanticTokensEdits:H.$rL,SemanticTokensLegend:H.$nL,ShellExecution:H.$TK,ShellQuoting:H.ShellQuoting,SignatureHelp:H.$BK,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.$AK,SnippetString:H.$jK,SourceBreakpoint:H.$0K,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.$pK,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.$VK,TaskGroup:H.$RK,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.$NK,TerminalQuickFixExecuteTerminalCommand:H.$PK,TerminalQuickFixOpener:H.$OK,TerminalLocation:H.TerminalLocation,TerminalProfile:H.$QK,TerminalExitReason:H.TerminalExitReason,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.$fK,SnippetTextEdit:H.$hK,TextEditorCursorStyle:b.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,SyntaxTokenType:H.SyntaxTokenType,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.$6K,ThemeIcon:H.$5K,TreeItem:H.$WK,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.$OL,UIKind:k.UIKind,Uri:R.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.$iK,DocumentDropEdit:H.$3K,DocumentPasteEdit:H.$4K,InlayHint:H.$DK,InlayHintLabelPart:H.$CK,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.$eK,ResolvedAuthority:H.$cK,ManagedResolvedAuthority:H.$dK,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.$DL,NotebookRange:H.$vL,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.$wL,NotebookData:H.$xL,NotebookRendererScript:H.$BL,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.$zL,NotebookCellOutputItem:H.$yL,NotebookCellStatusBarItem:H.$AL,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.$gK,NotebookKernelSourceAction:H.$CL,PortAttributes:H.$FL,LinkedEditingRanges:H.$EL,TestResultState:H.TestResultState,TestRunRequest:H.$GL,TestMessage:H.$HL,TestMessage2:H.$HL,TestTag:H.$IL,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Fe.TextSearchCompleteMessageType,DataTransfer:H.$2K,DataTransferItem:H.$XK,CoveredCount:H.$JL,FileCoverage:H.$KL,StatementCoverage:H.$LL,BranchCoverage:H.$ML,FunctionCoverage:H.$NL,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.$PL,TabInputTextDiff:H.$QL,TabInputTextMerge:H.$RL,TabInputCustom:H.$SL,TabInputNotebook:H.$UL,TabInputNotebookDiff:H.$VL,TabInputWebview:H.$TL,TabInputTerminal:H.$WL,TabInputInteractiveWindow:H.$XL,TelemetryTrustedValue:fe.$co,LogLevel:ie.LogLevel,EditSessionIdentityMatch:ot.EditSessionIdentityMatch,InteractiveSessionVoteDirection:H.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:H.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:H.InteractiveEditorResponseFeedbackKind,StackFrameFocus:H.$eL,ThreadFocus:H.$fL,RelatedInformationType:H.RelatedInformationType}}}e.$Gdc=Wt}),define(De[355],Ce([1,0,104,152,39,149,40,33,69,44,94,95,96,115,72,90,151,71,55,114,89,70,150,13,56,112,113]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m,l,t,n,o,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$pr)(i.$hcc,i.$gcc,1),(0,D.$pr)(n.$9i,t.$Hdc,1),(0,D.$pr)(p.$Gbc,p.$Hbc,1),(0,D.$pr)(b.$tM,b.$sM,0),(0,D.$pr)(R.$Tbc,R.$Rbc,0),(0,D.$pr)(r.$9bc,r.$8bc,0),(0,D.$pr)(I.$Wcc,I.$1cc,0),(0,D.$pr)(L.$Occ,L.$Ncc,0),(0,D.$pr)(E.$iM,E.$hM,0),(0,D.$pr)(c.$icc,c.$jcc,0),(0,D.$pr)(s.$Dbc,s.$Cbc,0),(0,D.$pr)(T.$ucc,T.$tcc,1),(0,D.$pr)(v.$7cc,v.$8cc,0),(0,D.$pr)(k.$5bc,k.$4bc,0),(0,D.$pr)(A.$Rcc,A.$Qcc,0),(0,D.$pr)(w.$_bc,w.$ccc,0),(0,D.$pr)(S.$Rvb,S.$Svb,0),(0,D.$pr)(u.$Kcc,u.$Jcc,0),(0,D.$pr)(g.$Qbc,g.$Pbc,0),(0,D.$pr)(a.$ecc,a.$dcc,0),(0,D.$pr)(m.$rM,m.$oM,0),(0,D.$pr)(l.$Scc,l.$Tcc,0),(0,D.$pr)(o.$Ucc,o.$Vcc,0)}),define(De[116],Ce([1,0,19,13,36,93]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=e.$Ydc=e.$Xdc=void 0;function R(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$Xdc=R;function b(I,v,k,S){const p=(0,D.$1b)(k,E),u=new g.$FI(v,p,S),r=u.preview.matches;return{ranges:(0,D.$1b)(p,w),uri:I,preview:{text:u.preview.text,matches:(0,D.$1b)(r,w)}}}e.$Ydc=b;function E(I){return new g.$GI(I.start.line,I.start.character,I.end.line,I.end.character)}function w(I){return new L.$uI(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let A=class{constructor(v,k){this.a=v,this.b=k}appendLine(v){this.b.debug(`${this.a}#search`,v)}};e.$Zdc=A,e.$Zdc=A=He([Be(1,T.$8i)],A)}),define(De[356],Ce([1,0,48,16,76,32,12,15,116,357]),function($e,e,D,T,g,L,R,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=e.$1dc=void 0;const A=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(a,m,l,t){const n=v(a,m,l,t),o=m.folder.fsPath;return{cmd:D.spawn(A,n.args,{cwd:o}),rgDiskPath:A,siblingClauses:n.siblingClauses,rgArgs:n,cwd:o}}e.$1dc=I;function v(a,m,l,t){const n=["--files","--hidden","--case-sensitive","--no-require-git"];S([m],l,!1).forEach(i=>{const c=(0,E.$Xdc)(i);if(n.push("-g",c),R.$k){const h=(0,g.$ll)(c);h!==c&&n.push("-g",h)}});const o=k([m],t,void 0,!1);return o.globArgs.forEach(i=>{const c=`!${(0,E.$Xdc)(i)}`;if(n.push("-g",c),R.$k){const h=(0,g.$ll)(c);h!==c&&n.push("-g",h)}}),m.disregardIgnoreFiles!==!1?n.push("--no-ignore"):m.disregardParentIgnoreFiles!==!1&&n.push("--no-ignore-parent"),m.ignoreSymlinks||n.push("--follow"),a.exists&&n.push("--quiet"),n.push("--no-config"),m.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:o.siblingClauses}}function k(a,m,l,t=!0){const n=[];let o={};return a.forEach(i=>{const c=Object.assign({},i.excludePattern||{},m||{}),h=p(c,t?i.folder.fsPath:void 0,l);n.push(...h.globArgs),h.siblingClauses&&(o=Object.assign(o,h.siblingClauses))}),{globArgs:n,siblingClauses:o}}function S(a,m,l=!0){const t=[];return a.forEach(n=>{const o=Object.assign({},m||{},n.includePattern||{}),i=p(o,l?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function p(a,m,l){const t=[],n={};return Object.keys(a).forEach(o=>{if(l&&l.has(o)||!o)return;const i=a[o];o=r(m?u(m,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof i=="boolean"&&i?(o.startsWith("\\\\")&&(o+="**"),t.push(s(o))):i&&i.when&&(n[o]=i)}),{globArgs:t,siblingClauses:n}}function u(a,m){return T.$hc(m)?m:T.$ic(a,m)}e.$2dc=u;function r(a){return a=b.$Je(a,"\\"),b.$Je(a,"/")}function s(a){return L.$Sf(a).toLowerCase()==="c:/"?a.replace(/^c:[/\\]/i,"/"):a}e.$3dc=s}),define(De[358],Ce([1,0,48,53,16,359,19,46,35,76,32,12,37,15,18,29,36,356,127]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=e.$4dc=void 0;const a=new Set;process.on("exit",()=>{a.forEach(o=>o())});class m{constructor(i){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=i,this.b=i.filePattern||"",this.d=i.includePattern&&E.$uj(i.includePattern),this.f=i.maxResults||null,this.g=!!i.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,s.$rq)(this.b).normalizedLowercase),this.u=i.excludePattern&&E.$uj(i.excludePattern),this.t=new Map,i.folderQueries.forEach(c=>{const h=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),y=c.folder.fsPath;i.folderQueries.map(C=>C.folder.fsPath).filter(C=>C!==y).forEach(C=>{(0,A.$Wf)(C,y)&&(h[g.$kc(y,C)]=!0)}),this.t.set(y,new t(h,y))})}cancel(){this.l=!0,a.forEach(i=>i())}walk(i,c,h,y,C){if(this.m=v.$Id.create(!1),this.l)return C(null,this.j);c.forEach($=>{const f=g.$mc($.fsPath);this.u&&this.u($.fsPath,f)||this.J(h,{relativePath:$.fsPath,searchPath:void 0})}),this.r=v.$Id.create(!1),this.w(i,($,f)=>{this.x(this.y,this,$,h,y,d=>{if(d){const P=(0,b.$yi)(d);console.error(P),this.q.push(P),f(d,void 0)}else f(null,void 0)})},($,f)=>{this.m.stop();const d=$?R.$Gb($)[0]:null;C(d,this.j)})}w(i,c,h){const y=new Array(i.length),C=new Array(i.length);let $=!1,f=0;if(i.length===0)return h(null,[]);i.forEach((d,P)=>{c(d,(N,O)=>{if(N?($=!0,y[P]=null,C[P]=N):(y[P]=O,C[P]=null),++f===i.length)return h($?C:null,y)})})}x(i,c,...h){try{i.apply(c,h)}catch(y){h[h.length-1](y)}}y(i,c,h,y){const C=i.folder.fsPath,$=I.$k,f=()=>M&&M.kill();a.add(f);let d=V=>{a.delete(f),d=()=>{},y(V)},P="";const N=this.D(),O=(0,r.$1dc)(this.a,i,this.a.includePattern,this.t.get(i.folder.fsPath).expression),M=O.cmd,j=!Object.keys(O.siblingClauses).length,U=O.rgArgs.args.map(V=>V.match(/^-/)?V:`'${V}'`).join(" ");let F=`${O.rgDiskPath} ${U}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),h({message:F}),this.s=0,this.z(M,"utf8",h,(V,H,fe)=>{if(V){d(V);return}if(this.j){d();return}const Y=(P+($?w.$kl(H||""):H)).split(`
`);if(fe){const q=Y.length;Y[q-1]=Y[q-1].trim(),Y[q-1]||Y.pop()}else P=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){d(new Error("Splitting up files failed"));return}if(this.s+=Y.length,j){for(const q of Y)if(this.J(c,{base:C,relativePath:q,searchPath:this.N(i,q)}),this.j){f();break}(fe||this.j)&&d();return}this.G(i,N,C,Y,c),fe&&(this.H(N,C,c),d())})}spawnFindCmd(i){const c=this.t.get(i.folder.fsPath),h=c.getBasenameTerms(),y=c.getPathTerms(),C=["-L","."];if(h.length||y.length){C.push("-not","(","(");for(const $ of h)C.push("-name",$),C.push("-o");for(const $ of y)C.push("-path",$),C.push("-o");C.pop(),C.push(")","-prune",")")}return C.push("-type","f"),D.spawn("find",C,{cwd:i.folder.fsPath})}readStdout(i,c,h){let y="";this.z(i,c,()=>{},(C,$,f)=>{if(C){h(C);return}y+=$,f&&h(null,y)})}z(i,c,h,y){let C=(d,P,N)=>{(d||N)&&(C=()=>{},this.r?.stop()),y(d,P,N)},$=!1;i.stdout?(this.A(i.stdout,c,C),i.stdout.once("data",()=>$=!0)):h({message:"stdout is null"});let f;i.stderr?f=this.B(i.stderr):h({message:"stderr is null"}),i.on("error",d=>{C(d)}),i.on("close",d=>{let P;!$&&(P=this.C(f,c))&&n(P)?C(new Error(`command failed with error code ${d}: ${this.C(f,c)}`)):(this.g&&d===0&&(this.j=!0),C(null,"",!0))})}A(i,c,h){const y=new L.StringDecoder(c);return i.on("data",C=>{h(null,y.write(C))}),y}B(i){const c=[];return i.on("data",h=>{c.push(h)}),c}C(i,c){const h=new L.StringDecoder(c);return i.map(y=>h.write(y)).join("")}D(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}G(i,{pathToEntries:c},h,y,C){y.indexOf(this.b)!==-1&&this.J(C,{base:h,relativePath:this.b,searchPath:this.N(i,this.b)});const $=f=>{const d=g.$mc(f),P=g.$lc(f);let N=c[P];N||(N=c[P]=[],$(P)),N.push({base:h,relativePath:f,basename:d,searchPath:this.N(i,f)})};y.forEach($)}H({rootEntries:i,pathToEntries:c},h,y){const C=this,$=this.t.get(h),f=this.b;function d(P){C.o++;const N=(0,u.$VI)(()=>P.map(O=>O.basename));for(let O=0,M=P.length;O<M;O++){const j=P[O],{relativePath:U,basename:F}=j;if($.test(U,F,f!==F?N:void 0))continue;const V=c[U];if(V)d(V);else{if(C.p++,U===f)continue;C.J(y,j)}if(C.j)break}}d(i)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(i,c,h,y,C){const $=i.folder,f=(0,u.$VI)(()=>h);this.w(h,(d,P)=>{if(this.l||this.j)return P(null);const N=c?[c,d].join(g.sep):d;if(this.t.get(i.folder.fsPath).test(N,d,this.a.filePattern!==d?f:void 0))return P(null);const O=[$.fsPath,N].join(g.sep);T.lstat(O,(M,j)=>{if(M||this.l||this.j)return P(null);this.L(O,j,(U,F)=>U||this.l||this.j?P(null):F.isDirectory()?(this.o++,this.M(O,j,(V,H)=>V||this.l||this.j||(H=H||"",this.v[H])?P(null):(this.v[H]=!0,p.Promises.readdir(O).then(fe=>{if(this.l||this.j)return P(null);this.I(i,N,fe,y,X=>P(X||null))},fe=>{P(null)})))):(this.p++,N===this.b||this.h&&S.$Bf(F.size)&&F.size>this.h||this.J(y,{base:$.fsPath,relativePath:N,searchPath:this.N(i,N)}),P(null,void 0)))})},d=>{const P=d&&R.$Gb(d);return C(P&&P.length>0?P[0]:void 0)})}J(i,c){this.K(c)&&(!this.d||this.d(c.relativePath,g.$mc(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||i(c))}K(i){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,u.$QI)(i,this.c)}return!0}L(i,c,h){return c.isSymbolicLink()?T.stat(i,h):h(null,c)}M(i,c,h){return c.isSymbolicLink()?T.realpath(i,(y,C)=>y?h(y):h(null,C)):h(null,i)}N(i,c){return i.folderName?g.$ic(i.folderName,c):c}}e.$4dc=m;class l{constructor(i){this.a=i.folderQueries,this.b=i.extraFileResources||[],this.c=new m(i)}search(i,c,h){this.c.walk(this.a,this.b,i,c,(y,C)=>{h(y,{limitHit:C,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$5dc=l;class t{constructor(i,c){this.expression=i,this.c=c,this.d(i)}d(i){let c,h;Object.keys(i).filter(y=>i[y]).forEach(y=>{g.$hc(y)?(c=c||E.$pj(),c[y]=i[y]):(h=h||E.$pj(),h[y]=i[y])}),this.a=c&&E.$uj(c,{trimForExclusions:!0}),this.b=h&&E.$uj(h,{trimForExclusions:!0})}test(i,c,h){return this.b&&this.b(i,c,h)||this.a&&this.a(g.$ic(this.c,i),c,h)}getBasenameTerms(){const i=[];return this.a&&i.push(...E.$wj(this.a)),this.b&&i.push(...E.$wj(this.b)),i}getPathTerms(){const i=[];return this.a&&i.push(...E.$xj(this.a)),this.b&&i.push(...E.$xj(this.b)),i}}function n(o){const i=o.trim().split(`
`),c=i[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return k.$pf(i[i.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(De[360],Ce([1,0,97,22,182,21]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wC=e.$vC=e.$uC=e.$tC=e.$sC=e.$rC=e.$qC=e.$pC=e.$oC=e.DecodeStreamErrorKind=e.$nC=e.$mC=e.$lC=e.$kC=e.$jC=e.$iC=e.$hC=e.$gC=void 0,e.$gC="utf8",e.$hC="utf8bom",e.$iC="utf16be",e.$jC="utf16le";function R(c){return[e.$gC,e.$hC,e.$iC,e.$jC].some(h=>h===c)}e.$kC=R,e.$lC=[254,255],e.$mC=[255,254],e.$nC=[239,187,191];const b=512,E=512,w=512*8,A=512*128;var I;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class v extends Error{constructor(h,y){super(h),this.decodeStreamErrorKind=y}}e.$oC=v;class k{static async create(h){let y;if(h!==e.$gC)y=(await(0,g.$fC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(r(h));else{const C=new TextDecoder;y={write($){return C.decode($,{stream:!0})},end(){return C.decode()}}}return new k(y)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function S(c,h){const y=h.minBytesRequiredForDetection??h.guessEncoding?w:E;return new Promise((C,$)=>{const f=(0,D.$1d)(j=>j.join("")),d=[];let P=0,N;const O=new L.$Wd,M=async()=>{try{const j=await i({buffer:T.$ae.concat(d),bytesRead:P},h.guessEncoding);if(j.seemsBinary&&h.acceptTextOnly)throw new v("Stream is binary but only text is accepted for decoding",1);j.encoding=await h.overwriteEncoding(j.encoding),N=await k.create(j.encoding);const U=N.write(T.$ae.concat(d).buffer);f.write(U),d.length=0,P=0,C({stream:f,detected:j})}catch(j){O.cancel(),f.destroy(),$(j)}};(0,D.$5d)(c,{onData:async j=>{N?f.write(N.write(j.buffer)):(d.push(j),P+=j.byteLength,P>=y&&(c.pause(),await M(),setTimeout(()=>c.resume())))},onError:j=>f.error(j),onEnd:async()=>{N||await M(),f.end(N?.end())}},O.token)})}e.$pC=S;async function p(c,h,y){const $=(await(0,g.$fC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(r(h),y);let f=!1,d=!1;return{read(){if(d)return null;const P=c.read();if(typeof P!="string"){if(d=!0,!f&&y?.addBOM)switch(h){case e.$gC:case e.$hC:return T.$ae.wrap(Uint8Array.from(e.$nC));case e.$iC:return T.$ae.wrap(Uint8Array.from(e.$lC));case e.$jC:return T.$ae.wrap(Uint8Array.from(e.$mC))}const N=$.end();return N&&N.length>0?(f=!0,T.$ae.wrap(N)):null}return f=!0,T.$ae.wrap($.write(P))}}}e.$qC=p;async function u(c){return(await(0,g.$fC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(r(c))}e.$rC=u;function r(c){return c===e.$hC||c===null?e.$gC:c}e.$sC=r;function s(c,h){if(!c||h<e.$lC.length)return null;const y=c.readUInt8(0),C=c.readUInt8(1);if(y===e.$lC[0]&&C===e.$lC[1])return e.$iC;if(y===e.$mC[0]&&C===e.$mC[1])return e.$jC;if(h<e.$nC.length)return null;const $=c.readUInt8(2);return y===e.$nC[0]&&C===e.$nC[1]&&$===e.$nC[2]?e.$hC:null}e.$tC=s;const a=["ascii","utf-16","utf-32"];async function m(c){const h=await(0,g.$fC)("jschardet","dist/jschardet.min.js"),y=c.slice(0,A),C=n(y.buffer),$=h.detect(C);if(!$||!$.encoding)return null;const f=$.encoding.toLowerCase();return 0<=a.indexOf(f)?null:t($.encoding)}const l={ibm866:"cp866",big5:"cp950"};function t(c){const h=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return l[h]||h}function n(c){let h="";for(let y=0;y<c.length;y++)h+=String.fromCharCode(c[y]);return h}function o(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=c.match(/windows(\d+)/);return h?"windows-"+h[1]:c}}}e.$uC=o;function i({buffer:c,bytesRead:h},y){let C=s(c,h),$=!1;if(C!==e.$iC&&C!==e.$jC&&c){let f=!0,d=!0,P=!1;for(let N=0;N<h&&N<b;N++){const O=N%2===1,M=c.readUInt8(N)===0;if(M&&(P=!0),f&&(O&&!M||!O&&M)&&(f=!1),d&&(O&&M||!O&&!M)&&(d=!1),M&&!f&&!d)break}P&&(f?C=e.$jC:d?C=e.$iC:$=!0)}return y&&!$&&!C&&c?m(c.slice(0,h)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:$,encoding:C}}e.$vC=i,e.$wC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[154],Ce([1,0,360,29,153]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class L extends g.$3cc{constructor(b,E,w=T,A="searchProcess"){super(b,E,{readdir:I=>w.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,D.$uC)(I)},A)}}e.$aec=L}),define(De[155],Ce([1,0,48,376,359,19,73,35,16,15,2,36,93,377,357,116]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=e.$$dc=e.$0dc=e.$9dc=e.$8dc=e.$7dc=e.$6dc=void 0;const u=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class r{constructor(d){this.a=d}provideTextSearchResults(d,P,N,O){return this.a.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((M,j)=>{O.onCancellationRequested(()=>q());const U=n(d,P),F=P.folder.fsPath,V=U.map(G=>G.match(/^-/)?G:`'${G}'`).join(" ");this.a.appendLine(`${u} ${V}
 - cwd: ${F}`);let H=D.spawn(u,U,{cwd:F});H.on("error",G=>{console.error(G),this.a.appendLine("Error: "+(G&&G.message)),j((0,I.$MI)(new I.$KI(G&&G.message,I.SearchErrorCode.rgProcessError)))});let fe=!1;const X=new m(P.maxResults,F,P.previewOptions);X.on("result",G=>{fe=!0,me="",N.report(G)});let Y=!1;const q=()=>{Y=!0,H?.kill(),X?.cancel()};let x=!1;X.on("hitLimit",()=>{x=!0,q()});let me="";H.stdout.on("data",G=>{X.handleData(G),fe||(me+=G)});let ue=!1;H.stdout.once("data",()=>ue=!0);let pe="";H.stderr.on("data",G=>{const z=G.toString();this.a.appendLine(z),pe.length+z.length<1e6&&(pe+=z)}),H.on("close",()=>{if(this.a.appendLine(ue?"Got data from stdout":"No data from stdout"),this.a.appendLine(fe?"Got result from parser":"No result from parser"),me&&this.a.appendLine(`Got data without result: ${me}`),this.a.appendLine(""),Y)M({limitHit:x});else{X.flush(),H=null;let G;pe&&!ue&&(G=s(pe))?j((0,I.$MI)(new I.$KI(G.message,G.code))):M({limitHit:x})}})})}}e.$6dc=r;function s(f){const d=f.split(`
`),P=d[0].trim();if(d.some(O=>O.startsWith("regex parse error")))return new I.$KI(a(d),I.SearchErrorCode.regexParseError);const N=P.match(/grep config error: unknown encoding: (.*)/);if(N)return new I.$KI(`Unknown encoding: ${N[1]}`,I.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new I.$KI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new I.$KI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new I.$KI(P,I.SearchErrorCode.regexParseError)}function a(f){const d=["Regex parse error"],P=f.filter(N=>N.startsWith("PCRE2:"));if(P.length>=1){const N=P[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const O=N.split(":")[1];d.push(":"+O)}}return d.join("")}class m extends T.EventEmitter{constructor(d,P,N){super(),this.g=d,this.h=P,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(d,P){return super.on(d,P),this}handleData(d){if(this.b)return;const P=typeof d=="string"?d:this.d.write(d);this.k(P)}k(d){let P=d.indexOf(`
`);const N=this.a+d;if(P>=0)P+=this.a.length;else{this.a=N;return}let O=0;for(;P>=0;)this.m(N.substring(O,P).trim()),O=P+1,P=N.indexOf(`
`,O);this.a=N.substring(O)}m(d){if(this.b||!d)return;let P;try{P=JSON.parse(d)}catch{throw new Error(`malformed line from rg: ${d}`)}if(P.type==="match"){const N=l(P.data.path),O=A.URI.file(E.$ic(this.h,N)),M=this.n(P.data,O);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const N=l(P.data.path),O=A.URI.file(E.$ic(this.h,N));this.o(P.data,O).forEach(j=>this.p(j))}}n(d,P){const N=d.line_number-1,O=l(d.lines),M=Buffer.from(O);let j=0,U=0,F=N;d.submatches.length===0&&d.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const V=(0,L.$Gb)(d.submatches.map((H,fe)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const X=l(H.match),Y=M.slice(j,H.start).toString(),q=t(Y),x=q.numLines>0?q.lastLineLength:q.lastLineLength+U,me=t(X),ue=q.numLines+F,pe=me.numLines+ue,G=me.numLines>0?me.lastLineLength:me.lastLineLength+x;return j=H.end,U=G,F=pe,new v.$uI(ue,x,pe,G)}));return(0,p.$Ydc)(P,O,V,this.j)}o(d,P){const N=l(d.lines),O=d.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((M,j)=>({text:M,uri:P,lineNumber:O+j}))}p(d){this.emit("result",d)}}e.$7dc=m;function l(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function t(f){const d=/\n/g;let P=0,N=-1,O;for(;O=d.exec(f);)P++,N=O.index;const M=N>=0?f.length-N-1:f.length;return{numLines:P,lastLineLength:M}}function n(f,d){const P=["--hidden","--no-require-git"];P.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:O}=(0,R.$J)(d.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const j=new Set;O.forEach(U=>{j.add(U)}),P.push("-g","!*"),j.forEach(U=>{o(U).map(p.$Xdc).forEach(F=>{P.push("-g",F)})})}N&&N.length&&N.forEach(j=>{P.push("-g",j)}),d.excludes.map(p.$Xdc).forEach(j=>P.push("-g",`!${j}`)),d.maxFileSize&&P.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?d.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),d.followSymlinks&&P.push("--follow"),d.encoding&&d.encoding!=="utf8"&&P.push("--encoding",d.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,w.$Ee)(f.pattern),f.isRegExp=!0),d.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),f.isRegExp&&(f.pattern=i(f.pattern),P.push("--engine","auto"));let M;if(f.isWordMatch){const U=(0,w.$Me)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",U)}else if(f.isRegExp){let j=h(f.pattern);j=y(j),P.push("--regexp",j)}else M=f.pattern,P.push("--fixed-strings");return P.push("--no-config"),d.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),f.isMultiline&&P.push("--multiline"),d.beforeContext&&P.push("--before-context",d.beforeContext+""),d.afterContext&&P.push("--after-context",d.afterContext+""),P.push("--"),M&&P.push(M),P.push("."),P}e.$8dc=n;function o(f){return $(f).flatMap(P=>{const N=(0,b.$sj)(P,"/");return N.map((O,M)=>N.slice(0,M+1).join("/"))})}function i(f){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(d);)f=f.replace(d,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(P);)f=f.replace(P,"$1\\x{$2}");return f}e.$9dc=i;const c=f=>f.type==="Assertion"&&f.kind==="lookbehind";function h(f){let d;try{d=new k.RegExpParser().parsePattern(f)}catch{return f}let P="",N=0;const O=(U,F,V)=>{P+=f.slice(N,U)+V,N=F},M=[];return new k.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const F=M[0];if(!F)O(U.start,U.end,"\\r?\\n");else if(!M.some(c))if(F.type==="CharacterClass")if(F.negate){const V=f.slice(F.start+2,U.start)+f.slice(U.end,F.end-1);F.parent?.type==="Quantifier"?O(F.start,F.end,V?`[^${V}]`:"."):O(F.start,F.end,"(?!\\r?\\n"+(V?`|[${V}]`:"")+")")}else{const V=f.slice(F.start+1,U.start)+f.slice(U.end,F.end-1);O(F.start,F.end,V===""?"\\r?\\n":`(?:[${V}]|\\r?\\n)`)}else F.type==="Quantifier"&&O(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){M.unshift(U)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(U){M.unshift(U)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(U){M.unshift(U)},onCharacterClassLeave(){M.shift()},onAssertionEnter(U){c(U)&&M.push(U)},onAssertionLeave(U){M[0]===U&&M.shift()}}).visit(d),P+=f.slice(N),P}e.$0dc=h;function y(f){return f.replace(/\n/g,"\\r?\\n")}e.$$dc=y;function C(f){let d=!1,P=!1,N="",O="";for(let M=0;M<f.length;M++){const j=f[M];switch(j){case"\\":P?(d?O+="\\"+j:N+="\\"+j,P=!1):P=!0;break;case"{":if(P)d?O+=j:N+=j,P=!1;else{if(d)return{strInBraces:N+"{"+O+"{"+f.substring(M+1)};d=!0}break;case"}":if(P)d?O+=j:N+=j,P=!1;else{if(d)return{fixedStart:N,strInBraces:O,fixedEnd:f.substring(M+1)};N+=j}break;default:d?O+=(P?"\\":"")+j:N+=(P?"\\":"")+j,P=!1;break}}return{strInBraces:N+(d?"{"+O:"")}}function $(f){const{fixedStart:d,strInBraces:P,fixedEnd:N}=C(f);if(d===void 0||N===void 0)return[P];let O=(0,b.$sj)(P,",");O.length||(O=[""]);const M=$(N);return O.flatMap(j=>{const U=d+j;return M.map(F=>U+F)})}e.$_dc=$}),define(De[361],Ce([1,0,21,155,84,17]),function($e,e,D,T,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;class R{constructor(w){this.b=w,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(w,A,I,v){const k=new T.$6dc(this.b);if(A.folder.scheme===L.Schemas.vscodeUserData){const S={...A,folder:A.folder.with({scheme:L.Schemas.file})},p=new g.$Yu(u=>I.report({...u,uri:u.uri.with({scheme:A.folder.scheme})}));return this.c(v,u=>k.provideTextSearchResults(w,S,p,u))}else return this.c(v,S=>k.provideTextSearchResults(w,A,I,S))}async c(w,A){const I=b(w);this.a.add(I);const v=await A(I.token);return this.a.delete(I),v}d(){this.a.forEach(w=>w.cancel())}}e.$dec=R;function b(E){const w=new D.$Wd;return E.onCancellationRequested(()=>w.cancel()),w}}),define(De[362],Ce([1,0,29,155,154]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class L{constructor(E){this.a=E}search(E,w,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(k){A({message:k})}},v=new g.$aec(this.a,new T.$6dc(I),D);return new Promise((k,S)=>v.search(p=>{w(p.map(R))},E).then(p=>k({limitHit:p.limitHit,type:"success",stats:p.stats}),S))}}e.$bec=L;function R(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((E,w)=>{if(w.ranges){const A=w;return E+(Array.isArray(A.ranges)?A.ranges.length:1)}else return E+1},0)}}}),define(De[363],Ce([1,0,19,11,8,4,127,16,37,2,30,36,358,362]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;class S{static{this.a=512}constructor(m="searchProcess"){this.d=m,this.b=Object.create(null)}fileSearch(m){let l;const t=r(m),n=new L.$Md({onDidAddFirstListener:()=>{l=(0,T.$Gg)(o=>this.doFileSearchWithEngine(v.$5dc,t,i=>n.fire(i),o)),l.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{l.cancel()}});return n.event}textSearch(m){let l;const t=r(m),n=new L.$Md({onDidAddFirstListener:()=>{l=(0,T.$Gg)(o=>this.f(t,i=>n.fire(i),o)),l.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{l.cancel()}});return n.event}f(m,l,t){return m.maxFileSize=this.g().maxFileSize,new k.$bec(m).search(t,l,l)}g(){return{maxFileSize:process.arch==="ia32"?300*A.$Dk.MB:16*A.$Dk.GB}}doFileSearch(m,l,t){return this.doFileSearchWithEngine(v.$5dc,m,l,t)}doFileSearchWithEngine(m,l,t,n,o=S.a){let i=0;const c=y=>{Array.isArray(y)?(i+=y.length,t(y.map(C=>this.h(C)))):y.relativePath?(i++,t(this.h(y))):t(y)};if(l.sortByScore){let y=this.l(l,c,n);if(!y){const C=l.maxResults?Object.assign({},l,{maxResults:null}):l,$=new m(C);y=this.j($,l,t,c,n)}return new Promise((C,$)=>{y.then(([f,d])=>{const P=d.map(N=>this.h(N));this.o(P,t,o),C(f)},$)})}const h=new m(l);return this.r(h,c,o,n).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.d,fromCache:!1,resultCount:i,sortingTime:void 0}}))}h(m){return{path:m.base?(0,b.$ic)(m.base,m.relativePath):m.relativePath}}j(m,l,t,n,o){const i=new L.$Md;let c=(0,T.$Gg)(y=>{let C=[];const $=f=>{Array.isArray(f)?C=f:(n(f),i.fire(f))};return this.r(m,$,-1,y).then(f=>[f,C])}),h;if(l.cacheKey){h=this.k(l.cacheKey);const y={promise:c,event:i.event,resolved:!1};h.resultsToSearchCache[l.filePattern||""]=y,c.then(()=>{y.resolved=!0},C=>{delete h.resultsToSearchCache[l.filePattern||""]}),c=this.s(c)}return c.then(([y,C])=>{const $=h?h.scorerCache:Object.create(null),f=(typeof l.maxResults!="number"||l.maxResults>0)&&E.$Id.create(!1);return this.n(l,C,$,o).then(d=>{const P=f?f.elapsed():-1;return[{type:"success",stats:{detailStats:y.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:l.folderQueries.length,resultCount:d.length},messages:y.messages,limitHit:y.limitHit||typeof l.maxResults=="number"&&C.length>l.maxResults},d]})})}k(m){const l=this.b[m];return l||(this.b[m]=new p)}l(m,l,t){const n=m.cacheKey&&this.b[m.cacheKey];if(!n)return;const o=this.q(n,m.filePattern||"",l,t);if(o)return o.then(([i,c,h])=>{const y=E.$Id.create(!1);return this.n(m,c,n.scorerCache,t).then(C=>{const $=y.elapsed(),f={fromCache:!0,detailStats:h,type:this.d,resultCount:c.length,sortingTime:$};return[{type:"success",limitHit:i.limitHit||typeof m.maxResults=="number"&&c.length>m.maxResults,stats:f},C]})})}n(m,l,t,n){const o=(0,R.$rq)(m.filePattern||""),i=(h,y)=>(0,R.$qq)(h,y,o,!0,u,t),c=typeof m.maxResults=="number"?m.maxResults:Number.MAX_VALUE;return D.$Fb(l,i,c,1e4,n)}o(m,l,t){if(t&&t>0)for(let n=0;n<m.length;n+=t)l(m.slice(n,n+t));else l(m)}q(m,l,t,n){const o=E.$Id.create(!1),i=l.indexOf(b.sep)>=0;let c;for(const $ in m.resultsToSearchCache)if(l.startsWith($)){if(i&&$.indexOf(b.sep)<0&&$!=="")continue;const f=m.resultsToSearchCache[$];c={promise:this.s(f.promise),event:f.event,resolved:f.resolved};break}if(!c)return null;const h=o.elapsed(),y=E.$Id.create(!1),C=c.event(t);return n&&n.onCancellationRequested(()=>{C.dispose()}),c.promise.then(([$,f])=>{if(n&&n.isCancellationRequested)throw(0,g.$5)();const d=[],P=(0,R.$rq)(l).normalizedLowercase;for(const N of f)(0,I.$QI)(N,P)&&d.push(N);return[$,d,{cacheWasResolved:c.resolved,cacheLookupTime:h,cacheFilterTime:y.elapsed(),cacheEntryCount:f.length}]})}r(m,l,t,n){return new Promise((o,i)=>{let c=[];n?.onCancellationRequested(()=>m.cancel()),m.search(h=>{h&&(t?(c.push(h),t>0&&c.length>=t&&(l(c),c=[])):l(h))},h=>{l(h)},(h,y)=>{c.length&&l(c),h?i(h):o(y)})})}clearCache(m){return delete this.b[m],Promise.resolve(void 0)}s(m){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(l,t){return m.then(l,t)}catch(l){return this.then(void 0,l)}finally(l){return m.finally(l)}}}}e.$cec=S;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const u=new class{getItemLabel(a){return(0,b.$mc)(a.relativePath)}getItemDescription(a){return(0,b.$lc)(a.relativePath)}getItemPath(a){return a.relativePath}};function r(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(s),extraFileResources:a.extraFileResources&&a.extraFileResources.map(m=>w.URI.revive(m))}}function s(a){return{...a,folder:w.URI.revive(a.folder)}}}),define(De[364],Ce([1,0,3,17,2,29,13,26,20,96,66,36,363,361,116,154]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;let u=class extends w.$8cc{constructor(s,a,m,l){super(s,m,l),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Qc;const t=new S.$Zdc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new k.$dec(t))),a.remote.isRemote&&a.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const s=new S.$Zdc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new k.$dec(s))),this.x.add(this.z(T.Schemas.file,new v.$cec("fileSearchProvider")))}z(s,a){const m=this.d++;return this.v=a,this.t=m,this.c.$registerFileSearchProvider(m,this.o(s)),(0,D.$Pc)(()=>{this.v=null,this.c.$unregisterProvider(m)})}$provideFileSearchResults(s,a,m,l){const t=(0,w.$9cc)(m);return s===this.t?this.A(s,a,t,l):super.$provideFileSearchResults(s,a,m,l)}A(s,a,m,l){const t=n=>{if((0,I.$PI)(n)&&(n=[n]),Array.isArray(n)){this.c.$handleFileMatch(s,a,n.map(o=>g.URI.file(o.path)));return}n.message&&this.n.debug("ExtHostSearch",n.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(m,t,l)}$clearCache(s){return this.v?.clearCache(s),super.$clearCache(s)}q(s,a){return new p.$aec(s,a,void 0,"textSearchProvider")}};e.$eec=u,e.$eec=u=He([Be(0,E.$0L),Be(1,b.$nM),Be(2,A.$Nbc),Be(3,R.$8i)],u)}),define(De[117],Ce([1,0,378,60,63,379,22,8,4,3,16,12,31,80,81]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class p{traceSocketEvent(f,d){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,d)}constructor(f,d=""){this.f=!0,this.debugLabel=d,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.$Z)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const d=P=>{this.traceSocketEvent("read",P),f(R.$ae.wrap(P))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(f){const d=P=>{f({type:0,hadError:P,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(f){const d=()=>{f()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,b.$Z)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,b.$Z)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Ch=p;var u;(function($){$[$.MinHeaderByteSize=2]="MinHeaderByteSize",$[$.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(u||(u={}));var r;(function($){$[$.PeekHeader=1]="PeekHeader",$[$.ReadHeader=2]="ReadHeader",$[$.ReadBody=3]="ReadBody",$[$.Fin=4]="Fin"})(r||(r={}));class s extends w.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,d){this.socket.traceSocketEvent(f,d)}constructor(f,d,P,N){super(),this.f=this.B(new E.$Md),this.g=this.B(new E.$Md),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:P?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new a(this,d,P,N,this.f,(O,M)=>this.m(O,M))),this.B(this.a.onError(O=>{console.error(O),(0,b.$Z)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new S.$xh,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let d=0;for(;d<f.byteLength;)this.a.writeMessage(f.slice(d,Math.min(d+262144,f.byteLength)),{compressed:!0,opcode:2}),d+=262144}m(f,{compressed:d,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let N=2;f.byteLength<126?N+=0:f.byteLength<2**16?N+=2:N+=8;const O=R.$ae.alloc(N),M=d?64:0,j=P&15;if(O.writeUInt8(128|M|j,0),f.byteLength<126)O.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){O.writeUInt8(126,1);let U=1;O.writeUInt8(f.byteLength>>>8&255,++U),O.writeUInt8(f.byteLength>>>0&255,++U)}else{O.writeUInt8(127,1);let U=1;O.writeUInt8(0,++U),O.writeUInt8(0,++U),O.writeUInt8(0,++U),O.writeUInt8(0,++U),O.writeUInt8(f.byteLength>>>24&255,++U),O.writeUInt8(f.byteLength>>>16&255,++U),O.writeUInt8(f.byteLength>>>8&255,++U),O.writeUInt8(f.byteLength>>>0&255,++U)}this.socket.write(R.$ae.concat([O,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const d=this.b.peek(this.j.readLen),P=d.readUInt8(0),N=(P&128)>>>7,O=(P&64)>>>6,M=P&15,j=d.readUInt8(1),U=(j&128)>>>7,F=j&127;this.j.state=2,this.j.readLen=2+(U?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const d=this.b.read(this.j.readLen),P=d.readUInt8(1),N=(P&128)>>>7;let O=P&127,M=1;O===126?O=d.readUInt8(++M)*2**8+d.readUInt8(++M):O===127&&(O=d.readUInt8(++M)*0+d.readUInt8(++M)*0+d.readUInt8(++M)*0+d.readUInt8(++M)*0+d.readUInt8(++M)*2**24+d.readUInt8(++M)*2**16+d.readUInt8(++M)*2**8+d.readUInt8(++M));let j=0;N&&(j=d.readUInt8(++M)*2**24+d.readUInt8(++M)*2**16+d.readUInt8(++M)*2**8+d.readUInt8(++M)),this.j.state=3,this.j.readLen=O,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const d=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),t(d,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(d,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(d,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Dh=s;class a extends w.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$ae.alloc(0)}constructor(f,d,P,N,O,M){super(),this.n=f,this.r=O,this.s=M,this.a=this.B(new E.$Md),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$Md),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$Md),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,d?(this.b=this.B(new m(this.n,N,P,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(f,d){this.g.push({data:f,options:d}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:d}=this.g.shift();if(this.f&&d.compressed){const P=await this.w(this.f,f);this.s(P,d)}else this.s(f,{...d,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,d){return new Promise((P,N)=>{f.write(d),f.flush(O=>P(O))})}acceptFrame(f,d,P){this.h.push({data:f,isCompressed:d,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const d=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(d)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,d,P){return new Promise((N,O)=>{f.write(d),P&&f.write(R.$ae.fromByteArray([0,0,255,255])),f.flush(M=>N(M))})}}class m extends w.$Rc{get recordedInflateBytes(){return this.j?R.$ae.concat(this.f):R.$ae.alloc(0)}constructor(f,d,P,N){super(),this.h=f,this.j=d,this.a=this.B(new E.$Md),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(N),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(R.$ae.wrap(O))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const d=R.$ae.concat(this.g);this.g.length=0,f(d)})}}class l extends w.$Rc{constructor(f,d){super(),this.g=f,this.a=this.B(new E.$Md),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(R.$ae.wrap(P))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let d=R.$ae.concat(this.f);this.f.length=0,d=d.slice(0,d.byteLength-4),f(d)})}}function t($,f){if(f===0)return;const d=$.byteLength>>>2;for(let U=0;U<d;U++){const F=$.readUInt32BE(U*4);$.writeUInt32BE(F^f,U*4)}const P=d*4,N=$.byteLength-P,O=f>>>24&255,M=f>>>16&255,j=f>>>8&255;N>=1&&$.writeUInt8($.readUInt8(P)^O,P),N>=2&&$.writeUInt8($.readUInt8(P+1)^M,P+1),N>=3&&$.writeUInt8($.readUInt8(P+2)^j,P+2)}e.$Eh=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function o(){const $=(0,v.$dg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${$}-sock`;const f=process.platform!=="darwin"&&e.$Eh?e.$Eh:(0,g.tmpdir)(),d=(0,A.$ic)(f,`vscode-ipc-${$}.sock`);return c(d),d}e.$Fh=o;function i($,f,d){const P=(0,D.createHash)("md5").update($).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${d}-${f}-sock`;const N=d.substr(0,4),O=f.substr(0,6),M=P.substr(0,8);let j;return process.platform!=="darwin"&&e.$Eh&&!process.env.VSCODE_PORTABLE?j=(0,A.$ic)(e.$Eh,`vscode-${M}-${N}-${O}.sock`):j=(0,A.$ic)($,`${N}-${O}.sock`),c(j),j}e.$Gh=i;function c($){const f=n[I.$u];typeof f=="number"&&$.length>=f&&console.warn(`WARNING: IPC handle "${$}" is longer than ${f} chars, try a shorter --user-data-dir`)}class h extends k.$rh{static b(f){const d=E.Event.fromNodeEventEmitter(f,"connection");return E.Event.map(d,P=>({protocol:new S.$yh(new p(P,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(P,"close"))}))}constructor(f){super(h.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Hh=h;function y($){return new Promise((f,d)=>{const P=(0,T.createServer)();P.on("error",d),P.listen($,()=>{P.removeListener("error",d),f(new h(P))})})}e.$Ih=y;function C($,f){return new Promise((d,P)=>{const N=(0,T.createConnection)($,()=>{N.removeListener("error",P),d(S.$zh.fromSocket(new p(N,`ipc-client${f}`),f))});N.once("error",P)})}e.$Jh=C}),define(De[365],Ce([1,0,60,63,163,117,11,3,12,49,13,135,247,248,107,86,22]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=e.$O7b=e.$N7b=e.$M7b=void 0;async function r(t,n,o,i,c){let h;for(let y=3;y&&(h?.dispose(),h=await new s(t,n,o,i,c).waitForReady(),!(c&&g.$gg[c]||!g.$gg[h.tunnelLocalPort]));y--);return h}class s extends b.$Rc{constructor(n,o,i,c,h){super(),this.m=o,this.n=h,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=D.createServer(),this.c=new R.$Rg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=y=>this.r(y),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,o=(0,p.$0u)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,g.$hg)(n,2,1e3,o),c=null;return this.b.listen(i,this.m),await this.c.wait(),c=this.b.address(),c||(i=0,this.b.listen(i,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(n){n.pause();const o=(0,p.$8u)(this.tunnelRemoteHost)||(0,p.$0u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.$3k)(this.a,o,this.tunnelRemotePort),c=i.getSocket(),h=i.readEntireBuffer();i.dispose(),h.byteLength>0&&n.write(h.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),c.end()}),n.on("close",()=>c.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),c instanceof L.$Ch?c.socket.destroy():c.end()}),c instanceof L.$Ch?this.t(n,c):this.s(n,c),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),c.end()})}s(n,o){o.onClose(()=>n.destroy()),o.onEnd(()=>n.end()),o.onData(i=>n.write(i.buffer)),n.on("data",i=>o.write(u.$ae.wrap(i))),n.resume()}t(n,o){const i=o.socket;i.on("end",()=>n.end()),i.on("close",()=>n.end()),i.on("error",()=>{n.destroy()}),i.pipe(n),n.pipe(i)}}e.$M7b=s;let a=class extends p.$av{constructor(n,o,i,c,h){super(o,h),this.u=n,this.v=i,this.w=c}isPortPrivileged(n){return(0,p.$$u)(n,this.l,E.OS,T.release())}s(n,o,i,c,h,y,C,$){const f=this.r(o,i);if(f)return++f.refcount,f.value;if((0,p.$5u)(n))return this.t(n,o,i,h,y,C,$);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${i} on local port ${h}.`);const d={commit:this.w.commit,quality:this.w.quality,addressProvider:n,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},P=r(d,c,o,i,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(o,i,P),P}}};e.$N7b=a,e.$N7b=a=He([Be(0,k.$Wk),Be(1,A.$8i),Be(2,S.$Zk),Be(3,I.$nj),Be(4,w.$hi)],a);let m=class extends a{constructor(n,o,i,c,h){super(n,o,i,c,h)}};e.$O7b=m,e.$O7b=m=He([Be(0,k.$Wk),Be(1,A.$8i),Be(2,S.$Zk),Be(3,I.$nj),Be(4,w.$hi)],m);let l=class extends b.$Rc{constructor(n,o,i,c,h){super(),this.b=n,this.c=o,this.f=i,this.g=c,this.h=h,this.a=new Map}async openTunnel(n,o,i,c,h,y,C,$,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${c} on local port ${y}.`),!this.a.has(n)){const d=new m(this.b,this.c,this.g,this.f,this.h);this.B(d),this.a.set(n,d),d.onTunnelClosed(async()=>{(await d.tunnels).length===0&&(d.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(o,i,c,h,y,C,$,f)}};e.$P7b=l,e.$P7b=l=He([Be(0,k.$Wk),Be(1,A.$8i),Be(2,I.$nj),Be(3,S.$Zk),Be(4,w.$hi)],l)}),define(De[366],Ce([1,0,117,267,53,33,2,13,43]),function($e,e,D,T,g,L,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zM=e.$yM=void 0;class w{constructor(v,k,S){this.b=v,this.c=k,this.f=S,this.a=T.createServer((p,u)=>this.h(p,u)),this.g().catch(p=>(k.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,k){const S=(u,r)=>{k.writeHead(u,{"content-type":"application/json"}),k.end(JSON.stringify(r||null),s=>s&&this.c.error(s))},p=[];v.setEncoding("utf8"),v.on("data",u=>p.push(u)),v.on("end",async()=>{try{const u=JSON.parse(p.join(""));let r;switch(u.type){case"open":r=await this.i(u);break;case"openExternal":r=await this.j(u);break;case"status":r=await this.l(u);break;case"extensionManagement":r=await this.k(u);break;default:S(404,`Unknown message type: ${u.type}`);break}S(200,r)}catch(u){const r=u instanceof Error?u.message:JSON.stringify(u);S(500,r),this.c.error("Error while processing pipe request",u)}})}async i(v){const{fileURIs:k,folderURIs:S,forceNewWindow:p,diffMode:u,mergeMode:r,addMode:s,forceReuseWindow:a,gotoLineMode:m,waitMarkerFilePath:l,remoteAuthority:t}=v,n=[];if(Array.isArray(S))for(const h of S)try{n.push({folderUri:R.URI.parse(h)})}catch{}if(Array.isArray(k))for(const h of k)try{(0,E.$gi)(h)?n.push({workspaceUri:R.URI.parse(h)}):n.push({fileUri:R.URI.parse(h)})}catch{}const o=l?R.URI.file(l):void 0,c={forceNewWindow:p,diffMode:u,mergeMode:r,addMode:s,gotoLineMode:m,forceReuseWindow:a,preferNewWindow:!a&&!o&&!s,waitMarkerFileURI:o,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",n,c)}async j(v){for(const k of v.uris){const S=R.URI.parse(k),p=S.scheme==="file"?S:k;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k(v){const k=p=>p?.map(u=>/\.vsix$/i.test(u)?R.URI.parse(u):u),S={list:v.list,install:k(v.install),uninstall:k(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$yM=w;let A=class extends w{constructor(v,k){super(v,k,(0,D.$Fh)())}};e.$zM=A,e.$zM=A=He([Be(0,L.$tM),Be(1,b.$8i)],A)}),define(De[367],Ce([1,0,54,354,349,266,45,337,2,17,7,366,101,335,336]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class p extends g.$Kdc{j(){const s=this,a=globalThis._VSCODE_NODE_MODULES.module,m=a._load;a._load=function(o,i,c){return o=t(o),s.a.has(o)?s.a.get(o).load(o,E.URI.file((0,v.$1p)(i.filename)),h=>m.apply(this,[h,i,c])):m.apply(this,arguments)};const l=a._resolveLookupPaths;a._resolveLookupPaths=(n,o)=>l.call(this,t(n),o);const t=n=>{for(const o of s.b){const i=o(n);if(i){n=i;break}}return n}}}class u extends R.$lcc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(k.$hec);const s=this.h.invokeFunction(T.$Gdc);if(this.h.createInstance(b.$gec),this.f.remote.isRemote&&this.f.remote.authority){const l=this.h.createInstance(I.$zM);process.env.VSCODE_IPC_HOOK_CLI=l.ipcHandlePath}this.h.createInstance(S.$iec),await this.h.createInstance(p,s,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const m=await this.m.getConfigProvider();await(0,L.$fec)(this.j,m,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(s){return s.main}async vb(s,a,m){if(a.scheme!==w.Schemas.file)throw new Error(`Cannot load URI: '${a}', must be of file-scheme`);let l=null;m.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${a.toString(!0)}`),this.s.flush();const t=s?.identifier.value;s&&await this.w.initializeLocalizedMessages(s);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),l=$e.__$__nodeRequire(a.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),m.codeLoadingStop()}return l}async $setRemoteEnvironment(s){if(this.f.remote.isRemote)for(const a in s){const m=s[a];m===null?delete process.env[a]:process.env[a]=m}}}e.$jec=u}),define(De[368],Ce([1,0,48,22,4,3,120,12,24,2,29,13,246,64,107,86,365,26,20,72,345]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=e.$qec=e.$pec=e.$oec=e.$nec=e.$mec=e.$lec=e.$kec=void 0;function l(f){const d=f.trim().split(`
`),P=[];return d.forEach(O=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(O);M&&M.length>=3&&P.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),P.reduce((O,M)=>(O[M.socket]=M,O),{})}e.$kec=l;function t(...f){const d=[].concat(...f.map(o));return[...new Map(d.filter(P=>P.st==="0A").map(P=>{const N=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:n(N[0]),port:parseInt(N[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$lec=t;function n(f){let d="";if(f.length===8)for(let P=f.length-2;P>=0;P-=2)d+=parseInt(f.substr(P,2),16),P!==0&&(d+=".");else for(let P=0;P<f.length;P+=8){const N=f.substring(P,P+8);let O="";for(let M=8;M>=2;M-=2)O+=N.substring(M-2,M),(M===6||M===2)&&(O=parseInt(O,16).toString(16),d+=`${O}`,O="",P+M!==f.length-6&&(d+=":"))}return d}e.$mec=n;function o(f){const d=f.trim().split(`
`),P=d.shift().trim().split(/\s+/).filter(O=>O!=="rx_queue"&&O!=="tm->when");return d.map(O=>O.trim().split(/\s+/).reduce((M,j,U)=>(M[P[U]||U]=j,M),{}))}e.$nec=o;function i(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/server-main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function c(f){const d=f.trim().split(`
`),P=[];return d.forEach(N=>{const O=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);O&&O.length>=4&&P.push({pid:parseInt(O[1],10),ppid:parseInt(O[2]),cmd:O[3]})}),P}e.$oec=c;async function h(f,d,P){const N=P.reduce((M,j)=>(M[j.pid]=j,M),{}),O=[];return f.forEach(({socket:M,ip:j,port:U})=>{const F=d[M]?d[M].pid:void 0,V=F?N[F]?.cmd:void 0;F&&V&&!i(V)&&O.push({host:j,port:U,detail:V,pid:F})}),O}e.$pec=h;function y(f,d,P){const N=new Map,O=c(d);for(const M of f){const j=P.get(M.port);if(j){N.set(M.port,j);continue}const U=O.find(F=>F.cmd.includes(`${M.port}`));if(U){let F=U,V;do V=O.find(H=>H.ppid===F.pid),V&&(F=V);while(V);N.set(M.port,{host:M.ip,port:M.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else N.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return N}e.$qec=y;let C=class extends a.$Svb{constructor(d,P,N,O){super(d,P,N),this.D=P,this.F=O,this.y=void 0,this.z=new Map,this.C=!1,b.$l&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(d){if(d&&this.C)return;this.C=d;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new R.$Nl;let O=0;for(;this.C;){const M=new Date().getTime(),j=(await this.I()).filter(V=>(0,p.$8u)(V.host)||(0,p.$0u)(V.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(V=>V.port).join(", ")}`);const U=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${U} ms.`),O++>3&&N.update(U),(!P||JSON.stringify(P)!==JSON.stringify(j))&&(P=j,await this.a.$onFoundNewCandidates(P));const F=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(V=>setTimeout(()=>V(),F))}}G(d){return Math.max(d*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(d=>d.port).join(", ")}`)}async I(){let d="",P="";try{d=await A.Promises.readFile("/proc/net/tcp","utf8"),P=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(d,P),O=await new Promise(X=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Y,q,x)=>{X(q)})}),M=l(O),j=await A.Promises.readdir("/proc"),U=[];for(const X of j)try{const Y=Number(X),q=E.$ug(w.URI.file("/proc"),X);if((await A.Promises.stat(q.fsPath)).isDirectory()&&!isNaN(Y)){const me=await A.Promises.readlink(E.$ug(q,"cwd").fsPath),ue=await A.Promises.readFile(E.$ug(q,"cmdline").fsPath,"utf8");U.push({pid:Y,cwd:me,cmd:ue})}}catch{}const F=[],V=N.filter(X=>{const Y=M[X.socket];return Y||F.push(X),Y}),H=h(V,M,U);let fe;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const X=await new Promise(Y=>{(0,D.exec)("ps -F -A -l | grep root",(q,x,me)=>{Y(x)})});this.z=y(F,X,this.z),fe=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${fe.map(Y=>Y.port).join(", ")}`)}return H.then(X=>fe?X.concat(fe):X)}w(d){return async P=>{const N=new u.$M7b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,j,U,F){const V=await d.makeConnection();return $.connect(V,j,U,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new k.$Nk(0),connectionToken:d.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await N.waitForReady();const O=new g.$Md;return{localAddress:(0,m.$wJ)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:O.event,dispose:()=>{N.dispose(),O.fire(),O.dispose()}}}}};e.$rec=C,e.$rec=C=He([Be(0,s.$0L),Be(1,r.$nM),Be(2,I.$8i),Be(3,S.$Zk)],C);class $ extends v.$pkb{static connect(d,P,N,O){const M=new L.$Qc,j={onClose:M.add(new g.$Md),onData:M.add(new g.$Md),onEnd:M.add(new g.$Md)};M.add(d.onDidReceiveMessage(F=>j.onData.fire(T.$ae.wrap(F)))),M.add(d.onDidEnd(()=>j.onEnd.fire())),M.add(d.onDidClose(F=>j.onClose.fire({type:0,error:F,hadError:!!F})));const U=new $(d,O,j);return U.B(M),(0,v.$okb)(U,P,N,O,j)}constructor(d,P,N){super(P,N),this.n=d}write(d){this.n.send(d.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(De[369],Ce([1,0,104,340,352,351,364,367,368,95,45,96,94,44,72,91,339,338,13,353,56,261,103,107,138]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r,s,a,m,l,t,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$pr)(A.$mcc,b.$jec,0),(0,D.$pr)(s.$9i,r.$tec,1),(0,D.$pr)(s.$8i,new t.$Kh(l.$Jdc,[!1],!0)),(0,D.$pr)(n.$Zk,o.$R7b,1),(0,D.$pr)(p.$0bc,u.$sec,0),(0,D.$pr)(w.$Wcc,L.$Wdc,0),(0,D.$pr)(I.$7cc,R.$eec,0),(0,D.$pr)(v.$Rcc,g.$Odc,0),(0,D.$pr)(k.$_bc,T.$Ndc,0),(0,D.$pr)(S.$Rvb,E.$rec,0),(0,D.$pr)(m.$Ucc,a.$uec,0)}),define(De[380],Ce([1,0,60,381,54,8,81,117,244,111,350,22,29,101,11,130,268,285,355,369]),function($e,e,D,T,g,L,R,b,E,w,A,I,v,k,S,p,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const s=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,h=c._load;c._load=function(y){if(y==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return h.apply(this,arguments)}})();const a=process.exit.bind(process);function m(c){process.exit=function(h){if(c)a(h);else{const y=new Error("An extension called process.exit() and this was prevented.");console.warn(y.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let l=function(c){a()};function t(){const c=(0,r.$um)(process.env);if(c.type===3)return new Promise((h,y)=>{const C=$=>{const f=$[0],d=new R.$Ah;f.on("message",P=>d.fire(I.$ae.wrap(P.data))),f.on("close",()=>{l("renderer closed the MessagePort")}),f.start(),h({onMessage:d.event,send:P=>f.postMessage(P.buffer)})};process.parentPort.on("message",$=>C($.ports))});if(c.type===2)return new Promise((h,y)=>{let C=null;const $=setTimeout(()=>{l("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),f=108e5,d=3e5,P=new S.$6g(()=>l("renderer disconnected for too long (1)"),f),N=new S.$6g(()=>l("renderer disconnected for too long (2)"),d);process.on("message",(M,j)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const U=I.$ae.wrap(Buffer.from(M.initialDataChunk,"base64"));let F;if(M.skipWebSocketFrames)F=new b.$Ch(j,"extHost-socket");else{const V=I.$ae.wrap(Buffer.from(M.inflateBytes,"base64"));F=new b.$Dh(new b.$Ch(j,"extHost-socket"),M.permessageDeflate,V,!1)}C?(P.cancel(),N.cancel(),C.beginAcceptReconnection(F,U),C.endAcceptReconnection(),C.sendResume()):(clearTimeout($),C=new R.$Bh({socket:F,initialChunk:U}),C.sendResume(),C.onDidDispose(()=>l("renderer disconnected")),h(C),C.onSocketClose(()=>{P.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;P.isScheduled()&&N.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const h=c.pipeName;return new Promise((y,C)=>{const $=D.createConnection(h,()=>{$.removeListener("error",C);const f=new R.$Bh({socket:new b.$Ch($,"extHost-renderer")});f.sendResume(),y(f)});$.once("error",C),$.on("close",()=>{l("renderer closed the socket")})})}}async function n(){const c=await t();return new class{constructor(){this.a=new R.$Ah,this.onMessage=this.a.event,this.b=!1,c.onMessage(h=>{(0,w.$8l)(h,2)?(this.b=!0,l("received terminate message from renderer")):this.a.fire(h)})}send(h){this.b||c.send(h)}async drain(){if(c.drain)return c.drain()}}}function o(c){return new Promise(h=>{const y=c.onMessage(C=>{y.dispose();const $=JSON.parse(C.toString()),f=$.commit,d=E.default.commit;if(f&&d&&f!==d&&a(55),$.parentPid){let P=0;setInterval(function(){try{process.kill($.parentPid,0),P=0}catch(O){O&&O.code==="EPERM"?(P++,P>=3&&l(`parent process ${$.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):l(`parent process ${$.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start($.parentPid)}catch(O){(0,L.$Z)(O)}}c.send((0,w.$7l)(0)),h({protocol:c,initData:$})});c.send((0,w.$7l)(1))})}async function i(){const c=[];process.on("unhandledRejection",(P,N)=>{c.push(N),setTimeout(()=>{const O=c.indexOf(N);O>=0&&N.catch(M=>{c.splice(O,1),(0,L.$3)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),P&&(0,L.$Z)(P))})},1e3)}),process.on("rejectionHandled",P=>{const N=c.indexOf(P);N>=0&&c.splice(N,1)}),process.on("uncaughtException",function(P){(0,L.$Y)(P)||(0,L.$Z)(P)}),g.mark("code/extHost/willConnectToRenderer");const h=await n();g.mark("code/extHost/didConnectToRenderer");const y=await o(h);g.mark("code/extHost/didWaitForInitData");const{initData:C}=y;m(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=s.useHostProxy!==void 0?s.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,p.boolean)(s.skipWorkspaceStorageLock,!1);const $=new class{constructor(){this.pid=process.pid}exit(N){a(N)}fsExists(N){return v.Promises.exists(N)}fsRealpath(N){return(0,k.$Zp)(N)}};let f=null;C.remote.authority&&s.transformURIs&&(f=(0,u.$tr)(C.remote.authority));const d=new A.$Mdc(y.protocol,C,$,f);l=P=>d.terminate(P)}i().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7d4027b62bb1e620e5454580450fa646682bc102/core/vs/workbench/api/node/extensionHostProcess.js.map
