/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(be){for(var e=[],w=0,M=be.length;w<M;w++)e[w]=Ae[be[w]];return e};define(Ae[65],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function w(A){return(h,E,g)=>{let P=null,k=null;if(typeof g.value=="function"?(P="value",k=g.value):typeof g.get=="function"&&(P="get",k=g.get),!k)throw new Error("not supported");g[P]=A(k,E)}}function M(A,h,E){let g=null,P=null;if(typeof E.value=="function"?(g="value",P=E.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(g="get",P=E.get),!P)throw new Error("not supported");const k=`$memoize$${h}`;E[g]=function(...a){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,a)}),this[k]}}e.$fh=M;function C(A,h,E){return w((g,P)=>{const k=`$debounce$${P}`,a=`$debounce$result$${P}`;return function(...b){this[a]||(this[a]=E?E():void 0),clearTimeout(this[k]),h&&(this[a]=h(this[a],...b),b=[this[a]]),this[k]=setTimeout(()=>{g.apply(this,b),this[a]=E?E():void 0},A)}})}e.$gh=C;function F(A,h,E){return w((g,P)=>{const k=`$throttle$timer$${P}`,a=`$throttle$result$${P}`,b=`$throttle$lastRun$${P}`,m=`$throttle$pending$${P}`;return function(...f){if(this[a]||(this[a]=E?E():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),h&&(this[a]=h(this[a],...f)),this[m])return;const t=this[b]+A;t<=Date.now()?(this[b]=Date.now(),g.apply(this,[this[a]]),this[a]=E?E():void 0):(this[m]=!0,this[k]=setTimeout(()=>{this[m]=!1,this[b]=Date.now(),g.apply(this,[this[a]]),this[a]=E?E():void 0},t-Date.now()))}})}e.$hh=F}),define(Ae[88],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=e.$cM=void 0;class w{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$cM=w,e.$dM=new w("id#")}),define(Ae[115],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var M;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var C;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var F;(function(r){r.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function A(r,s=!1){let i=0;const o=r.length;let y="",$=0,S=16,I=0;function u(W){let N=0,O=0;for(;N<W;){const ee=r.charCodeAt(i);if(ee>=48&&ee<=57)O=O*16+ee-48;else if(ee>=65&&ee<=70)O=O*16+ee-65+10;else if(ee>=97&&ee<=102)O=O*16+ee-97+10;else break;i++,N++}return N<W&&(O=-1),O}function d(W){i=W,y="",$=0,S=16,I=0}function l(){const W=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&g(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&g(r.charCodeAt(i)))for(i++;i<r.length&&g(r.charCodeAt(i));)i++;else return I=3,r.substring(W,i);let N=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&g(r.charCodeAt(i))){for(i++;i<r.length&&g(r.charCodeAt(i));)i++;N=i}else I=3;return r.substring(W,N)}function R(){let W="",N=i;for(;;){if(i>=o){W+=r.substring(N,i),I=2;break}const O=r.charCodeAt(i);if(O===34){W+=r.substring(N,i),i++;break}if(O===92){if(W+=r.substring(N,i),i++,i>=o){I=2;break}switch(r.charCodeAt(i++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const Z=u(4);Z>=0?W+=String.fromCharCode(Z):I=4;break}default:I=5}N=i;continue}if(O>=0&&O<=31)if(E(O)){W+=r.substring(N,i),I=2;break}else I=6;i++}return W}function B(){if(y="",I=0,$=i,i>=o)return $=o,S=17;let W=r.charCodeAt(i);if(h(W)){do i++,y+=String.fromCharCode(W),W=r.charCodeAt(i);while(h(W));return S=15}if(E(W))return i++,y+=String.fromCharCode(W),W===13&&r.charCodeAt(i)===10&&(i++,y+=`
`),S=14;switch(W){case 123:return i++,S=1;case 125:return i++,S=2;case 91:return i++,S=3;case 93:return i++,S=4;case 58:return i++,S=6;case 44:return i++,S=5;case 34:return i++,y=R(),S=10;case 47:{const N=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<o&&!E(r.charCodeAt(i));)i++;return y=r.substring(N,i),S=12}if(r.charCodeAt(i+1)===42){i+=2;const O=o-1;let ee=!1;for(;i<O;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,ee=!0;break}i++}return ee||(i++,I=1),y=r.substring(N,i),S=13}return y+=String.fromCharCode(W),i++,S=16}case 45:if(y+=String.fromCharCode(W),i++,i===o||!g(r.charCodeAt(i)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return y+=l(),S=11;default:for(;i<o&&V(W);)i++,W=r.charCodeAt(i);if($!==i){switch(y=r.substring($,i),y){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return y+=String.fromCharCode(W),i++,S=16}}function V(W){if(h(W)||E(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let W;do W=B();while(W>=12&&W<=15);return W}return{setPosition:d,getPosition:()=>i,scan:s?U:B,getToken:()=>S,getTokenValue:()=>y,getTokenOffset:()=>$,getTokenLength:()=>i-$,getTokenError:()=>I}}e.$Mm=A;function h(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function E(r){return r===10||r===13||r===8232||r===8233}function g(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function k(r,s){const i=[],o=new Object;let y;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function I(u,d,l,R){$.value=u,$.offset=d,$.length=l,$.type=R,$.colonOffset=void 0,y=$}try{v(r,{onObjectBegin:(u,d)=>{if(s<=u)throw o;y=void 0,S=s>u,i.push("")},onObjectProperty:(u,d,l)=>{if(s<d||(I(u,d,l,"property"),i[i.length-1]=u,s<=d+l))throw o},onObjectEnd:(u,d)=>{if(s<=u)throw o;y=void 0,i.pop()},onArrayBegin:(u,d)=>{if(s<=u)throw o;y=void 0,i.push(0)},onArrayEnd:(u,d)=>{if(s<=u)throw o;y=void 0,i.pop()},onLiteralValue:(u,d,l)=>{if(s<d||(I(u,d,l,p(u)),s<=d+l))throw o},onSeparator:(u,d,l)=>{if(s<=d)throw o;if(u===":"&&y&&y.type==="property")y.colonOffset=d,S=!1,y=void 0;else if(u===","){const R=i[i.length-1];typeof R=="number"?i[i.length-1]=R+1:(S=!0,i[i.length-1]=""),y=void 0}}})}catch(u){if(u!==o)throw u}return{path:i,previousNode:y,isAtPropertyKey:S,matches:u=>{let d=0;for(let l=0;d<u.length&&l<i.length;l++)if(u[d]===i[l]||u[d]==="*")d++;else if(u[d]!=="**")return!1;return d===u.length}}}e.$Nm=k;function a(r,s=[],i=F.DEFAULT){let o=null,y=[];const $=[];function S(u){Array.isArray(y)?y.push(u):o!==null&&(y[o]=u)}return v(r,{onObjectBegin:()=>{const u={};S(u),$.push(y),y=u,o=null},onObjectProperty:u=>{o=u},onObjectEnd:()=>{y=$.pop()},onArrayBegin:()=>{const u=[];S(u),$.push(y),y=u,o=null},onArrayEnd:()=>{y=$.pop()},onLiteralValue:S,onError:(u,d,l)=>{s.push({error:u,offset:d,length:l})}},i),y[0]}e.$Om=a;function b(r,s=[],i=F.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function y(u){o.type==="property"&&(o.length=u-o.offset,o=o.parent)}function $(u){return o.children.push(u),u}v(r,{onObjectBegin:u=>{o=$({type:"object",offset:u,length:-1,parent:o,children:[]})},onObjectProperty:(u,d,l)=>{o=$({type:"property",offset:d,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:u,offset:d,length:l,parent:o})},onObjectEnd:(u,d)=>{o.length=u+d-o.offset,o=o.parent,y(u+d)},onArrayBegin:(u,d)=>{o=$({type:"array",offset:u,length:-1,parent:o,children:[]})},onArrayEnd:(u,d)=>{o.length=u+d-o.offset,o=o.parent,y(u+d)},onLiteralValue:(u,d,l)=>{$({type:p(u),offset:d,length:l,parent:o,value:u}),y(d+l)},onSeparator:(u,d,l)=>{o.type==="property"&&(u===":"?o.colonOffset=d:u===","&&y(d))},onError:(u,d,l)=>{s.push({error:u,offset:d,length:l})}},i);const I=o.children[0];return I&&delete I.parent,I}e.$Pm=b;function m(r,s){if(!r)return;let i=r;for(const o of s)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let y=!1;for(const $ of i.children)if(Array.isArray($.children)&&$.children[0].value===o){i=$.children[1],y=!0;break}if(!y)return}else{const y=o;if(i.type!=="array"||y<0||!Array.isArray(i.children)||y>=i.children.length)return;i=i.children[y]}return i}e.$Qm=m;function f(r){if(!r.parent||!r.parent.children)return[];const s=f(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;s.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&s.push(i)}return s}e.$Rm=f;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const s=Object.create(null);for(const i of r.children){const o=i.children[1];o&&(s[i.children[0].value]=t(o))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$Sm=t;function n(r,s,i=!1){return s>=r.offset&&s<r.offset+r.length||i&&s===r.offset+r.length}e.$Tm=n;function c(r,s,i=!1){if(n(r,s,i)){const o=r.children;if(Array.isArray(o))for(let y=0;y<o.length&&o[y].offset<=s;y++){const $=c(o[y],s,i);if($)return $}return r}}e.$Um=c;function v(r,s,i=F.DEFAULT){const o=A(r,!1);function y(Ee){return Ee?()=>Ee(o.getTokenOffset(),o.getTokenLength()):()=>!0}function $(Ee){return Ee?ce=>Ee(ce,o.getTokenOffset(),o.getTokenLength()):()=>!0}const S=y(s.onObjectBegin),I=$(s.onObjectProperty),u=y(s.onObjectEnd),d=y(s.onArrayBegin),l=y(s.onArrayEnd),R=$(s.onLiteralValue),B=$(s.onSeparator),V=y(s.onComment),U=$(s.onError),W=i&&i.disallowComments,N=i&&i.allowTrailingComma;function O(){for(;;){const Ee=o.scan();switch(o.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:W||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(Ee){case 12:case 13:W?ee(10):V();break;case 16:ee(1);break;case 15:case 14:break;default:return Ee}}}function ee(Ee,ce=[],$e=[]){if(U(Ee),ce.length+$e.length>0){let ie=o.getToken();for(;ie!==17;){if(ce.indexOf(ie)!==-1){O();break}else if($e.indexOf(ie)!==-1)break;ie=O()}}}function Z(Ee){const ce=o.getTokenValue();return Ee?R(ce):I(ce),O(),!0}function ye(){switch(o.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(o.getTokenValue()),typeof Ee!="number"&&(ee(2),Ee=0)}catch{ee(2)}R(Ee);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return O(),!0}function De(){return o.getToken()!==10?(ee(3,[],[2,5]),!1):(Z(!1),o.getToken()===6?(B(":"),O(),le()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function Pe(){S(),O();let Ee=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(Ee||ee(4,[],[]),B(","),O(),o.getToken()===2&&N)break}else Ee&&ee(6,[],[]);De()||ee(4,[],[2,5]),Ee=!0}return u(),o.getToken()!==2?ee(7,[2],[]):O(),!0}function X(){d(),O();let Ee=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(Ee||ee(4,[],[]),B(","),O(),o.getToken()===4&&N)break}else Ee&&ee(6,[],[]);le()||ee(4,[],[4,5]),Ee=!0}return l(),o.getToken()!==4?ee(8,[4],[]):O(),!0}function le(){switch(o.getToken()){case 3:return X();case 1:return Pe();case 10:return Z(!0);default:return ye()}}return O(),o.getToken()===17?i.allowEmptyContent?!0:(ee(4,[],[]),!1):le()?(o.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.$Vm=v;function D(r,s){const i=A(r),o=[];let y,$=0,S;do switch(S=i.getPosition(),y=i.scan(),y){case 12:case 13:case 17:$!==S&&o.push(r.substring($,S)),s!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,s)),$=i.getPosition();break}while(y!==17);return o.join("")}e.$Wm=D;function p(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$Xm=p}),function(be,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(ve,me){for(var ke=0;ke<me.length;ke++){var re=me[ke];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ve,re.key,re)}}function w(ve,me,ke){return me&&e(ve.prototype,me),ke&&e(ve,ke),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function M(ve,me){if(ve){if(typeof ve=="string")return C(ve,me);var ke=Object.prototype.toString.call(ve).slice(8,-1);if(ke==="Object"&&ve.constructor&&(ke=ve.constructor.name),ke==="Map"||ke==="Set")return Array.from(ve);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return C(ve,me)}}function C(ve,me){(me==null||me>ve.length)&&(me=ve.length);for(var ke=0,re=new Array(me);ke<me;ke++)re[ke]=ve[ke];return re}function F(ve,me){var ke=typeof Symbol<"u"&&ve[Symbol.iterator]||ve["@@iterator"];if(ke)return(ke=ke.call(ve)).next.bind(ke);if(Array.isArray(ve)||(ke=M(ve))||me&&ve&&typeof ve.length=="number"){ke&&(ve=ke);var re=0;return function(){return re>=ve.length?{done:!0}:{done:!1,value:ve[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function h(ve){be.defaults=ve}var E=/[&<>"']/,g=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(me){return a[me]};function m(ve,me){if(me){if(E.test(ve))return ve.replace(g,b)}else if(P.test(ve))return ve.replace(k,b);return ve}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ve){return ve.replace(f,function(me,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var n=/(^|[^\[])\^/g;function c(ve,me){ve=typeof ve=="string"?ve:ve.source,me=me||"";var ke={replace:function(he,se){return se=se.source||se,se=se.replace(n,"$1"),ve=ve.replace(he,se),ke},getRegex:function(){return new RegExp(ve,me)}};return ke}var v=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(ve,me,ke){if(ve){var re;try{re=decodeURIComponent(t(ke)).replace(v,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}me&&!D.test(ke)&&(ke=y(me,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var r={},s=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(ve,me){r[" "+ve]||(s.test(ve)?r[" "+ve]=ve+"/":r[" "+ve]=u(ve,"/",!0)),ve=r[" "+ve];var ke=ve.indexOf(":")===-1;return me.substring(0,2)==="//"?ke?me:ve.replace(i,"$1")+me:me.charAt(0)==="/"?ke?me:ve.replace(o,"$1")+me:ve+me}var $={exec:function(){}};function S(ve){for(var me=1,ke,re;me<arguments.length;me++){ke=arguments[me];for(re in ke)Object.prototype.hasOwnProperty.call(ke,re)&&(ve[re]=ke[re])}return ve}function I(ve,me){var ke=ve.replace(/\|/g,function(se,oe,de){for(var Ie=!1,T=oe;--T>=0&&de[T]==="\\";)Ie=!Ie;return Ie?"|":" |"}),re=ke.split(/ \|/),he=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>me)re.splice(me);else for(;re.length<me;)re.push("");for(;he<re.length;he++)re[he]=re[he].trim().replace(/\\\|/g,"|");return re}function u(ve,me,ke){var re=ve.length;if(re===0)return"";for(var he=0;he<re;){var se=ve.charAt(re-he-1);if(se===me&&!ke)he++;else if(se!==me&&ke)he++;else break}return ve.slice(0,re-he)}function d(ve,me){if(ve.indexOf(me[1])===-1)return-1;for(var ke=ve.length,re=0,he=0;he<ke;he++)if(ve[he]==="\\")he++;else if(ve[he]===me[0])re++;else if(ve[he]===me[1]&&(re--,re<0))return he;return-1}function l(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(ve,me){if(me<1)return"";for(var ke="";me>1;)me&1&&(ke+=ve),me>>=1,ve+=ve;return ke+ve}function B(ve,me,ke,re){var he=me.href,se=me.title?m(me.title):null,oe=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){re.state.inLink=!0;var de={type:"link",raw:ke,href:he,title:se,text:oe,tokens:re.inlineTokens(oe)};return re.state.inLink=!1,de}return{type:"image",raw:ke,href:he,title:se,text:m(oe)}}function V(ve,me){var ke=ve.match(/^(\s+)(?:```)/);if(ke===null)return me;var re=ke[1];return me.split(`
`).map(function(he){var se=he.match(/^\s+/);if(se===null)return he;var oe=se[0];return oe.length>=re.length?he.slice(re.length):he}).join(`
`)}var U=function(){function ve(ke){this.options=ke||be.defaults}var me=ve.prototype;return me.space=function(re){var he=this.rules.block.newline.exec(re);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},me.code=function(re){var he=this.rules.block.code.exec(re);if(he){var se=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?se:u(se,`
`)}}},me.fences=function(re){var he=this.rules.block.fences.exec(re);if(he){var se=he[0],oe=V(se,he[3]||"");return{type:"code",raw:se,lang:he[2]?he[2].trim():he[2],text:oe}}},me.heading=function(re){var he=this.rules.block.heading.exec(re);if(he){var se=he[2].trim();if(/#$/.test(se)){var oe=u(se,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(se=oe.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:se,tokens:this.lexer.inline(se)}}},me.hr=function(re){var he=this.rules.block.hr.exec(re);if(he)return{type:"hr",raw:he[0]}},me.blockquote=function(re){var he=this.rules.block.blockquote.exec(re);if(he){var se=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},me.list=function(re){var he=this.rules.block.list.exec(re);if(he){var se,oe,de,Ie,T,K,G,Q,H,_,ae,Fe,Ue=he[1].trim(),Qe=Ue.length>1,Je={type:"list",raw:"",ordered:Qe,start:Qe?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Qe?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Qe?Ue:"[*+-]");for(var xe=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Fe=!1,!(!(he=xe.exec(re))||this.rules.block.hr.test(re)));){if(se=he[0],re=re.substring(se.length),Q=he[2].split(`
`,1)[0],H=re.split(`
`,1)[0],this.options.pedantic?(Ie=2,ae=Q.trimLeft()):(Ie=he[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ae=Q.slice(Ie),Ie+=he[1].length),K=!1,!Q&&/^ *$/.test(H)&&(se+=H+`
`,re=re.substring(H.length+1),Fe=!0),!Fe)for(var Xe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");re&&(_=re.split(`
`,1)[0],Q=_,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Xe.test(Q)||_e.test(re)));){if(Q.search(/[^ ]/)>=Ie||!Q.trim())ae+=`
`+Q.slice(Ie);else if(!K)ae+=`
`+Q;else break;!K&&!Q.trim()&&(K=!0),se+=_+`
`,re=re.substring(_.length+1)}Je.loose||(G?Je.loose=!0:/\n *\n *$/.test(se)&&(G=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ae),oe&&(de=oe[0]!=="[ ] ",ae=ae.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:se,task:!!oe,checked:de,loose:!1,text:ae}),Je.raw+=se}Je.items[Je.items.length-1].raw=se.trimRight(),Je.items[Je.items.length-1].text=ae.trimRight(),Je.raw=Je.raw.trimRight();var ze=Je.items.length;for(T=0;T<ze;T++){this.lexer.state.top=!1,Je.items[T].tokens=this.lexer.blockTokens(Je.items[T].text,[]);var st=Je.items[T].tokens.filter(function(Y){return Y.type==="space"}),x=st.every(function(Y){for(var pe=Y.raw.split(""),Be=0,Oe=F(pe),Ye;!(Ye=Oe()).done;){var rt=Ye.value;if(rt===`
`&&(Be+=1),Be>1)return!0}return!1});!Je.loose&&st.length&&x&&(Je.loose=!0,Je.items[T].loose=!0)}return Je}},me.html=function(re){var he=this.rules.block.html.exec(re);if(he){var se={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(he[0]):m(he[0]);se.type="paragraph",se.text=oe,se.tokens=this.lexer.inline(oe)}return se}},me.def=function(re){var he=this.rules.block.def.exec(re);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var se=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:he[0],href:he[2],title:he[3]}}},me.table=function(re){var he=this.rules.block.table.exec(re);if(he){var se={type:"table",header:I(he[1]).map(function(G){return{text:G}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=he[0];var oe=se.align.length,de,Ie,T,K;for(de=0;de<oe;de++)/^ *-+: *$/.test(se.align[de])?se.align[de]="right":/^ *:-+: *$/.test(se.align[de])?se.align[de]="center":/^ *:-+ *$/.test(se.align[de])?se.align[de]="left":se.align[de]=null;for(oe=se.rows.length,de=0;de<oe;de++)se.rows[de]=I(se.rows[de],se.header.length).map(function(G){return{text:G}});for(oe=se.header.length,Ie=0;Ie<oe;Ie++)se.header[Ie].tokens=this.lexer.inline(se.header[Ie].text);for(oe=se.rows.length,Ie=0;Ie<oe;Ie++)for(K=se.rows[Ie],T=0;T<K.length;T++)K[T].tokens=this.lexer.inline(K[T].text);return se}}},me.lheading=function(re){var he=this.rules.block.lheading.exec(re);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},me.paragraph=function(re){var he=this.rules.block.paragraph.exec(re);if(he){var se=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:se,tokens:this.lexer.inline(se)}}},me.text=function(re){var he=this.rules.block.text.exec(re);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},me.escape=function(re){var he=this.rules.inline.escape.exec(re);if(he)return{type:"escape",raw:he[0],text:m(he[1])}},me.tag=function(re){var he=this.rules.inline.tag.exec(re);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):m(he[0]):he[0]}},me.link=function(re){var he=this.rules.inline.link.exec(re);if(he){var se=he[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var oe=u(se.slice(0,-1),"\\");if((se.length-oe.length)%2===0)return}else{var de=d(he[2],"()");if(de>-1){var Ie=he[0].indexOf("!")===0?5:4,T=Ie+he[1].length+de;he[2]=he[2].substring(0,de),he[0]=he[0].substring(0,T).trim(),he[3]=""}}var K=he[2],G="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);Q&&(K=Q[1],G=Q[3])}else G=he[3]?he[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(se)?K=K.slice(1):K=K.slice(1,-1)),B(he,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},me.reflink=function(re,he){var se;if((se=this.rules.inline.reflink.exec(re))||(se=this.rules.inline.nolink.exec(re))){var oe=(se[2]||se[1]).replace(/\s+/g," ");if(oe=he[oe.toLowerCase()],!oe||!oe.href){var de=se[0].charAt(0);return{type:"text",raw:de,text:de}}return B(se,oe,se[0],this.lexer)}},me.emStrong=function(re,he,se){se===void 0&&(se="");var oe=this.rules.inline.emStrong.lDelim.exec(re);if(oe&&!(oe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=oe[1]||oe[2]||"";if(!de||de&&(se===""||this.rules.inline.punctuation.exec(se))){var Ie=oe[0].length-1,T,K,G=Ie,Q=0,H=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,he=he.slice(-1*re.length+Ie);(oe=H.exec(he))!=null;)if(T=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!T){if(K=T.length,oe[3]||oe[4]){G+=K;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+K)%3)){Q+=K;continue}if(G-=K,!(G>0)){if(K=Math.min(K,K+G+Q),Math.min(Ie,K)%2){var _=re.slice(1,Ie+oe.index+K);return{type:"em",raw:re.slice(0,Ie+oe.index+K+1),text:_,tokens:this.lexer.inlineTokens(_)}}var ae=re.slice(2,Ie+oe.index+K-1);return{type:"strong",raw:re.slice(0,Ie+oe.index+K+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}}}}},me.codespan=function(re){var he=this.rules.inline.code.exec(re);if(he){var se=he[2].replace(/\n/g," "),oe=/[^ ]/.test(se),de=/^ /.test(se)&&/ $/.test(se);return oe&&de&&(se=se.substring(1,se.length-1)),se=m(se,!0),{type:"codespan",raw:he[0],text:se}}},me.br=function(re){var he=this.rules.inline.br.exec(re);if(he)return{type:"br",raw:he[0]}},me.del=function(re){var he=this.rules.inline.del.exec(re);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},me.autolink=function(re,he){var se=this.rules.inline.autolink.exec(re);if(se){var oe,de;return se[2]==="@"?(oe=m(this.options.mangle?he(se[1]):se[1]),de="mailto:"+oe):(oe=m(se[1]),de=oe),{type:"link",raw:se[0],text:oe,href:de,tokens:[{type:"text",raw:oe,text:oe}]}}},me.url=function(re,he){var se;if(se=this.rules.inline.url.exec(re)){var oe,de;if(se[2]==="@")oe=m(this.options.mangle?he(se[0]):se[0]),de="mailto:"+oe;else{var Ie;do Ie=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Ie!==se[0]);oe=m(se[0]),se[1]==="www."?de="http://"+oe:de=oe}return{type:"link",raw:se[0],text:oe,href:de,tokens:[{type:"text",raw:oe,text:oe}]}}},me.inlineText=function(re,he){var se=this.rules.inline.text.exec(re);if(se){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):m(se[0]):se[0]:oe=m(this.options.smartypants?he(se[0]):se[0]),{type:"text",raw:se[0],text:oe}}},ve}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:$,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=c(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=c(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=c(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=c(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=c(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=S({},W),W.gfm=S({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=c(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=c(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=S({},W.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,paragraph:c(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:$,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:$,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=c(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=c(W._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=c(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=c(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=c(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=c(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=c(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=c(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=c(N.reflink).replace("label",N._label).replace("ref",W._label).getRegex(),N.nolink=c(N.nolink).replace("ref",W._label).getRegex(),N.reflinkSearch=c(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=S({},N),N.pedantic=S({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=S({},N.normal,{escape:c(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=c(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=S({},N.gfm,{br:c(N.br).replace("{2,}","*").getRegex(),text:c(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(ve){var me="",ke,re,he=ve.length;for(ke=0;ke<he;ke++)re=ve.charCodeAt(ke),Math.random()>.5&&(re="x"+re.toString(16)),me+="&#"+re+";";return me}var Z=function(){function ve(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||be.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:W.normal,inline:N.normal};this.options.pedantic?(re.block=W.pedantic,re.inline=N.pedantic):this.options.gfm&&(re.block=W.gfm,this.options.breaks?re.inline=N.breaks:re.inline=N.gfm),this.tokenizer.rules=re}ve.lex=function(re,he){var se=new ve(he);return se.lex(re)},ve.lexInline=function(re,he){var se=new ve(he);return se.inlineTokens(re)};var me=ve.prototype;return me.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},me.blockTokens=function(re,he){var se=this;he===void 0&&(he=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(G,Q,H){return Q+"    ".repeat(H.length)});for(var oe,de,Ie,T;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(oe=G.call({lexer:se},re,he))?(re=re.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.space(re)){re=re.substring(oe.raw.length),oe.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(oe);continue}if(oe=this.tokenizer.code(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):he.push(oe);continue}if(oe=this.tokenizer.fences(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.heading(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.hr(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.blockquote(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.list(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.html(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.def(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.lheading(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,Q=re.slice(1),H=void 0;se.options.extensions.startBlock.forEach(function(_){H=_.call({lexer:this},Q),typeof H=="number"&&H>=0&&(G=Math.min(G,H))}),G<1/0&&G>=0&&(Ie=re.substring(0,G+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){de=he[he.length-1],T&&de.type==="paragraph"?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):he.push(oe),T=Ie.length!==re.length,re=re.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&de.type==="text"?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):he.push(oe);continue}if(re){var K="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,he},me.inline=function(re,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:re,tokens:he}),he},me.inlineTokens=function(re,he){var se=this;he===void 0&&(he=[]);var oe,de,Ie,T=re,K,G,Q;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(T))!=null;)H.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(T=T.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(T))!=null;)T=T.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(T))!=null;)T=T.slice(0,K.index)+"++"+T.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(G||(Q=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(oe=ae.call({lexer:se},re,he))?(re=re.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.tag(re)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&oe.type==="text"&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.link(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(oe.raw.length),de=he[he.length-1],de&&oe.type==="text"&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.emStrong(re,T,Q)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.codespan(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.br(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.del(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.autolink(re,ee)){re=re.substring(oe.raw.length),he.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(re,ee))){re=re.substring(oe.raw.length),he.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=1/0,Fe=re.slice(1),Ue=void 0;se.options.extensions.startInline.forEach(function(Qe){Ue=Qe.call({lexer:this},Fe),typeof Ue=="number"&&Ue>=0&&(ae=Math.min(ae,Ue))}),ae<1/0&&ae>=0&&(Ie=re.substring(0,ae+1))}(),oe=this.tokenizer.inlineText(Ie,O)){re=re.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Q=oe.raw.slice(-1)),G=!0,de=he[he.length-1],de&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):he.push(oe);continue}if(re){var _="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(_);break}else throw new Error(_)}}return he},w(ve,null,[{key:"rules",get:function(){return{block:W,inline:N}}}]),ve}(),ye=function(){function ve(ke){this.options=ke||be.defaults}var me=ve.prototype;return me.code=function(re,he,se){var oe=(he||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(re,oe);de!=null&&de!==re&&(se=!0,re=de)}return re=re.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+m(oe,!0)+'">'+(se?re:m(re,!0))+`</code></pre>
`:"<pre><code>"+(se?re:m(re,!0))+`</code></pre>
`},me.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},me.html=function(re){return re},me.heading=function(re,he,se,oe){if(this.options.headerIds){var de=this.options.headerPrefix+oe.slug(se);return"<h"+he+' id="'+de+'">'+re+"</h"+he+`>
`}return"<h"+he+">"+re+"</h"+he+`>
`},me.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},me.list=function(re,he,se){var oe=he?"ol":"ul",de=he&&se!==1?' start="'+se+'"':"";return"<"+oe+de+`>
`+re+"</"+oe+`>
`},me.listitem=function(re){return"<li>"+re+`</li>
`},me.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},me.paragraph=function(re){return"<p>"+re+`</p>
`},me.table=function(re,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+he+`</table>
`},me.tablerow=function(re){return`<tr>
`+re+`</tr>
`},me.tablecell=function(re,he){var se=he.header?"th":"td",oe=he.align?"<"+se+' align="'+he.align+'">':"<"+se+">";return oe+re+("</"+se+`>
`)},me.strong=function(re){return"<strong>"+re+"</strong>"},me.em=function(re){return"<em>"+re+"</em>"},me.codespan=function(re){return"<code>"+re+"</code>"},me.br=function(){return this.options.xhtml?"<br/>":"<br>"},me.del=function(re){return"<del>"+re+"</del>"},me.link=function(re,he,se){if(re=p(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<a href="'+m(re)+'"';return he&&(oe+=' title="'+he+'"'),oe+=">"+se+"</a>",oe},me.image=function(re,he,se){if(re=p(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<img src="'+re+'" alt="'+se+'"';return he&&(oe+=' title="'+he+'"'),oe+=this.options.xhtml?"/>":">",oe},me.text=function(re){return re},ve}(),De=function(){function ve(){}var me=ve.prototype;return me.strong=function(re){return re},me.em=function(re){return re},me.codespan=function(re){return re},me.del=function(re){return re},me.html=function(re){return re},me.text=function(re){return re},me.link=function(re,he,se){return""+se},me.image=function(re,he,se){return""+se},me.br=function(){return""},ve}(),Pe=function(){function ve(){this.seen={}}var me=ve.prototype;return me.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},me.getNextSafeSlug=function(re,he){var se=re,oe=0;if(this.seen.hasOwnProperty(se)){oe=this.seen[re];do oe++,se=re+"-"+oe;while(this.seen.hasOwnProperty(se))}return he||(this.seen[re]=oe,this.seen[se]=0),se},me.slug=function(re,he){he===void 0&&(he={});var se=this.serialize(re);return this.getNextSafeSlug(se,he.dryrun)},ve}(),X=function(){function ve(ke){this.options=ke||be.defaults,this.options.renderer=this.options.renderer||new ye,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new Pe}ve.parse=function(re,he){var se=new ve(he);return se.parse(re)},ve.parseInline=function(re,he){var se=new ve(he);return se.parseInline(re)};var me=ve.prototype;return me.parse=function(re,he){he===void 0&&(he=!0);var se="",oe,de,Ie,T,K,G,Q,H,_,ae,Fe,Ue,Qe,Je,xe,Xe,_e,it,tt,ze=re.length;for(oe=0;oe<ze;oe++){if(ae=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(tt=this.options.extensions.renderers[ae.type].call({parser:this},ae),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){se+=tt||"";continue}switch(ae.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,t(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(H="",Q="",T=ae.header.length,de=0;de<T;de++)Q+=this.renderer.tablecell(this.parseInline(ae.header[de].tokens),{header:!0,align:ae.align[de]});for(H+=this.renderer.tablerow(Q),_="",T=ae.rows.length,de=0;de<T;de++){for(G=ae.rows[de],Q="",K=G.length,Ie=0;Ie<K;Ie++)Q+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:ae.align[Ie]});_+=this.renderer.tablerow(Q)}se+=this.renderer.table(H,_);continue}case"blockquote":{_=this.parse(ae.tokens),se+=this.renderer.blockquote(_);continue}case"list":{for(Fe=ae.ordered,Ue=ae.start,Qe=ae.loose,T=ae.items.length,_="",de=0;de<T;de++)xe=ae.items[de],Xe=xe.checked,_e=xe.task,Je="",xe.task&&(it=this.renderer.checkbox(Xe),Qe?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=it+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=it+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:it}):Je+=it),Je+=this.parse(xe.tokens,Qe),_+=this.renderer.listitem(Je,_e,Xe);se+=this.renderer.list(_,Fe,Ue);continue}case"html":{se+=this.renderer.html(ae.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(_=ae.tokens?this.parseInline(ae.tokens):ae.text;oe+1<ze&&re[oe+1].type==="text";)ae=re[++oe],_+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);se+=he?this.renderer.paragraph(_):_;continue}default:{var st='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return se},me.parseInline=function(re,he){he=he||this.renderer;var se="",oe,de,Ie,T=re.length;for(oe=0;oe<T;oe++){if(de=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(Ie=this.options.extensions.renderers[de.type].call({parser:this},de),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type))){se+=Ie||"";continue}switch(de.type){case"escape":{se+=he.text(de.text);break}case"html":{se+=he.html(de.text);break}case"link":{se+=he.link(de.href,de.title,this.parseInline(de.tokens,he));break}case"image":{se+=he.image(de.href,de.title,de.text);break}case"strong":{se+=he.strong(this.parseInline(de.tokens,he));break}case"em":{se+=he.em(this.parseInline(de.tokens,he));break}case"codespan":{se+=he.codespan(de.text);break}case"br":{se+=he.br();break}case"del":{se+=he.del(this.parseInline(de.tokens,he));break}case"text":{se+=he.text(de.text);break}default:{var K='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return se},ve}();function le(ve,me,ke){if(typeof ve>"u"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof me=="function"&&(ke=me,me=null),me=S({},le.defaults,me||{}),l(me),ke){var re=me.highlight,he;try{he=Z.lex(ve,me)}catch(T){return ke(T)}var se=function(K){var G;if(!K)try{me.walkTokens&&le.walkTokens(he,me.walkTokens),G=X.parse(he,me)}catch(Q){K=Q}return me.highlight=re,K?ke(K):ke(null,G)};if(!re||re.length<3||(delete me.highlight,!he.length))return se();var oe=0;le.walkTokens(he,function(T){T.type==="code"&&(oe++,setTimeout(function(){re(T.text,T.lang,function(K,G){if(K)return se(K);G!=null&&G!==T.text&&(T.text=G,T.escaped=!0),oe--,oe===0&&se()})},0))}),oe===0&&se();return}function de(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+m(T.message+"",!0)+"</pre>";throw T}try{var Ie=Z.lex(ve,me);if(me.walkTokens){if(me.async)return Promise.all(le.walkTokens(Ie,me.walkTokens)).then(function(){return X.parse(Ie,me)}).catch(de);le.walkTokens(Ie,me.walkTokens)}return X.parse(Ie,me)}catch(T){de(T)}}le.options=le.setOptions=function(ve){return S(le.defaults,ve),h(le.defaults),le},le.getDefaults=A,le.defaults=be.defaults,le.use=function(){for(var ve=arguments.length,me=new Array(ve),ke=0;ke<ve;ke++)me[ke]=arguments[ke];var re=S.apply(void 0,[{}].concat(me)),he=le.defaults.extensions||{renderers:{},childTokens:{}},se;me.forEach(function(oe){if(oe.extensions&&(se=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var T=he.renderers?he.renderers[Ie.name]:null;T?he.renderers[Ie.name]=function(){for(var K=arguments.length,G=new Array(K),Q=0;Q<K;Q++)G[Q]=arguments[Q];var H=Ie.renderer.apply(this,G);return H===!1&&(H=T.apply(this,G)),H}:he.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ie.level]?he[Ie.level].unshift(Ie.tokenizer):he[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?he.startBlock?he.startBlock.push(Ie.start):he.startBlock=[Ie.start]:Ie.level==="inline"&&(he.startInline?he.startInline.push(Ie.start):he.startInline=[Ie.start]))}Ie.childTokens&&(he.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=le.defaults.renderer||new ye,T=function(Q){var H=Ie[Q];Ie[Q]=function(){for(var _=arguments.length,ae=new Array(_),Fe=0;Fe<_;Fe++)ae[Fe]=arguments[Fe];var Ue=oe.renderer[Q].apply(Ie,ae);return Ue===!1&&(Ue=H.apply(Ie,ae)),Ue}};for(var K in oe.renderer)T(K);re.renderer=Ie}(),oe.tokenizer&&function(){var Ie=le.defaults.tokenizer||new U,T=function(Q){var H=Ie[Q];Ie[Q]=function(){for(var _=arguments.length,ae=new Array(_),Fe=0;Fe<_;Fe++)ae[Fe]=arguments[Fe];var Ue=oe.tokenizer[Q].apply(Ie,ae);return Ue===!1&&(Ue=H.apply(Ie,ae)),Ue}};for(var K in oe.tokenizer)T(K);re.tokenizer=Ie}(),oe.walkTokens){var de=le.defaults.walkTokens;re.walkTokens=function(Ie){var T=[];return T.push(oe.walkTokens.call(this,Ie)),de&&(T=T.concat(de.call(this,Ie))),T}}se&&(re.extensions=he),le.setOptions(re)})},le.walkTokens=function(ve,me){for(var ke=[],re=function(){var de=se.value;switch(ke=ke.concat(me.call(le,de)),de.type){case"table":{for(var Ie=F(de.header),T;!(T=Ie()).done;){var K=T.value;ke=ke.concat(le.walkTokens(K.tokens,me))}for(var G=F(de.rows),Q;!(Q=G()).done;)for(var H=Q.value,_=F(H),ae;!(ae=_()).done;){var Fe=ae.value;ke=ke.concat(le.walkTokens(Fe.tokens,me))}break}case"list":{ke=ke.concat(le.walkTokens(de.items,me));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[de.type]?le.defaults.extensions.childTokens[de.type].forEach(function(Ue){ke=ke.concat(le.walkTokens(de[Ue],me))}):de.tokens&&(ke=ke.concat(le.walkTokens(de.tokens,me)))}},he=F(ve),se;!(se=he()).done;)re();return ke},le.parseInline=function(ve,me){if(typeof ve>"u"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");me=S({},le.defaults,me||{}),l(me);try{var ke=Z.lexInline(ve,me);return me.walkTokens&&le.walkTokens(ke,me.walkTokens),X.parseInline(ke,me)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+m(re.message+"",!0)+"</pre>";throw re}},le.Parser=X,le.parser=X.parse,le.Renderer=ye,le.TextRenderer=De,le.Lexer=Z,le.lexer=Z.lex,le.Tokenizer=U,le.Slugger=Pe,le.parse=le;var Ee=le.options,ce=le.setOptions,$e=le.use,ie=le.walkTokens,z=le.parseInline,q=le,ue=X.parse,we=Z.lex;be.Lexer=Z,be.Parser=X,be.Renderer=ye,be.Slugger=Pe,be.TextRenderer=De,be.Tokenizer=U,be.getDefaults=A,be.lexer=we,be.marked=le,be.options=Ee,be.parse=q,be.parseInline=z,be.parser=ue,be.setOptions=ce,be.use=$e,be.walkTokens=ie,Object.defineProperty(be,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.rot=e.$Kl=void 0;function w(h,E,g){return Math.min(Math.max(h,E),g)}e.$Kl=w;function M(h,E){return(E+h%E)%E}e.rot=M;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Ml=C;class F{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nl=F;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const g=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ol=A}),function(){function be(C){const F=[];typeof C=="number"&&F.push("code/timeOrigin",C);function A(E){F.push(E,Date.now())}function h(){const E=[];for(let g=0;g<F.length;g+=2)E.push({name:F[g],startTime:F[g+1]});return E}return{mark:A,getMarks:h}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))F.push({name:A.name,startTime:Math.round(C+A.startTime)});return F}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=w(M))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var M in w)(typeof exports=="object"?exports:be)[M]=w[M]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function w(M){if(e[M])return e[M].exports;var C=e[M]={i:M,l:!1,exports:{}};return be[M].call(C.exports,C,C.exports,w),C.l=!0,C.exports}return w.m=be,w.c=e,w.d=function(M,C,F){w.o(M,C)||Object.defineProperty(M,C,{enumerable:!0,get:F})},w.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},w.t=function(M,C){if(1&C&&(M=w(M)),8&C||4&C&&typeof M=="object"&&M&&M.__esModule)return M;var F=Object.create(null);if(w.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:M}),2&C&&typeof M!="string")for(var A in M)w.d(F,A,function(h){return M[h]}.bind(null,A));return F},w.n=function(M){var C=M&&M.__esModule?function(){return M.default}:function(){return M};return w.d(C,"a",C),C},w.o=function(M,C){return Object.prototype.hasOwnProperty.call(M,C)},w.p="",w(w.s=0)}([function(be,e,w){(function(M){var C;e=be.exports=$e,C=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,h=e.re=[],E=e.src=[],g=0,P=g++;E[P]="0|[1-9]\\d*";var k=g++;E[k]="[0-9]+";var a=g++;E[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=g++;E[b]="("+E[P]+")\\.("+E[P]+")\\.("+E[P]+")";var m=g++;E[m]="("+E[k]+")\\.("+E[k]+")\\.("+E[k]+")";var f=g++;E[f]="(?:"+E[P]+"|"+E[a]+")";var t=g++;E[t]="(?:"+E[k]+"|"+E[a]+")";var n=g++;E[n]="(?:-("+E[f]+"(?:\\."+E[f]+")*))";var c=g++;E[c]="(?:-?("+E[t]+"(?:\\."+E[t]+")*))";var v=g++;E[v]="[0-9A-Za-z-]+";var D=g++;E[D]="(?:\\+("+E[v]+"(?:\\."+E[v]+")*))";var p=g++,r="v?"+E[b]+E[n]+"?"+E[D]+"?";E[p]="^"+r+"$";var s="[v=\\s]*"+E[m]+E[c]+"?"+E[D]+"?",i=g++;E[i]="^"+s+"$";var o=g++;E[o]="((?:<|>)?=?)";var y=g++;E[y]=E[k]+"|x|X|\\*";var $=g++;E[$]=E[P]+"|x|X|\\*";var S=g++;E[S]="[v=\\s]*("+E[$]+")(?:\\.("+E[$]+")(?:\\.("+E[$]+")(?:"+E[n]+")?"+E[D]+"?)?)?";var I=g++;E[I]="[v=\\s]*("+E[y]+")(?:\\.("+E[y]+")(?:\\.("+E[y]+")(?:"+E[c]+")?"+E[D]+"?)?)?";var u=g++;E[u]="^"+E[o]+"\\s*"+E[S]+"$";var d=g++;E[d]="^"+E[o]+"\\s*"+E[I]+"$";var l=g++;E[l]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=g++;E[R]="(?:~>?)";var B=g++;E[B]="(\\s*)"+E[R]+"\\s+",h[B]=new RegExp(E[B],"g");var V=g++;E[V]="^"+E[R]+E[S]+"$";var U=g++;E[U]="^"+E[R]+E[I]+"$";var W=g++;E[W]="(?:\\^)";var N=g++;E[N]="(\\s*)"+E[W]+"\\s+",h[N]=new RegExp(E[N],"g");var O=g++;E[O]="^"+E[W]+E[S]+"$";var ee=g++;E[ee]="^"+E[W]+E[I]+"$";var Z=g++;E[Z]="^"+E[o]+"\\s*("+s+")$|^$";var ye=g++;E[ye]="^"+E[o]+"\\s*("+r+")$|^$";var De=g++;E[De]="(\\s*)"+E[o]+"\\s*("+s+"|"+E[S]+")",h[De]=new RegExp(E[De],"g");var Pe=g++;E[Pe]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var X=g++;E[X]="^\\s*("+E[I]+")\\s+-\\s+("+E[I]+")\\s*$";var le=g++;E[le]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)C(Ee,E[Ee]),h[Ee]||(h[Ee]=new RegExp(E[Ee]));function ce(H,_){if(H instanceof $e)return H;if(typeof H!="string"||H.length>F||!(_?h[i]:h[p]).test(H))return null;try{return new $e(H,_)}catch{return null}}function $e(H,_){if(H instanceof $e){if(H.loose===_)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof $e))return new $e(H,_);C("SemVer",H,_),this.loose=_;var ae=H.trim().match(_?h[i]:h[p]);if(!ae)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(Fe){if(/^[0-9]+$/.test(Fe)){var Ue=+Fe;if(Ue>=0&&Ue<A)return Ue}return Fe}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=ce,e.valid=function(H,_){var ae=ce(H,_);return ae?ae.version:null},e.clean=function(H,_){var ae=ce(H.trim().replace(/^[=v]+/,""),_);return ae?ae.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(H){return C("SemVer.compare",this.version,this.loose,H),H instanceof $e||(H=new $e(H,this.loose)),this.compareMain(H)||this.comparePre(H)},$e.prototype.compareMain=function(H){return H instanceof $e||(H=new $e(H,this.loose)),z(this.major,H.major)||z(this.minor,H.minor)||z(this.patch,H.patch)},$e.prototype.comparePre=function(H){if(H instanceof $e||(H=new $e(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var _=0;do{var ae=this.prerelease[_],Fe=H.prerelease[_];if(C("prerelease compare",_,ae,Fe),ae===void 0&&Fe===void 0)return 0;if(Fe===void 0)return 1;if(ae===void 0)return-1;if(ae!==Fe)return z(ae,Fe)}while(++_)},$e.prototype.inc=function(H,_){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,_,ae,Fe){typeof ae=="string"&&(Fe=ae,ae=void 0);try{return new $e(H,ae).inc(_,Fe).version}catch{return null}},e.diff=function(H,_){if(ve(H,_))return null;var ae=ce(H),Fe=ce(_);if(ae.prerelease.length||Fe.prerelease.length){for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Fe[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Fe[Ue])return Ue},e.compareIdentifiers=z;var ie=/^[0-9]+$/;function z(H,_){var ae=ie.test(H),Fe=ie.test(_);return ae&&Fe&&(H=+H,_=+_),ae&&!Fe?-1:Fe&&!ae?1:H<_?-1:H>_?1:0}function q(H,_,ae){return new $e(H,ae).compare(new $e(_,ae))}function ue(H,_,ae){return q(H,_,ae)>0}function we(H,_,ae){return q(H,_,ae)<0}function ve(H,_,ae){return q(H,_,ae)===0}function me(H,_,ae){return q(H,_,ae)!==0}function ke(H,_,ae){return q(H,_,ae)>=0}function re(H,_,ae){return q(H,_,ae)<=0}function he(H,_,ae,Fe){var Ue;switch(_){case"===":typeof H=="object"&&(H=H.version),typeof ae=="object"&&(ae=ae.version),Ue=H===ae;break;case"!==":typeof H=="object"&&(H=H.version),typeof ae=="object"&&(ae=ae.version),Ue=H!==ae;break;case"":case"=":case"==":Ue=ve(H,ae,Fe);break;case"!=":Ue=me(H,ae,Fe);break;case">":Ue=ue(H,ae,Fe);break;case">=":Ue=ke(H,ae,Fe);break;case"<":Ue=we(H,ae,Fe);break;case"<=":Ue=re(H,ae,Fe);break;default:throw new TypeError("Invalid operator: "+_)}return Ue}function se(H,_){if(H instanceof se){if(H.loose===_)return H;H=H.value}if(!(this instanceof se))return new se(H,_);C("comparator",H,_),this.loose=_,this.parse(H),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(H,_){return z(_,H)},e.major=function(H,_){return new $e(H,_).major},e.minor=function(H,_){return new $e(H,_).minor},e.patch=function(H,_){return new $e(H,_).patch},e.compare=q,e.compareLoose=function(H,_){return q(H,_,!0)},e.rcompare=function(H,_,ae){return q(_,H,ae)},e.sort=function(H,_){return H.sort(function(ae,Fe){return e.compare(ae,Fe,_)})},e.rsort=function(H,_){return H.sort(function(ae,Fe){return e.rcompare(ae,Fe,_)})},e.gt=ue,e.lt=we,e.eq=ve,e.neq=me,e.gte=ke,e.lte=re,e.cmp=he,e.Comparator=se;var oe={};function de(H,_){if(H instanceof de)return H.loose===_?H:new de(H.raw,_);if(H instanceof se)return new de(H.value,_);if(!(this instanceof de))return new de(H,_);if(this.loose=_,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function Ie(H){return!H||H.toLowerCase()==="x"||H==="*"}function T(H,_,ae,Fe,Ue,Qe,Je,xe,Xe,_e,it,tt,ze){return((_=Ie(ae)?"":Ie(Fe)?">="+ae+".0.0":Ie(Ue)?">="+ae+"."+Fe+".0":">="+_)+" "+(xe=Ie(Xe)?"":Ie(_e)?"<"+(+Xe+1)+".0.0":Ie(it)?"<"+Xe+"."+(+_e+1)+".0":tt?"<="+Xe+"."+_e+"."+it+"-"+tt:"<="+xe)).trim()}function K(H,_){for(var ae=0;ae<H.length;ae++)if(!H[ae].test(_))return!1;if(_.prerelease.length){for(ae=0;ae<H.length;ae++)if(C(H[ae].semver),H[ae].semver!==oe&&H[ae].semver.prerelease.length>0){var Fe=H[ae].semver;if(Fe.major===_.major&&Fe.minor===_.minor&&Fe.patch===_.patch)return!0}return!1}return!0}function G(H,_,ae){try{_=new de(_,ae)}catch{return!1}return _.test(H)}function Q(H,_,ae,Fe){var Ue,Qe,Je,xe,Xe;switch(H=new $e(H,Fe),_=new de(_,Fe),ae){case">":Ue=ue,Qe=re,Je=we,xe=">",Xe=">=";break;case"<":Ue=we,Qe=ke,Je=ue,xe="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(H,_,Fe))return!1;for(var _e=0;_e<_.set.length;++_e){var it=_.set[_e],tt=null,ze=null;if(it.forEach(function(st){st.semver===oe&&(st=new se(">=0.0.0")),tt=tt||st,ze=ze||st,Ue(st.semver,tt.semver,Fe)?tt=st:Je(st.semver,ze.semver,Fe)&&(ze=st)}),tt.operator===xe||tt.operator===Xe||(!ze.operator||ze.operator===xe)&&Qe(H,ze.semver)||ze.operator===Xe&&Je(H,ze.semver))return!1}return!0}se.prototype.parse=function(H){var _=this.loose?h[Z]:h[ye],ae=H.match(_);if(!ae)throw new TypeError("Invalid comparator: "+H);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new $e(ae[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(H){return C("Comparator.test",H,this.loose),this.semver===oe||(typeof H=="string"&&(H=new $e(H,this.loose)),he(H,this.operator,this.semver,this.loose))},se.prototype.intersects=function(H,_){if(!(H instanceof se))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new de(H.value,_),G(this.value,ae,_);if(H.operator==="")return ae=new de(this.value,_),G(H.semver,ae,_);var Fe=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Qe=this.semver.version===H.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),xe=he(this.semver,"<",H.semver,_)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),Xe=he(this.semver,">",H.semver,_)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return Fe||Ue||Qe&&Je||xe||Xe},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(H){var _=this.loose;H=H.trim(),C("range",H,_);var ae=_?h[X]:h[Pe];H=H.replace(ae,T),C("hyphen replace",H),H=H.replace(h[De],"$1$2$3"),C("comparator trim",H,h[De]),H=(H=(H=H.replace(h[B],"$1~")).replace(h[N],"$1^")).split(/\s+/).join(" ");var Fe=_?h[Z]:h[ye],Ue=H.split(" ").map(function(Qe){return function(Je,xe){return C("comp",Je),Je=function(Xe,_e){return Xe.trim().split(/\s+/).map(function(it){return function(tt,ze){C("caret",tt,ze);var st=ze?h[ee]:h[O];return tt.replace(st,function(x,Y,pe,Be,Oe){var Ye;return C("caret",tt,x,Y,pe,Be,Oe),Ie(Y)?Ye="":Ie(pe)?Ye=">="+Y+".0.0 <"+(+Y+1)+".0.0":Ie(Be)?Ye=Y==="0"?">="+Y+"."+pe+".0 <"+Y+"."+(+pe+1)+".0":">="+Y+"."+pe+".0 <"+(+Y+1)+".0.0":Oe?(C("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ye=Y==="0"?pe==="0"?">="+Y+"."+pe+"."+Be+Oe+" <"+Y+"."+pe+"."+(+Be+1):">="+Y+"."+pe+"."+Be+Oe+" <"+Y+"."+(+pe+1)+".0":">="+Y+"."+pe+"."+Be+Oe+" <"+(+Y+1)+".0.0"):(C("no pr"),Ye=Y==="0"?pe==="0"?">="+Y+"."+pe+"."+Be+" <"+Y+"."+pe+"."+(+Be+1):">="+Y+"."+pe+"."+Be+" <"+Y+"."+(+pe+1)+".0":">="+Y+"."+pe+"."+Be+" <"+(+Y+1)+".0.0"),C("caret return",Ye),Ye})}(it,_e)}).join(" ")}(Je,xe),C("caret",Je),Je=function(Xe,_e){return Xe.trim().split(/\s+/).map(function(it){return function(tt,ze){var st=ze?h[U]:h[V];return tt.replace(st,function(x,Y,pe,Be,Oe){var Ye;return C("tilde",tt,x,Y,pe,Be,Oe),Ie(Y)?Ye="":Ie(pe)?Ye=">="+Y+".0.0 <"+(+Y+1)+".0.0":Ie(Be)?Ye=">="+Y+"."+pe+".0 <"+Y+"."+(+pe+1)+".0":Oe?(C("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ye=">="+Y+"."+pe+"."+Be+Oe+" <"+Y+"."+(+pe+1)+".0"):Ye=">="+Y+"."+pe+"."+Be+" <"+Y+"."+(+pe+1)+".0",C("tilde return",Ye),Ye})}(it,_e)}).join(" ")}(Je,xe),C("tildes",Je),Je=function(Xe,_e){return C("replaceXRanges",Xe,_e),Xe.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var st=ze?h[d]:h[u];return tt.replace(st,function(x,Y,pe,Be,Oe,Ye){C("xRange",tt,x,Y,pe,Be,Oe,Ye);var rt=Ie(pe),gt=rt||Ie(Be),yt=gt||Ie(Oe);return Y==="="&&yt&&(Y=""),rt?x=Y===">"||Y==="<"?"<0.0.0":"*":Y&&yt?(gt&&(Be=0),yt&&(Oe=0),Y===">"?(Y=">=",gt?(pe=+pe+1,Be=0,Oe=0):yt&&(Be=+Be+1,Oe=0)):Y==="<="&&(Y="<",gt?pe=+pe+1:Be=+Be+1),x=Y+pe+"."+Be+"."+Oe):gt?x=">="+pe+".0.0 <"+(+pe+1)+".0.0":yt&&(x=">="+pe+"."+Be+".0 <"+pe+"."+(+Be+1)+".0"),C("xRange return",x),x})}(it,_e)}).join(" ")}(Je,xe),C("xrange",Je),Je=function(Xe,_e){return C("replaceStars",Xe,_e),Xe.trim().replace(h[le],"")}(Je,xe),C("stars",Je),Je}(Qe,_)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Qe){return!!Qe.match(Fe)})),Ue=Ue.map(function(Qe){return new se(Qe,_)})},de.prototype.intersects=function(H,_){if(!(H instanceof de))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(Fe){return H.set.some(function(Ue){return Ue.every(function(Qe){return Fe.intersects(Qe,_)})})})})},e.toComparators=function(H,_){return new de(H,_).set.map(function(ae){return ae.map(function(Fe){return Fe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new $e(H,this.loose));for(var _=0;_<this.set.length;_++)if(K(this.set[_],H))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(H,_,ae){var Fe=null,Ue=null;try{var Qe=new de(_,ae)}catch{return null}return H.forEach(function(Je){Qe.test(Je)&&(Fe&&Ue.compare(Je)!==-1||(Ue=new $e(Fe=Je,ae)))}),Fe},e.minSatisfying=function(H,_,ae){var Fe=null,Ue=null;try{var Qe=new de(_,ae)}catch{return null}return H.forEach(function(Je){Qe.test(Je)&&(Fe&&Ue.compare(Je)!==1||(Ue=new $e(Fe=Je,ae)))}),Fe},e.validRange=function(H,_){try{return new de(H,_).range||"*"}catch{return null}},e.ltr=function(H,_,ae){return Q(H,_,"<",ae)},e.gtr=function(H,_,ae){return Q(H,_,">",ae)},e.outside=Q,e.prerelease=function(H,_){var ae=ce(H,_);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(H,_,ae){return H=new de(H,ae),_=new de(_,ae),H.intersects(_)},e.coerce=function(H){if(H instanceof $e)return H;if(typeof H!="string")return null;var _=H.match(h[l]);return _==null?null:ce((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,w(1))},function(be,e){var w,M,C=be.exports={};function F(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function h(t){if(w===setTimeout)return setTimeout(t,0);if((w===F||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:F}catch{w=F}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var E,g=[],P=!1,k=-1;function a(){P&&E&&(P=!1,E.length?g=E.concat(g):k=-1,g.length&&b())}function b(){if(!P){var t=h(a);P=!0;for(var n=g.length;n;){for(E=g,g=[];++k<n;)E&&E[k].run();k=-1,n=g.length}E=null,P=!1,function(c){if(M===clearTimeout)return clearTimeout(c);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(c);try{M(c)}catch{try{return M.call(null,c)}catch{return M.call(this,c)}}}(t)}}function m(t,n){this.fun=t,this.array=n}function f(){}C.nextTick=function(t){var n=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)n[c-1]=arguments[c];g.push(new m(t,n)),g.length!==1||P||h(b)},m.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=f,C.addListener=f,C.once=f,C.off=f,C.removeListener=f,C.removeAllListeners=f,C.emit=f,C.prependListener=f,C.prependOnceListener=f,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[118],Re([1,0,9,6]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function C(D){const p=D;return p?typeof p.read=="function":!1}e.$Xd=C;function F(D){const p=D;return p?[p.on,p.pause,p.resume,p.destroy].every(r=>typeof r=="function"):!1}e.$Yd=F;function A(D){const p=D;return p?F(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.$Zd=A;function h(D,p){return new E(D,p)}e.$1d=h;class E{constructor(p,r){this.e=p,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(r=>r(p))}h(p){this.c.error.length===0?(0,w.$Z)(p):this.c.error.slice(0).forEach(r=>r(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,r){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(p,r){if(this.a.destroyed)return;let s;switch(p){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const i=s.indexOf(r);i>=0&&s.splice(i,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(D,p){const r=[];let s;for(;(s=D.read())!==null;)r.push(s);return p(r)}e.$2d=g;function P(D,p,r){const s=[];let i;for(;(i=D.read())!==null&&s.length<r;)s.push(i);return i===null&&s.length>0?p(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const o=i;return i=void 0,o}return D.read()}}}e.$3d=P;function k(D,p){return new Promise((r,s)=>{const i=[];a(D,{onData:o=>{p&&i.push(o)},onError:o=>{p?s(o):r(void 0)},onEnd:()=>{r(p?p(i):void 0)}})})}e.$4d=k;function a(D,p,r){D.on("error",s=>{r?.isCancellationRequested||p.onError(s)}),D.on("end",()=>{r?.isCancellationRequested||p.onEnd()}),D.on("data",s=>{r?.isCancellationRequested||p.onData(s)})}e.$5d=a;function b(D,p){return new Promise((r,s)=>{const i=new M.$Qc,o=[],y=I=>{if(o.push(I),o.length>p)return i.dispose(),D.pause(),r({stream:D,buffer:o,ended:!1})},$=I=>(i.dispose(),s(I)),S=()=>(i.dispose(),r({stream:D,buffer:o,ended:!0}));i.add((0,M.$Pc)(()=>D.removeListener("error",$))),D.on("error",$),i.add((0,M.$Pc)(()=>D.removeListener("end",S))),D.on("end",S),i.add((0,M.$Pc)(()=>D.removeListener("data",y))),D.on("data",y)})}e.$6d=b;function m(D,p){const r=h(p);return r.end(D),r}e.$7d=m;function f(){const D=h(()=>{throw new Error("not supported")});return D.end(),D}e.$8d=f;function t(D){let p=!1;return{read:()=>p?null:(p=!0,D)}}e.$9d=t;function n(D,p,r){const s=h(r);return a(D,{onData:i=>s.write(p.data(i)),onError:i=>s.error(p.error?p.error(i):i),onEnd:()=>s.end()}),s}e.$0d=n;function c(D,p,r){let s=!1;return{read:()=>{const i=p.read();return s?i:(s=!0,i!==null?r([D,i]):D)}}}e.$$d=c;function v(D,p,r){let s=!1;const i=h(r);return a(p,{onData:o=>s?i.write(o):(s=!0,i.write(r([D,o]))),onError:o=>i.error(o),onEnd:()=>{s||(s=!0,i.write(D)),i.end()}}),i}e.$_d=v}),define(Ae[25],Re([1,0,48,118]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const C=typeof Buffer<"u",F=new w.$U(()=>new Uint8Array(256));let A,h;class E{static alloc(l){return C?new E(Buffer.allocUnsafe(l)):new E(new Uint8Array(l))}static wrap(l){return C&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new E(l)}static fromString(l,R){return!(R?.dontUseNodeBuffer||!1)&&C?new E(Buffer.from(l)):(A||(A=new TextEncoder),new E(A.encode(l)))}static fromByteArray(l){const R=E.alloc(l.length);for(let B=0,V=l.length;B<V;B++)R.buffer[B]=l[B];return R}static concat(l,R){if(typeof R>"u"){R=0;for(let U=0,W=l.length;U<W;U++)R+=l[U].byteLength}const B=E.alloc(R);let V=0;for(let U=0,W=l.length;U<W;U++){const N=l[U];B.set(N,V),V+=N.byteLength}return B}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=E.alloc(this.byteLength);return l.set(this),l}toString(){return C?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(l,R){return new E(this.buffer.subarray(l,R))}set(l,R){if(l instanceof E)this.buffer.set(l.buffer,R);else if(l instanceof Uint8Array)this.buffer.set(l,R);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),R);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return a(this.buffer,l)}writeUInt32BE(l,R){b(this.buffer,l,R)}readUInt32LE(l){return m(this.buffer,l)}writeUInt32LE(l,R){f(this.buffer,l,R)}readUInt8(l){return t(this.buffer,l)}writeUInt8(l,R){n(this.buffer,l,R)}indexOf(l,R=0){return g(this.buffer,l instanceof E?l.buffer:l,R)}}e.$ae=E;function g(d,l,R=0){const B=l.byteLength,V=d.byteLength;if(B===0)return 0;if(B===1)return d.indexOf(l[0]);if(B>V-R)return-1;const U=F.value;U.fill(l.length);for(let ee=0;ee<l.length;ee++)U[l[ee]]=l.length-ee-1;let W=R+l.length-1,N=W,O=-1;for(;W<V;)if(d[W]===l[N]){if(N===0){O=W;break}W--,N--}else W+=Math.max(l.length-N,U[d[W]]),N=l.length-1;return O}e.$be=g;function P(d,l){return d[l+0]<<0>>>0|d[l+1]<<8>>>0}e.$ce=P;function k(d,l,R){d[R+0]=l&255,l=l>>>8,d[R+1]=l&255}e.$de=k;function a(d,l){return d[l]*2**24+d[l+1]*2**16+d[l+2]*2**8+d[l+3]}e.$ee=a;function b(d,l,R){d[R+3]=l,l=l>>>8,d[R+2]=l,l=l>>>8,d[R+1]=l,l=l>>>8,d[R]=l}e.$fe=b;function m(d,l){return d[l+0]<<0>>>0|d[l+1]<<8>>>0|d[l+2]<<16>>>0|d[l+3]<<24>>>0}e.$ge=m;function f(d,l,R){d[R+0]=l&255,l=l>>>8,d[R+1]=l&255,l=l>>>8,d[R+2]=l&255,l=l>>>8,d[R+3]=l&255}e.$he=f;function t(d,l){return d[l]}e.$ie=t;function n(d,l,R){d[R]=l}e.$je=n;function c(d){return M.$2d(d,l=>E.concat(l))}e.$ke=c;function v(d){return M.$9d(d)}e.$le=v;function D(d){return M.$4d(d,l=>E.concat(l))}e.$me=D;async function p(d){return d.ended?E.concat(d.buffer):E.concat([...d.buffer,await D(d.stream)])}e.$ne=p;function r(d){return M.$7d(d,l=>E.concat(l))}e.$oe=r;function s(d){return M.$0d(d,{data:l=>typeof l=="string"?E.fromString(l):E.wrap(l)},l=>E.concat(l))}e.$pe=s;function i(d){return M.$1d(l=>E.concat(l),d)}e.$qe=i;function o(d,l){return M.$$d(d,l,R=>E.concat(R))}e.$re=o;function y(d,l){return M.$_d(d,l,R=>E.concat(R))}e.$se=y;function $(d){let l=0,R=0,B=0;const V=new Uint8Array(Math.floor(d.length/4*3)),U=N=>{switch(R){case 3:V[B++]=l|N,R=0;break;case 2:V[B++]=l|N>>>2,l=N<<6,R=3;break;case 1:V[B++]=l|N>>>4,l=N<<4,R=2;break;default:l=N<<2,R=1}};for(let N=0;N<d.length;N++){const O=d.charCodeAt(N);if(O>=65&&O<=90)U(O-65);else if(O>=97&&O<=122)U(O-97+26);else if(O>=48&&O<=57)U(O-48+52);else if(O===43||O===45)U(62);else if(O===47||O===95)U(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${d[N]}`)}}const W=B;for(;R>0;)U(0);return E.wrap(V).slice(0,W)}e.$te=$;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:d},l=!0,R=!1){const B=R?I:S;let V="";const U=d.byteLength%3;let W=0;for(;W<d.byteLength-U;W+=3){const N=d[W+0],O=d[W+1],ee=d[W+2];V+=B[N>>>2],V+=B[(N<<4|O>>>4)&63],V+=B[(O<<2|ee>>>6)&63],V+=B[ee&63]}if(U===1){const N=d[W+0];V+=B[N>>>2],V+=B[N<<4&63],l&&(V+="==")}else if(U===2){const N=d[W+0],O=d[W+1];V+=B[N>>>2],V+=B[(N<<4|O>>>4)&63],V+=B[O<<2&63],l&&(V+="=")}return V}e.$ue=u}),define(Ae[119],Re([1,0,28,15]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.FuzzyScore=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.or=void 0;function C(...se){return function(oe,de){for(let Ie=0,T=se.length;Ie<T;Ie++){const K=se[Ie](oe,de);if(K)return K}return null}}e.or=C,e.$Aj=F.bind(void 0,!1),e.$Bj=F.bind(void 0,!0);function F(se,oe,de){if(!de||de.length<oe.length)return null;let Ie;return se?Ie=M.$2e(de,oe):Ie=de.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(se,oe){const de=oe.toLowerCase().indexOf(se.toLowerCase());return de===-1?null:[{start:de,end:de+se.length}]}e.$Cj=A;function h(se,oe){return E(se.toLowerCase(),oe.toLowerCase(),0,0)}e.$Dj=h;function E(se,oe,de,Ie){if(de===se.length)return[];if(Ie===oe.length)return null;if(se[de]===oe[Ie]){let T=null;return(T=E(se,oe,de+1,Ie+1))?n({start:Ie,end:Ie+1},T):null}return E(se,oe,de,Ie+1)}function g(se){return 97<=se&&se<=122}function P(se){return 65<=se&&se<=90}e.$Ej=P;function k(se){return 48<=se&&se<=57}function a(se){return se===32||se===9||se===10||se===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>b.add(se.charCodeAt(0)));function m(se){return a(se)||b.has(se)}function f(se,oe){return se===oe||m(se)&&m(oe)}function t(se){return g(se)||P(se)||k(se)}function n(se,oe){return oe.length===0?oe=[se]:se.end===oe[0].start?oe[0].start=se.start:oe.unshift(se),oe}function c(se,oe){for(let de=oe;de<se.length;de++){const Ie=se.charCodeAt(de);if(P(Ie)||k(Ie)||de>0&&!t(se.charCodeAt(de-1)))return de}return se.length}function v(se,oe,de,Ie){if(de===se.length)return[];if(Ie===oe.length)return null;if(se[de]!==oe[Ie].toLowerCase())return null;{let T=null,K=Ie+1;for(T=v(se,oe,de+1,Ie+1);!T&&(K=c(oe,K))<oe.length;)T=v(se,oe,de+1,K),K++;return T===null?null:n({start:Ie,end:Ie+1},T)}}function D(se){let oe=0,de=0,Ie=0,T=0,K=0;for(let ae=0;ae<se.length;ae++)K=se.charCodeAt(ae),P(K)&&oe++,g(K)&&de++,t(K)&&Ie++,k(K)&&T++;const G=oe/se.length,Q=de/se.length,H=Ie/se.length,_=T/se.length;return{upperPercent:G,lowerPercent:Q,alphaPercent:H,numericPercent:_}}function p(se){const{upperPercent:oe,lowerPercent:de}=se;return de===0&&oe>.6}function r(se){const{upperPercent:oe,lowerPercent:de,alphaPercent:Ie,numericPercent:T}=se;return de>.2&&oe<.8&&Ie>.6&&T<.2}function s(se){let oe=0,de=0,Ie=0,T=0;for(let K=0;K<se.length;K++)Ie=se.charCodeAt(K),P(Ie)&&oe++,g(Ie)&&de++,a(Ie)&&T++;return(oe===0||de===0)&&T===0?se.length<=30:oe<=5}function i(se,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!s(se)||oe.length>60)return null;const de=D(oe);if(!r(de)){if(!p(de))return null;oe=oe.toLowerCase()}let Ie=null,T=0;for(se=se.toLowerCase();T<oe.length&&(Ie=v(se,oe,0,T))===null;)T=c(oe,T+1);return Ie}e.$Fj=i;function o(se,oe,de=!1){if(!oe||oe.length===0)return null;let Ie=null,T=0;for(se=se.toLowerCase(),oe=oe.toLowerCase();T<oe.length&&(Ie=y(se,oe,0,T,de))===null;)T=$(oe,T+1);return Ie}e.$Gj=o;function y(se,oe,de,Ie,T){if(de===se.length)return[];if(Ie===oe.length)return null;if(f(se.charCodeAt(de),oe.charCodeAt(Ie))){let K=null,G=Ie+1;if(K=y(se,oe,de+1,Ie+1,T),!T)for(;!K&&(G=$(oe,G))<oe.length;)K=y(se,oe,de+1,G,T),G++;return K?se.charCodeAt(de)!==oe.charCodeAt(Ie)?K:n({start:Ie,end:Ie+1},K):null}else return null}function $(se,oe){for(let de=oe;de<se.length;de++)if(m(se.charCodeAt(de))||de>0&&m(se.charCodeAt(de-1)))return de;return se.length}const S=C(e.$Bj,i,A),I=C(e.$Bj,i,h),u=new w.$Cc(1e4);function d(se,oe,de=!1){if(typeof se!="string"||typeof oe!="string")return null;let Ie=u.get(se);Ie||(Ie=new RegExp(M.$Ke(se),"i"),u.set(se,Ie));const T=Ie.exec(oe);return T?[{start:T.index,end:T.index+T[0].length}]:de?I(se,oe):S(se,oe)}e.$Hj=d;function l(se,oe){const de=ue(se,se.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return de?B(de):null}e.$Ij=l;function R(se,oe,de,Ie,T,K){const G=Math.min(13,se.length);for(;de<G;de++){const Q=ue(se,oe,de,Ie,T,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,K]}e.$Jj=R;function B(se){if(typeof se>"u")return[];const oe=[],de=se[1];for(let Ie=se.length-1;Ie>1;Ie--){const T=se[Ie]+de,K=oe[oe.length-1];K&&K.end===T?K.end=T+1:oe.push({start:T,end:T+1})}return oe}e.$Kj=B;const V=128;function U(){const se=[],oe=[];for(let de=0;de<=V;de++)oe[de]=0;for(let de=0;de<=V;de++)se.push(oe.slice(0));return se}function W(se){const oe=[];for(let de=0;de<=se;de++)oe[de]=0;return oe}const N=W(2*V),O=W(2*V),ee=U(),Z=U(),ye=U(),De=!1;function Pe(se,oe,de,Ie,T){function K(Q,H,_=" "){for(;Q.length<H;)Q=_+Q;return Q}let G=` |   |${Ie.split("").map(Q=>K(Q,3)).join("|")}
`;for(let Q=0;Q<=de;Q++)Q===0?G+=" |":G+=`${oe[Q-1]}|`,G+=se[Q].slice(0,T+1).map(H=>K(H.toString(),3)).join("|")+`
`;return G}function X(se,oe,de,Ie){se=se.substr(oe),de=de.substr(Ie),console.log(Pe(Z,se,se.length,de,de.length)),console.log(Pe(ye,se,se.length,de,de.length)),console.log(Pe(ee,se,se.length,de,de.length))}function le(se,oe){if(oe<0||oe>=se.length)return!1;const de=se.codePointAt(oe);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$hf(de)}}function Ee(se,oe){if(oe<0||oe>=se.length)return!1;switch(se.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ce(se,oe,de){return oe[se]!==de[se]}function $e(se,oe,de,Ie,T,K,G=!1){for(;oe<de&&T<K;)se[oe]===Ie[T]&&(G&&(N[oe]=T),oe+=1),T+=1;return oe===de}e.$Lj=$e;var ie;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var z;(function(se){se.Default=[-100,0];function oe(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}se.isDefault=oe})(z||(e.FuzzyScore=z={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,de){this.firstMatchCanBeWeak=oe,this.boostFullMatch=de}}e.$Mj=q;function ue(se,oe,de,Ie,T,K,G=q.default){const Q=se.length>V?V:se.length,H=Ie.length>V?V:Ie.length;if(de>=Q||K>=H||Q-de>H-K||!$e(oe,de,Q,T,K,H,!0))return;we(Q,H,de,K,oe,T);let _=1,ae=1,Fe=de,Ue=K;const Qe=[!1];for(_=1,Fe=de;Fe<Q;_++,Fe++){const it=N[Fe],tt=O[Fe],ze=Fe+1<Q?O[Fe+1]:H;for(ae=it-K+1,Ue=it;Ue<ze;ae++,Ue++){let st=Number.MIN_SAFE_INTEGER,x=!1;Ue<=tt&&(st=ve(se,oe,Fe,de,Ie,T,Ue,H,K,ee[_-1][ae-1]===0,Qe));let Y=0;st!==Number.MAX_SAFE_INTEGER&&(x=!0,Y=st+Z[_-1][ae-1]);const pe=Ue>it,Be=pe?Z[_][ae-1]+(ee[_][ae-1]>0?-5:0):0,Oe=Ue>it+1&&ee[_][ae-1]>0,Ye=Oe?Z[_][ae-2]+(ee[_][ae-2]>0?-5:0):0;if(Oe&&(!pe||Ye>=Be)&&(!x||Ye>=Y))Z[_][ae]=Ye,ye[_][ae]=3,ee[_][ae]=0;else if(pe&&(!x||Be>=Y))Z[_][ae]=Be,ye[_][ae]=2,ee[_][ae]=0;else if(x)Z[_][ae]=Y,ye[_][ae]=1,ee[_][ae]=ee[_-1][ae-1]+1;else throw new Error("not possible")}}if(De&&X(se,de,Ie,K),!Qe[0]&&!G.firstMatchCanBeWeak)return;_--,ae--;const Je=[Z[_][ae],K];let xe=0,Xe=0;for(;_>=1;){let it=ae;do{const tt=ye[_][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);xe>1&&oe[de+_-1]===T[K+ae-1]&&!ce(it+K-1,Ie,T)&&xe+1>ee[_][it]&&(it=ae),it===ae?xe++:xe=1,Xe||(Xe=it),_--,ae=it-1,Je.push(ae)}H===Q&&G.boostFullMatch&&(Je[0]+=2);const _e=Xe-Q;return Je[0]-=_e,Je}e.$Nj=ue;function we(se,oe,de,Ie,T,K){let G=se-1,Q=oe-1;for(;G>=de&&Q>=Ie;)T[G]===K[Q]&&(O[G]=Q,G--),Q--}function ve(se,oe,de,Ie,T,K,G,Q,H,_,ae){if(oe[de]!==K[G])return Number.MIN_SAFE_INTEGER;let Fe=1,Ue=!1;return G===de-Ie?Fe=se[de]===T[G]?7:5:ce(G,T,K)&&(G===0||!ce(G-1,T,K))?(Fe=se[de]===T[G]?7:5,Ue=!0):le(K,G)&&(G===0||!le(K,G-1))?Fe=5:(le(K,G-1)||Ee(K,G-1))&&(Fe=5,Ue=!0),Fe>1&&de===Ie&&(ae[0]=!0),Ue||(Ue=ce(G,T,K)||le(K,G-1)||Ee(K,G-1)),de===Ie?G>H&&(Fe-=Ue?3:5):_?Fe+=Ue?2:0:Fe+=Ue?0:1,G+1===Q&&(Fe-=Ue?3:5),Fe}function me(se,oe,de,Ie,T,K,G){return re(se,oe,de,Ie,T,K,!0,G)}e.$Oj=me;function ke(se,oe,de,Ie,T,K,G){return re(se,oe,de,Ie,T,K,!1,G)}e.$Pj=ke;function re(se,oe,de,Ie,T,K,G,Q){let H=ue(se,oe,de,Ie,T,K,Q);if(H&&!G)return H;if(se.length>=3){const _=Math.min(7,se.length-1);for(let ae=de+1;ae<_;ae++){const Fe=he(se,ae);if(Fe){const Ue=ue(Fe,Fe.toLowerCase(),de,Ie,T,K,Q);Ue&&(Ue[0]-=3,(!H||Ue[0]>H[0])&&(H=Ue))}}}return H}function he(se,oe){if(oe+1>=se.length)return;const de=se[oe],Ie=se[oe+1];if(de!==Ie)return se.slice(0,oe)+Ie+de+se.slice(oe+2)}}),define(Ae[29],Re([1,0,15]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(M||(M={})),function(C){const F="error",A="warning",h="warn",E="info",g="ignore";function P(a){return a?w.$1e(F,a)?C.Error:w.$1e(A,a)||w.$1e(h,a)?C.Warning:w.$1e(E,a)?C.Info:C.Ignore:C.Ignore}C.fromValue=P;function k(a){switch(a){case C.Error:return F;case C.Warning:return A;case C.Info:return E;default:return g}}C.toString=k}(M||(M={})),e.default=M}),define(Ae[120],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Jd=Symbol("MicrotaskDelay")}),define(Ae[49],Re([1,0,18,15]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class C{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const m=b.charCodeAt(0),f=this.b.charCodeAt(this.c);return m-f}value(){return this.b[this.c]}}e.$Ph=C;class F{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,M.$Ue)(b,this.b,0,b.length,this.c,this.d):(0,M.$We)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Qh=F;class A{constructor(b=!0,m=!0){this.f=b,this.g=m}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let m=b.length-1;m>=0;m--,this.c--){const f=this.b.charCodeAt(m);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,M.$Ue)(b,this.b,0,b.length,this.d,this.e):(0,M.$We)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Rh=A;var h;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(h||(h={}));class E{constructor(b,m){this.f=b,this.g=m,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,M.$Ve)(b,this.c.scheme);if(this.d[this.e]===2)return(0,M.$Ve)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,M.$Te)(b,this.c.query);if(this.d[this.e]===5)return(0,M.$Te)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Sh=E;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(P||(P={}));class k{static forUris(b=()=>!1,m=()=>!1){return new k(new E(b,m))}static forPaths(b=!1){return new k(new A(void 0,!b))}static forStrings(){return new k(new C)}static forConfigKeys(){return new k(new F)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,m){if(m){const f=m.slice(0);(0,w.$Wb)(f);for(const t of f)this.set(t,b)}else{const f=b.slice(0);(0,w.$Wb)(f);for(const t of f)this.set(t[0],t[1])}}set(b,m){const f=this.b.reset(b);let t;this.c||(this.c=new g,this.c.segment=f.value());const n=[];for(t=this.c;;){const v=f.cmp(t.segment);if(v>0)t.left||(t.left=new g,t.left.segment=f.value()),n.push([-1,t]),t=t.left;else if(v<0)t.right||(t.right=new g,t.right.segment=f.value()),n.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new g,t.mid.segment=f.value()),n.push([0,t]),t=t.mid;else break}const c=t.value;t.value=m,t.key=b;for(let v=n.length-1;v>=0;v--){const D=n[v][1];D.updateHeight();const p=D.balanceFactor();if(p<-1||p>1){const r=n[v][0],s=n[v+1][0];if(r===1&&s===1)n[v][1]=D.rotateLeft();else if(r===-1&&s===-1)n[v][1]=D.rotateRight();else if(r===1&&s===-1)D.right=n[v+1][1]=n[v+1][1].rotateRight(),n[v][1]=D.rotateLeft();else if(r===-1&&s===1)D.left=n[v+1][1]=n[v+1][1].rotateLeft(),n[v][1]=D.rotateRight();else throw new Error;if(v>0)switch(n[v-1][0]){case-1:n[v-1][1].left=n[v][1];break;case 1:n[v-1][1].right=n[v][1];break;case 0:n[v-1][1].mid=n[v][1];break}else this.c=n[0][1]}}return c}get(b){return this.d(b)?.value}d(b){const m=this.b.reset(b);let f=this.c;for(;f;){const t=m.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(m.hasNext())m.next(),f=f.mid;else break}return f}has(b){const m=this.d(b);return!(m?.value===void 0&&m?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,m){const f=this.b.reset(b),t=[];let n=this.c;for(;n;){const c=f.cmp(n.segment);if(c>0)t.push([-1,n]),n=n.left;else if(c<0)t.push([1,n]),n=n.right;else if(f.hasNext())f.next(),t.push([0,n]),n=n.mid;else break}if(n){if(m?(n.left=void 0,n.mid=void 0,n.right=void 0,n.height=1):(n.key=void 0,n.value=void 0),!n.mid&&!n.value)if(n.left&&n.right){const c=this.f(n.right);if(c.key){const{key:v,value:D,segment:p}=c;this.e(c.key,!1),n.key=v,n.value=D,n.segment=p}}else{const c=n.left??n.right;if(t.length>0){const[v,D]=t[t.length-1];switch(v){case-1:D.left=c;break;case 0:D.mid=c;break;case 1:D.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const v=t[c][1];v.updateHeight();const D=v.balanceFactor();if(D>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),t[c][1]=v.rotateLeft()):D<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),t[c][1]=v.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const m=this.b.reset(b);let f=this.c,t;for(;f;){const n=m.cmp(f.segment);if(n>0)f=f.left;else if(n<0)f=f.right;else if(m.hasNext())m.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(b){return this.g(b,!1)}g(b,m){const f=this.b.reset(b);let t=this.c;for(;t;){const n=f.cmp(t.segment);if(n>0)t=t.left;else if(n<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.h(t.mid):m?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[m,f]of this)b(f,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const m=[];return this.j(b,m),m[Symbol.iterator]()}j(b,m){b&&(b.left&&this.j(b.left,m),b.value&&m.push([b.key,b.value]),b.mid&&this.j(b.mid,m),b.right&&this.j(b.right,m))}_isBalanced(){const b=m=>{if(!m)return!0;const f=m.balanceFactor();return f<-1||f>1?!1:b(m.left)&&b(m.right)};return b(this.c)}}e.$Th=k}),define(Ae[40],Re([1,0,89]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Tj=e.ThemeColor=void 0;var M;(function(A){function h(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=h})(M||(e.ThemeColor=M={}));function C(A){return{id:A}}e.$Tj=C;var F;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const h=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(c){const v=h.exec(c.id);if(!v)return E(w.$Sj.error);const[,D,p]=v,r=["codicon","codicon-"+D];return p&&r.push("codicon-modifier-"+p.substring(1)),r}A.asClassNameArray=E;function g(c){return E(c).join(" ")}A.asClassName=g;function P(c){return"."+E(c).join(".")}A.asCSSSelector=P;function k(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||M.isThemeColor(c.color))}A.isThemeIcon=k;const a=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(c){const v=a.exec(c);if(!v)return;const[,D]=v;return{id:D}}A.fromString=b;function m(c){return{id:c}}A.fromId=m;function f(c,v){let D=c.id;const p=D.lastIndexOf("~");return p!==-1&&(D=D.substring(0,p)),v&&(D=`${D}~${v}`),{id:D}}A.modify=f;function t(c){const v=c.id.lastIndexOf("~");if(v!==-1)return c.id.substring(v+1)}A.getModifier=t;function n(c,v){return c.id===v.id&&c.color?.id===v.color?.id}A.isEqual=n})(F||(e.ThemeIcon=F={}))}),define(Ae[121],Re([1,0,119,15,40]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=void 0;const F="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),h=new RegExp(`(\\\\)?${A.source}`,"g");function E(n){return n.replace(h,(c,v)=>v?c:`\\${c}`)}e.$Uj=E;const g=new RegExp(`\\\\${A.source}`,"g");function P(n){return n.replace(g,c=>`\\${c}`)}e.$Vj=P;const k=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function a(n){return n.indexOf(F)===-1?n:n.replace(k,(c,v,D,p)=>D?c:v||p||"")}e.$Wj=a;function b(n){return n?n.replace(/\$\((.*?)\)/g,(c,v)=>` ${v} `).trim():""}e.$Xj=b;const m=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(n){m.lastIndex=0;let c="";const v=[];let D=0;for(;;){const p=m.lastIndex,r=m.exec(n),s=n.substring(p,r?.index);if(s.length>0){c+=s;for(let i=0;i<s.length;i++)v.push(D)}if(!r)break;D+=r[0].length}return{text:c,iconOffsets:v}}e.$Yj=f;function t(n,c,v=!1){const{text:D,iconOffsets:p}=c;if(!p||p.length===0)return(0,w.$Hj)(n,D,v);const r=(0,M.$Ie)(D," "),s=D.length-r.length,i=(0,w.$Hj)(n,r,v);if(i)for(const o of i){const y=p[o.start+s]+s;o.start+=y,o.end+=y}return i}e.$Zj=t}),define(Ae[36],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return w.test(C)}e.$cg=M,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(h){for(let E=0;E<h.length;E++)h[E]=Math.floor(Math.random()*256);return h};const F=new Uint8Array(16),A=[];for(let h=0;h<256;h++)A.push(h.toString(16).padStart(2,"0"));return function(){C(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let E=0,g="";return g+=A[F[E++]],g+=A[F[E++]],g+=A[F[E++]],g+=A[F[E++]],g+="-",g+=A[F[E++]],g+=A[F[E++]],g+="-",g+=A[F[E++]],g+=A[F[E++]],g+="-",g+=A[F[E++]],g+=A[F[E++]],g+="-",g+=A[F[E++]],g+=A[F[E++]],g+=A[F[E++]],g+=A[F[E++]],g+=A[F[E++]],g+=A[F[E++]],g}}()}),define(Ae[122],Re([1,0,18,66,36]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.$Vs=e.$Us=e.$Ts=e.$Ss=void 0;function F(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$Ss=F;function A(k,a,b){const m={id:(0,C.$dg)(),name:k,uri:a,data:b};return{asString:async()=>"",asFile:()=>m,value:void 0}}e.$Ts=A;class h{constructor(){this.a=new Map}get size(){let a=0;for(const b of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const b=[...this.a.keys()];return M.Iterable.some(this,([m,f])=>f.asFile())&&b.push("files"),P(E(a),b)}get(a){return this.a.get(this.b(a))?.[0]}append(a,b){const m=this.a.get(a);m?m.push(b):this.a.set(this.b(a),[b])}replace(a,b){this.a.set(this.b(a),[b])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,b]of this.a)for(const m of b)yield[a,m]}b(a){return E(a)}}e.$Us=h;function E(k){return k.toLowerCase()}function g(k,a){return P(E(k),a.map(E))}e.$Vs=g;function P(k,a){if(k==="*/*")return a.length>0;if(a.includes(k))return!0;const b=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[m,f,t]=b;return t==="*"?a.some(n=>n.startsWith(f+"/")):!1}e.$Ws=Object.freeze({create:k=>(0,w.$Lb)(k.map(a=>a.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$Ws.split(k).filter(a=>!a.startsWith("#"))})}),define(Ae[123],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=void 0,e.$Xr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[124],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=e.$jt=e.IndentAction=void 0;var w;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class M{constructor(h){if(this.e=null,this.f=!1,this.open=h.open,this.close=h.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(h.notIn))for(let E=0,g=h.notIn.length;E<g;E++)switch(h.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(h){switch(h){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(h,E){if(h.getTokenCount()===0)return!0;const g=h.findTokenIndexAtOffset(E-2),P=h.getStandardTokenType(g);return this.isOK(P)}g(h,E){for(let g=h;g<=E;g++){const P=String.fromCharCode(g);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$jt=M;class C{constructor(h){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of h)F(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),F(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),F(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),F(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&F(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$kt=C;function F(A,h,E){A.has(h)?A.get(h).push(E):A.set(h,[E])}}),define(Ae[125],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7=e.$A7=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const A=this.a.get(F);return this.a.delete(F),A}}addDragOperationTransfer(F,A){this.a.set(F,A)}}e.$A7=w;class M{constructor(F){this.identifier=F}}e.$B7=M}),define(Ae[126],Re([10,11]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Ae[127],Re([1,0,5,6,126]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class F extends M.$Rc{constructor(a,b="",m="",f=!0,t){super(),this.h=this.B(new w.$Md),this.onDidChange=this.h.event,this.w=!0,this.j=a,this.m=b,this.u=m,this.w=f,this.C=t}get id(){return this.j}get label(){return this.m}set label(a){this.D(a)}D(a){this.m!==a&&(this.m=a,this.h.fire({label:a}))}get tooltip(){return this.n||""}set tooltip(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.h.fire({tooltip:a}))}get class(){return this.u}set class(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.h.fire({class:a}))}get enabled(){return this.w}set enabled(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.h.fire({enabled:a}))}get checked(){return this.z}set checked(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.h.fire({checked:a}))}async run(a,b){this.C&&await this.C(a)}}e.$si=F;class A extends M.$Rc{constructor(){super(...arguments),this.f=this.B(new w.$Md),this.onWillRun=this.f.event,this.m=this.B(new w.$Md),this.onDidRun=this.m.event}async run(a,b){if(!a.enabled)return;this.f.fire({action:a});let m;try{await this.u(a,b)}catch(f){m=f}this.m.fire({action:a,error:m})}async u(a,b){await a.run(b)}}e.$ti=A;class h{constructor(){this.id=h.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let b=[];for(const m of a)m.length&&(b.length?b=[...b,new h,...m]:b=m);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$ui=h;class E{get actions(){return this.a}constructor(a,b,m,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=b,this.class=f,this.a=m}async run(){}}e.$vi=E;class g extends F{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,C.localize(0,null),void 0,!1)}}e.$wi=g;function P(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...a)=>k.run(...a),tooltip:k.label}}e.$xi=P}),define(Ae[128],Re([10,11]),function(be,e){return be.create("vs/base/common/date",e)}),define(Ae[129],Re([1,0,128]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=void 0;const M=60,C=M*60,F=C*24,A=F*7,h=F*30,E=F*365;function g(k,a,b,m){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,w.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(!m&&f<30)return(0,w.localize)(1,null);let t;return f<M?(t=f,a?t===1?b?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):b?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?b?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):b?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):f<C?(t=Math.floor(f/M),a?t===1?b?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):b?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?b?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):b?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):f<F?(t=Math.floor(f/C),a?t===1?b?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):b?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?b?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):b?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):f<A?(t=Math.floor(f/F),a?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):f<h?(t=Math.floor(f/A),a?t===1?b?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):b?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?b?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):b?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):f<E?(t=Math.floor(f/h),a?t===1?b?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):b?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?b?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):b?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(f/E),a?t===1?b?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):b?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?b?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):b?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.$9l=g;function P(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$0l=P}),define(Ae[130],Re([10,11]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Ae[41],Re([1,0,18,16,130]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function F(k,a){return a&&(k.stack||k.stacktrace)?C.localize(0,null,h(k),A(k.stack)||A(k.stacktrace)):h(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function h(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function E(k=null,a=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const b=w.$Gb(k),m=E(b[0],a);return b.length>1?C.localize(4,null,m,b.length):m}if(M.$xf(k))return k;if(k.detail){const b=k.detail;if(b.error)return F(b.error,a);if(b.exception)return F(b.exception,a)}return k.stack?F(k,a):k.message?k.message:C.localize(5,null)}e.$yi=E;function g(k){const a=k;return a instanceof Error&&Array.isArray(a.actions)}e.$zi=g;function P(k,a){let b;return typeof k=="string"?b=new Error(k):b=k,b.actions=a,b}e.$Ai=P}),define(Ae[131],Re([1,0,48,19]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=void 0;const C=new w.$U(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),F=new w.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function h(I,u,d=!1){const l=I||"",R=u||"",B=C.value.collator.compare(l,R);return C.value.collatorIsNumeric&&B===0&&l!==R?l<R?-1:1:B}e.$aq=h;function E(I,u){const d=F.value.collator;return I=I||"",u=u||"",D(d,I,u)}e.$bq=E;function g(I,u){const d=F.value.collator;return I=I||"",u=u||"",i(I,u)||D(d,I,u)}e.$cq=g;function P(I,u){const d=F.value.collator;return I=I||"",u=u||"",s(I,u)||D(d,I,u)}e.$dq=P;function k(I,u){return I=I||"",u=u||"",I===u?0:I<u?-1:1}e.$eq=k;function a(I,u){const[d,l]=c(I),[R,B]=c(u);let V=C.value.collator.compare(l,B);if(V===0){if(C.value.collatorIsNumeric&&l!==B)return l<B?-1:1;if(V=C.value.collator.compare(d,R),C.value.collatorIsNumeric&&V===0&&d!==R)return d<R?-1:1}return V}e.$fq=a;function b(I,u){I=I||"",u=u||"";const d=v(I),l=v(u),R=F.value.collator,B=A.value.collator;return D(B,d,l)||D(R,I,u)}e.$gq=b;function m(I,u){I=I||"",u=u||"";const d=v(I),l=v(u),R=F.value.collator,B=A.value.collator;return D(B,d,l)||i(I,u)||D(R,I,u)}e.$hq=m;function f(I,u){I=I||"",u=u||"";const d=v(I),l=v(u),R=F.value.collator,B=A.value.collator;return D(B,d,l)||s(I,u)||D(R,I,u)}e.$iq=f;function t(I,u){I=I||"",u=u||"";const d=v(I).toLowerCase(),l=v(u).toLowerCase();return d!==l?d<l?-1:1:I!==u?I<u?-1:1:0}e.$jq=t;const n=/^(.*?)(\.([^.]*))?$/;function c(I,u=!1){const d=I?n.exec(I):[];let l=[d&&d[1]||"",d&&d[3]||""];return u&&(!l[0]&&l[1]||l[0]&&l[0].charAt(0)===".")&&(l=[l[0]+"."+l[1],""]),l}function v(I){const u=I?n.exec(I):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function D(I,u,d){const l=I.compare(u,d);return l!==0?l:u.length!==d.length?u.length<d.length?-1:1:0}function p(I){const u=I.charAt(0);return u.toLocaleUpperCase()!==u}function r(I){const u=I.charAt(0);return u.toLocaleLowerCase()!==u}function s(I,u){return p(I)&&r(u)?-1:r(I)&&p(u)?1:0}function i(I,u){return r(I)&&p(u)?-1:p(I)&&r(u)?1:0}function o(I,u,d=!1){return d||(I=I&&I.toLowerCase(),u=u&&u.toLowerCase()),I===u?0:I<u?-1:1}function y(I,u,d=!1){const l=I.split(M.sep),R=u.split(M.sep),B=l.length-1,V=R.length-1;let U,W;for(let N=0;;N++){if(U=B===N,W=V===N,U&&W)return h(l[N],R[N],d);if(U)return-1;if(W)return 1;const O=o(l[N],R[N],d);if(O!==0)return O}}e.$kq=y;function $(I,u,d){const l=I.toLowerCase(),R=u.toLowerCase(),B=S(I,u,d);if(B)return B;const V=l.endsWith(d),U=R.endsWith(d);if(V!==U)return V?-1:1;const W=h(l,R);return W!==0?W:l.localeCompare(R)}e.$lq=$;function S(I,u,d){const l=I.toLowerCase(),R=u.toLowerCase(),B=l.startsWith(d),V=R.startsWith(d);if(B!==V)return B?-1:1;if(B&&V){if(l.length<R.length)return-1;if(l.length>R.length)return 1}return 0}e.$mq=S}),define(Ae[42],Re([1,0,19,22,15,16]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=void 0;function A($){return $===47||$===92}e.$Pf=A;function h($){return $.replace(/[\\/]/g,w.$fc.sep)}e.$Qf=h;function E($){return $.indexOf("/")===-1&&($=h($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Rf=E;function g($,S=w.$fc.sep){if(!$)return"";const I=$.length,u=$.charCodeAt(0);if(A(u)){if(A($.charCodeAt(1))&&!A($.charCodeAt(2))){let l=3;const R=l;for(;l<I&&!A($.charCodeAt(l));l++);if(R!==l&&!A($.charCodeAt(l+1))){for(l+=1;l<I;l++)if(A($.charCodeAt(l)))return $.slice(0,l+1).replace(/[\\/]/g,S)}}return S}else if(n(u)&&$.charCodeAt(1)===58)return A($.charCodeAt(2))?$.slice(0,2)+S:$.slice(0,2);let d=$.indexOf("://");if(d!==-1){for(d+=3;d<I;d++)if(A($.charCodeAt(d)))return $.slice(0,d+1)}return""}e.$Sf=g;function P($){if(!M.$j||!$||$.length<5)return!1;let S=$.charCodeAt(0);if(S!==92||(S=$.charCodeAt(1),S!==92))return!1;let I=2;const u=I;for(;I<$.length&&(S=$.charCodeAt(I),S!==92);I++);return!(u===I||(S=$.charCodeAt(I+1),isNaN(S)||S===92))}e.$Tf=P;const k=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m($,S=M.$j){const I=S?k:a;return!(!$||$.length===0||/^\s+$/.test($)||(I.lastIndex=0,I.test($))||S&&b.test($)||$==="."||$===".."||S&&$[$.length-1]==="."||S&&$.length!==$.trim().length||$.length>255)}e.$Uf=m;function f($,S,I){const u=$===S;return!I||u?u:!$||!S?!1:(0,C.$1e)($,S)}e.$Vf=f;function t($,S,I,u=w.sep){if($===S)return!0;if(!$||!S||S.length>$.length)return!1;if(I){if(!(0,C.$2e)($,S))return!1;if(S.length===$.length)return!0;let l=S.length;return S.charAt(S.length-1)===u&&l--,$.charAt(l)===u}return S.charAt(S.length-1)!==u&&(S+=u),$.indexOf(S)===0}e.$Wf=t;function n($){return $>=65&&$<=90||$>=97&&$<=122}e.$Xf=n;function c($,S){return M.$j&&$.endsWith(":")&&($+=w.sep),(0,w.$hc)($)||($=(0,w.$ic)(S,$)),$=(0,w.$gc)($),M.$j?($=(0,C.$Je)($,w.sep),$.endsWith(":")&&($+=w.sep)):($=(0,C.$Je)($,w.sep),$||($=w.sep)),$}e.$Yf=c;function v($){const S=(0,w.$gc)($);return M.$j?$.length>3?!1:D(S)&&($.length===2||S.charCodeAt(2)===92):S===w.$fc.sep}e.$Zf=v;function D($,S=M.$j){return S?n($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$1f=D;function p($,S=M.$j){return D($,S)?$[0]:void 0}e.$2f=p;function r($,S,I){return S.length>$.length?-1:$===S?0:(I&&($=$.toLowerCase(),S=S.toLowerCase()),$.indexOf(S))}e.$3f=r;function s($){const S=$.split(":");let I,u,d;for(const l of S){const R=Number(l);(0,F.$Bf)(R)?u===void 0?u=R:d===void 0&&(d=R):I=I?[I,l].join(":"):l}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:u!==void 0?u:void 0,column:d!==void 0?d:u!==void 0?1:void 0}}e.$4f=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y($,S,I=8){let u="";for(let l=0;l<I;l++){let R;l===0&&M.$j&&!S&&(I===3||I===4)?R=o:R=i,u+=R.charAt(Math.floor(Math.random()*R.length))}let d;return S?d=`${S}-${u}`:d=u,$?(0,w.$ic)($,d):d}e.$5f=y}),define(Ae[67],Re([1,0,19]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=e.$Nr=e.$Mr=e.$Lr=e.$Kr=void 0,e.$Kr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(P){const k=(0,w.$nc)(P),a=M[k.toLowerCase()];return a!==void 0?a:A(P)}e.$Lr=F;function A(P){const k=(0,w.$nc)(P);return C[k.toLowerCase()]}e.$Mr=A;function h(P){for(const k in C)if(C[k]===P)return k}e.$Nr=h;const E=/^(.+)\/(.+?)(;.+)?$/;function g(P,k){const a=E.exec(P);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:k?void 0:P}e.$Or=g}),define(Ae[68],Re([1,0,25,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function C(E){return JSON.stringify(E,A)}e.$ih=C;function F(E){let g=JSON.parse(E);return g=h(g),g}e.$jh=F;function A(E,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function h(E,g=0){if(!E||g>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return M.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof w.$ae||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let P=0;P<E.length;++P)E[P]=h(E[P],g+1);else for(const P in E)Object.hasOwnProperty.call(E,P)&&(E[P]=h(E[P],g+1))}return E}e.$kh=h}),define(Ae[12],Re([1,0,9,22,2]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.Schemas=void 0;var F;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(F||(e.Schemas=F={})),e.$6f="vscode-tkn",e.$7f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${F.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${F.vscodeRemoteResource}`}set(P,k,a){this.a[P]=k,this.b[P]=a}setConnectionToken(P,k){this.c[P]=k}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(t){return w.$Z(t),P}const k=P.authority;let a=this.a[k];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const b=this.b[k],m=this.c[k];let f=`path=${encodeURIComponent(P.path)}`;return typeof m=="string"&&(f+=`&${e.$7f}=${encodeURIComponent(m)}`),C.URI.from({scheme:M.$p?this.d:F.vscodeRemoteResource,authority:`${a}:${b}`,path:this.f,query:f})}}e.$8f=new A,e.$9f="vs/../../extensions",e.$0f="vs/../../node_modules",e.$$f="vs/../../node_modules.asar",e.$_f="vs/../../node_modules.asar.unpacked",e.$ag="vscode-app";class h{static{this.a=e.$ag}asBrowserUri(P){const k=this.b(P,be);return this.uriToBrowserUri(k)}uriToBrowserUri(P){return P.scheme===F.vscodeRemote?e.$8f.rewrite(P):P.scheme===F.file&&(M.$n||M.$q&&M.$h.origin===`${F.vscodeFileResource}://${h.a}`)?P.with({scheme:F.vscodeFileResource,authority:P.authority||h.a,query:null,fragment:null}):P}asFileUri(P){const k=this.b(P,be);return this.uriToFileUri(k)}uriToFileUri(P){return P.scheme===F.vscodeFileResource?P.with({scheme:F.file,authority:P.authority!==h.a?P.authority:null,query:null,fragment:null}):P}b(P,k){return C.URI.isUri(P)?P:C.URI.parse(k.toUrl(P))}}e.$bg=new h;var E;(function(g){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(P.get("3"));const k="vscode-coi";function a(m){let f;typeof m=="string"?f=new URL(m).searchParams:m instanceof URL?f=m.searchParams:C.URI.isUri(m)&&(f=new URL(m.toString(!0)).searchParams);const t=f?.get(k);if(t)return P.get(t)}g.getHeadersFromQuery=a;function b(m,f,t){if(!globalThis.crossOriginIsolated)return;const n=f&&t?"3":t?"2":"1";m instanceof URLSearchParams?m.set(k,n):m[k]=n}g.addSearchParam=b})(E||(e.COI=E={}))}),define(Ae[23],Re([1,0,42,12,19,22,15,2]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.DataUri=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function E(b){return(0,h.$vc)(b,!0)}e.$ig=E;class g{constructor(m){this.a=m}compare(m,f,t=!1){return m===f?0:(0,A.$Te)(this.getComparisonKey(m,t),this.getComparisonKey(f,t))}isEqual(m,f,t=!1){return m===f?!0:!m||!f?!1:this.getComparisonKey(m,t)===this.getComparisonKey(f,t)}getComparisonKey(m,f=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,f,t=!1){if(m.scheme===f.scheme){if(m.scheme===M.Schemas.file)return w.$Wf(E(m),E(f),this.a(m))&&m.query===f.query&&(t||m.fragment===f.fragment);if((0,e.$zg)(m.authority,f.authority))return w.$Wf(m.path,f.path,this.a(m),"/")&&m.query===f.query&&(t||m.fragment===f.fragment)}return!1}joinPath(m,...f){return h.URI.joinPath(m,...f)}basenameOrAuthority(m){return(0,e.$rg)(m)||m.authority}basename(m){return C.$fc.basename(m.path)}extname(m){return C.$fc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let f;return m.scheme===M.Schemas.file?f=h.URI.file(C.$lc(E(m))).path:(f=C.$fc.dirname(m.path),m.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),f="/")),m.with({path:f})}normalizePath(m){if(!m.path.length)return m;let f;return m.scheme===M.Schemas.file?f=h.URI.file(C.$gc(E(m))).path:f=C.$fc.normalize(m.path),m.with({path:f})}relativePath(m,f){if(m.scheme!==f.scheme||!(0,e.$zg)(m.authority,f.authority))return;if(m.scheme===M.Schemas.file){const c=C.$kc(E(m),E(f));return F.$j?w.$Qf(c):c}let t=m.path||"/";const n=f.path||"/";if(this.a(m)){let c=0;for(const v=Math.min(t.length,n.length);c<v&&!(t.charCodeAt(c)!==n.charCodeAt(c)&&t.charAt(c).toLowerCase()!==n.charAt(c).toLowerCase());c++);t=n.substr(0,c)+t.substr(c)}return C.$fc.relative(t,n)}resolvePath(m,f){if(m.scheme===M.Schemas.file){const t=h.URI.file(C.$jc(E(m),f));return m.with({authority:t.authority,path:t.path})}return f=w.$Rf(f),m.with({path:C.$fc.resolve(m.path,f)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,f){return m===f||m!==void 0&&f!==void 0&&(0,A.$1e)(m,f)}hasTrailingPathSeparator(m,f=C.sep){if(m.scheme===M.Schemas.file){const t=E(m);return t.length>w.$Sf(t).length&&t[t.length-1]===f}else{const t=m.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,f=C.sep){return(0,e.$Ag)(m,f)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,f=C.sep){let t=!1;if(m.scheme===M.Schemas.file){const n=E(m);t=n!==void 0&&n.length===w.$Sf(n).length&&n[n.length-1]===f}else{f="/";const n=m.path;t=n.length===1&&n.charCodeAt(n.length-1)===47}return!t&&!(0,e.$Ag)(m,f)?m.with({path:m.path+"/"}):m}}e.$jg=g,e.$kg=new g(()=>!1),e.$lg=new g(b=>b.scheme===M.Schemas.file?!F.$l:!0),e.$mg=new g(b=>!0),e.$ng=e.$kg.isEqual.bind(e.$kg),e.$og=e.$kg.isEqualOrParent.bind(e.$kg),e.$pg=e.$kg.getComparisonKey.bind(e.$kg),e.$qg=e.$kg.basenameOrAuthority.bind(e.$kg),e.$rg=e.$kg.basename.bind(e.$kg),e.$sg=e.$kg.extname.bind(e.$kg),e.$tg=e.$kg.dirname.bind(e.$kg),e.$ug=e.$kg.joinPath.bind(e.$kg),e.$vg=e.$kg.normalizePath.bind(e.$kg),e.$wg=e.$kg.relativePath.bind(e.$kg),e.$xg=e.$kg.resolvePath.bind(e.$kg),e.$yg=e.$kg.isAbsolutePath.bind(e.$kg),e.$zg=e.$kg.isEqualAuthority.bind(e.$kg),e.$Ag=e.$kg.hasTrailingPathSeparator.bind(e.$kg),e.$Bg=e.$kg.removeTrailingPathSeparator.bind(e.$kg),e.$Cg=e.$kg.addTrailingPathSeparator.bind(e.$kg);function P(b,m){const f=[];for(let t=0;t<b.length;t++){const n=m(b[t]);b.some((c,v)=>v===t?!1:(0,e.$og)(n,m(c)))||f.push(b[t])}return f}e.$Dg=P;var k;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function m(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(v=>{const[D,p]=v.split(":");D&&p&&t.set(D,p)});const c=f.path.substring(0,f.path.indexOf(";"));return c&&t.set(b.META_DATA_MIME,c),t}b.parseMetaData=m})(k||(e.DataUri=k={}));function a(b,m,f){if(m){let t=b.path;return t&&t[0]!==C.$fc.sep&&(t=C.$fc.sep+t),b.with({scheme:f,authority:m,path:t})}return b.with({scheme:f})}e.$Eg=a}),define(Ae[13],Re([1,0,21,9,5,6,23,22,120]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eh=e.$dh=e.$ch=e.Promises=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function g(z){return!!z&&typeof z.then=="function"}e.$Fg=g;function P(z){const q=new w.$Wd,ue=z(q.token),we=new Promise((ve,me)=>{const ke=q.token.onCancellationRequested(()=>{ke.dispose(),q.dispose(),me(new M.$4)});Promise.resolve(ue).then(re=>{ke.dispose(),q.dispose(),ve(re)},re=>{ke.dispose(),q.dispose(),me(re)})});return new class{cancel(){q.cancel()}then(ve,me){return we.then(ve,me)}catch(ve){return this.then(void 0,ve)}finally(ve){return we.finally(ve)}}}e.$Gg=P;function k(z,q,ue){return new Promise((we,ve)=>{const me=q.onCancellationRequested(()=>{me.dispose(),we(ue)});z.then(we,ve).finally(()=>me.dispose())})}e.$Hg=k;function a(z,q){return new Promise((ue,we)=>{const ve=q.onCancellationRequested(()=>{ve.dispose(),we(new M.$4)});z.then(ue,we).finally(()=>ve.dispose())})}e.$Ig=a;async function b(z){let q=-1;const ue=z.map((we,ve)=>we.then(me=>(q=ve,me)));try{return await Promise.race(ue)}finally{z.forEach((we,ve)=>{ve!==q&&we.cancel()})}}e.$Jg=b;function m(z,q,ue){let we;const ve=setTimeout(()=>{we?.(void 0),ue?.()},q);return Promise.race([z.finally(()=>clearTimeout(ve)),new Promise(me=>we=me)])}e.$Kg=m;function f(z){return new Promise((q,ue)=>{const we=z();g(we)?we.then(q,ue):q(we)})}e.$Lg=f;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const ue=()=>{if(this.b=null,this.f)return;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(ue,ue).then(we)})}return new Promise((ue,we)=>{this.b.then(ue,we)})}return this.a=q(),new Promise((ue,we)=>{this.a.then(ve=>{this.a=null,ue(ve)},ve=>{this.a=null,we(ve)})})}dispose(){this.f=!0}}e.$Mg=t;class n{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$Ng=n;class c{constructor(){this.a=new Map}queue(q,ue){const ve=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(ue).finally(()=>{this.a.get(q)===ve&&this.a.delete(q)});return this.a.set(q,ve),ve}}e.$Og=c;const v=(z,q)=>{let ue=!0;const we=setTimeout(()=>{ue=!1,q()},z);return{isTriggered:()=>ue,dispose:()=>{clearTimeout(we),ue=!1}}},D=z=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,z())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class p{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,ue=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((ve,me)=>{this.d=ve,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=ue===E.$Jd?D(we):v(ue,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Pg=p;class r{constructor(q){this.a=new p(q),this.b=new t}trigger(q,ue){return this.a.trigger(()=>this.b.queue(q),ue)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Qg=r;class s{constructor(){this.a=!1,this.b=new Promise((q,ue)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Rg=s;class i extends s{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Sg=i;function o(z,q){return q?new Promise((ue,we)=>{const ve=setTimeout(()=>{me.dispose(),ue()},z),me=q.onCancellationRequested(()=>{clearTimeout(ve),me.dispose(),we(new M.$4)})}):P(ue=>o(z,ue))}e.$Tg=o;function y(z,q=0,ue){const we=setTimeout(()=>{z(),ue&&ve.dispose()},q),ve=(0,F.$Pc)(()=>{clearTimeout(we),ue?.deleteAndLeak(ve)});return ue?.add(ve),ve}e.$Ug=y;function $(z){const q=[];let ue=0;const we=z.length;function ve(){return ue<we?z[ue++]():null}function me(ke){ke!=null&&q.push(ke);const re=ve();return re?re.then(me):Promise.resolve(q)}return Promise.resolve(null).then(me)}e.$Vg=$;function S(z,q=we=>!!we,ue=null){let we=0;const ve=z.length,me=()=>{if(we>=ve)return Promise.resolve(ue);const ke=z[we++];return Promise.resolve(ke()).then(he=>q(he)?Promise.resolve(he):me())};return me()}e.$Wg=S;function I(z,q=we=>!!we,ue=null){if(z.length===0)return Promise.resolve(ue);let we=z.length;const ve=()=>{we=-1;for(const me of z)me.cancel?.()};return new Promise((me,ke)=>{for(const re of z)re.then(he=>{--we>=0&&q(he)?(ve(),me(he)):we===0&&me(ue)}).catch(he=>{--we>=0&&(ve(),ke(he))})})}e.$Xg=I;class u{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new C.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((ue,we)=>{this.f.push({factory:q,c:ue,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const ue=q.factory();ue.then(q.c,q.e),ue.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Yg=u;class d extends u{constructor(){super(1)}}e.$Zg=d;class l{constructor(){this.a=new ye,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$1g=l;class R{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new X;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,ue=A.$kg){const we=ue.getComparisonKey(q);let ve=this.a.get(we);if(!ve){ve=new d;const me=this.f++,ke=C.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$Zc),this.d.set(me,ke),this.a.set(we,ve)}return ve}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$2g=R;class B{constructor(q,ue){this.a=-1,typeof q=="function"&&typeof ue=="number"&&this.setIfNotSet(q,ue)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,ue){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},ue)}setIfNotSet(q,ue){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},ue))}}e.$3g=B;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,ue){this.cancel(),this.a=setInterval(()=>{q()},ue)}}e.$4g=V;class U{constructor(q,ue){this.b=-1,this.a=q,this.d=ue,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$5g=U;class W{constructor(q,ue){ue%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ue}ms is not a multiple of 1000ms.`),this.a=q,this.b=ue,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$6g=W;class N extends U{constructor(q,ue){super(q,ue),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$7g=N;class O extends F.$Rc{constructor(q,ue){super(),this.g=q,this.h=ue,this.a=[],this.b=this.B(new F.$Sc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ue of q)this.a.push(ue);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$8g=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$9g=z=>{(0,h.$B)(()=>{if(q)return;const ue=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$9g=(z,q)=>{const ue=requestIdleCallback(z,typeof q=="number"?{timeout:q}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(ue))}}}}();class ee{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(ue){this.g=ue}finally{this.d=!0}},this.b=(0,e.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$0g=ee;async function Z(z,q,ue){let we;for(let ve=0;ve<ue;ve++)try{return await z()}catch(me){we=me,await o(q)}throw we}e.$$g=Z;class ye{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,ue,we){return this.a={taskId:q,cancel:()=>we?.(),promise:ue},ue.then(()=>this.d(q),()=>this.d(q)),ue}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let ue,we;const ve=new Promise((me,ke)=>{ue=me,we=ke});this.b={run:q,promise:ve,promiseResolve:ue,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$_g=ye;class De{constructor(q,ue=()=>Date.now()){this.d=q,this.f=ue,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$ah=De;var Pe;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(Pe||(Pe={}));class X{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,ue)=>{this.a=q,this.b=ue})}complete(q){return new Promise(ue=>{this.a(q),this.d={outcome:0,value:q},ue()})}error(q){return new Promise(ue=>{this.b(q),this.d={outcome:1,value:q},ue()})}cancel(){return this.error(new M.$4)}}e.$bh=X;var le;(function(z){async function q(we){let ve;const me=await Promise.all(we.map(ke=>ke.then(re=>re,re=>{ve||(ve=re)})));if(typeof ve<"u")throw ve;return me}z.settled=q;function ue(we){return new Promise(async(ve,me)=>{try{await we(ve,me)}catch(ke){me(ke)}})}z.withAsyncBody=ue})(le||(e.Promises=le={}));var Ee;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(Ee||(Ee={}));class ce{static fromArray(q){return new ce(ue=>{ue.emitMany(q)})}static fromPromise(q){return new ce(async ue=>{ue.emitMany(await q)})}static fromPromises(q){return new ce(async ue=>{await Promise.all(q.map(async we=>ue.emitOne(await we)))})}static merge(q){return new ce(async ue=>{await Promise.all(q.map(async we=>{for await(const ve of we)ue.emitOne(ve)}))})}static{this.EMPTY=ce.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new C.$Md,queueMicrotask(async()=>{const ue={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(q(ue)),this.j()}catch(we){this.k(we)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(q,ue){return new ce(async we=>{for await(const ve of q)we.emitOne(ue(ve))})}map(q){return ce.map(this,q)}static filter(q,ue){return new ce(async we=>{for await(const ve of q)ue(ve)&&we.emitOne(ve)})}filter(q){return ce.filter(this,q)}static coalesce(q){return ce.filter(q,ue=>!!ue)}coalesce(){return ce.coalesce(this)}static async toPromise(q){const ue=[];for await(const we of q)ue.push(we);return ue}toPromise(){return ce.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$ch=ce;class $e extends ce{constructor(q,ue){super(ue),this.l=q}cancel(){this.l.cancel()}}e.$dh=$e;function ie(z){const q=new w.$Wd,ue=z(q.token);return new $e(q,async we=>{const ve=q.token.onCancellationRequested(()=>{ve.dispose(),q.dispose(),we.reject(new M.$4)});try{for await(const me of ue){if(q.token.isCancellationRequested)return;we.emitOne(me)}ve.dispose(),q.dispose()}catch(me){ve.dispose(),q.dispose(),we.reject(me)}})}e.$eh=ie}),define(Ae[37],Re([1,0,18,13,42,28,19,22,15]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0;function g(){return Object.create(null)}e.$pj=g,e.$qj="**",e.$rj="/";const P="[/\\\\]",k="[^/\\\\]",a=/\//g;function b(ye,De){switch(ye){case 0:return"";case 1:return`${k}*?`;default:return`(?:${P}|${k}+${P}${De?`|${P}${k}+`:""})*?`}}function m(ye,De){if(!ye)return[];const Pe=[];let X=!1,le=!1,Ee="";for(const ce of ye){switch(ce){case De:if(!X&&!le){Pe.push(Ee),Ee="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":le=!0;break;case"]":le=!1;break}Ee+=ce}return Ee&&Pe.push(Ee),Pe}e.$sj=m;function f(ye){if(!ye)return"";let De="";const Pe=m(ye,e.$rj);if(Pe.every(X=>X===e.$qj))De=".*";else{let X=!1;Pe.forEach((le,Ee)=>{if(le===e.$qj){if(X)return;De+=b(2,Ee===Pe.length-1)}else{let ce=!1,$e="",ie=!1,z="";for(const q of le){if(q!=="}"&&ce){$e+=q;continue}if(ie&&(q!=="]"||!z)){let ue;q==="-"?ue=q:(q==="^"||q==="!")&&!z?ue="^":q===e.$rj?ue="":ue=(0,E.$Ee)(q),z+=ue;continue}switch(q){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const we=`(?:${m($e,",").map(ve=>f(ve)).join("|")})`;De+=we,ce=!1,$e="";break}case"]":{De+="["+z+"]",ie=!1,z="";break}case"?":De+=k;continue;case"*":De+=b(1);continue;default:De+=(0,E.$Ee)(q)}}Ee<Pe.length-1&&(Pe[Ee+1]!==e.$qj||Ee+2<Pe.length)&&(De+=P)}X=le===e.$qj})}return De}const t=/^\*\*\/\*\.[\w\.-]+$/,n=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new F.$Cc(1e4),s=function(){return!1},i=function(){return null};function o(ye,De){if(!ye)return i;let Pe;typeof ye!="string"?Pe=ye.pattern:Pe=ye,Pe=Pe.trim();const X=`${Pe}_${!!De.trimForExclusions}`;let le=r.get(X);if(le)return y(le,ye);let Ee;return t.test(Pe)?le=S(Pe.substr(4),Pe):(Ee=n.exec($(Pe,De)))?le=I(Ee[1],Pe):(De.trimForExclusions?v:c).test(Pe)?le=u(Pe,De):(Ee=D.exec($(Pe,De)))?le=d(Ee[1].substr(1),Pe,!0):(Ee=p.exec($(Pe,De)))?le=d(Ee[1],Pe,!1):le=l(Pe),r.set(X,le),y(le,ye)}function y(ye,De){if(typeof De=="string")return ye;const Pe=function(X,le){return(0,C.$Wf)(X,De.base,!h.$l)?ye((0,E.$Ie)(X.substr(De.base.length),A.sep),le):null};return Pe.allBasenames=ye.allBasenames,Pe.allPaths=ye.allPaths,Pe.basenames=ye.basenames,Pe.patterns=ye.patterns,Pe}function $(ye,De){return De.trimForExclusions&&ye.endsWith("/**")?ye.substr(0,ye.length-2):ye}function S(ye,De){return function(Pe,X){return typeof Pe=="string"&&Pe.endsWith(ye)?De:null}}function I(ye,De){const Pe=`/${ye}`,X=`\\${ye}`,le=function(ce,$e){return typeof ce!="string"?null:$e?$e===ye?De:null:ce===ye||ce.endsWith(Pe)||ce.endsWith(X)?De:null},Ee=[ye];return le.basenames=Ee,le.patterns=[De],le.allBasenames=Ee,le}function u(ye,De){const Pe=ee(ye.slice(1,-1).split(",").map($e=>o($e,De)).filter($e=>$e!==i),ye),X=Pe.length;if(!X)return i;if(X===1)return Pe[0];const le=function($e,ie){for(let z=0,q=Pe.length;z<q;z++)if(Pe[z]($e,ie))return ye;return null},Ee=Pe.find($e=>!!$e.allBasenames);Ee&&(le.allBasenames=Ee.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(le.allPaths=ce),le}function d(ye,De,Pe){const X=A.sep===A.$fc.sep,le=X?ye:ye.replace(a,A.sep),Ee=A.sep+le,ce=A.$fc.sep+ye;let $e;return Pe?$e=function(ie,z){return typeof ie=="string"&&(ie===le||ie.endsWith(Ee)||!X&&(ie===ye||ie.endsWith(ce)))?De:null}:$e=function(ie,z){return typeof ie=="string"&&(ie===le||!X&&ie===ye)?De:null},$e.allPaths=[(Pe?"*/":"./")+ye],$e}function l(ye){try{const De=new RegExp(`^${f(ye)}$`);return function(Pe){return De.lastIndex=0,typeof Pe=="string"&&De.test(Pe)?ye:null}}catch{return i}}function R(ye,De,Pe){return!ye||typeof De!="string"?!1:B(ye)(De,void 0,Pe)}e.$tj=R;function B(ye,De={}){if(!ye)return s;if(typeof ye=="string"||V(ye)){const Pe=o(ye,De);if(Pe===i)return s;const X=function(le,Ee){return!!Pe(le,Ee)};return Pe.allBasenames&&(X.allBasenames=Pe.allBasenames),Pe.allPaths&&(X.allPaths=Pe.allPaths),X}return N(ye,De)}e.$uj=B;function V(ye){const De=ye;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$vj=V;function U(ye){return ye.allBasenames||[]}e.$wj=U;function W(ye){return ye.allPaths||[]}e.$xj=W;function N(ye,De){const Pe=ee(Object.getOwnPropertyNames(ye).map($e=>O($e,ye[$e],De)).filter($e=>$e!==i)),X=Pe.length;if(!X)return i;if(!Pe.some($e=>!!$e.requiresSiblings)){if(X===1)return Pe[0];const $e=function(q,ue){let we;for(let ve=0,me=Pe.length;ve<me;ve++){const ke=Pe[ve](q,ue);if(typeof ke=="string")return ke;(0,M.$Fg)(ke)&&(we||(we=[]),we.push(ke))}return we?(async()=>{for(const ve of we){const me=await ve;if(typeof me=="string")return me}return null})():null},ie=Pe.find(q=>!!q.allBasenames);ie&&($e.allBasenames=ie.allBasenames);const z=Pe.reduce((q,ue)=>ue.allPaths?q.concat(ue.allPaths):q,[]);return z.length&&($e.allPaths=z),$e}const le=function($e,ie,z){let q,ue;for(let we=0,ve=Pe.length;we<ve;we++){const me=Pe[we];me.requiresSiblings&&z&&(ie||(ie=(0,A.$mc)($e)),q||(q=ie.substr(0,ie.length-(0,A.$nc)($e).length)));const ke=me($e,ie,q,z);if(typeof ke=="string")return ke;(0,M.$Fg)(ke)&&(ue||(ue=[]),ue.push(ke))}return ue?(async()=>{for(const we of ue){const ve=await we;if(typeof ve=="string")return ve}return null})():null},Ee=Pe.find($e=>!!$e.allBasenames);Ee&&(le.allBasenames=Ee.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(le.allPaths=ce),le}function O(ye,De,Pe){if(De===!1)return i;const X=o(ye,Pe);if(X===i)return i;if(typeof De=="boolean")return X;if(De){const le=De.when;if(typeof le=="string"){const Ee=(ce,$e,ie,z)=>{if(!z||!X(ce,$e))return null;const q=le.replace("$(basename)",()=>ie),ue=z(q);return(0,M.$Fg)(ue)?ue.then(we=>we?ye:null):ue?ye:null};return Ee.requiresSiblings=!0,Ee}}return X}function ee(ye,De){const Pe=ye.filter($e=>!!$e.basenames);if(Pe.length<2)return ye;const X=Pe.reduce(($e,ie)=>{const z=ie.basenames;return z?$e.concat(z):$e},[]);let le;if(De){le=[];for(let $e=0,ie=X.length;$e<ie;$e++)le.push(De)}else le=Pe.reduce(($e,ie)=>{const z=ie.patterns;return z?$e.concat(z):$e},[]);const Ee=function($e,ie){if(typeof $e!="string")return null;if(!ie){let q;for(q=$e.length;q>0;q--){const ue=$e.charCodeAt(q-1);if(ue===47||ue===92)break}ie=$e.substr(q)}const z=X.indexOf(ie);return z!==-1?le[z]:null};Ee.basenames=X,Ee.patterns=le,Ee.allBasenames=X;const ce=ye.filter($e=>!$e.basenames);return ce.push(Ee),ce}function Z(ye,De){return(0,w.$tb)(ye,De,(Pe,X)=>typeof Pe=="string"&&typeof X=="string"?Pe===X:typeof Pe!="string"&&typeof X!="string"?Pe.base===X.base&&Pe.pattern===X.pattern:!1)}e.$yj=Z}),define(Ae[50],Re([1,0,9,121,23,15,2]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.MarkdownStringTextNewlineStyle=void 0;var h;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(h||(e.MarkdownStringTextNewlineStyle=h={}));class E{constructor(n="",c=!1){if(this.value=n,typeof this.value!="string")throw(0,w.$6)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(n,c=0){return this.value+=a(this.supportThemeIcons?(0,M.$Uj)(n):n).replace(/([ \t]+)/g,(v,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,c){return this.value+="\n```",this.value+=n,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(n,c,v){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(n),")"),v&&(this.value+=` "${this.c(this.c(v,'"'),")")}"`),this.value+=")",this}c(n,c){const v=new RegExp((0,F.$Ee)(c),"g");return n.replace(v,(D,p)=>n.charAt(p-1)!=="\\"?`\\${D}`:D)}}e.$1j=E;function g(t){return P(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.$2j=g;function P(t){return t instanceof E?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$3j=P;function k(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,C.$ng)(A.URI.from(t.baseUri),A.URI.from(n.baseUri)))}e.$4j=k;function a(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$5j=a;function b(t){return t.replace(/"/g,"&quot;")}e.$6j=b;function m(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$7j=m;function f(t){const n=[],c=t.split("|").map(D=>D.trim());t=c[0];const v=c[1];if(v){const D=/height=(\d+)/.exec(v),p=/width=(\d+)/.exec(v),r=D?D[1]:"",s=p?p[1]:"",i=isFinite(parseInt(s)),o=isFinite(parseInt(r));i&&n.push(`width="${s}"`),o&&n.push(`height="${r}"`)}return{href:t,dimensions:n}}e.$8j=f}),define(Ae[90],Re([1,0,18,42,19,22,23,15]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=void 0;function E(o,y){const{os:$,tildify:S,relative:I}=y;if(I){const l=g(o,I,$);if(typeof l=="string")return l}let u=o.fsPath;if($===1&&!F.$j?u=u.replace(/\//g,"\\"):$!==1&&F.$j&&(u=u.replace(/\\/g,"/")),$!==1&&S?.userHome){const l=S.userHome.fsPath;let R;o.scheme!==S.userHome.scheme&&o.path.startsWith(C.$fc.sep)?R=S.userHome.with({path:o.path}).fsPath:R=o.fsPath,u=a(R,l,$)}return($===1?C.$ec:C.$fc).normalize(P(u,$===1))}e.$kv=E;function g(o,y,$){const S=$===1?C.$ec:C.$fc,I=$===3?A.$kg:A.$mg,u=y.getWorkspace(),d=(0,w.$Nb)(u.folders);if(!d)return;o.scheme!==d.uri.scheme&&o.path.startsWith(C.$fc.sep)&&(o=d.uri.with({path:o.path}));const l=y.getWorkspaceFolder(o);if(!l)return;let R;if(I.isEqual(l.uri,o)?R="":R=I.relativePath(l.uri,o)??"",R&&(R=S.normalize(R)),u.folders.length>1&&!y.noPrefix){const B=l.name?l.name:I.basenameOrAuthority(l.uri);R=R?`${B} \u2022 ${R}`:B}return R}function P(o,y=F.$j){return(0,M.$1f)(o,y)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$lv=P;let k=Object.create(null);function a(o,y,$=F.OS){if($===1||!o||!y)return o;let S=k.original===y?k.normalized:void 0;S||(S=y,F.$j&&(S=(0,M.$Qf)(S)),S=`${(0,h.$Je)(S,C.$fc.sep)}${C.$fc.sep}`,k={original:y,normalized:S});let I=o;return F.$j&&(I=(0,M.$Qf)(I)),($===3?I.startsWith(S):(0,h.$2e)(I,S))?`~/${I.substr(S.length)}`:o}e.$mv=a;function b(o,y){return o.replace(/^~($|\/|\\)/,`${y}$1`)}e.$nv=b;const m="\u2026",f="\\\\",t="~";function n(o,y=C.sep){const $=new Array(o.length);let S=!1;for(let I=0;I<o.length;I++){const u=o[I];if(u===""){$[I]=`.${y}`;continue}if(!u){$[I]=u;continue}S=!0;let d="",l=u;l.indexOf(f)===0?(d=l.substr(0,l.indexOf(f)+f.length),l=l.substr(l.indexOf(f)+f.length)):l.indexOf(y)===0?(d=l.substr(0,l.indexOf(y)+y.length),l=l.substr(l.indexOf(y)+y.length)):l.indexOf(t)===0&&(d=l.substr(0,l.indexOf(t)+t.length),l=l.substr(l.indexOf(t)+t.length));const R=l.split(y);for(let B=1;S&&B<=R.length;B++)for(let V=R.length-B;S&&V>=0;V--){S=!1;let U=R.slice(V,V+B).join(y);for(let W=0;!S&&W<o.length;W++)if(W!==I&&o[W]&&o[W].indexOf(U)>-1){const N=V+B===R.length,O=V>0&&o[W].indexOf(y)>-1?y+U:U,ee=o[W].endsWith(O);S=!N||ee}if(!S){let W="";(R[0].endsWith(":")||d!=="")&&(V===1&&(V=0,B++,U=R[0]+y+U),V>0&&(W=R[0]+y),W=d+W),V>0&&(W=W+m+y),W=W+U,V+B<R.length&&(W=W+y+m),$[I]=W}}S&&($[I]=u)}return $}e.$ov=n;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function v(o,y=Object.create(null)){const $=[];let S=!1,I="";for(const u of o)if(u==="$"||S&&u==="{")I&&$.push({value:I,type:c.TEXT}),I="",S=!0;else if(u==="}"&&S){const d=y[I];if(typeof d=="string")d.length&&$.push({value:d,type:c.VARIABLE});else if(d){const l=$[$.length-1];(!l||l.type!==c.SEPARATOR)&&$.push({value:d.label,type:c.SEPARATOR})}I="",S=!1}else I+=u;return I&&!S&&$.push({value:I,type:c.TEXT}),$.filter((u,d)=>{if(u.type===c.SEPARATOR){const l=$[d-1],R=$[d+1];return[l,R].every(B=>B&&(B.type===c.VARIABLE||B.type===c.TEXT)&&B.value.length>0)}return!0}).map(u=>u.value).join("")}e.$pv=v;function D(o,y){return F.$k||y?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$k?"&":"&&"):o.replace(/&&|&/g,$=>$==="&"?"&&":"&")}e.$qv=D;function p(o,y){return F.$k||y?o.replace(/\(&&\w\)|&&/g,""):F.$j?o.replace(/&&|&/g,$=>$==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$rv=p;function r(o){return o.replace(/&/g,"&&")}e.$sv=r;function s(o){if(o.endsWith("]")){const y=o.lastIndexOf(" [",o.length-2);if(y!==-1){const $=i(o.substring(0,y));return{name:$.name,parentPath:$.parentPath+o.substring(y)}}}return i(o)}e.$tv=s;function i(o){const y=o.indexOf("/")!==-1?C.$fc:C.$ec,$=y.basename(o),S=y.dirname(o);return $.length?{name:$,parentPath:S}:{name:S,parentPath:""}}}),define(Ae[132],Re([1,0,25,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=e.$Gm=e.$Fm=e.$Em=void 0;function C(k){return k.toJSON()}class F{constructor(a){this.a=a}transformIncoming(a){const b=this.a.transformIncoming(a);return b===a?a:C(M.URI.from(b))}transformOutgoing(a){const b=this.a.transformOutgoing(a);return b===a?a:C(M.URI.from(b))}transformOutgoingURI(a){const b=this.a.transformOutgoing(a);return b===a?a:M.URI.from(b)}transformOutgoingScheme(a){return this.a.transformOutgoingScheme(a)}}e.$Em=F,e.$Fm=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function A(k,a,b){if(!k||b>200)return null;if(typeof k=="object"){if(k instanceof M.URI)return a.transformOutgoing(k);for(const m in k)if(Object.hasOwnProperty.call(k,m)){const f=A(k[m],a,b+1);f!==null&&(k[m]=f)}}return null}function h(k,a){const b=A(k,a,0);return b===null?k:b}e.$Gm=h;function E(k,a,b,m){if(!k||m>200)return null;if(typeof k=="object"){if(k.$mid===1)return b?M.URI.revive(a.transformIncoming(k)):a.transformIncoming(k);if(k instanceof w.$ae)return null;for(const f in k)if(Object.hasOwnProperty.call(k,f)){const t=E(k[f],a,b,m+1);t!==null&&(k[f]=t)}}return null}function g(k,a){const b=E(k,a,!1,0);return b===null?k:b}e.$Hm=g;function P(k,a){const b=E(k,a,!0,0);return b===null?k:b}e.$Im=P}),define(Ae[133],Re([1,0,37,19]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jE=void 0;function C(F,A,h,E,g,P){if(Array.isArray(F)){let k=0;for(const a of F){const b=C(a,A,h,E,g,P);if(b===10)return b;b>k&&(k=b)}return k}else{if(typeof F=="string")return E?F==="*"?5:F===h?10:0:0;if(F){const{language:k,pattern:a,scheme:b,hasAccessToAllModels:m,notebookType:f}=F;if(!E&&!m)return 0;f&&g&&(A=g);let t=0;if(b)if(b===A.scheme)t=10;else if(b==="*")t=5;else return 0;if(k)if(k===h)t=10;else if(k==="*")t=Math.max(t,5);else return 0;if(f)if(f===P)t=10;else if(f==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(a){let n;if(typeof a=="string"?n=a:n={...a,base:(0,M.$gc)(a.base)},n===A.fsPath||(0,w.$tj)(n,A.fsPath))t=10;else return 0}return t}else return 0}}e.$jE=C}),define(Ae[91],Re([1,0,25,22]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L0=e.$K0=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function F(k){for(let a=0,b=k.length;a<b;a+=4){const m=k[a+0],f=k[a+1],t=k[a+2],n=k[a+3];k[a+0]=n,k[a+1]=t,k[a+2]=f,k[a+3]=m}}function A(k){const a=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return M.$D()||F(a),w.$ae.wrap(a)}function h(k){const a=k.buffer;if(M.$D()||F(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const b=new Uint8Array(a.byteLength);return b.set(a),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function E(k){const a=new Uint32Array(g(k));let b=0;if(a[b++]=k.id,k.type==="full")a[b++]=1,a[b++]=k.data.length,a.set(k.data,b),b+=k.data.length;else{a[b++]=2,a[b++]=k.deltas.length;for(const m of k.deltas)a[b++]=m.start,a[b++]=m.deleteCount,m.data?(a[b++]=m.data.length,a.set(m.data,b),b+=m.data.length):a[b++]=0}return A(a)}e.$K0=E;function g(k){let a=0;if(a+=1+1,k.type==="full")a+=1+k.data.length;else{a+=1,a+=(1+1+1)*k.deltas.length;for(const b of k.deltas)b.data&&(a+=b.data.length)}return a}function P(k){const a=h(k);let b=0;const m=a[b++];if(a[b++]===1){const c=a[b++],v=a.subarray(b,b+c);return b+=c,{id:m,type:"full",data:v}}const t=a[b++],n=[];for(let c=0;c<t;c++){const v=a[b++],D=a[b++],p=a[b++];let r;p>0&&(r=a.subarray(b,b+p),b+=p),n[c]={start:v,deleteCount:D,data:r}}return{id:m,type:"delta",deltas:n}}e.$L0=P}),define(Ae[134],Re([10,11]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,18,24,22,123,136,134]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(x){x[x.None=0]="None",x[x.Keep=1]="Keep",x[x.Brackets=2]="Brackets",x[x.Advanced=3]="Advanced",x[x.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=g;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class k{constructor(Y,pe,Be,Oe){this.id=Y,this.name=pe,this.defaultValue=Be,this.schema=Oe}applyUpdate(Y,pe){return b(Y,pe)}compute(Y,pe,Be){return Be}}class a{constructor(Y,pe){this.newValue=Y,this.didChange=pe}}e.ApplyUpdateResult=a;function b(x,Y){if(typeof x!="object"||typeof Y!="object"||!x||!Y)return new a(Y,x!==Y);if(Array.isArray(x)||Array.isArray(Y)){const Be=Array.isArray(x)&&Array.isArray(Y)&&w.$tb(x,Y);return new a(Y,!Be)}let pe=!1;for(const Be in Y)if(Y.hasOwnProperty(Be)){const Oe=b(x[Be],Y[Be]);Oe.didChange&&(x[Be]=Oe.newValue,pe=!0)}return new a(x,pe)}class m{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,pe){return b(Y,pe)}validate(Y){return this.defaultValue}}class f{constructor(Y,pe,Be,Oe){this.id=Y,this.name=pe,this.defaultValue=Be,this.schema=Oe}applyUpdate(Y,pe){return b(Y,pe)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,pe,Be){return Be}}function t(x,Y){return typeof x>"u"?Y:x==="false"?!1:!!x}e.boolean=t;class n extends f{constructor(Y,pe,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=Be),super(Y,pe,Be,Oe)}validate(Y){return t(Y,this.defaultValue)}}function c(x,Y,pe,Be){if(typeof x>"u")return Y;let Oe=parseInt(x,10);return isNaN(Oe)?Y:(Oe=Math.max(pe,Oe),Oe=Math.min(Be,Oe),Oe|0)}e.clampedInt=c;class v extends f{static clampedInt(Y,pe,Be,Oe){return c(Y,pe,Be,Oe)}constructor(Y,pe,Be,Oe,Ye,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Be,rt.minimum=Oe,rt.maximum=Ye),super(Y,pe,Be,rt),this.minimum=Oe,this.maximum=Ye}validate(Y){return v.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function D(x,Y,pe,Be){if(typeof x>"u")return Y;const Oe=p.float(x,Y);return p.clamp(Oe,pe,Be)}e.clampedFloat=D;class p extends f{static clamp(Y,pe,Be){return Y<pe?pe:Y>Be?Be:Y}static float(Y,pe){if(typeof Y=="number")return Y;if(typeof Y>"u")return pe;const Be=parseFloat(Y);return isNaN(Be)?pe:Be}constructor(Y,pe,Be,Oe,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=Be),super(Y,pe,Be,Ye),this.validationFn=Oe}validate(Y){return this.validationFn(p.float(Y,this.defaultValue))}}class r extends f{static string(Y,pe){return typeof Y!="string"?pe:Y}constructor(Y,pe,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=Be),super(Y,pe,Be,Oe)}validate(Y){return r.string(Y,this.defaultValue)}}function s(x,Y,pe,Be){return typeof x!="string"?Y:Be&&x in Be?Be[x]:pe.indexOf(x)===-1?Y:x}e.stringSet=s;class i extends f{constructor(Y,pe,Be,Oe,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=Oe,Ye.default=Be),super(Y,pe,Be,Ye),this.c=Oe}validate(Y){return s(Y,this.defaultValue,this.c)}}class o extends k{constructor(Y,pe,Be,Oe,Ye,rt,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=Ye,gt.default=Oe),super(Y,pe,Be,gt),this.c=Ye,this.d=rt}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function y(x){switch(x){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class $ extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",tags:["accessibility"],description:h.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,pe,Be){return Be===0?Y.accessibilitySupport:Be}}class S extends k{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:h.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{insertSpace:t(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(x){x[x.Hidden=0]="Hidden",x[x.Blink=1]="Blink",x[x.Smooth=2]="Smooth",x[x.Phase=3]="Phase",x[x.Expand=4]="Expand",x[x.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function u(x){switch(x){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(x){x[x.Line=1]="Line",x[x.Block=2]="Block",x[x.Underline=3]="Underline",x[x.LineThin=4]="LineThin",x[x.BlockOutline=5]="BlockOutline",x[x.UnderlineThin=6]="UnderlineThin"})(d||(e.TextEditorCursorStyle=d={}));function l(x){switch(x){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function R(x){switch(x){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class B extends m{constructor(){super(140)}compute(Y,pe,Be){const Oe=["monaco-editor"];return pe.get(39)&&Oe.push(pe.get(39)),Y.extraEditorClassName&&Oe.push(Y.extraEditorClassName),pe.get(73)==="default"?Oe.push("mouse-default"):pe.get(73)==="copy"&&Oe.push("mouse-copy"),pe.get(110)&&Oe.push("showUnused"),pe.get(138)&&Oe.push("showDeprecated"),Oe.join(" ")}}class V extends n{constructor(){super(37,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(Y,pe,Be){return Be&&Y.emptySelectionClipboard}}class U extends k{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:h.localize(16,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:h.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{cursorMoveOnType:t(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":s(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":s(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(pe.loop,this.defaultValue.loop)}}}class W extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?W.OFF:Y==="true"?W.ON:Y:Y?W.ON:W.OFF}}e.EditorFontLigatures=W;class N extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:h.localize(22,null)},{type:"string",description:h.localize(23,null)}],description:h.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?N.OFF:Y==="true"?N.TRANSLATE:Y:Y?N.TRANSLATE:N.OFF}compute(Y,pe,Be){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class O extends m{constructor(){super(50)}compute(Y,pe,Be){return Y.fontInfo}}class ee extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(25,null)})}validate(Y){const pe=p.float(Y,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(pe,6,100)}compute(Y,pe,Be){return Y.fontInfo.fontSize}}class Z extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Z.d,maximum:Z.e,errorMessage:h.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(v.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,Z.d,Z.e))}}class ye extends k{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[h.localize(28,null),h.localize(29,null),h.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:h.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:h.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:h.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Be,description:h.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Be,description:h.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Be,description:h.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Be,description:h.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Be,description:h.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{multiple:s(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??s(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??s(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??s(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??s(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??s(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends k{constructor(){const Y={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:h.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:h.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:h.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Y.hidingDelay,description:h.localize(45,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:h.localize(46,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),delay:v.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:t(pe.sticky,this.defaultValue.sticky),hidingDelay:v.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(pe.above,this.defaultValue.above)}}}var Pe;(function(x){x[x.None=0]="None",x[x.Text=1]="Text",x[x.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class X extends m{constructor(){super(143)}compute(Y,pe,Be){return X.computeLayout(pe,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const pe=Y.height/Y.lineHeight,Be=Math.floor(Y.paddingTop/Y.lineHeight);let Oe=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(Oe=Math.max(Oe,pe-1));const Ye=(Be+Y.viewLineCount+Oe)/(Y.pixelRatio*Y.height),rt=Math.floor(Y.viewLineCount/Ye);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Oe,desiredRatio:Ye,minimapLineCount:rt}}static c(Y,pe){const Be=Y.outerWidth,Oe=Y.outerHeight,Ye=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const rt=pe.stableMinimapLayoutInput,gt=rt&&Y.outerHeight===rt.outerHeight&&Y.lineHeight===rt.lineHeight&&Y.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&Y.pixelRatio===rt.pixelRatio&&Y.scrollBeyondLastLine===rt.scrollBeyondLastLine&&Y.paddingTop===rt.paddingTop&&Y.paddingBottom===rt.paddingBottom&&Y.minimap.enabled===rt.minimap.enabled&&Y.minimap.side===rt.minimap.side&&Y.minimap.size===rt.minimap.size&&Y.minimap.showSlider===rt.minimap.showSlider&&Y.minimap.renderCharacters===rt.minimap.renderCharacters&&Y.minimap.maxColumn===rt.minimap.maxColumn&&Y.minimap.scale===rt.minimap.scale&&Y.verticalScrollbarWidth===rt.verticalScrollbarWidth&&Y.isViewportWrapping===rt.isViewportWrapping,yt=Y.lineHeight,Pt=Y.typicalHalfwidthCharacterWidth,Yt=Y.scrollBeyondLastLine,qt=Y.minimap.renderCharacters;let bt=Ye>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Ut=Y.minimap.maxColumn,Ft=Y.minimap.size,jt=Y.minimap.side,At=Y.verticalScrollbarWidth,Rt=Y.viewLineCount,Nt=Y.remainingWidth,Bt=Y.isViewportWrapping,Kt=qt?2:3;let Wt=Math.floor(Ye*Oe);const at=Wt/Ye;let ut=!1,Jt=!1,Ct=Kt*bt,Dt=bt/Ye,ht=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Me,extraLinesBeforeFirstLine:ge,extraLinesBeyondLastLine:J,desiredRatio:Te,minimapLineCount:je}=X.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Yt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:Oe,lineHeight:yt,pixelRatio:Ye});if(Rt/je>1)ut=!0,Jt=!0,bt=1,Ct=1,Dt=bt/Ye;else{let We=!1,et=bt+1;if(Ft==="fit"){const pt=Math.ceil((ge+Rt+J)*Ct);Bt&&gt&&Nt<=pe.stableFitRemainingWidth?(We=!0,et=pe.stableFitMaxMinimapScale):We=pt>Wt}if(Ft==="fill"||We){ut=!0;const pt=bt;Ct=Math.min(yt*Ye,Math.max(1,Math.floor(1/Te))),Bt&&gt&&Nt<=pe.stableFitRemainingWidth&&(et=pe.stableFitMaxMinimapScale),bt=Math.min(et,Math.max(1,Math.floor(Ct/Kt))),bt>pt&&(ht=Math.min(2,bt/pt)),Dt=bt/Ye/ht,Wt=Math.ceil(Math.max(Me,ge+Rt+J)*Ct),Bt?(pe.stableMinimapLayoutInput=Y,pe.stableFitRemainingWidth=Nt,pe.stableFitMaxMinimapScale=bt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const St=Math.floor(Ut*Dt),Lt=Math.min(St,Math.max(0,Math.floor((Nt-At-2)*Dt/(Pt+Dt)))+e.MINIMAP_GUTTER_WIDTH);let Et=Math.floor(Ye*Lt);const qe=Et/Ye;Et=Math.floor(Et*ht);const Ot=qt?1:2,Ce=jt==="left"?0:Be-Lt-At;return{renderMinimap:Ot,minimapLeft:Ce,minimapWidth:Lt,minimapHeightIsEditorHeight:ut,minimapIsSampling:Jt,minimapScale:bt,minimapLineHeight:Ct,minimapCanvasInnerWidth:Et,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:qe,minimapCanvasOuterHeight:at}}static computeLayout(Y,pe){const Be=pe.outerWidth|0,Oe=pe.outerHeight|0,Ye=pe.lineHeight|0,rt=pe.lineNumbersDigitCount|0,gt=pe.typicalHalfwidthCharacterWidth,yt=pe.maxDigitWidth,Pt=pe.pixelRatio,Yt=pe.viewLineCount,qt=Y.get(135),bt=qt==="inherit"?Y.get(134):qt,Ut=bt==="inherit"?Y.get(130):bt,Ft=Y.get(133),jt=pe.isDominatedByLongLines,At=Y.get(57),Rt=Y.get(67).renderType!==0,Nt=Y.get(68),Bt=Y.get(104),Kt=Y.get(83),Wt=Y.get(72),at=Y.get(102),ut=at.verticalScrollbarSize,Jt=at.verticalHasArrows,Ct=at.arrowSize,Dt=at.horizontalScrollbarSize,ht=Y.get(43),St=Y.get(109)!=="never";let Lt=Y.get(65);ht&&St&&(Lt+=16);let Et=0;if(Rt){const dt=Math.max(rt,Nt);Et=Math.round(dt*yt)}let qe=0;At&&(qe=Ye*pe.glyphMarginDecorationLaneCount);let Ot=0,Ce=Ot+qe,Me=Ce+Et,ge=Me+Lt;const J=Be-qe-Et-Lt;let Te=!1,je=!1,Ge=-1;bt==="inherit"&&jt?(Te=!0,je=!0):Ut==="on"||Ut==="bounded"?je=!0:Ut==="wordWrapColumn"&&(Ge=Ft);const We=X.c({outerWidth:Be,outerHeight:Oe,lineHeight:Ye,typicalHalfwidthCharacterWidth:gt,pixelRatio:Pt,scrollBeyondLastLine:Bt,paddingTop:Kt.top,paddingBottom:Kt.bottom,minimap:Wt,verticalScrollbarWidth:ut,viewLineCount:Yt,remainingWidth:J,isViewportWrapping:je},pe.memory||new P);We.renderMinimap!==0&&We.minimapLeft===0&&(Ot+=We.minimapWidth,Ce+=We.minimapWidth,Me+=We.minimapWidth,ge+=We.minimapWidth);const et=J-We.minimapWidth,pt=Math.max(1,Math.floor((et-ut-2)/gt)),vt=Jt?Ct:0;return je&&(Ge=Math.max(1,pt),Ut==="bounded"&&(Ge=Math.min(Ge,Ft))),{width:Be,height:Oe,glyphMarginLeft:Ot,glyphMarginWidth:qe,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Ce,lineNumbersWidth:Et,decorationsLeft:Me,decorationsWidth:Lt,contentLeft:ge,contentWidth:et,minimap:We,viewportColumn:pt,isWordWrapMinified:Te,isViewportWrapping:je,wrappingColumn:Ge,verticalScrollbarWidth:ut,horizontalScrollbarHeight:Dt,overviewRuler:{top:vt,width:ut,height:Oe-2*vt,right:0}}}}e.EditorLayoutInfoComputer=X;class le extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[h.localize(47,null),h.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:h.localize(49,null)}})}validate(Y){return s(Y,"simple",["simple","advanced"])}compute(Y,pe,Be){return pe.get(2)===2?"advanced":Be}}class Ee extends k{constructor(){const Y={enabled:!0};super(64,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:h.localize(50,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:t(Y.enabled,this.defaultValue.enabled)}}}class ce extends k{constructor(){const Y={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:h.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:h.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:h.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Y.scrollWithEditor,description:h.localize(54,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),maxLineCount:v.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class $e extends k{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:h.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[h.localize(56,null),h.localize(57,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),h.localize(58,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),h.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:h.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:h.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:h.localize(62,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:s(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:v.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(pe.fontFamily,this.defaultValue.fontFamily),padding:t(pe.padding,this.defaultValue.padding)}}}class ie extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):v.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,pe,Be){return Be<0?v.clampedInt(-Be*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class z extends p{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>p.clamp(Y,0,150),{markdownDescription:h.localize(63,null)})}compute(Y,pe,Be){return Y.fontInfo.lineHeight}}class q extends k{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:h.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:h.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(66,null),h.localize(67,null),h.localize(68,null)],default:Y.size,description:h.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:h.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:h.localize(71,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:h.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:h.localize(74,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),autohide:t(pe.autohide,this.defaultValue.autohide),size:s(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(pe.side,this.defaultValue.side,["right","left"]),showSlider:s(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(pe.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(pe.scale,1,1,3),maxColumn:v.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ue(x){return x==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class we extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(76,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{top:v.clampedInt(pe.top,0,0,1e3),bottom:v.clampedInt(pe.bottom,0,0,1e3)}}}class ve extends k{constructor(){const Y={enabled:!0,cycle:!0};super(85,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:h.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:h.localize(78,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),cycle:t(pe.cycle,this.defaultValue.cycle)}}}class me extends m{constructor(){super(141)}compute(Y,pe,Be){return Y.pixelRatio}}class ke extends k{constructor(){const Y={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[h.localize(79,null),h.localize(80,null),h.localize(81,null)]}];super(88,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Y.strings,description:h.localize(82,null)},comments:{anyOf:pe,default:Y.comments,description:h.localize(83,null)},other:{anyOf:pe,default:Y.other,description:h.localize(84,null)}},default:Y,markdownDescription:h.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Pt=Y?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:pe,comments:Be,strings:Oe}=Y,Ye=["on","inline","off"];let rt,gt,yt;return typeof pe=="boolean"?rt=pe?"on":"off":rt=s(pe,this.defaultValue.other,Ye),typeof Be=="boolean"?gt=Be?"on":"off":gt=s(Be,this.defaultValue.comments,Ye),typeof Oe=="boolean"?yt=Oe?"on":"off":yt=s(Oe,this.defaultValue.strings,Ye),{other:rt,comments:gt,strings:yt}}}var re;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative",x[x.Interval=3]="Interval",x[x.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class he extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(86,null),h.localize(87,null),h.localize(88,null),h.localize(89,null)],default:"on",description:h.localize(90,null)})}validate(Y){let pe=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(pe=4,Be=Y):Y==="interval"?pe=3:Y==="relative"?pe=2:Y==="on"?pe=1:pe=0),{renderType:pe,renderFn:Be}}}function se(x){const Y=x.get(97);return Y==="editable"?x.get(90):Y!=="on"}e.filterValidationDecorations=se;class oe extends k{constructor(){const Y=[],pe={type:"number",description:h.localize(91,null)};super(101,"rulers",Y,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:h.localize(92,null),format:"color-hex"}}}]},default:Y,description:h.localize(93,null)})}validate(Y){if(Array.isArray(Y)){const pe=[];for(const Be of Y)if(typeof Be=="number")pe.push({column:v.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Oe=Be;pe.push({column:v.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return pe.sort((Be,Oe)=>Be.column-Oe.column),pe}return this.defaultValue}}class de extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function Ie(x,Y){if(typeof x!="string")return Y;switch(x){case"hidden":return 2;case"visible":return 3;default:return 1}}class T extends k{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(94,null),h.localize(95,null),h.localize(96,null)],default:"auto",description:h.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(98,null),h.localize(99,null),h.localize(100,null)],default:"auto",description:h.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:h.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:h.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:h.localize(104,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y,Be=v.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=v.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(pe.vertical,this.defaultValue.vertical),horizontal:Ie(pe.horizontal,this.defaultValue.horizontal),useShadows:t(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:v.clampedInt(pe.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:v.clampedInt(pe.verticalSliderSize,Oe,0,1e3),scrollByPage:t(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends k{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:h.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:h.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:h.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:h.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:h.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:h.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:h.localize(111,null)}})}applyUpdate(Y,pe){let Be=!1;pe.allowedCharacters&&Y&&(M.$3m(Y.allowedCharacters,pe.allowedCharacters)||(Y={...Y,allowedCharacters:pe.allowedCharacters},Be=!0)),pe.allowedLocales&&Y&&(M.$3m(Y.allowedLocales,pe.allowedLocales)||(Y={...Y,allowedLocales:pe.allowedLocales},Be=!0));const Oe=super.applyUpdate(Y,pe);return Be?new a(Oe.newValue,!0):Oe}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{nonBasicASCII:_(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,pe){if(typeof Y!="object"||!Y)return pe;const Be={};for(const[Oe,Ye]of Object.entries(Y))Ye===!0&&(Be[Oe]=!0);return Be}}class G extends k{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:h.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[h.localize(113,null),h.localize(114,null)],description:h.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:h.localize(116,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),mode:s(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends k{constructor(){const Y={enabled:F.$Xr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$Xr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:h.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:h.localize(118,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(119,null),h.localize(120,null),h.localize(121,null)],default:Y.bracketPairs,description:h.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(123,null),h.localize(124,null),h.localize(125,null)],default:Y.bracketPairsHorizontal,description:h.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:h.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:h.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[h.localize(129,null),h.localize(130,null),h.localize(131,null)],default:Y.highlightActiveIndentation,description:h.localize(132,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{bracketPairs:_(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(x,Y,pe){const Be=pe.indexOf(x);return Be===-1?Y:pe[Be]}class ae extends k{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(133,null),h.localize(134,null)],default:Y.insertMode,description:h.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:h.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:h.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:h.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[h.localize(139,null),h.localize(140,null),h.localize(141,null),h.localize(142,null)],default:Y.selectionMode,markdownDescription:h.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:h.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:h.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:h.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:h.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:h.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:h.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(180,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{insertMode:s(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(pe.showIcons,this.defaultValue.showIcons),showStatusBar:t(pe.showStatusBar,this.defaultValue.showStatusBar),preview:t(pe.preview,this.defaultValue.preview),previewMode:s(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(pe.showMethods,this.defaultValue.showMethods),showFunctions:t(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:t(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(pe.showFields,this.defaultValue.showFields),showVariables:t(pe.showVariables,this.defaultValue.showVariables),showClasses:t(pe.showClasses,this.defaultValue.showClasses),showStructs:t(pe.showStructs,this.defaultValue.showStructs),showInterfaces:t(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:t(pe.showModules,this.defaultValue.showModules),showProperties:t(pe.showProperties,this.defaultValue.showProperties),showEvents:t(pe.showEvents,this.defaultValue.showEvents),showOperators:t(pe.showOperators,this.defaultValue.showOperators),showUnits:t(pe.showUnits,this.defaultValue.showUnits),showValues:t(pe.showValues,this.defaultValue.showValues),showConstants:t(pe.showConstants,this.defaultValue.showConstants),showEnums:t(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:t(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(pe.showKeywords,this.defaultValue.showKeywords),showWords:t(pe.showWords,this.defaultValue.showWords),showColors:t(pe.showColors,this.defaultValue.showColors),showFiles:t(pe.showFiles,this.defaultValue.showFiles),showReferences:t(pe.showReferences,this.defaultValue.showReferences),showFolders:t(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:t(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(pe.showSnippets,this.defaultValue.showSnippets),showUsers:t(pe.showUsers,this.defaultValue.showUsers),showIssues:t(pe.showIssues,this.defaultValue.showIssues)}}}class Fe extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:h.localize(182,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Y.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(x){x[x.None=0]="None",x[x.Same=1]="Same",x[x.Indent=2]="Indent",x[x.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Qe extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[h.localize(183,null),h.localize(184,null),h.localize(185,null),h.localize(186,null)],description:h.localize(187,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,pe,Be){return pe.get(2)===2?0:Be}}class Je extends m{constructor(){super(144)}compute(Y,pe,Be){const Oe=pe.get(143);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class xe extends k{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:h.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:h.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[h.localize(190,null),h.localize(191,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),showDropSelector:s(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Xe extends k{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:h.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:h.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[h.localize(194,null),h.localize(195,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const pe=Y;return{enabled:t(pe.enabled,this.defaultValue.enabled),showPasteSelector:s(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const _e="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?it:C.$l?tt:_e,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(x){return e.editorOptionsRegistry[x.id]=x,x}var st;(function(x){x[x.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",x[x.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",x[x.accessibilitySupport=2]="accessibilitySupport",x[x.accessibilityPageSize=3]="accessibilityPageSize",x[x.ariaLabel=4]="ariaLabel",x[x.ariaRequired=5]="ariaRequired",x[x.autoClosingBrackets=6]="autoClosingBrackets",x[x.autoClosingComments=7]="autoClosingComments",x[x.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",x[x.autoClosingDelete=9]="autoClosingDelete",x[x.autoClosingOvertype=10]="autoClosingOvertype",x[x.autoClosingQuotes=11]="autoClosingQuotes",x[x.autoIndent=12]="autoIndent",x[x.automaticLayout=13]="automaticLayout",x[x.autoSurround=14]="autoSurround",x[x.bracketPairColorization=15]="bracketPairColorization",x[x.guides=16]="guides",x[x.codeLens=17]="codeLens",x[x.codeLensFontFamily=18]="codeLensFontFamily",x[x.codeLensFontSize=19]="codeLensFontSize",x[x.colorDecorators=20]="colorDecorators",x[x.colorDecoratorsLimit=21]="colorDecoratorsLimit",x[x.columnSelection=22]="columnSelection",x[x.comments=23]="comments",x[x.contextmenu=24]="contextmenu",x[x.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",x[x.cursorBlinking=26]="cursorBlinking",x[x.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",x[x.cursorStyle=28]="cursorStyle",x[x.cursorSurroundingLines=29]="cursorSurroundingLines",x[x.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",x[x.cursorWidth=31]="cursorWidth",x[x.disableLayerHinting=32]="disableLayerHinting",x[x.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",x[x.domReadOnly=34]="domReadOnly",x[x.dragAndDrop=35]="dragAndDrop",x[x.dropIntoEditor=36]="dropIntoEditor",x[x.emptySelectionClipboard=37]="emptySelectionClipboard",x[x.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",x[x.extraEditorClassName=39]="extraEditorClassName",x[x.fastScrollSensitivity=40]="fastScrollSensitivity",x[x.find=41]="find",x[x.fixedOverflowWidgets=42]="fixedOverflowWidgets",x[x.folding=43]="folding",x[x.foldingStrategy=44]="foldingStrategy",x[x.foldingHighlight=45]="foldingHighlight",x[x.foldingImportsByDefault=46]="foldingImportsByDefault",x[x.foldingMaximumRegions=47]="foldingMaximumRegions",x[x.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",x[x.fontFamily=49]="fontFamily",x[x.fontInfo=50]="fontInfo",x[x.fontLigatures=51]="fontLigatures",x[x.fontSize=52]="fontSize",x[x.fontWeight=53]="fontWeight",x[x.fontVariations=54]="fontVariations",x[x.formatOnPaste=55]="formatOnPaste",x[x.formatOnType=56]="formatOnType",x[x.glyphMargin=57]="glyphMargin",x[x.gotoLocation=58]="gotoLocation",x[x.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",x[x.hover=60]="hover",x[x.inDiffEditor=61]="inDiffEditor",x[x.inlineSuggest=62]="inlineSuggest",x[x.letterSpacing=63]="letterSpacing",x[x.lightbulb=64]="lightbulb",x[x.lineDecorationsWidth=65]="lineDecorationsWidth",x[x.lineHeight=66]="lineHeight",x[x.lineNumbers=67]="lineNumbers",x[x.lineNumbersMinChars=68]="lineNumbersMinChars",x[x.linkedEditing=69]="linkedEditing",x[x.links=70]="links",x[x.matchBrackets=71]="matchBrackets",x[x.minimap=72]="minimap",x[x.mouseStyle=73]="mouseStyle",x[x.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",x[x.mouseWheelZoom=75]="mouseWheelZoom",x[x.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",x[x.multiCursorModifier=77]="multiCursorModifier",x[x.multiCursorPaste=78]="multiCursorPaste",x[x.multiCursorLimit=79]="multiCursorLimit",x[x.occurrencesHighlight=80]="occurrencesHighlight",x[x.overviewRulerBorder=81]="overviewRulerBorder",x[x.overviewRulerLanes=82]="overviewRulerLanes",x[x.padding=83]="padding",x[x.pasteAs=84]="pasteAs",x[x.parameterHints=85]="parameterHints",x[x.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",x[x.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",x[x.quickSuggestions=88]="quickSuggestions",x[x.quickSuggestionsDelay=89]="quickSuggestionsDelay",x[x.readOnly=90]="readOnly",x[x.readOnlyMessage=91]="readOnlyMessage",x[x.renameOnType=92]="renameOnType",x[x.renderControlCharacters=93]="renderControlCharacters",x[x.renderFinalNewline=94]="renderFinalNewline",x[x.renderLineHighlight=95]="renderLineHighlight",x[x.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",x[x.renderValidationDecorations=97]="renderValidationDecorations",x[x.renderWhitespace=98]="renderWhitespace",x[x.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",x[x.roundedSelection=100]="roundedSelection",x[x.rulers=101]="rulers",x[x.scrollbar=102]="scrollbar",x[x.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",x[x.scrollBeyondLastLine=104]="scrollBeyondLastLine",x[x.scrollPredominantAxis=105]="scrollPredominantAxis",x[x.selectionClipboard=106]="selectionClipboard",x[x.selectionHighlight=107]="selectionHighlight",x[x.selectOnLineNumbers=108]="selectOnLineNumbers",x[x.showFoldingControls=109]="showFoldingControls",x[x.showUnused=110]="showUnused",x[x.snippetSuggestions=111]="snippetSuggestions",x[x.smartSelect=112]="smartSelect",x[x.smoothScrolling=113]="smoothScrolling",x[x.stickyScroll=114]="stickyScroll",x[x.stickyTabStops=115]="stickyTabStops",x[x.stopRenderingLineAfter=116]="stopRenderingLineAfter",x[x.suggest=117]="suggest",x[x.suggestFontSize=118]="suggestFontSize",x[x.suggestLineHeight=119]="suggestLineHeight",x[x.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",x[x.suggestSelection=121]="suggestSelection",x[x.tabCompletion=122]="tabCompletion",x[x.tabIndex=123]="tabIndex",x[x.unicodeHighlighting=124]="unicodeHighlighting",x[x.unusualLineTerminators=125]="unusualLineTerminators",x[x.useShadowDOM=126]="useShadowDOM",x[x.useTabStops=127]="useTabStops",x[x.wordBreak=128]="wordBreak",x[x.wordSeparators=129]="wordSeparators",x[x.wordWrap=130]="wordWrap",x[x.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",x[x.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",x[x.wordWrapColumn=133]="wordWrapColumn",x[x.wordWrapOverride1=134]="wordWrapOverride1",x[x.wordWrapOverride2=135]="wordWrapOverride2",x[x.wrappingIndent=136]="wrappingIndent",x[x.wrappingStrategy=137]="wrappingStrategy",x[x.showDeprecated=138]="showDeprecated",x[x.inlayHints=139]="inlayHints",x[x.editorClassName=140]="editorClassName",x[x.pixelRatio=141]="pixelRatio",x[x.tabFocusMode=142]="tabFocusMode",x[x.layoutInfo=143]="layoutInfo",x[x.wrappingInfo=144]="wrappingInfo",x[x.defaultColorDecorators=145]="defaultColorDecorators",x[x.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",x[x.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new n(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(196,null)})),acceptSuggestionOnEnter:ze(new i(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(197,null),""],markdownDescription:h.localize(198,null)})),accessibilitySupport:ze(new $),accessibilityPageSize:ze(new v(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(199,null),tags:["accessibility"]})),ariaLabel:ze(new r(4,"ariaLabel",h.localize(200,null))),ariaRequired:ze(new n(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new n(8,"screenReaderAnnounceInlineSuggestion",!0,{description:h.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:ze(new i(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(202,null),h.localize(203,null),""],description:h.localize(204,null)})),autoClosingComments:ze(new i(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(205,null),h.localize(206,null),""],description:h.localize(207,null)})),autoClosingDelete:ze(new i(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(208,null),""],description:h.localize(209,null)})),autoClosingOvertype:ze(new i(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(210,null),""],description:h.localize(211,null)})),autoClosingQuotes:ze(new i(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(212,null),h.localize(213,null),""],description:h.localize(214,null)})),autoIndent:ze(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[h.localize(215,null),h.localize(216,null),h.localize(217,null),h.localize(218,null),h.localize(219,null)],description:h.localize(220,null)})),automaticLayout:ze(new n(13,"automaticLayout",!1)),autoSurround:ze(new i(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(221,null),h.localize(222,null),h.localize(223,null),""],description:h.localize(224,null)})),bracketPairColorization:ze(new Q),bracketPairGuides:ze(new H),stickyTabStops:ze(new n(115,"stickyTabStops",!1,{description:h.localize(225,null)})),codeLens:ze(new n(17,"codeLens",!0,{description:h.localize(226,null)})),codeLensFontFamily:ze(new r(18,"codeLensFontFamily","",{description:h.localize(227,null)})),codeLensFontSize:ze(new v(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(228,null)})),colorDecorators:ze(new n(20,"colorDecorators",!0,{description:h.localize(229,null)})),colorDecoratorActivatedOn:ze(new i(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[h.localize(230,null),h.localize(231,null),h.localize(232,null)],description:h.localize(233,null)})),colorDecoratorsLimit:ze(new v(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:h.localize(234,null)})),columnSelection:ze(new n(22,"columnSelection",!1,{description:h.localize(235,null)})),comments:ze(new S),contextmenu:ze(new n(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new n(25,"copyWithSyntaxHighlighting",!0,{description:h.localize(236,null)})),cursorBlinking:ze(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:h.localize(237,null)})),cursorSmoothCaretAnimation:ze(new i(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[h.localize(238,null),h.localize(239,null),h.localize(240,null)],description:h.localize(241,null)})),cursorStyle:ze(new o(28,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:h.localize(242,null)})),cursorSurroundingLines:ze(new v(29,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(243,null)})),cursorSurroundingLinesStyle:ze(new i(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(244,null),h.localize(245,null)],markdownDescription:h.localize(246,null)})),cursorWidth:ze(new v(31,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(247,null)})),disableLayerHinting:ze(new n(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new n(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new n(34,"domReadOnly",!1)),dragAndDrop:ze(new n(35,"dragAndDrop",!0,{description:h.localize(248,null)})),emptySelectionClipboard:ze(new V),dropIntoEditor:ze(new xe),stickyScroll:ze(new ce),experimentalWhitespaceRendering:ze(new i(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[h.localize(249,null),h.localize(250,null),h.localize(251,null)],description:h.localize(252,null)})),extraEditorClassName:ze(new r(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new p(40,"fastScrollSensitivity",5,x=>x<=0?5:x,{markdownDescription:h.localize(253,null)})),find:ze(new U),fixedOverflowWidgets:ze(new n(42,"fixedOverflowWidgets",!1)),folding:ze(new n(43,"folding",!0,{description:h.localize(254,null)})),foldingStrategy:ze(new i(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(255,null),h.localize(256,null)],description:h.localize(257,null)})),foldingHighlight:ze(new n(45,"foldingHighlight",!0,{description:h.localize(258,null)})),foldingImportsByDefault:ze(new n(46,"foldingImportsByDefault",!1,{description:h.localize(259,null)})),foldingMaximumRegions:ze(new v(47,"foldingMaximumRegions",5e3,10,65e3,{description:h.localize(260,null)})),unfoldOnClickAfterEndOfLine:ze(new n(48,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(261,null)})),fontFamily:ze(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(262,null)})),fontInfo:ze(new O),fontLigatures2:ze(new W),fontSize:ze(new ee),fontWeight:ze(new Z),fontVariations:ze(new N),formatOnPaste:ze(new n(55,"formatOnPaste",!1,{description:h.localize(263,null)})),formatOnType:ze(new n(56,"formatOnType",!1,{description:h.localize(264,null)})),glyphMargin:ze(new n(57,"glyphMargin",!0,{description:h.localize(265,null)})),gotoLocation:ze(new ye),hideCursorInOverviewRuler:ze(new n(59,"hideCursorInOverviewRuler",!1,{description:h.localize(266,null)})),hover:ze(new De),inDiffEditor:ze(new n(61,"inDiffEditor",!1)),letterSpacing:ze(new p(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,x=>p.clamp(x,-5,20),{description:h.localize(267,null)})),lightbulb:ze(new Ee),lineDecorationsWidth:ze(new ie),lineHeight:ze(new z),lineNumbers:ze(new he),lineNumbersMinChars:ze(new v(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new n(69,"linkedEditing",!1,{description:h.localize(268,null)})),links:ze(new n(70,"links",!0,{description:h.localize(269,null)})),matchBrackets:ze(new i(71,"matchBrackets","always",["always","near","never"],{description:h.localize(270,null)})),minimap:ze(new q),mouseStyle:ze(new i(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new p(74,"mouseWheelScrollSensitivity",1,x=>x===0?1:x,{markdownDescription:h.localize(271,null)})),mouseWheelZoom:ze(new n(75,"mouseWheelZoom",!1,{markdownDescription:h.localize(272,null)})),multiCursorMergeOverlapping:ze(new n(76,"multiCursorMergeOverlapping",!0,{description:h.localize(273,null)})),multiCursorModifier:ze(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[h.localize(274,null),h.localize(275,null)],markdownDescription:h.localize(276,null)})),multiCursorPaste:ze(new i(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(277,null),h.localize(278,null)],markdownDescription:h.localize(279,null)})),multiCursorLimit:ze(new v(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:h.localize(280,null)})),occurrencesHighlight:ze(new n(80,"occurrencesHighlight",!0,{description:h.localize(281,null)})),overviewRulerBorder:ze(new n(81,"overviewRulerBorder",!0,{description:h.localize(282,null)})),overviewRulerLanes:ze(new v(82,"overviewRulerLanes",3,0,3)),padding:ze(new we),pasteAs:ze(new Xe),parameterHints:ze(new ve),peekWidgetDefaultFocus:ze(new i(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(283,null),h.localize(284,null)],description:h.localize(285,null)})),definitionLinkOpensInPeek:ze(new n(87,"definitionLinkOpensInPeek",!1,{description:h.localize(286,null)})),quickSuggestions:ze(new ke),quickSuggestionsDelay:ze(new v(89,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(287,null)})),readOnly:ze(new n(90,"readOnly",!1)),readOnlyMessage:ze(new de),renameOnType:ze(new n(92,"renameOnType",!1,{description:h.localize(288,null),markdownDeprecationMessage:h.localize(289,null)})),renderControlCharacters:ze(new n(93,"renderControlCharacters",!0,{description:h.localize(290,null),restricted:!0})),renderFinalNewline:ze(new i(94,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:h.localize(291,null)})),renderLineHighlight:ze(new i(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(292,null)],description:h.localize(293,null)})),renderLineHighlightOnlyWhenFocus:ze(new n(96,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(294,null)})),renderValidationDecorations:ze(new i(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new i(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(295,null),h.localize(296,null),h.localize(297,null),""],description:h.localize(298,null)})),revealHorizontalRightPadding:ze(new v(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new n(100,"roundedSelection",!0,{description:h.localize(299,null)})),rulers:ze(new oe),scrollbar:ze(new T),scrollBeyondLastColumn:ze(new v(103,"scrollBeyondLastColumn",4,0,1073741824,{description:h.localize(300,null)})),scrollBeyondLastLine:ze(new n(104,"scrollBeyondLastLine",!0,{description:h.localize(301,null)})),scrollPredominantAxis:ze(new n(105,"scrollPredominantAxis",!0,{description:h.localize(302,null)})),selectionClipboard:ze(new n(106,"selectionClipboard",!0,{description:h.localize(303,null),included:C.$l})),selectionHighlight:ze(new n(107,"selectionHighlight",!0,{description:h.localize(304,null)})),selectOnLineNumbers:ze(new n(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new i(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[h.localize(305,null),h.localize(306,null),h.localize(307,null)],description:h.localize(308,null)})),showUnused:ze(new n(110,"showUnused",!0,{description:h.localize(309,null)})),showDeprecated:ze(new n(138,"showDeprecated",!0,{description:h.localize(310,null)})),inlayHints:ze(new $e),snippetSuggestions:ze(new i(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(311,null),h.localize(312,null),h.localize(313,null),h.localize(314,null)],description:h.localize(315,null)})),smartSelect:ze(new Fe),smoothScrolling:ze(new n(113,"smoothScrolling",!1,{description:h.localize(316,null)})),stopRenderingLineAfter:ze(new v(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ae),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new n(147,"inlineCompletionsAccessibilityVerbose",!1,{description:h.localize(317,null)})),suggestFontSize:ze(new v(118,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new v(119,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new n(120,"suggestOnTriggerCharacters",!0,{description:h.localize(320,null)})),suggestSelection:ze(new i(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(321,null),h.localize(322,null),h.localize(323,null)],description:h.localize(324,null)})),tabCompletion:ze(new i(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(325,null),h.localize(326,null),h.localize(327,null)],description:h.localize(328,null)})),tabIndex:ze(new v(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new K),unusualLineTerminators:ze(new i(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(329,null),h.localize(330,null),h.localize(331,null)],description:h.localize(332,null)})),useShadowDOM:ze(new n(126,"useShadowDOM",!0)),useTabStops:ze(new n(127,"useTabStops",!0,{description:h.localize(333,null)})),wordBreak:ze(new i(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[h.localize(334,null),h.localize(335,null)],description:h.localize(336,null)})),wordSeparators:ze(new r(129,"wordSeparators",A.$Yr,{description:h.localize(337,null)})),wordWrap:ze(new i(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(338,null),h.localize(339,null),h.localize(340,null),h.localize(341,null)],description:h.localize(342,null)})),wordWrapBreakAfterCharacters:ze(new r(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new r(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new v(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(343,null)})),wordWrapOverride1:ze(new i(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new i(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new B),defaultColorDecorators:ze(new n(145,"defaultColorDecorators",!1,{markdownDescription:h.localize(344,null)})),pixelRatio:ze(new me),tabFocusMode:ze(new n(142,"tabFocusMode",!1,{markdownDescription:h.localize(345,null)})),layoutInfo:ze(new X),wrappingInfo:ze(new Je),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new le)}}),define(Ae[137],Re([10,11]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([10,11]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([10,11]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([10,11]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([10,11]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([10,11]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([10,11]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[148],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[149],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[150],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[151],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[152],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[153],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[154],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[155],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[156],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[157],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[158],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[159],Re([10,11]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Ae[160],Re([10,11]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Ae[161],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[162],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[163],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[164],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[165],Re([10,11]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[166],Re([10,11]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[167],Re([10,11]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[168],Re([1,0,9,139]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var C;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(C||(e.TokenType=C={}));function F(...g){switch(g.length){case 1:return(0,M.localize)(0,null,g[0]);case 2:return(0,M.localize)(1,null,g[0],g[1]);case 3:return(0,M.localize)(2,null,g[0],g[1],g[2]);default:return}}const A=(0,M.localize)(3,null),h=(0,M.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,w.$7)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const k=this.d,a=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:a};this.g.push({offset:k,lexeme:a,additionalInfo:P}),this.f.push(b)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const k=this.c.substring(this.d,this.e),a=E.b.get(k);a?this.k(a):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,k=!1,a=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(h);return}const m=this.c.charCodeAt(P);if(k)k=!1;else if(m===47&&!a){P++;break}else m===91?a=!0:m===92?k=!0:m===93&&(a=!1);P++}for(;P<this.c.length&&E.a.has(this.c.charCodeAt(P));)P++;this.e=P;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=E}),define(Ae[169],Re([1,0,23,29,141,276]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,h=/^-(\d{4})(\d{2})(\d{2})$/;function E(n){return n=n.trim(),n==="*"||A.test(n)}e.$Eo=E;function g(n){if(!E(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=n.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$Fo=g;function P(n){if(!n)return null;const c=n.majorBase,v=n.majorMustEqual,D=n.minorBase;let p=n.minorMustEqual;const r=n.patchBase;let s=n.patchMustEqual;n.hasCaret&&(c===0||(p=!1),s=!1);let i=0;if(n.preRelease){const o=h.exec(n.preRelease);if(o){const[,y,$,S]=o;i=Date.UTC(Number(y),Number($)-1,Number(S))}}return{majorBase:c,majorMustEqual:v,minorBase:D,minorMustEqual:p,patchBase:r,patchMustEqual:s,isMinimum:n.hasGreaterEquals,notBefore:i}}e.$Go=P;function k(n,c,v){let D;typeof n=="string"?D=P(g(n)):D=n;let p;c instanceof Date?p=c.getTime():typeof c=="string"&&(p=new Date(c).getTime());let r;if(typeof v=="string"?r=P(g(v)):r=v,!D||!r)return!1;const s=D.majorBase,i=D.minorBase,o=D.patchBase;let y=r.majorBase,$=r.minorBase,S=r.patchBase;const I=r.notBefore;let u=r.majorMustEqual,d=r.minorMustEqual,l=r.patchMustEqual;return r.isMinimum?s>y?!0:s<y?!1:i>$?!0:i<$||p&&p<I?!1:o>=S:(s===1&&y===0&&(!u||!d||!l)&&(y=1,$=0,S=0,u=!0,d=!1,l=!1),s<y?!1:s>y?!u:i<$?!1:i>$?!d:o<S?!1:o>S?!l:!(p&&p<I))}e.$Ho=k;function a(n,c,v,D,p){const r=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return r.push([M.default.Error,C.localize(0,null)]),r;if(typeof D.name!="string")return r.push([M.default.Error,C.localize(1,null,"name")]),r;if(typeof D.version!="string")return r.push([M.default.Error,C.localize(2,null,"version")]),r;if(!D.engines)return r.push([M.default.Error,C.localize(3,null,"engines")]),r;if(typeof D.engines.vscode!="string")return r.push([M.default.Error,C.localize(4,null,"engines.vscode")]),r;if(typeof D.extensionDependencies<"u"&&!t(D.extensionDependencies))return r.push([M.default.Error,C.localize(5,null,"extensionDependencies")]),r;if(typeof D.activationEvents<"u"){if(!t(D.activationEvents))return r.push([M.default.Error,C.localize(6,null,"activationEvents")]),r;if(typeof D.main>"u"&&typeof D.browser>"u")return r.push([M.default.Error,C.localize(7,null,"activationEvents","main","browser")]),r}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&r.push([M.default.Warning,C.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return r.push([M.default.Error,C.localize(9,null,"main")]),r;{const o=(0,w.$ug)(v,D.main);(0,w.$og)(o,v)||r.push([M.default.Warning,C.localize(10,null,o.path,v.path)])}}if(typeof D.browser<"u"){if(typeof D.browser!="string")return r.push([M.default.Error,C.localize(11,null,"browser")]),r;{const o=(0,w.$ug)(v,D.browser);(0,w.$og)(o,v)||r.push([M.default.Warning,C.localize(12,null,o.path,v.path)])}}if(!F.valid(D.version))return r.push([M.default.Error,C.localize(13,null)]),r;const s=[];if(!b(n,c,D,p,s))for(const o of s)r.push([M.default.Error,o]);return r}e.$Io=a;function b(n,c,v,D,p){return D||typeof v.main>"u"&&typeof v.browser>"u"?!0:f(n,c,v.engines.vscode,p)}e.$Jo=b;function m(n,c,v){return n==="*"||f(c,v,n)}e.$Ko=m;function f(n,c,v,D=[]){const p=P(g(v));if(!p)return D.push(C.localize(14,null,v)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return D.push(C.localize(15,null,v)),!1}else if(!p.majorMustEqual)return D.push(C.localize(16,null,v)),!1;return k(n,c,p)?!0:(D.push(C.localize(17,null,n,v)),!1)}function t(n){if(!Array.isArray(n))return!1;for(let c=0,v=n.length;c<v;c++)if(typeof n[c]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class w{constructor(C,F=[],A=!1){this.ctor=C,this.staticArguments=F,this.supportsDelayedInstantiation=A}}e.$Kh=w}),define(Ae[70],Re([1,0,69]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=e.InstantiationType=void 0;const M=[];var C;(function(h){h[h.Eager=0]="Eager",h[h.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function F(h,E,g){E instanceof w.$Kh||(E=new w.$Kh(E,[],!!g)),M.push([h,E])}e.$pr=F;function A(){return M}e.$qr=A}),define(Ae[170],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0;class w{constructor(F,A){this.key=F,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$7p=w;class M{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const A of this.a.values())A.outgoing.size===0&&F.push(A);return F}insertEdge(F,A){const h=this.lookupOrInsertNode(F),E=this.lookupOrInsertNode(A);h.outgoing.set(E.key,E),E.incoming.set(h.key,h)}removeNode(F){const A=this.b(F);this.a.delete(A);for(const h of this.a.values())h.outgoing.delete(A),h.incoming.delete(A)}lookupOrInsertNode(F){const A=this.b(F);let h=this.a.get(A);return h||(h=new w(A,F),this.a.set(A,h)),h}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[A,h]of this.a)F.push(`${A}
	(-> incoming)[${[...h.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...h.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,A]of this.a){const h=new Set([F]),E=this.c(A,h);if(E)return E}}c(F,A){for(const[h,E]of F.outgoing){if(A.has(h))return[...A,h].join(" -> ");A.add(h);const g=this.c(E,A);if(g)return g;A.delete(h)}}}e.$8p=M}),define(Ae[4],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e._util=void 0;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function h(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=h})(w||(e._util=w={})),e.$Mh=C("instantiationService");function M(A,h,E){h[w.DI_TARGET]===h?h[w.DI_DEPENDENCIES].push({id:A,index:E}):(h[w.DI_DEPENDENCIES]=[{id:A,index:E}],h[w.DI_TARGET]=h)}function C(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const h=function(E,g,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(h,E,P)};return h.toString=()=>A,w.serviceIds.set(A,h),h}e.$Nh=C;function F(A){return A}e.$Oh=F}),define(Ae[43],Re([1,0,16,2,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,C.$Nh)("configurationService");function F(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof M.URI)}e.$ii=F;function A(n){return n&&typeof n=="object"&&(!n.overrideIdentifiers||Array.isArray(n.overrideIdentifiers))&&!n.overrideIdentifier&&(!n.resource||n.resource instanceof M.URI)}e.$ji=A;var h;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.USER=2]="USER",n[n.USER_LOCAL=3]="USER_LOCAL",n[n.USER_REMOTE=4]="USER_REMOTE",n[n.WORKSPACE=5]="WORKSPACE",n[n.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",n[n.DEFAULT=7]="DEFAULT",n[n.MEMORY=8]="MEMORY"})(h||(e.ConfigurationTarget=h={}));function E(n){switch(n){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=E;function g(n){return n.applicationValue!==void 0||n.userValue!==void 0||n.userLocalValue!==void 0||n.userRemoteValue!==void 0||n.workspaceValue!==void 0||n.workspaceFolderValue!==void 0}e.$li=g;function P(n,c){const v=Object.create(null);for(const D in n)k(v,D,n[D],c);return v}e.$mi=P;function k(n,c,v,D){const p=c.split("."),r=p.pop();let s=n;for(let i=0;i<p.length;i++){const o=p[i];let y=s[o];switch(typeof y){case"undefined":y=s[o]=Object.create(null);break;case"object":break;default:D(`Ignoring ${c} as ${p.slice(0,i+1).join(".")} is ${JSON.stringify(y)}`);return}s=y}if(typeof s=="object"&&s!==null)try{s[r]=v}catch{D(`Ignoring ${c} as ${p.join(".")} is ${JSON.stringify(s)}`)}else D(`Ignoring ${c} as ${p.join(".")} is ${JSON.stringify(s)}`)}e.$ni=k;function a(n,c){const v=c.split(".");b(n,v)}e.$oi=a;function b(n,c){const v=c.shift();if(c.length===0){delete n[v];return}if(Object.keys(n).indexOf(v)!==-1){const D=n[v];typeof D=="object"&&!Array.isArray(D)&&(b(D,c),Object.keys(D).length===0&&delete n[v])}}function m(n,c,v){function D(s,i){let o=s;for(const y of i){if(typeof o!="object"||o===null)return;o=o[y]}return o}const p=c.split("."),r=D(n,p);return typeof r>"u"?v:r}e.$pi=m;function f(n,c,v){Object.keys(c).forEach(D=>{D!=="__proto__"&&(D in n?w.$zf(n[D])&&w.$zf(c[D])?f(n[D],c[D],v):v&&(n[D]=c[D]):n[D]=c[D])})}e.$qi=f;function t(n){return n.replace(/[\[\]]/g,"")}e.$ri=t}),define(Ae[32],Re([1,0,22,15,168,4,138,9]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",w.$k),E.set("isLinux",w.$l),E.set("isWindows",w.$j),E.set("isWeb",w.$p),E.set("isMacNative",w.$k&&!w.$p),E.set("isEdge",w.$H),E.set("isFirefox",w.$F),E.set("isChrome",w.$E),E.set("isSafari",w.$G);function g(ie,z){if(E.get(ie)!==void 0)throw(0,h.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(ie,z)}e.$Ji=g;const P=Object.prototype.hasOwnProperty;var k;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const a={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),m=(0,A.localize)(1,null),f=(0,A.localize)(2,null),t=(0,A.localize)(3,null),n=(0,A.localize)(4,null),c=(0,A.localize)(5,null),v=(0,A.localize)(6,null),D=(0,A.localize)(7,null);class p{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=a){this.k=z,this.d=new C.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const ue=this.D(),we=ue.type===17?c:void 0;throw this.h.push({message:n,offset:ue.offset,lexeme:C.$Ii.getLexeme(ue),additionalInfo:we}),p.c}return q}catch(q){if(q!==p.c)throw q;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const q=this.o();z.push(q)}return z.length===1?z[0]:r.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const q=this.s();z.push(q)}return z.length===1?z[0]:r.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),y.INSTANCE;case 12:return this.z(),$.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,t),q?.negate()}case 17:return this.z(),R.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const q=this.l();return this.A(1,t),q}case 17:{const q=z.lexeme;if(this.z(),this.y(9)){const we=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),we.type!==10)throw this.B("REGEX",we);const ve=we.lexeme,me=ve.lastIndexOf("/"),ke=me===ve.length-1?void 0:this.w(ve.substring(me+1));let re;try{re=new RegExp(ve.substring(1,me),ke)}catch{throw this.B("REGEX",we)}return O.create(q,re)}switch(we.type){case 10:case 19:{const ve=[we.lexeme];this.z();let me=this.D(),ke=0;for(let de=0;de<we.lexeme.length;de++)we.lexeme.charCodeAt(de)===40?ke++:we.lexeme.charCodeAt(de)===41&&ke--;for(;!this.E()&&me.type!==15&&me.type!==16;){switch(me.type){case 0:ke++;break;case 1:ke--;break;case 10:case 18:for(let de=0;de<me.lexeme.length;de++)me.lexeme.charCodeAt(de)===40?ke++:we.lexeme.charCodeAt(de)===41&&ke--}if(ke<0)break;ve.push(C.$Ii.getLexeme(me)),this.z(),me=this.D()}const re=ve.join(""),he=re.lastIndexOf("/"),se=he===re.length-1?void 0:this.w(re.substring(he+1));let oe;try{oe=new RegExp(re.substring(1,he),se)}catch{throw this.B("REGEX",we)}return r.regex(q,oe)}case 18:{const ve=we.lexeme;this.z();let me=null;if(!(0,M.$Ae)(ve)){const ke=ve.indexOf("/"),re=ve.lastIndexOf("/");if(ke!==re&&ke>=0){const he=ve.slice(ke+1,re),se=ve[re+1]==="i"?"i":"";try{me=new RegExp(he,se)}catch{throw this.B("REGEX",we)}}}if(me===null)throw this.B("REGEX",we);return O.create(q,me)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const we=this.u();return r.notIn(q,we)}switch(this.D().type){case 3:{this.z();const we=this.u();if(this.x().type===18)return r.equals(q,we);switch(we){case"true":return r.has(q);case"false":return r.not(q);default:return r.equals(q,we)}}case 4:{this.z();const we=this.u();if(this.x().type===18)return r.notEquals(q,we);switch(we){case"true":return r.not(q);case"false":return r.has(q);default:return r.notEquals(q,we)}}case 5:return this.z(),W.create(q,this.u());case 6:return this.z(),N.create(q,this.u());case 7:return this.z(),V.create(q,this.u());case 8:return this.z(),U.create(q,this.u());case 13:return this.z(),r.in(q,this.u());default:return r.has(q)}}case 20:throw this.h.push({message:v,offset:z.offset,lexeme:"",additionalInfo:D}),p.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,q){if(this.C(z))return this.z();throw this.B(q,this.D())}B(z,q,ue){const we=(0,A.localize)(8,null,z,C.$Ii.getLexeme(q)),ve=q.offset,me=C.$Ii.getLexeme(q);return this.h.push({message:we,offset:ve,lexeme:me,additionalInfo:ue}),p.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=p;class r{static false(){return y.INSTANCE}static true(){return $.INSTANCE}static has(z){return S.create(z)}static equals(z,q){return I.create(z,q)}static notEquals(z,q){return l.create(z,q)}static regex(z,q){return O.create(z,q)}static in(z,q){return u.create(z,q)}static notIn(z,q){return d.create(z,q)}static not(z){return R.create(z)}static and(...z){return ye.create(z,null,!0)}static or(...z){return De.create(z,null,!0)}static greater(z,q){return V.create(z,q)}static greaterEquals(z,q){return U.create(z,q)}static smaller(z,q){return W.create(z,q)}static smallerEquals(z,q){return N.create(z,q)}static{this.c=new p({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Li=r;function s(ie){const z=new p({regexParsingWithErrorRecovery:!1});return ie.map(q=>(z.parse(q),z.lexingErrors.length>0?z.lexingErrors.map(ue=>({errorMessage:ue.additionalInfo?(0,A.localize)(9,null,ue.additionalInfo):(0,A.localize)(10,null),offset:ue.offset,length:ue.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(ue=>({errorMessage:ue.additionalInfo?`${ue.message}. ${ue.additionalInfo}`:ue.message,offset:ue.offset,length:ue.lexeme.length})):[]))}e.$Mi=s;function i(ie,z){const q=ie?ie.substituteConstants():void 0,ue=z?z.substituteConstants():void 0;return!q&&!ue?!0:!q||!ue?!1:q.equals(ue)}e.$Ni=i;function o(ie,z){return ie.cmp(z)}class y{static{this.INSTANCE=new y}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return $.INSTANCE}}e.$Oi=y;class ${static{this.INSTANCE=new $}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return y.INSTANCE}}e.$Pi=$;class S{static create(z,q=null){const ue=E.get(z);return typeof ue=="boolean"?ue?$.INSTANCE:y.INSTANCE:new S(z,q)}constructor(z,q){this.key=z,this.c=q,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:X(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=E.get(this.key);return typeof z=="boolean"?z?$.INSTANCE:y.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$Qi=S;class I{static create(z,q,ue=null){if(typeof q=="boolean")return q?S.create(z,ue):R.create(z,ue);const we=E.get(z);return typeof we=="boolean"?q===(we?"true":"false")?$.INSTANCE:y.INSTANCE:new I(z,q,ue)}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=E.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?$.INSTANCE:y.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.$Ri=I;class u{static create(z,q){return new u(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:le(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.f),ue=z.getValue(this.d);return Array.isArray(q)?q.includes(ue):typeof ue=="string"&&typeof q=="object"&&q!==null?P.call(q,ue):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.$Si=u;class d{static create(z,q){return new d(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=11,this.c=u.create(z,q)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=d;class l{static create(z,q,ue=null){if(typeof q=="boolean")return q?R.create(z,ue):S.create(z,ue);const we=E.get(z);return typeof we=="boolean"?q===(we?"true":"false")?y.INSTANCE:$.INSTANCE:new l(z,q,ue)}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=E.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?y.INSTANCE:$.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ui=l;class R{static create(z,q=null){const ue=E.get(z);return typeof ue=="boolean"?ue?y.INSTANCE:$.INSTANCE:new R(z,q)}constructor(z,q){this.c=z,this.d=q,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:X(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=E.get(this.c);return typeof z=="boolean"?z?y.INSTANCE:$.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$Vi=R;function B(ie,z){if(typeof ie=="string"){const q=parseFloat(ie);isNaN(q)||(ie=q)}return typeof ie=="string"||typeof ie=="number"?z(ie):y.INSTANCE}class V{static create(z,q,ue=null){return B(q,we=>new V(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Wi=V;class U{static create(z,q,ue=null){return B(q,we=>new U(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Xi=U;class W{static create(z,q,ue=null){return B(q,we=>new W(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Yi=W;class N{static create(z,q,ue=null){return B(q,we=>new N(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Zi=N;class O{static create(z,q){return new O(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const q=this.f?this.f.source:"",ue=z.f?z.f.source:"";return q<ue?-1:q>ue?1:0}equals(z){if(z.type===this.type){const q=this.f?this.f.source:"",ue=z.f?z.f.source:"";return this.d===z.d&&q===ue}return!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$1i=O;class ee{static create(z){return new ee(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new ee(this.c.map(z))}negate(){return this.c}}e.$2i=ee;function Z(ie){let z=null;for(let q=0,ue=ie.length;q<ue;q++){const we=ie[q].substituteConstants();if(ie[q]!==we&&z===null){z=[];for(let ve=0;ve<q;ve++)z[ve]=ie[ve]}z!==null&&(z[q]=we)}return z===null?ie:z}class ye{static create(z,q,ue){return ye.d(z,q,ue)}constructor(z,q){this.expr=z,this.c=q,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,ue=this.expr.length;q<ue;q++){const we=o(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=Z(this.expr);return z===this.expr?this:ye.create(z,this.c,!1)}evaluate(z){for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].evaluate(z))return!1;return!0}static d(z,q,ue){const we=[];let ve=!1;for(const me of z)if(me){if(me.type===1){ve=!0;continue}if(me.type===0)return y.INSTANCE;if(me.type===6){we.push(...me.expr);continue}we.push(me)}if(we.length===0&&ve)return $.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(o);for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];for(;we.length>1;){const me=we[we.length-1];if(me.type!==9)break;we.pop();const ke=we.pop(),re=we.length===0,he=De.create(me.expr.map(se=>ye.create([se,ke],null,ue)),null,re);he&&(we.push(he),we.sort(o))}if(we.length===1)return we[0];if(ue){for(let me=0;me<we.length;me++)for(let ke=me+1;ke<we.length;ke++)if(we[me].negate().equals(we[ke]))return y.INSTANCE;if(we.length===1)return we[0]}return new ye(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new ye(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());this.c=De.create(z,this,!0)}return this.c}}e.$3i=ye;class De{static create(z,q,ue){return De.d(z,q,ue)}constructor(z,q){this.expr=z,this.c=q,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,ue=this.expr.length;q<ue;q++){const we=o(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=Z(this.expr);return z===this.expr?this:De.create(z,this.c,!1)}evaluate(z){for(let q=0,ue=this.expr.length;q<ue;q++)if(this.expr[q].evaluate(z))return!0;return!1}static d(z,q,ue){let we=[],ve=!1;if(z){for(let me=0,ke=z.length;me<ke;me++){const re=z[me];if(re){if(re.type===0){ve=!0;continue}if(re.type===1)return $.INSTANCE;if(re.type===9){we=we.concat(re.expr);continue}we.push(re)}}if(we.length===0&&ve)return y.INSTANCE;we.sort(o)}if(we.length!==0){if(we.length===1)return we[0];for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];if(ue){for(let me=0;me<we.length;me++)for(let ke=me+1;ke<we.length;ke++)if(we[me].negate().equals(we[ke]))return $.INSTANCE;if(we.length===1)return we[0]}return new De(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new De(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());for(;z.length>1;){const q=z.shift(),ue=z.shift(),we=[];for(const ve of $e(q))for(const me of $e(ue))we.push(ye.create([ve,me],null,!1));z.unshift(De.create(we,null,!1))}this.c=De.create(z,this,!0)}return this.c}}e.$4i=De;class Pe extends S{static{this.d=[]}static all(){return Pe.d.values()}constructor(z,q,ue){super(z,null),this.f=q,typeof ue=="object"?Pe.d.push({...ue,key:z}):ue!==!0&&Pe.d.push({key:z,description:ue,type:q!=null?typeof q:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return I.create(this.key,z)}notEqualsTo(z){return l.create(this.key,z)}}e.$5i=Pe,e.$6i=(0,F.$Nh)("contextKeyService");function X(ie,z){return ie<z?-1:ie>z?1:0}function le(ie,z,q,ue){return ie<q?-1:ie>q?1:z<ue?-1:z>ue?1:0}function Ee(ie,z){if(ie.type===0||z.type===1)return!0;if(ie.type===9)return z.type===9?ce(ie.expr,z.expr):!1;if(z.type===9){for(const q of z.expr)if(Ee(ie,q))return!0;return!1}if(ie.type===6){if(z.type===6)return ce(z.expr,ie.expr);for(const q of ie.expr)if(Ee(q,z))return!0;return!1}return ie.equals(z)}e.$7i=Ee;function ce(ie,z){let q=0,ue=0;for(;q<ie.length&&ue<z.length;){const we=ie[q].cmp(z[ue]);if(we<0)return!1;we===0&&q++,ue++}return q===ie.length}function $e(ie){return ie.type===9?ie.expr:[ie]}}),define(Ae[171],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,w.$Nh)("environmentService"),e.$Vh=(0,w.$Oh)(e.$Uh)}),define(Ae[92],Re([1,0,140,4]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$3n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=void 0,e.$Pn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Qn=new RegExp(e.$Pn),e.$Rn="__web_extension",e.$Sn="skipWalkthrough",e.$Tn="extensionsSync",e.$Un="dependecyOrPackExtensionInstall";function C(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Vn=C;function F(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Wn=F;function A(c,v){switch(c){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Xn=A;function h(c,v){return v==="web"&&!c.includes("web")}e.$Yn=h;function E(c,v,D){return h(v,D)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===D?!0:g(D).includes(c)}e.$Zn=E;function g(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$1n=g;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$2n=P;var k;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var a;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var b;(function(c){c.Install="install",c.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var m;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$3n=(0,M.$Nh)("extensionGalleryService");var f;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class n extends Error{constructor(v,D){super(v),this.code=D,this.name=D}}e.$4n=n,e.$5n=(0,M.$Nh)("extensionManagementService"),e.$6n="extensionsIdentifiers/disabled",e.$7n="extensionsIdentifiers/enabled",e.$8n=(0,M.$Nh)("IGlobalExtensionEnablementService"),e.$9n=(0,M.$Nh)("IExtensionTipsService"),e.$0n=(0,w.localize)(0,null),e.$$n={value:e.$0n,original:"Extensions"},e.$_n={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Ae[38],Re([1,0,49,19,15,16,2,142,4,22,12]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.FileKind=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileOperationResult=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileChangeType=e.$nk=e.FileOperation=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderErrorCode=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$0j=e.$9j=void 0,e.$9j=(0,E.$Nh)("fileService");function k(X){return X.create===!0}e.$0j=k;var a;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(a||(e.FileType=a={}));var b;(function(X){X[X.Readonly=1]="Readonly",X[X.Locked=2]="Locked"})(b||(e.FilePermission=b={}));var m;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileAtomicWrite=32768]="FileAtomicWrite",X[X.FileAtomicDelete=65536]="FileAtomicDelete",X[X.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function f(X){return!!(X.capabilities&2)}e.$$j=f;function t(X){return!!(X.capabilities&8)}e.$_j=t;function n(X){return!!(X.capabilities&131072)}e.$ak=n;function c(X){return!!(X.capabilities&4)}e.$bk=c;function v(X){return!!(X.capabilities&16)}e.$ck=v;function D(X){return f(X)?!!(X.capabilities&16384):!1}e.$dk=D;function p(X){return f(X)?!!(X.capabilities&32768):!1}e.$ek=p;function r(X){return!!(X.capabilities&65536)}e.$fk=r;function s(X){return!!(X.capabilities&2048)}e.$gk=s;var i;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsStorageQuota="EntryExceedsStorageQuota",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(i||(e.FileSystemProviderErrorCode=i={}));class o extends Error{static create(le,Ee){const ce=new o(le.toString(),Ee);return S(ce,Ee),ce}constructor(le,Ee){super(le),this.code=Ee}}e.$hk=o;function y(X,le){return o.create(X,le)}e.$ik=y;function $(X){return X||y((0,h.localize)(0,null),i.Unknown)}e.$jk=$;function S(X,le){return X.name=le?`${le} (FileSystemError)`:"FileSystemError",X}e.$kk=S;function I(X){if(!X)return i.Unknown;if(X instanceof o)return X.code;const le=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!le)return i.Unknown;switch(le[1]){case i.FileExists:return i.FileExists;case i.FileIsADirectory:return i.FileIsADirectory;case i.FileNotADirectory:return i.FileNotADirectory;case i.FileNotFound:return i.FileNotFound;case i.FileTooLarge:return i.FileTooLarge;case i.FileWriteLocked:return i.FileWriteLocked;case i.NoPermissions:return i.NoPermissions;case i.Unavailable:return i.Unavailable}return i.Unknown}e.$lk=I;function u(X){if(X instanceof U)return X.fileOperationResult;switch(I(X)){case i.FileNotFound:return 1;case i.FileIsADirectory:return 0;case i.FileNotADirectory:return 9;case i.FileWriteLocked:return 5;case i.NoPermissions:return 6;case i.FileExists:return 4;case i.FileTooLarge:return 7;default:return 10}}e.$mk=u;var d;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(d||(e.FileOperation=d={}));class l{constructor(le,Ee,ce){this.resource=le,this.operation=Ee,this.target=ce}isOperation(le){return this.operation===le}}e.$nk=l;var R;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class B{constructor(le,Ee){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const $e of le){const ie=ce.get($e.type);switch(ie?ie.push([$e.resource,$e]):ce.set($e.type,[[$e.resource,$e]]),$e.type){case 1:this.rawAdded.push($e.resource);break;case 0:this.rawUpdated.push($e.resource);break;case 2:this.rawDeleted.push($e.resource);break}}for(const[$e,ie]of ce)switch($e){case 1:this.a=w.$Th.forUris(()=>Ee),this.a.fill(ie);break;case 0:this.b=w.$Th.forUris(()=>Ee),this.b.fill(ie);break;case 2:this.c=w.$Th.forUris(()=>Ee),this.c.fill(ie);break}}contains(le,...Ee){return this.d(le,{includeChildren:!1},...Ee)}affects(le,...Ee){return this.d(le,{includeChildren:!0},...Ee)}d(le,Ee,...ce){if(!le)return!1;const $e=ce.length>0;return!!((!$e||ce.includes(1))&&(this.a?.get(le)||Ee.includeChildren&&this.a?.findSuperstr(le))||(!$e||ce.includes(0))&&(this.b?.get(le)||Ee.includeChildren&&this.b?.findSuperstr(le))||(!$e||ce.includes(2))&&(this.c?.findSubstr(le)||Ee.includeChildren&&this.c?.findSuperstr(le)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$ok=B;function V(X,le,Ee){return!X||!le||X===le||le.length>X.length?!1:(le.charAt(le.length-1)!==M.sep&&(le+=M.sep),Ee?(0,C.$2e)(X,le):X.indexOf(le)===0)}e.$pk=V;class U extends Error{constructor(le,Ee,ce){super(le),this.fileOperationResult=Ee,this.options=ce}}e.$qk=U;class W extends U{constructor(le,Ee,ce,$e){super(le,Ee,$e),this.fileOperationResult=Ee,this.size=ce}}e.$rk=W;class N extends U{constructor(le,Ee,ce){super(le,2,ce),this.stat=Ee}}e.$sk=N;var O;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(O||(e.FileOperationResult=O={})),e.$tk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$uk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$vk="files.associations",e.$wk="files.exclude",e.$xk="files.readonlyInclude",e.$yk="files.readonlyExclude",e.$zk="files.readonlyFromPermissions";var ee;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.$Ak="";function Z(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.$Bk=Z;async function ye(X,le){if(!le.hasProvider(A.URI.from({scheme:X.scheme})))return new Promise(Ee=>{const ce=le.onDidChangeFileSystemProviderRegistrations($e=>{$e.scheme===X.scheme&&$e.added&&(ce.dispose(),Ee())})})}e.$Ck=ye;class De{static{this.KB=1024}static{this.MB=De.KB*De.KB}static{this.GB=De.MB*De.KB}static{this.TB=De.GB*De.KB}static formatSize(le){return(0,F.$Bf)(le)||(le=0),le<De.KB?(0,h.localize)(1,null,le.toFixed(0)):le<De.MB?(0,h.localize)(2,null,(le/De.KB).toFixed(2)):le<De.GB?(0,h.localize)(3,null,(le/De.MB).toFixed(2)):le<De.TB?(0,h.localize)(4,null,(le/De.GB).toFixed(2)):(0,h.localize)(5,null,(le/De.TB).toFixed(2))}}e.$Dk=De;function Pe(X){const le=typeof X=="string"||X?.scheme===P.Schemas.vscodeRemote;return typeof X!="string"&&X?.scheme===P.Schemas.file?1024*De.MB:le?10*De.MB:g.$p?50*De.MB:1024*De.MB}e.$Ek=Pe}),define(Ae[71],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class w{constructor(...C){this.a=new Map;for(const[F,A]of C)this.set(F,A)}set(C,F){const A=this.a.get(C);return this.a.set(C,F),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Lh=w}),define(Ae[172],Re([1,0,13,9,6,69,170,4,71,173]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0;const P=!1;class k extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class a{constructor(t=new E.$Lh,n=!1,c,v=P){this.f=t,this.g=n,this.h=c,this.i=v,this.o=new Set,this.f.set(h.$Mh,this),this._globalGraph=v?c?._globalGraph??new A.$8p(D=>D):void 0}createChild(t){return new a(t,this.g,this,this.i)}invokeFunction(t,...n){const c=m.traceInvocation(this.i,t);let v=!1;try{return t({get:p=>{if(v)throw(0,M.$7)("service accessor is only valid during the invocation of its target method");const r=this.m(p,c);if(!r)throw new Error(`[invokeFunction] unknown service '${p}'`);return r}},...n)}finally{v=!0,c.stop()}}createInstance(t,...n){let c,v;return t instanceof F.$Kh?(c=m.traceCreation(this.i,t.ctor),v=this.j(t.ctor,t.staticArguments.concat(n),c)):(c=m.traceCreation(this.i,t),v=this.j(t,n,c)),c.stop(),v}j(t,n=[],c){const v=h._util.getServiceDependencies(t).sort((r,s)=>r.index-s.index),D=[];for(const r of v){const s=this.m(r.id,c);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),D.push(s)}const p=v.length>0?v[0].index:n.length;if(n.length!==p){console.trace(`[createInstance] First service dependency of ${t.name} at position ${p+1} conflicts with ${n.length} static arguments`);const r=p-n.length;r>0?n=n.concat(new Array(r)):n=n.slice(0,p)}return Reflect.construct(t,n.concat(D))}k(t,n){if(this.f.get(t)instanceof F.$Kh)this.f.set(t,n);else if(this.h)this.h.k(t,n);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const n=this.f.get(t);return!n&&this.h?this.h.l(t):n}m(t,n){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof F.$Kh?this.q(t,c,n.branch(t,!0)):(n.branch(t,!1),c)}q(t,n,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,n,c)}finally{this.o.delete(t)}}r(t,n,c){const v=new A.$8p(r=>r.id.toString());let D=0;const p=[{id:t,desc:n,_trace:c}];for(;p.length;){const r=p.pop();if(v.lookupOrInsertNode(r),D++>1e3)throw new k(v);for(const s of h._util.getServiceDependencies(r.desc.ctor)){const i=this.l(s.id);if(i||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),i instanceof F.$Kh){const o={id:s.id,desc:i,_trace:r._trace.branch(s.id,!0)};v.insertEdge(r,o),p.push(o)}}}for(;;){const r=v.roots();if(r.length===0){if(!v.isEmpty())throw new k(v);break}for(const{data:s}of r){if(this.l(s.id)instanceof F.$Kh){const o=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,o)}v.removeNode(s)}}return this.l(t)}s(t,n,c=[],v,D){if(this.f.get(t)instanceof F.$Kh)return this.t(t,n,c,v,D);if(this.h)return this.h.s(t,n,c,v,D);throw new Error(`illegalState - creating UNKNOWN service instance ${n.name}`)}t(t,n,c=[],v,D){if(v){const p=new a(void 0,this.g,this,this.i);p.c=String(t);const r=new Map,s=new w.$0g(()=>{const i=p.j(n,c,D);for(const[o,y]of r){const $=i[o];if(typeof $=="function")for(const S of y)$.apply(i,S)}return r.clear(),i});return new Proxy(Object.create(null),{get(i,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let S=r.get(o);return S||(S=new g.$1c,r.set(o,S)),(u,d,l)=>{const R=S.push([u,d,l]);return(0,C.$Pc)(R)}}if(o in i)return i[o];const y=s.value;let $=y[o];return typeof $!="function"||($=$.bind(y),i[o]=$),$},set(i,o,y){return s.value[o]=y,!0},getPrototypeOf(i){return n.prototype}})}else return this.j(n,c,D)}u(t,n){if(n&&console.warn(t),this.g)throw new Error(t)}}e.$9p=a;var b;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(b||(b={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,n){return t?new m(2,n.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(t,n){return t?new m(1,n.name):m.c}static{this.f=0}constructor(t,n){this.type=t,this.name=n,this.g=Date.now(),this.h=[]}branch(t,n){const c=new m(3,t.toString());return this.h.push([t,n,c]),c}stop(){const t=Date.now()-this.g;m.f+=t;let n=!1;function c(D,p){const r=[],s=new Array(D+1).join("	");for(const[i,o,y]of p.h)if(o&&y){n=!0,r.push(`${s}CREATES -> ${i}`);const $=c(D+1,y);$&&r.push($)}else r.push(`${s}uses -> ${i}`);return r.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(t>2||n)&&m.all.add(v.join(`
`))}}e.$0p=m}),define(Ae[14],Re([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,a.$Nh)("logService"),e.$9i=(0,a.$Nh)("loggerService");function b(){return new Date().toISOString()}function m(u){return(0,g.$Bf)(u)}e.$0i=m;var f;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$$i=f.Info;function t(u,d,l){switch(d){case f.Trace:u.trace(l);break;case f.Debug:u.debug(l);break;case f.Info:u.info(l);break;case f.Warning:u.warn(l);break;case f.Error:u.error(l);break;case f.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=t;function n(u,d=!1){let l="";for(let R=0;R<u.length;R++){let B=u[R];if(B instanceof Error&&(B=(0,w.$yi)(B,d)),typeof B=="object")try{B=JSON.stringify(B)}catch{}l+=(R>0?" ":"")+B}return l}class c extends F.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new M.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(d){this.b!==d&&(this.b=d,this.c.fire(this.b))}getLevel(){return this.b}f(d){return this.b!==f.Off&&this.b<=d}}e.$aj=c;class v extends c{constructor(d){super(),this.h=d}f(d){return this.h||super.f(d)}trace(d,...l){this.f(f.Trace)&&this.g(f.Trace,n([d,...l],!0))}debug(d,...l){this.f(f.Debug)&&this.g(f.Debug,n([d,...l]))}info(d,...l){this.f(f.Info)&&this.g(f.Info,n([d,...l]))}warn(d,...l){this.f(f.Warning)&&this.g(f.Warning,n([d,...l]))}error(d,...l){if(this.f(f.Error))if(d instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=d.stack,this.g(f.Error,n(R))}else this.g(f.Error,n([d,...l]))}flush(){}}e.$bj=v;class D extends c{constructor(d=e.$$i){super(),this.setLevel(d),this.g=!h.$j}trace(d,...l){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,d,...l):console.log(`[main ${b()}]`,d,...l))}debug(d,...l){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,d,...l):console.log(`[main ${b()}]`,d,...l))}info(d,...l){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,d,...l):console.log(`[main ${b()}]`,d,...l))}warn(d,...l){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,d,...l):console.warn(`[main ${b()}]`,d,...l))}error(d,...l){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,d,...l):console.error(`[main ${b()}]`,d,...l))}dispose(){}flush(){}}e.$cj=D;class p extends c{constructor(d=e.$$i,l=!0){super(),this.g=l,this.setLevel(d)}trace(d,...l){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",d,...l):console.log(d,...l))}debug(d,...l){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",d,...l):console.log(d,...l))}info(d,...l){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",d,...l):console.log(d,...l))}warn(d,...l){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",d,...l):console.log(d,...l))}error(d,...l){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",d,...l):console.error(d,...l))}dispose(){}flush(){}}e.$dj=p;class r extends c{constructor(d,l=e.$$i){super(),this.g=d,this.setLevel(l)}trace(d,...l){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(d),...l])}debug(d,...l){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(d),...l])}info(d,...l){this.f(f.Info)&&this.g.log(f.Info,[this.h(d),...l])}warn(d,...l){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(d),...l])}error(d,...l){this.f(f.Error)&&this.g.log(f.Error,[this.h(d),...l])}h(d){return typeof d=="string"?d:(0,w.$yi)(d,this.f(f.Trace))}dispose(){}flush(){}}e.$ej=r;class s extends c{constructor(d){super(),this.g=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const l of this.g)l.setLevel(d);super.setLevel(d)}trace(d,...l){for(const R of this.g)R.trace(d,...l)}debug(d,...l){for(const R of this.g)R.debug(d,...l)}info(d,...l){for(const R of this.g)R.info(d,...l)}warn(d,...l){for(const R of this.g)R.warn(d,...l)}error(d,...l){for(const R of this.g)R.error(d,...l)}flush(){for(const d of this.g)d.flush()}dispose(){for(const d of this.g)d.dispose()}}e.$fj=s;class i extends F.$Rc{constructor(d,l,R){if(super(),this.h=d,this.j=l,this.b=new A.$zc,this.c=this.B(new M.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Md),this.onDidChangeVisibility=this.g.event,R)for(const B of R)this.b.set(B.resource,{logger:void 0,info:B})}m(d){return(0,g.$xf)(d)?[...this.b.values()].find(l=>l.info.id===d):this.b.get(d)}getLogger(d){return this.m(d)?.logger}createLogger(d,l){const R=this.n(d),B=(0,g.$xf)(d)?d:l?.id??(0,C.$Bi)(R.toString()).toString(16);let V=this.b.get(R)?.logger;const U=l?.logLevel==="always"?f.Trace:l?.logLevel;V||(V=this.s(R,U??this.getLogLevel(R)??this.h,{...l,id:B}));const W={logger:V,info:{resource:R,id:B,logLevel:U,name:l?.name,hidden:l?.hidden,extensionId:l?.extensionId,when:l?.when}};return this.registerLogger(W.info),this.b.set(R,W),V}n(d){return(0,g.$xf)(d)?(0,E.$ug)(this.j,`${d}.log`):d}setLogLevel(d,l){if(P.URI.isUri(d)){const R=d,B=l,V=this.b.get(R);V&&B!==V.info.logLevel&&(V.info.logLevel=B===this.h?void 0:B,V.logger?.setLevel(B),this.b.set(V.info.resource,V),this.f.fire([R,B]))}else{this.h=d;for(const[R,B]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(d,l){const R=this.m(d);R&&l!==!R.info.hidden&&(R.info.hidden=!l,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,l]))}getLogLevel(d){let l;return d&&(l=this.b.get(d)?.info.logLevel),l??this.h}registerLogger(d){const l=this.b.get(d.resource);l?l.info.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this.b.set(d.resource,{info:d,logger:void 0}),this.c.fire({added:[d],removed:[]}))}deregisterLogger(d){const l=this.b.get(d);l&&(l.logger&&l.logger.dispose(),this.b.delete(d),this.c.fire({added:[],removed:[l.info]}))}*getRegisteredLoggers(){for(const d of this.b.values())yield d.info}getRegisteredLogger(d){return this.b.get(d)?.info}dispose(){this.b.forEach(d=>d.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=i;class o{constructor(){this.onDidChangeLogLevel=new M.$Md().event}setLevel(d){}getLevel(){return f.Info}trace(d,...l){}debug(d,...l){}info(d,...l){}warn(d,...l){}error(d,...l){}critical(d,...l){}dispose(){}flush(){}}e.$hj=o;class y extends o{}e.$ij=y;function $(u){if(u.verbose)return f.Trace;if(typeof u.logLevel=="string"){const d=I(u.logLevel.toLowerCase());if(d!==void 0)return d}return e.$$i}e.$jj=$;function S(u){switch(u){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$kj=S;function I(u){switch(u){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$lj=I,e.$mj=new k.$5i("logLevel",S(f.Info))}),define(Ae[174],Re([1,0,6,14]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=void 0;class C extends w.$Rc{constructor(A,h=[]){super(),this.a=new M.$fj([A,...h]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...h){this.a.trace(A,...h)}debug(A,...h){this.a.debug(A,...h)}info(A,...h){this.a.info(A,...h)}warn(A,...h){this.a.warn(A,...h)}error(A,...h){this.a.error(A,...h)}flush(){this.a.flush()}}e.$uN=C}),define(Ae[94],Re([1,0,29,143,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function g(m,f){return f-m}E.compare=g;const P=Object.create(null);P[E.Error]=(0,M.localize)(0,null),P[E.Warning]=(0,M.localize)(1,null),P[E.Info]=(0,M.localize)(2,null);function k(m){return P[m]||""}E.toString=k;function a(m){switch(m){case w.default.Error:return E.Error;case w.default.Warning:return E.Warning;case w.default.Info:return E.Info;case w.default.Ignore:return E.Hint}}E.fromSeverity=a;function b(m){switch(m){case E.Error:return w.default.Error;case E.Warning:return w.default.Warning;case E.Info:return w.default.Info;case E.Hint:return w.default.Ignore}}E.toSeverity=b}(A||(e.MarkerSeverity=A={}));var h;(function(E){const g="";function P(a){return k(a,!0)}E.makeKey=P;function k(a,b){const m=[g];return a.source?m.push(a.source.replace("\xA6","\\\xA6")):m.push(g),a.code?typeof a.code=="string"?m.push(a.code.replace("\xA6","\\\xA6")):m.push(a.code.value.replace("\xA6","\\\xA6")):m.push(g),a.severity!==void 0&&a.severity!==null?m.push(A.toString(a.severity)):m.push(g),a.message&&b?m.push(a.message.replace("\xA6","\\\xA6")):m.push(g),a.startLineNumber!==void 0&&a.startLineNumber!==null?m.push(a.startLineNumber.toString()):m.push(g),a.startColumn!==void 0&&a.startColumn!==null?m.push(a.startColumn.toString()):m.push(g),a.endLineNumber!==void 0&&a.endLineNumber!==null?m.push(a.endLineNumber.toString()):m.push(g),a.endColumn!==void 0&&a.endColumn!==null?m.push(a.endColumn.toString()):m.push(g),m.push(g),m.join("\xA6")}E.makeKeyOptionalMessage=k})(h||(e.IMarkerData=h={})),e.$6s=(0,C.$Nh)("markerService")}),define(Ae[175],Re([1,0,5,29,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vu=e.$Uu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Tu=e.Severity=void 0,e.Severity=M.default,e.$Tu=(0,C.$Nh)("notificationService");var F;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var h;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(h||(e.NotificationsFilter=h={}));class E{constructor(){this.progress=new g,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$Uu=E;class g{infinite(){}done(){}total(k){}worked(k){}}e.$Vu=g}),define(Ae[95],Re([1,0,15,2,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7T=e.$6T=e.$5T=e.$4T=e.$3T=void 0,e.$3T=(0,C.$Nh)("openerService");function F(g,P){return M.URI.isUri(g)?(0,w.$1e)(g.scheme,P):(0,w.$2e)(g,P+":")}e.$4T=F;function A(g,...P){return P.some(k=>F(g,k))}e.$5T=A;function h(g,P){return g.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$6T=h;function E(g){let P;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return k&&(P={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},g=g.with({fragment:""})),{selection:P,uri:g}}e.$7T=E}),define(Ae[176],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,w.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(be,e,w,M){var C=arguments.length,F=C<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,w):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(be,e,w,M);else for(var h=be.length-1;h>=0;h--)(A=be[h])&&(F=(C<3?A(F):C>3?A(e,w,F):A(e,w))||F);return C>3&&F&&Object.defineProperty(e,w,F),F},Ve=this&&this.__param||function(be,e){return function(w,M){e(w,M,be)}};define(Ae[72],Re([1,0,13,21,6,4]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=e.$1u=e.$Zu=e.$Yu=e.$Xu=e.ProgressLocation=e.$Wu=void 0,e.$Wu=(0,F.$Nh)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Xu=Object.freeze({total(){},worked(){},done(){}});class h{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(k,a){this.e=k,this.report=a?.async?this.g.bind(this):this.f.bind(this)}f(k){this.a=k,this.e(this.a)}g(k){this.b?this.b.push(k):this.b=[k],this.h()}async h(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const k=this.b.shift();this.a=k,await this.e(this.a)}}finally{this.c=!1;const k=this.d;this.d=void 0,k?.()}}drain(){return this.c?new Promise(k=>{const a=this.d;this.d=()=>{a?.(),k()}}):Promise.resolve()}}e.$Yu=h;let E=class extends C.$Rc{constructor(k,a){super(),this.a=new w.$bh,a.withProgress(k,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,C.$Pc)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};e.$Zu=E,e.$Zu=E=Ke([Ve(1,e.$Wu)],E);class g extends C.$Rc{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new C.$Qc)}start(k){this.stop();const a=++this.a,b=new M.$Wd;return this.f=setTimeout(()=>{a===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,C.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Pc)(()=>b.cancel())),this.b.add((0,C.$Pc)(()=>this.c?this.c.done():void 0)),{id:a,token:b.token,stop:()=>this.h(a),isCurrent:()=>this.a===a}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.$1u=g,e.$2u=(0,F.$Nh)("editorProgressService")}),define(Ae[30],Re([1,0,51,16]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0;class C{constructor(){this.a=new Map}add(A,h){w.ok(M.$xf(A)),w.ok(M.$zf(h)),w.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,h)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$$m=new C}),define(Ae[73],Re([1,0,5,30]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=void 0,e.$_m={JSONContribution:"base.contributions.json"};function C(h){return h.length>0&&h.charAt(h.length-1)==="#"?h.substring(0,h.length-1):h}class F{constructor(){this.b=new w.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,g){this.a[C(E)]=g,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new F;M.$$m.add(e.$_m.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,16,137,43,73,30]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.ConfigurationScope=e.$dn=e.EditPresentationTypes=void 0;var g;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$dn={Configuration:"base.contributions.configuration"};var P;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn="vscode://schemas/settings/resourceLanguage",e.$ln="vscode://schemas/settings/configurationDefaults";const k=E.$$m.as(h.$_m.JSONContribution);class a{constructor(){this.h=new Set,this.i=new M.$Md,this.onDidSchemaChange=this.i.event,this.j=new M.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$kn,this.g),this.v()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const i=new Set;this.n(r,s,i),k.registerSchema(e.$kn,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(r){const s=new Set;this.o(r,s),k.registerSchema(e.$kn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:r,remove:s}){const i=new Set;this.o(s,i),this.n(r,!1,i),k.registerSchema(e.$kn,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(r){const s=new Set;this.k(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(r,s){const i=[];for(const{overrides:o,source:y}of r)for(const $ in o)if(s.add($),e.$nn.test($)){const S=this.a.get($),I=S?.valuesSources??new Map;if(y)for(const R of Object.keys(o[$]))I.set(R,y);const u={...S?.value||{},...o[$]};this.a.set($,{source:y,value:u,valuesSources:I});const d=(0,A.$ri)($),l={type:"object",default:u,description:F.localize(1,null,d),$ref:e.$kn,defaultDefaultValue:u,source:C.$xf(y)?void 0:y,defaultValueSource:y};i.push(...f($)),this.d[$]=l,this.b.properties[$]=l}else{this.a.set($,{value:o[$],source:y});const S=this.d[$];S&&(this.w($,S),this.r($,S))}this.m(i)}deregisterDefaultConfigurations(r){const s=new Set;this.l(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(r,s){for(const{overrides:i,source:o}of r)for(const y in i){const $=this.a.get(y),S=C.$xf(o)?o:o?.id,I=C.$xf($?.source)?$?.source:$?.source?.id;if(S===I)if(s.add(y),this.a.delete(y),e.$nn.test(y))delete this.d[y],delete this.b.properties[y];else{const u=this.d[y];u&&(this.w(y,u),this.r(y,u))}}this.u()}deltaConfiguration(r){let s=!1;const i=new Set;r.removedDefaults&&(this.l(r.removedDefaults,i),s=!0),r.addedDefaults&&(this.k(r.addedDefaults,i),s=!0),r.removedConfigurations&&this.o(r.removedConfigurations,i),r.addedConfigurations&&this.n(r.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const s of r)this.h.add(s);this.u()}n(r,s,i){r.forEach(o=>{this.p(o,s,o.extensionInfo,o.restrictedProperties,void 0,i),this.c.push(o),this.q(o)})}o(r,s){const i=o=>{if(o.properties)for(const y in o.properties){s.add(y);const $=this.d[y];$?.policy?.name&&this.e.delete($.policy.name),delete this.d[y],this.s(y,o.properties[y])}o.allOf?.forEach(y=>i(y))};for(const o of r){i(o);const y=this.c.indexOf(o);y!==-1&&this.c.splice(y,1)}}p(r,s=!0,i,o,y=3,$){y=C.$Gf(r.scope)?y:r.scope;const S=r.properties;if(S)for(const u in S){const d=S[u];if(s&&v(u,d)){delete S[u];continue}if(d.source=i,d.defaultDefaultValue=S[u].default,this.w(u,d),e.$nn.test(u)?d.scope=void 0:(d.scope=C.$Gf(d.scope)?y:d.scope,d.restricted=C.$Gf(d.restricted)?!!o?.includes(u):d.restricted),S[u].hasOwnProperty("included")&&!S[u].included){this.f[u]=S[u],delete S[u];continue}else this.d[u]=S[u],S[u].policy?.name&&this.e.set(S[u].policy.name,u);!S[u].deprecationMessage&&S[u].markdownDeprecationMessage&&(S[u].deprecationMessage=S[u].markdownDeprecationMessage),$.add(u)}const I=r.allOf;if(I)for(const u of I)this.p(u,s,i,o,y,$)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const s=i=>{const o=i.properties;if(o)for(const $ in o)this.r($,o[$]);i.allOf?.forEach(s)};s(r)}r(r,s){switch(e.$en.properties[r]=s,s.scope){case 1:e.$fn.properties[r]=s;break;case 2:e.$gn.properties[r]=s;break;case 6:e.$hn.properties[r]=s;break;case 3:e.$in.properties[r]=s;break;case 4:e.$jn.properties[r]=s;break;case 5:e.$jn.properties[r]=s,this.g.properties[r]=s;break}}s(r,s){switch(delete e.$en.properties[r],s.scope){case 1:delete e.$fn.properties[r];break;case 2:delete e.$gn.properties[r];break;case 6:delete e.$hn.properties[r];break;case 3:delete e.$in.properties[r];break;case 4:case 5:delete e.$jn.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const s=`[${r}]`,i={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$kn};this.w(s,i),e.$en.properties[s]=i,e.$fn.properties[s]=i,e.$gn.properties[s]=i,e.$hn.properties[s]=i,e.$in.properties[s]=i,e.$jn.properties[s]=i}}v(){const r={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$kn};e.$en.patternProperties[e.$mn]=r,e.$fn.patternProperties[e.$mn]=r,e.$gn.patternProperties[e.$mn]=r,e.$hn.patternProperties[e.$mn]=r,e.$in.patternProperties[e.$mn]=r,e.$jn.patternProperties[e.$mn]=r,this.i.fire()}w(r,s){const i=this.a.get(r);let o=i?.value,y=i?.source;C.$Ef(o)&&(o=s.defaultDefaultValue,y=void 0),C.$Ef(o)&&(o=n(s.type)),s.default=o,s.defaultValueSource=y}}const b="\\[([^\\]]+)\\]",m=new RegExp(b,"g");e.$mn=`^(${b})+$`,e.$nn=new RegExp(e.$mn);function f(p){const r=[];if(e.$nn.test(p)){let s=m.exec(p);for(;s?.length;){const i=s[1].trim();i&&r.push(i),s=m.exec(p)}}return(0,w.$Lb)(r)}e.$on=f;function t(p){return p.reduce((r,s)=>`${r}[${s}]`,"")}e.$pn=t;function n(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$qn=n;const c=new a;E.$$m.add(e.$dn.Configuration,c);function v(p,r){return p.trim()?e.$nn.test(p)?F.localize(7,null,p):c.getConfigurationProperties()[p]!==void 0?F.localize(8,null,p):r.policy?.name&&c.getPolicyConfigurations().get(r.policy?.name)!==void 0?F.localize(9,null,p,r.policy?.name,c.getPolicyConfigurations().get(r.policy?.name)):null:F.localize(6,null)}e.$rn=v;function D(){const p=[],r=c.getConfigurationProperties();for(const s of Object.keys(r))p.push([s,r[s].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.$sn=D}),define(Ae[177],Re([1,0,18,5,115,6,28,24,16,2,43,96,30]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=void 0;function b(s){return Object.isFrozen(s)?s:h.$Zm(s)}class m{constructor(i={},o=[],y=[],$){this.b=i,this.c=o,this.d=y,this.raw=$,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(o=>{if(o instanceof m)return o;const y=new f("");return y.parseRaw(o),y.configurationModel});this.f=i.reduce((o,y)=>y===o?y:o.merge(y),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,P.$pi)(this.contents,i):this.contents}inspect(i,o){const y=this.rawConfiguration.getValue(i),$=o?this.rawConfiguration.getOverrideValue(i,o):void 0,S=o?this.rawConfiguration.override(o).getValue(i):y;return{value:y,override:$,merged:S}}getOverrideValue(i,o){const y=this.i(o);return y?i?(0,P.$pi)(y,i):y:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const y of this.overrides)y.identifiers.includes(i)&&o.push(...y.keys);return w.$Lb(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return w.$Lb(i)}override(i){let o=this.a.get(i);return o||(o=this.g(i),this.a.set(i,o)),o}merge(...i){const o=h.$Ym(this.contents),y=h.$Ym(this.overrides),$=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const I of i)if(S.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(o,I.contents);for(const u of I.overrides){const[d]=y.filter(l=>w.$tb(l.identifiers,u.identifiers));d?(this.h(d.contents,u.contents),d.keys.push(...u.keys),d.keys=w.$Lb(d.keys)):y.push(h.$Ym(u))}for(const u of I.keys)$.indexOf(u)===-1&&$.push(u)}return new m(o,$,y,S.every(I=>I instanceof m)?void 0:S)}g(i){const o=this.i(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const y={};for(const $ of w.$Lb([...Object.keys(this.contents),...Object.keys(o)])){let S=this.contents[$];const I=o[$];I&&(typeof S=="object"&&typeof I=="object"?(S=h.$Ym(S),this.h(S,I)):S=I),y[$]=S}return new m(y,this.keys,this.overrides)}h(i,o){for(const y of Object.keys(o)){if(y in i&&E.$zf(i[y])&&E.$zf(o[y])){this.h(i[y],o[y]);continue}i[y]=h.$Ym(o[y])}}i(i){let o=null,y=null;const $=S=>{S&&(y?this.h(y,S):y=h.$Ym(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===i?o=S.contents:S.identifiers.includes(i)&&$(S.contents);return $(o),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,o){this.j(i,o,!0)}setValue(i,o){this.j(i,o,!1)}removeValue(i){const o=this.keys.indexOf(i);o!==-1&&(this.keys.splice(o,1),(0,P.$oi)(this.contents,i),k.$nn.test(i)&&this.overrides.splice(this.overrides.findIndex(y=>w.$tb(y.identifiers,(0,k.$on)(i))),1))}j(i,o,y){(0,P.$ni)(this.contents,i,o,$=>console.error($)),y=y||this.keys.indexOf(i)===-1,y&&this.keys.push(i),k.$nn.test(i)&&this.overrides.push({identifiers:(0,k.$on)(i),keys:Object.keys(this.contents[i]),contents:(0,P.$mi)(this.contents[i],$=>console.error($))})}}e.$tn=m;class f{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,o){if(!E.$Gf(i)){const y=this.g(i);this.parseRaw(y,o)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,o){this.a=i;const{contents:y,keys:$,overrides:S,restricted:I,hasExcludedProperties:u}=this.h(i,o);this.b=new m(y,$,S,u?[i]:void 0),this.c=I||[]}g(i){let o={},y=null,$=[];const S=[],I=[];function u(l){Array.isArray($)?$.push(l):y!==null&&($[y]=l)}const d={onObjectBegin:()=>{const l={};u(l),S.push($),$=l,y=null},onObjectProperty:l=>{y=l},onObjectEnd:()=>{$=S.pop()},onArrayBegin:()=>{const l=[];u(l),S.push($),$=l,y=null},onArrayEnd:()=>{$=S.pop()},onLiteralValue:u,onError:(l,R,B)=>{I.push({error:l,offset:R,length:B})}};if(i)try{C.$Vm(i,d),o=$[0]||{}}catch(l){console.error(`Error while parsing settings file ${this.f}: ${l}`),this.d=[l]}return o}h(i,o){const y=a.$$m.as(k.$dn.Configuration).getConfigurationProperties(),$=this.i(i,y,!0,o);i=$.raw;const S=(0,P.$mi)(i,d=>console.error(`Conflict in settings file ${this.f}: ${d}`)),I=Object.keys(i),u=this.j(i,d=>console.error(`Conflict in settings file ${this.f}: ${d}`));return{contents:S,keys:I,overrides:u,restricted:$.restricted,hasExcludedProperties:$.hasExcludedProperties}}i(i,o,y,$){let S=!1;if(!$?.scopes&&!$?.skipRestricted&&!$?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:S};const I={},u=[];for(const d in i)if(k.$nn.test(d)&&y){const l=this.i(i[d],o,!1,$);I[d]=l.raw,S=S||l.hasExcludedProperties,u.push(...l.restricted)}else{const l=o[d],R=l?typeof l.scope<"u"?l.scope:3:void 0;l?.restricted&&u.push(d),!$.exclude?.includes(d)&&($.include?.includes(d)||(R===void 0||$.scopes===void 0||$.scopes.includes(R))&&!($.skipRestricted&&l?.restricted))?I[d]=i[d]:S=!0}return{raw:I,restricted:u,hasExcludedProperties:S}}j(i,o){const y=[];for(const $ of Object.keys(i))if(k.$nn.test($)){const S={};for(const I in i[$])S[I]=i[$][I];y.push({identifiers:(0,k.$on)($),keys:Object.keys(S),contents:(0,P.$mi)(S,o)})}return y}}e.$un=f;class t extends F.$Rc{constructor(i,o,y,$){super(),this.c=i,this.f=o,this.g=$,this.b=this.B(new M.$Md),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&y.isEqual(S.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$vn=t;class n{constructor(i,o,y,$,S,I,u,d,l,R,B,V,U){this.a=i,this.b=o,this.c=y,this.overrideIdentifiers=$,this.d=S,this.f=I,this.g=u,this.h=d,this.i=l,this.j=R,this.k=B,this.l=V,this.m=U}get value(){return b(this.c)}n(i,o,y){const $=i.inspect(o,y);return{get value(){return b($.value)},get override(){return b($.override)},get merged(){return b($.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(i,o,y,$,S=new m,I=new m,u=new A.$zc,d=new m,l=new A.$zc){this.c=i,this.d=o,this.f=y,this.g=$,this.h=S,this.i=I,this.j=u,this.l=d,this.m=l,this.a=null,this.b=new A.$zc,this.n=null}getValue(i,o,y){return this.q(i,o,y).getValue(i)}updateValue(i,o,y={}){let $;y.resource?($=this.m.get(y.resource),$||($=new m,this.m.set(y.resource,$))):$=this.l,o===void 0?$.removeValue(i):$.setValue(i,o),y.resource||(this.a=null)}inspect(i,o,y){const $=this.q(i,o,y),S=this.u(o.resource,y),I=o.resource?this.m.get(o.resource)||this.l:this.l,u=new Set;for(const d of $.overrides)for(const l of d.identifiers)$.getOverrideValue(i,l)!==void 0&&u.add(l);return new n(i,o,$.getValue(i),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.i:void 0,S||void 0,I)}keys(i){const o=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,o){this.j.set(i,o),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const y=[];if(!o){const{added:$,updated:S,removed:I}=p(this.c,i);o=[...$,...S,...I]}for(const $ of o)for(const S of(0,k.$on)($)){const I=this.c.getKeysForOverrideIdentifier(S),u=i.getKeysForOverrideIdentifier(S),d=[...u.filter(l=>I.indexOf(l)===-1),...I.filter(l=>u.indexOf(l)===-1),...I.filter(l=>!h.$3m(this.c.override(S).getValue(l),i.override(S).getValue(l)))];y.push([S,d])}return this.updateDefaultConfiguration(i),{keys:o,overrides:y}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:y,removed:$}=p(this.d,i),S=[...o,...y,...$];return S.length&&this.updatePolicyConfiguration(i),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:y,removed:$,overrides:S}=p(this.applicationConfiguration,i),I=[...o,...y,...$];return I.length&&this.updateApplicationConfiguration(i),{keys:I,overrides:S}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:y,removed:$,overrides:S}=p(this.localUserConfiguration,i),I=[...o,...y,...$];return I.length&&this.updateLocalUserConfiguration(i),{keys:I,overrides:S}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:y,removed:$,overrides:S}=p(this.remoteUserConfiguration,i),I=[...o,...y,...$];return I.length&&this.updateRemoteUserConfiguration(i),{keys:I,overrides:S}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:y,removed:$,overrides:S}=p(this.workspaceConfiguration,i),I=[...o,...y,...$];return I.length&&this.updateWorkspaceConfiguration(i),{keys:I,overrides:S}}compareAndUpdateFolderConfiguration(i,o){const y=this.p.get(i),{added:$,updated:S,removed:I,overrides:u}=p(y,o),d=[...$,...S,...I];return(d.length||!y)&&this.updateFolderConfiguration(i,o),{keys:d,overrides:u}}compareAndDeleteFolderConfiguration(i){const o=this.p.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:y,updated:$,removed:S,overrides:I}=p(o,void 0);return{keys:[...y,...$,...S],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,o,y){let $=this.r(o,y);return o.overrideIdentifier&&($=$.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&($=$.merge(this.d)),$}r({resource:i},o){let y=this.s();if(o&&i){const $=o.getFolder(i);$&&(y=this.t($.uri)||y);const S=this.m.get(i);S&&(y=y.merge(S))}return y}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let o=this.b.get(i);if(!o){const y=this.s(),$=this.j.get(i);$?(o=y.merge($),this.b.set(i,o)):o=y}return o}u(i,o){if(o&&i){const y=o.getFolder(i);if(y)return this.j.get(y.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,o)=>{const{contents:y,overrides:$,keys:S}=this.j.get(o);return i.push([o,{contents:y,overrides:$,keys:S}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(o=>i.add(o)),this.userConfiguration.keys.forEach(o=>i.add(o)),this.i.keys.forEach(o=>i.add(o)),this.j.forEach(o=>o.keys.forEach(y=>i.add(y))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(y=>i.add(y))),[...i.values()]}w(i){const o=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.i.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.j.forEach(y=>y.getKeysForOverrideIdentifier(i).forEach($=>o.add($))),[...o.values()]}static parse(i){const o=this.x(i.defaults),y=this.x(i.policy),$=this.x(i.application),S=this.x(i.user),I=this.x(i.workspace),u=i.folders.reduce((d,l)=>(d.set(g.URI.revive(l[0]),this.x(l[1])),d),new A.$zc);return new c(o,y,$,S,new m,I,u,new m,new A.$zc)}static x(i){return new m(i.contents,i.keys,i.overrides)}}e.$wn=c;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,o=new Map;for(const $ of s)$.keys.forEach(S=>i.add(S)),$.overrides.forEach(([S,I])=>{const u=(0,A.$wc)(o,S,new Set);I.forEach(d=>u.add(d))});const y=[];return o.forEach(($,S)=>y.push([S,[...$.values()]])),{keys:[...i.values()],overrides:y}}e.$xn=v;class D{constructor(i,o,y,$){this.change=i,this.f=o,this.g=y,this.h=$,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of i.keys)this.affectedKeys.add(S);for(const[,S]of i.overrides)for(const I of S)this.affectedKeys.add(I);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(i,o){const y=this.a+i,$=this.d.indexOf(y);if($<0)return!1;const S=$+y.length;if(S>=this.d.length)return!1;const I=this.d.charCodeAt(S);if(I!==this.b&&I!==this.c)return!1;if(o){const u=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.f?.workspace):void 0,d=this.g.getValue(i,o,this.h);return!h.$3m(u,d)}return!0}}e.$yn=D;function p(s,i){const{added:o,removed:y,updated:$}=r(i?.rawConfiguration,s?.rawConfiguration),S=[],I=s?.getAllOverrideIdentifiers()||[],u=i?.getAllOverrideIdentifiers()||[];if(i){const d=u.filter(l=>!I.includes(l));for(const l of d)S.push([l,i.getKeysForOverrideIdentifier(l)])}if(s){const d=I.filter(l=>!u.includes(l));for(const l of d)S.push([l,s.getKeysForOverrideIdentifier(l)])}if(i&&s){for(const d of I)if(u.includes(d)){const l=r({contents:s.getOverrideValue(void 0,d)||{},keys:s.getKeysForOverrideIdentifier(d)},{contents:i.getOverrideValue(void 0,d)||{},keys:i.getKeysForOverrideIdentifier(d)});S.push([d,[...l.added,...l.removed,...l.updated]])}}return{added:o,removed:y,updated:$,overrides:S}}function r(s,i){const o=s?i?s.keys.filter(S=>i.keys.indexOf(S)===-1):[...s.keys]:[],y=i?s?i.keys.filter(S=>s.keys.indexOf(S)===-1):[...i.keys]:[],$=[];if(s&&i){for(const S of i.keys)if(s.keys.indexOf(S)!==-1){const I=(0,P.$pi)(i.contents,S),u=(0,P.$pi)(s.contents,S);h.$3m(I,u)||$.push(S)}}return{added:o,removed:y,updated:$}}}),define(Ae[97],Re([1,0,9,4]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.RemoteAuthorityResolverErrorCode=e.$Ok=e.$Nk=e.RemoteConnectionType=e.$Mk=void 0,e.$Mk=(0,M.$Nh)("remoteAuthorityResolverService");var C;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class F{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Nk=F;class A{constructor(k,a){this.host=k,this.port=a,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ok=A;var h;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(h||(e.RemoteAuthorityResolverErrorCode=h={}));class E extends w.$ab{static isNotAvailable(k){return k instanceof E&&k._code===h.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof E&&k._code===h.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof E&&k._code===h.NoResolverFound}static isInvalidAuthority(k){return k instanceof E&&k._code===h.InvalidAuthority}static isHandled(k){return k instanceof E&&k.isHandled}constructor(k,a=h.Unknown,b){super(k),this._message=k,this._code=a,this._detail=b,this.isHandled=a===h.NotAvailable&&b===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Pk=E;function g(P){const k=P.indexOf("+");return k===-1?P:P.substring(0,k)}e.$Qk=g}),define(Ae[52],Re([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=void 0;function M(g){return g.scheme===w.Schemas.vscodeRemote?g.authority:void 0}e.$Rk=M;function C(g){if(!g)return;const P=g.indexOf("+");return P<0?g:g.substr(0,P)}e.$Sk=C;function F(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Tk=F;function A(g){const{host:P,port:k}=E(g);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:k}}e.$Uk=A;function h(g,P){let{host:k,port:a}=E(g);return typeof a>"u"&&(a=P),{host:k,port:a}}e.$Vk=h;function E(g){const P=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const k=g.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const a=g.match(/(.*):(\d+)$/);return a?{host:a[1],port:parseInt(a[2],10)}:{host:g,port:void 0}}}),define(Ae[20],Re([1,0,15,4,52]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.TargetPlatform=e.ExtensionType=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=void 0,e.$Sl="extensions.user.cache",e.$Tl="extensions.builtin.cache",e.$Ul="undefined_publisher",e.$Vl=["ui","workspace","web"];function F(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$Wl=F,e.$Xl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A||(e.ExtensionType=A={}));var h;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(h||(e.TargetPlatform=h={}));class E{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,n){if(typeof t>"u"||t===null)return typeof n>"u"||n===null;if(typeof n>"u"||n===null)return!1;if(typeof t=="string"||typeof n=="string"){const c=typeof t=="string"?t:t.value,v=typeof n=="string"?n:n.value;return w.$1e(c,v)}return t._lower===n._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Yl=E;class g{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const n of t)this.add(n)}add(t){this.c.add(E.toKey(t))}delete(t){return this.c.delete(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}}e.$Zl=g;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(E.toKey(t))}get(t){return this.c.get(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}set(t,n){this.c.set(E.toKey(t),n)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$1l=P;function k(f){return a(f)}e.$2l=k;function a(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$3l=a;function b(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$4l=b;function m(f,t){if(t){const n=`onResolveRemoteAuthority:${(0,C.$Sk)(t)}`;return!!f.activationEvents?.includes(n)}return!1}e.$5l=m,e.$6l=(0,M.$Nh)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,20]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NE=e.$ME=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,h){this.a.set(A,h)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const h=Object.create(null);for(const E of A){const g=this.readActivationEvents(E);g.length>0&&(h[M.$Yl.toKey(E.identifier)]=g)}return h}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const h=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return h;for(const E in A.contributes){const g=this.a.get(E);if(!g)continue;const P=A.contributes[E],k=Array.isArray(P)?P:[P];try{g(k,h)}catch(a){(0,w.$Z)(a)}}return h}}e.$ME=C,e.$NE=new C}),define(Ae[178],Re([1,0,22,74,36]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=void 0;function F(E){if(w.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,g,P,k,a,b,m,f){const t=Object.create(null);t["common.machineId"]=b,t.sessionID=(0,C.$dg)()+Date.now(),t.commitHash=k,t.version=a,t["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,w.$i)(w.$u),t["common.nodePlatform"]=M.$cc,t["common.nodeArch"]=P,t["common.product"]=f||"desktop",m&&(t["common.msftInternal"]=m);let n=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),w.$m&&(t["common.snap"]="true");const v=F(g);return v&&(t["common.platformDetail"]=v),t}e.$ao=A;function h(E){const g=M.env.USERDNSDOMAIN;if(!g)return!1;const P=g.toLowerCase();return E.some(k=>P===k)}e.$bo=h}),define(Ae[179],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=void 0,e.$_k=(0,w.$Nh)("telemetryService"),e.$al=(0,w.$Nh)("customEndpointTelemetryService"),e.$bl="telemetry.currentSessionDate",e.$cl="telemetry.firstSessionDate",e.$dl="telemetry.lastSessionDate",e.$el="telemetry.machineId",e.$fl="telemetry",e.$gl="telemetry.telemetryLevel",e.$hl="telemetry.enableCrashReporter",e.$il="telemetry.enableTelemetry";var M;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var C;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[53],Re([1,0,24,16,5,43,52,178,179]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=void 0;class g{constructor(y){this.value=y,this.isTrustedTelemetryValue=!0}}e.$co=g;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$do=P,e.$eo=new P;class k{async publicLog(y,$,S){}async publicLogError(y,$,S){}}e.$fo=k,e.$go="telemetry",e.$ho="extensionTelemetryLog",e.$io={log:()=>null,flush:()=>Promise.resolve(null)};function a(o,y){return C.Event.debounce(y.onDidChangeConfiguration,(S,I)=>{const u=S?new Set([...S.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:u}},1e3,!0)(S=>{S.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,F.$ki)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$jo=a;function b(o,y){return!y.isBuilt&&!y.disableTelemetry?!0:!(y.disableTelemetry||!o.enableTelemetry)}e.$ko=b;function m(o,y){return y.extensionTestsLocationURI?!0:!(y.isBuilt||y.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$lo=m;function f(o){const y=o.getValue(E.$gl),$=o.getValue(E.$hl);if(o.getValue(E.$il)===!1||$===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$mo=f;function t(o){const y={},$={},S={};v(o,S);for(let I in S){I=I.length>150?I.substr(I.length-149):I;const u=S[I];typeof u=="number"?$[I]=u:typeof u=="boolean"?$[I]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${u.length}`),y[I]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(y[I]=u)}return{properties:y,measurements:$}}e.$no=t;const n=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const y=(0,A.$Sk)(o);return n.has(y)?y:"other"}e.$oo=c;function v(o,y,$=0,S){if(o)for(const I of Object.getOwnPropertyNames(o)){const u=o[I],d=S?S+I:I;Array.isArray(u)?y[d]=(0,w.$4m)(u):u instanceof Date?y[d]=u.toISOString():(0,M.$zf)(u)?$<2?v(u,y,$+1,d+"."):y[d]=(0,w.$4m)(u):y[d]=u}}function D(o,y){const $=o.msftInternalDomains||[],S=y.getValue("telemetry.internalTesting");return(0,h.$bo)($)||S}e.$po=D;function p(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$qo=p;function r(o,y){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let $=o;const S=[];for(const l of y)for(;;){const R=l.exec(o);if(!R)break;S.push([R.index,l.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for($="";;){const l=u.exec(o);if(!l)break;const R=S.some(([B,V])=>l.index<V&&B<u.lastIndex);!I.test(l[0])&&!R&&($+=o.substring(d,l.index)+"<REDACTED: user-file-path>",d=u.lastIndex)}return d<o.length&&($+=o.substr(d)),$}function s(o){if(!o)return o;const y=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const $ of y)if($.regex.test(o))return`<REDACTED: ${$.label}>`;return o}function i(o,y){return(0,w.$1m)(o,$=>{if($ instanceof g||Object.hasOwnProperty.call($,"isTrustedTelemetryValue"))return $.value;if(typeof $=="string"){let S=$.replaceAll("%20"," ");S=r(S,y);for(const I of y)S=S.replace(I,"");return S=s(S),S}})}e.$ro=i}),define(Ae[180],Re([1,0,15,92,20,22,2,9,74,53]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=void 0;function P(i,o){return i.uuid&&o.uuid?i.uuid===o.uuid:i.id===o.id?!0:(0,w.$Ve)(i.id,o.id)===0}e.$so=P;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(o){const y=o.manifest?o.manifest.version:o.version,$=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new a(o.identifier,y,$)}static parse(o){const y=k.exec(o);return y&&y[1]&&y[2]?new a({id:y[1]},y[2],y[4]||void 0):null}constructor(o,y,$="undefined"){this.version=y,this.targetPlatform=$,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof a?P(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$to=a;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(i){const o=b.exec(i);return o&&o[1]?[t(o[1]),o[2]]:[t(i),void 0]}e.$uo=m;function f(i,o){return`${i}.${o}`}e.$vo=f;function t(i){return i.toLowerCase()}e.$wo=t;function n(i,o){return t(f(i??C.$Ul,o))}e.$xo=n;function c(i,o){const y=[],$=S=>{for(const I of y)if(I.some(u=>P(o(u),o(S))))return I;return null};for(const S of i){const I=$(S);I?I.push(S):y.push([S])}return y}e.$yo=c;function v(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$zo=v;function D(i){return{id:new g.$co(i.identifier.id),name:new g.$co(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$Ao=D,e.$Bo=new C.$Yl("pprice.better-merge");function p(i,o){const y=[],$=o.manifest.extensionDependencies?.slice(0)??[];for(;$.length;){const S=$.shift();if(S&&y.every(I=>!P(I.identifier,{id:S}))){const I=i.filter(u=>P(u.identifier,{id:S}));I.length===1&&(y.push(I[0]),$.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.$Co=p;async function r(i,o){if(!F.$l)return!1;let y;try{y=(await i.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{y=(await i.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){o.debug("Error while getting the os-release file.",(0,h.$9)(S))}}return!!y&&(y.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(i,o){const y=await r(i,o),$=(0,M.$Xn)(y?"alpine":F.$u,E.$dc);return o.debug("ComputeTargetPlatform:",$),$}e.$Do=s}),define(Ae[181],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=e.$gr=e.$fr=e.$er=e.$dr=void 0;function w(E){return[...E.entries()]}e.$dr=w;function M(E){return E?[...E.entries()]:[]}e.$er=M;function C(E){return new Map(E)}e.$fr=C;function F(E){return new Map(E??[])}e.$gr=F;function A(E){return Array.from(E.entries()).map(g=>[g[0],w(g[1].map),M(g[1].descriptionMap)])}e.$hr=A;function h(E){return new Map(E.map(g=>[g[0],{map:C(g[1]),descriptionMap:F(g[2])}]))}e.$ir=h}),define(Ae[182],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkb=void 0;class w{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,F,A=5){const h=F(E=>{const g=typeof E=="string"?E:E.data;let P=this.a.get(C);if(P){P.data.push(g);return}const k=setTimeout(()=>this.flushBuffer(C),A);P={data:[g],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),h.dispose()}},this.a.set(C,P)});return h}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const F=this.a.get(C);F&&(this.a.delete(C),this.b(C,F.data.join("")))}}e.$Fkb=w}),define(Ae[183],Re([1,0,13,89,40,5,16,2,144,73,30]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.IconFontDefinition=e.IconContribution=e.$Xv=void 0,e.$Xv={IconContribution:"base.contributions.icons"};var k;(function(D){function p(r,s){let i=r.defaults;for(;C.ThemeIcon.isThemeIcon(i);){const o=m.getIcon(i.id);if(!o)return;i=o.defaults}return i}D.getDefinition=p})(k||(e.IconContribution=k={}));var a;(function(D){function p(s){return{weight:s.weight,style:s.style,src:s.src.map(i=>({format:i.format,location:i.location.toString()}))}}D.toJSONObject=p;function r(s){const i=o=>(0,A.$xf)(o)?o:void 0;if(s&&Array.isArray(s.src)&&s.src.every(o=>(0,A.$xf)(o.format)&&(0,A.$xf)(o.location)))return{weight:i(s.weight),style:i(s.style),src:s.src.map(o=>({format:o.format,location:h.URI.parse(o.location)}))}}D.fromJSONObject=r})(a||(e.IconFontDefinition=a={}));class b{constructor(){this.a=new F.$Md,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,r,s,i){const o=this.b[p];if(o){if(s&&!o.description){o.description=s,this.d.properties[p].markdownDescription=`${s} $(${p})`;const S=this.e.enum.indexOf(p);S!==-1&&(this.e.enumDescriptions[S]=s),this.a.fire()}return o}const y={id:p,description:s,defaults:r,deprecationMessage:i};this.b[p]=y;const $={$ref:"#/definitions/icons"};return i&&($.deprecationMessage=i),s&&($.markdownDescription=`${s}: $(${p})`),this.d.properties[p]=$,this.e.enum.push(p),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const r=this.e.enum.indexOf(p);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,r){const s=this.f[p];return s||(this.f[p]=r,this.a.fire(),r)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(o,y)=>o.id.localeCompare(y.id),r=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const i=Object.keys(this.b).map(o=>this.b[o]);for(const o of i.filter(y=>!!y.description).sort(p))s.push(`|<i class="${r(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const o of i.filter(y=>!C.ThemeIcon.isThemeIcon(y.defaults)).sort(p))s.push(`|<i class="${r(o)}"></i>|${o.id}|`);return s.join(`
`)}}const m=new b;P.$$m.add(e.$Xv.IconContribution,m);function f(D,p,r,s){return m.registerIcon(D,p,r,s)}e.$Yv=f;function t(){return m}e.$Zv=t;function n(){const D=(0,M.$Qj)();for(const p in D){const r="\\"+D[p].toString(16);m.registerIcon(p,{fontCharacter:r})}}n(),e.$1v="vscode://schemas/icons";const c=P.$$m.as(g.$_m.JSONContribution);c.registerSchema(e.$1v,m.getIconSchema());const v=new w.$5g(()=>c.notifySchemaChanged(e.$1v),200);m.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.$2v=f("widget-close",M.$Sj.close,(0,E.localize)(2,null)),e.$3v=f("goto-previous-location",M.$Sj.arrowUp,(0,E.localize)(3,null)),e.$4v=f("goto-next-location",M.$Sj.arrowDown,(0,E.localize)(4,null)),e.$5v=C.ThemeIcon.modify(M.$Sj.sync,"spin"),e.$6v=C.ThemeIcon.modify(M.$Sj.loading,"spin")}),define(Ae[184],Re([1,0,5,43,4,14]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.ProvidedOnAutoForward=e.$5u=e.TunnelPrivacyId=e.TunnelProtocol=e.$4u=e.$3u=void 0,e.$3u=(0,C.$Nh)("tunnelService"),e.$4u=(0,C.$Nh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var h;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(h||(e.TunnelPrivacyId=h={}));function E(t){return!!t.forwardPort}e.$5u=E;var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(n)return{address:n[1],port:+n[2]}}e.$6u=P,e.$7u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(t){return e.$7u.indexOf(t)>=0}e.$8u=k,e.$9u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(t){return e.$9u.indexOf(t)>=0}e.$0u=a;function b(t,n,c,v){if(c===1)return!1;if(c===2&&a(n)){const D=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(D?.length===4&&parseInt(D[1])>=18)return!1}return t<1024}e.$$u=b;class m{constructor(n,c,v){this.remoteAddress=n,this.localAddress=c,this.b=v,this.a=new w.$Md,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$_u=m;let f=class{constructor(n,c){this.j=n,this.k=c,this.a=new w.$Md,this.onTunnelOpened=this.a.event,this.b=new w.$Md,this.onTunnelClosed=this.b.event,this.c=new w.$Md,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const n=this.k.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.h=n.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const n=[],c=Array.from(this.e.values());for(const v of c){const D=Array.from(v.values());for(const p of D){const r=await p.value;r&&typeof r!="string"&&n.push(r)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:c}of n.values())await c.then(v=>typeof v!="string"?v?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,c,v,D,p){this.p(n,c,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:c,localAddress:v,privacy:D,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,c){(a(n)||k(n))&&(n=e.$7u[0]);const v=this.r(n,c);if(v)return++v.refcount,v.value}openTunnel(n,c,v,D,p,r=!1,s,i){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${v} on local port ${p}.`);const o=this.f??n;if(!o)return;if(c||(c="localhost"),D||(D=this.l),this.f&&this.i.has(v)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.s(o,c,v,D,p,r,s,i);return y?y.then($=>{if($){if(typeof $=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,v),$}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,v);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n($);return($.tunnelRemoteHost!==c||$.tunnelRemotePort!==v)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&$.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}n(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const c=this.e.get(n.tunnelRemoteHost);if(c){const v=c.get(n.tunnelRemotePort);v&&(v.refcount--,await this.o(n.tunnelRemoteHost,n.tunnelRemotePort,v))}}}}async o(n,c,v){if(v.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${c}.`);const D=v.value.then(async p=>{p&&typeof p!="string"&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(c),D}}async closeTunnel(n,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${c} `);const v=this.e.get(n);if(v&&v.has(c)){const D=v.get(c);D.refcount=0,await this.o(n,c,D)}}p(n,c,v){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(c,{refcount:1,value:v})}async q(n,c){const v=this.e.get(n);if(v){const D=v.get(c),p=D?await D.value:void 0;(!p||typeof p=="string")&&v.delete(c),v.size===0&&this.e.delete(n)}}r(n,c){const v=[n];k(n)?(v.push(...e.$7u),v.push(...e.$9u)):a(n)&&v.push(...e.$9u);const D=v.map(p=>this.e.get(p));for(const p of D){const r=p?.get(c);if(r)return r}}canTunnel(n){return!!P(n)}t(n,c,v,D,p,r,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${v} on local port ${D}.`);const i=v;this.i.add(i);const o=D===void 0?v:D,y={elevationRequired:p?this.isPortPrivileged(o):!1},$={remoteAddress:{host:c,port:v},localAddressPort:D,privacy:r,public:r?r!==h.Private:void 0,protocol:s},S=n.forwardPort($,y);return S?(this.p(c,v,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(i)})):this.i.delete(i),S}};e.$av=f,e.$av=f=Ke([Ve(0,F.$8i),Ve(1,M.$hi)],f)}),define(Ae[185],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$bv=void 0,e.$bv=(0,w.$Nh)("editSessionIdentityService");var M;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Ae[186],Re([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=void 0;function M(E){return E.scheme!==w.Schemas.file&&E.scheme!==w.Schemas.vscodeRemote}e.$FJ=M;function C(E){if(E.folders.length)return E.folders.every(g=>M(g.uri))?E.folders[0].uri:void 0;if(E.configuration&&M(E.configuration))return E.configuration}e.$GJ=C;function F(E){return C(E)?.scheme}e.$HJ=F;function A(E){return C(E)?.authority}e.$IJ=A;function h(E){return C(E)!==void 0}e.$JJ=h}),define(Ae[54],Re([1,0,145,19,49,23,2,4,12]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,h.$Nh)("contextService");function g(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.uri)}e.$Xh=g;function P(o){return typeof o?.id=="string"&&!g(o)&&!a(o)}e.$Yh=P,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function k(o,y){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,M.$mc)(o)}:y?e.$Zh:e.$1h;const $=o;return $.configuration?{id:$.id,configPath:$.configuration}:$.folders.length===1?{id:$.id,uri:$.folders[0].uri}:{id:$.id}}e.$2h=k;function a(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.configPath)}e.$3h=a;function b(o){const y=o;if(y?.uri)return{id:y.id,uri:A.URI.revive(y.uri)};const $=o;if($?.configPath)return{id:$.id,configPath:A.URI.revive($.configPath)};if(o?.id)return{id:o.id}}e.$4h=b;var m;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function f(o){const y=o;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.$5h=f;function t(o){const y=o;return!!(y&&typeof y=="object"&&A.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.$6h=t;class n{constructor(y,$,S,I,u){this.h=y,this.j=S,this.k=I,this.l=u,this.c=C.$Th.forUris(this.l,()=>!0),this.folders=$}update(y){this.h=y.id,this.k=y.configuration,this.j=y.transient,this.l=y.l,this.folders=y.folders}get folders(){return this.g}set folders(y){this.g=y,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(y){this.k=y}getFolder(y){return y&&this.c.findSubstr(y)||null}n(){this.c=C.$Th.forUris(this.l,()=>!0);for(const y of this.folders)this.c.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=n;class c{constructor(y,$){this.raw=$,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,F.$ug)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=c;function v(o){return new c({uri:o,index:0,name:(0,F.$qg)(o)},{uri:o.toString()})}e.$9h=v,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,w.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function D(o,y){return F.$lg.isEqualOrParent(o,y.untitledWorkspacesHome)}e.$bi=D;function p(o){let y;return A.URI.isUri(o)?y=o:y=o.configuration,y?.scheme===E.Schemas.tmp}e.$ci=p,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(o){return o.id===e.$di}e.$ei=r;function s(o,y){return!D(o,y)&&!p(o)}e.$fi=s;function i(o){return(typeof o=="string"?(0,M.$nc)(o):(0,F.$sg)(o))===e.$$h}e.$gi=i}),define(Ae[55],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=void 0;class w{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const F=this.c++;return this.b.set(F,C),this.e(),F}get(C,F){return this.b.has(C)?this.b.get(C)[F]:void 0}delete(C){this.b.delete(C),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Abc=w}),define(Ae[39],Re([1,0,12,23,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=e.$Cbc=void 0;class F{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new M.$jg(h=>{const E=this.b.get(h.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(h,E){E===null?this.b.delete(h.scheme):this.b.set(h.scheme,E)}isFreeScheme(h){return!this.b.has(h)&&!this.a.has(h)}getCapabilities(h){return this.b.get(h)}}e.$Cbc=F,e.$Dbc=(0,C.$Nh)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=void 0,e.$nM=(0,w.$Nh)("IExtHostInitDataService")}),define(Ae[187],Re([1,0,150,14,174,27]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;let A=class extends C.$uN{constructor(E,g,P){const k=P.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",a=P.remote.isRemote?(0,w.localize)(0,null):E?(0,w.localize)(1,null):(0,w.localize)(2,null);super(g.createLogger(k,{name:a}))}};e.$Jdc=A,e.$Jdc=A=Ke([Ve(1,M.$9i),Ve(2,F.$nM)],A)}),define(Ae[188],Re([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=e.$6bc=void 0;class M{constructor(A,h,E){this.h=new Map,this.a=A,this.b=h,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new w.$5g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of g.values())P.complete()}catch(P){for(const k of g.values())k.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,h){let E=this.f[A];return typeof E>"u"&&(E=h),E}update(A,h){this.f[A]=h;const E=this.h.get(A);if(E!==void 0)return E.p;const g=new w.$bh;return this.h.set(A,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$6bc=M;class C extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,h){super(A.identifier.value,!0,h),this.j=A}}e.$7bc=C}),define(Ae[189],Re([1,0,5,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;class C{constructor(A){this.c=A,this.a=new w.$Md,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$Md,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,h,E,g){const k=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(h.value,E,g);this.b.fire(k)}$acceptDirtyStateChanged(A,h){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(h)}$acceptModelSaved(A){const h=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(h.apiNotebook)}}e.$sdc=C}),define(Ae[17],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=void 0,e.$0L=(0,w.$Nh)("IExtHostRpcService");class M{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$$L=M}),define(Ae[190],Re([1,0,20,5]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;class C{#e;constructor(A,h){this.b=new M.$Md,this.onDidChange=this.b.event,this.a=w.$Yl.toKey(A.identifier),this.#e=h,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,h){return this.#e.store(this.a,A,h)}delete(A){return this.#e.delete(this.a,A)}}e.$fcc=C}),define(Ae[56],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=void 0,e.$Nbc=(0,w.$Nh)("IURITransformerService");class M{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Obc=M}),define(Ae[191],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncb=e.$mcb=void 0;class M{constructor(){this.buffers=[]}add(E){let g=this.buffers.indexOf(E);return g<0&&(g=this.buffers.length,this.buffers.push(E)),g}}function C(h,E){if(E.serializeBuffersForPostMessage){const g=new M,k=JSON.stringify(h,(b,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(m)};if(ArrayBuffer.isView(m)){const f=F(m);if(f)return{$$vscode_array_buffer_reference$$:!0,index:g.add(m.buffer),view:{type:f,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),a=g.buffers.map(b=>{const m=new Uint8Array(b);return w.$ae.wrap(m)});return{message:k,buffers:a}}else return{message:JSON.stringify(h),buffers:[]}}e.$mcb=C;function F(h){switch(h.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(h,E){const g=E.map(a=>{const b=new ArrayBuffer(a.byteLength);return new Uint8Array(b).set(a.buffer),b}),P=E.length?(a,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const m=b,{index:f}=m,t=g[f];if(m.view)switch(m.view.type){case 1:return new Int8Array(t,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse(h,P),arrayBuffers:g}}e.$ncb=A}),define(Ae[99],Re([1,0,159,16,2,6,4,30,38,12,41,127,29]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_D=e.$$D=e.$0D=e.EditorsOrder=e.$9D=e.CloseDirection=e.$8D=e.$7D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$6D=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.EditorInputCapabilities=e.$XD=e.SaveReason=e.Verbosity=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=e.$QD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$PD=e.$OD=e.$ND=e.$MD=e.$LD=void 0,e.$LD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$MD={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$ND="workbench.editor.sidebysideEditor",e.$OD="workbench.editors.textDiffEditor",e.$PD="workbench.editors.binaryResourceDiffEditor";var b;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var m;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function f(ce){const $e=ce;return!!$e&&typeof $e.getSelection=="function"&&!!$e.onDidChangeSelection}e.$QD=f;function t(ce,$e,ie){for(const z of ie.visibleEditorPanes)if(z.group.id===$e&&ce.matches(z.input))return z.getViewState()}e.$RD=t;function n(ce){if($(ce))return!1;const $e=ce;return C.URI.isUri($e?.resource)}e.$SD=n;function c(ce){if($(ce))return!1;const $e=ce;return $e?.original!==void 0&&$e.modified!==void 0}e.$TD=c;function v(ce){if($(ce)||c(ce))return!1;const $e=ce;return $e?.primary!==void 0&&$e.secondary!==void 0}e.$UD=v;function D(ce){if($(ce))return!1;const $e=ce;return $e?$e.resource===void 0||$e.resource.scheme===g.Schemas.untitled||$e.forceUntitled===!0:!1}e.$VD=D;function p(ce){if($(ce))return!1;const $e=ce;return C.URI.isUri($e?.base?.resource)&&C.URI.isUri($e?.input1?.resource)&&C.URI.isUri($e?.input2?.resource)&&C.URI.isUri($e?.result?.resource)}e.$WD=p;var r;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var s;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class i{constructor(){this.a=new Map}registerSource($e,ie){let z=this.a.get($e);return z||(z={source:$e,label:ie},this.a.set($e,z)),z.source}getSourceLabel($e){return this.a.get($e)?.label??$e}}e.$XD=new i;var o;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class y extends F.$Rc{}e.$YD=y;function $(ce){return ce instanceof y}e.$ZD=$;function S(ce){const $e=ce;return C.URI.isUri($e?.preferredResource)}function I(ce){const $e=ce;return $($e?.primary)&&$($e?.secondary)}e.$1D=I;function u(ce){const $e=ce;return $($e?.modified)&&$($e?.original)}e.$2D=u;function d(ce,$e,ie,z,q){return Ee(z,[(0,k.$xi)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const ue={...ie,limits:{size:Number.MAX_VALUE}};ce.openEditor($e,ue)}}),(0,k.$xi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}e.$3D=d;function l(ce){return $(ce?.editor)}e.$4D=l;function R(ce){const $e=ce;return l(ce)&&$e?.group!==void 0}e.$5D=R;function B(ce){const $e=ce;return typeof $e?.groupId=="number"&&$($e.editor)}e.$6D=B;var V;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var U;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var W;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class N{getOriginalUri($e,ie){if(!$e)return;if(p($e))return e.$8D.getOriginalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:ue}=this.a($e);if(q&&ue){if(ie?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(ue,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===W.ANY)return this.getOriginalUri(q,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(ue,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===W.PRIMARY?q:ue}}if(c($e)||v($e)||p($e))return;const z=S($e)?$e.preferredResource:$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}a($e){return I($e)||v($e)?{primary:$e.primary,secondary:$e.secondary}:u($e)||c($e)?{primary:$e.modified,secondary:$e.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($e,ie){if(!$e)return;if(p($e))return e.$8D.getCanonicalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:ue}=this.a($e);if(q&&ue){if(ie?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(ue,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===W.ANY)return this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(ue,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===W.PRIMARY?q:ue}}if(c($e)||v($e)||p($e))return;const z=$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}b($e,ie){if(Array.isArray(ie)){if(ie.some(z=>$e.scheme===z))return $e}else if(ie===$e.scheme)return $e}}var O;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function ee(ce,$e,ie,z){if(!ce.isSticky($e))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return ie===O.MOUSE||ie===O.KEYBOARD;case"mouse":return ie===O.MOUSE;case"keyboard":return ie===O.KEYBOARD}return!1}e.$7D=ee,e.$8D=new N;var Z;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(Z||(e.CloseDirection=Z={}));class ye{constructor(){this.c=new Map,this.d=new Map}start($e){const ie=this.a=$e.get(A.$Mh);for(const[z,q]of this.c)this.e(z,q,ie);this.c.clear()}e($e,ie,z){const q=z.createInstance(ie);this.d.set($e,q)}registerFileEditorFactory($e){if(this.b)throw new Error("Can only register one file editor factory.");this.b=$e}getFileEditorFactory(){return(0,M.$If)(this.b)}registerEditorSerializer($e,ie){if(this.c.has($e)||this.d.has($e))throw new Error(`A editor serializer with type ID '${$e}' was already registered.`);return this.a?this.e($e,ie,this.a):this.c.set($e,ie),(0,F.$Pc)(()=>{this.c.delete($e),this.d.delete($e)})}getEditorSerializer($e){return this.d.get(typeof $e=="string"?$e:$e.typeId)}}h.$$m.add(e.$LD.EditorFactory,new ye);async function De(ce,$e,ie){return!ce||!ce.length?[]:await Promise.all(ce.map(async z=>{const q=C.URI.revive(z.fileUri);if(!q){ie.info("Cannot resolve the path because it is not valid.",z);return}if(!await $e.canHandleResource(q)){ie.info("Cannot resolve the path because it cannot be handled",z);return}let we=z.exists,ve=z.type;if(typeof we!="boolean"||typeof ve!="number")try{ve=(await $e.stat(q)).isDirectory?E.FileType.Directory:E.FileType.Unknown,we=!0}catch(ke){ie.error(ke),we=!1}if(!we&&z.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",z);return}if(ve===E.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",z);return}const me={...z.options,pinned:!0};return we?{resource:q,options:me}:{resource:q,options:me,forceUntitled:!0}}))}e.$9D=De;var Pe;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function X(ce){const $e=ce;if(!$e)return!1;const ie=$e;if(ie.modified)return X(ie.modified);const z=$e;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$0D=X;function le(ce){return(0,P.$zi)(ce)}e.$$D=le;function Ee(ce,$e,ie){const z=(0,P.$Ai)(ce,$e);return z.forceMessage=ie?.forceMessage,z.forceSeverity=ie?.forceSeverity,z.allowDialog=ie?.allowDialog,z}e.$_D=Ee}),define(Ae[192],Re([1,0,5,160,4,6,28,30,18,24,89,183]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iE=e.$hE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$gE=e.$fE=e.ViewContentGroups=e.$eE=e.$dE=e.ViewContainerLocation=e.Extensions=e.$cE=void 0,e.$cE=(0,k.$Yv)("default-view-icon",P.$Sj.window,(0,M.localize)(0,null));var a;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(a||(e.Extensions=a={}));var b;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$dE=[0,1,2];function m(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$eE=m;class f extends F.$Rc{constructor(){super(...arguments),this.c=this.B(new w.$Md),this.onDidRegister=this.c.event,this.f=this.B(new w.$Md),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Qb)([...this.g.values()])}registerViewContainer(i,o,y){const $=this.get(i.id);if($)return $;const S=i;return S.openCommandActionDescriptor=y?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,A.$wc)(this.g,o,[]).push(S),y?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:o}),S}deregisterViewContainer(i){for(const o of this.g.keys()){const y=this.g.get(o),$=y?.indexOf(i);if($!==-1){y?.splice($,1),y.length===0&&this.g.delete(o),this.f.fire({viewContainer:i,viewContainerLocation:o});return}}}get(i){return this.all.filter(o=>o.id===i)[0]}getViewContainers(i){return[...this.g.get(i)||[]]}getViewContainerLocation(i){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(y=>y?.id===i.id).length>0)[0]}getDefaultViewContainer(i){return this.h.find(o=>this.getViewContainerLocation(o)===i)}}h.$$m.add(a.ViewContainersRegistry,new f);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function n(s,i){const o=s.group??t.More,y=i.group??t.More;return o!==y?o.localeCompare(y):(s.order??5)-(i.order??5)}class c extends F.$Rc{constructor(){super(...arguments),this.c=this.B(new w.$Md),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$Md),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$Md),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$Md),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Fc}registerViews(i,o){this.registerViews2([{views:i,viewContainer:o}])}registerViews2(i){i.forEach(({views:o,viewContainer:y})=>this.r(o,y)),this.c.fire(i)}deregisterViews(i,o){const y=this.s(i,o);y.length&&this.f.fire({views:y,viewContainer:o})}moveViews(i,o){for(const y of this.m.keys())if(y!==o){const $=this.s(i,y);$.length&&(this.r($,o),this.g.fire({views:$,from:y,to:o}))}}getViews(i){return this.m.get(i)||[]}getView(i){for(const o of this.j){const y=(this.m.get(o)||[]).filter($=>$.id===i)[0];if(y)return y}return null}getViewContainer(i){for(const o of this.j)if((this.m.get(o)||[]).filter($=>$.id===i)[0])return o;return null}registerViewWelcomeContent(i,o){return this.n.add(i,o),this.h.fire(i),(0,F.$Pc)(()=>{this.n.delete(i,o),this.h.fire(i)})}registerViewWelcomeContent2(i,o){const y=new Map;for(const[$,S]of o)this.n.add(i,S),y.set($,(0,F.$Pc)(()=>{this.n.delete(i,S),this.h.fire(i)}));return this.h.fire(i),y}getViewWelcomeContent(i){const o=[];return this.n.forEach(i,y=>o.push(y)),o.sort(n)}r(i,o){let y=this.m.get(o);y||(y=[],this.m.set(o,y),this.j.push(o));for(const $ of i){if(this.getView($.id)!==null)throw new Error((0,M.localize)(1,null,$.id));y.push($)}}s(i,o){const y=this.m.get(o);if(!y)return[];const $=[],S=[];for(const I of y)i.includes(I)?$.push(I):S.push(I);return $.length&&(S.length?this.m.set(o,S):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),$}}h.$$m.add(a.ViewsRegistry,new c),e.$fE=(0,C.$Nh)("viewsService"),e.$gE=(0,C.$Nh)("viewDescriptorService");var v;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(v||(e.ViewVisibilityState=v={}));var D;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(D||(e.TreeItemCollapsibleState=D={}));class p{constructor(i,o){this.c=!1,this.d=!1,(0,g.$2m)(this,i),this.d=!!o,this.resolve=async y=>{if(o&&!this.c){const $=await o(y);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}y.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$hE=p;class r extends Error{constructor(i){super((0,M.localize)(2,null,i)),this.name="NoTreeViewError"}static is(i){return i.name==="NoTreeViewError"}}e.$iE=r}),define(Ae[193],Re([1,0,5,13,161]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scb=void 0;class F{constructor(){this.f=new Map,this.k=[],this.m=new w.$Md,this.n=new w.$Md,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(h){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=h}onEvent(h){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=h}onRequest(h){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=h}sendResponse(h){h.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${h.command}`)):this.s("response",h)}sendRequest(h,E,g,P){const k={command:h};if(E&&Object.keys(E).length>0&&(k.arguments=E),this.s("request",k),typeof P=="number"){const a=setTimeout(()=>{clearTimeout(a);const b=this.f.get(k.seq);if(b){this.f.delete(k.seq);const m={type:"response",seq:0,request_seq:k.seq,success:!1,command:h,message:(0,C.localize)(0,null,P,h)};b(m)}},P)}return g&&this.f.set(k.seq,g),k.seq}acceptMessage(h){this.j?this.j(h):(this.k.push(h),this.k.length===1&&this.q())}o(h,E){return h.type!=="event"||E.type!=="event"}async q(){let h;for(;this.k.length;){if((!h||this.o(this.k[0],h))&&await(0,M.$Tg)(0),h=this.k.shift(),!h)return;switch(h.type){case"event":this.i?.(h);break;case"request":this.g?.(h);break;case"response":{const E=h,g=this.f.get(E.request_seq);g&&(this.f.delete(E.request_seq),g(E));break}}}}s(h,E){E.type=h,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const h=new Map;this.f.forEach((E,g)=>h.set(g,E)),await(0,M.$Tg)(500),h.forEach((E,g)=>{E({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Scb=F}),define(Ae[194],Re([1,0,162,32,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$YG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$XG=e.MemoryRangeType=e.$WG=e.State=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=void 0,e.$UF="workbench.view.debug",e.$VF="workbench.debug.variablesView",e.$WF="workbench.debug.watchExpressionsView",e.$XF="workbench.debug.callStackView",e.$YF="workbench.debug.loadedScriptsView",e.$ZF="workbench.debug.breakPointsView",e.$1F="workbench.debug.disassemblyView",e.$2F="workbench.panel.repl",e.$3F="workbench.panel.repl.view",e.$4F=new M.$5i("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.$5F=new M.$5i("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.$6F=new M.$5i("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.$7F="debugUx",e.$8F=new M.$5i(e.$7F,"default",{type:"string",description:w.localize(3,null)}),e.$9F=new M.$5i("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.$0F=new M.$5i("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.$$F=new M.$5i("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.$_F=new M.$5i("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.$aG=new M.$5i("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.$bG=new M.$5i("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.$cG=new M.$5i("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.$dG=new M.$5i("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.$eG=new M.$5i("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.$fG=new M.$5i("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.$gG=new M.$5i("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.$hG=new M.$5i("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.$iG=new M.$5i("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.$jG=new M.$5i("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.$kG=new M.$5i("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.$lG=new M.$5i("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.$mG=new M.$5i("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.$nG=new M.$5i("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.$oG=new M.$5i("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.$pG=new M.$5i("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.$qG=new M.$5i("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.$rG=new M.$5i("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.$sG=new M.$5i("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.$tG=new M.$5i("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.$uG=new M.$5i("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.$vG=new M.$5i("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.$wG=new M.$5i("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.$xG=new M.$5i("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.$yG=new M.$5i("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.$zG=new M.$5i("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.$AG=new M.$5i("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.$BG=new M.$5i("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.$CG=new M.$5i("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.$DG=new M.$5i("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.$EG=new M.$5i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.$FG=new M.$5i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.$GG=new M.$5i("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.$HG=new M.$5i("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.$IG=new M.$5i("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.$JG=new M.$5i("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.$KG=new M.$5i("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.$LG=new M.$5i("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.$MG=new M.$5i("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.$NG=new M.$5i("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.$OG=new M.$5i("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.$PG=new M.$5i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.$QG=new M.$5i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const F=a=>w.localize(51,null,a);e.$RG=F,e.$SG="editor.contrib.debug",e.$TG="editor.contrib.breakpoint",e.$UG="debug",e.$VG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var A;(function(a){a[a.Inactive=0]="Inactive",a[a.Initializing=1]="Initializing",a[a.Stopped=2]="Stopped",a[a.Running=3]="Running"})(A||(e.State=A={}));function h(a){switch(a){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$WG=h;var E;(function(a){a[a.Valid=0]="Valid",a[a.Unreadable=1]="Unreadable",a[a.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$XG="vscode-debug-memory";var g;(function(a){a[a.Initial=1]="Initial",a[a.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var P;(function(a){a.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$YG=(0,C.$Nh)("debugService");var k;(function(a){a[a.CONDITION=0]="CONDITION",a[a.HIT_COUNT=1]="HIT_COUNT",a[a.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ae[195],Re([1,0,15,2,19,24,12,44,21,18]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=void 0;const P=/{([^}]+)}/g;function k(I,u,d){return I.replace(P,function(l,R){return u&&R.length>0&&R[0]!=="_"?l:d&&d.hasOwnProperty(R)?d[R]:l})}e.$jF=k;function a(I){const u={};for(const d of Object.keys(I))d.startsWith("!")||(u[d]=I[d]);return u}e.$kF=a;function b(I){return I.configuration.request==="attach"&&!m(I)&&(!I.parentSession||b(I.parentSession))}e.$lF=b;function m(I){let u=I.configuration.type;if(u)return u==="vslsShare"&&(u=I.configuration.adapterProxy.configuration.type),(0,w.$1e)(u,"extensionhost")||(0,w.$1e)(u,"pwa-extensionhost")?I:I.parentSession?m(I.parentSession):void 0}e.$mF=m;function f(I){return I.type&&(I.label||I.program||I.runtime)}e.$nF=f;function t(I,u,d){let l,R=0;const B=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=B.exec(I);){const U=V.index+1,W=U+V[0].length;if(U<=u&&W>=d){l=V[0],R=U;break}}if(l){const U=/\w+/g;let W=null;for(;(W=U.exec(l))&&!(W.index+1+R+W[0].length>=d););W&&(l=l.substring(0,U.lastIndex))}return l?{start:R,end:R+l.length-1}:{start:0,end:0}}e.$oF=t;async function n(I,u,d,l){if(I.evaluatableExpressionProvider.has(u)){const R=I.evaluatableExpressionProvider.ordered(u),B=(0,g.$Gb)(await Promise.all(R.map(async V=>{try{return await V.provideEvaluatableExpression(u,d,l??E.CancellationToken.None)}catch{return}})));if(B.length>0){let V=B[0].expression;const U=B[0].range;return V||(V=u.getLineContent(d.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:V}}}else{const R=u.getLineContent(d.lineNumber),{start:B,end:V}=t(R,d.column,d.column),U=R.substring(B-1,V);return{matchingExpression:U,range:new h.$ns(d.lineNumber,B,d.lineNumber,B+U.length)}}return null}e.$pF=n;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(I){return!!(I&&I.match(c))}e.$qF=v;function D(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(v(I.path))return M.URI.parse(I.path);if((0,C.$hc)(I.path))return M.URI.file(I.path)}return I.path}function p(I){if(typeof I.path=="object"){const u=M.URI.revive(I.path);if(u)return u.scheme===A.Schemas.file?u.fsPath:u.toString()}return I.path}function r(I,u){const d=u?D:p,l=(0,F.$Ym)(I);return i(l,(R,B)=>{R&&B&&(B.path=d(B))}),l}e.$rF=r;function s(I,u){const d=u?D:p,l=(0,F.$Ym)(I);return i(l,(R,B)=>{!R&&B&&(B.path=d(B))}),l}e.$sF=s;function i(I,u){switch(I.type){case"event":{const d=I;switch(d.event){case"output":u(!1,d.body.source);break;case"loadedSource":u(!1,d.body.source);break;case"breakpoint":u(!1,d.body.breakpoint.source);break;default:break}break}case"request":{const d=I;switch(d.command){case"setBreakpoints":u(!0,d.arguments.source);break;case"breakpointLocations":u(!0,d.arguments.source);break;case"source":u(!0,d.arguments.source);break;case"gotoTargets":u(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(l=>u(!1,l));break;default:break}break}case"response":{const d=I;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(l=>u(!1,l.source));break;case"loadedSources":d.body.sources.forEach(l=>u(!1,l));break;case"scopes":d.body.scopes.forEach(l=>u(!1,l.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(l=>u(!1,l.source));break;case"setBreakpoints":d.body.breakpoints.forEach(l=>u(!1,l.source));break;case"disassemble":d.body?.instructions.forEach(R=>u(!1,R.location));break;default:break}break}}}function o(I){return I.filter(u=>!u.presentation?.hidden).sort((u,d)=>u.presentation?d.presentation?u.presentation.group?d.presentation.group?u.presentation.group!==d.presentation.group?u.presentation.group.localeCompare(d.presentation.group):y(u.presentation.order,d.presentation.order):-1:d.presentation.group?1:y(u.presentation.order,d.presentation.order):-1:d.presentation?1:0)}e.$tF=o;function y(I,u){return typeof I!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:I-u}async function $(I,u){const d=I.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(d!=="none"&&(await u.saveAll(),d==="allEditorsInActiveGroup")){const l=u.activeEditorPane;l&&l.input.resource?.scheme===A.Schemas.untitled&&await u.save({editor:l.input,groupId:l.group.id})}await I.reloadConfiguration()}e.$uF=$;const S=(I,u)=>!I||!u?I===u:I.name===u.name&&I.path===u.path&&I.sourceReference===u.sourceReference;e.$vF=S}),define(Ae[75],Re([1,0,25,37,66,67,12,19,22,32]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kI=e.$jI=e.$iI=e.$hI=e.CellStatusbarAlignment=e.$gI=e.$fI=e.$eI=e.NotebookEditorPriority=e.$dI=e.$cI=e.$bI=e.$aI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$_H=e.$$H=e.$0H=e.$9H=e.CellKind=e.$8H=e.$7H=e.$6H=void 0,e.$6H="workbench.editor.notebook",e.$7H="workbench.editor.notebookTextDiffEditor",e.$8H="workbench.editor.interactive";var P;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(P||(e.CellKind=P={})),e.$9H=["application/json","application/javascript","text/html","image/svg+xml",F.$Kr.latex,F.$Kr.markdown,"image/png","image/jpeg",F.$Kr.text],e.$0H=[F.$Kr.latex,F.$Kr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$Kr.text],e.$$H=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$_H="_notAvailable";var k;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var a;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(a||(e.NotebookCellExecutionState=a={}));var b;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var m;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(m||(e.NotebookRendererMatch=m={}));var f;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var n;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var c;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var v;(function(O){O.scheme=A.Schemas.vscodeNotebookCell;const ee=["W","X","Y","Z","a","b","c","d","e","f"],Z=new RegExp(`^[${ee.join("")}]+`),ye=7;function De($e,ie){const z=ie.toString(ye),ue=`${z.length<ee.length?ee[z.length-1]:"z"}${z}s${(0,w.$ue)(w.$ae.fromString($e.scheme),!0,!0)}`;return $e.with({scheme:O.scheme,fragment:ue})}O.generate=De;function Pe($e){if($e.scheme!==O.scheme)return;const ie=$e.fragment.indexOf("s");if(ie<0)return;const z=parseInt($e.fragment.substring(0,ie).replace(Z,""),ye),q=(0,w.$te)($e.fragment.substring(ie+1)).toString();if(!isNaN(z))return{handle:z,notebook:$e.with({scheme:q,fragment:null})}}O.parse=Pe;function X($e,ie){return $e.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${$e.scheme!==A.Schemas.file?$e.scheme:""}`})}O.generateCellOutputUri=X;function le($e){if($e.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!ie)return;const z=ie[1]&&ie[1]!==""?ie[1]:void 0,q=ie[2];return{outputId:z,notebook:$e.with({scheme:q||A.Schemas.file,fragment:null})}}O.parseCellOutputUri=le;function Ee($e,ie,z){return O.generate($e,ie).with({scheme:z})}O.generateCellPropertyUri=Ee;function ce($e,ie){if($e.scheme===ie)return O.parse($e.with({scheme:O.scheme}))}O.parseCellPropertyUri=ce})(v||(e.CellUri=v={}));const D=O=>E.$j?O.replace(/\//g,"\\"):O;class p{constructor(ee=[],Z=e.$9H){this.e=Z,this.d=[...new Set(ee)].map(ye=>({pattern:ye,matches:M.$uj(D(ye))}))}sort(ee){const Z=new Map(C.Iterable.map(ee,De=>[De,D(De)]));let ye=[];for(const{matches:De}of this.d)for(const[Pe,X]of Z)if(De(X)){ye.push(Pe),Z.delete(Pe);break}return Z.size&&(ye=ye.concat([...Z.keys()].sort((De,Pe)=>this.e.indexOf(De)-this.e.indexOf(Pe)))),ye}prioritize(ee,Z){const ye=this.f(ee);if(ye===-1){this.d.unshift({pattern:ee,matches:M.$uj(D(ee))});return}const De=new Set(Z.map(X=>this.f(X,ye)));De.delete(-1);const Pe=Array.from(De).sort();this.d.splice(ye+1,0,...Pe.map(X=>this.d[X]));for(let X=Pe.length-1;X>=0;X--)this.d.splice(Pe[X],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,Z=this.d.length){const ye=D(ee);for(let De=0;De<Z;De++)if(this.d[De].matches(ye))return De;return-1}}e.$aI=p;function r(O,ee,Z,ye=(De,Pe)=>De===Pe){const De=[];function Pe(Ee,ce,$e){if(ce===0&&$e.length===0)return;const ie=De[De.length-1];ie&&ie.start+ie.deleteCount===Ee?(ie.deleteCount+=ce,ie.toInsert.push(...$e)):De.push({start:Ee,deleteCount:ce,toInsert:$e})}let X=0,le=0;for(;;){if(X===O.length){Pe(X,0,ee.slice(le));break}if(le===ee.length){Pe(X,O.length-X,[]);break}const Ee=O[X],ce=ee[le];if(ye(Ee,ce)){X+=1,le+=1;continue}Z(ce)?(Pe(X,1,[]),X+=1):(Pe(X,0,[ce]),le+=1)}return De}e.$bI=r,e.$cI=new g.$5i("notebookEditorCursorAtBoundary","none"),e.$dI=new g.$5i("notebookEditorCursorAtLineBoundary","none");var s;(function(O){O.default="default",O.option="option"})(s||(e.NotebookEditorPriority=s={}));function i(O){const ee=O;return!!((typeof ee.include=="string"||M.$vj(ee.include))&&(typeof ee.exclude=="string"||M.$vj(ee.exclude)))}e.$eI=i;function o(O,ee,Z){if(Array.isArray(O.viewType)&&O.viewType.indexOf(ee)>=0||O.viewType===ee)return!0;if(O.filenamePattern){const ye=i(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,De=i(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(M.$tj(ye,(0,h.$mc)(Z.fsPath).toLowerCase()))return!(De&&M.$tj(De,(0,h.$mc)(Z.fsPath).toLowerCase()))}return!1}e.$fI=o,e.$gI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var y;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class ${static{this.d="notebook/"}static create(ee){return`${$.d}${ee}`}static parse(ee){if(ee.startsWith($.d))return ee.substring($.d.length)}}e.$hI=$;function S(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$iI=S;const I=new TextDecoder;function u(O){const ee=[];let Z=!1;for(const X of O)(ee.length===0||Z)&&(ee.push(X),Z=!0);let ye=R(ee);const De=w.$ae.concat(ee.map(X=>w.$ae.wrap(X))),Pe=N(De);return ye=ye||Pe.byteLength!==De.byteLength,{data:Pe,didCompression:ye}}e.$jI=u,e.$kI=`${String.fromCharCode(27)}[A`;const d=e.$kI.split("").map(O=>O.charCodeAt(0)),l=10;function R(O){let ee=!1;return O.forEach((Z,ye)=>{if(ye===0||Z.length<e.$kI.length)return;const De=O[ye-1],Pe=Z.subarray(0,e.$kI.length);if(Pe[0]===d[0]&&Pe[1]===d[1]&&Pe[2]===d[2]){const X=De.lastIndexOf(l);if(X===-1)return;ee=!0,O[ye-1]=De.subarray(0,X),O[ye]=Z.subarray(e.$kI.length)}}),ee}function B(O){let ee=O;do O=ee,ee=O.replace(/[^\n]\x08/gm,"");while(ee.length<O.length);return O}function V(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const ee=O.match(/^(.*)\r+/m)[1];let Z=O.match(/\r+(.*)$/m)[1];Z=Z+ee.slice(Z.length,ee.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Z)}return O}const U="\b".charCodeAt(0),W="\r".charCodeAt(0);function N(O){return!O.buffer.includes(U)&&!O.buffer.includes(W)?O:w.$ae.fromString(V(B(I.decode(O.buffer))))}}),define(Ae[7],Re([1,0,18,9,50,28,67,15,16,2,36,20,38,97,75]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m){"use strict";var f,t,n,c,v,D,p,r,s,i,o,y,$,S,I,u,d,l;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$YL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.TestRunProfileKind=e.TestResultState=e.$FL=e.$EL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$DL=e.$CL=e.$BL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$AL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.ColorThemeKind=e.$uL=e.$tL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$sL=e.DebugConsoleMode=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$mL=e.$lL=e.FileChangeType=e.$kL=e.$jL=e.$iL=e.$hL=e.InlineCompletionTriggerKind=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.ConfigurationTarget=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$WK=e.ViewBadge=e.ProgressLocation=e.$VK=e.$UK=e.TaskScope=e.ShellQuoting=e.$TK=e.$SK=e.$RK=e.TaskPanelKind=e.TaskRevealKind=e.$QK=e.TerminalLocation=e.$PK=e.$OK=e.$NK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$MK=e.$LK=e.$KK=e.$JK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$IK=e.StatusBarAlignment=e.ViewColumn=e.$HK=e.$GK=e.$FK=e.$EK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$DK=e.$CK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.LanguageStatusSeverity=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.CodeActionTriggerKind=e.$qK=e.$pK=e.SymbolTag=e.SymbolKind=e.$oK=e.DocumentHighlightKind=e.$nK=e.$mK=e.$lK=e.$kK=e.DiagnosticSeverity=e.DiagnosticTag=e.$jK=e.$iK=e.FileEditType=e.$hK=e.$gK=e.$fK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function R(j){return Object.assign(j,{apply:function(...ne){if(ne.length===0)return Reflect.construct(j,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(j,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(j,[]);{const[Se,...He]=ne;return Reflect.construct(j,He,Se.constructor)}}})}var B;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(B||(e.TerminalOutputAnchor=B={}));var V;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let U=f=class{static from(...L){let ne=L;return new f(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$$J=U,e.$$J=U=f=Ke([R],U);let W=t=class{static Min(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Se=1;Se<L.length;Se++){const He=L[Se];He.isBefore(ne)&&(ne=He)}return ne}static Max(...L){if(L.length===0)throw new TypeError;let ne=L[0];for(let Se=1;Se<L.length;Se++){const He=L[Se];He.isAfter(ne)&&(ne=He)}return ne}static isPosition(L){if(!L)return!1;if(L instanceof t)return!0;const{line:ne,character:Se}=L;return typeof ne=="number"&&typeof Se=="number"}static of(L){if(L instanceof t)return L;if(this.isPosition(L))return new t(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,ne){if(L<0)throw(0,M.$6)("line must be non-negative");if(ne<0)throw(0,M.$6)("character must be non-negative");this.c=L,this.e=ne}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,ne=0){if(L===null||ne===null)throw(0,M.$6)();let Se;return typeof L>"u"?Se=0:typeof L=="number"?Se=L:(Se=typeof L.lineDelta=="number"?L.lineDelta:0,ne=typeof L.characterDelta=="number"?L.characterDelta:0),Se===0&&ne===0?this:new t(this.line+Se,this.character+ne)}with(L,ne=this.character){if(L===null||ne===null)throw(0,M.$6)();let Se;return typeof L>"u"?Se=this.line:typeof L=="number"?Se=L:(Se=typeof L.line=="number"?L.line:this.line,ne=typeof L.character=="number"?L.character:this.character),Se===this.line&&ne===this.character?this:new t(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$_J=W,e.$_J=W=t=Ke([R],W);let N=n=class{static isRange(L){return L instanceof n?!0:L?W.isPosition(L.start)&&W.isPosition(L.end):!1}static of(L){if(L instanceof n)return L;if(this.isRange(L))return new n(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,ne,Se,He){let Ze,ot;if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof He=="number"?(Ze=new W(L,ne),ot=new W(Se,He)):W.isPosition(L)&&W.isPosition(ne)&&(Ze=W.of(L),ot=W.of(ne)),!Ze||!ot)throw new Error("Invalid arguments");Ze.isBefore(ot)?(this.c=Ze,this.e=ot):(this.c=ot,this.e=Ze)}contains(L){return n.isRange(L)?this.contains(L.start)&&this.contains(L.end):W.isPosition(L)?!(W.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const ne=W.Max(L.start,this.c),Se=W.Min(L.end,this.e);if(!ne.isAfter(Se))return new n(ne,Se)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ne=W.Min(L.start,this.c),Se=W.Max(L.end,this.end);return new n(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,ne=this.end){if(L===null||ne===null)throw(0,M.$6)();let Se;return L?W.isPosition(L)?Se=L:(Se=L.start||this.start,ne=L.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new n(Se,ne)}toJSON(){return[this.start,this.end]}};e.$aK=N,e.$aK=N=n=Ke([R],N);let O=c=class extends N{static isSelection(L){return L instanceof c?!0:L?N.isRange(L)&&W.isPosition(L.anchor)&&W.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,ne,Se,He){let Ze,ot;if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof He=="number"?(Ze=new W(L,ne),ot=new W(Se,He)):W.isPosition(L)&&W.isPosition(ne)&&(Ze=W.of(L),ot=W.of(ne)),!Ze||!ot)throw new Error("Invalid arguments");super(Ze,ot),this.f=Ze,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$bK=O,e.$bK=O=c=Ke([R],O);const ee=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,M.$6)("connectionToken")};class Z{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ne,Se){if(typeof L!="string"||L.length===0)throw(0,M.$6)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,M.$6)("port");typeof Se<"u"&&ee(Se),this.host=L,this.port=Math.round(ne),this.connectionToken=Se}}e.$cK=Z;class ye{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ne){this.makeConnection=L,this.connectionToken=ne,typeof ne<"u"&&ee(ne)}}e.$dK=ye;class De extends Error{static NotAvailable(L,ne){return new De(L,b.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(L){return new De(L,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,ne=b.RemoteAuthorityResolverErrorCode.Unknown,Se){super(L),this._message=L,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,De.prototype)}}e.$eK=De;var Pe;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var X;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let le=v=class{static isTextEdit(L){return L instanceof v?!0:L?N.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ne){return new v(L,ne)}static insert(L,ne){return v.replace(new N(L,L),ne)}static delete(L){return v.replace(L,"")}static setEndOfLine(L){const ne=new v(new N(new W(0,0),new W(0,0)),"");return ne.newEol=L,ne}get range(){return this.c}set range(L){if(L&&!N.isRange(L))throw(0,M.$6)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,M.$6)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,M.$6)("newEol");this.f=L}constructor(L,ne){this.c=L,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$fK=le,e.$fK=le=v=Ke([R],le);let Ee=D=class{static isNotebookCellEdit(L){return L instanceof D?!0:L?Xt.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ne){return new D(L,ne)}static insertCells(L,ne){return new D(new Xt(L,L),ne)}static deleteCells(L){return new D(L,[])}static updateCellMetadata(L,ne){const Se=new D(new Xt(L,L),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(L){const ne=new D(new Xt(0,0),[]);return ne.newNotebookMetadata=L,ne}constructor(L,ne){this.range=L,this.newCells=ne}};e.$gK=Ee,e.$gK=Ee=D=Ke([R],Ee);class ce{static isSnippetTextEdit(L){return L instanceof ce?!0:L?N.isRange(L.range)&&z.isSnippetString(L.snippet):!1}static replace(L,ne){return new ce(L,ne)}static insert(L,ne){return ce.replace(new N(L,L),ne)}constructor(L,ne){this.range=L,this.snippet=ne}}e.$hK=ce;var $e;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,ne,Se,He){this.c.push({_type:1,from:L,to:ne,options:Se,metadata:He})}createFile(L,ne,Se){this.c.push({_type:1,from:void 0,to:L,options:ne,metadata:Se})}deleteFile(L,ne,Se){this.c.push({_type:1,from:L,to:void 0,options:ne,metadata:Se})}e(L,ne,Se){this.c.push({_type:3,metadata:Se,uri:L,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(L,ne,Se,He){const Ze=ne.start,ot=ne.end;(Ze!==ot||Se.length>0)&&this.c.push({_type:5,uri:L,index:Ze,count:ot-Ze,cells:Se,metadata:He})}g(L,ne,Se,He){this.c.push({_type:3,metadata:He,uri:L,edit:{editType:3,index:ne,metadata:Se}})}replace(L,ne,Se,He){this.c.push({_type:2,uri:L,edit:new le(ne,Se),metadata:He})}insert(L,ne,Se,He){this.replace(L,new N(ne,ne),Se,He)}delete(L,ne,Se){this.replace(L,ne,"",Se)}has(L){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===L.toString())}set(L,ne){if(ne)for(const Se of ne){if(!Se)continue;let He,Ze;Array.isArray(Se)?(He=Se[0],Ze=Se[1]):He=Se,Ee.isNotebookCellEdit(He)?He.newCellMetadata?this.g(L,He.range.start,He.newCellMetadata,Ze):He.newNotebookMetadata?this.e(L,He.newNotebookMetadata,Ze):this.f(L,He.range,He.newCells,Ze):ce.isSnippetTextEdit(He)?this.c.push({_type:6,uri:L,range:He.range,edit:He.snippet,metadata:Ze}):this.c.push({_type:2,uri:L,edit:He,metadata:Ze})}else{for(let Se=0;Se<this.c.length;Se++){const He=this.c[Se];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===L.toString()&&(this.c[Se]=void 0);break}}(0,w.$Hb)(this.c)}}get(L){const ne=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===L.toString()&&ne.push(Se.edit);return ne}entries(){const L=new F.$zc;for(const ne of this.c)if(ne._type===2){let Se=L.get(ne.uri);Se||(Se=[ne.uri,[]],L.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$iK=ie,e.$iK=ie=Ke([R],ie);let z=p=class{static isSnippetString(L){return L instanceof p?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=p.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ne=this.e++){if(typeof L=="function"){const Se=new p;Se.e=this.e,L(Se),this.e=Se.e,L=Se.value}else L=p.c(L);return this.value+="${",this.value+=ne,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ne=this.e++){const Se=L.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(L,ne){if(typeof ne=="function"){const Se=new p;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$jK=z,e.$jK=z=p=Ke([R],z);var q;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var ue;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ue||(e.DiagnosticSeverity=ue={}));let we=r=class{static isLocation(L){return L instanceof r?!0:L?N.isRange(L.range)&&g.URI.isUri(L.uri):!1}constructor(L,ne){if(this.uri=L,ne)if(N.isRange(ne))this.range=N.of(ne);else if(W.isPosition(ne))this.range=new N(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$kK=we,e.$kK=we=r=Ke([R],we);let ve=class{static is(L){return L?typeof L.message=="string"&&L.location&&N.isRange(L.location.range)&&g.URI.isUri(L.location.uri):!1}constructor(L,ne){this.location=L,this.message=ne}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.location.range.isEqual(ne.location.range)&&L.location.uri.toString()===ne.location.uri.toString()}};e.$lK=ve,e.$lK=ve=Ke([R],ve);let me=class{constructor(L,ne,Se=ue.Error){if(!N.isRange(L))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=L,this.message=ne,this.severity=Se}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ne){return L===ne?!0:!L||!ne?!1:L.message===ne.message&&L.severity===ne.severity&&L.code===ne.code&&L.severity===ne.severity&&L.source===ne.source&&L.range.isEqual(ne.range)&&(0,w.$tb)(L.tags,ne.tags)&&(0,w.$tb)(L.relatedInformation,ne.relatedInformation,ve.isEqual)}};e.$mK=me,e.$mK=me=Ke([R],me);let ke=class{constructor(L,ne){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ne}};e.$nK=ke,e.$nK=ke=Ke([R],ke);var re;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let he=class{constructor(L,ne=re.Text){this.range=L,this.kind=ne}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$oK=he,e.$oK=he=Ke([R],he);var se;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(se||(e.SymbolKind=se={}));var oe;(function(j){j[j.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let de=s=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,ne,Se,He,Ze){this.name=L,this.kind=ne,this.containerName=Ze,typeof Se=="string"&&(this.containerName=Se),He instanceof we?this.location=He:Se instanceof N&&(this.location=new we(He,Se)),s.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};e.$pK=de,e.$pK=de=s=Ke([R],de);let Ie=i=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(i.validate)}constructor(L,ne,Se,He,Ze){this.name=L,this.detail=ne,this.kind=Se,this.range=He,this.selectionRange=Ze,this.children=[],i.validate(this)}};e.$qK=Ie,e.$qK=Ie=i=Ke([R],Ie);var T;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(T||(e.CodeActionTriggerKind=T={}));let K=class{constructor(L,ne){this.title=L,this.kind=ne}};e.$rK=K,e.$rK=K=Ke([R],K);let G=class{static{o=this}static{this.c="."}constructor(L){this.value=L}append(L){return new o(this.value?this.value+o.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+o.c)}};e.$sK=G,e.$sK=G=o=Ke([R],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let Q=class{constructor(L,ne){if(this.range=L,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$tK=Q,e.$tK=Q=Ke([R],Q);class H{constructor(L,ne,Se,He,Ze,ot){this.kind=L,this.name=ne,this.detail=Se,this.uri=He,this.range=Ze,this.selectionRange=ot}}e.$uK=H;class _{constructor(L,ne){this.fromRanges=ne,this.from=L}}e.$vK=_;class ae{constructor(L,ne){this.fromRanges=ne,this.to=L}}e.$wK=ae;var Fe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Fe||(e.LanguageStatusSeverity=Fe={}));let Ue=class{constructor(L,ne){this.range=L,this.command=ne}get isResolved(){return!!this.command}};e.$xK=Ue,e.$xK=Ue=Ke([R],Ue);let Qe=y=class{#e;static isMarkdownString(L){return L instanceof y?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,ne=!1){this.#e=new C.$1j(L,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,ne){return this.#e.appendCodeblock(ne??"",L),this}};e.$yK=Qe,e.$yK=Qe=y=Ke([R],Qe);let Je=class{constructor(L,ne){this.label=L,this.documentation=ne}};e.$zK=Je,e.$zK=Je=Ke([R],Je);let xe=class{constructor(L,ne){this.label=L,this.documentation=ne,this.parameters=[]}};e.$AK=xe,e.$AK=xe=Ke([R],xe);let Xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$BK=Xe,e.$BK=Xe=Ke([R],Xe);var _e;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(_e||(e.SignatureHelpTriggerKind=_e={}));var it;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(L){this.value=L}};e.$CK=tt,e.$CK=tt=Ke([R],tt);let ze=class{constructor(L,ne,Se){this.position=L,this.label=ne,this.kind=Se}};e.$DK=ze,e.$DK=ze=Ke([R],ze);var st;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var x;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(x||(e.CompletionItemKind=x={}));var Y;(function(j){j[j.Deprecated=1]="Deprecated"})(Y||(e.CompletionItemTag=Y={}));let pe=class{constructor(L,ne){this.label=L,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&x[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$EK=pe,e.$EK=pe=Ke([R],pe);let Be=class{constructor(L=[],ne=!1){this.items=L,this.isIncomplete=ne}};e.$FK=Be,e.$FK=Be=Ke([R],Be);let Oe=class{constructor(L,ne,Se){this.insertText=L,this.range=ne,this.command=Se}};e.$GK=Oe,e.$GK=Oe=Ke([R],Oe);let Ye=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$HK=Ye,e.$HK=Ye=Ke([R],Ye);var rt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var gt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(gt||(e.StatusBarAlignment=gt={}));function yt(j,L){return`${k.$Yl.toKey(j)}.${L}`}e.$IK=yt;var Pt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Yt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Yt||(e.TextDocumentSaveReason=Yt={}));var qt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(qt||(e.TextEditorRevealType=qt={}));var bt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(bt||(e.TextEditorSelectionChangeKind=bt={}));var Ut;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Ft;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ft||(e.DecorationRangeBehavior=Ft={})),function(j){function L(ne){switch(ne){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=L}(bt||(e.TextEditorSelectionChangeKind=bt={}));var jt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(jt||(e.SyntaxTokenType=jt={})),function(j){function L(ne){switch(ne){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=L}(jt||(e.SyntaxTokenType=jt={}));let At=class{constructor(L,ne){if(ne&&!g.URI.isUri(ne))throw(0,M.$6)("target");if(!N.isRange(L)||L.isEmpty)throw(0,M.$6)("range");this.range=L,this.target=ne}};e.$JK=At,e.$JK=At=Ke([R],At);let Rt=class{constructor(L,ne,Se,He){this.red=L,this.green=ne,this.blue=Se,this.alpha=He}};e.$KK=Rt,e.$KK=Rt=Ke([R],Rt);let Nt=class{constructor(L,ne){if(ne&&!(ne instanceof Rt))throw(0,M.$6)("color");if(!N.isRange(L)||L.isEmpty)throw(0,M.$6)("range");this.range=L,this.color=ne}};e.$LK=Nt,e.$LK=Nt=Ke([R],Nt);let Bt=class{constructor(L){if(!L||typeof L!="string")throw(0,M.$6)("label");this.label=L}};e.$MK=Bt,e.$MK=Bt=Ke([R],Bt);var Kt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Kt||(e.ColorFormat=Kt={}));var Wt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var at;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(at||(e.TerminalExitReason=at={}));class ut{constructor(L,ne,Se){if(this.startIndex=L,this.length=ne,this.tooltip=Se,typeof L!="number"||L<0)throw(0,M.$6)("startIndex");if(typeof ne!="number"||ne<1)throw(0,M.$6)("length");if(Se!==void 0&&typeof Se!="string")throw(0,M.$6)("tooltip")}}e.$NK=ut;class Jt{constructor(L){this.uri=L}}e.$OK=Jt;class Ct{constructor(L){this.terminalCommand=L}}e.$PK=Ct;var Dt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class ht{constructor(L){if(this.options=L,typeof L!="object")throw(0,M.$6)("options")}}e.$QK=ht;var St;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(St||(e.TaskRevealKind=St={}));var Lt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Lt||(e.TaskPanelKind=Lt={}));let Et=class{static{$=this}static{this.Clean=new $("clean","Clean")}static{this.Build=new $("build","Build")}static{this.Rebuild=new $("rebuild","Rebuild")}static{this.Test=new $("test","Test")}static from(L){switch(L){case"clean":return $.Clean;case"build":return $.Build;case"rebuild":return $.Rebuild;case"test":return $.Test;default:return}}constructor(L,ne){if(this.label=ne,typeof L!="string"||typeof ne!="string")throw(0,M.$6)("name");this.c=L}get id(){return this.c}};e.$RK=Et,e.$RK=Et=$=Ke([R],Et);function qe(j){let L="";for(let ne=0;ne<j.length;ne++)L+=j[ne].replace(/,/g,",,")+",";return L}let Ot=class{constructor(L,ne,Se){if(typeof L!="string")throw(0,M.$6)("process");this.e=[],this.c=L,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,M.$6)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)L.push(ne);return qe(L)}};e.$SK=Ot,e.$SK=Ot=Ke([R],Ot);let Ce=class{constructor(L,ne,Se){if(this.f=[],Array.isArray(ne)){if(!L)throw(0,M.$6)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$6)("command");this.e=L,this.f=ne,this.g=Se}else{if(typeof L!="string")throw(0,M.$6)("commandLine");this.c=L,this.g=ne}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,M.$6)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$6)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)L.push(typeof ne=="string"?ne:ne.value);return qe(L)}};e.$TK=Ce,e.$TK=Ce=Ke([R],Ce);var Me;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Me||(e.ShellQuoting=Me={}));var ge;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(ge||(e.TaskScope=ge={}));class J{constructor(L){this.c=L}computeId(){return"customExecution"+(0,P.$dg)()}set callback(L){this.c=L}get callback(){return this.c}}e.$UK=J;let Te=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,ne,Se,He,Ze,ot){this.j=!1,this.k=this.definition=L;let lt;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=Se,this.execution=He,lt=Ze,this.j=!0):ne===ge.Global||ne===ge.Workspace?(this.target=ne,this.m=this.name=Se,this.t=this.source=He,this.execution=Ze,lt=ot):(this.target=ne,this.m=this.name=Se,this.t=this.source=He,this.execution=Ze,lt=ot),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(L){this.h=L}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ot?this.k={type:S.e,id:this.n.computeId()}:this.n instanceof Ce?this.k={type:S.f,id:this.n.computeId()}:this.n instanceof J?this.k={type:S.c,id:this.n.computeId()}:this.k={type:S.g,id:(0,P.$dg)()}}get definition(){return this.k}set definition(L){if(L==null)throw(0,M.$6)("Kind can't be undefined or null");this.z(),this.k=L}get scope(){return this.l}set target(L){this.z(),this.l=L}get name(){return this.m}set name(L){if(typeof L!="string")throw(0,M.$6)("name");this.z(),this.m=L}get execution(){return this.n}set execution(L){L===null&&(L=void 0),this.z(),this.n=L;const ne=this.k.type;(S.g===ne||S.e===ne||S.f===ne||S.c===ne)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(L){if(Array.isArray(L))this.z(),this.o=L,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.z(),this.r=L}get source(){return this.t}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.$6)("source must be a string of length > 0");this.z(),this.t=L}get group(){return this.u}set group(L){L===null&&(L=void 0),this.z(),this.u=L}get detail(){return this.y}set detail(L){L===null&&(L=void 0),this.y=L}get presentationOptions(){return this.w}set presentationOptions(L){L==null&&(L=Object.create(null)),this.z(),this.w=L}get runOptions(){return this.x}set runOptions(L){L==null&&(L=Object.create(null)),this.z(),this.x=L}};e.$VK=Te,e.$VK=Te=S=Ke([R],Te);var je;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(je||(e.ProgressLocation=je={}));var Ge;(function(j){function L(ne){const Se=ne;return(0,E.$Bf)(Se.value)?Se.tooltip&&!(0,E.$xf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}j.isViewBadge=L})(Ge||(e.ViewBadge=Ge={}));let We=I=class{static isTreeItem(L,ne){const Se=L;if(Se.checkboxState!==void 0){const He=(0,E.$Bf)(Se.checkboxState)?Se.checkboxState:(0,E.$zf)(Se.checkboxState)&&(0,E.$Bf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Ze=!(0,E.$Bf)(Se.checkboxState)&&(0,E.$zf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(He===void 0||He!==pt.Checked&&He!==pt.Unchecked||Ze!==void 0&&!(0,E.$xf)(Ze))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(L instanceof I)return!0;if(Se.label!==void 0&&!(0,E.$xf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,E.$xf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,E.$xf)(Se.iconPath)&&!g.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,E.$xf)(Se.iconPath.id))){const He=Se.iconPath;if(!He||!(0,E.$xf)(He.light)&&!g.URI.isUri(He.light)&&!(0,E.$xf)(He.dark)&&!g.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,E.$xf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!g.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,E.$xf)(Se.tooltip)&&!(Se.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<et.None&&Se.collapsibleState>et.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,E.$xf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(L,ne=et.None){this.collapsibleState=ne,g.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$WK=We,e.$WK=We=I=Ke([R],We);var et;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(et||(e.TreeItemCollapsibleState=et={}));var pt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(pt||(e.TreeItemCheckboxState=pt={}));let vt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$XK=vt,e.$XK=vt=Ke([R],vt);class dt extends vt{}e.$YK=dt;class ft extends dt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$ZK=ft;class mt{constructor(L,ne,Se,He){this.name=L,this.uri=ne,this._itemId=Se,this.c=He}data(){return this.c()}}e.$1K=mt;let gi=class{#e=new Map;constructor(L){for(const[ne,Se]of L??[]){const He=this.#e.get(this.#t(ne));He?He.push(Se):this.#e.set(this.#t(ne),[Se])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,ne){this.#e.set(this.#t(L),[ne])}forEach(L,ne){for(const[Se,He]of this.#e)for(const Ze of He)L.call(ne,Ze,Se,this)}*[Symbol.iterator](){for(const[L,ne]of this.#e)for(const Se of ne)yield[L,Se]}#t(L){return L.toLowerCase()}};e.$2K=gi,e.$2K=gi=Ke([R],gi);let Ht=class{constructor(L){this.insertText=L}};e.$3K=Ht,e.$3K=Ht=Ke([R],Ht);let Ei=class{constructor(L,ne){this.label=ne,this.insertText=L}};e.$4K=Ei,e.$4K=Ei=Ke([R],Ei);let Vt=class{constructor(L,ne){this.id=L,this.color=ne}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$5K=Vt,e.$5K=Vt=Ke([R],Vt),Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let mi=class{constructor(L){this.id=L}};e.$6K=mi,e.$6K=mi=Ke([R],mi);var It;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(It||(e.ConfigurationTarget=It={}));let Di=class{get base(){return this.c}set base(L){this.c=L,this.e=g.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,ne){if(typeof L!="string"&&(!L||!g.URI.isUri(L)&&!g.URI.isUri(L.uri)))throw(0,M.$6)("base");if(typeof ne!="string")throw(0,M.$6)("pattern");typeof L=="string"?this.baseUri=g.URI.file(L):g.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$7K=Di,e.$7K=Di=Ke([R],Di);const Vi=new WeakMap;function kt(j,L){Vi.set(j,L)}e.$8K=kt;let ti=class{constructor(L,ne,Se,He){this.enabled=typeof L=="boolean"?L:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=Vi.get(this)??(0,P.$dg)()),this.c}};e.$9K=ti,e.$9K=ti=Ke([R],ti);let $i=class extends ti{constructor(L,ne,Se,He,Ze){if(super(ne,Se,He,Ze),L===null)throw(0,M.$6)("location");this.location=L}};e.$0K=$i,e.$0K=$i=Ke([R],$i);let si=class extends ti{constructor(L,ne,Se,He,Ze){super(ne,Se,He,Ze),this.functionName=L}};e.$$K=si,e.$$K=si=Ke([R],si);let ki=class extends ti{constructor(L,ne,Se,He,Ze,ot,lt){if(super(He,Ze,ot,lt),!ne)throw(0,M.$6)("dataId");this.label=L,this.dataId=ne,this.canPersist=Se}};e.$_K=ki,e.$_K=ki=Ke([R],ki);let Si=class{constructor(L,ne,Se){this.command=L,this.args=ne||[],this.options=Se}};e.$aL=Si,e.$aL=Si=Ke([R],Si);let Mt=class{constructor(L,ne){this.port=L,this.host=ne}};e.$bL=Mt,e.$bL=Mt=Ke([R],Mt);let pi=class{constructor(L){this.path=L}};e.$cL=pi,e.$cL=pi=Ke([R],pi);let Ii=class{constructor(L){this.implementation=L}};e.$dL=Ii,e.$dL=Ii=Ke([R],Ii);let oi=class{constructor(L,ne,Se){this.session=L,this.threadId=ne,this.frameId=Se}};e.$eL=oi,e.$eL=oi=Ke([R],oi);let ai=class{constructor(L,ne){this.session=L,this.threadId=ne}};e.$fL=ai,e.$fL=ai=Ke([R],ai);let ct=class{constructor(L,ne){this.range=L,this.expression=ne}};e.$gL=ct,e.$gL=ct=Ke([R],ct);var qi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let Zt=class{constructor(L,ne){this.range=L,this.text=ne}};e.$hL=Zt,e.$hL=Zt=Ke([R],Zt);let ii=class{constructor(L,ne,Se=!0){this.range=L,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$iL=ii,e.$iL=ii=Ke([R],ii);let vi=class{constructor(L,ne){this.range=L,this.expression=ne}};e.$jL=vi,e.$jL=vi=Ke([R],vi);let Ci=class{constructor(L,ne){this.frameId=L,this.stoppedLocation=ne}};e.$kL=Ci,e.$kL=Ci=Ke([R],Ci);var Ki;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Pi=u=class extends Error{static FileExists(L){return new u(L,a.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(L){return new u(L,a.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(L){return new u(L,a.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(L){return new u(L,a.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(L){return new u(L,a.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(L){return new u(L,a.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(L,ne=a.FileSystemProviderErrorCode.Unknown,Se){super(g.URI.isUri(L)?L.toString(!0):L),this.code=Se?.name??"Unknown",(0,a.$kk)(this,ne),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$lL=Pi,e.$lL=Pi=u=Ke([R],Pi);let bi=class{constructor(L,ne,Se){this.start=L,this.end=ne,this.kind=Se}};e.$mL=bi,e.$mL=bi=Ke([R],bi);var Hi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Ai;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ci;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var Ji;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Ji||(e.CommentState=Ji={}));var wi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(L,ne=[]){this.tokenTypes=L,this.tokenModifiers=ne}}e.$nL=Ri;function cn(j){return typeof j>"u"||(0,E.$yf)(j)}class Mi{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,L){this.l=!0;for(let ne=0,Se=L.tokenTypes.length;ne<Se;ne++)this.j.set(L.tokenTypes[ne],ne);for(let ne=0,Se=L.tokenModifiers.length;ne<Se;ne++)this.k.set(L.tokenModifiers[ne],ne)}}push(L,ne,Se,He,Ze){if(typeof L=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof He=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.n(L,ne,Se,He,Ze);if(N.isRange(L)&&typeof ne=="string"&&cn(Se))return this.m(L,ne,Se);throw(0,M.$6)()}m(L,ne,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,Ze=L.start.character,ot=L.end.character-L.start.character,lt=this.j.get(ne);let zt=0;if(Se)for(const Qt of Se){if(!this.k.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this.k.get(Qt);zt|=1<<_t>>>0}this.n(He,Ze,ot,lt,zt)}n(L,ne,Se,He,Ze){if(this.f&&(L<this.c||L===this.c&&ne<this.e)){this.f=!1;const zt=this.g.length/5|0;let Qt=0,_t=0;for(let ei=0;ei<zt;ei++){let ri=this.g[5*ei],Bi=this.g[5*ei+1];ri===0?(ri=Qt,Bi+=_t):ri+=Qt,this.g[5*ei]=ri,this.g[5*ei+1]=Bi,Qt=ri,_t=Bi}}let ot=L,lt=ne;this.f&&this.h>0&&(ot-=this.c,ot===0&&(lt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=He,this.g[this.h++]=Ze,this.c=L,this.e=ne}static o(L){const ne=[],Se=L.length/5|0;for(let lt=0;lt<Se;lt++)ne[lt]=lt;ne.sort((lt,zt)=>{const Qt=L[5*lt],_t=L[5*zt];if(Qt===_t){const ei=L[5*lt+1],ri=L[5*zt+1];return ei-ri}return Qt-_t});const He=new Uint32Array(L.length);let Ze=0,ot=0;for(let lt=0;lt<Se;lt++){const zt=5*ne[lt],Qt=L[zt+0],_t=L[zt+1],ei=L[zt+2],ri=L[zt+3],Bi=L[zt+4],wn=Qt-Ze,Mn=wn===0?_t-ot:_t,Wi=5*lt;He[Wi+0]=wn,He[Wi+1]=Mn,He[Wi+2]=ei,He[Wi+3]=ri,He[Wi+4]=Bi,Ze=Qt,ot=_t}return He}build(L){return this.f?new ni(new Uint32Array(this.g),L):new ni(Mi.o(this.g),L)}}e.$oL=Mi;class ni{constructor(L,ne){this.resultId=ne,this.data=L}}e.$pL=ni;class un{constructor(L,ne,Se){this.start=L,this.deleteCount=ne,this.data=Se}}e.$qL=un;class ln{constructor(L,ne){this.resultId=ne,this.edits=L}}e.$rL=ln;var Gi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Vt("arrow-left")}}constructor(){}};e.$sL=fi,e.$sL=fi=Ke([R],fi);var Qi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Yi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Yi||(e.InputBoxValidationSeverity=Yi={}));var ui;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Zi{static validate(L){if(typeof L.badge=="string"){let ne=(0,h.$$e)(L.badge,0);if(ne<L.badge.length&&(ne+=(0,h.$$e)(L.badge,ne)),L.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!Vt.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,ne,Se){this.badge=L,this.tooltip=ne,this.color=Se}}e.$tL=Zi;let Ti=class{constructor(L){this.kind=L}};e.$uL=Ti,e.$uL=Ti=Ke([R],Ti);var Xi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Xi||(e.ColorThemeKind=Xi={}));class Xt{static isNotebookRange(L){return L instanceof Xt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,ne){if(L<0)throw(0,M.$6)("start must be positive");if(ne<0)throw(0,M.$6)("end must be positive");L<=ne?(this.c=L,this.e=ne):(this.c=ne,this.e=L)}with(L){let ne=this.c,Se=this.e;return L.start!==void 0&&(ne=L.start),L.end!==void 0&&(Se=L.end),ne===this.c&&Se===this.e?this:new Xt(ne,Se)}}e.$vL=Xt;class yi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ne=>yi.isNotebookCellData(ne))}static isNotebookCellData(L){return!0}constructor(L,ne,Se,He,Ze,ot,lt){this.kind=L,this.value=ne,this.languageId=Se,this.mime=He,this.outputs=Ze??[],this.metadata=ot,this.executionSummary=lt,yi.validate(this)}}e.$wL=yi;class hn{constructor(L){this.cells=L}}e.$xL=hn;class Gt{static isNotebookCellOutputItem(L){return L instanceof Gt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ne={name:L.name,message:L.message,stack:L.stack};return Gt.json(ne,"application/vnd.code.notebook.error")}static stdout(L){return Gt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Gt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ne="application/octet-stream"){return new Gt(L,ne)}static#e=new TextEncoder;static text(L,ne=A.$Kr.text){const Se=Gt.#e.encode(String(L));return new Gt(Se,ne)}static json(L,ne="text/x-json"){const Se=JSON.stringify(L,void 0,"	");return Gt.text(Se,ne)}constructor(L,ne){this.data=L,this.mime=ne;const Se=(0,A.$Or)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$yL=Gt;class li{static isNotebookCellOutput(L){return L instanceof li?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,ne=!1){const Se=new Set,He=new Set;for(let Ze=0;Ze<L.length;Ze++){const ot=L[Ze],lt=(0,A.$Or)(ot.mime);if(!Se.has(lt)||(0,m.$iI)(lt)){Se.add(lt);continue}He.add(Ze),ne&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return He.size===0?L:L.filter((Ze,ot)=>!He.has(ot))}constructor(L,ne,Se){this.items=li.ensureUniqueMimeTypes(L,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,P.$dg)(),this.metadata=ne??Se)}}e.$zL=li;var Li;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Li||(e.NotebookCellKind=Li={}));var Ne;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Ne||(e.NotebookCellExecutionState=Ne={}));var xt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(xt||(e.NotebookCellStatusBarAlignment=xt={}));var Fi;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Fi||(e.NotebookEditorRevealType=Fi={}));class $t{constructor(L,ne){this.text=L,this.alignment=ne}}e.$AL=$t;var xi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(xi||(e.NotebookControllerAffinity=xi={}));var _i;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class en{constructor(L,ne=[]){this.uri=L,this.provides=(0,w.$2b)(ne)}}e.$BL=en;class dn{constructor(L){this.label=L}}e.$CL=dn;let hi=class{constructor(L,ne){this.label=L,this.timestamp=ne}};e.$DL=hi,e.$DL=hi=Ke([R],hi);var tn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(L,ne){this.ranges=L,this.wordPattern=ne}}e.$EL=sn;class fn{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$FL=fn;var on;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ni=class{constructor(L=void 0,ne=void 0,Se=void 0,He=!1){this.include=L,this.exclude=ne,this.profile=Se,this.continuous=He}};e.$GL=Ni,e.$GL=Ni=Ke([R],Ni);let Oi=d=class{static diff(L,ne,Se){const He=new d(L);return He.expectedOutput=ne,He.actualOutput=Se,He}constructor(L){this.message=L}};e.$HL=Oi,e.$HL=Oi=d=Ke([R],Oi);let zi=class{constructor(L){this.id=L}};e.$IL=zi,e.$IL=zi=Ke([R],zi);let di=class{constructor(L,ne){this.covered=L,this.total=ne}};e.$JL=di,e.$JL=di=Ke([R],di);let Ui=l=class{static fromDetails(L,ne){const Se=new di(0,0),He=new di(0,0),Ze=new di(0,0);for(const lt of ne)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const zt of lt.branches)He.total+=1,He.covered+=zt.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=lt.executionCount>0?1:0;const ot=new l(L,Se,He.total>0?He:void 0,Ze.total>0?Ze:void 0);return ot.detailedCoverage=ne,ot}constructor(L,ne,Se,He){this.uri=L,this.statementCoverage=ne,this.branchCoverage=Se,this.functionCoverage=He}};e.$KL=Ui,e.$KL=Ui=l=Ke([R],Ui);let ji=class{constructor(L,ne,Se=[]){this.executionCount=L,this.location=ne,this.branches=Se}};e.$LL=ji,e.$LL=ji=Ke([R],ji);let te=class{constructor(L,ne){this.executionCount=L,this.location=ne}};e.$ML=te,e.$ML=te=Ke([R],te);let fe=class{constructor(L,ne){this.executionCount=L,this.location=ne}};e.$NL=fe,e.$NL=fe=Ke([R],fe);var Le;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Le||(e.ExternalUriOpenerPriority=Le={}));var nt;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(nt||(e.WorkspaceTrustState=nt={}));var wt;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(wt||(e.PortAutoForwardAction=wt={}));class Tt{constructor(L,ne,Se,He,Ze,ot){this.kind=L,this.name=ne,this.detail=Se,this.uri=He,this.range=Ze,this.selectionRange=ot}}e.$OL=Tt;class yn{constructor(L){this.uri=L}}e.$PL=yn;class En{constructor(L,ne){this.original=L,this.modified=ne}}e.$QL=En;class Dn{constructor(L,ne,Se,He){this.base=L,this.input1=ne,this.input2=Se,this.result=He}}e.$RL=Dn;class kn{constructor(L,ne){this.uri=L,this.viewType=ne}}e.$SL=kn;class Sn{constructor(L){this.viewType=L}}e.$TL=Sn;class In{constructor(L,ne){this.uri=L,this.notebookType=ne}}e.$UL=In;class Cn{constructor(L,ne,Se){this.original=L,this.modified=ne,this.notebookType=Se}}e.$VL=Cn;class Pn{constructor(){}}e.$WL=Pn;class An{constructor(L,ne){this.uri=L,this.inputBoxUri=ne}}e.$XL=An;var gn;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var pn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(pn||(e.ChatMessageRole=pn={}));var vn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Rn{constructor(L,ne){this.role=L,this.content=ne}}e.$YL=Rn;var bn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(bn||(e.RelatedInformationType=bn={}))}),define(Ae[100],Re([1,0,51,12,15,277,136,7,18]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=e.$_L=void 0;const g=new Map;function P(m,f){f?g.set(m,f):g.delete(m)}e.$_L=P;function k(m){return g.get(m)}class a extends F.$Pu{constructor(f,t,n,c,v,D,p,r){super(t,n,c,v),this.c=f,this.m=D,this.q=p,this.notebook=r,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,E.$tb)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===M.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(t){return t?f.s(t):f.getText()},get eol(){return f.g===`
`?h.EndOfLine.LF:h.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(t){return f.t(t)},offsetAt(t){return f.u(t)},positionAt(t){return f.v(t)},validateRange(t){return f.w(t)},validatePosition(t){return f.x(t)},getWordRangeAtPosition(t,n){return f.y(t,n)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,w.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,w.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const t=this.w(f);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const n=this.g,c=t.start.line,v=t.end.line,D=[];D.push(this.f[c].substring(t.start.character));for(let p=c+1;p<v;p++)D.push(this.f[p]);return D.push(this.f[v].substring(0,t.end.character)),D.join(n)}t(f){let t;if(f instanceof h.$_J?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const t=this.j.getIndexOf(f),n=this.f[t.index].length;return new h.$_J(t.index,Math.min(t.remainder,n))}w(f){if(!(f instanceof h.$aK))throw new Error("Invalid argument");const t=this.x(f.start),n=this.x(f.end);return t===f.start&&n===f.end?f:new h.$aK(t.line,t.character,n.line,n.character)}x(f){if(!(f instanceof h.$_J))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:t,character:n}=f,c=!1;if(t<0)t=0,n=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,n=this.f[t].length,c=!0;else{const v=this.f[t].length;n<0?(n=0,c=!0):n>v&&(n=v,c=!0)}return c?new h.$_J(t,n):f}y(f,t){const n=this.x(f);if(!t)t=k(this.m);else if((0,C.$Ne)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,A.$3r)(n.character+1,(0,A.$1r)(t),this.f[n.line],0);if(c)return new h.$aK(n.line,c.startColumn-1,n.line,c.endColumn-1)}}e.$aM=a;class b{constructor(f,t,n){this.a=f,this.b=t,this.c=n}get lineNumber(){return this.a}get text(){return this.b}get range(){return new h.$aK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new h.$aK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$bM=b}),define(Ae[196],Re([1,0,7,17,5]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0;let F=class{constructor(h){this.a=new w.$uL(w.ColorThemeKind.Dark),this.b=new C.$Md}get activeColorTheme(){return this.a}$onColorThemeChange(h){let E;switch(h){case"light":E=w.ColorThemeKind.Light;break;case"hcDark":E=w.ColorThemeKind.HighContrast;break;case"hcLight":E=w.ColorThemeKind.HighContrastLight;break;default:E=w.ColorThemeKind.Dark}this.a=new w.$uL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$bdc=F,e.$bdc=F=Ke([Ve(0,M.$0L)],F)}),define(Ae[197],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mI=e.CellExecutionUpdateType=void 0;var M;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$mI=(0,w.$Nh)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2I=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(F){F.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var M;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class C{static fromExtHostTestItem(A,h,E=A.parent){if(A._isRoot)return new C([h]);const g=[A.id];for(let P=E;P&&P.id!==h;P=P.parent)g.push(P.id);return g.push(h),new C(g.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const h=A.indexOf("\0");return h===-1?A:A.slice(0,h)}static fromString(A){return new C(A.split("\0"))}static join(A,h){return new C([...A.path,h])}static joinToString(A,h){return A.toString()+"\0"+h}static parentId(A){const h=A.lastIndexOf("\0");return h===-1?void 0:A.slice(0,h)}static localId(A){const h=A.lastIndexOf("\0");return h===-1?A:A.slice(h+1)}static isChild(A,h){return h.startsWith(A)&&h[A.length]==="\0"}static compare(A,h){return A===h?0:C.isChild(A,h)?2:C.isChild(h,A)?3:1}constructor(A,h=A.length){if(this.path=A,this.d=h,A.length===0||h<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let h=0;h<A.d&&h<this.d;h++)if(A.path[h]!==this.path[h])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$2I=C}),define(Ae[57],Re([1,0,2,44,45]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9I=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$8I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$7I=e.$6I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$5I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$4I=e.$3I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var F;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(F||(e.TestResultState=F={}));var A;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var h;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(h||(e.TestRunProfileBitset=h={})),e.$3I=[2,4,8,16,32,64];const E=I=>"runId"in I;e.$4I=E;var g;(function(I){I.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),I.deserialize=u=>({range:M.$ns.lift(u.range),uri:w.URI.revive(u.uri)})})(g||(e.IRichLocation=g={}));var P;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(P||(e.TestMessageType=P={}));var k;(function(I){I.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&g.serialize(u.location)}),I.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&g.deserialize(u.location)})})(k||(e.ITestErrorMessage=k={}));const a=(I,u)=>`${u?"s":"e"}${I}`;e.$5I=a;var b;(function(I){I.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&g.serialize(u.location)}),I.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&g.deserialize(u.location)})})(b||(e.ITestOutputMessage=b={}));var m;(function(I){I.serialize=u=>u.type===0?k.serialize(u):b.serialize(u),I.deserialize=u=>u.type===0?k.deserialize(u):b.deserialize(u)})(m||(e.ITestMessage=m={}));var f;(function(I){I.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),I.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(m.serialize)}),I.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(m.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",n=(I,u)=>I+t+u;e.$6I=n;const c=I=>{const u=I.indexOf(t);return{ctrlId:I.slice(0,u),tagId:I.slice(u+1)}};e.$7I=c;var v;(function(I){I.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),I.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?w.URI.revive(u.uri):void 0,range:u.range?M.$ns.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(v||(e.ITestItem=v={}));var D;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(D||(e.TestItemExpandState=D={}));var p;(function(I){I.serialize=u=>({expand:u.expand,item:v.serialize(u.item)}),I.deserialize=u=>({controllerId:C.$2I.root(u.item.extId),expand:u.expand,item:v.deserialize(u.item)})})(p||(e.InternalTestItem=p={}));var r;(function(I){I.serialize=u=>{let d;return u.item&&(d={},u.item.label!==void 0&&(d.label=u.item.label),u.item.tags!==void 0&&(d.tags=u.item.tags),u.item.busy!==void 0&&(d.busy=u.item.busy),u.item.uri!==void 0&&(d.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(d.range=u.item.range?.toJSON()),u.item.description!==void 0&&(d.description=u.item.description),u.item.error!==void 0&&(d.error=u.item.error),u.item.sortText!==void 0&&(d.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:d}},I.deserialize=u=>{let d;return u.item&&(d={},u.item.label!==void 0&&(d.label=u.item.label),u.item.tags!==void 0&&(d.tags=u.item.tags),u.item.busy!==void 0&&(d.busy=u.item.busy),u.item.range!==void 0&&(d.range=u.item.range?M.$ns.lift(u.item.range):null),u.item.description!==void 0&&(d.description=u.item.description),u.item.error!==void 0&&(d.error=u.item.error),u.item.sortText!==void 0&&(d.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:d}}})(r||(e.ITestItemUpdate=r={}));const s=(I,u)=>{u.expand!==void 0&&(I.expand=u.expand),u.item!==void 0&&(I.item=I.item?Object.assign(I.item,u.item):u.item)};e.$8I=s;var i;(function(I){I.serializeWithoutMessages=u=>({...p.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serializeWithoutMessages)}),I.serialize=u=>({...p.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serialize)}),I.deserialize=u=>({...p.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.deserialize),retired:!0})})(i||(e.TestResultItem=i={}));var o;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(o||(e.DetailType=o={}));var y;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(y||(e.TestDiffOpType=y={}));var $;(function(I){I.deserialize=u=>u.op===0?{op:u.op,item:p.deserialize(u.item)}:u.op===1?{op:u.op,item:r.deserialize(u.item)}:u.op===2?{op:u.op,uri:w.URI.revive(u.uri),docv:u.docv}:u,I.serialize=u=>u.op===0?{op:u.op,item:p.serialize(u.item)}:u.op===1?{op:u.op,item:r.serialize(u.item)}:u})($||(e.TestsDiffOp=$={}));class S{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const d=this.p();for(const l of u)switch(l.op){case 0:this.k(p.deserialize(l.item),d);break;case 1:this.l(r.deserialize(l.item),d);break;case 3:this.m(l.itemId,d);break;case 5:this.o(l.itemId);break;case 4:this.updatePendingRoots(l.amount);break;case 6:this.d.set(l.tag.id,l.tag);break;case 7:this.d.delete(l.id);break}d.complete?.()}k(u,d){const l=C.$2I.parentId(u.item.extId)?.toString();let R;if(!l)R=this.q(u),this.g.add(R),this.f.set(u.item.extId,R);else if(this.f.has(l)){const B=this.f.get(l);B.children.add(u.item.extId),R=this.q(u,B),this.f.set(u.item.extId,R)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return d.add?.(R),u.expand===2&&this.h++,R}l(u,d){const l=this.f.get(u.extId);if(l)return u.expand!==void 0&&(l.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$8I)(l,u),d.update?.(l),l}m(u,d){const l=this.f.get(u);if(!l)return;const R=C.$2I.parentId(l.item.extId)?.toString();R?this.f.get(R).children.delete(l.item.extId):this.g.delete(l);const B=[[u]];for(;B.length;)for(const V of B.pop()){const U=this.f.get(V);U&&(B.push(U.children),this.f.delete(V),d.remove?.(U,U!==l),U.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$9I=S}),define(Ae[76],Re([1,0,13,5,6,51,57,45]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.TestItemEventOp=void 0;var E;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const g=(c,v)=>c===v,k=Object.entries({range:(c,v)=>c===v?!0:!c||!v?!1:c.equalsRange(v),busy:g,label:g,description:g,error:g,sortText:g,tags:(c,v)=>!(c.length!==v.length||c.some(D=>!v.includes(D)))}),a=(c,v)=>{let D;for(const[p,r]of k)r(c[p],v[p])||(D?D[p]=v[p]:D={[p]:v[p]});return D};class b extends C.$Rc{get root(){return this.s.root}constructor(v){super(),this.s=v,this.f=this.B(new w.$5g(()=>this.flushDiff(),200)),this.g=this.B(new M.$Md),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(v){this.h=v;for(const D of this.tree.values())this.I(D)}get resolveHandler(){return this.h}collectDiff(){const v=this.m;return this.m=[],v}pushDiff(v){switch(v.op){case 2:{for(const D of this.m)if(D.op===2&&D.uri===v.uri){D.docv=v.docv;return}break}case 1:{const D=this.m[this.m.length-1];if(D){if(D.op===1&&D.item.extId===v.item.extId){(0,A.$8I)(D.item,v.item);return}if(D.op===0&&D.item.item.extId===v.item.extId){(0,A.$8I)(D.item,v.item);return}}break}}this.m.push(v),this.f.isScheduled()||this.f.schedule()}expand(v,D){const p=this.tree.get(v);if(p){if((p.expandLevels===void 0||D>p.expandLevels)&&(p.expandLevels=D),p.expand===1){const r=this.L(p);return r.isOpen()?this.J(p,D-1):r.wait().then(()=>this.J(p,D-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.J(p,D-1)):this.J(p,D-1)}}dispose(){for(const v of this.tree.values())this.s.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(v,D){switch(D.op){case 3:this.N(h.$2I.joinToString(v.fullId,D.id));break;case 0:this.y(D.item,v);break;case 5:for(const p of D.ops)this.u(v,p);break;case 1:this.z(D.new,D.old,v.fullId.toString());break;case 2:this.I(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:D.update}});break;case 6:this.w(v.actual.uri);break;default:(0,F.$3c)(D)}}w(v){v&&this.pushDiff({op:2,uri:v,docv:this.s.getDocumentVersion(v)})}y(v,D){const p=h.$2I.fromExtHostTestItem(v,this.root.id,D?.actual),r=this.s.getApiFor(v);r.parent&&r.parent!==D?.actual&&this.s.getChildren(r.parent).delete(v.id);let s=this.tree.get(p.toString());if(!s){s={fullId:p,actual:v,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},v.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(v,D),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(v)}}),this.H(v,s,D);return}if(s.actual===v){this.G(v,s,D);return}if(s.actual.uri?.toString()!==v.uri?.toString())return this.N(p.toString()),this.y(v,D);const i=this.s.getChildren(s.actual),o=s.actual,y=a(this.s.toITestItem(o),this.s.toITestItem(v));this.s.getApiFor(o).listener=void 0,s.actual=v,s.expand=0,y&&(y.hasOwnProperty("tags")&&(this.z(v.tags,o.tags,p.toString()),delete y.tags),this.u(s,{op:4,update:y})),this.H(v,s,D);for(const[$,S]of i)this.s.getChildren(v).get(S.id)||this.N(h.$2I.joinToString(p,S.id));this.w(s.actual.uri)}z(v,D,p){const r=new Set(D.map(s=>s.id));for(const s of v)r.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:p,item:{tags:v.map(s=>(0,A.$6I)(this.s.controllerId,s.id))}}}),r.forEach(this.D,this)}C(v){const D=this.j.get(v.id);D?D.refCount++:(this.j.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$6I)(this.s.controllerId,v.id)}}))}D(v){const D=this.j.get(v);D&&!--D.refCount&&(this.j.delete(v),this.pushDiff({op:7,id:(0,A.$6I)(this.s.controllerId,v)}))}F(v,D){this.s.getApiFor(v).parent=D&&D.actual!==this.root?D.actual:void 0}G(v,D,p){this.F(v,p);const r=this.s.getApiFor(v);r.parent=p?.actual,r.listener=s=>this.u(D,s),this.I(D)}H(v,D,p){this.G(v,D,p);for(const[r,s]of this.s.getChildren(v))this.y(s,D)}I(v){let D;this.h?v.resolveBarrier?D=v.resolveBarrier.isOpen()?3:2:D=v.actual.canResolveChildren?1:0:D=0,D!==v.expand&&(v.expand=D,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:D}}),D===1&&v.expandLevels!==void 0&&this.L(v))}J(v,D){if(D<0)return;const p=[];for(const[r,s]of this.s.getChildren(v.actual)){const i=this.expand(h.$2I.joinToString(v.fullId,s.id),D);(0,w.$Fg)(i)&&p.push(i)}if(p.length)return Promise.all(p).then(()=>{})}L(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this.h){const s=new w.$Rg;return s.open(),s}v.expand=2,this.M(v);const D=v.resolveBarrier=new w.$Rg,p=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let r;try{r=this.h(v.actual===this.root?void 0:v.actual)}catch(s){p(s)}return(0,w.$Fg)(r)?r.catch(p).then(()=>{D.open(),this.I(v)}):(D.open(),this.I(v)),v.resolveBarrier}M(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}N(v){const D=this.tree.get(v);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const p=[D];for(;p.length;){const r=p.pop();if(r){this.s.getApiFor(r.actual).listener=void 0;for(const s of r.actual.tags)this.D(s.id);this.tree.delete(r.fullId.toString());for(const[s,i]of this.s.getChildren(r.actual))p.push(this.tree.get(h.$2I.joinToString(r.fullId,i.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.g.fire(v)}}e.$ZL=b;class m extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.$1L=m;class f extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$2L=f;class t extends Error{constructor(v,D,p){super(`TestItem with ID "${v}" is from controller "${D}" and cannot be added as a child of an item from controller "${p}".`)}}e.$3L=t;const n=(c,v,D)=>{let p=new Map;return{get size(){return p.size},forEach(r,s){for(const i of p.values())r.call(s,i,this)},[Symbol.iterator](){return p.entries()},replace(r){const s=new Map,i=new Set(p.keys()),o={op:5,ops:[]};for(const y of r){if(!(y instanceof D))throw new f(y.id);const $=v(y).controllerId;if($!==c.controllerId)throw new t(y.id,$,c.controllerId);if(s.has(y.id))throw new m(y.id);s.set(y.id,y),i.delete(y.id),o.ops.push({op:0,item:y})}for(const y of i.keys())o.ops.push({op:3,id:y});c.listener?.(o),p=s},add(r){if(!(r instanceof D))throw new f(r.id);p.set(r.id,r),c.listener?.({op:0,item:r})},delete(r){p.delete(r)&&c.listener?.({op:3,id:r})},get(r){return p.get(r)},toJSON(){return Array.from(p.values())}}};e.$4L=n}),define(Ae[101],Re([1,0,76]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=void 0;const M=new WeakMap,C=(A,h)=>{const E={controllerId:h};return M.set(A,E),E};e.$5L=C;const F=A=>{const h=M.get(A);if(!h)throw new w.$2L(A?.id||"<unknown>");return h};e.$6L=F}),define(Ae[77],Re([1,0,12,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wob=e.$Vob=e.$Uob=e.$Tob=e.$Sob=void 0,e.$Sob="vscode-cdn.net",e.$Tob=`vscode-resource.${e.$Sob}`,e.$Uob=`'self' https://*.${e.$Sob}`;function C(h,E){return h.scheme===w.Schemas.http||h.scheme===w.Schemas.https?h:(E&&E.authority&&E.isRemote&&h.scheme===w.Schemas.file&&(h=M.URI.from({scheme:w.Schemas.vscodeRemote,authority:E.authority,path:h.path})),M.URI.from({scheme:w.Schemas.https,authority:`${h.scheme}+${F(h.authority)}.${e.$Tob}`,path:h.path,fragment:h.fragment,query:h.query}))}e.$Vob=C;function F(h){return h.replace(/./g,E=>{const g=E.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?E:"-"+g.toString(16).padStart(4,"0")})}function A(h){return h.replace(/-([0-9a-f]{4})/g,(E,g)=>String.fromCharCode(parseInt(g,16)))}e.$Wob=A}),define(Ae[198],Re([1,0,5,6,77]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;class F{constructor(h,E,g){this.d=h,this.e=E,this.f=g,this.a=0,this.b=new M.$Qc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const P=E.getVisibleTextEditors();for(const k of this.c.values())P.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(h=>h.inset.dispose()),this.b.dispose()}createWebviewEditorInset(h,E,g,P,k){let a;for(const v of this.e.getVisibleTextEditors(!0))if(v.value===h){a=v;break}if(!a)throw new Error("not a visible editor");const b=this,m=this.a++,f=new w.$Md,t=new w.$Md,n=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(v){return(0,C.$Vob)(v,b.f)}get cspSource(){return C.$Uob}set options(v){this.b=v,b.d.$setOptions(m,v)}get options(){return this.b}set html(v){this.a=v,b.d.$setHtml(m,v)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(v){return b.d.$postMessage(m,v)}},c=new class{constructor(){this.editor=h,this.line=E,this.height=g,this.webview=n,this.onDidDispose=t.event}dispose(){b.c.has(m)&&(b.c.delete(m),b.d.$disposeEditorInset(m),t.fire(),t.dispose(),f.dispose())}};return this.d.$createEditorInset(m,a.id,a.value.document.uri,E+1,g,P||{},k.identifier,k.extensionLocation),this.c.set(m,{editor:h,inset:c,onDidReceiveMessage:f}),c}$onDidDispose(h){const E=this.c.get(h);E&&E.inset.dispose()}$onDidReceiveMessage(h,E){this.c.get(h)?.onDidReceiveMessage.fire(E)}}e.$Lcc=F}),define(Ae[199],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.VariableKind=e.$VM=void 0,e.$VM=(0,w.$Nh)("configurationResolverService");var M;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class C extends Error{constructor(A,h){super(h),this.variable=A}}e.$WM=C}),define(Ae[200],Re([1,0,19,74,16,24,22,90,165,199,15]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,m,f,t){this.h=new Map,this.a=b,this.b=m,this.g=f,t&&(this.c=t.then(n=>this.i(n)))}i(b){if(A.$j){const m=Object.create(null);return Object.keys(b).forEach(f=>{m[f.toLowerCase()]=b[f]}),m}return b}resolveWithEnvironment(b,m,f){return this.l({env:this.i(b),userHome:void 0},m?m.uri:void 0,f)}async resolveAsync(b,m){const f={env:await this.c,userHome:await this.g};return this.l(f,b?b.uri:void 0,m)}async j(b,m,f,t){const n=F.$Ym(m);A.$j&&n.windows?Object.keys(n.windows).forEach(v=>n[v]=n.windows[v]):A.$k&&n.osx?Object.keys(n.osx).forEach(v=>n[v]=n.osx[v]):A.$l&&n.linux&&Object.keys(n.linux).forEach(v=>n[v]=n.linux[v]),delete n.windows,delete n.osx,delete n.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,b?b.uri:void 0,n,f,t)}async resolveAnyAsync(b,m,f){return this.j(b,m,f)}async resolveAnyMap(b,m,f){const t=new Map;return{newConfig:await this.j(b,m,f,t),resolvedVariables:t}}resolveWithInteractionReplace(b,m,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,m,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,m){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,m)}async l(b,m,f,t,n){if(C.$xf(f))return this.m(b,m,f,t,n);if(Array.isArray(f))return Promise.all(f.map(c=>this.l(b,m,c,t,n)));if(C.$zf(f)){const c=Object.create(null),v=await Promise.all(Object.keys(f).map(async D=>[await this.m(b,m,D,t,n),await this.l(b,m,f[D],t,n)]));for(const[D,p]of v)c[D]=p;return c}return f}m(b,m,f,t,n){return(0,P.$Se)(f,k.VARIABLE_REGEXP,async(c,v)=>{if(v.includes(k.VARIABLE_LHS))return c;let D=await this.o(b,c,v,m,t);return n?.set(v,D),D!==c&&C.$xf(D)&&D.match(k.VARIABLE_REGEXP)&&(D=await this.m(b,m,D,t,n)),D})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,m,f,t,n){let c;const v=f.split(":");v.length>1&&(f=v[0],c=v[1]);const D=s=>{const i=this.a.getFilePath();if(i)return(0,h.$lv)(i);throw new g.$WM(s,(0,E.localize)(0,null,m))},p=s=>{const i=D(s);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,h.$lv)(o)}throw new g.$WM(s,(0,E.localize)(1,null,m,w.$mc(i)))},r=s=>{if(c){const i=this.a.getFolderUri(c);if(i)return i;throw new g.$WM(s,(0,E.localize)(2,null,m,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new g.$WM(s,(0,E.localize)(3,null,m)):new g.$WM(s,(0,E.localize)(4,null,m))};switch(f){case"env":if(c){if(b.env){const s=b.env[A.$j?c.toLowerCase():c];if(C.$xf(s))return s}return""}throw new g.$WM(g.VariableKind.Env,(0,E.localize)(5,null,m));case"config":if(c){const s=this.a.getConfigurationValue(t,c);if(C.$Gf(s))throw new g.$WM(g.VariableKind.Config,(0,E.localize)(6,null,m,c));if(C.$zf(s))throw new g.$WM(g.VariableKind.Config,(0,E.localize)(7,null,m,c));return s}throw new g.$WM(g.VariableKind.Config,(0,E.localize)(8,null,m));case"command":return this.p(g.VariableKind.Command,m,c,n,"command");case"input":return this.p(g.VariableKind.Input,m,c,n,"input");case"extensionInstallFolder":if(c){const s=await this.a.getExtension(c);if(!s)throw new g.$WM(g.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,m,c));return this.n(s.extensionLocation)}throw new g.$WM(g.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,m));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,h.$lv)(this.n(r(g.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,h.$lv)(this.n(r(g.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,h.$lv)(w.$mc(this.n(r(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new g.$WM(g.VariableKind.UserHome,(0,E.localize)(11,null,m))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new g.$WM(g.VariableKind.LineNumber,(0,E.localize)(12,null,m))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new g.$WM(g.VariableKind.SelectedText,(0,E.localize)(13,null,m))}case"file":return D(g.VariableKind.File);case"fileWorkspaceFolder":return p(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?w.$kc(this.n(r(g.VariableKind.RelativeFile)),D(g.VariableKind.RelativeFile)):D(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=w.$lc(D(g.VariableKind.RelativeFileDirname));if(t||c){const i=w.$kc(this.n(r(g.VariableKind.RelativeFileDirname)),s);return i.length===0?".":i}return s}case"fileDirname":return w.$lc(D(g.VariableKind.FileDirname));case"fileExtname":return w.$nc(D(g.VariableKind.FileExtname));case"fileBasename":return w.$mc(D(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=w.$mc(D(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-w.$nc(s).length)}case"fileDirnameBasename":return w.$mc(w.$lc(D(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||m}case"execInstallFolder":{const s=this.a.getAppRoot();return s||m}case"pathSeparator":return w.sep;default:try{const s=c?`${f}:${c}`:f;return this.p(g.VariableKind.Unknown,m,s,n,void 0)}catch{return m}}}}p(b,m,f,t,n){if(f&&t){const c=n===void 0?t[f]:t[n+":"+f];if(typeof c=="string")return c;throw new g.$WM(b,(0,E.localize)(14,null,m))}return m}}e.$$M=k}),define(Ae[102],Re([1,0,4,99]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=e.$_B=e.OpenEditorContext=e.GroupsOrder=e.$$B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$0B=void 0,e.$0B=(0,w.$Nh)("editorGroupsService");var C;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var F;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var A;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var h;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(h||(e.GroupsArrangement=h={}));var E;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function g(m){const f=m;return(0,M.$ZD)(f?.editor)&&(0,M.$ZD)(f?.replacement)}e.$$B=g;var P;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var k;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function a(m){const f=m;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$_B=a;function b(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$aC=b}),define(Ae[201],Re([1,0,4,102]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=e.$dC=e.$cC=e.$bC=void 0,e.$bC=(0,w.$Nh)("editorService"),e.$cC=-1,e.$dC=-2;function C(F){const A=F;return typeof F=="number"||(0,M.$_B)(A)}e.$eC=C}),define(Ae[8],Re([1,0,18,25,122,202,50,28,116,68,67,24,16,2,44,78,94,101,99,75,45,57,201,7]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$9L=e.$8L=e.MarkdownString=e.$7L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(Ce){function Me(J){const{selectionStartLineNumber:Te,selectionStartColumn:je,positionLineNumber:Ge,positionColumn:We}=J,et=new s.$_J(Te-1,je-1),pt=new s.$_J(Ge-1,We-1);return new s.$bK(et,pt)}Ce.to=Me;function ge(J){const{anchor:Te,active:je}=J;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Ce.from=ge})(i||(e.Selection=i={}));var o;(function(Ce){function Me(J){if(!J)return;const{start:Te,end:je}=J;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Ce.from=Me;function ge(J){if(!J)return;const{startLineNumber:Te,startColumn:je,endLineNumber:Ge,endColumn:We}=J;return new s.$aK(Te-1,je-1,Ge-1,We-1)}Ce.to=ge})(o||(e.Range=o={}));var y;(function(Ce){function Me(ge){switch(ge){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ce.to=Me})(y||(e.TokenType=y={}));var $;(function(Ce){function Me(J){return new s.$_J(J.lineNumber-1,J.column-1)}Ce.to=Me;function ge(J){return{lineNumber:J.line+1,column:J.character+1}}Ce.from=ge})($||(e.Position=$={}));var S;(function(Ce){function Me(Te,je,Ge){return(0,w.$Gb)((0,w.$2b)(Te).map(We=>ge(We,je,Ge)))}Ce.from=Me;function ge(Te,je,Ge){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:Ge?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:J(Te.scheme,je),pattern:st.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:Ge?.isBuiltin}}function J(Te,je){return je&&typeof Te=="string"?je.transformOutgoingScheme(Te):Te}})(S||(e.DocumentSelector=S={}));var I;(function(Ce){function Me(J){switch(J){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ce.from=Me;function ge(J){switch(J){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ce.to=ge})(I||(e.DiagnosticTag=I={}));var u;(function(Ce){function Me(J){let Te;return J.code&&((0,a.$xf)(J.code)||(0,a.$Bf)(J.code)?Te=String(J.code):Te={value:String(J.code.value),target:J.code.target}),{...o.from(J.range),message:J.message,source:J.source,code:Te,severity:l.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(d.from),tags:Array.isArray(J.tags)?(0,w.$Gb)(J.tags.map(I.from)):void 0}}Ce.from=Me;function ge(J){const Te=new s.$mK(o.to(J),J.message,l.to(J.severity));return Te.source=J.source,Te.code=(0,a.$xf)(J.code)?J.code:J.code?.value,Te.relatedInformation=J.relatedInformation&&J.relatedInformation.map(d.to),Te.tags=J.tags&&(0,w.$Gb)(J.tags.map(I.to)),Te}Ce.to=ge})(u||(e.Diagnostic=u={}));var d;(function(Ce){function Me(J){return{...o.from(J.location.range),message:J.message,resource:J.location.uri}}Ce.from=Me;function ge(J){return new s.$lK(new s.$kK(J.resource,o.to(J)),J.message)}Ce.to=ge})(d||(e.DiagnosticRelatedInformation=d={}));var l;(function(Ce){function Me(J){switch(J){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Me;function ge(J){switch(J){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ce.to=ge})(l||(e.DiagnosticSeverity=l={}));var R;(function(Ce){function Me(J){return typeof J=="number"&&J>=s.ViewColumn.One?J-1:J===s.ViewColumn.Beside?r.$dC:r.$cC}Ce.from=Me;function ge(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=ge})(R||(e.ViewColumn=R={}));function B(Ce){return typeof Ce.range<"u"}function V(Ce){return Ce.length===0?!0:!!B(Ce[0])}e.$7L=V;var U;(function(Ce){function Me(We){return We.map(Ce.from)}Ce.fromMany=Me;function ge(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function J(We){let et;if(ge(We)){const{language:ft,value:mt}=We;et={value:"```"+ft+`
`+mt+"\n```\n"}}else s.$yK.isMarkdownString(We)?et={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?et={value:We}:et={value:""};const pt=Object.create(null);et.uris=pt;const vt=ft=>{try{let mt=b.URI.parse(ft,!0);mt=mt.with({query:Te(mt.query,pt)}),pt[ft]=mt}catch{}return""},dt=new E.marked.Renderer;return dt.link=vt,dt.image=ft=>typeof ft=="string"?vt(A.$8j(ft).href):"",(0,E.marked)(et.value,{renderer:dt}),et}Ce.from=J;function Te(We,et){if(!We)return We;let pt;try{pt=(0,g.$jh)(We)}catch{}if(!pt)return We;let vt=!1;return pt=(0,k.$1m)(pt,dt=>{if(b.URI.isUri(dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[ft]=dt,vt=!0,ft}else return}),vt?JSON.stringify(pt):We}function je(We){const et=new s.$yK(We.value,We.supportThemeIcons);return et.isTrusted=We.isTrusted,et.supportHtml=We.supportHtml,et.baseUri=We.baseUri?b.URI.from(We.baseUri):void 0,et}Ce.to=je;function Ge(We){if(We)return typeof We=="string"?We:Ce.from(We)}Ce.fromStrict=Ge})(U||(e.MarkdownString=U={}));function W(Ce){return V(Ce)?Ce.map(Me=>({range:o.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?U.fromMany(Me.hoverMessage):Me.hoverMessage?U.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ce.map(Me=>({range:o.from(Me)}))}e.$8L=W;function N(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?b.URI.file(Ce):Ce}e.$9L=N;var O;(function(Ce){function Me(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?N(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ce.from=Me})(O||(e.ThemableDecorationAttachmentRenderOptions=O={}));var ee;(function(Ce){function Me(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?N(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?O.from(ge.before):void 0,after:ge.after?O.from(ge.after):void 0}}Ce.from=Me})(ee||(e.ThemableDecorationRenderOptions=ee={}));var Z;(function(Ce){function Me(ge){if(typeof ge>"u")return ge;switch(ge){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Me})(Z||(e.DecorationRangeBehavior=Z={}));var ye;(function(Ce){function Me(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?Z.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?ee.from(ge.light):void 0,dark:ge.dark?ee.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?N(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?O.from(ge.before):void 0,after:ge.after?O.from(ge.after):void 0}}Ce.from=Me})(ye||(e.DecorationRenderOptions=ye={}));var De;(function(Ce){function Me(J){return{text:J.newText,eol:J.newEol&&Xe.from(J.newEol),range:o.from(J.range)}}Ce.from=Me;function ge(J){const Te=new s.$fK(o.to(J.range),J.text);return Te.newEol=typeof J.eol>"u"?void 0:Xe.to(J.eol),Te}Ce.to=ge})(De||(e.TextEdit=De={}));var Pe;(function(Ce){function Me(J,Te){const je={edits:[]};if(J instanceof s.$iK){const Ge=new h.$Ac;for(const We of J._allEntries())We._type===1&&b.URI.isUri(We.to)&&We.from===void 0&&Ge.add(We.to);for(const We of J._allEntries())if(We._type===1){let et;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?et={type:"base64",value:(0,M.$ue)(M.$ae.wrap(We.options.contents))}:et={type:"dataTransferItem",id:We.options.contents._itemId}),je.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:et},metadata:We.metadata})}else We._type===2?je.edits.push({resource:We.uri,textEdit:De.from(We.edit),versionId:Ge.has(We.uri)?void 0:Te?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?je.edits.push({resource:We.uri,textEdit:{range:o.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ge.has(We.uri)?void 0:Te?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?je.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(We.uri)}):We._type===5&&je.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Te?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(gt.from)}})}return je}Ce.from=Me;function ge(J){const Te=new s.$iK,je=new h.$zc;for(const Ge of J.edits)if(Ge.textEdit){const We=Ge,et=b.URI.revive(We.resource),pt=o.to(We.textEdit.range),vt=We.textEdit.text,dt=We.textEdit.insertAsSnippet;let ft;dt?ft=s.$hK.replace(pt,new s.$jK(vt)):ft=s.$fK.replace(pt,vt);const mt=je.get(et);mt?mt.push(ft):je.set(et,[ft])}else Te.renameFile(b.URI.revive(Ge.oldResource),b.URI.revive(Ge.newResource),Ge.options);for(const[Ge,We]of je)Te.set(Ge,We);return Te}Ce.to=ge})(Pe||(e.WorkspaceEdit=Pe={}));var X;(function(Ce){const Me=Object.create(null);Me[s.SymbolKind.File]=0,Me[s.SymbolKind.Module]=1,Me[s.SymbolKind.Namespace]=2,Me[s.SymbolKind.Package]=3,Me[s.SymbolKind.Class]=4,Me[s.SymbolKind.Method]=5,Me[s.SymbolKind.Property]=6,Me[s.SymbolKind.Field]=7,Me[s.SymbolKind.Constructor]=8,Me[s.SymbolKind.Enum]=9,Me[s.SymbolKind.Interface]=10,Me[s.SymbolKind.Function]=11,Me[s.SymbolKind.Variable]=12,Me[s.SymbolKind.Constant]=13,Me[s.SymbolKind.String]=14,Me[s.SymbolKind.Number]=15,Me[s.SymbolKind.Boolean]=16,Me[s.SymbolKind.Array]=17,Me[s.SymbolKind.Object]=18,Me[s.SymbolKind.Key]=19,Me[s.SymbolKind.Null]=20,Me[s.SymbolKind.EnumMember]=21,Me[s.SymbolKind.Struct]=22,Me[s.SymbolKind.Event]=23,Me[s.SymbolKind.Operator]=24,Me[s.SymbolKind.TypeParameter]=25;function ge(Te){return typeof Me[Te]=="number"?Me[Te]:6}Ce.from=ge;function J(Te){for(const je in Me)if(Me[je]===Te)return Number(je);return s.SymbolKind.Property}Ce.to=J})(X||(e.SymbolKind=X={}));var le;(function(Ce){function Me(J){switch(J){case s.SymbolTag.Deprecated:return 1}}Ce.from=Me;function ge(J){switch(J){case 1:return s.SymbolTag.Deprecated}}Ce.to=ge})(le||(e.SymbolTag=le={}));var Ee;(function(Ce){function Me(J){return{name:J.name,kind:X.from(J.kind),tags:J.tags&&J.tags.map(le.from),containerName:J.containerName,location:q.from(J.location)}}Ce.from=Me;function ge(J){const Te=new s.$pK(J.name,X.to(J.kind),J.containerName,q.to(J.location));return Te.tags=J.tags&&J.tags.map(le.to),Te}Ce.to=ge})(Ee||(e.WorkspaceSymbol=Ee={}));var ce;(function(Ce){function Me(J){const Te={name:J.name||"!!MISSING: name!!",detail:J.detail,range:o.from(J.range),selectionRange:o.from(J.selectionRange),kind:X.from(J.kind),tags:J.tags?.map(le.from)??[]};return J.children&&(Te.children=J.children.map(Me)),Te}Ce.from=Me;function ge(J){const Te=new s.$qK(J.name,J.detail,X.to(J.kind),o.to(J.range),o.to(J.selectionRange));return(0,w.$Kb)(J.tags)&&(Te.tags=J.tags.map(le.to)),J.children&&(Te.children=J.children.map(ge)),Te}Ce.to=ge})(ce||(e.DocumentSymbol=ce={}));var $e;(function(Ce){function Me(J){const Te=new s.$uK(X.to(J.kind),J.name,J.detail||"",b.URI.revive(J.uri),o.to(J.range),o.to(J.selectionRange));return Te._sessionId=J._sessionId,Te._itemId=J._itemId,Te}Ce.to=Me;function ge(J,Te,je){if(Te=Te??J._sessionId,je=je??J._itemId,Te===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:je,name:J.name,detail:J.detail,kind:X.from(J.kind),uri:J.uri,range:o.from(J.range),selectionRange:o.from(J.selectionRange),tags:J.tags?.map(le.from)}}Ce.from=ge})($e||(e.CallHierarchyItem=$e={}));var ie;(function(Ce){function Me(ge){return new s.$vK($e.to(ge.from),ge.fromRanges.map(J=>o.to(J)))}Ce.to=Me})(ie||(e.CallHierarchyIncomingCall=ie={}));var z;(function(Ce){function Me(ge){return new s.$wK($e.to(ge.to),ge.fromRanges.map(J=>o.to(J)))}Ce.to=Me})(z||(e.CallHierarchyOutgoingCall=z={}));var q;(function(Ce){function Me(J){return{range:J.range&&o.from(J.range),uri:J.uri}}Ce.from=Me;function ge(J){return new s.$kK(b.URI.revive(J.uri),o.to(J.range))}Ce.to=ge})(q||(e.location=q={}));var ue;(function(Ce){function Me(J){const Te=J,je=J;return{originSelectionRange:Te.originSelectionRange?o.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:je.uri,range:o.from(Te.targetRange?Te.targetRange:je.range),targetSelectionRange:Te.targetSelectionRange?o.from(Te.targetSelectionRange):void 0}}Ce.from=Me;function ge(J){return{targetUri:b.URI.revive(J.uri),targetRange:o.to(J.range),targetSelectionRange:J.targetSelectionRange?o.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?o.to(J.originSelectionRange):void 0}}Ce.to=ge})(ue||(e.DefinitionLink=ue={}));var we;(function(Ce){function Me(J){return{range:o.from(J.range),contents:U.fromMany(J.contents)}}Ce.from=Me;function ge(J){return new s.$nK(J.contents.map(U.to),o.to(J.range))}Ce.to=ge})(we||(e.Hover=we={}));var ve;(function(Ce){function Me(J){return{range:o.from(J.range),expression:J.expression}}Ce.from=Me;function ge(J){return new s.$gL(o.to(J.range),J.expression)}Ce.to=ge})(ve||(e.EvaluatableExpression=ve={}));var me;(function(Ce){function Me(J){if(J instanceof s.$hL)return{type:"text",range:o.from(J.range),text:J.text};if(J instanceof s.$iL)return{type:"variable",range:o.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof s.$jL)return{type:"expression",range:o.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Me;function ge(J){switch(J.type){case"text":return{range:o.to(J.range),text:J.text};case"variable":return{range:o.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:o.to(J.range),expression:J.expression}}}Ce.to=ge})(me||(e.InlineValue=me={}));var ke;(function(Ce){function Me(J){return{frameId:J.frameId,stoppedLocation:o.from(J.stoppedLocation)}}Ce.from=Me;function ge(J){return new s.$kL(J.frameId,o.to(J.stoppedLocation))}Ce.to=ge})(ke||(e.InlineValueContext=ke={}));var re;(function(Ce){function Me(J){return{range:o.from(J.range),kind:J.kind}}Ce.from=Me;function ge(J){return new s.$oK(o.to(J.range),J.kind)}Ce.to=ge})(re||(e.DocumentHighlight=re={}));var he;(function(Ce){function Me(ge){switch(ge){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ce.to=Me})(he||(e.CompletionTriggerKind=he={}));var se;(function(Ce){function Me(ge){return{triggerKind:he.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ce.to=Me})(se||(e.CompletionContext=se={}));var oe;(function(Ce){function Me(J){switch(J){case s.CompletionItemTag.Deprecated:return 1}}Ce.from=Me;function ge(J){switch(J){case 1:return s.CompletionItemTag.Deprecated}}Ce.to=ge})(oe||(e.CompletionItemTag=oe={}));var de;(function(Ce){const Me=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ge(je){return Me.get(je)??9}Ce.from=ge;const J=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Te(je){return J.get(je)??s.CompletionItemKind.Property}Ce.to=Te})(de||(e.CompletionItemKind=de={}));var Ie;(function(Ce){function Me(ge,J){const Te=new s.$EK(ge.label);return Te.insertText=ge.insertText,Te.kind=de.to(ge.kind),Te.tags=ge.tags?.map(oe.to),Te.detail=ge.detail,Te.documentation=A.$3j(ge.documentation)?U.to(ge.documentation):ge.documentation,Te.sortText=ge.sortText,Te.filterText=ge.filterText,Te.preselect=ge.preselect,Te.commitCharacters=ge.commitCharacters,m.$ns.isIRange(ge.range)?Te.range=o.to(ge.range):typeof ge.range=="object"&&(Te.range={inserting:o.to(ge.range.insert),replacing:o.to(ge.range.replace)}),Te.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Te.insertText=new s.$jK(ge.insertText):(Te.insertText=ge.insertText,Te.textEdit=Te.range instanceof s.$aK?new s.$fK(Te.range,Te.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Te.additionalTextEdits=ge.additionalTextEdits.map(je=>De.to(je))),Te.command=J&&ge.command?J.fromInternal(ge.command):void 0,Te}Ce.to=Me})(Ie||(e.CompletionItem=Ie={}));var T;(function(Ce){function Me(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:U.fromStrict(J.documentation)}}Ce.from=Me;function ge(J){return{label:J.label,documentation:A.$3j(J.documentation)?U.to(J.documentation):J.documentation}}Ce.to=ge})(T||(e.ParameterInformation=T={}));var K;(function(Ce){function Me(J){return{label:J.label,documentation:U.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(T.from):[],activeParameter:J.activeParameter}}Ce.from=Me;function ge(J){return{label:J.label,documentation:A.$3j(J.documentation)?U.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(T.to):[],activeParameter:J.activeParameter}}Ce.to=ge})(K||(e.SignatureInformation=K={}));var G;(function(Ce){function Me(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(K.from):[]}}Ce.from=Me;function ge(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(K.to):[]}}Ce.to=ge})(G||(e.SignatureHelp=G={}));var Q;(function(Ce){function Me(ge,J){const Te=new s.$DK($.to(J.position),typeof J.label=="string"?J.label:J.label.map(H.to.bind(void 0,ge)),J.kind&&_.to(J.kind));return Te.textEdits=J.textEdits&&J.textEdits.map(De.to),Te.tooltip=A.$3j(J.tooltip)?U.to(J.tooltip):J.tooltip,Te.paddingLeft=J.paddingLeft,Te.paddingRight=J.paddingRight,Te}Ce.to=Me})(Q||(e.InlayHint=Q={}));var H;(function(Ce){function Me(ge,J){const Te=new s.$CK(J.label);return Te.tooltip=A.$3j(J.tooltip)?U.to(J.tooltip):J.tooltip,f.Command.is(J.command)&&(Te.command=ge.fromInternal(J.command)),J.location&&(Te.location=q.to(J.location)),Te}Ce.to=Me})(H||(e.InlayHintLabelPart=H={}));var _;(function(Ce){function Me(J){return J}Ce.from=Me;function ge(J){return J}Ce.to=ge})(_||(e.InlayHintKind=_={}));var ae;(function(Ce){function Me(J){return{range:o.from(J.range),url:J.target,tooltip:J.tooltip}}Ce.from=Me;function ge(J){let Te;if(J.url)try{Te=typeof J.url=="string"?b.URI.parse(J.url,!0):b.URI.revive(J.url)}catch{}return new s.$JK(o.to(J.range),Te)}Ce.to=ge})(ae||(e.DocumentLink=ae={}));var Fe;(function(Ce){function Me(J){const Te=new s.$MK(J.label);return J.textEdit&&(Te.textEdit=De.to(J.textEdit)),J.additionalTextEdits&&(Te.additionalTextEdits=J.additionalTextEdits.map(je=>De.to(je))),Te}Ce.to=Me;function ge(J){return{label:J.label,textEdit:J.textEdit?De.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Te=>De.from(Te)):void 0}}Ce.from=ge})(Fe||(e.ColorPresentation=Fe={}));var Ue;(function(Ce){function Me(J){return new s.$KK(J[0],J[1],J[2],J[3])}Ce.to=Me;function ge(J){return[J.red,J.green,J.blue,J.alpha]}Ce.from=ge})(Ue||(e.Color=Ue={}));var Qe;(function(Ce){function Me(J){return{range:o.from(J.range)}}Ce.from=Me;function ge(J){return new s.$tK(o.to(J.range))}Ce.to=ge})(Qe||(e.SelectionRange=Qe={}));var Je;(function(Ce){function Me(ge){switch(ge){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ce.to=Me})(Je||(e.TextDocumentSaveReason=Je={}));var xe;(function(Ce){function Me(J){switch(J){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Me;function ge(J){switch(J){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ce.to=ge})(xe||(e.TextEditorLineNumbersStyle=xe={}));var Xe;(function(Ce){function Me(J){if(J===s.EndOfLine.CRLF)return 1;if(J===s.EndOfLine.LF)return 0}Ce.from=Me;function ge(J){if(J===1)return s.EndOfLine.CRLF;if(J===0)return s.EndOfLine.LF}Ce.to=ge})(Xe||(e.EndOfLine=Xe={}));var _e;(function(Ce){function Me(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Me})(_e||(e.ProgressLocation=_e={}));var it;(function(Ce){function Me(J){const Te={start:J.start+1,end:J.end+1};return J.kind&&(Te.kind=tt.from(J.kind)),Te}Ce.from=Me;function ge(J){const Te={start:J.start-1,end:J.end-1};return J.kind&&(Te.kind=tt.to(J.kind)),Te}Ce.to=ge})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Me(J){if(J)switch(J){case s.FoldingRangeKind.Comment:return f.$ct.Comment;case s.FoldingRangeKind.Imports:return f.$ct.Imports;case s.FoldingRangeKind.Region:return f.$ct.Region}}Ce.from=Me;function ge(J){if(J)switch(J.value){case f.$ct.Comment.value:return s.FoldingRangeKind.Comment;case f.$ct.Imports.value:return s.FoldingRangeKind.Imports;case f.$ct.Region.value:return s.FoldingRangeKind.Region}}Ce.to=ge})(tt||(e.FoldingRangeKind=tt={}));var ze;(function(Ce){function Me(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?o.from(ge.selection):void 0,override:typeof ge.override=="boolean"?c.$MD.id:void 0}}Ce.from=Me})(ze||(e.TextEditorOpenOptions=ze={}));var st;(function(Ce){function Me(je){return je instanceof s.$7K?je.toJSON():typeof je=="string"?je:ge(je)||J(je)?new s.$7K(je.baseUri??je.base,je.pattern).toJSON():je}Ce.from=Me;function ge(je){const Ge=je;return Ge?b.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function J(je){const Ge=je;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Te(je){return typeof je=="string"?je:new s.$7K(b.URI.revive(je.baseUri),je.pattern)}Ce.to=Te})(st||(e.GlobPattern=st={}));var x;(function(Ce){function Me(ge){if(ge){if(Array.isArray(ge))return ge.map(Me);if(typeof ge=="string")return ge;{const J=ge;return{language:J.language,scheme:J.scheme,pattern:st.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Ce.from=Me})(x||(e.LanguageSelector=x={}));var Y;(function(Ce){function Me(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Te=>Array.isArray(Te)&&Te.every(je=>je&&typeof je=="object"&&"uri"in je&&b.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Ge=>Ge instanceof s.$aK)))}Ce.is=Me;function ge(J){return{documents:J.documents.map(Te=>Te.map(je=>({uri:b.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Ge=>o.from(Ge))})))}}Ce.from=ge})(Y||(e.MappedEditsContext=Y={}));var pe;(function(Ce){function Me(J){return{start:J.start,end:J.end}}Ce.from=Me;function ge(J){return new s.$vL(J.start,J.end)}Ce.to=ge})(pe||(e.NotebookRange=pe={}));var Be;(function(Ce){function Me(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Ce.to=Me;function ge(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Ce.from=ge})(Be||(e.NotebookCellExecutionSummary=Be={}));var Oe;(function(Ce){function Me(ge){if(ge===v.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(ge===v.NotebookCellExecutionState.Pending)return;if(ge===v.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ce.to=Me})(Oe||(e.NotebookCellExecutionState=Oe={}));var Ye;(function(Ce){function Me(J){switch(J){case s.NotebookCellKind.Markup:return v.CellKind.Markup;case s.NotebookCellKind.Code:default:return v.CellKind.Code}}Ce.from=Me;function ge(J){switch(J){case v.CellKind.Markup:return s.NotebookCellKind.Markup;case v.CellKind.Code:default:return s.NotebookCellKind.Code}}Ce.to=ge})(Ye||(e.NotebookCellKind=Ye={}));var rt;(function(Ce){function Me(J){const Te={metadata:J.metadata??Object.create(null),cells:[]};for(const je of J.cells)s.$wL.validate(je),Te.cells.push(gt.from(je));return Te}Ce.from=Me;function ge(J){const Te=new s.$xL(J.cells.map(gt.to));return(0,a.$Kf)(J.metadata)||(Te.metadata=J.metadata),Te}Ce.to=ge})(rt||(e.NotebookData=rt={}));var gt;(function(Ce){function Me(J){return{cellKind:Ye.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:Be.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Pt.from):[]}}Ce.from=Me;function ge(J){return new s.$wL(Ye.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Pt.to):void 0,J.metadata,J.internalMetadata?Be.to(J.internalMetadata):void 0)}Ce.to=ge})(gt||(e.NotebookCellData=gt={}));var yt;(function(Ce){function Me(J){return{mime:J.mime,valueBytes:M.$ae.wrap(J.data)}}Ce.from=Me;function ge(J){return new s.$yL(J.valueBytes.buffer,J.mime)}Ce.to=ge})(yt||(e.NotebookCellOutputItem=yt={}));var Pt;(function(Ce){function Me(J){return{outputId:J.id,items:J.items.map(yt.from),metadata:J.metadata}}Ce.from=Me;function ge(J){const Te=J.items.map(yt.to);return new s.$zL(Te,J.outputId,J.metadata)}Ce.to=ge})(Pt||(e.NotebookCellOutput=Pt={}));var Yt;(function(Ce){function Me(Te){return J(Te)?{include:st.from(Te.include)??void 0,exclude:st.from(Te.exclude)??void 0}:st.from(Te)??void 0}Ce.from=Me;function ge(Te){return J(Te)?{include:st.to(Te.include),exclude:st.to(Te.exclude)}:st.to(Te)}Ce.to=ge;function J(Te){const je=Te;return je?!(0,a.$Gf)(je.include)&&!(0,a.$Gf)(je.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var qt;(function(Ce){function Me(ge,J,Te){const je=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(je,Te),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ce.from=Me})(qt||(e.NotebookStatusBarItem=qt={}));var bt;(function(Ce){function Me(ge,J,Te){const je=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:J.toInternal(je,Te),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ce.from=Me})(bt||(e.NotebookKernelSourceAction=bt={}));var Ut;(function(Ce){function Me(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ce.from=Me})(Ut||(e.NotebookDocumentContentOptions=Ut={}));var Ft;(function(Ce){function Me(J){return{uri:J.uri,provides:J.provides}}Ce.from=Me;function ge(J){return new s.$BL(b.URI.revive(J.uri),J.provides)}Ce.to=ge})(Ft||(e.NotebookRendererScript=Ft={}));var jt;(function(Ce){function Me(J){return{message:U.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:o.from(J.location.range),uri:J.location.uri}}}Ce.from=Me;function ge(J){const Te=new s.$HL(typeof J.message=="string"?J.message:U.to(J.message));return Te.actualOutput=J.actual,Te.expectedOutput=J.expected,Te.contextValue=J.contextValue,Te.location=J.location?q.to(J.location):void 0,Te}Ce.to=ge})(jt||(e.TestMessage=jt={}));var At;(function(Ce){Ce.namespace=p.$6I,Ce.denamespace=p.$7I})(At||(e.TestTag=At={}));var Rt;(function(Ce){function Me(J){const Te=(0,n.$6L)(J).controllerId;return{extId:D.$2I.fromExtHostTestItem(J,Te).toString(),label:J.label,uri:b.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(je=>At.namespace(Te,je.id)),range:m.$ns.lift(o.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&U.fromStrict(J.error)||null}}Ce.from=Me;function ge(J){return{parent:void 0,error:void 0,id:D.$2I.fromString(J.extId).localId,label:J.label,uri:b.URI.revive(J.uri),tags:(J.tags||[]).map(Te=>{const{tagId:je}=At.denamespace(Te);return new s.$IL(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Ce.toPlain=ge})(Rt||(e.TestItem=Rt={})),function(Ce){function Me(J){return{id:J.id}}Ce.from=Me;function ge(J){return new s.$IL(J.id)}Ce.to=ge}(At||(e.TestTag=At={}));var Nt;(function(Ce){const Me=(J,Te)=>{const je=[];for(const[We,et]of Te)D.$2I.compare(et.item.extId,We)===2&&(Te.delete(We),je.push(et));const Ge={...Rt.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(et=>et.type===0).map(jt.to)})),children:je.map(We=>Me(We,Te))};for(const We of Ge.children)We.parent=Ge;return Ge};function ge(J){const Te=[],je=new Map;for(const Ge of J.items){je.set(Ge.item.extId,Ge);const We=D.$2I.root(Ge.item.extId);J.request.targets.some(et=>et.controllerId===We&&et.testIds.includes(Ge.item.extId))&&Te.push(Ge)}return{completedAt:J.completedAt,results:Te.map(Ge=>Me(Ge,je))}}Ce.to=ge})(Nt||(e.TestResults=Nt={}));var Bt;(function(Ce){function Me(je){return{covered:je.covered,total:je.covered}}function ge(je){return"line"in je?$.from(je):o.from(je)}function J(je){return"branches"in je?{count:je.executionCount,location:ge(je.location),type:1,branches:je.branches.length?je.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ge(Ge.location)})):void 0}:{type:0,count:je.executionCount,location:ge(je.location)}}Ce.fromDetailed=J;function Te(je){return{uri:je.uri,statement:Me(je.statementCoverage),branch:je.branchCoverage&&Me(je.branchCoverage),function:je.functionCoverage&&Me(je.functionCoverage),details:je.detailedCoverage?.map(J)}}Ce.fromFile=Te})(Bt||(e.TestCoverage=Bt={}));var Kt;(function(Ce){function Me(ge){switch(ge){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ce.to=Me})(Kt||(e.CodeActionTriggerKind=Kt={}));var Wt;(function(Ce){function Me(J){const Te=new s.$OL(X.to(J.kind),J.name,J.detail||"",b.URI.revive(J.uri),o.to(J.range),o.to(J.selectionRange));return Te._sessionId=J._sessionId,Te._itemId=J._itemId,Te}Ce.to=Me;function ge(J,Te,je){if(Te=Te??J._sessionId,je=je??J._itemId,Te===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:je,kind:X.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:o.from(J.range),selectionRange:o.from(J.selectionRange),tags:J.tags?.map(le.from)}}Ce.from=ge})(Wt||(e.TypeHierarchyItem=Wt={}));var at;(function(Ce){function Me(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}Ce.from=Me})(at||(e.ViewBadge=at={}));var ut;(function(Ce){function Me(je,Ge,We){const et=Ge.fileData;return et?new s.$ZK(new s.$1K(et.name,b.URI.revive(et.uri),et.id,(0,F.$cb)(()=>We(et.id)))):je===P.$Kr.uriList&&Ge.uriListData?new s.$YK(Te(Ge.uriListData)):new s.$YK(Ge.asString)}Ce.to=Me;async function ge(je,Ge){const We=await Ge.asString();if(je===P.$Kr.uriList)return{asString:We,fileData:void 0,uriListData:J(We)};const et=Ge.asFile();return{asString:We,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ce.from=ge;function J(je){return C.$Ws.split(je).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return b.URI.parse(Ge)}catch{}return Ge})}function Te(je){return C.$Ws.create(je.map(Ge=>typeof Ge=="string"?Ge:b.URI.revive(Ge)))}})(ut||(e.DataTransferItem=ut={}));var Jt;(function(Ce){function Me(J,Te){const je=J.items.map(([Ge,We])=>[Ge,ut.to(Ge,We,Te)]);return new s.$2K(je)}Ce.toDataTransfer=Me;async function ge(J){const Te={items:[]},je=[];for(const[Ge,We]of J)je.push((async()=>{Te.items.push([Ge,await ut.from(Ge,We)])})());return await Promise.all(je),Te}Ce.from=ge})(Jt||(e.DataTransfer=Jt={}));var Ct;(function(Ce){function Me(J){return{message:J.message,metadata:J.metadata,title:J.title,tooltip:J.tooltip}}Ce.to=Me;function ge(J){return{kind:"reply",message:J.message,metadata:J.metadata,title:J.title,tooltip:J.tooltip}}Ce.from=ge})(Ct||(e.ChatReplyFollowup=Ct={}));var Dt;(function(Ce){function Me(ge){return typeof ge=="string"?{title:ge,message:ge,kind:"reply"}:"commandId"in ge?{kind:"command",title:ge.title??"",commandId:ge.commandId??"",when:ge.when??"",args:ge.args}:Ct.from(ge)}Ce.from=Me})(Dt||(e.ChatFollowup=Dt={}));var ht;(function(Ce){function Me(J){const Te=new s.$YL(St.to(J.role),J.content);return Te.name=J.name,Te}Ce.to=Me;function ge(J){return{role:St.from(J.role),content:J.content,name:J.name}}Ce.from=ge})(ht||(e.ChatMessage=ht={}));var St;(function(Ce){function Me(J){switch(J){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ce.to=Me;function ge(J){switch(J){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ce.from=ge})(St||(e.ChatMessageRole=St={}));var Lt;(function(Ce){function Me(J){return{level:Et.to(J.level),value:J.value,description:J.description}}Ce.to=Me;function ge(J){return{level:Et.from(J.level),value:J.value,description:J.description}}Ce.from=ge})(Lt||(e.ChatVariable=Lt={}));var Et;(function(Ce){function Me(J){switch(J){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ce.to=Me;function ge(J){switch(J){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ce.from=ge})(Et||(e.ChatVariableLevel=Et={}));var qe;(function(Ce){function Me(ge){switch(ge){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Me})(qe||(e.InteractiveEditorResponseFeedbackKind=qe={}));var Ot;(function(Ce){function Me(ge,J,Te){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand}:"uri"in ge?{uri:ge.uri}:J.toInternal(ge,Te)}Ce.from=Me})(Ot||(e.TerminalQuickFix=Ot={}))}),define(Ae[203],Re([1,0,2,9,7,8,173]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=void 0;class h{constructor(g,P,k,a={timeout:1500,errors:3}){this.c=g,this.d=P,this.f=k,this.g=a,this.a=new A.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(P,k,a)=>{const m={dispose:this.a.push([P,k,g])};return Array.isArray(a)&&a.push(m),m}}async $participateInSave(g,P){const k=w.URI.revive(g);let a=!1;const b=setTimeout(()=>a=!0,this.g.timeout),m=[];try{for(const f of[...this.a]){if(a)break;const t=this.d.getDocument(k),n=await this.h(f,{document:t,reason:F.TextDocumentSaveReason.to(P)});m.push(n)}}finally{clearTimeout(b)}return m}h([g,P,k],a){const b=this.b.get(g);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(k,g,P,a).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const f=this.b.get(g);this.b.set(g,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,P,k,a){const b=[],m=Date.now(),{document:f,reason:t}=a,{version:n}=f,c=Object.freeze({document:f,reason:t,waitUntil(v){if(Object.isFrozen(b))throw(0,M.$7)("waitUntil can not be called async");b.push(Promise.resolve(v))}});try{P.apply(k,[c])}catch(v){return Promise.reject(v)}return Object.freeze(b),new Promise((v,D)=>{const p=setTimeout(()=>D(new Error("timeout")),this.g.timeout);return Promise.all(b).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(p),v(r)}).catch(r=>{clearTimeout(p),D(r)})}).then(v=>{const D={edits:[]};for(const p of v)if(Array.isArray(p)&&p.every(r=>r instanceof C.$fK))for(const{newText:r,newEol:s,range:i}of p)D.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:i&&F.Range.from(i),text:r,eol:s&&F.EndOfLine.from(s)}});if(D.edits.length!==0)return n===f.version?this.f.$tryApplyWorkspaceEdit(D):Promise.reject(new Error("concurrent_edits"))})}}e.$Wbc=h}),define(Ae[204],Re([1,0,12,2,8,7,75]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=e.$0cc=void 0;class h{constructor(k,a,b,m){this.start=k,this.deletedCount=a,this.deletedItems=b,this.items=m}asApiEvent(){return{range:new F.$vL(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(k,a){return{EOL:a.eol,lines:a.source,languageId:a.language,uri:a.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,a,b){this.notebook=k,this.h=a,this.j=b,this.handle=b.handle,this.uri=M.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(C.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return k.g},set mime(m){k.g=m},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(b)}return this.f}setOutputs(k){this.a=k.map(C.NotebookCellOutput.to)}setOutputItems(k,a,b){const m=b.map(C.NotebookCellOutputItem.to),f=this.a.find(t=>t.id===k);if(f&&(a||(f.items.length=0),f.items.push(...m),f.items.length>1&&f.items.every(t=>A.$iI(t.mime)))){const t=new Map,n=[];f.items.forEach(c=>{let v;t.has(c.mime)?v=t.get(c.mime):(v=[],t.set(c.mime,v),n.push(c.mime)),v.push(c.data)}),f.items.length=0,n.forEach(c=>{const v=A.$jI(t.get(c));f.items.push({mime:c,data:v.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$0cc=E;class g{static{this.a=0}constructor(k,a,b,m,f){this.k=k,this.l=a,this.m=b,this.uri=m,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,a={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===w.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(b){return b=k.n(b),k.b[b].apiCell},getCells(b){return(b?k.p(b):k.b).map(f=>f.apiCell)},save(){return k.q()}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,a,b){this.g=k.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:b});const m={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},f=[];for(const n of k.rawEvents)n.kind===A.NotebookCellsChangeType.ModelChange?this.r(n.changes,!1,m.contentChanges):n.kind===A.NotebookCellsChangeType.Move?this.s(n.index,n.length,n.newIdx,m.contentChanges):n.kind===A.NotebookCellsChangeType.Output?(this.t(n.index,n.outputs),f.push({cell:this.b[n.index].apiCell,outputs:this.b[n.index].apiCell.outputs})):n.kind===A.NotebookCellsChangeType.OutputItem?(this.u(n.index,n.outputId,n.append,n.outputItems),f.push({cell:this.b[n.index].apiCell,outputs:this.b[n.index].apiCell.outputs})):n.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(n.index,n.language),f.push({cell:this.b[n.index].apiCell,document:this.b[n.index].apiCell.document})):n.kind===A.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[n.index].apiCell,document:this.b[n.index].apiCell.document}):n.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(n.index,n.mime):n.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(n.index,n.metadata),f.push({cell:this.b[n.index].apiCell,metadata:this.b[n.index].apiCell.metadata})):n.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(n.index,n.internalMetadata),f.push({cell:this.b[n.index].apiCell,executionSummary:this.b[n.index].apiCell.executionSummary}));const t=new Map;for(let n=0;n<f.length;n++){const c=f[n],v=t.get(c.cell);if(v===void 0){const D=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,D-1)}else m.cellChanges[v]={...m.cellChanges[v],...c}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let a=k.start|0,b=k.end|0;return a<0&&(a=0),b>this.b.length&&(b=this.b.length),k.with({start:a,end:b})}p(k){k=this.o(k);const a=[];for(let b=k.start;b<k.end;b++)a.push(this.b[b]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,a,b){if(this.j)return;const m=[],f=[],t=[];if(k.reverse().forEach(n=>{const v=n[2].map(r=>{const s=new E(this,this.l,r);return a||f.push(E.asModelAddData(this.apiNotebook,r)),s}),D=new h(n[0],n[1],[],v),p=this.b.splice(n[0],n[1],...v);for(const r of p)t.push(r.uri),D.deletedItems.push(r.apiCell);m.push(D)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),b)for(const n of m)b.push(n.asApiEvent())}s(k,a,b,m){const f=this.b.splice(k,a);this.b.splice(b,0,...f);const t=[new h(k,a,f.map(n=>n.apiCell),[]),new h(b,0,[],f)];for(const n of t)m.push(n.asApiEvent())}t(k,a){this.b[k].setOutputs(a)}u(k,a,b,m){this.b[k].setOutputItems(a,b,m)}v(k,a){const b=this.b[k];b.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(b.uri,a)}w(k,a){const b=this.b[k];b.apiCell.mime=a}x(k,a){this.b[k].setMetadata(a)}y(k,a){this.b[k].setInternalMetadata(a)}getCellFromApiCell(k){return this.b.find(a=>a.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(a=>a.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$$cc=g}),define(Ae[205],Re([1,0,5,2,8,7]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class A{constructor(E,g,P,k={timeout:1500,errors:3}){this.b=E,this.c=g,this.d=P,this.f=k,this.a=new w.$Od}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(g,P,k)=>{const a=function(m){g.call(P,m)};return a.extension=E,this.a.event(a,void 0,k)}}async $participateInSave(E,g,P){const k=M.URI.revive(E),a=this.c.getNotebookDocument(k);if(!a)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:a.apiNotebook,reason:C.TextDocumentSaveReason.to(g)},P,async(f,t)=>{const n=Date.now(),c=await await Promise.resolve(f);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&c&&(c instanceof F.$iK?b.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(b.length===0)return!0;const m={edits:[]};for(const f of b){const{edits:t}=C.WorkspaceEdit.from(f);m.edits=m.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(m)}}e.$ydc=A}),define(Ae[103],Re([1,0,9,8,7]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(h,E,g,P,k,a){this.id=h,this.f=E,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=P,this.c=a}get apiEditor(){if(!this.e){const h=this;this.e={get notebook(){return h.notebookData.apiNotebook},get selection(){return h.a[0]},set selection(E){this.selections=[E]},get selections(){return h.a},set selections(E){if(!Array.isArray(E)||!E.every(C.$vL.isNotebookRange))throw(0,w.$6)("selections");h.a=E,h.g(E)},get visibleRanges(){return h.b},revealRange(E,g){h.f.$tryRevealRange(h.id,M.NotebookRange.from(E),g??C.NotebookEditorRevealType.Default)},get viewColumn(){return h.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(h){this.d=h}_acceptVisibleRanges(h){this.b=h}_acceptSelections(h){this.a=h}g(h){this.f.$trySetSelections(this.id,h.map(M.NotebookRange.from))}_acceptViewColumn(h){this.c=h}}e.$_cc=F}),define(Ae[206],Re([1,0,9,5,14,8]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;let A=class{constructor(E,g){this.c=E,this.d=g,this.a=new M.$Md({onListenerError:w.$1}),this.b=new M.$Md({onListenerError:w.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,g);const P=this.d.getEditorById(E);g.visibleRanges&&P._acceptVisibleRanges(g.visibleRanges.ranges.map(F.NotebookRange.to)),g.selections&&P._acceptSelections(g.selections.selections.map(F.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const g in E)this.d.getEditorById(g)._acceptViewColumn(F.ViewColumn.to(E[g]))}};e.$rdc=A,e.$rdc=A=Ke([Ve(0,C.$8i)],A)}),define(Ae[207],Re([1,0,8,72,152,21,65,9]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class E{constructor(a){this.b=0,this.c=new Map,this.a=a}async withProgress(a,b,m){const f=this.b++,{title:t,location:n,cancellable:c}=b,v={label:(0,C.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this.a.$startProgress(f,{location:w.ProgressLocation.from(n),title:t,source:v,cancellable:c},a.isUnderDevelopment?void 0:a.identifier.value).catch(h.$1),this.d(f,m,!!c)}d(a,b,m){let f;m&&(f=new F.$Wd,this.c.set(a,f));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),f?.dispose()};let n;try{n=b(new P(this.a,a),m&&f?f.token:F.CancellationToken.None)}catch(c){throw t(a),c}return n.then(c=>t(a),c=>t(a)),n}$acceptProgressCanceled(a){const b=this.c.get(a);b&&(b.cancel(),this.c.delete(a))}}e.$vcc=E;function g(k,a){return k.message=a.message,typeof a.increment=="number"&&(typeof k.increment=="number"?k.increment+=a.increment:k.increment=a.increment),k}class P extends M.$Yu{constructor(a,b){super(m=>this.throttledReport(m)),this.i=a,this.j=b}throttledReport(a){this.i.$progressReport(this.j,a)}}Ke([(0,A.$hh)(100,(k,a)=>g(k,a),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Ae[104],Re([1,0,44,101,45,76,57,8,2]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=e.$kM=e.$jM=void 0;const g=(v,D,p,r)=>{let s=D;return{enumerable:!0,configurable:!1,get(){return s},set(i){if(!p(s,i)){const o=s;s=i,v.listener?.(r(i,o))}}}},P=(v,D)=>v===D,k={range:(v,D)=>v===D?!0:!v||!D?!1:v.isEqual(D),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(v,D)=>!(v.length!==D.length||v.some(p=>!D.find(r=>p.id===r.id)))},a=v=>D=>({op:4,update:v(D)}),b=(v,D)=>({range:(()=>{let p;const r=a(s=>({range:w.$ns.lift(h.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return p},set(s){v.listener?.({op:6}),k.range(p,s)||(p=s,v.listener?.(r(s)))}}})(),label:g(v,D,k.label,a(p=>({label:p}))),description:g(v,void 0,k.description,a(p=>({description:p}))),sortText:g(v,void 0,k.sortText,a(p=>({sortText:p}))),canResolveChildren:g(v,!1,k.canResolveChildren,p=>({op:2,state:p})),busy:g(v,!1,k.busy,a(p=>({busy:p}))),error:g(v,void 0,k.error,a(p=>({error:h.MarkdownString.fromStrict(p)||null}))),tags:g(v,[],k.tags,(p,r)=>({op:1,new:p.map(h.TestTag.from),old:r.map(h.TestTag.from)}))}),m=v=>{const D=C.$2I.fromString(v.extId),p=new t(D.controllerId,D.localId,v.label,E.URI.revive(v.uri)||void 0);return p.range=h.Range.to(v.range||void 0),p.description=v.description||void 0,p.sortText=v.sortText||void 0,p.tags=v.tags.map(r=>h.TestTag.to({id:(0,A.$7I)(r).tagId})),p},f=v=>{let D;for(const p of v.tests){const r=m(p.item);(0,M.$6L)(r).parent=D,D=r}return D};e.$jM=f;class t{constructor(D,p,r,s){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const i=(0,M.$5L)(this,D);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof n?void 0:i.parent}},children:{value:(0,F.$4L)(i,M.$6L,t),enumerable:!0,writable:!1},...b(i,r)})}}e.$kM=t;class n extends t{constructor(D,p){super(D,D,p,void 0),this._isRoot=!0}}e.$lM=n;class c extends F.$ZL{constructor(D,p,r){super({controllerId:D,getDocumentVersion:s=>s&&r.getDocument(s)?.version,getApiFor:M.$6L,getChildren:s=>s.children,root:new n(D,p),toITestItem:h.TestItem.from})}}e.$mM=c}),define(Ae[105],Re([1,0,51,9,88,8,7]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gM=e.$fM=e.$eM=void 0;class h{static{this.c=new C.$cM("TextEditorDecorationType")}constructor(a,b,m){const f=h.c.nextId();a.$registerTextEditorDecorationType(b.identifier,f,F.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:f,dispose(){a.$removeTextEditorDecorationType(f)}})}}e.$eM=h;class E{constructor(a,b){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,b){this.k();let m=null;if(a instanceof A.$_J)m=new A.$aK(a,a);else if(a instanceof A.$aK)m=a;else throw new Error("Unrecognized location");this.l(m,b,!1)}insert(a,b){this.k(),this.l(new A.$aK(a,a),b,!0)}delete(a){this.k();let b=null;if(a instanceof A.$aK)b=a;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(a,b,m){const f=this.c.validateRange(a);this.g.push({range:f,text:b,forceMoveMarkers:m})}setEndOfLine(a){if(this.k(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,M.$6)("endOfLine");this.h=a}}class g{constructor(a,b,m,f){this.c=a,this.d=b,this._accept(m),this.e=f;const t=this;this.value={get tabSize(){return t.f},set tabSize(n){t.m(n)},get indentSize(){return t.g},set indentSize(n){t.o(n)},get insertSpaces(){return t.h},set insertSpaces(n){t.q(n)},get cursorStyle(){return t.j},set cursorStyle(n){t.s(n)},get lineNumbers(){return t.k},set lineNumbers(n){t.t(n)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.insertSpaces,this.j=a.cursorStyle,this.k=F.TextEditorLineNumbersStyle.to(a.lineNumbers)}l(a){if(a==="auto")return"auto";if(typeof a=="number"){const b=Math.floor(a);return b>0?b:null}if(typeof a=="string"){const b=parseInt(a,10);return isNaN(b)?null:b>0?b:null}return null}m(a){const b=this.l(a);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const b=Math.floor(a);return b>0?b:null}if(typeof a=="string"){const b=parseInt(a,10);return isNaN(b)?null:b>0?b:null}return null}o(a){const b=this.n(a);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(a){return a==="auto"?"auto":a==="false"?!1:!!a}q(a){const b=this.p(a);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(a){this.j!==a&&(this.j=a,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}t(a){this.k!==a&&(this.k=a,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(a)})))}assign(a){const b={};let m=!1;if(typeof a.tabSize<"u"){const f=this.l(a.tabSize);f==="auto"?(m=!0,b.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,m=!0,b.tabSize=f)}if(typeof a.indentSize<"u"){const f=this.n(a.indentSize);f==="tabSize"?(m=!0,b.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,m=!0,b.indentSize=f)}if(typeof a.insertSpaces<"u"){const f=this.p(a.insertSpaces);f==="auto"?(m=!0,b.insertSpaces=f):this.h!==f&&(this.h=f,m=!0,b.insertSpaces=f)}typeof a.cursorStyle<"u"&&this.j!==a.cursorStyle&&(this.j=a.cursorStyle,m=!0,b.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.k!==a.lineNumbers&&(this.k=a.lineNumbers,m=!0,b.lineNumbers=F.TextEditorLineNumbersStyle.from(a.lineNumbers)),m&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(a,b){b.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn(m)})}}e.$fM=g;class P{constructor(a,b,m,f,t,n,c,v){this.id=a,this.j=b,this.k=m,this.g=!1,this.h=new Set,this.c=t,this.d=new g(this.j,this.id,n,m),this.e=c,this.f=v;const D=this;this.value=Object.freeze({get document(){return f.value},set document(p){throw new M.$8("document")},get selection(){return D.c&&D.c[0]},set selection(p){if(!(p instanceof A.$bK))throw(0,M.$6)("selection");D.c=[p],D.l()},get selections(){return D.c},set selections(p){if(!Array.isArray(p)||p.some(r=>!(r instanceof A.$bK)))throw(0,M.$6)("selections");D.c=p,D.l()},get visibleRanges(){return D.e},set visibleRanges(p){throw new M.$8("visibleRanges")},get options(){return D.d.value},set options(p){D.g||D.d.assign(p)},get viewColumn(){return D.f},set viewColumn(p){throw new M.$8("viewColumn")},edit(p,r={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new E(f.value,r);return p(s),D.m(s)},insertSnippet(p,r,s={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!r||Array.isArray(r)&&r.length===0)i=D.c.map(o=>F.Range.from(o));else if(r instanceof A.$_J){const{lineNumber:o,column:y}=F.Position.from(r);i=[{startLineNumber:o,startColumn:y,endLineNumber:o,endColumn:y}]}else if(r instanceof A.$aK)i=[F.Range.from(r)];else{i=[];for(const o of r)if(o instanceof A.$aK)i.push(F.Range.from(o));else{const{lineNumber:y,column:$}=F.Position.from(o);i.push({startLineNumber:y,startColumn:$,endLineNumber:y,endColumn:$})}}return b.$tryInsertSnippet(a,f.value.version,p.value,i,s)},setDecorations(p,r){const s=r.length===0;s&&!D.h.has(p.key)||(s?D.h.delete(p.key):D.h.add(p.key),D.n(()=>{if(F.$7L(r))return b.$trySetDecorations(a,p.key,F.$8L(r));{const i=new Array(4*r.length);for(let o=0,y=r.length;o<y;o++){const $=r[o];i[4*o]=$.start.line+1,i[4*o+1]=$.start.character+1,i[4*o+2]=$.end.line+1,i[4*o+3]=$.end.character+1}return b.$trySetDecorationsFast(a,p.key,i)}}))},revealRange(p,r){D.n(()=>b.$tryRevealRange(a,F.Range.from(p),r||A.TextEditorRevealType.Default))},show(p){b.$tryShowEditor(a,F.ViewColumn.from(p))},hide(){b.$tryHideEditor(a)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,w.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,w.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,w.ok)(!this.g),this.f=a}_acceptSelections(a){(0,w.ok)(!this.g),this.c=a}async l(){const a=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const b=a.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const m=b.edits.map(t=>t.range);m.sort((t,n)=>t.end.line===n.end.line?t.end.character===n.end.character?t.start.line===n.start.line?t.start.character-n.start.character:t.start.line-n.start.line:t.end.character-n.end.character:t.end.line-n.end.line);for(let t=0,n=m.length-1;t<n;t++){const c=m[t].end;if(m[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=b.edits.map(t=>({range:F.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,f,{setEndOfLine:typeof b.setEndOfLine=="number"?F.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$gM=P}),define(Ae[208],Re([1,0,4,171]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=void 0,e.$tJ=(0,w.$Oh)(M.$Uh)}),define(Ae[106],Re([1,0,20,5,19,6]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$03b=e.$93b=e.$83b=e.$73b=e.$63b=e.$53b=void 0;class A{constructor(n,c){this.versionId=n,this.removedDueToLooping=c}}e.$53b=A;class h{static isHostExtension(n,c,v){if(c.getExtensionDescription(n))return!1;const D=v.getExtensionDescription(n);return D?!!((D.main||D.browser)&&D.api==="none"):!1}constructor(n,c){this.j=n,this.c=new M.$Md,this.onDidChange=this.c.event,this.d=0,this.e=c,this.k()}k(){this.e.sort(m),this.f=new w.$1l,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const c=this.j.readActivationEvents(n);if(Array.isArray(c))for(let v of c)v==="onUri"&&(v=`onUri:${w.$Yl.toKey(n.identifier)}`),this.h.has(v)||this.h.set(v,[]),this.h.get(v).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,c){this.e=f(this.e,c),this.e=this.e.concat(n);const v=h.l(this.e);return this.e=f(this.e,v.map(D=>D.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,v)}static l(n){const c=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,i){this.addNode(s),this.addNode(i),this.c.has(s)?this.c.get(s).push(i):this.c.set(s,[i])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,i){const o=c.getArcs(s);for(let y=0;y<o.length;y++)if(!i.has(o[y]))return!1;return!0}getNodes(){return this.e}},v=new w.$1l;for(const s of n)if(v.set(s.identifier,s),s.extensionDependencies)for(const i of s.extensionDependencies)c.addArc(w.$Yl.toKey(s.identifier),w.$Yl.toKey(i));const D=new Set;c.getNodes().filter(s=>c.getArcs(s).length===0).forEach(s=>D.add(s));const p=c.getNodes().filter(s=>!D.has(s));let r;do{r=!1;for(let s=0;s<p.length;s++){const i=p[s];c.hasOnlyGoodArcs(i,D)&&(p.splice(s,1),s--,D.add(i),r=!0)}}while(r);return p.map(s=>v.get(s))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const c=this.h.get(n);return c?c.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const c=this.f.get(n);return c||void 0}getExtensionDescriptionByUUID(n){for(const c of this.g)if(c.uuid===n)return c}getExtensionDescriptionByIdOrUUID(n,c){return this.getExtensionDescription(n)??(c?this.getExtensionDescriptionByUUID(c):void 0)}}e.$63b=h;class E{constructor(n,c){this.versionId=n,this.extensions=c}}e.$73b=E,e.$83b={readActivationEvents:t=>t.activationEvents};class g{constructor(n){this.d=new a,this.c=new h(n,[])}async acquireLock(n){const c=await this.d.acquire(n);return new P(this,c)}deltaExtensions(n,c,v){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(c,v)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,c){return this.c.getExtensionDescriptionByIdOrUUID(n,c)}}e.$93b=g;class P extends F.$Rc{constructor(n,c){super(),this.f=n,this.c=!1,this.B(c)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$03b=P;class k{constructor(n){this.name=n,this.promise=new Promise((c,v)=>{this.c=c})}resolve(n){this.c(n)}}class a{constructor(){this.c=[],this.d=!1}async acquire(n){const c=new k(n);return this.c.push(c),this.e(),c.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let c=!0;const v=setTimeout(()=>{c&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),D=()=>{c&&(clearTimeout(v),c=!1,this.d=!1,this.e())};n.resolve((0,F.$Pc)(D))}}var b;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(b||(b={}));function m(t,n){const c=t.isBuiltin?0:t.isUnderDevelopment?2:1,v=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(c!==v)return c-v;const D=C.$fc.basename(t.extensionLocation.path),p=C.$fc.basename(n.extensionLocation.path);return D<p?-1:D>p?1:0}function f(t,n){const c=new w.$Zl(n);return t.filter(v=>!c.has(v.identifier))}}),define(Ae[79],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$8l=e.$7l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(M||(e.UIKind=M={}));var C;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var F;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function A(g){const P=w.$ae.alloc(1);switch(g){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$7l=A;function h(g,P){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$8l=h;var E;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(Ae[58],Re([1,0,4,5,14,27,79,52,53,24,2,6,154]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=e.$pM=e.$oM=void 0;let b=class extends k.$Rc{constructor(n,c){super(),this.s=n,this.t=c,this.a=this.B(new M.$Md),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Md),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=c.createLogger(this.m,{id:E.$ho,name:(0,a.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(v=>{(0,C.$0i)(v)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(n,c,v){const D=this.getTelemetryDetails(),p=new m(c,v,n,this.n,this.j,this.getBuiltInCommonProperties(n),{isUsageEnabled:D.isUsageEnabled,isErrorsEnabled:D.isErrorsEnabled}),r=this.r.get(n.identifier.value)??[];return this.r.set(n.identifier.value,[...r,p]),p.apiTelemetryLogger}$initializeTelemetryLevel(n,c,v){this.f=n,this.g=c,this.c=v??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(n){const c=Object.create(null);switch(c["common.extname"]=`${n.publisher}.${n.name}`,c["common.extversion"]=n.version,c["common.vscodemachineid"]=this.s.telemetryInfo.machineId,c["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,c["common.vscodeversion"]=this.s.version,c["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),c["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:c["common.uikind"]="web";break;case A.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,h.$Sk)((0,E.$oo)(this.s.remote.authority)),c}$onDidChangeTelemetryLevel(n){this.h=this.getTelemetryConfiguration(),this.f=n;const c=this.getTelemetryDetails();this.r.forEach((v,D)=>{const p=v.filter(r=>!r.isDisposed);p.length===0?this.r.delete(D):this.r.set(D,p)}),this.r.forEach(v=>{for(const D of v)D.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(n,c){const D=this.r.get(n.value)?.filter(r=>!r.isDisposed);if(!D)return this.r.delete(n.value),!1;let p=!1;for(const r of D)r.ignoreUnhandledExtHostErrors||(r.logError(c),p=!0);return p}};e.$oM=b,e.$oM=b=Ke([Ve(0,F.$nM),Ve(1,C.$9i)],b);class m{static validateSender(n){if(typeof n!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof n.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof n.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof n.flush<"u"&&typeof n.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(n,c,v,D,p,r,s){this.g=v,this.h=D,this.i=p,this.j=r,this.a=new M.$Md,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=n,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(n,c){this.e&&(this.d={isUsageEnabled:n,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(n){let c="properties"in n?n.properties??{}:n;return c=(0,E.$ro)(c,[]),this.c&&(c=(0,g.$2m)(c,this.c)),this.b||(c=(0,g.$2m)(c,this.j)),"properties"in n?n.properties=c:n=c,n}k(n,c){this.f&&(this.g.publisher==="vscode"?n=this.g.name+"/"+n:n=this.g.identifier.value+"/"+n,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(n,c),this.h.trace(n,c))}logUsage(n,c){this.d.isUsageEnabled&&this.k(n,c)}logError(n,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof n=="string")this.k(n,c);else{const v={name:n.name,message:n.message,stack:n.stack,cause:n.cause},D=(0,E.$ro)(v,[]),p=new Error(D.message,{cause:D.cause});p.stack=D.stack,p.name=D.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData(p,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const n=this,c={logUsage:n.logUsage.bind(n),get isUsageEnabled(){return n.d.isUsageEnabled},get isErrorsEnabled(){return n.d.isErrorsEnabled},logError:n.logError.bind(n),dispose:n.dispose.bind(n),onDidChangeEnableStates:n.a.event.bind(n)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let n=this.f;this.f=void 0,Promise.resolve(n.flush()).then(n=void 0),this.e=void 0}else this.f=void 0}}e.$pM=m;function f(t){const n=Date.now()-new Date(t).getTime();return isNaN(n)?!1:n<1e3*60*60*24}e.$qM=f,e.$rM=(0,w.$Nh)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,180,98,20,4]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bF=e.$aF=e.$_E=e.ActivationKind=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.ExtensionHostStartup=e.$6E=e.$5E=e.$4E=e.$3E=void 0,e.$3E=Object.freeze({identifier:new A.$Yl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$4E="extensions.webWorker",e.$5E=(0,h.$Nh)("extensionService");class E{constructor(p){this.dependency=p}}e.$6E=E;var g;(function(D){D[D.EagerAutoStart=1]="EagerAutoStart",D[D.EagerManualStart=2]="EagerManualStart",D[D.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class P{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(p,r,s){this.c=p,this.d=r.slice(0),this.e=s.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$NE.createActivationEventsMap(this.d)}}set(p,r,s){if(this.c>p)throw new Error(`ExtensionHostExtensions: invalid versionId ${p} (current: ${this.c})`);const i=[],o=[],y=[],$=[],S=k(this.d),I=k(r),u=(V,U)=>V.extensionLocation.toString()===U.extensionLocation.toString()||V.isBuiltin===U.isBuiltin||V.isUserBuiltin===U.isUserBuiltin||V.isUnderDevelopment===U.isUnderDevelopment;for(const V of this.d){const U=I.get(V.identifier);if(!U){i.push(V.identifier),S.delete(V.identifier);continue}if(!u(V,U)){i.push(V.identifier),S.delete(V.identifier);continue}}for(const V of r){const U=S.get(V.identifier);if(!U){o.push(V);continue}if(!u(U,V)){i.push(U.identifier),S.delete(U.identifier);continue}}const d=new A.$Zl(this.e),l=new A.$Zl(s);for(const V of this.e)l.has(V)||y.push(V);for(const V of s)d.has(V)||$.push(V);const R=F.$NE.createActivationEventsMap(o),B={versionId:p,toRemove:i,toAdd:o,addActivationEvents:R,myToRemove:y,myToAdd:$};return this.delta(B),B}delta(p){if(this.c>=p.versionId)return null;const{toRemove:r,toAdd:s,myToRemove:i,myToAdd:o}=p,y=new A.$Zl(r),$=new A.$Zl(i);for(let S=0;S<this.d.length;S++)y.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)$.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of s)this.d.push(S);for(const S of o)this.e.push(S);return p}containsExtension(p){for(const r of this.e)if(A.$Yl.equals(r,p))return!0;return!1}}e.$7E=P;function k(D){const p=new A.$1l;for(const r of D)p.set(r.identifier,r);return p}function a(D,p){return D.enabledApiProposals?D.enabledApiProposals.includes(p):!1}e.$8E=a;function b(D,p){if(!a(D,p))throw new Error(`Extension '${D.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${D.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${D.identifier.value}`)}e.$9E=b;class m{constructor(p,r,s,i){this.codeLoadingTime=p,this.activateCallTime=r,this.activateResolvedTime=s,this.activationReason=i}}e.$0E=m;class f{constructor(p,r){this.description=p,this.value=r}}e.$$E=f;var t;(function(D){D[D.Normal=0]="Normal",D[D.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function n(D){return{type:D.isBuiltin?0:1,isBuiltin:D.isBuiltin||D.isUserBuiltin,identifier:{id:(0,C.$xo)(D.publisher,D.name),uuid:D.uuid},manifest:D,location:D.extensionLocation,targetPlatform:D.targetPlatform,validations:[],isValid:!0}}e.$_E=n;function c(D,p){return{identifier:new A.$Yl((0,C.$vo)(D.manifest.publisher,D.manifest.name)),isBuiltin:D.type===0,isUserBuiltin:D.type===1&&D.isBuiltin,isUnderDevelopment:!!p,extensionLocation:D.location,...D.manifest,uuid:D.identifier.uuid,targetPlatform:D.targetPlatform}}e.$aF=c;class v{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$bF=v}),define(Ae[209],Re([1,0,9,106,20,26,14,13]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=e.$1bc=e.$Zbc=e.$Ybc=e.$Xbc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(n,c,v,D){this.startup=n,this.codeLoadingTime=c,this.activateCallTime=v,this.activateResolvedTime=D}}e.$Xbc=E;class g{constructor(n){this.a=n,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(n,c){return n===-1||c===-1?-1:c-n}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ybc=g;class P{constructor(n,c,v,D,p,r){this.activationFailed=n,this.activationFailedError=c,this.activationTimes=v,this.module=D,this.exports=p,this.subscriptions=r}}e.$Zbc=P;class k extends P{constructor(n){super(!1,null,n,{activate:void 0,deactivate:void 0},void 0,[])}}e.$1bc=k;class a extends P{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$2bc=a;class b extends P{constructor(n){super(!0,n,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(n,c,v,D){this.g=D,this.a=n,this.b=c,this.c=v,this.d=new C.$1l,this.f=Object.create(null)}dispose(){for(const[n,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const n=[];for(const[c,v]of this.d)n.push(v.wait());await Promise.all(n)}isActivated(n){const c=this.d.get(n);return!!(c&&c.value)}getActivatedExtension(n){const c=this.d.get(n);if(!c||!c.value)throw new Error(`Extension '${n.value}' is not known or not activated`);return c.value}async activateByEvent(n,c){if(this.f[n])return;const v=this.a.getExtensionDescriptionsForActivationEvent(n);await this.h(v.map(D=>({id:D.identifier,reason:{startup:c,extensionId:D.identifier,activationEvent:n}}))),this.f[n]=!0}activateById(n,c){const v=this.a.getExtensionDescription(n);if(!v)throw new Error(`Extension '${n}' is not known`);return this.h([{id:v.identifier,reason:c}])}async h(n){const c=n.filter(v=>!this.isActivated(v.id)).map(v=>this.j(v));await Promise.all(c.map(v=>v.wait()))}j(n){if(this.d.has(n.id))return this.d.get(n.id);if(this.l(n.id))return this.k(n,null,[],null);const c=this.a.getExtensionDescription(n.id);if(!c){const p=new Error(`Cannot activate unknown extension '${n.id.value}'`),r=this.k(n,null,[],new b(p));return this.c.onExtensionActivationError(n.id,p,new F.$6E(n.id.value)),r}const v=[],D=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const p of D){if(this.m(p))continue;const r=this.d.get(p);if(r){v.push(r);continue}if(this.l(p)){v.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:n.reason}));continue}const s=this.a.getExtensionDescription(p);if(s){if(!s.main&&!s.browser)continue;v.push(this.j({id:s.identifier,reason:n.reason}));continue}const i=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${p}'`),y=this.k(n,c.displayName,[],new b(o));return this.c.onExtensionActivationError(c.identifier,o,new F.$6E(p)),y}return this.k(n,c.displayName,v,null)}k(n,c,v,D){const p=new f(n.id,c,n.reason,v,D,this.c,this.g);return this.d.set(n.id,p),p}l(n){return M.$63b.isHostExtension(n,this.a,this.b)}m(n){const c=this.b.getExtensionDescription(n);return c?!c.main&&!c.browser:!1}};e.$3bc=m,e.$3bc=m=Ke([Ve(3,A.$8i)],m);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(n,c,v,D,p,r,s){this.c=n,this.d=c,this.f=v,this.g=D,this.h=p,this.j=r,this.k=s,this.a=new h.$Rg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let n=0;n<this.g.length;n++){const c=this.g[n];if(c.value&&!c.value.activationFailed){this.g.splice(n,1),n--;continue}if(c.value&&c.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);v.detail=c.value.activationFailedError,this.h=new b(v),this.j.onExtensionActivationError(this.c,v,null);return}}this.g.length>0&&await Promise.race(this.g.map(n=>n.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(n){const c=new Error;if(n&&n.name&&(c.name=n.name),n&&n.message?c.message=`Activating extension '${this.c.value}' failed: ${n.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${n}.`,n&&n.stack&&(c.stack=n.stack),this.h=new b(c),this.b&&w.$3(n))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(n)}}};f=Ke([Ve(6,A.$8i)],f)}),define(Ae[210],Re([1,0,156,23,2,5,6,192,13,7,16,18,8,50,21,125,26]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;function n(D,p){if((0,P.$xf)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let r;return Array.isArray(D.highlights)&&(r=D.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:D.label,highlights:r}}}class c extends A.$Rc{constructor(p,r,s){super(),this.f=p,this.g=r,this.h=s,this.a=new Map,this.b=new f.$A7;function i(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:o=>i(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(y=>i(y)?this.r(y):y):o})}registerTreeDataProvider(p,r,s){const i=this.createTreeView(p,{treeDataProvider:r},s);return{dispose:()=>i.dispose()}}createTreeView(p,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=r.dragAndDropController?.dropMimeTypes??[],o=r.dragAndDropController?.dragMimeTypes??[],y=!!r.dragAndDropController?.handleDrag,$=!!r.dragAndDropController?.handleDrop,S=this.m(p,r,s),I={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:i,dragMimeTypes:o,hasHandleDrag:y,hasHandleDrop:$,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(p,I),d={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,t.$9E)(s,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,t.$9E)(s,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(l){(0,b.$3j)(l)&&(0,t.$9E)(s,"treeViewMarkdownMessage"),S.message=l},get title(){return S.title},set title(l){S.title=l},get description(){return S.description},set description(l){S.description=l},get badge(){return S.badge},set badge(l){l!==void 0&&g.ViewBadge.isViewBadge(l)?S.badge={value:Math.floor(Math.abs(l.value)),tooltip:l.tooltip}:l===void 0&&(S.badge=void 0)},reveal:(l,R)=>S.reveal(l,R),dispose:async()=>{await u,this.a.delete(p),S.dispose()}};return this.B(d),d}$getChildren(p,r){const s=this.a.get(p);return s?s.getChildren(r):Promise.reject(new h.$iE(p))}async $handleDrop(p,r,s,i,o,y,$,S){const I=this.a.get(p);if(!I)return Promise.reject(new h.$iE(p));const u=a.DataTransfer.toDataTransfer(s,async d=>(await this.f.$resolveDropFileData(p,r,d)).buffer);return $===p&&S&&await this.j(u,I,S,o,y),I.onDrop(u,i,o)}async j(p,r,s,i,o){const y=this.b.removeDragOperationTransfer(o);if(y)(await y)?.forEach(($,S)=>{$&&p.set(S,$)});else if(o&&r.handleDrag){const $=r.handleDrag(s,p,i);this.b.addDragOperationTransfer(o,$),await $}return p}async $handleDrag(p,r,s,i){const o=this.a.get(p);if(!o)return Promise.reject(new h.$iE(p));const y=await this.j(new g.$2K,o,r,i,s);if(!(!y||i.isCancellationRequested))return a.DataTransfer.from(y)}async $hasResolve(p){const r=this.a.get(p);if(!r)throw new h.$iE(p);return r.hasResolve}$resolve(p,r,s){const i=this.a.get(p);if(!i)throw new h.$iE(p);return i.resolveTreeItem(r,s)}$setExpanded(p,r,s){const i=this.a.get(p);if(!i)throw new h.$iE(p);i.setExpanded(r,s)}$setSelectionAndFocus(p,r,s){const i=this.a.get(p);if(!i)throw new h.$iE(p);i.setSelectionAndFocus(r,s)}$setVisible(p,r){const s=this.a.get(p);if(!s){if(!r)return;throw new h.$iE(p)}s.setVisible(r)}$changeCheckboxState(p,r){const s=this.a.get(p);if(!s)throw new h.$iE(p);s.setCheckboxState(r)}m(p,r,s){const i=this.B(new v(p,r,this.f,this.g.converter,this.h,s));return this.a.set(p,i),i}r(p){const r=this.a.get(p.$treeViewId);return r&&"$treeItemHandle"in p?r.getExtensionElement(p.$treeItemHandle):r&&"$focusedTreeItem"in p&&p.$focusedTreeItem?r.focusedElement:null}}e.$Ccc=c;class v extends A.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(p=>this.getExtensionElement(p)).filter(p=>!(0,P.$Gf)(p))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(p,r,s,i,o,y){if(super(),this.I=p,this.J=s,this.L=i,this.M=o,this.N=y,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$Md),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$Md),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$Md),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$Md),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$Md),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$Md),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$Md),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$Wd,y.contributes&&y.contributes.views)for(const u in y.contributes.views)for(const d of y.contributes.views[u])d.id===p&&(this.P=d.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.F.fire({message:!1,element:u})));let $,S;const I=F.Event.debounce(this.F.event,(u,d)=>(u||(u={message:!1,elements:[]}),d.element!==!1&&($||($=new Promise(l=>S=l),this.G=this.G.then(()=>$)),Array.isArray(d.element)?u.elements.push(...d.element):u.elements.push(d.element)),d.message&&(u.message=!0),u),200,!0);this.B(I(({message:u,elements:d})=>{d.length&&(this.H=this.H.then(()=>{const l=S;return $=null,this.$(d).then(()=>l())})),u&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(p){const r=p?this.getExtensionElement(p):void 0;if(p&&!r)return this.M.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let s=this.X(p);return s||(s=await this.Y(r)),s?s.map(i=>i.item):void 0}getExtensionElement(p){return this.j.get(p)}reveal(p,r){r=r||{select:!0,focus:!1};const s=(0,P.$Gf)(r.select)?!0:r.select,i=(0,P.$Gf)(r.focus)?!1:r.focus,o=(0,P.$Gf)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.G.then(()=>this.S(p)).then(y=>this.W(p,y[y.length-1]).then($=>this.J.$reveal(this.I,{item:$.item,parentChain:y.map(S=>S.item)},{select:s,focus:i,expand:o})),y=>this.M.error(y)):this.J.$reveal(this.I,void 0,{select:s,focus:i,expand:o})}get message(){return this.O}set message(p){this.O=p,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(p){this.P=p,this.J.$setTitle(this.I,p,this.Q)}get description(){return this.Q}set description(p){this.Q=p,this.J.$setTitle(this.I,this.P,p)}get badge(){return this.R}set badge(p){this.R?.value===p?.value&&this.R?.tooltip===p?.tooltip||(this.R=a.ViewBadge.from(p),this.J.$setBadge(this.I,p))}setExpanded(p,r){const s=this.getExtensionElement(p);s&&(r?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(p,r){const s=!(0,k.$tb)(this.s,p);this.s=p;const i=this.t!==r;this.t=r,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),i&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(p){p!==this.r&&(this.r=p,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(p){const r=(await Promise.all(p.map(async s=>{const i=this.getExtensionElement(s.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag(p,r,s){const i=[];for(const o of p){const y=this.getExtensionElement(o);y&&i.push(y)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,r,s),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,r,s){const i=r?this.getExtensionElement(r):void 0;if(!(!i&&r||!this.g?.handleDrop))return(0,E.$Lg)(()=>this.g?.handleDrop?this.g.handleDrop(i,p,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,r){if(!this.f.resolveTreeItem)return;const s=this.j.get(p);if(s){const i=this.m.get(s);if(i){const o=await this.f.resolveTreeItem(i.extensionItem,s,r)??i.extensionItem;return this.hb(o),i.item.tooltip=this.eb(o.tooltip),i.item.command=this.fb(i.disposableStore,o.command),i.item}}}S(p){return this.U(p).then(r=>r?this.S(r).then(s=>this.W(r,s[s.length-1]).then(i=>(s.push(i),s))):Promise.resolve([]))}U(p){const r=this.m.get(p);return r?Promise.resolve(r.parent?this.j.get(r.parent.item.handle):void 0):(0,E.$Lg)(()=>this.f.getParent(p))}W(p,r){const s=this.m.get(p);return s?Promise.resolve(s):(0,E.$Lg)(()=>this.f.getTreeItem(p)).then(i=>this.kb(p,i,r,!0)).then(i=>this.getChildren(r?r.item.handle:void 0).then(()=>{const o=this.getExtensionElement(i);if(o){const y=this.m.get(o);if(y)return Promise.resolve(y)}throw new Error(`Cannot resolve tree item for element ${i} from extension ${this.N.identifier.value}`)}))}X(p){if(p){let r;if(typeof p=="string"){const s=this.getExtensionElement(p);r=s?this.m.get(s):void 0}else r=p;return r&&r.children||void 0}return this.h}async Y(p){this.rb(p);const r=new m.$Wd(this.Z.token);try{const s=p?this.m.get(p):void 0,i=await this.f.getChildren(p);if(r.token.isCancellationRequested)return;const o=await Promise.all((0,k.$Gb)(i||[]).map(async y=>{const $=await this.f.getTreeItem(y);return $&&!r.token.isCancellationRequested?this.db(y,$,s):null}));return r.token.isCancellationRequested?void 0:(0,k.$Gb)(o)}finally{r.dispose()}}$(p){if(p.some(s=>!s))return this.Z.dispose(!0),this.Z=new m.$Wd,this.tb(),this.J.$refresh(this.I);{const s=this.ab(p);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(p){const r=new Set,s=p.map(o=>this.m.get(o));for(const o of s)if(o&&!r.has(o.item.handle)){let y=o;for(;y&&y.parent&&s.findIndex($=>y&&y.parent&&$&&$.item.handle===y.parent.item.handle)===-1;){const $=this.j.get(y.parent.item.handle);y=$?this.m.get($):void 0}y&&!y.parent&&r.add(o.item.handle)}const i=[];return r.forEach(o=>{const y=this.j.get(o);if(y){const $=this.m.get(y);$&&(!$.parent||!r.has($.parent.item.handle))&&i.push(o)}}),i}bb(p){const r={};return Promise.all(p.map(s=>this.cb(s).then(i=>{i&&(r[s]=i.item)}))).then(()=>Object.keys(r).length?this.J.$refresh(this.I,r):void 0)}cb(p){const r=this.getExtensionElement(p);if(r){const s=this.m.get(r);if(s)return this.rb(r),(0,E.$Lg)(()=>this.f.getTreeItem(r)).then(i=>{if(i){const o=this.ib(r,i,s.parent);return this.pb(r,o,s,s.parent),s.dispose(),o}return null})}return Promise.resolve(null)}db(p,r,s){const i=this.ib(p,r,s);if(r.id&&this.j.has(i.item.handle))throw new Error((0,w.localize)(0,null,r.id));return this.ob(p,i),this.qb(i,s),i}eb(p){return g.$yK.isMarkdownString(p)?a.MarkdownString.from(p):p}fb(p,r){return r?{...this.L.toInternal(r,p),originalId:r.command}:void 0}gb(p){if(p.checkboxState===void 0)return;let r,s,i;return typeof p.checkboxState=="number"?r=p.checkboxState:(r=p.checkboxState.state,s=p.checkboxState.tooltip,i=p.checkboxState.accessibilityInformation),{isChecked:r===g.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:i}}hb(p){if(!g.$WK.isTreeItem(p,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(p,r,s){this.hb(r);const i=this.B(new A.$Qc),o=this.kb(p,r,s),y=this.lb(r);return{item:{handle:o,parentHandle:s?s.item.handle:void 0,label:n(r.label,this.N),description:r.description,resourceUri:r.resourceUri,tooltip:this.eb(r.tooltip),command:this.fb(i,r.command),contextValue:r.contextValue,icon:y,iconDark:this.mb(r)||y,themeIcon:this.jb(r),collapsibleState:(0,P.$Gf)(r.collapsibleState)?g.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.gb(r)},extensionItem:r,parent:s,children:void 0,disposableStore:i,dispose(){i.dispose()}}}jb(p){return p.iconPath instanceof g.$5K?p.iconPath:void 0}kb(p,{id:r,label:s,resourceUri:i},o,y){if(r)return`${v.b}/${r}`;const $=n(s,this.N),S=o?o.item.handle:v.a;let I=$?$.label:i?(0,M.$rg)(i):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const u=this.m.has(p)?this.m.get(p).item.handle:void 0,d=this.X(o)||[];let l,R=0;do{if(l=`${S}/${R}:${I}`,y||!this.j.has(l)||u===l)break;R++}while(R<=d.length);return l}lb(p){if(p.iconPath&&!(p.iconPath instanceof g.$5K))return typeof p.iconPath=="string"||C.URI.isUri(p.iconPath)?this.nb(p.iconPath):this.nb(p.iconPath.light)}mb(p){if(p.iconPath&&!(p.iconPath instanceof g.$5K)&&p.iconPath.dark)return this.nb(p.iconPath.dark)}nb(p){return C.URI.isUri(p)?p:C.URI.file(p)}ob(p,r){this.j.set(r.item.handle,p),this.m.set(p,r)}pb(p,r,s,i){this.j.delete(r.item.handle),this.m.delete(p),r.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(p,r);const o=this.X(i)||[],y=o.filter($=>$.item.handle===s.item.handle)[0];y&&o.splice(o.indexOf(y),1,r)}qb(p,r){r?(r.children||(r.children=[]),r.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}rb(p){if(p){const r=this.m.get(p);if(r){if(r.children)for(const s of r.children){const i=this.j.get(s.item.handle);i&&this.sb(i)}r.children=void 0}}else this.tb()}sb(p){const r=this.m.get(p);if(r){if(r.children)for(const s of r.children){const i=this.j.get(s.item.handle);i&&this.sb(i)}this.m.delete(p),this.j.delete(r.item.handle),r.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(p=>p.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[211],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[212],Re([1,0,166,9,29,92,73,30,20,211,176,98]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=void 0;const a=h.$$m.as(A.$_m.JSONContribution);class b{constructor(p,r,s){this.a=p,this.b=r,this.c=s}d(p,r){this.a({type:p,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(C.default.Error,p)}warn(p){this.d(C.default.Warning,p)}info(p){this.d(C.default.Info,p)}}e.$WE=b;class m{static a(p){const r=new E.$Zl;for(let s=0,i=p.length;s<i;s++)r.add(p[s].description.identifier);return r}static compute(p,r){if(!p||!p.length)return new m(r,[]);if(!r||!r.length)return new m([],p);const s=this.a(p),i=this.a(r),o=r.filter($=>!s.has($.description.identifier)),y=p.filter($=>!i.has($.description.identifier));return new m(o,y)}constructor(p,r){this.added=p,this.removed=r}}e.$XE=m;class f{constructor(p,r){this.name=p,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=m.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,M.$Z)(p)}}}e.$YE=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},n="vscode://schemas/vscode-extensions";e.$ZE={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$Xl},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Pn}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Pn}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)},pricing:{type:"string",markdownDescription:w.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const r=new f(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,r),p.activationEventsGenerator&&k.$NE.register(p.extensionPoint,p.activationEventsGenerator),e.$ZE.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,a.registerSchema(n,e.$ZE),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$1E=c;const v={ExtensionsRegistry:"ExtensionsRegistry"};h.$$m.add(v.ExtensionsRegistry,new c),e.$2E=h.$$m.as(v.ExtensionsRegistry),a.registerSchema(n,e.$ZE),a.registerSchema(P.$oj,{properties:{extensionEnabledApiProposals:{description:w.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Ae[213],Re([1,0,163,16,24,212,32,5]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var g;(function(a){function b(m,f,t){if(!m)return;const n=M.$xf(m.type)?m.type:void 0;if(!n||n.length===0){t.error(w.localize(3,null));return}const c=[];if(Array.isArray(m.required))for(const v of m.required)M.$xf(v)&&c.push(v);return{extensionId:f.value,taskType:n,required:c,properties:m.properties?C.$Ym(m.properties):{},when:m.when?A.$Li.deserialize(m.when):void 0}}a.from=b})(g||(g={}));const P=F.$2E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,b)=>{for(const m of a)m.type&&b.push(`onTaskType:${m.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:E}});class k{constructor(){this.d=new h.$Md,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,m)=>{P.setHandler((f,t)=>{this.c=void 0;try{for(const n of t.removed){const c=n.value;for(const v of c)this.a&&v.type&&this.a[v.type]&&delete this.a[v.type]}for(const n of t.added){const c=n.value;for(const v of c){const D=g.from(v,n.description.identifier,n.collector);D&&(this.a[D.taskType]=D)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const m of this.all()){const f={type:"object",additionalProperties:!1};m.required.length>0&&(f.required=m.required.slice(0)),m.properties!==void 0?f.properties=C.$Ym(m.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[m.taskType]},b.push(f)}this.c={oneOf:b}}return this.c}}e.$JF=new k}),define(Ae[214],Re([1,0,164,16,23,24,32,213]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$TF=e.JsonSchemaVersion=e.ExecutionEngine=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$NF=e.ShellQuoting=e.$MF=e.$LF=e.$KF=void 0,e.$KF="settings",e.$LF=new A.$5i("taskRunning",!1,w.localize(0,null)),e.$MF={value:w.localize(1,null),original:"Tasks"};var E;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$NF="$customized",function(N){function O(ee){if(!ee)return N.Strong;switch(ee.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=O}(E||(e.ShellQuoting=E={}));var g;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var P;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(P||(e.RevealKind=P={})),function(N){function O(ee){switch(ee.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=O}(P||(e.RevealKind=P={}));var k;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(N){function O(ee){switch(ee.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=O}(k||(e.RevealProblemKind=k={}));var a;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(a||(e.PanelKind=a={})),function(N){function O(ee){switch(ee.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=O}(a||(e.PanelKind=a={}));var b;(function(N){N.defaults={echo:!0,reveal:P.Always,revealProblems:k.Never,focus:!1,panel:a.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var m;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(N){function O(Z){switch(Z.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=O;function ee(Z){switch(Z){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=ee}(m||(e.RuntimeType=m={}));var f;(function(N){function O(ee){return M.$xf(ee)?ee:ee.value}N.value=O})(f||(e.CommandString=f={}));var t;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function O(Z){return Z===N.Clean._id||Z===N.Build._id||Z===N.Rebuild._id||Z===N.Test._id}N.is=O;function ee(Z){if(Z!==void 0)return M.$xf(Z)?O(Z)?{_id:Z,isDefault:!1}:void 0:Z}N.from=ee})(t||(e.TaskGroup=t={}));var n;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(n||(e.TaskScope=n={}));var c;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function O(ee){switch(ee){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=O})(c||(e.TaskSourceKind=c={}));var v;(function(N){N.parallel="parallel",N.sequence="sequence"})(v||(e.DependsOrder=v={}));var D;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(D||(e.RunOnOptions=D={}));var p;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:D.default,instanceLimit:1}})(p||(e.RunOptions=p={}));class r{constructor(O,ee,Z,ye,De,Pe){this._label="",this._id=O,ee&&(this._label=ee),Z&&(this.type=Z),this.runOptions=ye,this.configurationProperties=De,this._source=Pe}getDefinition(O){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,ee=!1){if(O===void 0)return!1;if(M.$xf(O))return O===this._label||O===this.configurationProperties.identifier||ee&&O===this._id;const Z=this.getDefinition(!0);return Z!==void 0&&Z._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$OF=r;class s extends r{constructor(O,ee,Z,ye,De,Pe,X,le){super(O,Z,void 0,X,le,ee),this.command={},this._source=ee,this.hasDefinedMatchers=Pe,De&&(this.command=De)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let ee;switch(this.command?this.command.runtime:void 0){case m.Shell:ee="shell";break;case m.Process:ee="process";break;case m.CustomExecution:ee="customExecution";break;case void 0:ee="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ee,_key:this._id,id:this._id}}}static is(O){return O instanceof s}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$KF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let ee=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ee+=this._source.kind);const Z={type:e.$NF,folder:O,id:ee};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$rg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new s(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$PF=s;class i extends r{constructor(O,ee,Z,ye,De,Pe,X){super(O,Z,ye,Pe,X,ee),this._source=ee,this.configures=De}static is(O){return O instanceof i}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$rg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$KF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let ee=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ee+=this._source.kind);const Z={type:e.$NF,folder:O,id:ee};return JSON.stringify(Z)}}e.$QF=i;class o extends r{constructor(O,ee,Z,ye,De,Pe,X,le,Ee){super(O,Z,ye,le,Ee,ee),this.defines=De,this.hasDefinedMatchers=X,this.command=Pe,this.icon=Ee.icon,this.hide=Ee.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof o}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new o(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$RF=o;class y extends r{constructor(O,ee,Z,ye,De,Pe){super(O,Z,ye,De,Pe,ee),this._source=ee}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new y(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$SF=y;var $;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})($||(e.ExecutionEngine=$={})),function(N){N._default=N.Terminal}($||(e.ExecutionEngine=$={}));var S;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class I{constructor(O){this.c=new Map;for(let ee=0;ee<O.length;ee++)this.c.set(O[ee].uri.toString(),ee)}compare(O,ee){const Z=O.getWorkspaceFolder(),ye=ee.getWorkspaceFolder();if(Z&&ye){let De=this.c.get(Z.uri.toString());De=De===void 0?0:De+1;let Pe=this.c.get(ye.uri.toString());return Pe=Pe===void 0?0:Pe+1,De===Pe?O._label.localeCompare(ee._label):De-Pe}else return!Z&&ye?-1:Z&&!ye?1:0}}e.$TF=I;var u;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(u||(e.TaskEventKind=u={}));var d;(function(N){N.SingleRun="singleRun",N.Background="background"})(d||(e.TaskRunType=d={}));var l;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(l||(e.TaskRunSource=l={}));var R;(function(N){function O(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?"background":"singleRun",group:le.configurationProperties.group,__task:le}}function ee(le,Ee,ce){return{...O(le),kind:"start",terminalId:Ee,resolvedVariables:ce}}N.start=ee;function Z(le,Ee,ce){return{...O(le),kind:"processStarted",terminalId:Ee,processId:ce}}N.processStarted=Z;function ye(le,Ee,ce){return{...O(le),kind:"processEnded",terminalId:Ee,exitCode:ce}}N.processEnded=ye;function De(le,Ee,ce){return{...O(le),kind:"terminated",exitReason:ce,terminalId:Ee}}N.terminated=De;function Pe(le,Ee,ce){return{...O(Ee),kind:le,terminalId:ce}}N.general=Pe;function X(){return{kind:"changed"}}N.changed=X})(R||(e.TaskEvent=R={}));var B;(function(N){function O(Z){const ye=Object.keys(Z).sort();let De="";for(const Pe of ye){let X=Z[Pe];X instanceof Object?X=O(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),De+=Pe+","+X+","}return De}function ee(Z){const De={_key:O(Z),type:Z.taskType};return Object.assign(De,Z),De}N.create=ee})(B||(e.KeyedTaskIdentifier=B={}));var V;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(V||(e.TaskSettingId=V={}));var U;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var W;(function(N){function O(ee,Z){const ye=h.$JF.get(ee.type);if(ye===void 0){const le=F.$Ym(ee);return delete le._key,B.create(le)}const De=Object.create(null);De.type=ye.taskType;const Pe=new Set;ye.required.forEach(le=>Pe.add(le));const X=ye.properties;for(const le of Object.keys(X)){const Ee=ee[le];if(Ee!=null)De[le]=Ee;else if(Pe.has(le)){const ce=X[le];if(ce.default!==void 0)De[le]=F.$Ym(ce.default);else switch(ce.type){case"boolean":De[le]=!1;break;case"number":case"integer":De[le]=0;break;case"string":De[le]="";break;default:Z.error(w.localize(2,null,JSON.stringify(ee,void 0,0),le));return}}}return B.create(De)}N.createTaskIdentifier=O})(W||(e.TaskDefinition=W={}))}),define(Ae[215],Re([1,0,9]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_3b=e.$$3b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,h)=>{this.b=A,this.d=h,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,w.$Z)(A))}then(A,h){return this.j().then(A,h)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$$3b=M;class C extends M{constructor(){super(),this.h=!0,this.i=new w.$4}}e.$_3b=C}),define(Ae[46],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jv=e.$iv=e.$hv=e.$gv=void 0;class w{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++w.count}}e.$gv=w;const M=[];function C(h){const E=new w(h);return M[E.nid]=E,E}e.$hv=C;function F(h){return M[h].sid}e.$iv=F;class A{constructor(E){this.value=E}}e.$jv=A}),define(Ae[3],Re([1,0,46]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$8J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var C;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var F;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var A;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var h;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(h||(e.WebviewMessageArrayBufferViewType=h={}));var E;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var g;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var P;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class k{static{this.a=0}static mixin(t){return t._id=k.a++,t}}e.$8J=k;var a;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var b;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var m;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$9J={MainThreadAuthentication:(0,w.$hv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$hv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,w.$hv)("MainThreadChatProvider"),MainThreadChatAgents:(0,w.$hv)("MainThreadChatAgents"),MainThreadChatVariables:(0,w.$hv)("MainThreadChatVariables"),MainThreadClipboard:(0,w.$hv)("MainThreadClipboard"),MainThreadCommands:(0,w.$hv)("MainThreadCommands"),MainThreadComments:(0,w.$hv)("MainThreadComments"),MainThreadConfiguration:(0,w.$hv)("MainThreadConfiguration"),MainThreadConsole:(0,w.$hv)("MainThreadConsole"),MainThreadDebugService:(0,w.$hv)("MainThreadDebugService"),MainThreadDecorations:(0,w.$hv)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$hv)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$hv)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$hv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$hv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$hv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$hv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$hv)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$hv)("MainThreadErrors"),MainThreadTreeViews:(0,w.$hv)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$hv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$hv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$hv)("MainThreadLanguages"),MainThreadLogger:(0,w.$hv)("MainThreadLogger"),MainThreadMessageService:(0,w.$hv)("MainThreadMessageService"),MainThreadOutputService:(0,w.$hv)("MainThreadOutputService"),MainThreadProgress:(0,w.$hv)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$hv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$hv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$hv)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$hv)("MainThreadSecretState"),MainThreadStorage:(0,w.$hv)("MainThreadStorage"),MainThreadTelemetry:(0,w.$hv)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$hv)("MainThreadTerminalService"),MainThreadWebviews:(0,w.$hv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$hv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$hv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$hv)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$hv)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$hv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$hv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$hv)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$hv)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.$hv)("MainThreadExtensionService"),MainThreadSCM:(0,w.$hv)("MainThreadSCM"),MainThreadSearch:(0,w.$hv)("MainThreadSearch"),MainThreadShare:(0,w.$hv)("MainThreadShare"),MainThreadTask:(0,w.$hv)("MainThreadTask"),MainThreadWindow:(0,w.$hv)("MainThreadWindow"),MainThreadLabelService:(0,w.$hv)("MainThreadLabelService"),MainThreadNotebook:(0,w.$hv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$hv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$hv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$hv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$hv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$hv)("MainThreadInteractive"),MainThreadChat:(0,w.$hv)("MainThreadChat"),MainThreadInlineChat:(0,w.$hv)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.$hv)("MainThreadTheming"),MainThreadTunnelService:(0,w.$hv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$hv)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$hv)("MainThreadTimeline"),MainThreadTesting:(0,w.$hv)("MainThreadTesting"),MainThreadLocalization:(0,w.$hv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$hv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$hv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,w.$hv)("MainThreadIssueReporter")},e.$0J={ExtHostCommands:(0,w.$hv)("ExtHostCommands"),ExtHostConfiguration:(0,w.$hv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$hv)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$hv)("ExtHostDebugService"),ExtHostDecorations:(0,w.$hv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$hv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$hv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$hv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$hv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$hv)("ExtHostEditors"),ExtHostTreeViews:(0,w.$hv)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$hv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$hv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$hv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$hv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$hv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$hv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$hv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$hv)("ExtHostStatusBar"),ExtHostShare:(0,w.$hv)("ExtHostShare"),ExtHostExtensionService:(0,w.$hv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$hv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$hv)("ExtHostTerminalService"),ExtHostSCM:(0,w.$hv)("ExtHostSCM"),ExtHostSearch:(0,w.$hv)("ExtHostSearch"),ExtHostTask:(0,w.$hv)("ExtHostTask"),ExtHostWorkspace:(0,w.$hv)("ExtHostWorkspace"),ExtHostWindow:(0,w.$hv)("ExtHostWindow"),ExtHostWebviews:(0,w.$hv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$hv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$hv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$hv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$hv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$hv)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$hv)("ExtHostProgress"),ExtHostComments:(0,w.$hv)("ExtHostComments"),ExtHostSecretState:(0,w.$hv)("ExtHostSecretState"),ExtHostStorage:(0,w.$hv)("ExtHostStorage"),ExtHostUrls:(0,w.$hv)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$hv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$hv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$hv)("ExtHostOutputService"),ExtHosLabelService:(0,w.$hv)("ExtHostLabelService"),ExtHostNotebook:(0,w.$hv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$hv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$hv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$hv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$hv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$hv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$hv)("ExtHostInteractive"),ExtHostInlineChat:(0,w.$hv)("ExtHostInlineChatShape"),ExtHostChat:(0,w.$hv)("ExtHostChat"),ExtHostChatAgents:(0,w.$hv)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.$hv)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.$hv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,w.$hv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$hv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$hv)("ExtHostTheming"),ExtHostTunnelService:(0,w.$hv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$hv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$hv)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$hv)("ExtHostTimeline"),ExtHostTesting:(0,w.$hv)("ExtHostTesting"),ExtHostTelemetry:(0,w.$hv)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$hv)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.$hv)("ExtHostIssueReporter")}}),define(Ae[216],Re([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$9J.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,h,E){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(A);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(h,E)??[]}getRelatedInformation(A,h,E){return this.c.$getAiRelatedInformation(h,E)}registerRelatedInformationProvider(A,h,E){const g=this.b;return this.b++,this.a.set(g,E),this.c.$registerAiRelatedInformationProvider(g,h),new M.$$J(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$Ddc=C}),define(Ae[80],Re([1,0,4,14,3,17]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=e.$Hbc=e.$Gbc=void 0,e.$Gbc=(0,w.$Nh)("IExtHostApiDeprecationService");let A=class{constructor(E,g){this.c=g,this.a=new Set,this.b=E.getProxy(C.$9J.MainThreadTelemetry)}report(E,g,P){const k=this.d(E,g);this.a.has(k)||(this.a.add(k),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:E}))}d(E,g){return`${E}-${g.identifier.value}`}};e.$Hbc=A,e.$Hbc=A=Ke([Ve(0,F.$0L),Ve(1,M.$8i)],A),e.$Ibc=Object.freeze(new class{report(h,E,g){}})}),define(Ae[217],Re([1,0,5,3,7,20]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;class A{constructor(g){this.b=new Map,this.c=[],this.d=new w.$Md,this.onDidChangeSessions=this.d.event,this.f=new h,this.g=new h,this.a=g.getProxy(M.$9J.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,P,k,a={}){const b=F.$Yl.toKey(g.identifier),m=[...k].sort().join(" ");return await this.f.getOrCreate(`${b} ${P} ${m}`,async()=>{await this.a.$ensureProvider(P);const f=g.displayName||g.name;return this.a.$getSession(P,k,b,f,a)})}async getSessions(g,P,k){const a=F.$Yl.toKey(g.identifier),b=[...k].sort().join(" ");return await this.g.getOrCreate(`${a} ${b}`,async()=>{await this.a.$ensureProvider(P);const m=g.displayName||g.name;return this.a.$getSessions(P,k,a,m)})}async removeSession(g,P){const k=this.b.get(g);return k?k.provider.removeSession(P):this.a.$removeSession(g,P)}registerAuthenticationProvider(g,P,k,a){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:P,provider:k,options:a??{supportsMultipleAccounts:!1}}),this.c.find(m=>m.id===g)||this.c.push({id:g,label:P});const b=k.onDidChangeSessions(m=>{this.a.$sendDidChangeSessions(g,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this.a.$registerAuthenticationProvider(g,P,a?.supportsMultipleAccounts??!1),new C.$$J(()=>{b.dispose(),this.b.delete(g);const m=this.c.findIndex(f=>f.id===g);m>-1&&this.c.splice(m),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,P,k){const a=this.b.get(g);if(a)return Promise.resolve(a.provider.createSession(P,k));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,P){const k=this.b.get(g);if(k)return Promise.resolve(k.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,P){const k=this.b.get(g);if(k)return Promise.resolve(k.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,P){return this.d.fire({provider:{id:g,label:P}}),Promise.resolve()}}e.$cdc=A;class h{constructor(){this.a=new Map}getOrCreate(g,P){const k=this.a.get(g);if(k)return k;const a=P().finally(()=>this.a.delete(g));return this.a.set(g,a),a}}}),define(Ae[218],Re([1,0,3,17,8]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;let F=class{constructor(h,E){this.a=h.getProxy(w.$9J.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>E.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(h,E,g){const P=C.WorkspaceEdit.from(h,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,g?.isRefactoring??!1)}};e.$idc=F,e.$idc=F=Ke([Ve(0,M.$0L)],F)}),define(Ae[219],Re([1,0,13,5,66,6,59,146,3,8]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class P{static{this.a=0}constructor(b,m){this.extension=b,this.provider=m,this.handle=P.a++}}class k{static{this.a=0}constructor(b,m){this.i=m,this.b=new Map,this.e=new Map,this.g=new M.$Md,this.onDidPerformUserAction=this.g.event,this.h=b.getProxy(E.$9J.MainThreadChat)}registerChatProvider(b,m,f){const t=new P(b,f);return this.b.set(t.handle,t),this.h.$registerChatProvider(t.handle,m),(0,F.$Pc)(()=>{this.h.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(b,m){const f=C.Iterable.find(this.e.keys(),t=>this.e.get(t)===b)??0;typeof f=="number"&&this.h.$transferChatSession(f,m)}addChatRequest(b){this.h.$addRequest(b)}sendInteractiveRequestToProvider(b,m){this.h.$sendRequestToProvider(b,m)}async $prepareChat(b,m,f){const t=this.b.get(b);if(!t)return;const n=await t.provider.prepareSession(m,f);if(!n)return;const c=k.a++;return this.e.set(c,n),{id:c,requesterUsername:n.requester?.name,requesterAvatarIconUri:n.requester?.icon,responderUsername:n.responder?.name,responderAvatarIconUri:n.responder?.icon,inputPlaceholder:n.inputPlaceholder}}async $resolveRequest(b,m,f,t){const n=this.b.get(b);if(!n)return;const c=this.e.get(m);if(!c||!n.provider.resolveRequest)return;const v=await n.provider.resolveRequest(c,f,t);if(v)return{message:typeof v.message=="string"?v.message:g.ChatReplyFollowup.from(v.message)}}async $provideWelcomeMessage(b,m){const f=this.b.get(b);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage(m);if(t)return t.map(n=>typeof n=="string"?n:n.map(c=>g.ChatReplyFollowup.from(c)))}async $provideFollowups(b,m,f){const t=this.b.get(b);if(!t)return;const n=this.e.get(m);return!n||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(n,f))?.map(v=>g.ChatFollowup.from(v))}$removeRequest(b,m,f){const t=this.b.get(b);if(!t)return;const n=this.e.get(m);n&&t.provider.removeRequest&&t.provider.removeRequest(n,f)}async $provideReply(b,m,f,t){const n=this.b.get(b);if(!n)return;const c=this.e.get(m);if(!c)return;const v={session:c,message:typeof f.message=="string"?f.message:g.ChatReplyFollowup.to(f.message),variables:{}};if(f.variables)for(const o of Object.keys(f.variables))v.variables[o]=f.variables[o].map(g.ChatVariable.to);const D=A.$Id.create(!1);let p;const r={report:o=>{if(!t.isCancellationRequested)if(typeof p>"u"&&(p=D.elapsed()),"responseId"in o)this.h.$acceptResponseProgress(b,m,{requestId:o.responseId});else if("placeholder"in o&&"resolvedContent"in o){const y=Promise.all([this.h.$acceptResponseProgress(b,m,{placeholder:o.placeholder}),o.resolvedContent]);(0,w.$Hg)(y,t).then($=>{if(!$)return;const[S,I]=$;this.h.$acceptResponseProgress(b,m,I,S??void 0)})}else"content"in o?this.h.$acceptResponseProgress(b,m,{content:typeof o.content=="string"?o.content:g.MarkdownString.from(o.content)}):"documents"in o?this.h.$acceptResponseProgress(b,m,{documents:o.documents.map(y=>({uri:y.uri,version:y.version,ranges:y.ranges.map($=>g.Range.from($))}))}):this.h.$acceptResponseProgress(b,m,o)}};let s;try{s=await n.provider.provideResponseWithProgress(v,r,t),s||(s={errorDetails:{message:(0,h.localize)(0,null)}})}catch(o){s={errorDetails:{message:(0,h.localize)(1,null,o.message),responseIsIncomplete:!0}},this.i.error(o)}try{if(c.saveState&&this.e.has(m)){const o=c.saveState();this.h.$acceptChatState(m,o)}}catch(o){this.i.warn(o)}const i={firstProgress:p??0,totalElapsed:D.elapsed()};return{errorDetails:s.errorDetails,timings:i}}async $provideSlashCommands(b,m,f){const t=this.b.get(b);if(!t)return;const n=this.e.get(m);return!n||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(n,f))?.map(v=>({...v,kind:g.CompletionItemKind.from(v.kind)}))}$releaseSession(b){this.e.delete(b)}async $onDidPerformUserAction(b){this.g.fire(b)}}e.$wdc=k}),define(Ae[220],Re([1,0,13,6,72,3,8,7]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class E{static{this.a=0}constructor(k,a,b){this.d=a,this.e=b,this.b=new Map,this.c=k.getProxy(F.$9J.MainThreadChatAgents)}registerAgent(k,a,b,m){const f=E.a++;return this.b.set(f,{extension:k,agent:b}),this.c.$registerAgent(f,a,m),(0,M.$Pc)(()=>{this.c.$unregisterAgent(f),this.b.delete(f)})}async $invokeAgent(k,a,b,m,f){const t=this.b.get(k);if(!t){this.e.warn(`[CHAT](${k}) CANNOT invoke agent because the agent is not registered`);return}let n=!1;function c(){if(n)throw new Error("Only valid while executing the command")}const v=new w.$bh;f.onCancellationRequested(()=>v.complete()),setTimeout(()=>v.complete(),3*1e3),this.d.allowListExtensionWhile(t.extension,v.p);const D=t.agent({role:h.ChatMessageRole.User,content:b},{history:m.history.map(A.ChatMessage.to)},new C.$Yu(p=>{c(),this.c.$handleProgressChunk(a,{content:g(p.message)?p.message:p.message.value})}),f);try{return await(0,w.$Hg)(Promise.resolve(D).then(p=>{if(p&&"followUp"in p)return{followUp:p?.followUp?.map(s=>A.ChatFollowup.from(s))}}),f)}finally{n=!0,v.complete()}}}e.$Fdc=E;function g(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Ae[221],Re([1,0,6,3,8,72,20]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class h{static{this.a=1}constructor(g,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$1l,this.b=g.getProxy(M.$9J.MainThreadChatProvider)}registerProvider(g,P,k,a){const b=h.a++;return this.c.set(b,{extension:g,provider:k}),this.b.$registerProvider(b,P,{extension:g,displayName:a.name??g.value}),(0,w.$Pc)(()=>{this.b.$unregisterProvider(b),this.c.delete(b)})}async $provideChatResponse(g,P,k,a,b){const m=this.c.get(g);if(!m)return;const f=new F.$Yu(async t=>{if(b.isCancellationRequested){this.d.warn(`[CHAT](${m.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return m.provider.provideChatResponse(k.map(C.ChatMessage.to),a,f,b)}allowListExtensionWhile(g,P){this.f.set(g,P),P.finally(()=>this.f.delete(g))}async requestChatResponseProvider(g,P){if(!this.f.has(g))throw new Error("Extension is NOT allowed to make chat requests");const k=this;return{get isRevoked(){return!k.f.has(g)},async makeRequest(a,b,m,f){if(!k.f.has(g))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;k.e.set(t,m);try{await k.b.$fetchResponse(g,P,t,a.map(C.ChatMessage.from),b,f)}finally{k.e.delete(t)}}}}async $handleResponseFragment(g,P){this.e.get(g)?.report(P)}}e.$Bdc=h}),define(Ae[222],Re([1,0,6,3,9,8]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class A{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(M.$9J.MainThreadChatVariables)}async $resolveVariable(E,g,P){const k=this.b.get(E);if(k)try{const a=await k.resolver.resolve(k.data.name,{message:g},P);if(a)return a.map(F.ChatVariable.from)}catch(a){(0,C.$1)(a)}}registerVariableResolver(E,g,P,k){const a=A.a++;return this.b.set(a,{extension:E.identifier,data:{name:g,description:P},resolver:k}),this.c.$registerVariable(a,{name:g,description:P}),(0,w.$Pc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$Cdc=A}),define(Ae[223],Re([1,0,3]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=void 0;class M{constructor(F){const A=F.getProxy(w.$9J.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(h){return A.$writeText(h)}})}}e.$Lbc=M}),define(Ae[31],Re([1,0,16,7,8,24,3,18,14,68,44,278,2,6,4,17,104,25,46,41,59,53,58]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=void 0;let s=class{#e;#t;#i;constructor(I,u,d){this.b=new Map,this.c=new Map,this.#e=I.getProxy(A.$9J.MainThreadCommands),this.d=u,this.#i=d,this.#t=I.getProxy(A.$9J.MainThreadTelemetry),this.converter=new i(this,l=>{const R=this.c.get(l);return R?.result===y.Void?R:void 0},u),this.f=[{processArgument(l){return(0,g.$kh)(l)}},{processArgument(l){return(0,F.$1m)(l,function(R){if(P.$ns.isIRange(R))return C.Range.to(R);if(k.$ms.isIPosition(R))return C.Position.to(R);if(P.$ns.isIRange(R.range)&&a.URI.isUri(R.uri))return C.location.to(R);if(R instanceof n.$ae)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(I){this.f.push(I)}registerApiCommand(I){const u=this.registerCommand(!1,I.id,async(...d)=>{const l=I.args.map((B,V)=>{if(!B.validate(d[V]))throw new Error(`Invalid argument '${B.name}' when running '${I.id}', received: ${typeof d[V]=="object"?JSON.stringify(d[V],null,"	"):d[V]} `);return B.convert(d[V])}),R=await this.executeCommand(I.internalId,...l);return I.result.convert(R,d,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this.c.set(I.id,I),new M.$$J(()=>{u.dispose(),this.c.delete(I.id)})}registerCommand(I,u,d,l,R,B){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:d,thisArg:l,description:R,extension:B}),I&&this.#e.$registerCommand(u),new M.$$J(()=>{this.b.delete(u)&&I&&this.#e.$unregisterCommand(u)})}executeCommand(I,...u){return this.d.trace("ExtHostCommands#executeCommand",I),this.g(I,u,!0)}async g(I,u,d){if(this.b.has(I))return this.#e.$fireCommandActivationEvent(I),this.h(I,u,!1);{let l=!1;const R=(0,F.$1m)(u,function(B){if(B instanceof M.$_J)return C.Position.from(B);if(B instanceof M.$aK)return C.Range.from(B);if(B instanceof M.$kK)return C.location.from(B);if(M.$vL.isNotebookRange(B))return C.NotebookRange.from(B);if(B instanceof ArrayBuffer)return l=!0,n.$ae.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return l=!0,n.$ae.wrap(B);if(B instanceof n.$ae)return l=!0,B;if(!Array.isArray(B))return B});try{const B=await this.#e.$executeCommand(I,l?new c.$jv(R):R,d);return(0,g.$kh)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(I,u,!1);throw B}}}async h(I,u,d){const l=this.b.get(I);if(!l)throw new Error("Unknown command");const{callback:R,thisArg:B,description:V}=l;if(V)for(let W=0;W<V.args.length;W++)try{(0,w.$Of)(u[W],V.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed.Illegal argument '${V.args[W].name}' - ${V.args[W].description} `)}const U=D.$Id.create();try{return await R.apply(B,u)}catch(W){if(I===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...u);N&&(I=N.command)}if(this.d.error(W,I,l.extension?.identifier),!d)throw W;if(l.extension?.identifier){const N=this.#i.onExtensionError(l.extension.identifier,W);this.d.trace("forwarded error to extension?",N,l.extension?.identifier)}throw new class extends Error{constructor(){super((0,v.$yi)(W)),this.id=I,this.source=l.extension?.displayName??l.extension?.name}}}finally{this.j(l,I,U.elapsed())}}j(I,u,d){I.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new p.$co(u),duration:d})}$executeContributedCommand(I,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",I);const d=this.b.get(I);return d?(u=u.map(l=>this.f.reduce((R,B)=>B.processArgument(R,d.extension?.identifier),l)),this.h(I,u,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this.d.trace("ExtHostCommands#getCommands",I),this.#e.$getCommands().then(u=>(I&&(u=u.filter(d=>d[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const I=Object.create(null);for(const[u,d]of this.b){const{description:l}=d;l&&(I[u]=l)}return Promise.resolve(I)}};e.$sM=s,e.$sM=s=Ke([Ve(0,f.$0L),Ve(1,E.$8i),Ve(2,r.$rM)],s),e.$tM=(0,m.$Nh)("IExtHostCommands");class i{constructor(I,u,d){this.d=I,this.f=u,this.g=d,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(I,u){if(!I)return;const d={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return d;const l=this.f(I.command);if(l)d.id=l.internalId,d.arguments=l.args.map((R,B)=>R.convert(I.arguments&&I.arguments[B]));else if((0,h.$Kb)(I.arguments)){const R=`${I.command} /${++this.c}`;this.b.set(R,I),u.add((0,b.$Pc)(()=>{this.b.delete(R),this.g.trace("CommandsConverter#DISPOSE",R)})),d.$ident=R,d.id=this.delegatingCommandId,d.arguments=[R],this.g.trace("CommandsConverter#CREATE",I.command,R)}return d}fromInternal(I){return typeof I.$ident=="string"?this.b.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this.b.get(I[0])}h(...I){const u=this.getActualCommand(...I);return this.g.trace("CommandsConverter#EXECUTE",I[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.$uM=i;class o{static{this.Uri=new o("uri","Uri of a text document",I=>a.URI.isUri(I),I=>I)}static{this.Position=new o("position","A position in a text document",I=>M.$_J.isPosition(I),C.Position.from)}static{this.Range=new o("range","A range in a text document",I=>M.$aK.isRange(I),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",I=>M.$bK.isSelection(I),C.Selection.from)}static{this.Number=new o("number","",I=>typeof I=="number",I=>I)}static{this.String=new o("string","",I=>typeof I=="string",I=>I)}static{this.StringArray=o.Arr(o.String)}static Arr(I){return new o(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,u=>Array.isArray(u)&&u.every(d=>I.validate(d)),u=>u.map(d=>I.convert(d)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",I=>I instanceof M.$uK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",I=>I instanceof M.$OL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",I=>I instanceof t.$kM,C.TestItem.from)}constructor(I,u,d,l){this.name=I,this.description=u,this.validate=d,this.convert=l}optional(){return new o(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,u){return new o(I??this.name,u??this.description,this.validate,this.convert)}}e.$vM=o;class y{static{this.Void=new y("no result",I=>I)}constructor(I,u){this.description=I,this.convert=u}}e.$wM=y;class ${constructor(I,u,d,l,R){this.id=I,this.internalId=u,this.description=d,this.args=l,this.result=R}}e.$xM=$}),define(Ae[224],Re([1,0,18,12,2,78,91,32,95,31,8,7]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;const a=[new g.$xM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$vM.Uri,g.$vM.Position],new g.$wM("A promise that resolves to an array of DocumentHighlight-instances.",m(P.DocumentHighlight.to))),new g.$xM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$vM.Uri],new g.$wM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,n)=>{if((0,w.$Jb)(t))return;class c extends k.$pK{static to(D){const p=new c(D.name,P.SymbolKind.to(D.kind),D.containerName||"",new k.$kK(n[0],P.Range.to(D.range)));return p.detail=D.detail,p.range=p.location.range,p.selectionRange=P.Range.to(D.selectionRange),p.children=D.children?D.children.map(c.to):[],p}}return t.map(c.to)})),new g.$xM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$vM.Uri,new g.$vM("options","Formatting options",t=>!0,t=>t)],new g.$wM("A promise that resolves to an array of TextEdits.",m(P.TextEdit.to))),new g.$xM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$vM.Uri,g.$vM.Range,new g.$vM("options","Formatting options",t=>!0,t=>t)],new g.$wM("A promise that resolves to an array of TextEdits.",m(P.TextEdit.to))),new g.$xM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$vM.Uri,g.$vM.Position,new g.$vM("ch","Trigger character",t=>typeof t=="string",t=>t),new g.$vM("options","Formatting options",t=>!0,t=>t)],new g.$wM("A promise that resolves to an array of TextEdits.",m(P.TextEdit.to))),new g.$xM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$vM.Uri,g.$vM.Position],new g.$wM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$xM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$vM.Uri,g.$vM.Position],new g.$wM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$xM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$vM.Uri,g.$vM.Position],new g.$wM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$xM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$vM.Uri,g.$vM.Position],new g.$wM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$xM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$vM.Uri,g.$vM.Position],new g.$wM("A promise that resolves to an array of Location-instances.",m(P.location.to))),new g.$xM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$vM.Uri,g.$vM.Position],new g.$wM("A promise that resolves to an array of Hover-instances.",m(P.Hover.to))),new g.$xM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$vM.Uri,new g.$vM("position","A position in a text document",t=>Array.isArray(t)&&t.every(n=>k.$_J.isPosition(n)),t=>t.map(P.Position.from))],new g.$wM("A promise that resolves to an array of ranges.",t=>t.map(n=>{let c;for(const v of n.reverse())c=new k.$tK(P.Range.to(v),c);return c}))),new g.$xM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$vM.String.with("query","Search string")],new g.$wM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new g.$xM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$vM.Uri,g.$vM.Position],new g.$wM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new g.$xM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$vM.CallHierarchyItem],new g.$wM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new g.$xM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$vM.CallHierarchyItem],new g.$wM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new g.$xM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$vM.Uri,g.$vM.Position],new g.$wM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new g.$xM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$vM.Uri,g.$vM.Position,g.$vM.String.with("newName","The new symbol name")],new g.$wM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new g.$xM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$vM.Uri,g.$vM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$wM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new g.$xM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$vM.Uri],new g.$wM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$nL(t.tokenTypes,t.tokenModifiers)})),new g.$xM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$vM.Uri],new g.$wM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const n=(0,A.$L0)(t);if(n.type==="full")return new k.$pL(n.data,void 0)})),new g.$xM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$vM.Uri,g.$vM.Range.optional()],new g.$wM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$nL(t.tokenTypes,t.tokenModifiers)})),new g.$xM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$vM.Uri,g.$vM.Range],new g.$wM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const n=(0,A.$L0)(t);if(n.type==="full")return new k.$pL(n.data,void 0)})),new g.$xM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$vM.Uri,g.$vM.Position,g.$vM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$vM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$wM("A promise that resolves to a CompletionList-instance.",(t,n,c)=>{if(!t)return new k.$FK([]);const v=t.suggestions.map(D=>P.CompletionItem.to(D,c));return new k.$FK(v,t.incomplete)})),new g.$xM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$vM.Uri,g.$vM.Position,g.$vM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$wM("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new g.$xM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$vM.Uri,g.$vM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$wM("A promise that resolves to an array of CodeLens-instances.",(t,n,c)=>m(v=>new k.$xK(P.Range.to(v.range),v.command&&c.fromInternal(v.command)))(t))),new g.$xM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$vM.Uri,new g.$vM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>k.$aK.isRange(t),t=>k.$bK.isSelection(t)?P.Selection.from(t):P.Range.from(t)),g.$vM.String.with("kind","Code action kind to return code actions for").optional(),g.$vM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$wM("A promise that resolves to an array of Command-instances.",(t,n,c)=>m(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(v.command)}else{const D=new k.$rK(v.title,v.kind?new k.$sK(v.kind):void 0);return v.edit&&(D.edit=P.WorkspaceEdit.to(v.edit)),v.command&&(D.command=c.fromInternal(v.command)),D.isPreferred=v.isPreferred,D}})(t))),new g.$xM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$vM.Uri],new g.$wM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(n=>new k.$LK(P.Range.to(n.range),P.Color.to(n.color))):[])),new g.$xM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$vM("color","The color to show and insert",t=>t instanceof k.$KK,P.Color.from),new g.$vM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new g.$wM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new g.$xM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$vM.Uri,g.$vM.Range],new g.$wM("A promise that resolves to an array of Inlay objects",(t,n,c)=>t.map(P.InlayHint.to.bind(void 0,c)))),new g.$xM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$vM.Uri],new g.$wM("A promise that resolves to an array of FoldingRange objects",(t,n)=>{if(t)return t.map(P.FoldingRange.to)})),new g.$xM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$wM("A promise that resolves to an array of NotebookContentProvider static info objects.",m(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(n=>P.NotebookExclusiveDocumentPattern.to(n))})))),new g.$xM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$vM.Uri,g.$vM.Range,new g.$vM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof k.$aK,t=>P.InlineValueContext.from(t))],new g.$wM("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new g.$xM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$vM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,E.$5T)(t,M.Schemas.http,M.Schemas.https),t=>t),new g.$vM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),g.$vM.String.with("label","").optional()],g.$wM.Void),new g.$xM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$vM.Uri.with("resource","Resource to open"),g.$vM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new g.$vM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],g.$wM.Void),new g.$xM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$vM.Uri.with("left","Left-hand side resource of the diff editor"),g.$vM.Uri.with("right","Right-hand side resource of the diff editor"),g.$vM.String.with("title","Human readable title for the diff editor").optional(),new g.$vM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],g.$wM.Void),new g.$xM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$vM.Uri,g.$vM.Position],new g.$wM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$xM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$vM.TypeHierarchyItem],new g.$wM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$xM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$vM.TypeHierarchyItem],new g.$wM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$xM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$vM.TestItem],g.$wM.Void),new g.$xM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$vM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$wM.Void),new g.$xM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$vM.String.with("name","The context key name"),new g.$vM("value","The context key value",()=>!0,t=>t)],g.$wM.Void),new g.$xM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$vM.Uri,g.$vM.StringArray,new g.$vM("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new g.$wM("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class b{static register(n){a.forEach(n.registerApiCommand,n),this.a(n)}static a(n){n.registerCommand(!1,"_validateWhenClauses",h.$Mi)}}e.$Kbc=b;function m(t){return n=>{if(Array.isArray(n))return n.map(t)}}function f(t){if(!Array.isArray(t))return;const n=[];for(const c of t)F.$$s(c)?n.push(P.DefinitionLink.to(c)):n.push(P.location.to(c));return n}}),define(Ae[225],Re([1,0,13,65,5,6,2,78,20,8,7,3,26]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=void 0;function b(m,f,t){const n=m.getProxy(k.$9J.MainThreadComments);class c{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$1l,f.registerArgumentProcessor({processArgument:$=>{if($&&$.$mid===6){const S=this.b.get($.handle);return S?S.value:$}else if($&&$.$mid===7){const S=this.b.get($.commentControlHandle);if(!S)return $;const I=S.getCommentThread($.commentThreadHandle);return I?I.value:$}else if($&&($.$mid===9||$.$mid===8)){const S=this.b.get($.thread.commentControlHandle);if(!S)return $;const I=S.getCommentThread($.thread.commentThreadHandle);return I?$.$mid===8?I.value:{thread:I.value,text:$.text}:$}else if($&&$.$mid===10){const S=this.b.get($.thread.commentControlHandle);if(!S)return $;const I=S.getCommentThread($.thread.commentThreadHandle);if(!I)return $;const u=$.commentUniqueId,d=I.getCommentByUniqueId(u);return d||$}else if($&&$.$mid===11){const S=this.b.get($.thread.commentControlHandle);if(!S)return $;const I=S.getCommentThread($.thread.commentThreadHandle);if(!I)return $;const u=$.text,d=$.commentUniqueId,l=I.getCommentByUniqueId(d);return l?(typeof l.body=="string"?l.body=u:l.body=new P.$yK(u),l):$}return $}})}createCommentController($,S,I){const u=c.a++,d=new D($,u,S,I);this.b.set(d.handle,d);const l=this.c.get($.identifier)||[];return l.push(d),this.c.set($.identifier,l),d.value}$createCommentThreadTemplate($,S,I){const u=this.b.get($);u&&u.$createCommentThreadTemplate(S,I)}async $updateCommentThreadTemplate($,S,I){const u=this.b.get($);u&&u.$updateCommentThreadTemplate(S,I)}$deleteCommentThread($,S){this.b.get($)?.$deleteCommentThread(S)}$provideCommentingRanges($,S,I){const u=this.b.get($);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const d=t.getDocument(A.URI.revive(S));return(0,w.$Lg)(async()=>{const l=await u.commentingRangeProvider.provideCommentingRanges(d,I);let R;return Array.isArray(l)?R={ranges:l,fileComments:!1}:l?R={ranges:l.ranges||[],fileComments:l.fileComments||!1}:R=l??void 0,R}).then(l=>{let R;return l&&(R={ranges:l.ranges.map(B=>g.Range.from(B)),fileComments:l.fileComments}),R})}$toggleReaction($,S,I,u,d){const l=this.b.get($);return!l||!l.reactionHandler?Promise.resolve(void 0):(0,w.$Lg)(()=>{const R=l.getCommentThread(S);if(R){const B=R.getCommentByUniqueId(u.uniqueIdInThread);if(l!==void 0&&B&&l.reactionHandler)return l.reactionHandler(B,s(d))}return Promise.resolve(void 0)})}}class v{static{this.a=0}set threadId($){this.n=$}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range($){($===void 0!=(this.p===void 0)||!$||!this.p||!$.isEqual(this.p))&&(this.p=$,this.b.range=$,this.c.fire())}get range(){return this.p}set canReply($){this.d!==$&&(this.d=$,this.b.canReply=$,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label($){this.e=$,this.b.label=$,this.c.fire()}get contextValue(){return this.f}set contextValue($){this.f=$,this.b.contextValue=$,this.c.fire()}get comments(){return this.q}set comments($){this.q=$,this.b.comments=$,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState($){this.g=$,this.b.collapsibleState=$,this.c.fire()}get state(){return this.h}set state($){this.h=$,this.b.state=$,this.c.fire()}get isDisposed(){return this.j}constructor($,S,I,u,d,l,R,B){this.m=S,this.n=I,this.o=u,this.p=d,this.q=l,this.extensionDescription=R,this.r=B,this.handle=v.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Md,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Sc,this.l.value=new F.$Qc,this.n===void 0&&(this.n=`${$}.${this.handle}`),n.$createCommentThread(S,this.handle,this.n,this.o,g.Range.from(this.p),R.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=l,this.i.push({dispose:()=>{n.$deleteCommentThread(S,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(U){V.range=U},get comments(){return V.comments},set comments(U){V.comments=U},get collapsibleState(){return V.collapsibleState},set collapsibleState(U){V.collapsibleState=U},get canReply(){return V.canReply},set canReply(U){V.canReply=U},get contextValue(){return V.contextValue},set contextValue(U){V.contextValue=U},get label(){return V.label},set label(U){V.label=U},get state(){return V.state},set state(U){V.state=U},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Qc);const $=I=>Object.prototype.hasOwnProperty.call(this.b,I),S={};$("range")&&(S.range=g.Range.from(this.p)),$("label")&&(S.label=this.label),$("contextValue")&&(S.contextValue=this.contextValue??null),$("comments")&&(S.comments=this.q.map(I=>p(this,I,this.k,this.extensionDescription))),$("collapsibleState")&&(S.collapseState=i(this.g)),$("canReply")&&(S.canReply=this.canReply),$("state")&&(S.state=o(this.h)),$("isTemplate")&&(S.isTemplate=this.r),this.b={},n.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId($){for(const S of this.k){const I=S[0],u=S[1];if($===u)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach($=>$.dispose())}}Ke([(0,M.$gh)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class D{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider($){this.b=$,n.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler($){this.c=$,n.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!$})}get options(){return this.d}set options($){this.d=$,n.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor($,S,I,u){this.f=$,this.g=S,this.h=I,this.i=u,this.a=new Map,n.$registerCommentController(this.handle,I,u,this.f.identifier.value);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(l){d.options=l},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(l){d.commentingRangeProvider=l},get reactionHandler(){return d.reactionHandler},set reactionHandler(l){d.reactionHandler=l},createCommentThread(l,R,B){return d.createCommentThread(l,R,B).value},dispose:()=>{d.dispose()}}),this.e=[],this.e.push({dispose:()=>{n.$unregisterCommentController(this.handle)}})}createCommentThread($,S,I){S===void 0&&(0,a.$9E)(this.f,"fileComments");const u=new v(this.id,this.handle,void 0,$,S,I,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate($,S){const I=new v(this.id,this.handle,void 0,A.URI.revive($),g.Range.to(S),[],this.f,!0);return I.collapsibleState=h.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate($,S){const I=this.a.get($);I&&(I.range=g.Range.to(S))}$deleteCommentThread($){this.a.get($)?.dispose(),this.a.delete($)}getCommentThread($){return this.a.get($)}dispose(){this.a.forEach($=>{$.dispose()}),this.e.forEach($=>$.dispose())}}function p(y,$,S,I){let u=S.get($);return u||(u=++y.commentHandle,S.set($,u)),$.state!==void 0&&(0,a.$9E)(I,"commentsDraftState"),{mode:$.mode,contextValue:$.contextValue,uniqueIdInThread:u,body:typeof $.body=="string"?$.body:g.MarkdownString.from($.body),userName:$.author.name,userIconPath:$.author.iconPath,label:$.label,commentReactions:$.reactions?$.reactions.map(d=>r(d)):void 0,state:$.state,timestamp:$.timestamp?.toJSON()}}function r(y){return{label:y.label,iconPath:y.iconPath?g.$9L(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted}}function s(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?A.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1}}function i(y){if(y!==void 0)switch(y){case P.CommentThreadCollapsibleState.Expanded:return h.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return h.CommentThreadCollapsibleState.Collapsed}return h.CommentThreadCollapsibleState.Collapsed}function o(y){if(y!==void 0)switch(y){case P.CommentThreadState.Unresolved:return h.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return h.CommentThreadState.Resolved}return h.CommentThreadState.Unresolved}return new c}e.$Mbc=b}),define(Ae[226],Re([1,0,24,3,27,17]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;let A=class{constructor(P,k){this.a=P.getProxy(M.$9J.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,k){const a=this,b=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){a.e(P,k,b,arguments)}})}e(P,k,a,b){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:E(b,this.b)}),this.c&&this.f(P,a,b)}};e.$Idc=A,e.$Idc=A=Ke([Ve(0,F.$0L),Ve(1,C.$nM)],A);const h=1e5;function E(g,P){const k=[];if(g.length)for(let a=0;a<g.length;a++){let b=g[a];if(typeof b>"u")b="undefined";else if(b instanceof Error){const m=b;m.stack?b=m.stack:b=m.toString()}k.push(b)}if(P){const a=new Error().stack;a&&k.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,w.$4m)(k);return a.length>h?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Ae[107],Re([1,0,2,3,7,4,17,14,18,15,19,26]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=void 0;let b=class{static{a=this}static{this.c=0}static{this.d=250}constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(M.$9J.MainThreadDecorations)}registerFileDecorationProvider(f,t){const n=a.c++;this.f.set(n,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(n,t.identifier.value);const c=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(v=>{if(!v){this.g.$onDidChange(n,null);return}const D=(0,E.$2b)(v);if(D.length<=a.d){this.g.$onDidChange(n,D);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,D.length);const p=D.map(i=>({uri:i,rank:(0,g.$Fe)(i.path,"/")})),r=(0,E.$yb)(p,(i,o)=>i.rank-o.rank||(0,g.$Te)(i.uri.path,o.uri.path)),s=[];e:for(const i of r){let o;for(const y of i){const $=(0,P.$lc)(y.uri.path);if(o!==$&&(o=$,s.push(y.uri)>=a.d))break e}}this.g.$onDidChange(n,s)});return new C.$$J(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(n),this.f.delete(n)})}async $provideDecorations(f,t,n){if(!this.f.has(f))return Object.create(null);const c=Object.create(null),{provider:v,extensionDescription:D}=this.f.get(f);return await Promise.all(t.map(async p=>{try{const{uri:r,id:s}=p,i=await Promise.resolve(v.provideFileDecoration(w.URI.revive(r),n));if(!i)return;try{C.$tL.validate(i),i.badge&&typeof i.badge!="string"&&(0,k.$9E)(D,"codiconDecoration"),c[s]=[i.propagate,i.tooltip,i.badge,i.color]}catch(o){this.h.warn(`INVALID decoration from extension '${D.identifier.value}': ${o}`)}}catch(r){this.h.error(r)}})),c}};e.$Ncc=b,e.$Ncc=b=a=Ke([Ve(0,A.$0L),Ve(1,h.$8i)],b),e.$Occ=(0,F.$Nh)("IExtHostDecorations")}),define(Ae[227],Re([1,0,147,94,2,3,7,8,5,14,28,39]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=e.$Ebc=void 0;class b{#e;#t;#i;constructor(t,n,c,v,D,p,r,s){this.d=t,this.e=n,this.f=c,this.g=v,this.h=D,this.c=!1,this.f=Math.max(v,c),this.#i=new P.$zc(i=>p.getComparisonKey(i)),this.#e=r,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,n){if(!t){this.clear();return}this.j();let c=[];if(C.URI.isUri(t)){if(!n){this.delete(t);return}this.#i.set(t,n.slice()),c=[t]}else if(Array.isArray(t)){c=[];let p;t=[...t].sort(b.k);for(const r of t){const[s,i]=r;if((!p||s.toString()!==p.toString())&&(p&&this.#i.get(p).length===0&&this.#i.delete(p),p=s,c.push(s),this.#i.set(s,[])),i)this.#i.get(s)?.push(...i);else{const o=this.#i.get(s);o&&(o.length=0)}}}if(this.#t.fire(c),!this.#e)return;const v=[];let D=0;for(const p of c){let r=[];const s=this.#i.get(p);if(s)if(s.length>this.g){r=[];const i=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const y of s)if(y.severity===i[o]&&r.push({...h.Diagnostic.from(y),modelVersionId:this.h(p)})===this.g)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,w.localize)(0,null,s.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(i=>({...h.Diagnostic.from(i),modelVersionId:this.h(p)}));if(v.push([p,r]),D+=r.length,D>this.f)break}this.#e.$changeMany(this.e,v)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,n){this.j();for(const[c,v]of this)t.call(n,c,v,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const n=this.#i.get(t);return Array.isArray(n)?Object.freeze(n.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,n){return t[0].toString()<n[0].toString()?-1:t[0].toString()>n[0].toString()?1:0}}e.$Ebc=b;let m=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*a.d}static _mapper(t){const n=new P.$zc;for(const c of t)n.set(c,c);return{uris:Object.freeze(Array.from(n.values()))}}constructor(t,n,c,v){this.j=n,this.k=c,this.l=v,this.g=new Map,this.h=new E.$Qd({merge:D=>D.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,a._mapper),this.f=t.getProxy(F.$9J.MainThreadDiagnostics)}createDiagnosticCollection(t,n){const{g:c,f:v,h:D,j:p,k:r,l:s}=this,i=new class{$changeMany($,S){v.$changeMany($,S),p.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,$,S.length===0?"CLEARING":S)}$clear($){v.$clear($),p.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,$)}dispose(){v.dispose()}};let o;if(!n)n="_generated_diagnostic_collection_name_#"+a.c++,o=n;else if(!c.has(n))o=n;else{this.j.warn(`DiagnosticCollection with name '${n}' does already exist.`);do o=n+a.c++;while(c.has(o))}return new class extends b{constructor(){super(n,o,a.e,a.d,$=>s.getDocument($)?.version,r.extUri,i,D),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const n=new Map,c=[];for(const v of this.g.values())v.forEach((D,p)=>{let r=n.get(D.toString());typeof r>"u"&&(r=c.length,n.set(D.toString(),r),c.push([D,[]])),c[r][1]=c[r][1].concat(...p)});return c}}m(t){let n=[];for(const c of this.g.values())c.has(t)&&(n=n.concat(c.get(t)));return n}$acceptMarkersChange(t){if(!this.n){const n="_generated_mirror",c=new b(n,n,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,v=>{},this.k.extUri,void 0,this.h);this.g.set(n,c),this.n=c}for(const[n,c]of t)this.n.set(C.URI.revive(n),c.map(h.Diagnostic.to))}};e.$Fbc=m,e.$Fbc=m=a=Ke([Ve(1,g.$8i),Ve(2,k.$Dbc)],m)}),define(Ae[228],Re([1,0,2,3,26]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class F{constructor(h){this.a=h.getProxy(M.$9J.MainThreadDialogs)}showOpenDialog(h,E){return E?.allowUIResources&&(0,C.$9E)(h,"showLocal"),this.a.$showOpenDialog(E).then(g=>g?g.map(P=>w.URI.revive(P)):void 0)}showSaveDialog(h){return this.a.$showSaveDialog(h).then(E=>E?w.URI.revive(E):void 0)}}e.$Ubc=F}),define(Ae[229],Re([1,0,9,2,7,3,12,21,15]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;class g{static{this.a=0}constructor(k,a,b){this.d=a,this.e=b,this.b=new Map,this.c=k.getProxy(F.$9J.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,a){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const b=g.a++;this.b.set(b,a),this.c.$registerTextContentProvider(b,k);let m;return typeof a.onDidChange=="function"&&(m=a.onDidChange(f=>{if(f.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(b,f).then(t=>{if(!t&&typeof t!="string")return;const n=this.d.getDocument(f);if(!n)return;const c=(0,E.$Oe)(t);if(!n.equalLines(c))return this.c.$onVirtualDocumentChange(f,t)},w.$Z)})),new C.$$J(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(k,a){const b=this.b.get(k);return b?Promise.resolve(b.provideTextDocumentContent(M.URI.revive(a),h.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$Vbc=g}),define(Ae[230],Re([1,0,5,6,2,3,100,8,16,24,7,9]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=void 0;class a{constructor(m,f){this.a=new w.$Md({onListenerError:k.$1}),this.b=new w.$Md({onListenerError:k.$1}),this.c=new w.$Md({onListenerError:k.$1}),this.d=new w.$Md({onListenerError:k.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Qc,this.h=new Map,this.f=m.getProxy(F.$9J.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const n of t)this.b.fire(n.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const n of t)this.a.fire(n.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(m){if(!m)return;const f=this.g.getDocument(m);if(f)return f}getDocument(m){const f=this.getDocumentData(m);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return f.document}ensureDocumentData(m){const f=this.g.getDocument(m);if(f)return Promise.resolve(f);let t=this.h.get(m.toString());return t||(t=this.f.$tryOpenDocument(m).then(n=>{this.h.delete(m.toString());const c=C.URI.revive(n);return(0,E.$If)(this.g.getDocument(c))},n=>(this.h.delete(m.toString()),Promise.reject(n))),this.h.set(m.toString(),t)),t}createDocumentData(m){return this.f.$tryCreateDocument(m).then(f=>C.URI.revive(f))}$acceptModelLanguageChanged(m,f){const t=C.URI.revive(m),n=this.g.getDocument(t);if(!n)throw new Error("unknown document");this.b.fire(n.document),n._acceptLanguageId(f),this.a.fire(n.document)}$acceptModelSaved(m){const f=C.URI.revive(m),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(m,f){const t=C.URI.revive(m),n=this.g.getDocument(t);if(!n)throw new Error("unknown document");n._acceptIsDirty(f),this.c.fire({document:n.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,f,t){const n=C.URI.revive(m),c=this.g.getDocument(n);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(f);let v;f.isUndoing?v=P.TextDocumentChangeReason.Undo:f.isRedoing&&(v=P.TextDocumentChangeReason.Redo),this.c.fire((0,g.$Zm)({document:c.document,contentChanges:f.changes.map(D=>({range:h.Range.to(D.range),rangeOffset:D.rangeOffset,rangeLength:D.rangeLength,text:D.text})),reason:v}))}setWordDefinitionFor(m,f){(0,A.$_L)(m,f)}}e.$Bbc=a}),define(Ae[60],Re([1,0,51,5,6,2,4,3,100,17,105,8,14,28,12,66,48]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=void 0;class n{constructor(D){this.value=D,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(D,p){this.h=D,this.i=p,this.a=null,this.b=new Map,this.c=new b.$zc,this.d=new M.$Md,this.e=new M.$Md,this.f=new M.$Md,this.g=new M.$Md,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(D){this.acceptDocumentsAndEditorsDelta(D)}acceptDocumentsAndEditorsDelta(D){const p=[],r=[],s=[];if(D.removedDocuments)for(const i of D.removedDocuments){const o=F.URI.revive(i),y=this.c.get(o);y?.unref()&&(this.c.delete(o),p.push(y.value))}if(D.addedDocuments)for(const i of D.addedDocuments){const o=F.URI.revive(i.uri);let y=this.c.get(o);if(y&&o.scheme!==m.Schemas.vscodeNotebookCell&&o.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);y||(y=new n(new E.$aM(this.h.getProxy(h.$9J.MainThreadDocuments),o,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this.c.set(o,y),r.push(y.value)),y.ref()}if(D.removedEditors)for(const i of D.removedEditors){const o=this.b.get(i);this.b.delete(i),o&&s.push(o)}if(D.addedEditors)for(const i of D.addedEditors){const o=F.URI.revive(i.documentUri);w.ok(this.c.has(o),`document '${o}' does not exist`),w.ok(!this.b.has(i.id),`editor '${i.id}' already exists!`);const y=this.c.get(o).value,$=new P.$gM(i.id,this.h.getProxy(h.$9J.MainThreadTextEditors),this.i,new t.$U(()=>y.document),i.selections.map(k.Selection.to),i.options,i.visibleRanges.map(S=>k.Range.to(S)),typeof i.editorPosition=="number"?k.ViewColumn.to(i.editorPosition):void 0);this.b.set(i.id,$)}D.newActiveEditor!==void 0&&(w.ok(D.newActiveEditor===null||this.b.has(D.newActiveEditor),`active editor '${D.newActiveEditor}' does not exist`),this.a=D.newActiveEditor),(0,C.$Mc)(p),(0,C.$Mc)(s),D.removedDocuments&&this.e.fire(p),D.addedDocuments&&this.d.fire(r),(D.removedEditors||D.addedEditors)&&this.f.fire(this.allEditors().map(i=>i.value)),D.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(D){return this.c.get(D)?.value}allDocuments(){return f.Iterable.map(this.c.values(),D=>D.value)}getEditor(D){return this.b.get(D)}activeEditor(D){if(!this.a)return;const p=this.b.get(this.a);return D?p:p?.value}allEditors(){return[...this.b.values()]}};e.$hM=c,e.$hM=c=Ke([Ve(0,g.$0L),Ve(1,a.$8i)],c),e.$iM=(0,A.$Nh)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,3,2,5,4,7,17,16,231]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=void 0,e.$Scc=(0,A.$Nh)("IExtHostEditorTabs");class k{constructor(t,n,c){this.e=c,this.d=n,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,n={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(n)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new h.$PL(C.URI.revive(this.b.input.uri));case 2:return new h.$QL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new h.$RL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new h.$SL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new h.$TL(this.b.input.viewType);case 4:return new h.$UL(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new h.$VL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new h.$WL;case 9:return new h.$XL(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class a{constructor(t,n){this.c=[],this.d="",this.b=t,this.e=n;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new k(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,n={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return w.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(n)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new k(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const n=this.c.find(c=>c.tabId===t.tabDto.id);if(!n)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),n.acceptDtoUpdate(t.tabDto),n}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new F.$Md,this.c=new F.$Md,this.e=[],this.a=t.getProxy(M.$9J.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,n={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,g.$If)(t.e.find(D=>D.groupId===c)?.apiObject)},close:async(c,v)=>{const D=Array.isArray(c)?c:[c];return D.length?m(D[0])?this.j(D,v):this.i(D,v):!0}};this.f=Object.freeze(n)}return this.f}$acceptEditorTabModel(t){const n=new Set(this.e.map(i=>i.groupId)),c=new Set(t.map(i=>i.groupId)),v=(0,P.$K)(n,c),D=this.e.filter(i=>v.removed.includes(i.groupId)).map(i=>i.apiObject),p=[],r=[];this.e=t.map(i=>{const o=new a(i,()=>this.d);return v.added.includes(o.groupId)?p.push(o.apiObject):r.push(o.apiObject),o});const s=(0,g.$If)(t.find(i=>i.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:p,closed:D,changed:r}))}$acceptTabGroupUpdate(t){const n=this.e.find(c=>c.groupId===t.groupId);if(!n)throw new Error("Update Group IPC call received before group creation.");n.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[n.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const n=this.e.find(v=>v.groupId===t.groupId);if(!n)throw new Error("Update Tabs IPC call received before group creation.");const c=n.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const n of this.e)for(const c of n.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(n=>n.apiObject===t)}async i(t,n){const c=[];for(const v of t){const D=this.g(v);if(!D)throw new Error("Tab close: Invalid tab not found!");c.push(D.tabId)}return this.a.$closeTab(c,n)}async j(t,n){const c=[];for(const v of t){const D=this.h(v);if(!D)throw new Error("Group close: Invalid group not found!");c.push(D.groupId)}return this.a.$closeGroup(c,n)}};e.$Tcc=b,e.$Tcc=b=Ke([Ve(0,E.$0L)],b);function m(f){return f.tabs!==void 0}}),define(Ae[232],Re([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$9J.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,h,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(A);if(!g)throw new Error("Embedding vector provider not found");const P=await g.provideEmbeddingVector(h,E);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,h,E){const g=this.b;return this.b++,this.a.set(g,E),this.c.$registerAiEmbeddingVectorProvider(h,g),new M.$$J(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$Edc=C}),define(Ae[233],Re([1,0,2,3,6,7,8,279,15,25,26,50]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;class a{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let n,c,v=14,D=14;for(const p of f){let r=n?(0,E.$3e)(n,p):0;for(r===0?c=1:c=D;r<p.length;r++)r+1===p.length?(v=D,D=9):D+=1,t.push([c,p.toUpperCase().charCodeAt(r),D]),t.push([c,p.toLowerCase().charCodeAt(r),D]),c=D;n=p,D=v}t.push([9,58,10]),t.push([10,47,12]),this.b=new h.$NY(t)}}provideDocumentLinks(f){this.c();const t=[],n=h.$OY.computeLinks({getLineContent(c){return f.lineAt(c-1).text},getLineCount(){return f.lineCount}},this.b);for(const c of n){const v=A.DocumentLink.to(c);v.target&&t.push(v)}return t}}class b{constructor(f,t){this.i=t,this.b=new a,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(M.$9J.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,n,c={}){if(b.j(n),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const v=this.h++;this.b.add(t),this.d.add(t),this.c.set(v,n);let D=2;c.isCaseSensitive&&(D+=1024),c.isReadonly&&(D+=2048),typeof n.copy=="function"&&(D+=8),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,P.$9E)(f,"fsChunks"),D+=4);let p;c.isReadonly&&(0,k.$3j)(c.isReadonly)&&((0,P.$9E)(f,"readonlyMessage"),p={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(v,t,D,p).catch(s=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(s)});const r=n.onDidChangeFile(s=>{const i=[];for(const o of s){const{uri:y,type:$}=o;if(y.scheme!==t)continue;let S;switch($){case F.FileChangeType.Changed:S=0;break;case F.FileChangeType.Created:S=1;break;case F.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:y,type:S})}this.a.$onFileSystemChange(v,i)});return(0,C.$Pc)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(v),this.a.$unregisterProvider(v)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:t,ctime:n,mtime:c,size:v,permissions:D}=f;return{type:t,ctime:n,mtime:c,size:v,permissions:D}}$stat(f,t){return Promise.resolve(this.l(f).stat(w.URI.revive(t))).then(n=>b.k(n))}$readdir(f,t){return Promise.resolve(this.l(f).readDirectory(w.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.l(f).readFile(w.URI.revive(t))).then(n=>g.$ae.wrap(n))}$writeFile(f,t,n,c){return Promise.resolve(this.l(f).writeFile(w.URI.revive(t),n.buffer,c))}$delete(f,t,n){return Promise.resolve(this.l(f).delete(w.URI.revive(t),n))}$rename(f,t,n,c){return Promise.resolve(this.l(f).rename(w.URI.revive(t),w.URI.revive(n),c))}$copy(f,t,n,c){const v=this.l(f);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(w.URI.revive(t),w.URI.revive(n),c))}$mkdir(f,t){return Promise.resolve(this.l(f).createDirectory(w.URI.revive(t)))}$watch(f,t,n,c){const v=this.l(f).watch(w.URI.revive(n),c);this.f.set(t,v)}$unwatch(f,t){const n=this.f.get(t);n&&(n.dispose(),this.f.delete(t))}$open(f,t,n){const c=this.l(f);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(w.URI.revive(t),n))}$close(f,t){const n=this.l(f);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(t))}$read(f,t,n,c){const v=this.l(f);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const D=g.$ae.alloc(c);return Promise.resolve(v.read(t,n,D.buffer,0,c)).then(p=>D.slice(0,p))}$write(f,t,n,c){const v=this.l(f);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(t,n,c.buffer,0,c.byteLength))}l(f){const t=this.c.get(f);if(!t){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return t}}e.$pcc=b}),define(Ae[62],Re([1,0,3,38,7,25,4,17,39,6,13,23,12]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=e.$8bc=void 0;let m=b=class{constructor(t,n){this.b=new Map,this.c=new P.$2g,this.a=t.getProxy(w.$9J.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(v){try{let D;const p=c.b.get(v.scheme);return p?(await c.a.$ensureActivation(v.scheme),D=await p.impl.stat(v)):D=await c.a.$stat(v),{type:D.type,ctime:D.ctime,mtime:D.mtime,size:D.size,permissions:D.permissions===M.FilePermission.Readonly?1:void 0}}catch(D){b.e(D)}},async readDirectory(v){try{const D=c.b.get(v.scheme);return D?(await c.a.$ensureActivation(v.scheme),(await D.impl.readDirectory(v)).slice()):await c.a.$readdir(v)}catch(D){return b.e(D)}},async createDirectory(v){try{const D=c.b.get(v.scheme);return D&&!D.isReadonly?(await c.a.$ensureActivation(v.scheme),await c.d(D.impl,D.extUri,v)):await c.a.$mkdir(v)}catch(D){return b.e(D)}},async readFile(v){try{const D=c.b.get(v.scheme);return D?(await c.a.$ensureActivation(v.scheme),(await D.impl.readFile(v)).slice()):(await c.a.$readFile(v)).buffer}catch(D){return b.e(D)}},async writeFile(v,D){try{const p=c.b.get(v.scheme);return p&&!p.isReadonly?(await c.a.$ensureActivation(v.scheme),await c.d(p.impl,p.extUri,p.extUri.dirname(v)),await c.c.queueFor(v).queue(()=>Promise.resolve(p.impl.writeFile(v,D,{create:!0,overwrite:!0})))):await c.a.$writeFile(v,F.$ae.wrap(D))}catch(p){return b.e(p)}},async delete(v,D){try{const p=c.b.get(v.scheme);return p&&!p.isReadonly?(await c.a.$ensureActivation(v.scheme),await p.impl.delete(v,{recursive:!1,...D})):await c.a.$delete(v,{recursive:!1,useTrash:!1,atomic:!1,...D})}catch(p){return b.e(p)}},async rename(v,D,p){try{return await c.a.$rename(v,D,{overwrite:!1,...p})}catch(r){return b.e(r)}},async copy(v,D,p){try{return await c.a.$copy(v,D,{overwrite:!1,...p})}catch(r){return b.e(r)}},isWritableFileSystem(v){const D=n.getCapabilities(v);if(typeof D=="number")return!(D&2048)}})}async d(t,n,c){const v=[];for(;!n.isEqual(c,n.dirname(c));)try{if(!((await t.stat(c)).type&M.FileType.Directory))throw C.$lL.FileExists(`Unable to create folder '${c.scheme===a.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(D){if(M.$lk(D)!==M.FileSystemProviderErrorCode.FileNotFound)throw D;v.push(n.basename(c)),c=n.dirname(c)}for(let D=v.length-1;D>=0;D--){c=n.joinPath(c,v[D]);try{await t.createDirectory(c)}catch(p){if(M.$lk(p)!==M.FileSystemProviderErrorCode.FileExists)throw p}}}static e(t){if(t instanceof C.$lL)throw t;if(t instanceof M.$hk)switch(t.code){case M.FileSystemProviderErrorCode.FileExists:throw C.$lL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$lL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$lL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$lL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$lL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$lL.Unavailable(t.message);default:throw new C.$lL(t.message,t.name)}if(!(t instanceof Error))throw new C.$lL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$lL.Unavailable(t.message);switch(t.name){case M.FileSystemProviderErrorCode.FileExists:throw C.$lL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$lL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$lL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$lL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$lL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$lL.Unavailable(t.message);default:throw new C.$lL(t.message,t.name)}}addFileSystemProvider(t,n,c){return this.b.set(t,{impl:n,extUri:c?.isCaseSensitive?k.$kg:k.$mg,isReadonly:!!c?.isReadonly}),(0,g.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??k.$kg}};e.$8bc=m,e.$8bc=m=b=Ke([Ve(0,h.$0L),Ve(1,E.$Dbc)],m),e.$9bc=(0,A.$Nh)("IExtHostConsumerFileSystem")}),define(Ae[234],Re([1,0,5,37,2,3,8,7,48]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;class g{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(b,m,f,t,n,c,v,D){this.a=new w.$Md,this.b=new w.$Md,this.c=new w.$Md;const p=this.h(b,f,n);this.g=0,c&&(this.g+=1),v&&(this.g+=2),D&&(this.g+=4);const r=(0,M.$uj)(n),s=typeof n=="string",i=t(o=>{if(!c)for(const y of o.created){const $=C.URI.revive(y);r($.fsPath)&&(!s||m.getWorkspaceFolder($))&&this.a.fire($)}if(!v)for(const y of o.changed){const $=C.URI.revive(y);r($.fsPath)&&(!s||m.getWorkspaceFolder($))&&this.b.fire($)}if(!D)for(const y of o.deleted){const $=C.URI.revive(y);r($.fsPath)&&(!s||m.getWorkspaceFolder($))&&this.c.fire($)}});this.d=h.$$J.from(p,this.a,this.b,this.c,i)}h(b,m,f){const t=h.$$J.from();if(typeof f=="string")return t;const n=b.getProxy(F.$9J.MainThreadFileSystem);let c=!1;(f.pattern.includes(M.$qj)||f.pattern.includes(M.$rj))&&(c=!0);const v=Math.random();return n.$watch(m.identifier.value,v,f.baseUri,{recursive:c,excludes:[]}),h.$$J.from({dispose:()=>n.$unwatch(v)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class P{constructor(b){this.a=b,this.b=new E.$U(()=>this.a.created.map(C.URI.revive)),this.c=new E.$U(()=>this.a.changed.map(C.URI.revive)),this.d=new E.$U(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(b,m,f){this.j=b,this.k=m,this.l=f,this.a=new w.$Md,this.b=new w.$Md,this.c=new w.$Md,this.d=new w.$Md,this.g=new w.$Od,this.h=new w.$Od,this.i=new w.$Od,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,m,f,t,n,c){return new g(this.j,b,m,this.a.event,A.GlobPattern.from(f),t,n,c)}$onFileEvent(b){this.a.fire(new P(b))}$onDidRunFileOperation(b,m){switch(b){case 2:this.b.fire(Object.freeze({files:m.map(f=>({oldUri:C.URI.revive(f.source),newUri:C.URI.revive(f.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(f=>C.URI.revive(f.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(f=>C.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,m){return(f,t,n)=>{const c=function(D){f.call(t,D)};return c.extension=b,m.event(c,void 0,n)}}async $onWillRunFileOperation(b,m,f,t){switch(b){case 2:return await this.n(this.g,{files:m.map(n=>({oldUri:C.URI.revive(n.source),newUri:C.URI.revive(n.target)}))},f,t);case 1:return await this.n(this.i,{files:m.map(n=>C.URI.revive(n.target))},f,t);case 0:case 3:return await this.n(this.h,{files:m.map(n=>C.URI.revive(n.target))},f,t)}}async n(b,m,f,t){const n=new Set,c=[];if(await b.fireAsync(m,t,async(D,p)=>{const r=Date.now(),s=await Promise.resolve(D);s instanceof h.$iK&&(c.push([p.extension,s]),n.add(p.extension.displayName??p.extension.identifier.value)),Date.now()-r>f&&this.k.warn("SLOW file-participant",p.extension.identifier)}),t.isCancellationRequested||c.length===0)return;const v={edits:[]};for(const[,D]of c){const{edits:p}=A.WorkspaceEdit.from(D,{getTextDocumentVersion:r=>this.l.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});v.edits=v.edits.concat(p)}return{edit:v,extensionNames:Array.from(n)}}}e.$qcc=k}),define(Ae[235],Re([1,0,6,2,3,8,7,31]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class E{static{this.a=0}constructor(a,b){this.extension=a,this.provider=b,this.handle=E.a++}}class g{constructor(a){this.session=a,this.responses=[]}}class P{static{this.a=0}constructor(a,b,m,f){this.f=m,this.g=f,this.b=new Map,this.d=new Map,this.e=a.getProxy(C.$9J.MainThreadInlineChat),b.registerApiCommand(new h.$xM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new h.$vM("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?F.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?F.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?F.Position.from(t.position):void 0}})],h.$wM.Void))}registerProvider(a,b,m){const f=new E(a,b);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,m.label,a.identifier.value,typeof b.handleInteractiveEditorResponseFeedback=="function"),(0,w.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(a,b,m,f){const t=this.b.get(a);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(M.URI.revive(b)),c=F.Selection.to(m),v=await t.provider.prepareInteractiveEditorSession({document:n,selection:c},f);if(!v)return;if(v.wholeRange&&!v.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const D=P.a++;return this.d.set(D,new g(v)),{id:D,placeholder:v.placeholder,slashCommands:v.slashCommands?.map(p=>({command:p.command,detail:p.detail,refer:p.refer,executeImmediately:p.executeImmediately})),wholeRange:F.Range.from(v.wholeRange),message:v.message}}async $provideResponse(a,b,m,f){const t=this.b.get(a);if(!t)return;const n=this.d.get(b.id);if(!n)return;const c={prompt:m.prompt,selection:F.Selection.to(m.selection),wholeRange:F.Range.to(m.wholeRange),attempt:m.attempt,live:m.live};let v=!1;const D={report:async s=>{if(!m.live)throw new Error("Progress reporting is only supported for live sessions");v||f.isCancellationRequested||!s.message&&!s.edits||await this.e.$handleProgressChunk(m.requestId,{message:s.message,edits:s.edits?.map(F.TextEdit.from)})}},p=t.provider.provideInteractiveEditorResponse(n.session,c,D,f);Promise.resolve(p).finally(()=>v=!0);const r=await p;if(r){const s=n.responses.push(r)-1,i={wholeRange:F.Range.from(r.wholeRange),placeholder:r.placeholder};if(P.h(r))return{...i,id:s,type:"message",message:F.MarkdownString.from(r.contents)};const{edits:o}=r;if(o instanceof A.$iK)return{...i,id:s,type:"bulkEdit",edits:F.WorkspaceEdit.from(o)};if(Array.isArray(o))return{...i,id:s,type:"editorEdit",edits:o.map(F.TextEdit.from)}}}$handleFeedback(a,b,m,f){const t=this.b.get(a),n=this.d.get(b),c=n?.responses[m];if(t&&c){const v=F.InteractiveEditorResponseFeedbackKind.to(f);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,c,v)}}$releaseSession(a,b){}static h(a){return typeof a=="object"&&typeof a.contents=="object"}}e.$xdc=P}),define(Ae[236],Re([1,0,2,31]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class C{constructor(A,h,E,g,P){this.a=h,this.b=E,this.c=g;const k=new M.$xM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$vM("showOptions","Show Options",a=>!0,a=>a),new M.$vM("resource","Interactive resource Uri",a=>!0,a=>a),new M.$vM("controllerId","Notebook controller Id",a=>!0,a=>a),new M.$vM("title","Interactive editor title",a=>!0,a=>a)],new M.$wM("Notebook and input URI",a=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const b=this.a.getEditorById(a.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri),notebookEditor:b.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(A,h,E,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:h,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(w.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,h){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$tdc=C}),define(Ae[237],Re([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(w.$9J.MainThreadIssueReporter)}async $getIssueReporterUri(A,h){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const g=await E.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(A,h){const E=A.identifier.value;return this.a.set(E,h),this.b.$registerIssueUriRequestHandler(E),new M.$$J(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$zdc=C}),define(Ae[238],Re([1,0,6,3]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(M.$9J.MainThreadLabelService)}$registerResourceLabelFormatter(A){const h=this.b++;return this.a.$registerResourceLabelFormatter(h,A),(0,w.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(h)})}}e.$Mcc=C}),define(Ae[239],Re([1,0,2,24,8,7,78,3,15,44,18,16,280,21,20,6,91,88,55,59,9,13,26,149]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class i{constructor(T,K){this.d=T,this.e=K}async provideDocumentSymbols(T,K){const G=this.d.getDocument(T),Q=await this.e.provideDocumentSymbols(G,K);if(!(0,P.$Jb)(Q))return Q[0]instanceof F.$qK?Q.map(C.DocumentSymbol.from):i.f(Q)}static f(T){T=T.slice(0).sort((Q,H)=>{let _=Q.location.range.start.compareTo(H.location.range.start);return _===0&&(_=H.location.range.end.compareTo(Q.location.range.end)),_});const K=[],G=[];for(const Q of T){const H={name:Q.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Q.kind),tags:Q.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:C.Range.from(Q.location.range),selectionRange:C.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(H),K.push(H);break}const _=G[G.length-1];if(g.$ns.containsRange(_.range,H.range)&&!g.$ns.equalsRange(_.range,H.range)){_.children?.push(H),G.push(H);break}G.pop()}}return K}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(T,K,G){this.g=T,this.h=K,this.j=G,this.e=new c.$Abc("CodeLens"),this.f=new Map}async provideCodeLenses(T,K){const G=this.g.getDocument(T),Q=await this.j.provideCodeLenses(G,K);if(!Q||K.isCancellationRequested)return;const H=this.e.add(Q),_=new f.$Qc;this.f.set(H,_);const ae={cacheId:H,lenses:[]};for(let Fe=0;Fe<Q.length;Fe++)ae.lenses.push({cacheId:[H,Fe],range:C.Range.from(Q[Fe].range),command:this.h.toInternal(Q[Fe].command,_)});return ae}async resolveCodeLens(T,K){const G=T.cacheId&&this.e.get(...T.cacheId);if(!G)return;let Q;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.j.resolveCodeLens(G,K),Q||(Q=G),K.isCancellationRequested)return;const H=T.cacheId&&this.f.get(T.cacheId[0]);if(H)return T.command=this.h.toInternal(Q.command??o.d,H),T}releaseCodeLenses(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}}function y(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class ${constructor(T,K){this.d=T,this.e=K}async provideDefinition(T,K,G){const Q=this.d.getDocument(T),H=C.Position.to(K),_=await this.e.provideDefinition(Q,H,G);return y(_)}}class S{constructor(T,K){this.d=T,this.e=K}async provideDeclaration(T,K,G){const Q=this.d.getDocument(T),H=C.Position.to(K),_=await this.e.provideDeclaration(Q,H,G);return y(_)}}class I{constructor(T,K){this.d=T,this.e=K}async provideImplementation(T,K,G){const Q=this.d.getDocument(T),H=C.Position.to(K),_=await this.e.provideImplementation(Q,H,G);return y(_)}}class u{constructor(T,K){this.d=T,this.e=K}async provideTypeDefinition(T,K,G){const Q=this.d.getDocument(T),H=C.Position.to(K),_=await this.e.provideTypeDefinition(Q,H,G);return y(_)}}class d{constructor(T,K){this.d=T,this.e=K}async provideHover(T,K,G){const Q=this.d.getDocument(T),H=C.Position.to(K),_=await this.e.provideHover(Q,H,G);if(!(!_||(0,P.$Jb)(_.contents)))return _.range||(_.range=Q.getWordRangeAtPosition(H)),_.range||(_.range=new F.$aK(H,H)),C.Hover.from(_)}}class l{constructor(T,K){this.d=T,this.e=K}async provideEvaluatableExpression(T,K,G){const Q=this.d.getDocument(T),H=C.Position.to(K),_=await this.e.provideEvaluatableExpression(Q,H,G);if(_)return C.EvaluatableExpression.from(_)}}class R{constructor(T,K){this.d=T,this.e=K}async provideInlineValues(T,K,G,Q){const H=this.d.getDocument(T),_=await this.e.provideInlineValues(H,C.Range.to(K),C.InlineValueContext.to(G),Q);if(Array.isArray(_))return _.map(ae=>C.InlineValue.from(ae))}}class B{constructor(T,K){this.d=T,this.e=K}async provideDocumentHighlights(T,K,G){const Q=this.d.getDocument(T),H=C.Position.to(K),_=await this.e.provideDocumentHighlights(Q,H,G);if(Array.isArray(_))return _.map(C.DocumentHighlight.from)}}class V{constructor(T,K){this.d=T,this.e=K}async provideLinkedEditingRanges(T,K,G){const Q=this.d.getDocument(T),H=C.Position.to(K),_=await this.e.provideLinkedEditingRanges(Q,H,G);if(_&&Array.isArray(_.ranges))return{ranges:(0,P.$Gb)(_.ranges.map(C.Range.from)),wordPattern:_.wordPattern}}}class U{constructor(T,K){this.d=T,this.e=K}async provideReferences(T,K,G,Q){const H=this.d.getDocument(T),_=C.Position.to(K),ae=await this.e.provideReferences(H,_,G,Q);if(Array.isArray(ae))return ae.map(C.location.from)}}class W{static{this.d=1e3}constructor(T,K,G,Q,H,_,ae){this.g=T,this.h=K,this.j=G,this.k=Q,this.l=H,this.m=_,this.n=ae,this.e=new c.$Abc("CodeAction"),this.f=new Map}async provideCodeActions(T,K,G,Q){const H=this.g.getDocument(T),_=a.$ps.isISelection(K)?C.Selection.to(K):C.Range.to(K),ae=[];for(const Xe of this.j.getDiagnostics(T))if(_.intersection(Xe.range)&&ae.push(Xe)>W.d)break;const Fe={diagnostics:ae,only:G.only?new F.$sK(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},Ue=await this.k.provideCodeActions(H,_,Fe,Q);if(!(0,P.$Kb)(Ue)||Q.isCancellationRequested)return;const Qe=this.e.add(Ue),Je=new f.$Qc;this.f.set(Qe,Je);const xe=[];for(let Xe=0;Xe<Ue.length;Xe++){const _e=Ue[Xe];_e&&(W.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),xe.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,Je)})):(Fe.only&&(_e.kind?Fe.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),xe.push({cacheId:[Qe,Xe],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,Je),diagnostics:_e.diagnostics&&_e.diagnostics.map(C.Diagnostic.from),edit:_e.edit&&C.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,isAI:(0,r.$8E)(this.m,"codeActionAI")?_e.isAI:!1,disabled:_e.disabled?.reason})))}return{cacheId:Qe,actions:xe}}async resolveCodeAction(T,K){const[G,Q]=T,H=this.e.get(G,Q);if(!H||W.o(H))return{};if(!this.k.resolveCodeAction)return{};const _=await this.k.resolveCodeAction(H,K)??H;let ae;_.edit&&(ae=C.WorkspaceEdit.from(_.edit,void 0));let Fe;if(_.command){const Ue=this.f.get(G);Ue&&(Fe=this.h.toInternal(_.command,Ue))}return{edit:ae,command:Fe}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}class N{static toInternalProviderId(T,K){return T+"."+K}constructor(T,K,G,Q,H){this.d=T,this.e=K,this.f=G,this.g=Q,this.h=H}async prepareDocumentPaste(T,K,G,Q){if(!this.f.prepareDocumentPaste)return;const H=this.e.getDocument(T),_=K.map(Ue=>C.Range.to(Ue)),ae=C.DataTransfer.toDataTransfer(G,()=>{throw new D.$0});if(await this.f.prepareDocumentPaste(H,_,ae,Q),Q.isCancellationRequested)return;const Fe=Array.from(ae).filter(([,Ue])=>!(Ue instanceof F.$YK));return C.DataTransfer.from(Fe)}async providePasteEdits(T,K,G,Q,H){if(!this.f.provideDocumentPasteEdits)return;const _=this.e.getDocument(K),ae=G.map(Qe=>C.Range.to(Qe)),Fe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolvePasteFileData(this.g,T,Qe)).buffer),Ue=await this.f.provideDocumentPasteEdits(_,ae,Fe,H);if(Ue)return{label:Ue.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:N.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class O{constructor(T,K){this.d=T,this.e=K}async provideDocumentFormattingEdits(T,K,G){const Q=this.d.getDocument(T),H=await this.e.provideDocumentFormattingEdits(Q,K,G);if(Array.isArray(H))return H.map(C.TextEdit.from)}}class ee{constructor(T,K){this.d=T,this.e=K}async provideDocumentRangeFormattingEdits(T,K,G,Q){const H=this.d.getDocument(T),_=C.Range.to(K),ae=await this.e.provideDocumentRangeFormattingEdits(H,_,G,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,K,G,Q){(0,k.$Hf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const H=this.d.getDocument(T),_=K.map(C.Range.to),ae=await this.e.provideDocumentRangesFormattingEdits(H,_,G,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}}class Z{constructor(T,K){this.d=T,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,K,G,Q,H){const _=this.d.getDocument(T),ae=C.Position.to(K),Fe=await this.e.provideOnTypeFormattingEdits(_,ae,G,Q,H);if(Array.isArray(Fe))return Fe.map(C.TextEdit.from)}}class ye{constructor(T,K){this.e=T,this.f=K,this.d=new c.$Abc("WorkspaceSymbols")}async provideWorkspaceSymbols(T,K){const G=await this.e.provideWorkspaceSymbols(T,K);if(!(0,P.$Kb)(G))return{symbols:[]};const Q=this.d.add(G),H={cacheId:Q,symbols:[]};for(let _=0;_<G.length;_++){const ae=G[_];if(!ae||!ae.name){this.f.warn("INVALID SymbolInformation",ae);continue}H.symbols.push({...C.WorkspaceSymbol.from(ae),cacheId:[Q,_]})}return H}async resolveWorkspaceSymbol(T,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const G=this.d.get(...T.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,K);return Q&&(0,M.$2m)(T,C.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class De{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,K,G){this.d=T,this.e=K,this.f=G}async provideRenameEdits(T,K,G,Q){const H=this.d.getDocument(T),_=C.Position.to(K);try{const ae=await this.e.provideRenameEdits(H,_,G,Q);return ae?C.WorkspaceEdit.from(ae):void 0}catch(ae){const Fe=De.g(ae);return Fe?{rejectReason:Fe,edits:void 0}:Promise.reject(ae)}}async resolveRenameLocation(T,K,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(T),H=C.Position.to(K);try{const _=await this.e.prepareRename(Q,H,G);let ae,Fe;if(F.$aK.isRange(_)?(ae=_,Fe=Q.getText(_)):(0,k.$zf)(_)&&(ae=_.range,Fe=_.placeholder),!ae||!Fe)return;if(ae.start.line>H.line||ae.end.line<H.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ae),text:Fe}}catch(_){const ae=De.g(_);return ae?{rejectReason:ae,range:void 0,text:void 0}:Promise.reject(_)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class Pe{constructor(T,K){this.resultId=T,this.tokens=K}}class X{constructor(T,K){this.f=T,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,K,G){const Q=this.f.getDocument(T),H=K!==0?this.d.get(K):null;let _=typeof H?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,H.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return H&&this.d.delete(K),_?(_=X.h(_),this.o(X.n(H,_),_)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return X.j(T)?X.k(T)?T:new F.$pL(new Uint32Array(T.data),T.resultId):X.l(T)?X.m(T)?T:new F.$rL(T.edits.map(K=>new F.$qL(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const K of T.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(T,K){if(!X.j(K)||!T||!T.tokens)return K;const G=T.tokens,Q=G.length,H=K.data,_=H.length;let ae=0;const Fe=Math.min(Q,_);for(;ae<Fe&&G[ae]===H[ae];)ae++;if(ae===Q&&ae===_)return new F.$rL([],K.resultId);let Ue=0;const Qe=Fe-ae;for(;Ue<Qe&&G[Q-Ue-1]===H[_-Ue-1];)Ue++;return new F.$rL([{start:ae,deleteCount:Q-ae-Ue,data:H.subarray(ae,_-Ue)}],K.resultId)}o(T,K){if(X.j(T)){const G=this.e++;return this.d.set(G,new Pe(T.resultId,T.data)),(0,t.$K0)({id:G,type:"full",data:T.data})}if(X.l(T)){const G=this.e++;return X.j(K)?this.d.set(G,new Pe(K.resultId,K.data)):this.d.set(G,new Pe(T.resultId)),(0,t.$K0)({id:G,type:"delta",deltas:(T.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class le{constructor(T,K){this.d=T,this.e=K}async provideDocumentRangeSemanticTokens(T,K,G){const Q=this.d.getDocument(T),H=await this.e.provideDocumentRangeSemanticTokens(Q,C.Range.to(K),G);return H?this.f(H):null}f(T){return(0,t.$K0)({id:0,type:"full",data:T.data})}}class Ee{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,K,G,Q,H){this.f=T,this.g=K,this.h=G,this.j=Q,this.k=H,this.d=new c.$Abc("CompletionItem"),this.e=new Map}async provideCompletionItems(T,K,G,Q){const H=this.f.getDocument(T),_=C.Position.to(K),ae=H.getWordRangeAtPosition(_)||new F.$aK(_,_),Fe=ae.with({end:_}),Ue=new v.$Id,Qe=await this.h.provideCompletionItems(H,_,Q,C.CompletionContext.to(G));if(!Qe||Q.isCancellationRequested)return;const Je=Array.isArray(Qe)?new F.$FK(Qe):Qe,xe=Ee.supportsResolving(this.h)?this.d.add(Je.items):this.d.add([]),Xe=new f.$Qc;this.e.set(xe,Xe);const _e=[],it={x:xe,b:_e,a:{replace:C.Range.from(ae),insert:C.Range.from(Fe)},c:Je.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<Je.items.length;tt++){const ze=Je.items[tt],st=this.l(ze,[xe,tt],Fe,ae);_e.push(st)}return it}async resolveCompletionItem(T,K){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...T);if(!G)return;const Q=this.l(G,T),H=await this.h.resolveCompletionItem(G,K);if(!H)return;const _=this.l(H,T);return(Q.h!==_.h||Q.i!==_.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==_.n||Q.o!==_.o||!(0,M.$3m)(Q.p,_.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:_.d,c:_.c,l:_.l,h:_.h,i:_.i,n:_.n,o:_.o,p:_.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,K,G,Q){const H=this.e.get(K[0]);if(!H)throw Error("DisposableStore is missing...");const _=this.g.toInternal(T.command,H),ae={x:K,a:T.label,b:T.kind!==void 0?C.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(C.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:C.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(C.TextEdit.from),n:_?.$ident,o:_?.id,p:_?.$ident?void 0:_?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=T.textEdit.newText):typeof T.insertText=="string"?ae.h=T.insertText:T.insertText instanceof F.$jK&&(ae.h=T.insertText.value,ae.i|=4);let Fe;return T.textEdit?Fe=T.textEdit.range:T.range&&(Fe=T.range),F.$aK.isRange(Fe)?ae.j=C.Range.from(Fe):Fe&&(!G?.isEqual(Fe.inserting)||!Q?.isEqual(Fe.replacing))&&(ae.j={insert:C.Range.from(Fe.inserting),replace:C.Range.from(Fe.replacing)}),ae}}class ce{async provideInlineCompletions(T,K,G,Q){}disposeCompletions(T){}handleDidShowCompletionItem(T,K,G){}handlePartialAccept(T,K,G){}}class $e extends ce{constructor(T,K,G,Q){super(),this.f=T,this.g=K,this.h=G,this.j=Q,this.d=new ie,this.e=(0,r.$8E)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:F.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:F.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$8E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,K,G,Q){const H=this.g.getDocument(T),_=C.Position.to(K),ae=await this.h.provideInlineCompletionItems(H,_,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!ae||Q.isCancellationRequested)return;const Fe=Array.isArray(ae)?ae:ae.items,Ue=this.e?Array.isArray(ae)?[]:ae.commands||[]:[],Qe=this.e&&!Array.isArray(ae)?ae.enableForwardStability:void 0;let Je;return{pid:this.d.createReferenceId({dispose(){Je?.dispose()},items:Fe}),items:Fe.map((Xe,_e)=>{let it;Xe.command&&(Je||(Je=new f.$Qc),it=this.j.toInternal(Xe.command,Je));const tt=Xe.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Xe.filterText,range:Xe.range?C.Range.from(Xe.range):void 0,command:it,idx:_e,completeBracketPairs:this.e?Xe.completeBracketPairs:!1}}),commands:Ue.map(Xe=>(Je||(Je=new f.$Qc),this.j.toInternal(Xe,Je))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,K,G){const Q=this.d.get(T)?.items[K];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,G)}handlePartialAccept(T,K,G){const Q=this.d.get(T)?.items[K];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,G)}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const K=this.e++;return this.d.set(K,T),K}disposeReferenceId(T){const K=this.d.get(T);return this.d.delete(T),K}get(T){return this.d.get(T)}}class z{constructor(T,K){this.e=T,this.f=K,this.d=new c.$Abc("SignatureHelp")}async provideSignatureHelp(T,K,G,Q){const H=this.e.getDocument(T),_=C.Position.to(K),ae=this.g(G),Fe=await this.f.provideSignatureHelp(H,_,Q,ae);if(Fe){const Ue=this.d.add([Fe]);return{...C.SignatureHelp.from(Fe),id:Ue}}}g(T){let K;if(T.activeSignatureHelp){const G=C.SignatureHelp.to(T.activeSignatureHelp),Q=this.d.get(T.activeSignatureHelp.id,0);Q?(K=Q,K.activeSignature=G.activeSignature,K.activeParameter=G.activeParameter):K=G}return{...T,activeSignatureHelp:K}}releaseSignatureHelp(T){this.d.delete(T)}}class q{constructor(T,K,G,Q,H){this.f=T,this.g=K,this.h=G,this.j=Q,this.k=H,this.d=new c.$Abc("InlayHints"),this.e=new Map}async provideInlayHints(T,K,G){const Q=this.f.getDocument(T),H=C.Range.to(K),_=await this.h.provideInlayHints(Q,H,G);if(!Array.isArray(_)||_.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${K}`);return}if(G.isCancellationRequested)return;const ae=this.d.add(_);this.e.set(ae,new f.$Qc);const Fe={hints:[],cacheId:ae};for(let Ue=0;Ue<_.length;Ue++)this.l(_[Ue],H)&&Fe.hints.push(this.m(_[Ue],[ae,Ue]));return this.j.trace(`[InlayHints] ${Fe.hints.length} inlay hints from '${this.k.identifier.value}' for ${K}`),Fe}async resolveInlayHint(T,K){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...T);if(!G)return;const Q=await this.h.resolveInlayHint(G,K);if(Q&&this.l(Q))return this.m(Q,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,K){return T.label.length===0||Array.isArray(T.label)&&T.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(K&&!K.contains(T.position))}m(T,K){const G=this.e.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:K,tooltip:C.MarkdownString.fromStrict(T.tooltip),position:C.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(C.TextEdit.from),kind:T.kind&&C.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?Q.label=T.label:Q.label=T.label.map(H=>{const _={label:H.value};return _.tooltip=C.MarkdownString.fromStrict(H.tooltip),F.$kK.isLocation(H.location)&&(_.location=C.location.from(H.location)),H.command&&(_.command=this.g.toInternal(H.command,G)),_}),Q}}class ue{constructor(T,K){this.e=T,this.f=K,this.d=new c.$Abc("DocumentLink")}async provideLinks(T,K){const G=this.e.getDocument(T),Q=await this.f.provideDocumentLinks(G,K);if(!(!Array.isArray(Q)||Q.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(ue.g).map(C.DocumentLink.from)};{const H=this.d.add(Q),_={links:[],cacheId:H};for(let ae=0;ae<Q.length;ae++){if(!ue.g(Q[ae]))continue;const Fe=C.DocumentLink.from(Q[ae]);Fe.cacheId=[H,ae],_.links.push(Fe)}return _}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,K){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...T);if(!G)return;const Q=await this.f.resolveDocumentLink(G,K);if(!(!Q||!ue.g(Q)))return C.DocumentLink.from(Q)}releaseLinks(T){this.d.delete(T)}}class we{constructor(T,K){this.d=T,this.e=K}async provideColors(T,K){const G=this.d.getDocument(T),Q=await this.e.provideDocumentColors(G,K);return Array.isArray(Q)?Q.map(_=>({color:C.Color.from(_.color),range:C.Range.from(_.range)})):[]}async provideColorPresentations(T,K,G){const Q=this.d.getDocument(T),H=C.Range.to(K.range),_=C.Color.to(K.color),ae=await this.e.provideColorPresentations(_,{document:Q,range:H},G);if(Array.isArray(ae))return ae.map(C.ColorPresentation.from)}}class ve{constructor(T,K){this.d=T,this.e=K}async provideFoldingRanges(T,K,G){const Q=this.d.getDocument(T),H=await this.e.provideFoldingRanges(Q,K,G);if(Array.isArray(H))return H.map(C.FoldingRange.from)}}class me{constructor(T,K,G){this.d=T,this.e=K,this.f=G}async provideSelectionRanges(T,K,G){const Q=this.d.getDocument(T),H=K.map(C.Position.to),_=await this.e.provideSelectionRanges(Q,H,G);if(!(0,P.$Kb)(_))return[];if(_.length!==H.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ae=[];for(let Fe=0;Fe<H.length;Fe++){const Ue=[];ae.push(Ue);let Qe=H[Fe],Je=_[Fe];for(;;){if(!Je.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(C.SelectionRange.from(Je)),!Je.parent)break;Qe=Je.range,Je=Je.parent}}return ae}}class ke{constructor(T,K){this.f=T,this.g=K,this.d=new n.$cM(""),this.e=new Map}async prepareSession(T,K,G){const Q=this.f.getDocument(T),H=C.Position.to(K),_=await this.g.prepareCallHierarchy(Q,H,G);if(!_)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(_)?_.map(Fe=>this.h(ae,Fe)):[this.h(ae,_)]}async provideCallsTo(T,K,G){const Q=this.j(T,K);if(!Q)throw new Error("missing call hierarchy item");const H=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(H)return H.map(_=>({from:this.h(T,_.from),fromRanges:_.fromRanges.map(ae=>C.Range.from(ae))}))}async provideCallsFrom(T,K,G){const Q=this.j(T,K);if(!Q)throw new Error("missing call hierarchy item");const H=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(H)return H.map(_=>({to:this.h(T,_.to),fromRanges:_.fromRanges.map(ae=>C.Range.from(ae))}))}releaseSession(T){this.e.delete(T)}h(T,K){const G=this.e.get(T),Q=C.CallHierarchyItem.from(K,T,G.size.toString(36));return G.set(Q._itemId,K),Q}j(T,K){return this.e.get(T)?.get(K)}}class re{constructor(T,K){this.f=T,this.g=K,this.d=new n.$cM(""),this.e=new Map}async prepareSession(T,K,G){const Q=this.f.getDocument(T),H=C.Position.to(K),_=await this.g.prepareTypeHierarchy(Q,H,G);if(!_)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(_)?_.map(Fe=>this.h(ae,Fe)):[this.h(ae,_)]}async provideSupertypes(T,K,G){const Q=this.j(T,K);if(!Q)throw new Error("missing type hierarchy item");const H=await this.g.provideTypeHierarchySupertypes(Q,G);if(H)return H.map(_=>this.h(T,_))}async provideSubtypes(T,K,G){const Q=this.j(T,K);if(!Q)throw new Error("missing type hierarchy item");const H=await this.g.provideTypeHierarchySubtypes(Q,G);if(H)return H.map(_=>this.h(T,_))}releaseSession(T){this.e.delete(T)}h(T,K){const G=this.e.get(T),Q=C.TypeHierarchyItem.from(K,T,G.size.toString(36));return G.set(Q._itemId,K),Q}j(T,K){return this.e.get(T)?.get(K)}}class he{static toInternalProviderId(T,K){return T+"."+K}constructor(T,K,G,Q,H){this.d=T,this.e=K,this.f=G,this.g=Q,this.h=H}async provideDocumentOnDropEdits(T,K,G,Q,H){const _=this.e.getDocument(K),ae=C.Position.to(G),Fe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,Qe)).buffer),Ue=await this.f.provideDocumentDropEdits(_,ae,Fe,H);if(Ue)return{label:Ue.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:he.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class se{constructor(T,K){this.d=T,this.e=K}async provideMappedEdits(T,K,G,Q){const H=w.URI.revive(T),_=this.d.getDocument(H),ae=G.documents.map(Qe=>Qe.map(Je=>({uri:w.URI.revive(Je.uri),version:Je.version,ranges:Je.ranges.map(xe=>C.Range.to(xe))}))),Fe={documents:ae,selections:ae[0]?.[0]?.ranges??[]},Ue=await this.e.provideMappedEdits(_,K,Fe,Q);return Ue?C.WorkspaceEdit.from(Ue):null}}class oe{constructor(T,K){this.adapter=T,this.extension=K}}class de{static{this.d=0}constructor(T,K,G,Q,H,_,ae,Fe){this.g=K,this.h=G,this.j=Q,this.k=H,this.l=_,this.m=ae,this.n=Fe,this.f=new Map,this.e=T.getProxy(h.$9J.MainThreadLanguageFeatures)}o(T,K){return C.DocumentSelector.from(T,this.g,K)}p(T){return new F.$$J(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return de.d++}async s(T,K,G,Q,H,_=!1){const ae=this.f.get(T);if(!ae||!(ae.adapter instanceof K))return Q;const Fe=Date.now();_||this.l.trace(`[${ae.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(ae.adapter,ae.extension);return Promise.resolve(Ue).catch(Qe=>{(0,D.$3)(Qe)||(this.l.error(`[${ae.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ae.extension.identifier,Qe))}).finally(()=>{_||this.l.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-Fe}ms`)}),b.CancellationToken.isCancellationToken(H)?(0,p.$Ig)(Ue,H):Ue}t(T,K){const G=this.q();return this.f.set(G,new oe(T,K)),G}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,K,G,Q){const H=this.t(new i(this.h,G),T),_=Q&&Q.label||de.u(T);return this.e.$registerDocumentSymbolProvider(H,this.o(K,T),_),this.p(H)}$provideDocumentSymbols(T,K,G){return this.s(T,i,Q=>Q.provideDocumentSymbols(w.URI.revive(K),G),void 0,G)}registerCodeLensProvider(T,K,G){const Q=this.q(),H=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new oe(new o(this.h,this.j.converter,G),T)),this.e.$registerCodeLensSupport(Q,this.o(K,T),H);let _=this.p(Q);if(H!==void 0){const ae=G.onDidChangeCodeLenses(Fe=>this.e.$emitCodeLensEvent(H));_=F.$$J.from(_,ae)}return _}$provideCodeLenses(T,K,G){return this.s(T,o,Q=>Q.provideCodeLenses(w.URI.revive(K),G),void 0,G)}$resolveCodeLens(T,K,G){return this.s(T,o,Q=>Q.resolveCodeLens(K,G),void 0,void 0)}$releaseCodeLenses(T,K){this.s(T,o,G=>Promise.resolve(G.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(T,K,G){const Q=this.t(new $(this.h,G),T);return this.e.$registerDefinitionSupport(Q,this.o(K,T)),this.p(Q)}$provideDefinition(T,K,G,Q){return this.s(T,$,H=>H.provideDefinition(w.URI.revive(K),G,Q),[],Q)}registerDeclarationProvider(T,K,G){const Q=this.t(new S(this.h,G),T);return this.e.$registerDeclarationSupport(Q,this.o(K,T)),this.p(Q)}$provideDeclaration(T,K,G,Q){return this.s(T,S,H=>H.provideDeclaration(w.URI.revive(K),G,Q),[],Q)}registerImplementationProvider(T,K,G){const Q=this.t(new I(this.h,G),T);return this.e.$registerImplementationSupport(Q,this.o(K,T)),this.p(Q)}$provideImplementation(T,K,G,Q){return this.s(T,I,H=>H.provideImplementation(w.URI.revive(K),G,Q),[],Q)}registerTypeDefinitionProvider(T,K,G){const Q=this.t(new u(this.h,G),T);return this.e.$registerTypeDefinitionSupport(Q,this.o(K,T)),this.p(Q)}$provideTypeDefinition(T,K,G,Q){return this.s(T,u,H=>H.provideTypeDefinition(w.URI.revive(K),G,Q),[],Q)}registerHoverProvider(T,K,G,Q){const H=this.t(new d(this.h,G),T);return this.e.$registerHoverProvider(H,this.o(K,T)),this.p(H)}$provideHover(T,K,G,Q){return this.s(T,d,H=>H.provideHover(w.URI.revive(K),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(T,K,G,Q){const H=this.t(new l(this.h,G),T);return this.e.$registerEvaluatableExpressionProvider(H,this.o(K,T)),this.p(H)}$provideEvaluatableExpression(T,K,G,Q){return this.s(T,l,H=>H.provideEvaluatableExpression(w.URI.revive(K),G,Q),void 0,Q)}registerInlineValuesProvider(T,K,G,Q){const H=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,_=this.t(new R(this.h,G),T);this.e.$registerInlineValuesProvider(_,this.o(K,T),H);let ae=this.p(_);if(H!==void 0){const Fe=G.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(H));ae=F.$$J.from(ae,Fe)}return ae}$provideInlineValues(T,K,G,Q,H){return this.s(T,R,_=>_.provideInlineValues(w.URI.revive(K),G,Q,H),void 0,H)}registerDocumentHighlightProvider(T,K,G){const Q=this.t(new B(this.h,G),T);return this.e.$registerDocumentHighlightProvider(Q,this.o(K,T)),this.p(Q)}$provideDocumentHighlights(T,K,G,Q){return this.s(T,B,H=>H.provideDocumentHighlights(w.URI.revive(K),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(T,K,G){const Q=this.t(new V(this.h,G),T);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(K,T)),this.p(Q)}$provideLinkedEditingRanges(T,K,G,Q){return this.s(T,V,async H=>{const _=await H.provideLinkedEditingRanges(w.URI.revive(K),G,Q);if(_)return{ranges:_.ranges,wordPattern:_.wordPattern?de.w(_.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(T,K,G){const Q=this.t(new U(this.h,G),T);return this.e.$registerReferenceSupport(Q,this.o(K,T)),this.p(Q)}$provideReferences(T,K,G,Q,H){return this.s(T,U,_=>_.provideReferences(w.URI.revive(K),G,Q,H),void 0,H)}registerCodeActionProvider(T,K,G,Q){const H=new f.$Qc,_=this.t(new W(this.h,this.j.converter,this.k,G,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(_,this.o(K,T),{providedKinds:Q?.providedCodeActionKinds?.map(ae=>ae.value),documentation:Q?.documentation?.map(ae=>({kind:ae.kind.value,command:this.j.converter.toInternal(ae.command,H)}))},de.u(T),!!G.resolveCodeAction),H.add(this.p(_)),H}$provideCodeActions(T,K,G,Q,H){return this.s(T,W,_=>_.provideCodeActions(w.URI.revive(K),G,Q,H),void 0,H)}$resolveCodeAction(T,K,G){return this.s(T,W,Q=>Q.resolveCodeAction(K,G),{},void 0)}$releaseCodeActions(T,K){this.s(T,W,G=>Promise.resolve(G.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(T,K,G){const Q=this.t(new O(this.h,G),T);return this.e.$registerDocumentFormattingSupport(Q,this.o(K,T),T.identifier,T.displayName||T.name),this.p(Q)}$provideDocumentFormattingEdits(T,K,G,Q){return this.s(T,O,H=>H.provideDocumentFormattingEdits(w.URI.revive(K),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(T,K,G){const Q=typeof G.provideDocumentRangesFormattingEdits=="function",H=this.t(new ee(this.h,G),T);return this.e.$registerRangeFormattingSupport(H,this.o(K,T),T.identifier,T.displayName||T.name,Q),this.p(H)}$provideDocumentRangeFormattingEdits(T,K,G,Q,H){return this.s(T,ee,_=>_.provideDocumentRangeFormattingEdits(w.URI.revive(K),G,Q,H),void 0,H)}$provideDocumentRangesFormattingEdits(T,K,G,Q,H){return this.s(T,ee,_=>_.provideDocumentRangesFormattingEdits(w.URI.revive(K),G,Q,H),void 0,H)}registerOnTypeFormattingEditProvider(T,K,G,Q){const H=this.t(new Z(this.h,G),T);return this.e.$registerOnTypeFormattingSupport(H,this.o(K,T),Q,T.identifier),this.p(H)}$provideOnTypeFormattingEdits(T,K,G,Q,H,_){return this.s(T,Z,ae=>ae.provideOnTypeFormattingEdits(w.URI.revive(K),G,Q,H,_),void 0,_)}registerWorkspaceSymbolProvider(T,K){const G=this.t(new ye(K,this.l),T);return this.e.$registerNavigateTypeSupport(G,typeof K.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(T,K,G){return this.s(T,ye,Q=>Q.provideWorkspaceSymbols(K,G),{symbols:[]},G)}$resolveWorkspaceSymbol(T,K,G){return this.s(T,ye,Q=>Q.resolveWorkspaceSymbol(K,G),void 0,void 0)}$releaseWorkspaceSymbols(T,K){this.s(T,ye,G=>G.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(T,K,G){const Q=this.t(new De(this.h,G,this.l),T);return this.e.$registerRenameSupport(Q,this.o(K,T),De.supportsResolving(G)),this.p(Q)}$provideRenameEdits(T,K,G,Q,H){return this.s(T,De,_=>_.provideRenameEdits(w.URI.revive(K),G,Q,H),void 0,H)}$resolveRenameLocation(T,K,G,Q){return this.s(T,De,H=>H.resolveRenameLocation(w.URI.revive(K),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(T,K,G,Q){const H=this.t(new X(this.h,G),T),_=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(H,this.o(K,T),Q,_);let ae=this.p(H);if(_){const Fe=G.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(_));ae=F.$$J.from(ae,Fe)}return ae}$provideDocumentSemanticTokens(T,K,G,Q){return this.s(T,X,H=>H.provideDocumentSemanticTokens(w.URI.revive(K),G,Q),null,Q)}$releaseDocumentSemanticTokens(T,K){this.s(T,X,G=>G.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,K,G,Q){const H=this.t(new le(this.h,G),T);return this.e.$registerDocumentRangeSemanticTokensProvider(H,this.o(K,T),Q),this.p(H)}$provideDocumentRangeSemanticTokens(T,K,G,Q){return this.s(T,le,H=>H.provideDocumentRangeSemanticTokens(w.URI.revive(K),G,Q),null,Q)}registerCompletionItemProvider(T,K,G,Q){const H=this.t(new Ee(this.h,this.j.converter,G,this.m,T),T);return this.e.$registerCompletionsProvider(H,this.o(K,T),Q,Ee.supportsResolving(G),T.identifier),this.p(H)}$provideCompletionItems(T,K,G,Q,H){return this.s(T,Ee,_=>_.provideCompletionItems(w.URI.revive(K),G,Q,H),void 0,H)}$resolveCompletionItem(T,K,G){return this.s(T,Ee,Q=>Q.resolveCompletionItem(K,G),void 0,G)}$releaseCompletionItems(T,K){this.s(T,Ee,G=>G.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(T,K,G,Q){const H=new $e(T,this.h,G,this.j.converter),_=this.t(H,T);return this.e.$registerInlineCompletionsSupport(_,this.o(K,T),H.supportsHandleEvents,m.$Yl.toKey(T.identifier.value),Q?.yieldTo?.map(ae=>m.$Yl.toKey(ae))||[]),this.p(_)}$provideInlineCompletions(T,K,G,Q,H){return this.s(T,ce,_=>_.provideInlineCompletions(w.URI.revive(K),G,Q,H),void 0,H)}$handleInlineCompletionDidShow(T,K,G,Q){this.s(T,ce,async H=>{H.handleDidShowCompletionItem(K,G,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,K,G,Q){this.s(T,ce,async H=>{H.handlePartialAccept(K,G,Q)},void 0,void 0)}$freeInlineCompletionsList(T,K){this.s(T,ce,async G=>{G.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(T,K,G,Q){const H=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,_=this.t(new z(this.h,G),T);return this.e.$registerSignatureHelpProvider(_,this.o(K,T),H),this.p(_)}$provideSignatureHelp(T,K,G,Q,H){return this.s(T,z,_=>_.provideSignatureHelp(w.URI.revive(K),G,Q,H),void 0,H)}$releaseSignatureHelp(T,K){this.s(T,z,G=>G.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(T,K,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,H=this.t(new q(this.h,this.j.converter,G,this.l,T),T);this.e.$registerInlayHintsProvider(H,this.o(K,T),typeof G.resolveInlayHint=="function",Q,de.u(T));let _=this.p(H);if(Q!==void 0){const ae=G.onDidChangeInlayHints(Fe=>this.e.$emitInlayHintsEvent(Q));_=F.$$J.from(_,ae)}return _}$provideInlayHints(T,K,G,Q){return this.s(T,q,H=>H.provideInlayHints(w.URI.revive(K),G,Q),void 0,Q)}$resolveInlayHint(T,K,G){return this.s(T,q,Q=>Q.resolveInlayHint(K,G),void 0,G)}$releaseInlayHints(T,K){this.s(T,q,G=>G.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(T,K,G){const Q=this.t(new ue(this.h,G),T);return this.e.$registerDocumentLinkProvider(Q,this.o(K,T),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(T,K,G){return this.s(T,ue,Q=>Q.provideLinks(w.URI.revive(K),G),void 0,G,K.scheme==="output")}$resolveDocumentLink(T,K,G){return this.s(T,ue,Q=>Q.resolveLink(K,G),void 0,void 0,!0)}$releaseDocumentLinks(T,K){this.s(T,ue,G=>G.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(T,K,G){const Q=this.t(new we(this.h,G),T);return this.e.$registerDocumentColorProvider(Q,this.o(K,T)),this.p(Q)}$provideDocumentColors(T,K,G){return this.s(T,we,Q=>Q.provideColors(w.URI.revive(K),G),[],G)}$provideColorPresentations(T,K,G,Q){return this.s(T,we,H=>H.provideColorPresentations(w.URI.revive(K),G,Q),void 0,Q)}registerFoldingRangeProvider(T,K,G){const Q=this.q(),H=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new oe(new ve(this.h,G),T)),this.e.$registerFoldingRangeProvider(Q,this.o(K,T),T.identifier,H);let _=this.p(Q);if(H!==void 0){const ae=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(H));_=F.$$J.from(_,ae)}return _}$provideFoldingRanges(T,K,G,Q){return this.s(T,ve,H=>H.provideFoldingRanges(w.URI.revive(K),G,Q),void 0,Q)}registerSelectionRangeProvider(T,K,G){const Q=this.t(new me(this.h,G,this.l),T);return this.e.$registerSelectionRangeProvider(Q,this.o(K,T)),this.p(Q)}$provideSelectionRanges(T,K,G,Q){return this.s(T,me,H=>H.provideSelectionRanges(w.URI.revive(K),G,Q),[],Q)}registerCallHierarchyProvider(T,K,G){const Q=this.t(new ke(this.h,G),T);return this.e.$registerCallHierarchyProvider(Q,this.o(K,T)),this.p(Q)}$prepareCallHierarchy(T,K,G,Q){return this.s(T,ke,H=>Promise.resolve(H.prepareSession(w.URI.revive(K),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(T,K,G,Q){return this.s(T,ke,H=>H.provideCallsTo(K,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(T,K,G,Q){return this.s(T,ke,H=>H.provideCallsFrom(K,G,Q),void 0,Q)}$releaseCallHierarchy(T,K){this.s(T,ke,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(T,K,G){const Q=this.t(new re(this.h,G),T);return this.e.$registerTypeHierarchyProvider(Q,this.o(K,T)),this.p(Q)}$prepareTypeHierarchy(T,K,G,Q){return this.s(T,re,H=>Promise.resolve(H.prepareSession(w.URI.revive(K),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(T,K,G,Q){return this.s(T,re,H=>H.provideSupertypes(K,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(T,K,G,Q){return this.s(T,re,H=>H.provideSubtypes(K,G,Q),void 0,Q)}$releaseTypeHierarchy(T,K){this.s(T,re,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(T,K,G,Q){const H=this.q();this.f.set(H,new oe(new he(this.e,this.h,G,H,T),T));const _=(0,r.$8E)(T,"dropMetadata")&&Q?he.toInternalProviderId(T.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(H,this.o(K,T),_,(0,r.$8E)(T,"dropMetadata")?Q:void 0),this.p(H)}$provideDocumentOnDropEdits(T,K,G,Q,H,_){return this.s(T,he,ae=>Promise.resolve(ae.provideDocumentOnDropEdits(K,w.URI.revive(G),Q,H,_)),void 0,void 0)}registerMappedEditsProvider(T,K,G){const Q=this.t(new se(this.h,G),T);return this.e.$registerMappedEditsProvider(Q,this.o(K,T)),this.p(Q)}$provideMappedEdits(T,K,G,Q,H){return this.s(T,se,_=>Promise.resolve(_.provideMappedEdits(K,G,Q,H)),null,H)}registerDocumentPasteEditProvider(T,K,G,Q){const H=this.q();this.f.set(H,new oe(new N(this.e,this.h,G,H,T),T));const _=N.toInternalProviderId(T.identifier.value,Q.id);return this.e.$registerPasteEditProvider(H,this.o(K,T),_,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(H)}$prepareDocumentPaste(T,K,G,Q,H){return this.s(T,N,_=>_.prepareDocumentPaste(w.URI.revive(K),G,Q,H),void 0,H)}$providePasteEdits(T,K,G,Q,H,_){return this.s(T,N,ae=>ae.providePasteEdits(K,w.URI.revive(G),Q,H,_),void 0,_)}static w(T){return{pattern:T.source,flags:T.flags}}static y(T){return{decreaseIndentPattern:de.w(T.decreaseIndentPattern),increaseIndentPattern:de.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?de.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?de.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:de.w(T.beforeText),afterText:T.afterText?de.w(T.afterText):void 0,previousLineText:T.previousLineText?de.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(de.z)}static C(T){return{open:T.open,close:T.close,notIn:T.notIn?T.notIn.map(K=>F.SyntaxTokenType.toString(K)):void 0}}static D(T){return T.map(de.C)}setLanguageConfiguration(T,K,G){const{wordPattern:Q}=G;if(Q&&(0,E.$Ne)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(K,Q):this.h.setWordDefinitionFor(K,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const H=this.q(),_={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?de.w(G.wordPattern):void 0,indentationRules:G.indentationRules?de.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?de.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?de.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(H,K,_),this.p(H)}$setWordDefinitions(T){for(const K of T)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$Jbc=de}),define(Ae[240],Re([1,0,3,8,7,29,13,6]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class E{constructor(P,k,a,b){this.c=k,this.d=a,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(w.$9J.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,k){await this.a.$changeLanguage(P,k);const a=this.c.getDocumentData(P);if(!a)throw new Error(`document '${P.toString()}' NOT found`);return a.document}async tokenAtPosition(P,k){const a=P.version,b=M.Position.from(k),m=await this.a.$tokensAtPosition(P.uri,b),f={type:C.StandardTokenType.Other,range:P.getWordRangeAtPosition(k)??new C.$aK(k.line,k.character,k.line,k.character)};if(!m)return f;const t={range:M.Range.to(m.range),type:M.TokenType.to(m.type)};return!t.range.contains(k)||a!==P.version?f:t}createLanguageStatusItem(P,k,a){const b=this.f++,m=this.a,f=this.g,t=`${P.identifier.value}/${k}`;if(f.has(t))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);f.add(t);const n={selector:a,id:k,name:P.displayName??P.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const v=new h.$Qc,D=()=>{if(c?.dispose(),!f.has(t)){console.warn(`LanguageStatusItem (${k}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$Ug)(()=>{v.clear(),this.a.$setLanguageStatus(b,{id:t,name:n.name??P.displayName??P.name,source:P.displayName??P.name,selector:M.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===C.LanguageStatusSeverity.Error?F.default.Error:n.severity===C.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:n.command&&this.d.toInternal(n.command,v),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},p={dispose(){v.dispose(),c?.dispose(),m.$removeLanguageStatus(b),f.delete(t)},get id(){return n.id},get name(){return n.name},set name(r){n.name=r,D()},get selector(){return n.selector},set selector(r){n.selector=r,D()},get text(){return n.text},set text(r){n.text=r,D()},get detail(){return n.detail},set detail(r){n.detail=r,D()},get severity(){return n.severity},set severity(r){n.severity=r,D()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(r){n.accessibilityInformation=r,D()},get command(){return n.command},set command(r){n.command=r,D()},get busy(){return n.busy},set busy(r){n.busy=r,D()}};return D(),p}}e.$rcc=E}),define(Ae[81],Re([1,0,22,15,2,4,14,3,27,17]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=e.$gcc=void 0;let P=class{constructor(a,b,m){this.f=m,this.d=new Map,this.a=b.getProxy(h.$9J.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===w.$g}getMessage(a,b){const{message:m,args:f,comment:t}=b;if(this.c)return(0,M.$Ce)(m,f??{});let n=m;t&&t.length>0&&(n+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(a)?.contents[n];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${n}`),(0,M.$Ce)(c??m,f??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let b;const m=await this.g(a);if(!m){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(m),t=JSON.parse(f);b=a.isBuiltin?t.contents?.bundle:t}catch(f){this.f.error(`Failed to load translations for ${a.identifier.value} from ${m}: ${f.message}`);return}b&&this.d.set(a.identifier.value,{contents:b,uri:m})}async g(a){if(a.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return C.URI.revive(b)}return a.l10n?C.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$gcc=P,e.$gcc=P=Ke([Ve(0,E.$nM),Ve(1,g.$0L),Ve(2,A.$8i)],P),e.$hcc=(0,F.$Nh)("IExtHostLocalizationService")}),define(Ae[241],Re([1,0,14,3,27,17,2,68]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;let E=class extends w.$gj{constructor(k,a){super(a.logLevel,a.logsLocation,a.loggers.map(b=>(0,h.$kh)(b))),this.r=k.getProxy(M.$9J.MainThreadLogger)}$setLogLevel(k,a){a?this.setLogLevel(A.URI.revive(a),k):this.setLogLevel(k)}setVisibility(k,a){super.setVisibility(k,a),this.r.$setVisibility(k,a)}s(k,a,b){return new g(this.r,k,a,b)}};e.$Hdc=E,e.$Hdc=E=Ke([Ve(0,F.$0L),Ve(1,C.$nM)],E);class g extends w.$bj{constructor(k,a,b,m){super(m?.logLevel==="always"),this.r=k,this.s=a,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(a,m).then(()=>{this.u(this.n),this.m=!0})}g(k,a){const b=[[k,a]];this.m?this.u(b):this.n.push(...b)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,25]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=void 0,e.$icc=(0,M.$Nh)("IExtHostManagedSockets");let h=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(w.$9J.MainThreadManagedSockets)}setFactory(k,a){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(k,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const a=++this.b,b=await this.c.makeConnection(),m=new C.$Qc;return this.d.set(a,new g(a,b,m)),m.add((0,C.$Pc)(()=>this.d.delete(a))),m.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),m.dispose()})),m.add(b.onDidClose(f=>{this.a.$onDidManagedSocketClose(a,f?.stack??f?.message),m.dispose()})),m.add(b.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(a,A.$ae.wrap(f)))),a}$remoteSocketWrite(k,a){this.d.get(k)?.actual.send(a.buffer)}$remoteSocketEnd(k){const a=this.d.get(k);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$jcc=h,e.$jcc=h=Ke([Ve(0,F.$0L)],h);class E{constructor(k,a){this.socketFactoryId=k,this.makeConnection=a}}class g extends C.$Rc{constructor(k,a,b){super(),this.socketId=k,this.actual=a,this.B(b)}}}),define(Ae[242],Re([1,0,3,14,26]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;function F(h){return h&&h.title}let A=class{constructor(E,g){this.b=g,this.a=E.getProxy(w.$9J.MainThreadMessageService)}showMessage(E,g,P,k,a){const b={source:{identifier:E.identifier,label:E.displayName||E.name}};let m;typeof k=="string"||F(k)?m=[k,...a]:(b.modal=k?.modal,b.useCustom=k?.useCustom,b.detail=k?.detail,m=a),b.useCustom&&(0,C.$9E)(E,"resolvers");const f=[];for(let t=0;t<m.length;t++){const n=m[t];if(typeof n=="string")f.push({title:n,handle:t,isCloseAffordance:!1});else if(typeof n=="object"){const{title:c,isCloseAffordance:v}=n;f.push({title:c,isCloseAffordance:!!v,handle:t})}else this.b.warn("Invalid message item:",n)}return this.a.$showMessage(g,P,b,f).then(t=>{if(typeof t=="number")return m[t]})}};e.$scc=A,e.$scc=A=Ke([Ve(1,M.$8i)],A)}),define(Ae[243],Re([1,0,151,25,5,6,28,15,16,2,38,55,3,31,8,7,46,204,103,9,24,12]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(i=>i.apiEditor)}constructor(i,o,y,$,S){this.q=y,this.r=$,this.s=S,this.f=new Map,this.g=new A.$zc,this.h=new Map,this.j=new C.$Md({onListenerError:v.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Md({onListenerError:v.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Md({onListenerError:v.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Md({onListenerError:v.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$Abc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=i.getProxy(a.$9J.MainThreadNotebook),this.c=i.getProxy(a.$9J.MainThreadNotebookDocuments),this.d=i.getProxy(a.$9J.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===13){const u=I.notebookEditor?.notebookUri,d=I.cell.handle,R=this.g.get(u)?.getCell(d);if(R)return R.apiCell}if(I&&I.$mid===14){const u=I.uri,d=this.g.get(u);if(d)return d.apiNotebook}return I}}),r.A(o)}getEditorById(i){const o=this.h.get(i);if(!o)throw new Error(`unknown text editor: ${i}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(i){for(const[o,y]of this.h)if(y.apiEditor===i)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(i,o){const y=this.g.get(i);if(!y&&!o)throw new Error(`NO notebook document for '${i}'`);return y}static t(i,o){if(!o)return;const y=o.filenamePattern.map($=>m.NotebookExclusiveDocumentPattern.from($)).filter($=>$!==void 0);if(o.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:i.identifier,providerDisplayName:i.displayName||i.name,displayName:o.displayName,filenamePattern:y,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(i,o,y){const $=r.a++,S=typeof y.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set($,y),this.b.$registerNotebookCellStatusBarItemProvider($,S,o);let I;return S!==void 0&&(I=y.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(S))),new f.$$J(()=>{this.f.delete($),this.b.$unregisterNotebookCellStatusBarItemProvider($,S),I?.dispose()})}async createNotebookDocument(i){const o=await this.c.$tryCreateNotebook({viewType:i.viewType,content:i.content&&m.NotebookData.from(i.content)});return g.URI.revive(o)}async openNotebookDocument(i){const o=this.g.get(i);if(o)return o.apiNotebook;const y=await this.c.$tryOpenNotebook(i),$=this.g.get(g.URI.revive(y));return(0,E.$If)($?.apiNotebook)}async showNotebookDocument(i,o){g.URI.isUri(i)&&(i=await this.openNotebookDocument(i));let y;typeof o=="object"?y={position:m.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(m.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:y={preserveFocus:!1};const $=await this.d.$tryShowNotebookDocument(i.uri,i.notebookType,y),S=$&&this.h.get($)?.apiEditor;if(S)return S;throw $?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(i,o,y,$){const S=this.f.get(i),I=g.URI.revive(o),u=this.g.get(I);if(!u||!S)return;const d=u.getCellFromIndex(y);if(!d)return;const l=await S.provideCellStatusBarItems(d.apiCell,$);if(!l)return;const R=new F.$Qc,B=this.p.add([R]),U=(Array.isArray(l)?l:[l]).map(W=>m.NotebookStatusBarItem.from(W,this.i,R));return{cacheId:B,items:U}}$releaseNotebookCellStatusBarItems(i){this.p.delete(i)}registerNotebookSerializer(i,o,y,$,S){if((0,h.$Ae)(o))throw new Error("viewType cannot be empty or just whitespace");const I=this.u++;return this.w.set(I,{viewType:o,serializer:y,options:$}),this.b.$registerNotebookSerializer(I,{id:i.identifier,location:i.extensionLocation},o,m.NotebookDocumentContentOptions.from($),r.t(i,S)),(0,F.$Pc)(()=>{this.b.$unregisterNotebookSerializer(I)})}async $dataToNotebook(i,o,y){const $=this.w.get(i);if(!$)throw new Error("NO serializer found");const S=await $.serializer.deserializeNotebook(o.buffer,y);return new t.$jv(m.NotebookData.from(S))}async $notebookToData(i,o,y){const $=this.w.get(i);if(!$)throw new Error("NO serializer found");const S=await $.serializer.serializeNotebook(m.NotebookData.to(o.value),y);return M.$ae.wrap(S)}async $saveNotebook(i,o,y,$,S){const I=g.URI.revive(o),u=this.w.get(i);if(!u)throw new Error("NO serializer found");const d=this.g.get(I);if(!d)throw new Error("Document NOT found");if(d.versionId!==y)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(I.scheme))throw new P.$qk((0,w.localize)(0,null,this.y(I)),6);await this.x(I,$);const l={metadata:(0,D.$7m)(d.apiNotebook.metadata,W=>!(u.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of d.apiNotebook.getCells()){const N=new f.$wL(W.kind,W.document.getText(),W.document.languageId,W.mime,u.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);N.metadata=(0,D.$7m)(W.metadata,O=>!(u.options?.transientCellMetadata??{})[O]),l.cells.push(N)}const R=await u.serializer.serializeNotebook(l,S);await this.s.value.writeFile(I,R);const B=this.s.getFileSystemProviderExtUri(I.scheme),V=await this.s.value.stat(I);return{name:B.basename(I),isFile:(V.type&P.FileType.File)!==0,isDirectory:(V.type&P.FileType.Directory)!==0,isSymbolicLink:(V.type&P.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(I.scheme),locked:!!((V.permissions??0)&P.FilePermission.Locked),etag:P.$Bk({mtime:V.mtime,size:V.size}),children:void 0}}async x(i,o){const y=await this.s.value.stat(i);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==P.$Ak&&typeof y.mtime=="number"&&typeof y.size=="number"&&o.mtime<y.mtime&&o.etag!==P.$Bk({mtime:o.mtime,size:y.size}))throw new P.$qk((0,w.localize)(1,null),3,o)}y(i){return i.scheme===p.Schemas.file?i.fsPath:i.toString()}z(i,o,y){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const $=new c.$_cc(o,this.d,i,y.visibleRanges.map(m.NotebookRange.to),y.selections.map(m.NotebookRange.to),typeof y.viewColumn=="number"?m.ViewColumn.to(y.viewColumn):void 0);this.h.set(o,$)}$acceptDocumentAndEditorsDelta(i){if(i.value.removedDocuments)for(const y of i.value.removedDocuments){const $=g.URI.revive(y),S=this.g.get($);S&&(S.dispose(),this.g.delete($),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(I=>I.document.uri)}),this.n.fire(S.apiNotebook));for(const I of this.h.values())I.notebookData.uri.toString()===$.toString()&&this.h.delete(I.id)}if(i.value.addedDocuments){const y=[];for(const $ of i.value.addedDocuments){const S=g.URI.revive($.uri);if(this.g.has(S))throw new Error(`adding EXISTING notebook ${S} `);const I=new n.$$cc(this.c,this.q,this.r,S,$);y.push(...$.cells.map(u=>n.$0cc.asModelAddData(I.apiNotebook,u))),this.g.get(S)?.dispose(),this.g.set(S,I),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this.m.fire(I.apiNotebook)}}if(i.value.addedEditors)for(const y of i.value.addedEditors){if(this.h.has(y.id))return;const $=g.URI.revive(y.documentUri),S=this.g.get($);S&&this.z(S,y.id,y)}const o=[];if(i.value.removedEditors)for(const y of i.value.removedEditors){const $=this.h.get(y);$&&(this.h.delete(y),this.k?.id===$.id&&(this.k=void 0),o.push($))}if(i.value.visibleEditors){this.l=i.value.visibleEditors.map($=>this.h.get($)).filter($=>!!$);const y=new Set;this.l.forEach($=>y.add($.id));for(const $ of this.h.values()){const S=y.has($.id);$._acceptVisibility(S)}this.l=[...this.h.values()].map($=>$).filter($=>$.visible),this.o.fire(this.visibleNotebookEditors)}i.value.newActiveEditor===null?this.k=void 0:i.value.newActiveEditor&&(this.h.get(i.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${i.value.newActiveEditor}`),this.k=this.h.get(i.value.newActiveEditor)),i.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(i){const o=b.$vM.String.with("notebookType","A notebook type"),y=new b.$xM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new b.$vM("data","Bytes to convert to data",S=>S instanceof Uint8Array,S=>M.$ae.wrap(S))],new b.$wM("Notebook Data",S=>m.NotebookData.to(S.value))),$=new b.$xM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new b.$vM("NotebookData","Notebook data to convert to bytes",S=>!0,S=>new t.$jv(m.NotebookData.from(S)))],new b.$wM("Bytes",S=>S.buffer));i.registerApiCommand(y),i.registerApiCommand($)}}e.$adc=r}),define(Ae[244],Re([1,0,18,13,21,5,6,28,2,20,14,55,3,31,8,7,77,197,26,46]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=e.$odc=void 0;let D=class{constructor(S,I,u,d,l){this.m=I,this.n=u,this.o=d,this.q=l,this.b=new h.$zc,this.c=new h.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new k.$Abc("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new F.$Md,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=S.getProxy(a.$9J.MainThreadNotebookKernels);const R=new b.$xM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.$vM("options","Select kernel options",B=>!0,B=>{if(B&&"notebookEditor"in B&&"id"in B){const V=this.n.getIdByEditor(B.notebookEditor);return{id:B.id,extension:B.extension,notebookEditorId:V}}else if(B&&"notebookEditor"in B){const V=this.n.getIdByEditor(B.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${B.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return B})],b.$wM.Void);this.o.registerApiCommand(R)}createNotebookController(S,I,u,d,l,R){for(const Ee of this.j.values())if(Ee.controller.id===I&&g.$Yl.equals(S.identifier,Ee.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const B=this.k++,V=this;this.q.trace(`NotebookController[${B}], CREATED by ${S.identifier.value}, ${I}`);const U=()=>console.warn(`NO execute handler from notebook controller '${ee.id}' of extension: '${S.identifier}'`);let W=!1;const N=new F.$Md,O=new F.$Md,ee={id:y(S.identifier,I),notebookType:u,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:d||S.identifier.value,preloads:R?R.map(m.NotebookRendererScript.from):[]};let Z=l??U,ye;this.a.$addKernel(B,ee).catch(Ee=>{console.log(Ee),W=!0});let De=0;const Pe=()=>{if(W)return;const Ee=++De;Promise.resolve().then(()=>{Ee===De&&this.a.$updateKernel(B,ee)})},X=new h.$zc,le={get id(){return I},get notebookType(){return ee.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return ee.label},set label(Ee){ee.label=Ee??S.displayName??S.name,Pe()},get detail(){return ee.detail??""},set detail(Ee){ee.detail=Ee,Pe()},get description(){return ee.description??""},set description(Ee){ee.description=Ee,Pe()},get supportedLanguages(){return ee.supportedLanguages},set supportedLanguages(Ee){ee.supportedLanguages=Ee,Pe()},get supportsExecutionOrder(){return ee.supportsExecutionOrder??!1},set supportsExecutionOrder(Ee){ee.supportsExecutionOrder=Ee,Pe()},get rendererScripts(){return ee.preloads?ee.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(Ee){Z=Ee??U},get interruptHandler(){return ye},set interruptHandler(Ee){ye=Ee,ee.supportsInterrupt=!!Ee,Pe()},createNotebookCellExecution(Ee){if(W)throw new Error("notebook controller is DISPOSED");if(!X.has(Ee.notebook.uri))throw V.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ee.notebook.uri.toString()}`);return V._createNotebookCellExecution(Ee,y(S.identifier,this.id))},createNotebookExecution(Ee){if((0,c.$9E)(S,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!X.has(Ee.uri))throw V.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ee.uri.toString()}`);return V._createNotebookExecution(Ee,y(S.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${B}], DISPOSED`),W=!0,this.j.delete(B),N.dispose(),O.dispose(),this.a.$removeKernel(B))},updateNotebookAffinity(Ee,ce){ce===f.NotebookControllerAffinity2.Hidden&&(0,c.$9E)(S,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(B,Ee.uri,ce)},onDidReceiveMessage:O.event,postMessage(Ee,ce){return(0,c.$9E)(S,"notebookMessaging"),V.a.$postMessage(B,ce&&V.n.getIdByEditor(ce),Ee)},asWebviewUri(Ee){return(0,c.$9E)(S,"notebookMessaging"),(0,t.$Vob)(Ee,V.m.remote)}};return this.j.set(B,{extensionId:S.identifier,controller:le,onDidReceiveMessage:O,onDidChangeSelection:N,associatedNotebooks:X}),le}getIdByController(S){for(const[I,u]of this.j)if(u.controller===S)return y(u.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,I){const u=this.f++,d=this;this.q.trace(`NotebookControllerDetectionTask[${u}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(u,I);const l={dispose:()=>{this.e.delete(u),d.a.$removeKernelDetectionTask(u)}};return this.e.set(u,l),l}registerKernelSourceActionProvider(S,I,u){const d=this.h++,l=typeof u.onDidChangeNotebookKernelSourceActions=="function"?d:void 0,R=this;this.g.set(d,u),this.q.trace(`NotebookKernelSourceActionProvider[${d}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(d,d,I);let B;return l!==void 0&&(B=u.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(l))),{dispose:()=>{this.g.delete(d),R.a.$removeKernelSourceActionProvider(d,d),B?.dispose()}}}async $provideKernelSourceActions(S,I){const u=this.g.get(S);if(u){const d=new A.$Qc;return this.i.add([d]),(await u.provideNotebookKernelSourceActions(I)??[]).map(R=>m.NotebookKernelSourceAction.from(R,this.o.converter,d))}return[]}$acceptNotebookAssociation(S,I,u){const d=this.j.get(S);if(d){const l=this.n.getNotebookDocument(E.URI.revive(I));u?d.associatedNotebooks.set(l.uri,!0):d.associatedNotebooks.delete(l.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,l.uri.toString(),u),d.onDidChangeSelection.fire({selected:u,notebook:l.apiNotebook})}}async $executeCells(S,I,u){const d=this.j.get(S);if(!d)return;const l=this.n.getNotebookDocument(E.URI.revive(I)),R=[];for(const B of u){const V=l.getCell(B);V&&R.push(V.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,l.uri.toString(),R.length),await d.controller.executeHandler.call(d.controller,R,l.apiNotebook,d.controller)}catch(B){this.q.error(`NotebookController[${S}] execute cells FAILED`,B),console.error(B)}}async $cancelCells(S,I,u){const d=this.j.get(S);if(!d)return;const l=this.n.getNotebookDocument(E.URI.revive(I));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,l.apiNotebook);else for(const R of u){const B=l.getCell(R);B&&this.b.get(B.uri)?.cancel()}if(d.controller.interruptHandler){const R=this.c.get(l.uri);u.length&&Array.isArray(R)&&R.length&&R.forEach(B=>B.dispose())}}$acceptKernelMessageFromRenderer(S,I,u){const d=this.j.get(S);if(!d)return;const l=this.n.getEditorById(I);d.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:u}))}$cellExecutionChanged(S,I,u){const l=this.n.getNotebookDocument(E.URI.revive(S)).getCell(I);if(l){const R=u?m.NotebookCellExecutionState.to(u):f.NotebookCellExecutionState.Idle;R!==void 0&&this.l.fire({cell:l.apiCell,state:R})}}_createNotebookCellExecution(S,I){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!d)throw new Error("invalid cell");if(this.b.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const l=new r(I,d,this.a);this.b.set(d.uri,l);const R=l.onDidChangeState(()=>{l.state===p.Resolved&&(l.dispose(),R.dispose(),this.b.delete(d.uri))});return l.asApiObject()}_createNotebookExecution(S,I){const u=this.n.getNotebookDocument(S.uri),d=S.getCells().find(B=>{const V=u.getCellFromApiCell(B);return V&&this.b.has(V.uri)});if(d)throw new Error(`duplicate cell execution for ${d.document.uri}`);if(this.c.has(u.uri))throw new Error(`duplicate notebook execution for ${u.uri}`);const l=new i(I,u,this.a),R=l.onDidChangeState(()=>{l.state===s.Resolved&&(l.dispose(),R.dispose(),this.c.delete(u.uri))});return this.c.set(u.uri,[l,R]),l.asApiObject()}};e.$odc=D,e.$odc=D=Ke([Ve(4,P.$8i)],D);var p;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(p||(p={}));class r extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(S,I,u){super(),this.m=I,this.n=u,this.b=r.a++,this.c=new F.$Md,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new C.$Wd),this.h=new o(10,d=>this.s(d)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const I=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new v.$jv(I))}t(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let I=this.m;if(S&&(I=this.m.notebook.getCellFromApiCell(S)),!I)throw new Error("INVALID cell");return I.handle}y(S){return S.map(I=>{const u=f.$zL.ensureUniqueMimeTypes(I.items,!0);return u===I.items?m.NotebookCellOutput.from(I):m.NotebookCellOutput.from({items:u,id:I.id,metadata:I.metadata})})}async z(S,I,u){const d=this.w(I),l=this.y((0,w.$2b)(S));return this.r({editType:n.CellExecutionUpdateType.Output,cellHandle:d,append:u,outputs:l})}async C(S,I,u){return S=f.$zL.ensureUniqueMimeTypes((0,w.$2b)(S),!0),this.r({editType:n.CellExecutionUpdateType.OutputItems,items:S.map(m.NotebookCellOutputItem.from),outputId:I.id,append:u})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(u){S.j=u,S.s([{editType:n.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(u){if(S.f===p.Resolved||S.f===p.Started)throw new Error("Cannot call start again");S.f=p.Started,S.c.fire(),S.s({editType:n.CellExecutionUpdateType.ExecutionState,runStartTime:u})},end(u,d){if(S.f===p.Resolved)throw new Error("Cannot call resolve twice");S.f=p.Resolved,S.c.fire(),S.h.flush(),S.n.$completeExecution(S.b,new v.$jv({runEndTime:d,lastRunSuccess:u}))},clearOutput(u){return S.t(),S.z([],u,!1)},appendOutput(u,d){return S.t(),S.z(u,d,!0)},replaceOutput(u,d){return S.t(),S.z(u,d,!1)},appendOutputItems(u,d){return S.t(),S.C(u,d,!0)},replaceOutputItems(u,d){return S.t(),S.C(u,d,!1)}})}}var s;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(s||(s={}));class i extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(S,I,u){super(),this.h=I,this.j=u,this.b=i.a++,this.c=new F.$Md,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new C.$Wd),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor(S,I){this.e=S,this.f=I,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new M.$bh,this.b=Date.now(),(0,M.$Tg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>S.complete())}}function y($,S){return`${$.value}/${S}`}e.$pdc=y}),define(Ae[245],Re([1,0,5,3,103]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class F{constructor(h,E){this.c=E,this.a=new Map,this.b=h.getProxy(M.$9J.MainThreadNotebookRenderers)}$postRendererMessage(h,E,g){const P=this.c.getEditorById(h);this.a.get(E)?.fire({editor:P.apiEditor,message:g})}createRendererMessaging(h,E){if(!h.contributes?.notebookRenderer?.some(P=>P.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(P,k,a)=>this.d(E).event(P,k,a),postMessage:(P,k)=>{C.$_cc.apiEditorsToExtHost.has(P)&&([P,k]=[k,P]);const a=k&&C.$_cc.apiEditorsToExtHost.get(k);return this.b.$postMessage(a?.id,E,P)}}}d(h){let E=this.a.get(h);return E||(E=new w.$Md({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(h)}}),this.a.set(h,E),E)}}e.$qdc=F}),define(Ae[246],Re([1,0,6,16,2,26,3]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;class h{constructor(g){this.b=new Map,this.a=g.getProxy(A.$9J.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,P,k){if((0,F.$9E)(g,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,k),this.a.$registerProfileContentHandler(P,k.name,k.description,g.identifier.value),(0,w.$Pc)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(g,P,k,a){const b=this.b.get(g);if(!b)throw new Error(`Unknown handler with id: ${g}`);return b.saveProfile(P,k,a)}async $readProfile(g,P,k){const a=this.b.get(g);if(!a)throw new Error(`Unknown handler with id: ${g}`);return a.readProfile((0,M.$xf)(P)?P:C.URI.revive(P),k)}}e.$udc=h}),define(Ae[247],Re([1,0,2,3,13,8]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=void 0;class A{static{this.a=0}constructor(E,g){this.d=g,this.c=new Map,this.b=E.getProxy(M.$9J.MainThreadQuickDiff)}$provideOriginalResource(E,g,P){const k=w.URI.revive(g),a=this.c.get(E);return a?(0,C.$Lg)(()=>a.provideOriginalResource(k,P)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(E,g,P,k){const a=A.a++;return this.c.set(a,g),this.b.$registerQuickDiffProvider(a,F.DocumentSelector.from(E,this.d),P,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$vdc=A}),define(Ae[248],Re([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;function m(f,t,n){const c=f.getProxy(F.$9J.MainThreadQuickOpen);class v{constructor(S,I){this.e=new Map,this.f=0,this.a=S,this.b=I}showQuickPick(S,I,u,d=w.CancellationToken.None){this.c=void 0;const l=Promise.resolve(I),R=++this.f,B=c.$show(R,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},d),V={},U=B.then(()=>V);return Promise.race([U,l]).then(W=>{if(W===V)return;const N=(0,a.$8E)(S,"quickPickItemTooltip");return l.then(O=>{const ee=[];for(let Z=0;Z<O.length;Z++){const ye=O[Z];if(typeof ye=="string")ee.push({label:ye,handle:Z});else if(ye.kind===h.QuickPickItemKind.Separator)ee.push({type:"separator",label:ye.label});else{ye.tooltip&&!N&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const De=ye.iconPath?i(ye.iconPath):void 0;ee.push({label:ye.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:ye.description,detail:ye.detail,picked:ye.picked,alwaysShow:ye.alwaysShow,tooltip:N?b.MarkdownString.fromStrict(ye.tooltip):void 0,handle:Z})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=Z=>{u.onDidSelectItem(O[Z])}),c.$setItems(R,ee),B.then(Z=>{if(typeof Z=="number")return O[Z];if(Array.isArray(Z))return Z.map(ye=>O[ye])})})}).then(void 0,W=>{if(!(0,E.$3)(W))return c.$setError(R,W),Promise.reject(W)})}$onItemSelected(S){this.c?.(S)}showInput(S,I=w.CancellationToken.None){return this.d=S?.validateInput,c.$input(S,typeof this.d=="function",I).then(void 0,u=>{if(!(0,E.$3)(u))return Promise.reject(u)})}async $validateInput(S){if(!this.d)return;const I=await this.d(S);if(!I||typeof I=="string")return I;let u;switch(I.severity){case h.InputBoxValidationSeverity.Info:u=P.default.Info;break;case h.InputBoxValidationSeverity.Warning:u=P.default.Warning;break;case h.InputBoxValidationSeverity.Error:u=P.default.Error;break;default:u=I.message?P.default.Error:P.default.Ignore;break}return{content:I.message,severity:u}}async showWorkspaceFolderPick(S,I=w.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!u)return;const d=await this.a.getWorkspaceFolders2();if(d)return d.find(l=>l.uri.toString()===u.uri.toString())}createQuickPick(S){const I=new o(S,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(S){const I=new y(S,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(S,I){this.e.get(S)?._fireDidChangeValue(I)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,I){const u=this.e.get(S);u instanceof o&&u._fireDidChangeActive(I)}$onDidChangeSelection(S,I){const u=this.e.get(S);u instanceof o&&u._fireDidChangeSelection(I)}$onDidTriggerButton(S,I){this.e.get(S)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(S,I,u){const d=this.e.get(S);d instanceof o&&d._fireDidTriggerItemButton(I,u)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class D{static{this.a=1}constructor(S,I){this.x=S,this.y=I,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Md,this.q=new M.$Md,this.r=new M.$Md,this.s=new M.$Md,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((I,u)=>{const d=I===h.$sL.Back?-1:u;this.o.set(d,I)}),this.z({buttons:S.map((I,u)=>({...i(I.iconPath),tooltip:I.tooltip,handle:I===h.$sL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const I=this.o.get(S);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(S){if(!this.v){for(const I of Object.keys(S)){const u=S[I];this.u[I]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function p($){if($ instanceof h.$5K)return{id:$.id};const S=s($),I=r($);return{dark:typeof S=="string"?A.URI.file(S):S,light:typeof I=="string"?A.URI.file(I):I}}function r($){return typeof $=="object"&&"light"in $?$.light:$}function s($){return typeof $=="object"&&"dark"in $?$.dark:$}function i($){const S=p($);let I,u;return"id"in S?u=k.ThemeIcon.asClassName(S):I=S,{iconPath:I,iconClass:u}}class o extends D{constructor(S,I){super(S.identifier,I),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Md,this.L=[],this.M=new M.$Md,this.N=new M.$Md,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((d,l)=>{this.C.set(l,d),this.D.set(d,l)});const I=(0,a.$8E)(this.O,"quickPickItemTooltip"),u=[];for(let d=0;d<S.length;d++){const l=S[d];if(l.kind===h.QuickPickItemKind.Separator)u.push({type:"separator",label:l.label});else{l.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const R=l.iconPath?i(l.iconPath):void 0;u.push({handle:d,label:l.label,iconPath:R?.iconPath,iconClass:R?.iconClass,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,tooltip:I?b.MarkdownString.fromStrict(l.tooltip):void 0,buttons:l.buttons?.map((B,V)=>({...i(B.iconPath),tooltip:B.tooltip,handle:V}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(S){const I=(0,g.$Gb)(S.map(u=>this.C.get(u)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(S){const I=(0,g.$Gb)(S.map(u=>this.C.get(u)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(S,I){const u=this.C.get(S);if(!u||!u.buttons||!u.buttons.length)return;const d=u.buttons[I];d&&this.N.fire({button:d,item:u})}}class y extends D{constructor(S,I){super(S.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:P.default.Error}):this.z({validationMessage:S.message,severity:S.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new v(t,n)}e.$wcc=m}),define(Ae[249],Re([1,0,2,5,65,6,13,3,18,131,14,20,40,8,26,12]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=void 0;function n(d){if(d)return typeof d.iconPath=="string"?w.URI.file(d.iconPath):w.URI.isUri(d.iconPath)||a.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function c(d){if(d.icon){if(w.URI.isUri(d.icon))return d.icon;if(a.ThemeIcon.isThemeIcon(d.icon))return d.icon;{const l=d.icon;return{light:l.light,dark:l.dark}}}else return}function v(d,l){if(!d.iconPath&&!l.iconPath)return 0;if(d.iconPath){if(!l.iconPath)return 1}else return-1;const R=typeof d.iconPath=="string"?d.iconPath:w.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,B=typeof l.iconPath=="string"?l.iconPath:w.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id;return(0,g.$kq)(R,B)}function D(d,l){let R=0;if(d.strikeThrough!==l.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==l.faded)return d.faded?1:-1;if(d.tooltip!==l.tooltip)return(d.tooltip||"").localeCompare(l.tooltip||"");if(R=v(d,l),R!==0)return R;if(d.light&&l.light)R=v(d.light,l.light);else{if(d.light)return 1;if(l.light)return-1}if(R!==0)return R;if(d.dark&&l.dark)R=v(d.dark,l.dark);else{if(d.dark)return 1;if(l.dark)return-1}return R}function p(d,l){if(d.command!==l.command)return d.command<l.command?-1:1;if(d.title!==l.title)return d.title<l.title?-1:1;if(d.tooltip!==l.tooltip){if(d.tooltip!==void 0&&l.tooltip!==void 0)return d.tooltip<l.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(d.arguments===l.arguments)return 0;if(d.arguments)if(l.arguments){if(d.arguments.length!==l.arguments.length)return d.arguments.length-l.arguments.length}else return 1;else return-1;for(let R=0;R<d.arguments.length;R++){const B=d.arguments[R],V=l.arguments[R];if(B!==V)return B<V?-1:1}return 0}function r(d,l){let R=(0,g.$kq)(d.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(R!==0)return R;if(d.command&&l.command)R=p(d.command,l.command);else{if(d.command)return 1;if(l.command)return-1}if(R!==0)return R;if(d.decorations&&l.decorations)R=D(d.decorations,l.decorations);else{if(d.decorations)return 1;if(l.decorations)return-1}return R}function s(d,l){for(let R=0;R<d.length;R++)if(d[R]!==l[R])return!1;return!0}function i(d,l){return d.command===l.command&&d.title===l.title&&d.tooltip===l.tooltip&&(d.arguments&&l.arguments?s(d.arguments,l.arguments):d.arguments===l.arguments)}function o(d,l){return(0,E.$tb)(d,l,i)}function y(d,l){return d===l?!0:!d||!l?!1:d.id===l.id&&d.label===l.label&&d.upstream?.id===l.upstream?.id&&d.upstream?.label===l.upstream?.label}class ${#e;#t;get value(){return this.d}set value(l){l=l??"",this.#e.$setInputBoxValue(this.l,l),this.n(l)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(l){this.#e.$setInputBoxPlaceholder(this.l,l),this.f=l}get validateInput(){return(0,m.$9E)(this.k,"scmValidation"),this.g}set validateInput(l){if((0,m.$9E)(this.k,"scmValidation"),l&&typeof l!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=l,this.#e.$setValidationProviderIsEnabled(this.l,!!l)}get enabled(){return this.h}set enabled(l){l=!!l,this.h!==l&&(this.h=l,this.#e.$setInputBoxEnablement(this.l,l))}get visible(){return this.j}set visible(l){l=!!l,this.j!==l&&(this.j=l,this.#e.$setInputBoxVisibility(this.l,l))}get document(){return(0,m.$9E)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(l,R,B,V,U){this.k=l,this.l=V,this.m=U,this.d="",this.e=new M.$Md,this.f="",this.h=!0,this.j=!0,this.#t=R,this.#e=B}showValidationMessage(l,R){(0,m.$9E)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,l,R)}$onInputBoxValueChange(l){this.n(l)}n(l){this.d=l,this.e.fire(l)}}e.$xcc=$;class S{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(l){this.v=l,this.q.$updateGroupLabel(this.t,this.handle,l)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(l){this.p=l,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(l){this.f=[...l],this.k.fire()}constructor(l,R,B,V,U){this.q=l,this.s=R,this.t=B,this.u=V,this.v=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Md,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Md,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=S.d++}getResourceState(l){return this.g.get(l)}$executeResourceCommand(l,R){const B=this.h.get(l);return B?(0,A.$Lg)(()=>this.s.executeCommand(B.command,...B.arguments||[],R)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const l=[...this.f].sort(r),B=(0,E.$Cb)(this.o,l,r).map(W=>{const N=W.toInsert.map(O=>{const ee=this.e++;this.g.set(ee,O);const Z=O.resourceUri;let ye;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const q=new F.$Qc;ye=this.s.converter.toInternal(O.command,q),this.j.set(ee,q)}else this.h.set(ee,O.command);const De=n(O.decorations),Pe=O.decorations&&n(O.decorations.light)||De,X=O.decorations&&n(O.decorations.dark)||De,le=[Pe,X],Ee=O.decorations&&O.decorations.tooltip||"",ce=O.decorations&&!!O.decorations.strikeThrough,$e=O.decorations&&!!O.decorations.faded,ie=O.contextValue||"";return{rawResource:[ee,Z,le,Ee,ce,$e,ie,ye],handle:ee}});return{start:W.start,deleteCount:W.deleteCount,toInsert:N}}),V=B.map(({start:W,deleteCount:N,toInsert:O})=>[W,N,O.map(ee=>ee.rawResource)]),U=B.reverse();for(const{start:W,deleteCount:N,toInsert:O}of U){const ee=O.map(ye=>ye.handle),Z=this.n.splice(W,N,...ee);for(const ye of Z)this.g.delete(ye),this.h.delete(ye),this.j.get(ye)?.dispose(),this.j.delete(ye)}return this.o=l,V}dispose(){this.l=!0,this.m.fire()}}class I{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(l){this.g!==l&&(this.g=l,this.#e.$updateSourceControl(this.x,{count:l}))}get quickDiffProvider(){return this.h}set quickDiffProvider(l){this.h=l;let R;(0,m.$8E)(this.y,"quickDiffProvider")&&(R=l?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!l,quickDiffLabel:R})}get historyProvider(){return(0,m.$9E)(this.y,"scmHistoryProvider"),this.j}set historyProvider(l){(0,m.$9E)(this.y,"scmHistoryProvider"),this.j=l,this.k.value=new F.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!l}),l&&(this.k.value.add(l.onDidChangeCurrentHistoryItemGroup(()=>{y(this.l,l?.currentHistoryItemGroup)||(this.l=l?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(l.onDidChangeActionButton(()=>{(0,m.$9E)(this.y,"scmActionButton"),this.m.value=new F.$Qc;const R=l.actionButton!==void 0?{command:this.z.converter.toInternal(l.actionButton.command,this.m.value),description:l.actionButton.description,enabled:l.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,R??null)})))}get commitTemplate(){return this.n}set commitTemplate(l){l!==this.n&&(this.n=l,this.#e.$updateSourceControl(this.x,{commitTemplate:l}))}get acceptInputCommand(){return this.p}set acceptInputCommand(l){this.o.value=new F.$Qc,this.p=l;const R=this.z.converter.toInternal(l,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:R})}get actionButton(){return(0,m.$9E)(this.y,"scmActionButton"),this.s}set actionButton(l){(0,m.$9E)(this.y,"scmActionButton"),this.q.value=new F.$Qc,this.s=l;const R=l!==void 0?{command:this.z.converter.toInternal(l.command,this.q.value),secondaryCommands:l.secondaryCommands?.map(B=>B.map(V=>this.z.converter.toInternal(V,this.q.value))),description:l.description,enabled:l.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:R??null})}get statusBarCommands(){return this.u}set statusBarCommands(l){if(this.u&&l&&o(this.u,l))return;this.t.value=new F.$Qc,this.u=l;const R=(l||[]).map(B=>this.z.converter.toInternal(B,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:R})}get selected(){return this.v}constructor(l,R,B,V,U,W,N){this.y=l,this.z=V,this.A=U,this.B=W,this.C=N,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Sc,this.m=new F.$Sc,this.n=void 0,this.o=new F.$Sc,this.p=void 0,this.q=new F.$Sc,this.t=new F.$Sc,this.u=void 0,this.v=!1,this.w=new M.$Md,this.onDidChangeSelection=this.w.event,this.x=I.d++,this.D=new Map,this.E=new Set,this.#e=B;const O=w.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this.f=new $(l,R,this.#e,this.x,O),this.#e.$registerSourceControl(this.x,U,W,N,O)}createResourceGroup(l,R){const B=new S(this.#e,this.z,this.x,l,R),V=M.Event.once(B.onDidDispose)(()=>this.D.delete(B));return this.D.set(B,V),this.eventuallyAddResourceGroups(),B}eventuallyAddResourceGroups(){const l=[],R=[];for(const[B,V]of this.D){V.dispose();const U=B.onDidUpdateResourceStates(()=>{this.E.add(B),this.eventuallyUpdateResourceStates()});M.Event.once(B.onDidDispose)(()=>{this.E.delete(B),U.dispose(),this.e.delete(B.handle),this.#e.$unregisterGroup(this.x,B.handle)}),l.push([B.handle,B.id,B.label,B.features]);const W=B._takeResourceStateSnapshot();W.length>0&&R.push([B.handle,W]),this.e.set(B.handle,B)}this.#e.$registerGroups(this.x,l,R),this.D.clear()}eventuallyUpdateResourceStates(){const l=[];this.E.forEach(R=>{const B=R._takeResourceStateSnapshot();B.length!==0&&l.push([R.handle,B])}),l.length>0&&this.#e.$spliceResourceStates(this.x,l),this.E.clear()}getResourceGroup(l){return this.e.get(l)}setSelectionState(l){this.v=l,this.w.fire(l)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(l=>l.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,C.$gh)(100)],I.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.$gh)(100)],I.prototype,"eventuallyUpdateResourceStates",null);let u=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(l,R,B,V){this.l=R,this.m=B,this.n=V,this.g=new Map,this.h=new k.$1l,this.j=new M.$Md,this.e=l.getProxy(h.$9J.MainThreadSCM),this.f=l.getProxy(h.$9J.MainThreadTelemetry),R.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const W=this.g.get(U.sourceControlHandle);if(!W)return U;const N=W.getResourceGroup(U.groupHandle);return N?N.getResourceState(U.handle):U}else if(U&&U.$mid===4){const W=this.g.get(U.sourceControlHandle);return W?W.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const W=this.g.get(U.handle);return W||U}return U}})}createSourceControl(l,R,B,V){this.n.trace("ExtHostSCM#createSourceControl",l.identifier.value,R,B,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const U=t.d++,W=new I(l,this.m,this.e,this.l,R,B,V);this.g.set(U,W);const N=this.h.get(l.identifier)||[];return N.push(W),this.h.set(l.identifier,N),W}getLastInputBox(l){this.n.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const R=this.h.get(l.identifier),B=R&&R[R.length-1];return B&&B.inputBox}$provideOriginalResource(l,R,B){const V=w.URI.revive(R);this.n.trace("ExtHostSCM#$provideOriginalResource",l,V.toString());const U=this.g.get(l);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Lg)(()=>U.quickDiffProvider.provideOriginalResource(V,B)).then(W=>W||null)}$onInputBoxValueChange(l,R){this.n.trace("ExtHostSCM#$onInputBoxValueChange",l);const B=this.g.get(l);return B&&B.inputBox.$onInputBoxValueChange(R),Promise.resolve(void 0)}$executeResourceCommand(l,R,B,V){this.n.trace("ExtHostSCM#$executeResourceCommand",l,R,B);const U=this.g.get(l);if(!U)return Promise.resolve(void 0);const W=U.getResourceGroup(R);return W?W.$executeResourceCommand(B,V):Promise.resolve(void 0)}$validateInput(l,R,B){this.n.trace("ExtHostSCM#$validateInput",l);const V=this.g.get(l);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Lg)(()=>V.inputBox.validateInput(R,B)).then(U=>{if(!U)return Promise.resolve(void 0);const W=b.MarkdownString.fromStrict(U.message);return W?Promise.resolve([W,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(l){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&this.g.get(l)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=l,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(l,R,B){return await this.g.get(l)?.historyProvider?.resolveHistoryItemGroupBase(R,B)??void 0}async $resolveHistoryItemGroupCommonAncestor(l,R,B,V){return await this.g.get(l)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(R,B,V)??void 0}async $provideHistoryItems(l,R,B,V){return(await this.g.get(l)?.historyProvider?.provideHistoryItems(R,B,V))?.map(N=>({id:N.id,parentIds:N.parentIds,label:N.label,description:N.description,icon:c(N),timestamp:N.timestamp}))??void 0}async $provideHistoryItemChanges(l,R,B){return await this.g.get(l)?.historyProvider?.provideHistoryItemChanges(R,B)??void 0}};e.$ycc=u,e.$ycc=u=t=Ke([Ve(3,P.$8i)],u)}),define(Ae[83],Re([1,0,3,5,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=void 0;class F{constructor(h){this.b=new M.$Md,this.onDidChangePassword=this.b.event,this.a=h.getProxy(w.$9J.MainThreadSecretState)}async $onDidChangePassword(h){this.b.fire(h)}get(h,E){return this.a.$getPassword(h,E)}store(h,E,g){return this.a.$setPassword(h,E,g)}delete(h,E){return this.a.$deletePassword(h,E)}}e.$dcc=F,e.$ecc=(0,C.$Nh)("IExtHostSecretState")}),define(Ae[250],Re([1,0,3,8,2]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;class F{static{this.a=0}constructor(h,E){this.d=E,this.c=new Map,this.b=h.getProxy(w.$9J.MainThreadShare)}async $provideShare(h,E,g){return await this.c.get(h)?.provideShare({selection:M.Range.to(E.selection),resourceUri:C.URI.revive(E.resourceUri)},g)??void 0}registerShareProvider(h,E){const g=F.a++;return this.c.set(g,E),this.b.$registerShareProvider(g,M.DocumentSelector.from(h,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$Adc=F}),define(Ae[251],Re([1,0,7,3,153,6,8,16]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$6K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$6K("statusBarItem.warningForeground")]])}#e;#t;constructor(a,b,m,f,t,n=w.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new F.$Qc,this.#e=a,this.#t=b,t&&f){this.c=(0,w.$IK)(f.identifier,t);const v=m.get(this.c);v&&(n=v.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,c=v.priority,this.j=!0,this.name=v.name,this.text=v.text,this.tooltip=v.tooltip,this.command=v.command,this.accessibilityInformation=v.accessibilityInformation)}else this.c=String(E.a++);this.e=f,this.f=t,this.g=n,this.h=this.u(c)}u(a){if((0,h.$Bf)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!E.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new F.$Qc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let b;this.m?b=this.m:b=(0,C.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=E.b.get(this.o.id));const f=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,b,this.k,f,this.r?.internal,m,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$zcc=E;class g{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const b={message:a};return this.b.unshift(b),this.c(),new w.$$J(()=>{const m=this.b.indexOf(b);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(a,b){this.e=new Map,this.a=a.getProxy(M.$9J.MainThreadStatusBar),this.b=b,this.c=new g(this)}$acceptStaticEntries(a){for(const b of a)this.e.set(b.entryId,b)}createStatusBarEntry(a,b,m,f){return new E(this.a,this.b,this.e,a,b,m,f)}setStatusBarMessage(a,b){const m=this.c.setMessage(a);let f;return typeof b=="number"?f=setTimeout(()=>m.dispose(),b):typeof b<"u"&&b.then(()=>m.dispose(),()=>m.dispose()),new w.$$J(()=>{m.dispose(),clearTimeout(f)})}}e.$Acc=P}),define(Ae[84],Re([1,0,3,5,4]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=e.$4bc=void 0;class F{constructor(h,E){this.c=E,this.b=new M.$Md,this.onDidChangeStorage=this.b.event,this.a=h.getProxy(w.$9J.MainThreadStorage)}registerExtensionStorageKeysToSync(h,E){this.a.$registerExtensionStorageKeysToSync(h,E)}async initializeExtensionStorage(h,E,g){const P=await this.a.$initializeExtensionStorage(h,E);let k;return P&&(k=this.d(h,E,P)),k||g}setValue(h,E,g){return this.a.$setValue(h,E,g)}$acceptValue(h,E,g){const P=this.d(h,E,g);P&&this.b.fire({shared:h,key:E,value:P})}d(h,E,g){try{return JSON.parse(g)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${h}): ${P}`)}}}e.$4bc=F,e.$5bc=(0,C.$Nh)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,62,2]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=void 0,e.$0bc=(0,w.$Nh)("IExtensionStoragePaths");let h=class{constructor(g,P,k){this.d=P,this.f=k,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(g){return A.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,P=await this.g(g);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(g){if(this.c)return A.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return A.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$$bc=h,e.$$bc=h=Ke([Ve(0,M.$nM),Ve(1,C.$8i),Ve(2,F.$9bc)],h)}),define(Ae[63],Re([1,0,5,3,4,2,17,6,7,155,9,181,21,36,182,40,13,8,31]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=e.$bcc=e.$acc=e.$_bc=void 0,e.$_bc=(0,C.$Nh)("IExtHostTerminalService");class v{constructor(u,d,l,R){this.l=u,this._id=d,this.m=l,this.n=R,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(V=>this.f=V);const B=this;this.value={get name(){return B.n||""},get processId(){return B.b},get creationOptions(){return B.m},get exitStatus(){return B.h},get state(){return B.j},get selection(){return B.k},sendText(V,U=!0){B.q(),B.l.$sendText(B._id,V,U)},show(V){B.q(),B.l.$show(B._id,V)},hide(){B.q(),B.l.$hide(B._id)},dispose(){B.a||(B.a=!0,B.l.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(u,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:y(u.iconPath)??void 0,color:f.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:d?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:d?.useShellEnvironment??void 0,location:d?.location||this.o(u.location,d?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,d,l,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:l,color:f.ThemeColor.isThemeColor(R)?R.id:void 0,location:this.o(u,d),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(u,d){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in u?{viewColumn:n.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.n=u}setExitStatus(u,d){this.h=Object.freeze({code:u,reason:d})}setDimensions(u,d){return u===this.d&&d===this.g||u===0||d===0?!1:(this.d=u,this.g=d,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(u){this.k=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(d=>{d!==u&&(this.b=Promise.resolve(u))})}}e.$acc=v;class D{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new w.$Md,this.onProcessData=this.a.event,this.b=new w.$Md,this.d=new w.$Md,this.onDidChangeProperty=this.d.event,this.f=new w.$Md,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,d){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${d}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,d){this.g.setDimensions?.({columns:u,rows:d})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(d=>this.a.fire(d)),this.g.onDidClose?.((d=void 0)=>{this.f.fire(d===void 0?void 0:d)}),this.g.onDidOverrideDimensions?.(d=>{d&&this.d.fire({type:"overrideDimensions",value:{cols:d.columns,rows:d.rows}})}),this.g.onDidChangeName?.(d=>{this.d.fire({type:"title",value:d})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let p=1,r=class extends h.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,d,l){super(),this.Q=d,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new h.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$Md,this.onDidCloseTerminal=this.H.event,this.I=new w.$Md,this.onDidOpenTerminal=this.I.event,this.J=new w.$Md,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$Md,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$Md,this.onDidChangeTerminalState=this.M.event,this.N=new w.$Md,this.onDidChangeShell=this.N.event,this.O=new w.$Md({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$Md({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=l.getProxy(M.$9J.MainThreadTerminalService),this.y=new m.$Fkb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.Q.registerArgumentProcessor({processArgument:R=>{const B=V=>{const U=V;return this.W(U.instanceId)?.value};switch(R?.$mid){case 15:return B(R);default:{if(Array.isArray(R))for(let V=0;V<R.length&&R[V].$mid===15;V++)R[V]=B(R[V]);return R}}}}),this.B({dispose:()=>{for(const[R,B]of this.g)B.shutdown(!0)}})}getDefaultShell(u){return(u?this.u:this.s)?.path||""}getDefaultShellArgs(u){return(u?this.u:this.s)?.args||[]}createExtensionTerminal(u,d){const l=new v(this.a,(0,b.$dg)(),u,u.name),R=new D(u.pty);return l.createExtensionTerminal(u.location,this.R(u,d).resolvedExtHostIdentifier,y(u.iconPath),$(u.color)).then(B=>{const V=this.S(B,R);this.h[B]=V}),this.f.push(l),l.value}R(u,d){if(d=d||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const l=u.location.parentTerminal;if(l){const R=this.f.find(B=>B.value===l);R&&(d.resolvedExtHostIdentifier=R._id)}}else u.location&&typeof u.location!="object"?d.location=u.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(u,d){if(!this.W(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const R=new D(d),B=this.S(u,R);this.h[u]=B}async $acceptActiveTerminalChanged(u){const d=this.b;if(u===null){this.b=void 0,d!==this.b&&this.J.fire(this.b);return}const l=this.W(u);l&&(this.b=l,d!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(u,d){const l=this.W(u);l&&this.O.fire({terminal:l.value,data:d})}async $acceptTerminalDimensions(u,d,l){const R=this.W(u);R&&R.setDimensions(d,l)&&this.L.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptDidExecuteCommand(u,d){const l=this.W(u);l&&this.P.fire({terminal:l.value,...d})}async $acceptTerminalMaximumDimensions(u,d,l){this.g.get(u)?.resize(d,l)}async $acceptTerminalTitleChange(u,d){const l=this.W(u);l&&(l.name=d)}async $acceptTerminalClosed(u,d,l){const R=this.Y(this.f,u);if(R!==null){const B=this.f.splice(R,1)[0];B.setExitStatus(d,l),this.H.fire(B.value)}}$acceptTerminalOpened(u,d,l,R){if(d){const U=this.Y(this.f,d);if(U!==null){this.f[U]._id=u,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const B={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:F.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},V=new v(this.a,u,B,l);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(u,d){this.W(u)?._setProcessId(d)}async $startExtensionTerminal(u,d){const l=this.W(u);if(!l)return{message:(0,g.localize)(0,null,u)};l.isOpen||await new Promise(B=>{const V=this.onDidOpenTerminal(async U=>{U===l.value&&(V.dispose(),B())})});const R=this.g.get(u);R?R.startSendingEvents(d):this.j[u]={initialDimensions:d}}S(u,d){const l=new h.$Qc;l.add(d.onProcessReady(B=>this.a.$sendProcessReady(u,B.pid,B.cwd,B.windowsPty))),l.add(d.onDidChangeProperty(B=>this.a.$sendProcessProperty(u,B))),this.y.startBuffering(u,d.onProcessData),l.add(d.onProcessExit(B=>this.U(u,B))),this.g.set(u,d);const R=this.j[u];return R&&d instanceof D&&(d.startSendingEvents(R.initialDimensions),delete this.j[u]),l}$acceptProcessAckDataEvent(u,d){this.g.get(u)?.acknowledgeDataEvent(d)}$acceptProcessInput(u,d){this.g.get(u)?.input(d)}$acceptTerminalInteraction(u){const d=this.W(u);d?.setInteractedWith()&&this.M.fire(d.value)}$acceptTerminalSelection(u,d){this.W(u)?.setSelection(d)}$acceptProcessResize(u,d,l){try{this.g.get(u)?.resize(d,l)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(u,d){this.g.get(u)?.shutdown(d)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(d=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:d}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(d=>this.a.$sendProcessProperty(u,{type:"cwd",value:d}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.z.add(u),this.z.size===1&&this.a.$startLinkProvider(),new E.$$J(()=>{this.z.delete(u),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,d,l){if(this.C.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this.C.set(d,l),this.a.$registerProfileProvider(d,u.identifier.value),new E.$$J(()=>{this.C.delete(d),this.a.$unregisterProfileProvider(d)})}registerTerminalQuickFixProvider(u,d,l){if(this.D.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.D.set(u,l),this.a.$registerQuickFixProvider(u,d),new E.$$J(()=>{this.D.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,d){const l=new a.$Wd().token;if(l.isCancellationRequested)return;const R=this.D.get(u);if(!R)return;const B=await R.provideTerminalQuickFixes(d,l);if(B===null||Array.isArray(B)&&B.length===0)return;const V=new h.$Qc;if(this.w.value=V,!Array.isArray(B))return B?n.TerminalQuickFix.from(B,this.Q.converter,V):void 0;const U=[];for(const W of B){const N=n.TerminalQuickFix.from(W,this.Q.converter,V);N&&U.push(N)}return U}async $createContributedProfileTerminal(u,d){const l=new a.$Wd().token;let R=await this.C.get(u)?.provideTerminalProfile(l);if(!l.isCancellationRequested){if(R&&!("options"in R)&&(R={options:R}),!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,d);return}this.createTerminalFromOptions(R.options,d)}}async $provideLinks(u,d){const l=this.W(u);if(!l)return[];this.F.delete(u),this.G.get(u)?.dispose(!0);const B=new a.$Wd;this.G.set(u,B);const V=[],U={terminal:l.value,line:d},W=[];for(const ee of this.z)W.push(t.Promises.withAsyncBody(async Z=>{B.token.onCancellationRequested(()=>Z({provider:ee,links:[]}));const ye=await ee.provideTerminalLinks(U,B.token)||[];B.token.isCancellationRequested||Z({provider:ee,links:ye})}));const N=await Promise.all(W);if(B.token.isCancellationRequested)return[];const O=new Map;for(const ee of N)ee&&ee.links.length>0&&V.push(...ee.links.map(Z=>{const ye={id:p++,startIndex:Z.startIndex,length:Z.length,label:Z.tooltip};return O.set(ye.id,{provider:ee.provider,link:Z}),ye}));return this.F.set(u,O),V}$activateLink(u,d){const l=this.F.get(u)?.get(d);l&&l.provider.handleTerminalLink(l.link)}U(u,d){this.y.stopBuffering(u),this.g.delete(u),delete this.j[u];const l=this.h[u];l&&(l.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,d)}W(u){return this.X(this.f,u)}X(u,d){const l=this.Y(u,d);return l!==null?u[l]:null}Y(u,d){const l=u.findIndex(R=>R._id===d);return l===-1?null:l}getEnvironmentVariableCollection(u){let d=this.n.get(u.identifier.value);return d||(d=new s,this.$(u.identifier.value,d)),d.getScopedEnvironmentVariableCollection(void 0)}Z(u,d){const l=(0,k.$dr)(d.map),R=(0,k.$er)(d.descriptionMap);this.a.$setEnvironmentVariableCollection(u,d.persistent,l.length===0?void 0:l,R)}$initEnvironmentVariableCollections(u){u.forEach(d=>{const l=d[0],R=new s(d[1]);this.$(l,R)})}$acceptDefaultProfile(u,d){const l=this.s;this.s=u,this.u=d,l?.path!==u.path&&this.N.fire(u.path)}$(u,d){this.n.set(u,d),d.onDidChangeCollection(()=>{this.Z(u,d)})}};e.$bcc=r,e.$bcc=r=Ke([Ve(1,c.$tM),Ve(2,A.$0L)],r);class s{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new w.$Md,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const d=this.h(u);let l=this.a.get(d);return l||(l=new i(this,u),this.a.set(d,l),l.onDidChangeCollection(()=>this.d.fire())),l}replace(u,d,l,R){this.f(u,{value:d,type:E.EnvironmentVariableMutatorType.Replace,options:l??{applyAtProcessCreation:!0},scope:R})}append(u,d,l,R){this.f(u,{value:d,type:E.EnvironmentVariableMutatorType.Append,options:l??{applyAtProcessCreation:!0},scope:R})}prepend(u,d,l,R){this.f(u,{value:d,type:E.EnvironmentVariableMutatorType.Prepend,options:l??{applyAtProcessCreation:!0},scope:R})}f(u,d){if(d.options&&d.options.applyAtProcessCreation===!1&&!d.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const l=this.g(u,d.scope),R=this.map.get(l),B=d.options?{applyAtProcessCreation:d.options.applyAtProcessCreation??!1,applyAtShellIntegration:d.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!R||R.value!==d.value||R.type!==d.type||R.options?.applyAtProcessCreation!==B.applyAtProcessCreation||R.options?.applyAtShellIntegration!==B.applyAtShellIntegration||R.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index){const V=this.g(u,d.scope),U={variable:u,...d,options:B};this.map.set(V,U),this.d.fire()}}get(u,d){const l=this.g(u,d),R=this.map.get(l);return R?S(R):void 0}g(u,d){const l=this.h(d);return l.length?`${u}:::${l}`:u}h(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const d=new Map;for(const[l,R]of this.map)this.h(R.scope)===this.h(u)&&d.set(R.variable,S(R));return d}delete(u,d){const l=this.g(u,d);this.map.delete(l),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[d,l]of this.map)l.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(d);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,d){const l=this.h(d),R=this.descriptionMap.get(l);if(!R||R.description!==u){let B;typeof u=="string"?B=u:B=u?.value.split(`

`)[0];const V={description:B,scope:d};this.descriptionMap.set(l,V),this.d.fire()}}getDescription(u){const d=this.h(u);return this.descriptionMap.get(d)?.description}k(u){const d=this.h(u);this.descriptionMap.delete(d)}}class i{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,d){this.b=u,this.d=d,this.a=new w.$Md}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,d,l){this.b.replace(u,d,l,this.d)}append(u,d,l){this.b.append(u,d,l,this.d)}prepend(u,d,l){this.b.prepend(u,d,l,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,d){this.b.getVariableMap(this.d).forEach((l,R)=>u.call(d,R,l,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends r{constructor(u,d){super(!1,u,d)}createTerminal(u,d,l){throw new P.$$}createTerminalFromOptions(u,d){throw new P.$$}};e.$ccc=o,e.$ccc=o=Ke([Ve(0,c.$tM),Ve(1,A.$0L)],o);function y(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function $(I){return f.ThemeColor.isThemeColor(I)?I:void 0}function S(I){const u={...I};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Ae[252],Re([1,0,281,13,25,21,5,202,93,6,24,16,36,3,17,104,8,7,45,76,57,26]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=e.$ldc=e.$kdc=e.$jdc=void 0;let r=class{constructor(U,W,N){this.k=N,this.d=new A.$Md,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=U.getProxy(b.$9J.MainThreadTesting),this.j=new l(this.g),this.h=new y(this.g),W.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const ee=O,Z=ee.tests[ee.tests.length-1].item.extId;return this.f.get(c.$2I.root(Z))?.collection.tree.get(Z)?.actual??(0,f.$jM)(O)}case 18:{const{extId:ee,message:Z}=O;return{test:this.f.get(c.$2I.root(ee))?.collection.tree.get(ee)?.actual,message:t.TestMessage.to(Z)}}default:return O}}}),W.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await W.executeCommand("_testing.getExplorerSelection"),ee=Z=>{const ye=this.f.get(c.$2I.root(Z));if(ye)return c.$2I.isRoot(Z)?ye.controller:ye.collection.tree.get(Z)?.actual};return{include:O?.include.map(ee).filter(k.$Ff)||[],exclude:O?.exclude.map(ee).filter(k.$Ff)||[]}})}createTestController(U,W,N,O){if(this.f.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const ee=new g.$Qc,Z=ee.add(new f.$mM(W,N,this.k));Z.root.label=N;const ye=new Map,De=this.g,Pe={items:Z.root.children,get label(){return N},set label(le){N=le,Z.root.label=le,De.$updateController(W,{label:N})},get refreshHandler(){return O},set refreshHandler(le){O=le,De.$updateController(W,{canRefresh:!!le})},get id(){return W},createRunProfile:(le,Ee,ce,$e,ie,z)=>{let q=(0,E.$Bi)(le);for(;ye.has(q);)q++;return new R(this.g,ye,W,q,le,Ee,ce,$e,ie,z)},createTestItem(le,Ee,ce){return new f.$kM(W,le,Ee,ce)},createTestRun:(le,Ee,ce=!0)=>this.h.createTestRun(U,W,Z,le,Ee,ce),invalidateTestResults:le=>{if(le===void 0)this.g.$markTestRetired(void 0);else{const Ee=le instanceof Array?le:[le];this.g.$markTestRetired(Ee.map(ce=>c.$2I.fromExtHostTestItem(ce,W).toString()))}},set resolveHandler(le){Z.resolveHandler=le},get resolveHandler(){return Z.resolveHandler},dispose:()=>{ee.dispose()}};De.$registerTestController(W,N,!!O),ee.add((0,g.$Pc)(()=>De.$unregisterTestController(W)));const X={controller:Pe,collection:Z,profiles:ye,extension:U};return this.f.set(W,X),ee.add((0,g.$Pc)(()=>this.f.delete(W))),ee.add(Z.onDidGenerateDiff(le=>De.$publishDiff(W,le.map(D.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(U,W=F.CancellationToken.None){const N=$(U);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.f.get(N.controllerId);if(!O)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(ee=>c.$2I.fromExtHostTestItem(ee,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:B[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:U.exclude?.map(ee=>ee.id)},W)}$syncTests(){for(const{collection:U}of this.f.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,W,N){return(0,w.$qb)(this.h.trackers,ee=>ee.id===U?ee.getCoverage(W):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(U,W,N,O){return(0,w.$qb)(this.h.trackers,Z=>Z.id===U?Z.getCoverage(W):void 0)?.resolveFileCoverage(N,O)??Promise.resolve([])}$configureRunProfile(U,W){this.f.get(U)?.profiles.get(W)?.configureHandler?.()}async $refreshTests(U,W){await this.f.get(U)?.controller.refreshHandler?.(W)}$publishTestResults(U){this.results=Object.freeze(U.map(W=>(0,P.$Zm)(t.TestResults.to(W))).concat(this.results).sort((W,N)=>N.completedAt-W.completedAt).slice(0,32)),this.d.fire()}async $expandTest(U,W){const N=this.f.get(c.$2I.fromString(U).controllerId)?.collection;N&&(await N.expand(U,W<0?1/0:W),N.flushDiff())}$acceptDiff(U){this.j.applyDiff(U.map(D.TestsDiffOp.deserialize))}async $runControllerTests(U,W){return Promise.all(U.map(N=>this.l(N,!1,W)))}async $startContinuousRun(U,W){const N=new F.$Wd(W),O=await Promise.all(U.map(ee=>this.l(ee,!0,N.token)));return!W.isCancellationRequested&&!O.some(ee=>ee.error)&&await new Promise(ee=>W.onCancellationRequested(ee)),N.dispose(!0),O}async l(U,W,N){const O=this.f.get(U.controllerId);if(!O)return{};const{collection:ee,profiles:Z,extension:ye}=O,De=Z.get(U.profileId);if(!De)return{};const Pe=U.testIds.map(ce=>ee.tree.get(ce)).filter(k.$Ff),X=U.excludeExtIds.map(ce=>O.collection.tree.get(ce)).filter(k.$Ff).filter(ce=>Pe.some($e=>$e.fullId.compare(ce.fullId)===2));if(!Pe.length)return{};const le=new n.$GL(Pe.some(ce=>ce.actual instanceof f.$lM)?void 0:Pe.map(ce=>ce.actual),X.map(ce=>ce.actual),De,W),Ee=(0,D.$4I)(U)&&this.h.prepareForMainThreadTestRun(le,S.fromInternal(U,O.collection),ye,N);try{return await De.runHandler(le,N),{}}catch(ce){return{error:String(ce)}}finally{Ee&&(Ee.hasRunningTasks&&!N.isCancellationRequested&&await A.Event.toPromise(Ee.onEnd),Ee.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.h.cancelAllRuns():this.h.cancelRunById(U)}};e.$jdc=r,e.$jdc=r=Ke([Ve(0,m.$0L)],r);const s=1e4;var i;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(i||(i={}));class o extends g.$Rc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(U,W,N,O){super(),this.s=U,this.u=W,this.w=N,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$Md),this.onEnd=this.m.event,this.j=this.B(new F.$Wd(O));const ee=this.B(new M.$5g(()=>this.y(),s));this.B(this.j.token.onCancellationRequested(()=>ee.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(U){return this.g.get(U)?.coverage}createRun(U){const W=this.s.id,N=this.s.controllerId,O=(0,a.$dg)(),ee=new I(this.u,W,O),Z=X=>(le,...Ee)=>{if(De){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}this.s.isIncluded(le)&&(this.C(le),X(le,...Ee))},ye=(X,le)=>{const Ee=le instanceof Array?le.map(t.TestMessage.from):[t.TestMessage.from(le)];if(Ee.some(ce=>ce.contextValue!==void 0)&&(0,p.$9E)(this.w,"testMessageContextValue"),X.uri&&X.range){const ce={range:t.Range.from(X.range),uri:X.uri};for(const $e of Ee)$e.location=$e.location||ce}this.u.$appendTestMessagesInRun(W,O,c.$2I.fromExtHostTestItem(X,N).toString(),Ee)};let De=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:U,get coverageProvider(){return ee.coverageProvider},set coverageProvider(X){ee.coverageProvider=X},enqueued:Z(X=>{this.u.$updateTestStateInRun(W,O,c.$2I.fromExtHostTestItem(X,N).toString(),1)}),skipped:Z(X=>{this.u.$updateTestStateInRun(W,O,c.$2I.fromExtHostTestItem(X,N).toString(),5)}),started:Z(X=>{this.u.$updateTestStateInRun(W,O,c.$2I.fromExtHostTestItem(X,N).toString(),2)}),errored:Z((X,le,Ee)=>{ye(X,le),this.u.$updateTestStateInRun(W,O,c.$2I.fromExtHostTestItem(X,N).toString(),6,Ee)}),failed:Z((X,le,Ee)=>{ye(X,le),this.u.$updateTestStateInRun(W,O,c.$2I.fromExtHostTestItem(X,N).toString(),4,Ee)}),passed:Z((X,le)=>{this.u.$updateTestStateInRun(W,O,c.$2I.fromExtHostTestItem(X,this.s.controllerId).toString(),3,le)}),appendOutput:(X,le,Ee)=>{De||(Ee&&(this.s.isIncluded(Ee)?this.C(Ee):Ee=void 0),this.u.$appendOutputToRun(W,O,C.$ae.fromString(X),le&&t.location.from(le),Ee&&c.$2I.fromExtHostTestItem(Ee,N).toString()))},end:()=>{De||(De=!0,this.u.$finishedTestRunTask(W,O),this.g.delete(O),this.g.size||this.z())}};return this.g.set(O,{run:Pe,coverage:ee}),this.u.$startedTestRunTask(W,{id:O,name:U,running:!0}),Pe}y(){for(const{run:U}of this.g.values())U.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(U){if(!(U instanceof f.$kM))throw new v.$2L(U.id);if(this.h.has(c.$2I.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const W=[],N=this.s.colllection.root;for(;;){const O=t.TestItem.from(U);if(W.unshift(O),this.h.has(O.extId)||(this.h.add(O.extId),U===N))break;U=U.parent||N}this.u.$addTestsToRun(this.s.controllerId,this.s.id,W)}dispose(){this.z(),super.dispose()}}class y{get trackers(){return this.d.values()}constructor(U){this.f=U,this.d=new Map}prepareForMainThreadTestRun(U,W,N,O){return this.g(U,W,N,O)}cancelRunById(U){for(const W of this.d.values())if(W.id===U){W.cancel();return}}cancelAllRuns(){for(const U of this.d.values())U.cancel()}createTestRun(U,W,N,O,ee,Z){const ye=this.d.get(O);if(ye)return ye.createRun(ee);const De=S.fromPublic(W,N,O,Z),Pe=$(O);this.f.$startedExtensionTestRun({controllerId:W,continuous:!!O.continuous,profile:Pe&&{group:B[Pe.kind],id:Pe.profileId},exclude:O.exclude?.map(le=>c.$2I.fromExtHostTestItem(le,N.root.id).toString())??[],id:De.id,include:O.include?.map(le=>c.$2I.fromExtHostTestItem(le,N.root.id).toString())??[N.root.id],persist:Z});const X=this.g(O,De,U);return A.Event.once(X.onEnd)(()=>{this.f.$finishedExtensionTestRun(De.id),X.dispose()}),X.createRun(ee)}g(U,W,N,O){const ee=new o(W,this.f,N,O);return this.d.set(U,ee),A.Event.once(ee.onEnd)(()=>this.d.delete(U)),ee}}e.$kdc=y;const $=V=>{if(V.profile){if(!(V.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class S{static fromPublic(U,W,N,O){return new S(U,(0,a.$dg)(),N.include?.map(ee=>c.$2I.fromExtHostTestItem(ee,U).toString())??[U],N.exclude?.map(ee=>c.$2I.fromExtHostTestItem(ee,U).toString())??[],O,W)}static fromInternal(U,W){return new S(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,W)}constructor(U,W,N,O,ee,Z){this.controllerId=U,this.id=W,this.isPersisted=ee,this.colllection=Z,this.d=N.map(ye=>ye+"\0"),this.f=O.map(ye=>ye+"\0")}isIncluded(U){const W=c.$2I.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const N of this.f)if(W===N||W.startsWith(N))return!1;for(const N of this.d)if(W===N||W.startsWith(N))return!0;return!1}}e.$ldc=S;class I{set coverageProvider(U){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.d=U,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(U,W,N){this.g=U,this.h=W,this.j=N}async provideFileCoverage(U){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(U))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(W){throw this.f=void 0,W}}async resolveFileCoverage(U,W){const N=await this.f;let O=N?.[U];return!this.d||!N||!O?[]:(O.detailedCoverage||(O=N[U]=await this.d.resolveFileCoverage?.(O,W)??O),O.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.d.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.d.has(U)||this.f.add(U)}remove(U){if(this.d.has(U)){this.d.delete(U);return}this.f.delete(U);const W=c.$2I.parentId(U.item.extId);if(W&&this.h.has(W.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{d:U,f:W,g:N}=this;return{get added(){return[...U].map(O=>O.revived)},get updated(){return[...W].map(O=>O.revived)},get removed(){return[...N].map(O=>O.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class d extends D.$9I{constructor(){super(...arguments),this.s=new A.$Md,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}q(U,W){return{...U,revived:t.TestItem.toPlain(U.item),depth:W?W.depth+1:0,children:new Set}}p(){return new u(this.s)}}class l{constructor(U){this.f=U}checkout(){this.d||(this.d=this.g());const U=this.d;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(W=>W.revived)},dispose:(0,h.$cb)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(U){return this.d?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.d?.tests.apply(U)}g(){const U=new d;return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}class R{#e;#t;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(U){U!==this.h&&(this.h=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.g}set isDefault(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.d}set configureHandler(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,W,N,O,ee,Z,ye,De=!1,Pe=void 0,X=!1){this.controllerId=N,this.profileId=O,this.f=ee,this.kind=Z,this.runHandler=ye,this.g=De,this._tag=Pe,this.h=X,this.#e=U,this.#t=W,W.set(O,this);const le=B[Z];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);this.#e.$publishTestRunProfile({profileId:O,controllerId:N,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:ee,group:le,isDefault:De,hasConfigurationHandler:!1,supportsContinuousRun:X})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$mdc=R;const B={[n.TestRunProfileKind.Coverage]:8,[n.TestRunProfileKind.Debug]:4,[n.TestRunProfileKind.Run]:2}}),define(Ae[253],Re([1,0,18,9,5,3,105,8,7]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class g{constructor(k,a){this.i=a,this.a=new C.$Md({onListenerError:M.$1}),this.b=new C.$Md({onListenerError:M.$1}),this.c=new C.$Md({onListenerError:M.$1}),this.d=new C.$Md({onListenerError:M.$1}),this.f=new C.$Md({onListenerError:M.$1}),this.g=new C.$Md({onListenerError:M.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(F.$9J.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const a=this.i.allEditors();return k?a:a.map(b=>b.value)}async showTextDocument(k,a,b){let m;typeof a=="number"?m={position:h.ViewColumn.from(a),preserveFocus:b}:typeof a=="object"?m={position:h.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?h.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:m={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(k.uri,m),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,a){return new A.$eM(this.h,k,a).value}$acceptEditorPropertiesChanged(k,a){const b=this.i.getEditor(k);if(!b)throw new Error("unknown text editor");if(a.options&&b._acceptOptions(a.options),a.selections){const m=a.selections.selections.map(h.Selection.to);b._acceptSelections(m)}if(a.visibleRanges){const m=w.$Gb(a.visibleRanges.map(h.Range.to));b._acceptVisibleRanges(m)}if(a.options&&this.b.fire({textEditor:b.value,options:{...a.options,lineNumbers:h.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const m=E.TextEditorSelectionChangeKind.fromValue(a.selections.source),f=a.selections.selections.map(h.Selection.to);this.a.fire({textEditor:b.value,selections:f,kind:m})}if(a.visibleRanges){const m=w.$Gb(a.visibleRanges.map(h.Range.to));this.c.fire({textEditor:b.value,visibleRanges:m})}}$acceptEditorPositionData(k){for(const a in k){const b=this.i.getEditor(a);if(!b)throw new Error("Unknown text editor");const m=h.ViewColumn.to(k[a]);b.value.viewColumn!==m&&(b._acceptViewColumn(m),this.d.fire({textEditor:b.value,viewColumn:m}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$Bcc=g}),define(Ae[254],Re([1,0,2,4,3,6,7,8,20,16]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=e.$ddc=void 0,e.$ddc=(0,M.$Nh)("IExtHostTimeline");class P{constructor(b,m){this.b=new Map,this.c=new Map,this.a=b.getProxy(C.$9J.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&E.$Yl.equals(t,this.b.get(f.source)?.extension)){const n=f.uri===void 0?void 0:w.URI.revive(f.uri);return this.c.get(f.source)?.get(k(n))?.get(f.handle)}else return;return f}})}async $getTimeline(b,m,f,t){return this.b.get(b)?.provider.provideTimeline(w.URI.revive(m),f,t)}registerTimelineProvider(b,m,f,t){const n=new F.$Qc,c=this.d(m.id,t,n).bind(this);let v;m.onDidChange&&(v=m.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:m.id}),this));const D=this.c;return this.f({...m,scheme:b,onDidChange:void 0,async provideTimeline(p,r,s){r?.resetCache&&(n.clear(),D.get(m.id)?.clear());const i=await m.provideTimeline(p,r,s);if(i==null)return;const o=c(p,r);return{...i,source:m.id,items:i.items.map(o)}},dispose(){for(const p of D.values())p.get(m.id)?.clear();v?.dispose(),n.dispose()}},f)}d(b,m,f){return(t,n)=>{let c;if(n?.cacheResults){let v=this.c.get(b);v===void 0&&(v=new Map,this.c.set(b,v));const D=k(t);c=v.get(D),c===void 0&&(c=new Map,v.set(D,c))}return v=>{const{iconPath:D,...p}=v,r=`${b}|${v.id??v.timestamp}`;c?.set(r,v);let s,i,o;v.iconPath&&(D instanceof A.$5K?o={id:D.id,color:D.color}:w.URI.isUri(D)?(s=D,i=D):{light:s,dark:i}=D);let y;return A.$yK.isMarkdownString(p.tooltip)?y=h.MarkdownString.from(p.tooltip):(0,g.$xf)(p.tooltip)?y=p.tooltip:A.$yK.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=h.MarkdownString.from(p.detail)):(0,g.$xf)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=p.detail),{...p,id:p.id??void 0,handle:r,source:b,command:v.command?m.toInternal(v.command,f):void 0,icon:s,iconDark:i,themeIcon:o,tooltip:y,accessibilityInformation:v.accessibilityInformation}}}}f(b,m){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:m}),(0,F.$Pc)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$edc=P;function k(a){return a?.toString()}}),define(Ae[86],Re([1,0,21,5,6,157,4,14,184,3,27,17,7]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Svb=e.$Rvb=e.TunnelDtoConverter=void 0;class b extends E.$_u{}var m;(function(t){function n(v){return{remoteAddress:v.remoteAddress,localAddress:v.localAddress,public:!!v.public,privacy:v.privacy??(v.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:v.protocol}}t.fromApiTunnel=n;function c(v){return{remoteAddress:{host:v.tunnelRemoteHost,port:v.tunnelRemotePort},localAddress:v.localAddress,public:v.privacy!==E.TunnelPrivacyId.ConstantPrivate&&v.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:v.privacy,protocol:v.protocol}}t.fromServiceTunnel=c})(m||(e.TunnelDtoConverter=m={})),e.$Rvb=(0,A.$Nh)("IExtHostTunnelService");let f=class extends C.$Rc{constructor(n,c,v){super(),this.s=v,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Md,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=n.getProxy(g.$9J.MainThreadTunnelService)}async openTunnel(n,c){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${n.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const v=await this.a.$openTunnel(c,n.displayName);if(v){const D=new b(v.remoteAddress,v.localAddress,()=>this.a.$closeTunnel(v.remoteAddress));return this.B(D),D}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(n,c){const v=this.u();return this.r.set(v,{selector:n,provider:c}),this.a.$registerPortsAttributesProvider(n,v),new a.$$J(()=>{this.r.delete(v),this.a.$unregisterPortsAttributesProvider(v)})}async $providePortAttributes(n,c,v,D,p){const r=[];for(const i of n){const o=this.r.get(i);if(!o)return[];r.push(...await Promise.all(c.map(async y=>{let $;try{$=await o.provider.providePortAttributes({port:y,pid:v,commandLine:D},p)}catch{$=await o.provider.providePortAttributes(y,v,D,p)}return{providedAttributes:$,port:y}})))}const s=r.filter(i=>!!i.providedAttributes);return s.length>0?s.map(i=>({autoForwardAction:i.providedAttributes.autoForwardAction,port:i.port})):[]}async $registerCandidateFinder(n){}registerTunnelProvider(n,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(D,p)=>await n.provideTunnel(D,p,new w.$Wd().token)??void 0;const v=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(v),Promise.resolve((0,C.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(n,c){if(n){n.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(n.candidatePortSource),n.showCandidatePort&&(this.f=n.showCandidatePort,this.a.$setCandidateFilter());const v=n.tunnelFactory??(c?this.w(c):void 0);if(v){this.b=v;let D=n.tunnelFeatures?.privacyOptions??[];n.tunnelFeatures?.public&&D.length===0&&(D=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const p=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,public:!!n.tunnelFeatures?.public,privacyOptions:D}:void 0;this.a.$setTunnelProvider(p)}}else this.b=void 0;return(0,C.$Pc)(()=>{this.b=void 0})}w(n){}async $closeTunnel(n,c){if(this.g.has(n.host)){const v=this.g.get(n.host);v.has(n.port)&&(c&&v.get(n.port).disposeListener.dispose(),await v.get(n.port).tunnel.dispose(),v.delete(n.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(n,c){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const v=this.b(n,c);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),v!==void 0){const D=await v;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),D===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(n.remoteAddress.host)||this.g.set(n.remoteAddress.host,new Map);const p=this.B(D.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(D.remoteAddress))));return this.g.get(n.remoteAddress.host).set(n.remoteAddress.port,{tunnel:D,disposeListener:p}),m.fromApiTunnel(D)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(v){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),v instanceof Error)return v.message}}async $applyCandidateFilter(n){const c=await Promise.all(n.map(D=>this.f(D.host,D.port,D.detail??""))),v=n.filter((D,p)=>c[p]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${n.map(D=>D.port).join(", ")} to ${v.map(D=>D.port).join(", ")}`),v}};e.$Svb=f,e.$Svb=f=Ke([Ve(0,k.$0L),Ve(1,P.$nM),Ve(2,h.$8i)],f)}),define(Ae[255],Re([1,0,6,12,2,3]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;class A{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(F.$9J.MainThreadUriOpeners)}registerExternalUriOpener(E,g,P,k){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const a=k.schemes.find(b=>!A.a.has(b));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(g,P),this.b.$registerUriOpener(g,k.schemes,E,k.label),(0,w.$Pc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(E,g,P){const k=this.c.get(E);if(!k)throw new Error(`Unknown opener with id: ${E}`);const a=C.URI.revive(g);return k.canOpenExternalUri(a,P)}async $openUri(E,g,P){const k=this.c.get(E);if(!k)throw new Error(`Unknown opener id: '${E}'`);return k.openExternalUri(C.URI.revive(g.resolvedUri),{sourceUri:C.URI.revive(g.sourceUri)},P)}}e.$ndc=A}),define(Ae[256],Re([1,0,3,2,6,9,20]),function(be,e,w,M,C,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;class h{static{this.a=0}constructor(g){this.c=new A.$Zl,this.d=new Map,this.b=g.getProxy(w.$9J.MainThreadUrls)}registerUriHandler(g,P){const k=g.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const a=h.a++;return this.c.add(k),this.d.set(a,P),this.b.$registerUriHandler(a,k,g.displayName||g.name),(0,C.$Pc)(()=>{this.c.delete(k),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(g,P){const k=this.d.get(g);if(!k)return Promise.resolve(void 0);try{k.handleUri(M.URI.revive(P))}catch(a){(0,F.$Z)(a)}return Promise.resolve(void 0)}async createAppUri(g){return M.URI.revive(await this.b.$createAppUri(g))}}e.$Dcc=h}),define(Ae[64],Re([1,0,5,6,12,24,2,169,191,77,3]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=e.$Hcc=e.$Gcc=e.$Fcc=e.$Ecc=void 0;class k{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(D,p,r,s,i,o,y){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.$Md,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$Md,this._onDidDispose=this.#h.event,this.#e=D,this.#t=p,this.#r=r,this.#l=s,this.#u=i,this.#n=o,this.#c=a(o),this.#d=b(o),this.#i=y}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(D){return this.#a=!0,(0,g.$Vob)(D,this.#l)}get cspSource(){const D=this.#n.extensionLocation;if(D.scheme===C.Schemas.https||D.scheme===C.Schemas.http){let p=D.toString();return p.endsWith("/")||(p+="/"),p+" "+g.$Uob}return g.$Uob}get html(){return this.a(),this.#s}set html(D){this.a(),this.#s!==D&&(this.#s=D,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(D)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(D)))}get options(){return this.a(),this.#r}set options(D){this.a(),F.$3m(this.#r,D)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,D)),this.#r=D}async postMessage(D){if(this.#o)return!1;const p=(0,E.$mcb)(D,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,p.message,...p.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(D){if(!this.#d)return D;const p=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return D.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,i,o,y,$,S)=>{const I=A.URI.from({scheme:y||"file",path:decodeURIComponent($)}),u=(0,g.$Vob)(I,{isRemote:p,authority:r}).toString();return`${i}${u}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,i,o,y,$,S)=>{const I=A.URI.from({scheme:y||"file",path:decodeURIComponent($)}),u=(0,g.$Vob)(I,{isRemote:p,authority:r}).toString();return`${i}${u}${S}`})}}e.$Ecc=k;function a(v){try{const D=(0,h.$Go)((0,h.$Fo)(v.engines.vscode));return!!D&&D.majorBase>=1&&D.minorBase>=57}catch{return!1}}e.$Fcc=a;function b(v){try{const D=(0,h.$Go)((0,h.$Fo)(v.engines.vscode));return D?D.majorBase<1||D.majorBase===1&&D.minorBase<60:!1}catch{return!1}}class m extends M.$Rc{constructor(D,p,r,s,i){super(),this.c=p,this.f=r,this.g=s,this.h=i,this.b=new Map,this.a=D.getProxy(P.$9J.MainThreadWebviews)}dispose(){super.dispose();for(const D of this.b.values())D.dispose();this.b.clear()}$onMessage(D,p,r){const s=this.j(D);if(s){const{message:i}=(0,E.$ncb)(p,r.value);s._onMessageEmitter.fire(i)}}$onMissingCsp(D,p){this.g.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(D,p,r){const s=new k(D,this.a,n(p),this.c,this.f,r,this.h);this.b.set(D,s);const i=s._onDidDispose(()=>{i.dispose(),this.deleteWebview(D)});return s}deleteWebview(D){this.b.delete(D)}j(D){return this.b.get(D)}}e.$Gcc=m;function f(v){return{id:v.identifier,location:v.extensionLocation}}e.$Hcc=f;function t(v,D,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||c(v,D)}}e.$Icc=t;function n(v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots?.map(D=>A.URI.from(D))}}function c(v,D){return[...(D?.getWorkspaceFolders()||[]).map(p=>p.uri),v.extensionLocation]}}),define(Ae[257],Re([1,0,21,93,6,12,23,2,8,64,55,3,7]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;class b{constructor(s,i){this.document=s,this.b=i,this.a=1,this.c=new P.$Abc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,i){await this.f(s).undo(),i||this.disposeBackup()}async redo(s,i){await this.f(s).redo(),i||this.disposeBackup()}disposeEdits(s){for(const i of s)this.c.delete(i)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=p(this.document.uri)+this.a++;return(0,A.$ug)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const i=this.c.get(s,0);if(!i)throw new Error("No edit found");return i}}class m{constructor(){this.a=new Map}get(s,i){return this.a.get(this.b(s,i))}add(s,i,o){const y=this.b(s,i.uri);if(this.a.has(y))throw new Error(`Document already exists for viewType:${s} resource:${i.uri}`);const $=new b(i,o);return this.a.set(y,$),$}delete(s,i){const o=this.b(s,i.uri);this.a.delete(o)}b(s,i){return`${s}@@@${i}`}}var f;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this.a=new Map}addTextProvider(s,i,o){return this.b(0,s,i,o)}addCustomProvider(s,i,o){return this.b(1,s,i,o)}get(s){return this.a.get(s)}b(s,i,o,y){if(this.a.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this.a.set(i,{type:s,extension:o,provider:y}),new a.$$J(()=>this.a.delete(i))}}class n{constructor(s,i,o,y,$){this.d=i,this.f=o,this.g=y,this.h=$,this.b=new t,this.c=new m,this.a=s.getProxy(k.$9J.MainThreadCustomEditors)}registerCustomEditorProvider(s,i,o,y){const $=new C.$Qc;return v(o)?($.add(this.b.addTextProvider(i,s,o)),this.a.$registerTextEditorProvider((0,g.$Hcc)(s),i,y.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,g.$Fcc)(s))):($.add(this.b.addCustomProvider(i,s,o)),c(o)&&$.add(o.onDidChangeCustomDocument(S=>{const I=this.i(i,S.document.uri);if(D(S)){const u=I.addEdit(S);this.a.$onDidEdit(S.document.uri,i,u,S.label)}else this.a.$onContentChange(S.document.uri,i)})),this.a.$registerCustomEditorProvider((0,g.$Hcc)(s),i,y.webviewOptions||{},!!y.supportsMultipleEditorsPerDocument,(0,g.$Fcc)(s))),a.$$J.from($,new a.$$J(()=>{this.a.$unregisterEditorProvider(i)}))}async $createCustomDocument(s,i,o,y,$){const S=this.b.get(i);if(!S)throw new Error(`No provider found for '${i}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${i}'`);const I=h.URI.revive(s),u=await S.provider.openCustomDocument(I,{backupId:o,untitledDocumentData:y?.buffer},$);let d;return c(S.provider)&&this.f&&(d=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(i,u,d),{editable:c(S.provider)}}async $disposeCustomDocument(s,i){const o=this.b.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${i}'`);const y=h.URI.revive(s),{document:$}=this.i(i,y);this.c.delete(i,$),$.dispose()}async $resolveCustomEditor(s,i,o,y,$,S){const I=this.b.get(o);if(!I)throw new Error(`No provider found for '${o}'`);const u=E.ViewColumn.to($),d=this.g.createNewWebview(i,y.contentOptions,I.extension),l=this.h.createNewWebviewPanel(i,o,y.title,u,y.options,d,y.active),R=h.URI.revive(s);switch(I.type){case 1:{const{document:B}=this.i(o,R);return I.provider.resolveCustomEditor(B,l,S)}case 0:{const B=this.d.getDocument(R);return I.provider.resolveCustomTextEditor(B,l,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,i,o){this.i(i,s).disposeEdits(o)}async $onMoveCustomEditor(s,i,o){const y=this.b.get(o);if(!y)throw new Error(`No provider found for '${o}'`);if(!y.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const $=this.h.getWebviewPanel(s);if(!$)throw new Error("No webview found");const S=h.URI.revive(i),I=this.d.getDocument(S);await y.provider.moveCustomTextEditor(I,$,w.CancellationToken.None)}async $undo(s,i,o,y){return this.i(i,s).undo(o,y)}async $redo(s,i,o,y){return this.i(i,s).redo(o,y)}async $revert(s,i,o){const y=this.i(i,s);await this.j(i).revertCustomDocument(y.document,o),y.disposeBackup()}async $onSave(s,i,o){const y=this.i(i,s);await this.j(i).saveCustomDocument(y.document,o),y.disposeBackup()}async $onSaveAs(s,i,o,y){const $=this.i(i,s);return this.j(i).saveCustomDocumentAs($.document,h.URI.revive(o),y)}async $backup(s,i,o){const y=this.i(i,s),S=await this.j(i).backupCustomDocument(y.document,{destination:y.getNewBackupUri()},o);return y.updateBackup(S),S.id}i(s,i){const o=this.c.get(s,h.URI.revive(i));if(!o)throw new Error("No custom document found");return o}j(s){const o=this.b.get(s)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.$hdc=n;function c(r){return!!r.onDidChangeCustomDocument}function v(r){return typeof r.resolveCustomTextEditor=="function"}function D(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function p(r){const s=r.scheme===F.Schemas.file||r.scheme===F.Schemas.untitled?r.fsPath:r.toString();return(0,M.$Bi)(s)+""}}),define(Ae[258],Re([1,0,5,6,2,36,8,64,3,7]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;class P extends M.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(m,f,t,n){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new w.$Md),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$Md),this.onDidChangeViewState=this.#h.event,this.#e=m,this.#t=f,this.#l=t,this.#i=n.viewType,this.#u=n.panelOptions,this.#r=n.viewColumn,this.#n=n.title,this.#a=n.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(m){this.c(),this.#n!==m&&(this.#n=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.c(),this.#s}set iconPath(m){this.c(),this.#s!==m&&(this.#s=m,this.#t.$setIconPath(this.#e,C.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(m){this.#c||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#a=m.active,this.#o=m.visible,this.#r=m.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(m,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:A.ViewColumn.from(m),preserveFocus:!!f})}c(){if(this.#c)throw new Error("Webview is disposed")}}class k extends M.$Rc{static c(){return(0,F.$dg)()}constructor(m,f,t){super(),this.j=f,this.m=t,this.g=new Map,this.h=new Map,this.f=m.getProxy(E.$9J.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(m=>m.dispose()),this.g.clear()}createWebviewPanel(m,f,t,n,c={}){const v=typeof n=="object"?n.viewColumn:n,D={viewColumn:A.ViewColumn.from(v),preserveFocus:typeof n=="object"&&!!n.preserveFocus},p=(0,h.$Fcc)(m),r=k.c();this.f.$createWebviewPanel((0,h.$Hcc)(m),r,f,{title:t,panelOptions:a(c),webviewOptions:(0,h.$Icc)(m,this.m,c),serializeBuffersForPostMessage:p},D);const s=this.j.createNewWebview(r,c,m);return this.createNewWebviewPanel(r,f,t,v,c,s,!0)}$onDidChangeWebviewPanelViewStates(m){const f=Object.keys(m);f.sort((t,n)=>{const c=m[t],v=m[n];return c.active?1:v.active?-1:+c.visible-+v.visible});for(const t of f){const n=this.getWebviewPanel(t);if(!n)continue;const c=m[t];n._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.g.delete(m),this.j.deleteWebview(m)}registerWebviewPanelSerializer(m,f,t){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:t,extension:m}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,h.$Fcc)(m)}),new g.$$J(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(m,f,t,n){const c=this.h.get(f);if(!c)throw new Error(`No serializer found for '${f}'`);const{serializer:v,extension:D}=c,p=this.j.createNewWebview(m,t.webviewOptions,D),r=this.createNewWebviewPanel(m,f,t.title,n,t.panelOptions,p,t.active);await v.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel(m,f,t,n,c,v,D){const p=new P(m,this.f,v,{viewType:f,title:t,viewColumn:n,panelOptions:c,active:D});return this.g.set(m,p),p}getWebviewPanel(m){return this.g.get(m)}}e.$gdc=k;function a(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Ae[259],Re([1,0,5,6,64,8,3,7]),function(be,e,w,M,C,F,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=void 0;class E extends M.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(k,a,b,m,f,t){super(),this.#u=!1,this.#a=this.B(new w.$Md),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new w.$Md),this.onDidDispose=this.#c.event,this.#i=b,this.#s=m,this.#e=k,this.#t=a,this.#l=f,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#r}set description(k){this.a(),this.#r!==k&&(this.#r=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#u||(this.#n=k,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(k){this.a(),!(k?.value===this.#o?.value&&k?.tooltip===this.#o?.tooltip)&&(this.#o=F.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#u)throw new Error("Webview is disposed")}}class g{constructor(k,a){this.d=a,this.b=new Map,this.c=new Map,this.a=k.getProxy(A.$9J.MainThreadWebviewViews)}registerWebviewViewProvider(k,a,b,m){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:b,extension:k}),this.a.$registerWebviewViewProvider((0,C.$Hcc)(k),a,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Fcc)(k)}),new h.$$J(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(k,a,b,m,f){const t=this.b.get(a);if(!t)throw new Error(`No view provider found for '${a}'`);const{provider:n,extension:c}=t,v=this.d.createNewWebview(k,{},c),D=new E(k,this.a,a,b,v,!0);this.c.set(k,D),await n.resolveWebviewView(D,{state:m},f)}async $onDidChangeWebviewViewVisibility(k,a){this.e(k)._setVisible(a)}async $disposeWebviewView(k){const a=this.e(k);this.c.delete(k),a.dispose(),this.d.deleteWebview(k)}e(k){const a=this.c.get(k);if(!a)throw new Error("No webview found");return a}}e.$fdc=g}),define(Ae[108],Re([1,0,5,3,2,12,15,4,17,26]),function(be,e,w,M,C,F,A,h,E,g){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=void 0;let k=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(b){const m=this.d;return{get focused(){return m.focused},get active(){return(0,g.$9E)(b,"windowActivity"),m.active}}}constructor(b){this.c=new w.$Md,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=b.getProxy(M.$9J.MainThreadWindow),this.b.$getInitialState().then(({isFocused:m,isActive:f})=>{this.onDidChangeWindowProperty("focused",m),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,m){m!==this.d[b]&&(this.d={...this.d,[b]:m},this.c.fire(this.d))}openUri(b,m){let f;if(typeof b=="string"){f=b;try{b=C.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$Ae)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,f,m)}async asExternalUri(b,m){if((0,A.$Ae)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(b,m);return C.URI.from(f)}};e.$Jcc=k,e.$Jcc=k=P=Ke([Ve(0,E.$0L)],k),e.$Kcc=(0,h.$Nh)("IExtHostWindow")}),define(Ae[260],Re([1,0,226,27,17]),function(be,e,w,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=void 0;let F=class extends w.$Idc{constructor(h,E){super(h,E)}f(h,E,g){E.apply(console,g)}};e.$Pfc=F,e.$Pfc=F=Ke([Ve(0,C.$0L),Ve(1,M.$nM)],F)}),define(Ae[261],Re([1,0,13,25,21,9,5,6,132,215,46]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$c4b=e.ResponsiveState=e.RequestInitiator=e.$b4b=e.$a4b=void 0;function a(l,R){try{return JSON.stringify(l,R)}catch{return"null"}}const b="$$ref$$",m={[b]:-1};class f{constructor(R,B){this.jsonString=R,this.referencedBuffers=B}}function t(l,R=null,B=!1){const V=[];return{jsonString:(B?a:JSON.stringify)(l,(W,N)=>{if(typeof N>"u")return m;if(typeof N=="object"){if(N instanceof M.$ae){const O=V.push(N)-1;return{[b]:O}}if(R)return R(W,N)}return N}),referencedBuffers:V}}e.$a4b=t;function n(l,R,B){return JSON.parse(l,(V,U)=>{if(U){const W=U[b];if(typeof W=="number")return R[W];if(B&&U.$mid===1)return B.transformIncoming(U)}return U})}e.$b4b=n;function c(l,R){return JSON.stringify(l,R)}function v(l){return l?(R,B)=>B&&B.$mid===1?l.transformOutgoing(B):B:null}var D;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));var p;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(p||(e.ResponsiveState=p={}));const r=()=>{},s=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class o extends h.$Rc{static{k=s}static{this.a=3*1e3}constructor(R,B=null,V=null){super(),this[k]=!0,this.b=this.B(new A.$Md),this.onDidChangeResponsiveState=this.b.event,this.c=R,this.f=B,this.g=V,this.h=v(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,W=P.$gv.count;U<W;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new w.$5g(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(R=>{const B=this.w[R];delete this.w[R],B.resolveErr(F.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(R){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(R){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(R){this.y!==R&&(this.y=R,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(R){return this.g?(0,E.$Hm)(R,this.g):R}getProxy(R){const{nid:B,sid:V}=R;return this.s[B]||(this.s[B]=this.J(B,V)),this.s[B]}J(R,B){const V={get:(U,W)=>(typeof W=="string"&&!U[W]&&W.charCodeAt(0)===36&&(U[W]=(...N)=>this.U(R,W,N)),W===i?B:U[W])};return new Proxy(Object.create(null),V)}set(R,B){return this.m[R.nid]=B,B}assertRegistered(R){for(let B=0,V=R.length;B<V;B++){const U=R[B];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(R){if(this.j)return;const B=R.byteLength,V=$.read(R,0),U=V.readUInt8(),W=V.readUInt32();switch(U){case 1:case 2:{let{rpcId:N,method:O,args:ee}=I.deserializeRequestJSONArgs(V);this.g&&(ee=(0,E.$Hm)(ee,this.g)),this.M(B,W,N,O,ee,U===2);break}case 3:case 4:{let{rpcId:N,method:O,args:ee}=I.deserializeRequestMixedArgs(V);this.g&&(ee=(0,E.$Hm)(ee,this.g)),this.M(B,W,N,O,ee,U===4);break}case 5:{this.f?.logIncoming(B,W,0,"ack"),this.G(W);break}case 6:{this.N(B,W);break}case 7:{this.O(B,W,void 0);break}case 9:{let N=I.deserializeReplyOKJSON(V);this.g&&(N=(0,E.$Hm)(N,this.g)),this.O(B,W,N);break}case 10:{const N=I.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(B,W,N);break}case 8:{const N=I.deserializeReplyOKVSBuffer(V);this.O(B,W,N);break}case 11:{let N=I.deserializeReplyErrError(V);this.g&&(N=(0,E.$Hm)(N,this.g)),this.P(B,W,N);break}case 12:{this.P(B,W,void 0);break}default:console.error("received unexpected message"),console.error(R)}}M(R,B,V,U,W,N){this.f?.logIncoming(R,B,1,`receiveRequest ${(0,P.$iv)(V)}.${U}(`,W);const O=String(B);let ee,Z;if(N){const De=new C.$Wd;W.push(De.token),ee=this.Q(V,U,W),Z=()=>De.cancel()}else ee=this.Q(V,U,W),Z=r;this.u[O]=Z;const ye=I.serializeAcknowledged(B);this.f?.logOutgoing(ye.byteLength,B,1,"ack"),this.c.send(ye),ee.then(De=>{delete this.u[O];const Pe=I.serializeReplyOK(B,De,this.h);this.f?.logOutgoing(Pe.byteLength,B,1,"reply:",De),this.c.send(Pe)},De=>{delete this.u[O];const Pe=I.serializeReplyErr(B,De);this.f?.logOutgoing(Pe.byteLength,B,1,"replyErr:",De),this.c.send(Pe)})}N(R,B){this.f?.logIncoming(R,B,1,"receiveCancel");const V=String(B);this.u[V]?.()}O(R,B,V){this.f?.logIncoming(R,B,0,"receiveReply:",V);const U=String(B);if(!this.w.hasOwnProperty(U))return;const W=this.w[U];delete this.w[U],W.resolveOk(V)}P(R,B,V){this.f?.logIncoming(R,B,0,"receiveReplyErr:",V);const U=String(B);if(!this.w.hasOwnProperty(U))return;const W=this.w[U];delete this.w[U];let N;V&&(V.$isError?(N=new Error,N.name=V.name,N.message=V.message,N.stack=V.stack):N=V),W.resolveErr(N)}Q(R,B,V){try{return Promise.resolve(this.S(R,B,V))}catch(U){return Promise.reject(U)}}S(R,B,V){const U=this.m[R];if(!U)throw new Error("Unknown actor "+(0,P.$iv)(R));const W=U[B];if(typeof W!="function")throw new Error("Unknown method "+B+" on actor "+(0,P.$iv)(R));return W.apply(U,V)}U(R,B,V){if(this.j)return new g.$_3b;let U=null;if(V.length>0&&C.CancellationToken.isCancellationToken(V[V.length-1])&&(U=V.pop()),U&&U.isCancellationRequested)return Promise.reject(F.$5());const W=I.serializeRequestArguments(V,this.h),N=++this.t,O=String(N),ee=new g.$$3b,Z=new h.$Qc;U&&Z.add(U.onCancellationRequested(()=>{const De=I.serializeCancel(N);this.f?.logOutgoing(De.byteLength,N,0,"cancel"),this.c.send(I.serializeCancel(N))})),this.w[O]=new y(ee,Z),this.F(N);const ye=I.serializeRequest(N,R,B,W,!!U);return this.f?.logOutgoing(ye.byteLength,N,0,`request: ${(0,P.$iv)(R)}.${B}(`,V),this.c.send(ye),ee}}e.$c4b=o;class y{constructor(R,B){this.a=R,this.b=B}resolveOk(R){this.a.resolveOk(R),this.b.dispose()}resolveErr(R){this.a.resolveErr(R),this.b.dispose()}}class ${static alloc(R,B,V){const U=new $(M.$ae.alloc(V+1+4),0);return U.writeUInt8(R),U.writeUInt32(B),U}static read(R,B){return new $(R,B)}get buffer(){return this.a}constructor(R,B){this.a=R,this.b=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(R){this.a.writeUInt8(R,this.b),this.b+=1}readUInt8(){const R=this.a.readUInt8(this.b);return this.b+=1,R}writeUInt32(R){this.a.writeUInt32BE(R,this.b),this.b+=4}readUInt32(){const R=this.a.readUInt32BE(this.b);return this.b+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this.a.writeUInt8(R.byteLength,this.b),this.b+=1,this.a.set(R,this.b),this.b+=R.byteLength}readShortString(){const R=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readLongString(){const R=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}writeBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readVSBuffer(){const R=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+R);return this.b+=R,B}static sizeMixedArray(R){let B=0;B+=1;for(let V=0,U=R.length;V<U;V++){const W=R[V];switch(B+=1,W.type){case 1:B+=this.sizeLongString(W.value);break;case 2:B+=this.sizeVSBuffer(W.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(W.value);for(let N=0;N<W.buffers.length;++N)B+=this.sizeVSBuffer(W.buffers[N]);break;case 4:break}}return B}writeMixedArray(R){this.a.writeUInt8(R.length,this.b),this.b+=1;for(let B=0,V=R.length;B<V;B++){const U=R[B];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let W=0;W<U.buffers.length;++W)this.writeBuffer(U.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this.a.readUInt8(this.b);this.b+=1;const B=new Array(R);for(let V=0;V<R;V++)switch(this.readUInt8()){case 1:B[V]=this.readLongString();break;case 2:B[V]=this.readVSBuffer();break;case 3:{const W=this.readUInt32(),N=this.readLongString(),O=[];for(let ee=0;ee<W;++ee)O.push(this.readVSBuffer());B[V]=new P.$jv(n(N,O,null));break}case 4:B[V]=void 0;break}return B}}var S;(function(l){l[l.Simple=0]="Simple",l[l.Mixed=1]="Mixed"})(S||(S={}));class I{static a(R){for(let B=0,V=R.length;B<V;B++)if(R[B]instanceof M.$ae||R[B]instanceof P.$jv||typeof R[B]>"u")return!0;return!1}static serializeRequestArguments(R,B){if(this.a(R)){const V=[];for(let U=0,W=R.length;U<W;U++){const N=R[U];if(N instanceof M.$ae)V[U]={type:2,value:N};else if(typeof N>"u")V[U]={type:4};else if(N instanceof P.$jv){const{jsonString:O,referencedBuffers:ee}=t(N.value,B);V[U]={type:3,value:M.$ae.fromString(O),buffers:ee}}else V[U]={type:1,value:M.$ae.fromString(c(N,B))}}return{type:1,args:V}}return{type:0,args:c(R,B)}}static serializeRequest(R,B,V,U,W){switch(U.type){case 0:return this.b(R,B,V,U.args,W);case 1:return this.c(R,B,V,U.args,W)}}static b(R,B,V,U,W){const N=M.$ae.fromString(V),O=M.$ae.fromString(U);let ee=0;ee+=$.sizeUInt8(),ee+=$.sizeShortString(N),ee+=$.sizeLongString(O);const Z=$.alloc(W?2:1,R,ee);return Z.writeUInt8(B),Z.writeShortString(N),Z.writeLongString(O),Z.buffer}static deserializeRequestJSONArgs(R){const B=R.readUInt8(),V=R.readShortString(),U=R.readLongString();return{rpcId:B,method:V,args:JSON.parse(U)}}static c(R,B,V,U,W){const N=M.$ae.fromString(V);let O=0;O+=$.sizeUInt8(),O+=$.sizeShortString(N),O+=$.sizeMixedArray(U);const ee=$.alloc(W?4:3,R,O);return ee.writeUInt8(B),ee.writeShortString(N),ee.writeMixedArray(U),ee.buffer}static deserializeRequestMixedArgs(R){const B=R.readUInt8(),V=R.readShortString(),U=R.readMixedArray(),W=new Array(U.length);for(let N=0,O=U.length;N<O;N++){const ee=U[N];typeof ee=="string"?W[N]=JSON.parse(ee):W[N]=ee}return{rpcId:B,method:V,args:W}}static serializeAcknowledged(R){return $.alloc(5,R,0).buffer}static serializeCancel(R){return $.alloc(6,R,0).buffer}static serializeReplyOK(R,B,V){if(typeof B>"u")return this.d(R);if(B instanceof M.$ae)return this.e(R,B);if(B instanceof P.$jv){const{jsonString:U,referencedBuffers:W}=t(B.value,V,!0);return this.g(R,U,W)}else return this.f(R,a(B,V))}static d(R){return $.alloc(7,R,0).buffer}static e(R,B){let V=0;V+=$.sizeVSBuffer(B);const U=$.alloc(8,R,V);return U.writeVSBuffer(B),U.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static f(R,B){const V=M.$ae.fromString(B);let U=0;U+=$.sizeLongString(V);const W=$.alloc(9,R,U);return W.writeLongString(V),W.buffer}static g(R,B,V){const U=M.$ae.fromString(B);let W=0;W+=$.sizeUInt32,W+=$.sizeLongString(U);for(const O of V)W+=$.sizeVSBuffer(O);const N=$.alloc(10,R,W);N.writeUInt32(V.length),N.writeLongString(U);for(const O of V)N.writeBuffer(O);return N.buffer}static deserializeReplyOKJSON(R){const B=R.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(R,B){const V=R.readUInt32(),U=R.readLongString(),W=[];for(let N=0;N<V;++N)W.push(R.readVSBuffer());return new P.$jv(n(U,W,B))}static serializeReplyErr(R,B){const V=B?a(F.$2(B),null):void 0;if(typeof V!="string")return this.h(R);const U=M.$ae.fromString(V);let W=0;W+=$.sizeLongString(U);const N=$.alloc(11,R,W);return N.writeLongString(U),N.buffer}static deserializeReplyErrError(R){const B=R.readLongString();return JSON.parse(B)}static h(R){return $.alloc(12,R,0).buffer}}var u;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",l[l.ReplyErrError=11]="ReplyErrError",l[l.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var d;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",l[l.Undefined=4]="Undefined"})(d||(d={}))}),define(Ae[262],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0;const w=function(F){const A=h=>{globalThis.removeEventListener("message",A);const E=h.data;Object.defineProperties(globalThis,{postMessage:{value(g,P){E.postMessage(g,P)}},onmessage:{get(){return E.onmessage},set(g){E.onmessage=g}}}),E.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),E.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",A)}.toString();class M extends EventTarget{constructor(F,A,h){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${w})('${A}'))`,g=new Blob([E],{type:"application/javascript"}),P=URL.createObjectURL(g),k=new MessageChannel,a=P,b={type:"_newWorker",id:a,port:k.port2,url:P,options:h};F(b,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{F({type:"_terminateWorker",id:a}),URL.revokeObjectURL(P),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(m){k.port1.onmessage=m}},onmessageerror:{get(){return k.port1.onmessageerror},set(m){k.port1.onmessageerror=m}}}),k.port1.addEventListener("messageerror",m=>{const f=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(f)}),k.port1.addEventListener("message",m=>{const f=new MessageEvent("message",{data:m.data});this.dispatchEvent(f)}),k.port1.start()}}e.$Rfc=M}),define(Ae[263],Re([1,0,5,30,32,4]),function(be,e,w,M,C,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.$rJ=e.OutputChannelUpdateMode=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=void 0,e.$hJ="text/x-code-output",e.$iJ="output",e.$jJ="Log",e.$kJ="text/x-code-log-output",e.$lJ="log",e.$mJ="workbench.panel.output",e.$nJ=new C.$5i("inOutput",!1),e.$oJ=new C.$5i("activeLogOutput",!1),e.$pJ=new C.$5i("outputView.scrollLock",!1),e.$qJ=(0,F.$Nh)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$rJ={OutputChannels:"workbench.contributions.outputChannels"};class h{constructor(){this.a=new Map,this.b=new w.$Md,this.onDidRegisterChannel=this.b.event,this.c=new w.$Md,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(P=>g.push(P)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}M.$$m.add(e.$rJ.OutputChannels,new h),e.$sJ=new C.$5i("activeOutputChannel","")}),define(Ae[109],Re([1,0,3,4,17,20,14,263,62,27,39,129,25,16,38,5,6]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=void 0;class n extends A.$bj{get disposed(){return this.n}constructor(p,r,s,i,o){super(),this.id=p,this.name=r,this.r=s,this.s=i,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(y=>this.setLevel(y)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.m;this.r.flush(),this.s.$update(this.id,h.OutputChannelUpdateMode.Clear,p)}replace(p){const r=this.m;this.info(p),this.s.$update(this.id,h.OutputChannelUpdateMode.Replace,r),this.visible&&this.r.flush()}show(p,r){this.r.flush(),this.s.$reveal(this.id,!!(typeof p=="boolean"?p:r))}hide(){this.s.$close(this.id)}g(p,r){this.m+=a.$ae.fromString(r).byteLength,(0,A.log)(this.r,p,r),this.visible&&(this.r.flush(),this.s.$update(this.id,h.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class c extends n{appendLine(p){this.append(p)}}let v=class{constructor(p,r,s,i,o,y){this.i=r,this.j=s,this.k=i,this.l=o,this.m=y,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(w.$9J.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,k.$0l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[r,s]of this.g)s.visible=r===this.h}createOutputChannel(p,r,s){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const i=typeof r=="object"&&r.log,o=(0,b.$xf)(r)?r:void 0;if((0,b.$xf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let y;const $=this.i.environment.extensionLogLevel?.find(([I])=>F.$Yl.equals(s.identifier,I))?.[1];$&&(y=(0,A.$lj)($));const S=i?this.o(p,y,s):this.n(p,o,s);return S.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),i?this.r(p,y??this.m.getLevel(),S):this.q(p,S)}async n(p,r,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const i=await this.c,o=this.k.extUri.joinPath(i,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),y=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),$=await this.a.$register(p,o,r,s.identifier.value);return new n($,p,y,this.a,s)}async o(p,r,s){const i=await this.p(s),o=p.replace(/[\\/:\*\?"<>\|]/g,""),y=this.k.extUri.joinPath(i,`${o}.log`),$=`${s.identifier.value}.${o}`,S=this.l.createLogger(y,{id:$,name:p,logLevel:r,extensionId:s.identifier.value});return new c($,p,S,this.a,s)}p(p){let r=this.d.get(p.identifier.value);if(!r){const s=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(s)}catch(i){if((0,m.$lk)(i)!==m.FileSystemProviderErrorCode.FileExists)throw i}return s})())}return r}q(p,r){let s=!1;const i=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return p},append(o){i(),r.then(y=>y.append(o))},appendLine(o){i(),r.then(y=>y.appendLine(o))},clear(){i(),r.then(o=>o.clear())},replace(o){i(),r.then(y=>y.replace(o))},show(o,y){i(),r.then($=>$.show(o,y))},hide(){i(),r.then(o=>o.hide())},dispose(){s=!0,r.then(o=>o.dispose())}}}r(p,r,s){const i=new t.$Qc,o=()=>{if(i.isDisposed)throw new Error("Channel has been closed")},y=i.add(new f.$Md);function $(S){r=S,y.fire(S)}return s.then(S=>{i.add(S),S.logLevel!==r&&$(S.logLevel),i.add(S.onDidChangeLogLevel(I=>$(I)))}),{...this.q(p,s),get logLevel(){return r},onDidChangeLogLevel:y.event,trace(S,...I){o(),s.then(u=>u.trace(S,...I))},debug(S,...I){o(),s.then(u=>u.debug(S,...I))},info(S,...I){o(),s.then(u=>u.info(S,...I))},warn(S,...I){o(),s.then(u=>u.warn(S,...I))},error(S,...I){o(),s.then(u=>u.error(S,...I))},dispose(){i.dispose()}}}};e.$tcc=v,e.$tcc=v=Ke([Ve(0,C.$0L),Ve(1,g.$nM),Ve(2,E.$9bc),Ve(3,P.$Dbc),Ve(4,A.$9i),Ve(5,A.$8i)],v),e.$ucc=(0,M.$Nh)("IExtHostOutputService")}),define(Ae[264],Re([1,0,4,13]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=void 0,e.$mm=(0,w.$Nh)("remoteAgentService"),e.$nm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let F=1/0;for(let h=0;h<this.maxSampleCount;h++){const E=await C.getRoundTripTime();if(E===void 0)return;F=Math.min(F,E/2),await(0,M.$Tg)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(F):A=this.initial.reduce((h,E)=>h+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:F,average:this.average.reduce((h,E)=>h+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[265],Re([1,0,42,12,19,22,23,2,4,186,54,208,264]),function(be,e,w,M,C,F,A,h,E,g,P,k,a){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$LJ=e.$KJ=void 0,e.$KJ=(0,E.$Nh)("pathService");let m=b=class{constructor(t,n,c,v){this.d=t,this.e=n,this.f=c,this.g=v,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const D=await this.e.getEnvironment();return this.c=D?.userHome??t})()}hasValidBasename(t,n,c){return typeof n=="string"||typeof n>"u"?this.a.then(v=>this.h(t,v,n)):this.h(t,n,c)}h(t,n,c){return t.scheme===M.Schemas.file||t.scheme===M.Schemas.vscodeRemote?(0,w.$Uf)(c??(0,A.$rg)(t),n===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,n){if(t.remoteAuthority)return M.Schemas.vscodeRemote;const c=(0,g.$HJ)(n.getWorkspace());if(c)return c;const v=n.getWorkspace().folders[0];if(v)return v.uri.scheme;const D=n.getWorkspace().configuration;return D?D.scheme:M.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$ec:C.$fc)}async fileURI(t){let n="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const v=t.indexOf("/",2);v===-1?(n=t.substring(2),t="/"):(n=t.substring(2,v),t=t.substring(v)||"/")}return h.URI.from({scheme:M.Schemas.file,authority:n,path:t,query:"",fragment:""})}};e.$LJ=m,e.$LJ=m=b=Ke([Ve(1,a.$mm),Ve(2,k.$tJ),Ve(3,P.$Wh)],m)}),define(Ae[110],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$uI=e.$tI=void 0;class w{constructor(A,h){this.line=A,this.character=h}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,h){return new w(0,0)}with(A){return new w(0,0)}}e.$tI=w;class M{constructor(A,h,E,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,h),this.end=new w(E,g)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$uI=M;var C;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[47],Re([1,0,18,37,24,42,15,4,19,9,110,13]),function(be,e,w,M,C,F,A,h,E,g,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.SearchErrorCode=e.$JI=e.$II=e.SearchSortOrder=e.ViewMode=e.$HI=e.$GI=e.$FI=e.$EI=e.SearchCompletionExitCode=e.$DI=e.$CI=e.$BI=e.QueryType=e.SearchProviderType=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$vI="workbench.view.search",e.$wI="workbench.panel.search",e.$xI="workbench.view.search",e.$yI="search-result",e.$zI="search.exclude";const a="\u27EA ",b=" characters skipped \u27EB",m=(a.length+b.length+5)*2;e.$AI=(0,h.$Nh)("searchService");var f;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(t||(e.QueryType=t={}));function n(X){return!!X.preview}e.$BI=n;function c(X){return!!X.resource}e.$CI=c;function v(X){return!!X.message}e.$DI=v;var D;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(D||(e.SearchCompletionExitCode=D={}));class p{constructor(le){this.resource=le,this.results=[]}}e.$EI=p;class r{constructor(le,Ee,ce,$e){this.ranges=Ee,this.webviewIndex=$e;const ie=Array.isArray(Ee)?Ee:[Ee];if(ce&&ce.matchLines===1&&s(ie)){le=(0,A.$qf)(le,ce.matchLines);let z="",q=0,ue=0;const we=Math.floor(ce.charsPerLine/5),ve=[];for(const me of ie){const ke=Math.max(me.startColumn-we,0),re=me.startColumn+ce.charsPerLine;if(ke>ue+we+m){const he=a+(ke-ue)+b;z+=he+le.slice(ke,re),q+=ke-(ue+he.length)}else z+=le.slice(ue,re);ve.push(new o(0,me.startColumn-q,me.endColumn-q)),ue=re}this.preview={text:z,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const z=Array.isArray(Ee)?Ee[0].startLineNumber:Ee.startLineNumber;this.preview={text:le,matches:(0,w.$1b)(Ee,q=>new i(q.startLineNumber-z,q.startColumn,q.endLineNumber-z,q.endColumn))}}}}e.$FI=r;function s(X){const le=X[0].startLineNumber;for(const Ee of X)if(Ee.startLineNumber!==le||Ee.endLineNumber!==le)return!1;return!0}class i{constructor(le,Ee,ce,$e){this.startLineNumber=le,this.startColumn=Ee,this.endLineNumber=ce,this.endColumn=$e}}e.$GI=i;class o extends i{constructor(le,Ee,ce){super(le,Ee,le,ce)}}e.$HI=o;var y;(function(X){X.List="list",X.Tree="tree"})(y||(e.ViewMode=y={}));var $;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})($||(e.SearchSortOrder=$={}));function S(X,le=!0){const Ee=X&&X.files&&X.files.exclude,ce=le&&X&&X.search&&X.search.exclude;if(!Ee&&!ce)return;if(!Ee||!ce)return Ee||ce;let $e=Object.create(null);return $e=C.$2m($e,C.$Ym(Ee)),$e=C.$2m($e,C.$Ym(ce),!0),$e}e.$II=S;function I(X,le){return X.excludePattern&&M.$tj(X.excludePattern,le)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&M.$tj(X.includePattern,le)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(Ee=>{const ce=Ee.folder.fsPath;if(F.$Wf(le,ce)){const $e=E.$kc(ce,le);return!Ee.includePattern||!!M.$tj(Ee.includePattern,$e)}else return!1}):!1:!0}e.$JI=I;var u;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class d extends Error{constructor(le,Ee){super(le),this.code=Ee}}e.$KI=d;function l(X){const le=X.message;if((0,g.$3)(X))return new d(le,u.canceled);try{const Ee=JSON.parse(le);return new d(Ee.message,Ee.code)}catch{return new d(le,u.other)}}e.$LI=l;function R(X){const le={message:X.message,code:X.code};return new Error(JSON.stringify(le))}e.$MI=R;function B(X){return X.type==="error"?!0:X.type==="success"}e.$NI=B;function V(X){return X.type==="success"}e.$OI=V;function U(X){return!!X.path}e.$PI=U;function W(X,le){const Ee=X.searchPath?X.searchPath:X.relativePath;return(0,A.$nf)(Ee,le)}e.$QI=W;class N{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$RI=N;function O(X,le){const Ee={...X||{},...le||{}};return Object.keys(Ee).filter(ce=>{const $e=Ee[ce];return typeof $e=="boolean"&&$e})}e.$SI=O;class ee{constructor(le,Ee){this.c=null,this.a={...le.excludePattern||{},...Ee.excludePattern||{}},this.b=M.$uj(this.a);let ce=le.includePattern;Ee.includePattern&&(ce?ce={...ce,...Ee.includePattern}:ce=Ee.includePattern),ce&&(this.c=M.$uj(ce))}matchesExcludesSync(le,Ee,ce){return!!(this.b&&this.b(le,Ee,ce))}includedInQuerySync(le,Ee,ce){return!(this.b&&this.b(le,Ee,ce)||this.c&&!this.c(le,Ee,ce))}includedInQuery(le,Ee,ce){const $e=this.b(le,Ee,ce),ie=()=>this.c?!!this.c(le,Ee,ce):!0;return(0,k.$Fg)($e)?$e.then(z=>z?!1:ie()):ie()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$TI=ee;function Z(X){for(const le in X)if(typeof X[le]!="boolean")return!0;return!1}function ye(X){if(!X)return;let le;return Ee=>(le||(le=(X()||Promise.resolve([])).then(ce=>ce?Pe(ce):{})),le.then(ce=>!!ce[Ee]))}e.$UI=ye;function De(X){if(!X)return;let le;return Ee=>{if(!le){const ce=X();le=ce?Pe(ce):{}}return!!le[Ee]}}e.$VI=De;function Pe(X){const le={};for(const Ee of X)le[Ee]=!0;return le}}),define(Ae[33],Re([1,0,18,13,21,5,6,49,12,117,23,15,2,158,4,14,175,54,39,27,17,8,7,56,47,3]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r,s,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=e.$Pbc=void 0;function y(B,V,U){return new P.$jg(W=>u(W,U)).isEqual(B,V)}function $(B,V,U){return y(B.uri,V.uri,U)?0:(0,k.$Te)(B.uri.toString(),V.uri.toString())}function S(B,V,U){return B.index!==V.index?B.index<V.index?-1:1:y(B.uri,V.uri,U)?(0,k.$Te)(B.name,V.name):(0,k.$Te)(B.uri.toString(),V.uri.toString())}function I(B,V,U,W){const N=B.slice(0).sort((ee,Z)=>U(ee,Z,W)),O=V.slice(0).sort((ee,Z)=>U(ee,Z,W));return(0,w.$Db)(N,O,(ee,Z)=>U(ee,Z,W))}function u(B,V){const U=V.getCapabilities(B.scheme);return!(U&&U&1024)}class d extends n.$7h{static toExtHostWorkspace(V,U,W,N){if(!V)return{workspace:null,added:[],removed:[]};const{id:O,name:ee,folders:Z,configuration:ye,transient:De,isUntitled:Pe}=V,X=[],le=U;U?Z.forEach((ie,z)=>{const q=a.URI.revive(ie.uri),ue=d.o(W||U,q,N);ue?(ue.name=ie.name,ue.index=ie.index,X.push(ue)):X.push({uri:q,name:ie.name,index:z})}):X.push(...Z.map(({uri:ie,name:z,index:q})=>({uri:a.URI.revive(ie),name:z,index:q}))),X.sort((ie,z)=>ie.index<z.index?-1:1);const Ee=new d(O,ee,X,!!De,ye?a.URI.revive(ye):null,!!Pe,ie=>u(ie,N)),{added:ce,removed:$e}=I(le?le.workspaceFolders:[],Ee.workspaceFolders,$,N);return{workspace:Ee,added:ce,removed:$e}}static o(V,U,W){for(let N=0;N<V.folders.length;N++){const O=V.workspaceFolders[N];if(y(O.uri,U,W))return O}}constructor(V,U,W,N,O,ee,Z){super(V,W.map(ye=>new n.$8h(ye)),N,O,Z),this.t=U,this.u=ee,this.q=[],this.s=h.$Th.forUris(Z),W.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,U){return U&&this.s.get(V)&&(V=(0,P.$tg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let l=class{constructor(V,U,W,N,O){this.c=new F.$Md,this.onDidChangeWorkspace=this.c.event,this.g=new F.$Md,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new F.$Od,this.B=new Map,this.h=N,this.s=W,this.t=O,this.j=new g.$Ml,this.k=new M.$Rg,this.o=V.getProxy(o.$9J.MainThreadWorkspace),this.q=V.getProxy(o.$9J.MainThreadMessageService);const ee=U.workspace;this.l=ee?new d(ee.id,ee.name,[],!!ee.transient,ee.configuration?a.URI.revive(ee.configuration):null,!!ee.isUntitled,Z=>u(Z,W)):void 0}$initializeWorkspace(V,U){this.v=U,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:E.Schemas.untitled,path:(0,P.$rg)((0,P.$tg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,U,W,...N){const O=[];if(Array.isArray(N)&&N.forEach(Pe=>{a.URI.isUri(Pe.uri)&&!O.some(X=>y(X.uri,Pe.uri,this.s))&&O.push({uri:Pe.uri,name:Pe.name||(0,P.$qg)(Pe.uri)})}),this.n||[U,W].some(Pe=>typeof Pe!="number"||Pe<0)||W===0&&O.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(U+W>ee.length)return!1;const Z=ee.slice(0);Z.splice(U,W,...O.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,P.$qg)(Pe.uri),index:void 0})));for(let Pe=0;Pe<Z.length;Pe++){const X=Z[Pe];if(Z.some((le,Ee)=>Ee!==Pe&&y(X.uri,le.uri,this.s)))return!1}Z.forEach((Pe,X)=>Pe.index=X);const{added:ye,removed:De}=I(ee,Z,S,this.s);if(ye.length===0&&De.length===0)return!1;if(this.o){const Pe=V.displayName||V.name;this.o.$updateWorkspaceFolders(Pe,U,W,O).then(void 0,X=>{this.n=void 0;const le={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(t.Severity.Error,(0,b.localize)(0,null,Pe,X.toString()),le,[])})}return this.y(Z),!0}getWorkspaceFolder(V,U){if(this.x)return this.x.getWorkspaceFolder(V,U)}async getWorkspaceFolder2(V,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,U)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,U){let W,N="";if(typeof V=="string"?(W=a.URI.file(V),N=V):typeof V<"u"&&(W=V,N=V.fsPath),!W)return N;const O=this.getWorkspaceFolder(W,!0);if(!O)return N;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ee=(0,P.$wg)(O.uri,W);return U&&O.name&&(ee=`${O.name}/${ee}`),ee}y(V){this.x&&(this.n=d.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:U,added:W,removed:N}=d.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:W,removed:N}))}findFiles(V,U,W,N,O=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let ee;if(U===null?ee=!1:U&&(typeof U=="string"?ee=U:ee=U.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:Z,folder:ye}=R(p.GlobPattern.from(V));return this.o.$startFileSearch(Z??null,ye??null,ee??null,W??null,O).then(De=>Array.isArray(De)?De.map(Pe=>a.URI.revive(Pe)):[])}async findTextInFiles(V,U,W,N,O=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const ee=this.j.getNext(),Z=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ye,folder:De}=R(p.GlobPattern.from(U.include)),Pe=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,X={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:Z,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ye,excludePattern:Pe},le=!1;if(this.u[ee]=Ee=>{if(le)return;const ce=a.URI.revive(Ee.resource);Ee.results.forEach($e=>{(0,i.$BI)($e)?W({uri:ce,preview:{text:$e.preview.text,matches:(0,w.$1b)($e.preview.matches,ie=>new r.$aK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,w.$1b)($e.ranges,ie=>new r.$aK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):W({uri:ce,text:$e.text,lineNumber:$e.lineNumber})})},O.isCancellationRequested)return{};try{const Ee=await this.o.$startTextSearch(V,De??null,X,ee,O);return delete this.u[ee],Ee||{}}catch(Ee){throw delete this.u[ee],Ee}}$handleTextSearchResult(V,U){this.u[U]?.(V)}async save(V){const U=await this.o.$save(V,{saveAs:!1});return a.URI.revive(U)}async saveAs(V){const U=await this.o.$save(V,{saveAs:!0});return a.URI.revive(U)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,U){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,U);const W=this.t.transformOutgoingScheme(V),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,W),(0,A.$Pc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(V,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const W=await this.resolveWorkspaceFolder(a.URI.revive(V));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const N=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!N),!N)return;const O=await N.provideEditSessionIdentity(W,U);if(this.h.info("Provider returned edit session identifier: ",O),!!O)return O}async $provideEditSessionIdentityMatch(V,U,W,N){this.h.info("Getting edit session identifier for workspaceFolder",V);const O=await this.resolveWorkspaceFolder(a.URI.revive(V));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const ee=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!ee),!ee)return;const Z=await ee.provideEditSessionIdentityMatch?.(U,W,N);if(this.h.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(V){return(U,W,N)=>{const O=function(Z){U.call(W,Z)};return O.extension=V,this.A.event(O,void 0,N)}}async $onWillCreateEditSessionIdentity(V,U,W){const N=await this.resolveWorkspaceFolder(a.URI.revive(V));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},U,async(O,ee)=>{const Z=Date.now();await Promise.resolve(O),Date.now()-Z>W&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(V,U){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,U);const W=this.t.transformOutgoingScheme(V),N=this.z++;return this.o.$registerCanonicalUriProvider(N,W),(0,A.$Pc)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(V,U,W){const N=this.B.get(V.scheme);if(!N)return;const O=await N.provideCanonicalUri?.(a.URI.revive(V),U,W);if(O)return O}async $provideCanonicalUri(V,U,W){return this.provideCanonicalUri(a.URI.revive(V),{targetScheme:U},W)}};e.$Pbc=l,e.$Pbc=l=Ke([Ve(0,D.$0L),Ve(1,v.$nM),Ve(2,c.$Dbc),Ve(3,f.$8i),Ve(4,s.$Nbc)],l),e.$Qbc=(0,m.$Nh)("IExtHostWorkspace");function R(B){let V,U;return B&&(typeof B=="string"?V=B:(V=B.pattern,U=a.URI.revive(B.baseUri))),{includePattern:V,folder:U}}}),define(Ae[34],Re([1,0,24,5,33,3,7,177,96,16,13,4,17,14,2]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=e.$Sbc=e.$Rbc=void 0;function f(s,i){if(i){const o=i.split(".");let y=s;for(let $=0;y&&$<o.length;$++)y=y[o[$]];return y}}function t(s){return s instanceof m.URI}function n(s){return s&&s.uri instanceof m.URI&&s.languageId&&typeof s.languageId=="string"}function c(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function v(s){return s&&s.uri instanceof m.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function D(s){if(t(s))return{resource:s};if(n(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(c(s))return{overrideIdentifier:s.languageId};if(v(s))return{resource:s.uri};if(s===null)return{resource:null}}let p=class{constructor(i,o,y){this.a=i.getProxy(F.$9J.MainThreadConfiguration),this.c=o,this.b=y,this.d=new P.$Rg,this.e=null}getConfigProvider(){return this.d.wait().then(i=>this.e)}$initializeConfiguration(i){this.e=new r(this.a,this.c,i,this.b),this.d.open()}$acceptConfigurationChanged(i,o){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(i,o))}};e.$Rbc=p,e.$Rbc=p=Ke([Ve(0,a.$0L),Ve(1,C.$Qbc),Ve(2,b.$8i)],p);class r{constructor(i,o,y,$){this.a=new M.$Md,this.b=i,this.f=$,this.c=o,this.e=h.$wn.parse(y),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(i,o){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=h.$wn.parse(i),this.d=this.k(i.configurationScopes),this.a.fire(this.j(o,y))}getConfiguration(i,o,y){const $=D(o)||{},S=this.g(i?f(this.e.getValue(void 0,$,this.c.workspace),i):this.e.getValue(void 0,$,this.c.workspace));i&&this.h(i,$,y?.identifier);function I(d){if(d==null)return null;if(typeof d=="boolean")return d?2:5;switch(d){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(d){return typeof f(S,d)<"u"},get:(d,l)=>{this.h(i?`${i}.${d}`:d,$,y?.identifier);let R=f(S,d);if(typeof R>"u")R=l;else{let B;const V=(U,W)=>{if((0,g.$zf)(U)){let N;const O=()=>{B=B||(0,w.$Ym)(S),N=N||f(B,W)};return new Proxy(U,{get:(ee,Z)=>{if(typeof Z=="string"&&Z.toLowerCase()==="tojson")return O(),()=>N;if(B)return N=N||f(B,W),N[Z];const ye=ee[Z];return typeof Z=="string"?V(ye,`${W}.${Z}`):ye},set:(ee,Z,ye)=>(O(),N&&(N[Z]=ye),!0),deleteProperty:(ee,Z)=>(O(),N&&delete N[Z],!0),defineProperty:(ee,Z,ye)=>(O(),N&&Object.defineProperty(N,Z,ye),!0)})}return Array.isArray(U)?(0,w.$Ym)(U):U};R=V(R,d)}return R},update:(d,l,R,B)=>{d=i?`${i}.${d}`:d;const V=I(R);return l!==void 0?this.b.$updateConfigurationOption(V,d,l,$,B):this.b.$removeConfigurationOption(V,d,$,B)},inspect:d=>{d=i?`${i}.${d}`:d;const l=this.e.inspect(d,$,this.c.workspace);if(l)return{key:d,defaultValue:(0,w.$Ym)(l.policy?.value??l.default?.value),globalValue:(0,w.$Ym)(l.user?.value??l.application?.value),workspaceValue:(0,w.$Ym)(l.workspace?.value),workspaceFolderValue:(0,w.$Ym)(l.workspaceFolder?.value),defaultLanguageValue:(0,w.$Ym)(l.default?.override),globalLanguageValue:(0,w.$Ym)(l.user?.override??l.application?.override),workspaceLanguageValue:(0,w.$Ym)(l.workspace?.override),workspaceFolderLanguageValue:(0,w.$Ym)(l.workspaceFolder?.override),languageIds:(0,w.$Ym)(l.overrideIdentifiers)}}};return typeof S=="object"&&(0,w.$2m)(u,S,!1),Object.freeze(u)}g(i){const o=y=>(0,g.$zf)(y)?new Proxy(y,{get:($,S)=>o($[S]),set:($,S,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:($,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:($,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:$=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return o(i)}h(i,o,y){const $=E.$nn.test(i)?4:this.d.get(i),S=y?`[${y.value}] `:"";if($===4){typeof o?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if($===3){o?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(i,o){const y=new h.$yn(i,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:($,S)=>y.affectsConfiguration($,D(S))})}k(i){return i.reduce((o,y)=>(o.set(y[0],y[1]),o),new Map)}}e.$Sbc=r,e.$Tbc=(0,k.$Nh)("IExtHostConfiguration")}),define(Ae[111],Re([1,0,2,13,5,3,7,33,60,34,21,63,17,27,4,12,22,14,80,214,9]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=e.$Pcc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var p;(function(V){function U(N){if(N!=null)return N}V.from=U;function W(N){if(N!=null)return N}V.to=W})(p||(p={}));var r;(function(V){function U(N){if(N!=null)return N}V.from=U;function W(N){if(N!=null)return N}V.to=W})(r||(r={}));var s;(function(V){function U(N){if(N!=null)return N}V.from=U;function W(N){if(N!=null)return N}V.to=W})(s||(s={}));var i;(function(V){function U(O){if(O){const ee=O;return ee&&!!ee.process}else return!1}V.is=U;function W(O){if(O==null)return;const ee={process:O.process,args:O.args};return O.options&&(ee.options=s.from(O.options)),ee}V.from=W;function N(O){if(O!=null)return new A.$SK(O.process,O.args,O.options)}V.to=N})(i||(i={}));var o;(function(V){function U(N){if(N!=null)return N}V.from=U;function W(N){if(N!=null)return N}V.to=W})(o||(o={}));var y;(function(V){function U(O){if(O){const ee=O;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}V.is=U;function W(O){if(O==null)return;const ee={};return O.commandLine!==void 0?ee.commandLine=O.commandLine:(ee.command=O.command,ee.args=O.args),O.options&&(ee.options=o.from(O.options)),ee}V.from=W;function N(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.$TK(O.commandLine,O.options):new A.$TK(O.command,O.args?O.args:[],O.options)}V.to=N})(y||(y={}));var $;(function(V){function U(O){if(O){const ee=O;return ee&&ee.customExecution==="customExecution"}else return!1}V.is=U;function W(O){return{customExecution:"customExecution"}}V.from=W;function N(O,ee){return ee.get(O)}V.to=N})($||(e.CustomExecutionDTO=$={}));var S;(function(V){function U(W,N){let O;return W.scope!==void 0&&typeof W.scope!="number"?O=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===A.TaskScope.Workspace&&N&&N.workspaceFile?O=N.workspaceFile:O=v.$KF),{id:W._id,workspaceFolder:O}}V.from=U})(S||(e.TaskHandleDTO=S={}));var I;(function(V){function U(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}V.from=U})(I||(I={}));var u;(function(V){function U(O,ee){if(O==null)return[];const Z=[];for(const ye of O){const De=W(ye,ee);De&&Z.push(De)}return Z}V.fromMany=U;function W(O,ee){if(O==null)return;let Z;O.execution instanceof A.$SK?Z=i.from(O.execution):O.execution instanceof A.$TK?Z=y.from(O.execution):O.execution&&O.execution instanceof A.$UK&&(Z=$.from(O.execution));const ye=p.from(O.definition);let De;return O.scope?typeof O.scope=="number"?De=O.scope:De=O.scope.uri:De=A.TaskScope.Workspace,!ye||!De?void 0:{_id:O._id,definition:ye,name:O.name,source:{extensionId:ee.identifier.value,label:O.source,scope:De},execution:Z,isBackground:O.isBackground,group:I.from(O.group),presentationOptions:r.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}V.from=W;async function N(O,ee,Z){if(O==null)return;let ye;i.is(O.execution)?ye=i.to(O.execution):y.is(O.execution)?ye=y.to(O.execution):$.is(O.execution)&&(ye=$.to(O._id,Z));const De=p.to(O.definition);let Pe;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Pe=O.source.scope:Pe=await ee.resolveWorkspaceFolder(w.URI.revive(O.source.scope)):Pe=A.TaskScope.Workspace),!De||!Pe)return;const X=new A.$VK(De,Pe,O.name,O.source.label,ye,O.problemMatchers);return O.isBackground!==void 0&&(X.isBackground=O.isBackground),O.group!==void 0&&(X.group=A.$RK.from(O.group._id),X.group&&O.group.isDefault&&(X.group=new A.$RK(X.group.id,X.group.label),O.group.isDefault===!0&&(X.group.isDefault=O.group.isDefault))),O.presentationOptions&&(X.presentationOptions=r.to(O.presentationOptions)),O._id&&(X._id=O._id),O.detail&&(X.detail=O.detail),X}V.to=N})(u||(e.TaskDTO=u={}));var d;(function(V){function U(N){return N}V.from=U;function W(N){if(N)return Object.assign(Object.create(null),N)}V.to=W})(d||(d={}));class l{#e;constructor(U,W,N){this._id=W,this.a=N,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let R=class{constructor(U,W,N,O,ee,Z,ye,De){this.q=new C.$Md,this.r=new C.$Md,this.s=new C.$Md,this.t=new C.$Md,this.a=U.getProxy(F.$9J.MainThreadTask),this.b=N,this.c=O,this.d=ee,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ye,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,W,N){if(!N)return new A.$$J(()=>{});const O=this.w();return this.j.set(O,{type:W,provider:N,extension:U}),this.a.$registerTaskProvider(O,W),new A.$$J(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(U,W){this.a.$registerTaskSystem(U,W)}fetchTasks(U){return this.a.$fetchTasks(d.from(U)).then(async W=>{const N=[];for(const O of W){const ee=await u.to(O,this.b,this.m);ee&&N.push(ee)}return N})}get taskExecutions(){const U=[];return this.k.forEach(W=>U.push(W)),U}terminateTask(U){if(!(U instanceof l))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,W,N){const O=this.m.get(U.id);O&&(this.o.set(U.id,O),this.e.attachPtyToTerminal(W,await O.callback(N))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const W=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const W=await this.y(U.id);this.s.fire({execution:W,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const W=await this.y(U.id);this.t.fire({execution:W,exitCode:U.exitCode})}$provideTasks(U,W){const N=this.j.get(U);if(!N)return Promise.reject(new Error("no handler found"));const O=[],ee=(0,M.$Lg)(()=>N.provider.provideTasks(P.CancellationToken.None)).then(Z=>this.u(W,O,N,Z));return new Promise(Z=>{ee.then(ye=>{Promise.all(O).then(()=>{Z(ye)})})})}async $resolveTask(U,W){const N=this.j.get(U);if(!N)return Promise.reject(new Error("no handler found"));if(W.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${N.type}].`);const O=await u.to(W,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const ee=await N.provider.resolveTask(O,P.CancellationToken.None);if(!ee)return;this.z(ee,N);const Z=u.from(ee,N.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return $.is(Z.execution)&&await this.x(Z,ee,!0),await this.v(Z)}w(){return this.h++}async x(U,W,N){const O=await this.a.$createTaskId(U);!N&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,W.execution)),this.m.set(O,W.execution)}async y(U,W){if(typeof U=="string"){const ee=this.l.get(U);if(!ee)throw new D.$ab("Unexpected: The specified task is missing an execution");return ee}const N=this.l.get(U.id);if(N)return N;const O=new Promise((ee,Z)=>{function ye(De,Pe,X){X?ee(new l(De,Pe.id,X)):Z("Unexpected: Task does not exist.")}W?ye(this,U,W):u.to(U.task,this.b,this.m).then(De=>ye(this,U,De))});return this.l.set(U.id,O),O.then(ee=>(this.k.set(U.id,ee),ee),ee=>Promise.reject(ee))}z(U,W){U._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const N=this.n.values();let O=N.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=N.next()}};e.$Pcc=R,e.$Pcc=R=Ke([Ve(0,a.$0L),Ve(1,b.$nM),Ve(2,h.$Qbc),Ve(3,E.$iM),Ve(4,g.$Tbc),Ve(5,k.$_bc),Ve(6,n.$8i),Ve(7,c.$Gbc)],R);let B=class extends R{constructor(U,W,N,O,ee,Z,ye,De){super(U,W,N,O,ee,Z,ye,De),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.$i(0)})}async executeTask(U,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const N=u.from(W,U);if(N===void 0)throw new Error("Task is not valid");if($.is(N.execution))await this.x(N,W,!1);else throw new D.$$;const O=await this.y(await this.a.$getTaskExecution(N),W);return this.a.$executeTask(N).catch(ee=>{throw new Error(ee)}),O}u(U,W,N,O){const ee=[];if(O)for(const Z of O){this.z(Z,N),(!Z.definition||!U[Z.definition.type])&&this.f.warn(`The task [${Z.source}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`);const ye=u.from(Z,N.extension);ye&&$.is(ye.execution)?(ee.push(ye),W.push(this.x(ye,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:N.extension}}async v(U){if($.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,W,N){}};e.$Qcc=B,e.$Qcc=B=Ke([Ve(0,a.$0L),Ve(1,b.$nM),Ve(2,h.$Qbc),Ve(3,E.$iM),Ve(4,g.$Tbc),Ve(5,k.$_bc),Ve(6,n.$8i),Ve(7,c.$Gbc)],B),e.$Rcc=(0,m.$Nh)("IExtHostTask")}),define(Ae[266],Re([1,0,19,21,41,37,23,59,47]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;class g{constructor(a,b,m){this.k=a,this.l=b,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&F.$uj(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&F.$uj(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const b=this.k.folderQueries||[];return new Promise((m,f)=>{const t=n=>{this.f++,a(n)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(n=>{const c=n.toString(),v=w.$mc(c);this.j&&this.j(c,v)||this.v(t,{base:n,basename:v})}),Promise.all(b.map(n=>this.p(n,t))).then(n=>{m({limitHit:this.e,stats:n[0]||void 0})},n=>{f(new Error((0,C.$yi)(n)))})})}async p(a,b){const m=new M.$Wd,f=this.q(a),t=this.r(),n=new E.$TI(this.k,a),c=!n.hasSiblingExcludeClauses();let v;try{this.h.add(m),v=h.$Id.create();const D=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,m.token),p=v.elapsed(),r=h.$Id.create();return this.g&&!this.e||(D&&D.forEach(s=>{const i=w.$fc.relative(a.folder.path,s.path);if(c){const o=w.$mc(s.path);this.v(b,{base:a.folder,relativePath:i,basename:o});return}this.s(t,a.folder,i,b)}),this.g&&!this.e)?null:(this.u(t,n,b),{providerTime:p,postProcessTime:r.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(a){const b=(0,E.$SI)(this.k.includePattern,a.includePattern),m=(0,E.$SI)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:m,includes:b,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},b,m,f){if(m===this.a){const n=w.$mc(this.a);this.v(f,{base:b,relativePath:this.a,basename:n})}function t(n){const c=w.$mc(n),v=w.$lc(n);let D=a[v];D||(D=a[v]=[],t(v)),D.push({base:b,relativePath:n,basename:c})}t(m)}u({rootEntries:a,pathToEntries:b},m,f){const t=this,n=this.a;function c(v){const D=(0,E.$VI)(()=>v.map(p=>p.basename));for(let p=0,r=v.length;p<r;p++){const s=v[p],{relativePath:i,basename:o}=s;if(m.matchesExcludesSync(i,o,n!==o?D:void 0))continue;const y=b[i];if(y)c(y);else{if(i===n)continue;t.v(f,s)}if(t.e)break}}c(a)}v(a,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(b))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,b,m,f){const t=this.c(a.cacheKey),n=new g(a,b,t&&t.token);let c=0;const v=D=>{c+=D.length,m(D.map(p=>this.d(p)))};return this.e(n,P.a,v,f).then(D=>({limitHit:D.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:D.stats}}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new M.$Wd),this.b.get(a)}d(a){return a.relativePath?{resource:A.$ug(a.base,a.relativePath)}:{resource:a.base}}e(a,b,m,f){const t=f.onCancellationRequested(()=>{a.cancel()}),n=v=>{v&&(c.push(v),b>0&&c.length>=b&&(m(c),c=[]))};let c=[];return a.search(n).then(v=>(c.length&&m(c),t.dispose(),v),v=>(c.length&&m(c),t.dispose(),Promise.reject(v)))}}e.$2cc=P}),define(Ae[267],Re([1,0,18,231,37,90,28,12,19,23,15,16,2,282,167,43,14,54,102,265,47]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.$MJ=void 0;let p=class{constructor(d,l,R,B,V){this.a=d,this.b=l,this.c=R,this.d=B,this.e=V}text(d,l,R={}){d=this.f(d,R);const B=this.a.getValue(),V=l&&l.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(l?.map(n.$9h),R),type:2,contentPattern:d,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:B.search.usePCRE2||V||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(d,l){const R=this.a.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const B={...d,wordSeparators:R.editor.wordSeparators};return this.j(d,l)&&(B.isCaseSensitive=!0),this.k(d)&&(B.isMultiline=!0),l.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=l.notebookSearchConfig.includeMarkupInput),l.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=l.notebookSearchConfig.includeMarkupPreview),l.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=l.notebookSearchConfig.includeCodeInput),l.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=l.notebookSearchConfig.includeOutput),B}file(d,l={}){return{...this.h(d,l),type:1,filePattern:l.filePattern?l.filePattern.trim():l.filePattern,exists:l.exists,sortByScore:l.sortByScore,cacheKey:l.cacheKey}}g(d,l){return d?(d=Array.isArray(d)?d.map(y):y(d),l?this.parseSearchPaths(d):{pattern:s(...Array.isArray(d)?d:[d])}):{}}h(d=[],l={}){const R=this.g(l.includePattern,l.expandPatterns),B=this.g(l.excludePattern,l.expandPatterns),V=d.length>1,U=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(O=>this.q(O,l,B)):d.map(O=>this.r(O,l,B,V))).filter(O=>!!O),W={_reason:l._reason,folderQueries:U,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:l.extraFileResources,excludePattern:B.pattern,includePattern:R.pattern,onlyOpenEditors:l.onlyOpenEditors,maxResults:l.maxResults};if(l.onlyOpenEditors){const O=w.$Gb(w.$Qb(this.c.groups.map(ye=>ye.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const ee=O.filter(ye=>(0,D.$JI)(W,ye.fsPath)),Z=this.i(ee);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...W,...Z}}const N=l.extraFileResources&&l.extraFileResources.filter(O=>(0,D.$JI)(W,O.fsPath));return W.extraFileResources=N&&N.length?N:void 0,W}i(d){const l=[],R=new A.$zc,B={};let V=!1;return d.forEach(U=>{if(U.scheme===h.Schemas.walkThrough)return;if((0,g.$yg)(U)){const N=this.b.getWorkspaceFolder(U)?.uri??U.with({path:E.$lc(U.fsPath)});let O=R.get(N);O||(V=!0,O={folder:N,includePattern:{}},l.push(O),R.set(N,O));const ee=E.$kc(N.fsPath,U.fsPath);(0,k.$If)(O.includePattern)[ee.replace(/\\/g,"/")]=!0}else U.fsPath&&(V=!0,B[U.fsPath]=!0)}),{folderQueries:l,includePattern:B,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(d,l){if(l.isSmartCase){if(d.isRegExp){if(P.$of(d.pattern,!0))return!0}else if(P.$of(d.pattern))return!0}return!!d.isCaseSensitive}k(d){return d.isMultiline||d.isRegExp&&(0,b.$nB)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const l=Z=>E.$hc(Z)||/^\.\.?([\/\\]|$)/.test(Z),B=(Array.isArray(d)?d:i(d)).map(Z=>{const ye=this.e.resolvedUserHome;return ye?(0,F.$nv)(Z,ye.scheme===h.Schemas.file?ye.fsPath:ye.path):Z}),V=M.$J(B,Z=>l(Z)?"searchPaths":"exprSegments"),U=(V.exprSegments||[]).map(Z=>P.$Je(Z,"/")).map(Z=>P.$Je(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),o(Z))),W={},N=this.m(V.searchPaths||[]);N&&N.length&&(W.searchPaths=N);const O=w.$Qb(U),ee=s(...O);return ee&&(W.pattern=ee),W}l(d,l){return l.disregardExcludeSettings?void 0:(0,D.$II)(d,!l.disregardSearchExcludeSettings)}m(d){if(!d||!d.length)return[];const l=d.flatMap(B=>{let{pathPortion:V,globPortion:U}=r(B);return U&&(U=$(U)),this.n(V).flatMap(N=>this.o(N,U))}),R=new Map;return l.forEach(B=>{const V=B.searchPath.toString(),U=R.get(V);U?B.pattern&&(U.pattern=U.pattern||{},U.pattern[B.pattern]=!0):R.set(V,{searchPath:B.searchPath,pattern:B.pattern?s(B.pattern):void 0})}),Array.from(R.values())}n(d){if(E.$hc(d)){const l=this.b.getWorkspace().folders;return l[0]&&l[0].uri.scheme!==h.Schemas.file?[{searchPath:l[0].uri.with({path:d})}]:[{searchPath:a.URI.file(E.$gc(d))}]}if(this.b.getWorkbenchState()===2){const l=this.b.getWorkspace().folders[0].uri;if(d=y(d),d.startsWith("../")||d===".."){const B=E.$fc.resolve(l.path,d);return[{searchPath:l.with({path:B})}]}const R=$(d);return[{searchPath:l,pattern:R}]}else{if(d==="./"||d===".\\")return[];{const l=d.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(V=>{const U=l.match(new RegExp(`^${P.$Ee(V.name)}(?:/(.*)|$)`));return U?{match:U,folder:V}:null}).filter(k.$Ff);if(B.length)return B.map(V=>{const U=V.match[1];return{searchPath:V.folder.uri,pattern:U&&$(U)}});{const V=d.match(/\.[\/\\](.+)[\/\\]?/),U=V?V[1]:d,W=m.localize(0,null,U);throw new Error(W)}}}}o(d,l){const R=d.pattern&&l?`${d.pattern}/${l}`:d.pattern||l,B=[{searchPath:d.searchPath,pattern:R}];return R&&!R.endsWith("**")&&B.push({searchPath:d.searchPath,pattern:R+"/**"}),B}q(d,l,R){const B=this.r((0,n.$9h)(d.searchPath),l,R,!1);return B?{...B,includePattern:d.pattern}:null}r(d,l,R,B){let V;const U=a.URI.isUri(d)?d:d.uri;if(R.searchPaths){const Z=R.searchPaths.filter(ye=>(0,g.$ng)(ye.searchPath,U))[0];if(Z&&!Z.pattern)return null;Z&&(V=Z.pattern)}const W=this.a.getValue({resource:U}),O={...this.l(W,l)||{},...V||{}},ee=a.URI.isUri(d)?(0,g.$rg)(d):d.name;return{folder:U,folderName:B?ee:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof l.disregardIgnoreFiles=="boolean"?l.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof l.disregardGlobalIgnoreFiles=="boolean"?l.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof l.disregardParentIgnoreFiles=="boolean"?l.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof l.ignoreSymlinks=="boolean"?l.ignoreSymlinks:!W.search.followSymlinks}}};e.$MJ=p,e.$MJ=p=Ke([Ve(0,f.$hi),Ve(1,n.$Wh),Ve(2,c.$0B),Ve(3,t.$8i),Ve(4,v.$KJ)],p);function r(u){const d=u.match(/[\*\{\}\(\)\[\]\?]/);if(d){const l=d.index,R=u.substr(0,l).match(/[/|\\][^/\\]*$/);if(R){let B=u.substr(0,R.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:u.substr((R.index||0)+1)}}}return{pathPortion:u}}function s(...u){return u.length?u.reduce((d,l)=>(d[l]=!0,d),Object.create(null)):void 0}function i(u){return C.$sj(u,",").map(d=>d.trim()).filter(d=>!!d.length)}function o(u){return[`**/${u}/**`,`**/${u}`].map(l=>l.replace(/\*\*\/\*\*/g,"**"))}function y(u){return u.replace(/\\/g,"/")}function $(u){return y(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(u){return u.replace(/([?*[\]])/g,"[$1]")}function I(u,d){u=w.$Lb(u,B=>B.toString());const l=[],R=d.getWorkspace();return u&&u.forEach(B=>{let V;if(d.getWorkbenchState()===2)V=(0,g.$wg)(R.folders[0].uri,B),V&&V!=="."&&(V="./"+V);else{const U=d.getWorkspaceFolder(B);if(U){const W=U.name;if(R.folders.filter(O=>O.name===W).length===1){const O=(0,g.$wg)(U.uri,B);O===""?V=`./${U.name}`:V=`./${U.name}/${O}`}else V=B.fsPath}}V&&l.push(S(V))}),l}e.$NJ=I}),define(Ae[268],Re([1,0,23,2,21,9,4,267,47,54]),function(be,e,w,M,C,F,A,h,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlb=e.$llb=void 0;const P=7e3;function k(f,t){const n=t.activationEvents;if(!n)return Promise.resolve(void 0);const c=[],v=[];for(const o of n)if(/^workspaceContains:/.test(o)){const y=o.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||f.forceUsingSearch?v.push(y):c.push(y)}if(c.length===0&&v.length===0)return Promise.resolve(void 0);let D;const p=new Promise((o,y)=>{D=o}),r=o=>D({activationEvent:o}),s=Promise.all(c.map(o=>a(f,o,r))).then(()=>{}),i=b(f,t.identifier,v,r);return Promise.all([s,i]).then(()=>{D(void 0)}),p}e.$llb=k;async function a(f,t,n){for(const c of f.folders)if(await f.exists(w.$ug(M.URI.revive(c),t))){n(`workspaceContains:${t}`);return}}async function b(f,t,n,c){if(n.length===0)return Promise.resolve(void 0);const v=new C.$Wd,D=f.checkExists(f.folders,n,v.token),p=setTimeout(async()=>{v.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},P);let r=!1;try{r=await D}catch(s){F.$3(s)||F.$Z(s)}v.dispose(),clearTimeout(p),r&&c(`workspaceContains:${n.join(",")}`)}function m(f,t,n,c){const v=f.get(A.$Mh),D=f.get(E.$AI),r=v.createInstance(h.$MJ).file(t.map(s=>(0,g.$9h)(M.URI.revive(s))),{_reason:"checkExists",includePattern:n,exists:!0});return D.fileSearch(r,c).then(s=>!!s.limitHit,s=>F.$3(s)?!1:Promise.reject(s))}e.$mlb=m}),define(Ae[35],Re([1,0,148,19,87,23,13,6,49,2,14,3,34,209,84,33,26,106,9,20,25,188,7,97,4,27,85,17,71,86,63,5,268,83,190,12,81,59,22,82]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r,s,i,o,y,$,S,I,u,d,l,R,B,V,U,W,N,O){"use strict";var ee;Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=e.$ncc=e.$mcc=e.$lcc=e.$kcc=void 0,e.$kcc=(0,i.$Nh)("IHostUtils");let Z=ee=class extends h.$Rc{constructor(ie,z,q,ue,we,ve,me,ke,re,he,se,oe){super(),this.X=oe,this.a=this.B(new d.$Md),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=z,this.g=q,this.f=me,this.j=ue,this.m=we,this.s=ve,this.t=re,this.u=he,this.w=se,this.y=this.g.getProxy(k.$9J.MainThreadWorkspace),this.z=this.g.getProxy(k.$9J.MainThreadTelemetry),this.C=this.g.getProxy(k.$9J.MainThreadExtensionService),this.D=new A.$Rg,this.F=new A.$Rg,this.G=new A.$Rg,this.H=new A.$Rg,this.I=new ce(this.f.extensions.activationEvents),this.L=new n.$63b(this.I,this.f.extensions.allExtensions);const de=new v.$Zl(this.f.extensions.myExtensions);this.J=new n.$63b(this.I,le(this.L,de)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new m.$4bc(this.g,this.s),this.N=new R.$dcc(this.g),this.O=ke,this.h=ie.createChild(new S.$Lh([m.$5bc,this.M],[R.$ecc,this.N])),this.P=this.B(new b.$3bc(this.J,this.L,{onExtensionActivationError:(Ie,T,K)=>{this.C.$onExtensionActivationError(Ie,c.$2(T),K)},actualActivateExtension:async(Ie,T)=>{if(n.$63b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,T),new b.$2bc;const K=this.J.getExtensionDescription(Ie);return this.db(K,T)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ie){c.$Z(ie)}}async Y(){this.O.onWillDeactivateAll();let ie=[];try{ie=this.J.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.cb(we))}catch{}await Promise.all(ie)}terminate(ie,z=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ie}`),this.s.flush(),this.u.dispose(),this.P.dispose(),c.setUnexpectedErrorHandler(ue=>{this.s.error(ue)}),this.g.dispose();const q=this.Y();Promise.race([(0,A.$Tg)(5e3),q]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(ie){return this.G.isOpen()?this.P.isActivated(ie):!1}async getExtension(ie){const z=await this.C.$getExtension(ie);return z&&{...z,identifier:new v.$Yl(z.identifier.value),extensionLocation:g.URI.revive(z.extensionLocation)}}Z(ie,z){return this.P.activateByEvent(ie,z)}$(ie,z){return this.P.activateById(ie,z)}activateByIdWithErrors(ie,z){return this.$(ie,z).then(()=>{const q=this.P.getActivatedExtension(ie);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ie=>this.J)}getExtensionExports(ie){if(this.G.isOpen())return this.P.getActivatedExtension(ie).exports;try{return this.P.getActivatedExtension(ie).exports}catch{return null}}async ab(ie){if(ie.scheme===V.Schemas.file&&this.c.fsRealpath){const z=await this.c.fsRealpath(ie.fsPath);return g.URI.file(z)}return ie}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ie=>new Ee(ie))),this.Q}async bb(ie){const z=E.$Th.forUris(q=>F.$lg.ignorePathCasing(q));return await Promise.all(ie.map(async q=>{if(this.ub(q)){const ue=await this.ab(q.extensionLocation);z.set(ue,q)}})),z}cb(ie){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ie))return z;const q=this.P.getActivatedExtension(ie);if(!q)return z;try{typeof q.module.deactivate=="function"&&(z=Promise.resolve(q.module.deactivate()).then(void 0,ue=>(this.s.error(ue),Promise.resolve(void 0))))}catch(ue){this.s.error(`An error occurred when deactivating the extension '${ie.value}':`),this.s.error(ue)}try{(0,h.$Mc)(q.subscriptions)}catch(ue){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this.s.error(ue)}return z}async db(ie,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ie.identifier):await this.C.$onWillActivateExtension(ie.identifier),this.fb(ie,z).then(q=>{const ue=q.activationTimes;return this.C.$onDidActivateExtension(ie.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,z),this.eb(ie,z,"success",ue),q},q=>{throw this.eb(ie,z,"failure"),q})}eb(ie,z,q,ue){const we=De(ie,z);this.z.$publicLog2("extensionActivationTimes",{...we,...ue||{},outcome:q})}fb(ie,z){const q=De(ie,z);this.z.$publicLog2("activatePlugin",q);const ue=this.ub(ie);if(!ue)return Promise.resolve(new b.$1bc(b.$Xbc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${ie.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const we=new b.$Ybc(z.startup);return Promise.all([this.vb(ie,(0,F.$ug)(ie.extensionLocation,ue),we),this.gb(ie)]).then(ve=>(C.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),ee.hb(this.s,ie.identifier,ve[0],ve[1],we))).then(ve=>(C.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),ve))}gb(ie){const z=new p.$7bc(ie,this.M),q=new p.$6bc(ie.identifier.value,!1,this.M),ue=new B.$fcc(ie,this.N),we=ie.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,ve=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([z.whenReady,q.whenReady,this.O.whenReady]).then(()=>{const me=this;let ke,re;const he=(0,t.$8E)(ie,"ipc")?this.f.messagePorts?.get(v.$Yl.toKey(ie.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:q,secrets:ue,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(se){return M.$ic(ie.extensionLocation.fsPath,se)},get storagePath(){return me.O.workspaceValue(ie)?.fsPath},get globalStoragePath(){return me.O.globalValue(ie).fsPath},get logPath(){return M.$ic(me.f.logsLocation.fsPath,ie.identifier.value)},get logUri(){return g.URI.joinPath(me.f.logsLocation,ie.identifier.value)},get storageUri(){return me.O.workspaceValue(ie)},get globalStorageUri(){return me.O.globalValue(ie)},get extensionMode(){return we},get extension(){return ke===void 0&&(ke=new X(me,ie.identifier,ie,ve,!1)),ke},get extensionRuntime(){return(0,t.$9E)(ie,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me.u.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!re){if(!he)return;const se=d.Event.buffer(d.Event.fromDOMEventEmitter(he,"message",oe=>oe.data));he.start(),re={onDidReceiveMessage:se,postMessage:he.postMessage.bind(he)}}return re}})})}static hb(ie,z,q,ue,we){return q=q||{activate:void 0,deactivate:void 0},this.ib(ie,z,q,ue,we).then(ve=>new b.$Zbc(!1,null,we.build(),q,ve,ue.subscriptions))}static ib(ie,z,q,ue,we){if(typeof q.activate=="function")try{we.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${z.value}`);const ve=typeof global=="object"?global:self,me=q.activate.apply(ve,[ue]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(me).then(ke=>(we.activateResolveStop(),ke))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}jb(ie,z){this.$(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:z}).then(void 0,q=>{this.s.error(q)})}kb(ie,z=0){const ue=Date.now();(0,N.$B)(()=>{for(let we=z;we<ie.length;we+=1){const ve=ie[we];for(const me of ve.activationEvents??[])if(me==="onStartupFinished")if(Date.now()-ue>50){this.kb(ie,we);break}else this.jb(ve,me)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(ie=>{const z=ie.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),q=this.J.getAllExtensionDescriptions();if(z)this.kb(q);else for(const ue of q)if(ue.activationEvents)for(const we of ue.activationEvents)we==="onStartupFinished"&&this.jb(ue,we)})}mb(){const ie=this.Z("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.nb(ve.added)));const z=this.j.workspace?this.j.workspace.folders:[],q=this.nb(z),ue=this.pb(),we=Promise.all([ue,ie,q]).then(()=>{});return Promise.race([we,(0,A.$Tg)(1e4)]).then(()=>{this.lb()}),we}nb(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.ob(ie,z))).then(()=>{})}async ob(ie,z){if(this.isActivated(z.identifier))return;const q=!this.f.remote.isRemote&&!!this.f.remote.authority,ue={logService:this.s,folders:ie.map(ve=>ve.uri),forceUsingSearch:q||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,me,ke)=>this.y.$checkExists(ve,me,ke)},we=await(0,l.$llb)(ue,z);if(we)return this.$(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:we.activationEvent}).then(void 0,ve=>this.s.error(ve))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ie){throw console.error(ie),ie}}async qb(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:z}=this.f.environment;if(!ie||!z)throw new Error(w.localize(0,null));const q=await this.vb(null,z,new b.$Ybc(!1));if(!q||typeof q.run!="function")throw new Error(w.localize(1,null,z.toString()));return new Promise((ue,we)=>{const ve=(re,he)=>{re?(N.$t&&this.s.error("Test runner called back with error",re),we(re)):(N.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),ue(typeof he=="number"&&he>0?1:0))},me=(0,F.$ig)(z),ke=q.run(me,ve);ke&&ke.then&&ke.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),ue(0)}).catch(re=>{N.$t&&this.s.error("Test runner finished with error",re),we(re instanceof Error&&re.stack?re.stack:String(re))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Tg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,z){return this.R[ie]=z,(0,h.$Pc)(()=>{delete this.R[ie]})}async getRemoteExecServer(ie){const{resolver:z}=await this.sb(ie);return z?.resolveExecServer?.(ie,{resolveAttempt:0})}async sb(ie){const z=ie.indexOf("+");if(z===-1)throw new r.$eK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const q=ie.substr(0,z);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this.R[q]}}async $resolveAuthority(ie,z){const q=W.$Id.create(!1),ue=()=>`[resolveAuthority(${(0,s.$Qk)(ie)},${z})][${q.elapsed()}ms] `,we=Q=>this.s.info(`${ue()}${Q}`),ve=Q=>this.s.warn(`${ue()}${Q}`),me=(Q,H=void 0)=>this.s.error(`${ue()}${Q}`,H),ke=Q=>{if(Q instanceof r.$eK)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q},re=async Q=>{we(`activating resolver for ${Q}...`);const{resolver:H,authorityPrefix:_}=await this.sb(Q);if(!H)throw me(`no resolver for ${_}`),new r.$eK(`No remote extension installed to resolve ${_}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:_,remoteAuthority:Q}},he=ie.split(/@|%40/g).reverse();we(`activating remote resolvers ${he.join(" -> ")}`);let se;try{se=await Promise.all(he.map(re)).catch(async Q=>{if(!(Q instanceof r.$eK)||Q._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Q;return ve(`resolving nested authorities failed: ${Q.message}`),[await re(ie)]})}catch(Q){return ke(Q)}const oe=new A.$4g;oe.cancelAndSet(()=>we("waiting..."),1e3);let de,Ie;for(const[Q,{authorityPrefix:H,resolver:_,remoteAuthority:ae}]of se.entries())try{if(Q===se.length-1)we("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${H}`),de=await _.resolve(ae,{resolveAttempt:z,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${H}`),we("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(_,r.$dK.isManagedResolvedAuthority(de)?de:void 0));else{if(we(`invoking resolveExecServer() for ${ae}`),C.mark(`code/extHost/willResolveExecServer/${H}`),Ie=await _.resolveExecServer?.(ae,{resolveAttempt:z,execServer:Ie}),!Ie)throw new r.$eK(`Exec server was not available for ${ae}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(Fe){return C.mark(`code/extHost/didResolveAuthorityError/${H}`),me("returned an error",Fe),oe.dispose(),ke(Fe)}oe.dispose();const T={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures},K={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};we(`returned ${r.$dK.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let G;if(r.$dK.isManagedResolvedAuthority(de)){const Q=z;this.X.setFactory(Q,de.makeConnection),G={authority:ie,connectTo:new s.$Nk(Q),connectionToken:de.connectionToken}}else G={authority:ie,connectTo:new s.$Ok(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:G,options:K,tunnelInformation:T}}}async $getCanonicalURI(ie,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Qk)(ie)})`);const{resolver:q}=await this.sb(ie);if(!q)return null;const ue=g.URI.revive(z);if(typeof q.getCanonicalURI>"u")return ue;const we=await(0,A.$Lg)(()=>q.getCanonicalURI(ue));return we||ue}$startExtensionHost(ie){ie.toAdd.forEach(ue=>ue.extensionLocation=g.URI.revive(ue.extensionLocation));const{globalRegistry:z,myExtensions:q}=ye(this.I,this.L,this.J,ie);return this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(ie,z){return z===1?this.D.wait().then(q=>this.Z(ie,!1)):this.G.wait().then(q=>this.Z(ie,!1))}async $activate(ie,z){return await this.G.wait(),this.J.getExtensionDescription(ie)?(await this.$(ie,z),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(ve=>ve.extensionLocation=g.URI.revive(ve.extensionLocation));const{globalRegistry:z,myExtensions:q}=ye(this.I,this.L,this.J,ie),ue=await this.bb(q);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const z=D.$ae.alloc(ie),q=Math.random()%256;for(let ue=0;ue<ie;ue++)z.writeUInt8(q,ue);return z}async $updateRemoteConnectionData(ie){this.W=ie,this.a.fire()}};e.$lcc=Z,e.$lcc=Z=ee=Ke([Ve(0,i.$Mh),Ve(1,e.$kcc),Ve(2,$.$0L),Ve(3,f.$Qbc),Ve(4,a.$Tbc),Ve(5,P.$8i),Ve(6,o.$nM),Ve(7,y.$0bc),Ve(8,I.$Rvb),Ve(9,u.$_bc),Ve(10,U.$hcc),Ve(11,O.$icc)],Z);function ye($e,ie,z,q){$e.addActivationEvents(q.addActivationEvents);const ue=new n.$63b($e,ie.getAllExtensionDescriptions());ue.deltaExtensions(q.toAdd,q.toRemove);const we=new v.$Zl(z.getAllExtensionDescriptions().map(me=>me.identifier));for(const me of q.myToRemove)we.delete(me);for(const me of q.myToAdd)we.add(me);const ve=le(ue,we);return{globalRegistry:ue,myExtensions:ve}}function De($e,ie){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}function Pe($e){return $e.getAllExtensionDescriptions().map(ie=>ie.identifier.value).join(",")}e.$mcc=(0,i.$Nh)("IExtHostExtensionService");class X{#e;#t;#i;constructor(ie,z,q,ue,we){this.#e=ie,this.#t=z,this.#i=q.identifier,this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=M.$gc((0,F.$ig)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=ue,this.isFromDifferentExtensionHost=we}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$ncc=X;function le($e,ie){return $e.getAllExtensionDescriptions().filter(z=>ie.has(z.identifier))}class Ee{constructor(ie){this.a=ie}setSearchTree(ie){this.a=ie}findSubstr(ie){return this.a.findSubstr(ie)}forEach(ie){return this.a.forEach(ie)}}e.$occ=Ee;class ce{constructor(ie){this.a=new v.$1l,this.addActivationEvents(ie)}readActivationEvents(ie){return this.a.get(ie.identifier)}addActivationEvents(ie){for(const z of Object.keys(ie))this.a.set(z,ie[z])}}}),define(Ae[269],Re([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;let f=class{constructor(D,p,r,s,i,o,y){this.c=D,this.d=p,this.e=r,this.f=s,this.g=i,this.h=o,this.i=y,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const D=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const p=await this.g.getExtensionPathIndex();this.register(new n(this.c,p,this.d,D,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(c,p,this.h.environment.appUriScheme))}register(D){if("nodeModuleName"in D)if(Array.isArray(D.nodeModuleName))for(const p of D.nodeModuleName)this.a.set(p,D);else this.a.set(D.nodeModuleName,D);typeof D.alternativeModuleName=="function"&&this.b.push(p=>D.alternativeModuleName(p))}};e.$Kdc=f,e.$Kdc=f=Ke([Ve(2,P.$Mh),Ve(3,F.$Tbc),Ve(4,k.$mcc),Ve(5,g.$nM),Ve(6,a.$8i)],f);let t=class{static{m=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(D){if(D.environment.appRoot&&m.a.size){const p=(0,b.$Ee)(this.c(D.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${p}/${i}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(D){if(!this.b)return;const p=this.b.exec(this.c(D));if(!p)return;const[,r,s,i]=p,o=m.a.get(s);if(o!==void 0)return console.warn(`${s} as been renamed to ${o}, please update your imports`),r+o+i}c(D){return D.replace(/\\/g,"/")}};t=m=Ke([Ve(0,g.$nM)],t);class n{constructor(D,p,r,s,i){this.c=D,this.d=p,this.e=r,this.f=s,this.g=i,this.nodeModuleName="vscode",this.a=new h.$1l}load(D,p){const r=this.d.findSubstr(p);if(r){let s=this.a.get(r.identifier);return s||(s=this.c(r,this.e,this.f),this.a.set(r.identifier,s)),s}if(!this.b){let s="";this.d.forEach((i,o)=>s+=`	${o} -> ${i.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${p}. These are the extension path mappings: 
${s}`),this.b=this.c(A.$3E,this.e,this.f)}return this.b}}let c=class{constructor(D,p,r){this.e=D,this.f=p,this.nodeModuleName=["open","opn"],this.d=r.getProxy(C.$9J.MainThreadTelemetry);const s=r.getProxy(C.$9J.MainThreadWindow);this.c=(i,o)=>{const y=M.URI.parse(i);return o?this.g(i,o):y.scheme==="http"||y.scheme==="https"?s.$openUri(y,i,{allowTunneling:!0}):y.scheme==="mailto"||y.scheme===this.f?s.$openUri(y,i,{}):this.g(i,o)}}load(D,p,r){const s=this.e.findSubstr(p);return s&&(this.a=s.identifier.value,this.h()),this.b=r(D),this.c}g(D,p){return this.i(),this.b(D,p)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=Ke([Ve(2,E.$0L)],c)}),define(Ae[112],Re([1,0,48,6,19,74,4,60,61,35,7,33,200,34]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=e.$Ucc=void 0,e.$Ucc=(0,A.$Nh)("IExtHostVariableResolverProvider");class m extends a.$$M{constructor(n,c,v,D,p,r,s){function i(){if(v){const o=v.activeEditor();if(o)return o.document.uri;const y=D.tabGroups.all.find($=>$.isActive)?.activeTab;if(y!==void 0){if(y.input instanceof P.$QL||y.input instanceof P.$VL)return y.input.modified;if(y.input instanceof P.$PL||y.input instanceof P.$UL||y.input instanceof P.$SL)return y.input.uri}}}super({getFolderUri:o=>{const y=r.folders.filter($=>$.name===o);if(y&&y.length>0)return y[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(o,y)=>p.getConfiguration(void 0,o).get(y),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=i();if(o)return C.$gc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=i();if(o){const y=c.getWorkspaceFolder(o);if(y)return C.$gc(y.uri.fsPath)}}},getSelectedText:()=>{if(v){const o=v.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(v){const o=v.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>n.getExtension(o)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(F.env))}}let f=class extends M.$Rc{constructor(n,c,v,D,p){super(),this.b=n,this.c=c,this.g=v,this.h=D,this.j=p,this.a=new w.$U(async()=>{const r=await this.h.getConfigProvider(),i={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{i.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,r,i,this.m())})}getResolver(){return this.a.value}m(){}};e.$Vcc=f,e.$Vcc=f=Ke([Ve(0,g.$mcc),Ve(1,k.$Qbc),Ve(2,h.$iM),Ve(3,b.$Tbc),Ve(4,E.$Scc)],f)}),define(Ae[113],Re([1,0,13,5,2,4,3,61,35,17,7,33,193,195,34,112]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=e.$Ycc=e.$Xcc=e.$Wcc=void 0,e.$Wcc=(0,F.$Nh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,i,o,y,$,S){this.E=i,this.F=o,this.G=y,this.H=$,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Md,this.n=new M.$Md,this.o=new M.$Md,this.u=new M.$Md,this.k=s.getProxy(A.$9J.MainThreadDebugService),this.y=new M.$Md,this.A=new M.$Md,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(I=>{I.onDidChange(u=>{this.J(I)}),this.J(I)})}asDebugSourceUri(s,i){const o=s;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let y=`debug:${encodeURIComponent(o.path||"")}`,$="?";return i&&(y+=`${$}session=${encodeURIComponent(i.id)}`,$="&"),y+=`${$}ref=${o.sourceReference}`,C.URI.parse(y)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const i=[];for(const o of s.getAllExtensionDescriptions())if(o.contributes){const y=o.contributes.debuggers;if(y&&y.length>0)for(const $ of y)(0,b.$nF)($)&&i.push($.type)}this.k.$registerDebugTypes(i)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(i=>s.push(i)),s}addBreakpoints(s){const i=s.filter($=>{const S=$.id;return this.w.has(S)?!1:(this.w.set(S,$),!0)});this.U(i,[],[]);const o=[],y=new Map;for(const $ of i)if($ instanceof P.$0K){let S=y.get($.location.uri.toString());S||(S={type:"sourceMulti",uri:$.location.uri,lines:[]},y.set($.location.uri.toString(),S),o.push(S)),S.lines.push({id:$.id,enabled:$.enabled,condition:$.condition,hitCondition:$.hitCondition,logMessage:$.logMessage,line:$.location.range.start.line,character:$.location.range.start.character})}else $ instanceof P.$$K&&o.push({type:"function",id:$.id,enabled:$.enabled,hitCondition:$.hitCondition,logMessage:$.logMessage,condition:$.condition,functionName:$.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(s){const i=s.filter(S=>this.w.delete(S.id));this.U([],i,[]);const o=i.filter(S=>S instanceof P.$0K).map(S=>S.id),y=i.filter(S=>S instanceof P.$$K).map(S=>S.id),$=i.filter(S=>S instanceof P.$_K).map(S=>S.id);return this.k.$unregisterBreakpoints(o,y,$)}startDebugging(s,i,o){return this.k.$startDebugging(s?s.uri:void 0,i,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,i,o){if(!i)return new P.$$J(()=>{});const y=this.d++;return this.f.push({type:s,handle:y,provider:i}),this.k.$registerDebugConfigurationProvider(s,o,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,y),new P.$$J(()=>{this.f=this.f.filter($=>$.provider!==i),this.k.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(s,i,o){if(!o)return new P.$$J(()=>{});if(!this.Q(s,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.N(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:i,handle:y,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(i,y),new P.$$J(()=>{this.h=this.h.filter($=>$.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(s,i){if(!i)return new P.$$J(()=>{});const o=this.i++;return this.j.push({type:s,handle:o,factory:i}),new P.$$J(()=>{this.j=this.j.filter(y=>y.factory!==i)})}async $runInTerminal(s,i){return Promise.resolve(void 0)}async $substituteVariables(s,i){let o;const y=await this.W(s);return y&&(o={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,i)}K(s,i){if(s.type==="implementation")return new D(s.implementation)}L(){}async $startDASession(s,i){const o=this,y=await this.V(i);return this.S(this.N(y.type),y).then($=>{if(!$)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const S=this.M($),I=this.K(S,y);if(!I)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const u=I;return this.B.set(s,u),this.R(y).then(d=>(d&&this.C.set(s,d),u.onMessage(async l=>{if(l.type==="request"&&l.command==="handshake"){const R=l,B={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(R.arguments.value);B.body={signature:V},u.sendResponse(B)}else throw new Error("no signer")}catch(V){B.success=!1,B.message=V.message,u.sendResponse(B)}}else d&&d.onDidSendMessage&&d.onDidSendMessage(l),l=(0,b.$sF)(l,!0),o.k.$acceptDAMessage(s,l)}),u.onError(l=>{d&&d.onError&&d.onError(l),this.k.$acceptDAError(s,l.name,l.message,l.stack)}),u.onExit(l=>{d&&d.onExit&&d.onExit(l??void 0,void 0),this.k.$acceptDAExit(s,l??void 0,void 0)}),d&&d.onWillStartSession&&d.onWillStartSession(),u.startSession()))})}$sendDAMessage(s,i){i=(0,b.$rF)(i,!1);const o=this.C.get(s);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(i),this.B.get(s)?.sendMessage(i)}$stopDASession(s){const i=this.C.get(s);this.C.delete(s),i&&i.onWillStopSession&&i.onWillStopSession();const o=this.B.get(s);return this.B.delete(s),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const i=[],o=[],y=[];if(s.added)for(const $ of s.added){const S=$.id;if(S&&!this.w.has(S)){let I;if($.type==="function")I=new P.$$K($.functionName,$.enabled,$.condition,$.hitCondition,$.logMessage);else if($.type==="data")I=new P.$_K($.label,$.dataId,$.canPersist,$.enabled,$.hitCondition,$.condition,$.logMessage);else{const u=C.URI.revive($.uri);I=new P.$0K(new P.$kK(u,new P.$_J($.line,$.character)),$.enabled,$.condition,$.hitCondition,$.logMessage)}(0,P.$8K)(I,S),this.w.set(S,I),i.push(I)}}if(s.removed)for(const $ of s.removed){const S=this.w.get($);S&&(this.w.delete($),o.push(S))}if(s.changed){for(const $ of s.changed)if($.id){const S=this.w.get($.id);if(S){if(S instanceof P.$$K&&$.type==="function"){const I=S;I.enabled=$.enabled,I.condition=$.condition,I.hitCondition=$.hitCondition,I.logMessage=$.logMessage,I.functionName=$.functionName}else if(S instanceof P.$0K&&$.type==="source"){const I=S;I.enabled=$.enabled,I.condition=$.condition,I.hitCondition=$.hitCondition,I.logMessage=$.logMessage,I.location=new P.$kK(C.URI.revive($.uri),new P.$_J($.line,$.character))}y.push(S)}}}this.U(i,o,y)}async $acceptStackFrameFocus(s){let i;const o=s.sessionId?await this.V(s.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?i=new P.$fL(o,s.threadId):i=new P.$eL(o,s.threadId,s.frameId),this.z=i,this.A.fire(this.z)}$provideDebugConfigurations(s,i,o){return(0,w.$Lg)(async()=>{const y=this.P(s);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const $=await this.W(i);return y.provideDebugConfigurations($,o)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(s,i,o,y){return(0,w.$Lg)(async()=>{const $=this.P(s);if(!$)throw new Error("no DebugConfigurationProvider found");if(!$.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(i);return $.resolveDebugConfiguration(S,o,y)})}$resolveDebugConfigurationWithSubstitutedVariables(s,i,o,y){return(0,w.$Lg)(async()=>{const $=this.P(s);if(!$)throw new Error("no DebugConfigurationProvider found");if(!$.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(i);return $.resolveDebugConfigurationWithSubstitutedVariables(S,o,y)})}async $provideDebugAdapter(s,i){const o=this.O(s);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.V(i);return this.S(o,y).then($=>{if(!$)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.M($)})}async $acceptDebugSessionStarted(s){const i=await this.V(s);this.m.fire(i)}async $acceptDebugSessionTerminated(s){const i=await this.V(s);i&&(this.n.fire(i),this.l.delete(i.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,i){(await this.V(s))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(s,i){const y={session:await this.V(s),event:i.event,body:i.body};this.u.fire(y)}M(s){if(s instanceof P.$aL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof P.$bL)return{type:"server",port:s.port,host:s.host};if(s instanceof P.$cL)return{type:"pipeServer",path:s.path};if(s instanceof P.$dL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const i=this.h.filter(o=>o.type===s);if(i.length>0)return i[0].factory}O(s){const i=this.h.filter(o=>o.handle===s);if(i.length>0)return i[0].factory}P(s){const i=this.f.filter(o=>o.handle===s);if(i.length>0)return i[0].provider}Q(s,i){if(s.contributes){const o=s.contributes.debuggers;if(o&&o.length>0){for(const y of o)if(y.label&&y.type&&y.type===i)return!0}}return!1}R(s){const o=s.configuration.type,y=this.j.filter($=>$.type===o||$.type==="*").map($=>(0,w.$Lg)(()=>$.factory.createDebugAdapterTracker(s)).then(S=>S,S=>null));return Promise.race([Promise.all(y).then($=>{const S=$.filter(I=>!!I);if(S.length>0)return new v(S)}),new Promise($=>setTimeout(()=>$(void 0),1e3))]).catch($=>{})}async S(s,i){const o=i.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new P.$bL(o));if(s){const $=await this.F.getExtensionRegistry();return(0,w.$Lg)(()=>s.createDebugAdapterDescriptor(i,this.T(i,$))).then(S=>{if(S)return S})}const y=await this.F.getExtensionRegistry();return Promise.resolve(this.T(i,y))}T(s,i){}U(s,i,o){(s.length>0||i.length>0||o.length>0)&&this.y.fire(Object.freeze({added:s,removed:i,changed:o}))}async V(s){if(s)if(typeof s=="string"){const i=this.l.get(s);if(i)return i}else{let i=this.l.get(s.id);if(!i){const o=await this.W(s.folderUri),y=s.parent?this.l.get(s.parent):void 0;i=new n(this.k,s.id,s.type,s.name,o,s.configuration,y),this.l.set(i.id,i),this.k.$sessionCached(i.id)}return i}throw new Error("cannot find session")}W(s){if(s){const i=C.URI.revive(s);return this.E.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};e.$Xcc=t,e.$Xcc=t=Ke([Ve(0,g.$0L),Ve(1,k.$Qbc),Ve(2,E.$mcc),Ve(3,m.$Tbc),Ve(4,h.$Scc),Ve(5,f.$Ucc)],t);class n{constructor(s,i,o,y,$,S,I){this.d=s,this.f=i,this.g=o,this.h=y,this.i=$,this.j=S,this.k=I}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,i){return this.d.$customDebugAdapterRequest(this.f,s,i)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Ycc=n;class c{constructor(s){this.value=Object.freeze({append(i){s.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.$Zcc=c;class v{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(i=>i.onError?i.onError(s):void 0)}onExit(s,i){this.d.forEach(o=>o.onExit?o.onExit(s,i):void 0)}}class D extends a.$Scb{constructor(s){super(),this.h=s,s.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let p=class extends t{constructor(s,i,o,y,$,S){super(s,i,o,y,$,S)}};e.$1cc=p,e.$1cc=p=Ke([Ve(0,g.$0L),Ve(1,k.$Qbc),Ve(2,E.$mcc),Ve(3,m.$Tbc),Ve(4,h.$Scc),Ve(5,f.$Ucc)],p)}),define(Ae[270],Re([1,0,9,87,2,3,261,14,70,71,27,172,17,56,35,58]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.$Ldc=void 0;class t{static async installEarlyHandler(v){Error.stackTraceLimit=100;const D=v.get(h.$8i),r=v.get(a.$0L).getProxy(F.$9J.MainThreadErrors);w.setUnexpectedErrorHandler(s=>{D.error(s);const i=w.$2(s);r.$onUnexpectedError(i)})}static async installFullHandler(v){const D=v.get(h.$8i),p=v.get(a.$0L),r=v.get(m.$mcc),s=v.get(f.$rM),i=p.getProxy(F.$9J.MainThreadExtensionService),o=p.getProxy(F.$9J.MainThreadErrors),y=await r.getExtensionPathIndex(),$=new WeakMap;function S(d,l){if($.has(d))return $.get(d).stack;let R="",B,V;for(const W of l)R+=`
	at ${W.toString()}`,V=W.getFileName(),!B&&V&&(B=y.findSubstr(C.URI.file(V)));const U=`${d.name||"Error"}: ${d.message||""}${R}`;return $.set(d,{extensionIdentifier:B?.identifier,stack:U}),U}const I=Symbol("prepareStackTrace wrapped");let u=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(d){if(d===S||!d||d[I]){u=d||S;return}u=function(l,R){return S(l,R),d.call(Error,l,R)},Object.assign(u,{[I]:!0})}}),w.setUnexpectedErrorHandler(d=>{D.error(d);const l=w.$2(d),R=$.get(d);if(!R?.extensionIdentifier){o.$onUnexpectedError(l);return}i.$onExtensionRuntimeError(R.extensionIdentifier,l);const B=s.onExtensionError(R.extensionIdentifier,d);D.trace("forwarded error to extension?",B,R)})}}e.$Ldc=t;class n{constructor(v,D,p,r,s){this.a=p,this.b=new A.$c4b(v,null,r),D=n.e(D,this.b);const i=new g.$Lh(...(0,E.$qr)());i.set(P.$nM,{_serviceBrand:void 0,...D,messagePorts:s}),i.set(a.$0L,new a.$$L(this.b)),i.set(b.$Nbc,new b.$Obc(r)),i.set(m.$kcc,p);const o=new k.$9p(i,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(y=>y.get(h.$8i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",D),this.c=o.invokeFunction(y=>y.get(m.$mcc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(v){const D=this.b.getProxy(F.$9J.MainThreadExtensionService);return C.URI.revive(await D.$asBrowserUri(v))}terminate(v){this.c.terminate(v)}static e(v,D){v.extensions.allExtensions.forEach(r=>{r.extensionLocation=C.URI.revive(D.transformIncomingURIs(r.extensionLocation))}),v.environment.appRoot=C.URI.revive(D.transformIncomingURIs(v.environment.appRoot));const p=v.environment.extensionDevelopmentLocationURI;return p&&(v.environment.extensionDevelopmentLocationURI=p.map(r=>C.URI.revive(D.transformIncomingURIs(r)))),v.environment.extensionTestsLocationURI=C.URI.revive(D.transformIncomingURIs(v.environment.extensionTestsLocationURI)),v.environment.globalStorageHome=C.URI.revive(D.transformIncomingURIs(v.environment.globalStorageHome)),v.environment.workspaceStorageHome=C.URI.revive(D.transformIncomingURIs(v.environment.workspaceStorageHome)),v.environment.extensionTelemetryLogResource=C.URI.revive(D.transformIncomingURIs(v.environment.extensionTelemetryLogResource)),v.nlsBaseUrl=C.URI.revive(D.transformIncomingURIs(v.nlsBaseUrl)),v.logsLocation=C.URI.revive(D.transformIncomingURIs(v.logsLocation)),v.workspace=D.transformIncomingURIs(v.workspace),v}}e.$Mdc=n}),define(Ae[271],Re([1,0,18,13,21,41,12,19,23,2,47]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=e.$5cc=e.$4cc=e.$3cc=void 0;class k{constructor(c,v,D,p){this.d=c,this.e=v,this.f=D,this.g=p,this.a=null,this.b=!1,this.c=0}search(c,v){const D=this.d.folderQueries||[],p=new C.$Wd(v);return new Promise((r,s)=>{this.a=new b(c);let i=!1;const o=(y,$)=>{if(!i&&!this.b){const S=this.h(y);f(y)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,i=!0,p.cancel(),y=this.j(y,this.d.maxResults-this.c));const I=this.h(y);this.c+=I,(I>0||!f(y))&&this.a.add(y,$)}};Promise.all(D.map((y,$)=>this.k(y,S=>o(S,$),p.token))).then(y=>{p.dispose(),this.a.flush();const $=y.some(S=>!!S&&!!S.limitHit);r({limitHit:this.b||$,messages:(0,w.$Qb)(y.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},y=>{p.dispose();const $=(0,F.$yi)(y);s(new Error($))})})}h(c){return f(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,v){const D=Array.isArray(c.ranges)?c.ranges:[c.ranges],p=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:D.slice(0,v),preview:{matches:p.slice(0,v),text:c.preview.text},uri:c.uri}}async k(c,v,D){const p=new P.$TI(this.d,c),r=[],s={report:y=>{if(!this.l(y))return;const $=c.folder.scheme===A.Schemas.file?(0,P.$UI)(()=>this.f.readdir(E.$tg(y.uri))):void 0,S=E.$wg(c.folder,y.uri);if(S){const I=p.includedInQuery(S,h.$mc(S),$);(0,M.$Fg)(I)?r.push(I.then(u=>{u&&v(y)})):I&&v(y)}}},i=this.n(c),o=await this.e.provideTextSearchResults(a(this.d.contentPattern),i,s,D);return r.length&&await Promise.all(r),o}l(c){if(f(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const v=(0,P.$SI)(this.d.includePattern,c.includePattern),D=(0,P.$SI)(this.d.excludePattern,c.excludePattern),p={folder:g.URI.from(c.folder),excludes:D,includes:v,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.$3cc=k;function a(n){return{isCaseSensitive:n.isCaseSensitive||!1,isRegExp:n.isRegExp||!1,isWordMatch:n.isWordMatch||!1,isMultiline:n.isMultiline||!1,pattern:n.pattern}}class b{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,v=>this.g(v))}add(c,v){this.d&&(this.b!==v||!E.$ng(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=v,this.d={resource:c.uri,results:[]}),this.d.results.push(m(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$4cc=b;function m(n){return f(n)?{preview:{matches:(0,w.$1b)(n.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:n.preview.text},ranges:(0,w.$1b)(n.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:n.text,lineNumber:n.lineNumber}}function f(n){return!!n.preview}e.$5cc=f;class t{static{this.a=4e3}static{this.b=50}constructor(c,v){this.g=c,this.h=v,this.c=0,this.d=[],this.e=0}addItem(c,v){c&&this.j(c,v)}addItems(c,v){c&&this.k(c,v)}j(c,v){this.d.push(c),this.e+=v,this.l()}k(c,v){this.d=this.d.concat(c),this.e+=v,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$6cc=t}),define(Ae[114],Re([1,0,6,3,4,266,17,56,14,2,271]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=e.$7cc=void 0,e.$7cc=(0,C.$Nh)("IExtHostSearch");let k=class{constructor(f,t,n){this.k=f,this.l=t,this.n=n,this.c=this.k.getProxy(M.$9J.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new F.$2cc}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const n=this.d++;return this.e.set(n,t),this.c.$registerTextSearchProvider(n,this.o(f)),(0,w.$Pc)(()=>{this.g.delete(f),this.e.delete(n),this.c.$unregisterProvider(n)})}registerFileSearchProvider(f,t){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const n=this.d++;return this.h.set(n,t),this.c.$registerFileSearchProvider(n,this.o(f)),(0,w.$Pc)(()=>{this.i.delete(f),this.h.delete(n),this.c.$unregisterProvider(n)})}$provideFileSearchResults(f,t,n,c){const v=a(n),D=this.h.get(f);if(D)return this.j.fileSearch(v,D,p=>{this.c.$handleFileMatch(f,t,p.map(r=>r.resource))},c);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,n,c){const v=this.e.get(f);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const D=a(n);return this.q(D,v).search(r=>this.c.$handleTextMatch(f,t,r),c)}$enableExtensionHostSearch(){}q(f,t){return new P.$3cc(f,t,{readdir:n=>Promise.resolve([]),toCanonicalName:n=>n},"textSearchProvider")}};e.$8cc=k,e.$8cc=k=Ke([Ve(0,A.$0L),Ve(1,h.$Nbc),Ve(2,E.$8i)],k);function a(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(b),extraFileResources:m.extraFileResources&&m.extraFileResources.map(f=>g.URI.revive(f))}}e.$9cc=a;function b(m){return{...m,folder:g.URI.revive(m.folder)}}}),define(Ae[272],Re([1,0,21,9,5,29,2,135,283,124,133,38,3,79,224,223,31,225,34,227,228,229,203,230,60,35,233,234,239,240,242,109,207,248,249,251,84,63,253,210,8,7,53,256,64,108,33,20,198,238,52,107,111,113,114,14,56,17,27,243,196,86,80,217,254,85,62,259,257,258,218,39,252,255,83,61,58,244,110,245,12,95,206,189,236,6,26,194,81,185,246,247,219,235,205,237,82,250,221,222,216,232,220]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r,s,i,o,y,$,S,I,u,d,l,R,B,V,U,W,N,O,ee,Z,ye,De,Pe,X,le,Ee,ce,$e,ie,z,q,ue,we,ve,me,ke,re,he,se,oe,de,Ie,T,K,G,Q,H,_,ae,Fe,Ue,Qe,Je,xe,Xe,_e,it,tt,ze,st,x,Y,pe,Be,Oe,Ye,rt,gt,yt,Pt,Yt,qt,bt,Ut,Ft,jt,At,Rt,Nt,Bt,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;function Wt(at){const ut=at.get(re.$nM),Jt=at.get(Fe.$Dbc),Ct=at.get(G.$9bc),Dt=at.get(o.$mcc),ht=at.get(le.$Qbc),St=at.get(Xe.$rM),Lt=at.get(c.$Tbc),Et=at.get(me.$Nbc),qe=at.get(ke.$0L),Ot=at.get(U.$5bc),Ce=at.get(K.$0bc),Me=at.get(ve.$9i),ge=at.get(ve.$8i),J=at.get(oe.$Rvb),Te=at.get(de.$Gbc),je=at.get(X.$Kcc),Ge=at.get(Je.$ecc),We=at.get(xe.$Scc),et=at.get(Ft.$icc);qe.set(a.$0J.ExtHostFileSystemInfo,Jt),qe.set(a.$0J.ExtHostLogLevelServiceShape,Me),qe.set(a.$0J.ExtHostWorkspace,ht),qe.set(a.$0J.ExtHostConfiguration,Lt),qe.set(a.$0J.ExtHostExtensionService,Dt),qe.set(a.$0J.ExtHostStorage,Ot),qe.set(a.$0J.ExtHostTunnelService,J),qe.set(a.$0J.ExtHostWindow,je),qe.set(a.$0J.ExtHostSecretState,Ge),qe.set(a.$0J.ExtHostTelemetry,St),qe.set(a.$0J.ExtHostEditorTabs,We),qe.set(a.$0J.ExtHostManagedSockets,et);const pt=qe.set(a.$0J.ExtHostDecorations,at.get(z.$Occ)),vt=qe.set(a.$0J.ExtHostDocumentsAndEditors,at.get(i.$iM)),dt=qe.set(a.$0J.ExtHostCommands,at.get(t.$tM)),ft=qe.set(a.$0J.ExtHostTerminalService,at.get(W.$_bc)),mt=qe.set(a.$0J.ExtHostDebugService,at.get(ue.$Wcc)),gi=qe.set(a.$0J.ExtHostSearch,at.get(we.$7cc)),Ht=qe.set(a.$0J.ExtHostTask,at.get(q.$Rcc)),Ei=qe.set(a.$0J.ExtHostOutputService,at.get(d.$ucc)),Vt=qe.set(a.$0J.ExtHostLocalization,at.get(rt.$hcc)),mi=qe.set(a.$0J.ExtHostUrls,new De.$Dcc(qe)),It=qe.set(a.$0J.ExtHostDocuments,new s.$Bbc(qe,vt)),Di=qe.set(a.$0J.ExtHostDocumentContentProviders,new p.$Vbc(qe,vt,ge)),Vi=qe.set(a.$0J.ExtHostDocumentSaveParticipant,new r.$Wbc(ge,It,qe.getProxy(a.$9J.MainThreadBulkEdits))),kt=qe.set(a.$0J.ExtHostNotebook,new he.$adc(qe,dt,vt,It,Ct)),ti=qe.set(a.$0J.ExtHostNotebookDocuments,new Y.$sdc(kt)),$i=qe.set(a.$0J.ExtHostNotebookEditors,new x.$rdc(ge,kt)),si=qe.set(a.$0J.ExtHostNotebookKernels,new _e.$odc(qe,ut,kt,dt,ge)),ki=qe.set(a.$0J.ExtHostNotebookRenderers,new tt.$qdc(qe,kt)),Si=qe.set(a.$0J.ExtHostNotebookDocumentSaveParticipant,new bt.$ydc(ge,kt,qe.getProxy(a.$9J.MainThreadBulkEdits))),Mt=qe.set(a.$0J.ExtHostEditors,new N.$Bcc(qe,vt)),pi=qe.set(a.$0J.ExtHostTreeViews,new O.$Ccc(qe.getProxy(a.$9J.MainThreadTreeViews),dt,ge)),Ii=qe.set(a.$0J.ExtHostEditorInsets,new ce.$Lcc(qe.getProxy(a.$9J.MainThreadEditorInsets),Mt,ut.remote)),oi=qe.set(a.$0J.ExtHostDiagnostics,new v.$Fbc(qe,ge,Jt,vt)),ai=qe.set(a.$0J.ExtHostLanguages,new I.$rcc(qe,It,dt.converter,Et)),ct=qe.set(a.$0J.ExtHostLanguageFeatures,new S.$Jbc(qe,Et,It,dt,oi,ge,Te,St)),qi=qe.set(a.$0J.ExtHostFileSystem,new y.$pcc(qe,ct)),Zt=qe.set(a.$0J.ExtHostFileSystemEventService,new $.$qcc(qe,ge,vt)),ii=qe.set(a.$0J.ExtHostQuickOpen,(0,R.$wcc)(qe,ht,dt)),vi=qe.set(a.$0J.ExtHostSCM,new B.$ycc(qe,dt,It,ge)),Ci=qe.set(a.$0J.ExtHostQuickDiff,new Pt.$vdc(qe,Et)),Ki=qe.set(a.$0J.ExtHostShare,new jt.$Adc(qe,Et)),Pi=qe.set(a.$0J.ExtHostComments,(0,n.$Mbc)(qe,dt,It)),bi=qe.set(a.$0J.ExtHostProgress,new l.$vcc(qe.getProxy(a.$9J.MainThreadProgress))),Hi=qe.set(a.$0J.ExtHosLabelService,new $e.$Mcc(qe)),Ai=qe.set(a.$0J.ExtHostTheming,new se.$bdc(qe)),ci=qe.set(a.$0J.ExtHostAuthentication,new Ie.$cdc(qe)),Ji=qe.set(a.$0J.ExtHostTimeline,new T.$edc(qe,dt)),wi=qe.set(a.$0J.ExtHostWebviews,new Pe.$Gcc(qe,ut.remote,ht,ge,Te)),Ri=qe.set(a.$0J.ExtHostWebviewPanels,new _.$gdc(qe,wi,ht)),cn=qe.set(a.$0J.ExtHostCustomEditors,new H.$hdc(qe,It,Ce,wi,Ri)),Mi=qe.set(a.$0J.ExtHostWebviewViews,new Q.$fdc(qe,wi)),ni=qe.set(a.$0J.ExtHostTesting,new Ue.$jdc(qe,dt,vt)),un=qe.set(a.$0J.ExtHostUriOpeners,new Qe.$ndc(qe)),ln=qe.set(a.$0J.ExtHostProfileContentHandlers,new yt.$udc(qe));qe.set(a.$0J.ExtHostInteractive,new pe.$tdc(qe,kt,vt,dt,ge));const Gi=qe.set(a.$0J.ExtHostInlineChat,new qt.$xdc(qe,dt,It,ge)),fi=qe.set(a.$0J.ExtHostChatProvider,new At.$Bdc(qe,ge)),Qi=qe.set(a.$0J.ExtHostChatAgents,new Kt.$Fdc(qe,fi,ge)),Yi=qe.set(a.$0J.ExtHostChatVariables,new Rt.$Cdc(qe)),ui=qe.set(a.$0J.ExtHostChat,new Yt.$wdc(qe,ge)),Zi=qe.set(a.$0J.ExtHostAiRelatedInformation,new Nt.$Ddc(qe)),Ti=qe.set(a.$0J.ExtHostAiEmbeddingVector,new Bt.$Edc(qe)),Xi=qe.set(a.$0J.ExtHostIssueReporter,new Ut.$zdc(qe)),Xt=qe.set(a.$0J.ExtHostStatusBar,new V.$Acc(qe,dt.converter)),yi=Object.values(a.$0J);qe.assertRegistered(yi);const hn=new ae.$idc(qe,vt),Gt=new f.$Lbc(qe),li=new u.$scc(qe,ge),Li=new D.$Ubc(qe);return m.$Kbc.register(dt),function(Ne,xt,Fi){const $t=function(){let te=!Ne.isUnderDevelopment;function fe(){te||(ge.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Le(nt){if(Array.isArray(nt))nt.forEach(Le);else if(typeof nt=="string")fe();else{const wt=nt;typeof wt.scheme>"u"&&fe(),typeof wt.exclusive=="boolean"&&(0,Oe.$9E)(Ne,"documentFiltersExclusive")}return nt}}(),xi={getSession(te,fe,Le){return ci.getSession(Ne,te,fe,Le)},getSessions(te,fe){return(0,Oe.$9E)(Ne,"authGetSessions"),ci.getSessions(Ne,te,fe)},async hasSession(te,fe){return(0,Oe.$9E)(Ne,"authSession"),!!await ci.getSession(Ne,te,fe,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(te,fe,Le,nt){return ci.registerAuthenticationProvider(te,fe,Le,nt)}},_i={registerCommand(te,fe,Le){return dt.registerCommand(!0,te,fe,Le,void 0,Ne)},registerTextEditorCommand(te,fe,Le){return dt.registerCommand(!0,te,(...nt)=>{const wt=Mt.getActiveTextEditor();if(!wt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}return wt.edit(Tt=>{fe.apply(Le,[wt,Tt,...nt])}).then(Tt=>{Tt||ge.warn("Edits from command "+te+" were not applied.")},Tt=>{ge.warn("An error occurred while running command "+te,Tt)})},void 0,void 0,Ne)},registerDiffInformationCommand:(te,fe,Le)=>((0,Oe.$9E)(Ne,"diffCommand"),dt.registerCommand(!0,te,async(...nt)=>{const wt=vt.activeEditor(!0);if(!wt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}const Tt=await Mt.getDiffInformation(wt.id);fe.apply(Le,[Tt,...nt])},void 0,void 0,Ne)),executeCommand(te,...fe){return dt.executeCommand(te,...fe)},getCommands(te=!1){return dt.getCommands(te)}},en={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return ft.getDefaultShell(!1)},get onDidChangeShell(){return ft.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$9E)(Ne,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$9E)(Ne,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Xe.$qM)(ut.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,fe){return Xe.$pM.validateSender(te),St.instantiateLogger(Ne,te,fe)},openExternal(te,fe){return je.openUri(te,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ut.environment.appUriScheme)return mi.createAppUri(te);try{return await je.asExternalUri(te,{allowTunneling:!!ut.remote.authority})}catch(fe){if((0,st.$4T)(te,ze.Schemas.http)||(0,st.$4T)(te,ze.Schemas.https))return te;throw fe}},get remoteName(){return(0,ie.$Sk)(ut.remote.authority)},get remoteAuthority(){return(0,Oe.$9E)(Ne,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind},get logLevel(){return ge.getLevel()},get onDidChangeLogLevel(){return ge.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Oe.$9E)(Ne,"handleIssueUri"),Xi.registerIssueUriRequestHandler(Ne,te)},get appQuality(){return(0,Oe.$9E)(Ne,"resolvers"),ut.quality},get appCommit(){return(0,Oe.$9E)(Ne,"resolvers"),ut.commit}};ut.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(te,fe,Le){return ni.createTestController(Ne,te,fe,Le)},createTestObserver(){return(0,Oe.$9E)(Ne,"testObserver"),ni.createTestObserver()},runTests(te){return(0,Oe.$9E)(Ne,"testObserver"),ni.runTests(te)},get onDidChangeTestResults(){return(0,Oe.$9E)(Ne,"testObserver"),ni.onResultsChanged},get testResults(){return(0,Oe.$9E)(Ne,"testObserver"),ni.results}},hi=ut.remote.isRemote?Z.ExtensionKind.Workspace:Z.ExtensionKind.UI,tn={getExtension(te,fe){(0,Oe.$8E)(Ne,"extensionsAny")||(fe=!1);const Le=xt.mine.getExtensionDescription(te);if(Le)return new o.$ncc(Dt,Ne.identifier,Le,hi,!1);if(fe){const nt=xt.all.getExtensionDescription(te);if(nt)return new o.$ncc(Dt,Ne.identifier,nt,hi,!0)}},get all(){const te=[];for(const fe of xt.mine.getAllExtensionDescriptions())te.push(new o.$ncc(Dt,Ne.identifier,fe,hi,!1));return te},get allAcrossExtensionHosts(){(0,Oe.$9E)(Ne,"extensionsAny");const te=new Ee.$Zl(xt.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),fe=[];for(const Le of xt.all.getAllExtensionDescriptions()){const nt=!te.has(Le.identifier);fe.push(new o.$ncc(Dt,Ne.identifier,Le,hi,nt))}return fe},get onDidChange(){return(0,Oe.$8E)(Ne,"extensionsAny")?C.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},nn={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Ne.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(te,fe){return ai.changeLanguage(te.uri,fe)},match(te,fe){const Le=It.getDocumentData(fe.uri)?.notebook;return(0,P.$jE)(ee.LanguageSelector.from(te),fe.uri,fe.languageId,!0,Le?.uri,Le?.notebookType)},registerCodeActionsProvider(te,fe,Le){return ct.registerCodeActionProvider(Ne,$t(te),fe,Le)},registerDocumentPasteEditProvider(te,fe,Le){return(0,Oe.$9E)(Ne,"documentPaste"),ct.registerDocumentPasteEditProvider(Ne,$t(te),fe,Le)},registerCodeLensProvider(te,fe){return ct.registerCodeLensProvider(Ne,$t(te),fe)},registerDefinitionProvider(te,fe){return ct.registerDefinitionProvider(Ne,$t(te),fe)},registerDeclarationProvider(te,fe){return ct.registerDeclarationProvider(Ne,$t(te),fe)},registerImplementationProvider(te,fe){return ct.registerImplementationProvider(Ne,$t(te),fe)},registerTypeDefinitionProvider(te,fe){return ct.registerTypeDefinitionProvider(Ne,$t(te),fe)},registerHoverProvider(te,fe){return ct.registerHoverProvider(Ne,$t(te),fe,Ne.identifier)},registerEvaluatableExpressionProvider(te,fe){return ct.registerEvaluatableExpressionProvider(Ne,$t(te),fe,Ne.identifier)},registerInlineValuesProvider(te,fe){return ct.registerInlineValuesProvider(Ne,$t(te),fe,Ne.identifier)},registerDocumentHighlightProvider(te,fe){return ct.registerDocumentHighlightProvider(Ne,$t(te),fe)},registerLinkedEditingRangeProvider(te,fe){return ct.registerLinkedEditingRangeProvider(Ne,$t(te),fe)},registerReferenceProvider(te,fe){return ct.registerReferenceProvider(Ne,$t(te),fe)},registerRenameProvider(te,fe){return ct.registerRenameProvider(Ne,$t(te),fe)},registerDocumentSymbolProvider(te,fe,Le){return ct.registerDocumentSymbolProvider(Ne,$t(te),fe,Le)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Ne,te)},registerDocumentFormattingEditProvider(te,fe){return ct.registerDocumentFormattingEditProvider(Ne,$t(te),fe)},registerDocumentRangeFormattingEditProvider(te,fe){return ct.registerDocumentRangeFormattingEditProvider(Ne,$t(te),fe)},registerOnTypeFormattingEditProvider(te,fe,Le,...nt){return ct.registerOnTypeFormattingEditProvider(Ne,$t(te),fe,[Le].concat(nt))},registerDocumentSemanticTokensProvider(te,fe,Le){return ct.registerDocumentSemanticTokensProvider(Ne,$t(te),fe,Le)},registerDocumentRangeSemanticTokensProvider(te,fe,Le){return ct.registerDocumentRangeSemanticTokensProvider(Ne,$t(te),fe,Le)},registerSignatureHelpProvider(te,fe,Le,...nt){return typeof Le=="object"?ct.registerSignatureHelpProvider(Ne,$t(te),fe,Le):ct.registerSignatureHelpProvider(Ne,$t(te),fe,typeof Le>"u"?[]:[Le,...nt])},registerCompletionItemProvider(te,fe,...Le){return ct.registerCompletionItemProvider(Ne,$t(te),fe,Le)},registerInlineCompletionItemProvider(te,fe,Le){return fe.handleDidShowCompletionItem&&(0,Oe.$9E)(Ne,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$9E)(Ne,"inlineCompletionsAdditions"),Le&&(0,Oe.$9E)(Ne,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ne,$t(te),fe,Le)},registerDocumentLinkProvider(te,fe){return ct.registerDocumentLinkProvider(Ne,$t(te),fe)},registerColorProvider(te,fe){return ct.registerColorProvider(Ne,$t(te),fe)},registerFoldingRangeProvider(te,fe){return ct.registerFoldingRangeProvider(Ne,$t(te),fe)},registerSelectionRangeProvider(te,fe){return ct.registerSelectionRangeProvider(Ne,te,fe)},registerCallHierarchyProvider(te,fe){return ct.registerCallHierarchyProvider(Ne,te,fe)},registerTypeHierarchyProvider(te,fe){return ct.registerTypeHierarchyProvider(Ne,te,fe)},setLanguageConfiguration:(te,fe)=>ct.setLanguageConfiguration(Ne,te,fe),getTokenInformationAtPosition(te,fe){return(0,Oe.$9E)(Ne,"tokenInformation"),ai.tokenAtPosition(te,fe)},registerInlayHintsProvider(te,fe){return ct.registerInlayHintsProvider(Ne,te,fe)},createLanguageStatusItem(te,fe){return ai.createLanguageStatusItem(Ne,te,fe)},registerDocumentDropEditProvider(te,fe,Le){return ct.registerDocumentOnDropEditProvider(Ne,te,fe,(0,Oe.$8E)(Ne,"dropMetadata")?Le:void 0)}},rn={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(te,fe,Le){const nt=await(A.URI.isUri(te)?Promise.resolve(sn.openTextDocument(te)):Promise.resolve(te));return Mt.showTextDocument(nt,fe,Le)},createTextEditorDecorationType(te){return Mt.createTextEditorDecorationType(Ne,te)},onDidChangeActiveTextEditor(te,fe,Le){return Mt.onDidChangeActiveTextEditor(te,fe,Le)},onDidChangeVisibleTextEditors(te,fe,Le){return Mt.onDidChangeVisibleTextEditors(te,fe,Le)},onDidChangeTextEditorSelection(te,fe,Le){return Mt.onDidChangeTextEditorSelection(te,fe,Le)},onDidChangeTextEditorOptions(te,fe,Le){return Mt.onDidChangeTextEditorOptions(te,fe,Le)},onDidChangeTextEditorVisibleRanges(te,fe,Le){return Mt.onDidChangeTextEditorVisibleRanges(te,fe,Le)},onDidChangeTextEditorViewColumn(te,fe,Le){return Mt.onDidChangeTextEditorViewColumn(te,fe,Le)},onDidCloseTerminal(te,fe,Le){return ft.onDidCloseTerminal(te,fe,Le)},onDidOpenTerminal(te,fe,Le){return ft.onDidOpenTerminal(te,fe,Le)},onDidChangeActiveTerminal(te,fe,Le){return ft.onDidChangeActiveTerminal(te,fe,Le)},onDidChangeTerminalDimensions(te,fe,Le){return(0,Oe.$9E)(Ne,"terminalDimensions"),ft.onDidChangeTerminalDimensions(te,fe,Le)},onDidChangeTerminalState(te,fe,Le){return ft.onDidChangeTerminalState(te,fe,Le)},onDidWriteTerminalData(te,fe,Le){return(0,Oe.$9E)(Ne,"terminalDataWriteEvent"),ft.onDidWriteTerminalData(te,fe,Le)},onDidExecuteTerminalCommand(te,fe,Le){return(0,Oe.$9E)(Ne,"terminalExecuteCommandEvent"),ft.onDidExecuteTerminalCommand(te,fe,Le)},get state(){return je.getState(Ne)},onDidChangeWindowState(te,fe,Le){return je.onDidChangeWindowState(te,fe,Le)},showInformationMessage(te,...fe){return li.showMessage(Ne,F.default.Info,te,fe[0],fe.slice(1))},showWarningMessage(te,...fe){return li.showMessage(Ne,F.default.Warning,te,fe[0],fe.slice(1))},showErrorMessage(te,...fe){return li.showMessage(Ne,F.default.Error,te,fe[0],fe.slice(1))},showQuickPick(te,fe,Le){return ii.showQuickPick(Ne,te,fe,Le)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,fe){return ii.showInput(te,fe)},showOpenDialog(te){return Li.showOpenDialog(Ne,te)},showSaveDialog(te){return Li.showSaveDialog(te)},createStatusBarItem(te,fe,Le){let nt,wt,Tt;return typeof te=="string"?(nt=te,wt=fe,Tt=Le):(wt=te,Tt=fe),Xt.createStatusBarEntry(Ne,nt,wt,Tt)},setStatusBarMessage(te,fe){return Xt.setStatusBarMessage(te,fe)},withScmProgress(te){return Te.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),bi.withProgress(Ne,{location:Z.ProgressLocation.SourceControl},(fe,Le)=>te({report(nt){}}))},withProgress(te,fe){return bi.withProgress(Ne,te,fe)},createOutputChannel(te,fe){return Ei.createOutputChannel(te,fe,Ne)},createWebviewPanel(te,fe,Le,nt){return Ri.createWebviewPanel(Ne,te,fe,Le,nt)},createWebviewTextEditorInset(te,fe,Le,nt){return(0,Oe.$9E)(Ne,"editorInsets"),Ii.createWebviewEditorInset(te,fe,Le,nt,Ne)},createTerminal(te,fe,Le){return typeof te=="object"?"pty"in te?ft.createExtensionTerminal(te):ft.createTerminalFromOptions(te):ft.createTerminal(te,fe,Le)},registerTerminalLinkProvider(te){return ft.registerLinkProvider(te)},registerTerminalProfileProvider(te,fe){return ft.registerProfileProvider(Ne,te,fe)},registerTerminalQuickFixProvider(te,fe){return(0,Oe.$9E)(Ne,"terminalQuickFixProvider"),ft.registerTerminalQuickFixProvider(te,Ne.identifier.value,fe)},registerTreeDataProvider(te,fe){return pi.registerTreeDataProvider(te,fe,Ne)},createTreeView(te,fe){return pi.createTreeView(te,fe,Ne)},registerWebviewPanelSerializer:(te,fe)=>Ri.registerWebviewPanelSerializer(Ne,te,fe),registerCustomEditorProvider:(te,fe,Le={})=>cn.registerCustomEditorProvider(Ne,te,fe,Le),registerFileDecorationProvider(te){return pt.registerFileDecorationProvider(te,Ne)},registerUriHandler(te){return mi.registerUriHandler(Ne,te)},createQuickPick(){return ii.createQuickPick(Ne)},createInputBox(){return ii.createInputBox(Ne)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(te,fe,Le){return Ai.onDidChangeActiveColorTheme(te,fe,Le)},registerWebviewViewProvider(te,fe,Le){return Mi.registerWebviewViewProvider(Ne,te,fe,Le?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,fe,Le){return kt.onDidChangeActiveNotebookEditor(te,fe,Le)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,fe,Le){return $i.onDidChangeNotebookEditorSelection(te,fe,Le)},onDidChangeNotebookEditorVisibleRanges(te,fe,Le){return $i.onDidChangeNotebookEditorVisibleRanges(te,fe,Le)},showNotebookDocument(te,fe){return kt.showNotebookDocument(te,fe)},registerExternalUriOpener(te,fe,Le){return(0,Oe.$9E)(Ne,"externalUriOpener"),un.registerExternalUriOpener(Ne.identifier,te,fe,Le)},registerProfileContentHandler(te,fe){return(0,Oe.$9E)(Ne,"profileContentHandlers"),ln.registrProfileContentHandler(Ne,te,fe)},registerQuickDiffProvider(te,fe,Le,nt){return(0,Oe.$9E)(Ne,"quickDiffProvider"),Ci.registerQuickDiffProvider($t(te),fe,Le,nt)},get tabGroups(){return We.tabGroups},registerShareProvider(te,fe){return(0,Oe.$9E)(Ne,"shareProvider"),Ki.registerShareProvider($t(te),fe)}},sn={get rootPath(){return Te.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(te){throw new M.$8("rootPath")},getWorkspaceFolder(te){return ht.getWorkspaceFolder(te)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(te){throw new M.$8("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(te){throw new M.$8("workspaceFile")},updateWorkspaceFolders:(te,fe,...Le)=>ht.updateWorkspaceFolders(Ne,te,fe||0,...Le),onDidChangeWorkspaceFolders:function(te,fe,Le){return ht.onDidChangeWorkspace(te,fe,Le)},asRelativePath:(te,fe)=>ht.getRelativePath(te,fe),findFiles:(te,fe,Le,nt)=>ht.findFiles(te,fe,Le,Ne.identifier,nt),findTextInFiles:(te,fe,Le,nt)=>{(0,Oe.$9E)(Ne,"findTextInFiles");let wt,Tt;return typeof fe=="object"?(wt=fe,Tt=Le):(wt={},Tt=fe,nt=Le),ht.findTextInFiles(te,wt||{},Tt,Ne.identifier,nt)},save:te=>((0,Oe.$9E)(Ne,"saveEditor"),ht.save(te)),saveAs:te=>((0,Oe.$9E)(Ne,"saveEditor"),ht.saveAs(te)),saveAll:te=>ht.saveAll(te),applyEdit(te,fe){return hn.applyWorkspaceEdit(te,Ne,fe)},createFileSystemWatcher:(te,fe,Le,nt)=>Zt.createFileSystemWatcher(ht,Ne,te,fe,Le,nt),get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new M.$8("textDocuments")},openTextDocument(te){let fe;const Le=te;if(typeof te=="string")fe=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))fe=Promise.resolve(te);else if(!Le||typeof Le=="object")fe=It.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(nt=>It.ensureDocumentData(nt).then(wt=>wt.document))},onDidOpenTextDocument:(te,fe,Le)=>It.onDidAddDocument(te,fe,Le),onDidCloseTextDocument:(te,fe,Le)=>It.onDidRemoveDocument(te,fe,Le),onDidChangeTextDocument:(te,fe,Le)=>It.onDidChangeDocument(te,fe,Le),onDidSaveTextDocument:(te,fe,Le)=>It.onDidSaveDocument(te,fe,Le),onWillSaveTextDocument:(te,fe,Le)=>Vi.getOnWillSaveTextDocumentEvent(Ne)(te,fe,Le),get notebookDocuments(){return kt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,fe){let Le;if(A.URI.isUri(te))Le=te,await kt.openNotebookDocument(te);else if(typeof te=="string")Le=A.URI.revive(await kt.createNotebookDocument({viewType:te,content:fe}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(te,fe,Le){return ti.onDidSaveNotebookDocument(te,fe,Le)},onDidChangeNotebookDocument(te,fe,Le){return ti.onDidChangeNotebookDocument(te,fe,Le)},onWillSaveNotebookDocument(te,fe,Le){return Si.getOnWillSaveNotebookDocumentEvent(Ne)(te,fe,Le)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(te,fe,Le,nt){return kt.registerNotebookSerializer(Ne,te,fe,Le,(0,Oe.$8E)(Ne,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(te,fe,Le)=>Fi.onDidChangeConfiguration(te,fe,Le),getConfiguration(te,fe){return fe=arguments.length===1?void 0:fe,Fi.getConfiguration(te,fe,Ne)},registerTextDocumentContentProvider(te,fe){return Di.registerTextDocumentContentProvider(te,fe)},registerTaskProvider:(te,fe)=>(Te.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(Ne,te,fe)),registerFileSystemProvider(te,fe,Le){return(0,Be.$Oc)(qi.registerFileSystemProvider(Ne,te,fe,Le),Ct.addFileSystemProvider(te,fe,Le))},get fs(){return Ct.value},registerFileSearchProvider:(te,fe)=>((0,Oe.$9E)(Ne,"fileSearchProvider"),gi.registerFileSearchProvider(te,fe)),registerTextSearchProvider:(te,fe)=>((0,Oe.$9E)(Ne,"textSearchProvider"),gi.registerTextSearchProvider(te,fe)),registerRemoteAuthorityResolver:(te,fe)=>((0,Oe.$9E)(Ne,"resolvers"),Dt.registerRemoteAuthorityResolver(te,fe)),registerResourceLabelFormatter:te=>((0,Oe.$9E)(Ne,"resolvers"),Hi.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Oe.$9E)(Ne,"resolvers"),Dt.getRemoteExecServer(te)),onDidCreateFiles:(te,fe,Le)=>Zt.onDidCreateFile(te,fe,Le),onDidDeleteFiles:(te,fe,Le)=>Zt.onDidDeleteFile(te,fe,Le),onDidRenameFiles:(te,fe,Le)=>Zt.onDidRenameFile(te,fe,Le),onWillCreateFiles:(te,fe,Le)=>Zt.getOnWillCreateFileEvent(Ne)(te,fe,Le),onWillDeleteFiles:(te,fe,Le)=>Zt.getOnWillDeleteFileEvent(Ne)(te,fe,Le),onWillRenameFiles:(te,fe,Le)=>Zt.getOnWillRenameFileEvent(Ne)(te,fe,Le),openTunnel:te=>((0,Oe.$9E)(Ne,"tunnels"),J.openTunnel(Ne,te).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Oe.$9E)(Ne,"tunnels"),J.getTunnels()},onDidChangeTunnels:(te,fe,Le)=>((0,Oe.$9E)(Ne,"tunnels"),J.onDidChangeTunnels(te,fe,Le)),registerPortAttributesProvider:(te,fe)=>((0,Oe.$9E)(Ne,"portsAttributes"),J.registerPortsAttributesProvider(te,fe)),registerTunnelProvider:(te,fe)=>((0,Oe.$9E)(Ne,"tunnelFactory"),J.registerTunnelProvider(te,fe)),registerTimelineProvider:(te,fe)=>((0,Oe.$9E)(Ne,"timeline"),Ji.registerTimelineProvider(te,fe,Ne.identifier,dt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:te=>((0,Oe.$9E)(Ne,"workspaceTrust"),ht.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,fe,Le)=>ht.onDidGrantWorkspaceTrust(te,fe,Le),registerEditSessionIdentityProvider:(te,fe)=>((0,Oe.$9E)(Ne,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(te,fe)),onWillCreateEditSessionIdentity:(te,fe,Le)=>((0,Oe.$9E)(Ne,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Ne)(te,fe,Le)),registerCanonicalUriProvider:(te,fe)=>((0,Oe.$9E)(Ne,"canonicalUriProvider"),ht.registerCanonicalUriProvider(te,fe)),getCanonicalUri:(te,fe,Le)=>((0,Oe.$9E)(Ne,"canonicalUriProvider"),ht.provideCanonicalUri(te,fe,Le))},fn={get inputBox(){return Te.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Ne)},createSourceControl(te,fe,Le){return vi.createSourceControl(Ne,te,fe,Le)}},on={createCommentController(te,fe){return Pi.createCommentController(Ne,te,fe)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(te,fe,Le){return mt.onDidStartDebugSession(te,fe,Le)},onDidTerminateDebugSession(te,fe,Le){return mt.onDidTerminateDebugSession(te,fe,Le)},onDidChangeActiveDebugSession(te,fe,Le){return mt.onDidChangeActiveDebugSession(te,fe,Le)},onDidReceiveDebugSessionCustomEvent(te,fe,Le){return mt.onDidReceiveDebugSessionCustomEvent(te,fe,Le)},onDidChangeBreakpoints(te,fe,Le){return mt.onDidChangeBreakpoints(te,fe,Le)},onDidChangeStackFrameFocus(te,fe,Le){return(0,Oe.$9E)(Ne,"debugFocus"),mt.onDidChangeStackFrameFocus(te,fe,Le)},registerDebugConfigurationProvider(te,fe,Le){return mt.registerDebugConfigurationProvider(te,fe,Le||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,fe){return mt.registerDebugAdapterDescriptorFactory(Ne,te,fe)},registerDebugAdapterTrackerFactory(te,fe){return mt.registerDebugAdapterTrackerFactory(te,fe)},startDebugging(te,fe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?mt.startDebugging(te,fe,{parentSession:Le}):mt.startDebugging(te,fe,Le||{})},stopDebugging(te){return mt.stopDebugging(te)},addBreakpoints(te){return mt.addBreakpoints(te)},removeBreakpoints(te){return mt.removeBreakpoints(te)},asDebugSourceUri(te,fe){return mt.asDebugSourceUri(te,fe)}},Ni={registerTaskProvider:(te,fe)=>Ht.registerTaskProvider(Ne,te,fe),fetchTasks:te=>Ht.fetchTasks(te),executeTask:te=>Ht.executeTask(Ne,te),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(te,fe,Le)=>Ht.onDidStartTask(te,fe,Le),onDidEndTask:(te,fe,Le)=>Ht.onDidEndTask(te,fe,Le),onDidStartTaskProcess:(te,fe,Le)=>Ht.onDidStartTaskProcess(te,fe,Le),onDidEndTaskProcess:(te,fe,Le)=>Ht.onDidEndTaskProcess(te,fe,Le)},Oi={createNotebookController(te,fe,Le,nt,wt){return si.createNotebookController(Ne,te,fe,Le,nt,(0,Oe.$8E)(Ne,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(te,fe)=>kt.registerNotebookCellStatusBarItemProvider(Ne,te,fe),createRendererMessaging(te){return ki.createRendererMessaging(Ne,te)},createNotebookControllerDetectionTask(te){return(0,Oe.$9E)(Ne,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Ne,te)},registerKernelSourceActionProvider(te,fe){return(0,Oe.$9E)(Ne,"notebookKernelSource"),si.registerKernelSourceActionProvider(Ne,te,fe)},onDidChangeNotebookCellExecutionState(te,fe,Le){return(0,Oe.$9E)(Ne,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,fe,Le)}},zi={t(...te){if(typeof te[0]=="string"){const fe=te.shift(),Le=!te||typeof te[0]!="object"?te:te[0];return Vt.getMessage(Ne.identifier.value,{message:fe,args:Le})}return Vt.getMessage(Ne.identifier.value,te[0])},get bundle(){return Vt.getBundle(Ne.identifier.value)},get uri(){return Vt.getBundleUri(Ne.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(te,fe){return(0,Oe.$9E)(Ne,"interactive"),Gi.registerProvider(Ne,te,fe={label:fe?.label??Ne.displayName??Ne.name})},registerInteractiveSessionProvider(te,fe){return(0,Oe.$9E)(Ne,"interactive"),ui.registerChatProvider(Ne,te,fe)},addInteractiveRequest(te){return(0,Oe.$9E)(Ne,"interactive"),ui.addChatRequest(te)},sendInteractiveRequestToProvider(te,fe){return(0,Oe.$9E)(Ne,"interactive"),ui.sendInteractiveRequestToProvider(te,fe)},get onDidPerformUserAction(){return(0,Oe.$9E)(Ne,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(te,fe){return(0,Oe.$9E)(Ne,"interactive"),ui.transferChatSession(te,fe)}},Ui={getRelatedInformation(te,fe){return(0,Oe.$9E)(Ne,"aiRelatedInformation"),Zi.getRelatedInformation(Ne,te,fe)},registerRelatedInformationProvider(te,fe){return(0,Oe.$9E)(Ne,"aiRelatedInformation"),Zi.registerRelatedInformationProvider(Ne,te,fe)},registerEmbeddingVectorProvider(te,fe){return(0,Oe.$9E)(Ne,"aiRelatedInformation"),Ti.registerEmbeddingVectorProvider(Ne,te,fe)}},ji={registerChatResponseProvider(te,fe,Le){return(0,Oe.$9E)(Ne,"chatProvider"),fi.registerProvider(Ne.identifier,te,fe,Le)},requestChatAccess(te){return(0,Oe.$9E)(Ne,"chatRequestAccess"),fi.requestChatResponseProvider(Ne.identifier,te)},registerVariable(te,fe,Le){return(0,Oe.$9E)(Ne,"chatVariables"),Yi.registerVariableResolver(Ne,te,fe,Le)},registerMappedEditsProvider(te,fe){return(0,Oe.$9E)(Ne,"mappedEditsProvider"),ct.registerMappedEditsProvider(Ne,te,fe)},registerAgent(te,fe,Le){return(0,Oe.$9E)(Ne,"chatAgents"),Qi.registerAgent(Ne.identifier,te,fe,Le)}};return{version:ut.version,ai:Ui,authentication:xi,commands:_i,comments:on,chat:ji,debug:an,env:en,extensions:tn,interactive:di,l10n:zi,languages:nn,notebooks:Oi,scm:fn,tasks:Ni,tests:dn,window:rn,workspace:sn,Breakpoint:Z.$9K,TerminalOutputAnchor:Z.TerminalOutputAnchor,ChatMessage:Z.$YL,ChatMessageRole:Z.ChatMessageRole,ChatVariableLevel:Z.ChatVariableLevel,CallHierarchyIncomingCall:Z.$vK,CallHierarchyItem:Z.$uK,CallHierarchyOutgoingCall:Z.$wK,CancellationError:M.$4,CancellationTokenSource:w.$Wd,CandidatePortSource:a.CandidatePortSource,CodeAction:Z.$rK,CodeActionKind:Z.$sK,CodeActionTriggerKind:Z.CodeActionTriggerKind,CodeLens:Z.$xK,Color:Z.$KK,ColorInformation:Z.$LK,ColorPresentation:Z.$MK,ColorThemeKind:Z.ColorThemeKind,CommentMode:Z.CommentMode,CommentState:Z.CommentState,CommentThreadCollapsibleState:Z.CommentThreadCollapsibleState,CommentThreadState:Z.CommentThreadState,CompletionItem:Z.$EK,CompletionItemKind:Z.CompletionItemKind,CompletionItemTag:Z.CompletionItemTag,CompletionList:Z.$FK,CompletionTriggerKind:Z.CompletionTriggerKind,ConfigurationTarget:Z.ConfigurationTarget,CustomExecution:Z.$UK,DebugAdapterExecutable:Z.$aL,DebugAdapterInlineImplementation:Z.$dL,DebugAdapterNamedPipeServer:Z.$cL,DebugAdapterServer:Z.$bL,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Z.DebugConsoleMode,DecorationRangeBehavior:Z.DecorationRangeBehavior,Diagnostic:Z.$mK,DiagnosticRelatedInformation:Z.$lK,DiagnosticSeverity:Z.DiagnosticSeverity,DiagnosticTag:Z.DiagnosticTag,Disposable:Z.$$J,DocumentHighlight:Z.$oK,DocumentHighlightKind:Z.DocumentHighlightKind,DocumentLink:Z.$JK,DocumentSymbol:Z.$qK,EndOfLine:Z.EndOfLine,EnvironmentVariableMutatorType:Z.EnvironmentVariableMutatorType,EvaluatableExpression:Z.$gL,InlineValueText:Z.$hL,InlineValueVariableLookup:Z.$iL,InlineValueEvaluatableExpression:Z.$jL,InlineCompletionTriggerKind:Z.InlineCompletionTriggerKind,EventEmitter:C.$Md,ExtensionKind:Z.ExtensionKind,ExtensionMode:Z.ExtensionMode,ExternalUriOpenerPriority:Z.ExternalUriOpenerPriority,FileChangeType:Z.FileChangeType,FileDecoration:Z.$tL,FileDecoration2:Z.$tL,FileSystemError:Z.$lL,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:Z.$mL,FoldingRangeKind:Z.FoldingRangeKind,FunctionBreakpoint:Z.$$K,InlineCompletionItem:Z.$GK,InlineCompletionList:Z.$HK,Hover:Z.$nK,IndentAction:g.IndentAction,Location:Z.$kK,MarkdownString:Z.$yK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:Z.$zK,PortAutoForwardAction:Z.PortAutoForwardAction,Position:Z.$_J,ProcessExecution:Z.$SK,ProgressLocation:Z.ProgressLocation,QuickInputButtons:Z.$sL,Range:Z.$aK,RelativePattern:Z.$7K,Selection:Z.$bK,SelectionRange:Z.$tK,SemanticTokens:Z.$pL,SemanticTokensBuilder:Z.$oL,SemanticTokensEdit:Z.$qL,SemanticTokensEdits:Z.$rL,SemanticTokensLegend:Z.$nL,ShellExecution:Z.$TK,ShellQuoting:Z.ShellQuoting,SignatureHelp:Z.$BK,SignatureHelpTriggerKind:Z.SignatureHelpTriggerKind,SignatureInformation:Z.$AK,SnippetString:Z.$jK,SourceBreakpoint:Z.$0K,StandardTokenType:Z.StandardTokenType,StatusBarAlignment:Z.StatusBarAlignment,SymbolInformation:Z.$pK,SymbolKind:Z.SymbolKind,SymbolTag:Z.SymbolTag,Task:Z.$VK,TaskGroup:Z.$RK,TaskPanelKind:Z.TaskPanelKind,TaskRevealKind:Z.TaskRevealKind,TaskScope:Z.TaskScope,TerminalLink:Z.$NK,TerminalQuickFixExecuteTerminalCommand:Z.$PK,TerminalQuickFixOpener:Z.$OK,TerminalLocation:Z.TerminalLocation,TerminalProfile:Z.$QK,TerminalExitReason:Z.TerminalExitReason,TextDocumentSaveReason:Z.TextDocumentSaveReason,TextEdit:Z.$fK,SnippetTextEdit:Z.$hK,TextEditorCursorStyle:h.TextEditorCursorStyle,TextEditorLineNumbersStyle:Z.TextEditorLineNumbersStyle,TextEditorRevealType:Z.TextEditorRevealType,TextEditorSelectionChangeKind:Z.TextEditorSelectionChangeKind,SyntaxTokenType:Z.SyntaxTokenType,TextDocumentChangeReason:Z.TextDocumentChangeReason,ThemeColor:Z.$6K,ThemeIcon:Z.$5K,TreeItem:Z.$WK,TreeItemCheckboxState:Z.TreeItemCheckboxState,TreeItemCollapsibleState:Z.TreeItemCollapsibleState,TypeHierarchyItem:Z.$OL,UIKind:b.UIKind,Uri:A.URI,ViewColumn:Z.ViewColumn,WorkspaceEdit:Z.$iK,DocumentDropEdit:Z.$3K,DocumentPasteEdit:Z.$4K,InlayHint:Z.$DK,InlayHintLabelPart:Z.$CK,InlayHintKind:Z.InlayHintKind,RemoteAuthorityResolverError:Z.$eK,ResolvedAuthority:Z.$cK,ManagedResolvedAuthority:Z.$dK,SourceControlInputBoxValidationType:Z.SourceControlInputBoxValidationType,ExtensionRuntime:Z.ExtensionRuntime,TimelineItem:Z.$DL,NotebookRange:Z.$vL,NotebookCellKind:Z.NotebookCellKind,NotebookCellExecutionState:Z.NotebookCellExecutionState,NotebookCellData:Z.$wL,NotebookData:Z.$xL,NotebookRendererScript:Z.$BL,NotebookCellStatusBarAlignment:Z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Z.NotebookEditorRevealType,NotebookCellOutput:Z.$zL,NotebookCellOutputItem:Z.$yL,NotebookCellStatusBarItem:Z.$AL,NotebookControllerAffinity:Z.NotebookControllerAffinity,NotebookControllerAffinity2:Z.NotebookControllerAffinity2,NotebookEdit:Z.$gK,NotebookKernelSourceAction:Z.$CL,PortAttributes:Z.$FL,LinkedEditingRanges:Z.$EL,TestResultState:Z.TestResultState,TestRunRequest:Z.$GL,TestMessage:Z.$HL,TestMessage2:Z.$HL,TestTag:Z.$IL,TestRunProfileKind:Z.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Z.$2K,DataTransferItem:Z.$XK,CoveredCount:Z.$JL,FileCoverage:Z.$KL,StatementCoverage:Z.$LL,BranchCoverage:Z.$ML,FunctionCoverage:Z.$NL,WorkspaceTrustState:Z.WorkspaceTrustState,LanguageStatusSeverity:Z.LanguageStatusSeverity,QuickPickItemKind:Z.QuickPickItemKind,InputBoxValidationSeverity:Z.InputBoxValidationSeverity,TabInputText:Z.$PL,TabInputTextDiff:Z.$QL,TabInputTextMerge:Z.$RL,TabInputCustom:Z.$SL,TabInputNotebook:Z.$UL,TabInputNotebookDiff:Z.$VL,TabInputWebview:Z.$TL,TabInputTerminal:Z.$WL,TabInputInteractiveWindow:Z.$XL,TelemetryTrustedValue:ye.$co,LogLevel:ve.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Z.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Z.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Z.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Z.$eL,ThreadFocus:Z.$fL,RelatedInformationType:Z.RelatedInformationType}}}e.$Gdc=Wt}),define(Ae[273],Re([1,0,70,109,33,107,34,31,60,63,111,113,114,84,86,80,108,62,39,83,58,61,241,14,112,81,82]),function(be,e,w,M,C,F,A,h,E,g,P,k,a,b,m,f,t,n,c,v,D,p,r,s,i,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$pr)(o.$hcc,o.$gcc,1),(0,w.$pr)(s.$9i,r.$Hdc,1),(0,w.$pr)(f.$Gbc,f.$Hbc,1),(0,w.$pr)(h.$tM,h.$sM,0),(0,w.$pr)(A.$Tbc,A.$Rbc,0),(0,w.$pr)(n.$9bc,n.$8bc,0),(0,w.$pr)(k.$Wcc,k.$1cc,0),(0,w.$pr)(F.$Occ,F.$Ncc,0),(0,w.$pr)(E.$iM,E.$hM,0),(0,w.$pr)(y.$icc,y.$jcc,0),(0,w.$pr)(c.$Dbc,c.$Cbc,0),(0,w.$pr)(M.$ucc,M.$tcc,1),(0,w.$pr)(a.$7cc,a.$8cc,0),(0,w.$pr)(b.$5bc,b.$4bc,0),(0,w.$pr)(P.$Rcc,P.$Qcc,0),(0,w.$pr)(g.$_bc,g.$ccc,0),(0,w.$pr)(m.$Rvb,m.$Svb,0),(0,w.$pr)(t.$Kcc,t.$Jcc,0),(0,w.$pr)(C.$Qbc,C.$Pbc,0),(0,w.$pr)(v.$ecc,v.$dcc,0),(0,w.$pr)(D.$rM,D.$oM,0),(0,w.$pr)(p.$Scc,p.$Tcc,0),(0,w.$pr)(i.$Ucc,i.$Vcc,0)}),define(Ae[274],Re([1,0,272,35,2,269,7,13,260]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0;class g extends F.$Kdc{j(){}getModule(b,m){for(const f of this.b){const t=f(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends M.$lcc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(E.$Pfc);const b=this.h.invokeFunction(w.$Gdc);this.r=this.h.createInstance(g,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(b){return b.browser}async vb(b,m,f){m=m.with({path:k(m.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const n=C.URI.revive(await this.C.$asBrowserUri(m)),c=await fetch(n.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const v=await c.text(),D=`${m.toString(!0)}#vscode-extension`,p=`${v}
//# sourceURL=${D}`;let r;try{r=new Function("module","exports","require",p)}catch(y){throw console.error(t?`Loading code for extension ${t} failed: ${y.message}`:`Loading code failed: ${y.message}`),console.error(`${m.toString(!0)}${typeof y.line=="number"?` line ${y.line}`:""}${typeof y.column=="number"?` column ${y.column}`:""}`),console.error(y),y}b&&await this.w.initializeLocalizedMessages(b);const s={},i={exports:s},o=y=>{const $=this.r.getModule(y,m);if($===void 0)throw new Error(`Cannot load module '${y}'`);return $};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(i,s,o),i.exports!==s?i.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(b){}async zb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+b;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,h.$Tg)(10)}}e.$Qfc=P;function k(a,b){return a.endsWith(b)?a:a+b}}),define(Ae[275],Re([1,0,69,70,14,35,187,85,274]),function(be,e,w,M,C,F,A,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$pr)(C.$8i,new w.$Kh(A.$Jdc,[!0],!0)),(0,M.$pr)(F.$mcc,E.$Qfc,0),(0,M.$pr)(h.$0bc,h.$$bc,0)}),define(Ae[284],Re([1,0,25,5,79,270,262,19,87,12,2,273,275]),function(be,e,w,M,C,F,A,h,E,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(r){return/^(file|vscode-remote):/i.test(r)}const m=fetch.bind(self);function f(r){self.fetch=async function(s,i){return s instanceof Request||b(String(s))&&(s=(await r(P.URI.parse(String(s)))).toString(!0)),m(s,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,i,o,y,$){(async()=>(b(i.toString())&&(i=(await r(P.URI.parse(i.toString()))).toString(!0)),super.open(s,i,o??!0,y,$)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(s,i){if(/^file:/i.test(s.toString()))s=g.$bg.uriToBrowserUri(P.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const y=`(${function(u){function d(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,`${g.Schemas.vscodeFileResource}://${g.$ag}`):B}const l=fetch.bind(self);self.fetch=function(B,V){return B instanceof Request?l(B,V):l(d(B),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,V,U,W,N){return super.open(B,d(V),U??!0,W,N)}};const R=importScripts.bind(self);self.importScripts=(...B)=>{R(...B.map(d))},R(u)}.toString()}('${s}'))`;i=i||{},i.name=i.name||h.$mc(s.toString());const $=new Blob([y],{type:"application/javascript"}),S=URL.createObjectURL($);return new r(S,i)}}else self.Worker=class extends A.$Rfc{constructor(r,s){super(a,r,{name:h.$mc(r.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(r){k()}};class n{constructor(){const s=new MessageChannel,i=new M.$Md;let o=!1;a(s.port2,[s.port2]),s.port1.onmessage=y=>{const{data:$}=y;if(!($ instanceof ArrayBuffer)){console.warn("UNKNOWN data received",$);return}const S=w.$ae.wrap(new Uint8Array($,0,$.byteLength));if((0,C.$8l)(S,2)){o=!0,v("received terminate message from renderer");return}i.fire(S)},this.protocol={onMessage:i.event,send:y=>{if(!o){const $=y.buffer.buffer.slice(y.buffer.byteOffset,y.buffer.byteOffset+y.buffer.byteLength);s.port1.postMessage($,[$])}}}}}function c(r){return new Promise(s=>{const i=r.onMessage(o=>{i.dispose();const y=JSON.parse(o.toString());r.send((0,C.$7l)(0)),s({protocol:r,initData:y})});r.send((0,C.$7l)(1))})}let v=r=>k();function D(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function p(){E.mark("code/extHost/willConnectToRenderer");const r=new n;return{onmessage(s){D(s)&&c(r.protocol).then(i=>{E.mark("code/extHost/didWaitForInitData");const o=new F.$Mdc(i.protocol,i.initData,t,null,s.data);f(y=>o.asBrowserUri(y)),v=y=>o.terminate(y)})}}}e.create=p})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7d4027b62bb1e620e5454580450fa646682bc102/core/vs/workbench/api/worker/extensionHostWorker.js.map
