/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],p=function(F){for(var e=[],I=0,S=F.length;I<S;I++)e[I]=q[F[I]];return e};define(q[21],p([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class I{static get(){const v=new Map,T=new Map,r=new Map,d=new Map;function t(o,n){o.has(n.detail)||o.set(n.detail,-n.timestamp)}function a(o,n){const i=o.get(n.detail);i&&(i>=0||o.set(n.detail,i+n.timestamp))}let u=[];typeof F=="function"&&typeof F.getStats=="function"&&(u=F.getStats().slice(0).sort((o,n)=>o.timestamp-n.timestamp));for(const o of u)switch(o.type){case 10:t(v,o);break;case 11:case 12:a(v,o);break;case 21:t(T,o);break;case 22:a(T,o);break;case 33:t(r,o);break;case 34:a(r,o);break;case 31:t(d,o);break;case 32:a(d,o);break}let h=0;r.forEach(o=>h+=o);function g(o){const n=[];return o.forEach((i,s)=>n.push([s,i])),n}return{amdLoad:g(v),amdInvoke:g(T),nodeRequire:g(r),nodeEval:g(d),nodeRequireTotal:h}}static toMarkdownTable(v,T){let r="";const d=[];return v.forEach((t,a)=>{d[a]=t.length}),T.forEach(t=>{t.forEach((a,u)=>{typeof a>"u"&&(a=t[u]="-");const h=a.toString().length;d[u]=Math.max(h,d[u])})}),v.forEach((t,a)=>{r+=`| ${t+" ".repeat(d[a]-t.toString().length)} `}),r+=`|
`,v.forEach((t,a)=>{r+=`| ${"-".repeat(d[a])} `}),r+=`|
`,T.forEach(t=>{t.forEach((a,u)=>{typeof a<"u"&&(r+=`| ${a+" ".repeat(d[u]-a.toString().length)} `)}),r+=`|
`}),r}}e.$T=I}),define(q[4],p([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qd=e.$pd=e.$od=void 0;let I;function S(i){I=i}e.$od=S;function v(){return I}e.$pd=v;class T{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([d(o("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[d(" "),a(u(s.oldValue,70),{color:"red",strikeThrough:!0}),d(" "),a(u(s.newValue,60),{color:"green"})]:[d(" (unchanged)")]:[d(" "),a(u(s.newValue,60),{color:"green"}),d(" (initial)")]}handleObservableChanged(s,l){console.log(...this.b([t("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c(l)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map(l=>l.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const l=s.handleChange;this.d.set(s,new Set),s.handleChange=(w,N)=>(this.d.get(s).add(w),l.apply(s,[w,N]))}handleDerivedRecomputed(s,l){const w=this.d.get(s);console.log(...this.b([t("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c(l),this.formatChanges(w),{data:[{fn:s._computeFn}]}])),w.clear()}handleFromEventObservableTriggered(s,l){console.log(...this.b([t("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c(l),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const l=s.handleChange;this.d.set(s,new Set),s.handleChange=(w,N)=>(this.d.get(s).add(w),l.apply(s,[w,N]))}handleAutorunTriggered(s){const l=this.d.get(s);console.log(...this.b([t("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges(l),{data:[{fn:s._runFn}]}])),l.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let l=s.getDebugName();l===void 0&&(l=""),console.log(...this.b([t("transaction"),a(l,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$qd=T;function r(i){const s=new Array,l=[];let w="";function N(E){if("length"in E)for(const f of E)f&&N(f);else"text"in E?(w+=`%c${E.text}`,s.push(E.style),E.data&&l.push(...E.data)):"data"in E&&l.push(...E.data)}N(i);const L=[w,...s];return L.push(...l),L}function d(i){return a(i,{color:"black"})}function t(i){return a(n(`${i}: `,10),{color:"black",bold:!0})}function a(i,s={color:"black"}){function l(N){return Object.entries(N).reduce((L,[E,f])=>`${L}${E}:${f};`,"")}const w={color:s.color};return s.strikeThrough&&(w["text-decoration"]="line-through"),s.bold&&(w["font-weight"]="bold"),{text:i,style:l(w)}}function u(i,s){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=s?`"${i}"`:`"${i.substr(0,s-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?h(i,s):g(i,s);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function h(i,s){let l="[ ",w=!0;for(const N of i){if(w||(l+=", "),l.length-5>s){l+="...";break}w=!1,l+=`${u(N,s-l.length)}`}return l+=" ]",l}function g(i,s){let l="{ ",w=!0;for(const[N,L]of Object.entries(i)){if(w||(l+=", "),l.length-5>s){l+="...";break}w=!1,l+=`${N}: ${u(L,s-l.length)}`}return l+=" }",l}function o(i,s){let l="";for(let w=1;w<=s;w++)l+=i;return l}function n(i,s){for(;i.length<s;)i+=" ";return i}}),define(q[5],p([0,1,4]),function(F,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=void 0;let S;function v(s){S=s}e.$wd=v;class T{get TChange(){return null}reportChanges(){this.get()}read(l){return l?l.readObservable(this):this.get()}map(l,w){const N=w===void 0?void 0:l,L=w===void 0?l:w;return S({owner:N,debugName:()=>{const E=h(L);if(E!==void 0)return E;const y=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(L.toString());if(y)return`${this.debugName}.${y[2]}`;if(!N)return`${this.debugName} (mapped)`}},E=>L(this.read(E),E))}}e.$xd=T;class r extends T{constructor(){super(...arguments),this.c=new Set}addObserver(l){const w=this.c.size;this.c.add(l),w===0&&this.f()}removeObserver(l){this.c.delete(l)&&this.c.size===0&&this.g()}f(){}g(){}}e.$yd=r;function d(s,l){const w=new a(s,l);try{s(w)}finally{w.finish()}}e.$zd=d;function t(s,l,w){s?l(s):d(l,w)}e.$Ad=t;class a{constructor(l,w){this._fn=l,this.b=w,this.a=[],(0,I.$pd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():h(this._fn)}updateObserver(l,w){this.a.push({observer:l,observable:w}),l.beginUpdate(w)}finish(){const l=this.a;this.a=null;for(const{observer:w,observable:N}of l)w.endUpdate(N);(0,I.$pd)()?.handleEndTransaction()}}e.$Bd=a;function u(s,l,w,N){let L;if(s!==void 0)if(typeof s=="function"){if(L=s(),L!==void 0)return L}else return s;if(l!==void 0&&(L=h(l),L!==void 0))return L;if(w!==void 0){for(const E in w)if(w[E]===N)return E}}e.$Cd=u;function h(s){const l=s.toString(),N=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(l);return(N?N[1]:void 0)?.trim()}e.$Dd=h;function g(s,l){return typeof s=="string"?new o(void 0,s,l):new o(s,void 0,l)}e.$Ed=g;class o extends r{get debugName(){return u(this.d,void 0,this.b,this)??"ObservableValue"}constructor(l,w,N){super(),this.b=l,this.d=w,this.a=N}get(){return this.a}set(l,w,N){if(this.a===l)return;let L;w||(w=L=new a(()=>{},()=>`Setting ${this.debugName}`));try{const E=this.a;this.e(l),(0,I.$pd)()?.handleObservableChanged(this,{oldValue:E,newValue:l,change:N,didChange:!0,hadValue:!0});for(const f of this.c)w.updateObserver(f,this),f.handleChange(this,N)}finally{L&&L.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(l){this.a=l}}e.$Fd=o;function n(s,l){return typeof s=="string"?new i(void 0,s,l):new i(s,void 0,l)}e.$Gd=n;class i extends o{e(l){this.a!==l&&(this.a&&this.a.dispose(),this.a=l)}dispose(){this.a?.dispose()}}e.$Hd=i}),define(q[9],p([0,1,42,2,5,4]),function(F,e,I,S,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=void 0;function r(n,i){return new g(n.debugName,i,void 0,void 0)}e.$7c=r;function d(n){return new g(void 0,n,void 0,void 0)}e.$8c=d;function t(n,i){return new g(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$9c=t;function a(n,i){const s=new S.$Qc,l=t({debugName:n.debugName??(()=>(0,v.$Dd)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(w,N)=>{s.clear(),i(w,N,s)});return(0,S.$Pc)(()=>{l.dispose(),s.dispose()})}e.$0c=a;function u(n){const i=new S.$Qc,s=r({debugName:()=>(0,v.$Dd)(n)||"(anonymous)"},l=>{i.clear(),n(l,i)});return(0,S.$Pc)(()=>{s.dispose(),i.dispose()})}e.$$c=u;var h;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(h||(h={}));class g{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const s=this.h();if(s!==void 0)return s}const i=(0,v.$Dd)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,s,l,w){this.h=i,this._runFn=s,this.i=l,this.j=w,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,T.$pd)()?.handleAutorunCreated(this),this.k(),(0,S.$Ic)(this)}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear(),(0,S.$Jc)(this)}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;try{if(!this.c){(0,T.$pd)()?.handleAutorunTriggered(this);const s=this.g;this.g=this.i?.(),this._runFn(this,s)}}finally{(0,T.$pd)()?.handleAutorunFinished(this);for(const s of this.f)s.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,I.$5c)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,s){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:s,didChange:w=>w===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const s=i.get();return this.e.add(i),this.f.delete(i),s}}e.$_c=g,function(n){n.Observer=g}(d||(e.$8c=d={}));function o(n,i){let s;return r({debugName:()=>(0,v.$Dd)(i)},l=>{const w=n.read(l),N=s;s=w,i({lastValue:N,newValue:w})})}e.$ad=o}),define(q[10],p([0,1,6,2,5,4]),function(F,e,I,S,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vd=e.$ud=e.$td=e.$sd=e.$rd=void 0;const r=(o,n)=>o===n;function d(o,n){return n!==void 0?new g(o,void 0,n,void 0,void 0,void 0,r):new g(void 0,void 0,o,void 0,void 0,void 0,r)}e.$rd=d;function t(o,n){return new g(o.owner,o.debugName,n,void 0,void 0,void 0,o.equalityComparer??r)}e.$sd=t;function a(o,n){return new g(o.owner,o.debugName,n,o.createEmptyChangeSummary,o.handleChange,void 0,o.equalityComparer??r)}e.$td=a;function u(o,n){let i,s;n===void 0?(i=o,s=void 0):(s=o,i=n);const l=new S.$Qc;return new g(s,()=>(0,v.$Dd)(i)??"(anonymous)",w=>(l.clear(),i(w,l)),void 0,void 0,()=>l.dispose(),r)}e.$ud=u,(0,v.$wd)(d);var h;(function(o){o[o.initial=0]="initial",o[o.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",o[o.stale=2]="stale",o[o.upToDate=3]="upToDate"})(h||(h={}));class g extends v.$yd{get debugName(){return(0,v.$Cd)(this.n,this._computeFn,this.m,this)??"(anonymous)"}constructor(n,i,s,l,w,N=void 0,L){super(),this.m=n,this.n=i,this._computeFn=s,this.p=l,this.q=w,this.s=N,this.t=L,this.e=0,this.h=void 0,this.i=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.p?.(),(0,T.$pd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.j)n.removeObserver(this);this.j.clear(),this.s?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.p?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.j)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const n=this.k;this.k=this.j,this.j=n;const i=this.e!==0,s=this.h;this.e=3;const l=this.l;this.l=this.p?.();try{this.h=this._computeFn(this,l)}finally{for(const N of this.k)N.removeObserver(this);this.k.clear()}const w=i&&!this.t(s,this.h);if((0,T.$pd)()?.handleDerivedRecomputed(this,{oldValue:s,newValue:this.h,change:void 0,didChange:w,hadValue:i}),w)for(const N of this.c)N.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.i++;const i=this.i===1;if(this.e===3&&(this.e=1,!i))for(const s of this.c)s.handlePossibleChange(this);if(i)for(const s of this.c)s.beginUpdate(this)}endUpdate(n){if(this.i--,this.i===0){const i=[...this.c];for(const s of i)s.endUpdate(this)}if(this.i<0)throw new I.$bb}handlePossibleChange(n){if(this.e===3&&this.j.has(n)&&!this.k.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.j.has(n)&&!this.k.has(n)){const s=this.q?this.q({changedObservable:n,change:i,didChange:w=>w===n},this.l):!0,l=this.e===3;if(s&&(this.e===1||l)&&(this.e=2,l))for(const w of this.c)w.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.j.add(n),this.k.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.i>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.i>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$vd=g}),define(q[22],p([0,1,2,9,5,10,4]),function(F,e,I,S,v,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=void 0;function d(m){return new t(m)}e.$bd=d;class t extends v.$xd{constructor(O){super(),this.a=O}get debugName(){return this.toString()}get(){return this.a}addObserver(O){}removeObserver(O){}toString(){return`Const: ${this.a}`}}function a(m){const O=(0,v.$Ed)("promiseValue",{});return m.then(D=>{O.set({value:D},void 0)}),O}e.$cd=a;function u(m,O){return new Promise(D=>{let $=!1,A=!1;const R=(0,S.$8c)(z=>{const C=m.read(z);O(C)&&($?R.dispose():A=!0,D(C))});$=!0,A&&R.dispose()})}e.$dd=u;function h(m,O){return new g(m,O)}e.$ed=h;class g extends v.$yd{constructor(O,D){super(),this.h=O,this._getValue=D,this.b=!1,this.k=$=>{const A=this._getValue($),R=!this.b||this.a!==A;(0,r.$pd)()?.handleFromEventObservableTriggered(this,{oldValue:this.a,newValue:A,change:void 0,didChange:R,hadValue:this.b}),R&&(this.a=A,this.b&&(0,v.$zd)(z=>{for(const C of this.c)z.updateObserver(C,this),C.handleChange(this,void 0)},()=>{const z=this.i();return"Event fired"+(z?`: ${z}`:"")}),this.b=!0)}}i(){return(0,v.$Dd)(this._getValue)}get debugName(){const O=this.i();return"From Event"+(O?`: ${O}`:"")}f(){this.e=this.h(this.k)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$fd=g,function(m){m.Observer=g}(h||(e.$ed=h={}));function o(m,O){return new n(m,O)}e.$gd=o;class n extends v.$yd{constructor(O,D){super(),this.debugName=O,this.b=D,this.h=()=>{(0,v.$zd)($=>{for(const A of this.c)$.updateObserver(A,this),A.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(m){return typeof m=="string"?new s(m):new s(void 0,m)}e.$hd=i;class s extends v.$yd{get debugName(){return(0,v.$Cd)(this.a,void 0,this.b,this)??"Observable Signal"}constructor(O,D){super(),this.a=O,this.b=D}trigger(O,D){if(!O){(0,v.$zd)($=>{this.trigger($,D)},()=>`Trigger signal ${this.debugName}`);return}for(const $ of this.c)O.updateObserver($,this),$.handleChange(this,D)}get(){}}function l(m,O,D){const $=(0,v.$Ed)("debounced",void 0);let A;return D.add((0,S.$8c)(R=>{const z=m.read(R);A&&clearTimeout(A),A=setTimeout(()=>{(0,v.$zd)(C=>{$.set(z,C)})},O)})),$}e.$id=l;function w(m,O,D){const $=(0,v.$Ed)("triggeredRecently",!1);let A;return D.add(m(()=>{$.set(!0,void 0),A&&clearTimeout(A),A=setTimeout(()=>{$.set(!1,void 0)},O)})),$}e.$jd=w;function N(m){const O=new E(!1);return m.addObserver(O),(0,I.$Pc)(()=>{m.removeObserver(O)})}e.$kd=N;function L(m){const O=new E(!0);return m.addObserver(O),m.reportChanges(),(0,I.$Pc)(()=>{m.removeObserver(O)})}e.$ld=L;class E{constructor(O){this.b=O,this.a=0}beginUpdate(O){this.a++}endUpdate(O){this.a--,this.a===0&&this.b&&O.reportChanges()}handlePossibleChange(O){}handleChange(O,D){}}function f(m){let O;return(0,T.$rd)($=>(O=m($,O),O))}e.$md=f;function y(m,O){let D;const $=(0,v.$Ed)("derivedObservableWithWritableCache.counter",0),A=(0,T.$rd)(m,R=>($.read(R),D=O(R,D),D));return Object.assign(A,{clearCache:R=>{D=void 0,$.set($.get()+1,R)}})}e.$nd=y}),define(q[11],p([0,1,5,10,9,22,4]),function(F,e,I,S,v,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return I.$Ed}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return I.$Gd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return I.$zd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return I.$Ad}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.$rd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return S.$sd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return S.$td}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return S.$ud}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$8c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$ad}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$9c}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$$c}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$7c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$0c}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return T.$bd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return T.$id}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return T.$md}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return T.$nd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return T.$kd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return T.$ld}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return T.$ed}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return T.$cd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return T.$hd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return T.$gd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return T.$dd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return T.$jd}}),!1&&(0,r.$od)(new r.$qd)}),define(q[23],p([0,1,6,2]),function(F,e,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function v(L){const E=L;return E?typeof E.read=="function":!1}e.$Xd=v;function T(L){const E=L;return E?[E.on,E.pause,E.resume,E.destroy].every(f=>typeof f=="function"):!1}e.$Yd=T;function r(L){const E=L;return E?T(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$Zd=r;function d(L,E){return new t(L,E)}e.$1d=d;class t{constructor(E,f){this.e=E,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(f=>f(E))}h(E){this.c.error.length===0?(0,I.$Z)(E):this.c.error.slice(0).forEach(f=>f(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,f){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(E,f){if(this.a.destroyed)return;let y;switch(E){case"data":y=this.c.data;break;case"end":y=this.c.end;break;case"error":y=this.c.error;break}if(y){const m=y.indexOf(f);m>=0&&y.splice(m,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(y=>y())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(L,E){const f=[];let y;for(;(y=L.read())!==null;)f.push(y);return E(f)}e.$2d=a;function u(L,E,f){const y=[];let m;for(;(m=L.read())!==null&&y.length<f;)y.push(m);return m===null&&y.length>0?E(y):{read:()=>{if(y.length>0)return y.shift();if(typeof m<"u"){const O=m;return m=void 0,O}return L.read()}}}e.$3d=u;function h(L,E){return new Promise((f,y)=>{const m=[];g(L,{onData:O=>{E&&m.push(O)},onError:O=>{E?y(O):f(void 0)},onEnd:()=>{f(E?E(m):void 0)}})})}e.$4d=h;function g(L,E,f){L.on("error",y=>{f?.isCancellationRequested||E.onError(y)}),L.on("end",()=>{f?.isCancellationRequested||E.onEnd()}),L.on("data",y=>{f?.isCancellationRequested||E.onData(y)})}e.$5d=g;function o(L,E){return new Promise((f,y)=>{const m=new S.$Qc,O=[],D=R=>{if(O.push(R),O.length>E)return m.dispose(),L.pause(),f({stream:L,buffer:O,ended:!1})},$=R=>(m.dispose(),y(R)),A=()=>(m.dispose(),f({stream:L,buffer:O,ended:!0}));m.add((0,S.$Pc)(()=>L.removeListener("error",$))),L.on("error",$),m.add((0,S.$Pc)(()=>L.removeListener("end",A))),L.on("end",A),m.add((0,S.$Pc)(()=>L.removeListener("data",D))),L.on("data",D)})}e.$6d=o;function n(L,E){const f=d(E);return f.end(L),f}e.$7d=n;function i(){const L=d(()=>{throw new Error("not supported")});return L.end(),L}e.$8d=i;function s(L){let E=!1;return{read:()=>E?null:(E=!0,L)}}e.$9d=s;function l(L,E,f){const y=d(f);return g(L,{onData:m=>y.write(E.data(m)),onError:m=>y.error(E.error?E.error(m):m),onEnd:()=>y.end()}),y}e.$0d=l;function w(L,E,f){let y=!1;return{read:()=>{const m=E.read();return y?m:(y=!0,m!==null?f([L,m]):L)}}}e.$$d=w;function N(L,E,f){let y=!1;const m=d(f);return g(E,{onData:O=>y?m.write(O):(y=!0,m.write(f([L,O]))),onError:O=>m.error(O),onEnd:()=>{y||(y=!0,m.write(L)),m.end()}}),m}e.$_d=N}),define(q[12],p([0,1,43,23]),function(F,e,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const v=typeof Buffer<"u",T=new I.$U(()=>new Uint8Array(256));let r,d;class t{static alloc(b){return v?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return v&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,B){return!(B?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(b)):(r||(r=new TextEncoder),new t(r.encode(b)))}static fromByteArray(b){const B=t.alloc(b.length);for(let K=0,V=b.length;K<V;K++)B.buffer[K]=b[K];return B}static concat(b,B){if(typeof B>"u"){B=0;for(let G=0,H=b.length;G<H;G++)B+=b[G].byteLength}const K=t.alloc(B);let V=0;for(let G=0,H=b.length;G<H;G++){const W=b[G];K.set(W,V),V+=W.byteLength}return K}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return v?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(b,B){return new t(this.buffer.subarray(b,B))}set(b,B){if(b instanceof t)this.buffer.set(b.buffer,B);else if(b instanceof Uint8Array)this.buffer.set(b,B);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),B);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return g(this.buffer,b)}writeUInt32BE(b,B){o(this.buffer,b,B)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,B){i(this.buffer,b,B)}readUInt8(b){return s(this.buffer,b)}writeUInt8(b,B){l(this.buffer,b,B)}indexOf(b,B=0){return a(this.buffer,b instanceof t?b.buffer:b,B)}}e.$ae=t;function a(C,b,B=0){const K=b.byteLength,V=C.byteLength;if(K===0)return 0;if(K===1)return C.indexOf(b[0]);if(K>V-B)return-1;const G=T.value;G.fill(b.length);for(let Q=0;Q<b.length;Q++)G[b[Q]]=b.length-Q-1;let H=B+b.length-1,W=H,_=-1;for(;H<V;)if(C[H]===b[W]){if(W===0){_=H;break}H--,W--}else H+=Math.max(b.length-W,G[C[H]]),W=b.length-1;return _}e.$be=a;function u(C,b){return C[b+0]<<0>>>0|C[b+1]<<8>>>0}e.$ce=u;function h(C,b,B){C[B+0]=b&255,b=b>>>8,C[B+1]=b&255}e.$de=h;function g(C,b){return C[b]*2**24+C[b+1]*2**16+C[b+2]*2**8+C[b+3]}e.$ee=g;function o(C,b,B){C[B+3]=b,b=b>>>8,C[B+2]=b,b=b>>>8,C[B+1]=b,b=b>>>8,C[B]=b}e.$fe=o;function n(C,b){return C[b+0]<<0>>>0|C[b+1]<<8>>>0|C[b+2]<<16>>>0|C[b+3]<<24>>>0}e.$ge=n;function i(C,b,B){C[B+0]=b&255,b=b>>>8,C[B+1]=b&255,b=b>>>8,C[B+2]=b&255,b=b>>>8,C[B+3]=b&255}e.$he=i;function s(C,b){return C[b]}e.$ie=s;function l(C,b,B){C[B]=b}e.$je=l;function w(C){return S.$2d(C,b=>t.concat(b))}e.$ke=w;function N(C){return S.$9d(C)}e.$le=N;function L(C){return S.$4d(C,b=>t.concat(b))}e.$me=L;async function E(C){return C.ended?t.concat(C.buffer):t.concat([...C.buffer,await L(C.stream)])}e.$ne=E;function f(C){return S.$7d(C,b=>t.concat(b))}e.$oe=f;function y(C){return S.$0d(C,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.$pe=y;function m(C){return S.$1d(b=>t.concat(b),C)}e.$qe=m;function O(C,b){return S.$$d(C,b,B=>t.concat(B))}e.$re=O;function D(C,b){return S.$_d(C,b,B=>t.concat(B))}e.$se=D;function $(C){let b=0,B=0,K=0;const V=new Uint8Array(Math.floor(C.length/4*3)),G=W=>{switch(B){case 3:V[K++]=b|W,B=0;break;case 2:V[K++]=b|W>>>2,b=W<<6,B=3;break;case 1:V[K++]=b|W>>>4,b=W<<4,B=2;break;default:b=W<<2,B=1}};for(let W=0;W<C.length;W++){const _=C.charCodeAt(W);if(_>=65&&_<=90)G(_-65);else if(_>=97&&_<=122)G(_-97+26);else if(_>=48&&_<=57)G(_-48+52);else if(_===43||_===45)G(62);else if(_===47||_===95)G(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${C[W]}`)}}const H=K;for(;B>0;)G(0);return t.wrap(V).slice(0,H)}e.$te=$;const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function z({buffer:C},b=!0,B=!1){const K=B?R:A;let V="";const G=C.byteLength%3;let H=0;for(;H<C.byteLength-G;H+=3){const W=C[H+0],_=C[H+1],Q=C[H+2];V+=K[W>>>2],V+=K[(W<<4|_>>>4)&63],V+=K[(_<<2|Q>>>6)&63],V+=K[Q&63]}if(G===1){const W=C[H+0];V+=K[W>>>2],V+=K[W<<4&63],b&&(V+="==")}else if(G===2){const W=C[H+0],_=C[H+1];V+=K[W>>>2],V+=K[(W<<4|_>>>4)&63],V+=K[_<<2&63],b&&(V+="=")}return V}e.$ue=z}),define(q[24],p([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Jd=Symbol("MicrotaskDelay")}),define(q[13],p([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.StringEOL=void 0;var I;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function S(v){let T=0,r=0,d=0,t=0;for(let a=0,u=v.length;a<u;a++){const h=v.charCodeAt(a);h===13?(T===0&&(r=a),T++,a+1<u&&v.charCodeAt(a+1)===10?(t|=2,a++):t|=3,d=a+1):h===10&&(t|=1,T===0&&(r=a),T++,d=a+1)}return T===0&&(r=v.length),[T,r,v.length-d,t]}e.$Zs=S}),define(q[14],p([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(I||(e.LanguageId=I={}));var S;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var T;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(T||(e.StandardTokenType=T={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class d{static getLanguageId(a){return(a&255)>>>0}static getTokenType(a){return(a&768)>>>8}static containsBalancedBrackets(a){return(a&1024)!==0}static getFontStyle(a){return(a&30720)>>>11}static getForeground(a){return(a&16744448)>>>15}static getBackground(a){return(a&4278190080)>>>24}static getClassNameFromMetadata(a){let h="mtk"+this.getForeground(a);const g=this.getFontStyle(a);return g&1&&(h+=" mtki"),g&2&&(h+=" mtkb"),g&4&&(h+=" mtku"),g&8&&(h+=" mtks"),h}static getInlineStyleFromMetadata(a,u){const h=this.getForeground(a),g=this.getFontStyle(a);let o=`color: ${u[h]};`;g&1&&(o+="font-style: italic;"),g&2&&(o+="font-weight: bold;");let n="";return g&4&&(n+=" underline"),g&8&&(n+=" line-through"),n&&(o+=`text-decoration:${n};`),o}static getPresentationFromMetadata(a){const u=this.getForeground(a),h=this.getFontStyle(a);return{foreground:u,italic:!!(h&1),bold:!!(h&2),underline:!!(h&4),strikethrough:!!(h&8)}}}e.$Xs=d}),define(q[25],p([0,1,26]),function(F,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CB=void 0;class S{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,d){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=d}replace(r,d,t){if(r>=this.a.length)return;if(d===0){this.insert(r,t);return}else if(t===0){this.delete(r,d);return}const a=this.a.slice(0,r),u=this.a.slice(r+d),h=v(t,this.b);this.a=a.concat(h,u)}delete(r,d){d===0||r>=this.a.length||this.a.splice(r,d)}insert(r,d){if(d===0||r>=this.a.length)return;const t=[];for(let a=0;a<d;a++)t[a]=this.b;this.a=(0,I.$Vb)(this.a,r,t)}}e.$CB=S;function v(T,r){const d=[];for(let t=0;t<T;t++)d[t]=r;return d}}),define(q[7],p([0,1,14]),function(F,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=void 0;class S{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(r,d){const t=S.defaultTokenMetadata,a=new Uint32Array(2);return a[0]=r.length,a[1]=t,new S(a,r,d)}constructor(r,d,t){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=d,this.d=t}equals(r){return r instanceof S?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,d,t){if(this.c!==r.c||this.b!==r.b)return!1;const a=d<<1,u=a+(t<<1);for(let h=a;h<u;h++)if(this.a[h]!==r.a[h])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const d=this.a[(r<<1)+1],t=I.$Xs.getLanguageId(d);return this.d.decodeLanguageId(t)}getStandardTokenType(r){const d=this.a[(r<<1)+1];return I.$Xs.getTokenType(d)}getForeground(r){const d=this.a[(r<<1)+1];return I.$Xs.getForeground(d)}getClassName(r){const d=this.a[(r<<1)+1];return I.$Xs.getClassNameFromMetadata(d)}getInlineStyle(r,d){const t=this.a[(r<<1)+1];return I.$Xs.getInlineStyleFromMetadata(t,d)}getPresentation(r){const d=this.a[(r<<1)+1];return I.$Xs.getPresentationFromMetadata(d)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return S.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,d,t){return new v(this,r,d,t)}static convertToEndOffset(r,d){const a=(r.length>>>1)-1;for(let u=0;u<a;u++)r[u<<1]=r[u+1<<1];r[a<<1]=d}static findIndexInTokensArray(r,d){if(r.length<=2)return 0;let t=0,a=(r.length>>>1)-1;for(;t<a;){const u=t+Math.floor((a-t)/2),h=r[u<<1];if(h===d)return u+1;h<d?t=u+1:h>d&&(a=u)}return t}withInserted(r){if(r.length===0)return this;let d=0,t=0,a="";const u=new Array;let h=0;for(;;){const g=d<this.b?this.a[d<<1]:-1,o=t<r.length?r[t]:null;if(g!==-1&&(o===null||g<=o.offset)){a+=this.c.substring(h,g);const n=this.a[(d<<1)+1];u.push(a.length,n),d++,h=g}else if(o){if(o.offset>h){a+=this.c.substring(h,o.offset);const n=this.a[(d<<1)+1];u.push(a.length,n),h=o.offset}a+=o.text,u.push(a.length,o.tokenMetadata),t++}else break}return new S(new Uint32Array(u),a,this.d)}}e.$1s=S;class v{constructor(r,d,t,a){this.a=r,this.b=d,this.c=t,this.d=a,this.e=r.findTokenIndexAtOffset(d),this.f=0;for(let u=this.e,h=r.getCount();u<h&&!(r.getStartOffset(u)>=t);u++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof v?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const d=this.a.getEndOffset(this.e+r);return Math.min(this.c,d)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,d){return this.a.getInlineStyle(this.e+r,d)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(q[27],p([0,1,7]),function(F,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=e.$2s=void 0,e.$2s=new Uint32Array(0).buffer;class S{static deleteBeginning(r,d){return r===null||r===e.$2s?r:S.delete(r,0,d)}static deleteEnding(r,d){if(r===null||r===e.$2s)return r;const t=v(r),a=t[t.length-2];return S.delete(r,d,a)}static delete(r,d,t){if(r===null||r===e.$2s||d===t)return r;const a=v(r),u=a.length>>>1;if(d===0&&a[a.length-2]===t)return e.$2s;const h=I.$1s.findIndexInTokensArray(a,d),g=h>0?a[h-1<<1]:0,o=a[h<<1];if(t<o){const w=t-d;for(let N=h;N<u;N++)a[N<<1]-=w;return r}let n,i;g!==d?(a[h<<1]=d,n=h+1<<1,i=d):(n=h<<1,i=g);const s=t-d;for(let w=h+1;w<u;w++){const N=a[w<<1]-s;N>i&&(a[n++]=N,a[n++]=a[(w<<1)+1],i=N)}if(n===a.length)return r;const l=new Uint32Array(n);return l.set(a.subarray(0,n),0),l.buffer}static append(r,d){if(d===e.$2s)return r;if(r===e.$2s)return d;if(r===null)return r;if(d===null)return null;const t=v(r),a=v(d),u=a.length>>>1,h=new Uint32Array(t.length+a.length);h.set(t,0);let g=t.length;const o=t[t.length-2];for(let n=0;n<u;n++)h[g++]=a[n<<1]+o,h[g++]=a[(n<<1)+1];return h.buffer}static insert(r,d,t){if(r===null||r===e.$2s)return r;const a=v(r),u=a.length>>>1;let h=I.$1s.findIndexInTokensArray(a,d);h>0&&a[h-1<<1]===d&&h--;for(let g=h;g<u;g++)a[g<<1]+=t;return r}}e.$3s=S;function v(T){return T instanceof Uint32Array?T:new Uint32Array(T)}e.$4s=v}),define(q[28],p([0,1,26,12,44,13,27,15]),function(F,e,I,S,v,T,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=void 0;class t{static deserialize(u,h,g){const o=new Uint32Array(u.buffer),n=(0,S.$ee)(u,h);h+=4;const i=(0,S.$ee)(u,h);h+=4;const s=[];for(let l=0;l<i;l++){const w=(0,S.$ee)(u,h);h+=4,s.push(o.subarray(h/4,h/4+w/4)),h+=w}return g.push(new t(n,s)),h}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(u,h){this.a=u,this.b=h}getLineRange(){return new d.$ws(this.a,this.a+this.b.length)}getLineTokens(u){return this.b[u-this.a]}appendLineTokens(u){this.b.push(u)}serializeSize(){let u=0;u+=4,u+=4;for(let h=0;h<this.b.length;h++){const g=this.b[h];if(!(g instanceof Uint32Array))throw new Error("Not supported!");u+=4,u+=g.byteLength}return u}serialize(u,h){(0,S.$fe)(u,this.a,h),h+=4,(0,S.$fe)(u,this.b.length,h),h+=4;for(let g=0;g<this.b.length;g++){const o=this.b[g];if(!(o instanceof Uint32Array))throw new Error("Not supported!");(0,S.$fe)(u,o.byteLength,h),h+=4,u.set(new Uint8Array(o.buffer),h),h+=o.byteLength}return h}applyEdit(u,h){const[g,o]=(0,T.$Zs)(h);this.c(u),this.d(new v.$ms(u.startLineNumber,u.startColumn),g,o)}c(u){if(u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn)return;const h=u.startLineNumber-this.a,g=u.endLineNumber-this.a;if(g<0){const o=g-h;this.a-=o;return}if(!(h>=this.b.length)){if(h<0&&g>=this.b.length){this.a=0,this.b=[];return}if(h===g){this.b[h]=r.$3s.delete(this.b[h],u.startColumn-1,u.endColumn-1);return}if(h>=0)if(this.b[h]=r.$3s.deleteEnding(this.b[h],u.startColumn-1),g<this.b.length){const o=r.$3s.deleteBeginning(this.b[g],u.endColumn-1);this.b[h]=r.$3s.append(this.b[h],o),this.b.splice(h+1,g-h)}else this.b[h]=r.$3s.append(this.b[h],null),this.b=this.b.slice(0,h+1);else{const o=-h;this.a-=o,this.b[g]=r.$3s.deleteBeginning(this.b[g],u.endColumn-1),this.b=this.b.slice(g)}}}d(u,h,g){if(h===0&&g===0)return;const o=u.lineNumber-this.a;if(o<0){this.a+=h;return}if(!(o>=this.b.length)){if(h===0){this.b[o]=r.$3s.insert(this.b[o],u.column-1,g);return}this.b[o]=r.$3s.deleteEnding(this.b[o],u.column-1),this.b[o]=r.$3s.insert(this.b[o],u.column-1,g),this.e(u.lineNumber,h)}}e(u,h){if(h===0)return;const g=[];for(let o=0;o<h;o++)g[o]=null;this.b=I.$Vb(this.b,u,g)}}e.$5s=t}),define(q[16],p([0,1,12,28]),function(F,e,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DB=void 0;class v{static deserialize(r){let d=0;const t=(0,I.$ee)(r,d);d+=4;const a=[];for(let u=0;u<t;u++)d=S.$5s.deserialize(r,d,a);return a}constructor(){this.a=[]}add(r,d){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(d);return}}this.a.push(new S.$5s(r,[d]))}finalize(){return this.a}serialize(){const r=this.b(),d=new Uint8Array(r);return this.c(d),d}b(){let r=0;r+=4;for(let d=0;d<this.a.length;d++)r+=this.a[d].serializeSize();return r}c(r){let d=0;(0,I.$fe)(r,this.a.length,d),d+=4;for(let t=0;t<this.a.length;t++)d=this.a[t].serialize(r,d)}}e.$DB=v}),define(q[29],p([0,1,30,3,31,45]),function(F,e,I,S,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=void 0;function r($){return $===47||$===92}e.$Pf=r;function d($){return $.replace(/[\\/]/g,I.$fc.sep)}e.$Qf=d;function t($){return $.indexOf("/")===-1&&($=d($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Rf=t;function a($,A=I.$fc.sep){if(!$)return"";const R=$.length,z=$.charCodeAt(0);if(r(z)){if(r($.charCodeAt(1))&&!r($.charCodeAt(2))){let b=3;const B=b;for(;b<R&&!r($.charCodeAt(b));b++);if(B!==b&&!r($.charCodeAt(b+1))){for(b+=1;b<R;b++)if(r($.charCodeAt(b)))return $.slice(0,b+1).replace(/[\\/]/g,A)}}return A}else if(l(z)&&$.charCodeAt(1)===58)return r($.charCodeAt(2))?$.slice(0,2)+A:$.slice(0,2);let C=$.indexOf("://");if(C!==-1){for(C+=3;C<R;C++)if(r($.charCodeAt(C)))return $.slice(0,C+1)}return""}e.$Sf=a;function u($){if(!S.$j||!$||$.length<5)return!1;let A=$.charCodeAt(0);if(A!==92||(A=$.charCodeAt(1),A!==92))return!1;let R=2;const z=R;for(;R<$.length&&(A=$.charCodeAt(R),A!==92);R++);return!(z===R||(A=$.charCodeAt(R+1),isNaN(A)||A===92))}e.$Tf=u;const h=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n($,A=S.$j){const R=A?h:g;return!(!$||$.length===0||/^\s+$/.test($)||(R.lastIndex=0,R.test($))||A&&o.test($)||$==="."||$===".."||A&&$[$.length-1]==="."||A&&$.length!==$.trim().length||$.length>255)}e.$Uf=n;function i($,A,R){const z=$===A;return!R||z?z:!$||!A?!1:(0,v.$1e)($,A)}e.$Vf=i;function s($,A,R,z=I.sep){if($===A)return!0;if(!$||!A||A.length>$.length)return!1;if(R){if(!(0,v.$2e)($,A))return!1;if(A.length===$.length)return!0;let b=A.length;return A.charAt(A.length-1)===z&&b--,$.charAt(b)===z}return A.charAt(A.length-1)!==z&&(A+=z),$.indexOf(A)===0}e.$Wf=s;function l($){return $>=65&&$<=90||$>=97&&$<=122}e.$Xf=l;function w($,A){return S.$j&&$.endsWith(":")&&($+=I.sep),(0,I.$hc)($)||($=(0,I.$ic)(A,$)),$=(0,I.$gc)($),S.$j?($=(0,v.$Je)($,I.sep),$.endsWith(":")&&($+=I.sep)):($=(0,v.$Je)($,I.sep),$||($=I.sep)),$}e.$Yf=w;function N($){const A=(0,I.$gc)($);return S.$j?$.length>3?!1:L(A)&&($.length===2||A.charCodeAt(2)===92):A===I.$fc.sep}e.$Zf=N;function L($,A=S.$j){return A?l($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$1f=L;function E($,A=S.$j){return L($,A)?$[0]:void 0}e.$2f=E;function f($,A,R){return A.length>$.length?-1:$===A?0:(R&&($=$.toLowerCase(),A=A.toLowerCase()),$.indexOf(A))}e.$3f=f;function y($){const A=$.split(":");let R,z,C;for(const b of A){const B=Number(b);(0,T.$Bf)(B)?z===void 0?z=B:C===void 0&&(C=B):R=R?[R,b].join(":"):b}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:z!==void 0?z:void 0,column:C!==void 0?C:z!==void 0?1:void 0}}e.$4f=y;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",O="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D($,A,R=8){let z="";for(let b=0;b<R;b++){let B;b===0&&S.$j&&!A&&(R===3||R===4)?B=O:B=m,z+=B.charAt(Math.floor(Math.random()*B.length))}let C;return A?C=`${A}-${z}`:C=z,$?(0,I.$ic)($,C):C}e.$5f=D}),define(q[17],p([0,1,6,3,8]),function(F,e,I,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.Schemas=void 0;var T;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={})),e.$6f="vscode-tkn",e.$7f="tkn";class r{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(u){this.d=u}setDelegate(u){this.e=u}setServerRootPath(u){this.f=`${u}/${T.vscodeRemoteResource}`}set(u,h,g){this.a[u]=h,this.b[u]=g}setConnectionToken(u,h){this.c[u]=h}getPreferredWebSchema(){return this.d}rewrite(u){if(this.e)try{return this.e(u)}catch(s){return I.$Z(s),u}const h=u.authority;let g=this.a[h];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const o=this.b[h],n=this.c[h];let i=`path=${encodeURIComponent(u.path)}`;return typeof n=="string"&&(i+=`&${e.$7f}=${encodeURIComponent(n)}`),v.URI.from({scheme:S.$p?this.d:T.vscodeRemoteResource,authority:`${g}:${o}`,path:this.f,query:i})}}e.$8f=new r,e.$9f="vs/../../extensions",e.$0f="vs/../../node_modules",e.$$f="vs/../../node_modules.asar",e.$_f="vs/../../node_modules.asar.unpacked",e.$ag="vscode-app";class d{static{this.a=e.$ag}asBrowserUri(u){const h=this.b(u,F);return this.uriToBrowserUri(h)}uriToBrowserUri(u){return u.scheme===T.vscodeRemote?e.$8f.rewrite(u):u.scheme===T.file&&(S.$n||S.$q&&S.$h.origin===`${T.vscodeFileResource}://${d.a}`)?u.with({scheme:T.vscodeFileResource,authority:u.authority||d.a,query:null,fragment:null}):u}asFileUri(u){const h=this.b(u,F);return this.uriToFileUri(h)}uriToFileUri(u){return u.scheme===T.vscodeFileResource?u.with({scheme:T.file,authority:u.authority!==d.a?u.authority:null,query:null,fragment:null}):u}b(u,h){return v.URI.isUri(u)?u:v.URI.parse(h.toUrl(u))}}e.$bg=new d;var t;(function(a){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(u.get("3"));const h="vscode-coi";function g(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:v.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const s=i?.get(h);if(s)return u.get(s)}a.getHeadersFromQuery=g;function o(n,i,s){if(!globalThis.crossOriginIsolated)return;const l=i&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(h,l):n[h]=l}a.addSearchParam=o})(t||(e.COI=t={}))}),define(q[32],p([0,1,21,17,3,8]),function(F,e,I,S,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=void 0;class r{constructor(g,o,n){this.id=g,this.dependencies=o,this.callback=n}}class d{static{this.INSTANCE=new d}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,o,n)=>{typeof g!="string"&&(n=o,o=g,g=null),(typeof o!="object"||!Array.isArray(o))&&(n=o,o=null),this.c.push(new r(g,o,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const o=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!o)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(o.dependencies)&&o.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${o.dependencies.join(", ")}`);return typeof o.callback=="function"?o.callback([]):o.callback}h(g){return new Promise((o,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const s=()=>{i.removeEventListener("load",l),i.removeEventListener("error",w)},l=N=>{s(),o(this.c.pop())},w=N=>{s(),n(N)};i.addEventListener("load",l),i.addEventListener("error",w),this.f&&(g=this.f.createScriptURL(g)),i.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(i)})}i(g){return new Promise((o,n)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),o(this.c.pop())}catch(i){n(i)}})}async j(g){try{const o=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,s=T.URI.parse(g).fsPath,l=o.readFileSync(s).toString(),w=i.wrap(l.replace(/^#!.*/,""));return new n.Script(w).runInThisContext().apply(),this.c.pop()}catch(o){throw o}}}const t=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function u(h,g,o){if(I.$S){o===void 0&&(o=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[h]&&(h=a[h]);const n=`${h}/${g}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const N=`${o&&!v.$p?S.$$f:S.$0f}/${n}`;i=S.$bg.asBrowserUri(N).toString(!0)}const s=d.INSTANCE.load(i);return t.set(n,s),s}else return await new Promise((n,i)=>{F([h],n,i)})}e.$fC=u}),define(q[18],p([0,1,29,17,30,3,31,8]),function(F,e,I,S,v,T,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.DataUri=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function t(o){return(0,d.$vc)(o,!0)}e.$ig=t;class a{constructor(n){this.a=n}compare(n,i,s=!1){return n===i?0:(0,r.$Te)(this.getComparisonKey(n,s),this.getComparisonKey(i,s))}isEqual(n,i,s=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,s)===this.getComparisonKey(i,s)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,s=!1){if(n.scheme===i.scheme){if(n.scheme===S.Schemas.file)return I.$Wf(t(n),t(i),this.a(n))&&n.query===i.query&&(s||n.fragment===i.fragment);if((0,e.$zg)(n.authority,i.authority))return I.$Wf(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(s||n.fragment===i.fragment)}return!1}joinPath(n,...i){return d.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$rg)(n)||n.authority}basename(n){return v.$fc.basename(n.path)}extname(n){return v.$fc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===S.Schemas.file?i=d.URI.file(v.$lc(t(n))).path:(i=v.$fc.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===S.Schemas.file?i=d.URI.file(v.$gc(t(n))).path:i=v.$fc.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$zg)(n.authority,i.authority))return;if(n.scheme===S.Schemas.file){const w=v.$kc(t(n),t(i));return T.$j?I.$Qf(w):w}let s=n.path||"/";const l=i.path||"/";if(this.a(n)){let w=0;for(const N=Math.min(s.length,l.length);w<N&&!(s.charCodeAt(w)!==l.charCodeAt(w)&&s.charAt(w).toLowerCase()!==l.charAt(w).toLowerCase());w++);s=l.substr(0,w)+s.substr(w)}return v.$fc.relative(s,l)}resolvePath(n,i){if(n.scheme===S.Schemas.file){const s=d.URI.file(v.$jc(t(n),i));return n.with({authority:s.authority,path:s.path})}return i=I.$Rf(i),n.with({path:v.$fc.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,r.$1e)(n,i)}hasTrailingPathSeparator(n,i=v.sep){if(n.scheme===S.Schemas.file){const s=t(n);return s.length>I.$Sf(s).length&&s[s.length-1]===i}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=v.sep){return(0,e.$Ag)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=v.sep){let s=!1;if(n.scheme===S.Schemas.file){const l=t(n);s=l!==void 0&&l.length===I.$Sf(l).length&&l[l.length-1]===i}else{i="/";const l=n.path;s=l.length===1&&l.charCodeAt(l.length-1)===47}return!s&&!(0,e.$Ag)(n,i)?n.with({path:n.path+"/"}):n}}e.$jg=a,e.$kg=new a(()=>!1),e.$lg=new a(o=>o.scheme===S.Schemas.file?!T.$l:!0),e.$mg=new a(o=>!0),e.$ng=e.$kg.isEqual.bind(e.$kg),e.$og=e.$kg.isEqualOrParent.bind(e.$kg),e.$pg=e.$kg.getComparisonKey.bind(e.$kg),e.$qg=e.$kg.basenameOrAuthority.bind(e.$kg),e.$rg=e.$kg.basename.bind(e.$kg),e.$sg=e.$kg.extname.bind(e.$kg),e.$tg=e.$kg.dirname.bind(e.$kg),e.$ug=e.$kg.joinPath.bind(e.$kg),e.$vg=e.$kg.normalizePath.bind(e.$kg),e.$wg=e.$kg.relativePath.bind(e.$kg),e.$xg=e.$kg.resolvePath.bind(e.$kg),e.$yg=e.$kg.isAbsolutePath.bind(e.$kg),e.$zg=e.$kg.isEqualAuthority.bind(e.$kg),e.$Ag=e.$kg.hasTrailingPathSeparator.bind(e.$kg),e.$Bg=e.$kg.removeTrailingPathSeparator.bind(e.$kg),e.$Cg=e.$kg.addTrailingPathSeparator.bind(e.$kg);function u(o,n){const i=[];for(let s=0;s<o.length;s++){const l=n(o[s]);o.some((w,N)=>N===s?!1:(0,e.$og)(l,n(w)))||i.push(o[s])}return i}e.$Dg=u;var h;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function n(i){const s=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(N=>{const[L,E]=N.split(":");L&&E&&s.set(L,E)});const w=i.path.substring(0,i.path.indexOf(";"));return w&&s.set(o.META_DATA_MIME,w),s}o.parseMetaData=n})(h||(e.DataUri=h={}));function g(o,n,i){if(n){let s=o.path;return s&&s[0]!==v.$fc.sep&&(s=v.$fc.sep+s),o.with({scheme:i,authority:n,path:s})}return o.with({scheme:i})}e.$Eg=g}),define(q[19],p([0,1,46,6,33,2,18,3,24]),function(F,e,I,S,v,T,r,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eh=e.$dh=e.$ch=e.Promises=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function a(j){return!!j&&typeof j.then=="function"}e.$Fg=a;function u(j){const c=new I.$Wd,k=j(c.token),P=new Promise((M,U)=>{const Z=c.token.onCancellationRequested(()=>{Z.dispose(),c.dispose(),U(new S.$4)});Promise.resolve(k).then(Y=>{Z.dispose(),c.dispose(),M(Y)},Y=>{Z.dispose(),c.dispose(),U(Y)})});return new class{cancel(){c.cancel()}then(M,U){return P.then(M,U)}catch(M){return this.then(void 0,M)}finally(M){return P.finally(M)}}}e.$Gg=u;function h(j,c,k){return new Promise((P,M)=>{const U=c.onCancellationRequested(()=>{U.dispose(),P(k)});j.then(P,M).finally(()=>U.dispose())})}e.$Hg=h;function g(j,c){return new Promise((k,P)=>{const M=c.onCancellationRequested(()=>{M.dispose(),P(new S.$4)});j.then(k,P).finally(()=>M.dispose())})}e.$Ig=g;async function o(j){let c=-1;const k=j.map((P,M)=>P.then(U=>(c=M,U)));try{return await Promise.race(k)}finally{j.forEach((P,M)=>{M!==c&&P.cancel()})}}e.$Jg=o;function n(j,c,k){let P;const M=setTimeout(()=>{P?.(void 0),k?.()},c);return Promise.race([j.finally(()=>clearTimeout(M)),new Promise(U=>P=U)])}e.$Kg=n;function i(j){return new Promise((c,k)=>{const P=j();a(P)?P.then(c,k):c(P)})}e.$Lg=i;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(c){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=c,!this.b){const k=()=>{if(this.b=null,this.f)return;const P=this.queue(this.d);return this.d=null,P};this.b=new Promise(P=>{this.a.then(k,k).then(P)})}return new Promise((k,P)=>{this.b.then(k,P)})}return this.a=c(),new Promise((k,P)=>{this.a.then(M=>{this.a=null,k(M)},M=>{this.a=null,P(M)})})}dispose(){this.f=!0}}e.$Mg=s;class l{constructor(){this.a=Promise.resolve(null)}queue(c){return this.a=this.a.then(()=>c(),()=>c())}}e.$Ng=l;class w{constructor(){this.a=new Map}queue(c,k){const M=(this.a.get(c)??Promise.resolve()).catch(()=>{}).then(k).finally(()=>{this.a.get(c)===M&&this.a.delete(c)});return this.a.set(c,M),M}}e.$Og=w;const N=(j,c)=>{let k=!0;const P=setTimeout(()=>{k=!1,c()},j);return{isTriggered:()=>k,dispose:()=>{clearTimeout(P),k=!1}}},L=j=>{let c=!0;return queueMicrotask(()=>{c&&(c=!1,j())}),{isTriggered:()=>c,dispose:()=>{c=!1}}};class E{constructor(c){this.defaultDelay=c,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(c,k=this.defaultDelay){this.g=c,this.h(),this.b||(this.b=new Promise((M,U)=>{this.d=M,this.f=U}).then(()=>{if(this.b=null,this.d=null,this.g){const M=this.g;return this.g=null,M()}}));const P=()=>{this.a=null,this.d?.(null)};return this.a=k===t.$Jd?L(P):N(k,P),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Pg=E;class f{constructor(c){this.a=new E(c),this.b=new s}trigger(c,k){return this.a.trigger(()=>this.b.queue(c),k)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Qg=f;class y{constructor(){this.a=!1,this.b=new Promise((c,k)=>{this.d=c})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Rg=y;class m extends y{constructor(c){super(),this.f=setTimeout(()=>this.open(),c)}open(){clearTimeout(this.f),super.open()}}e.$Sg=m;function O(j,c){return c?new Promise((k,P)=>{const M=setTimeout(()=>{U.dispose(),k()},j),U=c.onCancellationRequested(()=>{clearTimeout(M),U.dispose(),P(new S.$4)})}):u(k=>O(j,k))}e.$Tg=O;function D(j,c=0,k){const P=setTimeout(()=>{j(),k&&M.dispose()},c),M=(0,T.$Pc)(()=>{clearTimeout(P),k?.deleteAndLeak(M)});return k?.add(M),M}e.$Ug=D;function $(j){const c=[];let k=0;const P=j.length;function M(){return k<P?j[k++]():null}function U(Z){Z!=null&&c.push(Z);const Y=M();return Y?Y.then(U):Promise.resolve(c)}return Promise.resolve(null).then(U)}e.$Vg=$;function A(j,c=P=>!!P,k=null){let P=0;const M=j.length,U=()=>{if(P>=M)return Promise.resolve(k);const Z=j[P++];return Promise.resolve(Z()).then(J=>c(J)?Promise.resolve(J):U())};return U()}e.$Wg=A;function R(j,c=P=>!!P,k=null){if(j.length===0)return Promise.resolve(k);let P=j.length;const M=()=>{P=-1;for(const U of j)U.cancel?.()};return new Promise((U,Z)=>{for(const Y of j)Y.then(J=>{--P>=0&&c(J)?(M(),U(J)):P===0&&U(k)}).catch(J=>{--P>=0&&(M(),Z(J))})})}e.$Xg=R;class z{constructor(c){this.a=0,this.d=c,this.f=[],this.b=0,this.g=new v.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(c){return this.a++,new Promise((k,P)=>{this.f.push({factory:c,c:k,e:P}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const c=this.f.shift();this.b++;const k=c.factory();k.then(c.c,c.e),k.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Yg=z;class C extends z{constructor(){super(1)}}e.$Zg=C;class b{constructor(){this.a=new x,this.b=0}queue(c){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,c())):this.a.run(this.b++,c())}}e.$1g=b;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const c=new te;return this.b.add(c),c.p}g(){for(const[,c]of this.a)if(c.size>0)return!1;return!0}queueFor(c,k=r.$kg){const P=k.getComparisonKey(c);let M=this.a.get(P);if(!M){M=new C;const U=this.f++,Z=v.Event.once(M.onDrained)(()=>{M?.dispose(),this.a.delete(P),this.h(),this.d?.deleteAndDispose(U),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$Zc),this.d.set(U,Z),this.a.set(P,M)}return M}h(){this.g()&&this.j()}j(){for(const c of this.b)c.complete();this.b.clear()}dispose(){for(const[,c]of this.a)c.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$2g=B;class K{constructor(c,k){this.a=-1,typeof c=="function"&&typeof k=="number"&&this.setIfNotSet(c,k)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(c,k){this.cancel(),this.a=setTimeout(()=>{this.a=-1,c()},k)}setIfNotSet(c,k){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,c()},k))}}e.$3g=K;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(c,k){this.cancel(),this.a=setInterval(()=>{c()},k)}}e.$4g=V;class G{constructor(c,k){this.b=-1,this.a=c,this.d=k,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(c=this.d){this.cancel(),this.b=setTimeout(this.f,c)}get delay(){return this.d}set delay(c){this.d=c}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$5g=G;class H{constructor(c,k){k%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${k}ms is not a multiple of 1000ms.`),this.a=c,this.b=k,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(c=this.b){c%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${c}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(c/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$6g=H;class W extends G{constructor(c,k){super(c,k),this.j=[]}work(c){this.j.push(c),this.isScheduled()||this.schedule()}h(){const c=this.j;this.j=[],this.a?.(c)}dispose(){this.j=[],super.dispose()}}e.$7g=W;class _ extends T.$Rc{constructor(c,k){super(),this.g=c,this.h=k,this.a=[],this.b=this.B(new T.$Sc),this.f=!1}get pending(){return this.a.length}work(c){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+c.length>this.g.maxBufferedWork)return!1}else if(this.pending+c.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const k of c)this.a.push(k);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$8g=_,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$9g=j=>{(0,d.$B)(()=>{if(c)return;const k=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,k-Date.now())}}))});let c=!1;return{dispose(){c||(c=!0)}}}:e.$9g=(j,c)=>{const k=requestIdleCallback(j,typeof c=="number"?{timeout:c}:void 0);let P=!1;return{dispose(){P||(P=!0,cancelIdleCallback(k))}}}}();class Q{constructor(c){this.d=!1,this.a=()=>{try{this.f=c()}catch(k){this.g=k}finally{this.d=!0}},this.b=(0,e.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$0g=Q;async function re(j,c,k){let P;for(let M=0;M<k;M++)try{return await j()}catch(U){P=U,await O(c)}throw P}e.$$g=re;class x{isRunning(c){return typeof c=="number"?this.a?.taskId===c:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(c,k,P){return this.a={taskId:c,cancel:()=>P?.(),promise:k},k.then(()=>this.d(c),()=>this.d(c)),k}d(c){this.a&&c===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const c=this.b;this.b=void 0,c.run().then(c.promiseResolve,c.promiseReject)}}queue(c){if(this.b)this.b.run=c;else{let k,P;const M=new Promise((U,Z)=>{k=U,P=Z});this.b={run:c,promise:M,promiseResolve:k,promiseReject:P}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$_g=x;class ae{constructor(c,k=()=>Date.now()){this.d=c,this.f=k,this.a=0,this.b=0}increment(){const c=this.f();return c-this.a>this.d&&(this.a=c,this.b=0),this.b++,this.b}}e.$ah=ae;var ee;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((c,k)=>{this.a=c,this.b=k})}complete(c){return new Promise(k=>{this.a(c),this.d={outcome:0,value:c},k()})}error(c){return new Promise(k=>{this.b(c),this.d={outcome:1,value:c},k()})}cancel(){return this.error(new S.$4)}}e.$bh=te;var ne;(function(j){async function c(P){let M;const U=await Promise.all(P.map(Z=>Z.then(Y=>Y,Y=>{M||(M=Y)})));if(typeof M<"u")throw M;return U}j.settled=c;function k(P){return new Promise(async(M,U)=>{try{await P(M,U)}catch(Z){U(Z)}})}j.withAsyncBody=k})(ne||(e.Promises=ne={}));var ie;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(ie||(ie={}));class X{static fromArray(c){return new X(k=>{k.emitMany(c)})}static fromPromise(c){return new X(async k=>{k.emitMany(await c)})}static fromPromises(c){return new X(async k=>{await Promise.all(c.map(async P=>k.emitOne(await P)))})}static merge(c){return new X(async k=>{await Promise.all(c.map(async P=>{for await(const M of P)k.emitOne(M)}))})}static{this.EMPTY=X.fromArray([])}constructor(c){this.a=0,this.b=[],this.d=null,this.f=new v.$Md,queueMicrotask(async()=>{const k={emitOne:P=>this.g(P),emitMany:P=>this.h(P),reject:P=>this.k(P)};try{await Promise.resolve(c(k)),this.j()}catch(P){this.k(P)}finally{k.emitOne=void 0,k.emitMany=void 0,k.reject=void 0}})}[Symbol.asyncIterator](){let c=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(c<this.b.length)return{done:!1,value:this.b[c++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(c,k){return new X(async P=>{for await(const M of c)P.emitOne(k(M))})}map(c){return X.map(this,c)}static filter(c,k){return new X(async P=>{for await(const M of c)k(M)&&P.emitOne(M)})}filter(c){return X.filter(this,c)}static coalesce(c){return X.filter(c,k=>!!k)}coalesce(){return X.coalesce(this)}static async toPromise(c){const k=[];for await(const P of c)k.push(P);return k}toPromise(){return X.toPromise(this)}g(c){this.a===0&&(this.b.push(c),this.f.fire())}h(c){this.a===0&&(this.b=this.b.concat(c),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(c){this.a===0&&(this.a=2,this.d=c,this.f.fire())}}e.$ch=X;class se extends X{constructor(c,k){super(k),this.l=c}cancel(){this.l.cancel()}}e.$dh=se;function he(j){const c=new I.$Wd,k=j(c.token);return new se(c,async P=>{const M=c.token.onCancellationRequested(()=>{M.dispose(),c.dispose(),P.reject(new S.$4)});try{for await(const U of k){if(c.token.isCancellationRequested)return;P.emitOne(U)}M.dispose(),c.dispose()}catch(U){M.dispose(),c.dispose(),P.reject(U)}})}e.$eh=he}),define(q[20],p([0,1,34]),function(F,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BB=e.$AB=e.$zB=void 0,e.$zB=new class{clone(){return this}equals(T){return this===T}};function S(T,r){return new I.$8s([new I.$7s(0,"",T)],r)}e.$AB=S;function v(T,r){const d=new Uint32Array(2);return d[0]=0,d[1]=(T<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new I.$9s(d,r===null?e.$zB:r)}e.$BB=v}),define(q[35],p([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(F,e,I,S,v,T,r,d,t,a,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JB=e.$IB=e.$HB=e.$GB=e.$FB=e.$EB=void 0;var o;(function(E){E[E.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(o||(o={}));class n{constructor(f,y){this.tokenizationSupport=y,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(f)}getStartState(f){return this.store.getStartState(f,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$EB=n;class i extends n{constructor(f,y,m,O){super(f,y),this._textModel=m,this._languageIdCodec=O}updateTokensUntilLine(f,y){const m=this._textModel.getLanguageId();for(;;){const O=this.getFirstInvalidLine();if(!O||O.lineNumber>y)break;const D=this._textModel.getLineContent(O.lineNumber),$=N(this._languageIdCodec,m,this.tokenizationSupport,D,!0,O.startState);f.add(O.lineNumber,$.tokens),this.store.setEndState(O.lineNumber,$.endState)}}getTokenTypeIfInsertingCharacter(f,y){const m=this.getStartState(f.lineNumber);if(!m)return 0;const O=this._textModel.getLanguageId(),D=this._textModel.getLineContent(f.lineNumber),$=D.substring(0,f.column-1)+y+D.substring(f.column-1),A=N(this._languageIdCodec,O,this.tokenizationSupport,$,!0,m),R=new g.$1s(A.tokens,$,this._languageIdCodec);if(R.getCount()===0)return 0;const z=R.findTokenIndexAtOffset(f.column-1);return R.getStandardTokenType(z)}tokenizeLineWithEdit(f,y,m){const O=f.lineNumber,D=f.column,$=this.getStartState(O);if(!$)return null;const A=this._textModel.getLineContent(O),R=A.substring(0,D-1)+m+A.substring(D-1+y),z=this._textModel.getLanguageIdAtPosition(O,0),C=N(this._languageIdCodec,z,this.tokenizationSupport,R,!0,$);return new g.$1s(C.tokens,R,this._languageIdCodec)}isCheapToTokenize(f){const y=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<y||f===y&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,y,m){if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(y<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,m),{heuristicTokens:!1};let O=this.b(y);const D=this._textModel.getLanguageId();for(let $=y;$<=m;$++){const A=this._textModel.getLineContent($),R=N(this._languageIdCodec,D,this.tokenizationSupport,A,!0,O);f.add($,R.tokens),O=R.endState}return{heuristicTokens:!0}}b(f){let y=this._textModel.getLineFirstNonWhitespaceColumn(f);const m=[];let O=null;for(let A=f-1;y>1&&A>=1;A--){const R=this._textModel.getLineFirstNonWhitespaceColumn(A);if(R!==0&&R<y&&(m.push(this._textModel.getLineContent(A)),y=R,O=this.getStartState(A),O))break}O||(O=this.tokenizationSupport.getInitialState()),m.reverse();const D=this._textModel.getLanguageId();let $=O;for(const A of m)$=N(this._languageIdCodec,D,this.tokenizationSupport,A,!1,$).endState;return $}}e.$FB=i;class s{constructor(f){this.d=f,this.a=new l,this.b=new w,this.b.addRange(new t.$us(1,f+1))}getEndState(f){return this.a.getEndState(f)}setEndState(f,y){if(!y)throw new S.$bb("Cannot set null/undefined state");this.b.delete(f);const m=this.a.setEndState(f,y);return m&&f<this.d&&this.b.addRange(new t.$us(f+1,f+2)),m}acceptChange(f,y){this.d+=y-f.length,this.a.acceptChange(f,y),this.b.addRangeAndResize(new t.$us(f.startLineNumber,f.endLineNumberExclusive),y)}acceptChanges(f){for(const y of f){const[m]=(0,r.$Zs)(y.text);this.acceptChange(new d.$ws(y.range.startLineNumber,y.range.endLineNumber+1),m+1)}}invalidateEndStateRange(f){this.b.addRange(new t.$us(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(f,y){return f===1?y:this.getEndState(f-1)}getFirstInvalidLine(f){const y=this.getFirstInvalidEndStateLineNumber();if(y===null)return null;const m=this.getStartState(y,f);if(!m)throw new S.$bb("Start state must be defined");return{lineNumber:y,startState:m}}}e.$GB=s;class l{constructor(){this.a=new u.$CB(null)}getEndState(f){return this.a.get(f)}setEndState(f,y){const m=this.a.get(f);return m&&m.equals(y)?!1:(this.a.set(f,y),!0)}acceptChange(f,y){let m=f.length;y>0&&m>0&&(m--,y--),this.a.replace(f.startLineNumber,m,y)}acceptChanges(f){for(const y of f){const[m]=(0,r.$Zs)(y.text);this.acceptChange(new d.$ws(y.range.startLineNumber,y.range.endLineNumber+1),m+1)}}}e.$HB=l;class w{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const f=this.a[0];return f.start+1===f.endExclusive?this.a.shift():this.a[0]=new t.$us(f.start+1,f.endExclusive),f.start}delete(f){const y=this.a.findIndex(m=>m.contains(f));if(y!==-1){const m=this.a[y];m.start===f?m.endExclusive===f+1?this.a.splice(y,1):this.a[y]=new t.$us(f+1,m.endExclusive):m.endExclusive===f+1?this.a[y]=new t.$us(m.start,f):this.a.splice(y,1,new t.$us(m.start,f),new t.$us(f+1,m.endExclusive))}}addRange(f){t.$us.addRange(f,this.a)}addRangeAndResize(f,y){let m=0;for(;!(m>=this.a.length||f.start<=this.a[m].endExclusive);)m++;let O=m;for(;!(O>=this.a.length||f.endExclusive<this.a[O].start);)O++;const D=y-f.length;for(let $=O;$<this.a.length;$++)this.a[$]=this.a[$].delta(D);if(m===O){const $=new t.$us(f.start,f.start+y);$.isEmpty||this.a.splice(m,0,$)}else{const $=Math.min(f.start,this.a[m].start),A=Math.max(f.endExclusive,this.a[O-1].endExclusive),R=new t.$us($,A+D);R.isEmpty?this.a.splice(m,O-m):this.a.splice(m,O-m,R)}}toString(){return this.a.map(f=>f.toString()).join(" + ")}}e.$IB=w;function N(E,f,y,m,O,D){let $=null;if(y)try{$=y.tokenizeEncoded(m,O,D.clone())}catch(A){(0,S.$Z)(A)}return $||($=(0,a.$BB)(E.encodeLanguageId(f),D)),g.$1s.convertToEndOffset($.tokens,m.length),$}class L{constructor(f,y){this.b=f,this.d=y,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,I.$9g)(f=>{this.f=!1,this.h(f)}))}h(f){const y=Date.now()+f.timeRemaining(),m=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<y?(0,v.$B)(m):this.g())};m()}j(){const f=this.b._textModel.getLineCount(),y=new h.$DB,m=T.$Id.create(!1);do if(m.elapsed()>1||this.l(y)>=f)break;while(this.k());this.d.setTokens(y.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(f){const y=this.b?.getFirstInvalidLine();return y?(this.b.updateTokensUntilLine(f,y.lineNumber),y.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(f,y){this.b.store.invalidateEndStateRange(new d.$ws(f,y))}}e.$JB=L}),define(q[37],p([0,1,33,2,36,14,34]),function(F,e,I,S,v,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Db=void 0;class d extends S.$Rc{constructor(a,u,h,g,o,n,i){super(),this.c=a,this.f=u,this.g=h,this.h=g,this.j=o,this.m=n,this.n=i,this.a=[],this.b=this.B(new I.$Md),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(a,u,h){throw new Error("Not supported!")}createBackgroundTokenizer(a,u){if(this.h)return this.h(a,u)}tokenizeEncoded(a,u,h){const g=Math.random()*1e4<1,o=this.n||g,n=o?new v.$Id(!0):void 0,i=this.c.tokenizeLine2(a,h,500);if(o){const l=n.elapsed();(g||l>32)&&this.m(l,a.length,g)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${a.substring(0,100)}`),new r.$9s(i.tokens,h);if(this.g){const l=this.a,w=i.tokens;for(let N=0,L=w.length>>>1;N<L;N++){const E=w[(N<<1)+1],f=T.$Xs.getLanguageId(E);l[f]||(l[f]=!0,this.b.fire(f))}}let s;return h.equals(i.ruleStack)?s=h:s=i.ruleStack,new r.$9s(i.tokens,s)}}e.$$Db=d}),define(q[38],p([0,1,20,2,11]),function(F,e,I,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Db=void 0;class T extends S.$Rc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(d,t,a){super(),this.a=d,this.b=t,this.c=a,this.B((0,v.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(d,t,a){throw new Error("Not supported!")}tokenizeEncoded(d,t,a){return d.length>=this.c.get()?(0,I.$BB)(this.a,a):this.b.tokenizeEncoded(d,t,a)}createBackgroundTokenizer(d,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(d,t)}}e.$_Db=T}),define(q[39],p([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(F,e,I,S,v,T,r,d,t,a,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eEb=void 0;class o extends d.$Pu{constructor(s,l,w,N,L,E,f,y){super(s,l,w,N),this.s=L,this.t=E,this.u=f,this.a=null,this.b=!1,this.c=(0,v.observableValue)(this,-1),this.q=new S.$5g(()=>this.w(),10),this.c.set(y,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,l){this.t=s,this.u=l,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,l){this.a&&(this.a.store.invalidateEndStateRange(new r.$ws(s,l)),this.q.schedule())}async v(){this.a=null;const s=this.t,l=this.u,w=await this.s.getOrCreateGrammar(s,l);if(!(this.b||s!==this.t||l!==this.u||!w)){if(w.grammar){const N=new g.$_Db(this.u,new h.$$Db(w.grammar,w.initialState,!1,void 0,()=>!1,(L,E,f)=>{this.s.reportTokenizationTime(L,s,w.sourceExtensionId,E,f)},!1),this.c);this.a=new t.$EB(this.f.length,N)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:l}=await(0,I.$fC)("vscode-textmate","release/main.js");this.m=l}const s=new Date().getTime();for(;;){let l=0;const w=new a.$DB,N=new n;for(;;){const f=this.a.getFirstInvalidLine();if(f===null||l>200)break;l++;const y=this.f[f.lineNumber-1],m=this.a.tokenizationSupport.tokenizeEncoded(y,!0,f.startState);if(this.a.store.setEndState(f.lineNumber,m.endState)){const D=this.m(f.startState,m.endState);N.setState(f.lineNumber,D)}else N.setState(f.lineNumber,null);if(u.$1s.convertToEndOffset(m.tokens,y.length),w.add(f.lineNumber,m.tokens),new Date().getTime()-s>20)break}if(l===0)break;const L=N.getStateDeltas();if(this.s.setTokensAndStates(this.h,w.serialize(),L),new Date().getTime()-s>20){(0,T.$B)(()=>this.w());return}}}}e.$eEb=o;class n{constructor(){this.a=-1,this.b=[]}setState(s,l){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(l):this.b.push({startLineNumber:s,stateDeltas:[l]}),this.a=s}getStateDeltas(){return this.b}}}),define(q[40],p([0,1,18]),function(F,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bEb=void 0;class S{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(T){if(this.a[T.scopeName]){const r=this.a[T.scopeName];I.$ng(r.location,T.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${T.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${T.location.toString()}`)}this.a[T.scopeName]=T}getGrammarDefinition(T){return this.a[T]||null}}e.$bEb=S}),define(q[41],p([0,1,2,40]),function(F,e,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dEb=e.$cEb=void 0,e.$cEb="No TM Grammar registered for this language.";class v extends I.$Rc{constructor(r,d,t,a){super(),this.a=r,this.b=t.INITIAL,this.c=new S.$bEb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:a,loadGrammar:async u=>{const h=this.c.getGrammarDefinition(u);if(!h)return this.a.logTrace(`No grammar found for scope ${u}`),null;const g=h.location;try{const o=await this.a.readFile(g);return t.parseRawGrammar(o,g.path)}catch(o){return this.a.logError(`Unable to load and parse grammar for scope ${u} from ${g}`,o),null}},getInjections:u=>{const h=u.split(".");let g=[];for(let o=1;o<=h.length;o++){const n=h.slice(0,o).join(".");g=[...g,...this.f[n]||[]]}return g}}));for(const u of d){if(this.c.register(u),u.injectTo){for(const h of u.injectTo){let g=this.f[h];g||(this.f[h]=g=[]),g.push(u.scopeName)}if(u.embeddedLanguages)for(const h of u.injectTo){let g=this.g[h];g||(this.g[h]=g=[]),g.push(u.embeddedLanguages)}}u.language&&this.h.set(u.language,u.scopeName)}}has(r){return this.h.has(r)}setTheme(r,d){this.j.setTheme(r,d)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,d){const t=this.h.get(r);if(typeof t!="string")throw new Error(e.$cEb);const a=this.c.getGrammarDefinition(t);if(!a)throw new Error(e.$cEb);const u=a.embeddedLanguages;if(this.g[t]){const o=this.g[t];for(const n of o)for(const i of Object.keys(n))u[i]=n[i]}const h=Object.keys(u).length>0;let g;try{g=await this.j.loadGrammarWithConfiguration(t,d,{embeddedLanguages:u,tokenTypes:a.tokenTypes,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors})}catch(o){throw o.message&&o.message.startsWith("No grammar provided for")?new Error(e.$cEb):o}return{languageId:r,grammar:g,initialState:this.b,containsEmbeddedLanguages:h,sourceExtensionId:a.sourceExtensionId}}}e.$dEb=v}),define(q[49],p([0,1,8,41,39]),function(F,e,I,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function T(d,t){return new r(d,t)}e.create=T;class r{constructor(t,a){this.f=a,this.b=new Map,this.c=[],this.a=t.host;const u=a.grammarDefinitions.map(h=>({location:I.URI.revive(h.location),language:h.language,scopeName:h.scopeName,embeddedLanguages:h.embeddedLanguages,tokenTypes:h.tokenTypes,injectTo:h.injectTo,balancedBracketSelectors:h.balancedBracketSelectors,unbalancedBracketSelectors:h.unbalancedBracketSelectors,sourceExtensionId:h.sourceExtensionId}));this.d=this.g(u)}async g(t){const a=this.f.textmateMainUri,u=await new Promise((i,s)=>{F([a],i,s)}),h=await new Promise((i,s)=>{F([this.f.onigurumaMainUri],i,s)}),o=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await h.loadWASM(o);const n=Promise.resolve({createOnigScanner:i=>h.createOnigScanner(i),createOnigString:i=>h.createOnigString(i)});return new S.$dEb({logTrace:i=>{},logError:(i,s)=>console.error(i,s),readFile:i=>this.a.readFile(i)},t,u,n)}acceptNewModel(t){const a=I.URI.revive(t.uri),u=this;this.b.set(t.controllerId,new v.$eEb(a,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(h,g){const o=await u.d;return o?(u.c[g]||(u.c[g]=o.createGrammar(h,g)),u.c[g]):Promise.resolve(null)},setTokensAndStates(h,g,o){u.a.setTokensAndStates(t.controllerId,h,g,o)},reportTokenizationTime(h,g,o,n,i){u.a.reportTokenizationTime(h,g,o,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,a){this.b.get(t).onEvents(a)}retokenize(t,a,u){this.b.get(t).retokenize(a,u)}acceptModelLanguageChanged(t,a,u){this.b.get(t).onLanguageId(a,u)}acceptRemovedModel(t){const a=this.b.get(t);a&&(a.dispose(),this.b.delete(t))}async acceptTheme(t,a){(await this.d)?.setTheme(t,a)}acceptMaxTokenizationLineLength(t,a){this.b.get(t).acceptMaxTokenizationLineLength(a)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7d4027b62bb1e620e5454580450fa646682bc102/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
